#include <math.h>
#include <string.h>
#include "comparison.h"
#include "comparison_prm.h"

void MdlEnable(void)
{

  rtDWork.Pos_a_IWORK.SystemEnable = (int_T) TRUE;
  
  rtDWork.Vel_a_IWORK.SystemEnable = (int_T) TRUE;
}

void MdlInitialize(void)
{
  
  rtDWork.Unit_Delay_DSTATE = rtP.Unit_Delay_X0;

  rtDWork.Difference_DSTATE = 0.0;

  rtDWork.Discrete_Time_Integrat_a_DSTATE = rtP.Discrete_Time_Integrat_a_IC;

  rtDWork.Discrete_Time_Integrat_b_DSTATE = rtP.Discrete_Time_Integrat_b_IC;

  {
    SimStruct *rts = ssGetSFunction(rtS, 0);
    sfcnInitializeConditions(rts);
  }
  
  rtDWork.alpha_k_1_DSTATE = rtP.alpha_k_1_X0;

  rtDWork.Discrete_Butterworth_a_DSTATE[0] = rtP.Discrete_Butterworth_a_X0;
  rtDWork.Discrete_Butterworth_a_DSTATE[1] = rtP.Discrete_Butterworth_a_X0;

  rtDWork.iMeas_k_1_a_DSTATE = rtP.iMeas_k_1_a_X0;

  rtDWork.G_k_1_DSTATE = rtP.G_k_1_X0;

  rtDWork.Discrete_Time_Integrat_c_DSTATE = rtP.Discrete_Time_Integrat_c_IC;

  rtDWork.iMeas_k_1_b_DSTATE = rtP.iMeas_k_1_b_X0;

  rtDWork.Discrete_Butterworth_b_DSTATE[0] = rtP.Discrete_Butterworth_b_X0;
  rtDWork.Discrete_Butterworth_b_DSTATE[1] = rtP.Discrete_Butterworth_b_X0;

  rtDWork.vel_k_1_a_DSTATE = rtP.vel_k_1_a_X0;

  rtDWork.pwm_k_1_a_DSTATE = rtP.pwm_k_1_a_X0;

  rtDWork.vel_k_1_b_DSTATE = rtP.vel_k_1_b_X0;

  rtDWork.pwm_k_1_b_DSTATE = rtP.pwm_k_1_b_X0;

  rtDWork.iMeas_k_1_c_DSTATE = rtP.iMeas_k_1_c_X0;

  rtDWork.Discrete_Butterworth_c_DSTATE[0] = rtP.Discrete_Butterworth_c_X0;
  rtDWork.Discrete_Butterworth_c_DSTATE[1] = rtP.Discrete_Butterworth_c_X0;

  rtDWork.vel_k_1_c_DSTATE = rtP.vel_k_1_c_X0;

  rtDWork.beta_k_1_DSTATE = rtP.beta_k_1_X0;

  rtDWork.pwm_k_1_c_DSTATE = rtP.pwm_k_1_c_X0;
}

void MdlStart(void)
{
  
  rtB.Unit_Delay = rtP.Unit_Delay_X0;

  rtB.D_A_bias_a = rtP.D_A_bias_a_Value;

  {
    int16_T value;

    value = MQ_dacVoltageToOutput(rtP.Analog_Output_P2);
    MQ_dacOutput(0x320, (uint_T)rtP.Analog_Output_P1, value);
  }

  {
    MQ_adcInitialize(0x320);
  }

  {
    MQ3_encResetAll(0x320);
    MQ3_encSetCount(0x320, (uint_T)rtP.Encoder_Input_P1,
     (int_T)rtP.Encoder_Input_P2);
  }

  rtB.Discrete_Time_Integrat_a = rtP.Discrete_Time_Integrat_a_IC;

  rtB.Constant_a = rtP.Constant_a_Value;

  rtB.Constant1_a = rtP.Constant1_a_Value;

  rtB.Discrete_Time_Integrat_b = rtP.Discrete_Time_Integrat_b_IC;

  rtB.Constant_b = rtP.Constant_b_Value;

  rtB.Constant1_b = rtP.Constant1_b_Value;

  rtB.D_A_bias_b = rtP.D_A_bias_b_Value;

  rtB.beta_a = rtP.beta_a_Value;

  rtB.alpha_k_1 = rtP.alpha_k_1_X0;

  rtB.id_a = rtP.id_a_Value;

  rtDWork.Traj_pos_ref_IWORK.PrevIndex = 0;

  rtB.Constant_c = rtP.Constant_c_Value;

  rtB.Constant1_c = rtP.Constant1_c_Value;

  rtB.Constant_d = rtP.Constant_d_Value;

  rtB.Constant1_d = rtP.Constant1_d_Value;

  rtDWork.Traj_vel_ref_IWORK.PrevIndex = 0;

  rtB.Constant_e = rtP.Constant_e_Value;

  rtB.Constant1_e = rtP.Constant1_e_Value;

  rtB.Constant_f = rtP.Constant_f_Value;

  rtB.Constant1_f = rtP.Constant1_f_Value;

  rtB.iMeas_k_1_a = rtP.iMeas_k_1_a_X0;

  rtB.G_k_1 = rtP.G_k_1_X0;

  rtB.Discrete_Time_Integrat_c = rtP.Discrete_Time_Integrat_c_IC;

  rtB.id_b = rtP.id_b_Value;

  rtB.iMeas_k_1_b = rtP.iMeas_k_1_b_X0;

  rtB.beta_b = rtP.beta_b_Value;

  rtB.vel_k_1_a = rtP.vel_k_1_a_X0;

  rtB.pwm_k_1_a = rtP.pwm_k_1_a_X0;

  rtB.vel_k_1_b = rtP.vel_k_1_b_X0;

  rtB.pwm_k_1_b = rtP.pwm_k_1_b_X0;

  rtB.Nominal_resistance = rtP.Nominal_resistance_Value;

  rtB.id_c = rtP.id_c_Value;

  rtB.iMeas_k_1_c = rtP.iMeas_k_1_c_X0;

  rtB.vel_k_1_c = rtP.vel_k_1_c_X0;

  rtB.beta_k_1 = rtP.beta_k_1_X0;

  rtB.pwm_k_1_c = rtP.pwm_k_1_c_X0;

  MdlInitialize();
  MdlEnable();
}

void MdlOutputs(int_T tid)
{
  
  (void)tid;

  rtB.Unit_Delay = rtDWork.Unit_Delay_DSTATE;

  rtB.D_A_bias_a = rtP.D_A_bias_a_Value;

  rtB.Sum_a = rtB.Unit_Delay - rtB.D_A_bias_a;

  rtB.Amplification = rtB.Sum_a * rtP.Amplification_Gain;

  if (rtB.Amplification >= rtP.Sat_a_UpperSat) {
    rtB.Sat_a = rtP.Sat_a_UpperSat;
  } else if (rtB.Amplification <= rtP.Sat_a_LowerSat) {
    rtB.Sat_a = rtP.Sat_a_LowerSat;
  } else {
    rtB.Sat_a = rtB.Amplification;
  }

  {
    int16_T value;

    value = MQ_dacVoltageToOutput(rtB.Sat_a);
    MQ_dacOutput(0x320, (uint_T)rtP.Analog_Output_P1, value);
  }

  {
    int_T value;

    value = MQ_adcInput(0x320, (uint_T)rtP.Current_P1);
    rtB.Current = MQ_adcInputToVoltage(value);
  }

  {
    int_T value;

    value = MQ_adcInput(0x320, (uint_T)rtP.Current_filtered_P1);
    rtB.Current_filtered = MQ_adcInputToVoltage(value);
  }

  {

    rtB.Encoder_Input = MQ3_encInput(0x320, (uint_T)rtP.Encoder_Input_P1);
  }

  rtB.K_curr = rtB.Current * rtP.K_curr_Gain;

  rtB.ZOH_1 = rtB.K_curr;

  rtB.K_curr_filt = rtB.Current_filtered * rtP.K_curr_filt_Gain;

  rtB.ZOH_2 = rtB.K_curr_filt;

  rtB.rad_count = rtB.Encoder_Input * rtP.rad_count_Gain;

  rtB.ZOH_3 = rtB.rad_count;

  rtB.Difference = rtP.Difference_D*rtB.ZOH_3;
  rtB.Difference += rtP.Difference_C*rtDWork.Difference_DSTATE;
  rtB.Ts = rtB.Difference * rtP.Ts_Gain;

  rtB.Discrete_Time_Integrat_a = rtDWork.Discrete_Time_Integrat_a_DSTATE;

  if (ssGetT(rtS) < rtP.Step_a_Time) {
    rtB.Step_a = rtP.Step_a_Y0;
  } else {
    rtB.Step_a = rtP.Step_a_YFinal;
  }

  rtB.Clock_a = ssGetT(rtS);

  rtB.Constant_a = rtP.Constant_a_Value;

  rtB.Sum_b = rtB.Clock_a - rtB.Constant_a;

  rtB.Product_a = rtB.Step_a * rtB.Sum_b;

  rtB.Constant1_a = rtP.Constant1_a_Value;

  rtB.Sum1_a = rtB.Product_a + rtB.Constant1_a;

  rtB.Reciprocal_a = 1.0/(rtB.Sum1_a);

  rtB.Product_b = rtB.Discrete_Time_Integrat_a * rtB.Reciprocal_a;

  if (rtB.Product_b < 0.0) {
    rtB.Sqrt_a = -sqrt(-rtB.Product_b);
  } else {
    rtB.Sqrt_a = sqrt(rtB.Product_b);
  }

  rtB.Discrete_Time_Integrat_b = rtDWork.Discrete_Time_Integrat_b_DSTATE;

  if (ssGetT(rtS) < rtP.Step_b_Time) {
    rtB.Step_b = rtP.Step_b_Y0;
  } else {
    rtB.Step_b = rtP.Step_b_YFinal;
  }

  rtB.Clock_b = ssGetT(rtS);

  rtB.Constant_b = rtP.Constant_b_Value;

  rtB.Sum_c = rtB.Clock_b - rtB.Constant_b;

  rtB.Product_c = rtB.Step_b * rtB.Sum_c;

  rtB.Constant1_b = rtP.Constant1_b_Value;

  rtB.Sum1_b = rtB.Product_c + rtB.Constant1_b;

  rtB.Reciprocal_b = 1.0/(rtB.Sum1_b);

  rtB.Product_d = rtB.Discrete_Time_Integrat_b * rtB.Reciprocal_b;

  if (rtB.Product_d < 0.0) {
    rtB.Sqrt_b = -sqrt(-rtB.Product_d);
  } else {
    rtB.Sqrt_b = sqrt(rtB.Product_d);
  }

  rtB.D_A_bias_b = rtP.D_A_bias_b_Value;

  if (rtB.Unit_Delay >= rtP.Sat_b_UpperSat) {
    rtB.Sat_b = rtP.Sat_b_UpperSat;
  } else if (rtB.Unit_Delay <= rtP.Sat_b_LowerSat) {
    rtB.Sat_b = rtP.Sat_b_LowerSat;
  } else {
    rtB.Sat_b = rtB.Unit_Delay;
  }

  rtB.Sum1_c = - rtB.D_A_bias_b + rtB.Sat_b;

  rtB.TmpHiddenBuf1_Driving_EKF_AtInp[0] = rtB.ZOH_2;
  rtB.TmpHiddenBuf1_Driving_EKF_AtInp[1] = rtB.ZOH_3;

  {
    SimStruct *rts = ssGetSFunction(rtS, 0);
    sfcnOutputs(rts, tid);
  }

  rtB.Sum3_a = rtB.ZOH_2 - rtB.EKF[7];

  rtB.Abs_i_a = fabs(rtB.Sum3_a);

  rtB.gamma_i_a = rtB.Abs_i_a * rtP.gamma_i_a_Gain;

  rtB.beta_a = rtP.beta_a_Value;

  rtB.Sum1_d = rtB.gamma_i_a + rtB.beta_a;

  rtB.alpha_k_1 = rtDWork.alpha_k_1_DSTATE;

  rtB.alpha_i_a = rtB.Abs_i_a * rtB.alpha_k_1;

  rtB.id_a = rtP.id_a_Value;

  rtB.Sum_d = rtB.alpha_i_a + rtB.id_a;

  rtB.Reciprocal_c = 1.0/(rtB.Sum_d);

  rtB.Product_e = rtB.Sum1_d * rtB.Reciprocal_c;

  {
    real_T t = ssGetT(rtS);
    real_T *pTimeValues = (real_T *) rtDWork.Traj_pos_ref_PWORK.TimePtr;
    real_T *pDataValues = (real_T *) rtDWork.Traj_pos_ref_PWORK.DataPtr;
    if (t < pTimeValues[0]) {
      rtB.Traj_pos_ref = 0.0;
    } else if (t >= pTimeValues[15563]) {
      rtB.Traj_pos_ref = pDataValues[15563];
    } else {
      int_T currTimeIndex = rtDWork.Traj_pos_ref_IWORK.PrevIndex;
      if (t < pTimeValues[currTimeIndex]) {
        while (t < pTimeValues[currTimeIndex]) {
          currTimeIndex--;
        }
      } else {
        while (t >= pTimeValues[currTimeIndex + 1]) {
          currTimeIndex++;
        }
      }
      rtB.Traj_pos_ref = pDataValues[currTimeIndex];
      rtDWork.Traj_pos_ref_IWORK.PrevIndex = currTimeIndex;
    }
  }
  if (ssGetT(rtS) < rtP.Step_c_Time) {
    rtB.Step_c = rtP.Step_c_Y0;
  } else {
    rtB.Step_c = rtP.Step_c_YFinal;
  }

  rtB.Clock_c = ssGetT(rtS);

  rtB.Constant_c = rtP.Constant_c_Value;

  rtB.Sum_e = rtB.Clock_c - rtB.Constant_c;

  rtB.Product_f = rtB.Step_c * rtB.Sum_e;

  rtB.Constant1_c = rtP.Constant1_c_Value;

  rtB.Sum1_e = rtB.Product_f + rtB.Constant1_c;

  if (ssGetT(rtS) < rtP.Step_d_Time) {
    rtB.Step_d = rtP.Step_d_Y0;
  } else {
    rtB.Step_d = rtP.Step_d_YFinal;
  }

  rtB.Clock_d = ssGetT(rtS);

  rtB.Constant_d = rtP.Constant_d_Value;

  rtB.Sum_f = rtB.Clock_d - rtB.Constant_d;

  rtB.Product_g = rtB.Step_d * rtB.Sum_f;

  rtB.Constant1_d = rtP.Constant1_d_Value;

  rtB.Sum1_f = rtB.Product_g + rtB.Constant1_d;

  rtB.Sum2_a = rtB.Sum1_e - rtB.Sum1_f;

  if ( (int_T)rtDWork.Pos_a_IWORK.SystemEnable ) {
    rtDWork.Pos_a_RWORK.LastSin = sin(rtP.Pos_a_Freq * ssGetT(rtS));
    rtDWork.Pos_a_RWORK.LastCos = cos(rtP.Pos_a_Freq * ssGetT(rtS));
    rtDWork.Pos_a_IWORK.SystemEnable = (int_T)FALSE;
  }

  rtB.Pos_a =
    rtP.Pos_a_Amp *
    (
    (rtDWork.Pos_a_RWORK.LastSin * rtP.Pos_a_PCos
    + rtDWork.Pos_a_RWORK.LastCos * rtP.Pos_a_PSin) * rtP.Pos_a_HCos
    + (rtDWork.Pos_a_RWORK.LastCos * rtP.Pos_a_PCos
    - rtDWork.Pos_a_RWORK.LastSin * rtP.Pos_a_PSin) * rtP.Pos_a_Hsin
    ) + rtP.Pos_a_Bias;

  rtB.Pos_b = rtB.Sum2_a * rtB.Pos_a;

  rtB.Sum1_g = rtB.Traj_pos_ref + rtB.Pos_b;

  rtB.Sum4_a = rtB.Sum1_g - rtB.ZOH_3;

  rtB.K_p_a = rtB.Sum4_a * rtP.K_p_a_Gain;

  {
    real_T t = ssGetT(rtS);
    real_T *pTimeValues = (real_T *) rtDWork.Traj_vel_ref_PWORK.TimePtr;
    real_T *pDataValues = (real_T *) rtDWork.Traj_vel_ref_PWORK.DataPtr;
    if (t < pTimeValues[0]) {
      rtB.Traj_vel_ref = 0.0;
    } else if (t >= pTimeValues[15563]) {
      rtB.Traj_vel_ref = pDataValues[15563];
    } else {
      int_T currTimeIndex = rtDWork.Traj_vel_ref_IWORK.PrevIndex;
      if (t < pTimeValues[currTimeIndex]) {
        while (t < pTimeValues[currTimeIndex]) {
          currTimeIndex--;
        }
      } else {
        while (t >= pTimeValues[currTimeIndex + 1]) {
          currTimeIndex++;
        }
      }
      rtB.Traj_vel_ref = pDataValues[currTimeIndex];
      rtDWork.Traj_vel_ref_IWORK.PrevIndex = currTimeIndex;
    }
  }
  if (ssGetT(rtS) < rtP.Step_e_Time) {
    rtB.Step_e = rtP.Step_e_Y0;
  } else {
    rtB.Step_e = rtP.Step_e_YFinal;
  }

  rtB.Clock_e = ssGetT(rtS);

  rtB.Constant_e = rtP.Constant_e_Value;

  rtB.Sum_g = rtB.Clock_e - rtB.Constant_e;

  rtB.Product_h = rtB.Step_e * rtB.Sum_g;

  rtB.Constant1_e = rtP.Constant1_e_Value;

  rtB.Sum1_h = rtB.Product_h + rtB.Constant1_e;

  if (ssGetT(rtS) < rtP.Step_f_Time) {
    rtB.Step_f = rtP.Step_f_Y0;
  } else {
    rtB.Step_f = rtP.Step_f_YFinal;
  }

  rtB.Clock_f = ssGetT(rtS);

  rtB.Constant_f = rtP.Constant_f_Value;

  rtB.Sum_h = rtB.Clock_f - rtB.Constant_f;

  rtB.Product_i = rtB.Step_f * rtB.Sum_h;

  rtB.Constant1_f = rtP.Constant1_f_Value;

  rtB.Sum1_i = rtB.Product_i + rtB.Constant1_f;

  rtB.Sum4_b = rtB.Sum1_h - rtB.Sum1_i;

  if ( (int_T)rtDWork.Vel_a_IWORK.SystemEnable ) {
    rtDWork.Vel_a_RWORK.LastSin = sin(rtP.Vel_a_Freq * ssGetT(rtS));
    rtDWork.Vel_a_RWORK.LastCos = cos(rtP.Vel_a_Freq * ssGetT(rtS));
    rtDWork.Vel_a_IWORK.SystemEnable = (int_T)FALSE;
  }

  rtB.Vel_a =
    rtP.Vel_a_Amp *
    (
    (rtDWork.Vel_a_RWORK.LastSin * rtP.Vel_a_PCos
    + rtDWork.Vel_a_RWORK.LastCos * rtP.Vel_a_PSin) * rtP.Vel_a_HCos
    + (rtDWork.Vel_a_RWORK.LastCos * rtP.Vel_a_PCos
    - rtDWork.Vel_a_RWORK.LastSin * rtP.Vel_a_PSin) * rtP.Vel_a_Hsin
    ) + rtP.Vel_a_Bias;

  rtB.Vel_b = rtB.Sum4_b * rtB.Vel_a;

  rtB.Sum5 = rtB.Traj_vel_ref + rtB.Vel_b;

  rtB.Sum1_j = rtB.Sum5 - rtB.Ts;

  rtB.K_d = rtB.Sum1_j * rtP.K_d_Gain;

  rtB.Sum2_b = rtB.K_p_a + rtB.K_d;

  {
    rtB.Discrete_Butterworth_a =
      rtP.Discrete_Butterworth_a_C*rtDWork.Discrete_Butterworth_a_DSTATE[1];
  }

  rtB.iMeas_k_1_a = rtDWork.iMeas_k_1_a_DSTATE;

  rtB.G_k_1 = rtDWork.G_k_1_DSTATE;

  rtB.i_hat = rtB.Discrete_Butterworth_a * rtB.G_k_1;

  rtB.Sum1_k = rtB.iMeas_k_1_a - rtB.i_hat;

  rtB.error_u = rtB.Discrete_Butterworth_a * rtB.Sum1_k;

  rtB.mu_a = rtB.error_u * rtP.mu_a_Gain;

  rtB.G_k = rtB.mu_a + rtB.G_k_1;

  rtB.Resiprocal = 1.0/(rtB.G_k);

  rtB.Discrete_Time_Integrat_c = rtDWork.Discrete_Time_Integrat_c_DSTATE;

  rtB.K_E_a = rtB.Ts * rtP.K_E_a_Gain;

  rtB.K_i = rtB.Discrete_Time_Integrat_c * rtP.K_i_Gain;

  rtB.Sum4_c = rtB.Sum2_b - rtB.Sum3_a;

  rtB.K_p_b = rtB.Sum4_c * rtP.K_p_b_Gain;

  rtB.Product_j = rtB.Sum2_b * rtB.Product_e;

  rtB.Sum_i = rtB.Product_j + rtB.K_E_a;

  rtB.Sum2_d = rtB.K_p_b + rtB.K_i;

  rtB.id_b = rtP.id_b_Value;

  rtB.iMeas_k_1_b = rtDWork.iMeas_k_1_b_DSTATE;

  rtB.Abs_i_b = fabs(rtB.iMeas_k_1_b);

  {
    rtB.Discrete_Butterworth_b =
      rtP.Discrete_Butterworth_b_C*rtDWork.Discrete_Butterworth_b_DSTATE[1];
  }

  rtB.Abs_uR_a = fabs(rtB.Discrete_Butterworth_b);

  rtB.alpha_i_b = rtB.alpha_k_1 * rtB.Abs_i_b;

  rtB.Sum4_d = rtB.alpha_i_b + rtB.id_b;

  rtB.beta_b = rtP.beta_b_Value;

  rtB.gamma_i_b = rtB.Abs_i_b * rtP.gamma_i_b_Gain;

  rtB.Sum1_l = rtB.beta_b + rtB.gamma_i_b;

  rtB.Reciprocal_d = 1.0/(rtB.Sum1_l);

  rtB.G = rtB.Sum4_d * rtB.Reciprocal_d;

  rtB.G_u = rtB.G * rtB.Abs_uR_a;

  rtB.vel_k_1_a = rtDWork.vel_k_1_a_DSTATE;

  rtB.K_E_b = rtB.vel_k_1_a * rtP.K_E_b_Gain;

  rtB.pwm_k_1_a = rtDWork.pwm_k_1_a_DSTATE;

  rtB.Sum_j = - rtB.K_E_b + rtB.pwm_k_1_a;

  rtB.Sum3_b = - rtB.G_u + rtB.Abs_i_b;

  rtB.error_phi_u = rtB.Reciprocal_d * rtB.Sum3_b * rtB.Abs_uR_a;

  rtB.mu_gs = rtB.error_phi_u * rtP.mu_gs_Gain;

  rtB.Sum2_e = rtB.mu_gs + rtB.alpha_k_1;

  rtB.vel_k_1_b = rtDWork.vel_k_1_b_DSTATE;

  rtB.K_E_c = rtB.vel_k_1_b * rtP.K_E_c_Gain;

  rtB.pwm_k_1_b = rtDWork.pwm_k_1_b_DSTATE;

  rtB.Sum_k = - rtB.K_E_c + rtB.pwm_k_1_b;

  rtB.Nominal_resistance = rtP.Nominal_resistance_Value;

  rtB.Sum4_e = - rtB.Sum3_a + rtB.Sum2_b;

  rtB.Square_a = rtB.Sum4_e * rtB.Sum4_e;

  rtB.Square_b = rtB.ZOH_2 * rtB.ZOH_2;

  rtB.id_c = rtP.id_c_Value;

  rtB.iMeas_k_1_c = rtDWork.iMeas_k_1_c_DSTATE;

  rtB.Abs_i_c = fabs(rtB.iMeas_k_1_c);

  {
    rtB.Discrete_Butterworth_c =
      rtP.Discrete_Butterworth_c_C*rtDWork.Discrete_Butterworth_c_DSTATE[1];
  }

  rtB.Abs_uR_b = fabs(rtB.Discrete_Butterworth_c);

  rtB.vel_k_1_c = rtDWork.vel_k_1_c_DSTATE;

  rtB.K_E_d = rtB.vel_k_1_c * rtP.K_E_d_Gain;

  rtB.beta_k_1 = rtDWork.beta_k_1_DSTATE;

  rtB.gamma = rtB.Abs_i_c * rtP.gamma_Gain;

  rtB.Sum1_m = rtB.beta_k_1 + rtB.gamma;

  rtB.alpha_b = rtB.Abs_i_c * rtP.alpha_b_Gain;

  rtB.Sum4_f = rtB.alpha_b + rtB.id_c;

  rtB.Reciprocal_e = 1.0/(rtB.Sum4_f);

  rtB.R_b = rtB.Sum1_m * rtB.Reciprocal_e;

  rtB.R_i = rtB.R_b * rtB.Abs_i_c;

  rtB.pwm_k_1_c = rtDWork.pwm_k_1_c_DSTATE;

  rtB.Sum_l = - rtB.K_E_d + rtB.pwm_k_1_c;

  rtB.Sum3_c = - rtB.R_i + rtB.Abs_uR_b;

  rtB.error_phi_i = rtB.Sum3_c * rtB.Abs_i_c * rtB.Reciprocal_e;

  rtB.mu_b = rtB.error_phi_i * rtP.mu_b_Gain;

  rtB.Sum2_f = rtB.mu_b + rtB.beta_k_1;
}

void MdlUpdate(int_T tid)
{
  
  (void)tid;

  rtDWork.Unit_Delay_DSTATE = rtB.Sum_i;

  {
    rtDWork.Difference_DSTATE = rtB.ZOH_3
      +rtP.Difference_A*rtDWork.Difference_DSTATE;
  }

  rtDWork.Discrete_Time_Integrat_a_DSTATE =
    rtDWork.Discrete_Time_Integrat_a_DSTATE + 0.001 * rtB.Square_b;

  rtDWork.Discrete_Time_Integrat_b_DSTATE =
    rtDWork.Discrete_Time_Integrat_b_DSTATE + 0.001 * rtB.Square_a;

  rtDWork.alpha_k_1_DSTATE = rtB.Sum2_e;

  {
    real_T hold_sin;
    real_T hold_cos;

    hold_sin = rtDWork.Pos_a_RWORK.LastSin;
    hold_cos = rtDWork.Pos_a_RWORK.LastCos;

    rtDWork.Pos_a_RWORK.LastSin = hold_sin * rtP.Pos_a_HCos + hold_cos *
      rtP.Pos_a_Hsin;
    rtDWork.Pos_a_RWORK.LastCos = hold_cos * rtP.Pos_a_HCos - hold_sin *
      rtP.Pos_a_Hsin;
  }

  {
    real_T hold_sin;
    real_T hold_cos;

    hold_sin = rtDWork.Vel_a_RWORK.LastSin;
    hold_cos = rtDWork.Vel_a_RWORK.LastCos;

    rtDWork.Vel_a_RWORK.LastSin = hold_sin * rtP.Vel_a_HCos + hold_cos *
      rtP.Vel_a_Hsin;
    rtDWork.Vel_a_RWORK.LastCos = hold_cos * rtP.Vel_a_HCos - hold_sin *
      rtP.Vel_a_Hsin;
  }

  {
    static real_T xnew[2];
    xnew[0] = rtP.Discrete_Butterworth_a_B[0]*rtB.Sum_k;
    xnew[0] +=
      rtP.Discrete_Butterworth_a_A[0]*rtDWork.Discrete_Butterworth_a_DSTATE[0]
      +rtP.Discrete_Butterworth_a_A[1]*rtDWork.Discrete_Butterworth_a_DSTATE[1];

    xnew[1] = rtP.Discrete_Butterworth_a_B[1]*rtB.Sum_k;
    xnew[1] +=
      rtP.Discrete_Butterworth_a_A[2]*rtDWork.Discrete_Butterworth_a_DSTATE[0]
      +rtP.Discrete_Butterworth_a_A[3]*rtDWork.Discrete_Butterworth_a_DSTATE[1];
    (void)memcpy(&rtDWork.Discrete_Butterworth_a_DSTATE[0], xnew,
     sizeof(real_T)*2);
  }

  rtDWork.iMeas_k_1_a_DSTATE = rtB.Sum3_a;

  rtDWork.G_k_1_DSTATE = rtB.G_k;

  rtDWork.Discrete_Time_Integrat_c_DSTATE =
    rtDWork.Discrete_Time_Integrat_c_DSTATE + 0.001 * rtB.Sum4_c;

  rtDWork.iMeas_k_1_b_DSTATE = rtB.Sum3_a;

  {
    static real_T xnew[2];
    xnew[0] = rtP.Discrete_Butterworth_b_B[0]*rtB.Sum_j;
    xnew[0] +=
      rtP.Discrete_Butterworth_b_A[0]*rtDWork.Discrete_Butterworth_b_DSTATE[0]
      +rtP.Discrete_Butterworth_b_A[1]*rtDWork.Discrete_Butterworth_b_DSTATE[1];

    xnew[1] = rtP.Discrete_Butterworth_b_B[1]*rtB.Sum_j;
    xnew[1] +=
      rtP.Discrete_Butterworth_b_A[2]*rtDWork.Discrete_Butterworth_b_DSTATE[0]
      +rtP.Discrete_Butterworth_b_A[3]*rtDWork.Discrete_Butterworth_b_DSTATE[1];
    (void)memcpy(&rtDWork.Discrete_Butterworth_b_DSTATE[0], xnew,
     sizeof(real_T)*2);
  }

  rtDWork.vel_k_1_a_DSTATE = rtB.Ts;

  rtDWork.pwm_k_1_a_DSTATE = rtB.Sum1_c;

  rtDWork.vel_k_1_b_DSTATE = rtB.Ts;

  rtDWork.pwm_k_1_b_DSTATE = rtB.Sum1_c;

  rtDWork.iMeas_k_1_c_DSTATE = 0.0;

  {
    static real_T xnew[2];
    xnew[0] = rtP.Discrete_Butterworth_c_B[0]*rtB.Sum_l;
    xnew[0] +=
      rtP.Discrete_Butterworth_c_A[0]*rtDWork.Discrete_Butterworth_c_DSTATE[0]
      +rtP.Discrete_Butterworth_c_A[1]*rtDWork.Discrete_Butterworth_c_DSTATE[1];

    xnew[1] = rtP.Discrete_Butterworth_c_B[1]*rtB.Sum_l;
    xnew[1] +=
      rtP.Discrete_Butterworth_c_A[2]*rtDWork.Discrete_Butterworth_c_DSTATE[0]
      +rtP.Discrete_Butterworth_c_A[3]*rtDWork.Discrete_Butterworth_c_DSTATE[1];
    (void)memcpy(&rtDWork.Discrete_Butterworth_c_DSTATE[0], xnew,
     sizeof(real_T)*2);
  }

  rtDWork.vel_k_1_c_DSTATE = 0.0;

  rtDWork.beta_k_1_DSTATE = rtB.Sum2_f;

  rtDWork.pwm_k_1_c_DSTATE = 0.0;
}

void MdlTerminate(void)
{
  
  {
    int16_T value;

    value = MQ_dacVoltageToOutput(rtP.Analog_Output_P3);
    MQ_dacOutput(0x320, (uint_T)rtP.Analog_Output_P1, value);
  }

  {
    SimStruct *rts = ssGetSFunction(rtS, 0);
    sfcnTerminate(rts);
  }
}

#include "comparison_reg.h"

#include "WinConLibrary.h"

void MdlRegister( void )
{
  
  {
    WCRegisterVariable("comparison\vCurrent RMS", &rtB.Sqrt_a);
    WCRegisterScope("comparison\vCurrent RMS", 1
     , &rtB.Sqrt_a
     );
  }

  {
    WCRegisterVariable("comparison\vError RMS", &rtB.Sqrt_b);
    WCRegisterScope("comparison\vError RMS", 1
     , &rtB.Sqrt_b
     );
  }

  {
    WCRegisterVariable("comparison\vGS", &rtB.Product_e);
    WCRegisterScope("comparison\vGS", 1
     , &rtB.Product_e
     );
  }

  {
    WCRegisterVariable("comparison\vR", &rtB.EKF[6]);
    WCRegisterScope("comparison\vR", 1
     , &rtB.EKF[6]
     );
  }

  {
    WCRegisterVariable("comparison\vT_L", &rtB.EKF[5]);
    WCRegisterScope("comparison\vT_L", 1
     , &rtB.EKF[5]
     );
  }

  {
    WCRegisterVariable("comparison\valpha", &rtB.alpha_k_1);
    WCRegisterScope("comparison\valpha", 1
     , &rtB.alpha_k_1
     );
  }

  {
    WCRegisterVariable("comparison\vi", &rtB.EKF[0]);
    WCRegisterScope("comparison\vi", 1
     , &rtB.EKF[0]
     );
  }

  {
    WCRegisterVariable("comparison\vi_meas", &rtB.ZOH_1);
    WCRegisterScope("comparison\vi_meas", 1
     , &rtB.ZOH_1
     );
  }

  {
    WCRegisterVariable("comparison\vib", &rtB.EKF[7]);
    WCRegisterScope("comparison\vib", 1
     , &rtB.EKF[7]
     );
  }

  {
    WCRegisterVariable("comparison\vif", &rtB.EKF[2]);
    WCRegisterScope("comparison\vif", 1
     , &rtB.EKF[2]
     );
  }

  {
    WCRegisterVariable("comparison\vif_meas", &rtB.ZOH_2);
    WCRegisterScope("comparison\vif_meas", 1
     , &rtB.ZOH_2
     );
  }

  {
    WCRegisterVariable("comparison\vir", &rtB.Sum2_b);
    WCRegisterScope("comparison\vir", 1
     , &rtB.Sum2_b
     );
  }

  {
    WCRegisterVariable("comparison\vmWinv", &rtB.Resiprocal);
    WCRegisterScope("comparison\vmWinv", 1
     , &rtB.Resiprocal
     );
  }

  {
    WCRegisterVariable("comparison\vomega", &rtB.EKF[3]);
    WCRegisterScope("comparison\vomega", 1
     , &rtB.EKF[3]
     );
  }

  {
    WCRegisterVariable("comparison\vtheta", &rtB.EKF[4]);
    WCRegisterScope("comparison\vtheta", 1
     , &rtB.EKF[4]
     );
  }

  {
    WCRegisterVariable("comparison\vtheta_meas", &rtB.ZOH_3);
    WCRegisterScope("comparison\vtheta_meas", 1
     , &rtB.ZOH_3
     );
  }

  {
    WCRegisterVariable("comparison\vu", &rtB.Sum1_c);
    WCRegisterScope("comparison\vu", 1
     , &rtB.Sum1_c
     );
  }

  {
    WCRegisterVariable("comparison\vAdaptive control law or PI\vUnit Delay",
     &rtB.Unit_Delay);
    WCRegisterVariable("comparison\vOutput\vD//A bias", &rtB.D_A_bias_a);
    WCRegisterVariable("comparison\vOutput\vSum", &rtB.Sum_a);
    WCRegisterVariable("comparison\vOutput\vAmplification", &rtB.Amplification);
    WCRegisterVariable("comparison\vOutput\vSat", &rtB.Sat_a);
    WCRegisterVariable("comparison\vInput\vCurrent", &rtB.Current);
    WCRegisterVariable("comparison\vInput\vCurrent filtered",
     &rtB.Current_filtered);
    WCRegisterVariable("comparison\vInput\vEncoder Input", &rtB.Encoder_Input);
    WCRegisterVariable("comparison\vInput\vK_curr", &rtB.K_curr);
    WCRegisterVariable("comparison\vInput\vZOH 1", &rtB.ZOH_1);
    WCRegisterVariable("comparison\vInput\vK_curr_filt", &rtB.K_curr_filt);
    WCRegisterVariable("comparison\vInput\vZOH 2", &rtB.ZOH_2);
    WCRegisterVariable("comparison\vInput\vrad//count", &rtB.rad_count);
    WCRegisterVariable("comparison\vInput\vZOH 3", &rtB.ZOH_3);
    WCRegisterVariable("comparison\vInput\vDifference", &rtB.Difference);
    WCRegisterVariable("comparison\vInput\vTs", &rtB.Ts);
    WCRegisterVariable("comparison\vRMS 2\vDiscrete-Time Integrator",
     &rtB.Discrete_Time_Integrat_a);
    WCRegisterVariable("comparison\vRMS 2\vRamp\vStep", &rtB.Step_a);
    WCRegisterVariable("comparison\vRMS 2\vRamp\vClock", &rtB.Clock_a);
    WCRegisterVariable("comparison\vRMS 2\vRamp\vConstant", &rtB.Constant_a);
    WCRegisterVariable("comparison\vRMS 2\vRamp\vSum", &rtB.Sum_b);
    WCRegisterVariable("comparison\vRMS 2\vRamp\vProduct", &rtB.Product_a);
    WCRegisterVariable("comparison\vRMS 2\vRamp\vConstant1", &rtB.Constant1_a);
    WCRegisterVariable("comparison\vRMS 2\vRamp\vSum1", &rtB.Sum1_a);
    WCRegisterVariable("comparison\vRMS 2\vReciprocal", &rtB.Reciprocal_a);
    WCRegisterVariable("comparison\vRMS 2\vProduct", &rtB.Product_b);
    WCRegisterVariable("comparison\vRMS 2\vSqrt", &rtB.Sqrt_a);
    WCRegisterVariable("comparison\vRMS 1\vDiscrete-Time Integrator",
     &rtB.Discrete_Time_Integrat_b);
    WCRegisterVariable("comparison\vRMS 1\vRamp\vStep", &rtB.Step_b);
    WCRegisterVariable("comparison\vRMS 1\vRamp\vClock", &rtB.Clock_b);
    WCRegisterVariable("comparison\vRMS 1\vRamp\vConstant", &rtB.Constant_b);
    WCRegisterVariable("comparison\vRMS 1\vRamp\vSum", &rtB.Sum_c);
    WCRegisterVariable("comparison\vRMS 1\vRamp\vProduct", &rtB.Product_c);
    WCRegisterVariable("comparison\vRMS 1\vRamp\vConstant1", &rtB.Constant1_b);
    WCRegisterVariable("comparison\vRMS 1\vRamp\vSum1", &rtB.Sum1_b);
    WCRegisterVariable("comparison\vRMS 1\vReciprocal", &rtB.Reciprocal_b);
    WCRegisterVariable("comparison\vRMS 1\vProduct", &rtB.Product_d);
    WCRegisterVariable("comparison\vRMS 1\vSqrt", &rtB.Sqrt_b);
    WCRegisterVariable("comparison\vD//A bias", &rtB.D_A_bias_b);
    WCRegisterVariable("comparison\vSat", &rtB.Sat_b);
    WCRegisterVariable("comparison\vSum1", &rtB.Sum1_c);
    WCRegisterVariable("comparison\vTmpHiddenBuf1_Driving_EKF_AtInput2[0]",
     &rtB.TmpHiddenBuf1_Driving_EKF_AtInp[0] + 0);
    WCRegisterVariable("comparison\vTmpHiddenBuf1_Driving_EKF_AtInput2[1]",
     &rtB.TmpHiddenBuf1_Driving_EKF_AtInp[0] + 1);
    WCRegisterVariable("comparison\vEKF[0]", &rtB.EKF[0] + 0);
    WCRegisterVariable("comparison\vEKF[1]", &rtB.EKF[0] + 1);
    WCRegisterVariable("comparison\vEKF[2]", &rtB.EKF[0] + 2);
    WCRegisterVariable("comparison\vEKF[3]", &rtB.EKF[0] + 3);
    WCRegisterVariable("comparison\vEKF[4]", &rtB.EKF[0] + 4);
    WCRegisterVariable("comparison\vEKF[5]", &rtB.EKF[0] + 5);
    WCRegisterVariable("comparison\vEKF[6]", &rtB.EKF[0] + 6);
    WCRegisterVariable("comparison\vEKF[7]", &rtB.EKF[0] + 7);
    WCRegisterVariable("comparison\vSum3", &rtB.Sum3_a);
    WCRegisterVariable("comparison\vGain-scheduler\vAbs(i)", &rtB.Abs_i_a);
    WCRegisterVariable("comparison\vGain-scheduler\vgamma*i", &rtB.gamma_i_a);
    WCRegisterVariable("comparison\vGain-scheduler\vbeta", &rtB.beta_a);
    WCRegisterVariable("comparison\vGain-scheduler\vSum1", &rtB.Sum1_d);
    WCRegisterVariable("comparison\vGS adapt alpha\valpha(k-1)", &rtB.alpha_k_1);
    WCRegisterVariable("comparison\vGain-scheduler\valpha*i", &rtB.alpha_i_a);
    WCRegisterVariable("comparison\vGain-scheduler\v1", &rtB.id_a);
    WCRegisterVariable("comparison\vGain-scheduler\vSum", &rtB.Sum_d);
    WCRegisterVariable("comparison\vGain-scheduler\vReciprocal",
     &rtB.Reciprocal_c);
    WCRegisterVariable("comparison\vGain-scheduler\vProduct", &rtB.Product_e);
    WCRegisterVariable("comparison\vRef.\vTraj. pos. ref.", &rtB.Traj_pos_ref);
    WCRegisterVariable("comparison\vRef.\vUp 1\vStep", &rtB.Step_c);
    WCRegisterVariable("comparison\vRef.\vUp 1\vClock", &rtB.Clock_c);
    WCRegisterVariable("comparison\vRef.\vUp 1\vConstant", &rtB.Constant_c);
    WCRegisterVariable("comparison\vRef.\vUp 1\vSum", &rtB.Sum_e);
    WCRegisterVariable("comparison\vRef.\vUp 1\vProduct", &rtB.Product_f);
    WCRegisterVariable("comparison\vRef.\vUp 1\vConstant1", &rtB.Constant1_c);
    WCRegisterVariable("comparison\vRef.\vUp 1\vSum1", &rtB.Sum1_e);
    WCRegisterVariable("comparison\vRef.\vDown 1\vStep", &rtB.Step_d);
    WCRegisterVariable("comparison\vRef.\vDown 1\vClock", &rtB.Clock_d);
    WCRegisterVariable("comparison\vRef.\vDown 1\vConstant", &rtB.Constant_d);
    WCRegisterVariable("comparison\vRef.\vDown 1\vSum", &rtB.Sum_f);
    WCRegisterVariable("comparison\vRef.\vDown 1\vProduct", &rtB.Product_g);
    WCRegisterVariable("comparison\vRef.\vDown 1\vConstant1", &rtB.Constant1_d);
    WCRegisterVariable("comparison\vRef.\vDown 1\vSum1", &rtB.Sum1_f);
    WCRegisterVariable("comparison\vRef.\vSum2", &rtB.Sum2_a);
    WCRegisterVariable("comparison\vRef.\vPos.", &rtB.Pos_a);
    WCRegisterVariable("comparison\vRef.\vPos", &rtB.Pos_b);
    WCRegisterVariable("comparison\vRef.\vSum1", &rtB.Sum1_g);
    WCRegisterVariable("comparison\vPD\vSum4", &rtB.Sum4_a);
    WCRegisterVariable("comparison\vPD\vK_p", &rtB.K_p_a);
    WCRegisterVariable("comparison\vRef.\vTraj. vel. ref.", &rtB.Traj_vel_ref);
    WCRegisterVariable("comparison\vRef.\vUp 2\vStep", &rtB.Step_e);
    WCRegisterVariable("comparison\vRef.\vUp 2\vClock", &rtB.Clock_e);
    WCRegisterVariable("comparison\vRef.\vUp 2\vConstant", &rtB.Constant_e);
    WCRegisterVariable("comparison\vRef.\vUp 2\vSum", &rtB.Sum_g);
    WCRegisterVariable("comparison\vRef.\vUp 2\vProduct", &rtB.Product_h);
    WCRegisterVariable("comparison\vRef.\vUp 2\vConstant1", &rtB.Constant1_e);
    WCRegisterVariable("comparison\vRef.\vUp 2\vSum1", &rtB.Sum1_h);
    WCRegisterVariable("comparison\vRef.\vDown 2\vStep", &rtB.Step_f);
    WCRegisterVariable("comparison\vRef.\vDown 2\vClock", &rtB.Clock_f);
    WCRegisterVariable("comparison\vRef.\vDown 2\vConstant", &rtB.Constant_f);
    WCRegisterVariable("comparison\vRef.\vDown 2\vSum", &rtB.Sum_h);
    WCRegisterVariable("comparison\vRef.\vDown 2\vProduct", &rtB.Product_i);
    WCRegisterVariable("comparison\vRef.\vDown 2\vConstant1", &rtB.Constant1_f);
    WCRegisterVariable("comparison\vRef.\vDown 2\vSum1", &rtB.Sum1_i);
    WCRegisterVariable("comparison\vRef.\vSum4", &rtB.Sum4_b);
    WCRegisterVariable("comparison\vRef.\vVel.", &rtB.Vel_a);
    WCRegisterVariable("comparison\vRef.\vVel", &rtB.Vel_b);
    WCRegisterVariable("comparison\vRef.\vSum5", &rtB.Sum5);
    WCRegisterVariable("comparison\vPD\vSum1", &rtB.Sum1_j);
    WCRegisterVariable("comparison\vPD\vK_d", &rtB.K_d);
    WCRegisterVariable("comparison\vPD\vSum2", &rtB.Sum2_b);
    WCRegisterVariable("comparison\vLMS\vDiscrete Butterworth",
     &rtB.Discrete_Butterworth_a);
    WCRegisterVariable("comparison\vLMS\viMeas(k-1)", &rtB.iMeas_k_1_a);
    WCRegisterVariable("comparison\vLMS\vG(k-1)", &rtB.G_k_1);
    WCRegisterVariable("comparison\vLMS\vi_hat", &rtB.i_hat);
    WCRegisterVariable("comparison\vLMS\vSum1", &rtB.Sum1_k);
    WCRegisterVariable("comparison\vLMS\verror*u", &rtB.error_u);
    WCRegisterVariable("comparison\vLMS\vmu", &rtB.mu_a);
    WCRegisterVariable("comparison\vLMS\vG(k)", &rtB.G_k);
    WCRegisterVariable("comparison\vLMS\vResiprocal", &rtB.Resiprocal);
    WCRegisterVariable("comparison\vAdaptive control law or PI\vDiscrete-Time Integrator",
     &rtB.Discrete_Time_Integrat_c);
    WCRegisterVariable("comparison\vAdaptive control law or PI\vK_E",
     &rtB.K_E_a);
    WCRegisterVariable("comparison\vAdaptive control law or PI\vK_i", &rtB.K_i);
    WCRegisterVariable("comparison\vAdaptive control law or PI\vSum4",
     &rtB.Sum4_c);
    WCRegisterVariable("comparison\vAdaptive control law or PI\vK_p",
     &rtB.K_p_b);
    WCRegisterVariable("comparison\vAdaptive control law or PI\vProduct",
     &rtB.Product_j);
    WCRegisterVariable("comparison\vAdaptive control law or PI\vSum",
     &rtB.Sum_i);
    WCRegisterVariable("comparison\vAdaptive control law or PI\vSum2",
     &rtB.Sum2_d);
    WCRegisterVariable("comparison\vGS adapt alpha\v1", &rtB.id_b);
    WCRegisterVariable("comparison\vGS adapt alpha\viMeas(k-1)",
     &rtB.iMeas_k_1_b);
    WCRegisterVariable("comparison\vGS adapt alpha\vAbs(i)", &rtB.Abs_i_b);
    WCRegisterVariable("comparison\vGS adapt alpha\vDiscrete Butterworth",
     &rtB.Discrete_Butterworth_b);
    WCRegisterVariable("comparison\vGS adapt alpha\vAbs(uR)", &rtB.Abs_uR_a);
    WCRegisterVariable("comparison\vGS adapt alpha\valpha*i", &rtB.alpha_i_b);
    WCRegisterVariable("comparison\vGS adapt alpha\vSum4", &rtB.Sum4_d);
    WCRegisterVariable("comparison\vGS adapt alpha\vbeta", &rtB.beta_b);
    WCRegisterVariable("comparison\vGS adapt alpha\vgamma*i", &rtB.gamma_i_b);
    WCRegisterVariable("comparison\vGS adapt alpha\vSum1", &rtB.Sum1_l);
    WCRegisterVariable("comparison\vGS adapt alpha\vReciprocal",
     &rtB.Reciprocal_d);
    WCRegisterVariable("comparison\vGS adapt alpha\vG", &rtB.G);
    WCRegisterVariable("comparison\vGS adapt alpha\vG*u", &rtB.G_u);
    WCRegisterVariable("comparison\vGS adapt alpha\vvel(k-1)", &rtB.vel_k_1_a);
    WCRegisterVariable("comparison\vGS adapt alpha\vK_E", &rtB.K_E_b);
    WCRegisterVariable("comparison\vGS adapt alpha\vpwm(k-1)", &rtB.pwm_k_1_a);
    WCRegisterVariable("comparison\vGS adapt alpha\vSum", &rtB.Sum_j);
    WCRegisterVariable("comparison\vGS adapt alpha\vSum3", &rtB.Sum3_b);
    WCRegisterVariable("comparison\vGS adapt alpha\verror*phi*u",
     &rtB.error_phi_u);
    WCRegisterVariable("comparison\vGS adapt alpha\vmu_gs", &rtB.mu_gs);
    WCRegisterVariable("comparison\vGS adapt alpha\vSum2", &rtB.Sum2_e);
    WCRegisterVariable("comparison\vLMS\vvel(k-1)", &rtB.vel_k_1_b);
    WCRegisterVariable("comparison\vLMS\vK_E", &rtB.K_E_c);
    WCRegisterVariable("comparison\vLMS\vpwm(k-1)", &rtB.pwm_k_1_b);
    WCRegisterVariable("comparison\vLMS\vSum", &rtB.Sum_k);
    WCRegisterVariable("comparison\vNominal resistance",
     &rtB.Nominal_resistance);
    WCRegisterVariable("comparison\vSum4", &rtB.Sum4_e);
    WCRegisterVariable("comparison\vRMS 1\vSquare", &rtB.Square_a);
    WCRegisterVariable("comparison\vRMS 2\vSquare", &rtB.Square_b);
    WCRegisterVariable("comparison\vGS adapt beta\v1", &rtB.id_c);
    WCRegisterVariable("comparison\vGS adapt beta\viMeas(k-1)",
     &rtB.iMeas_k_1_c);
    WCRegisterVariable("comparison\vGS adapt beta\vAbs(i)", &rtB.Abs_i_c);
    WCRegisterVariable("comparison\vGS adapt beta\vDiscrete Butterworth",
     &rtB.Discrete_Butterworth_c);
    WCRegisterVariable("comparison\vGS adapt beta\vAbs(uR)", &rtB.Abs_uR_b);
    WCRegisterVariable("comparison\vGS adapt beta\vvel(k-1)", &rtB.vel_k_1_c);
    WCRegisterVariable("comparison\vGS adapt beta\vK_E", &rtB.K_E_d);
    WCRegisterVariable("comparison\vGS adapt beta\vbeta(k-1)", &rtB.beta_k_1);
    WCRegisterVariable("comparison\vGS adapt beta\vgamma", &rtB.gamma);
    WCRegisterVariable("comparison\vGS adapt beta\vSum1", &rtB.Sum1_m);
    WCRegisterVariable("comparison\vGS adapt beta\valpha", &rtB.alpha_b);
    WCRegisterVariable("comparison\vGS adapt beta\vSum4", &rtB.Sum4_f);
    WCRegisterVariable("comparison\vGS adapt beta\vReciprocal",
     &rtB.Reciprocal_e);
    WCRegisterVariable("comparison\vGS adapt beta\vR", &rtB.R_b);
    WCRegisterVariable("comparison\vGS adapt beta\vR*i", &rtB.R_i);
    WCRegisterVariable("comparison\vGS adapt beta\vpwm(k-1)", &rtB.pwm_k_1_c);
    WCRegisterVariable("comparison\vGS adapt beta\vSum", &rtB.Sum_l);
    WCRegisterVariable("comparison\vGS adapt beta\vSum3", &rtB.Sum3_c);
    WCRegisterVariable("comparison\vGS adapt beta\verror*phi*i",
     &rtB.error_phi_i);
    WCRegisterVariable("comparison\vGS adapt beta\vmu", &rtB.mu_b);
    WCRegisterVariable("comparison\vGS adapt beta\vSum2", &rtB.Sum2_f);
  }

  {
    WCRegisterScalarParameter("comparison\vAdaptive control law or PI\vUnit Delay\vX0",
     &rtP.Unit_Delay_X0);

    WCRegisterScalarParameter("comparison\vOutput\vD//A bias\vValue",
     &rtP.D_A_bias_a_Value);

    WCRegisterScalarParameter("comparison\vOutput\vAmplification\vGain",
     &rtP.Amplification_Gain);

    WCRegisterScalarParameter("comparison\vOutput\vSat\vUpperLimit",
     &rtP.Sat_a_UpperSat);

    WCRegisterScalarParameter("comparison\vOutput\vSat\vLowerLimit",
     &rtP.Sat_a_LowerSat);

    WCRegisterScalarParameter("comparison\vOutput\vAnalog Output\vChannels",
     &rtP.Analog_Output_P1);

    WCRegisterScalarParameter("comparison\vOutput\vAnalog Output\vInitialOutputs",
     &rtP.Analog_Output_P2);

    WCRegisterScalarParameter("comparison\vOutput\vAnalog Output\vFinalOutputs",
     &rtP.Analog_Output_P3);

    WCRegisterScalarParameter("comparison\vInput\vCurrent\vChannels",
     &rtP.Current_P1);

    WCRegisterScalarParameter("comparison\vInput\vCurrent filtered\vChannels",
     &rtP.Current_filtered_P1);

    WCRegisterScalarParameter("comparison\vInput\vEncoder Input\vChannels",
     &rtP.Encoder_Input_P1);

    WCRegisterScalarParameter("comparison\vInput\vEncoder Input\vInitialValues",
     &rtP.Encoder_Input_P2);

    WCRegisterScalarParameter("comparison\vInput\vK_curr\vGain",
     &rtP.K_curr_Gain);

    WCRegisterScalarParameter("comparison\vInput\vK_curr_filt\vGain",
     &rtP.K_curr_filt_Gain);

    WCRegisterScalarParameter("comparison\vInput\vrad//count\vGain",
     &rtP.rad_count_Gain);

    WCRegisterScalarParameter("comparison\vInput\vTs\vGain", &rtP.Ts_Gain);

    WCRegisterScalarParameter("comparison\vRMS 2\vDiscrete-Time Integrator\vInitialCondition",
     &rtP.Discrete_Time_Integrat_a_IC);

    WCRegisterScalarParameter("comparison\vRMS 2\vRamp\vStep\vTime",
     &rtP.Step_a_Time);

    WCRegisterScalarParameter("comparison\vRMS 2\vRamp\vStep\vBefore",
     &rtP.Step_a_Y0);

    WCRegisterScalarParameter("comparison\vRMS 2\vRamp\vStep\vAfter",
     &rtP.Step_a_YFinal);

    WCRegisterScalarParameter("comparison\vRMS 2\vRamp\vConstant\vValue",
     &rtP.Constant_a_Value);

    WCRegisterScalarParameter("comparison\vRMS 2\vRamp\vConstant1\vValue",
     &rtP.Constant1_a_Value);

    WCRegisterScalarParameter("comparison\vRMS 1\vDiscrete-Time Integrator\vInitialCondition",
     &rtP.Discrete_Time_Integrat_b_IC);

    WCRegisterScalarParameter("comparison\vRMS 1\vRamp\vStep\vTime",
     &rtP.Step_b_Time);

    WCRegisterScalarParameter("comparison\vRMS 1\vRamp\vStep\vBefore",
     &rtP.Step_b_Y0);

    WCRegisterScalarParameter("comparison\vRMS 1\vRamp\vStep\vAfter",
     &rtP.Step_b_YFinal);

    WCRegisterScalarParameter("comparison\vRMS 1\vRamp\vConstant\vValue",
     &rtP.Constant_b_Value);

    WCRegisterScalarParameter("comparison\vRMS 1\vRamp\vConstant1\vValue",
     &rtP.Constant1_b_Value);

    WCRegisterScalarParameter("comparison\vD//A bias\vValue",
     &rtP.D_A_bias_b_Value);

    WCRegisterScalarParameter("comparison\vSat\vUpperLimit",
     &rtP.Sat_b_UpperSat);

    WCRegisterScalarParameter("comparison\vSat\vLowerLimit",
     &rtP.Sat_b_LowerSat);

    WCRegisterVectorParameter("comparison\vEKF\vP1", 8, &rtP.EKF_P1[0]);

    WCRegisterVectorParameter("comparison\vEKF\vP2", 8, &rtP.EKF_P2[0]);

    WCRegisterScalarParameter("comparison\vGain-scheduler\vgamma*i\vGain",
     &rtP.gamma_i_a_Gain);

    WCRegisterScalarParameter("comparison\vGain-scheduler\vbeta\vValue",
     &rtP.beta_a_Value);

    WCRegisterScalarParameter("comparison\vGS adapt alpha\valpha(k-1)\vX0",
     &rtP.alpha_k_1_X0);

    WCRegisterScalarParameter("comparison\vGain-scheduler\v1\vValue",
     &rtP.id_a_Value);

    WCRegisterScalarParameter("comparison\vRef.\vUp 1\vStep\vTime",
     &rtP.Step_c_Time);

    WCRegisterScalarParameter("comparison\vRef.\vUp 1\vStep\vBefore",
     &rtP.Step_c_Y0);

    WCRegisterScalarParameter("comparison\vRef.\vUp 1\vStep\vAfter",
     &rtP.Step_c_YFinal);

    WCRegisterScalarParameter("comparison\vRef.\vUp 1\vConstant\vValue",
     &rtP.Constant_c_Value);

    WCRegisterScalarParameter("comparison\vRef.\vUp 1\vConstant1\vValue",
     &rtP.Constant1_c_Value);

    WCRegisterScalarParameter("comparison\vRef.\vDown 1\vStep\vTime",
     &rtP.Step_d_Time);

    WCRegisterScalarParameter("comparison\vRef.\vDown 1\vStep\vBefore",
     &rtP.Step_d_Y0);

    WCRegisterScalarParameter("comparison\vRef.\vDown 1\vStep\vAfter",
     &rtP.Step_d_YFinal);

    WCRegisterScalarParameter("comparison\vRef.\vDown 1\vConstant\vValue",
     &rtP.Constant_d_Value);

    WCRegisterScalarParameter("comparison\vRef.\vDown 1\vConstant1\vValue",
     &rtP.Constant1_d_Value);

    WCRegisterScalarParameter("comparison\vRef.\vPos.\vAmplitude",
     &rtP.Pos_a_Amp);

    WCRegisterScalarParameter("comparison\vRef.\vPos.\vBias", &rtP.Pos_a_Bias);

    WCRegisterScalarParameter("comparison\vRef.\vPos.\vFrequency",
     &rtP.Pos_a_Freq);

    WCRegisterScalarParameter("comparison\vPD\vK_p\vGain", &rtP.K_p_a_Gain);

    WCRegisterScalarParameter("comparison\vRef.\vUp 2\vStep\vTime",
     &rtP.Step_e_Time);

    WCRegisterScalarParameter("comparison\vRef.\vUp 2\vStep\vBefore",
     &rtP.Step_e_Y0);

    WCRegisterScalarParameter("comparison\vRef.\vUp 2\vStep\vAfter",
     &rtP.Step_e_YFinal);

    WCRegisterScalarParameter("comparison\vRef.\vUp 2\vConstant\vValue",
     &rtP.Constant_e_Value);

    WCRegisterScalarParameter("comparison\vRef.\vUp 2\vConstant1\vValue",
     &rtP.Constant1_e_Value);

    WCRegisterScalarParameter("comparison\vRef.\vDown 2\vStep\vTime",
     &rtP.Step_f_Time);

    WCRegisterScalarParameter("comparison\vRef.\vDown 2\vStep\vBefore",
     &rtP.Step_f_Y0);

    WCRegisterScalarParameter("comparison\vRef.\vDown 2\vStep\vAfter",
     &rtP.Step_f_YFinal);

    WCRegisterScalarParameter("comparison\vRef.\vDown 2\vConstant\vValue",
     &rtP.Constant_f_Value);

    WCRegisterScalarParameter("comparison\vRef.\vDown 2\vConstant1\vValue",
     &rtP.Constant1_f_Value);

    WCRegisterScalarParameter("comparison\vRef.\vVel.\vAmplitude",
     &rtP.Vel_a_Amp);

    WCRegisterScalarParameter("comparison\vRef.\vVel.\vBias", &rtP.Vel_a_Bias);

    WCRegisterScalarParameter("comparison\vRef.\vVel.\vFrequency",
     &rtP.Vel_a_Freq);

    WCRegisterScalarParameter("comparison\vPD\vK_d\vGain", &rtP.K_d_Gain);

    WCRegisterScalarParameter("comparison\vLMS\vDiscrete Butterworth\vX0",
     &rtP.Discrete_Butterworth_a_X0);

    WCRegisterScalarParameter("comparison\vLMS\viMeas(k-1)\vX0",
     &rtP.iMeas_k_1_a_X0);

    WCRegisterScalarParameter("comparison\vLMS\vG(k-1)\vX0", &rtP.G_k_1_X0);

    WCRegisterScalarParameter("comparison\vLMS\vmu\vGain", &rtP.mu_a_Gain);

    WCRegisterScalarParameter("comparison\vAdaptive control law or PI\vDiscrete-Time Integrator\vInitialCondition",
     &rtP.Discrete_Time_Integrat_c_IC);

    WCRegisterScalarParameter("comparison\vAdaptive control law or PI\vK_E\vGain",
     &rtP.K_E_a_Gain);

    WCRegisterScalarParameter("comparison\vAdaptive control law or PI\vK_i\vGain",
     &rtP.K_i_Gain);

    WCRegisterScalarParameter("comparison\vAdaptive control law or PI\vK_p\vGain",
     &rtP.K_p_b_Gain);

    WCRegisterScalarParameter("comparison\vGS adapt alpha\v1\vValue",
     &rtP.id_b_Value);

    WCRegisterScalarParameter("comparison\vGS adapt alpha\viMeas(k-1)\vX0",
     &rtP.iMeas_k_1_b_X0);

    WCRegisterScalarParameter("comparison\vGS adapt alpha\vDiscrete Butterworth\vX0",
     &rtP.Discrete_Butterworth_b_X0);

    WCRegisterScalarParameter("comparison\vGS adapt alpha\vbeta\vValue",
     &rtP.beta_b_Value);

    WCRegisterScalarParameter("comparison\vGS adapt alpha\vgamma*i\vGain",
     &rtP.gamma_i_b_Gain);

    WCRegisterScalarParameter("comparison\vGS adapt alpha\vvel(k-1)\vX0",
     &rtP.vel_k_1_a_X0);

    WCRegisterScalarParameter("comparison\vGS adapt alpha\vK_E\vGain",
     &rtP.K_E_b_Gain);

    WCRegisterScalarParameter("comparison\vGS adapt alpha\vpwm(k-1)\vX0",
     &rtP.pwm_k_1_a_X0);

    WCRegisterScalarParameter("comparison\vGS adapt alpha\vmu_gs\vGain",
     &rtP.mu_gs_Gain);

    WCRegisterScalarParameter("comparison\vLMS\vvel(k-1)\vX0",
     &rtP.vel_k_1_b_X0);

    WCRegisterScalarParameter("comparison\vLMS\vK_E\vGain", &rtP.K_E_c_Gain);

    WCRegisterScalarParameter("comparison\vLMS\vpwm(k-1)\vX0",
     &rtP.pwm_k_1_b_X0);

    WCRegisterScalarParameter("comparison\vNominal resistance\vValue",
     &rtP.Nominal_resistance_Value);

    WCRegisterScalarParameter("comparison\vGS adapt beta\v1\vValue",
     &rtP.id_c_Value);

    WCRegisterScalarParameter("comparison\vGS adapt beta\viMeas(k-1)\vX0",
     &rtP.iMeas_k_1_c_X0);

    WCRegisterScalarParameter("comparison\vGS adapt beta\vDiscrete Butterworth\vX0",
     &rtP.Discrete_Butterworth_c_X0);

    WCRegisterScalarParameter("comparison\vGS adapt beta\vvel(k-1)\vX0",
     &rtP.vel_k_1_c_X0);

    WCRegisterScalarParameter("comparison\vGS adapt beta\vK_E\vGain",
     &rtP.K_E_d_Gain);

    WCRegisterScalarParameter("comparison\vGS adapt beta\vbeta(k-1)\vX0",
     &rtP.beta_k_1_X0);

    WCRegisterScalarParameter("comparison\vGS adapt beta\vgamma\vGain",
     &rtP.gamma_Gain);

    WCRegisterScalarParameter("comparison\vGS adapt beta\valpha\vGain",
     &rtP.alpha_b_Gain);

    WCRegisterScalarParameter("comparison\vGS adapt beta\vpwm(k-1)\vX0",
     &rtP.pwm_k_1_c_X0);

    WCRegisterScalarParameter("comparison\vGS adapt beta\vmu\vGain",
     &rtP.mu_b_Gain);
  }
}

void MdlChecksum( uint_T iValues[4] )
{

  iValues[0] = 2211699589U;
  iValues[1] = 751753027U;
  iValues[2] = 3161353201U;
  iValues[3] = 390333186U;
}

uint_T MdlGetNumDataTypes()
{
  return 13;
}

boolean_T MdlGetDataTypeSizes(uint_T *puSizes, uint_T cDataTypes)
{
  
  
  
  

  if (cDataTypes == 13)
  {
    memcpy(puSizes, rtDataTypeSizes, cDataTypes * sizeof(uint_T));
    return 1; 
  }

  return 0; 
}

real_T MdlSamplingPeriod( void )
{
  return(0.001);
}

