#ifndef _RTW_COMMON_HEADER_FILE_
#define _RTW_COMMON_HEADER_FILE_

#ifndef TRUE
# define TRUE (1)
#endif
#ifndef FALSE
# define FALSE (0)
#endif

#define fcn_call_T                      real_T
#define pointer_T                       void*
#define action_T                        real_T

#ifndef RT_SQUARE
#define RT_SQUARE(x) ( x * x )
#endif

#ifndef rtInterpolate
# define rtInterpolate(v1,v2,f1,f2) (((v1)==(v2))?((double)(v1)): (((f1)*((double)(v1)))+((f2)*((double)(v2)))))
#endif

#ifndef rtRound
# define rtRound(v) ( ((v) >= 0) ? floor((v) + 0.5) : ceil((v) - 0.5) )
#endif

#define assert(exp)

#include <math.h>

#include "simstruc.h"
#include "rtlibsrc.h"
#include "dt_info.h"
#include "comparison_export.h"

#include "multiqda.h"
#include "multiqad.h"
#include "mq3en.h"

typedef struct BlockIO_tag {
  real_T Unit_Delay;
  real_T D_A_bias_a;
  real_T Sum_a;
  real_T Amplification;
  real_T Sat_a;
  real_T Current;
  real_T Current_filtered;
  real_T Encoder_Input;
  real_T K_curr;
  real_T ZOH_1;
  real_T K_curr_filt;
  real_T ZOH_2;
  real_T rad_count;
  real_T ZOH_3;
  real_T Difference;
  real_T Ts;
  real_T Discrete_Time_Integrat_a;
  real_T Step_a;
  real_T Clock_a;
  real_T Constant_a;
  real_T Sum_b;
  real_T Product_a;
  real_T Constant1_a;
  real_T Sum1_a;
  real_T Reciprocal_a;
  real_T Product_b;
  real_T Sqrt_a;
  real_T Discrete_Time_Integrat_b;
  real_T Step_b;
  real_T Clock_b;
  real_T Constant_b;
  real_T Sum_c;
  real_T Product_c;
  real_T Constant1_b;
  real_T Sum1_b;
  real_T Reciprocal_b;
  real_T Product_d;
  real_T Sqrt_b;
  real_T D_A_bias_b;
  real_T Sat_b;
  real_T Sum1_c;
  real_T TmpHiddenBuf1_Driving_EKF_AtInp[2];
  real_T EKF[8];
  real_T Sum3_a;
  real_T Abs_i_a;
  real_T gamma_i_a;
  real_T beta_a;
  real_T Sum1_d;
  real_T alpha_k_1;
  real_T alpha_i_a;
  real_T id_a;
  real_T Sum_d;
  real_T Reciprocal_c;
  real_T Product_e;
  real_T Traj_pos_ref;
  real_T Step_c;
  real_T Clock_c;
  real_T Constant_c;
  real_T Sum_e;
  real_T Product_f;
  real_T Constant1_c;
  real_T Sum1_e;
  real_T Step_d;
  real_T Clock_d;
  real_T Constant_d;
  real_T Sum_f;
  real_T Product_g;
  real_T Constant1_d;
  real_T Sum1_f;
  real_T Sum2_a;
  real_T Pos_a;
  real_T Pos_b;
  real_T Sum1_g;
  real_T Sum4_a;
  real_T K_p_a;
  real_T Traj_vel_ref;
  real_T Step_e;
  real_T Clock_e;
  real_T Constant_e;
  real_T Sum_g;
  real_T Product_h;
  real_T Constant1_e;
  real_T Sum1_h;
  real_T Step_f;
  real_T Clock_f;
  real_T Constant_f;
  real_T Sum_h;
  real_T Product_i;
  real_T Constant1_f;
  real_T Sum1_i;
  real_T Sum4_b;
  real_T Vel_a;
  real_T Vel_b;
  real_T Sum5;
  real_T Sum1_j;
  real_T K_d;
  real_T Sum2_b;
  real_T Discrete_Butterworth_a;
  real_T iMeas_k_1_a;
  real_T G_k_1;
  real_T i_hat;
  real_T Sum1_k;
  real_T error_u;
  real_T mu_a;
  real_T G_k;
  real_T Resiprocal;
  real_T Discrete_Time_Integrat_c;
  real_T K_E_a;
  real_T K_i;
  real_T Sum4_c;
  real_T K_p_b;
  real_T Product_j;
  real_T Sum_i;
  real_T Sum2_d;
  real_T id_b;
  real_T iMeas_k_1_b;
  real_T Abs_i_b;
  real_T Discrete_Butterworth_b;
  real_T Abs_uR_a;
  real_T alpha_i_b;
  real_T Sum4_d;
  real_T beta_b;
  real_T gamma_i_b;
  real_T Sum1_l;
  real_T Reciprocal_d;
  real_T G;
  real_T G_u;
  real_T vel_k_1_a;
  real_T K_E_b;
  real_T pwm_k_1_a;
  real_T Sum_j;
  real_T Sum3_b;
  real_T error_phi_u;
  real_T mu_gs;
  real_T Sum2_e;
  real_T vel_k_1_b;
  real_T K_E_c;
  real_T pwm_k_1_b;
  real_T Sum_k;
  real_T Nominal_resistance;
  real_T Sum4_e;
  real_T Square_a;
  real_T Square_b;
  real_T id_c;
  real_T iMeas_k_1_c;
  real_T Abs_i_c;
  real_T Discrete_Butterworth_c;
  real_T Abs_uR_b;
  real_T vel_k_1_c;
  real_T K_E_d;
  real_T beta_k_1;
  real_T gamma;
  real_T Sum1_m;
  real_T alpha_b;
  real_T Sum4_f;
  real_T Reciprocal_e;
  real_T R_b;
  real_T R_i;
  real_T pwm_k_1_c;
  real_T Sum_l;
  real_T Sum3_c;
  real_T error_phi_i;
  real_T mu_b;
  real_T Sum2_f;
} BlockIO;

typedef struct Parameters_tag {
  real_T Unit_Delay_X0;
  real_T D_A_bias_a_Value;
  real_T Amplification_Gain;
  real_T Sat_a_UpperSat;
  real_T Sat_a_LowerSat;
  real_T Analog_Output_P1;
  real_T Analog_Output_P2;
  real_T Analog_Output_P3;
  real_T Current_P1;
  real_T Current_filtered_P1;
  real_T Encoder_Input_P1;
  real_T Encoder_Input_P2;
  real_T K_curr_Gain;
  real_T K_curr_filt_Gain;
  real_T rad_count_Gain;
  real_T Difference_A;
  real_T Difference_C;
  real_T Difference_D;

  real_T Ts_Gain;
  real_T Discrete_Time_Integrat_a_IC;
  real_T Step_a_Time;
  real_T Step_a_Y0;
  real_T Step_a_YFinal;
  real_T Constant_a_Value;
  real_T Constant1_a_Value;
  real_T Discrete_Time_Integrat_b_IC;
  real_T Step_b_Time;
  real_T Step_b_Y0;
  real_T Step_b_YFinal;
  real_T Constant_b_Value;
  real_T Constant1_b_Value;
  real_T D_A_bias_b_Value;
  real_T Sat_b_UpperSat;
  real_T Sat_b_LowerSat;
  real_T EKF_P1_Size[2];
  real_T EKF_P1[8];
  real_T EKF_P2_Size[2];
  real_T EKF_P2[8];
  real_T gamma_i_a_Gain;
  real_T beta_a_Value;
  real_T alpha_k_1_X0;
  real_T id_a_Value;
  real_T Step_c_Time;
  real_T Step_c_Y0;
  real_T Step_c_YFinal;
  real_T Constant_c_Value;
  real_T Constant1_c_Value;
  real_T Step_d_Time;
  real_T Step_d_Y0;
  real_T Step_d_YFinal;
  real_T Constant_d_Value;
  real_T Constant1_d_Value;
  real_T Pos_a_Amp;
  real_T Pos_a_Bias;
  real_T Pos_a_Freq;
  real_T Pos_a_Hsin;
  real_T Pos_a_HCos;
  real_T Pos_a_PSin;
  real_T Pos_a_PCos;
  real_T K_p_a_Gain;
  real_T Step_e_Time;
  real_T Step_e_Y0;
  real_T Step_e_YFinal;
  real_T Constant_e_Value;
  real_T Constant1_e_Value;
  real_T Step_f_Time;
  real_T Step_f_Y0;
  real_T Step_f_YFinal;
  real_T Constant_f_Value;
  real_T Constant1_f_Value;
  real_T Vel_a_Amp;
  real_T Vel_a_Bias;
  real_T Vel_a_Freq;
  real_T Vel_a_Hsin;
  real_T Vel_a_HCos;
  real_T Vel_a_PSin;
  real_T Vel_a_PCos;
  real_T K_d_Gain;
  real_T Discrete_Butterworth_a_A[4];
  real_T Discrete_Butterworth_a_B[2];
  real_T Discrete_Butterworth_a_C;

  real_T Discrete_Butterworth_a_X0;
  real_T iMeas_k_1_a_X0;
  real_T G_k_1_X0;
  real_T mu_a_Gain;
  real_T Discrete_Time_Integrat_c_IC;
  real_T K_E_a_Gain;
  real_T K_i_Gain;
  real_T K_p_b_Gain;
  real_T id_b_Value;
  real_T iMeas_k_1_b_X0;
  real_T Discrete_Butterworth_b_A[4];
  real_T Discrete_Butterworth_b_B[2];
  real_T Discrete_Butterworth_b_C;

  real_T Discrete_Butterworth_b_X0;
  real_T beta_b_Value;
  real_T gamma_i_b_Gain;
  real_T vel_k_1_a_X0;
  real_T K_E_b_Gain;
  real_T pwm_k_1_a_X0;
  real_T mu_gs_Gain;
  real_T vel_k_1_b_X0;
  real_T K_E_c_Gain;
  real_T pwm_k_1_b_X0;
  real_T Nominal_resistance_Value;
  real_T id_c_Value;
  real_T iMeas_k_1_c_X0;
  real_T Discrete_Butterworth_c_A[4];
  real_T Discrete_Butterworth_c_B[2];
  real_T Discrete_Butterworth_c_C;

  real_T Discrete_Butterworth_c_X0;
  real_T vel_k_1_c_X0;
  real_T K_E_d_Gain;
  real_T beta_k_1_X0;
  real_T gamma_Gain;
  real_T alpha_b_Gain;
  real_T pwm_k_1_c_X0;
  real_T mu_b_Gain;
} Parameters;

typedef struct D_Work_tag {
  real_T Unit_Delay_DSTATE;
  real_T Difference_DSTATE;
  real_T Discrete_Time_Integrat_a_DSTATE;
  real_T Discrete_Time_Integrat_b_DSTATE;
  real_T EKF_DSTATE[8];
  real_T alpha_k_1_DSTATE;
  real_T Discrete_Butterworth_a_DSTATE[2];
  real_T iMeas_k_1_a_DSTATE;
  real_T G_k_1_DSTATE;
  real_T Discrete_Time_Integrat_c_DSTATE;
  real_T iMeas_k_1_b_DSTATE;
  real_T Discrete_Butterworth_b_DSTATE[2];
  real_T vel_k_1_a_DSTATE;
  real_T pwm_k_1_a_DSTATE;
  real_T vel_k_1_b_DSTATE;
  real_T pwm_k_1_b_DSTATE;
  real_T iMeas_k_1_c_DSTATE;
  real_T Discrete_Butterworth_c_DSTATE[2];
  real_T vel_k_1_c_DSTATE;
  real_T beta_k_1_DSTATE;
  real_T pwm_k_1_c_DSTATE;
  struct {
    real_T LastSin;
    real_T LastCos;
  } Pos_a_RWORK;
  struct {
    real_T LastSin;
    real_T LastCos;
  } Vel_a_RWORK;
  struct {
    void *LoggedData;
  } Current_RMS_PWORK;
  struct {
    void *LoggedData;
  } Error_RMS_PWORK;
  void *EKF_PWORK[13];
  struct {
    void *LoggedData;
  } GS_PWORK;
  struct {
    void *LoggedData;
  } R_a_PWORK;
  struct {
    void *LoggedData;
  } T_L_PWORK;
  struct {
    void *LoggedData;
  } alpha_a_PWORK;
  struct {
    void *LoggedData;
  } i_PWORK;
  struct {
    void *LoggedData;
  } i_meas_PWORK;
  struct {
    void *LoggedData;
  } ib_PWORK;
  struct {
    void *LoggedData;
  } ifX_PWORK;
  struct {
    void *LoggedData;
  } if_meas_PWORK;
  struct {
    void *TimePtr;
    void *DataPtr;
    void *RSimInfoPtr;
  } Traj_pos_ref_PWORK;
  struct {
    void *TimePtr;
    void *DataPtr;
    void *RSimInfoPtr;
  } Traj_vel_ref_PWORK;
  struct {
    void *LoggedData;
  } ir_PWORK;
  struct {
    void *LoggedData;
  } mWinv_PWORK;
  struct {
    void *LoggedData;
  } omega_PWORK;
  struct {
    void *LoggedData;
  } theta_PWORK;
  struct {
    void *LoggedData;
  } theta_meas_PWORK;
  struct {
    void *LoggedData;
  } u_PWORK;
  struct {
    int_T PrevIndex;
  } Traj_pos_ref_IWORK;
  struct {
    int_T SystemEnable;
  } Pos_a_IWORK;
  struct {
    int_T PrevIndex;
  } Traj_vel_ref_IWORK;
  struct {
    int_T SystemEnable;
  } Vel_a_IWORK;
} D_Work;

extern void joint_ekf_R_ib(SimStruct *rts);

#if defined(MULTITASKING)
# error Model (comparison) was built in \
  SingleTasking solver mode, however the MULTITASKING define is \
  present. If you have multitasking (e.g. -DMT or -DMULTITASKING) \
  defined on the RTW page of Simulation parameter dialog, please \
  remove it and on the Solver page, select solver mode \
  MultiTasking. If the Simulation parameter dialog is configured \
  correctly, please verify that your template makefile is \
  configured correctly.
#endif

static real_T __inline sgn( real_T x )
{
  if (x > 0) return +1.0;
  else if (x < 0) return -1.0;
  else return 0.0;
}

#endif

