#ifndef _CONSTANTS_H_
#define _CONSTANTS_H_

#ifndef M_PI
#define M_PI (3.14159265F)
#endif

/* Spindles, moments of inertia, 3 sizes */
#define Js1_  (0.85e-6F) // kg m^2
#define Js2_  (1.1e-6F)  // kg m^2
#define Js3_  (1.6e-6F)  // kg m^2

/* Motor constants, nominal values */
#define L_   (0.487e-3F) // mH -> H
#define R_   (2.74F) // Omega
#define K_T_ (56.6e-3F) // mNm/A -> Nm/A
#define K_E_ (K_T_) // V/(rad/s)
#define Jm_  (6.78e-6F) // g cm^2 -> kg m^2

/* Total moment of inertia */
//#define J_   (Jm_) // kg m^2
//#define J_   (Js1_ + Jm_) // kg m^2
//#define J_   (Js2_ + Jm_) // kg m^2
#define J_   (Js3_ + Jm_) // kg m^2

/* Sampling time */
#define Ts    (1.0e-3) // s
#define Ts_   ((float)Ts) // s

#endif /* _CONSTANTS_H_ */
