#ifndef _RTW_COMMON_HEADER_FILE_
#define _RTW_COMMON_HEADER_FILE_

#ifndef TRUE
# define TRUE (1)
#endif
#ifndef FALSE
# define FALSE (0)
#endif

#define fcn_call_T                      real_T
#define pointer_T                       void*
#define action_T                        real_T

#ifndef rtInterpolate
# define rtInterpolate(v1,v2,f1,f2) (((v1)==(v2))?((double)(v1)): (((f1)*((double)(v1)))+((f2)*((double)(v2)))))
#endif

#ifndef rtRound
# define rtRound(v) ( ((v) >= 0) ? floor((v) + 0.5) : ceil((v) - 0.5) )
#endif

#define assert(exp)

#include <math.h>

#include "simstruc.h"
#include "rtlibsrc.h"
#include "dt_info.h"
#include "kalman_R_K_ib_export.h"

#include "mq3en.h"
#include "multiqda.h"
#include "multiqad.h"

typedef struct BlockIO_tag {
  real_T From_Workspace;
  real_T Step_a;
  real_T Clock_a;
  real_T Constant_a;
  real_T Sum_a;
  real_T Product_a;
  real_T Constant1_a;
  real_T Sum1_a;
  real_T Step_b;
  real_T Clock_b;
  real_T Constant_b;
  real_T Sum_b;
  real_T Product_b;
  real_T Constant1_b;
  real_T Sum1_b;
  real_T Sum2_a;
  real_T Sine_Wave_a;
  real_T Pos_a;
  real_T Sum1_c;
  real_T Encoder_Input;
  real_T rad_count;
  real_T ZOH_3;
  real_T Sum4_a;
  real_T K_p;
  real_T Bias_a;
  real_T Sum_c;
  real_T Amplification;
  real_T Sat_a;
  real_T Current;
  real_T Current_filtered;
  real_T K_curr;
  real_T ZOH_1;
  real_T K_curr_filt;
  real_T ZOH_2;
  real_T Difference;
  real_T Ts;
  real_T AD595_output;
  real_T A_D_offset_Volt;
  real_T Closed_loop_gain;
  real_T Input_offset_Volt;
  real_T Bias_b;
  real_T Sat_b;
  real_T Sum1_d;
  real_T TmpHiddenBuf1_Driving_Kalman_R[2];
  real_T Kalman_R[9];
  real_T V_A;
  real_T Sum4_b;
  real_T Sum1_e;
  real_T Resiprocal_a;
  real_T Product_c;
  real_T Sum_d;
  real_T V_to_mV;
  real_T Kelvin_a;
  real_T Type_K_mV_to_Celsius;
  real_T Type_T_mV_to_Celsius;
  real_T Switch;
  real_T T_linear_error_comp_1;
  real_T T_offset_K;
  real_T Sum1_f;
  real_T Sum2_b;
  real_T Square;
  real_T Qjoule;
  real_T Kelvin_b;
  real_T Ambient_temperature;
  real_T Thermal_model_Kalman[3];
  real_T Sum2_c[3];
  real_T Sum7;
  real_T Discrete_Butterworth;
  real_T iMeas_k_1;
  real_T G_k_1;
  real_T i_hat;
  real_T Sum1_g;
  real_T error_u;
  real_T mu;
  real_T G_k;
  real_T Resiprocal_b;
  real_T vel_k_1;
  real_T K_E;
  real_T pwm_k_1;
  real_T Sum_e;
  real_T Sum3;
  real_T Step_c;
  real_T Clock_c;
  real_T Constant_c;
  real_T Sum_f;
  real_T Product_d;
  real_T Constant1_c;
  real_T Sum1_h;
  real_T Step_d;
  real_T Clock_d;
  real_T Constant_d;
  real_T Sum_g;
  real_T Product_e;
  real_T Constant1_d;
  real_T Sum1_i;
  real_T Sum2_e;
  real_T Sine_Wave_b;
  real_T Pos_b;
  boolean_T S_Function;
} BlockIO;

typedef struct Parameters_tag {
  real_T Step_a_Time;
  real_T Step_a_Y0;
  real_T Step_a_YFinal;
  real_T Constant_a_Value;
  real_T Constant1_a_Value;
  real_T Step_b_Time;
  real_T Step_b_Y0;
  real_T Step_b_YFinal;
  real_T Constant_b_Value;
  real_T Constant1_b_Value;
  real_T Sine_Wave_a_Amp;
  real_T Sine_Wave_a_Bias;
  real_T Sine_Wave_a_Freq;
  real_T Sine_Wave_a_Hsin;
  real_T Sine_Wave_a_HCos;
  real_T Sine_Wave_a_PSin;
  real_T Sine_Wave_a_PCos;
  real_T Encoder_Input_P1;
  real_T Encoder_Input_P2;
  real_T rad_count_Gain;
  real_T K_p_Gain;
  real_T Bias_a_Value;
  real_T Amplification_Gain;
  real_T Sat_a_UpperSat;
  real_T Sat_a_LowerSat;
  real_T Analog_Output_P1;
  real_T Analog_Output_P2;
  real_T Analog_Output_P3;
  real_T Current_P1;
  real_T Current_filtered_P1;
  real_T K_curr_Gain;
  real_T K_curr_filt_Gain;
  real_T Difference_A;
  real_T Difference_C;
  real_T Difference_D;

  real_T Ts_Gain;
  real_T AD595_output_P1;
  real_T A_D_offset_Volt_Value;
  real_T Closed_loop_gain_Value;
  real_T Input_offset_Volt_Value;
  real_T Bias_b_Value;
  real_T Sat_b_UpperSat;
  real_T Sat_b_LowerSat;
  real_T Kalman_R_P1_Size[2];
  real_T Kalman_R_P1[9];
  real_T Kalman_R_P2_Size[2];
  real_T Kalman_R_P2[9];
  real_T V_A_Gain;
  real_T V_to_mV_Gain;
  real_T Kelvin_a_Value;
  real_T Type_K_mV_to_Celsius_XData[207];
  real_T Type_K_mV_to_Celsius_YData[207];
  real_T Type_T_mV_to_Celsius_XData[209];
  real_T Type_T_mV_to_Celsius_YData[209];
  real_T T_linear_error_comp_1_Gain;
  real_T T_offset_K_Value;
  real_T Kelvin_b_Value;
  real_T Ambient_temperature_Value;
  real_T Thermal_model_Kalman_A[4];
  real_T Thermal_model_Kalman_B[6];
  real_T Thermal_model_Kalman_C[4];
  real_T Thermal_model_Kalman_D[3];
  real_T Thermal_model_Kalman_X0[2];
  real_T Discrete_Butterworth_A[4];
  real_T Discrete_Butterworth_B[2];
  real_T Discrete_Butterworth_C;

  real_T Discrete_Butterworth_X0;
  real_T iMeas_k_1_X0;
  real_T G_k_1_X0;
  real_T mu_Gain;
  real_T vel_k_1_X0;
  real_T K_E_Gain;
  real_T pwm_k_1_X0;
  real_T Step_c_Time;
  real_T Step_c_Y0;
  real_T Step_c_YFinal;
  real_T Constant_c_Value;
  real_T Constant1_c_Value;
  real_T Step_d_Time;
  real_T Step_d_Y0;
  real_T Step_d_YFinal;
  real_T Constant_d_Value;
  real_T Constant1_d_Value;
  real_T Sine_Wave_b_Amp;
  real_T Sine_Wave_b_Bias;
  real_T Sine_Wave_b_Freq;
  real_T Sine_Wave_b_Hsin;
  real_T Sine_Wave_b_HCos;
  real_T Sine_Wave_b_PSin;
  real_T Sine_Wave_b_PCos;
  boolean_T S_Function_P1;
} Parameters;

typedef struct D_Work_tag {
  real_T Difference_DSTATE;
  real_T Kalman_R_DSTATE[9];
  real_T Thermal_model_Kalman_DSTATE[2];
  real_T Discrete_Butterworth_DSTATE[2];
  real_T iMeas_k_1_DSTATE;
  real_T G_k_1_DSTATE;
  real_T vel_k_1_DSTATE;
  real_T pwm_k_1_DSTATE;
  struct {
    real_T LastSin;
    real_T LastCos;
  } Sine_Wave_a_RWORK;
  struct {
    real_T LastSin;
    real_T LastCos;
  } Sine_Wave_b_RWORK;
  struct {
    void *TimePtr;
    void *DataPtr;
    void *RSimInfoPtr;
  } From_Workspace_PWORK;
  void *Kalman_R_PWORK[15];
  struct {
    void *LoggedData;
  } AD595_PWORK;
  struct {
    void *LoggedData;
  } K_PWORK;
  struct {
    void *LoggedData;
  } Q_PWORK;
  struct {
    void *LoggedData;
  } R_PWORK;
  struct {
    void *LoggedData;
  } Ref_PWORK;
  struct {
    void *LoggedData;
  } T_L_PWORK;
  struct {
    void *LoggedData;
  } Th_PWORK;
  struct {
    void *LoggedData;
  } Th_meas_PWORK;
  struct {
    void *LoggedData;
  } Tw_PWORK;
  struct {
    void *LoggedData;
  } i_PWORK;
  struct {
    void *LoggedData;
  } i_meas_PWORK;
  struct {
    void *LoggedData;
  } ib_PWORK;
  struct {
    void *LoggedData;
  } ifX_PWORK;
  struct {
    void *LoggedData;
  } if_meas_PWORK;
  struct {
    void *LoggedData;
  } mWinv_PWORK;
  struct {
    void *LoggedData;
  } omega_PWORK;
  struct {
    void *LoggedData;
  } theta_PWORK;
  struct {
    void *LoggedData;
  } theta_meas_PWORK;
  struct {
    void *LoggedData;
  } u_PWORK;
  struct {
    int_T PrevIndex;
  } From_Workspace_IWORK;
  struct {
    int_T SystemEnable;
  } Sine_Wave_a_IWORK;
  struct {
    int_T SystemEnable;
  } Sine_Wave_b_IWORK;
} D_Work;

extern void joint_ekf_R_K_ib(SimStruct *rts);

#if defined(MULTITASKING)
# error Model (kalman_R_K_ib) was built in \
  SingleTasking solver mode, however the MULTITASKING define is \
  present. If you have multitasking (e.g. -DMT or -DMULTITASKING) \
  defined on the RTW page of Simulation parameter dialog, please \
  remove it and on the Solver page, select solver mode \
  MultiTasking. If the Simulation parameter dialog is configured \
  correctly, please verify that your template makefile is \
  configured correctly.
#endif

static real_T __inline sgn( real_T x )
{
  if (x > 0) return +1.0;
  else if (x < 0) return -1.0;
  else return 0.0;
}

#endif

