% Spindles, moment of inertias

% Diameters of spindles (common for all)
dh = 6.0e-3; % diameter, hole [meter]
dm = 15e-3;  % diameter, cylinder middle [meter]
de = 19e-3;  % diameter, cylinder edges [meter]

% Radiuses
rh = dh/2;
rm = dm/2;
re = de/2;

% Lengts of spindles
lt = [12e-3, 16e-3, 26e-3]; % length, total [meter]
lm = [7.7e-3, 9.7e-3, 18e-3]; % length, between edges [meter] -> middle
le = lt - lm; % difference -> edges

pm = lm./lt; % proportion middle
pe = le./lt; % proportion edge

M = [22e-3, 27e-3, 42e-3]; % kg

% Moment of inetia, hollow cylinder about symmerty axis
% J = 1/2*M*(b^2 + a^2)

Jm = 1/2*M*(rh^2 + rm^2).*pm;
Je = 1/2*M*(rh^2 + re^2).*pe;

J = Jm + Je
