% Load data as saved by WinCon, and processes it.

%  1 - 'u'
%  2 - 'i'
%  3 - 'if'
%  4 - 'omega'
%  5 - 'theta'
%  6 - 'T_L'
%  7 - 'R'
%  8 - 'ib'
%  9 - 'i_meas'
% 10 - 'if_meas'
% 11 - 'theta_meas'
% 12 - 'mWinv'
% 13 - 'Th_meas'
% 14 - 'Th'
% 15 - 'Tw'
clear plot_names
plot_names = {'u', 'i', 'if', 'omega', 'theta', 'T_L', 'R', 'ib', 'i_meas', 'if_meas', 'theta_meas', 'mWinv', 'Th_meas', 'Th', 'Tw'};

fname_root = 'data';

%set_nos = [1 2 3 4 5 6 7 8 9];
set_nos = [10 11];

for set_no = set_nos
    clear dir dnames plot_select N S vltg crnt vlct rstnc trq tmprtr
    
    disp(set_no)
    
    dname_root = ['dataset_' num2str(set_no)];
    
    d = dir(dname_root);
    n = 1;
    for i = 1:length(d)
        if d(i).isdir
            if length(d(i).name) == length('yyyymmddTHHMMSS')
                dnames{n} = d(i).name;
                n = n + 1;
            end
        end
    end

    % Choose a set of directories
    %dindices = [1];
    dindices = 1:length(dnames);

    % Choose data to extract
    %plot_select = [1, 2, 4, 5, 6, 7, 13, 14, 15];
    plot_select = [1, 2, 4, 6, 7, 15];

    n = 1;
    for i = dindices
        % Select experiment
        dname = dnames{i};
        disp(dname);

        % Load parameters for experiement
        parameters_filename = [dname_root '\' dname '\parameters'];
        load(parameters_filename);
        disp(Weight)
        disp(N_runs)
        
        if 1

            N(n) = N_runs;

            if 0 % Load trajectory data for experiment
                trajectory_filename = ['trajectory-' num2str(Wref) '-rad-s'];
                load([dname_root '\' trajectory_filename])
            end

            % Load saved states ("plots" in WinCon)
            for j = plot_select
                for k = 1:N_runs
                    fname = [dname_root '\' dname '\' fname_root '-' plot_names{j} '-' int2str(k) '.mat'];
                    S{j,k} = load(fname);
                end
            end

            [vltg{n},crnt{n},vlct{n},rstnc{n},trq{n},tmprtr{n}] = process_data(S,N(n));

        end

        n = n + 1;
    end
    
    save(['processed_data\processed_data_set_no_' num2str(set_no)], 'vltg', 'crnt', 'vlct', 'rstnc', 'trq', 'tmprtr')

    beep
end
