% Plots actuation voltage, estimated/calculated resistance, current
% referece and measurement, and current error for various controller
% schemes. Calculates the RMS value of the error.

Ts = 1e-3;
%TT = (1):(15/Ts);
TT = (29/Ts+2):(31/Ts);

I = dindices; % Directory No.
K = 1; % Run No. = 1
J = 1;
time = S{I,J,K}.plot_time(TT);

if 1 % EKF, LMS, GS, GS^a

    subplot 221
    J = 1;
    u = S{I,J,K}.comparison_u;
    plot(time, u(TT))
    xlabel('Time [s]')
    ylabel('u [V]')

    subplot 222
    J = 13;
    switch J
        case 7
            R = S{I,J,K}.comparison_R; % EKF
            plot(time, R(TT))
        case 12
            R = S{I,J,K}.comparison_mWinv; % LMS
            plot(time, R(TT))
        case 13
            R = S{I,J,K}.comparison_GS; % GS
            plot(time, R(TT))
    end
    xlabel('Time [s]')
    ylabel('R [\Omega]')

    subplot 223
    J = 8;
    i_b = S{I,J,K}.comparison_ib;
    J = 10;
    i_m = S{I,J,K}.comparison_if_meas - i_b;
    J = 14;
    i_r = S{I,J,K}.comparison_ir;

    plot(time, i_m(TT), time, i_r(TT))
    xlabel('Time [s]')
    ylabel('i_m and i_r [A]')
    %legend('i_m', 'i_r')
    
    subplot 224
    error = i_r - i_m;
    plot(time, error(TT))
    xlabel('Time [s]')
    ylabel('Error [A]')

    
else % const./PI
    
    subplot 311
    J = 1;
    u = S{I,J,K}.comparison_u;
    plot(time, u(TT))
    xlabel('Time [s]')
    ylabel('u [V]')

    subplot 312
    J = 8;
    i_b = S{I,J,K}.comparison_ib;
    J = 10;
    i_m = S{I,J,K}.comparison_if_meas - i_b;
    J = 14;
    i_r = S{I,J,K}.comparison_ir;

    plot(time, i_m(TT), time, i_r(TT))
    xlabel('Time [s]')
    ylabel('i_m and i_r [A]')

    subplot 313
    error = i_r - i_m;
    plot(time, error(TT))
    xlabel('Time [s]')
    ylabel('Error [A]')

end

error_RMS = sqrt(mean(error.^2))
