% Plots point estimates of the current and corresponding resistance with
% standard error.

VOLTAGE = [];
CURRENT = [];
CURRENT_MEAN = [];
VELOCITY = [];
RESISTANCE = [];
RESISTANCE_MEAN = [];
TEMPERATURE = [];
RESISTANCE_TMP = [];
RESISTANCE_STD = [];
for set_no = [8]%[2 3 4 5 6 7 8 9]
    load(['processed_data_' num2str(set_no)])
    
    for i = 1:length(vltg)
        VOLTAGE         = [VOLTAGE, vltg{i}.points];
        CURRENT         = [CURRENT, crnt{i}.points];
        CURRENT_MEAN    = [CURRENT_MEAN, crnt{i}.mean];
        VELOCITY        = [VELOCITY, vlct{i}.points];
        RESISTANCE      = [RESISTANCE, rstnc{i}.points];
        RESISTANCE_MEAN = [RESISTANCE_MEAN, rstnc{i}.mean];
        RESISTANCE_STD  = [RESISTANCE_STD, rstnc{i}.std];
        
        % Remove outliers in temperature data
        [Y,I] = max(tmprtr{i}.points);
        if Y > 100
            tmprtr{i}.points(I) = tmprtr{i}.points(I-1);
        end
        TEMPERATURE = [TEMPERATURE, tmprtr{i}.points];
    end
    
    % Adjust resistance for winding temperautre
    RESISTANCE_TMP = RESISTANCE - 0.0039*(TEMPERATURE - 25.0)*2.74;
end

plot(CURRENT_MEAN, RESISTANCE_MEAN, '.')
hold
errorbar(CURRENT_MEAN, RESISTANCE_MEAN, RESISTANCE_STD)
xlabel('Estimated current as RMS [A]')
ylabel('Estimated terminal resistance [\Omega]')

max(RESISTANCE_STD)
