temperature_data = importdata('motor_temperature_experiment_4_matlab_friendly.csv');

SEL = 4;

Ts = 5e-4;

time_vector = S{SEL,1,1}.plot_time;
sim_time = ceil(time_vector(end)/Ts)*Ts + Ts;

% Power
switch 1
    case 1
        % Joule losses
        simin_Q = [time_vector, ((S{SEL,7,1}.kalman_R_ib_R).*(S{SEL,2,1}.kalman_R_ib_i).^2)];
    case 2
        % Electrical power - mechanical power = Joule losses
        simin_Q = [time_vector, S{SEL,1,1}.kalman_R_ib_u.*S{2,1}.kalman_R_ib_i - S{SEL,4,1}.kalman_R_ib_omega.*S{SEL,6,1}.kalman_R_ib_T_L];
    case 3
        % Joule losses
        simin_Q = [time_vector, ((2.74*(1 + 0.0039*(S{SEL,15,1}.kalman_R_ib_Tw - 25.0))).*(S{SEL,2,1}.kalman_R_ib_i).^2)];
end

% Motor
switch 1
    case 1
        % Fluke 54II (Ts = 1 [s])
        simin_Th = [(0:(length(temperature_data.data(:,1)) - 1))', temperature_data.data(:,1)];
    case 2
        % AD595
        simin_Th = [S{SEL,13,1}.plot_time S{SEL,13,1}.kalman_R_ib_Th_meas];
end

% Ambient
switch 1
    case 1
        % Fluke 54II (Ts = 1 [s])
        simin_Tinf = [(0:(length(temperature_data.data(:,2)) - 1))', temperature_data.data(:,2)];
    case 2
        % Assume constant ambient temperature
        Tinf_ = 22.7;
        simin_Tinf = [time_vector, Tinf_*ones(length(time_vector), 1)];
end

Tinit = [temperature_data.data(1,1), temperature_data.data(1,2)];

thermal_model

[Bbutter,Abutter] = butter(1, (1/tau1)/1000);
R_filt = filtfilt(Bbutter, Abutter, S{SEL,7,1}.kalman_R_ib_R(15*2000:end));
