% 3d Bode-like plot, gain vs. resistance and frequency.

% Data for DC motor (Maxon RE 36.118800)
L = 0.487/1000; %mH -> H
R_star = 2.74; %Omega
K_T = 56.6/1000; %mNm/A -> Nm/A
K_E = K_T; %V/(rad/s)
J = 67.8/(1000*100^2); %g cm^2 -> kg m^2

% figure;
num = 100;
w_log = logspace(2,4,num);
R_l = 0.1;
R_u = 5.0;
[w, R] = meshgrid(w_log, [R_l:(R_u-R_l)/(num-1):R_u]);

G_T = ( K_T.*R ) ./ sqrt(R_star^2 + (w.*L).^2);

G_3 = sqrt( ((w.*K_T.*J.*R).^2 + (w.^2.*K_T.*J.*L - K_T.^2.*K_E).^2) ./ (w.^3*J.^2.*R.^2 + w.*(w.^2.*J.*L - K_T.*K_E).^2).^2 );

if 0
    mesh(w, R, G_T)
else
    mesh(w, R, G_3)
end

set(gca,'XScale','log')
%set(gca,'ZScale','log')
xlabel('\omega [rad/sec]'); ylabel('R [\Omega]'); zlabel('Amplitude');
