% Loads processed data and prepares it for regression.
% Arnfinn Aas Eielsen, 2007

VOLTAGE = [];
CURRENT = [];
VELOCITY = [];
RESISTANCE = [];
TEMPERATURE = [];
RESISTANCE_TMP = [];

%set_nos = [1 2 3 4 5 6 7 8 9 10 11];
set_nos = [10 11];

for set_no = set_nos
    load(['..\..\experimental_data\processed_data\processed_data_set_no_' num2str(set_no)])
    
    for i = 1:length(vltg)
        VOLTAGE    = [VOLTAGE, vltg{i}.points];
        CURRENT    = [CURRENT, crnt{i}.points];
        VELOCITY   = [VELOCITY, vlct{i}.points];
        RESISTANCE = [RESISTANCE, rstnc{i}.points];
        
        % Remove outliers in temperature data
        [Y,I] = max(tmprtr{i}.points);
        if Y > 100
            tmprtr{i}.points(I) = tmprtr{i}.points(I-1);
        end
        TEMPERATURE = [TEMPERATURE, tmprtr{i}.points];
    end
    
    % Adjust resistance for winding temperautre
    RESISTANCE_TMP = RESISTANCE - 0.0039*(TEMPERATURE - 25.0)*2.74;
end

plot(CURRENT, RESISTANCE, 'o', CURRENT, RESISTANCE_TMP, '.')
xlabel('Estimated current as RMS [A]')
ylabel('Estimated terminal resistance [\Omega]')

% Initialize dataset for regression
global x y

x = CURRENT;
y = RESISTANCE_TMP;

return
