% Exponential model.
% Arnfinn Aas Eielsen, 2007
function [F,J] = residual_exponential_vector(th)

% Assume the sample times and measurements are initialized somewhere.
global x y

a = th(1); b = th(2); c = th(3);

eta = a*exp(b*x) + c;

F = y - eta;

if nargout > 1
    J = [(-exp(b*x))', (-a*x.*exp(b*x))', -ones(length(x),1)];
end
