% Holliday model.
% Arnfinn Aas Eielsen, 2007
function [F,J] = residual_holliday_vector(th)

% Assume the sample times and measurements are initialized somewhere.
global x y

a = th(1); b = th(2); c = th(3);

num = 1;
den = a + b.*x + c.*x.^2;

eta = num ./ den;

F = y - eta;

if nargout > 1
    J = [(1./den.^2)', (x./den.^2)', (x.^2./den.^2)'];
end
