% Second order rational model with 5 parameters.
% Arnfinn Aas Eielsen, 2007
function [F,J] = residual_rational_2_vector(th)

% Assume the sample times and measurements are initialized somewhere.
global x y

a = th(1); b = th(2); c = th(3); d = th(4); e = th(5);

num = c + d.*x + e.*x.^2;
den = 1 + a.*x + b.*x.^2;

eta = num ./ den;

F = y - eta;

if nargout > 1
    J = [((num.*x)./den.^2)', ((num.*x.^2)./den.^2)', -(1./den)', -(x./den)', -(x.^2./den)'];
end
