% Second order rational model with 3 parameters.
% Arnfinn Aas Eielsen, 2007
function [F,J] = residual_rational_3_vector(th)

% Assume the sample times and measurements are initialized somewhere.
global x y

a = th(1); b = th(2); c = th(3);

num = b + c.*x.^2;
den = 1 + a.*x.^2;

eta = num ./ den;

F = y - eta;

if nargout > 1
    J = [((num.*x.^2)./den.^2)', -(1./den)', -(x.^2./den)'];
end
