// Arnfinn Aas Eielsen - Gauss-Jordan fra Kreyszig

#include <stdio.h>
#include <stdlib.h>
#include <math.h>

void print_matrix(long double *, int, int);
void print_vector(long double *, int);

int gauss(long double *C, long double *x, int N)
{
	int r, k, i, j, p;

	int M = N+1;

	printf("%dx%d\n", N, M); print_matrix(C, N, M);

	for (k = 0; k < N-1; k++)
	{
		long double max_val = 0;
		int r_max = 0;

		//printf("1 - k=%d\n", k); // 1
		int n_row = 0;
		for (r = k; r < N; r++)
		{
			if (C[M*r+k] == 0.0) n_row++;
		}
		if (n_row == N-k) {
			printf("Feil: Ingen unik lsning eksisterer, A er singulr.\n");
			return -1;
		} else {
			//printf("2 - k=%d r=%d\n", k, r); // 2
			for (r = k; r < N; r++)
			{
				if(abs(C[M*r+k]) > max_val)
				{
					max_val = abs(C[M*r+k]);
					r_max = r;
				}
			}
			if (r_max != k) {
				for (i = 0; i < N+1; i++)
				{
					long double temp = C[M*k+i];
					C[M*k+i] = C[M*r_max+i];
					C[M*r_max+i] = temp;
				}
			}
		}

		//printf("3 - k=%d\n", k); // 3
		long double Mjk[N];
		for (j = k+1; j < N; j++)
		{
			Mjk[j] = C[M*j+k]/C[M*k+k];
			//printf("4 - k=%d j=%d\n", k, j); // 4
			for (p = k+1; p < N+1; p++)
			{
				C[M*j+p] = C[M*j+p] - Mjk[j]*C[M*k+p];
			}
		}
	}

	//printf("5\n"); // 5
	if (C[M*(N-1)+(N-1)] == 0) {
		printf("Feil: Ingen unik lsning.\n");
		return -1;
	} else {
		//printf("6\n"); // 6
		x[N-1] = C[M*(N-1)+N]/C[M*(N-1)+(N-1)];

		for (i= N-2; i >= 0; i--)
		{
			// 7
			long double c = 0;
			for (j = i+1; j < N; j++)
			{
				c = c + C[M*i+j]*x[j];
			}
			x[i] = (1/C[M*i+i])*(C[M*i+N] - c);
		}
	}

	return;
}

void print_matrix(long double *C, int N, int M)
{
	int i, j;
	for(i = 0; i < N; i++)
	{
		printf("%2d: ", i);
		for(j = 0; j < M; j++)
		{
			printf("%9.3f ", (float)C[M*i+j]);
		}
		printf("\n");
	}
	return;
}

void print_vector(long double *b, int N)
{
	int i;
	for(i = 0; i < N; i++)
	{
		printf("%2d: %9.3f\n", i, (float)b[i]);
	}
	return;
}
