Vouts = 0:0.25:5;
plot_names = {'Current', 'Velocity'};
dname = '20070622T044453';
fname_root = 'data';

for n = 1:length(Vouts)
    for i = 1:length(plot_names)
        fname = ['data\' dname '\' fname_root '-' plot_names{i} '-' int2str(n) '.mat'];
        S = load(fname);
        
        switch i
            case 1
                i_std(n) = std(S.test_Current);
            case 2
                omega_mean(n) = mean(S.test_Velocity);
        end
    end
end


plot(omega_mean, i_std, '.')
hold on
x = 0:260;
plot(x, 0.00025*x + 0.0020, '--g')
hold off
axis([0 260 0 0.07])
xlabel('Angular velocity [rad/s]')
ylabel('Noise, standard deviation [A]')
