%clear all

Ts = 5e-4;
Vouts = 0:0.25:5;
Vout = 0;

model = 'test';
project_name = 'test';

path = wc_path(model);

if wc_open(project_name)
    error(['Could not find WinCon project: ' model]);
end

% wc_clean(model) % Make a clean build...
if 1 % Build before running
    wc_setoptions
    wc_build(model, path)
end

plot_names = {'Current', 'Velocity'};

% Make a directory to save the files in
dname = datestr(now, 30);
mkdir(['data\' dname]);

for n = 1:length(Vouts)
    
    Vout = Vouts(n);
    
    fprintf('Run # %d:\n', n);
    
    wc_start(model, path);
    fprintf('\tRunning...\n');
    pause( 15 ); % Wait a while...
    wc_stop( model, path );
    wc_stop( model, path );
    
    % Save data to a file with a timestamp in the filname 
    fname_root = 'data';
    
    % Save a file for each timeseries
    for i = 1:length(plot_names)
        
        fname = ['data\' dname '\' fname_root '-' plot_names{i} '-' int2str(n) '.mat'];
        wc_saveplot(['Scope - ' model '\' plot_names{i}], fname);
        
        % Wait for the data to be saved...
        fprintf('\tSaving data to ''%s'': ', fname);
        done = 0;
        while (done == 0)
            pause(0.5);
            if (exist(fname, 'file') == 2)
                done = 1;
            end
        end
        fprintf('\nData saved.\n')
    end
    
    % Check saved files to see if data was saved, WinCon is weird sometimes...
    for i = 1:length(plot_names)
        fname = ['data\' dname '\' fname_root '-' plot_names{i} '-' int2str(n) '.mat'];
        S = load(fname);
        if ~eval(['length(S.test_' plot_names{i} ')'])
            error('Something wrong with the saved data file...')
        end
    end
    
end

% Disconnect from the real-time code
wc_disconnect( model, path );


