#ifndef _RTW_COMMON_HEADER_FILE_
#define _RTW_COMMON_HEADER_FILE_

#ifndef TRUE
# define TRUE (1)
#endif
#ifndef FALSE
# define FALSE (0)
#endif

#define fcn_call_T                      real_T
#define pointer_T                       void*
#define action_T                        real_T

#define assert(exp)

#include <math.h>

#include "simstruc.h"
#include "rtlibsrc.h"
#include "dt_info.h"
#include "test_export.h"

#include "multiqad.h"
#include "multiqda.h"
#include "mq3en.h"

typedef struct BlockIO_tag {
  real_T Analog_Input;
  real_T Current_filtered;
  real_T Current_unfiltered;
  real_T Analog_Input1;
  real_T Sine_Wave;
  real_T u_bias;
  real_T Sum_a;
  real_T Encoder_Input;
  real_T Ki_filt;
  real_T S_Function;
  real_T Ki;
  real_T Sum1_a[2];
  real_T Q;
  real_T Ambient;
  real_T A_A;
  real_T A_D_offset_Volt_a;
  real_T Sum1_b;
  real_T Closed_loop_gain;
  real_T Resiprocal;
  real_T Product;
  real_T Input_offset_Volt;
  real_T Sum_b;
  real_T V_to_mV;
  real_T Sum6;
  real_T Type_K_mV_to_Celsius;
  real_T T_offset_K;
  real_T Sum4;
  real_T Kelvin;
  real_T Sum2;
  real_T Discrete_State_Space[3];
  real_T Sum3[3];
  real_T Type_T_mV_to_Celsius;
  real_T A_D_offset_Volt_b;
  real_T Sum5;
  real_T rad_count;
  real_T Difference;
  real_T Ts;
} BlockIO;

typedef struct Parameters_tag {
  real_T Analog_Input_P1;
  real_T Current_filtered_P1;
  real_T Current_unfiltered_P1;
  real_T Analog_Input1_P1;
  real_T Sine_Wave_Amp;
  real_T Sine_Wave_Bias;
  real_T Sine_Wave_Freq;
  real_T Sine_Wave_Phase;
  real_T u_bias_Value;
  real_T Analog_Output_P1;
  real_T Analog_Output_P2;
  real_T Analog_Output_P3;
  real_T Encoder_Input_P1;
  real_T Encoder_Input_P2;
  real_T Ki_filt_Gain;
  real_T Ki_Gain;
  real_T Q_Value;
  real_T Ambient_Value;
  real_T A_A_Gain;
  real_T A_D_offset_Volt_a_Value;
  real_T Closed_loop_gain_Value;
  real_T Input_offset_Volt_Value;
  real_T V_to_mV_Gain;
  real_T Type_K_mV_to_Celsius_XData[207];
  real_T Type_K_mV_to_Celsius_YData[207];
  real_T T_offset_K_Value;
  real_T Kelvin_Value;
  real_T Discrete_State_Space_A[4];
  real_T Discrete_State_Space_B[6];
  real_T Discrete_State_Space_C[4];
  real_T Discrete_State_Space_D[3];
  real_T Discrete_State_Space_X0[2];
  real_T Type_T_mV_to_Celsius_XData[209];
  real_T Type_T_mV_to_Celsius_YData[209];
  real_T A_D_offset_Volt_b_Value;
  real_T rad_count_Gain;
  real_T Difference_A;
  real_T Difference_C;
  real_T Difference_D;

  real_T Ts_Gain;
} Parameters;

typedef struct D_Work_tag {
  real_T S_Function_DSTATE;
  real_T Discrete_State_Space_DSTATE[2];
  real_T Difference_DSTATE;
  real_T S_Function_RWORK[4];
  struct {
    void *LoggedData;
  } Current_PWORK;
  struct {
    void *LoggedData;
  } Current_bias_PWORK;
  struct {
    void *LoggedData;
  } Current_scope_PWORK;
  struct {
    void *LoggedData;
  } Temp_PWORK;
  struct {
    void *LoggedData;
  } Type_K_PWORK;
  struct {
    void *LoggedData;
  } Type_K_mod_PWORK;
  struct {
    void *LoggedData;
  } Type_T_PWORK;
  struct {
    void *LoggedData;
  } Ch_3_PWORK;
  struct {
    void *LoggedData;
  } Position_PWORK;
  struct {
    void *LoggedData;
  } Velocity_PWORK;
} D_Work;

extern void bias(SimStruct *rts);

#if defined(MULTITASKING)
# error Model (test) was built in \
  SingleTasking solver mode, however the MULTITASKING define is \
  present. If you have multitasking (e.g. -DMT or -DMULTITASKING) \
  defined on the RTW page of Simulation parameter dialog, please \
  remove it and on the Solver page, select solver mode \
  MultiTasking. If the Simulation parameter dialog is configured \
  correctly, please verify that your template makefile is \
  configured correctly.
#endif

static real_T __inline sgn( real_T x )
{
  if (x > 0) return +1.0;
  else if (x < 0) return -1.0;
  else return 0.0;
}

#endif

