/*
 * comparison_reg.h
 *
 * Real-Time Workshop code generation for Simulink model "comparison.mdl".
 *
 * Model Version                        : 1.936
 * Real-Time Workshop file version      : 4.1 $Date: 2001/05/16 13:59:43 $
 * Real-Time Workshop file generated on : Sun Jul 15 20:41:08 2007
 * TLC version                          : 4.1 (May 19 2001)
 * C source code generated on           : Sun Jul 15 20:41:09 2007
 *
 * Relevant TLC Options:
 *   InlineParameters      = 0
 *   RollThreshold         = 5
 *   CodeFormat            = RealTime
 *
 * Simulink model settings:
 *   Solver     : FixedStep
 *   StartTime  : 0.0 s
 *   StopTime   : 1.0 s
 *   FixedStep  : 0.001 s
 *
 * SOURCES: comparison.c 
 */

#include "comparison_dt.c"

/* Function to initialize sizes */
void MdlInitializeSizes(void)
{
  ssSetNumContStates(rtS, 0);           /* Number of continuous states */
  ssSetNumOutputs(rtS, 0);              /* Number of model outputs */
  ssSetNumInputs(rtS, 0);               /* Number of model inputs */
  ssSetDirectFeedThrough(rtS, 0);       /* The model is not direct feedthrough */
  ssSetNumSampleTimes(rtS, 2);          /* Number of sample times */
  ssSetNumBlocks(rtS, 182);             /* Number of blocks */
  ssSetNumBlockIO(rtS, 164);            /* Number of block outputs */
  ssSetNumBlockParams(rtS, 146);        /* Sum of parameter "widths" */
}

/* Function to initialize sample times */
void MdlInitializeSampleTimes(void)
{
  /* task periods */
  ssSetSampleTime(rtS, 0, 0.0);
  ssSetSampleTime(rtS, 1, 0.001);

  /* task offsets */
  ssSetOffsetTime(rtS, 0, 0.0);
  ssSetOffsetTime(rtS, 1, 0.0);
}

/* Function to register the model */
SimStruct *comparison(void)
{
  static struct _ssMdlInfo mdlInfo;

  (void)memset((char *)rtS, 0, sizeof(SimStruct));
  (void)memset((char *)&mdlInfo, 0, sizeof(struct _ssMdlInfo));

  ssSetMdlInfoPtr(rtS, &mdlInfo);

  /* timing info */
  {
    static time_T mdlPeriod[NSAMPLE_TIMES];
    static time_T mdlOffset[NSAMPLE_TIMES];
    static time_T mdlTaskTimes[NSAMPLE_TIMES];
    static int_T mdlTsMap[NSAMPLE_TIMES];
    static int_T mdlSampleHits[NSAMPLE_TIMES];

    {
      int_T i;

      for(i = 0; i < NSAMPLE_TIMES; i++) {
        mdlPeriod[i] = 0.0;
        mdlOffset[i] = 0.0;
        mdlTaskTimes[i] = 0.0;
      }
    }
    (void)memset((char_T *)&mdlTsMap[0], 0, 2 * sizeof(int_T));
    (void)memset((char_T *)&mdlSampleHits[0], 0, 2 * sizeof(int_T));

    ssSetSampleTimePtr(rtS, &mdlPeriod[0]);
    ssSetOffsetTimePtr(rtS, &mdlOffset[0]);
    ssSetSampleTimeTaskIDPtr(rtS, &mdlTsMap[0]);
    ssSetTPtr(rtS, &mdlTaskTimes[0]);
    ssSetSampleHitPtr(rtS, &mdlSampleHits[0]);
  }
  ssSetSolverMode(rtS, SOLVER_MODE_SINGLETASKING);

  /*
   * initialize model vectors and cache them in SimStruct
   */

  /* block I/O */
  {
    void *b = (void *) &rtB;

    ssSetBlockIO(rtS, b);

    {
      int_T i;

      for (i = 0; i < 172; i++) {
        ((real_T*) b)[i] = 0.0;
      }
    }
  }

  /* parameters */
  ssSetDefaultParam(rtS, (real_T *) &rtP);

  /* data type work */
  {
    void *dwork = (void *) &rtDWork;
    ssSetRootDWork(rtS, dwork);
    (void)memset((char_T *) dwork, 0, sizeof(D_Work));
    {
      int_T i;
      real_T *dwork_ptr = (real_T *) &rtDWork.Unit_Delay_DSTATE;

      for (i = 0; i < 35; i++) {
        dwork_ptr[i] = 0.0;
      }
    }
  }

  /* data type transition information (for external mode) */
  {
    static DataTypeTransInfo dtInfo;

    (void)memset((char_T *) &dtInfo, 0, sizeof(dtInfo));
    ssSetModelMappingInfo(rtS, &dtInfo);

    dtInfo.numDataTypes = 13;
    dtInfo.dataTypeSizes = &rtDataTypeSizes[0];
    dtInfo.dataTypeNames = &rtDataTypeNames[0];

    /* Block I/O transition table */
    dtInfo.B = &rtBTransTable;

    /* Parameters transition table */
    dtInfo.P = &rtPTransTable;
  }

  /* Model specific registration */
  ssSetRootSS(rtS, rtS);
  ssSetVersion(rtS, SIMSTRUCT_VERSION_LEVEL2);

  ssSetModelName(rtS, "comparison");
  ssSetPath(rtS, "comparison");

  ssSetTStart(rtS, 0.0);
  ssSetTFinal(rtS, 1.0);
  ssSetStepSize(rtS, 0.001);
  ssSetFixedStepSize(rtS, 0.001);

  ssSetChecksum0(rtS, 2211699589U);
  ssSetChecksum1(rtS, 751753027U);
  ssSetChecksum2(rtS, 3161353201U);
  ssSetChecksum3(rtS, 390333186U);

  {
    static const EnableStates rtAlwaysEnabled = SUBSYS_ENABLED;
    static const void *sysModes[1];

    sysModes[0] = &rtAlwaysEnabled;

    ssSetSubSystemModeVectorAddresses(rtS, ((void*)sysModes));
  }

  /* block instance data */
  {
    /* FromWorkspace Block: <S11>/Traj. pos. ref. */

    static real_T pTimeValues[] = {
      0.0,
      0.001,
      0.002,
      0.003,
      0.004,
      0.005,
      0.006,
      0.007,
      0.008,
      9.0000000000000011E-003,
      0.01,
      0.011,
      0.012,
      1.3000000000000001E-002,
      0.014,
      0.015,
      0.016,
      0.017,
      1.8000000000000002E-002,
      0.019,
      0.02,
      0.021,
      0.022,
      0.023,
      0.024,
      0.025,
      2.6000000000000002E-002,
      0.027,
      0.028,
      0.029,
      0.03,
      0.031,
      0.032,
      0.033,
      0.034,
      0.035,
      3.6000000000000004E-002,
      0.037,
      0.038,
      0.039,
      0.04,
      0.041,
      0.042,
      4.3000000000000003E-002,
      0.044,
      0.045,
      0.046,
      0.047,
      0.048,
      0.049,
      0.05,
      5.1000000000000004E-002,
      5.2000000000000005E-002,
      0.053,
      0.054,
      0.055,
      0.056,
      0.057,
      0.058,
      5.9000000000000004E-002,
      0.06,
      0.061,
      0.062,
      0.063,
      0.064,
      0.065,
      0.066,
      0.067,
      0.068,
      0.069,
      0.07,
      7.1000000000000008E-002,
      7.2000000000000008E-002,
      0.073,
      0.074,
      0.075,
      0.076,
      0.077,
      0.078,
      0.079,
      0.08,
      0.081,
      0.082,
      0.083,
      0.084,
      0.085,
      8.6000000000000007E-002,
      8.7000000000000008E-002,
      0.088,
      0.089,
      0.09,
      0.091,
      0.092,
      0.093,
      0.094,
      0.095,
      0.096,
      0.097,
      0.098,
      0.099,
      0.1,
      0.101,
      1.0200000000000001E-001,
      1.0300000000000001E-001,
      1.0400000000000001E-001,
      0.105,
      0.106,
      0.107,
      0.108,
      0.109,
      0.11,
      0.111,
      0.112,
      0.113,
      0.114,
      0.115,
      0.116,
      0.117,
      1.1800000000000001E-001,
      1.1900000000000001E-001,
      0.12,
      0.121,
      0.122,
      0.123,
      0.124,
      0.125,
      0.126,
      0.127,
      0.128,
      0.129,
      0.13,
      0.131,
      0.132,
      0.133,
      0.134,
      0.135,
      0.136,
      0.137,
      0.138,
      0.139,
      0.14,
      1.4100000000000001E-001,
      1.4200000000000002E-001,
      1.4300000000000002E-001,
      1.4400000000000002E-001,
      0.145,
      0.146,
      0.147,
      0.148,
      0.149,
      0.15,
      0.151,
      0.152,
      0.153,
      0.154,
      0.155,
      0.156,
      0.157,
      0.158,
      0.159,
      0.16,
      0.161,
      0.162,
      0.163,
      0.164,
      0.165,
      0.166,
      0.167,
      0.168,
      0.169,
      0.17,
      0.171,
      1.7200000000000001E-001,
      1.7300000000000001E-001,
      1.7400000000000002E-001,
      1.7500000000000002E-001,
      0.176,
      0.177,
      0.178,
      0.179,
      0.18,
      0.181,
      0.182,
      0.183,
      0.184,
      0.185,
      0.186,
      0.187,
      0.188,
      0.189,
      0.19,
      0.191,
      0.192,
      0.193,
      0.194,
      0.195,
      0.196,
      0.197,
      0.198,
      0.199,
      0.2,
      0.201,
      0.202,
      0.203,
      2.0400000000000001E-001,
      2.0500000000000002E-001,
      2.0600000000000002E-001,
      2.0700000000000002E-001,
      2.0800000000000002E-001,
      0.209,
      0.21,
      0.211,
      0.212,
      0.213,
      0.214,
      0.215,
      0.216,
      0.217,
      0.218,
      0.219,
      0.22,
      0.221,
      0.222,
      0.223,
      0.224,
      0.225,
      0.226,
      0.227,
      0.228,
      0.229,
      0.23,
      0.231,
      0.232,
      0.233,
      0.234,
      2.3500000000000001E-001,
      2.3600000000000002E-001,
      2.3700000000000002E-001,
      2.3800000000000002E-001,
      2.3900000000000002E-001,
      0.24,
      0.241,
      0.242,
      0.243,
      0.244,
      0.245,
      0.246,
      0.247,
      0.248,
      0.249,
      0.25,
      0.251,
      0.252,
      0.253,
      0.254,
      0.255,
      0.256,
      0.257,
      0.258,
      0.259,
      0.26,
      0.261,
      0.262,
      0.263,
      0.264,
      0.265,
      0.266,
      0.267,
      0.268,
      0.269,
      0.27,
      0.271,
      0.272,
      0.273,
      0.274,
      0.275,
      0.276,
      0.277,
      0.278,
      0.279,
      0.28,
      0.281,
      2.8200000000000003E-001,
      2.8300000000000003E-001,
      2.8400000000000003E-001,
      2.8500000000000003E-001,
      2.8600000000000003E-001,
      2.8700000000000003E-001,
      2.8800000000000003E-001,
      0.289,
      0.29,
      0.291,
      0.292,
      0.293,
      0.294,
      0.295,
      0.296,
      0.297,
      0.298,
      0.299,
      0.3,
      0.301,
      0.302,
      0.303,
      0.304,
      0.305,
      0.306,
      0.307,
      0.308,
      0.309,
      0.31,
      0.311,
      0.312,
      0.313,
      0.314,
      0.315,
      0.316,
      0.317,
      0.318,
      0.319,
      0.32,
      0.321,
      0.322,
      0.323,
      0.324,
      0.325,
      0.326,
      0.327,
      0.328,
      0.329,
      0.33,
      0.331,
      0.332,
      0.333,
      0.334,
      0.335,
      0.336,
      0.337,
      0.338,
      0.339,
      0.34,
      0.341,
      0.342,
      0.343,
      3.4400000000000003E-001,
      3.4500000000000003E-001,
      3.4600000000000003E-001,
      3.4700000000000003E-001,
      3.4800000000000003E-001,
      3.4900000000000003E-001,
      3.5000000000000003E-001,
      3.5100000000000003E-001,
      0.352,
      0.353,
      0.354,
      0.355,
      0.356,
      0.357,
      0.358,
      0.359,
      0.36,
      0.361,
      0.362,
      0.363,
      0.364,
      0.365,
      0.366,
      0.367,
      0.368,
      0.369,
      0.37,
      0.371,
      0.372,
      0.373,
      0.374,
      0.375,
      0.376,
      0.377,
      0.378,
      0.379,
      0.38,
      0.381,
      0.382,
      0.383,
      0.384,
      0.385,
      0.386,
      0.387,
      0.388,
      0.389,
      0.39,
      0.391,
      0.392,
      0.393,
      0.394,
      0.395,
      0.396,
      0.397,
      0.398,
      0.399,
      0.4,
      0.401,
      0.402,
      0.403,
      0.404,
      0.405,
      0.406,
      4.0700000000000003E-001,
      4.0800000000000003E-001,
      4.0900000000000003E-001,
      4.1000000000000003E-001,
      4.1100000000000003E-001,
      4.1200000000000003E-001,
      4.1300000000000003E-001,
      4.1400000000000003E-001,
      4.1500000000000004E-001,
      4.1600000000000004E-001,
      0.417,
      0.418,
      0.419,
      0.42,
      0.421,
      0.422,
      0.423,
      0.424,
      0.425,
      0.426,
      0.427,
      0.428,
      0.429,
      0.43,
      0.431,
      0.432,
      0.433,
      0.434,
      0.435,
      0.436,
      0.437,
      0.438,
      0.439,
      0.44,
      0.441,
      0.442,
      0.443,
      0.444,
      0.445,
      0.446,
      0.447,
      0.448,
      0.449,
      0.45,
      0.451,
      0.452,
      0.453,
      0.454,
      0.455,
      0.456,
      0.457,
      0.458,
      0.459,
      0.46,
      0.461,
      0.462,
      0.463,
      0.464,
      0.465,
      0.466,
      0.467,
      0.468,
      4.6900000000000003E-001,
      4.7000000000000003E-001,
      4.7100000000000003E-001,
      4.7200000000000003E-001,
      4.7300000000000003E-001,
      4.7400000000000003E-001,
      4.7500000000000003E-001,
      4.7600000000000003E-001,
      4.7700000000000004E-001,
      4.7800000000000004E-001,
      4.7900000000000004E-001,
      0.48,
      0.481,
      0.482,
      0.483,
      0.484,
      0.485,
      0.486,
      0.487,
      0.488,
      0.489,
      0.49,
      0.491,
      0.492,
      0.493,
      0.494,
      0.495,
      0.496,
      0.497,
      0.498,
      0.499,
      0.5,
      0.501,
      0.502,
      0.503,
      0.504,
      0.505,
      0.506,
      0.507,
      0.508,
      0.509,
      0.51,
      0.511,
      0.512,
      0.513,
      0.514,
      0.515,
      0.516,
      0.517,
      0.518,
      0.519,
      0.52,
      0.521,
      0.522,
      0.523,
      0.524,
      0.525,
      0.526,
      0.527,
      0.528,
      0.529,
      0.53,
      0.531,
      0.532,
      0.533,
      0.534,
      0.535,
      0.536,
      0.537,
      0.538,
      0.539,
      0.54,
      0.541,
      0.542,
      0.543,
      0.544,
      0.545,
      0.546,
      0.547,
      0.548,
      0.549,
      0.55,
      0.551,
      0.552,
      0.553,
      0.554,
      0.555,
      0.556,
      0.557,
      0.558,
      0.559,
      0.56,
      0.561,
      0.562,
      5.6300000000000006E-001,
      5.6400000000000006E-001,
      5.6500000000000006E-001,
      5.6600000000000006E-001,
      5.6700000000000006E-001,
      5.6800000000000006E-001,
      5.6900000000000006E-001,
      5.7000000000000006E-001,
      5.7100000000000006E-001,
      5.7200000000000006E-001,
      5.7300000000000006E-001,
      5.7400000000000007E-001,
      5.7500000000000007E-001,
      5.7600000000000007E-001,
      0.577,
      0.578,
      0.579,
      0.58,
      0.581,
      0.582,
      0.583,
      0.584,
      0.585,
      0.586,
      0.587,
      0.588,
      0.589,
      0.59,
      0.591,
      0.592,
      0.593,
      0.594,
      0.595,
      0.596,
      0.597,
      0.598,
      0.599,
      0.6,
      0.601,
      0.602,
      0.603,
      0.604,
      0.605,
      0.606,
      0.607,
      0.608,
      0.609,
      0.61,
      0.611,
      0.612,
      0.613,
      0.614,
      0.615,
      0.616,
      0.617,
      0.618,
      0.619,
      0.62,
      0.621,
      0.622,
      0.623,
      0.624,
      0.625,
      0.626,
      0.627,
      0.628,
      0.629,
      0.63,
      0.631,
      0.632,
      0.633,
      0.634,
      0.635,
      0.636,
      0.637,
      0.638,
      0.639,
      0.64,
      0.641,
      0.642,
      0.643,
      0.644,
      0.645,
      0.646,
      0.647,
      0.648,
      0.649,
      0.65,
      0.651,
      0.652,
      0.653,
      0.654,
      0.655,
      0.656,
      0.657,
      0.658,
      0.659,
      0.66,
      0.661,
      0.662,
      0.663,
      0.664,
      0.665,
      0.666,
      0.667,
      0.668,
      0.669,
      0.67,
      0.671,
      0.672,
      0.673,
      0.674,
      0.675,
      0.676,
      0.677,
      0.678,
      0.679,
      0.68,
      0.681,
      0.682,
      0.683,
      0.684,
      0.685,
      0.686,
      0.687,
      6.8800000000000006E-001,
      6.8900000000000006E-001,
      6.9000000000000006E-001,
      6.9100000000000006E-001,
      6.9200000000000006E-001,
      6.9300000000000006E-001,
      6.9400000000000006E-001,
      6.9500000000000006E-001,
      6.9600000000000006E-001,
      6.9700000000000006E-001,
      6.9800000000000006E-001,
      6.9900000000000007E-001,
      7.0000000000000007E-001,
      7.0100000000000007E-001,
      7.0200000000000007E-001,
      7.0300000000000007E-001,
      0.704,
      0.705,
      0.706,
      0.707,
      0.708,
      0.709,
      0.71,
      0.711,
      0.712,
      0.713,
      0.714,
      0.715,
      0.716,
      0.717,
      0.718,
      0.719,
      0.72,
      0.721,
      0.722,
      0.723,
      0.724,
      0.725,
      0.726,
      0.727,
      0.728,
      0.729,
      0.73,
      0.731,
      0.732,
      0.733,
      0.734,
      0.735,
      0.736,
      0.737,
      0.738,
      0.739,
      0.74,
      0.741,
      0.742,
      0.743,
      0.744,
      0.745,
      0.746,
      0.747,
      0.748,
      0.749,
      0.75,
      0.751,
      0.752,
      0.753,
      0.754,
      0.755,
      0.756,
      0.757,
      0.758,
      0.759,
      0.76,
      0.761,
      0.762,
      0.763,
      0.764,
      0.765,
      0.766,
      0.767,
      0.768,
      0.769,
      0.77,
      0.771,
      0.772,
      0.773,
      0.774,
      0.775,
      0.776,
      0.777,
      0.778,
      0.779,
      0.78,
      0.781,
      0.782,
      0.783,
      0.784,
      0.785,
      0.786,
      0.787,
      0.788,
      0.789,
      0.79,
      0.791,
      0.792,
      0.793,
      0.794,
      0.795,
      0.796,
      0.797,
      0.798,
      0.799,
      0.8,
      0.801,
      0.802,
      0.803,
      0.804,
      0.805,
      0.806,
      0.807,
      0.808,
      0.809,
      0.81,
      0.811,
      0.812,
      8.1300000000000006E-001,
      8.1400000000000006E-001,
      8.1500000000000006E-001,
      8.1600000000000006E-001,
      8.1700000000000006E-001,
      8.1800000000000006E-001,
      8.1900000000000006E-001,
      8.2000000000000006E-001,
      8.2100000000000006E-001,
      8.2200000000000006E-001,
      8.2300000000000006E-001,
      8.2400000000000007E-001,
      8.2500000000000007E-001,
      8.2600000000000007E-001,
      8.2700000000000007E-001,
      8.2800000000000007E-001,
      8.2900000000000007E-001,
      8.3000000000000007E-001,
      8.3100000000000007E-001,
      8.3200000000000007E-001,
      0.833,
      0.834,
      0.835,
      0.836,
      0.837,
      0.838,
      0.839,
      0.84,
      0.841,
      0.842,
      0.843,
      0.844,
      0.845,
      0.846,
      0.847,
      0.848,
      0.849,
      0.85,
      0.851,
      0.852,
      0.853,
      0.854,
      0.855,
      0.856,
      0.857,
      0.858,
      0.859,
      0.86,
      0.861,
      0.862,
      0.863,
      0.864,
      0.865,
      0.866,
      0.867,
      0.868,
      0.869,
      0.87,
      0.871,
      0.872,
      0.873,
      0.874,
      0.875,
      0.876,
      0.877,
      0.878,
      0.879,
      0.88,
      0.881,
      0.882,
      0.883,
      0.884,
      0.885,
      0.886,
      0.887,
      0.888,
      0.889,
      0.89,
      0.891,
      0.892,
      0.893,
      0.894,
      0.895,
      0.896,
      0.897,
      0.898,
      0.899,
      0.9,
      0.901,
      0.902,
      0.903,
      0.904,
      0.905,
      0.906,
      0.907,
      0.908,
      0.909,
      0.91,
      0.911,
      0.912,
      0.913,
      0.914,
      0.915,
      0.916,
      0.917,
      0.918,
      0.919,
      0.92,
      0.921,
      0.922,
      0.923,
      0.924,
      0.925,
      0.926,
      0.927,
      0.928,
      0.929,
      0.93,
      0.931,
      0.932,
      0.933,
      0.934,
      0.935,
      0.936,
      0.937,
      9.3800000000000006E-001,
      9.3900000000000006E-001,
      9.4000000000000006E-001,
      9.4100000000000006E-001,
      9.4200000000000006E-001,
      9.4300000000000006E-001,
      9.4400000000000006E-001,
      9.4500000000000006E-001,
      9.4600000000000006E-001,
      9.4700000000000006E-001,
      9.4800000000000006E-001,
      9.4900000000000007E-001,
      9.5000000000000007E-001,
      9.5100000000000007E-001,
      9.5200000000000007E-001,
      9.5300000000000007E-001,
      9.5400000000000007E-001,
      9.5500000000000007E-001,
      9.5600000000000007E-001,
      9.5700000000000007E-001,
      9.5800000000000007E-001,
      9.5900000000000007E-001,
      0.96,
      0.961,
      0.962,
      0.963,
      0.964,
      0.965,
      0.966,
      0.967,
      0.968,
      0.969,
      0.97,
      0.971,
      0.972,
      0.973,
      0.974,
      0.975,
      0.976,
      0.977,
      0.978,
      0.979,
      0.98,
      0.981,
      0.982,
      0.983,
      0.984,
      0.985,
      0.986,
      0.987,
      0.988,
      0.989,
      0.99,
      0.991,
      0.992,
      0.993,
      0.994,
      0.995,
      0.996,
      0.997,
      0.998,
      0.999,
      1.0,
      1.0010000000000001E+000,
      1.002,
      1.0030000000000001E+000,
      1.004,
      1.0050000000000001E+000,
      1.006,
      1.0070000000000001E+000,
      1.008,
      1.0090000000000001E+000,
      1.01,
      1.0110000000000001E+000,
      1.012,
      1.0130000000000001E+000,
      1.014,
      1.0150000000000001E+000,
      1.016,
      1.0170000000000001E+000,
      1.018,
      1.0190000000000001E+000,
      1.02,
      1.0210000000000001E+000,
      1.022,
      1.0230000000000001E+000,
      1.024,
      1.025,
      1.026,
      1.027,
      1.028,
      1.029,
      1.03,
      1.031,
      1.032,
      1.033,
      1.034,
      1.035,
      1.036,
      1.037,
      1.038,
      1.039,
      1.04,
      1.041,
      1.042,
      1.043,
      1.044,
      1.045,
      1.046,
      1.047,
      1.048,
      1.049,
      1.05,
      1.051,
      1.052,
      1.053,
      1.054,
      1.055,
      1.056,
      1.057,
      1.058,
      1.059,
      1.06,
      1.061,
      1.062,
      1.063,
      1.064,
      1.065,
      1.066,
      1.067,
      1.068,
      1.069,
      1.07,
      1.071,
      1.072,
      1.073,
      1.074,
      1.075,
      1.076,
      1.077,
      1.078,
      1.079,
      1.08,
      1.081,
      1.082,
      1.083,
      1.084,
      1.085,
      1.086,
      1.087,
      1.088,
      1.089,
      1.09,
      1.091,
      1.092,
      1.093,
      1.094,
      1.095,
      1.096,
      1.097,
      1.098,
      1.099,
      1.1,
      1.101,
      1.102,
      1.103,
      1.104,
      1.105,
      1.106,
      1.107,
      1.108,
      1.109,
      1.11,
      1.111,
      1.112,
      1.113,
      1.114,
      1.115,
      1.116,
      1.117,
      1.118,
      1.119,
      1.12,
      1.121,
      1.122,
      1.123,
      1.124,
      1.125,
      1.1260000000000001E+000,
      1.127,
      1.1280000000000001E+000,
      1.129,
      1.1300000000000001E+000,
      1.131,
      1.1320000000000001E+000,
      1.133,
      1.1340000000000001E+000,
      1.135,
      1.1360000000000001E+000,
      1.137,
      1.1380000000000001E+000,
      1.139,
      1.1400000000000001E+000,
      1.141,
      1.1420000000000001E+000,
      1.143,
      1.1440000000000001E+000,
      1.145,
      1.1460000000000001E+000,
      1.147,
      1.1480000000000001E+000,
      1.149,
      1.1500000000000001E+000,
      1.151,
      1.1520000000000001E+000,
      1.153,
      1.154,
      1.155,
      1.156,
      1.157,
      1.158,
      1.159,
      1.16,
      1.161,
      1.162,
      1.163,
      1.164,
      1.165,
      1.166,
      1.167,
      1.168,
      1.169,
      1.17,
      1.171,
      1.172,
      1.173,
      1.174,
      1.175,
      1.176,
      1.177,
      1.178,
      1.179,
      1.18,
      1.181,
      1.182,
      1.183,
      1.184,
      1.185,
      1.186,
      1.187,
      1.188,
      1.189,
      1.19,
      1.191,
      1.192,
      1.193,
      1.194,
      1.195,
      1.196,
      1.197,
      1.198,
      1.199,
      1.2,
      1.201,
      1.202,
      1.203,
      1.204,
      1.205,
      1.206,
      1.207,
      1.208,
      1.209,
      1.21,
      1.211,
      1.212,
      1.213,
      1.214,
      1.215,
      1.216,
      1.217,
      1.218,
      1.219,
      1.22,
      1.221,
      1.222,
      1.223,
      1.224,
      1.225,
      1.226,
      1.227,
      1.228,
      1.229,
      1.23,
      1.231,
      1.232,
      1.233,
      1.234,
      1.235,
      1.236,
      1.237,
      1.238,
      1.239,
      1.24,
      1.241,
      1.242,
      1.243,
      1.244,
      1.245,
      1.246,
      1.247,
      1.248,
      1.249,
      1.25,
      1.2510000000000001E+000,
      1.252,
      1.2530000000000001E+000,
      1.254,
      1.2550000000000001E+000,
      1.256,
      1.2570000000000001E+000,
      1.258,
      1.2590000000000001E+000,
      1.26,
      1.2610000000000001E+000,
      1.262,
      1.2630000000000001E+000,
      1.264,
      1.2650000000000001E+000,
      1.266,
      1.2670000000000001E+000,
      1.268,
      1.2690000000000001E+000,
      1.27,
      1.2710000000000001E+000,
      1.272,
      1.2730000000000001E+000,
      1.274,
      1.2750000000000001E+000,
      1.276,
      1.2770000000000001E+000,
      1.278,
      1.2790000000000001E+000,
      1.28,
      1.281,
      1.282,
      1.283,
      1.284,
      1.285,
      1.286,
      1.287,
      1.288,
      1.289,
      1.29,
      1.291,
      1.292,
      1.293,
      1.294,
      1.295,
      1.296,
      1.297,
      1.298,
      1.299,
      1.3,
      1.301,
      1.302,
      1.303,
      1.304,
      1.305,
      1.306,
      1.307,
      1.308,
      1.309,
      1.31,
      1.311,
      1.312,
      1.313,
      1.314,
      1.315,
      1.316,
      1.317,
      1.318,
      1.319,
      1.32,
      1.321,
      1.322,
      1.323,
      1.324,
      1.325,
      1.326,
      1.327,
      1.328,
      1.329,
      1.33,
      1.331,
      1.332,
      1.333,
      1.334,
      1.335,
      1.336,
      1.337,
      1.338,
      1.339,
      1.34,
      1.341,
      1.342,
      1.343,
      1.344,
      1.345,
      1.346,
      1.347,
      1.348,
      1.349,
      1.35,
      1.351,
      1.352,
      1.353,
      1.354,
      1.355,
      1.356,
      1.357,
      1.358,
      1.359,
      1.36,
      1.361,
      1.362,
      1.363,
      1.364,
      1.365,
      1.366,
      1.367,
      1.368,
      1.369,
      1.37,
      1.371,
      1.372,
      1.373,
      1.374,
      1.375,
      1.3760000000000001E+000,
      1.377,
      1.3780000000000001E+000,
      1.379,
      1.3800000000000001E+000,
      1.381,
      1.3820000000000001E+000,
      1.383,
      1.3840000000000001E+000,
      1.385,
      1.3860000000000001E+000,
      1.387,
      1.3880000000000001E+000,
      1.389,
      1.3900000000000001E+000,
      1.391,
      1.3920000000000001E+000,
      1.393,
      1.3940000000000001E+000,
      1.395,
      1.3960000000000001E+000,
      1.397,
      1.3980000000000001E+000,
      1.399,
      1.4000000000000001E+000,
      1.401,
      1.4020000000000001E+000,
      1.403,
      1.4040000000000001E+000,
      1.405,
      1.4060000000000001E+000,
      1.407,
      1.408,
      1.409,
      1.41,
      1.411,
      1.412,
      1.413,
      1.414,
      1.415,
      1.416,
      1.417,
      1.418,
      1.419,
      1.42,
      1.421,
      1.422,
      1.423,
      1.424,
      1.425,
      1.426,
      1.427,
      1.428,
      1.429,
      1.43,
      1.431,
      1.432,
      1.433,
      1.434,
      1.435,
      1.436,
      1.437,
      1.438,
      1.439,
      1.44,
      1.441,
      1.442,
      1.443,
      1.444,
      1.445,
      1.446,
      1.447,
      1.448,
      1.449,
      1.45,
      1.451,
      1.452,
      1.453,
      1.454,
      1.455,
      1.456,
      1.457,
      1.458,
      1.459,
      1.46,
      1.461,
      1.462,
      1.463,
      1.464,
      1.465,
      1.466,
      1.467,
      1.468,
      1.469,
      1.47,
      1.471,
      1.472,
      1.473,
      1.474,
      1.475,
      1.476,
      1.477,
      1.478,
      1.479,
      1.48,
      1.481,
      1.482,
      1.483,
      1.484,
      1.485,
      1.486,
      1.487,
      1.488,
      1.489,
      1.49,
      1.491,
      1.492,
      1.493,
      1.494,
      1.495,
      1.496,
      1.497,
      1.498,
      1.499,
      1.5,
      1.5010000000000001E+000,
      1.502,
      1.5030000000000001E+000,
      1.504,
      1.5050000000000001E+000,
      1.506,
      1.5070000000000001E+000,
      1.508,
      1.5090000000000001E+000,
      1.51,
      1.5110000000000001E+000,
      1.512,
      1.5130000000000001E+000,
      1.514,
      1.5150000000000001E+000,
      1.516,
      1.5170000000000001E+000,
      1.518,
      1.5190000000000001E+000,
      1.52,
      1.5210000000000001E+000,
      1.522,
      1.5230000000000001E+000,
      1.524,
      1.5250000000000001E+000,
      1.526,
      1.5270000000000001E+000,
      1.528,
      1.5290000000000001E+000,
      1.53,
      1.5310000000000001E+000,
      1.532,
      1.5330000000000001E+000,
      1.534,
      1.5350000000000001E+000,
      1.536,
      1.537,
      1.538,
      1.539,
      1.54,
      1.541,
      1.542,
      1.543,
      1.544,
      1.545,
      1.546,
      1.547,
      1.548,
      1.549,
      1.55,
      1.551,
      1.552,
      1.553,
      1.554,
      1.555,
      1.556,
      1.557,
      1.558,
      1.559,
      1.56,
      1.561,
      1.562,
      1.563,
      1.564,
      1.565,
      1.566,
      1.567,
      1.568,
      1.569,
      1.57,
      1.571,
      1.572,
      1.573,
      1.574,
      1.575,
      1.576,
      1.577,
      1.578,
      1.579,
      1.58,
      1.581,
      1.582,
      1.583,
      1.584,
      1.585,
      1.586,
      1.587,
      1.588,
      1.589,
      1.59,
      1.591,
      1.592,
      1.593,
      1.594,
      1.595,
      1.596,
      1.597,
      1.598,
      1.599,
      1.6,
      1.601,
      1.602,
      1.603,
      1.604,
      1.605,
      1.606,
      1.607,
      1.608,
      1.609,
      1.61,
      1.611,
      1.612,
      1.613,
      1.614,
      1.615,
      1.616,
      1.617,
      1.618,
      1.619,
      1.62,
      1.621,
      1.622,
      1.623,
      1.624,
      1.625,
      1.6260000000000001E+000,
      1.627,
      1.6280000000000001E+000,
      1.629,
      1.6300000000000001E+000,
      1.631,
      1.6320000000000001E+000,
      1.633,
      1.6340000000000001E+000,
      1.635,
      1.6360000000000001E+000,
      1.637,
      1.6380000000000001E+000,
      1.639,
      1.6400000000000001E+000,
      1.641,
      1.6420000000000001E+000,
      1.643,
      1.6440000000000001E+000,
      1.645,
      1.6460000000000001E+000,
      1.647,
      1.6480000000000001E+000,
      1.649,
      1.6500000000000001E+000,
      1.651,
      1.6520000000000001E+000,
      1.653,
      1.6540000000000001E+000,
      1.655,
      1.6560000000000001E+000,
      1.657,
      1.6580000000000001E+000,
      1.659,
      1.6600000000000001E+000,
      1.661,
      1.6620000000000001E+000,
      1.663,
      1.6640000000000001E+000,
      1.665,
      1.666,
      1.667,
      1.668,
      1.669,
      1.67,
      1.671,
      1.672,
      1.673,
      1.674,
      1.675,
      1.676,
      1.677,
      1.678,
      1.679,
      1.68,
      1.681,
      1.682,
      1.683,
      1.684,
      1.685,
      1.686,
      1.687,
      1.688,
      1.689,
      1.69,
      1.691,
      1.692,
      1.693,
      1.694,
      1.695,
      1.696,
      1.697,
      1.698,
      1.699,
      1.7,
      1.701,
      1.702,
      1.703,
      1.704,
      1.705,
      1.706,
      1.707,
      1.708,
      1.709,
      1.71,
      1.711,
      1.712,
      1.713,
      1.714,
      1.715,
      1.716,
      1.717,
      1.718,
      1.719,
      1.72,
      1.721,
      1.722,
      1.723,
      1.724,
      1.725,
      1.726,
      1.727,
      1.728,
      1.729,
      1.73,
      1.731,
      1.732,
      1.733,
      1.734,
      1.735,
      1.736,
      1.737,
      1.738,
      1.739,
      1.74,
      1.741,
      1.742,
      1.743,
      1.744,
      1.745,
      1.746,
      1.747,
      1.748,
      1.749,
      1.75,
      1.7510000000000001E+000,
      1.752,
      1.7530000000000001E+000,
      1.754,
      1.7550000000000001E+000,
      1.756,
      1.7570000000000001E+000,
      1.758,
      1.7590000000000001E+000,
      1.76,
      1.7610000000000001E+000,
      1.762,
      1.7630000000000001E+000,
      1.764,
      1.7650000000000001E+000,
      1.766,
      1.7670000000000001E+000,
      1.768,
      1.7690000000000001E+000,
      1.77,
      1.7710000000000001E+000,
      1.772,
      1.7730000000000001E+000,
      1.774,
      1.7750000000000001E+000,
      1.776,
      1.7770000000000001E+000,
      1.778,
      1.7790000000000001E+000,
      1.78,
      1.7810000000000001E+000,
      1.782,
      1.7830000000000001E+000,
      1.784,
      1.7850000000000001E+000,
      1.786,
      1.7870000000000001E+000,
      1.788,
      1.7890000000000001E+000,
      1.79,
      1.7910000000000001E+000,
      1.792,
      1.793,
      1.794,
      1.795,
      1.796,
      1.797,
      1.798,
      1.799,
      1.8,
      1.801,
      1.802,
      1.803,
      1.804,
      1.805,
      1.806,
      1.807,
      1.808,
      1.809,
      1.81,
      1.811,
      1.812,
      1.813,
      1.814,
      1.815,
      1.816,
      1.817,
      1.818,
      1.819,
      1.82,
      1.821,
      1.822,
      1.823,
      1.824,
      1.825,
      1.826,
      1.827,
      1.828,
      1.829,
      1.83,
      1.831,
      1.832,
      1.833,
      1.834,
      1.835,
      1.836,
      1.837,
      1.838,
      1.839,
      1.84,
      1.841,
      1.842,
      1.843,
      1.844,
      1.845,
      1.846,
      1.847,
      1.848,
      1.849,
      1.85,
      1.851,
      1.852,
      1.853,
      1.854,
      1.855,
      1.856,
      1.857,
      1.858,
      1.859,
      1.86,
      1.861,
      1.862,
      1.863,
      1.864,
      1.865,
      1.866,
      1.867,
      1.868,
      1.869,
      1.87,
      1.871,
      1.872,
      1.873,
      1.874,
      1.875,
      1.8760000000000001E+000,
      1.877,
      1.8780000000000001E+000,
      1.879,
      1.8800000000000001E+000,
      1.881,
      1.8820000000000001E+000,
      1.883,
      1.8840000000000001E+000,
      1.885,
      1.8860000000000001E+000,
      1.887,
      1.8880000000000001E+000,
      1.889,
      1.8900000000000001E+000,
      1.891,
      1.8920000000000001E+000,
      1.893,
      1.8940000000000001E+000,
      1.895,
      1.8960000000000001E+000,
      1.897,
      1.8980000000000001E+000,
      1.899,
      1.9000000000000001E+000,
      1.901,
      1.9020000000000001E+000,
      1.903,
      1.9040000000000001E+000,
      1.905,
      1.9060000000000001E+000,
      1.907,
      1.9080000000000001E+000,
      1.909,
      1.9100000000000001E+000,
      1.911,
      1.9120000000000001E+000,
      1.913,
      1.9140000000000001E+000,
      1.915,
      1.9160000000000001E+000,
      1.917,
      1.9180000000000001E+000,
      1.919,
      1.92,
      1.921,
      1.922,
      1.923,
      1.924,
      1.925,
      1.926,
      1.927,
      1.928,
      1.929,
      1.93,
      1.931,
      1.932,
      1.933,
      1.934,
      1.935,
      1.936,
      1.937,
      1.938,
      1.939,
      1.94,
      1.941,
      1.942,
      1.943,
      1.944,
      1.945,
      1.946,
      1.947,
      1.948,
      1.949,
      1.95,
      1.951,
      1.952,
      1.953,
      1.954,
      1.955,
      1.956,
      1.957,
      1.958,
      1.959,
      1.96,
      1.961,
      1.962,
      1.963,
      1.964,
      1.965,
      1.966,
      1.967,
      1.968,
      1.969,
      1.97,
      1.971,
      1.972,
      1.973,
      1.974,
      1.975,
      1.976,
      1.977,
      1.978,
      1.979,
      1.98,
      1.981,
      1.982,
      1.983,
      1.984,
      1.985,
      1.986,
      1.987,
      1.988,
      1.989,
      1.99,
      1.991,
      1.992,
      1.993,
      1.994,
      1.995,
      1.996,
      1.997,
      1.998,
      1.999,
      2.0,
      2.001,
      2.0020000000000002E+000,
      2.003,
      2.004,
      2.005,
      2.0060000000000002E+000,
      2.007,
      2.008,
      2.009,
      2.0100000000000002E+000,
      2.011,
      2.012,
      2.013,
      2.0140000000000002E+000,
      2.015,
      2.016,
      2.017,
      2.0180000000000002E+000,
      2.019,
      2.02,
      2.021,
      2.0220000000000002E+000,
      2.023,
      2.024,
      2.025,
      2.0260000000000002E+000,
      2.027,
      2.028,
      2.029,
      2.0300000000000002E+000,
      2.031,
      2.032,
      2.033,
      2.0340000000000003E+000,
      2.035,
      2.036,
      2.037,
      2.0380000000000003E+000,
      2.039,
      2.04,
      2.041,
      2.0420000000000003E+000,
      2.043,
      2.044,
      2.045,
      2.0460000000000003E+000,
      2.047,
      2.048,
      2.049,
      2.05,
      2.051,
      2.052,
      2.053,
      2.054,
      2.055,
      2.056,
      2.057,
      2.058,
      2.059,
      2.06,
      2.061,
      2.062,
      2.063,
      2.064,
      2.065,
      2.066,
      2.067,
      2.068,
      2.069,
      2.07,
      2.071,
      2.072,
      2.073,
      2.074,
      2.075,
      2.076,
      2.077,
      2.078,
      2.079,
      2.08,
      2.081,
      2.082,
      2.083,
      2.084,
      2.085,
      2.086,
      2.087,
      2.088,
      2.089,
      2.09,
      2.091,
      2.092,
      2.093,
      2.094,
      2.095,
      2.096,
      2.097,
      2.098,
      2.099,
      2.1,
      2.101,
      2.102,
      2.103,
      2.104,
      2.105,
      2.106,
      2.107,
      2.108,
      2.109,
      2.11,
      2.111,
      2.112,
      2.113,
      2.114,
      2.115,
      2.116,
      2.117,
      2.118,
      2.119,
      2.12,
      2.121,
      2.122,
      2.123,
      2.124,
      2.125,
      2.126,
      2.1270000000000002E+000,
      2.128,
      2.129,
      2.13,
      2.1310000000000002E+000,
      2.132,
      2.133,
      2.134,
      2.1350000000000002E+000,
      2.136,
      2.137,
      2.138,
      2.1390000000000002E+000,
      2.14,
      2.141,
      2.142,
      2.1430000000000002E+000,
      2.144,
      2.145,
      2.146,
      2.1470000000000002E+000,
      2.148,
      2.149,
      2.15,
      2.1510000000000002E+000,
      2.152,
      2.153,
      2.154,
      2.1550000000000002E+000,
      2.156,
      2.157,
      2.158,
      2.1590000000000003E+000,
      2.16,
      2.161,
      2.162,
      2.1630000000000003E+000,
      2.164,
      2.165,
      2.166,
      2.1670000000000003E+000,
      2.168,
      2.169,
      2.17,
      2.1710000000000003E+000,
      2.172,
      2.173,
      2.174,
      2.1750000000000003E+000,
      2.176,
      2.177,
      2.178,
      2.179,
      2.18,
      2.181,
      2.182,
      2.183,
      2.184,
      2.185,
      2.186,
      2.187,
      2.188,
      2.189,
      2.19,
      2.191,
      2.192,
      2.193,
      2.194,
      2.195,
      2.196,
      2.197,
      2.198,
      2.199,
      2.2,
      2.201,
      2.202,
      2.203,
      2.204,
      2.205,
      2.206,
      2.207,
      2.208,
      2.209,
      2.21,
      2.211,
      2.212,
      2.213,
      2.214,
      2.215,
      2.216,
      2.217,
      2.218,
      2.219,
      2.22,
      2.221,
      2.222,
      2.223,
      2.224,
      2.225,
      2.226,
      2.227,
      2.228,
      2.229,
      2.23,
      2.231,
      2.232,
      2.233,
      2.234,
      2.235,
      2.236,
      2.237,
      2.238,
      2.239,
      2.24,
      2.241,
      2.242,
      2.243,
      2.244,
      2.245,
      2.246,
      2.247,
      2.248,
      2.249,
      2.25,
      2.251,
      2.2520000000000002E+000,
      2.253,
      2.254,
      2.255,
      2.2560000000000002E+000,
      2.257,
      2.258,
      2.259,
      2.2600000000000002E+000,
      2.261,
      2.262,
      2.263,
      2.2640000000000002E+000,
      2.265,
      2.266,
      2.267,
      2.2680000000000002E+000,
      2.269,
      2.27,
      2.271,
      2.2720000000000002E+000,
      2.273,
      2.274,
      2.275,
      2.2760000000000002E+000,
      2.277,
      2.278,
      2.279,
      2.2800000000000002E+000,
      2.281,
      2.282,
      2.283,
      2.2840000000000003E+000,
      2.285,
      2.286,
      2.287,
      2.2880000000000003E+000,
      2.289,
      2.29,
      2.291,
      2.2920000000000003E+000,
      2.293,
      2.294,
      2.295,
      2.2960000000000003E+000,
      2.297,
      2.298,
      2.299,
      2.3000000000000003E+000,
      2.301,
      2.302,
      2.303,
      2.3040000000000003E+000,
      2.305,
      2.306,
      2.307,
      2.308,
      2.309,
      2.31,
      2.311,
      2.312,
      2.313,
      2.314,
      2.315,
      2.316,
      2.317,
      2.318,
      2.319,
      2.32,
      2.321,
      2.322,
      2.323,
      2.324,
      2.325,
      2.326,
      2.327,
      2.328,
      2.329,
      2.33,
      2.331,
      2.332,
      2.333,
      2.334,
      2.335,
      2.336,
      2.337,
      2.338,
      2.339,
      2.34,
      2.341,
      2.342,
      2.343,
      2.344,
      2.345,
      2.346,
      2.347,
      2.348,
      2.349,
      2.35,
      2.351,
      2.352,
      2.353,
      2.354,
      2.355,
      2.356,
      2.357,
      2.358,
      2.359,
      2.36,
      2.361,
      2.362,
      2.363,
      2.364,
      2.365,
      2.366,
      2.367,
      2.368,
      2.369,
      2.37,
      2.371,
      2.372,
      2.373,
      2.374,
      2.375,
      2.376,
      2.3770000000000002E+000,
      2.378,
      2.379,
      2.38,
      2.3810000000000002E+000,
      2.382,
      2.383,
      2.384,
      2.3850000000000002E+000,
      2.386,
      2.387,
      2.388,
      2.3890000000000002E+000,
      2.39,
      2.391,
      2.392,
      2.3930000000000002E+000,
      2.394,
      2.395,
      2.396,
      2.3970000000000002E+000,
      2.398,
      2.399,
      2.4,
      2.4010000000000002E+000,
      2.402,
      2.403,
      2.404,
      2.4050000000000002E+000,
      2.406,
      2.407,
      2.408,
      2.4090000000000003E+000,
      2.41,
      2.411,
      2.412,
      2.4130000000000003E+000,
      2.414,
      2.415,
      2.416,
      2.4170000000000003E+000,
      2.418,
      2.419,
      2.42,
      2.4210000000000003E+000,
      2.422,
      2.423,
      2.424,
      2.4250000000000003E+000,
      2.426,
      2.427,
      2.428,
      2.4290000000000003E+000,
      2.43,
      2.431,
      2.432,
      2.433,
      2.434,
      2.435,
      2.436,
      2.437,
      2.438,
      2.439,
      2.44,
      2.441,
      2.442,
      2.443,
      2.444,
      2.445,
      2.446,
      2.447,
      2.448,
      2.449,
      2.45,
      2.451,
      2.452,
      2.453,
      2.454,
      2.455,
      2.456,
      2.457,
      2.458,
      2.459,
      2.46,
      2.461,
      2.462,
      2.463,
      2.464,
      2.465,
      2.466,
      2.467,
      2.468,
      2.469,
      2.47,
      2.471,
      2.472,
      2.473,
      2.474,
      2.475,
      2.476,
      2.477,
      2.478,
      2.479,
      2.48,
      2.481,
      2.482,
      2.483,
      2.484,
      2.485,
      2.486,
      2.487,
      2.488,
      2.489,
      2.49,
      2.491,
      2.492,
      2.493,
      2.494,
      2.495,
      2.496,
      2.497,
      2.498,
      2.499,
      2.5,
      2.501,
      2.5020000000000002E+000,
      2.503,
      2.504,
      2.505,
      2.5060000000000002E+000,
      2.507,
      2.508,
      2.509,
      2.5100000000000002E+000,
      2.511,
      2.512,
      2.513,
      2.5140000000000002E+000,
      2.515,
      2.516,
      2.517,
      2.5180000000000002E+000,
      2.519,
      2.52,
      2.521,
      2.5220000000000002E+000,
      2.523,
      2.524,
      2.525,
      2.5260000000000002E+000,
      2.527,
      2.528,
      2.529,
      2.5300000000000002E+000,
      2.531,
      2.532,
      2.533,
      2.5340000000000003E+000,
      2.535,
      2.536,
      2.537,
      2.5380000000000003E+000,
      2.539,
      2.54,
      2.541,
      2.5420000000000003E+000,
      2.543,
      2.544,
      2.545,
      2.5460000000000003E+000,
      2.547,
      2.548,
      2.549,
      2.5500000000000003E+000,
      2.551,
      2.552,
      2.553,
      2.5540000000000003E+000,
      2.555,
      2.556,
      2.557,
      2.5580000000000003E+000,
      2.559,
      2.56,
      2.561,
      2.562,
      2.563,
      2.564,
      2.565,
      2.566,
      2.567,
      2.568,
      2.569,
      2.57,
      2.571,
      2.572,
      2.573,
      2.574,
      2.575,
      2.576,
      2.577,
      2.578,
      2.579,
      2.58,
      2.581,
      2.582,
      2.583,
      2.584,
      2.585,
      2.586,
      2.587,
      2.588,
      2.589,
      2.59,
      2.591,
      2.592,
      2.593,
      2.594,
      2.595,
      2.596,
      2.597,
      2.598,
      2.599,
      2.6,
      2.601,
      2.602,
      2.603,
      2.604,
      2.605,
      2.606,
      2.607,
      2.608,
      2.609,
      2.61,
      2.611,
      2.612,
      2.613,
      2.614,
      2.615,
      2.616,
      2.617,
      2.618,
      2.619,
      2.62,
      2.621,
      2.622,
      2.623,
      2.624,
      2.625,
      2.626,
      2.6270000000000002E+000,
      2.628,
      2.629,
      2.63,
      2.6310000000000002E+000,
      2.632,
      2.633,
      2.634,
      2.6350000000000002E+000,
      2.636,
      2.637,
      2.638,
      2.6390000000000002E+000,
      2.64,
      2.641,
      2.642,
      2.6430000000000002E+000,
      2.644,
      2.645,
      2.646,
      2.6470000000000002E+000,
      2.648,
      2.649,
      2.65,
      2.6510000000000002E+000,
      2.652,
      2.653,
      2.654,
      2.6550000000000002E+000,
      2.656,
      2.657,
      2.658,
      2.6590000000000003E+000,
      2.66,
      2.661,
      2.662,
      2.6630000000000003E+000,
      2.664,
      2.665,
      2.666,
      2.6670000000000003E+000,
      2.668,
      2.669,
      2.67,
      2.6710000000000003E+000,
      2.672,
      2.673,
      2.674,
      2.6750000000000003E+000,
      2.676,
      2.677,
      2.678,
      2.6790000000000003E+000,
      2.68,
      2.681,
      2.682,
      2.6830000000000003E+000,
      2.684,
      2.685,
      2.686,
      2.6870000000000003E+000,
      2.688,
      2.689,
      2.69,
      2.691,
      2.692,
      2.693,
      2.694,
      2.695,
      2.696,
      2.697,
      2.698,
      2.699,
      2.7,
      2.701,
      2.702,
      2.703,
      2.704,
      2.705,
      2.706,
      2.707,
      2.708,
      2.709,
      2.71,
      2.711,
      2.712,
      2.713,
      2.714,
      2.715,
      2.716,
      2.717,
      2.718,
      2.719,
      2.72,
      2.721,
      2.722,
      2.723,
      2.724,
      2.725,
      2.726,
      2.727,
      2.728,
      2.729,
      2.73,
      2.731,
      2.732,
      2.733,
      2.734,
      2.735,
      2.736,
      2.737,
      2.738,
      2.739,
      2.74,
      2.741,
      2.742,
      2.743,
      2.744,
      2.745,
      2.746,
      2.747,
      2.748,
      2.749,
      2.75,
      2.751,
      2.7520000000000002E+000,
      2.753,
      2.754,
      2.755,
      2.7560000000000002E+000,
      2.757,
      2.758,
      2.759,
      2.7600000000000002E+000,
      2.761,
      2.762,
      2.763,
      2.7640000000000002E+000,
      2.765,
      2.766,
      2.767,
      2.7680000000000002E+000,
      2.769,
      2.77,
      2.771,
      2.7720000000000002E+000,
      2.773,
      2.774,
      2.775,
      2.7760000000000002E+000,
      2.777,
      2.778,
      2.779,
      2.7800000000000002E+000,
      2.781,
      2.782,
      2.783,
      2.7840000000000003E+000,
      2.785,
      2.786,
      2.787,
      2.7880000000000003E+000,
      2.789,
      2.79,
      2.791,
      2.7920000000000003E+000,
      2.793,
      2.794,
      2.795,
      2.7960000000000003E+000,
      2.797,
      2.798,
      2.799,
      2.8000000000000003E+000,
      2.801,
      2.802,
      2.803,
      2.8040000000000003E+000,
      2.805,
      2.806,
      2.807,
      2.8080000000000003E+000,
      2.809,
      2.81,
      2.811,
      2.8120000000000003E+000,
      2.813,
      2.814,
      2.815,
      2.816,
      2.817,
      2.818,
      2.819,
      2.82,
      2.821,
      2.822,
      2.823,
      2.824,
      2.825,
      2.826,
      2.827,
      2.828,
      2.829,
      2.83,
      2.831,
      2.832,
      2.833,
      2.834,
      2.835,
      2.836,
      2.837,
      2.838,
      2.839,
      2.84,
      2.841,
      2.842,
      2.843,
      2.844,
      2.845,
      2.846,
      2.847,
      2.848,
      2.849,
      2.85,
      2.851,
      2.852,
      2.853,
      2.854,
      2.855,
      2.856,
      2.857,
      2.858,
      2.859,
      2.86,
      2.861,
      2.862,
      2.863,
      2.864,
      2.865,
      2.866,
      2.867,
      2.868,
      2.869,
      2.87,
      2.871,
      2.872,
      2.873,
      2.874,
      2.875,
      2.876,
      2.8770000000000002E+000,
      2.878,
      2.879,
      2.88,
      2.8810000000000002E+000,
      2.882,
      2.883,
      2.884,
      2.8850000000000002E+000,
      2.886,
      2.887,
      2.888,
      2.8890000000000002E+000,
      2.89,
      2.891,
      2.892,
      2.8930000000000002E+000,
      2.894,
      2.895,
      2.896,
      2.8970000000000002E+000,
      2.898,
      2.899,
      2.9,
      2.9010000000000002E+000,
      2.902,
      2.903,
      2.904,
      2.9050000000000002E+000,
      2.906,
      2.907,
      2.908,
      2.9090000000000003E+000,
      2.91,
      2.911,
      2.912,
      2.9130000000000003E+000,
      2.914,
      2.915,
      2.916,
      2.9170000000000003E+000,
      2.918,
      2.919,
      2.92,
      2.9210000000000003E+000,
      2.922,
      2.923,
      2.924,
      2.9250000000000003E+000,
      2.926,
      2.927,
      2.928,
      2.9290000000000003E+000,
      2.93,
      2.931,
      2.932,
      2.9330000000000003E+000,
      2.934,
      2.935,
      2.936,
      2.9370000000000003E+000,
      2.938,
      2.939,
      2.94,
      2.9410000000000003E+000,
      2.942,
      2.943,
      2.944,
      2.945,
      2.946,
      2.947,
      2.948,
      2.949,
      2.95,
      2.951,
      2.952,
      2.953,
      2.954,
      2.955,
      2.956,
      2.957,
      2.958,
      2.959,
      2.96,
      2.961,
      2.962,
      2.963,
      2.964,
      2.965,
      2.966,
      2.967,
      2.968,
      2.969,
      2.97,
      2.971,
      2.972,
      2.973,
      2.974,
      2.975,
      2.976,
      2.977,
      2.978,
      2.979,
      2.98,
      2.981,
      2.982,
      2.983,
      2.984,
      2.985,
      2.986,
      2.987,
      2.988,
      2.989,
      2.99,
      2.991,
      2.992,
      2.993,
      2.994,
      2.995,
      2.996,
      2.997,
      2.998,
      2.999,
      3.0,
      3.001,
      3.0020000000000002E+000,
      3.003,
      3.004,
      3.005,
      3.0060000000000002E+000,
      3.007,
      3.008,
      3.009,
      3.0100000000000002E+000,
      3.011,
      3.012,
      3.013,
      3.0140000000000002E+000,
      3.015,
      3.016,
      3.017,
      3.0180000000000002E+000,
      3.019,
      3.02,
      3.021,
      3.0220000000000002E+000,
      3.023,
      3.024,
      3.025,
      3.0260000000000002E+000,
      3.027,
      3.028,
      3.029,
      3.0300000000000002E+000,
      3.031,
      3.032,
      3.033,
      3.0340000000000003E+000,
      3.035,
      3.036,
      3.037,
      3.0380000000000003E+000,
      3.039,
      3.04,
      3.041,
      3.0420000000000003E+000,
      3.043,
      3.044,
      3.045,
      3.0460000000000003E+000,
      3.047,
      3.048,
      3.049,
      3.0500000000000003E+000,
      3.051,
      3.052,
      3.053,
      3.0540000000000003E+000,
      3.055,
      3.056,
      3.057,
      3.0580000000000003E+000,
      3.059,
      3.06,
      3.061,
      3.0620000000000003E+000,
      3.063,
      3.064,
      3.065,
      3.0660000000000003E+000,
      3.067,
      3.068,
      3.069,
      3.0700000000000003E+000,
      3.071,
      3.072,
      3.073,
      3.074,
      3.075,
      3.076,
      3.077,
      3.078,
      3.079,
      3.08,
      3.081,
      3.082,
      3.083,
      3.084,
      3.085,
      3.086,
      3.087,
      3.088,
      3.089,
      3.09,
      3.091,
      3.092,
      3.093,
      3.094,
      3.095,
      3.096,
      3.097,
      3.098,
      3.099,
      3.1,
      3.101,
      3.102,
      3.103,
      3.104,
      3.105,
      3.106,
      3.107,
      3.108,
      3.109,
      3.11,
      3.111,
      3.112,
      3.113,
      3.114,
      3.115,
      3.116,
      3.117,
      3.118,
      3.119,
      3.12,
      3.121,
      3.122,
      3.123,
      3.124,
      3.125,
      3.126,
      3.1270000000000002E+000,
      3.128,
      3.129,
      3.13,
      3.1310000000000002E+000,
      3.132,
      3.133,
      3.134,
      3.1350000000000002E+000,
      3.136,
      3.137,
      3.138,
      3.1390000000000002E+000,
      3.14,
      3.141,
      3.142,
      3.1430000000000002E+000,
      3.144,
      3.145,
      3.146,
      3.1470000000000002E+000,
      3.148,
      3.149,
      3.15,
      3.1510000000000002E+000,
      3.152,
      3.153,
      3.154,
      3.1550000000000002E+000,
      3.156,
      3.157,
      3.158,
      3.1590000000000003E+000,
      3.16,
      3.161,
      3.162,
      3.1630000000000003E+000,
      3.164,
      3.165,
      3.166,
      3.1670000000000003E+000,
      3.168,
      3.169,
      3.17,
      3.1710000000000003E+000,
      3.172,
      3.173,
      3.174,
      3.1750000000000003E+000,
      3.176,
      3.177,
      3.178,
      3.1790000000000003E+000,
      3.18,
      3.181,
      3.182,
      3.1830000000000003E+000,
      3.184,
      3.185,
      3.186,
      3.1870000000000003E+000,
      3.188,
      3.189,
      3.19,
      3.1910000000000003E+000,
      3.192,
      3.193,
      3.194,
      3.1950000000000003E+000,
      3.196,
      3.197,
      3.198,
      3.1990000000000003E+000,
      3.2,
      3.201,
      3.202,
      3.203,
      3.204,
      3.205,
      3.206,
      3.207,
      3.208,
      3.209,
      3.21,
      3.211,
      3.212,
      3.213,
      3.214,
      3.215,
      3.216,
      3.217,
      3.218,
      3.219,
      3.22,
      3.221,
      3.222,
      3.223,
      3.224,
      3.225,
      3.226,
      3.227,
      3.228,
      3.229,
      3.23,
      3.231,
      3.232,
      3.233,
      3.234,
      3.235,
      3.236,
      3.237,
      3.238,
      3.239,
      3.24,
      3.241,
      3.242,
      3.243,
      3.244,
      3.245,
      3.246,
      3.247,
      3.248,
      3.249,
      3.25,
      3.251,
      3.2520000000000002E+000,
      3.253,
      3.254,
      3.255,
      3.2560000000000002E+000,
      3.257,
      3.258,
      3.259,
      3.2600000000000002E+000,
      3.261,
      3.262,
      3.263,
      3.2640000000000002E+000,
      3.265,
      3.266,
      3.267,
      3.2680000000000002E+000,
      3.269,
      3.27,
      3.271,
      3.2720000000000002E+000,
      3.273,
      3.274,
      3.275,
      3.2760000000000002E+000,
      3.277,
      3.278,
      3.279,
      3.2800000000000002E+000,
      3.281,
      3.282,
      3.283,
      3.2840000000000003E+000,
      3.285,
      3.286,
      3.287,
      3.2880000000000003E+000,
      3.289,
      3.29,
      3.291,
      3.2920000000000003E+000,
      3.293,
      3.294,
      3.295,
      3.2960000000000003E+000,
      3.297,
      3.298,
      3.299,
      3.3000000000000003E+000,
      3.301,
      3.302,
      3.303,
      3.3040000000000003E+000,
      3.305,
      3.306,
      3.307,
      3.3080000000000003E+000,
      3.309,
      3.31,
      3.311,
      3.3120000000000003E+000,
      3.313,
      3.314,
      3.315,
      3.3160000000000003E+000,
      3.317,
      3.318,
      3.319,
      3.3200000000000003E+000,
      3.321,
      3.322,
      3.323,
      3.3240000000000003E+000,
      3.325,
      3.326,
      3.327,
      3.3280000000000003E+000,
      3.329,
      3.33,
      3.331,
      3.332,
      3.333,
      3.334,
      3.335,
      3.336,
      3.337,
      3.338,
      3.339,
      3.34,
      3.341,
      3.342,
      3.343,
      3.344,
      3.345,
      3.346,
      3.347,
      3.348,
      3.349,
      3.35,
      3.351,
      3.352,
      3.353,
      3.354,
      3.355,
      3.356,
      3.357,
      3.358,
      3.359,
      3.36,
      3.361,
      3.362,
      3.363,
      3.364,
      3.365,
      3.366,
      3.367,
      3.368,
      3.369,
      3.37,
      3.371,
      3.372,
      3.373,
      3.374,
      3.375,
      3.376,
      3.3770000000000002E+000,
      3.378,
      3.379,
      3.38,
      3.3810000000000002E+000,
      3.382,
      3.383,
      3.384,
      3.3850000000000002E+000,
      3.386,
      3.387,
      3.388,
      3.3890000000000002E+000,
      3.39,
      3.391,
      3.392,
      3.3930000000000002E+000,
      3.394,
      3.395,
      3.396,
      3.3970000000000002E+000,
      3.398,
      3.399,
      3.4,
      3.4010000000000002E+000,
      3.402,
      3.403,
      3.404,
      3.4050000000000002E+000,
      3.406,
      3.407,
      3.408,
      3.4090000000000003E+000,
      3.41,
      3.411,
      3.412,
      3.4130000000000003E+000,
      3.414,
      3.415,
      3.416,
      3.4170000000000003E+000,
      3.418,
      3.419,
      3.42,
      3.4210000000000003E+000,
      3.422,
      3.423,
      3.424,
      3.4250000000000003E+000,
      3.426,
      3.427,
      3.428,
      3.4290000000000003E+000,
      3.43,
      3.431,
      3.432,
      3.4330000000000003E+000,
      3.434,
      3.435,
      3.436,
      3.4370000000000003E+000,
      3.438,
      3.439,
      3.44,
      3.4410000000000003E+000,
      3.442,
      3.443,
      3.444,
      3.4450000000000003E+000,
      3.446,
      3.447,
      3.448,
      3.4490000000000003E+000,
      3.45,
      3.451,
      3.452,
      3.4530000000000003E+000,
      3.454,
      3.455,
      3.456,
      3.457,
      3.458,
      3.459,
      3.46,
      3.461,
      3.462,
      3.463,
      3.464,
      3.465,
      3.466,
      3.467,
      3.468,
      3.469,
      3.47,
      3.471,
      3.472,
      3.473,
      3.474,
      3.475,
      3.476,
      3.477,
      3.478,
      3.479,
      3.48,
      3.481,
      3.482,
      3.483,
      3.484,
      3.485,
      3.486,
      3.487,
      3.488,
      3.489,
      3.49,
      3.491,
      3.492,
      3.493,
      3.494,
      3.495,
      3.496,
      3.497,
      3.498,
      3.499,
      3.5,
      3.501,
      3.5020000000000002E+000,
      3.503,
      3.504,
      3.505,
      3.5060000000000002E+000,
      3.507,
      3.508,
      3.509,
      3.5100000000000002E+000,
      3.511,
      3.512,
      3.513,
      3.5140000000000002E+000,
      3.515,
      3.516,
      3.517,
      3.5180000000000002E+000,
      3.519,
      3.52,
      3.521,
      3.5220000000000002E+000,
      3.523,
      3.524,
      3.525,
      3.5260000000000002E+000,
      3.527,
      3.528,
      3.529,
      3.5300000000000002E+000,
      3.531,
      3.532,
      3.533,
      3.5340000000000003E+000,
      3.535,
      3.536,
      3.537,
      3.5380000000000003E+000,
      3.539,
      3.54,
      3.541,
      3.5420000000000003E+000,
      3.543,
      3.544,
      3.545,
      3.5460000000000003E+000,
      3.547,
      3.548,
      3.549,
      3.5500000000000003E+000,
      3.551,
      3.552,
      3.553,
      3.5540000000000003E+000,
      3.555,
      3.556,
      3.557,
      3.5580000000000003E+000,
      3.559,
      3.56,
      3.561,
      3.5620000000000003E+000,
      3.563,
      3.564,
      3.565,
      3.5660000000000003E+000,
      3.567,
      3.568,
      3.569,
      3.5700000000000003E+000,
      3.571,
      3.572,
      3.573,
      3.5740000000000003E+000,
      3.575,
      3.576,
      3.577,
      3.5780000000000003E+000,
      3.579,
      3.58,
      3.581,
      3.5820000000000003E+000,
      3.583,
      3.584,
      3.585,
      3.586,
      3.587,
      3.588,
      3.589,
      3.59,
      3.591,
      3.592,
      3.593,
      3.594,
      3.595,
      3.596,
      3.597,
      3.598,
      3.599,
      3.6,
      3.601,
      3.602,
      3.603,
      3.604,
      3.605,
      3.606,
      3.607,
      3.608,
      3.609,
      3.61,
      3.611,
      3.612,
      3.613,
      3.614,
      3.615,
      3.616,
      3.617,
      3.618,
      3.619,
      3.62,
      3.621,
      3.622,
      3.623,
      3.624,
      3.625,
      3.626,
      3.6270000000000002E+000,
      3.628,
      3.629,
      3.63,
      3.6310000000000002E+000,
      3.632,
      3.633,
      3.634,
      3.6350000000000002E+000,
      3.636,
      3.637,
      3.638,
      3.6390000000000002E+000,
      3.64,
      3.641,
      3.642,
      3.6430000000000002E+000,
      3.644,
      3.645,
      3.646,
      3.6470000000000002E+000,
      3.648,
      3.649,
      3.65,
      3.6510000000000002E+000,
      3.652,
      3.653,
      3.654,
      3.6550000000000002E+000,
      3.656,
      3.657,
      3.658,
      3.6590000000000003E+000,
      3.66,
      3.661,
      3.662,
      3.6630000000000003E+000,
      3.664,
      3.665,
      3.666,
      3.6670000000000003E+000,
      3.668,
      3.669,
      3.67,
      3.6710000000000003E+000,
      3.672,
      3.673,
      3.674,
      3.6750000000000003E+000,
      3.676,
      3.677,
      3.678,
      3.6790000000000003E+000,
      3.68,
      3.681,
      3.682,
      3.6830000000000003E+000,
      3.684,
      3.685,
      3.686,
      3.6870000000000003E+000,
      3.688,
      3.689,
      3.69,
      3.6910000000000003E+000,
      3.692,
      3.693,
      3.694,
      3.6950000000000003E+000,
      3.696,
      3.697,
      3.698,
      3.6990000000000003E+000,
      3.7,
      3.701,
      3.702,
      3.7030000000000003E+000,
      3.704,
      3.705,
      3.706,
      3.7070000000000003E+000,
      3.708,
      3.709,
      3.71,
      3.7110000000000003E+000,
      3.712,
      3.713,
      3.714,
      3.715,
      3.716,
      3.717,
      3.718,
      3.719,
      3.72,
      3.721,
      3.722,
      3.723,
      3.724,
      3.725,
      3.726,
      3.727,
      3.728,
      3.729,
      3.73,
      3.731,
      3.732,
      3.733,
      3.734,
      3.735,
      3.736,
      3.737,
      3.738,
      3.739,
      3.74,
      3.741,
      3.742,
      3.743,
      3.744,
      3.745,
      3.746,
      3.747,
      3.748,
      3.749,
      3.75,
      3.751,
      3.7520000000000002E+000,
      3.753,
      3.754,
      3.755,
      3.7560000000000002E+000,
      3.757,
      3.758,
      3.759,
      3.7600000000000002E+000,
      3.761,
      3.762,
      3.763,
      3.7640000000000002E+000,
      3.765,
      3.766,
      3.767,
      3.7680000000000002E+000,
      3.769,
      3.77,
      3.771,
      3.7720000000000002E+000,
      3.773,
      3.774,
      3.775,
      3.7760000000000002E+000,
      3.777,
      3.778,
      3.779,
      3.7800000000000002E+000,
      3.781,
      3.782,
      3.783,
      3.7840000000000003E+000,
      3.785,
      3.786,
      3.787,
      3.7880000000000003E+000,
      3.789,
      3.79,
      3.791,
      3.7920000000000003E+000,
      3.793,
      3.794,
      3.795,
      3.7960000000000003E+000,
      3.797,
      3.798,
      3.799,
      3.8000000000000003E+000,
      3.801,
      3.802,
      3.803,
      3.8040000000000003E+000,
      3.805,
      3.806,
      3.807,
      3.8080000000000003E+000,
      3.809,
      3.81,
      3.811,
      3.8120000000000003E+000,
      3.813,
      3.814,
      3.815,
      3.8160000000000003E+000,
      3.817,
      3.818,
      3.819,
      3.8200000000000003E+000,
      3.821,
      3.822,
      3.823,
      3.8240000000000003E+000,
      3.825,
      3.826,
      3.827,
      3.8280000000000003E+000,
      3.829,
      3.83,
      3.831,
      3.8320000000000003E+000,
      3.833,
      3.834,
      3.835,
      3.8360000000000003E+000,
      3.837,
      3.838,
      3.839,
      3.84,
      3.841,
      3.842,
      3.843,
      3.844,
      3.845,
      3.846,
      3.847,
      3.848,
      3.849,
      3.85,
      3.851,
      3.852,
      3.853,
      3.854,
      3.855,
      3.856,
      3.857,
      3.858,
      3.859,
      3.86,
      3.861,
      3.862,
      3.863,
      3.864,
      3.865,
      3.866,
      3.867,
      3.868,
      3.869,
      3.87,
      3.871,
      3.872,
      3.873,
      3.874,
      3.875,
      3.876,
      3.8770000000000002E+000,
      3.878,
      3.879,
      3.88,
      3.8810000000000002E+000,
      3.882,
      3.883,
      3.884,
      3.8850000000000002E+000,
      3.886,
      3.887,
      3.888,
      3.8890000000000002E+000,
      3.89,
      3.891,
      3.892,
      3.8930000000000002E+000,
      3.894,
      3.895,
      3.896,
      3.8970000000000002E+000,
      3.898,
      3.899,
      3.9,
      3.9010000000000002E+000,
      3.902,
      3.903,
      3.904,
      3.9050000000000002E+000,
      3.906,
      3.907,
      3.908,
      3.9090000000000003E+000,
      3.91,
      3.911,
      3.912,
      3.9130000000000003E+000,
      3.914,
      3.915,
      3.916,
      3.9170000000000003E+000,
      3.918,
      3.919,
      3.92,
      3.9210000000000003E+000,
      3.922,
      3.923,
      3.924,
      3.9250000000000003E+000,
      3.926,
      3.927,
      3.928,
      3.9290000000000003E+000,
      3.93,
      3.931,
      3.932,
      3.9330000000000003E+000,
      3.934,
      3.935,
      3.936,
      3.9370000000000003E+000,
      3.938,
      3.939,
      3.94,
      3.9410000000000003E+000,
      3.942,
      3.943,
      3.944,
      3.9450000000000003E+000,
      3.946,
      3.947,
      3.948,
      3.9490000000000003E+000,
      3.95,
      3.951,
      3.952,
      3.9530000000000003E+000,
      3.954,
      3.955,
      3.956,
      3.9570000000000003E+000,
      3.958,
      3.959,
      3.96,
      3.9610000000000003E+000,
      3.962,
      3.963,
      3.964,
      3.9650000000000003E+000,
      3.966,
      3.967,
      3.968,
      3.969,
      3.97,
      3.971,
      3.972,
      3.973,
      3.974,
      3.975,
      3.976,
      3.977,
      3.978,
      3.979,
      3.98,
      3.981,
      3.982,
      3.983,
      3.984,
      3.985,
      3.986,
      3.987,
      3.988,
      3.989,
      3.99,
      3.991,
      3.992,
      3.993,
      3.994,
      3.995,
      3.996,
      3.997,
      3.998,
      3.999,
      4.0,
      4.001,
      4.002,
      4.003,
      4.0040000000000004E+000,
      4.005,
      4.006,
      4.007,
      4.008,
      4.009,
      4.01,
      4.011,
      4.0120000000000005E+000,
      4.013,
      4.014,
      4.015,
      4.016,
      4.017,
      4.018,
      4.019,
      4.0200000000000005E+000,
      4.021,
      4.022,
      4.023,
      4.024,
      4.025,
      4.026,
      4.027,
      4.0280000000000005E+000,
      4.029,
      4.03,
      4.031,
      4.032,
      4.033,
      4.034,
      4.035,
      4.0360000000000005E+000,
      4.037,
      4.038,
      4.039,
      4.04,
      4.041,
      4.042,
      4.043,
      4.0440000000000005E+000,
      4.045,
      4.046,
      4.047,
      4.048,
      4.049,
      4.05,
      4.051,
      4.0520000000000005E+000,
      4.053,
      4.054,
      4.055,
      4.056,
      4.057,
      4.058,
      4.059,
      4.0600000000000005E+000,
      4.061,
      4.062,
      4.063,
      4.064,
      4.065,
      4.066,
      4.067,
      4.0680000000000005E+000,
      4.069,
      4.07,
      4.071,
      4.072,
      4.073,
      4.074,
      4.075,
      4.0760000000000005E+000,
      4.077,
      4.078,
      4.079,
      4.08,
      4.081,
      4.082,
      4.083,
      4.0840000000000005E+000,
      4.085,
      4.086,
      4.087,
      4.088,
      4.089,
      4.09,
      4.091,
      4.0920000000000005E+000,
      4.093,
      4.094,
      4.095,
      4.096,
      4.097,
      4.098,
      4.099,
      4.1,
      4.101,
      4.102,
      4.103,
      4.104,
      4.105,
      4.106,
      4.107,
      4.108,
      4.109,
      4.11,
      4.111,
      4.112,
      4.113,
      4.114,
      4.115,
      4.116,
      4.117,
      4.118,
      4.119,
      4.12,
      4.121,
      4.122,
      4.123,
      4.124,
      4.125,
      4.126,
      4.127,
      4.128,
      4.1290000000000004E+000,
      4.13,
      4.131,
      4.132,
      4.133,
      4.134,
      4.135,
      4.136,
      4.1370000000000005E+000,
      4.138,
      4.139,
      4.14,
      4.141,
      4.142,
      4.143,
      4.144,
      4.1450000000000005E+000,
      4.146,
      4.147,
      4.148,
      4.149,
      4.15,
      4.151,
      4.152,
      4.1530000000000005E+000,
      4.154,
      4.155,
      4.156,
      4.157,
      4.158,
      4.159,
      4.16,
      4.1610000000000005E+000,
      4.162,
      4.163,
      4.164,
      4.165,
      4.166,
      4.167,
      4.168,
      4.1690000000000005E+000,
      4.17,
      4.171,
      4.172,
      4.173,
      4.174,
      4.175,
      4.176,
      4.1770000000000005E+000,
      4.178,
      4.179,
      4.18,
      4.181,
      4.182,
      4.183,
      4.184,
      4.1850000000000005E+000,
      4.186,
      4.187,
      4.188,
      4.189,
      4.19,
      4.191,
      4.192,
      4.1930000000000005E+000,
      4.194,
      4.195,
      4.196,
      4.197,
      4.198,
      4.199,
      4.2,
      4.2010000000000005E+000,
      4.202,
      4.203,
      4.204,
      4.205,
      4.206,
      4.207,
      4.208,
      4.2090000000000005E+000,
      4.21,
      4.211,
      4.212,
      4.213,
      4.214,
      4.215,
      4.216,
      4.2170000000000005E+000,
      4.218,
      4.219,
      4.22,
      4.221,
      4.222,
      4.223,
      4.224,
      4.225,
      4.226,
      4.227,
      4.228,
      4.229,
      4.23,
      4.231,
      4.232,
      4.233,
      4.234,
      4.235,
      4.236,
      4.237,
      4.238,
      4.239,
      4.24,
      4.241,
      4.242,
      4.243,
      4.244,
      4.245,
      4.246,
      4.247,
      4.248,
      4.249,
      4.25,
      4.251,
      4.252,
      4.253,
      4.2540000000000004E+000,
      4.255,
      4.256,
      4.257,
      4.258,
      4.259,
      4.26,
      4.261,
      4.2620000000000005E+000,
      4.263,
      4.264,
      4.265,
      4.266,
      4.267,
      4.268,
      4.269,
      4.2700000000000005E+000,
      4.271,
      4.272,
      4.273,
      4.274,
      4.275,
      4.276,
      4.277,
      4.2780000000000005E+000,
      4.279,
      4.28,
      4.281,
      4.282,
      4.283,
      4.284,
      4.285,
      4.2860000000000005E+000,
      4.287,
      4.288,
      4.289,
      4.29,
      4.291,
      4.292,
      4.293,
      4.2940000000000005E+000,
      4.295,
      4.296,
      4.297,
      4.298,
      4.299,
      4.3,
      4.301,
      4.3020000000000005E+000,
      4.303,
      4.304,
      4.305,
      4.306,
      4.307,
      4.308,
      4.309,
      4.3100000000000005E+000,
      4.311,
      4.312,
      4.313,
      4.314,
      4.315,
      4.316,
      4.317,
      4.3180000000000005E+000,
      4.319,
      4.32,
      4.321,
      4.322,
      4.323,
      4.324,
      4.325,
      4.3260000000000005E+000,
      4.327,
      4.328,
      4.329,
      4.33,
      4.331,
      4.332,
      4.333,
      4.3340000000000005E+000,
      4.335,
      4.336,
      4.337,
      4.338,
      4.339,
      4.34,
      4.341,
      4.3420000000000005E+000,
      4.343,
      4.344,
      4.345,
      4.346,
      4.347,
      4.348,
      4.349,
      4.3500000000000005E+000,
      4.351,
      4.352,
      4.353,
      4.354,
      4.355,
      4.356,
      4.357,
      4.358,
      4.359,
      4.36,
      4.361,
      4.362,
      4.363,
      4.364,
      4.365,
      4.366,
      4.367,
      4.368,
      4.369,
      4.37,
      4.371,
      4.372,
      4.373,
      4.374,
      4.375,
      4.376,
      4.377,
      4.378,
      4.3790000000000004E+000,
      4.38,
      4.381,
      4.382,
      4.383,
      4.384,
      4.385,
      4.386,
      4.3870000000000005E+000,
      4.388,
      4.389,
      4.39,
      4.391,
      4.392,
      4.393,
      4.394,
      4.3950000000000005E+000,
      4.396,
      4.397,
      4.398,
      4.399,
      4.4,
      4.401,
      4.402,
      4.4030000000000005E+000,
      4.404,
      4.405,
      4.406,
      4.407,
      4.408,
      4.409,
      4.41,
      4.4110000000000005E+000,
      4.412,
      4.413,
      4.414,
      4.415,
      4.416,
      4.417,
      4.418,
      4.4190000000000005E+000,
      4.42,
      4.421,
      4.422,
      4.423,
      4.424,
      4.425,
      4.426,
      4.4270000000000005E+000,
      4.428,
      4.429,
      4.43,
      4.431,
      4.432,
      4.433,
      4.434,
      4.4350000000000005E+000,
      4.436,
      4.437,
      4.438,
      4.439,
      4.44,
      4.441,
      4.442,
      4.4430000000000005E+000,
      4.444,
      4.445,
      4.446,
      4.447,
      4.448,
      4.449,
      4.45,
      4.4510000000000005E+000,
      4.452,
      4.453,
      4.454,
      4.455,
      4.456,
      4.457,
      4.458,
      4.4590000000000005E+000,
      4.46,
      4.461,
      4.462,
      4.463,
      4.464,
      4.465,
      4.466,
      4.4670000000000005E+000,
      4.468,
      4.469,
      4.47,
      4.471,
      4.472,
      4.473,
      4.474,
      4.4750000000000005E+000,
      4.476,
      4.477,
      4.478,
      4.479,
      4.48,
      4.481,
      4.482,
      4.483,
      4.484,
      4.485,
      4.486,
      4.487,
      4.488,
      4.489,
      4.49,
      4.491,
      4.492,
      4.493,
      4.494,
      4.495,
      4.496,
      4.497,
      4.498,
      4.499,
      4.5,
      4.501,
      4.502,
      4.503,
      4.5040000000000004E+000,
      4.505,
      4.506,
      4.507,
      4.508,
      4.509,
      4.51,
      4.511,
      4.5120000000000005E+000,
      4.513,
      4.514,
      4.515,
      4.516,
      4.517,
      4.518,
      4.519,
      4.5200000000000005E+000,
      4.521,
      4.522,
      4.523,
      4.524,
      4.525,
      4.526,
      4.527,
      4.5280000000000005E+000,
      4.529,
      4.53,
      4.531,
      4.532,
      4.533,
      4.534,
      4.535,
      4.5360000000000005E+000,
      4.537,
      4.538,
      4.539,
      4.54,
      4.541,
      4.542,
      4.543,
      4.5440000000000005E+000,
      4.545,
      4.546,
      4.547,
      4.548,
      4.549,
      4.55,
      4.551,
      4.5520000000000005E+000,
      4.553,
      4.554,
      4.555,
      4.556,
      4.557,
      4.558,
      4.559,
      4.5600000000000005E+000,
      4.561,
      4.562,
      4.563,
      4.564,
      4.565,
      4.566,
      4.567,
      4.5680000000000005E+000,
      4.569,
      4.57,
      4.571,
      4.572,
      4.573,
      4.574,
      4.575,
      4.5760000000000005E+000,
      4.577,
      4.578,
      4.579,
      4.58,
      4.581,
      4.582,
      4.583,
      4.5840000000000005E+000,
      4.585,
      4.586,
      4.587,
      4.588,
      4.589,
      4.59,
      4.591,
      4.5920000000000005E+000,
      4.593,
      4.594,
      4.595,
      4.596,
      4.597,
      4.598,
      4.599,
      4.6000000000000005E+000,
      4.601,
      4.602,
      4.603,
      4.604,
      4.605,
      4.606,
      4.607,
      4.6080000000000005E+000,
      4.609,
      4.61,
      4.611,
      4.612,
      4.613,
      4.614,
      4.615,
      4.616,
      4.617,
      4.618,
      4.619,
      4.62,
      4.621,
      4.622,
      4.623,
      4.624,
      4.625,
      4.626,
      4.627,
      4.628,
      4.6290000000000004E+000,
      4.63,
      4.631,
      4.632,
      4.633,
      4.634,
      4.635,
      4.636,
      4.6370000000000005E+000,
      4.638,
      4.639,
      4.64,
      4.641,
      4.642,
      4.643,
      4.644,
      4.6450000000000005E+000,
      4.646,
      4.647,
      4.648,
      4.649,
      4.65,
      4.651,
      4.652,
      4.6530000000000005E+000,
      4.654,
      4.655,
      4.656,
      4.657,
      4.658,
      4.659,
      4.66,
      4.6610000000000005E+000,
      4.662,
      4.663,
      4.664,
      4.665,
      4.666,
      4.667,
      4.668,
      4.6690000000000005E+000,
      4.67,
      4.671,
      4.672,
      4.673,
      4.674,
      4.675,
      4.676,
      4.6770000000000005E+000,
      4.678,
      4.679,
      4.68,
      4.681,
      4.682,
      4.683,
      4.684,
      4.6850000000000005E+000,
      4.686,
      4.687,
      4.688,
      4.689,
      4.69,
      4.691,
      4.692,
      4.6930000000000005E+000,
      4.694,
      4.695,
      4.696,
      4.697,
      4.698,
      4.699,
      4.7,
      4.7010000000000005E+000,
      4.702,
      4.703,
      4.704,
      4.705,
      4.706,
      4.707,
      4.708,
      4.7090000000000005E+000,
      4.71,
      4.711,
      4.712,
      4.713,
      4.714,
      4.715,
      4.716,
      4.7170000000000005E+000,
      4.718,
      4.719,
      4.72,
      4.721,
      4.722,
      4.723,
      4.724,
      4.7250000000000005E+000,
      4.726,
      4.727,
      4.728,
      4.729,
      4.73,
      4.731,
      4.732,
      4.7330000000000005E+000,
      4.734,
      4.735,
      4.736,
      4.737,
      4.738,
      4.739,
      4.74,
      4.741,
      4.742,
      4.743,
      4.744,
      4.745,
      4.746,
      4.747,
      4.748,
      4.749,
      4.75,
      4.751,
      4.752,
      4.753,
      4.7540000000000004E+000,
      4.755,
      4.756,
      4.757,
      4.758,
      4.759,
      4.76,
      4.761,
      4.7620000000000005E+000,
      4.763,
      4.764,
      4.765,
      4.766,
      4.767,
      4.768,
      4.769,
      4.7700000000000005E+000,
      4.771,
      4.772,
      4.773,
      4.774,
      4.775,
      4.776,
      4.777,
      4.7780000000000005E+000,
      4.779,
      4.78,
      4.781,
      4.782,
      4.783,
      4.784,
      4.785,
      4.7860000000000005E+000,
      4.787,
      4.788,
      4.789,
      4.79,
      4.791,
      4.792,
      4.793,
      4.7940000000000005E+000,
      4.795,
      4.796,
      4.797,
      4.798,
      4.799,
      4.8,
      4.801,
      4.8020000000000005E+000,
      4.803,
      4.804,
      4.805,
      4.806,
      4.807,
      4.808,
      4.809,
      4.8100000000000005E+000,
      4.811,
      4.812,
      4.813,
      4.814,
      4.815,
      4.816,
      4.817,
      4.8180000000000005E+000,
      4.819,
      4.82,
      4.821,
      4.822,
      4.823,
      4.824,
      4.825,
      4.8260000000000005E+000,
      4.827,
      4.828,
      4.829,
      4.83,
      4.831,
      4.832,
      4.833,
      4.8340000000000005E+000,
      4.835,
      4.836,
      4.837,
      4.838,
      4.839,
      4.84,
      4.841,
      4.8420000000000005E+000,
      4.843,
      4.844,
      4.845,
      4.846,
      4.847,
      4.848,
      4.849,
      4.8500000000000005E+000,
      4.851,
      4.852,
      4.853,
      4.854,
      4.855,
      4.856,
      4.857,
      4.8580000000000005E+000,
      4.859,
      4.86,
      4.861,
      4.862,
      4.863,
      4.864,
      4.865,
      4.866,
      4.867,
      4.868,
      4.869,
      4.87,
      4.871,
      4.872,
      4.873,
      4.874,
      4.875,
      4.876,
      4.877,
      4.878,
      4.8790000000000004E+000,
      4.88,
      4.881,
      4.882,
      4.883,
      4.884,
      4.885,
      4.886,
      4.8870000000000005E+000,
      4.888,
      4.889,
      4.89,
      4.891,
      4.892,
      4.893,
      4.894,
      4.8950000000000005E+000,
      4.896,
      4.897,
      4.898,
      4.899,
      4.9,
      4.901,
      4.902,
      4.9030000000000005E+000,
      4.904,
      4.905,
      4.906,
      4.907,
      4.908,
      4.909,
      4.91,
      4.9110000000000005E+000,
      4.912,
      4.913,
      4.914,
      4.915,
      4.916,
      4.917,
      4.918,
      4.9190000000000005E+000,
      4.92,
      4.921,
      4.922,
      4.923,
      4.924,
      4.925,
      4.926,
      4.9270000000000005E+000,
      4.928,
      4.929,
      4.93,
      4.931,
      4.932,
      4.933,
      4.934,
      4.9350000000000005E+000,
      4.936,
      4.937,
      4.938,
      4.939,
      4.94,
      4.941,
      4.942,
      4.9430000000000005E+000,
      4.944,
      4.945,
      4.946,
      4.947,
      4.948,
      4.949,
      4.95,
      4.9510000000000005E+000,
      4.952,
      4.953,
      4.954,
      4.955,
      4.956,
      4.957,
      4.958,
      4.9590000000000005E+000,
      4.96,
      4.961,
      4.962,
      4.963,
      4.964,
      4.965,
      4.966,
      4.9670000000000005E+000,
      4.968,
      4.969,
      4.97,
      4.971,
      4.972,
      4.973,
      4.974,
      4.9750000000000005E+000,
      4.976,
      4.977,
      4.978,
      4.979,
      4.98,
      4.981,
      4.982,
      4.9830000000000005E+000,
      4.984,
      4.985,
      4.986,
      4.987,
      4.988,
      4.989,
      4.99,
      4.9910000000000005E+000,
      4.992,
      4.993,
      4.994,
      4.995,
      4.996,
      4.997,
      4.998,
      4.999,
      5.0,
      5.001,
      5.002,
      5.003,
      5.0040000000000004E+000,
      5.005,
      5.006,
      5.007,
      5.008,
      5.009,
      5.01,
      5.011,
      5.0120000000000005E+000,
      5.013,
      5.014,
      5.015,
      5.016,
      5.017,
      5.018,
      5.019,
      5.0200000000000005E+000,
      5.021,
      5.022,
      5.023,
      5.024,
      5.025,
      5.026,
      5.027,
      5.0280000000000005E+000,
      5.029,
      5.03,
      5.031,
      5.032,
      5.033,
      5.034,
      5.035,
      5.0360000000000005E+000,
      5.037,
      5.038,
      5.039,
      5.04,
      5.041,
      5.042,
      5.043,
      5.0440000000000005E+000,
      5.045,
      5.046,
      5.047,
      5.048,
      5.049,
      5.05,
      5.051,
      5.0520000000000005E+000,
      5.053,
      5.054,
      5.055,
      5.056,
      5.057,
      5.058,
      5.059,
      5.0600000000000005E+000,
      5.061,
      5.062,
      5.063,
      5.064,
      5.065,
      5.066,
      5.067,
      5.0680000000000005E+000,
      5.069,
      5.07,
      5.071,
      5.072,
      5.073,
      5.074,
      5.075,
      5.0760000000000005E+000,
      5.077,
      5.078,
      5.079,
      5.08,
      5.081,
      5.082,
      5.083,
      5.0840000000000005E+000,
      5.085,
      5.086,
      5.087,
      5.088,
      5.089,
      5.09,
      5.091,
      5.0920000000000005E+000,
      5.093,
      5.094,
      5.095,
      5.096,
      5.097,
      5.098,
      5.099,
      5.1000000000000005E+000,
      5.101,
      5.102,
      5.103,
      5.104,
      5.105,
      5.106,
      5.107,
      5.1080000000000005E+000,
      5.109,
      5.11,
      5.111,
      5.112,
      5.113,
      5.114,
      5.115,
      5.1160000000000005E+000,
      5.117,
      5.118,
      5.119,
      5.12,
      5.121,
      5.122,
      5.123,
      5.124,
      5.125,
      5.126,
      5.127,
      5.128,
      5.1290000000000004E+000,
      5.13,
      5.131,
      5.132,
      5.133,
      5.134,
      5.135,
      5.136,
      5.1370000000000005E+000,
      5.138,
      5.139,
      5.14,
      5.141,
      5.142,
      5.143,
      5.144,
      5.1450000000000005E+000,
      5.146,
      5.147,
      5.148,
      5.149,
      5.15,
      5.151,
      5.152,
      5.1530000000000005E+000,
      5.154,
      5.155,
      5.156,
      5.157,
      5.158,
      5.159,
      5.16,
      5.1610000000000005E+000,
      5.162,
      5.163,
      5.164,
      5.165,
      5.166,
      5.167,
      5.168,
      5.1690000000000005E+000,
      5.17,
      5.171,
      5.172,
      5.173,
      5.174,
      5.175,
      5.176,
      5.1770000000000005E+000,
      5.178,
      5.179,
      5.18,
      5.181,
      5.182,
      5.183,
      5.184,
      5.1850000000000005E+000,
      5.186,
      5.187,
      5.188,
      5.189,
      5.19,
      5.191,
      5.192,
      5.1930000000000005E+000,
      5.194,
      5.195,
      5.196,
      5.197,
      5.198,
      5.199,
      5.2,
      5.2010000000000005E+000,
      5.202,
      5.203,
      5.204,
      5.205,
      5.206,
      5.207,
      5.208,
      5.2090000000000005E+000,
      5.21,
      5.211,
      5.212,
      5.213,
      5.214,
      5.215,
      5.216,
      5.2170000000000005E+000,
      5.218,
      5.219,
      5.22,
      5.221,
      5.222,
      5.223,
      5.224,
      5.2250000000000005E+000,
      5.226,
      5.227,
      5.228,
      5.229,
      5.23,
      5.231,
      5.232,
      5.2330000000000005E+000,
      5.234,
      5.235,
      5.236,
      5.237,
      5.238,
      5.239,
      5.24,
      5.2410000000000005E+000,
      5.242,
      5.243,
      5.244,
      5.245,
      5.246,
      5.247,
      5.248,
      5.249,
      5.25,
      5.251,
      5.252,
      5.253,
      5.2540000000000004E+000,
      5.255,
      5.256,
      5.257,
      5.258,
      5.259,
      5.26,
      5.261,
      5.2620000000000005E+000,
      5.263,
      5.264,
      5.265,
      5.266,
      5.267,
      5.268,
      5.269,
      5.2700000000000005E+000,
      5.271,
      5.272,
      5.273,
      5.274,
      5.275,
      5.276,
      5.277,
      5.2780000000000005E+000,
      5.279,
      5.28,
      5.281,
      5.282,
      5.283,
      5.284,
      5.285,
      5.2860000000000005E+000,
      5.287,
      5.288,
      5.289,
      5.29,
      5.291,
      5.292,
      5.293,
      5.2940000000000005E+000,
      5.295,
      5.296,
      5.297,
      5.298,
      5.299,
      5.3,
      5.301,
      5.3020000000000005E+000,
      5.303,
      5.304,
      5.305,
      5.306,
      5.307,
      5.308,
      5.309,
      5.3100000000000005E+000,
      5.311,
      5.312,
      5.313,
      5.314,
      5.315,
      5.316,
      5.317,
      5.3180000000000005E+000,
      5.319,
      5.32,
      5.321,
      5.322,
      5.323,
      5.324,
      5.325,
      5.3260000000000005E+000,
      5.327,
      5.328,
      5.329,
      5.33,
      5.331,
      5.332,
      5.333,
      5.3340000000000005E+000,
      5.335,
      5.336,
      5.337,
      5.338,
      5.339,
      5.34,
      5.341,
      5.3420000000000005E+000,
      5.343,
      5.344,
      5.345,
      5.346,
      5.347,
      5.348,
      5.349,
      5.3500000000000005E+000,
      5.351,
      5.352,
      5.353,
      5.354,
      5.355,
      5.356,
      5.357,
      5.3580000000000005E+000,
      5.359,
      5.36,
      5.361,
      5.362,
      5.363,
      5.364,
      5.365,
      5.3660000000000005E+000,
      5.367,
      5.368,
      5.369,
      5.37,
      5.371,
      5.372,
      5.373,
      5.3740000000000006E+000,
      5.375,
      5.376,
      5.377,
      5.378,
      5.3790000000000004E+000,
      5.38,
      5.381,
      5.382,
      5.383,
      5.384,
      5.385,
      5.386,
      5.3870000000000005E+000,
      5.388,
      5.389,
      5.39,
      5.391,
      5.392,
      5.393,
      5.394,
      5.3950000000000005E+000,
      5.396,
      5.397,
      5.398,
      5.399,
      5.4,
      5.401,
      5.402,
      5.4030000000000005E+000,
      5.404,
      5.405,
      5.406,
      5.407,
      5.408,
      5.409,
      5.41,
      5.4110000000000005E+000,
      5.412,
      5.413,
      5.414,
      5.415,
      5.416,
      5.417,
      5.418,
      5.4190000000000005E+000,
      5.42,
      5.421,
      5.422,
      5.423,
      5.424,
      5.425,
      5.426,
      5.4270000000000005E+000,
      5.428,
      5.429,
      5.43,
      5.431,
      5.432,
      5.433,
      5.434,
      5.4350000000000005E+000,
      5.436,
      5.437,
      5.438,
      5.439,
      5.44,
      5.441,
      5.442,
      5.4430000000000005E+000,
      5.444,
      5.445,
      5.446,
      5.447,
      5.448,
      5.449,
      5.45,
      5.4510000000000005E+000,
      5.452,
      5.453,
      5.454,
      5.455,
      5.456,
      5.457,
      5.458,
      5.4590000000000005E+000,
      5.46,
      5.461,
      5.462,
      5.463,
      5.464,
      5.465,
      5.466,
      5.4670000000000005E+000,
      5.468,
      5.469,
      5.47,
      5.471,
      5.472,
      5.473,
      5.474,
      5.4750000000000005E+000,
      5.476,
      5.477,
      5.478,
      5.479,
      5.48,
      5.481,
      5.482,
      5.4830000000000005E+000,
      5.484,
      5.485,
      5.486,
      5.487,
      5.488,
      5.489,
      5.49,
      5.4910000000000005E+000,
      5.492,
      5.493,
      5.494,
      5.495,
      5.496,
      5.497,
      5.498,
      5.4990000000000006E+000,
      5.5,
      5.501,
      5.502,
      5.503,
      5.5040000000000004E+000,
      5.505,
      5.506,
      5.507,
      5.508,
      5.509,
      5.51,
      5.511,
      5.5120000000000005E+000,
      5.513,
      5.514,
      5.515,
      5.516,
      5.517,
      5.518,
      5.519,
      5.5200000000000005E+000,
      5.521,
      5.522,
      5.523,
      5.524,
      5.525,
      5.526,
      5.527,
      5.5280000000000005E+000,
      5.529,
      5.53,
      5.531,
      5.532,
      5.533,
      5.534,
      5.535,
      5.5360000000000005E+000,
      5.537,
      5.538,
      5.539,
      5.54,
      5.541,
      5.542,
      5.543,
      5.5440000000000005E+000,
      5.545,
      5.546,
      5.547,
      5.548,
      5.549,
      5.55,
      5.551,
      5.5520000000000005E+000,
      5.553,
      5.554,
      5.555,
      5.556,
      5.557,
      5.558,
      5.559,
      5.5600000000000005E+000,
      5.561,
      5.562,
      5.563,
      5.564,
      5.565,
      5.566,
      5.567,
      5.5680000000000005E+000,
      5.569,
      5.57,
      5.571,
      5.572,
      5.573,
      5.574,
      5.575,
      5.5760000000000005E+000,
      5.577,
      5.578,
      5.579,
      5.58,
      5.581,
      5.582,
      5.583,
      5.5840000000000005E+000,
      5.585,
      5.586,
      5.587,
      5.588,
      5.589,
      5.59,
      5.591,
      5.5920000000000005E+000,
      5.593,
      5.594,
      5.595,
      5.596,
      5.597,
      5.598,
      5.599,
      5.6000000000000005E+000,
      5.601,
      5.602,
      5.603,
      5.604,
      5.605,
      5.606,
      5.607,
      5.6080000000000005E+000,
      5.609,
      5.61,
      5.611,
      5.612,
      5.613,
      5.614,
      5.615,
      5.6160000000000005E+000,
      5.617,
      5.618,
      5.619,
      5.62,
      5.621,
      5.622,
      5.623,
      5.6240000000000006E+000,
      5.625,
      5.626,
      5.627,
      5.628,
      5.6290000000000004E+000,
      5.63,
      5.631,
      5.632,
      5.633,
      5.634,
      5.635,
      5.636,
      5.6370000000000005E+000,
      5.638,
      5.639,
      5.64,
      5.641,
      5.642,
      5.643,
      5.644,
      5.6450000000000005E+000,
      5.646,
      5.647,
      5.648,
      5.649,
      5.65,
      5.651,
      5.652,
      5.6530000000000005E+000,
      5.654,
      5.655,
      5.656,
      5.657,
      5.658,
      5.659,
      5.66,
      5.6610000000000005E+000,
      5.662,
      5.663,
      5.664,
      5.665,
      5.666,
      5.667,
      5.668,
      5.6690000000000005E+000,
      5.67,
      5.671,
      5.672,
      5.673,
      5.674,
      5.675,
      5.676,
      5.6770000000000005E+000,
      5.678,
      5.679,
      5.68,
      5.681,
      5.682,
      5.683,
      5.684,
      5.6850000000000005E+000,
      5.686,
      5.687,
      5.688,
      5.689,
      5.69,
      5.691,
      5.692,
      5.6930000000000005E+000,
      5.694,
      5.695,
      5.696,
      5.697,
      5.698,
      5.699,
      5.7,
      5.7010000000000005E+000,
      5.702,
      5.703,
      5.704,
      5.705,
      5.706,
      5.707,
      5.708,
      5.7090000000000005E+000,
      5.71,
      5.711,
      5.712,
      5.713,
      5.714,
      5.715,
      5.716,
      5.7170000000000005E+000,
      5.718,
      5.719,
      5.72,
      5.721,
      5.722,
      5.723,
      5.724,
      5.7250000000000005E+000,
      5.726,
      5.727,
      5.728,
      5.729,
      5.73,
      5.731,
      5.732,
      5.7330000000000005E+000,
      5.734,
      5.735,
      5.736,
      5.737,
      5.738,
      5.739,
      5.74,
      5.7410000000000005E+000,
      5.742,
      5.743,
      5.744,
      5.745,
      5.746,
      5.747,
      5.748,
      5.7490000000000006E+000,
      5.75,
      5.751,
      5.752,
      5.753,
      5.7540000000000004E+000,
      5.755,
      5.756,
      5.7570000000000006E+000,
      5.758,
      5.759,
      5.76,
      5.761,
      5.7620000000000005E+000,
      5.763,
      5.764,
      5.765,
      5.766,
      5.767,
      5.768,
      5.769,
      5.7700000000000005E+000,
      5.771,
      5.772,
      5.773,
      5.774,
      5.775,
      5.776,
      5.777,
      5.7780000000000005E+000,
      5.779,
      5.78,
      5.781,
      5.782,
      5.783,
      5.784,
      5.785,
      5.7860000000000005E+000,
      5.787,
      5.788,
      5.789,
      5.79,
      5.791,
      5.792,
      5.793,
      5.7940000000000005E+000,
      5.795,
      5.796,
      5.797,
      5.798,
      5.799,
      5.8,
      5.801,
      5.8020000000000005E+000,
      5.803,
      5.804,
      5.805,
      5.806,
      5.807,
      5.808,
      5.809,
      5.8100000000000005E+000,
      5.811,
      5.812,
      5.813,
      5.814,
      5.815,
      5.816,
      5.817,
      5.8180000000000005E+000,
      5.819,
      5.82,
      5.821,
      5.822,
      5.823,
      5.824,
      5.825,
      5.8260000000000005E+000,
      5.827,
      5.828,
      5.829,
      5.83,
      5.831,
      5.832,
      5.833,
      5.8340000000000005E+000,
      5.835,
      5.836,
      5.837,
      5.838,
      5.839,
      5.84,
      5.841,
      5.8420000000000005E+000,
      5.843,
      5.844,
      5.845,
      5.846,
      5.847,
      5.848,
      5.849,
      5.8500000000000005E+000,
      5.851,
      5.852,
      5.853,
      5.854,
      5.855,
      5.856,
      5.857,
      5.8580000000000005E+000,
      5.859,
      5.86,
      5.861,
      5.862,
      5.863,
      5.864,
      5.865,
      5.8660000000000005E+000,
      5.867,
      5.868,
      5.869,
      5.87,
      5.871,
      5.872,
      5.873,
      5.8740000000000006E+000,
      5.875,
      5.876,
      5.877,
      5.878,
      5.8790000000000004E+000,
      5.88,
      5.881,
      5.8820000000000006E+000,
      5.883,
      5.884,
      5.885,
      5.886,
      5.8870000000000005E+000,
      5.888,
      5.889,
      5.89,
      5.891,
      5.892,
      5.893,
      5.894,
      5.8950000000000005E+000,
      5.896,
      5.897,
      5.898,
      5.899,
      5.9,
      5.901,
      5.902,
      5.9030000000000005E+000,
      5.904,
      5.905,
      5.906,
      5.907,
      5.908,
      5.909,
      5.91,
      5.9110000000000005E+000,
      5.912,
      5.913,
      5.914,
      5.915,
      5.916,
      5.917,
      5.918,
      5.9190000000000005E+000,
      5.92,
      5.921,
      5.922,
      5.923,
      5.924,
      5.925,
      5.926,
      5.9270000000000005E+000,
      5.928,
      5.929,
      5.93,
      5.931,
      5.932,
      5.933,
      5.934,
      5.9350000000000005E+000,
      5.936,
      5.937,
      5.938,
      5.939,
      5.94,
      5.941,
      5.942,
      5.9430000000000005E+000,
      5.944,
      5.945,
      5.946,
      5.947,
      5.948,
      5.949,
      5.95,
      5.9510000000000005E+000,
      5.952,
      5.953,
      5.954,
      5.955,
      5.956,
      5.957,
      5.958,
      5.9590000000000005E+000,
      5.96,
      5.961,
      5.962,
      5.963,
      5.964,
      5.965,
      5.966,
      5.9670000000000005E+000,
      5.968,
      5.969,
      5.97,
      5.971,
      5.972,
      5.973,
      5.974,
      5.9750000000000005E+000,
      5.976,
      5.977,
      5.978,
      5.979,
      5.98,
      5.981,
      5.982,
      5.9830000000000005E+000,
      5.984,
      5.985,
      5.986,
      5.987,
      5.988,
      5.989,
      5.99,
      5.9910000000000005E+000,
      5.992,
      5.993,
      5.994,
      5.995,
      5.996,
      5.997,
      5.998,
      5.9990000000000006E+000,
      6.0,
      6.001,
      6.002,
      6.003,
      6.0040000000000004E+000,
      6.005,
      6.006,
      6.0070000000000006E+000,
      6.008,
      6.009,
      6.01,
      6.011,
      6.0120000000000005E+000,
      6.013,
      6.014,
      6.0150000000000006E+000,
      6.016,
      6.017,
      6.018,
      6.019,
      6.0200000000000005E+000,
      6.021,
      6.022,
      6.023,
      6.024,
      6.025,
      6.026,
      6.027,
      6.0280000000000005E+000,
      6.029,
      6.03,
      6.031,
      6.032,
      6.033,
      6.034,
      6.035,
      6.0360000000000005E+000,
      6.037,
      6.038,
      6.039,
      6.04,
      6.041,
      6.042,
      6.043,
      6.0440000000000005E+000,
      6.045,
      6.046,
      6.047,
      6.048,
      6.049,
      6.05,
      6.051,
      6.0520000000000005E+000,
      6.053,
      6.054,
      6.055,
      6.056,
      6.057,
      6.058,
      6.059,
      6.0600000000000005E+000,
      6.061,
      6.062,
      6.063,
      6.064,
      6.065,
      6.066,
      6.067,
      6.0680000000000005E+000,
      6.069,
      6.07,
      6.071,
      6.072,
      6.073,
      6.074,
      6.075,
      6.0760000000000005E+000,
      6.077,
      6.078,
      6.079,
      6.08,
      6.081,
      6.082,
      6.083,
      6.0840000000000005E+000,
      6.085,
      6.086,
      6.087,
      6.088,
      6.089,
      6.09,
      6.091,
      6.0920000000000005E+000,
      6.093,
      6.094,
      6.095,
      6.096,
      6.097,
      6.098,
      6.099,
      6.1000000000000005E+000,
      6.101,
      6.102,
      6.103,
      6.104,
      6.105,
      6.106,
      6.107,
      6.1080000000000005E+000,
      6.109,
      6.11,
      6.111,
      6.112,
      6.113,
      6.114,
      6.115,
      6.1160000000000005E+000,
      6.117,
      6.118,
      6.119,
      6.12,
      6.121,
      6.122,
      6.123,
      6.1240000000000006E+000,
      6.125,
      6.126,
      6.127,
      6.128,
      6.1290000000000004E+000,
      6.13,
      6.131,
      6.1320000000000006E+000,
      6.133,
      6.134,
      6.135,
      6.136,
      6.1370000000000005E+000,
      6.138,
      6.139,
      6.1400000000000006E+000,
      6.141,
      6.142,
      6.143,
      6.144,
      6.1450000000000005E+000,
      6.146,
      6.147,
      6.148,
      6.149,
      6.15,
      6.151,
      6.152,
      6.1530000000000005E+000,
      6.154,
      6.155,
      6.156,
      6.157,
      6.158,
      6.159,
      6.16,
      6.1610000000000005E+000,
      6.162,
      6.163,
      6.164,
      6.165,
      6.166,
      6.167,
      6.168,
      6.1690000000000005E+000,
      6.17,
      6.171,
      6.172,
      6.173,
      6.174,
      6.175,
      6.176,
      6.1770000000000005E+000,
      6.178,
      6.179,
      6.18,
      6.181,
      6.182,
      6.183,
      6.184,
      6.1850000000000005E+000,
      6.186,
      6.187,
      6.188,
      6.189,
      6.19,
      6.191,
      6.192,
      6.1930000000000005E+000,
      6.194,
      6.195,
      6.196,
      6.197,
      6.198,
      6.199,
      6.2,
      6.2010000000000005E+000,
      6.202,
      6.203,
      6.204,
      6.205,
      6.206,
      6.207,
      6.208,
      6.2090000000000005E+000,
      6.21,
      6.211,
      6.212,
      6.213,
      6.214,
      6.215,
      6.216,
      6.2170000000000005E+000,
      6.218,
      6.219,
      6.22,
      6.221,
      6.222,
      6.223,
      6.224,
      6.2250000000000005E+000,
      6.226,
      6.227,
      6.228,
      6.229,
      6.23,
      6.231,
      6.232,
      6.2330000000000005E+000,
      6.234,
      6.235,
      6.236,
      6.237,
      6.238,
      6.239,
      6.24,
      6.2410000000000005E+000,
      6.242,
      6.243,
      6.244,
      6.245,
      6.246,
      6.247,
      6.248,
      6.2490000000000006E+000,
      6.25,
      6.251,
      6.252,
      6.253,
      6.2540000000000004E+000,
      6.255,
      6.256,
      6.2570000000000006E+000,
      6.258,
      6.259,
      6.26,
      6.261,
      6.2620000000000005E+000,
      6.263,
      6.264,
      6.2650000000000006E+000,
      6.266,
      6.267,
      6.268,
      6.269,
      6.2700000000000005E+000,
      6.271,
      6.272,
      6.273,
      6.274,
      6.275,
      6.276,
      6.277,
      6.2780000000000005E+000,
      6.279,
      6.28,
      6.281,
      6.282,
      6.283,
      6.284,
      6.285,
      6.2860000000000005E+000,
      6.287,
      6.288,
      6.289,
      6.29,
      6.291,
      6.292,
      6.293,
      6.2940000000000005E+000,
      6.295,
      6.296,
      6.297,
      6.298,
      6.299,
      6.3,
      6.301,
      6.3020000000000005E+000,
      6.303,
      6.304,
      6.305,
      6.306,
      6.307,
      6.308,
      6.309,
      6.3100000000000005E+000,
      6.311,
      6.312,
      6.313,
      6.314,
      6.315,
      6.316,
      6.317,
      6.3180000000000005E+000,
      6.319,
      6.32,
      6.321,
      6.322,
      6.323,
      6.324,
      6.325,
      6.3260000000000005E+000,
      6.327,
      6.328,
      6.329,
      6.33,
      6.331,
      6.332,
      6.333,
      6.3340000000000005E+000,
      6.335,
      6.336,
      6.337,
      6.338,
      6.339,
      6.34,
      6.341,
      6.3420000000000005E+000,
      6.343,
      6.344,
      6.345,
      6.346,
      6.347,
      6.348,
      6.349,
      6.3500000000000005E+000,
      6.351,
      6.352,
      6.353,
      6.354,
      6.355,
      6.356,
      6.357,
      6.3580000000000005E+000,
      6.359,
      6.36,
      6.361,
      6.362,
      6.363,
      6.364,
      6.365,
      6.3660000000000005E+000,
      6.367,
      6.368,
      6.369,
      6.37,
      6.371,
      6.372,
      6.373,
      6.3740000000000006E+000,
      6.375,
      6.376,
      6.377,
      6.378,
      6.3790000000000004E+000,
      6.38,
      6.381,
      6.3820000000000006E+000,
      6.383,
      6.384,
      6.385,
      6.386,
      6.3870000000000005E+000,
      6.388,
      6.389,
      6.3900000000000006E+000,
      6.391,
      6.392,
      6.393,
      6.394,
      6.3950000000000005E+000,
      6.396,
      6.397,
      6.3980000000000006E+000,
      6.399,
      6.4,
      6.401,
      6.402,
      6.4030000000000005E+000,
      6.404,
      6.405,
      6.406,
      6.407,
      6.408,
      6.409,
      6.41,
      6.4110000000000005E+000,
      6.412,
      6.413,
      6.414,
      6.415,
      6.416,
      6.417,
      6.418,
      6.4190000000000005E+000,
      6.42,
      6.421,
      6.422,
      6.423,
      6.424,
      6.425,
      6.426,
      6.4270000000000005E+000,
      6.428,
      6.429,
      6.43,
      6.431,
      6.432,
      6.433,
      6.434,
      6.4350000000000005E+000,
      6.436,
      6.437,
      6.438,
      6.439,
      6.44,
      6.441,
      6.442,
      6.4430000000000005E+000,
      6.444,
      6.445,
      6.446,
      6.447,
      6.448,
      6.449,
      6.45,
      6.4510000000000005E+000,
      6.452,
      6.453,
      6.454,
      6.455,
      6.456,
      6.457,
      6.458,
      6.4590000000000005E+000,
      6.46,
      6.461,
      6.462,
      6.463,
      6.464,
      6.465,
      6.466,
      6.4670000000000005E+000,
      6.468,
      6.469,
      6.47,
      6.471,
      6.472,
      6.473,
      6.474,
      6.4750000000000005E+000,
      6.476,
      6.477,
      6.478,
      6.479,
      6.48,
      6.481,
      6.482,
      6.4830000000000005E+000,
      6.484,
      6.485,
      6.486,
      6.487,
      6.488,
      6.489,
      6.49,
      6.4910000000000005E+000,
      6.492,
      6.493,
      6.494,
      6.495,
      6.496,
      6.497,
      6.498,
      6.4990000000000006E+000,
      6.5,
      6.501,
      6.502,
      6.503,
      6.5040000000000004E+000,
      6.505,
      6.506,
      6.5070000000000006E+000,
      6.508,
      6.509,
      6.51,
      6.511,
      6.5120000000000005E+000,
      6.513,
      6.514,
      6.5150000000000006E+000,
      6.516,
      6.517,
      6.518,
      6.519,
      6.5200000000000005E+000,
      6.521,
      6.522,
      6.5230000000000006E+000,
      6.524,
      6.525,
      6.526,
      6.527,
      6.5280000000000005E+000,
      6.529,
      6.53,
      6.531,
      6.532,
      6.533,
      6.534,
      6.535,
      6.5360000000000005E+000,
      6.537,
      6.538,
      6.539,
      6.54,
      6.541,
      6.542,
      6.543,
      6.5440000000000005E+000,
      6.545,
      6.546,
      6.547,
      6.548,
      6.549,
      6.55,
      6.551,
      6.5520000000000005E+000,
      6.553,
      6.554,
      6.555,
      6.556,
      6.557,
      6.558,
      6.559,
      6.5600000000000005E+000,
      6.561,
      6.562,
      6.563,
      6.564,
      6.565,
      6.566,
      6.567,
      6.5680000000000005E+000,
      6.569,
      6.57,
      6.571,
      6.572,
      6.573,
      6.574,
      6.575,
      6.5760000000000005E+000,
      6.577,
      6.578,
      6.579,
      6.58,
      6.581,
      6.582,
      6.583,
      6.5840000000000005E+000,
      6.585,
      6.586,
      6.587,
      6.588,
      6.589,
      6.59,
      6.591,
      6.5920000000000005E+000,
      6.593,
      6.594,
      6.595,
      6.596,
      6.597,
      6.598,
      6.599,
      6.6000000000000005E+000,
      6.601,
      6.602,
      6.603,
      6.604,
      6.605,
      6.606,
      6.607,
      6.6080000000000005E+000,
      6.609,
      6.61,
      6.611,
      6.612,
      6.613,
      6.614,
      6.615,
      6.6160000000000005E+000,
      6.617,
      6.618,
      6.619,
      6.62,
      6.621,
      6.622,
      6.623,
      6.6240000000000006E+000,
      6.625,
      6.626,
      6.627,
      6.628,
      6.6290000000000004E+000,
      6.63,
      6.631,
      6.6320000000000006E+000,
      6.633,
      6.634,
      6.635,
      6.636,
      6.6370000000000005E+000,
      6.638,
      6.639,
      6.6400000000000006E+000,
      6.641,
      6.642,
      6.643,
      6.644,
      6.6450000000000005E+000,
      6.646,
      6.647,
      6.6480000000000006E+000,
      6.649,
      6.65,
      6.651,
      6.652,
      6.6530000000000005E+000,
      6.654,
      6.655,
      6.6560000000000006E+000,
      6.657,
      6.658,
      6.659,
      6.66,
      6.6610000000000005E+000,
      6.662,
      6.663,
      6.664,
      6.665,
      6.666,
      6.667,
      6.668,
      6.6690000000000005E+000,
      6.67,
      6.671,
      6.672,
      6.673,
      6.674,
      6.675,
      6.676,
      6.6770000000000005E+000,
      6.678,
      6.679,
      6.68,
      6.681,
      6.682,
      6.683,
      6.684,
      6.6850000000000005E+000,
      6.686,
      6.687,
      6.688,
      6.689,
      6.69,
      6.691,
      6.692,
      6.6930000000000005E+000,
      6.694,
      6.695,
      6.696,
      6.697,
      6.698,
      6.699,
      6.7,
      6.7010000000000005E+000,
      6.702,
      6.703,
      6.704,
      6.705,
      6.706,
      6.707,
      6.708,
      6.7090000000000005E+000,
      6.71,
      6.711,
      6.712,
      6.713,
      6.714,
      6.715,
      6.716,
      6.7170000000000005E+000,
      6.718,
      6.719,
      6.72,
      6.721,
      6.722,
      6.723,
      6.724,
      6.7250000000000005E+000,
      6.726,
      6.727,
      6.728,
      6.729,
      6.73,
      6.731,
      6.732,
      6.7330000000000005E+000,
      6.734,
      6.735,
      6.736,
      6.737,
      6.738,
      6.739,
      6.74,
      6.7410000000000005E+000,
      6.742,
      6.743,
      6.744,
      6.745,
      6.746,
      6.747,
      6.748,
      6.7490000000000006E+000,
      6.75,
      6.751,
      6.752,
      6.753,
      6.7540000000000004E+000,
      6.755,
      6.756,
      6.7570000000000006E+000,
      6.758,
      6.759,
      6.76,
      6.761,
      6.7620000000000005E+000,
      6.763,
      6.764,
      6.7650000000000006E+000,
      6.766,
      6.767,
      6.768,
      6.769,
      6.7700000000000005E+000,
      6.771,
      6.772,
      6.7730000000000006E+000,
      6.774,
      6.775,
      6.776,
      6.777,
      6.7780000000000005E+000,
      6.779,
      6.78,
      6.7810000000000006E+000,
      6.782,
      6.783,
      6.784,
      6.785,
      6.7860000000000005E+000,
      6.787,
      6.788,
      6.789,
      6.79,
      6.791,
      6.792,
      6.793,
      6.7940000000000005E+000,
      6.795,
      6.796,
      6.797,
      6.798,
      6.799,
      6.8,
      6.801,
      6.8020000000000005E+000,
      6.803,
      6.804,
      6.805,
      6.806,
      6.807,
      6.808,
      6.809,
      6.8100000000000005E+000,
      6.811,
      6.812,
      6.813,
      6.814,
      6.815,
      6.816,
      6.817,
      6.8180000000000005E+000,
      6.819,
      6.82,
      6.821,
      6.822,
      6.823,
      6.824,
      6.825,
      6.8260000000000005E+000,
      6.827,
      6.828,
      6.829,
      6.83,
      6.831,
      6.832,
      6.833,
      6.8340000000000005E+000,
      6.835,
      6.836,
      6.837,
      6.838,
      6.839,
      6.84,
      6.841,
      6.8420000000000005E+000,
      6.843,
      6.844,
      6.845,
      6.846,
      6.847,
      6.848,
      6.849,
      6.8500000000000005E+000,
      6.851,
      6.852,
      6.853,
      6.854,
      6.855,
      6.856,
      6.857,
      6.8580000000000005E+000,
      6.859,
      6.86,
      6.861,
      6.862,
      6.863,
      6.864,
      6.865,
      6.8660000000000005E+000,
      6.867,
      6.868,
      6.869,
      6.87,
      6.871,
      6.872,
      6.873,
      6.8740000000000006E+000,
      6.875,
      6.876,
      6.877,
      6.878,
      6.8790000000000004E+000,
      6.88,
      6.881,
      6.8820000000000006E+000,
      6.883,
      6.884,
      6.885,
      6.886,
      6.8870000000000005E+000,
      6.888,
      6.889,
      6.8900000000000006E+000,
      6.891,
      6.892,
      6.893,
      6.894,
      6.8950000000000005E+000,
      6.896,
      6.897,
      6.8980000000000006E+000,
      6.899,
      6.9,
      6.901,
      6.902,
      6.9030000000000005E+000,
      6.904,
      6.905,
      6.9060000000000006E+000,
      6.907,
      6.908,
      6.909,
      6.91,
      6.9110000000000005E+000,
      6.912,
      6.913,
      6.914,
      6.915,
      6.916,
      6.917,
      6.918,
      6.9190000000000005E+000,
      6.92,
      6.921,
      6.922,
      6.923,
      6.924,
      6.925,
      6.926,
      6.9270000000000005E+000,
      6.928,
      6.929,
      6.93,
      6.931,
      6.932,
      6.933,
      6.934,
      6.9350000000000005E+000,
      6.936,
      6.937,
      6.938,
      6.939,
      6.94,
      6.941,
      6.942,
      6.9430000000000005E+000,
      6.944,
      6.945,
      6.946,
      6.947,
      6.948,
      6.949,
      6.95,
      6.9510000000000005E+000,
      6.952,
      6.953,
      6.954,
      6.955,
      6.956,
      6.957,
      6.958,
      6.9590000000000005E+000,
      6.96,
      6.961,
      6.962,
      6.963,
      6.964,
      6.965,
      6.966,
      6.9670000000000005E+000,
      6.968,
      6.969,
      6.97,
      6.971,
      6.972,
      6.973,
      6.974,
      6.9750000000000005E+000,
      6.976,
      6.977,
      6.978,
      6.979,
      6.98,
      6.981,
      6.982,
      6.9830000000000005E+000,
      6.984,
      6.985,
      6.986,
      6.987,
      6.988,
      6.989,
      6.99,
      6.9910000000000005E+000,
      6.992,
      6.993,
      6.994,
      6.995,
      6.996,
      6.997,
      6.998,
      6.9990000000000006E+000,
      7.0,
      7.001,
      7.002,
      7.003,
      7.0040000000000004E+000,
      7.005,
      7.006,
      7.0070000000000006E+000,
      7.008,
      7.009,
      7.01,
      7.011,
      7.0120000000000005E+000,
      7.013,
      7.014,
      7.0150000000000006E+000,
      7.016,
      7.017,
      7.018,
      7.019,
      7.0200000000000005E+000,
      7.021,
      7.022,
      7.0230000000000006E+000,
      7.024,
      7.025,
      7.026,
      7.027,
      7.0280000000000005E+000,
      7.029,
      7.03,
      7.0310000000000006E+000,
      7.032,
      7.033,
      7.034,
      7.035,
      7.0360000000000005E+000,
      7.037,
      7.038,
      7.0390000000000006E+000,
      7.04,
      7.041,
      7.042,
      7.043,
      7.0440000000000005E+000,
      7.045,
      7.046,
      7.047,
      7.048,
      7.049,
      7.05,
      7.051,
      7.0520000000000005E+000,
      7.053,
      7.054,
      7.055,
      7.056,
      7.057,
      7.058,
      7.059,
      7.0600000000000005E+000,
      7.061,
      7.062,
      7.063,
      7.064,
      7.065,
      7.066,
      7.067,
      7.0680000000000005E+000,
      7.069,
      7.07,
      7.071,
      7.072,
      7.073,
      7.074,
      7.075,
      7.0760000000000005E+000,
      7.077,
      7.078,
      7.079,
      7.08,
      7.081,
      7.082,
      7.083,
      7.0840000000000005E+000,
      7.085,
      7.086,
      7.087,
      7.088,
      7.089,
      7.09,
      7.091,
      7.0920000000000005E+000,
      7.093,
      7.094,
      7.095,
      7.096,
      7.097,
      7.098,
      7.099,
      7.1000000000000005E+000,
      7.101,
      7.102,
      7.103,
      7.104,
      7.105,
      7.106,
      7.107,
      7.1080000000000005E+000,
      7.109,
      7.11,
      7.111,
      7.112,
      7.113,
      7.114,
      7.115,
      7.1160000000000005E+000,
      7.117,
      7.118,
      7.119,
      7.12,
      7.121,
      7.122,
      7.123,
      7.1240000000000006E+000,
      7.125,
      7.126,
      7.127,
      7.128,
      7.1290000000000004E+000,
      7.13,
      7.131,
      7.1320000000000006E+000,
      7.133,
      7.134,
      7.135,
      7.136,
      7.1370000000000005E+000,
      7.138,
      7.139,
      7.1400000000000006E+000,
      7.141,
      7.142,
      7.143,
      7.144,
      7.1450000000000005E+000,
      7.146,
      7.147,
      7.1480000000000006E+000,
      7.149,
      7.15,
      7.151,
      7.152,
      7.1530000000000005E+000,
      7.154,
      7.155,
      7.1560000000000006E+000,
      7.157,
      7.158,
      7.159,
      7.16,
      7.1610000000000005E+000,
      7.162,
      7.163,
      7.1640000000000006E+000,
      7.165,
      7.166,
      7.167,
      7.168,
      7.1690000000000005E+000,
      7.17,
      7.171,
      7.172,
      7.173,
      7.174,
      7.175,
      7.176,
      7.1770000000000005E+000,
      7.178,
      7.179,
      7.18,
      7.181,
      7.182,
      7.183,
      7.184,
      7.1850000000000005E+000,
      7.186,
      7.187,
      7.188,
      7.189,
      7.19,
      7.191,
      7.192,
      7.1930000000000005E+000,
      7.194,
      7.195,
      7.196,
      7.197,
      7.198,
      7.199,
      7.2,
      7.2010000000000005E+000,
      7.202,
      7.203,
      7.204,
      7.205,
      7.206,
      7.207,
      7.208,
      7.2090000000000005E+000,
      7.21,
      7.211,
      7.212,
      7.213,
      7.214,
      7.215,
      7.216,
      7.2170000000000005E+000,
      7.218,
      7.219,
      7.22,
      7.221,
      7.222,
      7.223,
      7.224,
      7.2250000000000005E+000,
      7.226,
      7.227,
      7.228,
      7.229,
      7.23,
      7.231,
      7.232,
      7.2330000000000005E+000,
      7.234,
      7.235,
      7.236,
      7.237,
      7.238,
      7.239,
      7.24,
      7.2410000000000005E+000,
      7.242,
      7.243,
      7.244,
      7.245,
      7.246,
      7.247,
      7.248,
      7.2490000000000006E+000,
      7.25,
      7.251,
      7.252,
      7.253,
      7.2540000000000004E+000,
      7.255,
      7.256,
      7.2570000000000006E+000,
      7.258,
      7.259,
      7.26,
      7.261,
      7.2620000000000005E+000,
      7.263,
      7.264,
      7.2650000000000006E+000,
      7.266,
      7.267,
      7.268,
      7.269,
      7.2700000000000005E+000,
      7.271,
      7.272,
      7.2730000000000006E+000,
      7.274,
      7.275,
      7.276,
      7.277,
      7.2780000000000005E+000,
      7.279,
      7.28,
      7.2810000000000006E+000,
      7.282,
      7.283,
      7.284,
      7.285,
      7.2860000000000005E+000,
      7.287,
      7.288,
      7.2890000000000006E+000,
      7.29,
      7.291,
      7.292,
      7.293,
      7.2940000000000005E+000,
      7.295,
      7.296,
      7.297,
      7.298,
      7.299,
      7.3,
      7.301,
      7.3020000000000005E+000,
      7.303,
      7.304,
      7.305,
      7.306,
      7.307,
      7.308,
      7.309,
      7.3100000000000005E+000,
      7.311,
      7.312,
      7.313,
      7.314,
      7.315,
      7.316,
      7.317,
      7.3180000000000005E+000,
      7.319,
      7.32,
      7.321,
      7.322,
      7.323,
      7.324,
      7.325,
      7.3260000000000005E+000,
      7.327,
      7.328,
      7.329,
      7.33,
      7.331,
      7.332,
      7.333,
      7.3340000000000005E+000,
      7.335,
      7.336,
      7.337,
      7.338,
      7.339,
      7.34,
      7.341,
      7.3420000000000005E+000,
      7.343,
      7.344,
      7.345,
      7.346,
      7.347,
      7.348,
      7.349,
      7.3500000000000005E+000,
      7.351,
      7.352,
      7.353,
      7.354,
      7.355,
      7.356,
      7.357,
      7.3580000000000005E+000,
      7.359,
      7.36,
      7.361,
      7.362,
      7.363,
      7.364,
      7.365,
      7.3660000000000005E+000,
      7.367,
      7.368,
      7.369,
      7.37,
      7.371,
      7.372,
      7.373,
      7.3740000000000006E+000,
      7.375,
      7.376,
      7.377,
      7.378,
      7.3790000000000004E+000,
      7.38,
      7.381,
      7.3820000000000006E+000,
      7.383,
      7.384,
      7.385,
      7.386,
      7.3870000000000005E+000,
      7.388,
      7.389,
      7.3900000000000006E+000,
      7.391,
      7.392,
      7.393,
      7.394,
      7.3950000000000005E+000,
      7.396,
      7.397,
      7.3980000000000006E+000,
      7.399,
      7.4,
      7.401,
      7.402,
      7.4030000000000005E+000,
      7.404,
      7.405,
      7.4060000000000006E+000,
      7.407,
      7.408,
      7.409,
      7.41,
      7.4110000000000005E+000,
      7.412,
      7.413,
      7.4140000000000006E+000,
      7.415,
      7.416,
      7.417,
      7.418,
      7.4190000000000005E+000,
      7.42,
      7.421,
      7.4220000000000006E+000,
      7.423,
      7.424,
      7.425,
      7.426,
      7.4270000000000005E+000,
      7.428,
      7.429,
      7.43,
      7.431,
      7.432,
      7.433,
      7.434,
      7.4350000000000005E+000,
      7.436,
      7.437,
      7.438,
      7.439,
      7.44,
      7.441,
      7.442,
      7.4430000000000005E+000,
      7.444,
      7.445,
      7.446,
      7.447,
      7.448,
      7.449,
      7.45,
      7.4510000000000005E+000,
      7.452,
      7.453,
      7.454,
      7.455,
      7.456,
      7.457,
      7.458,
      7.4590000000000005E+000,
      7.46,
      7.461,
      7.462,
      7.463,
      7.464,
      7.465,
      7.466,
      7.4670000000000005E+000,
      7.468,
      7.469,
      7.47,
      7.471,
      7.472,
      7.473,
      7.474,
      7.4750000000000005E+000,
      7.476,
      7.477,
      7.478,
      7.479,
      7.48,
      7.481,
      7.482,
      7.4830000000000005E+000,
      7.484,
      7.485,
      7.486,
      7.487,
      7.488,
      7.489,
      7.49,
      7.4910000000000005E+000,
      7.492,
      7.493,
      7.494,
      7.495,
      7.496,
      7.497,
      7.498,
      7.4990000000000006E+000,
      7.5,
      7.501,
      7.502,
      7.503,
      7.5040000000000004E+000,
      7.505,
      7.506,
      7.5070000000000006E+000,
      7.508,
      7.509,
      7.51,
      7.511,
      7.5120000000000005E+000,
      7.513,
      7.514,
      7.5150000000000006E+000,
      7.516,
      7.517,
      7.518,
      7.519,
      7.5200000000000005E+000,
      7.521,
      7.522,
      7.5230000000000006E+000,
      7.524,
      7.525,
      7.526,
      7.527,
      7.5280000000000005E+000,
      7.529,
      7.53,
      7.5310000000000006E+000,
      7.532,
      7.533,
      7.534,
      7.535,
      7.5360000000000005E+000,
      7.537,
      7.538,
      7.5390000000000006E+000,
      7.54,
      7.541,
      7.542,
      7.543,
      7.5440000000000005E+000,
      7.545,
      7.546,
      7.5470000000000006E+000,
      7.548,
      7.549,
      7.55,
      7.551,
      7.5520000000000005E+000,
      7.553,
      7.554,
      7.555,
      7.556,
      7.557,
      7.558,
      7.559,
      7.5600000000000005E+000,
      7.561,
      7.562,
      7.563,
      7.564,
      7.565,
      7.566,
      7.567,
      7.5680000000000005E+000,
      7.569,
      7.57,
      7.571,
      7.572,
      7.573,
      7.574,
      7.575,
      7.5760000000000005E+000,
      7.577,
      7.578,
      7.579,
      7.58,
      7.581,
      7.582,
      7.583,
      7.5840000000000005E+000,
      7.585,
      7.586,
      7.587,
      7.588,
      7.589,
      7.59,
      7.591,
      7.5920000000000005E+000,
      7.593,
      7.594,
      7.595,
      7.596,
      7.597,
      7.598,
      7.599,
      7.6000000000000005E+000,
      7.601,
      7.602,
      7.603,
      7.604,
      7.605,
      7.606,
      7.607,
      7.6080000000000005E+000,
      7.609,
      7.61,
      7.611,
      7.612,
      7.613,
      7.614,
      7.615,
      7.6160000000000005E+000,
      7.617,
      7.618,
      7.619,
      7.62,
      7.621,
      7.622,
      7.623,
      7.6240000000000006E+000,
      7.625,
      7.626,
      7.627,
      7.628,
      7.6290000000000004E+000,
      7.63,
      7.631,
      7.6320000000000006E+000,
      7.633,
      7.634,
      7.635,
      7.636,
      7.6370000000000005E+000,
      7.638,
      7.639,
      7.6400000000000006E+000,
      7.641,
      7.642,
      7.643,
      7.644,
      7.6450000000000005E+000,
      7.646,
      7.647,
      7.6480000000000006E+000,
      7.649,
      7.65,
      7.651,
      7.652,
      7.6530000000000005E+000,
      7.654,
      7.655,
      7.6560000000000006E+000,
      7.657,
      7.658,
      7.659,
      7.66,
      7.6610000000000005E+000,
      7.662,
      7.663,
      7.6640000000000006E+000,
      7.665,
      7.666,
      7.667,
      7.668,
      7.6690000000000005E+000,
      7.67,
      7.671,
      7.6720000000000006E+000,
      7.673,
      7.674,
      7.675,
      7.676,
      7.6770000000000005E+000,
      7.678,
      7.679,
      7.68,
      7.681,
      7.682,
      7.683,
      7.684,
      7.6850000000000005E+000,
      7.686,
      7.687,
      7.688,
      7.689,
      7.69,
      7.691,
      7.692,
      7.6930000000000005E+000,
      7.694,
      7.695,
      7.696,
      7.697,
      7.698,
      7.699,
      7.7,
      7.7010000000000005E+000,
      7.702,
      7.703,
      7.704,
      7.705,
      7.706,
      7.707,
      7.708,
      7.7090000000000005E+000,
      7.71,
      7.711,
      7.712,
      7.713,
      7.714,
      7.715,
      7.716,
      7.7170000000000005E+000,
      7.718,
      7.719,
      7.72,
      7.721,
      7.722,
      7.723,
      7.724,
      7.7250000000000005E+000,
      7.726,
      7.727,
      7.728,
      7.729,
      7.73,
      7.731,
      7.732,
      7.7330000000000005E+000,
      7.734,
      7.735,
      7.736,
      7.737,
      7.738,
      7.739,
      7.74,
      7.7410000000000005E+000,
      7.742,
      7.743,
      7.744,
      7.745,
      7.746,
      7.747,
      7.748,
      7.7490000000000006E+000,
      7.75,
      7.751,
      7.752,
      7.753,
      7.7540000000000004E+000,
      7.755,
      7.756,
      7.7570000000000006E+000,
      7.758,
      7.759,
      7.76,
      7.761,
      7.7620000000000005E+000,
      7.763,
      7.764,
      7.7650000000000006E+000,
      7.766,
      7.767,
      7.768,
      7.769,
      7.7700000000000005E+000,
      7.771,
      7.772,
      7.7730000000000006E+000,
      7.774,
      7.775,
      7.776,
      7.777,
      7.7780000000000005E+000,
      7.779,
      7.78,
      7.7810000000000006E+000,
      7.7820000000000018E+000,
      7.7830000000000021E+000,
      7.7840000000000025E+000,
      7.7850000000000019E+000,
      7.7860000000000023E+000,
      7.7870000000000026E+000,
      7.7880000000000020E+000,
      7.7890000000000024E+000,
      7.7900000000000018E+000,
      7.7910000000000021E+000,
      7.7920000000000025E+000,
      7.7930000000000019E+000,
      7.7940000000000023E+000,
      7.7950000000000026E+000,
      7.7960000000000020E+000,
      7.7970000000000024E+000,
      7.7980000000000018E+000,
      7.7990000000000022E+000,
      7.8000000000000025E+000,
      7.8010000000000019E+000,
      7.8020000000000023E+000,
      7.8030000000000026E+000,
      7.8040000000000020E+000,
      7.8050000000000024E+000,
      7.8060000000000018E+000,
      7.8070000000000022E+000,
      7.8080000000000025E+000,
      7.8090000000000019E+000,
      7.8100000000000023E+000,
      7.8110000000000026E+000,
      7.8120000000000021E+000,
      7.8130000000000024E+000,
      7.8140000000000018E+000,
      7.8150000000000022E+000,
      7.8160000000000025E+000,
      7.8170000000000019E+000,
      7.8180000000000023E+000,
      7.8190000000000026E+000,
      7.8200000000000021E+000,
      7.8210000000000024E+000,
      7.8220000000000018E+000,
      7.8230000000000022E+000,
      7.8240000000000025E+000,
      7.8250000000000020E+000,
      7.8260000000000023E+000,
      7.8270000000000026E+000,
      7.8280000000000021E+000,
      7.8290000000000024E+000,
      7.8300000000000018E+000,
      7.8310000000000022E+000,
      7.8320000000000025E+000,
      7.8330000000000020E+000,
      7.8340000000000023E+000,
      7.8350000000000026E+000,
      7.8360000000000021E+000,
      7.8370000000000024E+000,
      7.8380000000000019E+000,
      7.8390000000000022E+000,
      7.8400000000000025E+000,
      7.8410000000000020E+000,
      7.8420000000000023E+000,
      7.8430000000000026E+000,
      7.8440000000000021E+000,
      7.8450000000000024E+000,
      7.8460000000000019E+000,
      7.8470000000000022E+000,
      7.8480000000000025E+000,
      7.8490000000000020E+000,
      7.8500000000000023E+000,
      7.8510000000000026E+000,
      7.8520000000000021E+000,
      7.8530000000000024E+000,
      7.8540000000000019E+000,
      7.8550000000000022E+000,
      7.8560000000000025E+000,
      7.8570000000000020E+000,
      7.8580000000000023E+000,
      7.8590000000000027E+000,
      7.8600000000000021E+000,
      7.8610000000000024E+000,
      7.8620000000000019E+000,
      7.8630000000000022E+000,
      7.8640000000000025E+000,
      7.8650000000000020E+000,
      7.8660000000000023E+000,
      7.8670000000000027E+000,
      7.8680000000000021E+000,
      7.8690000000000024E+000,
      7.8700000000000019E+000,
      7.8710000000000022E+000,
      7.8720000000000026E+000,
      7.8730000000000020E+000,
      7.8740000000000023E+000,
      7.8750000000000027E+000,
      7.8760000000000021E+000,
      7.8770000000000024E+000,
      7.8780000000000019E+000,
      7.8790000000000022E+000,
      7.8800000000000026E+000,
      7.8810000000000020E+000,
      7.8820000000000023E+000,
      7.8830000000000027E+000,
      7.8840000000000021E+000,
      7.8850000000000025E+000,
      7.8860000000000019E+000,
      7.8870000000000022E+000,
      7.8880000000000026E+000,
      7.8890000000000020E+000,
      7.8900000000000023E+000,
      7.8910000000000018E+000,
      7.8920000000000021E+000,
      7.8930000000000025E+000,
      7.8940000000000019E+000,
      7.8950000000000022E+000,
      7.8960000000000026E+000,
      7.8970000000000020E+000,
      7.8980000000000024E+000,
      7.8990000000000018E+000,
      7.9000000000000021E+000,
      7.9010000000000025E+000,
      7.9020000000000019E+000,
      7.9030000000000022E+000,
      7.9040000000000026E+000,
      7.9050000000000020E+000,
      7.9060000000000024E+000,
      7.9070000000000018E+000,
      7.9080000000000021E+000,
      7.9090000000000025E+000,
      7.9100000000000019E+000,
      7.9110000000000023E+000,
      7.9120000000000026E+000,
      7.9130000000000020E+000,
      7.9140000000000024E+000,
      7.9150000000000018E+000,
      7.9160000000000021E+000,
      7.9170000000000025E+000,
      7.9180000000000019E+000,
      7.9190000000000023E+000,
      7.9200000000000026E+000,
      7.9210000000000020E+000,
      7.9220000000000024E+000,
      7.9230000000000018E+000,
      7.9240000000000022E+000,
      7.9250000000000025E+000,
      7.9260000000000019E+000,
      7.9270000000000023E+000,
      7.9280000000000026E+000,
      7.9290000000000020E+000,
      7.9300000000000024E+000,
      7.9310000000000018E+000,
      7.9320000000000022E+000,
      7.9330000000000025E+000,
      7.9340000000000019E+000,
      7.9350000000000023E+000,
      7.9360000000000026E+000,
      7.9370000000000021E+000,
      7.9380000000000024E+000,
      7.9390000000000018E+000,
      7.9400000000000022E+000,
      7.9410000000000025E+000,
      7.9420000000000019E+000,
      7.9430000000000023E+000,
      7.9440000000000026E+000,
      7.9450000000000021E+000,
      7.9460000000000024E+000,
      7.9470000000000018E+000,
      7.9480000000000022E+000,
      7.9490000000000025E+000,
      7.9500000000000020E+000,
      7.9510000000000023E+000,
      7.9520000000000026E+000,
      7.9530000000000021E+000,
      7.9540000000000024E+000,
      7.9550000000000018E+000,
      7.9560000000000022E+000,
      7.9570000000000025E+000,
      7.9580000000000020E+000,
      7.9590000000000023E+000,
      7.9600000000000026E+000,
      7.9610000000000021E+000,
      7.9620000000000024E+000,
      7.9630000000000019E+000,
      7.9640000000000022E+000,
      7.9650000000000025E+000,
      7.9660000000000020E+000,
      7.9670000000000023E+000,
      7.9680000000000026E+000,
      7.9690000000000021E+000,
      7.9700000000000024E+000,
      7.9710000000000019E+000,
      7.9720000000000022E+000,
      7.9730000000000025E+000,
      7.9740000000000020E+000,
      7.9750000000000023E+000,
      7.9760000000000026E+000,
      7.9770000000000021E+000,
      7.9780000000000024E+000,
      7.9790000000000019E+000,
      7.9800000000000022E+000,
      7.9810000000000025E+000,
      7.9820000000000020E+000,
      7.9830000000000023E+000,
      7.9840000000000027E+000,
      7.9850000000000021E+000,
      7.9860000000000024E+000,
      7.9870000000000019E+000,
      7.9880000000000022E+000,
      7.9890000000000025E+000,
      7.9900000000000020E+000,
      7.9910000000000023E+000,
      7.9920000000000027E+000,
      7.9930000000000021E+000,
      7.9940000000000024E+000,
      7.9950000000000019E+000,
      7.9960000000000022E+000,
      7.9970000000000026E+000,
      7.9980000000000020E+000,
      7.9990000000000023E+000,
      8.0000000000000036E+000,
      8.0010000000000012E+000,
      8.0020000000000024E+000,
      8.0030000000000019E+000,
      8.0040000000000013E+000,
      8.0050000000000026E+000,
      8.0060000000000020E+000,
      8.0070000000000014E+000,
      8.0080000000000027E+000,
      8.0090000000000021E+000,
      8.0100000000000016E+000,
      8.0110000000000028E+000,
      8.0120000000000022E+000,
      8.0130000000000017E+000,
      8.0140000000000029E+000,
      8.0150000000000023E+000,
      8.0160000000000018E+000,
      8.0170000000000030E+000,
      8.0180000000000025E+000,
      8.0190000000000019E+000,
      8.0200000000000031E+000,
      8.0210000000000026E+000,
      8.0220000000000020E+000,
      8.0230000000000032E+000,
      8.0240000000000009E+000,
      8.0250000000000021E+000,
      8.0260000000000034E+000,
      8.0270000000000010E+000,
      8.0280000000000022E+000,
      8.0290000000000035E+000,
      8.0300000000000011E+000,
      8.0310000000000024E+000,
      8.0320000000000018E+000,
      8.0330000000000013E+000,
      8.0340000000000025E+000,
      8.0350000000000019E+000,
      8.0360000000000014E+000,
      8.0370000000000026E+000,
      8.0380000000000020E+000,
      8.0390000000000015E+000,
      8.0400000000000027E+000,
      8.0410000000000021E+000,
      8.0420000000000016E+000,
      8.0430000000000028E+000,
      8.0440000000000023E+000,
      8.0450000000000017E+000,
      8.0460000000000029E+000,
      8.0470000000000024E+000,
      8.0480000000000018E+000,
      8.0490000000000030E+000,
      8.0500000000000025E+000,
      8.0510000000000019E+000,
      8.0520000000000032E+000,
      8.0530000000000026E+000,
      8.0540000000000020E+000,
      8.0550000000000033E+000,
      8.0560000000000009E+000,
      8.0570000000000022E+000,
      8.0580000000000034E+000,
      8.0590000000000011E+000,
      8.0600000000000023E+000,
      8.0610000000000035E+000,
      8.0620000000000012E+000,
      8.0630000000000024E+000,
      8.0640000000000018E+000,
      8.0650000000000013E+000,
      8.0660000000000025E+000,
      8.0670000000000019E+000,
      8.0680000000000014E+000,
      8.0690000000000026E+000,
      8.0700000000000021E+000,
      8.0710000000000015E+000,
      8.0720000000000027E+000,
      8.0730000000000022E+000,
      8.0740000000000016E+000,
      8.0750000000000028E+000,
      8.0760000000000023E+000,
      8.0770000000000017E+000,
      8.0780000000000030E+000,
      8.0790000000000024E+000,
      8.0800000000000018E+000,
      8.0810000000000031E+000,
      8.0820000000000025E+000,
      8.0830000000000020E+000,
      8.0840000000000032E+000,
      8.0850000000000026E+000,
      8.0860000000000021E+000,
      8.0870000000000033E+000,
      8.0880000000000010E+000,
      8.0890000000000022E+000,
      8.0900000000000034E+000,
      8.0910000000000011E+000,
      8.0920000000000023E+000,
      8.0930000000000035E+000,
      8.0940000000000012E+000,
      8.0950000000000024E+000,
      8.0960000000000019E+000,
      8.0970000000000013E+000,
      8.0980000000000025E+000,
      8.0990000000000020E+000,
      8.1000000000000014E+000,
      8.1010000000000026E+000,
      8.1020000000000021E+000,
      8.1030000000000015E+000,
      8.1040000000000028E+000,
      8.1050000000000022E+000,
      8.1060000000000016E+000,
      8.1070000000000029E+000,
      8.1080000000000023E+000,
      8.1090000000000018E+000,
      8.1100000000000030E+000,
      8.1110000000000024E+000,
      8.1120000000000019E+000,
      8.1130000000000031E+000,
      8.1140000000000025E+000,
      8.1150000000000020E+000,
      8.1160000000000032E+000,
      8.1170000000000027E+000,
      8.1180000000000021E+000,
      8.1190000000000033E+000,
      8.1200000000000010E+000,
      8.1210000000000022E+000,
      8.1220000000000034E+000,
      8.1230000000000011E+000,
      8.1240000000000023E+000,
      8.1250000000000036E+000,
      8.1260000000000012E+000,
      8.1270000000000024E+000,
      8.1280000000000019E+000,
      8.1290000000000013E+000,
      8.1300000000000026E+000,
      8.1310000000000020E+000,
      8.1320000000000014E+000,
      8.1330000000000027E+000,
      8.1340000000000021E+000,
      8.1350000000000016E+000,
      8.1360000000000028E+000,
      8.1370000000000022E+000,
      8.1380000000000017E+000,
      8.1390000000000029E+000,
      8.1400000000000023E+000,
      8.1410000000000018E+000,
      8.1420000000000030E+000,
      8.1430000000000025E+000,
      8.1440000000000019E+000,
      8.1450000000000031E+000,
      8.1460000000000026E+000,
      8.1470000000000020E+000,
      8.1480000000000032E+000,
      8.1490000000000009E+000,
      8.1500000000000021E+000,
      8.1510000000000034E+000,
      8.1520000000000010E+000,
      8.1530000000000022E+000,
      8.1540000000000035E+000,
      8.1550000000000011E+000,
      8.1560000000000024E+000,
      8.1570000000000018E+000,
      8.1580000000000013E+000,
      8.1590000000000025E+000,
      8.1600000000000019E+000,
      8.1610000000000014E+000,
      8.1620000000000026E+000,
      8.1630000000000020E+000,
      8.1640000000000015E+000,
      8.1650000000000027E+000,
      8.1660000000000021E+000,
      8.1670000000000016E+000,
      8.1680000000000028E+000,
      8.1690000000000023E+000,
      8.1700000000000017E+000,
      8.1710000000000029E+000,
      8.1720000000000024E+000,
      8.1730000000000018E+000,
      8.1740000000000030E+000,
      8.1750000000000025E+000,
      8.1760000000000019E+000,
      8.1770000000000032E+000,
      8.1780000000000026E+000,
      8.1790000000000020E+000,
      8.1800000000000033E+000,
      8.1810000000000009E+000,
      8.1820000000000022E+000,
      8.1830000000000034E+000,
      8.1840000000000011E+000,
      8.1850000000000023E+000,
      8.1860000000000035E+000,
      8.1870000000000012E+000,
      8.1880000000000024E+000,
      8.1890000000000018E+000,
      8.1900000000000013E+000,
      8.1910000000000025E+000,
      8.1920000000000019E+000,
      8.1930000000000014E+000,
      8.1940000000000026E+000,
      8.1950000000000021E+000,
      8.1960000000000015E+000,
      8.1970000000000027E+000,
      8.1980000000000022E+000,
      8.1990000000000016E+000,
      8.2000000000000028E+000,
      8.2010000000000023E+000,
      8.2020000000000017E+000,
      8.2030000000000030E+000,
      8.2040000000000024E+000,
      8.2050000000000018E+000,
      8.2060000000000031E+000,
      8.2070000000000025E+000,
      8.2080000000000020E+000,
      8.2090000000000032E+000,
      8.2100000000000026E+000,
      8.2110000000000021E+000,
      8.2120000000000033E+000,
      8.2130000000000010E+000,
      8.2140000000000022E+000,
      8.2150000000000034E+000,
      8.2160000000000011E+000,
      8.2170000000000023E+000,
      8.2180000000000035E+000,
      8.2190000000000012E+000,
      8.2200000000000024E+000,
      8.2210000000000019E+000,
      8.2220000000000013E+000,
      8.2230000000000025E+000,
      8.2240000000000020E+000,
      8.2250000000000014E+000,
      8.2260000000000026E+000,
      8.2270000000000021E+000,
      8.2280000000000015E+000,
      8.2290000000000028E+000,
      8.2300000000000022E+000,
      8.2310000000000016E+000,
      8.2320000000000029E+000,
      8.2330000000000023E+000,
      8.2340000000000018E+000,
      8.2350000000000030E+000,
      8.2360000000000024E+000,
      8.2370000000000019E+000,
      8.2380000000000031E+000,
      8.2390000000000025E+000,
      8.2400000000000020E+000,
      8.2410000000000032E+000,
      8.2420000000000027E+000,
      8.2430000000000021E+000,
      8.2440000000000033E+000,
      8.2450000000000010E+000,
      8.2460000000000022E+000,
      8.2470000000000034E+000,
      8.2480000000000011E+000,
      8.2490000000000023E+000,
      8.2500000000000036E+000,
      8.2510000000000012E+000,
      8.2520000000000024E+000,
      8.2530000000000019E+000,
      8.2540000000000013E+000,
      8.2550000000000026E+000,
      8.2560000000000020E+000,
      8.2570000000000014E+000,
      8.2580000000000027E+000,
      8.2590000000000021E+000,
      8.2600000000000016E+000,
      8.2610000000000028E+000,
      8.2620000000000022E+000,
      8.2630000000000017E+000,
      8.2640000000000029E+000,
      8.2650000000000023E+000,
      8.2660000000000018E+000,
      8.2670000000000030E+000,
      8.2680000000000025E+000,
      8.2690000000000019E+000,
      8.2700000000000031E+000,
      8.2710000000000026E+000,
      8.2720000000000020E+000,
      8.2730000000000032E+000,
      8.2740000000000009E+000,
      8.2750000000000021E+000,
      8.2760000000000034E+000,
      8.2770000000000010E+000,
      8.2780000000000022E+000,
      8.2790000000000035E+000,
      8.2800000000000011E+000,
      8.2810000000000024E+000,
      8.2820000000000018E+000,
      8.2830000000000013E+000,
      8.2840000000000025E+000,
      8.2850000000000019E+000,
      8.2860000000000014E+000,
      8.2870000000000026E+000,
      8.2880000000000020E+000,
      8.2890000000000015E+000,
      8.2900000000000027E+000,
      8.2910000000000021E+000,
      8.2920000000000016E+000,
      8.2930000000000028E+000,
      8.2940000000000023E+000,
      8.2950000000000017E+000,
      8.2960000000000029E+000,
      8.2970000000000024E+000,
      8.2980000000000018E+000,
      8.2990000000000030E+000,
      8.3000000000000025E+000,
      8.3010000000000019E+000,
      8.3020000000000032E+000,
      8.3030000000000026E+000,
      8.3040000000000020E+000,
      8.3050000000000033E+000,
      8.3060000000000009E+000,
      8.3070000000000022E+000,
      8.3080000000000034E+000,
      8.3090000000000011E+000,
      8.3100000000000023E+000,
      8.3110000000000035E+000,
      8.3120000000000012E+000,
      8.3130000000000024E+000,
      8.3140000000000018E+000,
      8.3150000000000013E+000,
      8.3160000000000025E+000,
      8.3170000000000019E+000,
      8.3180000000000014E+000,
      8.3190000000000026E+000,
      8.3200000000000021E+000,
      8.3210000000000015E+000,
      8.3220000000000027E+000,
      8.3230000000000022E+000,
      8.3240000000000016E+000,
      8.3250000000000028E+000,
      8.3260000000000023E+000,
      8.3270000000000017E+000,
      8.3280000000000030E+000,
      8.3290000000000024E+000,
      8.3300000000000018E+000,
      8.3310000000000031E+000,
      8.3320000000000025E+000,
      8.3330000000000020E+000,
      8.3340000000000032E+000,
      8.3350000000000026E+000,
      8.3360000000000021E+000,
      8.3370000000000033E+000,
      8.3380000000000010E+000,
      8.3390000000000022E+000,
      8.3400000000000034E+000,
      8.3410000000000011E+000,
      8.3420000000000023E+000,
      8.3430000000000035E+000,
      8.3440000000000012E+000,
      8.3450000000000024E+000,
      8.3460000000000019E+000,
      8.3470000000000013E+000,
      8.3480000000000025E+000,
      8.3490000000000020E+000,
      8.3500000000000014E+000,
      8.3510000000000026E+000,
      8.3520000000000021E+000,
      8.3530000000000015E+000,
      8.3540000000000028E+000,
      8.3550000000000022E+000,
      8.3560000000000016E+000,
      8.3570000000000029E+000,
      8.3580000000000023E+000,
      8.3590000000000018E+000,
      8.3600000000000030E+000,
      8.3610000000000024E+000,
      8.3620000000000019E+000,
      8.3630000000000031E+000,
      8.3640000000000025E+000,
      8.3650000000000020E+000,
      8.3660000000000032E+000,
      8.3670000000000027E+000,
      8.3680000000000021E+000,
      8.3690000000000033E+000,
      8.3700000000000010E+000,
      8.3710000000000022E+000,
      8.3720000000000034E+000,
      8.3730000000000011E+000,
      8.3740000000000023E+000,
      8.3750000000000036E+000,
      8.3760000000000012E+000,
      8.3770000000000024E+000,
      8.3780000000000019E+000,
      8.3790000000000013E+000,
      8.3800000000000026E+000,
      8.3810000000000020E+000,
      8.3820000000000014E+000,
      8.3830000000000027E+000,
      8.3840000000000021E+000,
      8.3850000000000016E+000,
      8.3860000000000028E+000,
      8.3870000000000022E+000,
      8.3880000000000017E+000,
      8.3890000000000029E+000,
      8.3900000000000023E+000,
      8.3910000000000018E+000,
      8.3920000000000030E+000,
      8.3930000000000025E+000,
      8.3940000000000019E+000,
      8.3950000000000031E+000,
      8.3960000000000026E+000,
      8.3970000000000020E+000,
      8.3980000000000032E+000,
      8.3990000000000009E+000,
      8.4000000000000021E+000,
      8.4010000000000034E+000,
      8.4020000000000010E+000,
      8.4030000000000022E+000,
      8.4040000000000035E+000,
      8.4050000000000011E+000,
      8.4060000000000024E+000,
      8.4070000000000018E+000,
      8.4080000000000013E+000,
      8.4090000000000025E+000,
      8.4100000000000019E+000,
      8.4110000000000014E+000,
      8.4120000000000026E+000,
      8.4130000000000020E+000,
      8.4140000000000015E+000,
      8.4150000000000027E+000,
      8.4160000000000021E+000,
      8.4170000000000016E+000,
      8.4180000000000028E+000,
      8.4190000000000023E+000,
      8.4200000000000017E+000,
      8.4210000000000029E+000,
      8.4220000000000024E+000,
      8.4230000000000018E+000,
      8.4240000000000030E+000,
      8.4250000000000025E+000,
      8.4260000000000019E+000,
      8.4270000000000032E+000,
      8.4280000000000026E+000,
      8.4290000000000020E+000,
      8.4300000000000033E+000,
      8.4310000000000009E+000,
      8.4320000000000022E+000,
      8.4330000000000034E+000,
      8.4340000000000011E+000,
      8.4350000000000023E+000,
      8.4360000000000035E+000,
      8.4370000000000012E+000,
      8.4380000000000024E+000,
      8.4390000000000018E+000,
      8.4400000000000013E+000,
      8.4410000000000025E+000,
      8.4420000000000019E+000,
      8.4430000000000014E+000,
      8.4440000000000026E+000,
      8.4450000000000021E+000,
      8.4460000000000015E+000,
      8.4470000000000027E+000,
      8.4480000000000022E+000,
      8.4490000000000016E+000,
      8.4500000000000028E+000,
      8.4510000000000023E+000,
      8.4520000000000017E+000,
      8.4530000000000030E+000,
      8.4540000000000024E+000,
      8.4550000000000018E+000,
      8.4560000000000031E+000,
      8.4570000000000025E+000,
      8.4580000000000020E+000,
      8.4590000000000032E+000,
      8.4600000000000026E+000,
      8.4610000000000021E+000,
      8.4620000000000033E+000,
      8.4630000000000010E+000,
      8.4640000000000022E+000,
      8.4650000000000034E+000,
      8.4660000000000011E+000,
      8.4670000000000023E+000,
      8.4680000000000035E+000,
      8.4690000000000012E+000,
      8.4700000000000024E+000,
      8.4710000000000019E+000,
      8.4720000000000013E+000,
      8.4730000000000025E+000,
      8.4740000000000020E+000,
      8.4750000000000014E+000,
      8.4760000000000026E+000,
      8.4770000000000021E+000,
      8.4780000000000015E+000,
      8.4790000000000028E+000,
      8.4800000000000022E+000,
      8.4810000000000016E+000,
      8.4820000000000029E+000,
      8.4830000000000023E+000,
      8.4840000000000018E+000,
      8.4850000000000030E+000,
      8.4860000000000024E+000,
      8.4870000000000019E+000,
      8.4880000000000031E+000,
      8.4890000000000025E+000,
      8.4900000000000020E+000,
      8.4910000000000032E+000,
      8.4920000000000027E+000,
      8.4930000000000021E+000,
      8.4940000000000033E+000,
      8.4950000000000010E+000,
      8.4960000000000022E+000,
      8.4970000000000034E+000,
      8.4980000000000011E+000,
      8.4990000000000023E+000,
      8.5000000000000036E+000,
      8.5010000000000012E+000,
      8.5020000000000024E+000,
      8.5030000000000019E+000,
      8.5040000000000013E+000,
      8.5050000000000026E+000,
      8.5060000000000020E+000,
      8.5070000000000014E+000,
      8.5080000000000027E+000,
      8.5090000000000021E+000,
      8.5100000000000016E+000,
      8.5110000000000028E+000,
      8.5120000000000022E+000,
      8.5130000000000017E+000,
      8.5140000000000029E+000,
      8.5150000000000023E+000,
      8.5160000000000018E+000,
      8.5170000000000030E+000,
      8.5180000000000025E+000,
      8.5190000000000019E+000,
      8.5200000000000031E+000,
      8.5210000000000026E+000,
      8.5220000000000020E+000,
      8.5230000000000032E+000,
      8.5240000000000009E+000,
      8.5250000000000021E+000,
      8.5260000000000034E+000,
      8.5270000000000010E+000,
      8.5280000000000022E+000,
      8.5290000000000035E+000,
      8.5300000000000011E+000,
      8.5310000000000024E+000,
      8.5320000000000018E+000,
      8.5330000000000013E+000,
      8.5340000000000025E+000,
      8.5350000000000019E+000,
      8.5360000000000014E+000,
      8.5370000000000026E+000,
      8.5380000000000020E+000,
      8.5390000000000015E+000,
      8.5400000000000027E+000,
      8.5410000000000021E+000,
      8.5420000000000016E+000,
      8.5430000000000028E+000,
      8.5440000000000023E+000,
      8.5450000000000017E+000,
      8.5460000000000029E+000,
      8.5470000000000024E+000,
      8.5480000000000018E+000,
      8.5490000000000030E+000,
      8.5500000000000025E+000,
      8.5510000000000019E+000,
      8.5520000000000032E+000,
      8.5530000000000026E+000,
      8.5540000000000020E+000,
      8.5550000000000033E+000,
      8.5560000000000009E+000,
      8.5570000000000022E+000,
      8.5580000000000034E+000,
      8.5590000000000011E+000,
      8.5600000000000023E+000,
      8.5610000000000035E+000,
      8.5620000000000012E+000,
      8.5630000000000024E+000,
      8.5640000000000018E+000,
      8.5650000000000013E+000,
      8.5660000000000025E+000,
      8.5670000000000019E+000,
      8.5680000000000014E+000,
      8.5690000000000026E+000,
      8.5700000000000021E+000,
      8.5710000000000015E+000,
      8.5720000000000027E+000,
      8.5730000000000022E+000,
      8.5740000000000016E+000,
      8.5750000000000028E+000,
      8.5760000000000023E+000,
      8.5770000000000017E+000,
      8.5780000000000030E+000,
      8.5790000000000024E+000,
      8.5800000000000018E+000,
      8.5810000000000031E+000,
      8.5820000000000025E+000,
      8.5830000000000020E+000,
      8.5840000000000032E+000,
      8.5850000000000026E+000,
      8.5860000000000021E+000,
      8.5870000000000033E+000,
      8.5880000000000010E+000,
      8.5890000000000022E+000,
      8.5900000000000034E+000,
      8.5910000000000011E+000,
      8.5920000000000023E+000,
      8.5930000000000035E+000,
      8.5940000000000012E+000,
      8.5950000000000024E+000,
      8.5960000000000019E+000,
      8.5970000000000013E+000,
      8.5980000000000025E+000,
      8.5990000000000020E+000,
      8.6000000000000014E+000,
      8.6010000000000026E+000,
      8.6020000000000021E+000,
      8.6030000000000015E+000,
      8.6040000000000028E+000,
      8.6050000000000022E+000,
      8.6060000000000016E+000,
      8.6070000000000029E+000,
      8.6080000000000023E+000,
      8.6090000000000018E+000,
      8.6100000000000030E+000,
      8.6110000000000024E+000,
      8.6120000000000019E+000,
      8.6130000000000031E+000,
      8.6140000000000025E+000,
      8.6150000000000020E+000,
      8.6160000000000032E+000,
      8.6170000000000027E+000,
      8.6180000000000021E+000,
      8.6190000000000033E+000,
      8.6200000000000010E+000,
      8.6210000000000022E+000,
      8.6220000000000034E+000,
      8.6230000000000011E+000,
      8.6240000000000023E+000,
      8.6250000000000036E+000,
      8.6260000000000012E+000,
      8.6270000000000024E+000,
      8.6280000000000019E+000,
      8.6290000000000013E+000,
      8.6300000000000026E+000,
      8.6310000000000020E+000,
      8.6320000000000014E+000,
      8.6330000000000027E+000,
      8.6340000000000021E+000,
      8.6350000000000016E+000,
      8.6360000000000028E+000,
      8.6370000000000022E+000,
      8.6380000000000017E+000,
      8.6390000000000029E+000,
      8.6400000000000023E+000,
      8.6410000000000018E+000,
      8.6420000000000030E+000,
      8.6430000000000025E+000,
      8.6440000000000019E+000,
      8.6450000000000031E+000,
      8.6460000000000026E+000,
      8.6470000000000020E+000,
      8.6480000000000032E+000,
      8.6490000000000027E+000,
      8.6500000000000021E+000,
      8.6510000000000034E+000,
      8.6520000000000010E+000,
      8.6530000000000022E+000,
      8.6540000000000035E+000,
      8.6550000000000011E+000,
      8.6560000000000024E+000,
      8.6570000000000018E+000,
      8.6580000000000013E+000,
      8.6590000000000025E+000,
      8.6600000000000019E+000,
      8.6610000000000014E+000,
      8.6620000000000026E+000,
      8.6630000000000020E+000,
      8.6640000000000015E+000,
      8.6650000000000027E+000,
      8.6660000000000021E+000,
      8.6670000000000016E+000,
      8.6680000000000028E+000,
      8.6690000000000023E+000,
      8.6700000000000017E+000,
      8.6710000000000029E+000,
      8.6720000000000024E+000,
      8.6730000000000018E+000,
      8.6740000000000030E+000,
      8.6750000000000025E+000,
      8.6760000000000019E+000,
      8.6770000000000032E+000,
      8.6780000000000026E+000,
      8.6790000000000020E+000,
      8.6800000000000033E+000,
      8.6810000000000009E+000,
      8.6820000000000022E+000,
      8.6830000000000034E+000,
      8.6840000000000011E+000,
      8.6850000000000023E+000,
      8.6860000000000035E+000,
      8.6870000000000012E+000,
      8.6880000000000024E+000,
      8.6890000000000018E+000,
      8.6900000000000013E+000,
      8.6910000000000025E+000,
      8.6920000000000019E+000,
      8.6930000000000014E+000,
      8.6940000000000026E+000,
      8.6950000000000021E+000,
      8.6960000000000015E+000,
      8.6970000000000027E+000,
      8.6980000000000022E+000,
      8.6990000000000016E+000,
      8.7000000000000028E+000,
      8.7010000000000023E+000,
      8.7020000000000017E+000,
      8.7030000000000030E+000,
      8.7040000000000024E+000,
      8.7050000000000018E+000,
      8.7060000000000031E+000,
      8.7070000000000025E+000,
      8.7080000000000020E+000,
      8.7090000000000032E+000,
      8.7100000000000026E+000,
      8.7110000000000021E+000,
      8.7120000000000033E+000,
      8.7130000000000010E+000,
      8.7140000000000022E+000,
      8.7150000000000034E+000,
      8.7160000000000011E+000,
      8.7170000000000023E+000,
      8.7180000000000035E+000,
      8.7190000000000012E+000,
      8.7200000000000024E+000,
      8.7210000000000019E+000,
      8.7220000000000013E+000,
      8.7230000000000025E+000,
      8.7240000000000020E+000,
      8.7250000000000014E+000,
      8.7260000000000026E+000,
      8.7270000000000021E+000,
      8.7280000000000015E+000,
      8.7290000000000028E+000,
      8.7300000000000022E+000,
      8.7310000000000016E+000,
      8.7320000000000029E+000,
      8.7330000000000023E+000,
      8.7340000000000018E+000,
      8.7350000000000030E+000,
      8.7360000000000024E+000,
      8.7370000000000019E+000,
      8.7380000000000031E+000,
      8.7390000000000025E+000,
      8.7400000000000020E+000,
      8.7410000000000032E+000,
      8.7420000000000027E+000,
      8.7430000000000021E+000,
      8.7440000000000033E+000,
      8.7450000000000010E+000,
      8.7460000000000022E+000,
      8.7470000000000034E+000,
      8.7480000000000011E+000,
      8.7490000000000023E+000,
      8.7500000000000036E+000,
      8.7510000000000012E+000,
      8.7520000000000024E+000,
      8.7530000000000019E+000,
      8.7540000000000013E+000,
      8.7550000000000026E+000,
      8.7560000000000020E+000,
      8.7570000000000014E+000,
      8.7580000000000027E+000,
      8.7590000000000021E+000,
      8.7600000000000016E+000,
      8.7610000000000028E+000,
      8.7620000000000022E+000,
      8.7630000000000017E+000,
      8.7640000000000029E+000,
      8.7650000000000023E+000,
      8.7660000000000018E+000,
      8.7670000000000030E+000,
      8.7680000000000025E+000,
      8.7690000000000019E+000,
      8.7700000000000031E+000,
      8.7710000000000026E+000,
      8.7720000000000020E+000,
      8.7730000000000032E+000,
      8.7740000000000027E+000,
      8.7750000000000021E+000,
      8.7760000000000034E+000,
      8.7770000000000010E+000,
      8.7780000000000022E+000,
      8.7790000000000035E+000,
      8.7800000000000011E+000,
      8.7810000000000024E+000,
      8.7820000000000018E+000,
      8.7830000000000013E+000,
      8.7840000000000025E+000,
      8.7850000000000019E+000,
      8.7860000000000014E+000,
      8.7870000000000026E+000,
      8.7880000000000020E+000,
      8.7890000000000015E+000,
      8.7900000000000027E+000,
      8.7910000000000021E+000,
      8.7920000000000016E+000,
      8.7930000000000028E+000,
      8.7940000000000023E+000,
      8.7950000000000017E+000,
      8.7960000000000029E+000,
      8.7970000000000024E+000,
      8.7980000000000018E+000,
      8.7990000000000030E+000,
      8.8000000000000025E+000,
      8.8010000000000019E+000,
      8.8020000000000032E+000,
      8.8030000000000026E+000,
      8.8040000000000020E+000,
      8.8050000000000033E+000,
      8.8060000000000009E+000,
      8.8070000000000022E+000,
      8.8080000000000034E+000,
      8.8090000000000011E+000,
      8.8100000000000023E+000,
      8.8110000000000035E+000,
      8.8120000000000012E+000,
      8.8130000000000024E+000,
      8.8140000000000018E+000,
      8.8150000000000013E+000,
      8.8160000000000025E+000,
      8.8170000000000019E+000,
      8.8180000000000014E+000,
      8.8190000000000026E+000,
      8.8200000000000021E+000,
      8.8210000000000015E+000,
      8.8220000000000027E+000,
      8.8230000000000022E+000,
      8.8240000000000016E+000,
      8.8250000000000028E+000,
      8.8260000000000023E+000,
      8.8270000000000017E+000,
      8.8280000000000030E+000,
      8.8290000000000024E+000,
      8.8300000000000018E+000,
      8.8310000000000031E+000,
      8.8320000000000025E+000,
      8.8330000000000020E+000,
      8.8340000000000032E+000,
      8.8350000000000026E+000,
      8.8360000000000021E+000,
      8.8370000000000033E+000,
      8.8380000000000010E+000,
      8.8390000000000022E+000,
      8.8400000000000034E+000,
      8.8410000000000011E+000,
      8.8420000000000023E+000,
      8.8430000000000035E+000,
      8.8440000000000012E+000,
      8.8450000000000024E+000,
      8.8460000000000019E+000,
      8.8470000000000013E+000,
      8.8480000000000025E+000,
      8.8490000000000020E+000,
      8.8500000000000014E+000,
      8.8510000000000026E+000,
      8.8520000000000021E+000,
      8.8530000000000015E+000,
      8.8540000000000028E+000,
      8.8550000000000022E+000,
      8.8560000000000016E+000,
      8.8570000000000029E+000,
      8.8580000000000023E+000,
      8.8590000000000018E+000,
      8.8600000000000030E+000,
      8.8610000000000024E+000,
      8.8620000000000019E+000,
      8.8630000000000031E+000,
      8.8640000000000025E+000,
      8.8650000000000020E+000,
      8.8660000000000032E+000,
      8.8670000000000027E+000,
      8.8680000000000021E+000,
      8.8690000000000033E+000,
      8.8700000000000010E+000,
      8.8710000000000022E+000,
      8.8720000000000034E+000,
      8.8730000000000011E+000,
      8.8740000000000023E+000,
      8.8750000000000036E+000,
      8.8760000000000012E+000,
      8.8770000000000024E+000,
      8.8780000000000019E+000,
      8.8790000000000013E+000,
      8.8800000000000026E+000,
      8.8810000000000020E+000,
      8.8820000000000014E+000,
      8.8830000000000027E+000,
      8.8840000000000021E+000,
      8.8850000000000016E+000,
      8.8860000000000028E+000,
      8.8870000000000022E+000,
      8.8880000000000017E+000,
      8.8890000000000029E+000,
      8.8900000000000023E+000,
      8.8910000000000018E+000,
      8.8920000000000030E+000,
      8.8930000000000025E+000,
      8.8940000000000019E+000,
      8.8950000000000031E+000,
      8.8960000000000026E+000,
      8.8970000000000020E+000,
      8.8980000000000032E+000,
      8.8990000000000027E+000,
      8.9000000000000021E+000,
      8.9010000000000034E+000,
      8.9020000000000010E+000,
      8.9030000000000022E+000,
      8.9040000000000035E+000,
      8.9050000000000011E+000,
      8.9060000000000024E+000,
      8.9070000000000018E+000,
      8.9080000000000013E+000,
      8.9090000000000025E+000,
      8.9100000000000019E+000,
      8.9110000000000014E+000,
      8.9120000000000026E+000,
      8.9130000000000020E+000,
      8.9140000000000015E+000,
      8.9150000000000027E+000,
      8.9160000000000021E+000,
      8.9170000000000016E+000,
      8.9180000000000028E+000,
      8.9190000000000023E+000,
      8.9200000000000017E+000,
      8.9210000000000029E+000,
      8.9220000000000024E+000,
      8.9230000000000018E+000,
      8.9240000000000030E+000,
      8.9250000000000025E+000,
      8.9260000000000019E+000,
      8.9270000000000032E+000,
      8.9280000000000026E+000,
      8.9290000000000020E+000,
      8.9300000000000033E+000,
      8.9310000000000009E+000,
      8.9320000000000022E+000,
      8.9330000000000034E+000,
      8.9340000000000011E+000,
      8.9350000000000023E+000,
      8.9360000000000035E+000,
      8.9370000000000012E+000,
      8.9380000000000024E+000,
      8.9390000000000018E+000,
      8.9400000000000013E+000,
      8.9410000000000025E+000,
      8.9420000000000019E+000,
      8.9430000000000014E+000,
      8.9440000000000026E+000,
      8.9450000000000021E+000,
      8.9460000000000015E+000,
      8.9470000000000027E+000,
      8.9480000000000022E+000,
      8.9490000000000016E+000,
      8.9500000000000028E+000,
      8.9510000000000023E+000,
      8.9520000000000017E+000,
      8.9530000000000030E+000,
      8.9540000000000024E+000,
      8.9550000000000018E+000,
      8.9560000000000031E+000,
      8.9570000000000025E+000,
      8.9580000000000020E+000,
      8.9590000000000032E+000,
      8.9600000000000026E+000,
      8.9610000000000021E+000,
      8.9620000000000033E+000,
      8.9630000000000010E+000,
      8.9640000000000022E+000,
      8.9650000000000034E+000,
      8.9660000000000011E+000,
      8.9670000000000023E+000,
      8.9680000000000035E+000,
      8.9690000000000012E+000,
      8.9700000000000024E+000,
      8.9710000000000019E+000,
      8.9720000000000013E+000,
      8.9730000000000025E+000,
      8.9740000000000020E+000,
      8.9750000000000014E+000,
      8.9760000000000026E+000,
      8.9770000000000021E+000,
      8.9780000000000015E+000,
      8.9790000000000028E+000,
      8.9800000000000022E+000,
      8.9810000000000016E+000,
      8.9820000000000029E+000,
      8.9830000000000023E+000,
      8.9840000000000018E+000,
      8.9850000000000030E+000,
      8.9860000000000024E+000,
      8.9870000000000019E+000,
      8.9880000000000031E+000,
      8.9890000000000025E+000,
      8.9900000000000020E+000,
      8.9910000000000032E+000,
      8.9920000000000027E+000,
      8.9930000000000021E+000,
      8.9940000000000033E+000,
      8.9950000000000010E+000,
      8.9960000000000022E+000,
      8.9970000000000034E+000,
      8.9980000000000011E+000,
      8.9990000000000023E+000,
      9.0000000000000036E+000,
      9.0010000000000012E+000,
      9.0020000000000024E+000,
      9.0030000000000019E+000,
      9.0040000000000013E+000,
      9.0050000000000026E+000,
      9.0060000000000020E+000,
      9.0070000000000014E+000,
      9.0080000000000027E+000,
      9.0090000000000021E+000,
      9.0100000000000016E+000,
      9.0110000000000028E+000,
      9.0120000000000022E+000,
      9.0130000000000017E+000,
      9.0140000000000029E+000,
      9.0150000000000023E+000,
      9.0160000000000018E+000,
      9.0170000000000030E+000,
      9.0180000000000025E+000,
      9.0190000000000019E+000,
      9.0200000000000031E+000,
      9.0210000000000026E+000,
      9.0220000000000020E+000,
      9.0230000000000032E+000,
      9.0240000000000027E+000,
      9.0250000000000021E+000,
      9.0260000000000034E+000,
      9.0270000000000010E+000,
      9.0280000000000022E+000,
      9.0290000000000035E+000,
      9.0300000000000011E+000,
      9.0310000000000024E+000,
      9.0320000000000036E+000,
      9.0330000000000013E+000,
      9.0340000000000025E+000,
      9.0350000000000019E+000,
      9.0360000000000014E+000,
      9.0370000000000026E+000,
      9.0380000000000020E+000,
      9.0390000000000015E+000,
      9.0400000000000027E+000,
      9.0410000000000021E+000,
      9.0420000000000016E+000,
      9.0430000000000028E+000,
      9.0440000000000023E+000,
      9.0450000000000017E+000,
      9.0460000000000029E+000,
      9.0470000000000024E+000,
      9.0480000000000018E+000,
      9.0490000000000030E+000,
      9.0500000000000025E+000,
      9.0510000000000019E+000,
      9.0520000000000032E+000,
      9.0530000000000026E+000,
      9.0540000000000020E+000,
      9.0550000000000033E+000,
      9.0560000000000009E+000,
      9.0570000000000022E+000,
      9.0580000000000034E+000,
      9.0590000000000011E+000,
      9.0600000000000023E+000,
      9.0610000000000035E+000,
      9.0620000000000012E+000,
      9.0630000000000024E+000,
      9.0640000000000018E+000,
      9.0650000000000013E+000,
      9.0660000000000025E+000,
      9.0670000000000019E+000,
      9.0680000000000014E+000,
      9.0690000000000026E+000,
      9.0700000000000021E+000,
      9.0710000000000015E+000,
      9.0720000000000027E+000,
      9.0730000000000022E+000,
      9.0740000000000016E+000,
      9.0750000000000028E+000,
      9.0760000000000023E+000,
      9.0770000000000017E+000,
      9.0780000000000030E+000,
      9.0790000000000024E+000,
      9.0800000000000018E+000,
      9.0810000000000031E+000,
      9.0820000000000025E+000,
      9.0830000000000020E+000,
      9.0840000000000032E+000,
      9.0850000000000026E+000,
      9.0860000000000021E+000,
      9.0870000000000033E+000,
      9.0880000000000010E+000,
      9.0890000000000022E+000,
      9.0900000000000034E+000,
      9.0910000000000011E+000,
      9.0920000000000023E+000,
      9.0930000000000035E+000,
      9.0940000000000012E+000,
      9.0950000000000024E+000,
      9.0960000000000019E+000,
      9.0970000000000013E+000,
      9.0980000000000025E+000,
      9.0990000000000020E+000,
      9.1000000000000014E+000,
      9.1010000000000026E+000,
      9.1020000000000021E+000,
      9.1030000000000015E+000,
      9.1040000000000028E+000,
      9.1050000000000022E+000,
      9.1060000000000016E+000,
      9.1070000000000029E+000,
      9.1080000000000023E+000,
      9.1090000000000018E+000,
      9.1100000000000030E+000,
      9.1110000000000024E+000,
      9.1120000000000019E+000,
      9.1130000000000031E+000,
      9.1140000000000025E+000,
      9.1150000000000020E+000,
      9.1160000000000032E+000,
      9.1170000000000027E+000,
      9.1180000000000021E+000,
      9.1190000000000033E+000,
      9.1200000000000010E+000,
      9.1210000000000022E+000,
      9.1220000000000034E+000,
      9.1230000000000011E+000,
      9.1240000000000023E+000,
      9.1250000000000036E+000,
      9.1260000000000012E+000,
      9.1270000000000024E+000,
      9.1280000000000019E+000,
      9.1290000000000013E+000,
      9.1300000000000026E+000,
      9.1310000000000020E+000,
      9.1320000000000014E+000,
      9.1330000000000027E+000,
      9.1340000000000021E+000,
      9.1350000000000016E+000,
      9.1360000000000028E+000,
      9.1370000000000022E+000,
      9.1380000000000017E+000,
      9.1390000000000029E+000,
      9.1400000000000023E+000,
      9.1410000000000018E+000,
      9.1420000000000030E+000,
      9.1430000000000025E+000,
      9.1440000000000019E+000,
      9.1450000000000031E+000,
      9.1460000000000026E+000,
      9.1470000000000020E+000,
      9.1480000000000032E+000,
      9.1490000000000027E+000,
      9.1500000000000021E+000,
      9.1510000000000034E+000,
      9.1520000000000010E+000,
      9.1530000000000022E+000,
      9.1540000000000035E+000,
      9.1550000000000011E+000,
      9.1560000000000024E+000,
      9.1570000000000036E+000,
      9.1580000000000013E+000,
      9.1590000000000025E+000,
      9.1600000000000019E+000,
      9.1610000000000014E+000,
      9.1620000000000026E+000,
      9.1630000000000020E+000,
      9.1640000000000015E+000,
      9.1650000000000027E+000,
      9.1660000000000021E+000,
      9.1670000000000016E+000,
      9.1680000000000028E+000,
      9.1690000000000023E+000,
      9.1700000000000017E+000,
      9.1710000000000029E+000,
      9.1720000000000024E+000,
      9.1730000000000018E+000,
      9.1740000000000030E+000,
      9.1750000000000025E+000,
      9.1760000000000019E+000,
      9.1770000000000032E+000,
      9.1780000000000026E+000,
      9.1790000000000020E+000,
      9.1800000000000033E+000,
      9.1810000000000009E+000,
      9.1820000000000022E+000,
      9.1830000000000034E+000,
      9.1840000000000011E+000,
      9.1850000000000023E+000,
      9.1860000000000035E+000,
      9.1870000000000012E+000,
      9.1880000000000024E+000,
      9.1890000000000018E+000,
      9.1900000000000013E+000,
      9.1910000000000025E+000,
      9.1920000000000019E+000,
      9.1930000000000014E+000,
      9.1940000000000026E+000,
      9.1950000000000021E+000,
      9.1960000000000015E+000,
      9.1970000000000027E+000,
      9.1980000000000022E+000,
      9.1990000000000016E+000,
      9.2000000000000028E+000,
      9.2010000000000023E+000,
      9.2020000000000017E+000,
      9.2030000000000030E+000,
      9.2040000000000024E+000,
      9.2050000000000018E+000,
      9.2060000000000031E+000,
      9.2070000000000025E+000,
      9.2080000000000020E+000,
      9.2090000000000032E+000,
      9.2100000000000026E+000,
      9.2110000000000021E+000,
      9.2120000000000033E+000,
      9.2130000000000010E+000,
      9.2140000000000022E+000,
      9.2150000000000034E+000,
      9.2160000000000011E+000,
      9.2170000000000023E+000,
      9.2180000000000035E+000,
      9.2190000000000012E+000,
      9.2200000000000024E+000,
      9.2210000000000019E+000,
      9.2220000000000013E+000,
      9.2230000000000025E+000,
      9.2240000000000020E+000,
      9.2250000000000014E+000,
      9.2260000000000026E+000,
      9.2270000000000021E+000,
      9.2280000000000015E+000,
      9.2290000000000028E+000,
      9.2300000000000022E+000,
      9.2310000000000016E+000,
      9.2320000000000029E+000,
      9.2330000000000023E+000,
      9.2340000000000018E+000,
      9.2350000000000030E+000,
      9.2360000000000024E+000,
      9.2370000000000019E+000,
      9.2380000000000031E+000,
      9.2390000000000025E+000,
      9.2400000000000020E+000,
      9.2410000000000032E+000,
      9.2420000000000027E+000,
      9.2430000000000021E+000,
      9.2440000000000033E+000,
      9.2450000000000010E+000,
      9.2460000000000022E+000,
      9.2470000000000034E+000,
      9.2480000000000011E+000,
      9.2490000000000023E+000,
      9.2500000000000036E+000,
      9.2510000000000012E+000,
      9.2520000000000024E+000,
      9.2530000000000019E+000,
      9.2540000000000013E+000,
      9.2550000000000026E+000,
      9.2560000000000020E+000,
      9.2570000000000014E+000,
      9.2580000000000027E+000,
      9.2590000000000021E+000,
      9.2600000000000016E+000,
      9.2610000000000028E+000,
      9.2620000000000022E+000,
      9.2630000000000017E+000,
      9.2640000000000029E+000,
      9.2650000000000023E+000,
      9.2660000000000018E+000,
      9.2670000000000030E+000,
      9.2680000000000025E+000,
      9.2690000000000019E+000,
      9.2700000000000031E+000,
      9.2710000000000026E+000,
      9.2720000000000020E+000,
      9.2730000000000032E+000,
      9.2740000000000027E+000,
      9.2750000000000021E+000,
      9.2760000000000034E+000,
      9.2770000000000010E+000,
      9.2780000000000022E+000,
      9.2790000000000035E+000,
      9.2800000000000011E+000,
      9.2810000000000024E+000,
      9.2820000000000036E+000,
      9.2830000000000013E+000,
      9.2840000000000025E+000,
      9.2850000000000019E+000,
      9.2860000000000014E+000,
      9.2870000000000026E+000,
      9.2880000000000020E+000,
      9.2890000000000015E+000,
      9.2900000000000027E+000,
      9.2910000000000021E+000,
      9.2920000000000016E+000,
      9.2930000000000028E+000,
      9.2940000000000023E+000,
      9.2950000000000017E+000,
      9.2960000000000029E+000,
      9.2970000000000024E+000,
      9.2980000000000018E+000,
      9.2990000000000030E+000,
      9.3000000000000025E+000,
      9.3010000000000019E+000,
      9.3020000000000032E+000,
      9.3030000000000026E+000,
      9.3040000000000020E+000,
      9.3050000000000033E+000,
      9.3060000000000009E+000,
      9.3070000000000022E+000,
      9.3080000000000034E+000,
      9.3090000000000011E+000,
      9.3100000000000023E+000,
      9.3110000000000035E+000,
      9.3120000000000012E+000,
      9.3130000000000024E+000,
      9.3140000000000018E+000,
      9.3150000000000013E+000,
      9.3160000000000025E+000,
      9.3170000000000019E+000,
      9.3180000000000014E+000,
      9.3190000000000026E+000,
      9.3200000000000021E+000,
      9.3210000000000015E+000,
      9.3220000000000027E+000,
      9.3230000000000022E+000,
      9.3240000000000016E+000,
      9.3250000000000028E+000,
      9.3260000000000023E+000,
      9.3270000000000017E+000,
      9.3280000000000030E+000,
      9.3290000000000024E+000,
      9.3300000000000018E+000,
      9.3310000000000031E+000,
      9.3320000000000025E+000,
      9.3330000000000020E+000,
      9.3340000000000032E+000,
      9.3350000000000026E+000,
      9.3360000000000021E+000,
      9.3370000000000033E+000,
      9.3380000000000010E+000,
      9.3390000000000022E+000,
      9.3400000000000034E+000,
      9.3410000000000011E+000,
      9.3420000000000023E+000,
      9.3430000000000035E+000,
      9.3440000000000012E+000,
      9.3450000000000024E+000,
      9.3460000000000019E+000,
      9.3470000000000013E+000,
      9.3480000000000025E+000,
      9.3490000000000020E+000,
      9.3500000000000014E+000,
      9.3510000000000026E+000,
      9.3520000000000021E+000,
      9.3530000000000015E+000,
      9.3540000000000028E+000,
      9.3550000000000022E+000,
      9.3560000000000016E+000,
      9.3570000000000029E+000,
      9.3580000000000023E+000,
      9.3590000000000018E+000,
      9.3600000000000030E+000,
      9.3610000000000024E+000,
      9.3620000000000019E+000,
      9.3630000000000031E+000,
      9.3640000000000025E+000,
      9.3650000000000020E+000,
      9.3660000000000032E+000,
      9.3670000000000027E+000,
      9.3680000000000021E+000,
      9.3690000000000033E+000,
      9.3700000000000010E+000,
      9.3710000000000022E+000,
      9.3720000000000034E+000,
      9.3730000000000011E+000,
      9.3740000000000023E+000,
      9.3750000000000036E+000,
      9.3760000000000012E+000,
      9.3770000000000024E+000,
      9.3780000000000019E+000,
      9.3790000000000013E+000,
      9.3800000000000026E+000,
      9.3810000000000020E+000,
      9.3820000000000014E+000,
      9.3830000000000027E+000,
      9.3840000000000021E+000,
      9.3850000000000016E+000,
      9.3860000000000028E+000,
      9.3870000000000022E+000,
      9.3880000000000017E+000,
      9.3890000000000029E+000,
      9.3900000000000023E+000,
      9.3910000000000018E+000,
      9.3920000000000030E+000,
      9.3930000000000025E+000,
      9.3940000000000019E+000,
      9.3950000000000031E+000,
      9.3960000000000026E+000,
      9.3970000000000020E+000,
      9.3980000000000032E+000,
      9.3990000000000027E+000,
      9.4000000000000021E+000,
      9.4010000000000034E+000,
      9.4020000000000010E+000,
      9.4030000000000022E+000,
      9.4040000000000035E+000,
      9.4050000000000011E+000,
      9.4060000000000024E+000,
      9.4070000000000036E+000,
      9.4080000000000013E+000,
      9.4090000000000025E+000,
      9.4100000000000019E+000,
      9.4110000000000014E+000,
      9.4120000000000026E+000,
      9.4130000000000020E+000,
      9.4140000000000015E+000,
      9.4150000000000027E+000,
      9.4160000000000021E+000,
      9.4170000000000016E+000,
      9.4180000000000028E+000,
      9.4190000000000023E+000,
      9.4200000000000017E+000,
      9.4210000000000029E+000,
      9.4220000000000024E+000,
      9.4230000000000018E+000,
      9.4240000000000030E+000,
      9.4250000000000025E+000,
      9.4260000000000019E+000,
      9.4270000000000032E+000,
      9.4280000000000026E+000,
      9.4290000000000020E+000,
      9.4300000000000033E+000,
      9.4310000000000009E+000,
      9.4320000000000022E+000,
      9.4330000000000034E+000,
      9.4340000000000011E+000,
      9.4350000000000023E+000,
      9.4360000000000035E+000,
      9.4370000000000012E+000,
      9.4380000000000024E+000,
      9.4390000000000018E+000,
      9.4400000000000013E+000,
      9.4410000000000025E+000,
      9.4420000000000019E+000,
      9.4430000000000014E+000,
      9.4440000000000026E+000,
      9.4450000000000021E+000,
      9.4460000000000015E+000,
      9.4470000000000027E+000,
      9.4480000000000022E+000,
      9.4490000000000016E+000,
      9.4500000000000028E+000,
      9.4510000000000023E+000,
      9.4520000000000017E+000,
      9.4530000000000030E+000,
      9.4540000000000024E+000,
      9.4550000000000018E+000,
      9.4560000000000031E+000,
      9.4570000000000025E+000,
      9.4580000000000020E+000,
      9.4590000000000032E+000,
      9.4600000000000026E+000,
      9.4610000000000021E+000,
      9.4620000000000033E+000,
      9.4630000000000010E+000,
      9.4640000000000022E+000,
      9.4650000000000034E+000,
      9.4660000000000011E+000,
      9.4670000000000023E+000,
      9.4680000000000035E+000,
      9.4690000000000012E+000,
      9.4700000000000024E+000,
      9.4710000000000019E+000,
      9.4720000000000013E+000,
      9.4730000000000025E+000,
      9.4740000000000020E+000,
      9.4750000000000014E+000,
      9.4760000000000026E+000,
      9.4770000000000021E+000,
      9.4780000000000015E+000,
      9.4790000000000028E+000,
      9.4800000000000022E+000,
      9.4810000000000016E+000,
      9.4820000000000029E+000,
      9.4830000000000023E+000,
      9.4840000000000018E+000,
      9.4850000000000030E+000,
      9.4860000000000024E+000,
      9.4870000000000019E+000,
      9.4880000000000031E+000,
      9.4890000000000025E+000,
      9.4900000000000020E+000,
      9.4910000000000032E+000,
      9.4920000000000027E+000,
      9.4930000000000021E+000,
      9.4940000000000033E+000,
      9.4950000000000010E+000,
      9.4960000000000022E+000,
      9.4970000000000034E+000,
      9.4980000000000011E+000,
      9.4990000000000023E+000,
      9.5000000000000036E+000,
      9.5010000000000012E+000,
      9.5020000000000024E+000,
      9.5030000000000019E+000,
      9.5040000000000013E+000,
      9.5050000000000026E+000,
      9.5060000000000020E+000,
      9.5070000000000014E+000,
      9.5080000000000027E+000,
      9.5090000000000021E+000,
      9.5100000000000016E+000,
      9.5110000000000028E+000,
      9.5120000000000022E+000,
      9.5130000000000017E+000,
      9.5140000000000029E+000,
      9.5150000000000023E+000,
      9.5160000000000018E+000,
      9.5170000000000030E+000,
      9.5180000000000025E+000,
      9.5190000000000019E+000,
      9.5200000000000031E+000,
      9.5210000000000026E+000,
      9.5220000000000020E+000,
      9.5230000000000032E+000,
      9.5240000000000027E+000,
      9.5250000000000021E+000,
      9.5260000000000034E+000,
      9.5270000000000010E+000,
      9.5280000000000022E+000,
      9.5290000000000035E+000,
      9.5300000000000011E+000,
      9.5310000000000024E+000,
      9.5320000000000036E+000,
      9.5330000000000013E+000,
      9.5340000000000025E+000,
      9.5350000000000019E+000,
      9.5360000000000014E+000,
      9.5370000000000026E+000,
      9.5380000000000020E+000,
      9.5390000000000015E+000,
      9.5400000000000027E+000,
      9.5410000000000021E+000,
      9.5420000000000016E+000,
      9.5430000000000028E+000,
      9.5440000000000023E+000,
      9.5450000000000017E+000,
      9.5460000000000029E+000,
      9.5470000000000024E+000,
      9.5480000000000018E+000,
      9.5490000000000030E+000,
      9.5500000000000025E+000,
      9.5510000000000019E+000,
      9.5520000000000032E+000,
      9.5530000000000026E+000,
      9.5540000000000020E+000,
      9.5550000000000033E+000,
      9.5560000000000009E+000,
      9.5570000000000022E+000,
      9.5580000000000034E+000,
      9.5590000000000011E+000,
      9.5600000000000023E+000,
      9.5610000000000035E+000,
      9.5620000000000012E+000,
      9.5630000000000024E+000,
      9.5640000000000018E+000,
      9.5650000000000013E+000,
      9.5660000000000025E+000,
      9.5670000000000019E+000,
      9.5680000000000014E+000,
      9.5690000000000026E+000,
      9.5700000000000021E+000,
      9.5710000000000015E+000,
      9.5720000000000027E+000,
      9.5730000000000022E+000,
      9.5740000000000016E+000,
      9.5750000000000028E+000,
      9.5760000000000023E+000,
      9.5770000000000017E+000,
      9.5780000000000030E+000,
      9.5790000000000024E+000,
      9.5800000000000018E+000,
      9.5810000000000031E+000,
      9.5820000000000025E+000,
      9.5830000000000020E+000,
      9.5840000000000032E+000,
      9.5850000000000026E+000,
      9.5860000000000021E+000,
      9.5870000000000033E+000,
      9.5880000000000010E+000,
      9.5890000000000022E+000,
      9.5900000000000034E+000,
      9.5910000000000011E+000,
      9.5920000000000023E+000,
      9.5930000000000035E+000,
      9.5940000000000012E+000,
      9.5950000000000024E+000,
      9.5960000000000019E+000,
      9.5970000000000013E+000,
      9.5980000000000025E+000,
      9.5990000000000020E+000,
      9.6000000000000014E+000,
      9.6010000000000026E+000,
      9.6020000000000021E+000,
      9.6030000000000015E+000,
      9.6040000000000028E+000,
      9.6050000000000022E+000,
      9.6060000000000016E+000,
      9.6070000000000029E+000,
      9.6080000000000023E+000,
      9.6090000000000018E+000,
      9.6100000000000030E+000,
      9.6110000000000024E+000,
      9.6120000000000019E+000,
      9.6130000000000031E+000,
      9.6140000000000025E+000,
      9.6150000000000020E+000,
      9.6160000000000032E+000,
      9.6170000000000027E+000,
      9.6180000000000021E+000,
      9.6190000000000033E+000,
      9.6200000000000010E+000,
      9.6210000000000022E+000,
      9.6220000000000034E+000,
      9.6230000000000011E+000,
      9.6240000000000023E+000,
      9.6250000000000036E+000,
      9.6260000000000012E+000,
      9.6270000000000024E+000,
      9.6280000000000019E+000,
      9.6290000000000013E+000,
      9.6300000000000026E+000,
      9.6310000000000020E+000,
      9.6320000000000014E+000,
      9.6330000000000027E+000,
      9.6340000000000021E+000,
      9.6350000000000016E+000,
      9.6360000000000028E+000,
      9.6370000000000022E+000,
      9.6380000000000017E+000,
      9.6390000000000029E+000,
      9.6400000000000023E+000,
      9.6410000000000018E+000,
      9.6420000000000030E+000,
      9.6430000000000025E+000,
      9.6440000000000019E+000,
      9.6450000000000031E+000,
      9.6460000000000026E+000,
      9.6470000000000020E+000,
      9.6480000000000032E+000,
      9.6490000000000027E+000,
      9.6500000000000021E+000,
      9.6510000000000034E+000,
      9.6520000000000010E+000,
      9.6530000000000022E+000,
      9.6540000000000035E+000,
      9.6550000000000011E+000,
      9.6560000000000024E+000,
      9.6570000000000036E+000,
      9.6580000000000013E+000,
      9.6590000000000025E+000,
      9.6600000000000019E+000,
      9.6610000000000014E+000,
      9.6620000000000026E+000,
      9.6630000000000020E+000,
      9.6640000000000015E+000,
      9.6650000000000027E+000,
      9.6660000000000021E+000,
      9.6670000000000016E+000,
      9.6680000000000028E+000,
      9.6690000000000023E+000,
      9.6700000000000017E+000,
      9.6710000000000029E+000,
      9.6720000000000024E+000,
      9.6730000000000018E+000,
      9.6740000000000030E+000,
      9.6750000000000025E+000,
      9.6760000000000019E+000,
      9.6770000000000032E+000,
      9.6780000000000026E+000,
      9.6790000000000020E+000,
      9.6800000000000033E+000,
      9.6810000000000009E+000,
      9.6820000000000022E+000,
      9.6830000000000034E+000,
      9.6840000000000011E+000,
      9.6850000000000023E+000,
      9.6860000000000035E+000,
      9.6870000000000012E+000,
      9.6880000000000024E+000,
      9.6890000000000018E+000,
      9.6900000000000013E+000,
      9.6910000000000025E+000,
      9.6920000000000019E+000,
      9.6930000000000014E+000,
      9.6940000000000026E+000,
      9.6950000000000021E+000,
      9.6960000000000015E+000,
      9.6970000000000027E+000,
      9.6980000000000022E+000,
      9.6990000000000016E+000,
      9.7000000000000028E+000,
      9.7010000000000023E+000,
      9.7020000000000017E+000,
      9.7030000000000030E+000,
      9.7040000000000024E+000,
      9.7050000000000018E+000,
      9.7060000000000031E+000,
      9.7070000000000025E+000,
      9.7080000000000020E+000,
      9.7090000000000032E+000,
      9.7100000000000026E+000,
      9.7110000000000021E+000,
      9.7120000000000033E+000,
      9.7130000000000010E+000,
      9.7140000000000022E+000,
      9.7150000000000034E+000,
      9.7160000000000011E+000,
      9.7170000000000023E+000,
      9.7180000000000035E+000,
      9.7190000000000012E+000,
      9.7200000000000024E+000,
      9.7210000000000019E+000,
      9.7220000000000013E+000,
      9.7230000000000025E+000,
      9.7240000000000020E+000,
      9.7250000000000014E+000,
      9.7260000000000026E+000,
      9.7270000000000021E+000,
      9.7280000000000015E+000,
      9.7290000000000028E+000,
      9.7300000000000022E+000,
      9.7310000000000016E+000,
      9.7320000000000029E+000,
      9.7330000000000023E+000,
      9.7340000000000018E+000,
      9.7350000000000030E+000,
      9.7360000000000024E+000,
      9.7370000000000019E+000,
      9.7380000000000031E+000,
      9.7390000000000025E+000,
      9.7400000000000020E+000,
      9.7410000000000032E+000,
      9.7420000000000027E+000,
      9.7430000000000021E+000,
      9.7440000000000033E+000,
      9.7450000000000010E+000,
      9.7460000000000022E+000,
      9.7470000000000034E+000,
      9.7480000000000011E+000,
      9.7490000000000023E+000,
      9.7500000000000036E+000,
      9.7510000000000012E+000,
      9.7520000000000024E+000,
      9.7530000000000019E+000,
      9.7540000000000013E+000,
      9.7550000000000026E+000,
      9.7560000000000020E+000,
      9.7570000000000014E+000,
      9.7580000000000027E+000,
      9.7590000000000021E+000,
      9.7600000000000016E+000,
      9.7610000000000028E+000,
      9.7620000000000022E+000,
      9.7630000000000017E+000,
      9.7640000000000029E+000,
      9.7650000000000023E+000,
      9.7660000000000018E+000,
      9.7670000000000030E+000,
      9.7680000000000025E+000,
      9.7690000000000019E+000,
      9.7700000000000031E+000,
      9.7710000000000026E+000,
      9.7720000000000020E+000,
      9.7730000000000032E+000,
      9.7740000000000027E+000,
      9.7750000000000021E+000,
      9.7760000000000034E+000,
      9.7770000000000010E+000,
      9.7780000000000022E+000,
      9.7790000000000035E+000,
      9.7800000000000011E+000,
      9.7810000000000024E+000,
      9.7820000000000036E+000,
      9.7830000000000013E+000,
      9.7840000000000025E+000,
      9.7850000000000019E+000,
      9.7860000000000014E+000,
      9.7870000000000026E+000,
      9.7880000000000020E+000,
      9.7890000000000015E+000,
      9.7900000000000027E+000,
      9.7910000000000021E+000,
      9.7920000000000016E+000,
      9.7930000000000028E+000,
      9.7940000000000023E+000,
      9.7950000000000017E+000,
      9.7960000000000029E+000,
      9.7970000000000024E+000,
      9.7980000000000018E+000,
      9.7990000000000030E+000,
      9.8000000000000025E+000,
      9.8010000000000019E+000,
      9.8020000000000032E+000,
      9.8030000000000026E+000,
      9.8040000000000020E+000,
      9.8050000000000033E+000,
      9.8060000000000009E+000,
      9.8070000000000022E+000,
      9.8080000000000034E+000,
      9.8090000000000011E+000,
      9.8100000000000023E+000,
      9.8110000000000035E+000,
      9.8120000000000012E+000,
      9.8130000000000024E+000,
      9.8140000000000018E+000,
      9.8150000000000013E+000,
      9.8160000000000025E+000,
      9.8170000000000019E+000,
      9.8180000000000014E+000,
      9.8190000000000026E+000,
      9.8200000000000021E+000,
      9.8210000000000015E+000,
      9.8220000000000027E+000,
      9.8230000000000022E+000,
      9.8240000000000016E+000,
      9.8250000000000028E+000,
      9.8260000000000023E+000,
      9.8270000000000017E+000,
      9.8280000000000030E+000,
      9.8290000000000024E+000,
      9.8300000000000018E+000,
      9.8310000000000031E+000,
      9.8320000000000025E+000,
      9.8330000000000020E+000,
      9.8340000000000032E+000,
      9.8350000000000026E+000,
      9.8360000000000021E+000,
      9.8370000000000033E+000,
      9.8380000000000010E+000,
      9.8390000000000022E+000,
      9.8400000000000034E+000,
      9.8410000000000011E+000,
      9.8420000000000023E+000,
      9.8430000000000035E+000,
      9.8440000000000012E+000,
      9.8450000000000024E+000,
      9.8460000000000019E+000,
      9.8470000000000013E+000,
      9.8480000000000025E+000,
      9.8490000000000020E+000,
      9.8500000000000014E+000,
      9.8510000000000026E+000,
      9.8520000000000021E+000,
      9.8530000000000015E+000,
      9.8540000000000028E+000,
      9.8550000000000022E+000,
      9.8560000000000016E+000,
      9.8570000000000029E+000,
      9.8580000000000023E+000,
      9.8590000000000018E+000,
      9.8600000000000030E+000,
      9.8610000000000024E+000,
      9.8620000000000019E+000,
      9.8630000000000031E+000,
      9.8640000000000025E+000,
      9.8650000000000020E+000,
      9.8660000000000032E+000,
      9.8670000000000027E+000,
      9.8680000000000021E+000,
      9.8690000000000033E+000,
      9.8700000000000010E+000,
      9.8710000000000022E+000,
      9.8720000000000034E+000,
      9.8730000000000011E+000,
      9.8740000000000023E+000,
      9.8750000000000036E+000,
      9.8760000000000012E+000,
      9.8770000000000024E+000,
      9.8780000000000019E+000,
      9.8790000000000013E+000,
      9.8800000000000026E+000,
      9.8810000000000020E+000,
      9.8820000000000014E+000,
      9.8830000000000027E+000,
      9.8840000000000021E+000,
      9.8850000000000016E+000,
      9.8860000000000028E+000,
      9.8870000000000022E+000,
      9.8880000000000017E+000,
      9.8890000000000029E+000,
      9.8900000000000023E+000,
      9.8910000000000018E+000,
      9.8920000000000030E+000,
      9.8930000000000025E+000,
      9.8940000000000019E+000,
      9.8950000000000031E+000,
      9.8960000000000026E+000,
      9.8970000000000020E+000,
      9.8980000000000032E+000,
      9.8990000000000027E+000,
      9.9000000000000021E+000,
      9.9010000000000034E+000,
      9.9020000000000010E+000,
      9.9030000000000022E+000,
      9.9040000000000035E+000,
      9.9050000000000011E+000,
      9.9060000000000024E+000,
      9.9070000000000036E+000,
      9.9080000000000013E+000,
      9.9090000000000025E+000,
      9.9100000000000019E+000,
      9.9110000000000014E+000,
      9.9120000000000026E+000,
      9.9130000000000020E+000,
      9.9140000000000015E+000,
      9.9150000000000027E+000,
      9.9160000000000021E+000,
      9.9170000000000016E+000,
      9.9180000000000028E+000,
      9.9190000000000023E+000,
      9.9200000000000017E+000,
      9.9210000000000029E+000,
      9.9220000000000024E+000,
      9.9230000000000018E+000,
      9.9240000000000030E+000,
      9.9250000000000025E+000,
      9.9260000000000019E+000,
      9.9270000000000032E+000,
      9.9280000000000026E+000,
      9.9290000000000020E+000,
      9.9300000000000033E+000,
      9.9310000000000027E+000,
      9.9320000000000022E+000,
      9.9330000000000034E+000,
      9.9340000000000011E+000,
      9.9350000000000023E+000,
      9.9360000000000035E+000,
      9.9370000000000012E+000,
      9.9380000000000024E+000,
      9.9390000000000018E+000,
      9.9400000000000013E+000,
      9.9410000000000025E+000,
      9.9420000000000019E+000,
      9.9430000000000014E+000,
      9.9440000000000026E+000,
      9.9450000000000021E+000,
      9.9460000000000015E+000,
      9.9470000000000027E+000,
      9.9480000000000022E+000,
      9.9490000000000016E+000,
      9.9500000000000028E+000,
      9.9510000000000023E+000,
      9.9520000000000017E+000,
      9.9530000000000030E+000,
      9.9540000000000024E+000,
      9.9550000000000018E+000,
      9.9560000000000031E+000,
      9.9570000000000025E+000,
      9.9580000000000020E+000,
      9.9590000000000032E+000,
      9.9600000000000026E+000,
      9.9610000000000021E+000,
      9.9620000000000033E+000,
      9.9630000000000010E+000,
      9.9640000000000022E+000,
      9.9650000000000034E+000,
      9.9660000000000011E+000,
      9.9670000000000023E+000,
      9.9680000000000035E+000,
      9.9690000000000012E+000,
      9.9700000000000024E+000,
      9.9710000000000019E+000,
      9.9720000000000013E+000,
      9.9730000000000025E+000,
      9.9740000000000020E+000,
      9.9750000000000014E+000,
      9.9760000000000026E+000,
      9.9770000000000021E+000,
      9.9780000000000015E+000,
      9.9790000000000028E+000,
      9.9800000000000022E+000,
      9.9810000000000016E+000,
      9.9820000000000029E+000,
      9.9830000000000023E+000,
      9.9840000000000018E+000,
      9.9850000000000030E+000,
      9.9860000000000024E+000,
      9.9870000000000019E+000,
      9.9880000000000031E+000,
      9.9890000000000025E+000,
      9.9900000000000020E+000,
      9.9910000000000032E+000,
      9.9920000000000027E+000,
      9.9930000000000021E+000,
      9.9940000000000033E+000,
      9.9950000000000010E+000,
      9.9960000000000022E+000,
      9.9970000000000034E+000,
      9.9980000000000011E+000,
      9.9990000000000023E+000,
      1.0000000000000004E+001,
      1.0001000000000001E+001,
      1.0002000000000002E+001,
      1.0003000000000002E+001,
      1.0004000000000001E+001,
      1.0005000000000003E+001,
      1.0006000000000002E+001,
      1.0007000000000001E+001,
      1.0008000000000003E+001,
      1.0009000000000002E+001,
      1.0010000000000002E+001,
      1.0011000000000003E+001,
      1.0012000000000002E+001,
      1.0013000000000002E+001,
      1.0014000000000003E+001,
      1.0015000000000002E+001,
      1.0016000000000002E+001,
      1.0017000000000003E+001,
      1.0018000000000002E+001,
      1.0019000000000002E+001,
      1.0020000000000003E+001,
      1.0021000000000003E+001,
      1.0022000000000002E+001,
      1.0023000000000003E+001,
      1.0024000000000003E+001,
      1.0025000000000002E+001,
      1.0026000000000003E+001,
      1.0027000000000001E+001,
      1.0028000000000002E+001,
      1.0029000000000003E+001,
      1.0030000000000001E+001,
      1.0031000000000002E+001,
      1.0032000000000004E+001,
      1.0033000000000001E+001,
      1.0034000000000002E+001,
      1.0035000000000002E+001,
      1.0036000000000001E+001,
      1.0037000000000003E+001,
      1.0038000000000002E+001,
      1.0039000000000001E+001,
      1.0040000000000003E+001,
      1.0041000000000002E+001,
      1.0042000000000002E+001,
      1.0043000000000003E+001,
      1.0044000000000002E+001,
      1.0045000000000002E+001,
      1.0046000000000003E+001,
      1.0047000000000002E+001,
      1.0048000000000002E+001,
      1.0049000000000003E+001,
      1.0050000000000002E+001,
      1.0051000000000002E+001,
      1.0052000000000003E+001,
      1.0053000000000003E+001,
      1.0054000000000002E+001,
      1.0055000000000003E+001,
      1.0056000000000003E+001,
      1.0057000000000002E+001,
      1.0058000000000003E+001,
      1.0059000000000001E+001,
      1.0060000000000002E+001,
      1.0061000000000003E+001,
      1.0062000000000001E+001,
      1.0063000000000002E+001,
      1.0064000000000002E+001,
      1.0065000000000001E+001,
      1.0066000000000003E+001,
      1.0067000000000002E+001,
      1.0068000000000001E+001,
      1.0069000000000003E+001,
      1.0070000000000002E+001,
      1.0071000000000002E+001,
      1.0072000000000003E+001,
      1.0073000000000002E+001,
      1.0074000000000002E+001,
      1.0075000000000003E+001,
      1.0076000000000002E+001,
      1.0077000000000002E+001,
      1.0078000000000003E+001,
      1.0079000000000002E+001,
      1.0080000000000002E+001,
      1.0081000000000003E+001,
      1.0082000000000003E+001,
      1.0083000000000002E+001,
      1.0084000000000003E+001,
      1.0085000000000003E+001,
      1.0086000000000002E+001,
      1.0087000000000003E+001,
      1.0088000000000001E+001,
      1.0089000000000002E+001,
      1.0090000000000003E+001,
      1.0091000000000001E+001,
      1.0092000000000002E+001,
      1.0093000000000004E+001,
      1.0094000000000001E+001,
      1.0095000000000002E+001,
      1.0096000000000002E+001,
      1.0097000000000001E+001,
      1.0098000000000003E+001,
      1.0099000000000002E+001,
      1.0100000000000001E+001,
      1.0101000000000003E+001,
      1.0102000000000002E+001,
      1.0103000000000002E+001,
      1.0104000000000003E+001,
      1.0105000000000002E+001,
      1.0106000000000002E+001,
      1.0107000000000003E+001,
      1.0108000000000002E+001,
      1.0109000000000002E+001,
      1.0110000000000003E+001,
      1.0111000000000002E+001,
      1.0112000000000002E+001,
      1.0113000000000003E+001,
      1.0114000000000003E+001,
      1.0115000000000002E+001,
      1.0116000000000003E+001,
      1.0117000000000003E+001,
      1.0118000000000002E+001,
      1.0119000000000003E+001,
      1.0120000000000001E+001,
      1.0121000000000002E+001,
      1.0122000000000003E+001,
      1.0123000000000001E+001,
      1.0124000000000002E+001,
      1.0125000000000004E+001,
      1.0126000000000001E+001,
      1.0127000000000002E+001,
      1.0128000000000002E+001,
      1.0129000000000001E+001,
      1.0130000000000003E+001,
      1.0131000000000002E+001,
      1.0132000000000001E+001,
      1.0133000000000003E+001,
      1.0134000000000002E+001,
      1.0135000000000002E+001,
      1.0136000000000003E+001,
      1.0137000000000002E+001,
      1.0138000000000002E+001,
      1.0139000000000003E+001,
      1.0140000000000002E+001,
      1.0141000000000002E+001,
      1.0142000000000003E+001,
      1.0143000000000002E+001,
      1.0144000000000002E+001,
      1.0145000000000003E+001,
      1.0146000000000003E+001,
      1.0147000000000002E+001,
      1.0148000000000003E+001,
      1.0149000000000003E+001,
      1.0150000000000002E+001,
      1.0151000000000003E+001,
      1.0152000000000001E+001,
      1.0153000000000002E+001,
      1.0154000000000003E+001,
      1.0155000000000001E+001,
      1.0156000000000002E+001,
      1.0157000000000004E+001,
      1.0158000000000001E+001,
      1.0159000000000002E+001,
      1.0160000000000002E+001,
      1.0161000000000001E+001,
      1.0162000000000003E+001,
      1.0163000000000002E+001,
      1.0164000000000001E+001,
      1.0165000000000003E+001,
      1.0166000000000002E+001,
      1.0167000000000002E+001,
      1.0168000000000003E+001,
      1.0169000000000002E+001,
      1.0170000000000002E+001,
      1.0171000000000003E+001,
      1.0172000000000002E+001,
      1.0173000000000002E+001,
      1.0174000000000003E+001,
      1.0175000000000002E+001,
      1.0176000000000002E+001,
      1.0177000000000003E+001,
      1.0178000000000003E+001,
      1.0179000000000002E+001,
      1.0180000000000003E+001,
      1.0181000000000003E+001,
      1.0182000000000002E+001,
      1.0183000000000003E+001,
      1.0184000000000001E+001,
      1.0185000000000002E+001,
      1.0186000000000003E+001,
      1.0187000000000001E+001,
      1.0188000000000002E+001,
      1.0189000000000002E+001,
      1.0190000000000001E+001,
      1.0191000000000003E+001,
      1.0192000000000002E+001,
      1.0193000000000001E+001,
      1.0194000000000003E+001,
      1.0195000000000002E+001,
      1.0196000000000002E+001,
      1.0197000000000003E+001,
      1.0198000000000002E+001,
      1.0199000000000002E+001,
      1.0200000000000003E+001,
      1.0201000000000002E+001,
      1.0202000000000002E+001,
      1.0203000000000003E+001,
      1.0204000000000002E+001,
      1.0205000000000002E+001,
      1.0206000000000003E+001,
      1.0207000000000003E+001,
      1.0208000000000002E+001,
      1.0209000000000003E+001,
      1.0210000000000003E+001,
      1.0211000000000002E+001,
      1.0212000000000003E+001,
      1.0213000000000001E+001,
      1.0214000000000002E+001,
      1.0215000000000003E+001,
      1.0216000000000001E+001,
      1.0217000000000002E+001,
      1.0218000000000004E+001,
      1.0219000000000001E+001,
      1.0220000000000002E+001,
      1.0221000000000002E+001,
      1.0222000000000001E+001,
      1.0223000000000003E+001,
      1.0224000000000002E+001,
      1.0225000000000001E+001,
      1.0226000000000003E+001,
      1.0227000000000002E+001,
      1.0228000000000002E+001,
      1.0229000000000003E+001,
      1.0230000000000002E+001,
      1.0231000000000002E+001,
      1.0232000000000003E+001,
      1.0233000000000002E+001,
      1.0234000000000002E+001,
      1.0235000000000003E+001,
      1.0236000000000002E+001,
      1.0237000000000002E+001,
      1.0238000000000003E+001,
      1.0239000000000003E+001,
      1.0240000000000002E+001,
      1.0241000000000003E+001,
      1.0242000000000003E+001,
      1.0243000000000002E+001,
      1.0244000000000003E+001,
      1.0245000000000001E+001,
      1.0246000000000002E+001,
      1.0247000000000003E+001,
      1.0248000000000001E+001,
      1.0249000000000002E+001,
      1.0250000000000004E+001,
      1.0251000000000001E+001,
      1.0252000000000002E+001,
      1.0253000000000002E+001,
      1.0254000000000001E+001,
      1.0255000000000003E+001,
      1.0256000000000002E+001,
      1.0257000000000001E+001,
      1.0258000000000003E+001,
      1.0259000000000002E+001,
      1.0260000000000002E+001,
      1.0261000000000003E+001,
      1.0262000000000002E+001,
      1.0263000000000002E+001,
      1.0264000000000003E+001,
      1.0265000000000002E+001,
      1.0266000000000002E+001,
      1.0267000000000003E+001,
      1.0268000000000002E+001,
      1.0269000000000002E+001,
      1.0270000000000003E+001,
      1.0271000000000003E+001,
      1.0272000000000002E+001,
      1.0273000000000003E+001,
      1.0274000000000003E+001,
      1.0275000000000002E+001,
      1.0276000000000003E+001,
      1.0277000000000001E+001,
      1.0278000000000002E+001,
      1.0279000000000003E+001,
      1.0280000000000001E+001,
      1.0281000000000002E+001,
      1.0282000000000004E+001,
      1.0283000000000001E+001,
      1.0284000000000002E+001,
      1.0285000000000002E+001,
      1.0286000000000001E+001,
      1.0287000000000003E+001,
      1.0288000000000002E+001,
      1.0289000000000001E+001,
      1.0290000000000003E+001,
      1.0291000000000002E+001,
      1.0292000000000002E+001,
      1.0293000000000003E+001,
      1.0294000000000002E+001,
      1.0295000000000002E+001,
      1.0296000000000003E+001,
      1.0297000000000002E+001,
      1.0298000000000002E+001,
      1.0299000000000003E+001,
      1.0300000000000002E+001,
      1.0301000000000002E+001,
      1.0302000000000003E+001,
      1.0303000000000003E+001,
      1.0304000000000002E+001,
      1.0305000000000003E+001,
      1.0306000000000003E+001,
      1.0307000000000002E+001,
      1.0308000000000003E+001,
      1.0309000000000001E+001,
      1.0310000000000002E+001,
      1.0311000000000003E+001,
      1.0312000000000001E+001,
      1.0313000000000002E+001,
      1.0314000000000004E+001,
      1.0315000000000001E+001,
      1.0316000000000003E+001,
      1.0317000000000002E+001,
      1.0318000000000001E+001,
      1.0319000000000003E+001,
      1.0320000000000002E+001,
      1.0321000000000002E+001,
      1.0322000000000003E+001,
      1.0323000000000002E+001,
      1.0324000000000002E+001,
      1.0325000000000003E+001,
      1.0326000000000002E+001,
      1.0327000000000002E+001,
      1.0328000000000003E+001,
      1.0329000000000002E+001,
      1.0330000000000002E+001,
      1.0331000000000003E+001,
      1.0332000000000003E+001,
      1.0333000000000002E+001,
      1.0334000000000003E+001,
      1.0335000000000003E+001,
      1.0336000000000002E+001,
      1.0337000000000003E+001,
      1.0338000000000001E+001,
      1.0339000000000002E+001,
      1.0340000000000003E+001,
      1.0341000000000001E+001,
      1.0342000000000002E+001,
      1.0343000000000004E+001,
      1.0344000000000001E+001,
      1.0345000000000002E+001,
      1.0346000000000002E+001,
      1.0347000000000001E+001,
      1.0348000000000003E+001,
      1.0349000000000002E+001,
      1.0350000000000001E+001,
      1.0351000000000003E+001,
      1.0352000000000002E+001,
      1.0353000000000002E+001,
      1.0354000000000003E+001,
      1.0355000000000002E+001,
      1.0356000000000002E+001,
      1.0357000000000003E+001,
      1.0358000000000002E+001,
      1.0359000000000002E+001,
      1.0360000000000003E+001,
      1.0361000000000002E+001,
      1.0362000000000002E+001,
      1.0363000000000003E+001,
      1.0364000000000003E+001,
      1.0365000000000002E+001,
      1.0366000000000003E+001,
      1.0367000000000003E+001,
      1.0368000000000002E+001,
      1.0369000000000003E+001,
      1.0370000000000001E+001,
      1.0371000000000002E+001,
      1.0372000000000003E+001,
      1.0373000000000001E+001,
      1.0374000000000002E+001,
      1.0375000000000004E+001,
      1.0376000000000001E+001,
      1.0377000000000002E+001,
      1.0378000000000002E+001,
      1.0379000000000001E+001,
      1.0380000000000003E+001,
      1.0381000000000002E+001,
      1.0382000000000001E+001,
      1.0383000000000003E+001,
      1.0384000000000002E+001,
      1.0385000000000002E+001,
      1.0386000000000003E+001,
      1.0387000000000002E+001,
      1.0388000000000002E+001,
      1.0389000000000003E+001,
      1.0390000000000002E+001,
      1.0391000000000002E+001,
      1.0392000000000003E+001,
      1.0393000000000002E+001,
      1.0394000000000002E+001,
      1.0395000000000003E+001,
      1.0396000000000003E+001,
      1.0397000000000002E+001,
      1.0398000000000003E+001,
      1.0399000000000003E+001,
      1.0400000000000002E+001,
      1.0401000000000003E+001,
      1.0402000000000001E+001,
      1.0403000000000002E+001,
      1.0404000000000003E+001,
      1.0405000000000001E+001,
      1.0406000000000002E+001,
      1.0407000000000004E+001,
      1.0408000000000001E+001,
      1.0409000000000002E+001,
      1.0410000000000002E+001,
      1.0411000000000001E+001,
      1.0412000000000003E+001,
      1.0413000000000002E+001,
      1.0414000000000001E+001,
      1.0415000000000003E+001,
      1.0416000000000002E+001,
      1.0417000000000002E+001,
      1.0418000000000003E+001,
      1.0419000000000002E+001,
      1.0420000000000002E+001,
      1.0421000000000003E+001,
      1.0422000000000002E+001,
      1.0423000000000002E+001,
      1.0424000000000003E+001,
      1.0425000000000002E+001,
      1.0426000000000002E+001,
      1.0427000000000003E+001,
      1.0428000000000003E+001,
      1.0429000000000002E+001,
      1.0430000000000003E+001,
      1.0431000000000003E+001,
      1.0432000000000002E+001,
      1.0433000000000003E+001,
      1.0434000000000001E+001,
      1.0435000000000002E+001,
      1.0436000000000003E+001,
      1.0437000000000001E+001,
      1.0438000000000002E+001,
      1.0439000000000004E+001,
      1.0440000000000001E+001,
      1.0441000000000003E+001,
      1.0442000000000002E+001,
      1.0443000000000001E+001,
      1.0444000000000003E+001,
      1.0445000000000002E+001,
      1.0446000000000002E+001,
      1.0447000000000003E+001,
      1.0448000000000002E+001,
      1.0449000000000002E+001,
      1.0450000000000003E+001,
      1.0451000000000002E+001,
      1.0452000000000002E+001,
      1.0453000000000003E+001,
      1.0454000000000002E+001,
      1.0455000000000002E+001,
      1.0456000000000003E+001,
      1.0457000000000003E+001,
      1.0458000000000002E+001,
      1.0459000000000003E+001,
      1.0460000000000003E+001,
      1.0461000000000002E+001,
      1.0462000000000003E+001,
      1.0463000000000001E+001,
      1.0464000000000002E+001,
      1.0465000000000003E+001,
      1.0466000000000001E+001,
      1.0467000000000002E+001,
      1.0468000000000004E+001,
      1.0469000000000001E+001,
      1.0470000000000002E+001,
      1.0471000000000002E+001,
      1.0472000000000001E+001,
      1.0473000000000003E+001,
      1.0474000000000002E+001,
      1.0475000000000001E+001,
      1.0476000000000003E+001,
      1.0477000000000002E+001,
      1.0478000000000002E+001,
      1.0479000000000003E+001,
      1.0480000000000002E+001,
      1.0481000000000002E+001,
      1.0482000000000003E+001,
      1.0483000000000002E+001,
      1.0484000000000002E+001,
      1.0485000000000003E+001,
      1.0486000000000002E+001,
      1.0487000000000002E+001,
      1.0488000000000003E+001,
      1.0489000000000003E+001,
      1.0490000000000002E+001,
      1.0491000000000003E+001,
      1.0492000000000003E+001,
      1.0493000000000002E+001,
      1.0494000000000003E+001,
      1.0495000000000001E+001,
      1.0496000000000002E+001,
      1.0497000000000003E+001,
      1.0498000000000001E+001,
      1.0499000000000002E+001,
      1.0500000000000004E+001,
      1.0501000000000001E+001,
      1.0502000000000002E+001,
      1.0503000000000002E+001,
      1.0504000000000001E+001,
      1.0505000000000003E+001,
      1.0506000000000002E+001,
      1.0507000000000001E+001,
      1.0508000000000003E+001,
      1.0509000000000002E+001,
      1.0510000000000002E+001,
      1.0511000000000003E+001,
      1.0512000000000002E+001,
      1.0513000000000002E+001,
      1.0514000000000003E+001,
      1.0515000000000002E+001,
      1.0516000000000002E+001,
      1.0517000000000003E+001,
      1.0518000000000002E+001,
      1.0519000000000002E+001,
      1.0520000000000003E+001,
      1.0521000000000003E+001,
      1.0522000000000002E+001,
      1.0523000000000003E+001,
      1.0524000000000003E+001,
      1.0525000000000002E+001,
      1.0526000000000003E+001,
      1.0527000000000001E+001,
      1.0528000000000002E+001,
      1.0529000000000003E+001,
      1.0530000000000001E+001,
      1.0531000000000002E+001,
      1.0532000000000004E+001,
      1.0533000000000001E+001,
      1.0534000000000002E+001,
      1.0535000000000002E+001,
      1.0536000000000001E+001,
      1.0537000000000003E+001,
      1.0538000000000002E+001,
      1.0539000000000001E+001,
      1.0540000000000003E+001,
      1.0541000000000002E+001,
      1.0542000000000002E+001,
      1.0543000000000003E+001,
      1.0544000000000002E+001,
      1.0545000000000002E+001,
      1.0546000000000003E+001,
      1.0547000000000002E+001,
      1.0548000000000002E+001,
      1.0549000000000003E+001,
      1.0550000000000002E+001,
      1.0551000000000002E+001,
      1.0552000000000003E+001,
      1.0553000000000003E+001,
      1.0554000000000002E+001,
      1.0555000000000003E+001,
      1.0556000000000003E+001,
      1.0557000000000002E+001,
      1.0558000000000003E+001,
      1.0559000000000001E+001,
      1.0560000000000002E+001,
      1.0561000000000003E+001,
      1.0562000000000001E+001,
      1.0563000000000002E+001,
      1.0564000000000004E+001,
      1.0565000000000001E+001,
      1.0566000000000003E+001,
      1.0567000000000002E+001,
      1.0568000000000001E+001,
      1.0569000000000003E+001,
      1.0570000000000002E+001,
      1.0571000000000002E+001,
      1.0572000000000003E+001,
      1.0573000000000002E+001,
      1.0574000000000002E+001,
      1.0575000000000003E+001,
      1.0576000000000002E+001,
      1.0577000000000002E+001,
      1.0578000000000003E+001,
      1.0579000000000002E+001,
      1.0580000000000002E+001,
      1.0581000000000003E+001,
      1.0582000000000003E+001,
      1.0583000000000002E+001,
      1.0584000000000003E+001,
      1.0585000000000003E+001,
      1.0586000000000002E+001,
      1.0587000000000003E+001,
      1.0588000000000001E+001,
      1.0589000000000002E+001,
      1.0590000000000003E+001,
      1.0591000000000001E+001,
      1.0592000000000002E+001,
      1.0593000000000004E+001,
      1.0594000000000001E+001,
      1.0595000000000002E+001,
      1.0596000000000002E+001,
      1.0597000000000001E+001,
      1.0598000000000003E+001,
      1.0599000000000002E+001,
      1.0600000000000001E+001,
      1.0601000000000003E+001,
      1.0602000000000002E+001,
      1.0603000000000002E+001,
      1.0604000000000003E+001,
      1.0605000000000002E+001,
      1.0606000000000002E+001,
      1.0607000000000003E+001,
      1.0608000000000002E+001,
      1.0609000000000002E+001,
      1.0610000000000003E+001,
      1.0611000000000002E+001,
      1.0612000000000002E+001,
      1.0613000000000003E+001,
      1.0614000000000003E+001,
      1.0615000000000002E+001,
      1.0616000000000003E+001,
      1.0617000000000003E+001,
      1.0618000000000002E+001,
      1.0619000000000003E+001,
      1.0620000000000001E+001,
      1.0621000000000002E+001,
      1.0622000000000003E+001,
      1.0623000000000001E+001,
      1.0624000000000002E+001,
      1.0625000000000004E+001,
      1.0626000000000001E+001,
      1.0627000000000002E+001,
      1.0628000000000002E+001,
      1.0629000000000001E+001,
      1.0630000000000003E+001,
      1.0631000000000002E+001,
      1.0632000000000001E+001,
      1.0633000000000003E+001,
      1.0634000000000002E+001,
      1.0635000000000002E+001,
      1.0636000000000003E+001,
      1.0637000000000002E+001,
      1.0638000000000002E+001,
      1.0639000000000003E+001,
      1.0640000000000002E+001,
      1.0641000000000002E+001,
      1.0642000000000003E+001,
      1.0643000000000002E+001,
      1.0644000000000002E+001,
      1.0645000000000003E+001,
      1.0646000000000003E+001,
      1.0647000000000002E+001,
      1.0648000000000003E+001,
      1.0649000000000003E+001,
      1.0650000000000002E+001,
      1.0651000000000003E+001,
      1.0652000000000001E+001,
      1.0653000000000002E+001,
      1.0654000000000003E+001,
      1.0655000000000001E+001,
      1.0656000000000002E+001,
      1.0657000000000004E+001,
      1.0658000000000001E+001,
      1.0659000000000002E+001,
      1.0660000000000002E+001,
      1.0661000000000001E+001,
      1.0662000000000003E+001,
      1.0663000000000002E+001,
      1.0664000000000001E+001,
      1.0665000000000003E+001,
      1.0666000000000002E+001,
      1.0667000000000002E+001,
      1.0668000000000003E+001,
      1.0669000000000002E+001,
      1.0670000000000002E+001,
      1.0671000000000003E+001,
      1.0672000000000002E+001,
      1.0673000000000002E+001,
      1.0674000000000003E+001,
      1.0675000000000002E+001,
      1.0676000000000002E+001,
      1.0677000000000003E+001,
      1.0678000000000003E+001,
      1.0679000000000002E+001,
      1.0680000000000003E+001,
      1.0681000000000003E+001,
      1.0682000000000002E+001,
      1.0683000000000003E+001,
      1.0684000000000001E+001,
      1.0685000000000002E+001,
      1.0686000000000003E+001,
      1.0687000000000001E+001,
      1.0688000000000002E+001,
      1.0689000000000004E+001,
      1.0690000000000001E+001,
      1.0691000000000003E+001,
      1.0692000000000002E+001,
      1.0693000000000001E+001,
      1.0694000000000003E+001,
      1.0695000000000002E+001,
      1.0696000000000002E+001,
      1.0697000000000003E+001,
      1.0698000000000002E+001,
      1.0699000000000002E+001,
      1.0700000000000003E+001,
      1.0701000000000002E+001,
      1.0702000000000002E+001,
      1.0703000000000003E+001,
      1.0704000000000002E+001,
      1.0705000000000002E+001,
      1.0706000000000003E+001,
      1.0707000000000003E+001,
      1.0708000000000002E+001,
      1.0709000000000003E+001,
      1.0710000000000003E+001,
      1.0711000000000002E+001,
      1.0712000000000003E+001,
      1.0713000000000001E+001,
      1.0714000000000002E+001,
      1.0715000000000003E+001,
      1.0716000000000001E+001,
      1.0717000000000002E+001,
      1.0718000000000004E+001,
      1.0719000000000001E+001,
      1.0720000000000002E+001,
      1.0721000000000002E+001,
      1.0722000000000001E+001,
      1.0723000000000003E+001,
      1.0724000000000002E+001,
      1.0725000000000001E+001,
      1.0726000000000003E+001,
      1.0727000000000002E+001,
      1.0728000000000002E+001,
      1.0729000000000003E+001,
      1.0730000000000002E+001,
      1.0731000000000002E+001,
      1.0732000000000003E+001,
      1.0733000000000002E+001,
      1.0734000000000002E+001,
      1.0735000000000003E+001,
      1.0736000000000002E+001,
      1.0737000000000002E+001,
      1.0738000000000003E+001,
      1.0739000000000003E+001,
      1.0740000000000002E+001,
      1.0741000000000003E+001,
      1.0742000000000003E+001,
      1.0743000000000002E+001,
      1.0744000000000003E+001,
      1.0745000000000001E+001,
      1.0746000000000002E+001,
      1.0747000000000003E+001,
      1.0748000000000001E+001,
      1.0749000000000002E+001,
      1.0750000000000004E+001,
      1.0751000000000001E+001,
      1.0752000000000002E+001,
      1.0753000000000002E+001,
      1.0754000000000001E+001,
      1.0755000000000003E+001,
      1.0756000000000002E+001,
      1.0757000000000001E+001,
      1.0758000000000003E+001,
      1.0759000000000002E+001,
      1.0760000000000002E+001,
      1.0761000000000003E+001,
      1.0762000000000002E+001,
      1.0763000000000002E+001,
      1.0764000000000003E+001,
      1.0765000000000002E+001,
      1.0766000000000002E+001,
      1.0767000000000003E+001,
      1.0768000000000002E+001,
      1.0769000000000002E+001,
      1.0770000000000003E+001,
      1.0771000000000003E+001,
      1.0772000000000002E+001,
      1.0773000000000003E+001,
      1.0774000000000003E+001,
      1.0775000000000002E+001,
      1.0776000000000003E+001,
      1.0777000000000001E+001,
      1.0778000000000002E+001,
      1.0779000000000003E+001,
      1.0780000000000001E+001,
      1.0781000000000002E+001,
      1.0782000000000004E+001,
      1.0783000000000001E+001,
      1.0784000000000002E+001,
      1.0785000000000002E+001,
      1.0786000000000001E+001,
      1.0787000000000003E+001,
      1.0788000000000002E+001,
      1.0789000000000001E+001,
      1.0790000000000003E+001,
      1.0791000000000002E+001,
      1.0792000000000002E+001,
      1.0793000000000003E+001,
      1.0794000000000002E+001,
      1.0795000000000002E+001,
      1.0796000000000003E+001,
      1.0797000000000002E+001,
      1.0798000000000002E+001,
      1.0799000000000003E+001,
      1.0800000000000002E+001,
      1.0801000000000002E+001,
      1.0802000000000003E+001,
      1.0803000000000003E+001,
      1.0804000000000002E+001,
      1.0805000000000003E+001,
      1.0806000000000003E+001,
      1.0807000000000002E+001,
      1.0808000000000003E+001,
      1.0809000000000001E+001,
      1.0810000000000002E+001,
      1.0811000000000003E+001,
      1.0812000000000001E+001,
      1.0813000000000002E+001,
      1.0814000000000004E+001,
      1.0815000000000001E+001,
      1.0816000000000003E+001,
      1.0817000000000002E+001,
      1.0818000000000001E+001,
      1.0819000000000003E+001,
      1.0820000000000002E+001,
      1.0821000000000002E+001,
      1.0822000000000003E+001,
      1.0823000000000002E+001,
      1.0824000000000002E+001,
      1.0825000000000003E+001,
      1.0826000000000002E+001,
      1.0827000000000002E+001,
      1.0828000000000003E+001,
      1.0829000000000002E+001,
      1.0830000000000002E+001,
      1.0831000000000003E+001,
      1.0832000000000003E+001,
      1.0833000000000002E+001,
      1.0834000000000003E+001,
      1.0835000000000003E+001,
      1.0836000000000002E+001,
      1.0837000000000003E+001,
      1.0838000000000001E+001,
      1.0839000000000002E+001,
      1.0840000000000003E+001,
      1.0841000000000001E+001,
      1.0842000000000002E+001,
      1.0843000000000004E+001,
      1.0844000000000001E+001,
      1.0845000000000002E+001,
      1.0846000000000002E+001,
      1.0847000000000001E+001,
      1.0848000000000003E+001,
      1.0849000000000002E+001,
      1.0850000000000001E+001,
      1.0851000000000003E+001,
      1.0852000000000002E+001,
      1.0853000000000002E+001,
      1.0854000000000003E+001,
      1.0855000000000002E+001,
      1.0856000000000002E+001,
      1.0857000000000003E+001,
      1.0858000000000002E+001,
      1.0859000000000002E+001,
      1.0860000000000003E+001,
      1.0861000000000002E+001,
      1.0862000000000002E+001,
      1.0863000000000003E+001,
      1.0864000000000003E+001,
      1.0865000000000002E+001,
      1.0866000000000003E+001,
      1.0867000000000003E+001,
      1.0868000000000002E+001,
      1.0869000000000003E+001,
      1.0870000000000001E+001,
      1.0871000000000002E+001,
      1.0872000000000003E+001,
      1.0873000000000001E+001,
      1.0874000000000002E+001,
      1.0875000000000004E+001,
      1.0876000000000001E+001,
      1.0877000000000002E+001,
      1.0878000000000002E+001,
      1.0879000000000001E+001,
      1.0880000000000003E+001,
      1.0881000000000002E+001,
      1.0882000000000001E+001,
      1.0883000000000003E+001,
      1.0884000000000002E+001,
      1.0885000000000002E+001,
      1.0886000000000003E+001,
      1.0887000000000002E+001,
      1.0888000000000002E+001,
      1.0889000000000003E+001,
      1.0890000000000002E+001,
      1.0891000000000002E+001,
      1.0892000000000003E+001,
      1.0893000000000002E+001,
      1.0894000000000002E+001,
      1.0895000000000003E+001,
      1.0896000000000003E+001,
      1.0897000000000002E+001,
      1.0898000000000003E+001,
      1.0899000000000003E+001,
      1.0900000000000002E+001,
      1.0901000000000003E+001,
      1.0902000000000001E+001,
      1.0903000000000002E+001,
      1.0904000000000003E+001,
      1.0905000000000001E+001,
      1.0906000000000002E+001,
      1.0907000000000004E+001,
      1.0908000000000001E+001,
      1.0909000000000002E+001,
      1.0910000000000002E+001,
      1.0911000000000001E+001,
      1.0912000000000003E+001,
      1.0913000000000002E+001,
      1.0914000000000001E+001,
      1.0915000000000003E+001,
      1.0916000000000002E+001,
      1.0917000000000002E+001,
      1.0918000000000003E+001,
      1.0919000000000002E+001,
      1.0920000000000002E+001,
      1.0921000000000003E+001,
      1.0922000000000002E+001,
      1.0923000000000002E+001,
      1.0924000000000003E+001,
      1.0925000000000002E+001,
      1.0926000000000002E+001,
      1.0927000000000003E+001,
      1.0928000000000003E+001,
      1.0929000000000002E+001,
      1.0930000000000003E+001,
      1.0931000000000003E+001,
      1.0932000000000002E+001,
      1.0933000000000003E+001,
      1.0934000000000001E+001,
      1.0935000000000002E+001,
      1.0936000000000003E+001,
      1.0937000000000001E+001,
      1.0938000000000002E+001,
      1.0939000000000004E+001,
      1.0940000000000001E+001,
      1.0941000000000003E+001,
      1.0942000000000002E+001,
      1.0943000000000001E+001,
      1.0944000000000003E+001,
      1.0945000000000002E+001,
      1.0946000000000002E+001,
      1.0947000000000003E+001,
      1.0948000000000002E+001,
      1.0949000000000002E+001,
      1.0950000000000003E+001,
      1.0951000000000002E+001,
      1.0952000000000002E+001,
      1.0953000000000003E+001,
      1.0954000000000002E+001,
      1.0955000000000002E+001,
      1.0956000000000003E+001,
      1.0957000000000003E+001,
      1.0958000000000002E+001,
      1.0959000000000003E+001,
      1.0960000000000003E+001,
      1.0961000000000002E+001,
      1.0962000000000003E+001,
      1.0963000000000001E+001,
      1.0964000000000002E+001,
      1.0965000000000003E+001,
      1.0966000000000001E+001,
      1.0967000000000002E+001,
      1.0968000000000004E+001,
      1.0969000000000001E+001,
      1.0970000000000002E+001,
      1.0971000000000002E+001,
      1.0972000000000001E+001,
      1.0973000000000003E+001,
      1.0974000000000002E+001,
      1.0975000000000001E+001,
      1.0976000000000003E+001,
      1.0977000000000002E+001,
      1.0978000000000002E+001,
      1.0979000000000003E+001,
      1.0980000000000002E+001,
      1.0981000000000002E+001,
      1.0982000000000003E+001,
      1.0983000000000002E+001,
      1.0984000000000002E+001,
      1.0985000000000003E+001,
      1.0986000000000002E+001,
      1.0987000000000002E+001,
      1.0988000000000003E+001,
      1.0989000000000003E+001,
      1.0990000000000002E+001,
      1.0991000000000003E+001,
      1.0992000000000003E+001,
      1.0993000000000002E+001,
      1.0994000000000003E+001,
      1.0995000000000001E+001,
      1.0996000000000002E+001,
      1.0997000000000003E+001,
      1.0998000000000001E+001,
      1.0999000000000002E+001,
      1.1000000000000004E+001,
      1.1001000000000001E+001,
      1.1002000000000002E+001,
      1.1003000000000002E+001,
      1.1004000000000001E+001,
      1.1005000000000003E+001,
      1.1006000000000002E+001,
      1.1007000000000001E+001,
      1.1008000000000003E+001,
      1.1009000000000002E+001,
      1.1010000000000002E+001,
      1.1011000000000003E+001,
      1.1012000000000002E+001,
      1.1013000000000002E+001,
      1.1014000000000003E+001,
      1.1015000000000002E+001,
      1.1016000000000002E+001,
      1.1017000000000003E+001,
      1.1018000000000002E+001,
      1.1019000000000002E+001,
      1.1020000000000003E+001,
      1.1021000000000003E+001,
      1.1022000000000002E+001,
      1.1023000000000003E+001,
      1.1024000000000003E+001,
      1.1025000000000002E+001,
      1.1026000000000003E+001,
      1.1027000000000001E+001,
      1.1028000000000002E+001,
      1.1029000000000003E+001,
      1.1030000000000001E+001,
      1.1031000000000002E+001,
      1.1032000000000004E+001,
      1.1033000000000001E+001,
      1.1034000000000002E+001,
      1.1035000000000002E+001,
      1.1036000000000001E+001,
      1.1037000000000003E+001,
      1.1038000000000002E+001,
      1.1039000000000001E+001,
      1.1040000000000003E+001,
      1.1041000000000002E+001,
      1.1042000000000002E+001,
      1.1043000000000003E+001,
      1.1044000000000002E+001,
      1.1045000000000002E+001,
      1.1046000000000003E+001,
      1.1047000000000002E+001,
      1.1048000000000002E+001,
      1.1049000000000003E+001,
      1.1050000000000002E+001,
      1.1051000000000002E+001,
      1.1052000000000003E+001,
      1.1053000000000003E+001,
      1.1054000000000002E+001,
      1.1055000000000003E+001,
      1.1056000000000003E+001,
      1.1057000000000002E+001,
      1.1058000000000003E+001,
      1.1059000000000001E+001,
      1.1060000000000002E+001,
      1.1061000000000003E+001,
      1.1062000000000001E+001,
      1.1063000000000002E+001,
      1.1064000000000004E+001,
      1.1065000000000001E+001,
      1.1066000000000003E+001,
      1.1067000000000002E+001,
      1.1068000000000001E+001,
      1.1069000000000003E+001,
      1.1070000000000002E+001,
      1.1071000000000002E+001,
      1.1072000000000003E+001,
      1.1073000000000002E+001,
      1.1074000000000002E+001,
      1.1075000000000003E+001,
      1.1076000000000002E+001,
      1.1077000000000002E+001,
      1.1078000000000003E+001,
      1.1079000000000002E+001,
      1.1080000000000002E+001,
      1.1081000000000003E+001,
      1.1082000000000003E+001,
      1.1083000000000002E+001,
      1.1084000000000003E+001,
      1.1085000000000003E+001,
      1.1086000000000002E+001,
      1.1087000000000003E+001,
      1.1088000000000001E+001,
      1.1089000000000002E+001,
      1.1090000000000003E+001,
      1.1091000000000001E+001,
      1.1092000000000002E+001,
      1.1093000000000004E+001,
      1.1094000000000001E+001,
      1.1095000000000002E+001,
      1.1096000000000002E+001,
      1.1097000000000001E+001,
      1.1098000000000003E+001,
      1.1099000000000002E+001,
      1.1100000000000001E+001,
      1.1101000000000003E+001,
      1.1102000000000002E+001,
      1.1103000000000002E+001,
      1.1104000000000003E+001,
      1.1105000000000002E+001,
      1.1106000000000002E+001,
      1.1107000000000003E+001,
      1.1108000000000002E+001,
      1.1109000000000002E+001,
      1.1110000000000003E+001,
      1.1111000000000002E+001,
      1.1112000000000002E+001,
      1.1113000000000003E+001,
      1.1114000000000003E+001,
      1.1115000000000002E+001,
      1.1116000000000003E+001,
      1.1117000000000003E+001,
      1.1118000000000002E+001,
      1.1119000000000003E+001,
      1.1120000000000001E+001,
      1.1121000000000002E+001,
      1.1122000000000003E+001,
      1.1123000000000001E+001,
      1.1124000000000002E+001,
      1.1125000000000004E+001,
      1.1126000000000001E+001,
      1.1127000000000002E+001,
      1.1128000000000002E+001,
      1.1129000000000001E+001,
      1.1130000000000003E+001,
      1.1131000000000002E+001,
      1.1132000000000001E+001,
      1.1133000000000003E+001,
      1.1134000000000002E+001,
      1.1135000000000002E+001,
      1.1136000000000003E+001,
      1.1137000000000002E+001,
      1.1138000000000002E+001,
      1.1139000000000003E+001,
      1.1140000000000002E+001,
      1.1141000000000002E+001,
      1.1142000000000003E+001,
      1.1143000000000002E+001,
      1.1144000000000002E+001,
      1.1145000000000003E+001,
      1.1146000000000003E+001,
      1.1147000000000002E+001,
      1.1148000000000003E+001,
      1.1149000000000003E+001,
      1.1150000000000002E+001,
      1.1151000000000003E+001,
      1.1152000000000001E+001,
      1.1153000000000002E+001,
      1.1154000000000003E+001,
      1.1155000000000001E+001,
      1.1156000000000002E+001,
      1.1157000000000004E+001,
      1.1158000000000001E+001,
      1.1159000000000002E+001,
      1.1160000000000002E+001,
      1.1161000000000001E+001,
      1.1162000000000003E+001,
      1.1163000000000002E+001,
      1.1164000000000001E+001,
      1.1165000000000003E+001,
      1.1166000000000002E+001,
      1.1167000000000002E+001,
      1.1168000000000003E+001,
      1.1169000000000002E+001,
      1.1170000000000002E+001,
      1.1171000000000003E+001,
      1.1172000000000002E+001,
      1.1173000000000002E+001,
      1.1174000000000003E+001,
      1.1175000000000002E+001,
      1.1176000000000002E+001,
      1.1177000000000003E+001,
      1.1178000000000003E+001,
      1.1179000000000002E+001,
      1.1180000000000003E+001,
      1.1181000000000003E+001,
      1.1182000000000002E+001,
      1.1183000000000003E+001,
      1.1184000000000001E+001,
      1.1185000000000002E+001,
      1.1186000000000003E+001,
      1.1187000000000001E+001,
      1.1188000000000002E+001,
      1.1189000000000004E+001,
      1.1190000000000001E+001,
      1.1191000000000003E+001,
      1.1192000000000002E+001,
      1.1193000000000001E+001,
      1.1194000000000003E+001,
      1.1195000000000002E+001,
      1.1196000000000002E+001,
      1.1197000000000003E+001,
      1.1198000000000002E+001,
      1.1199000000000002E+001,
      1.1200000000000003E+001,
      1.1201000000000002E+001,
      1.1202000000000002E+001,
      1.1203000000000003E+001,
      1.1204000000000002E+001,
      1.1205000000000002E+001,
      1.1206000000000003E+001,
      1.1207000000000003E+001,
      1.1208000000000002E+001,
      1.1209000000000003E+001,
      1.1210000000000003E+001,
      1.1211000000000002E+001,
      1.1212000000000003E+001,
      1.1213000000000001E+001,
      1.1214000000000002E+001,
      1.1215000000000003E+001,
      1.1216000000000001E+001,
      1.1217000000000002E+001,
      1.1218000000000004E+001,
      1.1219000000000001E+001,
      1.1220000000000002E+001,
      1.1221000000000002E+001,
      1.1222000000000001E+001,
      1.1223000000000003E+001,
      1.1224000000000002E+001,
      1.1225000000000001E+001,
      1.1226000000000003E+001,
      1.1227000000000002E+001,
      1.1228000000000002E+001,
      1.1229000000000003E+001,
      1.1230000000000002E+001,
      1.1231000000000002E+001,
      1.1232000000000003E+001,
      1.1233000000000002E+001,
      1.1234000000000002E+001,
      1.1235000000000003E+001,
      1.1236000000000002E+001,
      1.1237000000000002E+001,
      1.1238000000000003E+001,
      1.1239000000000003E+001,
      1.1240000000000002E+001,
      1.1241000000000003E+001,
      1.1242000000000003E+001,
      1.1243000000000002E+001,
      1.1244000000000003E+001,
      1.1245000000000001E+001,
      1.1246000000000002E+001,
      1.1247000000000003E+001,
      1.1248000000000001E+001,
      1.1249000000000002E+001,
      1.1250000000000004E+001,
      1.1251000000000001E+001,
      1.1252000000000002E+001,
      1.1253000000000002E+001,
      1.1254000000000001E+001,
      1.1255000000000003E+001,
      1.1256000000000002E+001,
      1.1257000000000001E+001,
      1.1258000000000003E+001,
      1.1259000000000002E+001,
      1.1260000000000002E+001,
      1.1261000000000003E+001,
      1.1262000000000002E+001,
      1.1263000000000002E+001,
      1.1264000000000003E+001,
      1.1265000000000002E+001,
      1.1266000000000002E+001,
      1.1267000000000003E+001,
      1.1268000000000002E+001,
      1.1269000000000002E+001,
      1.1270000000000003E+001,
      1.1271000000000003E+001,
      1.1272000000000002E+001,
      1.1273000000000003E+001,
      1.1274000000000003E+001,
      1.1275000000000002E+001,
      1.1276000000000003E+001,
      1.1277000000000001E+001,
      1.1278000000000002E+001,
      1.1279000000000003E+001,
      1.1280000000000001E+001,
      1.1281000000000002E+001,
      1.1282000000000004E+001,
      1.1283000000000001E+001,
      1.1284000000000002E+001,
      1.1285000000000002E+001,
      1.1286000000000001E+001,
      1.1287000000000003E+001,
      1.1288000000000002E+001,
      1.1289000000000001E+001,
      1.1290000000000003E+001,
      1.1291000000000002E+001,
      1.1292000000000002E+001,
      1.1293000000000003E+001,
      1.1294000000000002E+001,
      1.1295000000000002E+001,
      1.1296000000000003E+001,
      1.1297000000000002E+001,
      1.1298000000000002E+001,
      1.1299000000000003E+001,
      1.1300000000000002E+001,
      1.1301000000000002E+001,
      1.1302000000000003E+001,
      1.1303000000000003E+001,
      1.1304000000000002E+001,
      1.1305000000000003E+001,
      1.1306000000000003E+001,
      1.1307000000000002E+001,
      1.1308000000000003E+001,
      1.1309000000000001E+001,
      1.1310000000000002E+001,
      1.1311000000000003E+001,
      1.1312000000000001E+001,
      1.1313000000000002E+001,
      1.1314000000000004E+001,
      1.1315000000000001E+001,
      1.1316000000000003E+001,
      1.1317000000000002E+001,
      1.1318000000000001E+001,
      1.1319000000000003E+001,
      1.1320000000000002E+001,
      1.1321000000000002E+001,
      1.1322000000000003E+001,
      1.1323000000000002E+001,
      1.1324000000000002E+001,
      1.1325000000000003E+001,
      1.1326000000000002E+001,
      1.1327000000000002E+001,
      1.1328000000000003E+001,
      1.1329000000000002E+001,
      1.1330000000000002E+001,
      1.1331000000000003E+001,
      1.1332000000000003E+001,
      1.1333000000000002E+001,
      1.1334000000000003E+001,
      1.1335000000000003E+001,
      1.1336000000000002E+001,
      1.1337000000000003E+001,
      1.1338000000000003E+001,
      1.1339000000000002E+001,
      1.1340000000000003E+001,
      1.1341000000000001E+001,
      1.1342000000000002E+001,
      1.1343000000000004E+001,
      1.1344000000000001E+001,
      1.1345000000000002E+001,
      1.1346000000000002E+001,
      1.1347000000000001E+001,
      1.1348000000000003E+001,
      1.1349000000000002E+001,
      1.1350000000000001E+001,
      1.1351000000000003E+001,
      1.1352000000000002E+001,
      1.1353000000000002E+001,
      1.1354000000000003E+001,
      1.1355000000000002E+001,
      1.1356000000000002E+001,
      1.1357000000000003E+001,
      1.1358000000000002E+001,
      1.1359000000000002E+001,
      1.1360000000000003E+001,
      1.1361000000000002E+001,
      1.1362000000000002E+001,
      1.1363000000000003E+001,
      1.1364000000000003E+001,
      1.1365000000000002E+001,
      1.1366000000000003E+001,
      1.1367000000000003E+001,
      1.1368000000000002E+001,
      1.1369000000000003E+001,
      1.1370000000000001E+001,
      1.1371000000000002E+001,
      1.1372000000000003E+001,
      1.1373000000000001E+001,
      1.1374000000000002E+001,
      1.1375000000000004E+001,
      1.1376000000000001E+001,
      1.1377000000000002E+001,
      1.1378000000000002E+001,
      1.1379000000000001E+001,
      1.1380000000000003E+001,
      1.1381000000000002E+001,
      1.1382000000000001E+001,
      1.1383000000000003E+001,
      1.1384000000000002E+001,
      1.1385000000000002E+001,
      1.1386000000000003E+001,
      1.1387000000000002E+001,
      1.1388000000000002E+001,
      1.1389000000000003E+001,
      1.1390000000000002E+001,
      1.1391000000000002E+001,
      1.1392000000000003E+001,
      1.1393000000000002E+001,
      1.1394000000000002E+001,
      1.1395000000000003E+001,
      1.1396000000000003E+001,
      1.1397000000000002E+001,
      1.1398000000000003E+001,
      1.1399000000000003E+001,
      1.1400000000000002E+001,
      1.1401000000000003E+001,
      1.1402000000000001E+001,
      1.1403000000000002E+001,
      1.1404000000000003E+001,
      1.1405000000000001E+001,
      1.1406000000000002E+001,
      1.1407000000000004E+001,
      1.1408000000000001E+001,
      1.1409000000000002E+001,
      1.1410000000000002E+001,
      1.1411000000000001E+001,
      1.1412000000000003E+001,
      1.1413000000000002E+001,
      1.1414000000000001E+001,
      1.1415000000000003E+001,
      1.1416000000000002E+001,
      1.1417000000000002E+001,
      1.1418000000000003E+001,
      1.1419000000000002E+001,
      1.1420000000000002E+001,
      1.1421000000000003E+001,
      1.1422000000000002E+001,
      1.1423000000000002E+001,
      1.1424000000000003E+001,
      1.1425000000000002E+001,
      1.1426000000000002E+001,
      1.1427000000000003E+001,
      1.1428000000000003E+001,
      1.1429000000000002E+001,
      1.1430000000000003E+001,
      1.1431000000000003E+001,
      1.1432000000000002E+001,
      1.1433000000000003E+001,
      1.1434000000000001E+001,
      1.1435000000000002E+001,
      1.1436000000000003E+001,
      1.1437000000000001E+001,
      1.1438000000000002E+001,
      1.1439000000000004E+001,
      1.1440000000000001E+001,
      1.1441000000000003E+001,
      1.1442000000000002E+001,
      1.1443000000000001E+001,
      1.1444000000000003E+001,
      1.1445000000000002E+001,
      1.1446000000000002E+001,
      1.1447000000000003E+001,
      1.1448000000000002E+001,
      1.1449000000000002E+001,
      1.1450000000000003E+001,
      1.1451000000000002E+001,
      1.1452000000000002E+001,
      1.1453000000000003E+001,
      1.1454000000000002E+001,
      1.1455000000000002E+001,
      1.1456000000000003E+001,
      1.1457000000000003E+001,
      1.1458000000000002E+001,
      1.1459000000000003E+001,
      1.1460000000000003E+001,
      1.1461000000000002E+001,
      1.1462000000000003E+001,
      1.1463000000000003E+001,
      1.1464000000000002E+001,
      1.1465000000000003E+001,
      1.1466000000000001E+001,
      1.1467000000000002E+001,
      1.1468000000000004E+001,
      1.1469000000000001E+001,
      1.1470000000000002E+001,
      1.1471000000000002E+001,
      1.1472000000000001E+001,
      1.1473000000000003E+001,
      1.1474000000000002E+001,
      1.1475000000000001E+001,
      1.1476000000000003E+001,
      1.1477000000000002E+001,
      1.1478000000000002E+001,
      1.1479000000000003E+001,
      1.1480000000000002E+001,
      1.1481000000000002E+001,
      1.1482000000000003E+001,
      1.1483000000000002E+001,
      1.1484000000000002E+001,
      1.1485000000000003E+001,
      1.1486000000000002E+001,
      1.1487000000000002E+001,
      1.1488000000000003E+001,
      1.1489000000000003E+001,
      1.1490000000000002E+001,
      1.1491000000000003E+001,
      1.1492000000000003E+001,
      1.1493000000000002E+001,
      1.1494000000000003E+001,
      1.1495000000000001E+001,
      1.1496000000000002E+001,
      1.1497000000000003E+001,
      1.1498000000000001E+001,
      1.1499000000000002E+001,
      1.1500000000000004E+001,
      1.1501000000000001E+001,
      1.1502000000000002E+001,
      1.1503000000000002E+001,
      1.1504000000000001E+001,
      1.1505000000000003E+001,
      1.1506000000000002E+001,
      1.1507000000000001E+001,
      1.1508000000000003E+001,
      1.1509000000000002E+001,
      1.1510000000000002E+001,
      1.1511000000000003E+001,
      1.1512000000000002E+001,
      1.1513000000000002E+001,
      1.1514000000000003E+001,
      1.1515000000000002E+001,
      1.1516000000000002E+001,
      1.1517000000000003E+001,
      1.1518000000000002E+001,
      1.1519000000000002E+001,
      1.1520000000000003E+001,
      1.1521000000000003E+001,
      1.1522000000000002E+001,
      1.1523000000000003E+001,
      1.1524000000000003E+001,
      1.1525000000000002E+001,
      1.1526000000000003E+001,
      1.1527000000000001E+001,
      1.1528000000000002E+001,
      1.1529000000000003E+001,
      1.1530000000000001E+001,
      1.1531000000000002E+001,
      1.1532000000000004E+001,
      1.1533000000000001E+001,
      1.1534000000000002E+001,
      1.1535000000000002E+001,
      1.1536000000000001E+001,
      1.1537000000000003E+001,
      1.1538000000000002E+001,
      1.1539000000000001E+001,
      1.1540000000000003E+001,
      1.1541000000000002E+001,
      1.1542000000000002E+001,
      1.1543000000000003E+001,
      1.1544000000000002E+001,
      1.1545000000000002E+001,
      1.1546000000000003E+001,
      1.1547000000000002E+001,
      1.1548000000000002E+001,
      1.1549000000000003E+001,
      1.1550000000000002E+001,
      1.1551000000000002E+001,
      1.1552000000000003E+001,
      1.1553000000000003E+001,
      1.1554000000000002E+001,
      1.1555000000000003E+001,
      1.1556000000000003E+001,
      1.1557000000000002E+001,
      1.1558000000000003E+001,
      1.1559000000000001E+001,
      1.1560000000000002E+001,
      1.1561000000000003E+001,
      1.1562000000000001E+001,
      1.1563000000000002E+001,
      1.1564000000000002E+001,
      1.1565000000000001E+001,
      1.1566000000000003E+001,
      1.1567000000000002E+001,
      1.1568000000000001E+001,
      1.1569000000000003E+001,
      1.1570000000000002E+001,
      1.1571000000000002E+001,
      1.1572000000000003E+001,
      1.1573000000000002E+001,
      1.1574000000000002E+001,
      1.1575000000000003E+001,
      1.1576000000000002E+001,
      1.1577000000000002E+001,
      1.1578000000000003E+001,
      1.1579000000000002E+001,
      1.1580000000000002E+001,
      1.1581000000000003E+001,
      1.1582000000000003E+001,
      1.1583000000000002E+001,
      1.1584000000000003E+001,
      1.1585000000000003E+001,
      1.1586000000000002E+001,
      1.1587000000000003E+001,
      1.1588000000000003E+001,
      1.1589000000000002E+001,
      1.1590000000000003E+001,
      1.1591000000000003E+001,
      1.1592000000000002E+001,
      1.1593000000000002E+001,
      1.1594000000000003E+001,
      1.1595000000000002E+001,
      1.1596000000000002E+001,
      1.1597000000000001E+001,
      1.1598000000000003E+001,
      1.1599000000000002E+001,
      1.1600000000000001E+001,
      1.1601000000000003E+001,
      1.1602000000000002E+001,
      1.1603000000000002E+001,
      1.1604000000000003E+001,
      1.1605000000000002E+001,
      1.1606000000000002E+001,
      1.1607000000000003E+001,
      1.1608000000000002E+001,
      1.1609000000000002E+001,
      1.1610000000000003E+001,
      1.1611000000000002E+001,
      1.1612000000000002E+001,
      1.1613000000000003E+001,
      1.1614000000000003E+001,
      1.1615000000000002E+001,
      1.1616000000000003E+001,
      1.1617000000000003E+001,
      1.1618000000000002E+001,
      1.1619000000000003E+001,
      1.1620000000000003E+001,
      1.1621000000000002E+001,
      1.1622000000000002E+001,
      1.1623000000000003E+001,
      1.1624000000000002E+001,
      1.1625000000000002E+001,
      1.1626000000000001E+001,
      1.1627000000000002E+001,
      1.1628000000000002E+001,
      1.1629000000000001E+001,
      1.1630000000000003E+001,
      1.1631000000000002E+001,
      1.1632000000000001E+001,
      1.1633000000000003E+001,
      1.1634000000000002E+001,
      1.1635000000000002E+001,
      1.1636000000000003E+001,
      1.1637000000000002E+001,
      1.1638000000000002E+001,
      1.1639000000000003E+001,
      1.1640000000000002E+001,
      1.1641000000000002E+001,
      1.1642000000000003E+001,
      1.1643000000000002E+001,
      1.1644000000000002E+001,
      1.1645000000000003E+001,
      1.1646000000000003E+001,
      1.1647000000000002E+001,
      1.1648000000000003E+001,
      1.1649000000000003E+001,
      1.1650000000000002E+001,
      1.1651000000000003E+001,
      1.1652000000000003E+001,
      1.1653000000000002E+001,
      1.1654000000000002E+001,
      1.1655000000000003E+001,
      1.1656000000000002E+001,
      1.1657000000000002E+001,
      1.1658000000000001E+001,
      1.1659000000000002E+001,
      1.1660000000000002E+001,
      1.1661000000000001E+001,
      1.1662000000000003E+001,
      1.1663000000000002E+001,
      1.1664000000000001E+001,
      1.1665000000000003E+001,
      1.1666000000000002E+001,
      1.1667000000000002E+001,
      1.1668000000000003E+001,
      1.1669000000000002E+001,
      1.1670000000000002E+001,
      1.1671000000000003E+001,
      1.1672000000000002E+001,
      1.1673000000000002E+001,
      1.1674000000000003E+001,
      1.1675000000000002E+001,
      1.1676000000000002E+001,
      1.1677000000000003E+001,
      1.1678000000000003E+001,
      1.1679000000000002E+001,
      1.1680000000000003E+001,
      1.1681000000000003E+001,
      1.1682000000000002E+001,
      1.1683000000000003E+001,
      1.1684000000000003E+001,
      1.1685000000000002E+001,
      1.1686000000000002E+001,
      1.1687000000000003E+001,
      1.1688000000000002E+001,
      1.1689000000000002E+001,
      1.1690000000000001E+001,
      1.1691000000000003E+001,
      1.1692000000000002E+001,
      1.1693000000000001E+001,
      1.1694000000000003E+001,
      1.1695000000000002E+001,
      1.1696000000000002E+001,
      1.1697000000000003E+001,
      1.1698000000000002E+001,
      1.1699000000000002E+001,
      1.1700000000000003E+001,
      1.1701000000000002E+001,
      1.1702000000000002E+001,
      1.1703000000000003E+001,
      1.1704000000000002E+001,
      1.1705000000000002E+001,
      1.1706000000000003E+001,
      1.1707000000000003E+001,
      1.1708000000000002E+001,
      1.1709000000000003E+001,
      1.1710000000000003E+001,
      1.1711000000000002E+001,
      1.1712000000000003E+001,
      1.1713000000000003E+001,
      1.1714000000000002E+001,
      1.1715000000000003E+001,
      1.1716000000000003E+001,
      1.1717000000000002E+001,
      1.1718000000000002E+001,
      1.1719000000000003E+001,
      1.1720000000000002E+001,
      1.1721000000000002E+001,
      1.1722000000000001E+001,
      1.1723000000000003E+001,
      1.1724000000000002E+001,
      1.1725000000000001E+001,
      1.1726000000000003E+001,
      1.1727000000000002E+001,
      1.1728000000000002E+001,
      1.1729000000000003E+001,
      1.1730000000000002E+001,
      1.1731000000000002E+001,
      1.1732000000000003E+001,
      1.1733000000000002E+001,
      1.1734000000000002E+001,
      1.1735000000000003E+001,
      1.1736000000000002E+001,
      1.1737000000000002E+001,
      1.1738000000000003E+001,
      1.1739000000000003E+001,
      1.1740000000000002E+001,
      1.1741000000000003E+001,
      1.1742000000000003E+001,
      1.1743000000000002E+001,
      1.1744000000000003E+001,
      1.1745000000000003E+001,
      1.1746000000000002E+001,
      1.1747000000000002E+001,
      1.1748000000000003E+001,
      1.1749000000000002E+001,
      1.1750000000000002E+001,
      1.1751000000000001E+001,
      1.1752000000000002E+001,
      1.1753000000000002E+001,
      1.1754000000000001E+001,
      1.1755000000000003E+001,
      1.1756000000000002E+001,
      1.1757000000000001E+001,
      1.1758000000000003E+001,
      1.1759000000000002E+001,
      1.1760000000000002E+001,
      1.1761000000000003E+001,
      1.1762000000000002E+001,
      1.1763000000000002E+001,
      1.1764000000000003E+001,
      1.1765000000000002E+001,
      1.1766000000000002E+001,
      1.1767000000000003E+001,
      1.1768000000000002E+001,
      1.1769000000000002E+001,
      1.1770000000000003E+001,
      1.1771000000000003E+001,
      1.1772000000000002E+001,
      1.1773000000000003E+001,
      1.1774000000000003E+001,
      1.1775000000000002E+001,
      1.1776000000000003E+001,
      1.1777000000000003E+001,
      1.1778000000000002E+001,
      1.1779000000000002E+001,
      1.1780000000000003E+001,
      1.1781000000000002E+001,
      1.1782000000000002E+001,
      1.1783000000000001E+001,
      1.1784000000000002E+001,
      1.1785000000000002E+001,
      1.1786000000000001E+001,
      1.1787000000000003E+001,
      1.1788000000000002E+001,
      1.1789000000000001E+001,
      1.1790000000000003E+001,
      1.1791000000000002E+001,
      1.1792000000000002E+001,
      1.1793000000000003E+001,
      1.1794000000000002E+001,
      1.1795000000000002E+001,
      1.1796000000000003E+001,
      1.1797000000000002E+001,
      1.1798000000000002E+001,
      1.1799000000000003E+001,
      1.1800000000000002E+001,
      1.1801000000000002E+001,
      1.1802000000000003E+001,
      1.1803000000000003E+001,
      1.1804000000000002E+001,
      1.1805000000000003E+001,
      1.1806000000000003E+001,
      1.1807000000000002E+001,
      1.1808000000000003E+001,
      1.1809000000000003E+001,
      1.1810000000000002E+001,
      1.1811000000000002E+001,
      1.1812000000000003E+001,
      1.1813000000000002E+001,
      1.1814000000000002E+001,
      1.1815000000000001E+001,
      1.1816000000000003E+001,
      1.1817000000000002E+001,
      1.1818000000000001E+001,
      1.1819000000000003E+001,
      1.1820000000000002E+001,
      1.1821000000000002E+001,
      1.1822000000000003E+001,
      1.1823000000000002E+001,
      1.1824000000000002E+001,
      1.1825000000000003E+001,
      1.1826000000000002E+001,
      1.1827000000000002E+001,
      1.1828000000000003E+001,
      1.1829000000000002E+001,
      1.1830000000000002E+001,
      1.1831000000000003E+001,
      1.1832000000000003E+001,
      1.1833000000000002E+001,
      1.1834000000000003E+001,
      1.1835000000000003E+001,
      1.1836000000000002E+001,
      1.1837000000000003E+001,
      1.1838000000000003E+001,
      1.1839000000000002E+001,
      1.1840000000000003E+001,
      1.1841000000000003E+001,
      1.1842000000000002E+001,
      1.1843000000000002E+001,
      1.1844000000000003E+001,
      1.1845000000000002E+001,
      1.1846000000000002E+001,
      1.1847000000000001E+001,
      1.1848000000000003E+001,
      1.1849000000000002E+001,
      1.1850000000000001E+001,
      1.1851000000000003E+001,
      1.1852000000000002E+001,
      1.1853000000000002E+001,
      1.1854000000000003E+001,
      1.1855000000000002E+001,
      1.1856000000000002E+001,
      1.1857000000000003E+001,
      1.1858000000000002E+001,
      1.1859000000000002E+001,
      1.1860000000000003E+001,
      1.1861000000000002E+001,
      1.1862000000000002E+001,
      1.1863000000000003E+001,
      1.1864000000000003E+001,
      1.1865000000000002E+001,
      1.1866000000000003E+001,
      1.1867000000000003E+001,
      1.1868000000000002E+001,
      1.1869000000000003E+001,
      1.1870000000000003E+001,
      1.1871000000000002E+001,
      1.1872000000000002E+001,
      1.1873000000000003E+001,
      1.1874000000000002E+001,
      1.1875000000000002E+001,
      1.1876000000000001E+001,
      1.1877000000000002E+001,
      1.1878000000000002E+001,
      1.1879000000000001E+001,
      1.1880000000000003E+001,
      1.1881000000000002E+001,
      1.1882000000000001E+001,
      1.1883000000000003E+001,
      1.1884000000000002E+001,
      1.1885000000000002E+001,
      1.1886000000000003E+001,
      1.1887000000000002E+001,
      1.1888000000000002E+001,
      1.1889000000000003E+001,
      1.1890000000000002E+001,
      1.1891000000000002E+001,
      1.1892000000000003E+001,
      1.1893000000000002E+001,
      1.1894000000000002E+001,
      1.1895000000000003E+001,
      1.1896000000000003E+001,
      1.1897000000000002E+001,
      1.1898000000000003E+001,
      1.1899000000000003E+001,
      1.1900000000000002E+001,
      1.1901000000000003E+001,
      1.1902000000000003E+001,
      1.1903000000000002E+001,
      1.1904000000000002E+001,
      1.1905000000000003E+001,
      1.1906000000000002E+001,
      1.1907000000000002E+001,
      1.1908000000000001E+001,
      1.1909000000000002E+001,
      1.1910000000000002E+001,
      1.1911000000000001E+001,
      1.1912000000000003E+001,
      1.1913000000000002E+001,
      1.1914000000000001E+001,
      1.1915000000000003E+001,
      1.1916000000000002E+001,
      1.1917000000000002E+001,
      1.1918000000000003E+001,
      1.1919000000000002E+001,
      1.1920000000000002E+001,
      1.1921000000000003E+001,
      1.1922000000000002E+001,
      1.1923000000000002E+001,
      1.1924000000000003E+001,
      1.1925000000000002E+001,
      1.1926000000000002E+001,
      1.1927000000000003E+001,
      1.1928000000000003E+001,
      1.1929000000000002E+001,
      1.1930000000000003E+001,
      1.1931000000000003E+001,
      1.1932000000000002E+001,
      1.1933000000000003E+001,
      1.1934000000000003E+001,
      1.1935000000000002E+001,
      1.1936000000000002E+001,
      1.1937000000000003E+001,
      1.1938000000000002E+001,
      1.1939000000000002E+001,
      1.1940000000000001E+001,
      1.1941000000000003E+001,
      1.1942000000000002E+001,
      1.1943000000000001E+001,
      1.1944000000000003E+001,
      1.1945000000000002E+001,
      1.1946000000000002E+001,
      1.1947000000000003E+001,
      1.1948000000000002E+001,
      1.1949000000000002E+001,
      1.1950000000000003E+001,
      1.1951000000000002E+001,
      1.1952000000000002E+001,
      1.1953000000000003E+001,
      1.1954000000000002E+001,
      1.1955000000000002E+001,
      1.1956000000000003E+001,
      1.1957000000000003E+001,
      1.1958000000000002E+001,
      1.1959000000000003E+001,
      1.1960000000000003E+001,
      1.1961000000000002E+001,
      1.1962000000000003E+001,
      1.1963000000000003E+001,
      1.1964000000000002E+001,
      1.1965000000000003E+001,
      1.1966000000000003E+001,
      1.1967000000000002E+001,
      1.1968000000000002E+001,
      1.1969000000000003E+001,
      1.1970000000000002E+001,
      1.1971000000000002E+001,
      1.1972000000000001E+001,
      1.1973000000000003E+001,
      1.1974000000000002E+001,
      1.1975000000000001E+001,
      1.1976000000000003E+001,
      1.1977000000000002E+001,
      1.1978000000000002E+001,
      1.1979000000000003E+001,
      1.1980000000000002E+001,
      1.1981000000000002E+001,
      1.1982000000000003E+001,
      1.1983000000000002E+001,
      1.1984000000000002E+001,
      1.1985000000000003E+001,
      1.1986000000000002E+001,
      1.1987000000000002E+001,
      1.1988000000000003E+001,
      1.1989000000000003E+001,
      1.1990000000000002E+001,
      1.1991000000000003E+001,
      1.1992000000000003E+001,
      1.1993000000000002E+001,
      1.1994000000000003E+001,
      1.1995000000000003E+001,
      1.1996000000000002E+001,
      1.1997000000000002E+001,
      1.1998000000000003E+001,
      1.1999000000000002E+001,
      1.2000000000000002E+001,
      1.2001000000000001E+001,
      1.2002000000000002E+001,
      1.2003000000000002E+001,
      1.2004000000000001E+001,
      1.2005000000000003E+001,
      1.2006000000000002E+001,
      1.2007000000000001E+001,
      1.2008000000000003E+001,
      1.2009000000000002E+001,
      1.2010000000000002E+001,
      1.2011000000000003E+001,
      1.2012000000000002E+001,
      1.2013000000000002E+001,
      1.2014000000000003E+001,
      1.2015000000000002E+001,
      1.2016000000000002E+001,
      1.2017000000000003E+001,
      1.2018000000000002E+001,
      1.2019000000000002E+001,
      1.2020000000000003E+001,
      1.2021000000000003E+001,
      1.2022000000000002E+001,
      1.2023000000000003E+001,
      1.2024000000000003E+001,
      1.2025000000000002E+001,
      1.2026000000000003E+001,
      1.2027000000000003E+001,
      1.2028000000000002E+001,
      1.2029000000000002E+001,
      1.2030000000000003E+001,
      1.2031000000000002E+001,
      1.2032000000000002E+001,
      1.2033000000000001E+001,
      1.2034000000000002E+001,
      1.2035000000000002E+001,
      1.2036000000000001E+001,
      1.2037000000000003E+001,
      1.2038000000000002E+001,
      1.2039000000000001E+001,
      1.2040000000000003E+001,
      1.2041000000000002E+001,
      1.2042000000000002E+001,
      1.2043000000000003E+001,
      1.2044000000000002E+001,
      1.2045000000000002E+001,
      1.2046000000000003E+001,
      1.2047000000000002E+001,
      1.2048000000000002E+001,
      1.2049000000000003E+001,
      1.2050000000000002E+001,
      1.2051000000000002E+001,
      1.2052000000000003E+001,
      1.2053000000000003E+001,
      1.2054000000000002E+001,
      1.2055000000000003E+001,
      1.2056000000000003E+001,
      1.2057000000000002E+001,
      1.2058000000000003E+001,
      1.2059000000000003E+001,
      1.2060000000000002E+001,
      1.2061000000000002E+001,
      1.2062000000000003E+001,
      1.2063000000000002E+001,
      1.2064000000000002E+001,
      1.2065000000000001E+001,
      1.2066000000000003E+001,
      1.2067000000000002E+001,
      1.2068000000000001E+001,
      1.2069000000000003E+001,
      1.2070000000000002E+001,
      1.2071000000000002E+001,
      1.2072000000000003E+001,
      1.2073000000000002E+001,
      1.2074000000000002E+001,
      1.2075000000000003E+001,
      1.2076000000000002E+001,
      1.2077000000000002E+001,
      1.2078000000000003E+001,
      1.2079000000000002E+001,
      1.2080000000000002E+001,
      1.2081000000000003E+001,
      1.2082000000000003E+001,
      1.2083000000000002E+001,
      1.2084000000000003E+001,
      1.2085000000000003E+001,
      1.2086000000000002E+001,
      1.2087000000000003E+001,
      1.2088000000000003E+001,
      1.2089000000000002E+001,
      1.2090000000000003E+001,
      1.2091000000000003E+001,
      1.2092000000000002E+001,
      1.2093000000000002E+001,
      1.2094000000000003E+001,
      1.2095000000000002E+001,
      1.2096000000000002E+001,
      1.2097000000000001E+001,
      1.2098000000000003E+001,
      1.2099000000000002E+001,
      1.2100000000000001E+001,
      1.2101000000000003E+001,
      1.2102000000000002E+001,
      1.2103000000000002E+001,
      1.2104000000000003E+001,
      1.2105000000000002E+001,
      1.2106000000000002E+001,
      1.2107000000000003E+001,
      1.2108000000000002E+001,
      1.2109000000000002E+001,
      1.2110000000000003E+001,
      1.2111000000000002E+001,
      1.2112000000000002E+001,
      1.2113000000000003E+001,
      1.2114000000000003E+001,
      1.2115000000000002E+001,
      1.2116000000000003E+001,
      1.2117000000000003E+001,
      1.2118000000000002E+001,
      1.2119000000000003E+001,
      1.2120000000000003E+001,
      1.2121000000000002E+001,
      1.2122000000000002E+001,
      1.2123000000000003E+001,
      1.2124000000000002E+001,
      1.2125000000000002E+001,
      1.2126000000000001E+001,
      1.2127000000000002E+001,
      1.2128000000000002E+001,
      1.2129000000000001E+001,
      1.2130000000000003E+001,
      1.2131000000000002E+001,
      1.2132000000000001E+001,
      1.2133000000000003E+001,
      1.2134000000000002E+001,
      1.2135000000000002E+001,
      1.2136000000000003E+001,
      1.2137000000000002E+001,
      1.2138000000000002E+001,
      1.2139000000000003E+001,
      1.2140000000000002E+001,
      1.2141000000000002E+001,
      1.2142000000000003E+001,
      1.2143000000000002E+001,
      1.2144000000000002E+001,
      1.2145000000000003E+001,
      1.2146000000000003E+001,
      1.2147000000000002E+001,
      1.2148000000000003E+001,
      1.2149000000000003E+001,
      1.2150000000000002E+001,
      1.2151000000000003E+001,
      1.2152000000000003E+001,
      1.2153000000000002E+001,
      1.2154000000000002E+001,
      1.2155000000000003E+001,
      1.2156000000000002E+001,
      1.2157000000000002E+001,
      1.2158000000000001E+001,
      1.2159000000000002E+001,
      1.2160000000000002E+001,
      1.2161000000000001E+001,
      1.2162000000000003E+001,
      1.2163000000000002E+001,
      1.2164000000000001E+001,
      1.2165000000000003E+001,
      1.2166000000000002E+001,
      1.2167000000000002E+001,
      1.2168000000000003E+001,
      1.2169000000000002E+001,
      1.2170000000000002E+001,
      1.2171000000000003E+001,
      1.2172000000000002E+001,
      1.2173000000000002E+001,
      1.2174000000000003E+001,
      1.2175000000000002E+001,
      1.2176000000000002E+001,
      1.2177000000000003E+001,
      1.2178000000000003E+001,
      1.2179000000000002E+001,
      1.2180000000000003E+001,
      1.2181000000000003E+001,
      1.2182000000000002E+001,
      1.2183000000000003E+001,
      1.2184000000000003E+001,
      1.2185000000000002E+001,
      1.2186000000000002E+001,
      1.2187000000000003E+001,
      1.2188000000000002E+001,
      1.2189000000000002E+001,
      1.2190000000000001E+001,
      1.2191000000000003E+001,
      1.2192000000000002E+001,
      1.2193000000000001E+001,
      1.2194000000000003E+001,
      1.2195000000000002E+001,
      1.2196000000000002E+001,
      1.2197000000000003E+001,
      1.2198000000000002E+001,
      1.2199000000000002E+001,
      1.2200000000000003E+001,
      1.2201000000000002E+001,
      1.2202000000000002E+001,
      1.2203000000000003E+001,
      1.2204000000000002E+001,
      1.2205000000000002E+001,
      1.2206000000000003E+001,
      1.2207000000000003E+001,
      1.2208000000000002E+001,
      1.2209000000000003E+001,
      1.2210000000000003E+001,
      1.2211000000000002E+001,
      1.2212000000000003E+001,
      1.2213000000000003E+001,
      1.2214000000000002E+001,
      1.2215000000000003E+001,
      1.2216000000000003E+001,
      1.2217000000000002E+001,
      1.2218000000000002E+001,
      1.2219000000000003E+001,
      1.2220000000000002E+001,
      1.2221000000000002E+001,
      1.2222000000000001E+001,
      1.2223000000000003E+001,
      1.2224000000000002E+001,
      1.2225000000000001E+001,
      1.2226000000000003E+001,
      1.2227000000000002E+001,
      1.2228000000000002E+001,
      1.2229000000000003E+001,
      1.2230000000000002E+001,
      1.2231000000000002E+001,
      1.2232000000000003E+001,
      1.2233000000000002E+001,
      1.2234000000000002E+001,
      1.2235000000000003E+001,
      1.2236000000000002E+001,
      1.2237000000000002E+001,
      1.2238000000000003E+001,
      1.2239000000000003E+001,
      1.2240000000000002E+001,
      1.2241000000000003E+001,
      1.2242000000000003E+001,
      1.2243000000000002E+001,
      1.2244000000000003E+001,
      1.2245000000000003E+001,
      1.2246000000000002E+001,
      1.2247000000000002E+001,
      1.2248000000000003E+001,
      1.2249000000000002E+001,
      1.2250000000000002E+001,
      1.2251000000000001E+001,
      1.2252000000000002E+001,
      1.2253000000000002E+001,
      1.2254000000000001E+001,
      1.2255000000000003E+001,
      1.2256000000000002E+001,
      1.2257000000000001E+001,
      1.2258000000000003E+001,
      1.2259000000000002E+001,
      1.2260000000000002E+001,
      1.2261000000000003E+001,
      1.2262000000000002E+001,
      1.2263000000000002E+001,
      1.2264000000000003E+001,
      1.2265000000000002E+001,
      1.2266000000000002E+001,
      1.2267000000000003E+001,
      1.2268000000000002E+001,
      1.2269000000000002E+001,
      1.2270000000000003E+001,
      1.2271000000000003E+001,
      1.2272000000000002E+001,
      1.2273000000000003E+001,
      1.2274000000000003E+001,
      1.2275000000000002E+001,
      1.2276000000000003E+001,
      1.2277000000000003E+001,
      1.2278000000000002E+001,
      1.2279000000000002E+001,
      1.2280000000000003E+001,
      1.2281000000000002E+001,
      1.2282000000000002E+001,
      1.2283000000000001E+001,
      1.2284000000000002E+001,
      1.2285000000000002E+001,
      1.2286000000000001E+001,
      1.2287000000000003E+001,
      1.2288000000000002E+001,
      1.2289000000000001E+001,
      1.2290000000000003E+001,
      1.2291000000000002E+001,
      1.2292000000000002E+001,
      1.2293000000000003E+001,
      1.2294000000000002E+001,
      1.2295000000000002E+001,
      1.2296000000000003E+001,
      1.2297000000000002E+001,
      1.2298000000000002E+001,
      1.2299000000000003E+001,
      1.2300000000000002E+001,
      1.2301000000000002E+001,
      1.2302000000000003E+001,
      1.2303000000000003E+001,
      1.2304000000000002E+001,
      1.2305000000000003E+001,
      1.2306000000000003E+001,
      1.2307000000000002E+001,
      1.2308000000000003E+001,
      1.2309000000000003E+001,
      1.2310000000000002E+001,
      1.2311000000000002E+001,
      1.2312000000000003E+001,
      1.2313000000000002E+001,
      1.2314000000000002E+001,
      1.2315000000000001E+001,
      1.2316000000000003E+001,
      1.2317000000000002E+001,
      1.2318000000000001E+001,
      1.2319000000000003E+001,
      1.2320000000000002E+001,
      1.2321000000000002E+001,
      1.2322000000000003E+001,
      1.2323000000000002E+001,
      1.2324000000000002E+001,
      1.2325000000000003E+001,
      1.2326000000000002E+001,
      1.2327000000000002E+001,
      1.2328000000000003E+001,
      1.2329000000000002E+001,
      1.2330000000000002E+001,
      1.2331000000000003E+001,
      1.2332000000000003E+001,
      1.2333000000000002E+001,
      1.2334000000000003E+001,
      1.2335000000000003E+001,
      1.2336000000000002E+001,
      1.2337000000000003E+001,
      1.2338000000000003E+001,
      1.2339000000000002E+001,
      1.2340000000000003E+001,
      1.2341000000000003E+001,
      1.2342000000000002E+001,
      1.2343000000000002E+001,
      1.2344000000000003E+001,
      1.2345000000000002E+001,
      1.2346000000000002E+001,
      1.2347000000000001E+001,
      1.2348000000000003E+001,
      1.2349000000000002E+001,
      1.2350000000000001E+001,
      1.2351000000000003E+001,
      1.2352000000000002E+001,
      1.2353000000000002E+001,
      1.2354000000000003E+001,
      1.2355000000000002E+001,
      1.2356000000000002E+001,
      1.2357000000000003E+001,
      1.2358000000000002E+001,
      1.2359000000000002E+001,
      1.2360000000000003E+001,
      1.2361000000000002E+001,
      1.2362000000000002E+001,
      1.2363000000000003E+001,
      1.2364000000000003E+001,
      1.2365000000000002E+001,
      1.2366000000000003E+001,
      1.2367000000000003E+001,
      1.2368000000000002E+001,
      1.2369000000000003E+001,
      1.2370000000000003E+001,
      1.2371000000000002E+001,
      1.2372000000000002E+001,
      1.2373000000000003E+001,
      1.2374000000000002E+001,
      1.2375000000000002E+001,
      1.2376000000000001E+001,
      1.2377000000000002E+001,
      1.2378000000000002E+001,
      1.2379000000000001E+001,
      1.2380000000000003E+001,
      1.2381000000000002E+001,
      1.2382000000000001E+001,
      1.2383000000000003E+001,
      1.2384000000000002E+001,
      1.2385000000000002E+001,
      1.2386000000000003E+001,
      1.2387000000000002E+001,
      1.2388000000000002E+001,
      1.2389000000000003E+001,
      1.2390000000000002E+001,
      1.2391000000000002E+001,
      1.2392000000000003E+001,
      1.2393000000000002E+001,
      1.2394000000000002E+001,
      1.2395000000000003E+001,
      1.2396000000000003E+001,
      1.2397000000000002E+001,
      1.2398000000000003E+001,
      1.2399000000000003E+001,
      1.2400000000000002E+001,
      1.2401000000000003E+001,
      1.2402000000000003E+001,
      1.2403000000000002E+001,
      1.2404000000000002E+001,
      1.2405000000000003E+001,
      1.2406000000000002E+001,
      1.2407000000000002E+001,
      1.2408000000000001E+001,
      1.2409000000000002E+001,
      1.2410000000000002E+001,
      1.2411000000000001E+001,
      1.2412000000000003E+001,
      1.2413000000000002E+001,
      1.2414000000000001E+001,
      1.2415000000000003E+001,
      1.2416000000000002E+001,
      1.2417000000000002E+001,
      1.2418000000000003E+001,
      1.2419000000000002E+001,
      1.2420000000000002E+001,
      1.2421000000000003E+001,
      1.2422000000000002E+001,
      1.2423000000000002E+001,
      1.2424000000000003E+001,
      1.2425000000000002E+001,
      1.2426000000000002E+001,
      1.2427000000000003E+001,
      1.2428000000000003E+001,
      1.2429000000000002E+001,
      1.2430000000000003E+001,
      1.2431000000000003E+001,
      1.2432000000000002E+001,
      1.2433000000000003E+001,
      1.2434000000000003E+001,
      1.2435000000000002E+001,
      1.2436000000000002E+001,
      1.2437000000000003E+001,
      1.2438000000000002E+001,
      1.2439000000000002E+001,
      1.2440000000000001E+001,
      1.2441000000000003E+001,
      1.2442000000000002E+001,
      1.2443000000000001E+001,
      1.2444000000000003E+001,
      1.2445000000000002E+001,
      1.2446000000000002E+001,
      1.2447000000000003E+001,
      1.2448000000000002E+001,
      1.2449000000000002E+001,
      1.2450000000000003E+001,
      1.2451000000000002E+001,
      1.2452000000000002E+001,
      1.2453000000000003E+001,
      1.2454000000000002E+001,
      1.2455000000000002E+001,
      1.2456000000000003E+001,
      1.2457000000000003E+001,
      1.2458000000000002E+001,
      1.2459000000000003E+001,
      1.2460000000000003E+001,
      1.2461000000000002E+001,
      1.2462000000000003E+001,
      1.2463000000000003E+001,
      1.2464000000000002E+001,
      1.2465000000000003E+001,
      1.2466000000000003E+001,
      1.2467000000000002E+001,
      1.2468000000000002E+001,
      1.2469000000000003E+001,
      1.2470000000000002E+001,
      1.2471000000000002E+001,
      1.2472000000000001E+001,
      1.2473000000000003E+001,
      1.2474000000000002E+001,
      1.2475000000000001E+001,
      1.2476000000000003E+001,
      1.2477000000000002E+001,
      1.2478000000000002E+001,
      1.2479000000000003E+001,
      1.2480000000000002E+001,
      1.2481000000000002E+001,
      1.2482000000000003E+001,
      1.2483000000000002E+001,
      1.2484000000000002E+001,
      1.2485000000000003E+001,
      1.2486000000000002E+001,
      1.2487000000000002E+001,
      1.2488000000000003E+001,
      1.2489000000000003E+001,
      1.2490000000000002E+001,
      1.2491000000000003E+001,
      1.2492000000000003E+001,
      1.2493000000000002E+001,
      1.2494000000000003E+001,
      1.2495000000000003E+001,
      1.2496000000000002E+001,
      1.2497000000000002E+001,
      1.2498000000000003E+001,
      1.2499000000000002E+001,
      1.2500000000000002E+001,
      1.2501000000000001E+001,
      1.2502000000000002E+001,
      1.2503000000000002E+001,
      1.2504000000000001E+001,
      1.2505000000000003E+001,
      1.2506000000000002E+001,
      1.2507000000000001E+001,
      1.2508000000000003E+001,
      1.2509000000000002E+001,
      1.2510000000000002E+001,
      1.2511000000000003E+001,
      1.2512000000000002E+001,
      1.2513000000000002E+001,
      1.2514000000000003E+001,
      1.2515000000000002E+001,
      1.2516000000000002E+001,
      1.2517000000000003E+001,
      1.2518000000000002E+001,
      1.2519000000000002E+001,
      1.2520000000000003E+001,
      1.2521000000000003E+001,
      1.2522000000000002E+001,
      1.2523000000000003E+001,
      1.2524000000000003E+001,
      1.2525000000000002E+001,
      1.2526000000000003E+001,
      1.2527000000000003E+001,
      1.2528000000000002E+001,
      1.2529000000000002E+001,
      1.2530000000000003E+001,
      1.2531000000000002E+001,
      1.2532000000000002E+001,
      1.2533000000000001E+001,
      1.2534000000000002E+001,
      1.2535000000000002E+001,
      1.2536000000000001E+001,
      1.2537000000000003E+001,
      1.2538000000000002E+001,
      1.2539000000000001E+001,
      1.2540000000000003E+001,
      1.2541000000000002E+001,
      1.2542000000000002E+001,
      1.2543000000000003E+001,
      1.2544000000000002E+001,
      1.2545000000000002E+001,
      1.2546000000000003E+001,
      1.2547000000000002E+001,
      1.2548000000000002E+001,
      1.2549000000000003E+001,
      1.2550000000000002E+001,
      1.2551000000000002E+001,
      1.2552000000000003E+001,
      1.2553000000000003E+001,
      1.2554000000000002E+001,
      1.2555000000000003E+001,
      1.2556000000000003E+001,
      1.2557000000000002E+001,
      1.2558000000000003E+001,
      1.2559000000000003E+001,
      1.2560000000000002E+001,
      1.2561000000000002E+001,
      1.2562000000000003E+001,
      1.2563000000000002E+001,
      1.2564000000000002E+001,
      1.2565000000000001E+001,
      1.2566000000000003E+001,
      1.2567000000000002E+001,
      1.2568000000000001E+001,
      1.2569000000000003E+001,
      1.2570000000000002E+001,
      1.2571000000000002E+001,
      1.2572000000000003E+001,
      1.2573000000000002E+001,
      1.2574000000000002E+001,
      1.2575000000000003E+001,
      1.2576000000000002E+001,
      1.2577000000000002E+001,
      1.2578000000000003E+001,
      1.2579000000000002E+001,
      1.2580000000000002E+001,
      1.2581000000000003E+001,
      1.2582000000000003E+001,
      1.2583000000000002E+001,
      1.2584000000000003E+001,
      1.2585000000000003E+001,
      1.2586000000000002E+001,
      1.2587000000000003E+001,
      1.2588000000000003E+001,
      1.2589000000000002E+001,
      1.2590000000000003E+001,
      1.2591000000000003E+001,
      1.2592000000000002E+001,
      1.2593000000000002E+001,
      1.2594000000000003E+001,
      1.2595000000000002E+001,
      1.2596000000000002E+001,
      1.2597000000000001E+001,
      1.2598000000000003E+001,
      1.2599000000000002E+001,
      1.2600000000000001E+001,
      1.2601000000000003E+001,
      1.2602000000000002E+001,
      1.2603000000000002E+001,
      1.2604000000000003E+001,
      1.2605000000000002E+001,
      1.2606000000000002E+001,
      1.2607000000000003E+001,
      1.2608000000000002E+001,
      1.2609000000000002E+001,
      1.2610000000000003E+001,
      1.2611000000000002E+001,
      1.2612000000000002E+001,
      1.2613000000000003E+001,
      1.2614000000000003E+001,
      1.2615000000000002E+001,
      1.2616000000000003E+001,
      1.2617000000000003E+001,
      1.2618000000000002E+001,
      1.2619000000000003E+001,
      1.2620000000000003E+001,
      1.2621000000000002E+001,
      1.2622000000000002E+001,
      1.2623000000000003E+001,
      1.2624000000000002E+001,
      1.2625000000000002E+001,
      1.2626000000000001E+001,
      1.2627000000000002E+001,
      1.2628000000000002E+001,
      1.2629000000000001E+001,
      1.2630000000000003E+001,
      1.2631000000000002E+001,
      1.2632000000000001E+001,
      1.2633000000000003E+001,
      1.2634000000000002E+001,
      1.2635000000000002E+001,
      1.2636000000000003E+001,
      1.2637000000000002E+001,
      1.2638000000000002E+001,
      1.2639000000000003E+001,
      1.2640000000000002E+001,
      1.2641000000000002E+001,
      1.2642000000000003E+001,
      1.2643000000000002E+001,
      1.2644000000000002E+001,
      1.2645000000000003E+001,
      1.2646000000000003E+001,
      1.2647000000000002E+001,
      1.2648000000000003E+001,
      1.2649000000000003E+001,
      1.2650000000000002E+001,
      1.2651000000000003E+001,
      1.2652000000000003E+001,
      1.2653000000000002E+001,
      1.2654000000000002E+001,
      1.2655000000000003E+001,
      1.2656000000000002E+001,
      1.2657000000000002E+001,
      1.2658000000000001E+001,
      1.2659000000000002E+001,
      1.2660000000000002E+001,
      1.2661000000000001E+001,
      1.2662000000000003E+001,
      1.2663000000000002E+001,
      1.2664000000000001E+001,
      1.2665000000000003E+001,
      1.2666000000000002E+001,
      1.2667000000000002E+001,
      1.2668000000000003E+001,
      1.2669000000000002E+001,
      1.2670000000000002E+001,
      1.2671000000000003E+001,
      1.2672000000000002E+001,
      1.2673000000000002E+001,
      1.2674000000000003E+001,
      1.2675000000000002E+001,
      1.2676000000000002E+001,
      1.2677000000000003E+001,
      1.2678000000000003E+001,
      1.2679000000000002E+001,
      1.2680000000000003E+001,
      1.2681000000000003E+001,
      1.2682000000000002E+001,
      1.2683000000000003E+001,
      1.2684000000000003E+001,
      1.2685000000000002E+001,
      1.2686000000000002E+001,
      1.2687000000000003E+001,
      1.2688000000000002E+001,
      1.2689000000000002E+001,
      1.2690000000000001E+001,
      1.2691000000000003E+001,
      1.2692000000000002E+001,
      1.2693000000000001E+001,
      1.2694000000000003E+001,
      1.2695000000000002E+001,
      1.2696000000000002E+001,
      1.2697000000000003E+001,
      1.2698000000000002E+001,
      1.2699000000000002E+001,
      1.2700000000000003E+001,
      1.2701000000000002E+001,
      1.2702000000000002E+001,
      1.2703000000000003E+001,
      1.2704000000000002E+001,
      1.2705000000000002E+001,
      1.2706000000000003E+001,
      1.2707000000000003E+001,
      1.2708000000000002E+001,
      1.2709000000000003E+001,
      1.2710000000000003E+001,
      1.2711000000000002E+001,
      1.2712000000000003E+001,
      1.2713000000000003E+001,
      1.2714000000000002E+001,
      1.2715000000000003E+001,
      1.2716000000000003E+001,
      1.2717000000000002E+001,
      1.2718000000000002E+001,
      1.2719000000000003E+001,
      1.2720000000000002E+001,
      1.2721000000000002E+001,
      1.2722000000000001E+001,
      1.2723000000000003E+001,
      1.2724000000000002E+001,
      1.2725000000000001E+001,
      1.2726000000000003E+001,
      1.2727000000000002E+001,
      1.2728000000000002E+001,
      1.2729000000000003E+001,
      1.2730000000000002E+001,
      1.2731000000000002E+001,
      1.2732000000000003E+001,
      1.2733000000000002E+001,
      1.2734000000000002E+001,
      1.2735000000000003E+001,
      1.2736000000000002E+001,
      1.2737000000000002E+001,
      1.2738000000000003E+001,
      1.2739000000000003E+001,
      1.2740000000000002E+001,
      1.2741000000000003E+001,
      1.2742000000000003E+001,
      1.2743000000000002E+001,
      1.2744000000000003E+001,
      1.2745000000000003E+001,
      1.2746000000000002E+001,
      1.2747000000000003E+001,
      1.2748000000000003E+001,
      1.2749000000000002E+001,
      1.2750000000000002E+001,
      1.2751000000000001E+001,
      1.2752000000000002E+001,
      1.2753000000000002E+001,
      1.2754000000000001E+001,
      1.2755000000000003E+001,
      1.2756000000000002E+001,
      1.2757000000000001E+001,
      1.2758000000000003E+001,
      1.2759000000000002E+001,
      1.2760000000000002E+001,
      1.2761000000000003E+001,
      1.2762000000000002E+001,
      1.2763000000000002E+001,
      1.2764000000000003E+001,
      1.2765000000000002E+001,
      1.2766000000000002E+001,
      1.2767000000000003E+001,
      1.2768000000000002E+001,
      1.2769000000000002E+001,
      1.2770000000000003E+001,
      1.2771000000000003E+001,
      1.2772000000000002E+001,
      1.2773000000000003E+001,
      1.2774000000000003E+001,
      1.2775000000000002E+001,
      1.2776000000000003E+001,
      1.2777000000000003E+001,
      1.2778000000000002E+001,
      1.2779000000000002E+001,
      1.2780000000000003E+001,
      1.2781000000000002E+001,
      1.2782000000000002E+001,
      1.2783000000000001E+001,
      1.2784000000000002E+001,
      1.2785000000000002E+001,
      1.2786000000000001E+001,
      1.2787000000000003E+001,
      1.2788000000000002E+001,
      1.2789000000000001E+001,
      1.2790000000000003E+001,
      1.2791000000000002E+001,
      1.2792000000000002E+001,
      1.2793000000000003E+001,
      1.2794000000000002E+001,
      1.2795000000000002E+001,
      1.2796000000000003E+001,
      1.2797000000000002E+001,
      1.2798000000000002E+001,
      1.2799000000000003E+001,
      1.2800000000000002E+001,
      1.2801000000000002E+001,
      1.2802000000000003E+001,
      1.2803000000000003E+001,
      1.2804000000000002E+001,
      1.2805000000000003E+001,
      1.2806000000000003E+001,
      1.2807000000000002E+001,
      1.2808000000000003E+001,
      1.2809000000000003E+001,
      1.2810000000000002E+001,
      1.2811000000000002E+001,
      1.2812000000000003E+001,
      1.2813000000000002E+001,
      1.2814000000000002E+001,
      1.2815000000000001E+001,
      1.2816000000000003E+001,
      1.2817000000000002E+001,
      1.2818000000000001E+001,
      1.2819000000000003E+001,
      1.2820000000000002E+001,
      1.2821000000000002E+001,
      1.2822000000000003E+001,
      1.2823000000000002E+001,
      1.2824000000000002E+001,
      1.2825000000000003E+001,
      1.2826000000000002E+001,
      1.2827000000000002E+001,
      1.2828000000000003E+001,
      1.2829000000000002E+001,
      1.2830000000000002E+001,
      1.2831000000000003E+001,
      1.2832000000000003E+001,
      1.2833000000000002E+001,
      1.2834000000000003E+001,
      1.2835000000000003E+001,
      1.2836000000000002E+001,
      1.2837000000000003E+001,
      1.2838000000000003E+001,
      1.2839000000000002E+001,
      1.2840000000000003E+001,
      1.2841000000000003E+001,
      1.2842000000000002E+001,
      1.2843000000000002E+001,
      1.2844000000000003E+001,
      1.2845000000000002E+001,
      1.2846000000000002E+001,
      1.2847000000000001E+001,
      1.2848000000000003E+001,
      1.2849000000000002E+001,
      1.2850000000000001E+001,
      1.2851000000000003E+001,
      1.2852000000000002E+001,
      1.2853000000000002E+001,
      1.2854000000000003E+001,
      1.2855000000000002E+001,
      1.2856000000000002E+001,
      1.2857000000000003E+001,
      1.2858000000000002E+001,
      1.2859000000000002E+001,
      1.2860000000000003E+001,
      1.2861000000000002E+001,
      1.2862000000000002E+001,
      1.2863000000000003E+001,
      1.2864000000000003E+001,
      1.2865000000000002E+001,
      1.2866000000000003E+001,
      1.2867000000000003E+001,
      1.2868000000000002E+001,
      1.2869000000000003E+001,
      1.2870000000000003E+001,
      1.2871000000000002E+001,
      1.2872000000000003E+001,
      1.2873000000000003E+001,
      1.2874000000000002E+001,
      1.2875000000000002E+001,
      1.2876000000000001E+001,
      1.2877000000000002E+001,
      1.2878000000000002E+001,
      1.2879000000000001E+001,
      1.2880000000000003E+001,
      1.2881000000000002E+001,
      1.2882000000000001E+001,
      1.2883000000000003E+001,
      1.2884000000000002E+001,
      1.2885000000000002E+001,
      1.2886000000000003E+001,
      1.2887000000000002E+001,
      1.2888000000000002E+001,
      1.2889000000000003E+001,
      1.2890000000000002E+001,
      1.2891000000000002E+001,
      1.2892000000000003E+001,
      1.2893000000000002E+001,
      1.2894000000000002E+001,
      1.2895000000000003E+001,
      1.2896000000000003E+001,
      1.2897000000000002E+001,
      1.2898000000000003E+001,
      1.2899000000000003E+001,
      1.2900000000000002E+001,
      1.2901000000000003E+001,
      1.2902000000000003E+001,
      1.2903000000000002E+001,
      1.2904000000000002E+001,
      1.2905000000000003E+001,
      1.2906000000000002E+001,
      1.2907000000000002E+001,
      1.2908000000000001E+001,
      1.2909000000000002E+001,
      1.2910000000000002E+001,
      1.2911000000000001E+001,
      1.2912000000000003E+001,
      1.2913000000000002E+001,
      1.2914000000000001E+001,
      1.2915000000000003E+001,
      1.2916000000000002E+001,
      1.2917000000000002E+001,
      1.2918000000000003E+001,
      1.2919000000000002E+001,
      1.2920000000000002E+001,
      1.2921000000000003E+001,
      1.2922000000000002E+001,
      1.2923000000000002E+001,
      1.2924000000000003E+001,
      1.2925000000000002E+001,
      1.2926000000000002E+001,
      1.2927000000000003E+001,
      1.2928000000000003E+001,
      1.2929000000000002E+001,
      1.2930000000000003E+001,
      1.2931000000000003E+001,
      1.2932000000000002E+001,
      1.2933000000000003E+001,
      1.2934000000000003E+001,
      1.2935000000000002E+001,
      1.2936000000000002E+001,
      1.2937000000000003E+001,
      1.2938000000000002E+001,
      1.2939000000000002E+001,
      1.2940000000000001E+001,
      1.2941000000000003E+001,
      1.2942000000000002E+001,
      1.2943000000000001E+001,
      1.2944000000000003E+001,
      1.2945000000000002E+001,
      1.2946000000000002E+001,
      1.2947000000000003E+001,
      1.2948000000000002E+001,
      1.2949000000000002E+001,
      1.2950000000000003E+001,
      1.2951000000000002E+001,
      1.2952000000000002E+001,
      1.2953000000000003E+001,
      1.2954000000000002E+001,
      1.2955000000000002E+001,
      1.2956000000000003E+001,
      1.2957000000000003E+001,
      1.2958000000000002E+001,
      1.2959000000000003E+001,
      1.2960000000000003E+001,
      1.2961000000000002E+001,
      1.2962000000000003E+001,
      1.2963000000000003E+001,
      1.2964000000000002E+001,
      1.2965000000000003E+001,
      1.2966000000000003E+001,
      1.2967000000000002E+001,
      1.2968000000000002E+001,
      1.2969000000000003E+001,
      1.2970000000000002E+001,
      1.2971000000000002E+001,
      1.2972000000000001E+001,
      1.2973000000000003E+001,
      1.2974000000000002E+001,
      1.2975000000000001E+001,
      1.2976000000000003E+001,
      1.2977000000000002E+001,
      1.2978000000000002E+001,
      1.2979000000000003E+001,
      1.2980000000000002E+001,
      1.2981000000000002E+001,
      1.2982000000000003E+001,
      1.2983000000000002E+001,
      1.2984000000000002E+001,
      1.2985000000000003E+001,
      1.2986000000000002E+001,
      1.2987000000000002E+001,
      1.2988000000000003E+001,
      1.2989000000000003E+001,
      1.2990000000000002E+001,
      1.2991000000000003E+001,
      1.2992000000000003E+001,
      1.2993000000000002E+001,
      1.2994000000000003E+001,
      1.2995000000000003E+001,
      1.2996000000000002E+001,
      1.2997000000000003E+001,
      1.2998000000000003E+001,
      1.2999000000000002E+001,
      1.3000000000000002E+001,
      1.3001000000000003E+001,
      1.3002000000000002E+001,
      1.3003000000000002E+001,
      1.3004000000000001E+001,
      1.3005000000000003E+001,
      1.3006000000000002E+001,
      1.3007000000000001E+001,
      1.3008000000000003E+001,
      1.3009000000000002E+001,
      1.3010000000000002E+001,
      1.3011000000000003E+001,
      1.3012000000000002E+001,
      1.3013000000000002E+001,
      1.3014000000000003E+001,
      1.3015000000000002E+001,
      1.3016000000000002E+001,
      1.3017000000000003E+001,
      1.3018000000000002E+001,
      1.3019000000000002E+001,
      1.3020000000000003E+001,
      1.3021000000000003E+001,
      1.3022000000000002E+001,
      1.3023000000000003E+001,
      1.3024000000000003E+001,
      1.3025000000000002E+001,
      1.3026000000000003E+001,
      1.3027000000000003E+001,
      1.3028000000000002E+001,
      1.3029000000000002E+001,
      1.3030000000000003E+001,
      1.3031000000000002E+001,
      1.3032000000000002E+001,
      1.3033000000000001E+001,
      1.3034000000000002E+001,
      1.3035000000000002E+001,
      1.3036000000000001E+001,
      1.3037000000000003E+001,
      1.3038000000000002E+001,
      1.3039000000000001E+001,
      1.3040000000000003E+001,
      1.3041000000000002E+001,
      1.3042000000000002E+001,
      1.3043000000000003E+001,
      1.3044000000000002E+001,
      1.3045000000000002E+001,
      1.3046000000000003E+001,
      1.3047000000000002E+001,
      1.3048000000000002E+001,
      1.3049000000000003E+001,
      1.3050000000000002E+001,
      1.3051000000000002E+001,
      1.3052000000000003E+001,
      1.3053000000000003E+001,
      1.3054000000000002E+001,
      1.3055000000000003E+001,
      1.3056000000000003E+001,
      1.3057000000000002E+001,
      1.3058000000000003E+001,
      1.3059000000000003E+001,
      1.3060000000000002E+001,
      1.3061000000000002E+001,
      1.3062000000000003E+001,
      1.3063000000000002E+001,
      1.3064000000000002E+001,
      1.3065000000000001E+001,
      1.3066000000000003E+001,
      1.3067000000000002E+001,
      1.3068000000000001E+001,
      1.3069000000000003E+001,
      1.3070000000000002E+001,
      1.3071000000000002E+001,
      1.3072000000000003E+001,
      1.3073000000000002E+001,
      1.3074000000000002E+001,
      1.3075000000000003E+001,
      1.3076000000000002E+001,
      1.3077000000000002E+001,
      1.3078000000000003E+001,
      1.3079000000000002E+001,
      1.3080000000000002E+001,
      1.3081000000000003E+001,
      1.3082000000000003E+001,
      1.3083000000000002E+001,
      1.3084000000000003E+001,
      1.3085000000000003E+001,
      1.3086000000000002E+001,
      1.3087000000000003E+001,
      1.3088000000000003E+001,
      1.3089000000000002E+001,
      1.3090000000000003E+001,
      1.3091000000000003E+001,
      1.3092000000000002E+001,
      1.3093000000000002E+001,
      1.3094000000000003E+001,
      1.3095000000000002E+001,
      1.3096000000000002E+001,
      1.3097000000000001E+001,
      1.3098000000000003E+001,
      1.3099000000000002E+001,
      1.3100000000000001E+001,
      1.3101000000000003E+001,
      1.3102000000000002E+001,
      1.3103000000000002E+001,
      1.3104000000000003E+001,
      1.3105000000000002E+001,
      1.3106000000000002E+001,
      1.3107000000000003E+001,
      1.3108000000000002E+001,
      1.3109000000000002E+001,
      1.3110000000000003E+001,
      1.3111000000000002E+001,
      1.3112000000000002E+001,
      1.3113000000000003E+001,
      1.3114000000000003E+001,
      1.3115000000000002E+001,
      1.3116000000000003E+001,
      1.3117000000000003E+001,
      1.3118000000000002E+001,
      1.3119000000000003E+001,
      1.3120000000000003E+001,
      1.3121000000000002E+001,
      1.3122000000000003E+001,
      1.3123000000000003E+001,
      1.3124000000000002E+001,
      1.3125000000000002E+001,
      1.3126000000000003E+001,
      1.3127000000000002E+001,
      1.3128000000000002E+001,
      1.3129000000000001E+001,
      1.3130000000000003E+001,
      1.3131000000000002E+001,
      1.3132000000000001E+001,
      1.3133000000000003E+001,
      1.3134000000000002E+001,
      1.3135000000000002E+001,
      1.3136000000000003E+001,
      1.3137000000000002E+001,
      1.3138000000000002E+001,
      1.3139000000000003E+001,
      1.3140000000000002E+001,
      1.3141000000000002E+001,
      1.3142000000000003E+001,
      1.3143000000000002E+001,
      1.3144000000000002E+001,
      1.3145000000000003E+001,
      1.3146000000000003E+001,
      1.3147000000000002E+001,
      1.3148000000000003E+001,
      1.3149000000000003E+001,
      1.3150000000000002E+001,
      1.3151000000000003E+001,
      1.3152000000000003E+001,
      1.3153000000000002E+001,
      1.3154000000000002E+001,
      1.3155000000000003E+001,
      1.3156000000000002E+001,
      1.3157000000000002E+001,
      1.3158000000000001E+001,
      1.3159000000000002E+001,
      1.3160000000000002E+001,
      1.3161000000000001E+001,
      1.3162000000000003E+001,
      1.3163000000000002E+001,
      1.3164000000000001E+001,
      1.3165000000000003E+001,
      1.3166000000000002E+001,
      1.3167000000000002E+001,
      1.3168000000000003E+001,
      1.3169000000000002E+001,
      1.3170000000000002E+001,
      1.3171000000000003E+001,
      1.3172000000000002E+001,
      1.3173000000000002E+001,
      1.3174000000000003E+001,
      1.3175000000000002E+001,
      1.3176000000000002E+001,
      1.3177000000000003E+001,
      1.3178000000000003E+001,
      1.3179000000000002E+001,
      1.3180000000000003E+001,
      1.3181000000000003E+001,
      1.3182000000000002E+001,
      1.3183000000000003E+001,
      1.3184000000000003E+001,
      1.3185000000000002E+001,
      1.3186000000000002E+001,
      1.3187000000000003E+001,
      1.3188000000000002E+001,
      1.3189000000000002E+001,
      1.3190000000000001E+001,
      1.3191000000000003E+001,
      1.3192000000000002E+001,
      1.3193000000000001E+001,
      1.3194000000000003E+001,
      1.3195000000000002E+001,
      1.3196000000000002E+001,
      1.3197000000000003E+001,
      1.3198000000000002E+001,
      1.3199000000000002E+001,
      1.3200000000000003E+001,
      1.3201000000000002E+001,
      1.3202000000000002E+001,
      1.3203000000000003E+001,
      1.3204000000000002E+001,
      1.3205000000000002E+001,
      1.3206000000000003E+001,
      1.3207000000000003E+001,
      1.3208000000000002E+001,
      1.3209000000000003E+001,
      1.3210000000000003E+001,
      1.3211000000000002E+001,
      1.3212000000000003E+001,
      1.3213000000000003E+001,
      1.3214000000000002E+001,
      1.3215000000000003E+001,
      1.3216000000000003E+001,
      1.3217000000000002E+001,
      1.3218000000000002E+001,
      1.3219000000000003E+001,
      1.3220000000000002E+001,
      1.3221000000000002E+001,
      1.3222000000000001E+001,
      1.3223000000000003E+001,
      1.3224000000000002E+001,
      1.3225000000000001E+001,
      1.3226000000000003E+001,
      1.3227000000000002E+001,
      1.3228000000000002E+001,
      1.3229000000000003E+001,
      1.3230000000000002E+001,
      1.3231000000000002E+001,
      1.3232000000000003E+001,
      1.3233000000000002E+001,
      1.3234000000000002E+001,
      1.3235000000000003E+001,
      1.3236000000000002E+001,
      1.3237000000000002E+001,
      1.3238000000000003E+001,
      1.3239000000000003E+001,
      1.3240000000000002E+001,
      1.3241000000000003E+001,
      1.3242000000000003E+001,
      1.3243000000000002E+001,
      1.3244000000000003E+001,
      1.3245000000000003E+001,
      1.3246000000000002E+001,
      1.3247000000000003E+001,
      1.3248000000000003E+001,
      1.3249000000000002E+001,
      1.3250000000000002E+001,
      1.3251000000000003E+001,
      1.3252000000000002E+001,
      1.3253000000000002E+001,
      1.3254000000000001E+001,
      1.3255000000000003E+001,
      1.3256000000000002E+001,
      1.3257000000000001E+001,
      1.3258000000000003E+001,
      1.3259000000000002E+001,
      1.3260000000000002E+001,
      1.3261000000000003E+001,
      1.3262000000000002E+001,
      1.3263000000000002E+001,
      1.3264000000000003E+001,
      1.3265000000000002E+001,
      1.3266000000000002E+001,
      1.3267000000000003E+001,
      1.3268000000000002E+001,
      1.3269000000000002E+001,
      1.3270000000000003E+001,
      1.3271000000000003E+001,
      1.3272000000000002E+001,
      1.3273000000000003E+001,
      1.3274000000000003E+001,
      1.3275000000000002E+001,
      1.3276000000000003E+001,
      1.3277000000000003E+001,
      1.3278000000000002E+001,
      1.3279000000000002E+001,
      1.3280000000000003E+001,
      1.3281000000000002E+001,
      1.3282000000000002E+001,
      1.3283000000000001E+001,
      1.3284000000000002E+001,
      1.3285000000000002E+001,
      1.3286000000000001E+001,
      1.3287000000000003E+001,
      1.3288000000000002E+001,
      1.3289000000000001E+001,
      1.3290000000000003E+001,
      1.3291000000000002E+001,
      1.3292000000000002E+001,
      1.3293000000000003E+001,
      1.3294000000000002E+001,
      1.3295000000000002E+001,
      1.3296000000000003E+001,
      1.3297000000000002E+001,
      1.3298000000000002E+001,
      1.3299000000000003E+001,
      1.3300000000000002E+001,
      1.3301000000000002E+001,
      1.3302000000000003E+001,
      1.3303000000000003E+001,
      1.3304000000000002E+001,
      1.3305000000000003E+001,
      1.3306000000000003E+001,
      1.3307000000000002E+001,
      1.3308000000000003E+001,
      1.3309000000000003E+001,
      1.3310000000000002E+001,
      1.3311000000000002E+001,
      1.3312000000000003E+001,
      1.3313000000000002E+001,
      1.3314000000000002E+001,
      1.3315000000000001E+001,
      1.3316000000000003E+001,
      1.3317000000000002E+001,
      1.3318000000000001E+001,
      1.3319000000000003E+001,
      1.3320000000000002E+001,
      1.3321000000000002E+001,
      1.3322000000000003E+001,
      1.3323000000000002E+001,
      1.3324000000000002E+001,
      1.3325000000000003E+001,
      1.3326000000000002E+001,
      1.3327000000000002E+001,
      1.3328000000000003E+001,
      1.3329000000000002E+001,
      1.3330000000000002E+001,
      1.3331000000000003E+001,
      1.3332000000000003E+001,
      1.3333000000000002E+001,
      1.3334000000000003E+001,
      1.3335000000000003E+001,
      1.3336000000000002E+001,
      1.3337000000000003E+001,
      1.3338000000000003E+001,
      1.3339000000000002E+001,
      1.3340000000000003E+001,
      1.3341000000000003E+001,
      1.3342000000000002E+001,
      1.3343000000000002E+001,
      1.3344000000000003E+001,
      1.3345000000000002E+001,
      1.3346000000000002E+001,
      1.3347000000000001E+001,
      1.3348000000000003E+001,
      1.3349000000000002E+001,
      1.3350000000000001E+001,
      1.3351000000000003E+001,
      1.3352000000000002E+001,
      1.3353000000000002E+001,
      1.3354000000000003E+001,
      1.3355000000000002E+001,
      1.3356000000000002E+001,
      1.3357000000000003E+001,
      1.3358000000000002E+001,
      1.3359000000000002E+001,
      1.3360000000000003E+001,
      1.3361000000000002E+001,
      1.3362000000000002E+001,
      1.3363000000000003E+001,
      1.3364000000000003E+001,
      1.3365000000000002E+001,
      1.3366000000000003E+001,
      1.3367000000000003E+001,
      1.3368000000000002E+001,
      1.3369000000000003E+001,
      1.3370000000000003E+001,
      1.3371000000000002E+001,
      1.3372000000000003E+001,
      1.3373000000000003E+001,
      1.3374000000000002E+001,
      1.3375000000000002E+001,
      1.3376000000000003E+001,
      1.3377000000000002E+001,
      1.3378000000000002E+001,
      1.3379000000000001E+001,
      1.3380000000000003E+001,
      1.3381000000000002E+001,
      1.3382000000000001E+001,
      1.3383000000000003E+001,
      1.3384000000000002E+001,
      1.3385000000000002E+001,
      1.3386000000000003E+001,
      1.3387000000000002E+001,
      1.3388000000000002E+001,
      1.3389000000000003E+001,
      1.3390000000000002E+001,
      1.3391000000000002E+001,
      1.3392000000000003E+001,
      1.3393000000000002E+001,
      1.3394000000000002E+001,
      1.3395000000000003E+001,
      1.3396000000000003E+001,
      1.3397000000000002E+001,
      1.3398000000000003E+001,
      1.3399000000000003E+001,
      1.3400000000000002E+001,
      1.3401000000000003E+001,
      1.3402000000000003E+001,
      1.3403000000000002E+001,
      1.3404000000000002E+001,
      1.3405000000000003E+001,
      1.3406000000000002E+001,
      1.3407000000000002E+001,
      1.3408000000000001E+001,
      1.3409000000000002E+001,
      1.3410000000000002E+001,
      1.3411000000000001E+001,
      1.3412000000000003E+001,
      1.3413000000000002E+001,
      1.3414000000000001E+001,
      1.3415000000000003E+001,
      1.3416000000000002E+001,
      1.3417000000000002E+001,
      1.3418000000000003E+001,
      1.3419000000000002E+001,
      1.3420000000000002E+001,
      1.3421000000000003E+001,
      1.3422000000000002E+001,
      1.3423000000000002E+001,
      1.3424000000000003E+001,
      1.3425000000000002E+001,
      1.3426000000000002E+001,
      1.3427000000000003E+001,
      1.3428000000000003E+001,
      1.3429000000000002E+001,
      1.3430000000000003E+001,
      1.3431000000000003E+001,
      1.3432000000000002E+001,
      1.3433000000000003E+001,
      1.3434000000000003E+001,
      1.3435000000000002E+001,
      1.3436000000000002E+001,
      1.3437000000000003E+001,
      1.3438000000000002E+001,
      1.3439000000000002E+001,
      1.3440000000000001E+001,
      1.3441000000000003E+001,
      1.3442000000000002E+001,
      1.3443000000000001E+001,
      1.3444000000000003E+001,
      1.3445000000000002E+001,
      1.3446000000000002E+001,
      1.3447000000000003E+001,
      1.3448000000000002E+001,
      1.3449000000000002E+001,
      1.3450000000000003E+001,
      1.3451000000000002E+001,
      1.3452000000000002E+001,
      1.3453000000000003E+001,
      1.3454000000000002E+001,
      1.3455000000000002E+001,
      1.3456000000000003E+001,
      1.3457000000000003E+001,
      1.3458000000000002E+001,
      1.3459000000000003E+001,
      1.3460000000000003E+001,
      1.3461000000000002E+001,
      1.3462000000000003E+001,
      1.3463000000000003E+001,
      1.3464000000000002E+001,
      1.3465000000000003E+001,
      1.3466000000000003E+001,
      1.3467000000000002E+001,
      1.3468000000000002E+001,
      1.3469000000000003E+001,
      1.3470000000000002E+001,
      1.3471000000000002E+001,
      1.3472000000000001E+001,
      1.3473000000000003E+001,
      1.3474000000000002E+001,
      1.3475000000000001E+001,
      1.3476000000000003E+001,
      1.3477000000000002E+001,
      1.3478000000000002E+001,
      1.3479000000000003E+001,
      1.3480000000000002E+001,
      1.3481000000000002E+001,
      1.3482000000000003E+001,
      1.3483000000000002E+001,
      1.3484000000000002E+001,
      1.3485000000000003E+001,
      1.3486000000000002E+001,
      1.3487000000000002E+001,
      1.3488000000000003E+001,
      1.3489000000000003E+001,
      1.3490000000000002E+001,
      1.3491000000000003E+001,
      1.3492000000000003E+001,
      1.3493000000000002E+001,
      1.3494000000000003E+001,
      1.3495000000000003E+001,
      1.3496000000000002E+001,
      1.3497000000000003E+001,
      1.3498000000000003E+001,
      1.3499000000000002E+001,
      1.3500000000000002E+001,
      1.3501000000000003E+001,
      1.3502000000000002E+001,
      1.3503000000000002E+001,
      1.3504000000000001E+001,
      1.3505000000000003E+001,
      1.3506000000000002E+001,
      1.3507000000000001E+001,
      1.3508000000000003E+001,
      1.3509000000000002E+001,
      1.3510000000000002E+001,
      1.3511000000000003E+001,
      1.3512000000000002E+001,
      1.3513000000000002E+001,
      1.3514000000000003E+001,
      1.3515000000000002E+001,
      1.3516000000000002E+001,
      1.3517000000000003E+001,
      1.3518000000000002E+001,
      1.3519000000000002E+001,
      1.3520000000000003E+001,
      1.3521000000000003E+001,
      1.3522000000000002E+001,
      1.3523000000000003E+001,
      1.3524000000000003E+001,
      1.3525000000000002E+001,
      1.3526000000000003E+001,
      1.3527000000000003E+001,
      1.3528000000000002E+001,
      1.3529000000000002E+001,
      1.3530000000000003E+001,
      1.3531000000000002E+001,
      1.3532000000000002E+001,
      1.3533000000000001E+001,
      1.3534000000000002E+001,
      1.3535000000000002E+001,
      1.3536000000000001E+001,
      1.3537000000000003E+001,
      1.3538000000000002E+001,
      1.3539000000000001E+001,
      1.3540000000000003E+001,
      1.3541000000000002E+001,
      1.3542000000000002E+001,
      1.3543000000000003E+001,
      1.3544000000000002E+001,
      1.3545000000000002E+001,
      1.3546000000000003E+001,
      1.3547000000000002E+001,
      1.3548000000000002E+001,
      1.3549000000000003E+001,
      1.3550000000000002E+001,
      1.3551000000000002E+001,
      1.3552000000000003E+001,
      1.3553000000000003E+001,
      1.3554000000000002E+001,
      1.3555000000000003E+001,
      1.3556000000000003E+001,
      1.3557000000000002E+001,
      1.3558000000000003E+001,
      1.3559000000000003E+001,
      1.3560000000000002E+001,
      1.3561000000000002E+001,
      1.3562000000000003E+001,
      1.3563000000000002E+001,
      1.3564000000000002E+001,
      1.3565000000000003E+001,
      1.3566000000000003E+001,
      1.3567000000000002E+001,
      1.3568000000000001E+001,
      1.3569000000000003E+001,
      1.3570000000000002E+001,
      1.3571000000000002E+001,
      1.3572000000000003E+001,
      1.3573000000000002E+001,
      1.3574000000000002E+001,
      1.3575000000000003E+001,
      1.3576000000000002E+001,
      1.3577000000000002E+001,
      1.3578000000000003E+001,
      1.3579000000000002E+001,
      1.3580000000000002E+001,
      1.3581000000000003E+001,
      1.3582000000000003E+001,
      1.3583000000000002E+001,
      1.3584000000000003E+001,
      1.3585000000000003E+001,
      1.3586000000000002E+001,
      1.3587000000000003E+001,
      1.3588000000000003E+001,
      1.3589000000000002E+001,
      1.3590000000000002E+001,
      1.3591000000000003E+001,
      1.3592000000000002E+001,
      1.3593000000000002E+001,
      1.3594000000000003E+001,
      1.3595000000000002E+001,
      1.3596000000000002E+001,
      1.3597000000000003E+001,
      1.3598000000000003E+001,
      1.3599000000000002E+001,
      1.3600000000000001E+001,
      1.3601000000000003E+001,
      1.3602000000000002E+001,
      1.3603000000000002E+001,
      1.3604000000000003E+001,
      1.3605000000000002E+001,
      1.3606000000000002E+001,
      1.3607000000000003E+001,
      1.3608000000000002E+001,
      1.3609000000000002E+001,
      1.3610000000000003E+001,
      1.3611000000000002E+001,
      1.3612000000000002E+001,
      1.3613000000000003E+001,
      1.3614000000000003E+001,
      1.3615000000000002E+001,
      1.3616000000000003E+001,
      1.3617000000000003E+001,
      1.3618000000000002E+001,
      1.3619000000000003E+001,
      1.3620000000000003E+001,
      1.3621000000000002E+001,
      1.3622000000000002E+001,
      1.3623000000000003E+001,
      1.3624000000000002E+001,
      1.3625000000000002E+001,
      1.3626000000000003E+001,
      1.3627000000000002E+001,
      1.3628000000000002E+001,
      1.3629000000000003E+001,
      1.3630000000000003E+001,
      1.3631000000000002E+001,
      1.3632000000000001E+001,
      1.3633000000000003E+001,
      1.3634000000000002E+001,
      1.3635000000000002E+001,
      1.3636000000000003E+001,
      1.3637000000000002E+001,
      1.3638000000000002E+001,
      1.3639000000000003E+001,
      1.3640000000000002E+001,
      1.3641000000000002E+001,
      1.3642000000000003E+001,
      1.3643000000000002E+001,
      1.3644000000000002E+001,
      1.3645000000000003E+001,
      1.3646000000000003E+001,
      1.3647000000000002E+001,
      1.3648000000000003E+001,
      1.3649000000000003E+001,
      1.3650000000000002E+001,
      1.3651000000000002E+001,
      1.3652000000000003E+001,
      1.3653000000000002E+001,
      1.3654000000000002E+001,
      1.3655000000000003E+001,
      1.3656000000000002E+001,
      1.3657000000000002E+001,
      1.3658000000000003E+001,
      1.3659000000000002E+001,
      1.3660000000000002E+001,
      1.3661000000000001E+001,
      1.3662000000000003E+001,
      1.3663000000000002E+001,
      1.3664000000000001E+001,
      1.3665000000000003E+001,
      1.3666000000000002E+001,
      1.3667000000000002E+001,
      1.3668000000000003E+001,
      1.3669000000000002E+001,
      1.3670000000000002E+001,
      1.3671000000000003E+001,
      1.3672000000000002E+001,
      1.3673000000000002E+001,
      1.3674000000000003E+001,
      1.3675000000000002E+001,
      1.3676000000000002E+001,
      1.3677000000000003E+001,
      1.3678000000000003E+001,
      1.3679000000000002E+001,
      1.3680000000000003E+001,
      1.3681000000000003E+001,
      1.3682000000000002E+001,
      1.3683000000000002E+001,
      1.3684000000000003E+001,
      1.3685000000000002E+001,
      1.3686000000000002E+001,
      1.3687000000000003E+001,
      1.3688000000000002E+001,
      1.3689000000000002E+001,
      1.3690000000000003E+001,
      1.3691000000000003E+001,
      1.3692000000000002E+001,
      1.3693000000000001E+001,
      1.3694000000000003E+001,
      1.3695000000000002E+001,
      1.3696000000000002E+001,
      1.3697000000000003E+001,
      1.3698000000000002E+001,
      1.3699000000000002E+001,
      1.3700000000000003E+001,
      1.3701000000000002E+001,
      1.3702000000000002E+001,
      1.3703000000000003E+001,
      1.3704000000000002E+001,
      1.3705000000000002E+001,
      1.3706000000000003E+001,
      1.3707000000000003E+001,
      1.3708000000000002E+001,
      1.3709000000000003E+001,
      1.3710000000000003E+001,
      1.3711000000000002E+001,
      1.3712000000000003E+001,
      1.3713000000000003E+001,
      1.3714000000000002E+001,
      1.3715000000000002E+001,
      1.3716000000000003E+001,
      1.3717000000000002E+001,
      1.3718000000000002E+001,
      1.3719000000000003E+001,
      1.3720000000000002E+001,
      1.3721000000000002E+001,
      1.3722000000000003E+001,
      1.3723000000000003E+001,
      1.3724000000000002E+001,
      1.3725000000000001E+001,
      1.3726000000000003E+001,
      1.3727000000000002E+001,
      1.3728000000000002E+001,
      1.3729000000000003E+001,
      1.3730000000000002E+001,
      1.3731000000000002E+001,
      1.3732000000000003E+001,
      1.3733000000000002E+001,
      1.3734000000000002E+001,
      1.3735000000000003E+001,
      1.3736000000000002E+001,
      1.3737000000000002E+001,
      1.3738000000000003E+001,
      1.3739000000000003E+001,
      1.3740000000000002E+001,
      1.3741000000000003E+001,
      1.3742000000000003E+001,
      1.3743000000000002E+001,
      1.3744000000000003E+001,
      1.3745000000000003E+001,
      1.3746000000000002E+001,
      1.3747000000000002E+001,
      1.3748000000000003E+001,
      1.3749000000000002E+001,
      1.3750000000000002E+001,
      1.3751000000000003E+001,
      1.3752000000000002E+001,
      1.3753000000000002E+001,
      1.3754000000000003E+001,
      1.3755000000000003E+001,
      1.3756000000000002E+001,
      1.3757000000000001E+001,
      1.3758000000000003E+001,
      1.3759000000000002E+001,
      1.3760000000000002E+001,
      1.3761000000000003E+001,
      1.3762000000000002E+001,
      1.3763000000000002E+001,
      1.3764000000000003E+001,
      1.3765000000000002E+001,
      1.3766000000000002E+001,
      1.3767000000000003E+001,
      1.3768000000000002E+001,
      1.3769000000000002E+001,
      1.3770000000000003E+001,
      1.3771000000000003E+001,
      1.3772000000000002E+001,
      1.3773000000000003E+001,
      1.3774000000000003E+001,
      1.3775000000000002E+001,
      1.3776000000000002E+001,
      1.3777000000000003E+001,
      1.3778000000000002E+001,
      1.3779000000000002E+001,
      1.3780000000000003E+001,
      1.3781000000000002E+001,
      1.3782000000000002E+001,
      1.3783000000000003E+001,
      1.3784000000000002E+001,
      1.3785000000000002E+001,
      1.3786000000000001E+001,
      1.3787000000000003E+001,
      1.3788000000000002E+001,
      1.3789000000000001E+001,
      1.3790000000000003E+001,
      1.3791000000000002E+001,
      1.3792000000000002E+001,
      1.3793000000000003E+001,
      1.3794000000000002E+001,
      1.3795000000000002E+001,
      1.3796000000000003E+001,
      1.3797000000000002E+001,
      1.3798000000000002E+001,
      1.3799000000000003E+001,
      1.3800000000000002E+001,
      1.3801000000000002E+001,
      1.3802000000000003E+001,
      1.3803000000000003E+001,
      1.3804000000000002E+001,
      1.3805000000000003E+001,
      1.3806000000000003E+001,
      1.3807000000000002E+001,
      1.3808000000000002E+001,
      1.3809000000000003E+001,
      1.3810000000000002E+001,
      1.3811000000000002E+001,
      1.3812000000000003E+001,
      1.3813000000000002E+001,
      1.3814000000000002E+001,
      1.3815000000000003E+001,
      1.3816000000000003E+001,
      1.3817000000000002E+001,
      1.3818000000000001E+001,
      1.3819000000000003E+001,
      1.3820000000000002E+001,
      1.3821000000000002E+001,
      1.3822000000000003E+001,
      1.3823000000000002E+001,
      1.3824000000000002E+001,
      1.3825000000000003E+001,
      1.3826000000000002E+001,
      1.3827000000000002E+001,
      1.3828000000000003E+001,
      1.3829000000000002E+001,
      1.3830000000000002E+001,
      1.3831000000000003E+001,
      1.3832000000000003E+001,
      1.3833000000000002E+001,
      1.3834000000000003E+001,
      1.3835000000000003E+001,
      1.3836000000000002E+001,
      1.3837000000000003E+001,
      1.3838000000000003E+001,
      1.3839000000000002E+001,
      1.3840000000000002E+001,
      1.3841000000000003E+001,
      1.3842000000000002E+001,
      1.3843000000000002E+001,
      1.3844000000000003E+001,
      1.3845000000000002E+001,
      1.3846000000000002E+001,
      1.3847000000000003E+001,
      1.3848000000000003E+001,
      1.3849000000000002E+001,
      1.3850000000000001E+001,
      1.3851000000000003E+001,
      1.3852000000000002E+001,
      1.3853000000000002E+001,
      1.3854000000000003E+001,
      1.3855000000000002E+001,
      1.3856000000000002E+001,
      1.3857000000000003E+001,
      1.3858000000000002E+001,
      1.3859000000000002E+001,
      1.3860000000000003E+001,
      1.3861000000000002E+001,
      1.3862000000000002E+001,
      1.3863000000000003E+001,
      1.3864000000000003E+001,
      1.3865000000000002E+001,
      1.3866000000000003E+001,
      1.3867000000000003E+001,
      1.3868000000000002E+001,
      1.3869000000000003E+001,
      1.3870000000000003E+001,
      1.3871000000000002E+001,
      1.3872000000000002E+001,
      1.3873000000000003E+001,
      1.3874000000000002E+001,
      1.3875000000000002E+001,
      1.3876000000000003E+001,
      1.3877000000000002E+001,
      1.3878000000000002E+001,
      1.3879000000000003E+001,
      1.3880000000000003E+001,
      1.3881000000000002E+001,
      1.3882000000000001E+001,
      1.3883000000000003E+001,
      1.3884000000000002E+001,
      1.3885000000000002E+001,
      1.3886000000000003E+001,
      1.3887000000000002E+001,
      1.3888000000000002E+001,
      1.3889000000000003E+001,
      1.3890000000000002E+001,
      1.3891000000000002E+001,
      1.3892000000000003E+001,
      1.3893000000000002E+001,
      1.3894000000000002E+001,
      1.3895000000000003E+001,
      1.3896000000000003E+001,
      1.3897000000000002E+001,
      1.3898000000000003E+001,
      1.3899000000000003E+001,
      1.3900000000000002E+001,
      1.3901000000000002E+001,
      1.3902000000000003E+001,
      1.3903000000000002E+001,
      1.3904000000000002E+001,
      1.3905000000000003E+001,
      1.3906000000000002E+001,
      1.3907000000000002E+001,
      1.3908000000000003E+001,
      1.3909000000000002E+001,
      1.3910000000000002E+001,
      1.3911000000000001E+001,
      1.3912000000000003E+001,
      1.3913000000000002E+001,
      1.3914000000000001E+001,
      1.3915000000000003E+001,
      1.3916000000000002E+001,
      1.3917000000000002E+001,
      1.3918000000000003E+001,
      1.3919000000000002E+001,
      1.3920000000000002E+001,
      1.3921000000000003E+001,
      1.3922000000000002E+001,
      1.3923000000000002E+001,
      1.3924000000000003E+001,
      1.3925000000000002E+001,
      1.3926000000000002E+001,
      1.3927000000000003E+001,
      1.3928000000000003E+001,
      1.3929000000000002E+001,
      1.3930000000000003E+001,
      1.3931000000000003E+001,
      1.3932000000000002E+001,
      1.3933000000000002E+001,
      1.3934000000000003E+001,
      1.3935000000000002E+001,
      1.3936000000000002E+001,
      1.3937000000000003E+001,
      1.3938000000000002E+001,
      1.3939000000000002E+001,
      1.3940000000000003E+001,
      1.3941000000000003E+001,
      1.3942000000000002E+001,
      1.3943000000000001E+001,
      1.3944000000000003E+001,
      1.3945000000000002E+001,
      1.3946000000000002E+001,
      1.3947000000000003E+001,
      1.3948000000000002E+001,
      1.3949000000000002E+001,
      1.3950000000000003E+001,
      1.3951000000000002E+001,
      1.3952000000000002E+001,
      1.3953000000000003E+001,
      1.3954000000000002E+001,
      1.3955000000000002E+001,
      1.3956000000000003E+001,
      1.3957000000000003E+001,
      1.3958000000000002E+001,
      1.3959000000000003E+001,
      1.3960000000000003E+001,
      1.3961000000000002E+001,
      1.3962000000000003E+001,
      1.3963000000000003E+001,
      1.3964000000000002E+001,
      1.3965000000000002E+001,
      1.3966000000000003E+001,
      1.3967000000000002E+001,
      1.3968000000000002E+001,
      1.3969000000000003E+001,
      1.3970000000000002E+001,
      1.3971000000000002E+001,
      1.3972000000000003E+001,
      1.3973000000000003E+001,
      1.3974000000000002E+001,
      1.3975000000000001E+001,
      1.3976000000000003E+001,
      1.3977000000000002E+001,
      1.3978000000000002E+001,
      1.3979000000000003E+001,
      1.3980000000000002E+001,
      1.3981000000000002E+001,
      1.3982000000000003E+001,
      1.3983000000000002E+001,
      1.3984000000000002E+001,
      1.3985000000000003E+001,
      1.3986000000000002E+001,
      1.3987000000000002E+001,
      1.3988000000000003E+001,
      1.3989000000000003E+001,
      1.3990000000000002E+001,
      1.3991000000000003E+001,
      1.3992000000000003E+001,
      1.3993000000000002E+001,
      1.3994000000000003E+001,
      1.3995000000000003E+001,
      1.3996000000000002E+001,
      1.3997000000000002E+001,
      1.3998000000000003E+001,
      1.3999000000000002E+001,
      1.4000000000000002E+001,
      1.4001000000000003E+001,
      1.4002000000000002E+001,
      1.4003000000000002E+001,
      1.4004000000000003E+001,
      1.4005000000000003E+001,
      1.4006000000000002E+001,
      1.4007000000000001E+001,
      1.4008000000000003E+001,
      1.4009000000000002E+001,
      1.4010000000000002E+001,
      1.4011000000000003E+001,
      1.4012000000000002E+001,
      1.4013000000000002E+001,
      1.4014000000000003E+001,
      1.4015000000000002E+001,
      1.4016000000000002E+001,
      1.4017000000000003E+001,
      1.4018000000000002E+001,
      1.4019000000000002E+001,
      1.4020000000000003E+001,
      1.4021000000000003E+001,
      1.4022000000000002E+001,
      1.4023000000000003E+001,
      1.4024000000000003E+001,
      1.4025000000000002E+001,
      1.4026000000000003E+001,
      1.4027000000000003E+001,
      1.4028000000000002E+001,
      1.4029000000000002E+001,
      1.4030000000000003E+001,
      1.4031000000000002E+001,
      1.4032000000000002E+001,
      1.4033000000000003E+001,
      1.4034000000000002E+001,
      1.4035000000000002E+001,
      1.4036000000000001E+001,
      1.4037000000000003E+001,
      1.4038000000000002E+001,
      1.4039000000000001E+001,
      1.4040000000000003E+001,
      1.4041000000000002E+001,
      1.4042000000000002E+001,
      1.4043000000000003E+001,
      1.4044000000000002E+001,
      1.4045000000000002E+001,
      1.4046000000000003E+001,
      1.4047000000000002E+001,
      1.4048000000000002E+001,
      1.4049000000000003E+001,
      1.4050000000000002E+001,
      1.4051000000000002E+001,
      1.4052000000000003E+001,
      1.4053000000000003E+001,
      1.4054000000000002E+001,
      1.4055000000000003E+001,
      1.4056000000000003E+001,
      1.4057000000000002E+001,
      1.4058000000000002E+001,
      1.4059000000000003E+001,
      1.4060000000000002E+001,
      1.4061000000000002E+001,
      1.4062000000000003E+001,
      1.4063000000000002E+001,
      1.4064000000000002E+001,
      1.4065000000000003E+001,
      1.4066000000000003E+001,
      1.4067000000000002E+001,
      1.4068000000000001E+001,
      1.4069000000000003E+001,
      1.4070000000000002E+001,
      1.4071000000000002E+001,
      1.4072000000000003E+001,
      1.4073000000000002E+001,
      1.4074000000000002E+001,
      1.4075000000000003E+001,
      1.4076000000000002E+001,
      1.4077000000000002E+001,
      1.4078000000000003E+001,
      1.4079000000000002E+001,
      1.4080000000000002E+001,
      1.4081000000000003E+001,
      1.4082000000000003E+001,
      1.4083000000000002E+001,
      1.4084000000000003E+001,
      1.4085000000000003E+001,
      1.4086000000000002E+001,
      1.4087000000000003E+001,
      1.4088000000000003E+001,
      1.4089000000000002E+001,
      1.4090000000000002E+001,
      1.4091000000000003E+001,
      1.4092000000000002E+001,
      1.4093000000000002E+001,
      1.4094000000000003E+001,
      1.4095000000000002E+001,
      1.4096000000000002E+001,
      1.4097000000000003E+001,
      1.4098000000000003E+001,
      1.4099000000000002E+001,
      1.4100000000000001E+001,
      1.4101000000000003E+001,
      1.4102000000000002E+001,
      1.4103000000000002E+001,
      1.4104000000000003E+001,
      1.4105000000000002E+001,
      1.4106000000000002E+001,
      1.4107000000000003E+001,
      1.4108000000000002E+001,
      1.4109000000000002E+001,
      1.4110000000000003E+001,
      1.4111000000000002E+001,
      1.4112000000000002E+001,
      1.4113000000000003E+001,
      1.4114000000000003E+001,
      1.4115000000000002E+001,
      1.4116000000000003E+001,
      1.4117000000000003E+001,
      1.4118000000000002E+001,
      1.4119000000000003E+001,
      1.4120000000000003E+001,
      1.4121000000000002E+001,
      1.4122000000000002E+001,
      1.4123000000000003E+001,
      1.4124000000000002E+001,
      1.4125000000000002E+001,
      1.4126000000000003E+001,
      1.4127000000000002E+001,
      1.4128000000000002E+001,
      1.4129000000000003E+001,
      1.4130000000000003E+001,
      1.4131000000000002E+001,
      1.4132000000000001E+001,
      1.4133000000000003E+001,
      1.4134000000000002E+001,
      1.4135000000000002E+001,
      1.4136000000000003E+001,
      1.4137000000000002E+001,
      1.4138000000000002E+001,
      1.4139000000000003E+001,
      1.4140000000000002E+001,
      1.4141000000000002E+001,
      1.4142000000000003E+001,
      1.4143000000000002E+001,
      1.4144000000000002E+001,
      1.4145000000000003E+001,
      1.4146000000000003E+001,
      1.4147000000000002E+001,
      1.4148000000000003E+001,
      1.4149000000000003E+001,
      1.4150000000000002E+001,
      1.4151000000000003E+001,
      1.4152000000000003E+001,
      1.4153000000000002E+001,
      1.4154000000000002E+001,
      1.4155000000000003E+001,
      1.4156000000000002E+001,
      1.4157000000000002E+001,
      1.4158000000000003E+001,
      1.4159000000000002E+001,
      1.4160000000000002E+001,
      1.4161000000000001E+001,
      1.4162000000000003E+001,
      1.4163000000000002E+001,
      1.4164000000000001E+001,
      1.4165000000000003E+001,
      1.4166000000000002E+001,
      1.4167000000000002E+001,
      1.4168000000000003E+001,
      1.4169000000000002E+001,
      1.4170000000000002E+001,
      1.4171000000000003E+001,
      1.4172000000000002E+001,
      1.4173000000000002E+001,
      1.4174000000000003E+001,
      1.4175000000000002E+001,
      1.4176000000000002E+001,
      1.4177000000000003E+001,
      1.4178000000000003E+001,
      1.4179000000000002E+001,
      1.4180000000000003E+001,
      1.4181000000000003E+001,
      1.4182000000000002E+001,
      1.4183000000000002E+001,
      1.4184000000000003E+001,
      1.4185000000000002E+001,
      1.4186000000000002E+001,
      1.4187000000000003E+001,
      1.4188000000000002E+001,
      1.4189000000000002E+001,
      1.4190000000000003E+001,
      1.4191000000000003E+001,
      1.4192000000000002E+001,
      1.4193000000000001E+001,
      1.4194000000000003E+001,
      1.4195000000000002E+001,
      1.4196000000000002E+001,
      1.4197000000000003E+001,
      1.4198000000000002E+001,
      1.4199000000000002E+001,
      1.4200000000000003E+001,
      1.4201000000000002E+001,
      1.4202000000000002E+001,
      1.4203000000000003E+001,
      1.4204000000000002E+001,
      1.4205000000000002E+001,
      1.4206000000000003E+001,
      1.4207000000000003E+001,
      1.4208000000000002E+001,
      1.4209000000000003E+001,
      1.4210000000000003E+001,
      1.4211000000000002E+001,
      1.4212000000000003E+001,
      1.4213000000000003E+001,
      1.4214000000000002E+001,
      1.4215000000000002E+001,
      1.4216000000000003E+001,
      1.4217000000000002E+001,
      1.4218000000000002E+001,
      1.4219000000000003E+001,
      1.4220000000000002E+001,
      1.4221000000000002E+001,
      1.4222000000000003E+001,
      1.4223000000000003E+001,
      1.4224000000000002E+001,
      1.4225000000000001E+001,
      1.4226000000000003E+001,
      1.4227000000000002E+001,
      1.4228000000000002E+001,
      1.4229000000000003E+001,
      1.4230000000000002E+001,
      1.4231000000000002E+001,
      1.4232000000000003E+001,
      1.4233000000000002E+001,
      1.4234000000000002E+001,
      1.4235000000000003E+001,
      1.4236000000000002E+001,
      1.4237000000000002E+001,
      1.4238000000000003E+001,
      1.4239000000000003E+001,
      1.4240000000000002E+001,
      1.4241000000000003E+001,
      1.4242000000000003E+001,
      1.4243000000000002E+001,
      1.4244000000000003E+001,
      1.4245000000000003E+001,
      1.4246000000000002E+001,
      1.4247000000000002E+001,
      1.4248000000000003E+001,
      1.4249000000000002E+001,
      1.4250000000000002E+001,
      1.4251000000000003E+001,
      1.4252000000000002E+001,
      1.4253000000000002E+001,
      1.4254000000000003E+001,
      1.4255000000000003E+001,
      1.4256000000000002E+001,
      1.4257000000000001E+001,
      1.4258000000000003E+001,
      1.4259000000000002E+001,
      1.4260000000000002E+001,
      1.4261000000000003E+001,
      1.4262000000000002E+001,
      1.4263000000000002E+001,
      1.4264000000000003E+001,
      1.4265000000000002E+001,
      1.4266000000000002E+001,
      1.4267000000000003E+001,
      1.4268000000000002E+001,
      1.4269000000000002E+001,
      1.4270000000000003E+001,
      1.4271000000000003E+001,
      1.4272000000000002E+001,
      1.4273000000000003E+001,
      1.4274000000000003E+001,
      1.4275000000000002E+001,
      1.4276000000000003E+001,
      1.4277000000000003E+001,
      1.4278000000000002E+001,
      1.4279000000000002E+001,
      1.4280000000000003E+001,
      1.4281000000000002E+001,
      1.4282000000000002E+001,
      1.4283000000000003E+001,
      1.4284000000000002E+001,
      1.4285000000000002E+001,
      1.4286000000000001E+001,
      1.4287000000000003E+001,
      1.4288000000000002E+001,
      1.4289000000000001E+001,
      1.4290000000000003E+001,
      1.4291000000000002E+001,
      1.4292000000000002E+001,
      1.4293000000000003E+001,
      1.4294000000000002E+001,
      1.4295000000000002E+001,
      1.4296000000000003E+001,
      1.4297000000000002E+001,
      1.4298000000000002E+001,
      1.4299000000000003E+001,
      1.4300000000000002E+001,
      1.4301000000000002E+001,
      1.4302000000000003E+001,
      1.4303000000000003E+001,
      1.4304000000000002E+001,
      1.4305000000000003E+001,
      1.4306000000000003E+001,
      1.4307000000000002E+001,
      1.4308000000000002E+001,
      1.4309000000000003E+001,
      1.4310000000000002E+001,
      1.4311000000000002E+001,
      1.4312000000000003E+001,
      1.4313000000000002E+001,
      1.4314000000000002E+001,
      1.4315000000000003E+001,
      1.4316000000000003E+001,
      1.4317000000000002E+001,
      1.4318000000000001E+001,
      1.4319000000000003E+001,
      1.4320000000000002E+001,
      1.4321000000000002E+001,
      1.4322000000000003E+001,
      1.4323000000000002E+001,
      1.4324000000000002E+001,
      1.4325000000000003E+001,
      1.4326000000000002E+001,
      1.4327000000000002E+001,
      1.4328000000000003E+001,
      1.4329000000000002E+001,
      1.4330000000000002E+001,
      1.4331000000000003E+001,
      1.4332000000000003E+001,
      1.4333000000000002E+001,
      1.4334000000000003E+001,
      1.4335000000000003E+001,
      1.4336000000000002E+001,
      1.4337000000000003E+001,
      1.4338000000000003E+001,
      1.4339000000000002E+001,
      1.4340000000000002E+001,
      1.4341000000000003E+001,
      1.4342000000000002E+001,
      1.4343000000000002E+001,
      1.4344000000000003E+001,
      1.4345000000000002E+001,
      1.4346000000000002E+001,
      1.4347000000000003E+001,
      1.4348000000000003E+001,
      1.4349000000000002E+001,
      1.4350000000000001E+001,
      1.4351000000000003E+001,
      1.4352000000000002E+001,
      1.4353000000000002E+001,
      1.4354000000000003E+001,
      1.4355000000000002E+001,
      1.4356000000000002E+001,
      1.4357000000000003E+001,
      1.4358000000000002E+001,
      1.4359000000000002E+001,
      1.4360000000000003E+001,
      1.4361000000000002E+001,
      1.4362000000000002E+001,
      1.4363000000000003E+001,
      1.4364000000000003E+001,
      1.4365000000000002E+001,
      1.4366000000000003E+001,
      1.4367000000000003E+001,
      1.4368000000000002E+001,
      1.4369000000000003E+001,
      1.4370000000000003E+001,
      1.4371000000000002E+001,
      1.4372000000000002E+001,
      1.4373000000000003E+001,
      1.4374000000000002E+001,
      1.4375000000000002E+001,
      1.4376000000000003E+001,
      1.4377000000000002E+001,
      1.4378000000000002E+001,
      1.4379000000000003E+001,
      1.4380000000000003E+001,
      1.4381000000000002E+001,
      1.4382000000000001E+001,
      1.4383000000000003E+001,
      1.4384000000000002E+001,
      1.4385000000000002E+001,
      1.4386000000000003E+001,
      1.4387000000000002E+001,
      1.4388000000000002E+001,
      1.4389000000000003E+001,
      1.4390000000000002E+001,
      1.4391000000000002E+001,
      1.4392000000000003E+001,
      1.4393000000000002E+001,
      1.4394000000000002E+001,
      1.4395000000000003E+001,
      1.4396000000000003E+001,
      1.4397000000000002E+001,
      1.4398000000000003E+001,
      1.4399000000000003E+001,
      1.4400000000000002E+001,
      1.4401000000000003E+001,
      1.4402000000000003E+001,
      1.4403000000000002E+001,
      1.4404000000000002E+001,
      1.4405000000000003E+001,
      1.4406000000000002E+001,
      1.4407000000000002E+001,
      1.4408000000000003E+001,
      1.4409000000000002E+001,
      1.4410000000000002E+001,
      1.4411000000000001E+001,
      1.4412000000000003E+001,
      1.4413000000000002E+001,
      1.4414000000000001E+001,
      1.4415000000000003E+001,
      1.4416000000000002E+001,
      1.4417000000000002E+001,
      1.4418000000000003E+001,
      1.4419000000000002E+001,
      1.4420000000000002E+001,
      1.4421000000000003E+001,
      1.4422000000000002E+001,
      1.4423000000000002E+001,
      1.4424000000000003E+001,
      1.4425000000000002E+001,
      1.4426000000000002E+001,
      1.4427000000000003E+001,
      1.4428000000000003E+001,
      1.4429000000000002E+001,
      1.4430000000000003E+001,
      1.4431000000000003E+001,
      1.4432000000000002E+001,
      1.4433000000000002E+001,
      1.4434000000000003E+001,
      1.4435000000000002E+001,
      1.4436000000000002E+001,
      1.4437000000000003E+001,
      1.4438000000000002E+001,
      1.4439000000000002E+001,
      1.4440000000000003E+001,
      1.4441000000000003E+001,
      1.4442000000000002E+001,
      1.4443000000000001E+001,
      1.4444000000000003E+001,
      1.4445000000000002E+001,
      1.4446000000000002E+001,
      1.4447000000000003E+001,
      1.4448000000000002E+001,
      1.4449000000000002E+001,
      1.4450000000000003E+001,
      1.4451000000000002E+001,
      1.4452000000000002E+001,
      1.4453000000000003E+001,
      1.4454000000000002E+001,
      1.4455000000000002E+001,
      1.4456000000000003E+001,
      1.4457000000000003E+001,
      1.4458000000000002E+001,
      1.4459000000000003E+001,
      1.4460000000000003E+001,
      1.4461000000000002E+001,
      1.4462000000000003E+001,
      1.4463000000000003E+001,
      1.4464000000000002E+001,
      1.4465000000000002E+001,
      1.4466000000000003E+001,
      1.4467000000000002E+001,
      1.4468000000000002E+001,
      1.4469000000000003E+001,
      1.4470000000000002E+001,
      1.4471000000000002E+001,
      1.4472000000000003E+001,
      1.4473000000000003E+001,
      1.4474000000000002E+001,
      1.4475000000000001E+001,
      1.4476000000000003E+001,
      1.4477000000000002E+001,
      1.4478000000000002E+001,
      1.4479000000000003E+001,
      1.4480000000000002E+001,
      1.4481000000000002E+001,
      1.4482000000000003E+001,
      1.4483000000000002E+001,
      1.4484000000000002E+001,
      1.4485000000000003E+001,
      1.4486000000000002E+001,
      1.4487000000000002E+001,
      1.4488000000000003E+001,
      1.4489000000000003E+001,
      1.4490000000000002E+001,
      1.4491000000000003E+001,
      1.4492000000000003E+001,
      1.4493000000000002E+001,
      1.4494000000000003E+001,
      1.4495000000000003E+001,
      1.4496000000000002E+001,
      1.4497000000000002E+001,
      1.4498000000000003E+001,
      1.4499000000000002E+001,
      1.4500000000000002E+001,
      1.4501000000000003E+001,
      1.4502000000000002E+001,
      1.4503000000000002E+001,
      1.4504000000000003E+001,
      1.4505000000000003E+001,
      1.4506000000000002E+001,
      1.4507000000000001E+001,
      1.4508000000000003E+001,
      1.4509000000000002E+001,
      1.4510000000000002E+001,
      1.4511000000000003E+001,
      1.4512000000000002E+001,
      1.4513000000000002E+001,
      1.4514000000000003E+001,
      1.4515000000000002E+001,
      1.4516000000000002E+001,
      1.4517000000000003E+001,
      1.4518000000000002E+001,
      1.4519000000000002E+001,
      1.4520000000000003E+001,
      1.4521000000000003E+001,
      1.4522000000000002E+001,
      1.4523000000000003E+001,
      1.4524000000000003E+001,
      1.4525000000000002E+001,
      1.4526000000000003E+001,
      1.4527000000000003E+001,
      1.4528000000000002E+001,
      1.4529000000000002E+001,
      1.4530000000000003E+001,
      1.4531000000000002E+001,
      1.4532000000000002E+001,
      1.4533000000000003E+001,
      1.4534000000000002E+001,
      1.4535000000000002E+001,
      1.4536000000000003E+001,
      1.4537000000000003E+001,
      1.4538000000000002E+001,
      1.4539000000000001E+001,
      1.4540000000000003E+001,
      1.4541000000000002E+001,
      1.4542000000000002E+001,
      1.4543000000000003E+001,
      1.4544000000000002E+001,
      1.4545000000000002E+001,
      1.4546000000000003E+001,
      1.4547000000000002E+001,
      1.4548000000000002E+001,
      1.4549000000000003E+001,
      1.4550000000000002E+001,
      1.4551000000000002E+001,
      1.4552000000000003E+001,
      1.4553000000000003E+001,
      1.4554000000000002E+001,
      1.4555000000000003E+001,
      1.4556000000000003E+001,
      1.4557000000000002E+001,
      1.4558000000000002E+001,
      1.4559000000000003E+001,
      1.4560000000000002E+001,
      1.4561000000000002E+001,
      1.4562000000000003E+001,
      1.4563000000000002E+001,
      1.4564000000000002E+001,
      1.4565000000000003E+001,
      1.4566000000000003E+001,
      1.4567000000000002E+001,
      1.4568000000000003E+001,
      1.4569000000000003E+001,
      1.4570000000000002E+001,
      1.4571000000000002E+001,
      1.4572000000000003E+001,
      1.4573000000000002E+001,
      1.4574000000000002E+001,
      1.4575000000000003E+001,
      1.4576000000000002E+001,
      1.4577000000000002E+001,
      1.4578000000000003E+001,
      1.4579000000000002E+001,
      1.4580000000000002E+001,
      1.4581000000000003E+001,
      1.4582000000000003E+001,
      1.4583000000000002E+001,
      1.4584000000000003E+001,
      1.4585000000000003E+001,
      1.4586000000000002E+001,
      1.4587000000000003E+001,
      1.4588000000000003E+001,
      1.4589000000000002E+001,
      1.4590000000000002E+001,
      1.4591000000000003E+001,
      1.4592000000000002E+001,
      1.4593000000000002E+001,
      1.4594000000000003E+001,
      1.4595000000000002E+001,
      1.4596000000000002E+001,
      1.4597000000000003E+001,
      1.4598000000000003E+001,
      1.4599000000000002E+001,
      1.4600000000000003E+001,
      1.4601000000000003E+001,
      1.4602000000000002E+001,
      1.4603000000000002E+001,
      1.4604000000000003E+001,
      1.4605000000000002E+001,
      1.4606000000000002E+001,
      1.4607000000000003E+001,
      1.4608000000000002E+001,
      1.4609000000000002E+001,
      1.4610000000000003E+001,
      1.4611000000000002E+001,
      1.4612000000000002E+001,
      1.4613000000000003E+001,
      1.4614000000000003E+001,
      1.4615000000000002E+001,
      1.4616000000000003E+001,
      1.4617000000000003E+001,
      1.4618000000000002E+001,
      1.4619000000000002E+001,
      1.4620000000000003E+001,
      1.4621000000000002E+001,
      1.4622000000000002E+001,
      1.4623000000000003E+001,
      1.4624000000000002E+001,
      1.4625000000000002E+001,
      1.4626000000000003E+001,
      1.4627000000000002E+001,
      1.4628000000000002E+001,
      1.4629000000000003E+001,
      1.4630000000000003E+001,
      1.4631000000000002E+001,
      1.4632000000000001E+001,
      1.4633000000000003E+001,
      1.4634000000000002E+001,
      1.4635000000000002E+001,
      1.4636000000000003E+001,
      1.4637000000000002E+001,
      1.4638000000000002E+001,
      1.4639000000000003E+001,
      1.4640000000000002E+001,
      1.4641000000000002E+001,
      1.4642000000000003E+001,
      1.4643000000000002E+001,
      1.4644000000000002E+001,
      1.4645000000000003E+001,
      1.4646000000000003E+001,
      1.4647000000000002E+001,
      1.4648000000000003E+001,
      1.4649000000000003E+001,
      1.4650000000000002E+001,
      1.4651000000000002E+001,
      1.4652000000000003E+001,
      1.4653000000000002E+001,
      1.4654000000000002E+001,
      1.4655000000000003E+001,
      1.4656000000000002E+001,
      1.4657000000000002E+001,
      1.4658000000000003E+001,
      1.4659000000000002E+001,
      1.4660000000000002E+001,
      1.4661000000000003E+001,
      1.4662000000000003E+001,
      1.4663000000000002E+001,
      1.4664000000000001E+001,
      1.4665000000000003E+001,
      1.4666000000000002E+001,
      1.4667000000000002E+001,
      1.4668000000000003E+001,
      1.4669000000000002E+001,
      1.4670000000000002E+001,
      1.4671000000000003E+001,
      1.4672000000000002E+001,
      1.4673000000000002E+001,
      1.4674000000000003E+001,
      1.4675000000000002E+001,
      1.4676000000000002E+001,
      1.4677000000000003E+001,
      1.4678000000000003E+001,
      1.4679000000000002E+001,
      1.4680000000000003E+001,
      1.4681000000000003E+001,
      1.4682000000000002E+001,
      1.4683000000000002E+001,
      1.4684000000000003E+001,
      1.4685000000000002E+001,
      1.4686000000000002E+001,
      1.4687000000000003E+001,
      1.4688000000000002E+001,
      1.4689000000000002E+001,
      1.4690000000000003E+001,
      1.4691000000000003E+001,
      1.4692000000000002E+001,
      1.4693000000000003E+001,
      1.4694000000000003E+001,
      1.4695000000000002E+001,
      1.4696000000000002E+001,
      1.4697000000000003E+001,
      1.4698000000000002E+001,
      1.4699000000000002E+001,
      1.4700000000000003E+001,
      1.4701000000000002E+001,
      1.4702000000000002E+001,
      1.4703000000000003E+001,
      1.4704000000000002E+001,
      1.4705000000000002E+001,
      1.4706000000000003E+001,
      1.4707000000000003E+001,
      1.4708000000000002E+001,
      1.4709000000000003E+001,
      1.4710000000000003E+001,
      1.4711000000000002E+001,
      1.4712000000000003E+001,
      1.4713000000000003E+001,
      1.4714000000000002E+001,
      1.4715000000000002E+001,
      1.4716000000000003E+001,
      1.4717000000000002E+001,
      1.4718000000000002E+001,
      1.4719000000000003E+001,
      1.4720000000000002E+001,
      1.4721000000000002E+001,
      1.4722000000000003E+001,
      1.4723000000000003E+001,
      1.4724000000000002E+001,
      1.4725000000000003E+001,
      1.4726000000000003E+001,
      1.4727000000000002E+001,
      1.4728000000000002E+001,
      1.4729000000000003E+001,
      1.4730000000000002E+001,
      1.4731000000000002E+001,
      1.4732000000000003E+001,
      1.4733000000000002E+001,
      1.4734000000000002E+001,
      1.4735000000000003E+001,
      1.4736000000000002E+001,
      1.4737000000000002E+001,
      1.4738000000000003E+001,
      1.4739000000000003E+001,
      1.4740000000000002E+001,
      1.4741000000000003E+001,
      1.4742000000000003E+001,
      1.4743000000000002E+001,
      1.4744000000000002E+001,
      1.4745000000000003E+001,
      1.4746000000000002E+001,
      1.4747000000000002E+001,
      1.4748000000000003E+001,
      1.4749000000000002E+001,
      1.4750000000000002E+001,
      1.4751000000000003E+001,
      1.4752000000000002E+001,
      1.4753000000000002E+001,
      1.4754000000000003E+001,
      1.4755000000000003E+001,
      1.4756000000000002E+001,
      1.4757000000000001E+001,
      1.4758000000000003E+001,
      1.4759000000000002E+001,
      1.4760000000000002E+001,
      1.4761000000000003E+001,
      1.4762000000000002E+001,
      1.4763000000000002E+001,
      1.4764000000000003E+001,
      1.4765000000000002E+001,
      1.4766000000000002E+001,
      1.4767000000000003E+001,
      1.4768000000000002E+001,
      1.4769000000000002E+001,
      1.4770000000000003E+001,
      1.4771000000000003E+001,
      1.4772000000000002E+001,
      1.4773000000000003E+001,
      1.4774000000000003E+001,
      1.4775000000000002E+001,
      1.4776000000000002E+001,
      1.4777000000000003E+001,
      1.4778000000000002E+001,
      1.4779000000000002E+001,
      1.4780000000000003E+001,
      1.4781000000000002E+001,
      1.4782000000000002E+001,
      1.4783000000000003E+001,
      1.4784000000000002E+001,
      1.4785000000000002E+001,
      1.4786000000000003E+001,
      1.4787000000000003E+001,
      1.4788000000000002E+001,
      1.4789000000000001E+001,
      1.4790000000000003E+001,
      1.4791000000000002E+001,
      1.4792000000000002E+001,
      1.4793000000000003E+001,
      1.4794000000000002E+001,
      1.4795000000000002E+001,
      1.4796000000000003E+001,
      1.4797000000000002E+001,
      1.4798000000000002E+001,
      1.4799000000000003E+001,
      1.4800000000000002E+001,
      1.4801000000000002E+001,
      1.4802000000000003E+001,
      1.4803000000000003E+001,
      1.4804000000000002E+001,
      1.4805000000000003E+001,
      1.4806000000000003E+001,
      1.4807000000000002E+001,
      1.4808000000000002E+001,
      1.4809000000000003E+001,
      1.4810000000000002E+001,
      1.4811000000000002E+001,
      1.4812000000000003E+001,
      1.4813000000000002E+001,
      1.4814000000000002E+001,
      1.4815000000000003E+001,
      1.4816000000000003E+001,
      1.4817000000000002E+001,
      1.4818000000000003E+001,
      1.4819000000000003E+001,
      1.4820000000000002E+001,
      1.4821000000000002E+001,
      1.4822000000000003E+001,
      1.4823000000000002E+001,
      1.4824000000000002E+001,
      1.4825000000000003E+001,
      1.4826000000000002E+001,
      1.4827000000000002E+001,
      1.4828000000000003E+001,
      1.4829000000000002E+001,
      1.4830000000000002E+001,
      1.4831000000000003E+001,
      1.4832000000000003E+001,
      1.4833000000000002E+001,
      1.4834000000000003E+001,
      1.4835000000000003E+001,
      1.4836000000000002E+001,
      1.4837000000000003E+001,
      1.4838000000000003E+001,
      1.4839000000000002E+001,
      1.4840000000000002E+001,
      1.4841000000000003E+001,
      1.4842000000000002E+001,
      1.4843000000000002E+001,
      1.4844000000000003E+001,
      1.4845000000000002E+001,
      1.4846000000000002E+001,
      1.4847000000000003E+001,
      1.4848000000000003E+001,
      1.4849000000000002E+001,
      1.4850000000000003E+001,
      1.4851000000000003E+001,
      1.4852000000000002E+001,
      1.4853000000000002E+001,
      1.4854000000000003E+001,
      1.4855000000000002E+001,
      1.4856000000000002E+001,
      1.4857000000000003E+001,
      1.4858000000000002E+001,
      1.4859000000000002E+001,
      1.4860000000000003E+001,
      1.4861000000000002E+001,
      1.4862000000000002E+001,
      1.4863000000000003E+001,
      1.4864000000000003E+001,
      1.4865000000000002E+001,
      1.4866000000000003E+001,
      1.4867000000000003E+001,
      1.4868000000000002E+001,
      1.4869000000000002E+001,
      1.4870000000000003E+001,
      1.4871000000000002E+001,
      1.4872000000000002E+001,
      1.4873000000000003E+001,
      1.4874000000000002E+001,
      1.4875000000000002E+001,
      1.4876000000000003E+001,
      1.4877000000000002E+001,
      1.4878000000000002E+001,
      1.4879000000000003E+001,
      1.4880000000000003E+001,
      1.4881000000000002E+001,
      1.4882000000000001E+001,
      1.4883000000000003E+001,
      1.4884000000000002E+001,
      1.4885000000000002E+001,
      1.4886000000000003E+001,
      1.4887000000000002E+001,
      1.4888000000000002E+001,
      1.4889000000000003E+001,
      1.4890000000000002E+001,
      1.4891000000000002E+001,
      1.4892000000000003E+001,
      1.4893000000000002E+001,
      1.4894000000000002E+001,
      1.4895000000000003E+001,
      1.4896000000000003E+001,
      1.4897000000000002E+001,
      1.4898000000000003E+001,
      1.4899000000000003E+001,
      1.4900000000000002E+001,
      1.4901000000000002E+001,
      1.4902000000000003E+001,
      1.4903000000000002E+001,
      1.4904000000000002E+001,
      1.4905000000000003E+001,
      1.4906000000000002E+001,
      1.4907000000000002E+001,
      1.4908000000000003E+001,
      1.4909000000000002E+001,
      1.4910000000000002E+001,
      1.4911000000000003E+001,
      1.4912000000000003E+001,
      1.4913000000000002E+001,
      1.4914000000000001E+001,
      1.4915000000000003E+001,
      1.4916000000000002E+001,
      1.4917000000000002E+001,
      1.4918000000000003E+001,
      1.4919000000000002E+001,
      1.4920000000000002E+001,
      1.4921000000000003E+001,
      1.4922000000000002E+001,
      1.4923000000000002E+001,
      1.4924000000000003E+001,
      1.4925000000000002E+001,
      1.4926000000000002E+001,
      1.4927000000000003E+001,
      1.4928000000000003E+001,
      1.4929000000000002E+001,
      1.4930000000000003E+001,
      1.4931000000000003E+001,
      1.4932000000000002E+001,
      1.4933000000000002E+001,
      1.4934000000000003E+001,
      1.4935000000000002E+001,
      1.4936000000000002E+001,
      1.4937000000000003E+001,
      1.4938000000000002E+001,
      1.4939000000000002E+001,
      1.4940000000000003E+001,
      1.4941000000000003E+001,
      1.4942000000000002E+001,
      1.4943000000000003E+001,
      1.4944000000000003E+001,
      1.4945000000000002E+001,
      1.4946000000000002E+001,
      1.4947000000000003E+001,
      1.4948000000000002E+001,
      1.4949000000000002E+001,
      1.4950000000000003E+001,
      1.4951000000000002E+001,
      1.4952000000000002E+001,
      1.4953000000000003E+001,
      1.4954000000000002E+001,
      1.4955000000000002E+001,
      1.4956000000000003E+001,
      1.4957000000000003E+001,
      1.4958000000000002E+001,
      1.4959000000000003E+001,
      1.4960000000000003E+001,
      1.4961000000000002E+001,
      1.4962000000000003E+001,
      1.4963000000000003E+001,
      1.4964000000000002E+001,
      1.4965000000000002E+001,
      1.4966000000000003E+001,
      1.4967000000000002E+001,
      1.4968000000000002E+001,
      1.4969000000000003E+001,
      1.4970000000000002E+001,
      1.4971000000000002E+001,
      1.4972000000000003E+001,
      1.4973000000000003E+001,
      1.4974000000000002E+001,
      1.4975000000000003E+001,
      1.4976000000000003E+001,
      1.4977000000000002E+001,
      1.4978000000000002E+001,
      1.4979000000000003E+001,
      1.4980000000000002E+001,
      1.4981000000000002E+001,
      1.4982000000000003E+001,
      1.4983000000000002E+001,
      1.4984000000000002E+001,
      1.4985000000000003E+001,
      1.4986000000000002E+001,
      1.4987000000000002E+001,
      1.4988000000000003E+001,
      1.4989000000000003E+001,
      1.4990000000000002E+001,
      1.4991000000000003E+001,
      1.4992000000000003E+001,
      1.4993000000000002E+001,
      1.4994000000000002E+001,
      1.4995000000000003E+001,
      1.4996000000000002E+001,
      1.4997000000000002E+001,
      1.4998000000000003E+001,
      1.4999000000000002E+001,
      1.5000000000000002E+001,
      1.5001000000000003E+001,
      1.5002000000000002E+001,
      1.5003000000000002E+001,
      1.5004000000000003E+001,
      1.5005000000000003E+001,
      1.5006000000000002E+001,
      1.5007000000000001E+001,
      1.5008000000000003E+001,
      1.5009000000000002E+001,
      1.5010000000000002E+001,
      1.5011000000000003E+001,
      1.5012000000000002E+001,
      1.5013000000000002E+001,
      1.5014000000000003E+001,
      1.5015000000000002E+001,
      1.5016000000000002E+001,
      1.5017000000000003E+001,
      1.5018000000000002E+001,
      1.5019000000000002E+001,
      1.5020000000000003E+001,
      1.5021000000000003E+001,
      1.5022000000000002E+001,
      1.5023000000000003E+001,
      1.5024000000000003E+001,
      1.5025000000000002E+001,
      1.5026000000000002E+001,
      1.5027000000000003E+001,
      1.5028000000000002E+001,
      1.5029000000000002E+001,
      1.5030000000000003E+001,
      1.5031000000000002E+001,
      1.5032000000000002E+001,
      1.5033000000000003E+001,
      1.5034000000000002E+001,
      1.5035000000000002E+001,
      1.5036000000000003E+001,
      1.5037000000000003E+001,
      1.5038000000000002E+001,
      1.5039000000000001E+001,
      1.5040000000000003E+001,
      1.5041000000000002E+001,
      1.5042000000000002E+001,
      1.5043000000000003E+001,
      1.5044000000000002E+001,
      1.5045000000000002E+001,
      1.5046000000000003E+001,
      1.5047000000000002E+001,
      1.5048000000000002E+001,
      1.5049000000000003E+001,
      1.5050000000000002E+001,
      1.5051000000000002E+001,
      1.5052000000000003E+001,
      1.5053000000000003E+001,
      1.5054000000000002E+001,
      1.5055000000000003E+001,
      1.5056000000000003E+001,
      1.5057000000000002E+001,
      1.5058000000000002E+001,
      1.5059000000000003E+001,
      1.5060000000000002E+001,
      1.5061000000000002E+001,
      1.5062000000000003E+001,
      1.5063000000000002E+001,
      1.5064000000000002E+001,
      1.5065000000000003E+001,
      1.5066000000000003E+001,
      1.5067000000000002E+001,
      1.5068000000000003E+001,
      1.5069000000000003E+001,
      1.5070000000000002E+001,
      1.5071000000000002E+001,
      1.5072000000000003E+001,
      1.5073000000000002E+001,
      1.5074000000000002E+001,
      1.5075000000000003E+001,
      1.5076000000000002E+001,
      1.5077000000000002E+001,
      1.5078000000000003E+001,
      1.5079000000000002E+001,
      1.5080000000000002E+001,
      1.5081000000000003E+001,
      1.5082000000000003E+001,
      1.5083000000000002E+001,
      1.5084000000000003E+001,
      1.5085000000000003E+001,
      1.5086000000000002E+001,
      1.5087000000000002E+001,
      1.5088000000000003E+001,
      1.5089000000000002E+001,
      1.5090000000000002E+001,
      1.5091000000000003E+001,
      1.5092000000000002E+001,
      1.5093000000000002E+001,
      1.5094000000000003E+001,
      1.5095000000000002E+001,
      1.5096000000000002E+001,
      1.5097000000000003E+001,
      1.5098000000000003E+001,
      1.5099000000000002E+001,
      1.5100000000000003E+001,
      1.5101000000000003E+001,
      1.5102000000000002E+001,
      1.5103000000000002E+001,
      1.5104000000000003E+001,
      1.5105000000000002E+001,
      1.5106000000000002E+001,
      1.5107000000000003E+001,
      1.5108000000000002E+001,
      1.5109000000000002E+001,
      1.5110000000000003E+001,
      1.5111000000000002E+001,
      1.5112000000000002E+001,
      1.5113000000000003E+001,
      1.5114000000000003E+001,
      1.5115000000000002E+001,
      1.5116000000000003E+001,
      1.5117000000000003E+001,
      1.5118000000000002E+001,
      1.5119000000000002E+001,
      1.5120000000000003E+001,
      1.5121000000000002E+001,
      1.5122000000000002E+001,
      1.5123000000000003E+001,
      1.5124000000000002E+001,
      1.5125000000000002E+001,
      1.5126000000000003E+001,
      1.5127000000000002E+001,
      1.5128000000000002E+001,
      1.5129000000000003E+001,
      1.5130000000000003E+001,
      1.5131000000000002E+001,
      1.5132000000000003E+001,
      1.5133000000000003E+001,
      1.5134000000000002E+001,
      1.5135000000000002E+001,
      1.5136000000000003E+001,
      1.5137000000000002E+001,
      1.5138000000000002E+001,
      1.5139000000000003E+001,
      1.5140000000000002E+001,
      1.5141000000000002E+001,
      1.5142000000000003E+001,
      1.5143000000000002E+001,
      1.5144000000000002E+001,
      1.5145000000000003E+001,
      1.5146000000000003E+001,
      1.5147000000000002E+001,
      1.5148000000000003E+001,
      1.5149000000000003E+001,
      1.5150000000000002E+001,
      1.5151000000000002E+001,
      1.5152000000000003E+001,
      1.5153000000000002E+001,
      1.5154000000000002E+001,
      1.5155000000000003E+001,
      1.5156000000000002E+001,
      1.5157000000000002E+001,
      1.5158000000000003E+001,
      1.5159000000000002E+001,
      1.5160000000000002E+001,
      1.5161000000000003E+001,
      1.5162000000000003E+001,
      1.5163000000000002E+001,
      1.5164000000000001E+001,
      1.5165000000000003E+001,
      1.5166000000000002E+001,
      1.5167000000000002E+001,
      1.5168000000000003E+001,
      1.5169000000000002E+001,
      1.5170000000000002E+001,
      1.5171000000000003E+001,
      1.5172000000000002E+001,
      1.5173000000000002E+001,
      1.5174000000000003E+001,
      1.5175000000000002E+001,
      1.5176000000000002E+001,
      1.5177000000000003E+001,
      1.5178000000000003E+001,
      1.5179000000000002E+001,
      1.5180000000000003E+001,
      1.5181000000000003E+001,
      1.5182000000000002E+001,
      1.5183000000000002E+001,
      1.5184000000000003E+001,
      1.5185000000000002E+001,
      1.5186000000000002E+001,
      1.5187000000000003E+001,
      1.5188000000000002E+001,
      1.5189000000000002E+001,
      1.5190000000000003E+001,
      1.5191000000000003E+001,
      1.5192000000000002E+001,
      1.5193000000000003E+001,
      1.5194000000000003E+001,
      1.5195000000000002E+001,
      1.5196000000000002E+001,
      1.5197000000000003E+001,
      1.5198000000000002E+001,
      1.5199000000000002E+001,
      1.5200000000000003E+001,
      1.5201000000000002E+001,
      1.5202000000000002E+001,
      1.5203000000000003E+001,
      1.5204000000000002E+001,
      1.5205000000000002E+001,
      1.5206000000000003E+001,
      1.5207000000000003E+001,
      1.5208000000000002E+001,
      1.5209000000000003E+001,
      1.5210000000000003E+001,
      1.5211000000000002E+001,
      1.5212000000000002E+001,
      1.5213000000000003E+001,
      1.5214000000000002E+001,
      1.5215000000000002E+001,
      1.5216000000000003E+001,
      1.5217000000000002E+001,
      1.5218000000000002E+001,
      1.5219000000000003E+001,
      1.5220000000000002E+001,
      1.5221000000000002E+001,
      1.5222000000000003E+001,
      1.5223000000000003E+001,
      1.5224000000000002E+001,
      1.5225000000000003E+001,
      1.5226000000000003E+001,
      1.5227000000000002E+001,
      1.5228000000000002E+001,
      1.5229000000000003E+001,
      1.5230000000000002E+001,
      1.5231000000000002E+001,
      1.5232000000000003E+001,
      1.5233000000000002E+001,
      1.5234000000000002E+001,
      1.5235000000000003E+001,
      1.5236000000000002E+001,
      1.5237000000000002E+001,
      1.5238000000000003E+001,
      1.5239000000000003E+001,
      1.5240000000000002E+001,
      1.5241000000000003E+001,
      1.5242000000000003E+001,
      1.5243000000000002E+001,
      1.5244000000000002E+001,
      1.5245000000000003E+001,
      1.5246000000000002E+001,
      1.5247000000000002E+001,
      1.5248000000000003E+001,
      1.5249000000000002E+001,
      1.5250000000000002E+001,
      1.5251000000000003E+001,
      1.5252000000000002E+001,
      1.5253000000000002E+001,
      1.5254000000000003E+001,
      1.5255000000000003E+001,
      1.5256000000000002E+001,
      1.5257000000000003E+001,
      1.5258000000000003E+001,
      1.5259000000000002E+001,
      1.5260000000000002E+001,
      1.5261000000000003E+001,
      1.5262000000000002E+001,
      1.5263000000000002E+001,
      1.5264000000000003E+001,
      1.5265000000000002E+001,
      1.5266000000000002E+001,
      1.5267000000000003E+001,
      1.5268000000000002E+001,
      1.5269000000000002E+001,
      1.5270000000000003E+001,
      1.5271000000000003E+001,
      1.5272000000000002E+001,
      1.5273000000000003E+001,
      1.5274000000000003E+001,
      1.5275000000000002E+001,
      1.5276000000000002E+001,
      1.5277000000000003E+001,
      1.5278000000000002E+001,
      1.5279000000000002E+001,
      1.5280000000000003E+001,
      1.5281000000000002E+001,
      1.5282000000000002E+001,
      1.5283000000000003E+001,
      1.5284000000000002E+001,
      1.5285000000000002E+001,
      1.5286000000000003E+001,
      1.5287000000000003E+001,
      1.5288000000000002E+001,
      1.5289000000000001E+001,
      1.5290000000000003E+001,
      1.5291000000000002E+001,
      1.5292000000000002E+001,
      1.5293000000000003E+001,
      1.5294000000000002E+001,
      1.5295000000000002E+001,
      1.5296000000000003E+001,
      1.5297000000000002E+001,
      1.5298000000000002E+001,
      1.5299000000000003E+001,
      1.5300000000000002E+001,
      1.5301000000000002E+001,
      1.5302000000000003E+001,
      1.5303000000000003E+001,
      1.5304000000000002E+001,
      1.5305000000000003E+001,
      1.5306000000000003E+001,
      1.5307000000000002E+001,
      1.5308000000000002E+001,
      1.5309000000000003E+001,
      1.5310000000000002E+001,
      1.5311000000000002E+001,
      1.5312000000000003E+001,
      1.5313000000000002E+001,
      1.5314000000000002E+001,
      1.5315000000000003E+001,
      1.5316000000000003E+001,
      1.5317000000000002E+001,
      1.5318000000000003E+001,
      1.5319000000000003E+001,
      1.5320000000000002E+001,
      1.5321000000000002E+001,
      1.5322000000000003E+001,
      1.5323000000000002E+001,
      1.5324000000000002E+001,
      1.5325000000000003E+001,
      1.5326000000000002E+001,
      1.5327000000000002E+001,
      1.5328000000000003E+001,
      1.5329000000000002E+001,
      1.5330000000000002E+001,
      1.5331000000000003E+001,
      1.5332000000000003E+001,
      1.5333000000000002E+001,
      1.5334000000000003E+001,
      1.5335000000000003E+001,
      1.5336000000000002E+001,
      1.5337000000000002E+001,
      1.5338000000000003E+001,
      1.5339000000000002E+001,
      1.5340000000000002E+001,
      1.5341000000000003E+001,
      1.5342000000000002E+001,
      1.5343000000000002E+001,
      1.5344000000000003E+001,
      1.5345000000000002E+001,
      1.5346000000000002E+001,
      1.5347000000000003E+001,
      1.5348000000000003E+001,
      1.5349000000000002E+001,
      1.5350000000000003E+001,
      1.5351000000000003E+001,
      1.5352000000000002E+001,
      1.5353000000000002E+001,
      1.5354000000000003E+001,
      1.5355000000000002E+001,
      1.5356000000000002E+001,
      1.5357000000000003E+001,
      1.5358000000000002E+001,
      1.5359000000000002E+001,
      1.5360000000000003E+001,
      1.5361000000000002E+001,
      1.5362000000000002E+001,
      1.5363000000000003E+001,
      1.5364000000000003E+001,
      1.5365000000000002E+001,
      1.5366000000000003E+001,
      1.5367000000000003E+001,
      1.5368000000000002E+001,
      1.5369000000000002E+001,
      1.5370000000000003E+001,
      1.5371000000000002E+001,
      1.5372000000000002E+001,
      1.5373000000000003E+001,
      1.5374000000000002E+001,
      1.5375000000000002E+001,
      1.5376000000000003E+001,
      1.5377000000000002E+001,
      1.5378000000000002E+001,
      1.5379000000000003E+001,
      1.5380000000000003E+001,
      1.5381000000000002E+001,
      1.5382000000000003E+001,
      1.5383000000000003E+001,
      1.5384000000000002E+001,
      1.5385000000000002E+001,
      1.5386000000000003E+001,
      1.5387000000000002E+001,
      1.5388000000000002E+001,
      1.5389000000000003E+001,
      1.5390000000000002E+001,
      1.5391000000000002E+001,
      1.5392000000000003E+001,
      1.5393000000000002E+001,
      1.5394000000000002E+001,
      1.5395000000000003E+001,
      1.5396000000000003E+001,
      1.5397000000000002E+001,
      1.5398000000000003E+001,
      1.5399000000000003E+001,
      1.5400000000000002E+001,
      1.5401000000000002E+001,
      1.5402000000000003E+001,
      1.5403000000000002E+001,
      1.5404000000000002E+001,
      1.5405000000000003E+001,
      1.5406000000000002E+001,
      1.5407000000000002E+001,
      1.5408000000000003E+001,
      1.5409000000000002E+001,
      1.5410000000000002E+001,
      1.5411000000000003E+001,
      1.5412000000000003E+001,
      1.5413000000000002E+001,
      1.5414000000000003E+001,
      1.5415000000000003E+001,
      1.5416000000000002E+001,
      1.5417000000000002E+001,
      1.5418000000000003E+001,
      1.5419000000000002E+001,
      1.5420000000000002E+001,
      1.5421000000000003E+001,
      1.5422000000000002E+001,
      1.5423000000000002E+001,
      1.5424000000000003E+001,
      1.5425000000000002E+001,
      1.5426000000000002E+001,
      1.5427000000000003E+001,
      1.5428000000000003E+001,
      1.5429000000000002E+001,
      1.5430000000000003E+001,
      1.5431000000000003E+001,
      1.5432000000000002E+001,
      1.5433000000000002E+001,
      1.5434000000000003E+001,
      1.5435000000000002E+001,
      1.5436000000000002E+001,
      1.5437000000000003E+001,
      1.5438000000000002E+001,
      1.5439000000000002E+001,
      1.5440000000000003E+001,
      1.5441000000000003E+001,
      1.5442000000000002E+001,
      1.5443000000000003E+001,
      1.5444000000000003E+001,
      1.5445000000000002E+001,
      1.5446000000000002E+001,
      1.5447000000000003E+001,
      1.5448000000000002E+001,
      1.5449000000000002E+001,
      1.5450000000000003E+001,
      1.5451000000000002E+001,
      1.5452000000000002E+001,
      1.5453000000000003E+001,
      1.5454000000000002E+001,
      1.5455000000000002E+001,
      1.5456000000000003E+001,
      1.5457000000000003E+001,
      1.5458000000000002E+001,
      1.5459000000000003E+001,
      1.5460000000000003E+001,
      1.5461000000000002E+001,
      1.5462000000000002E+001,
      1.5463000000000003E+001,
      1.5464000000000002E+001,
      1.5465000000000002E+001,
      1.5466000000000003E+001,
      1.5467000000000002E+001,
      1.5468000000000002E+001,
      1.5469000000000003E+001,
      1.5470000000000002E+001,
      1.5471000000000002E+001,
      1.5472000000000003E+001,
      1.5473000000000003E+001,
      1.5474000000000002E+001,
      1.5475000000000003E+001,
      1.5476000000000003E+001,
      1.5477000000000002E+001,
      1.5478000000000002E+001,
      1.5479000000000003E+001,
      1.5480000000000002E+001,
      1.5481000000000002E+001,
      1.5482000000000003E+001,
      1.5483000000000002E+001,
      1.5484000000000002E+001,
      1.5485000000000003E+001,
      1.5486000000000002E+001,
      1.5487000000000002E+001,
      1.5488000000000003E+001,
      1.5489000000000003E+001,
      1.5490000000000002E+001,
      1.5491000000000003E+001,
      1.5492000000000003E+001,
      1.5493000000000002E+001,
      1.5494000000000002E+001,
      1.5495000000000003E+001,
      1.5496000000000002E+001,
      1.5497000000000002E+001,
      1.5498000000000003E+001,
      1.5499000000000002E+001,
      1.5500000000000002E+001,
      1.5501000000000003E+001,
      1.5502000000000002E+001,
      1.5503000000000002E+001,
      1.5504000000000003E+001,
      1.5505000000000003E+001,
      1.5506000000000002E+001,
      1.5507000000000003E+001,
      1.5508000000000003E+001,
      1.5509000000000002E+001,
      1.5510000000000002E+001,
      1.5511000000000003E+001,
      1.5512000000000002E+001,
      1.5513000000000002E+001,
      1.5514000000000003E+001,
      1.5515000000000002E+001,
      1.5516000000000002E+001,
      1.5517000000000003E+001,
      1.5518000000000002E+001,
      1.5519000000000002E+001,
      1.5520000000000003E+001,
      1.5521000000000003E+001,
      1.5522000000000002E+001,
      1.5523000000000003E+001,
      1.5524000000000003E+001,
      1.5525000000000002E+001,
      1.5526000000000002E+001,
      1.5527000000000003E+001,
      1.5528000000000002E+001,
      1.5529000000000002E+001,
      1.5530000000000003E+001,
      1.5531000000000002E+001,
      1.5532000000000002E+001,
      1.5533000000000003E+001,
      1.5534000000000002E+001,
      1.5535000000000002E+001,
      1.5536000000000003E+001,
      1.5537000000000003E+001,
      1.5538000000000002E+001,
      1.5539000000000003E+001,
      1.5540000000000003E+001,
      1.5541000000000002E+001,
      1.5542000000000002E+001,
      1.5543000000000003E+001,
      1.5544000000000002E+001,
      1.5545000000000002E+001,
      1.5546000000000003E+001,
      1.5547000000000002E+001,
      1.5548000000000002E+001,
      1.5549000000000003E+001,
      1.5550000000000002E+001,
      1.5551000000000002E+001,
      1.5552000000000003E+001,
      1.5553000000000003E+001,
      1.5554000000000002E+001,
      1.5555000000000003E+001,
      1.5556000000000003E+001,
      1.5557000000000002E+001,
      1.5558000000000002E+001,
      1.5559000000000003E+001,
      1.5560000000000002E+001,
      1.5561000000000002E+001,
      1.5562000000000003E+001,
      1.5563000000000002E+001
    };

    static real_T pDataValues[] = {
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      -4.9999999999999989E-005,
      -1.9999999999999996E-004,
      -4.4999999999999993E-004,
      -7.9999999999999982E-004,
      -0.00125,
      -1.7999999999999997E-003,
      -0.00245,
      -3.1999999999999993E-003,
      -4.0500000000000006E-003,
      -0.005,
      -6.0499999999999990E-003,
      -7.1999999999999989E-003,
      -8.4500000000000009E-003,
      -0.0098,
      -0.01125,
      -1.2799999999999997E-002,
      -0.01445,
      -1.6200000000000003E-002,
      -1.8049999999999997E-002,
      -0.02,
      -0.02205,
      -2.4199999999999996E-002,
      -2.6449999999999994E-002,
      -2.8799999999999996E-002,
      -3.1250000000000007E-002,
      -3.3800000000000004E-002,
      -3.6449999999999996E-002,
      -0.0392,
      -0.04205,
      -0.045,
      -4.8049999999999989E-002,
      -5.1199999999999989E-002,
      -0.05445,
      -0.0578,
      -0.06125,
      -6.4800000000000010E-002,
      -6.8449999999999983E-002,
      -7.2199999999999986E-002,
      -7.6049999999999993E-002,
      -0.08,
      -0.08405,
      -0.0882,
      -9.2450000000000018E-002,
      -9.6799999999999983E-002,
      -1.0124999999999998E-001,
      -1.0579999999999998E-001,
      -1.1044999999999999E-001,
      -1.1519999999999998E-001,
      -0.12005,
      -1.2500000000000003E-001,
      -0.13005,
      -1.3520000000000001E-001,
      -1.4045000000000002E-001,
      -0.1458,
      -1.5125000000000002E-001,
      -0.1568,
      -1.6244999999999998E-001,
      -0.1682,
      -0.17405,
      -1.8000000000000002E-001,
      -1.8605000000000002E-001,
      -0.1922,
      -0.19845,
      -2.0479999999999995E-001,
      -0.21125,
      -0.2178,
      -0.22445,
      -0.2312,
      -2.3804999999999998E-001,
      -0.245,
      -2.5205000000000005E-001,
      -2.5920000000000004E-001,
      -0.26645,
      -2.7380000000000004E-001,
      -2.8125000000000006E-001,
      -2.8880000000000006E-001,
      -2.9645000000000010E-001,
      -3.0419999999999997E-001,
      -3.1204999999999994E-001,
      -0.32,
      -3.2804999999999995E-001,
      -0.3362,
      -3.4445000000000003E-001,
      -0.3528,
      -0.36125,
      -3.6980000000000007E-001,
      -3.7845000000000006E-001,
      -3.8720000000000004E-001,
      -0.39605,
      -4.0499999999999992E-001,
      -0.41405,
      -4.2319999999999991E-001,
      -0.43245,
      -4.4179999999999997E-001,
      -4.5124999999999993E-001,
      -4.6079999999999993E-001,
      -0.47045,
      -0.4802,
      -0.49005,
      -0.5,
      -0.51,
      -0.52,
      -0.53,
      -0.54,
      -0.55,
      -5.5999999999999994E-001,
      -5.7000000000000006E-001,
      -0.58,
      -5.9000000000000008E-001,
      -0.6,
      -0.61,
      -0.62,
      -0.63,
      -0.64,
      -0.65,
      -6.5999999999999992E-001,
      -0.67,
      -0.68,
      -6.9000000000000006E-001,
      -0.7,
      -0.71,
      -0.72,
      -0.73,
      -0.74,
      -0.75,
      -0.76,
      -0.77,
      -7.7999999999999992E-001,
      -0.79,
      -0.8,
      -8.0999999999999994E-001,
      -0.82,
      -0.83,
      -8.4000000000000008E-001,
      -8.5000000000000009E-001,
      -0.86,
      -0.87,
      -0.88,
      -8.9000000000000012E-001,
      -0.9,
      -9.0999999999999992E-001,
      -0.92,
      -0.93,
      -0.94,
      -0.95,
      -0.96,
      -9.7000000000000008E-001,
      -0.98,
      -0.99,
      -1.0,
      -1.01,
      -1.02,
      -1.03,
      -1.04,
      -1.05,
      -1.0599999999999998E+000,
      -1.07,
      -1.08,
      -1.09,
      -1.1,
      -1.1099999999999999E+000,
      -1.1199999999999999E+000,
      -1.1300000000000001E+000,
      -1.14,
      -1.1500000000000001E+000,
      -1.16,
      -1.17,
      -1.1800000000000002E+000,
      -1.19,
      -1.2000000000000002E+000,
      -1.21,
      -1.22,
      -1.2300000000000002E+000,
      -1.24,
      -1.25,
      -1.26,
      -1.2699999999999998E+000,
      -1.2800000000000002E+000,
      -1.29,
      -1.3,
      -1.31,
      -1.3199999999999998E+000,
      -1.3300000000000003E+000,
      -1.34,
      -1.35,
      -1.36,
      -1.3699999999999999E+000,
      -1.38,
      -1.3900000000000001E+000,
      -1.4,
      -1.41,
      -1.42,
      -1.43,
      -1.4400000000000002E+000,
      -1.45,
      -1.46,
      -1.47,
      -1.48,
      -1.4900000000000002E+000,
      -1.5,
      -1.51,
      -1.52,
      -1.53,
      -1.5400000000000003E+000,
      -1.55,
      -1.5599999999999998E+000,
      -1.5699999999999998E+000,
      -1.58,
      -1.59,
      -1.6,
      -1.6099999999999999E+000,
      -1.6199999999999999E+000,
      -1.6300000000000001E+000,
      -1.6400000000000001E+000,
      -1.6500000000000001E+000,
      -1.66,
      -1.67,
      -1.6800000000000002E+000,
      -1.6900000000000002E+000,
      -1.7,
      -1.71,
      -1.72,
      -1.73,
      -1.74,
      -1.75,
      -1.76,
      -1.77,
      -1.78,
      -1.79,
      -1.8,
      -1.81,
      -1.82,
      -1.83,
      -1.84,
      -1.85,
      -1.86,
      -1.87,
      -1.8800000000000001E+000,
      -1.8900000000000001E+000,
      -1.9000000000000001E+000,
      -1.9100000000000001E+000,
      -1.9200000000000002E+000,
      -1.9300000000000002E+000,
      -1.9400000000000002E+000,
      -1.95,
      -1.96,
      -1.9699999999999998E+000,
      -1.98,
      -1.99,
      -2.0,
      -2.0100000000000002E+000,
      -2.02,
      -2.03,
      -2.04,
      -2.0500000000000003E+000,
      -2.06,
      -2.07,
      -2.08,
      -2.0900000000000003E+000,
      -2.1,
      -2.11,
      -2.1199999999999997E+000,
      -2.13,
      -2.14,
      -2.1500000000000004E+000,
      -2.16,
      -2.17,
      -2.18,
      -2.1900000000000004E+000,
      -2.2,
      -2.21,
      -2.2199999999999998E+000,
      -2.23,
      -2.24,
      -2.2500000000000004E+000,
      -2.2600000000000002E+000,
      -2.27,
      -2.28,
      -2.29,
      -2.3000000000000003E+000,
      -2.31,
      -2.32,
      -2.3299999999999996E+000,
      -2.34,
      -2.3500000000000005E+000,
      -2.3600000000000003E+000,
      -2.37,
      -2.38,
      -2.39,
      -2.4,
      -2.41,
      -2.42,
      -2.4299999999999997E+000,
      -2.44,
      -2.4499999999999997E+000,
      -2.4600000000000004E+000,
      -2.47,
      -2.48,
      -2.49,
      -2.5,
      -2.5100000000000002E+000,
      -2.52,
      -2.53,
      -2.54,
      -2.5500000000000003E+000,
      -2.5600000000000005E+000,
      -2.5700000000000003E+000,
      -2.58,
      -2.59,
      -2.6,
      -2.61,
      -2.6199999999999997E+000,
      -2.63,
      -2.6399999999999997E+000,
      -2.6500000000000004E+000,
      -2.66,
      -2.67,
      -2.68,
      -2.69,
      -2.7,
      -2.71,
      -2.7199999999999998E+000,
      -2.73,
      -2.7399999999999998E+000,
      -2.7500000000000004E+000,
      -2.7600000000000002E+000,
      -2.77,
      -2.7800000000000002E+000,
      -2.79,
      -2.8000000000000003E+000,
      -2.81,
      -2.82,
      -2.83,
      -2.84,
      -2.8500000000000005E+000,
      -2.8600000000000003E+000,
      -2.87,
      -2.8800000000000003E+000,
      -2.89,
      -2.9,
      -2.9099999999999997E+000,
      -2.92,
      -2.9299999999999997E+000,
      -2.94,
      -2.9499999999999997E+000,
      -2.96,
      -2.97,
      -2.98,
      -2.99,
      -3.0,
      -3.01,
      -3.02,
      -3.03,
      -3.04,
      -3.0500000000000003E+000,
      -3.06,
      -3.0700000000000003E+000,
      -3.08,
      -3.0900000000000003E+000,
      -3.1,
      -3.11,
      -3.12,
      -3.13,
      -3.14,
      -3.1500000000000004E+000,
      -3.16,
      -3.1700000000000004E+000,
      -3.18,
      -3.1900000000000004E+000,
      -3.2,
      -3.21,
      -3.22,
      -3.23,
      -3.24,
      -3.2500000000000004E+000,
      -3.2600000000000002E+000,
      -3.2700000000000005E+000,
      -3.2800000000000002E+000,
      -3.2900000000000005E+000,
      -3.3000000000000003E+000,
      -3.31,
      -3.3200000000000003E+000,
      -3.33,
      -3.3400000000000003E+000,
      -3.3500000000000005E+000,
      -3.3600000000000003E+000,
      -3.3700000000000006E+000,
      -3.3800000000000003E+000,
      -3.3900000000000006E+000,
      -3.4000000000000004E+000,
      -3.41,
      -3.4200000000000004E+000,
      -3.43,
      -3.4400000000000004E+000,
      -3.4500000000000006E+000,
      -3.4600000000000004E+000,
      -3.4700000000000006E+000,
      -3.4800000000000004E+000,
      -3.4900000000000007E+000,
      -3.5000000000000004E+000,
      -3.5100000000000002E+000,
      -3.5200000000000005E+000,
      -3.5300000000000002E+000,
      -3.5400000000000005E+000,
      -3.5500000000000007E+000,
      -3.5600000000000005E+000,
      -3.5700000000000007E+000,
      -3.5800000000000005E+000,
      -3.5900000000000007E+000,
      -3.6000000000000005E+000,
      -3.6100000000000003E+000,
      -3.6200000000000006E+000,
      -3.6300000000000003E+000,
      -3.6400000000000006E+000,
      -3.6500000000000008E+000,
      -3.6600000000000006E+000,
      -3.6700000000000008E+000,
      -3.6800000000000006E+000,
      -3.6900000000000008E+000,
      -3.7000000000000006E+000,
      -3.7100000000000004E+000,
      -3.7200000000000006E+000,
      -3.7300000000000004E+000,
      -3.7400000000000007E+000,
      -3.7500000000000009E+000,
      -3.7600000000000007E+000,
      -3.7700000000000009E+000,
      -3.7800000000000007E+000,
      -3.7900000000000009E+000,
      -3.8000000000000007E+000,
      -3.8100000000000005E+000,
      -3.8200000000000007E+000,
      -3.8300000000000005E+000,
      -3.8400000000000007E+000,
      -3.8500000000000010E+000,
      -3.8600000000000008E+000,
      -3.8700000000000010E+000,
      -3.8800000000000008E+000,
      -3.8900000000000010E+000,
      -3.9000000000000008E+000,
      -3.9100000000000006E+000,
      -3.9200000000000008E+000,
      -3.9300000000000006E+000,
      -3.9400000000000008E+000,
      -3.9500000000000011E+000,
      -3.9600000000000009E+000,
      -3.9700000000000011E+000,
      -3.9800000000000009E+000,
      -3.9900000000000011E+000,
      -4.0000000000000009E+000,
      -4.0100000000000007E+000,
      -4.0200000000000014E+000,
      -4.0300000000000011E+000,
      -4.0400000000000009E+000,
      -4.0500000000000007E+000,
      -4.0600000000000005E+000,
      -4.07,
      -4.08,
      -4.09,
      -4.1000000000000005E+000,
      -4.11,
      -4.1200000000000010E+000,
      -4.1300000000000008E+000,
      -4.1400000000000006E+000,
      -4.15,
      -4.16,
      -4.1700000000000008E+000,
      -4.1800000000000006E+000,
      -4.19,
      -4.2,
      -4.2100000000000009E+000,
      -4.2200000000000006E+000,
      -4.23,
      -4.24,
      -4.25,
      -4.2600000000000007E+000,
      -4.27,
      -4.28,
      -4.29,
      -4.3000000000000007E+000,
      -4.3100000000000014E+000,
      -4.32,
      -4.3300000000000010E+000,
      -4.3400000000000007E+000,
      -4.3500000000000005E+000,
      -4.3600000000000012E+000,
      -4.37,
      -4.3800000000000008E+000,
      -4.3900000000000006E+000,
      -4.4,
      -4.41,
      -4.42,
      -4.4300000000000006E+000,
      -4.4399999999999995E+000,
      -4.45,
      -4.46,
      -4.47,
      -4.48,
      -4.4899999999999993E+000,
      -4.5000000000000009E+000,
      -4.5100000000000007E+000,
      -4.5200000000000005E+000,
      -4.5300000000000011E+000,
      -4.54,
      -4.5500000000000007E+000,
      -4.5600000000000005E+000,
      -4.57,
      -4.5800000000000010E+000,
      -4.59,
      -4.6000000000000005E+000,
      -4.61,
      -4.62,
      -4.6300000000000008E+000,
      -4.64,
      -4.65,
      -4.66,
      -4.67,
      -4.6800000000000006E+000,
      -4.6899999999999995E+000,
      -4.7000000000000011E+000,
      -4.71,
      -4.7200000000000006E+000,
      -4.7300000000000013E+000,
      -4.74,
      -4.7500000000000009E+000,
      -4.76,
      -4.7700000000000005E+000,
      -4.7800000000000011E+000,
      -4.79,
      -4.8000000000000007E+000,
      -4.81,
      -4.82,
      -4.8300000000000010E+000,
      -4.84,
      -4.8500000000000005E+000,
      -4.8599999999999994E+000,
      -4.87,
      -4.8800000000000008E+000,
      -4.89,
      -4.9000000000000012E+000,
      -4.91,
      -4.9200000000000008E+000,
      -4.9300000000000015E+000,
      -4.94,
      -4.9500000000000011E+000,
      -4.96,
      -4.9700000000000006E+000,
      -4.9800000000000013E+000,
      -4.99,
      -5.0000000000000009E+000,
      -5.01,
      -5.0200000000000005E+000,
      -5.0300000000000011E+000,
      -5.04,
      -5.0500000000000007E+000,
      -5.06,
      -5.07,
      -5.0800000000000010E+000,
      -5.09,
      -5.1000000000000014E+000,
      -5.11,
      -5.1200000000000010E+000,
      -5.1300000000000017E+000,
      -5.1400000000000006E+000,
      -5.1500000000000012E+000,
      -5.16,
      -5.1700000000000008E+000,
      -5.1800000000000015E+000,
      -5.19,
      -5.2000000000000011E+000,
      -5.21,
      -5.2200000000000006E+000,
      -5.2300000000000013E+000,
      -5.24,
      -5.2500000000000009E+000,
      -5.26,
      -5.2700000000000005E+000,
      -5.2799999999999994E+000,
      -5.29,
      -5.3000000000000016E+000,
      -5.3100000000000005E+000,
      -5.3200000000000012E+000,
      -5.33,
      -5.3400000000000007E+000,
      -5.3500000000000014E+000,
      -5.36,
      -5.3700000000000010E+000,
      -5.38,
      -5.3900000000000006E+000,
      -5.4000000000000012E+000,
      -5.41,
      -5.4200000000000008E+000,
      -5.43,
      -5.44,
      -5.4500000000000011E+000,
      -5.46,
      -5.4700000000000006E+000,
      -5.4799999999999995E+000,
      -5.49,
      -5.4999999999999991E+000,
      -5.5100000000000007E+000,
      -5.52,
      -5.5300000000000020E+000,
      -5.5400000000000009E+000,
      -5.5500000000000016E+000,
      -5.5600000000000005E+000,
      -5.5699999999999994E+000,
      -5.58,
      -5.5900000000000007E+000,
      -5.6,
      -5.61,
      -5.6199999999999992E+000,
      -5.63,
      -5.6400000000000006E+000,
      -5.6499999999999995E+000,
      -5.66,
      -5.6699999999999990E+000,
      -5.68,
      -5.69,
      -5.6999999999999993E+000,
      -5.7100000000000009E+000,
      -5.72,
      -5.73,
      -5.7400000000000011E+000,
      -5.75,
      -5.7600000000000007E+000,
      -5.77,
      -5.78,
      -5.7900000000000009E+000,
      -5.8,
      -5.8100000000000005E+000,
      -5.8199999999999994E+000,
      -5.83,
      -5.8400000000000007E+000,
      -5.85,
      -5.86,
      -5.8699999999999992E+000,
      -5.88,
      -5.8900000000000006E+000,
      -5.8999999999999995E+000,
      -5.9100000000000010E+000,
      -5.92,
      -5.9300000000000006E+000,
      -5.9400000000000013E+000,
      -5.95,
      -5.9600000000000009E+000,
      -5.97,
      -5.98,
      -5.9900000000000011E+000,
      -6.0,
      -6.0100000000000007E+000,
      -6.02,
      -6.03,
      -6.0400000000000009E+000,
      -6.05,
      -6.0600000000000005E+000,
      -6.0699999999999994E+000,
      -6.08,
      -6.0900000000000016E+000,
      -6.1000000000000005E+000,
      -6.1100000000000012E+000,
      -6.12,
      -6.1300000000000008E+000,
      -6.1400000000000015E+000,
      -6.15,
      -6.1666666666666670E+000,
      -6.1766166666666678E+000,
      -6.1864666666666679E+000,
      -6.1962166666666674E+000,
      -6.2058666666666671E+000,
      -6.2154166666666679E+000,
      -6.2248666666666681E+000,
      -6.2342166666666667E+000,
      -6.2434666666666674E+000,
      -6.2526166666666683E+000,
      -6.2616666666666676E+000,
      -6.2706166666666681E+000,
      -6.2794666666666670E+000,
      -6.2882166666666670E+000,
      -6.2968666666666673E+000,
      -6.3054166666666669E+000,
      -6.3138666666666676E+000,
      -6.3222166666666677E+000,
      -6.3304666666666680E+000,
      -6.3386166666666668E+000,
      -6.3466666666666676E+000,
      -6.3546166666666668E+000,
      -6.3624666666666663E+000,
      -6.3702166666666677E+000,
      -6.3778666666666668E+000,
      -6.3854166666666679E+000,
      -6.3928666666666674E+000,
      -6.4002166666666680E+000,
      -6.4074666666666671E+000,
      -6.4146166666666673E+000,
      -6.4216666666666669E+000,
      -6.4286166666666666E+000,
      -6.4354666666666676E+000,
      -6.4422166666666669E+000,
      -6.4488666666666674E+000,
      -6.4554166666666672E+000,
      -6.4618666666666682E+000,
      -6.4682166666666676E+000,
      -6.4744666666666673E+000,
      -6.4806166666666671E+000,
      -6.4866666666666664E+000,
      -6.4926166666666676E+000,
      -6.4984666666666673E+000,
      -6.5042166666666681E+000,
      -6.5098666666666674E+000,
      -6.5154166666666686E+000,
      -6.5208666666666675E+000,
      -6.5262166666666683E+000,
      -6.5314666666666668E+000,
      -6.5366166666666672E+000,
      -6.5416666666666679E+000,
      -6.5466166666666679E+000,
      -6.5514666666666672E+000,
      -6.5562166666666668E+000,
      -6.5608666666666666E+000,
      -6.5654166666666685E+000,
      -6.5698666666666670E+000,
      -6.5742166666666675E+000,
      -6.5784666666666682E+000,
      -6.5826166666666666E+000,
      -6.5866666666666669E+000,
      -6.5906166666666675E+000,
      -6.5944666666666674E+000,
      -6.5982166666666675E+000,
      -6.6018666666666670E+000,
      -6.6054166666666676E+000,
      -6.6088666666666667E+000,
      -6.6122166666666669E+000,
      -6.6154666666666682E+000,
      -6.6186166666666679E+000,
      -6.6216666666666670E+000,
      -6.6246166666666682E+000,
      -6.6274666666666668E+000,
      -6.6302166666666684E+000,
      -6.6328666666666667E+000,
      -6.6354166666666679E+000,
      -6.6378666666666684E+000,
      -6.6402166666666673E+000,
      -6.6424666666666674E+000,
      -6.6446166666666677E+000,
      -6.6466666666666674E+000,
      -6.6486166666666682E+000,
      -6.6504666666666674E+000,
      -6.6522166666666678E+000,
      -6.6538666666666675E+000,
      -6.6554166666666674E+000,
      -6.6568666666666667E+000,
      -6.6582166666666671E+000,
      -6.6594666666666678E+000,
      -6.6606166666666669E+000,
      -6.6616666666666680E+000,
      -6.6626166666666675E+000,
      -6.6634666666666682E+000,
      -6.6642166666666673E+000,
      -6.6648666666666676E+000,
      -6.6654166666666663E+000,
      -6.6658666666666662E+000,
      -6.6662166666666671E+000,
      -6.6664666666666674E+000,
      -6.6666166666666680E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6667719421006026E+000,
      -6.6670877642463147E+000,
      -6.6676141206356867E+000,
      -6.6683509904890679E+000,
      -6.6692983447160987E+000,
      -6.6704561459168579E+000,
      -6.6718243483833355E+000,
      -6.6734028981012408E+000,
      -6.6751917327521344E+000,
      -6.6771907817158853E+000,
      -6.6793999660734658E+000,
      -6.6818191986100599E+000,
      -6.6844483838185083E+000,
      -6.6872874179030806E+000,
      -6.6903361887835739E+000,
      -6.6935945760997333E+000,
      -6.6970624512160066E+000,
      -6.7007396772266219E+000,
      -6.7046261089609942E+000,
      -6.7087215929894519E+000,
      -6.7130259676292985E+000,
      -6.7175390629511949E+000,
      -6.7222607007858617E+000,
      -6.7271906947311262E+000,
      -6.7323288501592655E+000,
      -6.7376749642247038E+000,
      -6.7432288258720110E+000,
      -6.7489902158442385E+000,
      -6.7549589066915754E+000,
      -6.7611346627803277E+000,
      -6.7675172403022188E+000,
      -6.7741063872840170E+000,
      -6.7809018435974835E+000,
      -6.7879033409696348E+000,
      -6.7951106029933470E+000,
      -6.8025233451382565E+000,
      -6.8101412747619925E+000,
      -6.8179640911217394E+000,
      -6.8259914853861030E+000,
      -6.8342231406473015E+000,
      -6.8426587319336800E+000,
      -6.8512979262225384E+000,
      -6.8601403824532818E+000,
      -6.8691857515408747E+000,
      -6.8784336763896379E+000,
      -6.8878837919073277E+000,
      -6.8975357250195719E+000,
      -6.9073890946845706E+000,
      -6.9174435119081670E+000,
      -6.9276985797591815E+000,
      -6.9381538933850946E+000,
      -6.9488090400280305E+000,
      -6.9596635990410407E+000,
      -6.9707171419047240E+000,
      -6.9819692322441309E+000,
      -6.9934194258460058E+000,
      -7.0050672706763075E+000,
      -7.0169123068980701E+000,
      -7.0289540668895416E+000,
      -7.0411920752626589E+000,
      -7.0536258488818060E+000,
      -7.0662548968828904E+000,
      -7.0790787206927224E+000,
      -7.0920968140486913E+000,
      -7.1053086630187687E+000,
      -7.1187137460217729E+000,
      -7.1323115338479859E+000,
      -7.1461014896800226E+000,
      -7.1600830691140427E+000,
      -7.1742557201812298E+000,
      -7.1886188833695845E+000,
      -7.2031719916460215E+000,
      -7.2179144704787417E+000,
      -7.2328457378599280E+000,
      -7.2479652043287048E+000,
      -7.2632722729944286E+000,
      -7.2787663395602387E+000,
      -7.2944467923469150E+000,
      -7.3103130123170343E+000,
      -7.3263643730993930E+000,
      -7.3426002410137601E+000,
      -7.3590199750958627E+000,
      -7.3756229271227189E+000,
      -7.3924084416382119E+000,
      -7.4093758559789693E+000,
      -7.4265245003005216E+000,
      -7.4438536976037586E+000,
      -7.4613627637616444E+000,
      -7.4790510075462215E+000,
      -7.4969177306559205E+000,
      -7.5149622277430979E+000,
      -7.5331837864419100E+000,
      -7.5515816873964203E+000,
      -7.5701552042889988E+000,
      -7.5889036038690048E+000,
      -7.6078261459817194E+000,
      -7.6269220835975879E+000,
      -7.6461906628416854E+000,
      -7.6656311230235001E+000,
      -7.6852426966669469E+000,
      -7.7050246095406809E+000,
      -7.7249760806886592E+000,
      -7.7450963224609541E+000,
      -7.7653845405448791E+000,
      -7.7858399339963178E+000,
      -7.8064616952713672E+000,
      -7.8272490102581962E+000,
      -7.8482010583092103E+000,
      -7.8693170122734193E+000,
      -7.8905960385291225E+000,
      -7.9120372970168020E+000,
      -7.9336399412722765E+000,
      -7.9554031184601506E+000,
      -7.9773259694074463E+000,
      -7.9994076286375506E+000,
      -8.0216472244043615E+000,
      -8.0440438787267254E+000,
      -8.0665967074230718E+000,
      -8.0893048201463458E+000,
      -8.1121673204191396E+000,
      -8.1351833056690843E+000,
      -8.1583518672644981E+000,
      -8.1816720905502329E+000,
      -8.2051430548838091E+000,
      -8.2287638336717475E+000,
      -8.2525334944061388E+000,
      -8.2764510987014805E+000,
      -8.3005157023317047E+000,
      -8.3247263552674760E+000,
      -8.3490821017136607E+000,
      -8.3735819801470992E+000,
      -8.3982250233545344E+000,
      -8.4230102584708284E+000,
      -8.4479367070173250E+000,
      -8.4730033849405260E+000,
      -8.4982093026508991E+000,
      -8.5235534650619780E+000,
      -8.5490348716296314E+000,
      -8.5746525163915503E+000,
      -8.6004053880069904E+000,
      -8.6262924697966685E+000,
      -8.6523127397829320E+000,
      -8.6784651707300675E+000,
      -8.7047487301848854E+000,
      -8.7311623805174587E+000,
      -8.7577050789621040E+000,
      -8.7843757776585356E+000,
      -8.8111734236932300E+000,
      -8.8380969591410175E+000,
      -8.8651453211068088E+000,
      -8.8923174417675934E+000,
      -8.9196122484145732E+000,
      -8.9470286634955141E+000,
      -8.9745656046573004E+000,
      -9.0022219847886351E+000,
      -9.0299967120629994E+000,
      -9.0578886899817039E+000,
      -9.0858968174172325E+000,
      -9.1140199886566613E+000,
      -9.1422570934453500E+000,
      -9.1706070170307523E+000,
      -9.1990686402064199E+000,
      -9.2276408393562175E+000,
      -9.2563224864986307E+000,
      -9.2851124493313542E+000,
      -9.3140095912759424E+000,
      -9.3430127715227176E+000,
      -9.3721208450757789E+000,
      -9.4013326627982270E+000,
      -9.4306470714575195E+000,
      -9.4600629137709902E+000,
      -9.4895790284515602E+000,
      -9.5191942502535554E+000,
      -9.5489074100187334E+000,
      -9.5787173347224162E+000,
      -9.6086228475198254E+000,
      -9.6386227677925262E+000,
      -9.6687159111950223E+000,
      -9.6989010897015540E+000,
      -9.7291771116529446E+000,
      -9.7595427818037024E+000,
      -9.7899969013691504E+000,
      -9.8205382680728022E+000,
      -9.8511656761937996E+000,
      -9.8818779166145045E+000,
      -9.9126737768682531E+000,
      -9.9435520411872176E+000,
      -9.9745114905503947E+000,
      -1.0005550902731731E+001,
      -1.0036669052348387E+001,
      -1.0067864710909088E+001,
      -1.0099136646862661E+001,
      -1.0130483625646617E+001,
      -1.0161904409735911E+001,
      -1.0193397758691781E+001,
      -1.0224962429210736E+001,
      -1.0256597175173642E+001,
      -1.0288300747694883E+001,
      -1.0320071895171708E+001,
      -1.0351909363333613E+001,
      -1.0383811895291869E+001,
      -1.0415778231589146E+001,
      -1.0447807110249219E+001,
      -1.0479897266826795E+001,
      -1.0512047434457443E+001,
      -1.0544256343907598E+001,
      -1.0576522723624663E+001,
      -1.0608845299787218E+001,
      -1.0641222796355295E+001,
      -1.0673653935120772E+001,
      -1.0706137435757828E+001,
      -1.0738672015873467E+001,
      -1.0771256391058186E+001,
      -1.0803889274936633E+001,
      -1.0836569379218437E+001,
      -1.0869295413749040E+001,
      -1.0902066086560636E+001,
      -1.0934880103923161E+001,
      -1.0967736170395410E+001,
      -1.1000632988876136E+001,
      -1.1033569260655266E+001,
      -1.1066543685465195E+001,
      -1.1099554961532084E+001,
      -1.1132601785627283E+001,
      -1.1165682853118767E+001,
      -1.1198796858022630E+001,
      -1.1231942493054655E+001,
      -1.1265118449681928E+001,
      -1.1298323418174494E+001,
      -1.1331556087657043E+001,
      -1.1364815146160698E+001,
      -1.1398099280674764E+001,
      -1.1431407177198611E+001,
      -1.1464737520793520E+001,
      -1.1498088995634593E+001,
      -1.1531460285062705E+001,
      -1.1564850071636490E+001,
      -1.1598257037184361E+001,
      -1.1631679862856499E+001,
      -1.1665117229176998E+001,
      -1.1698567816095869E+001,
      -1.1732030303041226E+001,
      -1.1765503368971386E+001,
      -1.1798985692427015E+001,
      -1.1832475951583316E+001,
      -1.1865972824302199E+001,
      -1.1899474988184490E+001,
      -1.1932981120622118E+001,
      -1.1966489898850355E+001,
      -12.0,
      -1.2033510101149645E+001,
      -1.2067018879377882E+001,
      -1.2100525011815508E+001,
      -1.2134027175697801E+001,
      -1.2167524048416682E+001,
      -1.2201014307572985E+001,
      -1.2234496631028614E+001,
      -1.2267969696958774E+001,
      -1.2301432183904131E+001,
      -1.2334882770823000E+001,
      -1.2368320137143499E+001,
      -1.2401742962815639E+001,
      -1.2435149928363508E+001,
      -1.2468539714937295E+001,
      -1.2501911004365411E+001,
      -1.2535262479206478E+001,
      -1.2568592822801387E+001,
      -1.2601900719325236E+001,
      -1.2635184853839302E+001,
      -1.2668443912342957E+001,
      -1.2701676581825506E+001,
      -1.2734881550318072E+001,
      -1.2768057506945345E+001,
      -1.2801203141977373E+001,
      -1.2834317146881233E+001,
      -1.2867398214372715E+001,
      -1.2900445038467916E+001,
      -1.2933456314534805E+001,
      -1.2966430739344734E+001,
      -1.2999367011123867E+001,
      -1.3032263829604588E+001,
      -1.3065119896076837E+001,
      -1.3097933913439368E+001,
      -1.3130704586250959E+001,
      -1.3163430620781561E+001,
      -1.3196110725063367E+001,
      -1.3228743608941814E+001,
      -1.3261327984126533E+001,
      -1.3293862564242172E+001,
      -1.3326346064879228E+001,
      -1.3358777203644705E+001,
      -1.3391154700212782E+001,
      -1.3423477276375337E+001,
      -1.3455743656092398E+001,
      -1.3487952565542557E+001,
      -1.3520102733173205E+001,
      -1.3552192889750781E+001,
      -1.3584221768410853E+001,
      -1.3616188104708131E+001,
      -1.3648090636666385E+001,
      -1.3679928104828292E+001,
      -1.3711699252305117E+001,
      -1.3743402824826356E+001,
      -1.3775037570789262E+001,
      -1.3806602241308219E+001,
      -1.3838095590264089E+001,
      -1.3869516374353383E+001,
      -1.3900863353137339E+001,
      -1.3932135289090912E+001,
      -1.3963330947651613E+001,
      -1.3994449097268269E+001,
      -1.4025488509449605E+001,
      -1.4056447958812782E+001,
      -1.4087326223131747E+001,
      -1.4118122083385495E+001,
      -1.4148834323806200E+001,
      -1.4179461731927198E+001,
      -1.4210003098630850E+001,
      -1.4240457218196298E+001,
      -1.4270822888347054E+001,
      -1.4301098910298453E+001,
      -1.4331284088804978E+001,
      -1.4361377232207474E+001,
      -1.4391377152480171E+001,
      -1.4421282665277584E+001,
      -1.4451092589981270E+001,
      -1.4480805749746443E+001,
      -1.4510420971548440E+001,
      -1.4539937086229008E+001,
      -1.4569352928542486E+001,
      -1.4598667337201773E+001,
      -1.4627879154924221E+001,
      -1.4656987228477281E+001,
      -1.4685990408724059E+001,
      -1.4714887550668651E+001,
      -1.4743677513501368E+001,
      -1.4772359160643783E+001,
      -1.4800931359793580E+001,
      -1.4829392982969251E+001,
      -1.4857742906554650E+001,
      -1.4885980011343337E+001,
      -1.4914103182582766E+001,
      -1.4942111310018296E+001,
      -1.4970003287937006E+001,
      -1.4997778015211365E+001,
      -1.5025434395342700E+001,
      -1.5052971336504484E+001,
      -1.5080387751585430E+001,
      -1.5107682558232408E+001,
      -1.5134854678893191E+001,
      -1.5161903040858983E+001,
      -1.5188826576306765E+001,
      -1.5215624222341463E+001,
      -1.5242294921037896E+001,
      -1.5268837619482541E+001,
      -1.5295251269815115E+001,
      -1.5321534829269934E+001,
      -1.5347687260217070E+001,
      -1.5373707530203330E+001,
      -1.5399594611993010E+001,
      -1.5425347483608450E+001,
      -1.5450965128370369E+001,
      -1.5476446534938024E+001,
      -1.5501790697349101E+001,
      -1.5526996615059474E+001,
      -1.5552063292982677E+001,
      -1.5576989741529175E+001,
      -1.5601774976645462E+001,
      -1.5626418019852903E+001,
      -1.5650917898286339E+001,
      -1.5675273644732524E+001,
      -1.5699484297668295E+001,
      -1.5723548901298519E+001,
      -1.5747466505593863E+001,
      -1.5771236166328254E+001,
      -1.5794856945116191E+001,
      -1.5818327909449767E+001,
      -1.5841648132735502E+001,
      -1.5864816694330916E+001,
      -1.5887832679580860E+001,
      -1.5910695179853656E+001,
      -1.5933403292576928E+001,
      -1.5955956121273275E+001,
      -1.5978352775595640E+001,
      -1.6000592371362455E+001,
      -1.6022674030592555E+001,
      -1.6044596881539849E+001,
      -1.6066360058727724E+001,
      -1.6087962702983198E+001,
      -1.6109403961470878E+001,
      -1.6130682987726580E+001,
      -1.6151798941690792E+001,
      -1.6172750989741804E+001,
      -1.6193538304728637E+001,
      -1.6214160066003686E+001,
      -1.6234615459455124E+001,
      -1.6254903677539048E+001,
      -1.6275023919311344E+001,
      -1.6294975390459317E+001,
      -1.6314757303333053E+001,
      -1.6334368876976502E+001,
      -1.6353809337158314E+001,
      -1.6373077916402416E+001,
      -1.6392173854018282E+001,
      -1.6411096396130997E+001,
      -1.6429844795711002E+001,
      -1.6448418312603582E+001,
      -1.6466816213558090E+001,
      -1.6485037772256902E+001,
      -1.6503082269344080E+001,
      -1.6520948992453778E+001,
      -1.6538637236238358E+001,
      -1.6556146302396243E+001,
      -1.6573475499699480E+001,
      -1.6590624144021035E+001,
      -1.6607591558361790E+001,
      -1.6624377072877284E+001,
      -1.6640980024904138E+001,
      -1.6657399758986241E+001,
      -1.6673635626900605E+001,
      -1.6689686987682965E+001,
      -1.6705553207653086E+001,
      -1.6721233660439761E+001,
      -1.6736727727005572E+001,
      -1.6752034795671296E+001,
      -1.6767154262140075E+001,
      -1.6782085529521261E+001,
      -1.6796828008353977E+001,
      -1.6811381116630411E+001,
      -1.6825744279818771E+001,
      -1.6839916930885959E+001,
      -1.6853898510319976E+001,
      -1.6867688466152018E+001,
      -1.6881286253978228E+001,
      -1.6894691336981236E+001,
      -1.6907903185951309E+001,
      -1.6920921279307283E+001,
      -1.6933745103117108E+001,
      -1.6946374151118192E+001,
      -1.6958807924737343E+001,
      -1.6971045933110460E+001,
      -1.6983087693101933E+001,
      -1.6994932729323693E+001,
      -1.7006580574153997E+001,
      -1.7018030767755871E+001,
      -1.7029282858095279E+001,
      -1.7040336400958960E+001,
      -1.7051190959971972E+001,
      -1.7061846106614905E+001,
      -1.7072301420240823E+001,
      -1.7082556488091836E+001,
      -1.7092610905315432E+001,
      -1.7102464274980431E+001,
      -1.7112116208092672E+001,
      -1.7121566323610363E+001,
      -1.7130814248459124E+001,
      -1.7139859617546719E+001,
      -1.7148702073777464E+001,
      -1.7157341268066322E+001,
      -1.7165776859352700E+001,
      -1.7174008514613899E+001,
      -1.7182035908878262E+001,
      -1.7189858725238011E+001,
      -1.7197476654861749E+001,
      -1.7204889397006657E+001,
      -1.7212096659030365E+001,
      -1.7219098156402520E+001,
      -1.7225893612715986E+001,
      -1.7232482759697785E+001,
      -1.7238865337219675E+001,
      -1.7245041093308426E+001,
      -1.7251009784155762E+001,
      -1.7256771174127991E+001,
      -1.7262325035775298E+001,
      -1.7267671149840737E+001,
      -1.7272809305268879E+001,
      -1.7277739299214140E+001,
      -1.7282460937048810E+001,
      -1.7286974032370704E+001,
      -1.7291278407010552E+001,
      -1.7295373891039009E+001,
      -1.7299260322773382E+001,
      -1.7302937548783998E+001,
      -1.7306405423900269E+001,
      -1.7309663811216428E+001,
      -1.7312712582096921E+001,
      -1.7315551616181494E+001,
      -1.7318180801389943E+001,
      -1.7320600033926539E+001,
      -1.7322809218284117E+001,
      -1.7324808267247867E+001,
      -1.7326597101898763E+001,
      -1.7328175651616665E+001,
      -1.7329543854083145E+001,
      -1.7330701655283903E+001,
      -1.7331649009510933E+001,
      -1.7332385879364317E+001,
      -1.7332912235753689E+001,
      -1.7333228057899401E+001,
      -1.7333333333333336E+001,
      -1.7333228057899401E+001,
      -1.7332912235753689E+001,
      -1.7332385879364317E+001,
      -1.7331649009510933E+001,
      -1.7330701655283903E+001,
      -1.7329543854083145E+001,
      -1.7328175651616665E+001,
      -1.7326597101898763E+001,
      -1.7324808267247867E+001,
      -1.7322809218284117E+001,
      -1.7320600033926539E+001,
      -1.7318180801389943E+001,
      -1.7315551616181494E+001,
      -1.7312712582096921E+001,
      -1.7309663811216428E+001,
      -1.7306405423900269E+001,
      -1.7302937548783998E+001,
      -1.7299260322773382E+001,
      -1.7295373891039009E+001,
      -1.7291278407010552E+001,
      -1.7286974032370704E+001,
      -1.7282460937048810E+001,
      -1.7277739299214144E+001,
      -1.7272809305268879E+001,
      -1.7267671149840737E+001,
      -1.7262325035775298E+001,
      -1.7256771174127991E+001,
      -1.7251009784155766E+001,
      -1.7245041093308426E+001,
      -1.7238865337219675E+001,
      -1.7232482759697785E+001,
      -1.7225893612715986E+001,
      -1.7219098156402520E+001,
      -1.7212096659030365E+001,
      -1.7204889397006657E+001,
      -1.7197476654861749E+001,
      -1.7189858725238011E+001,
      -1.7182035908878262E+001,
      -1.7174008514613899E+001,
      -1.7165776859352700E+001,
      -1.7157341268066322E+001,
      -1.7148702073777464E+001,
      -1.7139859617546723E+001,
      -1.7130814248459124E+001,
      -1.7121566323610363E+001,
      -1.7112116208092672E+001,
      -1.7102464274980431E+001,
      -1.7092610905315432E+001,
      -1.7082556488091836E+001,
      -1.7072301420240823E+001,
      -1.7061846106614908E+001,
      -1.7051190959971976E+001,
      -1.7040336400958960E+001,
      -1.7029282858095279E+001,
      -1.7018030767755874E+001,
      -1.7006580574153997E+001,
      -1.6994932729323693E+001,
      -1.6983087693101933E+001,
      -1.6971045933110460E+001,
      -1.6958807924737343E+001,
      -1.6946374151118196E+001,
      -1.6933745103117111E+001,
      -1.6920921279307283E+001,
      -1.6907903185951312E+001,
      -1.6894691336981232E+001,
      -1.6881286253978228E+001,
      -1.6867688466152018E+001,
      -1.6853898510319979E+001,
      -1.6839916930885959E+001,
      -1.6825744279818775E+001,
      -1.6811381116630418E+001,
      -1.6796828008353980E+001,
      -1.6782085529521261E+001,
      -1.6767154262140071E+001,
      -1.6752034795671296E+001,
      -1.6736727727005572E+001,
      -1.6721233660439765E+001,
      -1.6705553207653086E+001,
      -1.6689686987682972E+001,
      -1.6673635626900612E+001,
      -1.6657399758986244E+001,
      -1.6640980024904142E+001,
      -1.6624377072877284E+001,
      -1.6607591558361793E+001,
      -1.6590624144021035E+001,
      -1.6573475499699480E+001,
      -1.6556146302396243E+001,
      -1.6538637236238358E+001,
      -1.6520948992453782E+001,
      -1.6503082269344084E+001,
      -1.6485037772256906E+001,
      -1.6466816213558094E+001,
      -1.6448418312603586E+001,
      -1.6429844795711002E+001,
      -1.6411096396130997E+001,
      -1.6392173854018282E+001,
      -1.6373077916402416E+001,
      -1.6353809337158321E+001,
      -1.6334368876976502E+001,
      -1.6314757303333053E+001,
      -1.6294975390459321E+001,
      -1.6275023919311344E+001,
      -1.6254903677539048E+001,
      -1.6234615459455124E+001,
      -1.6214160066003686E+001,
      -1.6193538304728641E+001,
      -1.6172750989741811E+001,
      -1.6151798941690792E+001,
      -1.6130682987726583E+001,
      -1.6109403961470882E+001,
      -1.6087962702983198E+001,
      -1.6066360058727721E+001,
      -1.6044596881539853E+001,
      -1.6022674030592558E+001,
      -1.6000592371362455E+001,
      -1.5978352775595644E+001,
      -1.5955956121273278E+001,
      -1.5933403292576928E+001,
      -1.5910695179853660E+001,
      -1.5887832679580860E+001,
      -1.5864816694330916E+001,
      -1.5841648132735505E+001,
      -1.5818327909449771E+001,
      -1.5794856945116191E+001,
      -1.5771236166328258E+001,
      -1.5747466505593863E+001,
      -1.5723548901298523E+001,
      -1.5699484297668295E+001,
      -1.5675273644732524E+001,
      -1.5650917898286339E+001,
      -1.5626418019852903E+001,
      -1.5601774976645467E+001,
      -1.5576989741529180E+001,
      -1.5552063292982680E+001,
      -1.5526996615059478E+001,
      -1.5501790697349101E+001,
      -1.5476446534938024E+001,
      -1.5450965128370369E+001,
      -1.5425347483608450E+001,
      -1.5399594611993013E+001,
      -1.5373707530203333E+001,
      -1.5347687260217073E+001,
      -1.5321534829269938E+001,
      -1.5295251269815125E+001,
      -1.5268837619482541E+001,
      -1.5242294921037900E+001,
      -1.5215624222341463E+001,
      -1.5188826576306765E+001,
      -1.5161903040858983E+001,
      -1.5134854678893191E+001,
      -1.5107682558232408E+001,
      -1.5080387751585434E+001,
      -1.5052971336504491E+001,
      -1.5025434395342703E+001,
      -1.4997778015211368E+001,
      -1.4970003287936999E+001,
      -1.4942111310018296E+001,
      -1.4914103182582769E+001,
      -1.4885980011343340E+001,
      -1.4857742906554654E+001,
      -1.4829392982969255E+001,
      -1.4800931359793575E+001,
      -1.4772359160643786E+001,
      -1.4743677513501371E+001,
      -1.4714887550668644E+001,
      -1.4685990408724056E+001,
      -1.4656987228477284E+001,
      -1.4627879154924225E+001,
      -1.4598667337201777E+001,
      -1.4569352928542486E+001,
      -1.4539937086229008E+001,
      -1.4510420971548440E+001,
      -1.4480805749746446E+001,
      -1.4451092589981267E+001,
      -1.4421282665277580E+001,
      -1.4391377152480171E+001,
      -1.4361377232207477E+001,
      -1.4331284088804978E+001,
      -1.4301098910298453E+001,
      -1.4270822888347054E+001,
      -1.4240457218196301E+001,
      -1.4210003098630853E+001,
      -1.4179461731927191E+001,
      -1.4148834323806200E+001,
      -1.4118122083385499E+001,
      -1.4087326223131747E+001,
      -1.4056447958812786E+001,
      -1.4025488509449614E+001,
      -1.3994449097268269E+001,
      -1.3963330947651617E+001,
      -1.3932135289090912E+001,
      -1.3900863353137332E+001,
      -1.3869516374353379E+001,
      -1.3838095590264093E+001,
      -1.3806602241308223E+001,
      -1.3775037570789266E+001,
      -1.3743402824826363E+001,
      -1.3711699252305117E+001,
      -1.3679928104828292E+001,
      -1.3648090636666389E+001,
      -1.3616188104708124E+001,
      -1.3584221768410851E+001,
      -1.3552192889750783E+001,
      -1.3520102733173209E+001,
      -1.3487952565542560E+001,
      -1.3455743656092409E+001,
      -1.3423477276375344E+001,
      -1.3391154700212793E+001,
      -1.3358777203644708E+001,
      -1.3326346064879230E+001,
      -1.3293862564242168E+001,
      -1.3261327984126531E+001,
      -1.3228743608941818E+001,
      -1.3196110725063370E+001,
      -1.3163430620781565E+001,
      -1.3130704586250967E+001,
      -1.3097933913439377E+001,
      -1.3065119896076840E+001,
      -1.3032263829604592E+001,
      -1.2999367011123862E+001,
      -1.2966430739344734E+001,
      -1.2933456314534807E+001,
      -1.2900445038467918E+001,
      -1.2867398214372717E+001,
      -1.2834317146881240E+001,
      -1.2801203141977380E+001,
      -1.2768057506945349E+001,
      -1.2734881550318075E+001,
      -1.2701676581825504E+001,
      -1.2668443912342955E+001,
      -1.2635184853839306E+001,
      -1.2601900719325240E+001,
      -1.2568592822801390E+001,
      -1.2535262479206487E+001,
      -1.2501911004365418E+001,
      -1.2468539714937300E+001,
      -1.2435149928363511E+001,
      -1.2401742962815637E+001,
      -1.2368320137143497E+001,
      -1.2334882770823004E+001,
      -1.2301432183904135E+001,
      -1.2267969696958778E+001,
      -1.2234496631028621E+001,
      -1.2201014307572992E+001,
      -1.2167524048416686E+001,
      -1.2134027175697804E+001,
      -1.2100525011815508E+001,
      -1.2067018879377878E+001,
      -1.2033510101149648E+001,
      -1.2000000000000004E+001,
      -1.1966489898850357E+001,
      -1.1932981120622125E+001,
      -1.1899474988184499E+001,
      -1.1865972824302201E+001,
      -1.1832475951583319E+001,
      -1.1798985692427012E+001,
      -1.1765503368971386E+001,
      -1.1732030303041229E+001,
      -1.1698567816095872E+001,
      -1.1665117229177000E+001,
      -1.1631679862856510E+001,
      -1.1598257037184368E+001,
      -1.1564850071636494E+001,
      -1.1531460285062709E+001,
      -1.1498088995634586E+001,
      -1.1464737520793518E+001,
      -1.1431407177198615E+001,
      -1.1398099280674767E+001,
      -1.1364815146160700E+001,
      -1.1331556087657050E+001,
      -1.1298323418174501E+001,
      -1.1265118449681932E+001,
      -1.1231942493054659E+001,
      -1.1198796858022625E+001,
      -1.1165682853118767E+001,
      -1.1132601785627287E+001,
      -1.1099554961532087E+001,
      -1.1066543685465199E+001,
      -1.1033569260655273E+001,
      -1.1000632988876143E+001,
      -1.0967736170395414E+001,
      -1.0934880103923165E+001,
      -1.0902066086560628E+001,
      -1.0869295413749040E+001,
      -1.0836569379218441E+001,
      -1.0803889274936637E+001,
      -1.0771256391058188E+001,
      -1.0738672015873474E+001,
      -1.0706137435757835E+001,
      -1.0673653935120775E+001,
      -1.0641222796355299E+001,
      -1.0608845299787212E+001,
      -1.0576522723624661E+001,
      -1.0544256343907598E+001,
      -1.0512047434457447E+001,
      -1.0479897266826798E+001,
      -1.0447807110249222E+001,
      -1.0415778231589155E+001,
      -1.0383811895291872E+001,
      -1.0351909363333615E+001,
      -1.0320071895171704E+001,
      -1.0288300747694878E+001,
      -1.0256597175173640E+001,
      -1.0224962429210738E+001,
      -1.0193397758691784E+001,
      -1.0161904409735916E+001,
      -1.0130483625646624E+001,
      -1.0099136646862664E+001,
      -1.0067864710909092E+001,
      -1.0036669052348380E+001,
      -1.0005550902731729E+001,
      -9.9745114905503947E+000,
      -9.9435520411872211E+000,
      -9.9126737768682567E+000,
      -9.8818779166145081E+000,
      -9.8511656761938067E+000,
      -9.8205382680728057E+000,
      -9.7899969013691539E+000,
      -9.7595427818036953E+000,
      -9.7291771116529429E+000,
      -9.6989010897015504E+000,
      -9.6687159111950258E+000,
      -9.6386227677925262E+000,
      -9.6086228475198325E+000,
      -9.5787173347224233E+000,
      -9.5489074100187317E+000,
      -9.5191942502535571E+000,
      -9.4895790284515567E+000,
      -9.4600629137709902E+000,
      -9.4306470714575177E+000,
      -9.4013326627982288E+000,
      -9.3721208450757807E+000,
      -9.3430127715227211E+000,
      -9.3140095912759477E+000,
      -9.2851124493313613E+000,
      -9.2563224864986342E+000,
      -9.2276408393562193E+000,
      -9.1990686402064288E+000,
      -9.1706070170307505E+000,
      -9.1422570934453535E+000,
      -9.1140199886566649E+000,
      -9.0858968174172343E+000,
      -9.0578886899817128E+000,
      -9.0299967120630047E+000,
      -9.0022219847886387E+000,
      -8.9745656046573039E+000,
      -8.9470286634955123E+000,
      -8.9196122484145715E+000,
      -8.8923174417675952E+000,
      -8.8651453211068123E+000,
      -8.8380969591410210E+000,
      -8.8111734236932389E+000,
      -8.7843757776585409E+000,
      -8.7577050789621058E+000,
      -8.7311623805174623E+000,
      -8.7047487301848800E+000,
      -8.6784651707300657E+000,
      -8.6523127397829303E+000,
      -8.6262924697966703E+000,
      -8.6004053880069939E+000,
      -8.5746525163915557E+000,
      -8.5490348716296367E+000,
      -8.5235534650619798E+000,
      -8.4982093026509027E+000,
      -8.4730033849405224E+000,
      -8.4479367070173232E+000,
      -8.4230102584708284E+000,
      -8.3982250233545397E+000,
      -8.3735819801471010E+000,
      -8.3490821017136660E+000,
      -8.3247263552674813E+000,
      -8.3005157023317082E+000,
      -8.2764510987014823E+000,
      -8.2525334944061353E+000,
      -8.2287638336717457E+000,
      -8.2051430548838109E+000,
      -8.1816720905502347E+000,
      -8.1583518672644999E+000,
      -8.1351833056690896E+000,
      -8.1121673204191449E+000,
      -8.0893048201463476E+000,
      -8.0665967074230753E+000,
      -8.0440438787267219E+000,
      -8.0216472244043597E+000,
      -7.9994076286375488E+000,
      -7.9773259694074481E+000,
      -7.9554031184601532E+000,
      -7.9336399412722827E+000,
      -7.9120372970168065E+000,
      -7.8905960385291252E+000,
      -7.8693170122734220E+000,
      -7.8482010583092059E+000,
      -7.8272490102581953E+000,
      -7.8064616952713655E+000,
      -7.7858399339963196E+000,
      -7.7653845405448809E+000,
      -7.7450963224609586E+000,
      -7.7249760806886636E+000,
      -7.7050246095406836E+000,
      -7.6852426966669487E+000,
      -7.6656311230234966E+000,
      -7.6461906628416845E+000,
      -7.6269220835975871E+000,
      -7.6078261459817211E+000,
      -7.5889036038690056E+000,
      -7.5701552042890023E+000,
      -7.5515816873964248E+000,
      -7.5331837864419118E+000,
      -7.5149622277430996E+000,
      -7.4969177306559178E+000,
      -7.4790510075462215E+000,
      -7.4613627637616435E+000,
      -7.4438536976037604E+000,
      -7.4265245003005234E+000,
      -7.4093758559789702E+000,
      -7.3924084416382163E+000,
      -7.3756229271227207E+000,
      -7.3590199750958645E+000,
      -7.3426002410137565E+000,
      -7.3263643730993930E+000,
      -7.3103130123170335E+000,
      -7.2944467923469167E+000,
      -7.2787663395602404E+000,
      -7.2632722729944321E+000,
      -7.2479652043287084E+000,
      -7.2328457378599271E+000,
      -7.2179144704787435E+000,
      -7.2031719916460188E+000,
      -7.1886188833695837E+000,
      -7.1742557201812289E+000,
      -7.1600830691140436E+000,
      -7.1461014896800243E+000,
      -7.1323115338479877E+000,
      -7.1187137460217755E+000,
      -7.1053086630187678E+000,
      -7.0920968140486922E+000,
      -7.0790787206927197E+000,
      -7.0662548968828895E+000,
      -7.0536258488818060E+000,
      -7.0411920752626598E+000,
      -7.0289540668895425E+000,
      -7.0169123068980710E+000,
      -7.0050672706763102E+000,
      -6.9934194258460050E+000,
      -6.9819692322441327E+000,
      -6.9707171419047214E+000,
      -6.9596635990410407E+000,
      -6.9488090400280305E+000,
      -6.9381538933850964E+000,
      -6.9276985797591824E+000,
      -6.9174435119081688E+000,
      -6.9073890946845733E+000,
      -6.8975357250195719E+000,
      -6.8878837919073295E+000,
      -6.8784336763896361E+000,
      -6.8691857515408739E+000,
      -6.8601403824532818E+000,
      -6.8512979262225402E+000,
      -6.8426587319336800E+000,
      -6.8342231406473015E+000,
      -6.8259914853861048E+000,
      -6.8179640911217412E+000,
      -6.8101412747619952E+000,
      -6.8025233451382565E+000,
      -6.7951106029933488E+000,
      -6.7879033409696348E+000,
      -6.7809018435974835E+000,
      -6.7741063872840179E+000,
      -6.7675172403022197E+000,
      -6.7611346627803286E+000,
      -6.7549589066915772E+000,
      -6.7489902158442394E+000,
      -6.7432288258720119E+000,
      -6.7376749642247047E+000,
      -6.7323288501592655E+000,
      -6.7271906947311253E+000,
      -6.7222607007858626E+000,
      -6.7175390629511949E+000,
      -6.7130259676293003E+000,
      -6.7087215929894528E+000,
      -6.7046261089609942E+000,
      -6.7007396772266219E+000,
      -6.6970624512160075E+000,
      -6.6935945760997333E+000,
      -6.6903361887835739E+000,
      -6.6872874179030806E+000,
      -6.6844483838185083E+000,
      -6.6818191986100599E+000,
      -6.6793999660734666E+000,
      -6.6771907817158853E+000,
      -6.6751917327521344E+000,
      -6.6734028981012408E+000,
      -6.6718243483833355E+000,
      -6.6704561459168579E+000,
      -6.6692983447160987E+000,
      -6.6683509904890679E+000,
      -6.6676141206356867E+000,
      -6.6670877642463147E+000,
      -6.6667719421006026E+000,
      -6.6666666666666670E+000,
      -6.6667719421006026E+000,
      -6.6670877642463147E+000,
      -6.6676141206356867E+000,
      -6.6683509904890679E+000,
      -6.6692983447160987E+000,
      -6.6704561459168570E+000,
      -6.6718243483833355E+000,
      -6.6734028981012408E+000,
      -6.6751917327521344E+000,
      -6.6771907817158853E+000,
      -6.6793999660734666E+000,
      -6.6818191986100599E+000,
      -6.6844483838185083E+000,
      -6.6872874179030806E+000,
      -6.6903361887835739E+000,
      -6.6935945760997324E+000,
      -6.6970624512160066E+000,
      -6.7007396772266219E+000,
      -6.7046261089609951E+000,
      -6.7087215929894519E+000,
      -6.7130259676292985E+000,
      -6.7175390629511949E+000,
      -6.7222607007858617E+000,
      -6.7271906947311253E+000,
      -6.7323288501592646E+000,
      -6.7376749642247038E+000,
      -6.7432288258720092E+000,
      -6.7489902158442376E+000,
      -6.7549589066915745E+000,
      -6.7611346627803286E+000,
      -6.7675172403022188E+000,
      -6.7741063872840162E+000,
      -6.7809018435974817E+000,
      -6.7879033409696339E+000,
      -6.7951106029933461E+000,
      -6.8025233451382556E+000,
      -6.8101412747619916E+000,
      -6.8179640911217403E+000,
      -6.8259914853861030E+000,
      -6.8342231406473006E+000,
      -6.8426587319336791E+000,
      -6.8512979262225384E+000,
      -6.8601403824532801E+000,
      -6.8691857515408756E+000,
      -6.8784336763896352E+000,
      -6.8878837919073312E+000,
      -6.8975357250195692E+000,
      -6.9073890946845724E+000,
      -6.9174435119081670E+000,
      -6.9276985797591806E+000,
      -6.9381538933850946E+000,
      -6.9488090400280287E+000,
      -6.9596635990410389E+000,
      -6.9707171419047231E+000,
      -6.9819692322441309E+000,
      -6.9934194258460067E+000,
      -7.0050672706763093E+000,
      -7.0169123068980692E+000,
      -7.0289540668895407E+000,
      -7.0411920752626580E+000,
      -7.0536258488818042E+000,
      -7.0662548968828922E+000,
      -7.0790787206927179E+000,
      -7.0920968140486949E+000,
      -7.1053086630187661E+000,
      -7.1187137460217746E+000,
      -7.1323115338479859E+000,
      -7.1461014896800226E+000,
      -7.1600830691140418E+000,
      -7.1742557201812280E+000,
      -7.1886188833695819E+000,
      -7.2031719916460215E+000,
      -7.2179144704787417E+000,
      -7.2328457378599289E+000,
      -7.2479652043287066E+000,
      -7.2632722729944303E+000,
      -7.2787663395602387E+000,
      -7.2944467923469150E+000,
      -7.3103130123170308E+000,
      -7.3263643730993948E+000,
      -7.3426002410137547E+000,
      -7.3590199750958671E+000,
      -7.3756229271227181E+000,
      -7.3924084416382136E+000,
      -7.4093758559789684E+000,
      -7.4265245003005207E+000,
      -7.4438536976037577E+000,
      -7.4613627637616418E+000,
      -7.4790510075462189E+000,
      -7.4969177306559196E+000,
      -7.5149622277430970E+000,
      -7.5331837864419144E+000,
      -7.5515816873964221E+000,
      -7.5701552042890006E+000,
      -7.5889036038690039E+000,
      -7.6078261459817194E+000,
      -7.6269220835975853E+000,
      -7.6461906628416871E+000,
      -7.6656311230234939E+000,
      -7.6852426966669514E+000,
      -7.7050246095406809E+000,
      -7.7249760806886609E+000,
      -7.7450963224609559E+000,
      -7.7653845405448783E+000,
      -7.7858399339963169E+000,
      -7.8064616952713637E+000,
      -7.8272490102581926E+000,
      -7.8482010583092086E+000,
      -7.8693170122734193E+000,
      -7.8905960385291278E+000,
      -7.9120372970168038E+000,
      -7.9336399412722782E+000,
      -7.9554031184601497E+000,
      -7.9773259694074454E+000,
      -7.9994076286375471E+000,
      -8.0216472244043651E+000,
      -8.0440438787267183E+000,
      -8.0665967074230771E+000,
      -8.0893048201463440E+000,
      -8.1121673204191413E+000,
      -8.1351833056690861E+000,
      -8.1583518672644963E+000,
      -8.1816720905502329E+000,
      -8.2051430548838091E+000,
      -8.2287638336717421E+000,
      -8.2525334944061388E+000,
      -8.2764510987014788E+000,
      -8.3005157023317100E+000,
      -8.3247263552674777E+000,
      -8.3490821017136625E+000,
      -8.3735819801470974E+000,
      -8.3982250233545344E+000,
      -8.4230102584708249E+000,
      -8.4479367070173268E+000,
      -8.4730033849405189E+000,
      -8.4982093026509062E+000,
      -8.5235534650619762E+000,
      -8.5490348716296332E+000,
      -8.5746525163915521E+000,
      -8.6004053880069904E+000,
      -8.6262924697966668E+000,
      -8.6523127397829267E+000,
      -8.6784651707300622E+000,
      -8.7047487301848836E+000,
      -8.7311623805174587E+000,
      -8.7577050789621094E+000,
      -8.7843757776585374E+000,
      -8.8111734236932353E+000,
      -8.8380969591410175E+000,
      -8.8651453211068088E+000,
      -8.8923174417675916E+000,
      -8.9196122484145750E+000,
      -8.9470286634955087E+000,
      -8.9745656046572897E+000,
      -9.0022219847886351E+000,
      -9.0299967120629940E+000,
      -9.0578886899817075E+000,
      -9.0858968174172308E+000,
      -9.1140199886566613E+000,
      -9.1422570934453482E+000,
      -9.1706070170307470E+000,
      -9.1990686402064163E+000,
      -9.2276408393562157E+000,
      -9.2563224864986307E+000,
      -9.2851124493313559E+000,
      -9.3140095912759442E+000,
      -9.3430127715227176E+000,
      -9.3721208450757771E+000,
      -9.4013326627982252E+000,
      -9.4306470714575141E+000,
      -9.4600629137709937E+000,
      -9.4895790284515513E+000,
      -9.5191942502535536E+000,
      -9.5489074100187281E+000,
      -9.5787173347224197E+000,
      -9.6086228475198290E+000,
      -9.6386227677925227E+000,
      -9.6687159111950223E+000,
      -9.6989010897015469E+000,
      -9.7291771116529393E+000,
      -9.7595427818036988E+000,
      -9.7899969013691504E+000,
      -9.8205382680728093E+000,
      -9.8511656761938013E+000,
      -9.8818779166145045E+000,
      -9.9126737768682531E+000,
      -9.9435520411872176E+000,
      -9.9745114905503911E+000,
      -1.0005550902731734E+001,
      -1.0036669052348376E+001,
      -1.0067864710909088E+001,
      -1.0099136646862659E+001,
      -1.0130483625646621E+001,
      -1.0161904409735911E+001,
      -1.0193397758691779E+001,
      -1.0224962429210734E+001,
      -1.0256597175173637E+001,
      -1.0288300747694874E+001,
      -1.0320071895171708E+001,
      -1.0351909363333611E+001,
      -1.0383811895291876E+001,
      -1.0415778231589149E+001,
      -1.0447807110249219E+001,
      -1.0479897266826793E+001,
      -1.0512047434457443E+001,
      -1.0544256343907595E+001,
      -1.0576522723624667E+001,
      -1.0608845299787207E+001,
      -1.0641222796355294E+001,
      -1.0673653935120772E+001,
      -1.0706137435757832E+001,
      -1.0738672015873471E+001,
      -1.0771256391058182E+001,
      -1.0803889274936632E+001,
      -1.0836569379218435E+001,
      -1.0869295413749036E+001,
      -1.0902066086560632E+001,
      -1.0934880103923161E+001,
      -1.0967736170395419E+001,
      -1.1000632988876140E+001,
      -1.1033569260655270E+001,
      -1.1066543685465195E+001,
      -1.1099554961532084E+001,
      -1.1132601785627283E+001,
      -1.1165682853118771E+001,
      -1.1198796858022620E+001,
      -1.1231942493054662E+001,
      -1.1265118449681927E+001,
      -1.1298323418174498E+001,
      -1.1331556087657047E+001,
      -1.1364815146160694E+001,
      -1.1398099280674762E+001,
      -1.1431407177198610E+001,
      -1.1464737520793514E+001,
      -1.1498088995634593E+001,
      -1.1531460285062703E+001,
      -1.1564850071636499E+001,
      -1.1598257037184364E+001,
      -1.1631679862856503E+001,
      -1.1665117229176996E+001,
      -1.1698567816095867E+001,
      -1.1732030303041224E+001,
      -1.1765503368971391E+001,
      -1.1798985692427008E+001,
      -1.1832475951583325E+001,
      -1.1865972824302196E+001,
      -1.1899474988184494E+001,
      -1.1932981120622122E+001,
      -1.1966489898850352E+001,
      -1.1999999999999998E+001,
      -1.2033510101149643E+001,
      -1.2067018879377875E+001,
      -1.2100525011815511E+001,
      -1.2134027175697801E+001,
      -1.2167524048416691E+001,
      -1.2201014307572988E+001,
      -1.2234496631028616E+001,
      -1.2267969696958772E+001,
      -1.2301432183904131E+001,
      -1.2334882770823000E+001,
      -1.2368320137143501E+001,
      -1.2401742962815632E+001,
      -1.2435149928363517E+001,
      -1.2468539714937295E+001,
      -1.2501911004365414E+001,
      -1.2535262479206482E+001,
      -1.2568592822801387E+001,
      -1.2601900719325235E+001,
      -1.2635184853839302E+001,
      -1.2668443912342950E+001,
      -1.2701676581825510E+001,
      -1.2734881550318072E+001,
      -1.2768057506945352E+001,
      -1.2801203141977366E+001,
      -1.2834317146881235E+001,
      -1.2867398214372713E+001,
      -1.2900445038467913E+001,
      -1.2933456314534801E+001,
      -1.2966430739344737E+001,
      -1.2999367011123867E+001,
      -1.3032263829604588E+001,
      -1.3065119896076835E+001,
      -1.3097933913439364E+001,
      -1.3130704586250962E+001,
      -1.3163430620781551E+001,
      -1.3196110725063365E+001,
      -1.3228743608941814E+001,
      -1.3261327984126526E+001,
      -1.3293862564242165E+001,
      -1.3326346064879225E+001,
      -1.3358777203644703E+001,
      -1.3391154700212779E+001,
      -1.3423477276375332E+001,
      -1.3455743656092404E+001,
      -1.3487952565542555E+001,
      -1.3520102733173205E+001,
      -1.3552192889750778E+001,
      -1.3584221768410854E+001,
      -1.3616188104708128E+001,
      -1.3648090636666385E+001,
      -1.3679928104828289E+001,
      -1.3711699252305122E+001,
      -1.3743402824826353E+001,
      -1.3775037570789262E+001,
      -1.3806602241308219E+001,
      -1.3838095590264089E+001,
      -1.3869516374353376E+001,
      -1.3900863353137339E+001,
      -1.3932135289090908E+001,
      -1.3963330947651613E+001,
      -1.3994449097268266E+001,
      -1.4025488509449605E+001,
      -1.4056447958812782E+001,
      -1.4087326223131743E+001,
      -1.4118122083385492E+001,
      -1.4148834323806204E+001,
      -1.4179461731927194E+001,
      -1.4210003098630850E+001,
      -1.4240457218196298E+001,
      -1.4270822888347057E+001,
      -1.4301098910298442E+001,
      -1.4331284088804974E+001,
      -1.4361377232207474E+001,
      -1.4391377152480178E+001,
      -1.4421282665277577E+001,
      -1.4451092589981270E+001,
      -1.4480805749746443E+001,
      -1.4510420971548436E+001,
      -1.4539937086229004E+001,
      -1.4569352928542482E+001,
      -1.4598667337201773E+001,
      -1.4627879154924221E+001,
      -1.4656987228477281E+001,
      -1.4685990408724059E+001,
      -1.4714887550668648E+001,
      -1.4743677513501368E+001,
      -1.4772359160643783E+001,
      -1.4800931359793584E+001,
      -1.4829392982969244E+001,
      -1.4857742906554650E+001,
      -1.4885980011343337E+001,
      -1.4914103182582773E+001,
      -1.4942111310018293E+001,
      -1.4970003287937002E+001,
      -1.4997778015211365E+001,
      -1.5025434395342700E+001,
      -1.5052971336504481E+001,
      -1.5080387751585430E+001,
      -1.5107682558232405E+001,
      -1.5134854678893188E+001,
      -1.5161903040858979E+001,
      -1.5188826576306770E+001,
      -1.5215624222341466E+001,
      -1.5242294921037896E+001,
      -1.5268837619482538E+001,
      -1.5295251269815122E+001,
      -1.5321534829269927E+001,
      -1.5347687260217070E+001,
      -1.5373707530203330E+001,
      -1.5399594611993018E+001,
      -1.5425347483608446E+001,
      -1.5450965128370372E+001,
      -1.5476446534938020E+001,
      -1.5501790697349097E+001,
      -1.5526996615059474E+001,
      -1.5552063292982677E+001,
      -1.5576989741529175E+001,
      -1.5601774976645462E+001,
      -1.5626418019852899E+001,
      -1.5650917898286343E+001,
      -1.5675273644732528E+001,
      -1.5699484297668295E+001,
      -1.5723548901298519E+001,
      -1.5747466505593867E+001,
      -1.5771236166328251E+001,
      -1.5794856945116191E+001,
      -1.5818327909449767E+001,
      -1.5841648132735509E+001,
      -1.5864816694330912E+001,
      -1.5887832679580864E+001,
      -1.5910695179853656E+001,
      -1.5933403292576928E+001,
      -1.5955956121273275E+001,
      -1.5978352775595640E+001,
      -1.6000592371362451E+001,
      -1.6022674030592555E+001,
      -1.6044596881539849E+001,
      -1.6066360058727724E+001,
      -1.6087962702983202E+001,
      -1.6109403961470878E+001,
      -1.6130682987726580E+001,
      -1.6151798941690796E+001,
      -1.6172750989741807E+001,
      -1.6193538304728637E+001,
      -1.6214160066003686E+001,
      -1.6234615459455128E+001,
      -1.6254903677539044E+001,
      -1.6275023919311344E+001,
      -1.6294975390459317E+001,
      -1.6314757303333053E+001,
      -1.6334368876976498E+001,
      -1.6353809337158317E+001,
      -1.6373077916402412E+001,
      -1.6392173854018282E+001,
      -1.6411096396130993E+001,
      -1.6429844795711006E+001,
      -1.6448418312603582E+001,
      -1.6466816213558086E+001,
      -1.6485037772256902E+001,
      -1.6503082269344080E+001,
      -1.6520948992453782E+001,
      -1.6538637236238351E+001,
      -1.6556146302396243E+001,
      -1.6573475499699480E+001,
      -1.6590624144021032E+001,
      -1.6607591558361786E+001,
      -1.6624377072877280E+001,
      -1.6640980024904138E+001,
      -1.6657399758986241E+001,
      -1.6673635626900605E+001,
      -1.6689686987682968E+001,
      -1.6705553207653086E+001,
      -1.6721233660439761E+001,
      -1.6736727727005572E+001,
      -1.6752034795671296E+001,
      -1.6767154262140071E+001,
      -1.6782085529521261E+001,
      -1.6796828008353977E+001,
      -1.6811381116630418E+001,
      -1.6825744279818768E+001,
      -1.6839916930885956E+001,
      -1.6853898510319976E+001,
      -1.6867688466152014E+001,
      -1.6881286253978228E+001,
      -1.6894691336981236E+001,
      -1.6907903185951309E+001,
      -1.6920921279307279E+001,
      -1.6933745103117108E+001,
      -1.6946374151118196E+001,
      -1.6958807924737339E+001,
      -1.6971045933110460E+001,
      -1.6983087693101933E+001,
      -1.6994932729323693E+001,
      -1.7006580574153997E+001,
      -1.7018030767755871E+001,
      -1.7029282858095279E+001,
      -1.7040336400958964E+001,
      -1.7051190959971965E+001,
      -1.7061846106614905E+001,
      -1.7072301420240823E+001,
      -1.7082556488091836E+001,
      -1.7092610905315428E+001,
      -1.7102464274980431E+001,
      -1.7112116208092672E+001,
      -1.7121566323610363E+001,
      -1.7130814248459124E+001,
      -1.7139859617546719E+001,
      -1.7148702073777464E+001,
      -1.7157341268066322E+001,
      -1.7165776859352700E+001,
      -1.7174008514613899E+001,
      -1.7182035908878262E+001,
      -1.7189858725238011E+001,
      -1.7197476654861749E+001,
      -1.7204889397006657E+001,
      -1.7212096659030365E+001,
      -1.7219098156402520E+001,
      -1.7225893612715986E+001,
      -1.7232482759697785E+001,
      -1.7238865337219675E+001,
      -1.7245041093308426E+001,
      -1.7251009784155762E+001,
      -1.7256771174127991E+001,
      -1.7262325035775298E+001,
      -1.7267671149840737E+001,
      -1.7272809305268879E+001,
      -1.7277739299214140E+001,
      -1.7282460937048810E+001,
      -1.7286974032370704E+001,
      -1.7291278407010552E+001,
      -1.7295373891039009E+001,
      -1.7299260322773382E+001,
      -1.7302937548783998E+001,
      -1.7306405423900269E+001,
      -1.7309663811216428E+001,
      -1.7312712582096921E+001,
      -1.7315551616181494E+001,
      -1.7318180801389943E+001,
      -1.7320600033926539E+001,
      -1.7322809218284117E+001,
      -1.7324808267247867E+001,
      -1.7326597101898763E+001,
      -1.7328175651616665E+001,
      -1.7329543854083145E+001,
      -1.7330701655283903E+001,
      -1.7331649009510933E+001,
      -1.7332385879364317E+001,
      -1.7332912235753689E+001,
      -1.7333228057899401E+001,
      -1.7333333333333336E+001,
      -1.7333228057899401E+001,
      -1.7332912235753689E+001,
      -1.7332385879364317E+001,
      -1.7331649009510933E+001,
      -1.7330701655283903E+001,
      -1.7329543854083145E+001,
      -1.7328175651616665E+001,
      -1.7326597101898763E+001,
      -1.7324808267247867E+001,
      -1.7322809218284117E+001,
      -1.7320600033926539E+001,
      -1.7318180801389943E+001,
      -1.7315551616181494E+001,
      -1.7312712582096921E+001,
      -1.7309663811216428E+001,
      -1.7306405423900269E+001,
      -1.7302937548783998E+001,
      -1.7299260322773382E+001,
      -1.7295373891039009E+001,
      -1.7291278407010552E+001,
      -1.7286974032370704E+001,
      -1.7282460937048810E+001,
      -1.7277739299214140E+001,
      -1.7272809305268879E+001,
      -1.7267671149840737E+001,
      -1.7262325035775298E+001,
      -1.7256771174127991E+001,
      -1.7251009784155766E+001,
      -1.7245041093308426E+001,
      -1.7238865337219675E+001,
      -1.7232482759697785E+001,
      -1.7225893612715986E+001,
      -1.7219098156402520E+001,
      -1.7212096659030365E+001,
      -1.7204889397006657E+001,
      -1.7197476654861749E+001,
      -1.7189858725238011E+001,
      -1.7182035908878266E+001,
      -1.7174008514613899E+001,
      -1.7165776859352700E+001,
      -1.7157341268066322E+001,
      -1.7148702073777464E+001,
      -1.7139859617546719E+001,
      -1.7130814248459124E+001,
      -1.7121566323610363E+001,
      -1.7112116208092672E+001,
      -1.7102464274980431E+001,
      -1.7092610905315432E+001,
      -1.7082556488091836E+001,
      -1.7072301420240823E+001,
      -1.7061846106614905E+001,
      -1.7051190959971972E+001,
      -1.7040336400958960E+001,
      -1.7029282858095279E+001,
      -1.7018030767755871E+001,
      -1.7006580574154000E+001,
      -1.6994932729323693E+001,
      -1.6983087693101933E+001,
      -1.6971045933110460E+001,
      -1.6958807924737343E+001,
      -1.6946374151118192E+001,
      -1.6933745103117111E+001,
      -1.6920921279307283E+001,
      -1.6907903185951312E+001,
      -1.6894691336981236E+001,
      -1.6881286253978228E+001,
      -1.6867688466152018E+001,
      -1.6853898510319979E+001,
      -1.6839916930885956E+001,
      -1.6825744279818771E+001,
      -1.6811381116630418E+001,
      -1.6796828008353980E+001,
      -1.6782085529521254E+001,
      -1.6767154262140071E+001,
      -1.6752034795671296E+001,
      -1.6736727727005576E+001,
      -1.6721233660439761E+001,
      -1.6705553207653086E+001,
      -1.6689686987682965E+001,
      -1.6673635626900609E+001,
      -1.6657399758986244E+001,
      -1.6640980024904142E+001,
      -1.6624377072877280E+001,
      -1.6607591558361790E+001,
      -1.6590624144021035E+001,
      -1.6573475499699484E+001,
      -1.6556146302396240E+001,
      -1.6538637236238355E+001,
      -1.6520948992453778E+001,
      -1.6503082269344084E+001,
      -1.6485037772256899E+001,
      -1.6466816213558090E+001,
      -1.6448418312603586E+001,
      -1.6429844795711002E+001,
      -1.6411096396130997E+001,
      -1.6392173854018285E+001,
      -1.6373077916402416E+001,
      -1.6353809337158314E+001,
      -1.6334368876976502E+001,
      -1.6314757303333057E+001,
      -1.6294975390459321E+001,
      -1.6275023919311341E+001,
      -1.6254903677539048E+001,
      -1.6234615459455124E+001,
      -1.6214160066003689E+001,
      -1.6193538304728630E+001,
      -1.6172750989741811E+001,
      -1.6151798941690796E+001,
      -1.6130682987726583E+001,
      -1.6109403961470875E+001,
      -1.6087962702983205E+001,
      -1.6066360058727724E+001,
      -1.6044596881539853E+001,
      -1.6022674030592558E+001,
      -1.6000592371362455E+001,
      -1.5978352775595640E+001,
      -1.5955956121273278E+001,
      -1.5933403292576932E+001,
      -1.5910695179853660E+001,
      -1.5887832679580860E+001,
      -1.5864816694330916E+001,
      -1.5841648132735505E+001,
      -1.5818327909449771E+001,
      -1.5794856945116187E+001,
      -1.5771236166328254E+001,
      -1.5747466505593863E+001,
      -1.5723548901298523E+001,
      -1.5699484297668292E+001,
      -1.5675273644732531E+001,
      -1.5650917898286339E+001,
      -1.5626418019852906E+001,
      -1.5601774976645467E+001,
      -1.5576989741529180E+001,
      -1.5552063292982677E+001,
      -1.5526996615059478E+001,
      -1.5501790697349106E+001,
      -1.5476446534938024E+001,
      -1.5450965128370369E+001,
      -1.5425347483608450E+001,
      -1.5399594611993013E+001,
      -1.5373707530203333E+001,
      -1.5347687260217066E+001,
      -1.5321534829269934E+001,
      -1.5295251269815118E+001,
      -1.5268837619482545E+001,
      -1.5242294921037892E+001,
      -1.5215624222341473E+001,
      -1.5188826576306770E+001,
      -1.5161903040858986E+001,
      -1.5134854678893195E+001,
      -1.5107682558232412E+001,
      -1.5080387751585427E+001,
      -1.5052971336504484E+001,
      -1.5025434395342703E+001,
      -1.4997778015211368E+001,
      -1.4970003287937002E+001,
      -1.4942111310018296E+001,
      -1.4914103182582769E+001,
      -1.4885980011343340E+001,
      -1.4857742906554646E+001,
      -1.4829392982969248E+001,
      -1.4800931359793580E+001,
      -1.4772359160643786E+001,
      -1.4743677513501364E+001,
      -1.4714887550668655E+001,
      -1.4685990408724059E+001,
      -1.4656987228477284E+001,
      -1.4627879154924225E+001,
      -1.4598667337201777E+001,
      -1.4569352928542479E+001,
      -1.4539937086229008E+001,
      -1.4510420971548443E+001,
      -1.4480805749746452E+001,
      -1.4451092589981267E+001,
      -1.4421282665277584E+001,
      -1.4391377152480175E+001,
      -1.4361377232207477E+001,
      -1.4331284088804971E+001,
      -1.4301098910298446E+001,
      -1.4270822888347054E+001,
      -1.4240457218196301E+001,
      -1.4210003098630846E+001,
      -1.4179461731927201E+001,
      -1.4148834323806200E+001,
      -1.4118122083385499E+001,
      -1.4087326223131740E+001,
      -1.4056447958812786E+001,
      -1.4025488509449605E+001,
      -1.3994449097268269E+001,
      -1.3963330947651617E+001,
      -1.3932135289090915E+001,
      -1.3900863353137336E+001,
      -1.3869516374353383E+001,
      -1.3838095590264093E+001,
      -1.3806602241308223E+001,
      -1.3775037570789259E+001,
      -1.3743402824826356E+001,
      -1.3711699252305117E+001,
      -1.3679928104828296E+001,
      -1.3648090636666382E+001,
      -1.3616188104708135E+001,
      -1.3584221768410853E+001,
      -1.3552192889750785E+001,
      -1.3520102733173202E+001,
      -1.3487952565542560E+001,
      -1.3455743656092398E+001,
      -1.3423477276375337E+001,
      -1.3391154700212786E+001,
      -1.3358777203644708E+001,
      -1.3326346064879221E+001,
      -1.3293862564242172E+001,
      -1.3261327984126533E+001,
      -1.3228743608941818E+001,
      -1.3196110725063363E+001,
      -1.3163430620781558E+001,
      -1.3130704586250959E+001,
      -1.3097933913439368E+001,
      -1.3065119896076832E+001,
      -1.3032263829604593E+001,
      -1.2999367011123871E+001,
      -1.2966430739344734E+001,
      -1.2933456314534808E+001,
      -1.2900445038467920E+001,
      -1.2867398214372720E+001,
      -1.2834317146881231E+001,
      -1.2801203141977373E+001,
      -1.2768057506945349E+001,
      -1.2734881550318075E+001,
      -1.2701676581825506E+001,
      -1.2668443912342957E+001,
      -1.2635184853839306E+001,
      -1.2601900719325240E+001,
      -1.2568592822801383E+001,
      -1.2535262479206489E+001,
      -1.2501911004365411E+001,
      -1.2468539714937300E+001,
      -1.2435149928363513E+001,
      -1.2401742962815648E+001,
      -1.2368320137143499E+001,
      -1.2334882770823006E+001,
      -1.2301432183904135E+001,
      -1.2267969696958778E+001,
      -1.2234496631028611E+001,
      -1.2201014307572985E+001,
      -1.2167524048416688E+001,
      -1.2134027175697804E+001,
      -1.2100525011815508E+001,
      -1.2067018879377882E+001,
      -1.2033510101149652E+001,
      -1.2000000000000004E+001,
      -1.1966489898850348E+001,
      -1.1932981120622127E+001,
      -1.1899474988184490E+001,
      -1.1865972824302203E+001,
      -1.1832475951583310E+001,
      -1.1798985692427022E+001,
      -1.1765503368971386E+001,
      -1.1732030303041229E+001,
      -1.1698567816095872E+001,
      -1.1665117229177003E+001,
      -1.1631679862856499E+001,
      -1.1598257037184361E+001,
      -1.1564850071636496E+001,
      -1.1531460285062709E+001,
      -1.1498088995634589E+001,
      -1.1464737520793518E+001,
      -1.1431407177198617E+001,
      -1.1398099280674767E+001,
      -1.1364815146160689E+001,
      -1.1331556087657050E+001,
      -1.1298323418174494E+001,
      -1.1265118449681932E+001,
      -1.1231942493054651E+001,
      -1.1198796858022634E+001,
      -1.1165682853118767E+001,
      -1.1132601785627289E+001,
      -1.1099554961532091E+001,
      -1.1066543685465199E+001,
      -1.1033569260655266E+001,
      -1.1000632988876136E+001,
      -1.0967736170395415E+001,
      -1.0934880103923167E+001,
      -1.0902066086560630E+001,
      -1.0869295413749040E+001,
      -1.0836569379218442E+001,
      -1.0803889274936637E+001,
      -1.0771256391058179E+001,
      -1.0738672015873474E+001,
      -1.0706137435757828E+001,
      -1.0673653935120775E+001,
      -1.0641222796355292E+001,
      -1.0608845299787221E+001,
      -1.0576522723624663E+001,
      -1.0544256343907598E+001,
      -1.0512047434457447E+001,
      -1.0479897266826798E+001,
      -1.0447807110249206E+001,
      -1.0415778231589156E+001,
      -1.0383811895291865E+001,
      -1.0351909363333627E+001,
      -1.0320071895171704E+001,
      -1.0288300747694883E+001,
      -1.0256597175173640E+001,
      -1.0224962429210741E+001,
      -1.0193397758691784E+001,
      -1.0161904409735916E+001,
      -1.0130483625646630E+001,
      -1.0099136646862656E+001,
      -1.0067864710909085E+001,
      -1.0036669052348380E+001,
      -1.0005550902731731E+001,
      -9.9745114905503947E+000,
      -9.9435520411872211E+000,
      -9.9126737768682585E+000,
      -9.8818779166144939E+000,
      -9.8511656761938067E+000,
      -9.8205382680727986E+000,
      -9.7899969013691628E+000,
      -9.7595427818036953E+000,
      -9.7291771116529446E+000,
      -9.6989010897015522E+000,
      -9.6687159111950258E+000,
      -9.6386227677925298E+000,
      -9.6086228475198183E+000,
      -9.5787173347224233E+000,
      -9.5489074100187263E+000,
      -9.5191942502535483E+000,
      -9.4895790284515567E+000,
      -9.4600629137709902E+000,
      -9.4306470714575195E+000,
      -9.4013326627982305E+000,
      -9.3721208450757825E+000,
      -9.3430127715227034E+000,
      -9.3140095912759495E+000,
      -9.2851124493313453E+000,
      -9.2563224864986431E+000,
      -9.2276408393562122E+000,
      -9.1990686402064199E+000,
      -9.1706070170307523E+000,
      -9.1422570934453535E+000,
      -9.1140199886566666E+000,
      -9.0858968174172219E+000,
      -9.0578886899817128E+000,
      -9.0299967120629905E+000,
      -9.0022219847886316E+000,
      -8.9745656046572968E+000,
      -8.9470286634955283E+000,
      -8.9196122484145732E+000,
      -8.8923174417675970E+000,
      -8.8651453211068141E+000,
      -8.8380969591410210E+000,
      -8.8111734236932406E+000,
      -8.7843757776585285E+000,
      -8.7577050789621165E+000,
      -8.7311623805174552E+000,
      -8.7047487301848818E+000,
      -8.6784651707300657E+000,
      -8.6523127397829320E+000,
      -8.6262924697966721E+000,
      -8.6004053880069780E+000,
      -8.5746525163915575E+000,
      -8.5490348716296243E+000,
      -8.5235534650619904E+000,
      -8.4982093026508938E+000,
      -8.4730033849405366E+000,
      -8.4479367070173250E+000,
      -8.4230102584708284E+000,
      -8.3982250233545397E+000,
      -8.3735819801471010E+000,
      -8.3490821017136660E+000,
      -8.3247263552674688E+000,
      -8.3005157023317171E+000,
      -8.2764510987014770E+000,
      -8.2525334944061353E+000,
      -8.2287638336717475E+000,
      -8.2051430548838127E+000,
      -8.1816720905502365E+000,
      -8.1583518672644875E+000,
      -8.1351833056690896E+000,
      -8.1121673204191325E+000,
      -8.0893048201463547E+000,
      -8.0665967074230700E+000,
      -8.0440438787267343E+000,
      -8.0216472244043615E+000,
      -7.9994076286375506E+000,
      -7.9773259694074490E+000,
      -7.9554031184601541E+000,
      -7.9336399412722836E+000,
      -7.9120372970167940E+000,
      -7.8905960385291314E+000,
      -7.8693170122734166E+000,
      -7.8482010583092068E+000,
      -7.8272490102581962E+000,
      -7.8064616952713672E+000,
      -7.7858399339963205E+000,
      -7.7653845405448703E+000,
      -7.7450963224609595E+000,
      -7.7249760806886520E+000,
      -7.7050246095406898E+000,
      -7.6852426966669443E+000,
      -7.6656311230235090E+000,
      -7.6461906628416854E+000,
      -7.6269220835975879E+000,
      -7.6078261459817220E+000,
      -7.5889036038690065E+000,
      -7.5701552042890032E+000,
      -7.5515816873964159E+000,
      -7.5331837864419171E+000,
      -7.5149622277430961E+000,
      -7.4969177306559178E+000,
      -7.4790510075462215E+000,
      -7.4613627637616444E+000,
      -7.4438536976037613E+000,
      -7.4265245003005145E+000,
      -7.4093758559789720E+000,
      -7.3924084416382074E+000,
      -7.3756229271227252E+000,
      -7.3590199750958609E+000,
      -7.3426002410137663E+000,
      -7.3263643730993930E+000,
      -7.3103130123170343E+000,
      -7.2944467923469176E+000,
      -7.2787663395602404E+000,
      -7.2632722729944321E+000,
      -7.2479652043287004E+000,
      -7.2328457378599316E+000,
      -7.2179144704787399E+000,
      -7.2031719916460197E+000,
      -7.1886188833695845E+000,
      -7.1742557201812298E+000,
      -7.1600830691140445E+000,
      -7.1461014896800172E+000,
      -7.1323115338479885E+000,
      -7.1187137460217693E+000,
      -7.1053086630187714E+000,
      -7.0920968140486895E+000,
      -7.0790787206927268E+000,
      -7.0662548968828904E+000,
      -7.0536258488818060E+000,
      -7.0411920752626598E+000,
      -7.0289540668895434E+000,
      -7.0169123068980710E+000,
      -7.0050672706763040E+000,
      -6.9934194258460094E+000,
      -6.9819692322441291E+000,
      -6.9707171419047222E+000,
      -6.9596635990410407E+000,
      -6.9488090400280305E+000,
      -6.9381538933850964E+000,
      -6.9276985797591770E+000,
      -6.9174435119081688E+000,
      -6.9073890946845680E+000,
      -6.8975357250195746E+000,
      -6.8878837919073268E+000,
      -6.8784336763896414E+000,
      -6.8691857515408747E+000,
      -6.8601403824532818E+000,
      -6.8512979262225402E+000,
      -6.8426587319336809E+000,
      -6.8342231406473024E+000,
      -6.8259914853860995E+000,
      -6.8179640911217412E+000,
      -6.8101412747619907E+000,
      -6.8025233451382547E+000,
      -6.7951106029933470E+000,
      -6.7879033409696348E+000,
      -6.7809018435974835E+000,
      -6.7741063872840144E+000,
      -6.7675172403022197E+000,
      -6.7611346627803250E+000,
      -6.7549589066915772E+000,
      -6.7489902158442376E+000,
      -6.7432288258720137E+000,
      -6.7376749642247038E+000,
      -6.7323288501592655E+000,
      -6.7271906947311262E+000,
      -6.7222607007858626E+000,
      -6.7175390629511949E+000,
      -6.7130259676292976E+000,
      -6.7087215929894528E+000,
      -6.7046261089609942E+000,
      -6.7007396772266237E+000,
      -6.6970624512160066E+000,
      -6.6935945760997351E+000,
      -6.6903361887835739E+000,
      -6.6872874179030806E+000,
      -6.6844483838185091E+000,
      -6.6818191986100599E+000,
      -6.6793999660734666E+000,
      -6.6771907817158853E+000,
      -6.6751917327521344E+000,
      -6.6734028981012408E+000,
      -6.6718243483833355E+000,
      -6.6704561459168579E+000,
      -6.6692983447160996E+000,
      -6.6683509904890679E+000,
      -6.6676141206356858E+000,
      -6.6670877642463147E+000,
      -6.6667719421006026E+000,
      -6.6666666666666670E+000,
      -6.6667719421006026E+000,
      -6.6670877642463147E+000,
      -6.6676141206356867E+000,
      -6.6683509904890679E+000,
      -6.6692983447160987E+000,
      -6.6704561459168579E+000,
      -6.6718243483833346E+000,
      -6.6734028981012408E+000,
      -6.6751917327521344E+000,
      -6.6771907817158853E+000,
      -6.6793999660734658E+000,
      -6.6818191986100599E+000,
      -6.6844483838185083E+000,
      -6.6872874179030806E+000,
      -6.6903361887835757E+000,
      -6.6935945760997324E+000,
      -6.6970624512160075E+000,
      -6.7007396772266228E+000,
      -6.7046261089609951E+000,
      -6.7087215929894501E+000,
      -6.7130259676292985E+000,
      -6.7175390629511966E+000,
      -6.7222607007858617E+000,
      -6.7271906947311253E+000,
      -6.7323288501592673E+000,
      -6.7376749642247056E+000,
      -6.7432288258720092E+000,
      -6.7489902158442394E+000,
      -6.7549589066915727E+000,
      -6.7611346627803277E+000,
      -6.7675172403022179E+000,
      -6.7741063872840162E+000,
      -6.7809018435974853E+000,
      -6.7879033409696339E+000,
      -6.7951106029933506E+000,
      -6.8025233451382530E+000,
      -6.8101412747619934E+000,
      -6.8179640911217403E+000,
      -6.8259914853861030E+000,
      -6.8342231406473006E+000,
      -6.8426587319336791E+000,
      -6.8512979262225384E+000,
      -6.8601403824532801E+000,
      -6.8691857515408783E+000,
      -6.8784336763896343E+000,
      -6.8878837919073312E+000,
      -6.8975357250195728E+000,
      -6.9073890946845715E+000,
      -6.9174435119081670E+000,
      -6.9276985797591806E+000,
      -6.9381538933850999E+000,
      -6.9488090400280287E+000,
      -6.9596635990410389E+000,
      -6.9707171419047258E+000,
      -6.9819692322441336E+000,
      -6.9934194258460005E+000,
      -7.0050672706763084E+000,
      -7.0169123068980621E+000,
      -7.0289540668895407E+000,
      -7.0411920752626571E+000,
      -7.0536258488818042E+000,
      -7.0662548968828949E+000,
      -7.0790787206927170E+000,
      -7.0920968140486940E+000,
      -7.1053086630187616E+000,
      -7.1187137460217738E+000,
      -7.1323115338479850E+000,
      -7.1461014896800226E+000,
      -7.1600830691140409E+000,
      -7.1742557201812271E+000,
      -7.1886188833695890E+000,
      -7.2031719916460162E+000,
      -7.2179144704787452E+000,
      -7.2328457378599200E+000,
      -7.2479652043287057E+000,
      -7.2632722729944295E+000,
      -7.2787663395602378E+000,
      -7.2944467923469229E+000,
      -7.3103130123170308E+000,
      -7.3263643730994001E+000,
      -7.3426002410137539E+000,
      -7.3590199750958663E+000,
      -7.3756229271227225E+000,
      -7.3924084416382128E+000,
      -7.4093758559789675E+000,
      -7.4265245003005207E+000,
      -7.4438536976037666E+000,
      -7.4613627637616400E+000,
      -7.4790510075462189E+000,
      -7.4969177306559143E+000,
      -7.5149622277431023E+000,
      -7.5331837864419136E+000,
      -7.5515816873964221E+000,
      -7.5701552042890095E+000,
      -7.5889036038690030E+000,
      -7.6078261459817176E+000,
      -7.6269220835975844E+000,
      -7.6461906628416809E+000,
      -7.6656311230234930E+000,
      -7.6852426966669505E+000,
      -7.7050246095406747E+000,
      -7.7249760806886600E+000,
      -7.7450963224609550E+000,
      -7.7653845405448783E+000,
      -7.7858399339963160E+000,
      -7.8064616952713628E+000,
      -7.8272490102582042E+000,
      -7.8482010583092023E+000,
      -7.8693170122734246E+000,
      -7.8905960385291269E+000,
      -7.9120372970168029E+000,
      -7.9336399412722782E+000,
      -7.9554031184601488E+000,
      -7.9773259694074437E+000,
      -7.9994076286375453E+000,
      -8.0216472244043704E+000,
      -8.0440438787267183E+000,
      -8.0665967074230771E+000,
      -8.0893048201463493E+000,
      -8.1121673204191396E+000,
      -8.1351833056690861E+000,
      -8.1583518672644963E+000,
      -8.1816720905502454E+000,
      -8.2051430548838074E+000,
      -8.2287638336717546E+000,
      -8.2525334944061441E+000,
      -8.2764510987014841E+000,
      -8.3005157023317100E+000,
      -8.3247263552674777E+000,
      -8.3490821017136465E+000,
      -8.3735819801470974E+000,
      -8.3982250233545326E+000,
      -8.4230102584708213E+000,
      -8.4479367070173339E+000,
      -8.4730033849405295E+000,
      -8.4982093026509062E+000,
      -8.5235534650619691E+000,
      -8.5490348716296314E+000,
      -8.5746525163915521E+000,
      -8.6004053880069886E+000,
      -8.6262924697966668E+000,
      -8.6523127397829267E+000,
      -8.6784651707300764E+000,
      -8.7047487301848747E+000,
      -8.7311623805174658E+000,
      -8.7577050789620934E+000,
      -8.7843757776585374E+000,
      -8.8111734236932353E+000,
      -8.8380969591410175E+000,
      -8.8651453211068230E+000,
      -8.8923174417675916E+000,
      -8.9196122484145821E+000,
      -8.9470286634955087E+000,
      -8.9745656046573057E+000,
      -9.0022219847886404E+000,
      -9.0299967120630011E+000,
      -9.0578886899817057E+000,
      -9.0858968174172308E+000,
      -9.1140199886566755E+000,
      -9.1422570934453464E+000,
      -9.1706070170307612E+000,
      -9.1990686402064146E+000,
      -9.2276408393562228E+000,
      -9.2563224864986360E+000,
      -9.2851124493313559E+000,
      -9.3140095912759584E+000,
      -9.3430127715227158E+000,
      -9.3721208450757771E+000,
      -9.4013326627982234E+000,
      -9.4306470714575124E+000,
      -9.4600629137710008E+000,
      -9.4895790284515673E+000,
      -9.5191942502535447E+000,
      -9.5489074100187334E+000,
      -9.5787173347224019E+000,
      -9.6086228475198290E+000,
      -9.6386227677925227E+000,
      -9.6687159111950223E+000,
      -9.6989010897015611E+000,
      -9.7291771116529393E+000,
      -9.7595427818037059E+000,
      -9.7899969013691397E+000,
      -9.8205382680728093E+000,
      -9.8511656761937996E+000,
      -9.8818779166145028E+000,
      -9.9126737768682531E+000,
      -9.9435520411872140E+000,
      -9.9745114905504053E+000,
      -1.0005550902731724E+001,
      -1.0036669052348390E+001,
      -1.0067864710909078E+001,
      -1.0099136646862666E+001,
      -1.0130483625646621E+001,
      -1.0161904409735907E+001,
      -1.0193397758691795E+001,
      -1.0224962429210734E+001,
      -1.0256597175173653E+001,
      -1.0288300747694874E+001,
      -1.0320071895171697E+001,
      -1.0351909363333618E+001,
      -1.0383811895291876E+001,
      -1.0415778231589131E+001,
      -1.0447807110249217E+001,
      -1.0479897266826811E+001,
      -1.0512047434457440E+001,
      -1.0544256343907591E+001,
      -1.0576522723624656E+001,
      -1.0608845299787225E+001,
      -1.0641222796355285E+001,
      -1.0673653935120779E+001,
      -1.0706137435757832E+001,
      -1.0738672015873469E+001,
      -1.0771256391058182E+001,
      -1.0803889274936630E+001,
      -1.0836569379218435E+001,
      -1.0869295413749033E+001,
      -1.0902066086560641E+001,
      -1.0934880103923151E+001,
      -1.0967736170395417E+001,
      -1.1000632988876138E+001,
      -1.1033569260655266E+001,
      -1.1066543685465193E+001,
      -1.1099554961532082E+001,
      -1.1132601785627301E+001,
      -1.1165682853118760E+001,
      -1.1198796858022638E+001,
      -1.1231942493054662E+001,
      -1.1265118449681937E+001,
      -1.1298323418174496E+001,
      -1.1331556087657045E+001,
      -1.1364815146160675E+001,
      -1.1398099280674760E+001,
      -1.1431407177198627E+001,
      -1.1464737520793513E+001,
      -1.1498088995634600E+001,
      -1.1531460285062710E+001,
      -1.1564850071636497E+001,
      -1.1598257037184341E+001,
      -1.1631679862856503E+001,
      -1.1665117229177014E+001,
      -1.1698567816095865E+001,
      -1.1732030303041222E+001,
      -1.1765503368971398E+001,
      -1.1798985692427026E+001,
      -1.1832475951583303E+001,
      -1.1865972824302204E+001,
      -1.1899474988184474E+001,
      -1.1932981120622122E+001,
      -1.1966489898850352E+001,
      -1.1999999999999996E+001,
      -1.2033510101149663E+001,
      -1.2067018879377875E+001,
      -1.2100525011815520E+001,
      -1.2134027175697788E+001,
      -1.2167524048416690E+001,
      -1.2201014307572988E+001,
      -1.2234496631028614E+001,
      -1.2267969696958771E+001,
      -1.2301432183904128E+001,
      -1.2334882770823020E+001,
      -1.2368320137143490E+001,
      -1.2401742962815650E+001,
      -1.2435149928363495E+001,
      -1.2468539714937304E+001,
      -1.2501911004365413E+001,
      -1.2535262479206482E+001,
      -1.2568592822801406E+001,
      -1.2601900719325233E+001,
      -1.2635184853839320E+001,
      -1.2668443912342950E+001,
      -1.2701676581825499E+001,
      -1.2734881550318079E+001,
      -1.2768057506945352E+001,
      -1.2801203141977355E+001,
      -1.2834317146881233E+001,
      -1.2867398214372731E+001,
      -1.2900445038467913E+001,
      -1.2933456314534801E+001,
      -1.2966430739344727E+001,
      -1.2999367011123875E+001,
      -1.3032263829604577E+001,
      -1.3065119896076844E+001,
      -1.3097933913439389E+001,
      -1.3130704586250960E+001,
      -1.3163430620781559E+001,
      -1.3196110725063363E+001,
      -1.3228743608941812E+001,
      -1.3261327984126526E+001,
      -1.3293862564242184E+001,
      -1.3326346064879216E+001,
      -1.3358777203644712E+001,
      -1.3391154700212788E+001,
      -1.3423477276375339E+001,
      -1.3455743656092402E+001,
      -1.3487952565542553E+001,
      -1.3520102733173220E+001,
      -1.3552192889750778E+001,
      -1.3584221768410863E+001,
      -1.3616188104708119E+001,
      -1.3648090636666373E+001,
      -1.3679928104828296E+001,
      -1.3711699252305122E+001,
      -1.3743402824826342E+001,
      -1.3775037570789262E+001,
      -1.3806602241308234E+001,
      -1.3838095590264084E+001,
      -1.3869516374353376E+001,
      -1.3900863353137328E+001,
      -1.3932135289090915E+001,
      -1.3963330947651603E+001,
      -1.3994449097268273E+001,
      -1.4025488509449625E+001,
      -1.4056447958812779E+001,
      -1.4087326223131743E+001,
      -1.4118122083385492E+001,
      -1.4148834323806193E+001,
      -1.4179461731927187E+001,
      -1.4210003098630857E+001,
      -1.4240457218196287E+001,
      -1.4270822888347057E+001,
      -1.4301098910298450E+001,
      -1.4331284088804974E+001,
      -1.4361377232207474E+001,
      -1.4391377152480167E+001,
      -1.4421282665277595E+001,
      -1.4451092589981259E+001,
      -1.4480805749746452E+001,
      -1.4510420971548443E+001,
      -1.4539937086229012E+001,
      -1.4569352928542482E+001,
      -1.4598667337201773E+001,
      -1.4627879154924218E+001,
      -1.4656987228477281E+001,
      -1.4685990408724066E+001,
      -1.4714887550668639E+001,
      -1.4743677513501375E+001,
      -1.4772359160643790E+001,
      -1.4800931359793580E+001,
      -1.4829392982969233E+001,
      -1.4857742906554650E+001,
      -1.4885980011343351E+001,
      -1.4914103182582766E+001,
      -1.4942111310018287E+001,
      -1.4970003287937010E+001,
      -1.4997778015211368E+001,
      -1.5025434395342689E+001,
      -1.5052971336504488E+001,
      -1.5080387751585413E+001,
      -1.5107682558232405E+001,
      -1.5134854678893188E+001,
      -1.5161903040858979E+001,
      -1.5188826576306777E+001,
      -1.5215624222341459E+001,
      -1.5242294921037903E+001,
      -1.5268837619482531E+001,
      -1.5295251269815122E+001,
      -1.5321534829269934E+001,
      -1.5347687260217070E+001,
      -1.5373707530203330E+001,
      -1.5399594611993010E+001,
      -1.5425347483608462E+001,
      -1.5450965128370365E+001,
      -1.5476446534938027E+001,
      -1.5501790697349090E+001,
      -1.5526996615059478E+001,
      -1.5552063292982677E+001,
      -1.5576989741529172E+001,
      -1.5601774976645478E+001,
      -1.5626418019852899E+001,
      -1.5650917898286346E+001,
      -1.5675273644732520E+001,
      -1.5699484297668288E+001,
      -1.5723548901298527E+001,
      -1.5747466505593867E+001,
      -1.5771236166328240E+001,
      -1.5794856945116187E+001,
      -1.5818327909449778E+001,
      -1.5841648132735502E+001,
      -1.5864816694330912E+001,
      -1.5887832679580857E+001,
      -1.5910695179853660E+001,
      -1.5933403292576921E+001,
      -1.5955956121273278E+001,
      -1.5978352775595654E+001,
      -1.6000592371362451E+001,
      -1.6022674030592555E+001,
      -1.6044596881539849E+001,
      -1.6066360058727717E+001,
      -1.6087962702983194E+001,
      -1.6109403961470882E+001,
      -1.6130682987726573E+001,
      -1.6151798941690796E+001,
      -1.6172750989741807E+001,
      -1.6193538304728637E+001,
      -1.6214160066003682E+001,
      -1.6234615459455121E+001,
      -1.6254903677539055E+001,
      -1.6275023919311337E+001,
      -1.6294975390459321E+001,
      -1.6314757303333057E+001,
      -1.6334368876976505E+001,
      -1.6353809337158317E+001,
      -1.6373077916402412E+001,
      -1.6392173854018282E+001,
      -1.6411096396130993E+001,
      -1.6429844795711009E+001,
      -1.6448418312603575E+001,
      -1.6466816213558094E+001,
      -1.6485037772256906E+001,
      -1.6503082269344084E+001,
      -1.6520948992453782E+001,
      -1.6538637236238355E+001,
      -1.6556146302396250E+001,
      -1.6573475499699480E+001,
      -1.6590624144021032E+001,
      -1.6607591558361793E+001,
      -1.6624377072877287E+001,
      -1.6640980024904131E+001,
      -1.6657399758986244E+001,
      -1.6673635626900602E+001,
      -1.6689686987682968E+001,
      -1.6705553207653082E+001,
      -1.6721233660439761E+001,
      -1.6736727727005572E+001,
      -1.6752034795671292E+001,
      -1.6767154262140078E+001,
      -1.6782085529521254E+001,
      -1.6796828008353980E+001,
      -1.6811381116630418E+001,
      -1.6825744279818771E+001,
      -1.6839916930885956E+001,
      -1.6853898510319976E+001,
      -1.6867688466152014E+001,
      -1.6881286253978224E+001,
      -1.6894691336981239E+001,
      -1.6907903185951305E+001,
      -1.6920921279307283E+001,
      -1.6933745103117111E+001,
      -1.6946374151118192E+001,
      -1.6958807924737339E+001,
      -1.6971045933110460E+001,
      -1.6983087693101936E+001,
      -1.6994932729323690E+001,
      -1.7006580574154000E+001,
      -1.7018030767755874E+001,
      -1.7029282858095282E+001,
      -1.7040336400958960E+001,
      -1.7051190959971972E+001,
      -1.7061846106614897E+001,
      -1.7072301420240819E+001,
      -1.7082556488091836E+001,
      -1.7092610905315428E+001,
      -1.7102464274980434E+001,
      -1.7112116208092676E+001,
      -1.7121566323610363E+001,
      -1.7130814248459121E+001,
      -1.7139859617546719E+001,
      -1.7148702073777464E+001,
      -1.7157341268066322E+001,
      -1.7165776859352700E+001,
      -1.7174008514613895E+001,
      -1.7182035908878266E+001,
      -1.7189858725238008E+001,
      -1.7197476654861749E+001,
      -1.7204889397006653E+001,
      -1.7212096659030365E+001,
      -1.7219098156402520E+001,
      -1.7225893612715986E+001,
      -1.7232482759697788E+001,
      -1.7238865337219675E+001,
      -1.7245041093308426E+001,
      -1.7251009784155762E+001,
      -1.7256771174127991E+001,
      -1.7262325035775298E+001,
      -1.7267671149840737E+001,
      -1.7272809305268879E+001,
      -1.7277739299214140E+001,
      -1.7282460937048810E+001,
      -1.7286974032370704E+001,
      -1.7291278407010552E+001,
      -1.7295373891039006E+001,
      -1.7299260322773382E+001,
      -1.7302937548783998E+001,
      -1.7306405423900269E+001,
      -1.7309663811216428E+001,
      -1.7312712582096921E+001,
      -1.7315551616181494E+001,
      -1.7318180801389943E+001,
      -1.7320600033926539E+001,
      -1.7322809218284117E+001,
      -1.7324808267247867E+001,
      -1.7326597101898759E+001,
      -1.7328175651616665E+001,
      -1.7329543854083145E+001,
      -1.7330701655283903E+001,
      -1.7331649009510933E+001,
      -1.7332385879364317E+001,
      -1.7332912235753689E+001,
      -1.7333228057899401E+001,
      -1.7333333333333336E+001,
      -1.7333228057899401E+001,
      -1.7332912235753689E+001,
      -1.7332385879364317E+001,
      -1.7331649009510933E+001,
      -1.7330701655283903E+001,
      -1.7329543854083145E+001,
      -1.7328175651616665E+001,
      -1.7326597101898763E+001,
      -1.7324808267247867E+001,
      -1.7322809218284117E+001,
      -1.7320600033926539E+001,
      -1.7318180801389943E+001,
      -1.7315551616181494E+001,
      -1.7312712582096921E+001,
      -1.7309663811216428E+001,
      -1.7306405423900269E+001,
      -1.7302937548783998E+001,
      -1.7299260322773382E+001,
      -1.7295373891039009E+001,
      -1.7291278407010552E+001,
      -1.7286974032370708E+001,
      -1.7282460937048810E+001,
      -1.7277739299214140E+001,
      -1.7272809305268879E+001,
      -1.7267671149840737E+001,
      -1.7262325035775294E+001,
      -1.7256771174127991E+001,
      -1.7251009784155766E+001,
      -1.7245041093308426E+001,
      -1.7238865337219675E+001,
      -1.7232482759697785E+001,
      -1.7225893612715986E+001,
      -1.7219098156402520E+001,
      -1.7212096659030362E+001,
      -1.7204889397006660E+001,
      -1.7197476654861745E+001,
      -1.7189858725238015E+001,
      -1.7182035908878262E+001,
      -1.7174008514613899E+001,
      -1.7165776859352700E+001,
      -1.7157341268066322E+001,
      -1.7148702073777464E+001,
      -1.7139859617546715E+001,
      -1.7130814248459128E+001,
      -1.7121566323610363E+001,
      -1.7112116208092672E+001,
      -1.7102464274980431E+001,
      -1.7092610905315436E+001,
      -1.7082556488091836E+001,
      -1.7072301420240819E+001,
      -1.7061846106614908E+001,
      -1.7051190959971965E+001,
      -1.7040336400958964E+001,
      -1.7029282858095279E+001,
      -1.7018030767755878E+001,
      -1.7006580574153997E+001,
      -1.6994932729323700E+001,
      -1.6983087693101933E+001,
      -1.6971045933110457E+001,
      -1.6958807924737343E+001,
      -1.6946374151118189E+001,
      -1.6933745103117115E+001,
      -1.6920921279307279E+001,
      -1.6907903185951316E+001,
      -1.6894691336981236E+001,
      -1.6881286253978221E+001,
      -1.6867688466152018E+001,
      -1.6853898510319972E+001,
      -1.6839916930885959E+001,
      -1.6825744279818768E+001,
      -1.6811381116630422E+001,
      -1.6796828008353977E+001,
      -1.6782085529521268E+001,
      -1.6767154262140071E+001,
      -1.6752034795671289E+001,
      -1.6736727727005576E+001,
      -1.6721233660439772E+001,
      -1.6705553207653089E+001,
      -1.6689686987682961E+001,
      -1.6673635626900612E+001,
      -1.6657399758986241E+001,
      -1.6640980024904124E+001,
      -1.6624377072877280E+001,
      -1.6607591558361797E+001,
      -1.6590624144021035E+001,
      -1.6573475499699473E+001,
      -1.6556146302396247E+001,
      -1.6538637236238351E+001,
      -1.6520948992453786E+001,
      -1.6503082269344080E+001,
      -1.6485037772256909E+001,
      -1.6466816213558090E+001,
      -1.6448418312603589E+001,
      -1.6429844795711002E+001,
      -1.6411096396130990E+001,
      -1.6392173854018285E+001,
      -1.6373077916402409E+001,
      -1.6353809337158321E+001,
      -1.6334368876976498E+001,
      -1.6314757303333060E+001,
      -1.6294975390459317E+001,
      -1.6275023919311330E+001,
      -1.6254903677539048E+001,
      -1.6234615459455114E+001,
      -1.6214160066003689E+001,
      -1.6193538304728651E+001,
      -1.6172750989741811E+001,
      -1.6151798941690789E+001,
      -1.6130682987726590E+001,
      -1.6109403961470875E+001,
      -1.6087962702983187E+001,
      -1.6066360058727724E+001,
      -1.6044596881539864E+001,
      -1.6022674030592558E+001,
      -1.6000592371362444E+001,
      -1.5978352775595647E+001,
      -1.5955956121273271E+001,
      -1.5933403292576912E+001,
      -1.5910695179853652E+001,
      -1.5887832679580875E+001,
      -1.5864816694330916E+001,
      -1.5841648132735520E+001,
      -1.5818327909449771E+001,
      -1.5794856945116180E+001,
      -1.5771236166328263E+001,
      -1.5747466505593859E+001,
      -1.5723548901298530E+001,
      -1.5699484297668292E+001,
      -1.5675273644732538E+001,
      -1.5650917898286339E+001,
      -1.5626418019852892E+001,
      -1.5601774976645471E+001,
      -1.5576989741529164E+001,
      -1.5552063292982684E+001,
      -1.5526996615059470E+001,
      -1.5501790697349113E+001,
      -1.5476446534938020E+001,
      -1.5450965128370383E+001,
      -1.5425347483608450E+001,
      -1.5399594611992999E+001,
      -1.5373707530203337E+001,
      -1.5347687260217063E+001,
      -1.5321534829269941E+001,
      -1.5295251269815109E+001,
      -1.5268837619482552E+001,
      -1.5242294921037896E+001,
      -1.5215624222341452E+001,
      -1.5188826576306770E+001,
      -1.5161903040859000E+001,
      -1.5134854678893195E+001,
      -1.5107682558232398E+001,
      -1.5080387751585434E+001,
      -1.5052971336504481E+001,
      -1.5025434395342716E+001,
      -1.4997778015211361E+001,
      -1.4970003287937018E+001,
      -1.4942111310018296E+001,
      -1.4914103182582787E+001,
      -1.4885980011343344E+001,
      -1.4857742906554639E+001,
      -1.4829392982969255E+001,
      -1.4800931359793571E+001,
      -1.4772359160643797E+001,
      -1.4743677513501364E+001,
      -1.4714887550668662E+001,
      -1.4685990408724059E+001,
      -1.4656987228477270E+001,
      -1.4627879154924225E+001,
      -1.4598667337201762E+001,
      -1.4569352928542489E+001,
      -1.4539937086229001E+001,
      -1.4510420971548450E+001,
      -1.4480805749746443E+001,
      -1.4451092589981286E+001,
      -1.4421282665277584E+001,
      -1.4391377152480157E+001,
      -1.4361377232207481E+001,
      -1.4331284088805001E+001,
      -1.4301098910298457E+001,
      -1.4270822888347046E+001,
      -1.4240457218196312E+001,
      -1.4210003098630846E+001,
      -1.4179461731927175E+001,
      -1.4148834323806200E+001,
      -1.4118122083385517E+001,
      -1.4087326223131750E+001,
      -1.4056447958812772E+001,
      -1.4025488509449614E+001,
      -1.3994449097268262E+001,
      -1.3963330947651627E+001,
      -1.3932135289090908E+001,
      -1.3900863353137353E+001,
      -1.3869516374353383E+001,
      -1.3838095590264111E+001,
      -1.3806602241308227E+001,
      -1.3775037570789252E+001,
      -1.3743402824826369E+001,
      -1.3711699252305110E+001,
      -1.3679928104828306E+001,
      -1.3648090636666383E+001,
      -1.3616188104708144E+001,
      -1.3584221768410854E+001,
      -1.3552192889750765E+001,
      -1.3520102733173211E+001,
      -1.3487952565542544E+001,
      -1.3455743656092409E+001,
      -1.3423477276375330E+001,
      -1.3391154700212796E+001,
      -1.3358777203644701E+001,
      -1.3326346064879242E+001,
      -1.3293862564242172E+001,
      -1.3261327984126515E+001,
      -1.3228743608941821E+001,
      -1.3196110725063392E+001,
      -1.3163430620781570E+001,
      -1.3130704586250948E+001,
      -1.3097933913439379E+001,
      -1.3065119896076835E+001,
      -1.3032263829604567E+001,
      -1.2999367011123864E+001,
      -1.2966430739344752E+001,
      -1.2933456314534808E+001,
      -1.2900445038467938E+001,
      -1.2867398214372720E+001,
      -1.2834317146881220E+001,
      -1.2801203141977384E+001,
      -1.2768057506945341E+001,
      -1.2734881550318086E+001,
      -1.2701676581825506E+001,
      -1.2668443912342976E+001,
      -1.2635184853839311E+001,
      -1.2601900719325222E+001,
      -1.2568592822801396E+001,
      -1.2535262479206470E+001,
      -1.2501911004365422E+001,
      -1.2468539714937291E+001,
      -1.2435149928363524E+001,
      -1.2401742962815639E+001,
      -1.2368320137143519E+001,
      -1.2334882770823009E+001,
      -1.2301432183904117E+001,
      -1.2267969696958779E+001,
      -1.2234496631028604E+001,
      -1.2201014307572995E+001,
      -1.2167524048416679E+001,
      -1.2134027175697815E+001,
      -1.2100525011815510E+001,
      -1.2067018879377864E+001,
      -1.2033510101149652E+001,
      -1.2000000000000025E+001,
      -1.1966489898850361E+001,
      -1.1932981120622111E+001,
      -1.1899474988184499E+001,
      -1.1865972824302196E+001,
      -1.1832475951583332E+001,
      -1.1798985692427015E+001,
      -1.1765503368971407E+001,
      -1.1732030303041233E+001,
      -1.1698567816095855E+001,
      -1.1665117229177003E+001,
      -1.1631679862856492E+001,
      -1.1598257037184371E+001,
      -1.1564850071636487E+001,
      -1.1531460285062719E+001,
      -1.1498088995634589E+001,
      -1.1464737520793541E+001,
      -1.1431407177198617E+001,
      -1.1398099280674751E+001,
      -1.1364815146160701E+001,
      -1.1331556087657036E+001,
      -1.1298323418174505E+001,
      -1.1265118449681925E+001,
      -1.1231942493054669E+001,
      -1.1198796858022627E+001,
      -1.1165682853118788E+001,
      -1.1132601785627291E+001,
      -1.1099554961532073E+001,
      -1.1066543685465202E+001,
      -1.1033569260655257E+001,
      -1.1000632988876147E+001,
      -1.0967736170395408E+001,
      -1.0934880103923177E+001,
      -1.0902066086560632E+001,
      -1.0869295413749025E+001,
      -1.0836569379218442E+001,
      -1.0803889274936621E+001,
      -1.0771256391058190E+001,
      -1.0738672015873460E+001,
      -1.0706137435757839E+001,
      -1.0673653935120768E+001,
      -1.0641222796355310E+001,
      -1.0608845299787214E+001,
      -1.0576522723624683E+001,
      -1.0544256343907602E+001,
      -1.0512047434457465E+001,
      -1.0479897266826798E+001,
      -1.0447807110249208E+001,
      -1.0415778231589156E+001,
      -1.0383811895291865E+001,
      -1.0351909363333629E+001,
      -1.0320071895171704E+001,
      -1.0288300747694901E+001,
      -1.0256597175173644E+001,
      -1.0224962429210724E+001,
      -1.0193397758691784E+001,
      -1.0161904409735900E+001,
      -1.0130483625646630E+001,
      -1.0099136646862657E+001,
      -1.0067864710909102E+001,
      -1.0036669052348383E+001,
      -1.0005550902731748E+001,
      -9.9745114905503964E+000,
      -9.9435520411872051E+000,
      -9.9126737768682602E+000,
      -9.8818779166144939E+000,
      -9.8511656761938067E+000,
      -9.8205382680727986E+000,
      -9.7899969013691663E+000,
      -9.7595427818036988E+000,
      -9.7291771116529286E+000,
      -9.6989010897015540E+000,
      -9.6687159111950098E+000,
      -9.6386227677925298E+000,
      -9.6086228475198183E+000,
      -9.5787173347224268E+000,
      -9.5489074100187263E+000,
      -9.5191942502535678E+000,
      -9.4895790284515584E+000,
      -9.4600629137709742E+000,
      -9.4306470714575195E+000,
      -9.4013326627982465E+000,
      -9.3721208450757842E+000,
      -9.3430127715227052E+000,
      -9.3140095912759513E+000,
      -9.2851124493313471E+000,
      -9.2563224864986431E+000,
      -9.2276408393562139E+000,
      -9.1990686402064394E+000,
      -9.1706070170307523E+000,
      -9.1422570934453393E+000,
      -9.1140199886566666E+000,
      -9.0858968174172219E+000,
      -9.0578886899817146E+000,
      -9.0299967120629923E+000,
      -9.0022219847886475E+000,
      -8.9745656046572968E+000,
      -8.9470286634955301E+000,
      -8.9196122484145732E+000,
      -8.8923174417675810E+000,
      -8.8651453211068141E+000,
      -8.8380969591410086E+000,
      -8.8111734236932424E+000,
      -8.7843757776585303E+000,
      -8.7577050789621165E+000,
      -8.7311623805174570E+000,
      -8.7047487301848978E+000,
      -8.6784651707300675E+000,
      -8.6523127397829196E+000,
      -8.6262924697966739E+000,
      -8.6004053880069780E+000,
      -8.5746525163915575E+000,
      -8.5490348716296243E+000,
      -8.5235534650619922E+000,
      -8.4982093026508956E+000,
      -8.4730033849405082E+000,
      -8.4479367070173268E+000,
      -8.4230102584708426E+000,
      -8.3982250233545415E+000,
      -8.3735819801470903E+000,
      -8.3490821017136678E+000,
      -8.3247263552674688E+000,
      -8.3005157023317171E+000,
      -8.2764510987014770E+000,
      -8.2525334944061512E+000,
      -8.2287638336717475E+000,
      -8.2051430548838002E+000,
      -8.1816720905502365E+000,
      -8.1583518672644892E+000,
      -8.1351833056690914E+000,
      -8.1121673204191325E+000,
      -8.0893048201463564E+000,
      -8.0665967074230700E+000,
      -8.0440438787267361E+000,
      -8.0216472244043615E+000,
      -7.9994076286375391E+000,
      -7.9773259694074490E+000,
      -7.9554031184601417E+000,
      -7.9336399412722844E+000,
      -7.9120372970167958E+000,
      -7.8905960385291332E+000,
      -7.8693170122734175E+000,
      -7.8482010583092201E+000,
      -7.8272490102581962E+000,
      -7.8064616952713566E+000,
      -7.7858399339963213E+000,
      -7.7653845405448942E+000,
      -7.7450963224609604E+000,
      -7.7249760806886538E+000,
      -7.7050246095406916E+000,
      -7.6852426966669452E+000,
      -7.6656311230234877E+000,
      -7.6461906628416854E+000,
      -7.6269220835976004E+000,
      -7.6078261459817229E+000,
      -7.5889036038689968E+000,
      -7.5701552042890041E+000,
      -7.5515816873964159E+000,
      -7.5331837864419180E+000,
      -7.5149622277430961E+000,
      -7.4969177306559285E+000,
      -7.4790510075462224E+000,
      -7.4613627637616551E+000,
      -7.4438536976037613E+000,
      -7.4265245003005154E+000,
      -7.4093758559789720E+000,
      -7.3924084416382083E+000,
      -7.3756229271227260E+000,
      -7.3590199750958618E+000,
      -7.3426002410137672E+000,
      -7.3263643730993939E+000,
      -7.3103130123170255E+000,
      -7.2944467923469185E+000,
      -7.2787663395602333E+000,
      -7.2632722729944330E+000,
      -7.2479652043287013E+000,
      -7.2328457378599325E+000,
      -7.2179144704787399E+000,
      -7.2031719916460286E+000,
      -7.1886188833695845E+000,
      -7.1742557201812218E+000,
      -7.1600830691140445E+000,
      -7.1461014896800341E+000,
      -7.1323115338479885E+000,
      -7.1187137460217693E+000,
      -7.1053086630187723E+000,
      -7.0920968140486904E+000,
      -7.0790787206927126E+000,
      -7.0662548968828904E+000,
      -7.0536258488818149E+000,
      -7.0411920752626607E+000,
      -7.0289540668895372E+000,
      -7.0169123068980719E+000,
      -7.0050672706763049E+000,
      -6.9934194258460094E+000,
      -6.9819692322441300E+000,
      -6.9707171419047285E+000,
      -6.9596635990410416E+000,
      -6.9488090400280367E+000,
      -6.9381538933850972E+000,
      -6.9276985797591770E+000,
      -6.9174435119081688E+000,
      -6.9073890946845689E+000,
      -6.8975357250195746E+000,
      -6.8878837919073277E+000,
      -6.8784336763896414E+000,
      -6.8691857515408756E+000,
      -6.8601403824532774E+000,
      -6.8512979262225402E+000,
      -6.8426587319336765E+000,
      -6.8342231406473024E+000,
      -6.8259914853860995E+000,
      -6.8179640911217421E+000,
      -6.8101412747619907E+000,
      -6.8025233451382592E+000,
      -6.7951106029933479E+000,
      -6.7879033409696321E+000,
      -6.7809018435974835E+000,
      -6.7741063872840215E+000,
      -6.7675172403022197E+000,
      -6.7611346627803250E+000,
      -6.7549589066915772E+000,
      -6.7489902158442376E+000,
      -6.7432288258720074E+000,
      -6.7376749642247038E+000,
      -6.7323288501592682E+000,
      -6.7271906947311262E+000,
      -6.7222607007858599E+000,
      -6.7175390629511949E+000,
      -6.7130259676292976E+000,
      -6.7087215929894537E+000,
      -6.7046261089609942E+000,
      -6.7007396772266237E+000,
      -6.6970624512160066E+000,
      -6.6935945760997351E+000,
      -6.6903361887835739E+000,
      -6.6872874179030788E+000,
      -6.6844483838185091E+000,
      -6.6818191986100590E+000,
      -6.6793999660734666E+000,
      -6.6771907817158853E+000,
      -6.6751917327521344E+000,
      -6.6734028981012408E+000,
      -6.6718243483833346E+000,
      -6.6704561459168579E+000,
      -6.6692983447160987E+000,
      -6.6683509904890679E+000,
      -6.6676141206356858E+000,
      -6.6670877642463147E+000,
      -6.6667719421006026E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6668666666666674E+000,
      -6.6674666666666669E+000,
      -6.6684666666666672E+000,
      -6.6698666666666675E+000,
      -6.6716666666666677E+000,
      -6.6738666666666671E+000,
      -6.6764666666666672E+000,
      -6.6794666666666673E+000,
      -6.6828666666666665E+000,
      -6.6866666666666665E+000,
      -6.6908666666666674E+000,
      -6.6954666666666673E+000,
      -6.7004666666666672E+000,
      -6.7058666666666680E+000,
      -6.7116666666666669E+000,
      -6.7178666666666675E+000,
      -6.7244666666666681E+000,
      -6.7314666666666669E+000,
      -6.7388666666666674E+000,
      -6.7466666666666679E+000,
      -6.7548666666666675E+000,
      -6.7634666666666670E+000,
      -6.7724666666666673E+000,
      -6.7818666666666667E+000,
      -6.7916666666666670E+000,
      -6.8018666666666672E+000,
      -6.8124666666666673E+000,
      -6.8234666666666666E+000,
      -6.8348666666666675E+000,
      -6.8466666666666667E+000,
      -6.8588666666666667E+000,
      -6.8714666666666675E+000,
      -6.8844666666666674E+000,
      -6.8978666666666673E+000,
      -6.9116666666666671E+000,
      -6.9258666666666677E+000,
      -6.9404666666666675E+000,
      -6.9554666666666671E+000,
      -6.9708666666666668E+000,
      -6.9866666666666672E+000,
      -7.0028666666666677E+000,
      -7.0194666666666681E+000,
      -7.0364666666666666E+000,
      -7.0538666666666670E+000,
      -7.0716666666666672E+000,
      -7.0898666666666665E+000,
      -7.1084666666666667E+000,
      -7.1274666666666677E+000,
      -7.1468666666666678E+000,
      -7.1666666666666679E+000,
      -7.1868666666666678E+000,
      -7.2074666666666678E+000,
      -7.2284666666666677E+000,
      -7.2498666666666676E+000,
      -7.2716666666666674E+000,
      -7.2938666666666672E+000,
      -7.3164666666666678E+000,
      -7.3394666666666675E+000,
      -7.3628666666666680E+000,
      -7.3866666666666676E+000,
      -7.4108666666666680E+000,
      -7.4354666666666676E+000,
      -7.4604666666666670E+000,
      -7.4858666666666664E+000,
      -7.5116666666666667E+000,
      -7.5378666666666669E+000,
      -7.5644666666666680E+000,
      -7.5914666666666673E+000,
      -7.6188666666666673E+000,
      -7.6466666666666674E+000,
      -7.6748666666666674E+000,
      -7.7034666666666674E+000,
      -7.7324666666666673E+000,
      -7.7618666666666671E+000,
      -7.7916666666666670E+000,
      -7.8218666666666676E+000,
      -7.8524666666666674E+000,
      -7.8834666666666671E+000,
      -7.9148666666666667E+000,
      -7.9466666666666672E+000,
      -7.9788666666666668E+000,
      -8.0114666666666672E+000,
      -8.0444666666666684E+000,
      -8.0778666666666670E+000,
      -8.1116666666666681E+000,
      -8.1458666666666666E+000,
      -8.1804666666666677E+000,
      -8.2154666666666678E+000,
      -8.2508666666666670E+000,
      -8.2866666666666671E+000,
      -8.3228666666666680E+000,
      -8.3594666666666679E+000,
      -8.3964666666666670E+000,
      -8.4338666666666668E+000,
      -8.4716666666666658E+000,
      -8.5098666666666674E+000,
      -8.5484666666666680E+000,
      -8.5874666666666677E+000,
      -8.6268666666666665E+000,
      -8.6666666666666679E+000,
      -8.7066666666666670E+000,
      -8.7466666666666679E+000,
      -8.7866666666666671E+000,
      -8.8266666666666680E+000,
      -8.8666666666666671E+000,
      -8.9066666666666663E+000,
      -8.9466666666666672E+000,
      -8.9866666666666664E+000,
      -9.0266666666666691E+000,
      -9.0666666666666682E+000,
      -9.1066666666666674E+000,
      -9.1466666666666665E+000,
      -9.1866666666666674E+000,
      -9.2266666666666666E+000,
      -9.2666666666666675E+000,
      -9.3066666666666666E+000,
      -9.3466666666666658E+000,
      -9.3866666666666667E+000,
      -9.4266666666666676E+000,
      -9.4666666666666686E+000,
      -9.5066666666666677E+000,
      -9.5466666666666669E+000,
      -9.5866666666666678E+000,
      -9.6266666666666669E+000,
      -9.6666666666666679E+000,
      -9.7066666666666670E+000,
      -9.7466666666666661E+000,
      -9.7866666666666653E+000,
      -9.8266666666666680E+000,
      -9.8666666666666689E+000,
      -9.9066666666666681E+000,
      -9.9466666666666672E+000,
      -9.9866666666666664E+000,
      -1.0026666666666667E+001,
      -1.0066666666666668E+001,
      -1.0106666666666667E+001,
      -1.0146666666666667E+001,
      -1.0186666666666666E+001,
      -1.0226666666666668E+001,
      -1.0266666666666667E+001,
      -1.0306666666666668E+001,
      -1.0346666666666668E+001,
      -1.0386666666666667E+001,
      -1.0426666666666666E+001,
      -1.0466666666666667E+001,
      -1.0506666666666668E+001,
      -1.0546666666666667E+001,
      -1.0586666666666666E+001,
      -1.0626666666666667E+001,
      -1.0666666666666668E+001,
      -1.0706666666666669E+001,
      -1.0746666666666668E+001,
      -1.0786666666666667E+001,
      -1.0826666666666666E+001,
      -1.0866666666666667E+001,
      -1.0906666666666666E+001,
      -1.0946666666666667E+001,
      -1.0986666666666666E+001,
      -1.1026666666666667E+001,
      -1.1066666666666668E+001,
      -1.1106666666666667E+001,
      -1.1146666666666668E+001,
      -1.1186666666666667E+001,
      -1.1226666666666667E+001,
      -1.1266666666666667E+001,
      -1.1306666666666667E+001,
      -1.1346666666666668E+001,
      -1.1386666666666667E+001,
      -1.1426666666666668E+001,
      -1.1466666666666669E+001,
      -1.1506666666666668E+001,
      -1.1546666666666669E+001,
      -1.1586666666666668E+001,
      -1.1626666666666667E+001,
      -1.1666666666666666E+001,
      -1.1706666666666667E+001,
      -1.1746666666666666E+001,
      -1.1786666666666667E+001,
      -1.1826666666666668E+001,
      -1.1866666666666667E+001,
      -1.1906666666666668E+001,
      -1.1946666666666667E+001,
      -1.1986666666666668E+001,
      -1.2026666666666667E+001,
      -1.2066666666666666E+001,
      -1.2106666666666667E+001,
      -1.2146666666666667E+001,
      -1.2186666666666666E+001,
      -1.2226666666666668E+001,
      -1.2266666666666667E+001,
      -1.2306666666666667E+001,
      -1.2346666666666668E+001,
      -1.2386666666666667E+001,
      -1.2426666666666668E+001,
      -1.2466666666666667E+001,
      -1.2506666666666666E+001,
      -1.2546666666666667E+001,
      -1.2586666666666666E+001,
      -1.2626666666666669E+001,
      -1.2666666666666668E+001,
      -1.2706666666666667E+001,
      -1.2746666666666668E+001,
      -1.2786666666666667E+001,
      -1.2826666666666668E+001,
      -1.2866666666666667E+001,
      -1.2906666666666666E+001,
      -1.2946666666666665E+001,
      -1.2986666666666666E+001,
      -1.3026666666666669E+001,
      -1.3066666666666668E+001,
      -1.3106666666666667E+001,
      -1.3146666666666667E+001,
      -1.3186666666666667E+001,
      -1.3226666666666668E+001,
      -1.3266666666666667E+001,
      -1.3306666666666667E+001,
      -1.3346666666666666E+001,
      -1.3386666666666667E+001,
      -1.3426666666666669E+001,
      -1.3466666666666669E+001,
      -1.3506666666666668E+001,
      -1.3546666666666667E+001,
      -1.3586666666666666E+001,
      -1.3626666666666667E+001,
      -1.3666666666666668E+001,
      -1.3706666666666667E+001,
      -1.3746666666666666E+001,
      -1.3786666666666665E+001,
      -1.3826666666666668E+001,
      -1.3866666666666669E+001,
      -1.3906666666666668E+001,
      -1.3946666666666667E+001,
      -1.3986666666666666E+001,
      -1.4026666666666667E+001,
      -1.4066666666666668E+001,
      -1.4106666666666667E+001,
      -1.4146666666666667E+001,
      -1.4186666666666666E+001,
      -1.4226666666666668E+001,
      -1.4266666666666669E+001,
      -1.4306666666666668E+001,
      -1.4346666666666668E+001,
      -1.4386666666666667E+001,
      -1.4426666666666668E+001,
      -1.4466666666666667E+001,
      -1.4506666666666668E+001,
      -1.4546666666666667E+001,
      -1.4586666666666666E+001,
      -1.4626666666666667E+001,
      -1.4666666666666668E+001,
      -1.4706666666666669E+001,
      -1.4746666666666668E+001,
      -1.4786666666666667E+001,
      -1.4826666666666666E+001,
      -1.4866666666666667E+001,
      -1.4906666666666668E+001,
      -1.4946666666666667E+001,
      -1.4986666666666666E+001,
      -1.5026666666666669E+001,
      -1.5066666666666668E+001,
      -1.5106666666666667E+001,
      -1.5146666666666667E+001,
      -1.5186666666666667E+001,
      -1.5226666666666668E+001,
      -1.5266666666666667E+001,
      -1.5306666666666667E+001,
      -1.5346666666666666E+001,
      -1.5386666666666667E+001,
      -1.5426666666666669E+001,
      -1.5466666666666669E+001,
      -1.5506666666666668E+001,
      -1.5546666666666667E+001,
      -1.5586666666666668E+001,
      -1.5626666666666669E+001,
      -1.5666666666666668E+001,
      -1.5706666666666667E+001,
      -1.5746666666666666E+001,
      -1.5786666666666665E+001,
      -1.5826666666666668E+001,
      -1.5866666666666669E+001,
      -1.5906666666666668E+001,
      -1.5946666666666667E+001,
      -1.5986666666666666E+001,
      -1.6026666666666667E+001,
      -1.6066666666666670E+001,
      -1.6106666666666669E+001,
      -1.6146666666666668E+001,
      -1.6186666666666667E+001,
      -1.6226666666666667E+001,
      -1.6266666666666666E+001,
      -1.6306666666666668E+001,
      -1.6346666666666668E+001,
      -1.6386666666666667E+001,
      -1.6426666666666669E+001,
      -1.6466666666666669E+001,
      -1.6506666666666668E+001,
      -1.6546666666666667E+001,
      -1.6586666666666666E+001,
      -1.6626666666666669E+001,
      -1.6666666666666668E+001,
      -1.6706666666666671E+001,
      -1.6746666666666666E+001,
      -1.6786666666666669E+001,
      -1.6826666666666668E+001,
      -1.6866666666666667E+001,
      -1.6906666666666670E+001,
      -1.6946666666666665E+001,
      -1.6986666666666668E+001,
      -1.7026666666666664E+001,
      -1.7066666666666666E+001,
      -1.7106666666666666E+001,
      -1.7146666666666665E+001,
      -1.7186666666666671E+001,
      -1.7226666666666667E+001,
      -1.7266666666666669E+001,
      -1.7306666666666668E+001,
      -1.7346666666666668E+001,
      -1.7386666666666670E+001,
      -1.7426666666666666E+001,
      -1.7466666666666669E+001,
      -1.7506666666666668E+001,
      -1.7546666666666667E+001,
      -1.7586666666666670E+001,
      -1.7626666666666665E+001,
      -1.7666666666666668E+001,
      -1.7706666666666667E+001,
      -1.7746666666666666E+001,
      -1.7786666666666669E+001,
      -1.7826666666666664E+001,
      -1.7866666666666667E+001,
      -1.7906666666666666E+001,
      -1.7946666666666665E+001,
      -1.7986666666666672E+001,
      -1.8026666666666667E+001,
      -1.8066666666666670E+001,
      -1.8106666666666669E+001,
      -1.8146666666666668E+001,
      -1.8186666666666671E+001,
      -1.8226666666666667E+001,
      -1.8266666666666669E+001,
      -1.8306666666666665E+001,
      -1.8346666666666668E+001,
      -1.8386666666666667E+001,
      -1.8426666666666666E+001,
      -1.8466666666666669E+001,
      -1.8506666666666664E+001,
      -1.8546666666666667E+001,
      -1.8586666666666666E+001,
      -1.8626666666666665E+001,
      -1.8666666666666668E+001,
      -1.8706666666666663E+001,
      -1.8746666666666666E+001,
      -1.8786666666666665E+001,
      -1.8826666666666668E+001,
      -1.8866666666666671E+001,
      -1.8906666666666666E+001,
      -1.8946666666666669E+001,
      -1.8986666666666668E+001,
      -1.9026666666666667E+001,
      -1.9066666666666670E+001,
      -1.9106666666666666E+001,
      -1.9146666666666668E+001,
      -1.9186666666666667E+001,
      -1.9226666666666667E+001,
      -1.9266666666666669E+001,
      -1.9306666666666665E+001,
      -1.9346666666666668E+001,
      -1.9386666666666667E+001,
      -1.9426666666666666E+001,
      -1.9466666666666669E+001,
      -1.9506666666666664E+001,
      -1.9546666666666667E+001,
      -1.9586666666666666E+001,
      -1.9626666666666669E+001,
      -1.9666666666666671E+001,
      -1.9706666666666667E+001,
      -1.9746666666666670E+001,
      -1.9786666666666669E+001,
      -1.9826666666666668E+001,
      -1.9866666666666671E+001,
      -1.9906666666666666E+001,
      -1.9946666666666669E+001,
      -1.9986666666666668E+001,
      -2.0026666666666667E+001,
      -2.0066666666666670E+001,
      -2.0106666666666666E+001,
      -2.0146666666666668E+001,
      -2.0186666666666667E+001,
      -2.0226666666666667E+001,
      -2.0266666666666666E+001,
      -2.0306666666666665E+001,
      -2.0346666666666668E+001,
      -2.0386666666666663E+001,
      -2.0426666666666669E+001,
      -2.0466666666666669E+001,
      -2.0506666666666668E+001,
      -2.0546666666666670E+001,
      -2.0586666666666666E+001,
      -2.0626666666666669E+001,
      -2.0666666666666668E+001,
      -2.0706666666666667E+001,
      -2.0746666666666670E+001,
      -2.0786666666666665E+001,
      -2.0826666666666668E+001,
      -2.0866666666666667E+001,
      -2.0906666666666666E+001,
      -2.0946666666666669E+001,
      -2.0986666666666665E+001,
      -2.1026666666666667E+001,
      -2.1066666666666666E+001,
      -2.1106666666666666E+001,
      -2.1146666666666668E+001,
      -2.1186666666666664E+001,
      -2.1226666666666670E+001,
      -2.1266666666666669E+001,
      -2.1306666666666668E+001,
      -2.1346666666666671E+001,
      -2.1386666666666667E+001,
      -2.1426666666666669E+001,
      -2.1466666666666669E+001,
      -2.1506666666666668E+001,
      -2.1546666666666670E+001,
      -2.1586666666666666E+001,
      -2.1626666666666669E+001,
      -2.1666666666666668E+001,
      -2.1706666666666667E+001,
      -2.1746666666666670E+001,
      -2.1786666666666665E+001,
      -2.1826666666666668E+001,
      -2.1866666666666667E+001,
      -2.1906666666666666E+001,
      -2.1946666666666669E+001,
      -2.1986666666666665E+001,
      -2.2026666666666671E+001,
      -2.2066666666666670E+001,
      -2.2106666666666669E+001,
      -2.2146666666666672E+001,
      -2.2186666666666667E+001,
      -2.2226666666666670E+001,
      -2.2266666666666669E+001,
      -2.2306666666666668E+001,
      -2.2346666666666671E+001,
      -2.2386666666666667E+001,
      -2.2426666666666669E+001,
      -2.2466666666666669E+001,
      -2.2506666666666668E+001,
      -2.2546666666666670E+001,
      -2.2586666666666666E+001,
      -2.2626666666666669E+001,
      -2.2666666666666668E+001,
      -2.2706666666666667E+001,
      -2.2746666666666663E+001,
      -2.2786666666666665E+001,
      -2.2826666666666668E+001,
      -2.2866666666666667E+001,
      -2.2906666666666670E+001,
      -2.2946666666666665E+001,
      -2.2986666666666668E+001,
      -2.3026666666666667E+001,
      -2.3066666666666666E+001,
      -2.3106666666666669E+001,
      -2.3146666666666665E+001,
      -2.3186666666666667E+001,
      -2.3226666666666667E+001,
      -2.3266666666666666E+001,
      -2.3306666666666668E+001,
      -2.3346666666666664E+001,
      -2.3386666666666667E+001,
      -2.3426666666666662E+001,
      -2.3466666666666665E+001,
      -2.3506666666666668E+001,
      -2.3546666666666663E+001,
      -2.3586666666666666E+001,
      -2.3626666666666662E+001,
      -2.3666666666666668E+001,
      -2.3706666666666671E+001,
      -2.3746666666666666E+001,
      -2.3786666666666669E+001,
      -2.3826666666666664E+001,
      -2.3866666666666667E+001,
      -2.3906666666666670E+001,
      -2.3946666666666665E+001,
      -2.3986666666666668E+001,
      -2.4026666666666664E+001,
      -2.4066666666666666E+001,
      -2.4106666666666669E+001,
      -2.4146666666666665E+001,
      -2.4186666666666667E+001,
      -2.4226666666666663E+001,
      -2.4266666666666666E+001,
      -2.4306666666666668E+001,
      -2.4346666666666664E+001,
      -2.4386666666666670E+001,
      -2.4426666666666666E+001,
      -2.4466666666666669E+001,
      -2.4506666666666671E+001,
      -2.4546666666666667E+001,
      -2.4586666666666670E+001,
      -2.4626666666666665E+001,
      -2.4666666666666668E+001,
      -2.4706666666666671E+001,
      -2.4746666666666666E+001,
      -2.4786666666666669E+001,
      -2.4826666666666664E+001,
      -2.4866666666666667E+001,
      -2.4906666666666670E+001,
      -2.4946666666666665E+001,
      -2.4986666666666668E+001,
      -2.5026666666666664E+001,
      -2.5066666666666666E+001,
      -2.5106666666666669E+001,
      -2.5146666666666665E+001,
      -2.5186666666666671E+001,
      -2.5226666666666667E+001,
      -2.5266666666666669E+001,
      -2.5306666666666672E+001,
      -2.5346666666666668E+001,
      -2.5386666666666663E+001,
      -2.5426666666666666E+001,
      -2.5466666666666669E+001,
      -2.5506666666666664E+001,
      -2.5546666666666667E+001,
      -2.5586666666666662E+001,
      -2.5626666666666665E+001,
      -2.5666666666666668E+001,
      -2.5706666666666663E+001,
      -2.5746666666666666E+001,
      -2.5786666666666662E+001,
      -2.5826666666666664E+001,
      -2.5866666666666667E+001,
      -2.5906666666666663E+001,
      -2.5946666666666665E+001,
      -2.5986666666666661E+001,
      -2.6026666666666667E+001,
      -2.6066666666666670E+001,
      -2.6106666666666666E+001,
      -2.6146666666666668E+001,
      -2.6186666666666664E+001,
      -2.6226666666666667E+001,
      -2.6266666666666669E+001,
      -2.6306666666666665E+001,
      -2.6346666666666668E+001,
      -2.6386666666666663E+001,
      -2.6426666666666666E+001,
      -2.6466666666666669E+001,
      -2.6506666666666664E+001,
      -2.6546666666666667E+001,
      -2.6586666666666662E+001,
      -2.6626666666666665E+001,
      -2.6666666666666668E+001,
      -2.6706666666666663E+001,
      -2.6746666666666666E+001,
      -2.6786666666666662E+001,
      -2.6826666666666668E+001,
      -2.6866666666666671E+001,
      -2.6906666666666666E+001,
      -2.6946666666666669E+001,
      -2.6986666666666665E+001,
      -2.7026666666666667E+001,
      -2.7066666666666670E+001,
      -2.7106666666666666E+001,
      -2.7146666666666668E+001,
      -2.7186666666666664E+001,
      -2.7226666666666667E+001,
      -2.7266666666666669E+001,
      -2.7306666666666665E+001,
      -2.7346666666666668E+001,
      -2.7386666666666663E+001,
      -2.7426666666666666E+001,
      -2.7466666666666669E+001,
      -2.7506666666666664E+001,
      -2.7546666666666667E+001,
      -2.7586666666666662E+001,
      -2.7626666666666669E+001,
      -2.7666666666666671E+001,
      -2.7706666666666667E+001,
      -2.7746666666666670E+001,
      -2.7786666666666665E+001,
      -2.7826666666666668E+001,
      -2.7866666666666664E+001,
      -2.7906666666666666E+001,
      -2.7946666666666662E+001,
      -2.7986666666666665E+001,
      -2.8026666666666667E+001,
      -2.8066666666666663E+001,
      -2.8106666666666666E+001,
      -2.8146666666666661E+001,
      -2.8186666666666664E+001,
      -2.8226666666666667E+001,
      -2.8266666666666662E+001,
      -2.8306666666666665E+001,
      -2.8346666666666660E+001,
      -2.8386666666666663E+001,
      -2.8426666666666669E+001,
      -2.8466666666666665E+001,
      -2.8506666666666668E+001,
      -2.8546666666666663E+001,
      -2.8586666666666666E+001,
      -2.8626666666666669E+001,
      -2.8666666666666664E+001,
      -2.8706666666666667E+001,
      -2.8746666666666663E+001,
      -2.8786666666666665E+001,
      -2.8826666666666668E+001,
      -2.8866666666666664E+001,
      -2.8906666666666666E+001,
      -2.8946666666666662E+001,
      -2.8986666666666665E+001,
      -2.9026666666666667E+001,
      -2.9066666666666663E+001,
      -2.9106666666666666E+001,
      -2.9146666666666661E+001,
      -2.9186666666666664E+001,
      -2.9226666666666670E+001,
      -2.9266666666666666E+001,
      -2.9306666666666668E+001,
      -2.9346666666666664E+001,
      -2.9386666666666667E+001,
      -2.9426666666666669E+001,
      -2.9466666666666665E+001,
      -2.9506666666666668E+001,
      -2.9546666666666663E+001,
      -2.9586666666666666E+001,
      -2.9626666666666669E+001,
      -2.9666666666666664E+001,
      -2.9706666666666667E+001,
      -2.9746666666666663E+001,
      -2.9786666666666665E+001,
      -2.9826666666666668E+001,
      -2.9866666666666664E+001,
      -2.9906666666666666E+001,
      -2.9946666666666662E+001,
      -2.9986666666666665E+001,
      -3.0026666666666671E+001,
      -3.0066666666666666E+001,
      -3.0106666666666669E+001,
      -3.0146666666666665E+001,
      -3.0186666666666667E+001,
      -3.0226666666666670E+001,
      -3.0266666666666666E+001,
      -3.0306666666666668E+001,
      -3.0346666666666664E+001,
      -3.0386666666666667E+001,
      -3.0426666666666669E+001,
      -3.0466666666666665E+001,
      -3.0506666666666668E+001,
      -3.0546666666666663E+001,
      -3.0586666666666666E+001,
      -3.0626666666666669E+001,
      -3.0666666666666664E+001,
      -3.0706666666666667E+001,
      -3.0746666666666663E+001,
      -3.0786666666666665E+001,
      -3.0826666666666672E+001,
      -3.0866666666666667E+001,
      -3.0906666666666670E+001,
      -3.0946666666666665E+001,
      -3.0986666666666668E+001,
      -3.1026666666666671E+001,
      -3.1066666666666666E+001,
      -3.1106666666666669E+001,
      -3.1146666666666665E+001,
      -3.1186666666666667E+001,
      -3.1226666666666670E+001,
      -3.1266666666666666E+001,
      -3.1306666666666668E+001,
      -3.1346666666666664E+001,
      -3.1386666666666667E+001,
      -3.1426666666666669E+001,
      -3.1466666666666665E+001,
      -3.1506666666666668E+001,
      -3.1546666666666663E+001,
      -3.1586666666666666E+001,
      -3.1626666666666672E+001,
      -3.1666666666666668E+001,
      -3.1706666666666671E+001,
      -3.1746666666666666E+001,
      -3.1786666666666662E+001,
      -3.1826666666666664E+001,
      -3.1866666666666667E+001,
      -3.1906666666666663E+001,
      -3.1946666666666665E+001,
      -3.1986666666666661E+001,
      -3.2026666666666664E+001,
      -3.2066666666666670E+001,
      -3.2106666666666662E+001,
      -3.2146666666666668E+001,
      -3.2186666666666660E+001,
      -3.2226666666666667E+001,
      -3.2266666666666666E+001,
      -3.2306666666666665E+001,
      -3.2346666666666664E+001,
      -3.2386666666666663E+001,
      -3.2426666666666662E+001,
      -3.2466666666666669E+001,
      -3.2506666666666661E+001,
      -3.2546666666666667E+001,
      -3.2586666666666659E+001,
      -3.2626666666666665E+001,
      -3.2666666666666664E+001,
      -3.2706666666666663E+001,
      -3.2746666666666663E+001,
      -3.2786666666666662E+001,
      -3.2826666666666668E+001,
      -3.2866666666666667E+001,
      -3.2906666666666666E+001,
      -3.2946666666666665E+001,
      -3.2986666666666665E+001,
      -3.3026666666666664E+001,
      -3.3066666666666670E+001,
      -3.3106666666666662E+001,
      -3.3146666666666668E+001,
      -3.3186666666666660E+001,
      -3.3226666666666667E+001,
      -3.3266666666666666E+001,
      -3.3306666666666665E+001,
      -3.3346666666666664E+001,
      -3.3386666666666663E+001,
      -3.3426666666666662E+001,
      -3.3466666666666669E+001,
      -3.3506666666666661E+001,
      -3.3546666666666667E+001,
      -3.3586666666666659E+001,
      -3.3626666666666665E+001,
      -3.3666666666666671E+001,
      -3.3706666666666663E+001,
      -3.3746666666666670E+001,
      -3.3786666666666662E+001,
      -3.3826666666666668E+001,
      -3.3866666666666667E+001,
      -3.3906666666666666E+001,
      -3.3946666666666665E+001,
      -3.3986666666666665E+001,
      -3.4026666666666664E+001,
      -3.4066666666666670E+001,
      -3.4106666666666662E+001,
      -3.4146666666666668E+001,
      -3.4186666666666660E+001,
      -3.4226666666666667E+001,
      -3.4266666666666666E+001,
      -3.4306666666666665E+001,
      -3.4346666666666664E+001,
      -3.4386666666666663E+001,
      -3.4426666666666669E+001,
      -3.4466666666666669E+001,
      -3.4506666666666668E+001,
      -3.4546666666666667E+001,
      -3.4586666666666666E+001,
      -3.4626666666666665E+001,
      -3.4666666666666671E+001,
      -3.4706666666666663E+001,
      -3.4746666666666670E+001,
      -3.4786666666666662E+001,
      -3.4826666666666668E+001,
      -3.4866666666666667E+001,
      -3.4906666666666666E+001,
      -3.4946666666666665E+001,
      -3.4986666666666665E+001,
      -3.5026666666666664E+001,
      -3.5066666666666670E+001,
      -3.5106666666666662E+001,
      -3.5146666666666668E+001,
      -3.5186666666666660E+001,
      -3.5226666666666667E+001,
      -3.5266666666666673E+001,
      -3.5306666666666665E+001,
      -3.5346666666666671E+001,
      -3.5386666666666663E+001,
      -3.5426666666666669E+001,
      -3.5466666666666669E+001,
      -3.5506666666666668E+001,
      -3.5546666666666667E+001,
      -3.5586666666666666E+001,
      -3.5626666666666665E+001,
      -3.5666666666666671E+001,
      -3.5706666666666663E+001,
      -3.5746666666666670E+001,
      -3.5786666666666662E+001,
      -3.5826666666666668E+001,
      -3.5866666666666667E+001,
      -3.5906666666666666E+001,
      -3.5946666666666665E+001,
      -3.5986666666666665E+001,
      -3.6026666666666671E+001,
      -3.6066666666666670E+001,
      -3.6106666666666669E+001,
      -3.6146666666666668E+001,
      -3.6186666666666667E+001,
      -3.6226666666666667E+001,
      -3.6266666666666673E+001,
      -3.6306666666666665E+001,
      -3.6346666666666671E+001,
      -3.6386666666666663E+001,
      -3.6426666666666669E+001,
      -3.6466666666666669E+001,
      -3.6506666666666668E+001,
      -3.6546666666666667E+001,
      -3.6586666666666666E+001,
      -3.6626666666666665E+001,
      -3.6666666666666671E+001,
      -3.6706666666666663E+001,
      -3.6746666666666670E+001,
      -3.6786666666666662E+001,
      -3.6826666666666661E+001,
      -3.6866666666666667E+001,
      -3.6906666666666666E+001,
      -3.6946666666666665E+001,
      -3.6986666666666665E+001,
      -3.7026666666666664E+001,
      -3.7066666666666663E+001,
      -3.7106666666666669E+001,
      -3.7146666666666661E+001,
      -3.7186666666666667E+001,
      -3.7226666666666659E+001,
      -3.7266666666666666E+001,
      -3.7306666666666665E+001,
      -3.7346666666666664E+001,
      -3.7386666666666663E+001,
      -3.7426666666666662E+001,
      -3.7466666666666661E+001,
      -3.7506666666666668E+001,
      -3.7546666666666660E+001,
      -3.7586666666666666E+001,
      -3.7626666666666658E+001,
      -3.7666666666666664E+001,
      -3.7706666666666671E+001,
      -3.7746666666666663E+001,
      -3.7786666666666669E+001,
      -3.7826666666666661E+001,
      -3.7866666666666667E+001,
      -3.7906666666666666E+001,
      -3.7946666666666665E+001,
      -3.7986666666666665E+001,
      -3.8026666666666664E+001,
      -3.8066666666666663E+001,
      -3.8106666666666669E+001,
      -3.8146666666666661E+001,
      -3.8186666666666667E+001,
      -3.8226666666666659E+001,
      -3.8266666666666666E+001,
      -3.8306666666666665E+001,
      -3.8346666666666664E+001,
      -3.8386666666666663E+001,
      -3.8426666666666662E+001,
      -3.8466666666666669E+001,
      -3.8506666666666668E+001,
      -3.8546666666666667E+001,
      -3.8586666666666666E+001,
      -3.8626666666666665E+001,
      -3.8666666666666664E+001,
      -3.8706666666666671E+001,
      -3.8746666666666663E+001,
      -3.8786666666666669E+001,
      -3.8826666666666661E+001,
      -3.8866666666666667E+001,
      -3.8906666666666666E+001,
      -3.8946666666666665E+001,
      -3.8986666666666665E+001,
      -3.9026666666666664E+001,
      -3.9066666666666663E+001,
      -3.9106666666666669E+001,
      -3.9146666666666661E+001,
      -3.9186666666666667E+001,
      -3.9226666666666659E+001,
      -3.9266666666666666E+001,
      -3.9306666666666672E+001,
      -3.9346666666666664E+001,
      -3.9386666666666670E+001,
      -3.9426666666666662E+001,
      -3.9466666666666669E+001,
      -3.9506666666666668E+001,
      -3.9546666666666667E+001,
      -3.9586666666666666E+001,
      -3.9626666666666665E+001,
      -3.9666666666666664E+001,
      -3.9706666666666671E+001,
      -3.9746666666666663E+001,
      -3.9786666666666669E+001,
      -3.9826666666666661E+001,
      -3.9866666666666667E+001,
      -3.9906666666666666E+001,
      -3.9946666666666665E+001,
      -3.9986666666666657E+001,
      -4.0026666666666664E+001,
      -4.0066666666666663E+001,
      -4.0106666666666662E+001,
      -4.0146666666666668E+001,
      -4.0186666666666660E+001,
      -4.0226666666666667E+001,
      -4.0266666666666659E+001,
      -4.0306666666666665E+001,
      -4.0346666666666664E+001,
      -4.0386666666666663E+001,
      -4.0426666666666662E+001,
      -4.0466666666666661E+001,
      -4.0506666666666661E+001,
      -4.0546666666666667E+001,
      -4.0586666666666659E+001,
      -4.0626666666666665E+001,
      -4.0666666666666657E+001,
      -4.0706666666666663E+001,
      -4.0746666666666663E+001,
      -4.0786666666666662E+001,
      -4.0826666666666668E+001,
      -4.0866666666666660E+001,
      -4.0906666666666666E+001,
      -4.0946666666666665E+001,
      -4.0986666666666665E+001,
      -4.1026666666666664E+001,
      -4.1066666666666663E+001,
      -4.1106666666666662E+001,
      -4.1146666666666668E+001,
      -4.1186666666666660E+001,
      -4.1226666666666667E+001,
      -4.1266666666666659E+001,
      -4.1306666666666665E+001,
      -4.1346666666666664E+001,
      -4.1386666666666663E+001,
      -4.1426666666666662E+001,
      -4.1466666666666661E+001,
      -4.1506666666666661E+001,
      -4.1546666666666667E+001,
      -4.1586666666666659E+001,
      -4.1626666666666665E+001,
      -4.1666666666666664E+001,
      -4.1706666666666663E+001,
      -4.1746666666666670E+001,
      -4.1786666666666662E+001,
      -4.1826666666666668E+001,
      -4.1866666666666660E+001,
      -4.1906666666666666E+001,
      -4.1946666666666665E+001,
      -4.1986666666666665E+001,
      -4.2026666666666664E+001,
      -4.2066666666666670E+001,
      -4.2106666666666662E+001,
      -4.2146666666666668E+001,
      -4.2186666666666660E+001,
      -4.2226666666666667E+001,
      -4.2266666666666666E+001,
      -4.2306666666666665E+001,
      -4.2346666666666664E+001,
      -4.2386666666666663E+001,
      -4.2426666666666669E+001,
      -4.2466666666666669E+001,
      -4.2506666666666668E+001,
      -4.2546666666666667E+001,
      -4.2586666666666666E+001,
      -4.2626666666666665E+001,
      -4.2666666666666671E+001,
      -4.2706666666666663E+001,
      -4.2746666666666670E+001,
      -4.2786666666666662E+001,
      -4.2826666666666668E+001,
      -4.2866666666666667E+001,
      -4.2906666666666666E+001,
      -4.2946666666666665E+001,
      -4.2986666666666665E+001,
      -4.3026666666666664E+001,
      -4.3066666666666670E+001,
      -4.3106666666666662E+001,
      -4.3146666666666661E+001,
      -4.3186666666666660E+001,
      -4.3226666666666659E+001,
      -4.3266666666666666E+001,
      -4.3306666666666665E+001,
      -4.3346666666666664E+001,
      -4.3386666666666663E+001,
      -4.3426666666666662E+001,
      -4.3466666666666661E+001,
      -4.3506666666666668E+001,
      -4.3546666666666660E+001,
      -4.3586666666666666E+001,
      -4.3626666666666658E+001,
      -4.3666666666666664E+001,
      -4.3706666666666663E+001,
      -4.3746666666666663E+001,
      -4.3786666666666662E+001,
      -4.3826666666666661E+001,
      -4.3866666666666660E+001,
      -4.3906666666666666E+001,
      -4.3946666666666658E+001,
      -4.3986666666666665E+001,
      -4.4026666666666657E+001,
      -4.4066666666666663E+001,
      -4.4106666666666669E+001,
      -4.4146666666666661E+001,
      -4.4186666666666667E+001,
      -4.4226666666666659E+001,
      -4.4266666666666666E+001,
      -4.4306666666666665E+001,
      -4.4346666666666664E+001,
      -4.4386666666666663E+001,
      -4.4426666666666662E+001,
      -4.4466666666666661E+001,
      -4.4506666666666668E+001,
      -4.4546666666666660E+001,
      -4.4586666666666666E+001,
      -4.4626666666666658E+001,
      -4.4666666666666664E+001,
      -4.4706666666666663E+001,
      -4.4746666666666663E+001,
      -4.4786666666666662E+001,
      -4.4826666666666661E+001,
      -4.4866666666666667E+001,
      -4.4906666666666666E+001,
      -4.4946666666666665E+001,
      -4.4986666666666665E+001,
      -4.5026666666666664E+001,
      -4.5066666666666663E+001,
      -4.5106666666666669E+001,
      -4.5146666666666661E+001,
      -4.5186666666666667E+001,
      -4.5226666666666659E+001,
      -4.5266666666666666E+001,
      -4.5306666666666665E+001,
      -4.5346666666666664E+001,
      -4.5386666666666663E+001,
      -4.5426666666666662E+001,
      -4.5466666666666661E+001,
      -4.5506666666666668E+001,
      -4.5546666666666660E+001,
      -4.5586666666666666E+001,
      -4.5626666666666658E+001,
      -4.5666666666666664E+001,
      -4.5706666666666671E+001,
      -4.5746666666666663E+001,
      -4.5786666666666669E+001,
      -4.5826666666666661E+001,
      -4.5866666666666667E+001,
      -4.5906666666666666E+001,
      -4.5946666666666665E+001,
      -4.5986666666666665E+001,
      -4.6026666666666664E+001,
      -4.6066666666666663E+001,
      -4.6106666666666669E+001,
      -4.6146666666666661E+001,
      -4.6186666666666667E+001,
      -4.6226666666666659E+001,
      -4.6266666666666666E+001,
      -4.6306666666666665E+001,
      -4.6346666666666664E+001,
      -4.6386666666666663E+001,
      -4.6426666666666662E+001,
      -4.6466666666666669E+001,
      -4.6506666666666668E+001,
      -4.6546666666666667E+001,
      -4.6586666666666666E+001,
      -4.6626666666666665E+001,
      -4.6666666666666664E+001,
      -4.6706666666666671E+001,
      -4.6746666666666663E+001,
      -4.6786666666666669E+001,
      -4.6826666666666661E+001,
      -4.6866666666666667E+001,
      -4.6906666666666666E+001,
      -4.6946666666666665E+001,
      -4.6986666666666665E+001,
      -4.7026666666666664E+001,
      -4.7066666666666663E+001,
      -4.7106666666666669E+001,
      -4.7146666666666661E+001,
      -4.7186666666666667E+001,
      -4.7226666666666659E+001,
      -4.7266666666666666E+001,
      -4.7306666666666672E+001,
      -4.7346666666666664E+001,
      -4.7386666666666670E+001,
      -4.7426666666666662E+001,
      -4.7466666666666669E+001,
      -4.7506666666666668E+001,
      -4.7546666666666667E+001,
      -4.7586666666666666E+001,
      -4.7626666666666665E+001,
      -4.7666666666666664E+001,
      -4.7706666666666671E+001,
      -4.7746666666666663E+001,
      -4.7786666666666669E+001,
      -4.7826666666666661E+001,
      -4.7866666666666667E+001,
      -4.7906666666666666E+001,
      -4.7946666666666665E+001,
      -4.7986666666666665E+001,
      -4.8026666666666664E+001,
      -4.8066666666666670E+001,
      -4.8106666666666669E+001,
      -4.8146666666666668E+001,
      -4.8186666666666667E+001,
      -4.8226666666666667E+001,
      -4.8266666666666659E+001,
      -4.8306666666666665E+001,
      -4.8346666666666664E+001,
      -4.8386666666666663E+001,
      -4.8426666666666662E+001,
      -4.8466666666666661E+001,
      -4.8506666666666661E+001,
      -4.8546666666666667E+001,
      -4.8586666666666659E+001,
      -4.8626666666666665E+001,
      -4.8666666666666657E+001,
      -4.8706666666666663E+001,
      -4.8746666666666655E+001,
      -4.8786666666666662E+001,
      -4.8826666666666668E+001,
      -4.8866666666666660E+001,
      -4.8906666666666659E+001,
      -4.8946666666666665E+001,
      -4.8986666666666672E+001,
      -4.9026666666666664E+001,
      -4.9066666666666663E+001,
      -4.9106666666666662E+001,
      -4.9146666666666668E+001,
      -4.9186666666666660E+001,
      -4.9226666666666659E+001,
      -4.9266666666666659E+001,
      -4.9306666666666672E+001,
      -4.9346666666666664E+001,
      -4.9386666666666663E+001,
      -4.9426666666666662E+001,
      -4.9466666666666669E+001,
      -4.9506666666666661E+001,
      -4.9546666666666660E+001,
      -4.9586666666666659E+001,
      -4.9626666666666665E+001,
      -4.9666666666666664E+001,
      -4.9706666666666656E+001,
      -4.9746666666666670E+001,
      -4.9786666666666669E+001,
      -4.9826666666666668E+001,
      -4.9866666666666660E+001,
      -4.9906666666666666E+001,
      -4.9946666666666665E+001,
      -4.9986666666666665E+001,
      -5.0026666666666657E+001,
      -5.0066666666666663E+001,
      -5.0106666666666669E+001,
      -5.0146666666666668E+001,
      -5.0186666666666660E+001,
      -5.0226666666666667E+001,
      -5.0266666666666666E+001,
      -5.0306666666666665E+001,
      -5.0346666666666657E+001,
      -5.0386666666666663E+001,
      -5.0426666666666669E+001,
      -5.0466666666666661E+001,
      -5.0506666666666661E+001,
      -5.0546666666666667E+001,
      -5.0586666666666673E+001,
      -5.0626666666666665E+001,
      -5.0666666666666664E+001,
      -5.0706666666666663E+001,
      -5.0746666666666670E+001,
      -5.0786666666666662E+001,
      -5.0826666666666661E+001,
      -5.0866666666666660E+001,
      -5.0906666666666673E+001,
      -5.0946666666666665E+001,
      -5.0986666666666665E+001,
      -5.1026666666666664E+001,
      -5.1066666666666670E+001,
      -5.1106666666666662E+001,
      -5.1146666666666661E+001,
      -5.1186666666666660E+001,
      -5.1226666666666667E+001,
      -5.1266666666666666E+001,
      -5.1306666666666658E+001,
      -5.1346666666666671E+001,
      -5.1386666666666670E+001,
      -5.1426666666666669E+001,
      -5.1466666666666661E+001,
      -5.1506666666666668E+001,
      -5.1546666666666667E+001,
      -5.1586666666666666E+001,
      -5.1626666666666658E+001,
      -5.1666666666666664E+001,
      -5.1706666666666671E+001,
      -5.1746666666666670E+001,
      -5.1786666666666662E+001,
      -5.1826666666666668E+001,
      -5.1866666666666667E+001,
      -5.1906666666666666E+001,
      -5.1946666666666658E+001,
      -5.1986666666666665E+001,
      -5.2026666666666671E+001,
      -5.2066666666666663E+001,
      -5.2106666666666662E+001,
      -5.2146666666666668E+001,
      -5.2186666666666667E+001,
      -5.2226666666666667E+001,
      -5.2266666666666666E+001,
      -5.2306666666666665E+001,
      -5.2346666666666664E+001,
      -5.2386666666666663E+001,
      -5.2426666666666662E+001,
      -5.2466666666666661E+001,
      -5.2506666666666661E+001,
      -5.2546666666666667E+001,
      -5.2586666666666666E+001,
      -5.2626666666666665E+001,
      -5.2666666666666664E+001,
      -5.2706666666666663E+001,
      -5.2746666666666663E+001,
      -5.2786666666666662E+001,
      -5.2826666666666661E+001,
      -5.2866666666666667E+001,
      -5.2906666666666659E+001,
      -5.2946666666666673E+001,
      -5.2986666666666665E+001,
      -5.3026666666666671E+001,
      -5.3066666666666663E+001,
      -5.3106666666666669E+001,
      -5.3146666666666661E+001,
      -5.3186666666666667E+001,
      -5.3226666666666659E+001,
      -5.3266666666666666E+001,
      -5.3306666666666658E+001,
      -5.3346666666666671E+001,
      -5.3386666666666663E+001,
      -5.3426666666666669E+001,
      -5.3466666666666661E+001,
      -5.3506666666666668E+001,
      -5.3546666666666660E+001,
      -5.3586666666666666E+001,
      -5.3626666666666658E+001,
      -5.3666666666666664E+001,
      -5.3706666666666663E+001,
      -5.3746666666666670E+001,
      -5.3786666666666669E+001,
      -5.3826666666666668E+001,
      -5.3866666666666667E+001,
      -5.3906666666666666E+001,
      -5.3946666666666665E+001,
      -5.3986666666666665E+001,
      -5.4026666666666664E+001,
      -5.4066666666666663E+001,
      -5.4106666666666662E+001,
      -5.4146666666666668E+001,
      -5.4186666666666667E+001,
      -5.4226666666666667E+001,
      -5.4266666666666666E+001,
      -5.4306666666666665E+001,
      -5.4346666666666664E+001,
      -5.4386666666666663E+001,
      -5.4426666666666662E+001,
      -5.4466666666666669E+001,
      -5.4506666666666661E+001,
      -5.4546666666666674E+001,
      -5.4586666666666666E+001,
      -5.4626666666666672E+001,
      -5.4666666666666664E+001,
      -5.4706666666666663E+001,
      -5.4746666666666663E+001,
      -5.4786666666666669E+001,
      -5.4826666666666661E+001,
      -5.4866666666666660E+001,
      -5.4906666666666659E+001,
      -5.4946666666666673E+001,
      -5.4986666666666665E+001,
      -5.5026666666666664E+001,
      -5.5066666666666663E+001,
      -5.5106666666666669E+001,
      -5.5146666666666661E+001,
      -5.5186666666666660E+001,
      -5.5226666666666659E+001,
      -5.5266666666666666E+001,
      -5.5306666666666665E+001,
      -5.5346666666666657E+001,
      -5.5386666666666670E+001,
      -5.5426666666666669E+001,
      -5.5466666666666669E+001,
      -5.5506666666666661E+001,
      -5.5546666666666667E+001,
      -5.5586666666666666E+001,
      -5.5626666666666665E+001,
      -5.5666666666666657E+001,
      -5.5706666666666663E+001,
      -5.5746666666666670E+001,
      -5.5786666666666669E+001,
      -5.5826666666666661E+001,
      -5.5866666666666667E+001,
      -5.5906666666666666E+001,
      -5.5946666666666665E+001,
      -5.5986666666666657E+001,
      -5.6026666666666664E+001,
      -5.6066666666666670E+001,
      -5.6106666666666662E+001,
      -5.6146666666666661E+001,
      -5.6186666666666667E+001,
      -5.6226666666666674E+001,
      -5.6266666666666666E+001,
      -5.6306666666666665E+001,
      -5.6346666666666664E+001,
      -5.6386666666666670E+001,
      -5.6426666666666662E+001,
      -5.6466666666666661E+001,
      -5.6506666666666661E+001,
      -5.6546666666666674E+001,
      -5.6586666666666666E+001,
      -5.6626666666666665E+001,
      -5.6666666666666664E+001,
      -5.6706666666666671E+001,
      -5.6746666666666663E+001,
      -5.6786666666666662E+001,
      -5.6826666666666668E+001,
      -5.6866666666666667E+001,
      -5.6906666666666666E+001,
      -5.6946666666666658E+001,
      -5.6986666666666672E+001,
      -5.7026666666666671E+001,
      -5.7066666666666670E+001,
      -5.7106666666666662E+001,
      -5.7146666666666668E+001,
      -5.7186666666666667E+001,
      -5.7226666666666667E+001,
      -5.7266666666666659E+001,
      -5.7306666666666665E+001,
      -5.7346666666666657E+001,
      -5.7386666666666670E+001,
      -5.7426666666666662E+001,
      -5.7466666666666669E+001,
      -5.7506666666666661E+001,
      -5.7546666666666667E+001,
      -5.7586666666666659E+001,
      -5.7626666666666665E+001,
      -5.7666666666666664E+001,
      -5.7706666666666663E+001,
      -5.7746666666666663E+001,
      -5.7786666666666669E+001,
      -5.7826666666666668E+001,
      -5.7866666666666667E+001,
      -5.7906666666666666E+001,
      -5.7946666666666665E+001,
      -5.7986666666666665E+001,
      -5.8026666666666664E+001,
      -5.8066666666666663E+001,
      -5.8106666666666662E+001,
      -5.8146666666666661E+001,
      -5.8186666666666667E+001,
      -5.8226666666666667E+001,
      -5.8266666666666666E+001,
      -5.8306666666666665E+001,
      -5.8346666666666664E+001,
      -5.8386666666666663E+001,
      -5.8426666666666669E+001,
      -5.8466666666666661E+001,
      -5.8506666666666668E+001,
      -5.8546666666666660E+001,
      -5.8586666666666673E+001,
      -5.8626666666666665E+001,
      -5.8666666666666671E+001,
      -5.8706666666666663E+001,
      -5.8746666666666670E+001,
      -5.8786666666666662E+001,
      -5.8826666666666668E+001,
      -5.8866666666666660E+001,
      -5.8906666666666666E+001,
      -5.8946666666666658E+001,
      -5.8986666666666672E+001,
      -5.9026666666666664E+001,
      -5.9066666666666670E+001,
      -5.9106666666666662E+001,
      -5.9146666666666668E+001,
      -5.9186666666666660E+001,
      -5.9226666666666667E+001,
      -5.9266666666666666E+001,
      -5.9306666666666665E+001,
      -5.9346666666666664E+001,
      -5.9386666666666670E+001,
      -5.9426666666666669E+001,
      -5.9466666666666669E+001,
      -5.9506666666666668E+001,
      -5.9546666666666667E+001,
      -5.9586666666666666E+001,
      -5.9626666666666665E+001,
      -5.9666666666666664E+001,
      -5.9706666666666663E+001,
      -5.9746666666666663E+001,
      -5.9786666666666669E+001,
      -5.9826666666666668E+001,
      -5.9866666666666660E+001,
      -5.9906666666666666E+001,
      -5.9946666666666665E+001,
      -5.9986666666666665E+001,
      -6.0026666666666657E+001,
      -6.0066666666666663E+001,
      -6.0106666666666669E+001,
      -6.0146666666666661E+001,
      -6.0186666666666660E+001,
      -6.0226666666666667E+001,
      -6.0266666666666673E+001,
      -6.0306666666666665E+001,
      -6.0346666666666664E+001,
      -6.0386666666666663E+001,
      -6.0426666666666669E+001,
      -6.0466666666666661E+001,
      -6.0506666666666661E+001,
      -6.0546666666666660E+001,
      -6.0586666666666673E+001,
      -6.0626666666666665E+001,
      -6.0666666666666664E+001,
      -6.0706666666666663E+001,
      -6.0746666666666670E+001,
      -6.0786666666666662E+001,
      -6.0826666666666661E+001,
      -6.0866666666666667E+001,
      -6.0906666666666666E+001,
      -6.0946666666666665E+001,
      -6.0986666666666657E+001,
      -6.1026666666666671E+001,
      -6.1066666666666670E+001,
      -6.1106666666666669E+001,
      -6.1146666666666661E+001,
      -6.1186666666666667E+001,
      -6.1226666666666667E+001,
      -6.1266666666666666E+001,
      -6.1306666666666658E+001,
      -6.1346666666666664E+001,
      -6.1386666666666670E+001,
      -6.1426666666666669E+001,
      -6.1466666666666661E+001,
      -6.1506666666666668E+001,
      -6.1546666666666667E+001,
      -6.1586666666666666E+001,
      -6.1626666666666658E+001,
      -6.1666666666666664E+001,
      -6.1706666666666663E+001,
      -6.1746666666666663E+001,
      -6.1786666666666662E+001,
      -6.1826666666666668E+001,
      -6.1866666666666667E+001,
      -6.1906666666666666E+001,
      -6.1946666666666665E+001,
      -6.1986666666666665E+001,
      -6.2026666666666664E+001,
      -6.2066666666666663E+001,
      -6.2106666666666662E+001,
      -6.2146666666666661E+001,
      -6.2186666666666660E+001,
      -6.2226666666666667E+001,
      -6.2266666666666666E+001,
      -6.2306666666666665E+001,
      -6.2346666666666664E+001,
      -6.2386666666666663E+001,
      -6.2426666666666662E+001,
      -6.2466666666666669E+001,
      -6.2506666666666661E+001,
      -6.2546666666666667E+001,
      -6.2586666666666659E+001,
      -6.2626666666666672E+001,
      -6.2666666666666664E+001,
      -6.2706666666666671E+001,
      -6.2746666666666663E+001,
      -6.2786666666666669E+001,
      -6.2826666666666661E+001,
      -6.2866666666666667E+001,
      -6.2906666666666659E+001,
      -6.2946666666666665E+001,
      -6.2986666666666657E+001,
      -6.3026666666666671E+001,
      -6.3066666666666663E+001,
      -6.3106666666666669E+001,
      -6.3146666666666661E+001,
      -6.3186666666666667E+001,
      -6.3226666666666659E+001,
      -6.3266666666666666E+001,
      -6.3306666666666665E+001,
      -6.3346666666666664E+001,
      -6.3386666666666663E+001,
      -6.3426666666666669E+001,
      -6.3466666666666669E+001,
      -6.3506666666666668E+001,
      -6.3546666666666667E+001,
      -6.3586666666666666E+001,
      -6.3626666666666665E+001,
      -6.3666666666666664E+001,
      -6.3706666666666663E+001,
      -6.3746666666666663E+001,
      -6.3786666666666662E+001,
      -6.3826666666666668E+001,
      -6.3866666666666667E+001,
      -6.3906666666666666E+001,
      -6.3946666666666665E+001,
      -6.3986666666666665E+001,
      -6.4026666666666671E+001,
      -6.4066666666666663E+001,
      -6.4106666666666669E+001,
      -6.4146666666666661E+001,
      -6.4186666666666667E+001,
      -6.4226666666666674E+001,
      -6.4266666666666666E+001,
      -6.4306666666666672E+001,
      -6.4346666666666664E+001,
      -6.4386666666666670E+001,
      -6.4426666666666662E+001,
      -6.4466666666666669E+001,
      -6.4506666666666661E+001,
      -6.4546666666666667E+001,
      -6.4586666666666659E+001,
      -6.4626666666666665E+001,
      -6.4666666666666671E+001,
      -6.4706666666666663E+001,
      -6.4746666666666670E+001,
      -6.4786666666666676E+001,
      -6.4826666666666668E+001,
      -6.4866666666666674E+001,
      -6.4906666666666666E+001,
      -6.4946666666666673E+001,
      -6.4986666666666665E+001,
      -6.5026666666666671E+001,
      -6.5066666666666663E+001,
      -6.5106666666666669E+001,
      -6.5146666666666661E+001,
      -6.5186666666666667E+001,
      -6.5226666666666659E+001,
      -6.5266666666666666E+001,
      -6.5306666666666658E+001,
      -6.5346666666666664E+001,
      -6.5386666666666656E+001,
      -6.5426666666666677E+001,
      -6.5466666666666669E+001,
      -6.5506666666666661E+001,
      -6.5546666666666667E+001,
      -6.5586666666666673E+001,
      -6.5626666666666665E+001,
      -6.5666666666666657E+001,
      -6.5706666666666663E+001,
      -6.5746666666666670E+001,
      -6.5786666666666662E+001,
      -6.5826666666666654E+001,
      -6.5866666666666674E+001,
      -6.5906666666666666E+001,
      -6.5946666666666673E+001,
      -6.5986666666666665E+001,
      -6.6026666666666671E+001,
      -6.6066666666666663E+001,
      -6.6106666666666669E+001,
      -6.6146666666666661E+001,
      -6.6186666666666667E+001,
      -6.6226666666666674E+001,
      -6.6266666666666666E+001,
      -6.6306666666666658E+001,
      -6.6346666666666664E+001,
      -6.6386666666666670E+001,
      -6.6426666666666662E+001,
      -6.6466666666666669E+001,
      -6.6506666666666661E+001,
      -6.6546666666666667E+001,
      -6.6586666666666659E+001,
      -6.6626666666666665E+001,
      -6.6666666666666671E+001,
      -6.6706666666666663E+001,
      -6.6746666666666670E+001,
      -6.6786666666666676E+001,
      -6.6826666666666668E+001,
      -6.6866666666666660E+001,
      -6.6906666666666666E+001,
      -6.6946666666666673E+001,
      -6.6986666666666665E+001,
      -6.7026666666666657E+001,
      -6.7066666666666663E+001,
      -6.7106666666666669E+001,
      -6.7146666666666675E+001,
      -6.7186666666666667E+001,
      -6.7226666666666674E+001,
      -6.7266666666666666E+001,
      -6.7306666666666672E+001,
      -6.7346666666666664E+001,
      -6.7386666666666670E+001,
      -6.7426666666666662E+001,
      -6.7466666666666669E+001,
      -6.7506666666666661E+001,
      -6.7546666666666681E+001,
      -6.7586666666666673E+001,
      -6.7626666666666665E+001,
      -6.7666666666666657E+001,
      -6.7706666666666678E+001,
      -6.7746666666666670E+001,
      -6.7786666666666662E+001,
      -6.7826666666666654E+001,
      -6.7866666666666674E+001,
      -6.7906666666666666E+001,
      -6.7946666666666673E+001,
      -6.7986666666666679E+001,
      -6.8026666666666671E+001,
      -6.8066666666666663E+001,
      -6.8106666666666669E+001,
      -6.8146666666666675E+001,
      -6.8186666666666667E+001,
      -6.8226666666666659E+001,
      -6.8266666666666666E+001,
      -6.8306666666666672E+001,
      -6.8346666666666678E+001,
      -6.8386666666666670E+001,
      -6.8426666666666662E+001,
      -6.8466666666666669E+001,
      -6.8506666666666675E+001,
      -6.8546666666666667E+001,
      -6.8586666666666659E+001,
      -6.8626666666666665E+001,
      -6.8666666666666671E+001,
      -6.8706666666666663E+001,
      -6.8746666666666684E+001,
      -6.8786666666666676E+001,
      -6.8826666666666668E+001,
      -6.8866666666666660E+001,
      -6.8906666666666680E+001,
      -6.8946666666666673E+001,
      -6.8986666666666665E+001,
      -6.9026666666666657E+001,
      -6.9066666666666677E+001,
      -6.9106666666666669E+001,
      -6.9146666666666675E+001,
      -6.9186666666666667E+001,
      -6.9226666666666674E+001,
      -6.9266666666666666E+001,
      -6.9306666666666672E+001,
      -6.9346666666666664E+001,
      -6.9386666666666670E+001,
      -6.9426666666666662E+001,
      -6.9466666666666669E+001,
      -6.9506666666666661E+001,
      -6.9546666666666681E+001,
      -6.9586666666666673E+001,
      -6.9626666666666665E+001,
      -6.9666666666666671E+001,
      -6.9706666666666678E+001,
      -6.9746666666666670E+001,
      -6.9786666666666662E+001,
      -6.9826666666666668E+001,
      -6.9866666666666674E+001,
      -6.9906666666666666E+001,
      -6.9946666666666673E+001,
      -6.9986666666666679E+001,
      -7.0026666666666671E+001,
      -7.0066666666666663E+001,
      -7.0106666666666669E+001,
      -7.0146666666666675E+001,
      -7.0186666666666667E+001,
      -7.0226666666666659E+001,
      -7.0266666666666666E+001,
      -7.0306666666666672E+001,
      -7.0346666666666678E+001,
      -7.0386666666666670E+001,
      -7.0426666666666677E+001,
      -7.0466666666666669E+001,
      -7.0506666666666675E+001,
      -7.0546666666666667E+001,
      -7.0586666666666673E+001,
      -7.0626666666666665E+001,
      -7.0666666666666671E+001,
      -7.0706666666666663E+001,
      -7.0746666666666684E+001,
      -7.0786666666666676E+001,
      -7.0826666666666668E+001,
      -7.0866666666666660E+001,
      -7.0906666666666680E+001,
      -7.0946666666666673E+001,
      -7.0986666666666665E+001,
      -7.1026666666666657E+001,
      -7.1066666666666677E+001,
      -7.1106666666666669E+001,
      -7.1146666666666675E+001,
      -7.1186666666666682E+001,
      -7.1226666666666674E+001,
      -7.1266666666666666E+001,
      -7.1333333333333343E+001,
      -7.1373133333333342E+001,
      -7.1412533333333343E+001,
      -7.1451533333333344E+001,
      -7.1490133333333333E+001,
      -7.1528333333333336E+001,
      -7.1566133333333340E+001,
      -7.1603533333333331E+001,
      -7.1640533333333337E+001,
      -7.1677133333333330E+001,
      -7.1713333333333338E+001,
      -7.1749133333333347E+001,
      -7.1784533333333329E+001,
      -7.1819533333333339E+001,
      -7.1854133333333337E+001,
      -7.1888333333333335E+001,
      -7.1922133333333335E+001,
      -7.1955533333333349E+001,
      -7.1988533333333336E+001,
      -7.2021133333333339E+001,
      -7.2053333333333342E+001,
      -7.2085133333333346E+001,
      -7.2116533333333336E+001,
      -7.2147533333333342E+001,
      -7.2178133333333335E+001,
      -7.2208333333333343E+001,
      -7.2238133333333337E+001,
      -7.2267533333333347E+001,
      -7.2296533333333343E+001,
      -7.2325133333333341E+001,
      -7.2353333333333325E+001,
      -7.2381133333333338E+001,
      -7.2408533333333338E+001,
      -7.2435533333333339E+001,
      -7.2462133333333341E+001,
      -7.2488333333333344E+001,
      -7.2514133333333334E+001,
      -7.2539533333333338E+001,
      -7.2564533333333330E+001,
      -7.2589133333333336E+001,
      -7.2613333333333330E+001,
      -7.2637133333333338E+001,
      -7.2660533333333348E+001,
      -7.2683533333333330E+001,
      -7.2706133333333341E+001,
      -7.2728333333333325E+001,
      -7.2750133333333338E+001,
      -7.2771533333333323E+001,
      -7.2792533333333338E+001,
      -7.2813133333333340E+001,
      -7.2833333333333343E+001,
      -7.2853133333333332E+001,
      -7.2872533333333337E+001,
      -7.2891533333333328E+001,
      -7.2910133333333334E+001,
      -7.2928333333333342E+001,
      -7.2946133333333336E+001,
      -7.2963533333333345E+001,
      -7.2980533333333341E+001,
      -7.2997133333333338E+001,
      -7.3013333333333335E+001,
      -7.3029133333333334E+001,
      -7.3044533333333348E+001,
      -7.3059533333333334E+001,
      -7.3074133333333336E+001,
      -7.3088333333333338E+001,
      -7.3102133333333342E+001,
      -7.3115533333333332E+001,
      -7.3128533333333323E+001,
      -7.3141133333333343E+001,
      -7.3153333333333336E+001,
      -7.3165133333333344E+001,
      -7.3176533333333339E+001,
      -7.3187533333333334E+001,
      -7.3198133333333331E+001,
      -7.3208333333333343E+001,
      -7.3218133333333327E+001,
      -7.3227533333333341E+001,
      -7.3236533333333341E+001,
      -7.3245133333333328E+001,
      -7.3253333333333330E+001,
      -7.3261133333333333E+001,
      -7.3268533333333338E+001,
      -7.3275533333333328E+001,
      -7.3282133333333334E+001,
      -7.3288333333333341E+001,
      -7.3294133333333335E+001,
      -7.3299533333333343E+001,
      -7.3304533333333339E+001,
      -7.3309133333333335E+001,
      -7.3313333333333347E+001,
      -7.3317133333333345E+001,
      -7.3320533333333344E+001,
      -7.3323533333333330E+001,
      -7.3326133333333345E+001,
      -7.3328333333333333E+001,
      -7.3330133333333336E+001,
      -7.3331533333333340E+001,
      -7.3332533333333330E+001,
      -7.3333133333333350E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333228057899404E+001,
      -7.3332912235753696E+001,
      -7.3332385879364310E+001,
      -7.3331649009510940E+001,
      -7.3330701655283903E+001,
      -7.3329543854083141E+001,
      -7.3328175651616661E+001,
      -7.3326597101898756E+001,
      -7.3324808267247860E+001,
      -7.3322809218284121E+001,
      -7.3320600033926539E+001,
      -7.3318180801389943E+001,
      -7.3315551616181494E+001,
      -7.3312712582096935E+001,
      -7.3309663811216438E+001,
      -7.3306405423900273E+001,
      -7.3302937548784001E+001,
      -7.3299260322773392E+001,
      -7.3295373891039006E+001,
      -7.3291278407010552E+001,
      -7.3286974032370708E+001,
      -7.3282460937048810E+001,
      -7.3277739299214133E+001,
      -7.3272809305268879E+001,
      -7.3267671149840737E+001,
      -7.3262325035775305E+001,
      -7.3256771174128005E+001,
      -7.3251009784155769E+001,
      -7.3245041093308416E+001,
      -7.3238865337219679E+001,
      -7.3232482759697788E+001,
      -7.3225893612715979E+001,
      -7.3219098156402524E+001,
      -7.3212096659030365E+001,
      -7.3204889397006653E+001,
      -7.3197476654861745E+001,
      -7.3189858725238011E+001,
      -7.3182035908878262E+001,
      -7.3174008514613902E+001,
      -7.3165776859352704E+001,
      -7.3157341268066318E+001,
      -7.3148702073777457E+001,
      -7.3139859617546719E+001,
      -7.3130814248459131E+001,
      -7.3121566323610367E+001,
      -7.3112116208092672E+001,
      -7.3102464274980434E+001,
      -7.3092610905315425E+001,
      -7.3082556488091839E+001,
      -7.3072301420240819E+001,
      -7.3061846106614908E+001,
      -7.3051190959971976E+001,
      -7.3040336400958964E+001,
      -7.3029282858095286E+001,
      -7.3018030767755874E+001,
      -7.3006580574153986E+001,
      -7.2994932729323693E+001,
      -7.2983087693101922E+001,
      -7.2971045933110460E+001,
      -7.2958807924737343E+001,
      -7.2946374151118192E+001,
      -7.2933745103117104E+001,
      -7.2920921279307279E+001,
      -7.2907903185951312E+001,
      -7.2894691336981239E+001,
      -7.2881286253978232E+001,
      -7.2867688466152018E+001,
      -7.2853898510319979E+001,
      -7.2839916930885963E+001,
      -7.2825744279818778E+001,
      -7.2811381116630429E+001,
      -7.2796828008353984E+001,
      -7.2782085529521268E+001,
      -7.2767154262140082E+001,
      -7.2752034795671292E+001,
      -7.2736727727005572E+001,
      -7.2721233660439765E+001,
      -7.2705553207653082E+001,
      -7.2689686987682975E+001,
      -7.2673635626900619E+001,
      -7.2657399758986244E+001,
      -7.2640980024904138E+001,
      -7.2624377072877294E+001,
      -7.2607591558361790E+001,
      -7.2590624144021035E+001,
      -7.2573475499699484E+001,
      -7.2556146302396257E+001,
      -7.2538637236238358E+001,
      -7.2520948992453782E+001,
      -7.2503082269344077E+001,
      -7.2485037772256916E+001,
      -7.2466816213558090E+001,
      -7.2448418312603593E+001,
      -7.2429844795711006E+001,
      -7.2411096396131001E+001,
      -7.2392173854018282E+001,
      -7.2373077916402423E+001,
      -7.2353809337158324E+001,
      -7.2334368876976512E+001,
      -7.2314757303333053E+001,
      -7.2294975390459314E+001,
      -7.2275023919311352E+001,
      -7.2254903677539048E+001,
      -7.2234615459455114E+001,
      -7.2214160066003686E+001,
      -7.2193538304728648E+001,
      -7.2172750989741814E+001,
      -7.2151798941690799E+001,
      -7.2130682987726587E+001,
      -7.2109403961470875E+001,
      -7.2087962702983205E+001,
      -7.2066360058727739E+001,
      -7.2044596881539846E+001,
      -7.2022674030592555E+001,
      -7.2000592371362458E+001,
      -7.1978352775595638E+001,
      -7.1955956121273275E+001,
      -7.1933403292576926E+001,
      -7.1910695179853661E+001,
      -7.1887832679580868E+001,
      -7.1864816694330926E+001,
      -7.1841648132735514E+001,
      -7.1818327909449764E+001,
      -7.1794856945116194E+001,
      -7.1771236166328265E+001,
      -7.1747466505593863E+001,
      -7.1723548901298528E+001,
      -7.1699484297668292E+001,
      -7.1675273644732528E+001,
      -7.1650917898286352E+001,
      -7.1626418019852906E+001,
      -7.1601774976645459E+001,
      -7.1576989741529175E+001,
      -7.1552063292982680E+001,
      -7.1526996615059488E+001,
      -7.1501790697349108E+001,
      -7.1476446534938020E+001,
      -7.1450965128370385E+001,
      -7.1425347483608448E+001,
      -7.1399594611993010E+001,
      -7.1373707530203333E+001,
      -7.1347687260217072E+001,
      -7.1321534829269936E+001,
      -7.1295251269815125E+001,
      -7.1268837619482539E+001,
      -7.1242294921037896E+001,
      -7.1215624222341475E+001,
      -7.1188826576306766E+001,
      -7.1161903040858988E+001,
      -7.1134854678893191E+001,
      -7.1107682558232412E+001,
      -7.1080387751585434E+001,
      -7.1052971336504484E+001,
      -7.1025434395342700E+001,
      -7.0997778015211367E+001,
      -7.0970003287937018E+001,
      -7.0942111310018305E+001,
      -7.0914103182582778E+001,
      -7.0885980011343335E+001,
      -7.0857742906554648E+001,
      -7.0829392982969253E+001,
      -7.0800931359793580E+001,
      -7.0772359160643788E+001,
      -7.0743677513501382E+001,
      -7.0714887550668649E+001,
      -7.0685990408724066E+001,
      -7.0656987228477291E+001,
      -7.0627879154924216E+001,
      -7.0598667337201775E+001,
      -7.0569352928542486E+001,
      -7.0539937086229017E+001,
      -7.0510420971548442E+001,
      -7.0480805749746452E+001,
      -7.0451092589981272E+001,
      -7.0421282665277573E+001,
      -7.0391377152480175E+001,
      -7.0361377232207474E+001,
      -7.0331284088804978E+001,
      -7.0301098910298450E+001,
      -7.0270822888347055E+001,
      -7.0240457218196312E+001,
      -7.0210003098630850E+001,
      -7.0179461731927205E+001,
      -7.0148834323806199E+001,
      -7.0118122083385501E+001,
      -7.0087326223131754E+001,
      -7.0056447958812782E+001,
      -7.0025488509449616E+001,
      -6.9994449097268273E+001,
      -6.9963330947651627E+001,
      -6.9932135289090908E+001,
      -6.9900863353137339E+001,
      -6.9869516374353381E+001,
      -6.9838095590264103E+001,
      -6.9806602241308227E+001,
      -6.9775037570789266E+001,
      -6.9743402824826362E+001,
      -6.9711699252305124E+001,
      -6.9679928104828292E+001,
      -6.9648090636666382E+001,
      -6.9616188104708129E+001,
      -6.9584221768410856E+001,
      -6.9552192889750785E+001,
      -6.9520102733173218E+001,
      -6.9487952565542571E+001,
      -6.9455743656092395E+001,
      -6.9423477276375337E+001,
      -6.9391154700212780E+001,
      -6.9358777203644706E+001,
      -6.9326346064879232E+001,
      -6.9293862564242175E+001,
      -6.9261327984126538E+001,
      -6.9228743608941826E+001,
      -6.9196110725063377E+001,
      -6.9163430620781568E+001,
      -6.9130704586250957E+001,
      -6.9097933913439363E+001,
      -6.9065119896076837E+001,
      -6.9032263829604588E+001,
      -6.8999367011123866E+001,
      -6.8966430739344730E+001,
      -6.8933456314534808E+001,
      -6.8900445038467922E+001,
      -6.8867398214372727E+001,
      -6.8834317146881233E+001,
      -6.8801203141977368E+001,
      -6.8768057506945354E+001,
      -6.8734881550318079E+001,
      -6.8701676581825510E+001,
      -6.8668443912342951E+001,
      -6.8635184853839306E+001,
      -6.8601900719325243E+001,
      -6.8568592822801392E+001,
      -6.8535262479206494E+001,
      -6.8501911004365411E+001,
      -6.8468539714937293E+001,
      -6.8435149928363515E+001,
      -6.8401742962815646E+001,
      -6.8368320137143513E+001,
      -6.8334882770823000E+001,
      -6.8301432183904140E+001,
      -6.8267969696958787E+001,
      -6.8234496631028605E+001,
      -6.8201014307572990E+001,
      -6.8167524048416695E+001,
      -6.8134027175697810E+001,
      -6.8100525011815506E+001,
      -6.8067018879377883E+001,
      -6.8033510101149659E+001,
      -68.0,
      -6.7966489898850369E+001,
      -6.7932981120622131E+001,
      -6.7899474988184494E+001,
      -6.7865972824302204E+001,
      -6.7832475951583319E+001,
      -6.7798985692427010E+001,
      -6.7765503368971395E+001,
      -6.7732030303041228E+001,
      -6.7698567816095874E+001,
      -6.7665117229177000E+001,
      -6.7631679862856501E+001,
      -6.7598257037184368E+001,
      -6.7564850071636499E+001,
      -6.7531460285062707E+001,
      -6.7498088995634603E+001,
      -6.7464737520793520E+001,
      -6.7431407177198622E+001,
      -6.7398099280674771E+001,
      -6.7364815146160694E+001,
      -6.7331556087657049E+001,
      -6.7298323418174505E+001,
      -6.7265118449681935E+001,
      -6.7231942493054660E+001,
      -6.7198796858022632E+001,
      -6.7165682853118767E+001,
      -6.7132601785627287E+001,
      -6.7099554961532078E+001,
      -6.7066543685465192E+001,
      -6.7033569260655270E+001,
      -6.7000632988876134E+001,
      -6.6967736170395412E+001,
      -6.6934880103923163E+001,
      -6.6902066086560623E+001,
      -6.6869295413749043E+001,
      -6.6836569379218446E+001,
      -6.6803889274936651E+001,
      -6.6771256391058188E+001,
      -6.6738672015873476E+001,
      -6.6706137435757839E+001,
      -6.6673653935120782E+001,
      -6.6641222796355308E+001,
      -6.6608845299787234E+001,
      -6.6576522723624677E+001,
      -6.6544256343907620E+001,
      -6.6512047434457457E+001,
      -6.6479897266826796E+001,
      -6.6447807110249229E+001,
      -6.6415778231589158E+001,
      -6.6383811895291885E+001,
      -6.6351909363333633E+001,
      -6.6320071895171722E+001,
      -6.6288300747694890E+001,
      -6.6256597175173653E+001,
      -6.6224962429210748E+001,
      -6.6193397758691788E+001,
      -6.6161904409735911E+001,
      -6.6130483625646633E+001,
      -6.6099136646862675E+001,
      -6.6067864710909106E+001,
      -6.6036669052348387E+001,
      -6.6005550902731741E+001,
      -6.5974511490550398E+001,
      -6.5943552041187232E+001,
      -6.5912673776868260E+001,
      -6.5881877916614513E+001,
      -6.5851165676193816E+001,
      -6.5820538268072809E+001,
      -6.5789996901369165E+001,
      -6.5759542781803717E+001,
      -6.5729177111652959E+001,
      -6.5698901089701565E+001,
      -6.5668715911195036E+001,
      -6.5638622767792540E+001,
      -6.5608622847519840E+001,
      -6.5578717334722441E+001,
      -6.5548907410018742E+001,
      -6.5519194250253562E+001,
      -6.5489579028451558E+001,
      -6.5460062913770997E+001,
      -6.5430647071457528E+001,
      -6.5401332662798239E+001,
      -6.5372120845075798E+001,
      -6.5343012771522723E+001,
      -6.5314009591275948E+001,
      -6.5285112449331365E+001,
      -6.5256322486498632E+001,
      -6.5227640839356226E+001,
      -6.5199068640206434E+001,
      -6.5170607017030761E+001,
      -6.5142257093445366E+001,
      -6.5114019988656679E+001,
      -6.5085896817417236E+001,
      -6.5057888689981709E+001,
      -6.5029996712063010E+001,
      -6.5002221984788648E+001,
      -6.4974565604657315E+001,
      -6.4947028663495530E+001,
      -6.4919612248414580E+001,
      -6.4892317441767602E+001,
      -6.4865145321106823E+001,
      -6.4838096959141026E+001,
      -6.4811173423693248E+001,
      -6.4784375777658553E+001,
      -6.4757705078962118E+001,
      -6.4731162380517475E+001,
      -6.4704748730184889E+001,
      -6.4678465170730078E+001,
      -6.4652312739782943E+001,
      -6.4626292469796681E+001,
      -6.4600405388007005E+001,
      -6.4574652516391566E+001,
      -6.4549034871629644E+001,
      -6.4523553465061994E+001,
      -6.4498209302650906E+001,
      -6.4473003384940526E+001,
      -6.4447936707017334E+001,
      -6.4423010258470839E+001,
      -6.4398225023354556E+001,
      -6.4373581980147108E+001,
      -6.4349082101713662E+001,
      -6.4324726355267487E+001,
      -6.4300515702331722E+001,
      -6.4276451098701486E+001,
      -6.4252533494406151E+001,
      -6.4228763833671749E+001,
      -6.4205143054883820E+001,
      -6.4181672090550251E+001,
      -6.4158351867264500E+001,
      -6.4135183305669088E+001,
      -6.4112167320419147E+001,
      -6.4089304820146353E+001,
      -6.4066596707423088E+001,
      -6.4044043878726740E+001,
      -6.4021647224404376E+001,
      -6.3999407628637556E+001,
      -6.3977325969407460E+001,
      -6.3955403118460161E+001,
      -6.3933639941272283E+001,
      -6.3912037297016816E+001,
      -6.3890596038529139E+001,
      -6.3869317012273434E+001,
      -6.3848201058309222E+001,
      -6.3827249010258207E+001,
      -6.3806461695271373E+001,
      -6.3785839933996328E+001,
      -6.3765384540544893E+001,
      -6.3745096322460967E+001,
      -6.3724976080688663E+001,
      -6.3705024609540700E+001,
      -6.3685242696666954E+001,
      -6.3665631123023502E+001,
      -6.3646190662841690E+001,
      -6.3626922083597591E+001,
      -6.3607826145981740E+001,
      -6.3588903603869021E+001,
      -6.3570155204289009E+001,
      -6.3551581687396428E+001,
      -6.3533183786441917E+001,
      -6.3514962227743105E+001,
      -6.3496917730655937E+001,
      -6.3479051007546232E+001,
      -6.3461362763761649E+001,
      -6.3443853697603764E+001,
      -6.3426524500300530E+001,
      -6.3409375855978979E+001,
      -6.3392408441638224E+001,
      -6.3375622927122727E+001,
      -6.3359019975095869E+001,
      -6.3342600241013770E+001,
      -6.3326364373099402E+001,
      -6.3310313012317046E+001,
      -6.3294446792346925E+001,
      -6.3278766339560256E+001,
      -6.3263272272994435E+001,
      -6.3247965204328715E+001,
      -6.3232845737859932E+001,
      -6.3217914470478746E+001,
      -6.3203171991646030E+001,
      -6.3188618883369593E+001,
      -6.3174255720181236E+001,
      -6.3160083069114059E+001,
      -6.3146101489680028E+001,
      -6.3132311533847997E+001,
      -6.3118713746021783E+001,
      -6.3105308663018782E+001,
      -6.3092096814048702E+001,
      -6.3079078720692735E+001,
      -6.3066254896882910E+001,
      -6.3053625848881822E+001,
      -6.3041192075262671E+001,
      -6.3028954066889554E+001,
      -6.3016912306898085E+001,
      -6.3005067270676321E+001,
      -6.2993419425846021E+001,
      -6.2981969232244147E+001,
      -6.2970717141904728E+001,
      -6.2959663599041050E+001,
      -6.2948809040028038E+001,
      -6.2938153893385106E+001,
      -6.2927698579759188E+001,
      -6.2917443511908182E+001,
      -6.2907389094684589E+001,
      -6.2897535725019580E+001,
      -6.2887883791907349E+001,
      -6.2878433676389641E+001,
      -6.2869185751540890E+001,
      -6.2860140382453288E+001,
      -6.2851297926222550E+001,
      -6.2842658731933696E+001,
      -6.2834223140647318E+001,
      -6.2825991485386112E+001,
      -6.2817964091121752E+001,
      -6.2810141274762003E+001,
      -6.2802523345138269E+001,
      -6.2795110602993361E+001,
      -6.2787903340969649E+001,
      -6.2780901843597498E+001,
      -6.2774106387284036E+001,
      -6.2767517240302233E+001,
      -6.2761134662780336E+001,
      -6.2754958906691591E+001,
      -6.2748990215844245E+001,
      -6.2743228825872016E+001,
      -6.2737674964224709E+001,
      -6.2732328850159270E+001,
      -6.2727190694731135E+001,
      -6.2722260700785874E+001,
      -6.2717539062951204E+001,
      -6.2713025967629306E+001,
      -6.2708721592989463E+001,
      -6.2704626108961001E+001,
      -6.2700739677226629E+001,
      -6.2697062451216020E+001,
      -6.2693594576099748E+001,
      -6.2690336188783576E+001,
      -6.2687287417903086E+001,
      -6.2684448383818520E+001,
      -6.2681819198610071E+001,
      -6.2679399966073476E+001,
      -6.2677190781715893E+001,
      -6.2675191732752154E+001,
      -6.2673402898101259E+001,
      -6.2671824348383353E+001,
      -6.2670456145916873E+001,
      -6.2669298344716111E+001,
      -6.2668350990489074E+001,
      -6.2667614120635704E+001,
      -6.2667087764246325E+001,
      -6.2666771942100617E+001,
      -6.2666666666666671E+001,
      -6.2666771942100617E+001,
      -6.2667087764246325E+001,
      -6.2667614120635704E+001,
      -6.2668350990489074E+001,
      -6.2669298344716111E+001,
      -6.2670456145916873E+001,
      -6.2671824348383353E+001,
      -6.2673402898101259E+001,
      -6.2675191732752154E+001,
      -6.2677190781715893E+001,
      -6.2679399966073476E+001,
      -6.2681819198610071E+001,
      -6.2684448383818520E+001,
      -6.2687287417903086E+001,
      -6.2690336188783576E+001,
      -6.2693594576099748E+001,
      -6.2697062451216020E+001,
      -6.2700739677226629E+001,
      -6.2704626108961001E+001,
      -6.2708721592989463E+001,
      -6.2713025967629306E+001,
      -6.2717539062951204E+001,
      -6.2722260700785874E+001,
      -6.2727190694731135E+001,
      -6.2732328850159270E+001,
      -6.2737674964224709E+001,
      -6.2743228825872016E+001,
      -6.2748990215844245E+001,
      -6.2754958906691591E+001,
      -6.2761134662780336E+001,
      -6.2767517240302233E+001,
      -6.2774106387284036E+001,
      -6.2780901843597498E+001,
      -6.2787903340969649E+001,
      -6.2795110602993361E+001,
      -6.2802523345138269E+001,
      -6.2810141274762003E+001,
      -6.2817964091121752E+001,
      -6.2825991485386112E+001,
      -6.2834223140647318E+001,
      -6.2842658731933696E+001,
      -6.2851297926222550E+001,
      -6.2860140382453288E+001,
      -6.2869185751540890E+001,
      -6.2878433676389641E+001,
      -6.2887883791907349E+001,
      -6.2897535725019580E+001,
      -6.2907389094684589E+001,
      -6.2917443511908182E+001,
      -6.2927698579759188E+001,
      -6.2938153893385106E+001,
      -6.2948809040028038E+001,
      -6.2959663599041050E+001,
      -6.2970717141904728E+001,
      -6.2981969232244147E+001,
      -6.2993419425846021E+001,
      -6.3005067270676321E+001,
      -6.3016912306898085E+001,
      -6.3028954066889554E+001,
      -6.3041192075262671E+001,
      -6.3053625848881822E+001,
      -6.3066254896882910E+001,
      -6.3079078720692735E+001,
      -6.3092096814048702E+001,
      -6.3105308663018782E+001,
      -6.3118713746021783E+001,
      -6.3132311533847997E+001,
      -6.3146101489680028E+001,
      -6.3160083069114059E+001,
      -6.3174255720181236E+001,
      -6.3188618883369593E+001,
      -6.3203171991646030E+001,
      -6.3217914470478746E+001,
      -6.3232845737859932E+001,
      -6.3247965204328715E+001,
      -6.3263272272994435E+001,
      -6.3278766339560256E+001,
      -6.3294446792346925E+001,
      -6.3310313012317046E+001,
      -6.3326364373099402E+001,
      -6.3342600241013770E+001,
      -6.3359019975095869E+001,
      -6.3375622927122727E+001,
      -6.3392408441638224E+001,
      -6.3409375855978979E+001,
      -6.3426524500300530E+001,
      -6.3443853697603764E+001,
      -6.3461362763761649E+001,
      -6.3479051007546232E+001,
      -6.3496917730655937E+001,
      -6.3514962227743105E+001,
      -6.3533183786441917E+001,
      -6.3551581687396428E+001,
      -6.3570155204289009E+001,
      -6.3588903603869021E+001,
      -6.3607826145981726E+001,
      -6.3626922083597591E+001,
      -6.3646190662841690E+001,
      -6.3665631123023502E+001,
      -6.3685242696666954E+001,
      -6.3705024609540686E+001,
      -6.3724976080688663E+001,
      -6.3745096322460967E+001,
      -6.3765384540544893E+001,
      -6.3785839933996328E+001,
      -6.3806461695271373E+001,
      -6.3827249010258207E+001,
      -6.3848201058309222E+001,
      -6.3869317012273434E+001,
      -6.3890596038529139E+001,
      -6.3912037297016816E+001,
      -6.3933639941272283E+001,
      -6.3955403118460161E+001,
      -6.3977325969407460E+001,
      -6.3999407628637556E+001,
      -6.4021647224404362E+001,
      -6.4044043878726740E+001,
      -6.4066596707423088E+001,
      -6.4089304820146353E+001,
      -6.4112167320419147E+001,
      -6.4135183305669088E+001,
      -6.4158351867264500E+001,
      -6.4181672090550251E+001,
      -6.4205143054883820E+001,
      -6.4228763833671749E+001,
      -6.4252533494406151E+001,
      -6.4276451098701486E+001,
      -6.4300515702331722E+001,
      -6.4324726355267487E+001,
      -6.4349082101713662E+001,
      -6.4373581980147108E+001,
      -6.4398225023354556E+001,
      -6.4423010258470839E+001,
      -6.4447936707017334E+001,
      -6.4473003384940526E+001,
      -6.4498209302650906E+001,
      -6.4523553465061994E+001,
      -6.4549034871629630E+001,
      -6.4574652516391566E+001,
      -6.4600405388007005E+001,
      -6.4626292469796681E+001,
      -6.4652312739782943E+001,
      -6.4678465170730078E+001,
      -6.4704748730184889E+001,
      -6.4731162380517461E+001,
      -6.4757705078962118E+001,
      -6.4784375777658553E+001,
      -6.4811173423693248E+001,
      -6.4838096959141026E+001,
      -6.4865145321106823E+001,
      -6.4892317441767602E+001,
      -6.4919612248414580E+001,
      -6.4947028663495530E+001,
      -6.4974565604657315E+001,
      -6.5002221984788633E+001,
      -6.5029996712063010E+001,
      -6.5057888689981709E+001,
      -6.5085896817417236E+001,
      -6.5114019988656679E+001,
      -6.5142257093445366E+001,
      -6.5170607017030761E+001,
      -6.5199068640206434E+001,
      -6.5227640839356226E+001,
      -6.5256322486498632E+001,
      -6.5285112449331365E+001,
      -6.5314009591275948E+001,
      -6.5343012771522723E+001,
      -6.5372120845075798E+001,
      -6.5401332662798239E+001,
      -6.5430647071457528E+001,
      -6.5460062913770997E+001,
      -6.5489579028451558E+001,
      -6.5519194250253562E+001,
      -6.5548907410018742E+001,
      -6.5578717334722427E+001,
      -6.5608622847519840E+001,
      -6.5638622767792540E+001,
      -6.5668715911195036E+001,
      -6.5698901089701565E+001,
      -6.5729177111652959E+001,
      -6.5759542781803717E+001,
      -6.5789996901369165E+001,
      -6.5820538268072809E+001,
      -6.5851165676193816E+001,
      -6.5881877916614513E+001,
      -6.5912673776868260E+001,
      -6.5943552041187232E+001,
      -6.5974511490550398E+001,
      -6.6005550902731741E+001,
      -6.6036669052348387E+001,
      -6.6067864710909106E+001,
      -6.6099136646862675E+001,
      -6.6130483625646633E+001,
      -6.6161904409735911E+001,
      -6.6193397758691788E+001,
      -6.6224962429210748E+001,
      -6.6256597175173653E+001,
      -6.6288300747694890E+001,
      -6.6320071895171722E+001,
      -6.6351909363333633E+001,
      -6.6383811895291885E+001,
      -6.6415778231589158E+001,
      -6.6447807110249229E+001,
      -6.6479897266826796E+001,
      -6.6512047434457443E+001,
      -6.6544256343907605E+001,
      -6.6576522723624677E+001,
      -6.6608845299787234E+001,
      -6.6641222796355308E+001,
      -6.6673653935120782E+001,
      -6.6706137435757839E+001,
      -6.6738672015873462E+001,
      -6.6771256391058188E+001,
      -6.6803889274936623E+001,
      -6.6836569379218446E+001,
      -6.6869295413749043E+001,
      -6.6902066086560623E+001,
      -6.6934880103923163E+001,
      -6.6967736170395412E+001,
      -6.7000632988876134E+001,
      -6.7033569260655270E+001,
      -6.7066543685465192E+001,
      -6.7099554961532078E+001,
      -6.7132601785627287E+001,
      -6.7165682853118767E+001,
      -6.7198796858022618E+001,
      -6.7231942493054646E+001,
      -6.7265118449681935E+001,
      -6.7298323418174505E+001,
      -6.7331556087657049E+001,
      -6.7364815146160694E+001,
      -6.7398099280674757E+001,
      -6.7431407177198622E+001,
      -6.7464737520793520E+001,
      -6.7498088995634603E+001,
      -6.7531460285062707E+001,
      -6.7564850071636499E+001,
      -6.7598257037184354E+001,
      -6.7631679862856501E+001,
      -6.7665117229177000E+001,
      -6.7698567816095874E+001,
      -6.7732030303041228E+001,
      -6.7765503368971380E+001,
      -6.7798985692427010E+001,
      -6.7832475951583319E+001,
      -6.7865972824302204E+001,
      -6.7899474988184494E+001,
      -6.7932981120622131E+001,
      -6.7966489898850369E+001,
      -68.0,
      -6.8033510101149645E+001,
      -6.8067018879377883E+001,
      -6.8100525011815506E+001,
      -6.8134027175697810E+001,
      -6.8167524048416681E+001,
      -6.8201014307572976E+001,
      -6.8234496631028605E+001,
      -6.8267969696958787E+001,
      -6.8301432183904140E+001,
      -6.8334882770823000E+001,
      -6.8368320137143513E+001,
      -6.8401742962815632E+001,
      -6.8435149928363515E+001,
      -6.8468539714937293E+001,
      -6.8501911004365411E+001,
      -6.8535262479206494E+001,
      -6.8568592822801392E+001,
      -6.8601900719325229E+001,
      -6.8635184853839306E+001,
      -6.8668443912342951E+001,
      -6.8701676581825510E+001,
      -6.8734881550318079E+001,
      -6.8768057506945340E+001,
      -6.8801203141977368E+001,
      -6.8834317146881233E+001,
      -6.8867398214372727E+001,
      -6.8900445038467922E+001,
      -6.8933456314534808E+001,
      -6.8966430739344730E+001,
      -6.8999367011123866E+001,
      -6.9032263829604588E+001,
      -6.9065119896076837E+001,
      -6.9097933913439377E+001,
      -6.9130704586250957E+001,
      -6.9163430620781568E+001,
      -6.9196110725063363E+001,
      -6.9228743608941826E+001,
      -6.9261327984126524E+001,
      -6.9293862564242175E+001,
      -6.9326346064879232E+001,
      -6.9358777203644706E+001,
      -6.9391154700212780E+001,
      -6.9423477276375337E+001,
      -6.9455743656092409E+001,
      -6.9487952565542557E+001,
      -6.9520102733173218E+001,
      -6.9552192889750785E+001,
      -6.9584221768410856E+001,
      -6.9616188104708129E+001,
      -6.9648090636666382E+001,
      -6.9679928104828292E+001,
      -6.9711699252305124E+001,
      -6.9743402824826362E+001,
      -6.9775037570789266E+001,
      -6.9806602241308227E+001,
      -6.9838095590264103E+001,
      -6.9869516374353381E+001,
      -6.9900863353137339E+001,
      -6.9932135289090908E+001,
      -6.9963330947651627E+001,
      -6.9994449097268273E+001,
      -7.0025488509449616E+001,
      -7.0056447958812782E+001,
      -7.0087326223131754E+001,
      -7.0118122083385501E+001,
      -7.0148834323806199E+001,
      -7.0179461731927205E+001,
      -7.0210003098630850E+001,
      -7.0240457218196312E+001,
      -7.0270822888347055E+001,
      -7.0301098910298450E+001,
      -7.0331284088804978E+001,
      -7.0361377232207488E+001,
      -7.0391377152480175E+001,
      -7.0421282665277573E+001,
      -7.0451092589981272E+001,
      -7.0480805749746452E+001,
      -7.0510420971548456E+001,
      -7.0539937086229017E+001,
      -7.0569352928542486E+001,
      -7.0598667337201775E+001,
      -7.0627879154924216E+001,
      -7.0656987228477291E+001,
      -7.0685990408724066E+001,
      -7.0714887550668649E+001,
      -7.0743677513501368E+001,
      -7.0772359160643788E+001,
      -7.0800931359793580E+001,
      -7.0829392982969253E+001,
      -7.0857742906554648E+001,
      -7.0885980011343335E+001,
      -7.0914103182582778E+001,
      -7.0942111310018305E+001,
      -7.0970003287937004E+001,
      -7.0997778015211367E+001,
      -7.1025434395342700E+001,
      -7.1052971336504484E+001,
      -7.1080387751585420E+001,
      -7.1107682558232412E+001,
      -7.1134854678893191E+001,
      -7.1161903040858988E+001,
      -7.1188826576306766E+001,
      -7.1215624222341461E+001,
      -7.1242294921037896E+001,
      -7.1268837619482539E+001,
      -7.1295251269815125E+001,
      -7.1321534829269936E+001,
      -7.1347687260217072E+001,
      -7.1373707530203333E+001,
      -7.1399594611993010E+001,
      -7.1425347483608448E+001,
      -7.1450965128370370E+001,
      -7.1476446534938020E+001,
      -7.1501790697349108E+001,
      -7.1526996615059488E+001,
      -7.1552063292982680E+001,
      -7.1576989741529175E+001,
      -7.1601774976645459E+001,
      -7.1626418019852906E+001,
      -7.1650917898286352E+001,
      -7.1675273644732528E+001,
      -7.1699484297668292E+001,
      -7.1723548901298528E+001,
      -7.1747466505593863E+001,
      -7.1771236166328265E+001,
      -7.1794856945116194E+001,
      -7.1818327909449764E+001,
      -7.1841648132735500E+001,
      -7.1864816694330926E+001,
      -7.1887832679580868E+001,
      -7.1910695179853661E+001,
      -7.1933403292576926E+001,
      -7.1955956121273275E+001,
      -7.1978352775595638E+001,
      -7.2000592371362458E+001,
      -7.2022674030592555E+001,
      -7.2044596881539846E+001,
      -7.2066360058727739E+001,
      -7.2087962702983205E+001,
      -7.2109403961470875E+001,
      -7.2130682987726587E+001,
      -7.2151798941690799E+001,
      -7.2172750989741814E+001,
      -7.2193538304728634E+001,
      -7.2214160066003686E+001,
      -7.2234615459455114E+001,
      -7.2254903677539048E+001,
      -7.2275023919311352E+001,
      -7.2294975390459314E+001,
      -7.2314757303333053E+001,
      -7.2334368876976512E+001,
      -7.2353809337158324E+001,
      -7.2373077916402423E+001,
      -7.2392173854018282E+001,
      -7.2411096396131001E+001,
      -7.2429844795711006E+001,
      -7.2448418312603593E+001,
      -7.2466816213558090E+001,
      -7.2485037772256916E+001,
      -7.2503082269344077E+001,
      -7.2520948992453782E+001,
      -7.2538637236238358E+001,
      -7.2556146302396257E+001,
      -7.2573475499699484E+001,
      -7.2590624144021035E+001,
      -7.2607591558361790E+001,
      -7.2624377072877294E+001,
      -7.2640980024904138E+001,
      -7.2657399758986244E+001,
      -7.2673635626900619E+001,
      -7.2689686987682975E+001,
      -7.2705553207653082E+001,
      -7.2721233660439765E+001,
      -7.2736727727005572E+001,
      -7.2752034795671292E+001,
      -7.2767154262140082E+001,
      -7.2782085529521268E+001,
      -7.2796828008353984E+001,
      -7.2811381116630429E+001,
      -7.2825744279818778E+001,
      -7.2839916930885963E+001,
      -7.2853898510319979E+001,
      -7.2867688466152018E+001,
      -7.2881286253978232E+001,
      -7.2894691336981239E+001,
      -7.2907903185951312E+001,
      -7.2920921279307279E+001,
      -7.2933745103117104E+001,
      -7.2946374151118192E+001,
      -7.2958807924737343E+001,
      -7.2971045933110460E+001,
      -7.2983087693101922E+001,
      -7.2994932729323693E+001,
      -7.3006580574153986E+001,
      -7.3018030767755874E+001,
      -7.3029282858095286E+001,
      -7.3040336400958964E+001,
      -7.3051190959971976E+001,
      -7.3061846106614908E+001,
      -7.3072301420240819E+001,
      -7.3082556488091839E+001,
      -7.3092610905315425E+001,
      -7.3102464274980434E+001,
      -7.3112116208092672E+001,
      -7.3121566323610367E+001,
      -7.3130814248459131E+001,
      -7.3139859617546719E+001,
      -7.3148702073777457E+001,
      -7.3157341268066318E+001,
      -7.3165776859352704E+001,
      -7.3174008514613902E+001,
      -7.3182035908878262E+001,
      -7.3189858725238011E+001,
      -7.3197476654861745E+001,
      -7.3204889397006653E+001,
      -7.3212096659030365E+001,
      -7.3219098156402524E+001,
      -7.3225893612715979E+001,
      -7.3232482759697788E+001,
      -7.3238865337219679E+001,
      -7.3245041093308416E+001,
      -7.3251009784155769E+001,
      -7.3256771174128005E+001,
      -7.3262325035775305E+001,
      -7.3267671149840737E+001,
      -7.3272809305268879E+001,
      -7.3277739299214133E+001,
      -7.3282460937048810E+001,
      -7.3286974032370708E+001,
      -7.3291278407010552E+001,
      -7.3295373891039006E+001,
      -7.3299260322773392E+001,
      -7.3302937548784001E+001,
      -7.3306405423900273E+001,
      -7.3309663811216438E+001,
      -7.3312712582096935E+001,
      -7.3315551616181494E+001,
      -7.3318180801389943E+001,
      -7.3320600033926539E+001,
      -7.3322809218284121E+001,
      -7.3324808267247860E+001,
      -7.3326597101898756E+001,
      -7.3328175651616661E+001,
      -7.3329543854083141E+001,
      -7.3330701655283903E+001,
      -7.3331649009510940E+001,
      -7.3332385879364310E+001,
      -7.3332912235753696E+001,
      -7.3333228057899404E+001,
      -7.3333333333333343E+001,
      -7.3333228057899404E+001,
      -7.3332912235753696E+001,
      -7.3332385879364310E+001,
      -7.3331649009510940E+001,
      -7.3330701655283903E+001,
      -7.3329543854083141E+001,
      -7.3328175651616661E+001,
      -7.3326597101898756E+001,
      -7.3324808267247860E+001,
      -7.3322809218284121E+001,
      -7.3320600033926539E+001,
      -7.3318180801389943E+001,
      -7.3315551616181494E+001,
      -7.3312712582096935E+001,
      -7.3309663811216438E+001,
      -7.3306405423900273E+001,
      -7.3302937548784001E+001,
      -7.3299260322773392E+001,
      -7.3295373891039006E+001,
      -7.3291278407010552E+001,
      -7.3286974032370708E+001,
      -7.3282460937048810E+001,
      -7.3277739299214133E+001,
      -7.3272809305268879E+001,
      -7.3267671149840737E+001,
      -7.3262325035775305E+001,
      -7.3256771174128005E+001,
      -7.3251009784155769E+001,
      -7.3245041093308444E+001,
      -7.3238865337219679E+001,
      -7.3232482759697788E+001,
      -7.3225893612715979E+001,
      -7.3219098156402524E+001,
      -7.3212096659030365E+001,
      -7.3204889397006653E+001,
      -7.3197476654861745E+001,
      -7.3189858725238011E+001,
      -7.3182035908878262E+001,
      -7.3174008514613902E+001,
      -7.3165776859352704E+001,
      -7.3157341268066318E+001,
      -7.3148702073777457E+001,
      -7.3139859617546719E+001,
      -7.3130814248459131E+001,
      -7.3121566323610367E+001,
      -7.3112116208092672E+001,
      -7.3102464274980434E+001,
      -7.3092610905315425E+001,
      -7.3082556488091839E+001,
      -7.3072301420240819E+001,
      -7.3061846106614908E+001,
      -7.3051190959971976E+001,
      -7.3040336400958964E+001,
      -7.3029282858095286E+001,
      -7.3018030767755874E+001,
      -7.3006580574153986E+001,
      -7.2994932729323693E+001,
      -7.2983087693101922E+001,
      -7.2971045933110460E+001,
      -7.2958807924737343E+001,
      -7.2946374151118192E+001,
      -7.2933745103117104E+001,
      -7.2920921279307279E+001,
      -7.2907903185951312E+001,
      -7.2894691336981239E+001,
      -7.2881286253978232E+001,
      -7.2867688466152018E+001,
      -7.2853898510319979E+001,
      -7.2839916930885963E+001,
      -7.2825744279818778E+001,
      -7.2811381116630429E+001,
      -7.2796828008353984E+001,
      -7.2782085529521268E+001,
      -7.2767154262140068E+001,
      -7.2752034795671292E+001,
      -7.2736727727005572E+001,
      -7.2721233660439765E+001,
      -7.2705553207653082E+001,
      -7.2689686987682975E+001,
      -7.2673635626900619E+001,
      -7.2657399758986244E+001,
      -7.2640980024904138E+001,
      -7.2624377072877294E+001,
      -7.2607591558361790E+001,
      -7.2590624144021035E+001,
      -7.2573475499699484E+001,
      -7.2556146302396257E+001,
      -7.2538637236238358E+001,
      -7.2520948992453782E+001,
      -7.2503082269344077E+001,
      -7.2485037772256916E+001,
      -7.2466816213558090E+001,
      -7.2448418312603579E+001,
      -7.2429844795711006E+001,
      -7.2411096396131001E+001,
      -7.2392173854018296E+001,
      -7.2373077916402423E+001,
      -7.2353809337158324E+001,
      -7.2334368876976512E+001,
      -7.2314757303333053E+001,
      -7.2294975390459328E+001,
      -7.2275023919311352E+001,
      -7.2254903677539048E+001,
      -7.2234615459455114E+001,
      -7.2214160066003686E+001,
      -7.2193538304728648E+001,
      -7.2172750989741814E+001,
      -7.2151798941690799E+001,
      -7.2130682987726587E+001,
      -7.2109403961470875E+001,
      -7.2087962702983205E+001,
      -7.2066360058727724E+001,
      -7.2044596881539846E+001,
      -7.2022674030592555E+001,
      -7.2000592371362458E+001,
      -7.1978352775595638E+001,
      -7.1955956121273289E+001,
      -7.1933403292576926E+001,
      -7.1910695179853661E+001,
      -7.1887832679580868E+001,
      -7.1864816694330926E+001,
      -7.1841648132735514E+001,
      -7.1818327909449764E+001,
      -7.1794856945116194E+001,
      -7.1771236166328265E+001,
      -7.1747466505593863E+001,
      -7.1723548901298528E+001,
      -7.1699484297668292E+001,
      -7.1675273644732528E+001,
      -7.1650917898286338E+001,
      -7.1626418019852906E+001,
      -7.1601774976645459E+001,
      -7.1576989741529175E+001,
      -7.1552063292982680E+001,
      -7.1526996615059488E+001,
      -7.1501790697349108E+001,
      -7.1476446534938020E+001,
      -7.1450965128370370E+001,
      -7.1425347483608448E+001,
      -7.1399594611993010E+001,
      -7.1373707530203333E+001,
      -7.1347687260217072E+001,
      -7.1321534829269936E+001,
      -7.1295251269815125E+001,
      -7.1268837619482554E+001,
      -7.1242294921037882E+001,
      -7.1215624222341461E+001,
      -7.1188826576306766E+001,
      -7.1161903040858988E+001,
      -7.1134854678893191E+001,
      -7.1107682558232412E+001,
      -7.1080387751585420E+001,
      -7.1052971336504484E+001,
      -7.1025434395342714E+001,
      -7.0997778015211381E+001,
      -7.0970003287937018E+001,
      -7.0942111310018305E+001,
      -7.0914103182582778E+001,
      -7.0885980011343335E+001,
      -7.0857742906554648E+001,
      -7.0829392982969253E+001,
      -7.0800931359793594E+001,
      -7.0772359160643788E+001,
      -7.0743677513501382E+001,
      -7.0714887550668635E+001,
      -7.0685990408724066E+001,
      -7.0656987228477291E+001,
      -7.0627879154924216E+001,
      -7.0598667337201775E+001,
      -7.0569352928542500E+001,
      -7.0539937086229017E+001,
      -7.0510420971548456E+001,
      -7.0480805749746452E+001,
      -7.0451092589981286E+001,
      -7.0421282665277573E+001,
      -7.0391377152480175E+001,
      -7.0361377232207474E+001,
      -7.0331284088804978E+001,
      -7.0301098910298464E+001,
      -7.0270822888347055E+001,
      -7.0240457218196312E+001,
      -7.0210003098630850E+001,
      -7.0179461731927191E+001,
      -7.0148834323806199E+001,
      -7.0118122083385501E+001,
      -7.0087326223131754E+001,
      -7.0056447958812782E+001,
      -7.0025488509449616E+001,
      -6.9994449097268273E+001,
      -6.9963330947651627E+001,
      -6.9932135289090908E+001,
      -6.9900863353137339E+001,
      -6.9869516374353381E+001,
      -6.9838095590264103E+001,
      -6.9806602241308227E+001,
      -6.9775037570789266E+001,
      -6.9743402824826362E+001,
      -6.9711699252305138E+001,
      -6.9679928104828292E+001,
      -6.9648090636666382E+001,
      -6.9616188104708129E+001,
      -6.9584221768410856E+001,
      -6.9552192889750785E+001,
      -6.9520102733173218E+001,
      -6.9487952565542571E+001,
      -6.9455743656092409E+001,
      -6.9423477276375337E+001,
      -6.9391154700212795E+001,
      -6.9358777203644706E+001,
      -6.9326346064879232E+001,
      -6.9293862564242175E+001,
      -6.9261327984126524E+001,
      -6.9228743608941826E+001,
      -6.9196110725063377E+001,
      -6.9163430620781568E+001,
      -6.9130704586250957E+001,
      -6.9097933913439363E+001,
      -6.9065119896076837E+001,
      -6.9032263829604588E+001,
      -6.8999367011123866E+001,
      -6.8966430739344730E+001,
      -6.8933456314534808E+001,
      -6.8900445038467922E+001,
      -6.8867398214372727E+001,
      -6.8834317146881233E+001,
      -6.8801203141977382E+001,
      -6.8768057506945340E+001,
      -6.8734881550318079E+001,
      -6.8701676581825510E+001,
      -6.8668443912342951E+001,
      -6.8635184853839306E+001,
      -6.8601900719325243E+001,
      -6.8568592822801392E+001,
      -6.8535262479206494E+001,
      -6.8501911004365411E+001,
      -6.8468539714937293E+001,
      -6.8435149928363501E+001,
      -6.8401742962815632E+001,
      -6.8368320137143499E+001,
      -6.8334882770823000E+001,
      -6.8301432183904140E+001,
      -6.8267969696958787E+001,
      -6.8234496631028605E+001,
      -6.8201014307572990E+001,
      -6.8167524048416681E+001,
      -6.8134027175697810E+001,
      -6.8100525011815506E+001,
      -6.8067018879377883E+001,
      -6.8033510101149659E+001,
      -68.0,
      -6.7966489898850369E+001,
      -6.7932981120622131E+001,
      -6.7899474988184494E+001,
      -6.7865972824302204E+001,
      -6.7832475951583319E+001,
      -6.7798985692427010E+001,
      -6.7765503368971380E+001,
      -6.7732030303041228E+001,
      -6.7698567816095874E+001,
      -6.7665117229177000E+001,
      -6.7631679862856501E+001,
      -6.7598257037184368E+001,
      -6.7564850071636499E+001,
      -6.7531460285062707E+001,
      -6.7498088995634603E+001,
      -6.7464737520793520E+001,
      -6.7431407177198622E+001,
      -6.7398099280674771E+001,
      -6.7364815146160694E+001,
      -6.7331556087657049E+001,
      -6.7298323418174505E+001,
      -6.7265118449681935E+001,
      -6.7231942493054646E+001,
      -6.7198796858022632E+001,
      -6.7165682853118767E+001,
      -6.7132601785627287E+001,
      -6.7099554961532078E+001,
      -6.7066543685465192E+001,
      -6.7033569260655270E+001,
      -6.7000632988876134E+001,
      -6.6967736170395412E+001,
      -6.6934880103923163E+001,
      -6.6902066086560637E+001,
      -6.6869295413749043E+001,
      -6.6836569379218460E+001,
      -6.6803889274936651E+001,
      -6.6771256391058202E+001,
      -6.6738672015873476E+001,
      -6.6706137435757839E+001,
      -6.6673653935120782E+001,
      -6.6641222796355308E+001,
      -6.6608845299787234E+001,
      -6.6576522723624677E+001,
      -6.6544256343907605E+001,
      -6.6512047434457457E+001,
      -6.6479897266826796E+001,
      -6.6447807110249229E+001,
      -6.6415778231589158E+001,
      -6.6383811895291885E+001,
      -6.6351909363333633E+001,
      -6.6320071895171722E+001,
      -6.6288300747694890E+001,
      -6.6256597175173667E+001,
      -6.6224962429210748E+001,
      -6.6193397758691788E+001,
      -6.6161904409735925E+001,
      -6.6130483625646647E+001,
      -6.6099136646862675E+001,
      -6.6067864710909106E+001,
      -6.6036669052348401E+001,
      -6.6005550902731741E+001,
      -6.5974511490550398E+001,
      -6.5943552041187232E+001,
      -6.5912673776868260E+001,
      -6.5881877916614513E+001,
      -6.5851165676193816E+001,
      -6.5820538268072809E+001,
      -6.5789996901369165E+001,
      -6.5759542781803717E+001,
      -6.5729177111652959E+001,
      -6.5698901089701565E+001,
      -6.5668715911195036E+001,
      -6.5638622767792540E+001,
      -6.5608622847519825E+001,
      -6.5578717334722441E+001,
      -6.5548907410018742E+001,
      -6.5519194250253562E+001,
      -6.5489579028451573E+001,
      -6.5460062913770997E+001,
      -6.5430647071457528E+001,
      -6.5401332662798239E+001,
      -6.5372120845075798E+001,
      -6.5343012771522723E+001,
      -6.5314009591275948E+001,
      -6.5285112449331365E+001,
      -6.5256322486498647E+001,
      -6.5227640839356226E+001,
      -6.5199068640206420E+001,
      -6.5170607017030761E+001,
      -6.5142257093445366E+001,
      -6.5114019988656679E+001,
      -6.5085896817417236E+001,
      -6.5057888689981723E+001,
      -6.5029996712062996E+001,
      -6.5002221984788648E+001,
      -6.4974565604657315E+001,
      -6.4947028663495530E+001,
      -6.4919612248414580E+001,
      -6.4892317441767602E+001,
      -6.4865145321106823E+001,
      -6.4838096959141026E+001,
      -6.4811173423693234E+001,
      -6.4784375777658539E+001,
      -6.4757705078962118E+001,
      -6.4731162380517475E+001,
      -6.4704748730184889E+001,
      -6.4678465170730078E+001,
      -6.4652312739782943E+001,
      -6.4626292469796681E+001,
      -6.4600405388007005E+001,
      -6.4574652516391566E+001,
      -6.4549034871629630E+001,
      -6.4523553465061994E+001,
      -6.4498209302650906E+001,
      -6.4473003384940526E+001,
      -6.4447936707017334E+001,
      -6.4423010258470839E+001,
      -6.4398225023354556E+001,
      -6.4373581980147108E+001,
      -6.4349082101713662E+001,
      -6.4324726355267487E+001,
      -6.4300515702331722E+001,
      -6.4276451098701500E+001,
      -6.4252533494406151E+001,
      -6.4228763833671749E+001,
      -6.4205143054883820E+001,
      -6.4181672090550251E+001,
      -6.4158351867264500E+001,
      -6.4135183305669088E+001,
      -6.4112167320419147E+001,
      -6.4089304820146353E+001,
      -6.4066596707423088E+001,
      -6.4044043878726740E+001,
      -6.4021647224404362E+001,
      -6.3999407628637556E+001,
      -6.3977325969407460E+001,
      -6.3955403118460161E+001,
      -6.3933639941272283E+001,
      -6.3912037297016816E+001,
      -6.3890596038529139E+001,
      -6.3869317012273434E+001,
      -6.3848201058309222E+001,
      -6.3827249010258207E+001,
      -6.3806461695271373E+001,
      -6.3785839933996328E+001,
      -6.3765384540544879E+001,
      -6.3745096322460967E+001,
      -6.3724976080688663E+001,
      -6.3705024609540700E+001,
      -6.3685242696666954E+001,
      -6.3665631123023523E+001,
      -6.3646190662841690E+001,
      -6.3626922083597591E+001,
      -6.3607826145981740E+001,
      -6.3588903603869021E+001,
      -6.3570155204289009E+001,
      -6.3551581687396428E+001,
      -6.3533183786441931E+001,
      -6.3514962227743105E+001,
      -6.3496917730655937E+001,
      -6.3479051007546232E+001,
      -6.3461362763761649E+001,
      -6.3443853697603764E+001,
      -6.3426524500300530E+001,
      -6.3409375855978979E+001,
      -6.3392408441638224E+001,
      -6.3375622927122727E+001,
      -6.3359019975095869E+001,
      -6.3342600241013770E+001,
      -6.3326364373099416E+001,
      -6.3310313012317046E+001,
      -6.3294446792346925E+001,
      -6.3278766339560256E+001,
      -6.3263272272994435E+001,
      -6.3247965204328715E+001,
      -6.3232845737859947E+001,
      -6.3217914470478746E+001,
      -6.3203171991646030E+001,
      -6.3188618883369593E+001,
      -6.3174255720181236E+001,
      -6.3160083069114059E+001,
      -6.3146101489680028E+001,
      -6.3132311533847997E+001,
      -6.3118713746021783E+001,
      -6.3105308663018782E+001,
      -6.3092096814048702E+001,
      -6.3079078720692735E+001,
      -6.3066254896882910E+001,
      -6.3053625848881822E+001,
      -6.3041192075262671E+001,
      -6.3028954066889554E+001,
      -6.3016912306898085E+001,
      -6.3005067270676321E+001,
      -6.2993419425846021E+001,
      -6.2981969232244147E+001,
      -6.2970717141904728E+001,
      -6.2959663599041050E+001,
      -6.2948809040028053E+001,
      -6.2938153893385106E+001,
      -6.2927698579759188E+001,
      -6.2917443511908182E+001,
      -6.2907389094684589E+001,
      -6.2897535725019580E+001,
      -6.2887883791907349E+001,
      -6.2878433676389641E+001,
      -6.2869185751540890E+001,
      -6.2860140382453288E+001,
      -6.2851297926222550E+001,
      -6.2842658731933696E+001,
      -6.2834223140647318E+001,
      -6.2825991485386112E+001,
      -6.2817964091121752E+001,
      -6.2810141274762003E+001,
      -6.2802523345138269E+001,
      -6.2795110602993361E+001,
      -6.2787903340969649E+001,
      -6.2780901843597498E+001,
      -6.2774106387284036E+001,
      -6.2767517240302233E+001,
      -6.2761134662780336E+001,
      -6.2754958906691591E+001,
      -6.2748990215844245E+001,
      -6.2743228825872016E+001,
      -6.2737674964224709E+001,
      -6.2732328850159270E+001,
      -6.2727190694731135E+001,
      -6.2722260700785874E+001,
      -6.2717539062951204E+001,
      -6.2713025967629306E+001,
      -6.2708721592989463E+001,
      -6.2704626108961001E+001,
      -6.2700739677226629E+001,
      -6.2697062451216020E+001,
      -6.2693594576099748E+001,
      -6.2690336188783576E+001,
      -6.2687287417903086E+001,
      -6.2684448383818520E+001,
      -6.2681819198610071E+001,
      -6.2679399966073476E+001,
      -6.2677190781715893E+001,
      -6.2675191732752154E+001,
      -6.2673402898101259E+001,
      -6.2671824348383353E+001,
      -6.2670456145916873E+001,
      -6.2669298344716111E+001,
      -6.2668350990489074E+001,
      -6.2667614120635704E+001,
      -6.2667087764246325E+001,
      -6.2666771942100617E+001,
      -6.2666666666666671E+001,
      -6.2666771942100617E+001,
      -6.2667087764246325E+001,
      -6.2667614120635704E+001,
      -6.2668350990489074E+001,
      -6.2669298344716111E+001,
      -6.2670456145916873E+001,
      -6.2671824348383353E+001,
      -6.2673402898101259E+001,
      -6.2675191732752154E+001,
      -6.2677190781715893E+001,
      -6.2679399966073476E+001,
      -6.2681819198610071E+001,
      -6.2684448383818520E+001,
      -6.2687287417903086E+001,
      -6.2690336188783576E+001,
      -6.2693594576099748E+001,
      -6.2697062451216020E+001,
      -6.2700739677226629E+001,
      -6.2704626108961001E+001,
      -6.2708721592989463E+001,
      -6.2713025967629306E+001,
      -6.2717539062951204E+001,
      -6.2722260700785874E+001,
      -6.2727190694731135E+001,
      -6.2732328850159270E+001,
      -6.2737674964224709E+001,
      -6.2743228825872016E+001,
      -6.2748990215844245E+001,
      -6.2754958906691591E+001,
      -6.2761134662780336E+001,
      -6.2767517240302233E+001,
      -6.2774106387284036E+001,
      -6.2780901843597498E+001,
      -6.2787903340969649E+001,
      -6.2795110602993361E+001,
      -6.2802523345138269E+001,
      -6.2810141274762003E+001,
      -6.2817964091121752E+001,
      -6.2825991485386112E+001,
      -6.2834223140647318E+001,
      -6.2842658731933696E+001,
      -6.2851297926222550E+001,
      -6.2860140382453288E+001,
      -6.2869185751540890E+001,
      -6.2878433676389641E+001,
      -6.2887883791907349E+001,
      -6.2897535725019580E+001,
      -6.2907389094684589E+001,
      -6.2917443511908182E+001,
      -6.2927698579759188E+001,
      -6.2938153893385106E+001,
      -6.2948809040028038E+001,
      -6.2959663599041050E+001,
      -6.2970717141904728E+001,
      -6.2981969232244147E+001,
      -6.2993419425846007E+001,
      -6.3005067270676321E+001,
      -6.3016912306898085E+001,
      -6.3028954066889554E+001,
      -6.3041192075262671E+001,
      -6.3053625848881822E+001,
      -6.3066254896882910E+001,
      -6.3079078720692735E+001,
      -6.3092096814048702E+001,
      -6.3105308663018782E+001,
      -6.3118713746021783E+001,
      -6.3132311533847997E+001,
      -6.3146101489680028E+001,
      -6.3160083069114059E+001,
      -6.3174255720181236E+001,
      -6.3188618883369593E+001,
      -6.3203171991646030E+001,
      -6.3217914470478760E+001,
      -6.3232845737859932E+001,
      -6.3247965204328715E+001,
      -6.3263272272994435E+001,
      -6.3278766339560256E+001,
      -6.3294446792346925E+001,
      -6.3310313012317046E+001,
      -6.3326364373099402E+001,
      -6.3342600241013770E+001,
      -6.3359019975095869E+001,
      -6.3375622927122727E+001,
      -6.3392408441638224E+001,
      -6.3409375855978979E+001,
      -6.3426524500300530E+001,
      -6.3443853697603778E+001,
      -6.3461362763761649E+001,
      -6.3479051007546232E+001,
      -6.3496917730655937E+001,
      -6.3514962227743105E+001,
      -6.3533183786441931E+001,
      -6.3551581687396428E+001,
      -6.3570155204289009E+001,
      -6.3588903603869021E+001,
      -6.3607826145981726E+001,
      -6.3626922083597591E+001,
      -6.3646190662841690E+001,
      -6.3665631123023502E+001,
      -6.3685242696666954E+001,
      -6.3705024609540686E+001,
      -6.3724976080688663E+001,
      -6.3745096322460967E+001,
      -6.3765384540544879E+001,
      -6.3785839933996328E+001,
      -6.3806461695271388E+001,
      -6.3827249010258207E+001,
      -6.3848201058309222E+001,
      -6.3869317012273434E+001,
      -6.3890596038529139E+001,
      -6.3912037297016802E+001,
      -6.3933639941272283E+001,
      -6.3955403118460161E+001,
      -6.3977325969407460E+001,
      -6.3999407628637556E+001,
      -6.4021647224404376E+001,
      -6.4044043878726740E+001,
      -6.4066596707423088E+001,
      -6.4089304820146353E+001,
      -6.4112167320419147E+001,
      -6.4135183305669088E+001,
      -6.4158351867264500E+001,
      -6.4181672090550251E+001,
      -6.4205143054883820E+001,
      -6.4228763833671749E+001,
      -6.4252533494406151E+001,
      -6.4276451098701486E+001,
      -6.4300515702331722E+001,
      -6.4324726355267487E+001,
      -6.4349082101713677E+001,
      -6.4373581980147108E+001,
      -6.4398225023354556E+001,
      -6.4423010258470839E+001,
      -6.4447936707017334E+001,
      -6.4473003384940526E+001,
      -6.4498209302650906E+001,
      -6.4523553465061994E+001,
      -6.4549034871629644E+001,
      -6.4574652516391566E+001,
      -6.4600405388007005E+001,
      -6.4626292469796667E+001,
      -6.4652312739782943E+001,
      -6.4678465170730078E+001,
      -6.4704748730184889E+001,
      -6.4731162380517461E+001,
      -6.4757705078962132E+001,
      -6.4784375777658539E+001,
      -6.4811173423693248E+001,
      -6.4838096959141026E+001,
      -6.4865145321106809E+001,
      -6.4892317441767602E+001,
      -6.4919612248414595E+001,
      -6.4947028663495530E+001,
      -6.4974565604657315E+001,
      -6.5002221984788633E+001,
      -6.5029996712063010E+001,
      -6.5057888689981709E+001,
      -6.5085896817417236E+001,
      -6.5114019988656679E+001,
      -6.5142257093445366E+001,
      -6.5170607017030761E+001,
      -6.5199068640206434E+001,
      -6.5227640839356226E+001,
      -6.5256322486498647E+001,
      -6.5285112449331365E+001,
      -6.5314009591275948E+001,
      -6.5343012771522723E+001,
      -6.5372120845075798E+001,
      -6.5401332662798239E+001,
      -6.5430647071457528E+001,
      -6.5460062913770997E+001,
      -6.5489579028451558E+001,
      -6.5519194250253562E+001,
      -6.5548907410018742E+001,
      -6.5578717334722441E+001,
      -6.5608622847519840E+001,
      -6.5638622767792540E+001,
      -6.5668715911195051E+001,
      -6.5698901089701565E+001,
      -6.5729177111652959E+001,
      -6.5759542781803717E+001,
      -6.5789996901369165E+001,
      -6.5820538268072809E+001,
      -6.5851165676193816E+001,
      -6.5881877916614513E+001,
      -6.5912673776868274E+001,
      -6.5943552041187232E+001,
      -6.5974511490550398E+001,
      -6.6005550902731741E+001,
      -6.6036669052348387E+001,
      -6.6067864710909106E+001,
      -6.6099136646862675E+001,
      -6.6130483625646633E+001,
      -6.6161904409735911E+001,
      -6.6193397758691788E+001,
      -6.6224962429210748E+001,
      -6.6256597175173653E+001,
      -6.6288300747694890E+001,
      -6.6320071895171722E+001,
      -6.6351909363333633E+001,
      -6.6383811895291871E+001,
      -6.6415778231589158E+001,
      -6.6447807110249229E+001,
      -6.6479897266826811E+001,
      -6.6512047434457443E+001,
      -6.6544256343907620E+001,
      -6.6576522723624677E+001,
      -6.6608845299787234E+001,
      -6.6641222796355308E+001,
      -6.6673653935120782E+001,
      -6.6706137435757839E+001,
      -6.6738672015873476E+001,
      -6.6771256391058188E+001,
      -6.6803889274936651E+001,
      -6.6836569379218446E+001,
      -6.6869295413749043E+001,
      -6.6902066086560637E+001,
      -6.6934880103923163E+001,
      -6.6967736170395412E+001,
      -6.7000632988876134E+001,
      -6.7033569260655270E+001,
      -6.7066543685465192E+001,
      -6.7099554961532078E+001,
      -6.7132601785627287E+001,
      -6.7165682853118767E+001,
      -6.7198796858022632E+001,
      -6.7231942493054646E+001,
      -6.7265118449681935E+001,
      -6.7298323418174505E+001,
      -6.7331556087657049E+001,
      -6.7364815146160694E+001,
      -6.7398099280674757E+001,
      -6.7431407177198622E+001,
      -6.7464737520793520E+001,
      -6.7498088995634603E+001,
      -6.7531460285062707E+001,
      -6.7564850071636499E+001,
      -6.7598257037184354E+001,
      -6.7631679862856515E+001,
      -6.7665117229177000E+001,
      -6.7698567816095874E+001,
      -6.7732030303041228E+001,
      -6.7765503368971395E+001,
      -6.7798985692427024E+001,
      -6.7832475951583319E+001,
      -6.7865972824302204E+001,
      -6.7899474988184494E+001,
      -6.7932981120622131E+001,
      -6.7966489898850355E+001,
      -68.0,
      -6.8033510101149659E+001,
      -6.8067018879377883E+001,
      -6.8100525011815506E+001,
      -6.8134027175697810E+001,
      -6.8167524048416695E+001,
      -6.8201014307572976E+001,
      -6.8234496631028620E+001,
      -6.8267969696958787E+001,
      -6.8301432183904140E+001,
      -6.8334882770823000E+001,
      -6.8368320137143513E+001,
      -6.8401742962815646E+001,
      -6.8435149928363515E+001,
      -6.8468539714937293E+001,
      -6.8501911004365411E+001,
      -6.8535262479206494E+001,
      -6.8568592822801392E+001,
      -6.8601900719325229E+001,
      -6.8635184853839320E+001,
      -6.8668443912342951E+001,
      -6.8701676581825510E+001,
      -6.8734881550318079E+001,
      -6.8768057506945354E+001,
      -6.8801203141977368E+001,
      -6.8834317146881233E+001,
      -6.8867398214372727E+001,
      -6.8900445038467922E+001,
      -6.8933456314534808E+001,
      -6.8966430739344730E+001,
      -6.8999367011123866E+001,
      -6.9032263829604588E+001,
      -6.9065119896076837E+001,
      -6.9097933913439377E+001,
      -6.9130704586250957E+001,
      -6.9163430620781568E+001,
      -6.9196110725063363E+001,
      -6.9228743608941826E+001,
      -6.9261327984126524E+001,
      -6.9293862564242175E+001,
      -6.9326346064879232E+001,
      -6.9358777203644721E+001,
      -6.9391154700212780E+001,
      -6.9423477276375337E+001,
      -6.9455743656092409E+001,
      -6.9487952565542557E+001,
      -6.9520102733173218E+001,
      -6.9552192889750799E+001,
      -6.9584221768410856E+001,
      -6.9616188104708129E+001,
      -6.9648090636666382E+001,
      -6.9679928104828292E+001,
      -6.9711699252305124E+001,
      -6.9743402824826362E+001,
      -6.9775037570789266E+001,
      -6.9806602241308227E+001,
      -6.9838095590264089E+001,
      -6.9869516374353381E+001,
      -6.9900863353137339E+001,
      -6.9932135289090922E+001,
      -6.9963330947651613E+001,
      -6.9994449097268273E+001,
      -7.0025488509449616E+001,
      -7.0056447958812782E+001,
      -7.0087326223131754E+001,
      -7.0118122083385501E+001,
      -7.0148834323806199E+001,
      -7.0179461731927205E+001,
      -7.0210003098630850E+001,
      -7.0240457218196312E+001,
      -7.0270822888347055E+001,
      -7.0301098910298450E+001,
      -7.0331284088804978E+001,
      -7.0361377232207488E+001,
      -7.0391377152480189E+001,
      -7.0421282665277602E+001,
      -7.0451092589981272E+001,
      -7.0480805749746466E+001,
      -7.0510420971548442E+001,
      -7.0539937086229017E+001,
      -7.0569352928542486E+001,
      -7.0598667337201775E+001,
      -7.0627879154924216E+001,
      -7.0656987228477291E+001,
      -7.0685990408724066E+001,
      -7.0714887550668649E+001,
      -7.0743677513501368E+001,
      -7.0772359160643788E+001,
      -7.0800931359793594E+001,
      -7.0829392982969253E+001,
      -7.0857742906554648E+001,
      -7.0885980011343349E+001,
      -7.0914103182582778E+001,
      -7.0942111310018305E+001,
      -7.0970003287937018E+001,
      -7.0997778015211381E+001,
      -7.1025434395342700E+001,
      -7.1052971336504484E+001,
      -7.1080387751585434E+001,
      -7.1107682558232412E+001,
      -7.1134854678893191E+001,
      -7.1161903040858988E+001,
      -7.1188826576306781E+001,
      -7.1215624222341461E+001,
      -7.1242294921037896E+001,
      -7.1268837619482539E+001,
      -7.1295251269815125E+001,
      -7.1321534829269936E+001,
      -7.1347687260217072E+001,
      -7.1373707530203333E+001,
      -7.1399594611993010E+001,
      -7.1425347483608448E+001,
      -7.1450965128370385E+001,
      -7.1476446534938020E+001,
      -7.1501790697349108E+001,
      -7.1526996615059488E+001,
      -7.1552063292982680E+001,
      -7.1576989741529175E+001,
      -7.1601774976645459E+001,
      -7.1626418019852906E+001,
      -7.1650917898286352E+001,
      -7.1675273644732528E+001,
      -7.1699484297668292E+001,
      -7.1723548901298514E+001,
      -7.1747466505593863E+001,
      -7.1771236166328265E+001,
      -7.1794856945116194E+001,
      -7.1818327909449764E+001,
      -7.1841648132735514E+001,
      -7.1864816694330912E+001,
      -7.1887832679580868E+001,
      -7.1910695179853661E+001,
      -7.1933403292576926E+001,
      -7.1955956121273275E+001,
      -7.1978352775595653E+001,
      -7.2000592371362458E+001,
      -7.2022674030592555E+001,
      -7.2044596881539846E+001,
      -7.2066360058727739E+001,
      -7.2087962702983205E+001,
      -7.2109403961470875E+001,
      -7.2130682987726587E+001,
      -7.2151798941690799E+001,
      -7.2172750989741814E+001,
      -7.2193538304728648E+001,
      -7.2214160066003686E+001,
      -7.2234615459455128E+001,
      -7.2254903677539048E+001,
      -7.2275023919311352E+001,
      -7.2294975390459314E+001,
      -7.2314757303333053E+001,
      -7.2334368876976498E+001,
      -7.2353809337158324E+001,
      -7.2373077916402423E+001,
      -7.2392173854018282E+001,
      -7.2411096396131001E+001,
      -7.2429844795711006E+001,
      -7.2448418312603593E+001,
      -7.2466816213558090E+001,
      -7.2485037772256916E+001,
      -7.2503082269344077E+001,
      -7.2520948992453782E+001,
      -7.2538637236238358E+001,
      -7.2556146302396257E+001,
      -7.2573475499699484E+001,
      -7.2590624144021035E+001,
      -7.2607591558361790E+001,
      -7.2624377072877294E+001,
      -7.2640980024904138E+001,
      -7.2657399758986244E+001,
      -7.2673635626900619E+001,
      -7.2689686987682975E+001,
      -7.2705553207653082E+001,
      -7.2721233660439765E+001,
      -7.2736727727005572E+001,
      -7.2752034795671292E+001,
      -7.2767154262140082E+001,
      -7.2782085529521268E+001,
      -7.2796828008353984E+001,
      -7.2811381116630429E+001,
      -7.2825744279818778E+001,
      -7.2839916930885963E+001,
      -7.2853898510319979E+001,
      -7.2867688466152018E+001,
      -7.2881286253978232E+001,
      -7.2894691336981239E+001,
      -7.2907903185951312E+001,
      -7.2920921279307279E+001,
      -7.2933745103117104E+001,
      -7.2946374151118192E+001,
      -7.2958807924737343E+001,
      -7.2971045933110460E+001,
      -7.2983087693101950E+001,
      -7.2994932729323693E+001,
      -7.3006580574153986E+001,
      -7.3018030767755874E+001,
      -7.3029282858095286E+001,
      -7.3040336400958964E+001,
      -7.3051190959971976E+001,
      -7.3061846106614908E+001,
      -7.3072301420240819E+001,
      -7.3082556488091839E+001,
      -7.3092610905315425E+001,
      -7.3102464274980434E+001,
      -7.3112116208092687E+001,
      -7.3121566323610367E+001,
      -7.3130814248459131E+001,
      -7.3139859617546719E+001,
      -7.3148702073777457E+001,
      -7.3157341268066318E+001,
      -7.3165776859352704E+001,
      -7.3174008514613902E+001,
      -7.3182035908878262E+001,
      -7.3189858725238011E+001,
      -7.3197476654861745E+001,
      -7.3204889397006653E+001,
      -7.3212096659030365E+001,
      -7.3219098156402524E+001,
      -7.3225893612715979E+001,
      -7.3232482759697788E+001,
      -7.3238865337219679E+001,
      -7.3245041093308416E+001,
      -7.3251009784155769E+001,
      -7.3256771174128005E+001,
      -7.3262325035775305E+001,
      -7.3267671149840737E+001,
      -7.3272809305268879E+001,
      -7.3277739299214133E+001,
      -7.3282460937048810E+001,
      -7.3286974032370708E+001,
      -7.3291278407010552E+001,
      -7.3295373891039006E+001,
      -7.3299260322773392E+001,
      -7.3302937548784001E+001,
      -7.3306405423900273E+001,
      -7.3309663811216438E+001,
      -7.3312712582096935E+001,
      -7.3315551616181494E+001,
      -7.3318180801389943E+001,
      -7.3320600033926539E+001,
      -7.3322809218284121E+001,
      -7.3324808267247860E+001,
      -7.3326597101898756E+001,
      -7.3328175651616661E+001,
      -7.3329543854083141E+001,
      -7.3330701655283903E+001,
      -7.3331649009510940E+001,
      -7.3332385879364310E+001,
      -7.3332912235753696E+001,
      -7.3333228057899404E+001,
      -7.3333333333333343E+001,
      -7.3333228057899404E+001,
      -7.3332912235753696E+001,
      -7.3332385879364310E+001,
      -7.3331649009510940E+001,
      -7.3330701655283903E+001,
      -7.3329543854083141E+001,
      -7.3328175651616661E+001,
      -7.3326597101898756E+001,
      -7.3324808267247860E+001,
      -7.3322809218284121E+001,
      -7.3320600033926539E+001,
      -7.3318180801389943E+001,
      -7.3315551616181494E+001,
      -7.3312712582096935E+001,
      -7.3309663811216438E+001,
      -7.3306405423900273E+001,
      -7.3302937548784001E+001,
      -7.3299260322773392E+001,
      -7.3295373891039006E+001,
      -7.3291278407010552E+001,
      -7.3286974032370708E+001,
      -7.3282460937048810E+001,
      -7.3277739299214133E+001,
      -7.3272809305268879E+001,
      -7.3267671149840737E+001,
      -7.3262325035775305E+001,
      -7.3256771174128005E+001,
      -7.3251009784155769E+001,
      -7.3245041093308444E+001,
      -7.3238865337219679E+001,
      -7.3232482759697788E+001,
      -7.3225893612715979E+001,
      -7.3219098156402524E+001,
      -7.3212096659030365E+001,
      -7.3204889397006653E+001,
      -7.3197476654861745E+001,
      -7.3189858725238011E+001,
      -7.3182035908878262E+001,
      -7.3174008514613902E+001,
      -7.3165776859352704E+001,
      -7.3157341268066332E+001,
      -7.3148702073777457E+001,
      -7.3139859617546719E+001,
      -7.3130814248459131E+001,
      -7.3121566323610367E+001,
      -7.3112116208092672E+001,
      -7.3102464274980434E+001,
      -7.3092610905315425E+001,
      -7.3082556488091839E+001,
      -7.3072301420240819E+001,
      -7.3061846106614908E+001,
      -7.3051190959971976E+001,
      -7.3040336400958964E+001,
      -7.3029282858095272E+001,
      -7.3018030767755874E+001,
      -7.3006580574154000E+001,
      -7.2994932729323693E+001,
      -7.2983087693101950E+001,
      -7.2971045933110460E+001,
      -7.2958807924737343E+001,
      -7.2946374151118192E+001,
      -7.2933745103117104E+001,
      -7.2920921279307279E+001,
      -7.2907903185951312E+001,
      -7.2894691336981239E+001,
      -7.2881286253978232E+001,
      -7.2867688466152018E+001,
      -7.2853898510319979E+001,
      -7.2839916930885963E+001,
      -7.2825744279818778E+001,
      -7.2811381116630429E+001,
      -7.2796828008353984E+001,
      -7.2782085529521268E+001,
      -7.2767154262140082E+001,
      -7.2752034795671292E+001,
      -7.2736727727005572E+001,
      -7.2721233660439765E+001,
      -7.2705553207653082E+001,
      -7.2689686987682975E+001,
      -7.2673635626900619E+001,
      -7.2657399758986244E+001,
      -7.2640980024904138E+001,
      -7.2624377072877294E+001,
      -7.2607591558361790E+001,
      -7.2590624144021035E+001,
      -7.2573475499699484E+001,
      -7.2556146302396229E+001,
      -7.2538637236238358E+001,
      -7.2520948992453782E+001,
      -7.2503082269344091E+001,
      -7.2485037772256916E+001,
      -7.2466816213558090E+001,
      -7.2448418312603593E+001,
      -7.2429844795711006E+001,
      -7.2411096396131001E+001,
      -7.2392173854018296E+001,
      -7.2373077916402423E+001,
      -7.2353809337158324E+001,
      -7.2334368876976512E+001,
      -7.2314757303333053E+001,
      -7.2294975390459328E+001,
      -7.2275023919311337E+001,
      -7.2254903677539048E+001,
      -7.2234615459455128E+001,
      -7.2214160066003686E+001,
      -7.2193538304728648E+001,
      -7.2172750989741814E+001,
      -7.2151798941690799E+001,
      -7.2130682987726587E+001,
      -7.2109403961470875E+001,
      -7.2087962702983205E+001,
      -7.2066360058727739E+001,
      -7.2044596881539846E+001,
      -7.2022674030592555E+001,
      -7.2000592371362458E+001,
      -7.1978352775595638E+001,
      -7.1955956121273275E+001,
      -7.1933403292576926E+001,
      -7.1910695179853647E+001,
      -7.1887832679580868E+001,
      -7.1864816694330926E+001,
      -7.1841648132735514E+001,
      -7.1818327909449764E+001,
      -7.1794856945116194E+001,
      -7.1771236166328265E+001,
      -7.1747466505593863E+001,
      -7.1723548901298514E+001,
      -7.1699484297668292E+001,
      -7.1675273644732528E+001,
      -7.1650917898286352E+001,
      -7.1626418019852892E+001,
      -7.1601774976645473E+001,
      -7.1576989741529175E+001,
      -7.1552063292982666E+001,
      -7.1526996615059474E+001,
      -7.1501790697349108E+001,
      -7.1476446534938020E+001,
      -7.1450965128370385E+001,
      -7.1425347483608448E+001,
      -7.1399594611993010E+001,
      -7.1373707530203347E+001,
      -7.1347687260217072E+001,
      -7.1321534829269936E+001,
      -7.1295251269815125E+001,
      -7.1268837619482554E+001,
      -7.1242294921037896E+001,
      -7.1215624222341461E+001,
      -7.1188826576306766E+001,
      -7.1161903040858988E+001,
      -7.1134854678893191E+001,
      -7.1107682558232412E+001,
      -7.1080387751585420E+001,
      -7.1052971336504484E+001,
      -7.1025434395342700E+001,
      -7.0997778015211367E+001,
      -7.0970003287937004E+001,
      -7.0942111310018305E+001,
      -7.0914103182582778E+001,
      -7.0885980011343335E+001,
      -7.0857742906554648E+001,
      -7.0829392982969253E+001,
      -7.0800931359793594E+001,
      -7.0772359160643774E+001,
      -7.0743677513501368E+001,
      -7.0714887550668649E+001,
      -7.0685990408724052E+001,
      -7.0656987228477306E+001,
      -7.0627879154924216E+001,
      -7.0598667337201775E+001,
      -7.0569352928542500E+001,
      -7.0539937086229003E+001,
      -7.0510420971548456E+001,
      -7.0480805749746452E+001,
      -7.0451092589981286E+001,
      -7.0421282665277602E+001,
      -7.0391377152480175E+001,
      -7.0361377232207488E+001,
      -7.0331284088804978E+001,
      -7.0301098910298450E+001,
      -7.0270822888347055E+001,
      -7.0240457218196312E+001,
      -7.0210003098630850E+001,
      -7.0179461731927205E+001,
      -7.0148834323806199E+001,
      -7.0118122083385501E+001,
      -7.0087326223131754E+001,
      -7.0056447958812782E+001,
      -7.0025488509449616E+001,
      -6.9994449097268273E+001,
      -6.9963330947651627E+001,
      -6.9932135289090922E+001,
      -6.9900863353137339E+001,
      -6.9869516374353381E+001,
      -6.9838095590264103E+001,
      -6.9806602241308227E+001,
      -6.9775037570789266E+001,
      -6.9743402824826362E+001,
      -6.9711699252305138E+001,
      -6.9679928104828292E+001,
      -6.9648090636666382E+001,
      -6.9616188104708144E+001,
      -6.9584221768410870E+001,
      -6.9552192889750785E+001,
      -6.9520102733173204E+001,
      -6.9487952565542571E+001,
      -6.9455743656092409E+001,
      -6.9423477276375351E+001,
      -6.9391154700212780E+001,
      -6.9358777203644706E+001,
      -6.9326346064879232E+001,
      -6.9293862564242175E+001,
      -6.9261327984126524E+001,
      -6.9228743608941826E+001,
      -6.9196110725063377E+001,
      -6.9163430620781568E+001,
      -6.9130704586250957E+001,
      -6.9097933913439377E+001,
      -6.9065119896076837E+001,
      -6.9032263829604588E+001,
      -6.8999367011123866E+001,
      -6.8966430739344730E+001,
      -6.8933456314534808E+001,
      -6.8900445038467922E+001,
      -6.8867398214372699E+001,
      -6.8834317146881233E+001,
      -6.8801203141977368E+001,
      -6.8768057506945340E+001,
      -6.8734881550318065E+001,
      -6.8701676581825510E+001,
      -6.8668443912342951E+001,
      -6.8635184853839320E+001,
      -6.8601900719325229E+001,
      -6.8568592822801392E+001,
      -6.8535262479206494E+001,
      -6.8501911004365411E+001,
      -6.8468539714937293E+001,
      -6.8435149928363515E+001,
      -6.8401742962815646E+001,
      -6.8368320137143513E+001,
      -6.8334882770823000E+001,
      -6.8301432183904140E+001,
      -6.8267969696958787E+001,
      -6.8234496631028605E+001,
      -6.8201014307572976E+001,
      -6.8167524048416695E+001,
      -6.8134027175697810E+001,
      -6.8100525011815520E+001,
      -6.8067018879377883E+001,
      -6.8033510101149659E+001,
      -68.0,
      -6.7966489898850355E+001,
      -6.7932981120622131E+001,
      -6.7899474988184494E+001,
      -6.7865972824302204E+001,
      -6.7832475951583334E+001,
      -6.7798985692427010E+001,
      -6.7765503368971380E+001,
      -6.7732030303041228E+001,
      -6.7698567816095874E+001,
      -6.7665117229176985E+001,
      -6.7631679862856501E+001,
      -6.7598257037184354E+001,
      -6.7564850071636499E+001,
      -6.7531460285062693E+001,
      -6.7498088995634603E+001,
      -6.7464737520793520E+001,
      -6.7431407177198622E+001,
      -6.7398099280674757E+001,
      -6.7364815146160694E+001,
      -6.7331556087657049E+001,
      -6.7298323418174505E+001,
      -6.7265118449681935E+001,
      -6.7231942493054646E+001,
      -6.7198796858022632E+001,
      -6.7165682853118753E+001,
      -6.7132601785627287E+001,
      -6.7099554961532093E+001,
      -6.7066543685465206E+001,
      -6.7033569260655284E+001,
      -6.7000632988876134E+001,
      -6.6967736170395412E+001,
      -6.6934880103923163E+001,
      -6.6902066086560623E+001,
      -6.6869295413749043E+001,
      -6.6836569379218446E+001,
      -6.6803889274936651E+001,
      -6.6771256391058202E+001,
      -6.6738672015873462E+001,
      -6.6706137435757839E+001,
      -6.6673653935120782E+001,
      -6.6641222796355294E+001,
      -6.6608845299787234E+001,
      -6.6576522723624677E+001,
      -6.6544256343907620E+001,
      -6.6512047434457457E+001,
      -6.6479897266826796E+001,
      -6.6447807110249215E+001,
      -6.6415778231589158E+001,
      -6.6383811895291871E+001,
      -6.6351909363333647E+001,
      -6.6320071895171722E+001,
      -6.6288300747694890E+001,
      -6.6256597175173653E+001,
      -6.6224962429210734E+001,
      -6.6193397758691788E+001,
      -6.6161904409735925E+001,
      -6.6130483625646647E+001,
      -6.6099136646862689E+001,
      -6.6067864710909092E+001,
      -6.6036669052348387E+001,
      -6.6005550902731756E+001,
      -6.5974511490550398E+001,
      -6.5943552041187232E+001,
      -6.5912673776868260E+001,
      -6.5881877916614513E+001,
      -6.5851165676193816E+001,
      -6.5820538268072809E+001,
      -6.5789996901369179E+001,
      -6.5759542781803717E+001,
      -6.5729177111652959E+001,
      -6.5698901089701565E+001,
      -6.5668715911195036E+001,
      -6.5638622767792540E+001,
      -6.5608622847519840E+001,
      -6.5578717334722441E+001,
      -6.5548907410018728E+001,
      -6.5519194250253577E+001,
      -6.5489579028451558E+001,
      -6.5460062913770997E+001,
      -6.5430647071457528E+001,
      -6.5401332662798239E+001,
      -6.5372120845075798E+001,
      -6.5343012771522709E+001,
      -6.5314009591275962E+001,
      -6.5285112449331365E+001,
      -6.5256322486498632E+001,
      -6.5227640839356226E+001,
      -6.5199068640206420E+001,
      -6.5170607017030761E+001,
      -6.5142257093445380E+001,
      -6.5114019988656679E+001,
      -6.5085896817417222E+001,
      -6.5057888689981723E+001,
      -6.5029996712062996E+001,
      -6.5002221984788633E+001,
      -6.4974565604657315E+001,
      -6.4947028663495544E+001,
      -6.4919612248414580E+001,
      -6.4892317441767602E+001,
      -6.4865145321106823E+001,
      -6.4838096959141026E+001,
      -6.4811173423693234E+001,
      -6.4784375777658539E+001,
      -6.4757705078962132E+001,
      -6.4731162380517461E+001,
      -6.4704748730184903E+001,
      -6.4678465170730078E+001,
      -6.4652312739782943E+001,
      -6.4626292469796681E+001,
      -6.4600405388006990E+001,
      -6.4574652516391566E+001,
      -6.4549034871629630E+001,
      -6.4523553465062008E+001,
      -6.4498209302650892E+001,
      -6.4473003384940526E+001,
      -6.4447936707017334E+001,
      -6.4423010258470839E+001,
      -6.4398225023354556E+001,
      -6.4373581980147108E+001,
      -6.4349082101713677E+001,
      -6.4324726355267472E+001,
      -6.4300515702331737E+001,
      -6.4276451098701486E+001,
      -6.4252533494406151E+001,
      -6.4228763833671749E+001,
      -6.4205143054883806E+001,
      -6.4181672090550251E+001,
      -6.4158351867264500E+001,
      -6.4135183305669102E+001,
      -6.4112167320419147E+001,
      -6.4089304820146353E+001,
      -6.4066596707423088E+001,
      -6.4044043878726740E+001,
      -6.4021647224404362E+001,
      -6.3999407628637542E+001,
      -6.3977325969407460E+001,
      -6.3955403118460161E+001,
      -6.3933639941272297E+001,
      -6.3912037297016802E+001,
      -6.3890596038529139E+001,
      -6.3869317012273434E+001,
      -6.3848201058309222E+001,
      -6.3827249010258207E+001,
      -6.3806461695271373E+001,
      -6.3785839933996328E+001,
      -6.3765384540544893E+001,
      -6.3745096322460967E+001,
      -6.3724976080688663E+001,
      -6.3705024609540700E+001,
      -6.3685242696666954E+001,
      -6.3665631123023502E+001,
      -6.3646190662841690E+001,
      -6.3626922083597591E+001,
      -6.3607826145981740E+001,
      -6.3588903603869007E+001,
      -6.3570155204289009E+001,
      -6.3551581687396428E+001,
      -6.3533183786441917E+001,
      -6.3514962227743105E+001,
      -6.3496917730655937E+001,
      -6.3479051007546232E+001,
      -6.3461362763761663E+001,
      -6.3443853697603764E+001,
      -6.3426524500300530E+001,
      -6.3409375855978979E+001,
      -6.3392408441638224E+001,
      -6.3375622927122727E+001,
      -6.3359019975095869E+001,
      -6.3342600241013770E+001,
      -6.3326364373099402E+001,
      -6.3310313012317032E+001,
      -6.3294446792346925E+001,
      -6.3278766339560256E+001,
      -6.3263272272994435E+001,
      -6.3247965204328715E+001,
      -6.3232845737859947E+001,
      -6.3217914470478746E+001,
      -6.3203171991646030E+001,
      -6.3188618883369593E+001,
      -6.3174255720181236E+001,
      -6.3160083069114059E+001,
      -6.3146101489680028E+001,
      -6.3132311533847997E+001,
      -6.3118713746021783E+001,
      -6.3105308663018782E+001,
      -6.3092096814048702E+001,
      -6.3079078720692735E+001,
      -6.3066254896882910E+001,
      -6.3053625848881822E+001,
      -6.3041192075262671E+001,
      -6.3028954066889554E+001,
      -6.3016912306898085E+001,
      -6.3005067270676321E+001,
      -6.2993419425846021E+001,
      -6.2981969232244147E+001,
      -6.2970717141904728E+001,
      -6.2959663599041050E+001,
      -6.2948809040028053E+001,
      -6.2938153893385106E+001,
      -6.2927698579759188E+001,
      -6.2917443511908182E+001,
      -6.2907389094684589E+001,
      -6.2897535725019580E+001,
      -6.2887883791907328E+001,
      -6.2878433676389655E+001,
      -6.2869185751540890E+001,
      -6.2860140382453288E+001,
      -6.2851297926222550E+001,
      -6.2842658731933696E+001,
      -6.2834223140647318E+001,
      -6.2825991485386112E+001,
      -6.2817964091121752E+001,
      -6.2810141274762003E+001,
      -6.2802523345138269E+001,
      -6.2795110602993361E+001,
      -6.2787903340969649E+001,
      -6.2780901843597498E+001,
      -6.2774106387284036E+001,
      -6.2767517240302233E+001,
      -6.2761134662780336E+001,
      -6.2754958906691591E+001,
      -6.2748990215844245E+001,
      -6.2743228825872016E+001,
      -6.2737674964224709E+001,
      -6.2732328850159270E+001,
      -6.2727190694731135E+001,
      -6.2722260700785874E+001,
      -6.2717539062951204E+001,
      -6.2713025967629306E+001,
      -6.2708721592989463E+001,
      -6.2704626108961001E+001,
      -6.2700739677226629E+001,
      -6.2697062451216020E+001,
      -6.2693594576099748E+001,
      -6.2690336188783576E+001,
      -6.2687287417903086E+001,
      -6.2684448383818520E+001,
      -6.2681819198610071E+001,
      -6.2679399966073476E+001,
      -6.2677190781715893E+001,
      -6.2675191732752154E+001,
      -6.2673402898101259E+001,
      -6.2671824348383353E+001,
      -6.2670456145916873E+001,
      -6.2669298344716111E+001,
      -6.2668350990489074E+001,
      -6.2667614120635704E+001,
      -6.2667087764246325E+001,
      -6.2666771942100617E+001,
      -6.2666666666666671E+001,
      -6.2666771942100617E+001,
      -6.2667087764246325E+001,
      -6.2667614120635704E+001,
      -6.2668350990489074E+001,
      -6.2669298344716111E+001,
      -6.2670456145916873E+001,
      -6.2671824348383353E+001,
      -6.2673402898101259E+001,
      -6.2675191732752154E+001,
      -6.2677190781715893E+001,
      -6.2679399966073476E+001,
      -6.2681819198610071E+001,
      -6.2684448383818520E+001,
      -6.2687287417903086E+001,
      -6.2690336188783576E+001,
      -6.2693594576099748E+001,
      -6.2697062451216020E+001,
      -6.2700739677226629E+001,
      -6.2704626108961001E+001,
      -6.2708721592989463E+001,
      -6.2713025967629306E+001,
      -6.2717539062951204E+001,
      -6.2722260700785874E+001,
      -6.2727190694731135E+001,
      -6.2732328850159270E+001,
      -6.2737674964224709E+001,
      -6.2743228825872016E+001,
      -6.2748990215844245E+001,
      -6.2754958906691577E+001,
      -6.2761134662780336E+001,
      -6.2767517240302233E+001,
      -6.2774106387284036E+001,
      -6.2780901843597498E+001,
      -6.2787903340969649E+001,
      -6.2795110602993361E+001,
      -6.2802523345138269E+001,
      -6.2810141274762003E+001,
      -6.2817964091121752E+001,
      -6.2825991485386112E+001,
      -6.2834223140647318E+001,
      -6.2842658731933682E+001,
      -6.2851297926222550E+001,
      -6.2860140382453288E+001,
      -6.2869185751540890E+001,
      -6.2878433676389641E+001,
      -6.2887883791907349E+001,
      -6.2897535725019580E+001,
      -6.2907389094684589E+001,
      -6.2917443511908168E+001,
      -6.2927698579759188E+001,
      -6.2938153893385106E+001,
      -6.2948809040028038E+001,
      -6.2959663599041065E+001,
      -6.2970717141904728E+001,
      -6.2981969232244147E+001,
      -6.2993419425846007E+001,
      -6.3005067270676321E+001,
      -6.3016912306898085E+001,
      -6.3028954066889554E+001,
      -6.3041192075262671E+001,
      -6.3053625848881822E+001,
      -6.3066254896882910E+001,
      -6.3079078720692735E+001,
      -6.3092096814048702E+001,
      -6.3105308663018768E+001,
      -6.3118713746021783E+001,
      -6.3132311533847997E+001,
      -6.3146101489680028E+001,
      -6.3160083069114059E+001,
      -6.3174255720181236E+001,
      -6.3188618883369607E+001,
      -6.3203171991646030E+001,
      -6.3217914470478760E+001,
      -6.3232845737859947E+001,
      -6.3247965204328715E+001,
      -6.3263272272994435E+001,
      -6.3278766339560256E+001,
      -6.3294446792346925E+001,
      -6.3310313012317046E+001,
      -6.3326364373099416E+001,
      -6.3342600241013770E+001,
      -6.3359019975095869E+001,
      -6.3375622927122727E+001,
      -6.3392408441638224E+001,
      -6.3409375855978965E+001,
      -6.3426524500300530E+001,
      -6.3443853697603778E+001,
      -6.3461362763761649E+001,
      -6.3479051007546246E+001,
      -6.3496917730655923E+001,
      -6.3514962227743105E+001,
      -6.3533183786441917E+001,
      -6.3551581687396428E+001,
      -6.3570155204289023E+001,
      -6.3588903603869007E+001,
      -6.3607826145981740E+001,
      -6.3626922083597591E+001,
      -6.3646190662841704E+001,
      -6.3665631123023502E+001,
      -6.3685242696666954E+001,
      -6.3705024609540686E+001,
      -6.3724976080688663E+001,
      -6.3745096322460981E+001,
      -6.3765384540544879E+001,
      -6.3785839933996343E+001,
      -6.3806461695271373E+001,
      -6.3827249010258221E+001,
      -6.3848201058309222E+001,
      -6.3869317012273434E+001,
      -6.3890596038529154E+001,
      -6.3912037297016816E+001,
      -6.3933639941272283E+001,
      -6.3955403118460161E+001,
      -6.3977325969407438E+001,
      -6.3999407628637556E+001,
      -6.4021647224404376E+001,
      -6.4044043878726725E+001,
      -6.4066596707423088E+001,
      -6.4089304820146353E+001,
      -6.4112167320419147E+001,
      -6.4135183305669074E+001,
      -6.4158351867264500E+001,
      -6.4181672090550265E+001,
      -6.4205143054883820E+001,
      -6.4228763833671778E+001,
      -6.4252533494406137E+001,
      -6.4276451098701500E+001,
      -6.4300515702331708E+001,
      -6.4324726355267487E+001,
      -6.4349082101713662E+001,
      -6.4373581980147108E+001,
      -6.4398225023354556E+001,
      -6.4423010258470839E+001,
      -6.4447936707017348E+001,
      -6.4473003384940526E+001,
      -6.4498209302650906E+001,
      -6.4523553465061980E+001,
      -6.4549034871629644E+001,
      -6.4574652516391581E+001,
      -6.4600405388007005E+001,
      -6.4626292469796681E+001,
      -6.4652312739782928E+001,
      -6.4678465170730092E+001,
      -6.4704748730184889E+001,
      -6.4731162380517475E+001,
      -6.4757705078962104E+001,
      -6.4784375777658553E+001,
      -6.4811173423693262E+001,
      -6.4838096959141026E+001,
      -6.4865145321106795E+001,
      -6.4892317441767602E+001,
      -6.4919612248414595E+001,
      -6.4947028663495516E+001,
      -6.4974565604657315E+001,
      -6.5002221984788633E+001,
      -6.5029996712063010E+001,
      -6.5057888689981695E+001,
      -6.5085896817417236E+001,
      -6.5114019988656693E+001,
      -6.5142257093445366E+001,
      -6.5170607017030775E+001,
      -6.5199068640206420E+001,
      -6.5227640839356241E+001,
      -6.5256322486498632E+001,
      -6.5285112449331365E+001,
      -6.5314009591275934E+001,
      -6.5343012771522723E+001,
      -6.5372120845075813E+001,
      -6.5401332662798239E+001,
      -6.5430647071457528E+001,
      -6.5460062913770983E+001,
      -6.5489579028451573E+001,
      -6.5519194250253548E+001,
      -6.5548907410018742E+001,
      -6.5578717334722455E+001,
      -6.5608622847519840E+001,
      -6.5638622767792555E+001,
      -6.5668715911195036E+001,
      -6.5698901089701579E+001,
      -6.5729177111652959E+001,
      -6.5759542781803731E+001,
      -6.5789996901369150E+001,
      -6.5820538268072823E+001,
      -6.5851165676193830E+001,
      -6.5881877916614513E+001,
      -6.5912673776868246E+001,
      -6.5943552041187232E+001,
      -6.5974511490550427E+001,
      -6.6005550902731727E+001,
      -6.6036669052348401E+001,
      -6.6067864710909120E+001,
      -6.6099136646862675E+001,
      -6.6130483625646619E+001,
      -6.6161904409735911E+001,
      -6.6193397758691802E+001,
      -6.6224962429210734E+001,
      -6.6256597175173667E+001,
      -6.6288300747694876E+001,
      -6.6320071895171736E+001,
      -6.6351909363333618E+001,
      -6.6383811895291885E+001,
      -6.6415778231589144E+001,
      -6.6447807110249229E+001,
      -6.6479897266826811E+001,
      -6.6512047434457443E+001,
      -6.6544256343907620E+001,
      -6.6576522723624663E+001,
      -6.6608845299787234E+001,
      -6.6641222796355294E+001,
      -6.6673653935120782E+001,
      -6.6706137435757853E+001,
      -6.6738672015873476E+001,
      -6.6771256391058202E+001,
      -6.6803889274936623E+001,
      -6.6836569379218417E+001,
      -6.6869295413749043E+001,
      -6.6902066086560637E+001,
      -6.6934880103923149E+001,
      -6.6967736170395412E+001,
      -6.7000632988876148E+001,
      -6.7033569260655270E+001,
      -6.7066543685465177E+001,
      -6.7099554961532078E+001,
      -6.7132601785627301E+001,
      -6.7165682853118753E+001,
      -6.7198796858022632E+001,
      -6.7231942493054675E+001,
      -6.7265118449681950E+001,
      -6.7298323418174490E+001,
      -6.7331556087657049E+001,
      -6.7364815146160666E+001,
      -6.7398099280674757E+001,
      -6.7431407177198636E+001,
      -6.7464737520793520E+001,
      -6.7498088995634603E+001,
      -6.7531460285062693E+001,
      -6.7564850071636499E+001,
      -6.7598257037184339E+001,
      -6.7631679862856501E+001,
      -6.7665117229177014E+001,
      -6.7698567816095874E+001,
      -6.7732030303041242E+001,
      -6.7765503368971380E+001,
      -6.7798985692427024E+001,
      -6.7832475951583319E+001,
      -6.7865972824302204E+001,
      -6.7899474988184480E+001,
      -6.7932981120622131E+001,
      -6.7966489898850384E+001,
      -68.0,
      -6.8033510101149659E+001,
      -6.8067018879377883E+001,
      -6.8100525011815520E+001,
      -6.8134027175697796E+001,
      -6.8167524048416695E+001,
      -6.8201014307573004E+001,
      -6.8234496631028605E+001,
      -6.8267969696958758E+001,
      -6.8301432183904140E+001,
      -6.8334882770823015E+001,
      -6.8368320137143499E+001,
      -6.8401742962815646E+001,
      -6.8435149928363501E+001,
      -6.8468539714937307E+001,
      -6.8501911004365397E+001,
      -6.8535262479206494E+001,
      -6.8568592822801378E+001,
      -6.8601900719325229E+001,
      -6.8635184853839320E+001,
      -6.8668443912342951E+001,
      -6.8701676581825524E+001,
      -6.8734881550318065E+001,
      -6.8768057506945354E+001,
      -6.8801203141977354E+001,
      -6.8834317146881233E+001,
      -6.8867398214372741E+001,
      -6.8900445038467907E+001,
      -6.8933456314534823E+001,
      -6.8966430739344716E+001,
      -6.8999367011123880E+001,
      -6.9032263829604574E+001,
      -6.9065119896076851E+001,
      -6.9097933913439348E+001,
      -6.9130704586250957E+001,
      -6.9163430620781583E+001,
      -6.9196110725063363E+001,
      -6.9228743608941798E+001,
      -6.9261327984126524E+001,
      -6.9293862564242190E+001,
      -6.9326346064879218E+001,
      -6.9358777203644721E+001,
      -6.9391154700212809E+001,
      -6.9423477276375337E+001,
      -6.9455743656092380E+001,
      -6.9487952565542557E+001,
      -6.9520102733173232E+001,
      -6.9552192889750785E+001,
      -6.9584221768410870E+001,
      -6.9616188104708129E+001,
      -6.9648090636666382E+001,
      -6.9679928104828278E+001,
      -6.9711699252305124E+001,
      -6.9743402824826347E+001,
      -6.9775037570789266E+001,
      -6.9806602241308241E+001,
      -6.9838095590264089E+001,
      -6.9869516374353395E+001,
      -6.9900863353137325E+001,
      -6.9932135289090908E+001,
      -6.9963330947651613E+001,
      -6.9994449097268273E+001,
      -7.0025488509449630E+001,
      -7.0056447958812782E+001,
      -7.0087326223131768E+001,
      -7.0118122083385501E+001,
      -7.0148834323806213E+001,
      -7.0179461731927191E+001,
      -7.0210003098630850E+001,
      -7.0240457218196283E+001,
      -7.0270822888347055E+001,
      -7.0301098910298464E+001,
      -7.0331284088804978E+001,
      -7.0361377232207460E+001,
      -7.0391377152480175E+001,
      -7.0421282665277602E+001,
      -7.0451092589981272E+001,
      -7.0480805749746452E+001,
      -7.0510420971548470E+001,
      -7.0539937086229017E+001,
      -7.0569352928542472E+001,
      -7.0598667337201775E+001,
      -7.0627879154924230E+001,
      -7.0656987228477291E+001,
      -7.0685990408724081E+001,
      -7.0714887550668635E+001,
      -7.0743677513501382E+001,
      -7.0772359160643774E+001,
      -7.0800931359793580E+001,
      -7.0829392982969239E+001,
      -7.0857742906554648E+001,
      -7.0885980011343349E+001,
      -7.0914103182582778E+001,
      -7.0942111310018305E+001,
      -7.0970003287937004E+001,
      -7.0997778015211381E+001,
      -7.1025434395342685E+001,
      -7.1052971336504484E+001,
      -7.1080387751585448E+001,
      -7.1107682558232412E+001,
      -7.1134854678893205E+001,
      -7.1161903040858988E+001,
      -7.1188826576306781E+001,
      -7.1215624222341461E+001,
      -7.1242294921037896E+001,
      -7.1268837619482539E+001,
      -7.1295251269815125E+001,
      -7.1321534829269950E+001,
      -7.1347687260217072E+001,
      -7.1373707530203319E+001,
      -7.1399594611993010E+001,
      -7.1425347483608462E+001,
      -7.1450965128370370E+001,
      -7.1476446534938020E+001,
      -7.1501790697349094E+001,
      -7.1526996615059488E+001,
      -7.1552063292982666E+001,
      -7.1576989741529175E+001,
      -7.1601774976645473E+001,
      -7.1626418019852892E+001,
      -7.1650917898286352E+001,
      -7.1675273644732528E+001,
      -7.1699484297668292E+001,
      -7.1723548901298514E+001,
      -7.1747466505593863E+001,
      -7.1771236166328251E+001,
      -7.1794856945116194E+001,
      -7.1818327909449792E+001,
      -7.1841648132735500E+001,
      -7.1864816694330926E+001,
      -7.1887832679580868E+001,
      -7.1910695179853661E+001,
      -7.1933403292576912E+001,
      -7.1955956121273289E+001,
      -7.1978352775595638E+001,
      -7.2000592371362458E+001,
      -7.2022674030592569E+001,
      -7.2044596881539846E+001,
      -7.2066360058727739E+001,
      -7.2087962702983205E+001,
      -7.2109403961470875E+001,
      -7.2130682987726587E+001,
      -7.2151798941690799E+001,
      -7.2172750989741829E+001,
      -7.2193538304728648E+001,
      -7.2214160066003672E+001,
      -7.2234615459455114E+001,
      -7.2254903677539048E+001,
      -7.2275023919311337E+001,
      -7.2294975390459328E+001,
      -7.2314757303333039E+001,
      -7.2334368876976512E+001,
      -7.2353809337158310E+001,
      -7.2373077916402423E+001,
      -7.2392173854018282E+001,
      -7.2411096396131001E+001,
      -7.2429844795711006E+001,
      -7.2448418312603579E+001,
      -7.2466816213558104E+001,
      -7.2485037772256888E+001,
      -7.2503082269344077E+001,
      -7.2520948992453768E+001,
      -7.2538637236238358E+001,
      -7.2556146302396257E+001,
      -7.2573475499699484E+001,
      -7.2590624144021035E+001,
      -7.2607591558361790E+001,
      -7.2624377072877294E+001,
      -7.2640980024904124E+001,
      -7.2657399758986244E+001,
      -7.2673635626900605E+001,
      -7.2689686987682975E+001,
      -7.2705553207653097E+001,
      -7.2721233660439765E+001,
      -7.2736727727005572E+001,
      -7.2752034795671292E+001,
      -7.2767154262140082E+001,
      -7.2782085529521254E+001,
      -7.2796828008353984E+001,
      -7.2811381116630429E+001,
      -7.2825744279818778E+001,
      -7.2839916930885963E+001,
      -7.2853898510319979E+001,
      -7.2867688466152018E+001,
      -7.2881286253978232E+001,
      -7.2894691336981239E+001,
      -7.2907903185951298E+001,
      -7.2920921279307279E+001,
      -7.2933745103117104E+001,
      -7.2946374151118192E+001,
      -7.2958807924737343E+001,
      -7.2971045933110460E+001,
      -7.2983087693101950E+001,
      -7.2994932729323693E+001,
      -7.3006580574154000E+001,
      -7.3018030767755874E+001,
      -7.3029282858095286E+001,
      -7.3040336400958950E+001,
      -7.3051190959971976E+001,
      -7.3061846106614922E+001,
      -7.3072301420240819E+001,
      -7.3082556488091839E+001,
      -7.3092610905315425E+001,
      -7.3102464274980434E+001,
      -7.3112116208092672E+001,
      -7.3121566323610367E+001,
      -7.3130814248459131E+001,
      -7.3139859617546719E+001,
      -7.3148702073777457E+001,
      -7.3157341268066318E+001,
      -7.3165776859352704E+001,
      -7.3174008514613902E+001,
      -7.3182035908878262E+001,
      -7.3189858725238011E+001,
      -7.3197476654861745E+001,
      -7.3204889397006653E+001,
      -7.3212096659030365E+001,
      -7.3219098156402538E+001,
      -7.3225893612715979E+001,
      -7.3232482759697788E+001,
      -7.3238865337219679E+001,
      -7.3245041093308444E+001,
      -7.3251009784155769E+001,
      -7.3256771174128005E+001,
      -7.3262325035775305E+001,
      -7.3267671149840737E+001,
      -7.3272809305268879E+001,
      -7.3277739299214133E+001,
      -7.3282460937048810E+001,
      -7.3286974032370708E+001,
      -7.3291278407010552E+001,
      -7.3295373891039006E+001,
      -7.3299260322773392E+001,
      -7.3302937548784001E+001,
      -7.3306405423900273E+001,
      -7.3309663811216438E+001,
      -7.3312712582096935E+001,
      -7.3315551616181494E+001,
      -7.3318180801389943E+001,
      -7.3320600033926539E+001,
      -7.3322809218284121E+001,
      -7.3324808267247860E+001,
      -7.3326597101898756E+001,
      -7.3328175651616661E+001,
      -7.3329543854083141E+001,
      -7.3330701655283903E+001,
      -7.3331649009510940E+001,
      -7.3332385879364310E+001,
      -7.3332912235753696E+001,
      -7.3333228057899404E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333333333333343E+001,
      -7.3333133333333350E+001,
      -7.3332533333333345E+001,
      -7.3331533333333340E+001,
      -7.3330133333333336E+001,
      -7.3328333333333333E+001,
      -7.3326133333333345E+001,
      -7.3323533333333344E+001,
      -7.3320533333333344E+001,
      -7.3317133333333345E+001,
      -7.3313333333333347E+001,
      -7.3309133333333349E+001,
      -7.3304533333333339E+001,
      -7.3299533333333343E+001,
      -7.3294133333333335E+001,
      -7.3288333333333341E+001,
      -7.3282133333333334E+001,
      -7.3275533333333343E+001,
      -7.3268533333333338E+001,
      -7.3261133333333348E+001,
      -7.3253333333333330E+001,
      -7.3245133333333342E+001,
      -7.3236533333333341E+001,
      -7.3227533333333341E+001,
      -7.3218133333333341E+001,
      -7.3208333333333343E+001,
      -7.3198133333333345E+001,
      -7.3187533333333349E+001,
      -7.3176533333333353E+001,
      -7.3165133333333344E+001,
      -7.3153333333333350E+001,
      -7.3141133333333343E+001,
      -7.3128533333333351E+001,
      -7.3115533333333346E+001,
      -7.3102133333333342E+001,
      -7.3088333333333338E+001,
      -7.3074133333333350E+001,
      -7.3059533333333334E+001,
      -7.3044533333333348E+001,
      -7.3029133333333334E+001,
      -7.3013333333333350E+001,
      -7.2997133333333352E+001,
      -7.2980533333333341E+001,
      -7.2963533333333345E+001,
      -7.2946133333333336E+001,
      -7.2928333333333342E+001,
      -7.2910133333333334E+001,
      -7.2891533333333342E+001,
      -7.2872533333333337E+001,
      -7.2853133333333332E+001,
      -7.2833333333333343E+001,
      -7.2813133333333340E+001,
      -7.2792533333333353E+001,
      -7.2771533333333338E+001,
      -7.2750133333333338E+001,
      -7.2728333333333339E+001,
      -7.2706133333333341E+001,
      -7.2683533333333344E+001,
      -7.2660533333333348E+001,
      -7.2637133333333338E+001,
      -7.2613333333333344E+001,
      -7.2589133333333336E+001,
      -7.2564533333333330E+001,
      -7.2539533333333353E+001,
      -7.2514133333333334E+001,
      -7.2488333333333344E+001,
      -7.2462133333333341E+001,
      -7.2435533333333353E+001,
      -7.2408533333333338E+001,
      -7.2381133333333338E+001,
      -7.2353333333333353E+001,
      -7.2325133333333341E+001,
      -7.2296533333333343E+001,
      -7.2267533333333347E+001,
      -7.2238133333333337E+001,
      -7.2208333333333343E+001,
      -7.2178133333333335E+001,
      -7.2147533333333342E+001,
      -7.2116533333333351E+001,
      -7.2085133333333346E+001,
      -7.2053333333333342E+001,
      -7.2021133333333353E+001,
      -7.1988533333333336E+001,
      -7.1955533333333349E+001,
      -7.1922133333333335E+001,
      -7.1888333333333335E+001,
      -7.1854133333333337E+001,
      -7.1819533333333339E+001,
      -7.1784533333333343E+001,
      -7.1749133333333347E+001,
      -7.1713333333333338E+001,
      -7.1677133333333344E+001,
      -7.1640533333333337E+001,
      -7.1603533333333345E+001,
      -7.1566133333333340E+001,
      -7.1528333333333350E+001,
      -7.1490133333333347E+001,
      -7.1451533333333344E+001,
      -7.1412533333333343E+001,
      -7.1373133333333342E+001,
      -7.1333333333333343E+001,
      -7.1293333333333351E+001,
      -7.1253333333333345E+001,
      -7.1213333333333338E+001,
      -7.1173333333333346E+001,
      -7.1133333333333354E+001,
      -7.1093333333333334E+001,
      -7.1053333333333342E+001,
      -7.1013333333333350E+001,
      -7.0973333333333329E+001,
      -7.0933333333333337E+001,
      -7.0893333333333345E+001,
      -7.0853333333333353E+001,
      -7.0813333333333333E+001,
      -7.0773333333333341E+001,
      -7.0733333333333348E+001,
      -7.0693333333333342E+001,
      -7.0653333333333336E+001,
      -7.0613333333333344E+001,
      -7.0573333333333338E+001,
      -7.0533333333333346E+001,
      -7.0493333333333339E+001,
      -7.0453333333333347E+001,
      -7.0413333333333341E+001,
      -7.0373333333333349E+001,
      -7.0333333333333343E+001,
      -7.0293333333333337E+001,
      -7.0253333333333345E+001,
      -7.0213333333333338E+001,
      -7.0173333333333332E+001,
      -7.0133333333333340E+001,
      -7.0093333333333348E+001,
      -7.0053333333333342E+001,
      -7.0013333333333335E+001,
      -6.9973333333333343E+001,
      -6.9933333333333351E+001,
      -6.9893333333333331E+001,
      -6.9853333333333339E+001,
      -6.9813333333333347E+001,
      -6.9773333333333355E+001,
      -6.9733333333333334E+001,
      -6.9693333333333342E+001,
      -6.9653333333333350E+001,
      -6.9613333333333344E+001,
      -6.9573333333333338E+001,
      -6.9533333333333346E+001,
      -6.9493333333333339E+001,
      -6.9453333333333333E+001,
      -6.9413333333333341E+001,
      -6.9373333333333349E+001,
      -6.9333333333333343E+001,
      -6.9293333333333337E+001,
      -6.9253333333333345E+001,
      -6.9213333333333338E+001,
      -6.9173333333333346E+001,
      -6.9133333333333340E+001,
      -6.9093333333333334E+001,
      -6.9053333333333342E+001,
      -6.9013333333333350E+001,
      -6.8973333333333343E+001,
      -6.8933333333333337E+001,
      -6.8893333333333345E+001,
      -6.8853333333333353E+001,
      -6.8813333333333333E+001,
      -6.8773333333333341E+001,
      -6.8733333333333348E+001,
      -6.8693333333333356E+001,
      -6.8653333333333336E+001,
      -6.8613333333333344E+001,
      -6.8573333333333352E+001,
      -6.8533333333333331E+001,
      -6.8493333333333339E+001,
      -6.8453333333333347E+001,
      -6.8413333333333341E+001,
      -6.8373333333333335E+001,
      -6.8333333333333343E+001,
      -6.8293333333333337E+001,
      -6.8253333333333345E+001,
      -6.8213333333333338E+001,
      -6.8173333333333346E+001,
      -6.8133333333333340E+001,
      -6.8093333333333348E+001,
      -6.8053333333333342E+001,
      -6.8013333333333335E+001,
      -6.7973333333333343E+001,
      -6.7933333333333351E+001,
      -6.7893333333333345E+001,
      -6.7853333333333339E+001,
      -6.7813333333333347E+001,
      -6.7773333333333341E+001,
      -6.7733333333333334E+001,
      -6.7693333333333342E+001,
      -6.7653333333333350E+001,
      -6.7613333333333344E+001,
      -6.7573333333333338E+001,
      -6.7533333333333346E+001,
      -6.7493333333333354E+001,
      -6.7453333333333333E+001,
      -6.7413333333333341E+001,
      -6.7373333333333349E+001,
      -6.7333333333333343E+001,
      -6.7293333333333337E+001,
      -6.7253333333333345E+001,
      -6.7213333333333338E+001,
      -6.7173333333333346E+001,
      -6.7133333333333340E+001,
      -6.7093333333333348E+001,
      -6.7053333333333342E+001,
      -6.7013333333333335E+001,
      -6.6973333333333343E+001,
      -6.6933333333333337E+001,
      -6.6893333333333345E+001,
      -6.6853333333333339E+001,
      -6.6813333333333347E+001,
      -6.6773333333333341E+001,
      -6.6733333333333348E+001,
      -6.6693333333333342E+001,
      -6.6653333333333350E+001,
      -6.6613333333333344E+001,
      -6.6573333333333338E+001,
      -6.6533333333333346E+001,
      -6.6493333333333339E+001,
      -6.6453333333333347E+001,
      -6.6413333333333341E+001,
      -6.6373333333333335E+001,
      -6.6333333333333343E+001,
      -6.6293333333333337E+001,
      -6.6253333333333345E+001,
      -6.6213333333333338E+001,
      -6.6173333333333346E+001,
      -6.6133333333333340E+001,
      -6.6093333333333334E+001,
      -6.6053333333333342E+001,
      -6.6013333333333335E+001,
      -6.5973333333333343E+001,
      -6.5933333333333337E+001,
      -6.5893333333333345E+001,
      -6.5853333333333339E+001,
      -6.5813333333333347E+001,
      -6.5773333333333341E+001,
      -6.5733333333333348E+001,
      -6.5693333333333342E+001,
      -6.5653333333333350E+001,
      -6.5613333333333344E+001,
      -6.5573333333333338E+001,
      -6.5533333333333346E+001,
      -6.5493333333333339E+001,
      -6.5453333333333347E+001,
      -6.5413333333333341E+001,
      -6.5373333333333349E+001,
      -6.5333333333333343E+001,
      -6.5293333333333337E+001,
      -6.5253333333333345E+001,
      -6.5213333333333338E+001,
      -6.5173333333333346E+001,
      -6.5133333333333340E+001,
      -6.5093333333333334E+001,
      -6.5053333333333342E+001,
      -6.5013333333333335E+001,
      -6.4973333333333343E+001,
      -6.4933333333333337E+001,
      -6.4893333333333345E+001,
      -6.4853333333333339E+001,
      -6.4813333333333347E+001,
      -6.4773333333333341E+001,
      -6.4733333333333348E+001,
      -6.4693333333333342E+001,
      -6.4653333333333336E+001,
      -6.4613333333333344E+001,
      -6.4573333333333338E+001,
      -6.4533333333333346E+001,
      -6.4493333333333339E+001,
      -6.4453333333333347E+001,
      -6.4413333333333341E+001,
      -6.4373333333333335E+001,
      -6.4333333333333343E+001,
      -6.4293333333333351E+001,
      -6.4253333333333345E+001,
      -6.4213333333333338E+001,
      -6.4173333333333346E+001,
      -6.4133333333333340E+001,
      -6.4093333333333334E+001,
      -6.4053333333333342E+001,
      -6.4013333333333350E+001,
      -6.3973333333333343E+001,
      -6.3933333333333337E+001,
      -6.3893333333333345E+001,
      -6.3853333333333339E+001,
      -6.3813333333333340E+001,
      -6.3773333333333341E+001,
      -6.3733333333333341E+001,
      -6.3693333333333335E+001,
      -6.3653333333333343E+001,
      -6.3613333333333344E+001,
      -6.3573333333333345E+001,
      -6.3533333333333339E+001,
      -6.3493333333333347E+001,
      -6.3453333333333340E+001,
      -6.3413333333333341E+001,
      -6.3373333333333342E+001,
      -6.3333333333333343E+001,
      -6.3293333333333337E+001,
      -6.3253333333333345E+001,
      -6.3213333333333345E+001,
      -6.3173333333333346E+001,
      -6.3133333333333340E+001,
      -6.3093333333333341E+001,
      -6.3053333333333342E+001,
      -6.3013333333333335E+001,
      -6.2973333333333343E+001,
      -6.2933333333333337E+001,
      -6.2893333333333345E+001,
      -6.2853333333333339E+001,
      -6.2813333333333347E+001,
      -6.2773333333333341E+001,
      -6.2733333333333341E+001,
      -6.2693333333333342E+001,
      -6.2653333333333343E+001,
      -6.2613333333333337E+001,
      -6.2573333333333345E+001,
      -6.2533333333333339E+001,
      -6.2493333333333347E+001,
      -6.2453333333333340E+001,
      -6.2413333333333348E+001,
      -6.2373333333333342E+001,
      -6.2333333333333336E+001,
      -6.2293333333333344E+001,
      -6.2253333333333337E+001,
      -6.2213333333333338E+001,
      -6.2173333333333339E+001,
      -6.2133333333333340E+001,
      -6.2093333333333341E+001,
      -6.2053333333333342E+001,
      -6.2013333333333343E+001,
      -6.1973333333333343E+001,
      -6.1933333333333337E+001,
      -6.1893333333333345E+001,
      -6.1853333333333339E+001,
      -6.1813333333333340E+001,
      -6.1773333333333341E+001,
      -6.1733333333333348E+001,
      -6.1693333333333342E+001,
      -6.1653333333333343E+001,
      -6.1613333333333344E+001,
      -6.1573333333333345E+001,
      -6.1533333333333339E+001,
      -6.1493333333333339E+001,
      -6.1453333333333340E+001,
      -6.1413333333333341E+001,
      -6.1373333333333342E+001,
      -6.1333333333333343E+001,
      -6.1293333333333344E+001,
      -6.1253333333333337E+001,
      -6.1213333333333345E+001,
      -6.1173333333333339E+001,
      -6.1133333333333340E+001,
      -6.1093333333333341E+001,
      -6.1053333333333342E+001,
      -6.1013333333333343E+001,
      -6.0973333333333343E+001,
      -6.0933333333333344E+001,
      -6.0893333333333345E+001,
      -6.0853333333333339E+001,
      -6.0813333333333347E+001,
      -6.0773333333333341E+001,
      -6.0733333333333334E+001,
      -6.0693333333333342E+001,
      -6.0653333333333336E+001,
      -6.0613333333333344E+001,
      -6.0573333333333338E+001,
      -6.0533333333333346E+001,
      -6.0493333333333339E+001,
      -6.0453333333333340E+001,
      -6.0413333333333341E+001,
      -6.0373333333333342E+001,
      -6.0333333333333336E+001,
      -6.0293333333333344E+001,
      -6.0253333333333337E+001,
      -6.0213333333333345E+001,
      -6.0173333333333339E+001,
      -6.0133333333333347E+001,
      -6.0093333333333341E+001,
      -6.0053333333333342E+001,
      -6.0013333333333343E+001,
      -5.9973333333333343E+001,
      -5.9933333333333337E+001,
      -5.9893333333333338E+001,
      -5.9853333333333339E+001,
      -5.9813333333333340E+001,
      -5.9773333333333341E+001,
      -5.9733333333333341E+001,
      -5.9693333333333342E+001,
      -5.9653333333333336E+001,
      -5.9613333333333344E+001,
      -5.9573333333333345E+001,
      -5.9533333333333346E+001,
      -5.9493333333333339E+001,
      -5.9453333333333347E+001,
      -5.9413333333333341E+001,
      -5.9373333333333342E+001,
      -5.9333333333333343E+001,
      -5.9293333333333344E+001,
      -5.9253333333333337E+001,
      -5.9213333333333345E+001,
      -5.9173333333333346E+001,
      -5.9133333333333347E+001,
      -5.9093333333333341E+001,
      -5.9053333333333342E+001,
      -5.9013333333333343E+001,
      -5.8973333333333336E+001,
      -5.8933333333333344E+001,
      -5.8893333333333338E+001,
      -5.8853333333333339E+001,
      -5.8813333333333340E+001,
      -5.8773333333333348E+001,
      -5.8733333333333341E+001,
      -5.8693333333333342E+001,
      -5.8653333333333343E+001,
      -5.8613333333333344E+001,
      -5.8573333333333338E+001,
      -5.8533333333333346E+001,
      -5.8493333333333339E+001,
      -5.8453333333333340E+001,
      -5.8413333333333341E+001,
      -5.8373333333333349E+001,
      -5.8333333333333343E+001,
      -5.8293333333333337E+001,
      -5.8253333333333345E+001,
      -5.8213333333333338E+001,
      -5.8173333333333339E+001,
      -5.8133333333333340E+001,
      -5.8093333333333341E+001,
      -5.8053333333333335E+001,
      -5.8013333333333343E+001,
      -5.7973333333333343E+001,
      -5.7933333333333344E+001,
      -5.7893333333333338E+001,
      -5.7853333333333346E+001,
      -5.7813333333333340E+001,
      -5.7773333333333341E+001,
      -5.7733333333333341E+001,
      -5.7693333333333342E+001,
      -5.7653333333333336E+001,
      -5.7613333333333344E+001,
      -5.7573333333333345E+001,
      -5.7533333333333346E+001,
      -5.7493333333333339E+001,
      -5.7453333333333340E+001,
      -5.7413333333333341E+001,
      -5.7373333333333335E+001,
      -5.7333333333333343E+001,
      -5.7293333333333337E+001,
      -5.7253333333333345E+001,
      -5.7213333333333338E+001,
      -5.7173333333333346E+001,
      -5.7133333333333340E+001,
      -5.7093333333333341E+001,
      -5.7053333333333342E+001,
      -5.7013333333333343E+001,
      -5.6973333333333343E+001,
      -5.6933333333333344E+001,
      -5.6893333333333345E+001,
      -5.6853333333333346E+001,
      -5.6813333333333340E+001,
      -5.6773333333333348E+001,
      -5.6733333333333341E+001,
      -5.6693333333333335E+001,
      -5.6653333333333343E+001,
      -5.6613333333333337E+001,
      -5.6573333333333345E+001,
      -5.6533333333333339E+001,
      -5.6493333333333347E+001,
      -5.6453333333333340E+001,
      -5.6413333333333341E+001,
      -5.6373333333333342E+001,
      -5.6333333333333343E+001,
      -5.6293333333333337E+001,
      -5.6253333333333345E+001,
      -5.6213333333333338E+001,
      -5.6173333333333346E+001,
      -5.6133333333333340E+001,
      -5.6093333333333348E+001,
      -5.6053333333333342E+001,
      -5.6013333333333343E+001,
      -5.5973333333333343E+001,
      -5.5933333333333337E+001,
      -5.5893333333333338E+001,
      -5.5853333333333339E+001,
      -5.5813333333333340E+001,
      -5.5773333333333341E+001,
      -5.5733333333333341E+001,
      -5.5693333333333342E+001,
      -5.5653333333333343E+001,
      -5.5613333333333337E+001,
      -5.5573333333333345E+001,
      -5.5533333333333339E+001,
      -5.5493333333333339E+001,
      -5.5453333333333340E+001,
      -5.5413333333333341E+001,
      -5.5373333333333342E+001,
      -5.5333333333333343E+001,
      -5.5293333333333344E+001,
      -5.5253333333333345E+001,
      -5.5213333333333338E+001,
      -5.5173333333333346E+001,
      -5.5133333333333340E+001,
      -5.5093333333333334E+001,
      -5.5053333333333342E+001,
      -5.5013333333333335E+001,
      -5.4973333333333343E+001,
      -5.4933333333333337E+001,
      -5.4893333333333345E+001,
      -5.4853333333333339E+001,
      -5.4813333333333340E+001,
      -5.4773333333333341E+001,
      -5.4733333333333341E+001,
      -5.4693333333333335E+001,
      -5.4653333333333343E+001,
      -5.4613333333333344E+001,
      -5.4573333333333345E+001,
      -5.4533333333333339E+001,
      -5.4493333333333347E+001,
      -5.4453333333333340E+001,
      -5.4413333333333348E+001,
      -5.4373333333333342E+001,
      -5.4333333333333336E+001,
      -5.4293333333333344E+001,
      -5.4253333333333337E+001,
      -5.4213333333333345E+001,
      -5.4173333333333339E+001,
      -5.4133333333333340E+001,
      -5.4093333333333341E+001,
      -5.4053333333333342E+001,
      -5.4013333333333343E+001,
      -5.3973333333333343E+001,
      -5.3933333333333337E+001,
      -5.3893333333333345E+001,
      -5.3853333333333339E+001,
      -5.3813333333333347E+001,
      -5.3773333333333341E+001,
      -5.3733333333333341E+001,
      -5.3693333333333342E+001,
      -5.3653333333333343E+001,
      -5.3613333333333344E+001,
      -5.3573333333333345E+001,
      -5.3533333333333339E+001,
      -5.3493333333333339E+001,
      -5.3453333333333340E+001,
      -5.3413333333333341E+001,
      -5.3373333333333342E+001,
      -5.3333333333333336E+001,
      -5.3293333333333344E+001,
      -5.3253333333333337E+001,
      -5.3213333333333345E+001,
      -5.3173333333333339E+001,
      -5.3133333333333340E+001,
      -5.3093333333333341E+001,
      -5.3053333333333342E+001,
      -5.3013333333333343E+001,
      -5.2973333333333343E+001,
      -5.2933333333333337E+001,
      -5.2893333333333345E+001,
      -5.2853333333333339E+001,
      -5.2813333333333347E+001,
      -5.2773333333333341E+001,
      -5.2733333333333334E+001,
      -5.2693333333333342E+001,
      -5.2653333333333336E+001,
      -5.2613333333333344E+001,
      -5.2573333333333338E+001,
      -5.2533333333333339E+001,
      -5.2493333333333339E+001,
      -5.2453333333333340E+001,
      -5.2413333333333341E+001,
      -5.2373333333333342E+001,
      -5.2333333333333336E+001,
      -5.2293333333333344E+001,
      -5.2253333333333337E+001,
      -5.2213333333333345E+001,
      -5.2173333333333339E+001,
      -5.2133333333333347E+001,
      -5.2093333333333341E+001,
      -5.2053333333333349E+001,
      -5.2013333333333343E+001,
      -5.1973333333333343E+001,
      -5.1933333333333344E+001,
      -5.1893333333333338E+001,
      -5.1853333333333346E+001,
      -5.1813333333333340E+001,
      -5.1773333333333341E+001,
      -5.1733333333333341E+001,
      -5.1693333333333342E+001,
      -5.1653333333333343E+001,
      -5.1613333333333344E+001,
      -5.1573333333333338E+001,
      -5.1533333333333346E+001,
      -5.1493333333333339E+001,
      -5.1453333333333347E+001,
      -5.1413333333333341E+001,
      -5.1373333333333342E+001,
      -5.1333333333333343E+001,
      -5.1293333333333344E+001,
      -5.1253333333333345E+001,
      -5.1213333333333345E+001,
      -5.1173333333333339E+001,
      -5.1133333333333347E+001,
      -5.1093333333333341E+001,
      -5.1053333333333342E+001,
      -5.1013333333333343E+001,
      -5.0973333333333336E+001,
      -5.0933333333333344E+001,
      -5.0893333333333338E+001,
      -5.0853333333333346E+001,
      -5.0813333333333340E+001,
      -5.0773333333333341E+001,
      -5.0733333333333341E+001,
      -5.0693333333333342E+001,
      -5.0653333333333343E+001,
      -5.0613333333333344E+001,
      -5.0573333333333338E+001,
      -5.0533333333333346E+001,
      -5.0493333333333339E+001,
      -5.0453333333333347E+001,
      -5.0413333333333341E+001,
      -5.0373333333333342E+001,
      -5.0333333333333343E+001,
      -5.0293333333333337E+001,
      -5.0253333333333345E+001,
      -5.0213333333333338E+001,
      -5.0173333333333339E+001,
      -5.0133333333333340E+001,
      -5.0093333333333341E+001,
      -5.0053333333333342E+001,
      -5.0013333333333343E+001,
      -4.9973333333333336E+001,
      -4.9933333333333344E+001,
      -4.9893333333333338E+001,
      -4.9853333333333346E+001,
      -4.9813333333333340E+001,
      -4.9773333333333341E+001,
      -4.9733333333333341E+001,
      -4.9693333333333342E+001,
      -4.9653333333333343E+001,
      -4.9613333333333344E+001,
      -4.9573333333333338E+001,
      -4.9533333333333346E+001,
      -4.9493333333333339E+001,
      -4.9453333333333340E+001,
      -4.9413333333333341E+001,
      -4.9373333333333335E+001,
      -4.9333333333333343E+001,
      -4.9293333333333337E+001,
      -4.9253333333333345E+001,
      -4.9213333333333338E+001,
      -4.9173333333333339E+001,
      -4.9133333333333340E+001,
      -4.9093333333333341E+001,
      -4.9053333333333342E+001,
      -4.9013333333333343E+001,
      -4.8973333333333336E+001,
      -4.8933333333333344E+001,
      -4.8893333333333338E+001,
      -4.8853333333333346E+001,
      -4.8813333333333340E+001,
      -4.8773333333333341E+001,
      -4.8733333333333341E+001,
      -4.8693333333333335E+001,
      -4.8653333333333343E+001,
      -4.8613333333333337E+001,
      -4.8573333333333338E+001,
      -4.8533333333333339E+001,
      -4.8493333333333339E+001,
      -4.8453333333333340E+001,
      -4.8413333333333341E+001,
      -4.8373333333333335E+001,
      -4.8333333333333343E+001,
      -4.8293333333333337E+001,
      -4.8253333333333345E+001,
      -4.8213333333333345E+001,
      -4.8173333333333346E+001,
      -4.8133333333333340E+001,
      -4.8093333333333348E+001,
      -4.8053333333333342E+001,
      -4.8013333333333350E+001,
      -4.7973333333333343E+001,
      -4.7933333333333337E+001,
      -4.7893333333333345E+001,
      -4.7853333333333339E+001,
      -4.7813333333333347E+001,
      -4.7773333333333341E+001,
      -4.7733333333333341E+001,
      -4.7693333333333342E+001,
      -4.7653333333333343E+001,
      -4.7613333333333344E+001,
      -4.7573333333333345E+001,
      -4.7533333333333339E+001,
      -4.7493333333333347E+001,
      -4.7453333333333340E+001,
      -4.7413333333333348E+001,
      -4.7373333333333342E+001,
      -4.7333333333333343E+001,
      -4.7293333333333344E+001,
      -4.7253333333333345E+001,
      -4.7213333333333345E+001,
      -4.7173333333333346E+001,
      -4.7133333333333340E+001,
      -4.7093333333333341E+001,
      -4.7053333333333342E+001,
      -4.7013333333333343E+001,
      -4.6973333333333343E+001,
      -4.6933333333333337E+001,
      -4.6893333333333345E+001,
      -4.6853333333333339E+001,
      -4.6813333333333347E+001,
      -4.6773333333333341E+001,
      -4.6733333333333341E+001,
      -4.6693333333333342E+001,
      -4.6653333333333343E+001,
      -4.6613333333333344E+001,
      -4.6573333333333345E+001,
      -4.6533333333333339E+001,
      -4.6493333333333347E+001,
      -4.6453333333333340E+001,
      -4.6413333333333348E+001,
      -4.6373333333333342E+001,
      -4.6333333333333336E+001,
      -4.6293333333333344E+001,
      -4.6253333333333337E+001,
      -4.6213333333333345E+001,
      -4.6173333333333339E+001,
      -4.6133333333333340E+001,
      -4.6093333333333341E+001,
      -4.6053333333333342E+001,
      -4.6013333333333343E+001,
      -4.5973333333333343E+001,
      -4.5933333333333337E+001,
      -4.5893333333333345E+001,
      -4.5853333333333339E+001,
      -4.5813333333333347E+001,
      -4.5773333333333341E+001,
      -4.5733333333333341E+001,
      -4.5693333333333342E+001,
      -4.5653333333333343E+001,
      -4.5613333333333344E+001,
      -4.5573333333333345E+001,
      -4.5533333333333339E+001,
      -4.5493333333333339E+001,
      -4.5453333333333340E+001,
      -4.5413333333333341E+001,
      -4.5373333333333342E+001,
      -4.5333333333333336E+001,
      -4.5293333333333344E+001,
      -4.5253333333333337E+001,
      -4.5213333333333345E+001,
      -4.5173333333333339E+001,
      -4.5133333333333340E+001,
      -4.5093333333333341E+001,
      -4.5053333333333342E+001,
      -4.5013333333333343E+001,
      -4.4973333333333343E+001,
      -4.4933333333333337E+001,
      -4.4893333333333345E+001,
      -4.4853333333333339E+001,
      -4.4813333333333347E+001,
      -4.4773333333333341E+001,
      -4.4733333333333334E+001,
      -4.4693333333333342E+001,
      -4.4653333333333336E+001,
      -4.4613333333333344E+001,
      -4.4573333333333338E+001,
      -4.4533333333333339E+001,
      -4.4493333333333339E+001,
      -4.4453333333333340E+001,
      -4.4413333333333341E+001,
      -4.4373333333333342E+001,
      -4.4333333333333336E+001,
      -4.4293333333333344E+001,
      -4.4253333333333337E+001,
      -4.4213333333333345E+001,
      -4.4173333333333339E+001,
      -4.4133333333333340E+001,
      -4.4093333333333341E+001,
      -4.4053333333333342E+001,
      -4.4013333333333343E+001,
      -4.3973333333333343E+001,
      -4.3933333333333337E+001,
      -4.3893333333333338E+001,
      -4.3853333333333339E+001,
      -4.3813333333333340E+001,
      -4.3773333333333341E+001,
      -4.3733333333333334E+001,
      -4.3693333333333342E+001,
      -4.3653333333333336E+001,
      -4.3613333333333344E+001,
      -4.3573333333333338E+001,
      -4.3533333333333339E+001,
      -4.3493333333333339E+001,
      -4.3453333333333340E+001,
      -4.3413333333333341E+001,
      -4.3373333333333342E+001,
      -4.3333333333333336E+001,
      -4.3293333333333344E+001,
      -4.3253333333333337E+001,
      -4.3213333333333345E+001,
      -4.3173333333333346E+001,
      -4.3133333333333347E+001,
      -4.3093333333333341E+001,
      -4.3053333333333342E+001,
      -4.3013333333333343E+001,
      -4.2973333333333343E+001,
      -4.2933333333333344E+001,
      -4.2893333333333338E+001,
      -4.2853333333333346E+001,
      -4.2813333333333340E+001,
      -4.2773333333333348E+001,
      -4.2733333333333341E+001,
      -4.2693333333333342E+001,
      -4.2653333333333343E+001,
      -4.2613333333333344E+001,
      -4.2573333333333345E+001,
      -4.2533333333333346E+001,
      -4.2493333333333339E+001,
      -4.2453333333333347E+001,
      -4.2413333333333341E+001,
      -4.2373333333333349E+001,
      -4.2333333333333343E+001,
      -4.2293333333333337E+001,
      -4.2253333333333345E+001,
      -4.2213333333333338E+001,
      -4.2173333333333346E+001,
      -4.2133333333333340E+001,
      -4.2093333333333341E+001,
      -4.2053333333333342E+001,
      -4.2013333333333343E+001,
      -4.1973333333333343E+001,
      -4.1933333333333344E+001,
      -4.1893333333333338E+001,
      -4.1853333333333346E+001,
      -4.1813333333333340E+001,
      -4.1773333333333348E+001,
      -4.1733333333333341E+001,
      -4.1693333333333342E+001,
      -4.1653333333333343E+001,
      -4.1613333333333344E+001,
      -4.1573333333333345E+001,
      -4.1533333333333346E+001,
      -4.1493333333333339E+001,
      -4.1453333333333340E+001,
      -4.1413333333333341E+001,
      -4.1373333333333342E+001,
      -4.1333333333333343E+001,
      -4.1293333333333337E+001,
      -4.1253333333333345E+001,
      -4.1213333333333338E+001,
      -4.1173333333333346E+001,
      -4.1133333333333340E+001,
      -4.1093333333333341E+001,
      -4.1053333333333342E+001,
      -4.1013333333333343E+001,
      -4.0973333333333343E+001,
      -4.0933333333333344E+001,
      -4.0893333333333338E+001,
      -4.0853333333333346E+001,
      -4.0813333333333340E+001,
      -4.0773333333333348E+001,
      -4.0733333333333341E+001,
      -4.0693333333333335E+001,
      -4.0653333333333343E+001,
      -4.0613333333333337E+001,
      -4.0573333333333345E+001,
      -4.0533333333333339E+001,
      -4.0493333333333339E+001,
      -4.0453333333333340E+001,
      -4.0413333333333341E+001,
      -4.0373333333333342E+001,
      -4.0333333333333343E+001,
      -4.0293333333333337E+001,
      -4.0253333333333345E+001,
      -4.0213333333333338E+001,
      -4.0173333333333346E+001,
      -4.0133333333333340E+001,
      -4.0093333333333341E+001,
      -4.0053333333333342E+001,
      -4.0013333333333350E+001,
      -3.9973333333333343E+001,
      -3.9933333333333351E+001,
      -3.9893333333333345E+001,
      -3.9853333333333339E+001,
      -3.9813333333333347E+001,
      -3.9773333333333341E+001,
      -3.9733333333333348E+001,
      -3.9693333333333342E+001,
      -3.9653333333333343E+001,
      -3.9613333333333344E+001,
      -3.9573333333333345E+001,
      -3.9533333333333346E+001,
      -3.9493333333333347E+001,
      -3.9453333333333340E+001,
      -3.9413333333333348E+001,
      -3.9373333333333342E+001,
      -3.9333333333333350E+001,
      -3.9293333333333344E+001,
      -3.9253333333333345E+001,
      -3.9213333333333345E+001,
      -3.9173333333333346E+001,
      -3.9133333333333347E+001,
      -3.9093333333333341E+001,
      -3.9053333333333342E+001,
      -3.9013333333333343E+001,
      -3.8973333333333343E+001,
      -3.8933333333333344E+001,
      -3.8893333333333345E+001,
      -3.8853333333333339E+001,
      -3.8813333333333347E+001,
      -3.8773333333333341E+001,
      -3.8733333333333348E+001,
      -3.8693333333333342E+001,
      -3.8653333333333343E+001,
      -3.8613333333333344E+001,
      -3.8573333333333345E+001,
      -3.8533333333333346E+001,
      -3.8493333333333347E+001,
      -3.8453333333333340E+001,
      -3.8413333333333348E+001,
      -3.8373333333333342E+001,
      -3.8333333333333350E+001,
      -3.8293333333333344E+001,
      -3.8253333333333337E+001,
      -3.8213333333333345E+001,
      -3.8173333333333339E+001,
      -3.8133333333333347E+001,
      -3.8093333333333341E+001,
      -3.8053333333333342E+001,
      -3.8013333333333343E+001,
      -3.7973333333333343E+001,
      -3.7933333333333337E+001,
      -3.7893333333333345E+001,
      -3.7853333333333339E+001,
      -3.7813333333333347E+001,
      -3.7773333333333341E+001,
      -3.7733333333333341E+001,
      -3.7693333333333342E+001,
      -3.7653333333333343E+001,
      -3.7613333333333344E+001,
      -3.7573333333333345E+001,
      -3.7533333333333339E+001,
      -3.7493333333333339E+001,
      -3.7453333333333340E+001,
      -3.7413333333333341E+001,
      -3.7373333333333342E+001,
      -3.7333333333333336E+001,
      -3.7293333333333344E+001,
      -3.7253333333333337E+001,
      -3.7213333333333345E+001,
      -3.7173333333333339E+001,
      -3.7133333333333340E+001,
      -3.7093333333333341E+001,
      -3.7053333333333342E+001,
      -3.7013333333333343E+001,
      -3.6973333333333343E+001,
      -3.6933333333333337E+001,
      -3.6893333333333345E+001,
      -3.6853333333333346E+001,
      -3.6813333333333347E+001,
      -3.6773333333333348E+001,
      -3.6733333333333348E+001,
      -3.6693333333333342E+001,
      -3.6653333333333343E+001,
      -3.6613333333333344E+001,
      -3.6573333333333345E+001,
      -3.6533333333333346E+001,
      -3.6493333333333339E+001,
      -3.6453333333333347E+001,
      -3.6413333333333341E+001,
      -3.6373333333333349E+001,
      -3.6333333333333343E+001,
      -3.6293333333333344E+001,
      -3.6253333333333345E+001,
      -3.6213333333333345E+001,
      -3.6173333333333346E+001,
      -3.6133333333333347E+001,
      -3.6093333333333341E+001,
      -3.6053333333333349E+001,
      -3.6013333333333343E+001,
      -3.5973333333333350E+001,
      -3.5933333333333344E+001,
      -3.5893333333333338E+001,
      -3.5853333333333346E+001,
      -3.5813333333333340E+001,
      -3.5773333333333348E+001,
      -3.5733333333333341E+001,
      -3.5693333333333342E+001,
      -3.5653333333333343E+001,
      -3.5613333333333344E+001,
      -3.5573333333333345E+001,
      -3.5533333333333346E+001,
      -3.5493333333333339E+001,
      -3.5453333333333347E+001,
      -3.5413333333333341E+001,
      -3.5373333333333349E+001,
      -3.5333333333333343E+001,
      -3.5293333333333344E+001,
      -3.5253333333333345E+001,
      -3.5213333333333345E+001,
      -3.5173333333333346E+001,
      -3.5133333333333347E+001,
      -3.5093333333333341E+001,
      -3.5053333333333342E+001,
      -3.5013333333333343E+001,
      -3.4973333333333343E+001,
      -3.4933333333333344E+001,
      -3.4893333333333338E+001,
      -3.4853333333333346E+001,
      -3.4813333333333340E+001,
      -3.4773333333333348E+001,
      -3.4733333333333341E+001,
      -3.4693333333333342E+001,
      -3.4653333333333343E+001,
      -3.4613333333333344E+001,
      -3.4573333333333345E+001,
      -3.4533333333333346E+001,
      -3.4493333333333339E+001,
      -3.4453333333333347E+001,
      -3.4413333333333341E+001,
      -3.4373333333333349E+001,
      -3.4333333333333343E+001,
      -3.4293333333333337E+001,
      -3.4253333333333345E+001,
      -3.4213333333333338E+001,
      -3.4173333333333346E+001,
      -3.4133333333333340E+001,
      -3.4093333333333341E+001,
      -3.4053333333333342E+001,
      -3.4013333333333343E+001,
      -3.3973333333333343E+001,
      -3.3933333333333344E+001,
      -3.3893333333333338E+001,
      -3.3853333333333346E+001,
      -3.3813333333333340E+001,
      -3.3773333333333348E+001,
      -3.3733333333333341E+001,
      -3.3693333333333342E+001,
      -3.3653333333333343E+001,
      -3.3613333333333344E+001,
      -3.3573333333333345E+001,
      -3.3533333333333346E+001,
      -3.3493333333333339E+001,
      -3.3453333333333340E+001,
      -3.3413333333333341E+001,
      -3.3373333333333342E+001,
      -3.3333333333333343E+001,
      -3.3293333333333337E+001,
      -3.3253333333333345E+001,
      -3.3213333333333338E+001,
      -3.3173333333333346E+001,
      -3.3133333333333340E+001,
      -3.3093333333333341E+001,
      -3.3053333333333342E+001,
      -3.3013333333333343E+001,
      -3.2973333333333343E+001,
      -3.2933333333333344E+001,
      -3.2893333333333338E+001,
      -3.2853333333333346E+001,
      -3.2813333333333340E+001,
      -3.2773333333333348E+001,
      -3.2733333333333341E+001,
      -3.2693333333333335E+001,
      -3.2653333333333343E+001,
      -3.2613333333333337E+001,
      -3.2573333333333345E+001,
      -3.2533333333333339E+001,
      -3.2493333333333339E+001,
      -3.2453333333333340E+001,
      -3.2413333333333341E+001,
      -3.2373333333333342E+001,
      -3.2333333333333343E+001,
      -3.2293333333333337E+001,
      -3.2253333333333345E+001,
      -3.2213333333333338E+001,
      -3.2173333333333346E+001,
      -3.2133333333333340E+001,
      -3.2093333333333341E+001,
      -3.2053333333333342E+001,
      -3.2013333333333343E+001,
      -3.1973333333333343E+001,
      -3.1933333333333341E+001,
      -3.1893333333333338E+001,
      -3.1853333333333342E+001,
      -3.1813333333333340E+001,
      -3.1773333333333344E+001,
      -3.1733333333333348E+001,
      -3.1693333333333346E+001,
      -3.1653333333333343E+001,
      -3.1613333333333347E+001,
      -3.1573333333333345E+001,
      -3.1533333333333349E+001,
      -3.1493333333333343E+001,
      -3.1453333333333340E+001,
      -3.1413333333333345E+001,
      -3.1373333333333342E+001,
      -3.1333333333333346E+001,
      -3.1293333333333344E+001,
      -3.1253333333333348E+001,
      -3.1213333333333345E+001,
      -3.1173333333333343E+001,
      -3.1133333333333347E+001,
      -3.1093333333333351E+001,
      -3.1053333333333342E+001,
      -3.1013333333333339E+001,
      -3.0973333333333343E+001,
      -3.0933333333333348E+001,
      -3.0893333333333345E+001,
      -3.0853333333333342E+001,
      -3.0813333333333347E+001,
      -3.0773333333333351E+001,
      -3.0733333333333348E+001,
      -3.0693333333333335E+001,
      -3.0653333333333340E+001,
      -3.0613333333333344E+001,
      -3.0573333333333341E+001,
      -3.0533333333333339E+001,
      -3.0493333333333343E+001,
      -3.0453333333333347E+001,
      -3.0413333333333345E+001,
      -3.0373333333333342E+001,
      -3.0333333333333346E+001,
      -3.0293333333333351E+001,
      -3.0253333333333341E+001,
      -3.0213333333333338E+001,
      -3.0173333333333343E+001,
      -3.0133333333333347E+001,
      -3.0093333333333344E+001,
      -3.0053333333333342E+001,
      -3.0013333333333346E+001,
      -2.9973333333333350E+001,
      -2.9933333333333348E+001,
      -2.9893333333333334E+001,
      -2.9853333333333339E+001,
      -2.9813333333333343E+001,
      -2.9773333333333341E+001,
      -2.9733333333333338E+001,
      -2.9693333333333342E+001,
      -2.9653333333333347E+001,
      -2.9613333333333344E+001,
      -2.9573333333333341E+001,
      -2.9533333333333346E+001,
      -2.9493333333333350E+001,
      -2.9453333333333340E+001,
      -2.9413333333333338E+001,
      -2.9373333333333342E+001,
      -2.9333333333333346E+001,
      -2.9293333333333344E+001,
      -2.9253333333333341E+001,
      -2.9213333333333345E+001,
      -2.9173333333333350E+001,
      -2.9133333333333347E+001,
      -2.9093333333333334E+001,
      -2.9053333333333338E+001,
      -2.9013333333333343E+001,
      -2.8973333333333340E+001,
      -2.8933333333333337E+001,
      -2.8893333333333342E+001,
      -2.8853333333333346E+001,
      -2.8813333333333343E+001,
      -2.8773333333333341E+001,
      -2.8733333333333345E+001,
      -2.8693333333333349E+001,
      -2.8653333333333340E+001,
      -2.8613333333333337E+001,
      -2.8573333333333341E+001,
      -2.8533333333333346E+001,
      -2.8493333333333343E+001,
      -2.8453333333333340E+001,
      -2.8413333333333345E+001,
      -2.8373333333333349E+001,
      -2.8333333333333346E+001,
      -2.8293333333333333E+001,
      -2.8253333333333337E+001,
      -2.8213333333333342E+001,
      -2.8173333333333339E+001,
      -2.8133333333333336E+001,
      -2.8093333333333341E+001,
      -2.8053333333333345E+001,
      -2.8013333333333343E+001,
      -2.7973333333333340E+001,
      -2.7933333333333344E+001,
      -2.7893333333333349E+001,
      -2.7853333333333339E+001,
      -2.7813333333333343E+001,
      -2.7773333333333341E+001,
      -2.7733333333333345E+001,
      -2.7693333333333342E+001,
      -2.7653333333333347E+001,
      -2.7613333333333344E+001,
      -2.7573333333333348E+001,
      -2.7533333333333346E+001,
      -2.7493333333333350E+001,
      -2.7453333333333337E+001,
      -2.7413333333333341E+001,
      -2.7373333333333338E+001,
      -2.7333333333333343E+001,
      -2.7293333333333340E+001,
      -2.7253333333333345E+001,
      -2.7213333333333342E+001,
      -2.7173333333333346E+001,
      -2.7133333333333344E+001,
      -2.7093333333333348E+001,
      -2.7053333333333338E+001,
      -2.7013333333333343E+001,
      -2.6973333333333340E+001,
      -2.6933333333333344E+001,
      -2.6893333333333342E+001,
      -2.6853333333333346E+001,
      -2.6813333333333343E+001,
      -2.6773333333333348E+001,
      -2.6733333333333345E+001,
      -2.6693333333333349E+001,
      -2.6653333333333336E+001,
      -2.6613333333333340E+001,
      -2.6573333333333338E+001,
      -2.6533333333333342E+001,
      -2.6493333333333339E+001,
      -2.6453333333333344E+001,
      -2.6413333333333341E+001,
      -2.6373333333333346E+001,
      -2.6333333333333343E+001,
      -2.6293333333333347E+001,
      -2.6253333333333337E+001,
      -2.6213333333333342E+001,
      -2.6173333333333339E+001,
      -2.6133333333333344E+001,
      -2.6093333333333341E+001,
      -2.6053333333333345E+001,
      -2.6013333333333343E+001,
      -2.5973333333333347E+001,
      -2.5933333333333344E+001,
      -2.5893333333333349E+001,
      -2.5853333333333335E+001,
      -2.5813333333333340E+001,
      -2.5773333333333337E+001,
      -2.5733333333333341E+001,
      -2.5693333333333339E+001,
      -2.5653333333333343E+001,
      -2.5613333333333340E+001,
      -2.5573333333333345E+001,
      -2.5533333333333342E+001,
      -2.5493333333333347E+001,
      -2.5453333333333337E+001,
      -2.5413333333333341E+001,
      -2.5373333333333338E+001,
      -2.5333333333333343E+001,
      -2.5293333333333347E+001,
      -2.5253333333333345E+001,
      -2.5213333333333342E+001,
      -2.5173333333333346E+001,
      -2.5133333333333351E+001,
      -2.5093333333333348E+001,
      -2.5053333333333335E+001,
      -2.5013333333333339E+001,
      -2.4973333333333343E+001,
      -2.4933333333333341E+001,
      -2.4893333333333338E+001,
      -2.4853333333333342E+001,
      -2.4813333333333347E+001,
      -2.4773333333333344E+001,
      -2.4733333333333341E+001,
      -2.4693333333333346E+001,
      -2.4653333333333350E+001,
      -2.4613333333333340E+001,
      -2.4573333333333338E+001,
      -2.4533333333333342E+001,
      -2.4493333333333347E+001,
      -2.4453333333333344E+001,
      -2.4413333333333341E+001,
      -2.4373333333333346E+001,
      -2.4333333333333350E+001,
      -2.4293333333333347E+001,
      -2.4253333333333334E+001,
      -2.4213333333333338E+001,
      -2.4173333333333343E+001,
      -2.4133333333333340E+001,
      -2.4093333333333337E+001,
      -2.4053333333333342E+001,
      -2.4013333333333346E+001,
      -2.3973333333333343E+001,
      -2.3933333333333341E+001,
      -2.3893333333333345E+001,
      -2.3853333333333349E+001,
      -2.3813333333333340E+001,
      -2.3773333333333337E+001,
      -2.3733333333333341E+001,
      -2.3693333333333346E+001,
      -2.3653333333333343E+001,
      -2.3613333333333340E+001,
      -2.3573333333333345E+001,
      -2.3533333333333349E+001,
      -2.3493333333333343E+001,
      -2.3453333333333333E+001,
      -2.3413333333333338E+001,
      -2.3373333333333342E+001,
      -2.3333333333333339E+001,
      -2.3293333333333337E+001,
      -2.3253333333333341E+001,
      -2.3213333333333345E+001,
      -2.3173333333333343E+001,
      -2.3133333333333340E+001,
      -2.3093333333333344E+001,
      -2.3053333333333349E+001,
      -2.3013333333333339E+001,
      -2.2973333333333336E+001,
      -2.2933333333333341E+001,
      -2.2893333333333345E+001,
      -2.2853333333333342E+001,
      -2.2813333333333340E+001,
      -2.2773333333333344E+001,
      -2.2733333333333348E+001,
      -2.2693333333333342E+001,
      -2.2653333333333347E+001,
      -2.2613333333333337E+001,
      -2.2573333333333341E+001,
      -2.2533333333333339E+001,
      -2.2493333333333343E+001,
      -2.2453333333333340E+001,
      -2.2413333333333345E+001,
      -2.2373333333333342E+001,
      -2.2333333333333346E+001,
      -2.2293333333333344E+001,
      -2.2253333333333348E+001,
      -2.2213333333333338E+001,
      -2.2173333333333343E+001,
      -2.2133333333333340E+001,
      -2.2093333333333344E+001,
      -2.2053333333333342E+001,
      -2.2013333333333346E+001,
      -2.1973333333333343E+001,
      -2.1933333333333348E+001,
      -2.1893333333333342E+001,
      -2.1853333333333346E+001,
      -2.1813333333333336E+001,
      -2.1773333333333341E+001,
      -2.1733333333333338E+001,
      -2.1693333333333342E+001,
      -2.1653333333333340E+001,
      -2.1613333333333344E+001,
      -2.1573333333333341E+001,
      -2.1533333333333346E+001,
      -2.1493333333333343E+001,
      -2.1453333333333347E+001,
      -2.1413333333333338E+001,
      -2.1373333333333342E+001,
      -2.1333333333333339E+001,
      -2.1293333333333344E+001,
      -2.1253333333333341E+001,
      -2.1213333333333345E+001,
      -2.1173333333333343E+001,
      -2.1133333333333347E+001,
      -2.1093333333333341E+001,
      -2.1053333333333345E+001,
      -2.1013333333333335E+001,
      -2.0973333333333340E+001,
      -2.0933333333333337E+001,
      -2.0893333333333342E+001,
      -2.0853333333333339E+001,
      -2.0813333333333343E+001,
      -2.0773333333333341E+001,
      -2.0733333333333345E+001,
      -2.0693333333333342E+001,
      -2.0653333333333347E+001,
      -2.0613333333333337E+001,
      -2.0573333333333341E+001,
      -2.0533333333333339E+001,
      -2.0493333333333343E+001,
      -2.0453333333333340E+001,
      -2.0413333333333345E+001,
      -2.0373333333333342E+001,
      -2.0333333333333346E+001,
      -2.0293333333333340E+001,
      -2.0253333333333345E+001,
      -2.0213333333333335E+001,
      -2.0173333333333339E+001,
      -2.0133333333333344E+001,
      -2.0093333333333341E+001,
      -2.0053333333333338E+001,
      -2.0013333333333343E+001,
      -1.9973333333333347E+001,
      -1.9933333333333344E+001,
      -1.9893333333333342E+001,
      -1.9853333333333346E+001,
      -1.9813333333333350E+001,
      -1.9773333333333341E+001,
      -1.9733333333333338E+001,
      -1.9693333333333342E+001,
      -1.9653333333333347E+001,
      -1.9613333333333344E+001,
      -1.9573333333333341E+001,
      -1.9533333333333346E+001,
      -1.9493333333333350E+001,
      -1.9453333333333344E+001,
      -1.9413333333333334E+001,
      -1.9373333333333338E+001,
      -1.9333333333333343E+001,
      -1.9293333333333340E+001,
      -1.9253333333333337E+001,
      -1.9213333333333342E+001,
      -1.9173333333333346E+001,
      -1.9133333333333344E+001,
      -1.9093333333333341E+001,
      -1.9053333333333345E+001,
      -1.9013333333333350E+001,
      -1.8973333333333340E+001,
      -1.8933333333333337E+001,
      -1.8893333333333342E+001,
      -1.8853333333333346E+001,
      -1.8813333333333343E+001,
      -1.8773333333333341E+001,
      -1.8733333333333345E+001,
      -1.8693333333333349E+001,
      -1.8653333333333343E+001,
      -1.8613333333333333E+001,
      -1.8573333333333338E+001,
      -1.8533333333333342E+001,
      -1.8493333333333339E+001,
      -1.8453333333333337E+001,
      -1.8413333333333341E+001,
      -1.8373333333333346E+001,
      -1.8333333333333343E+001,
      -1.8293333333333347E+001,
      -1.8253333333333345E+001,
      -1.8213333333333349E+001,
      -1.8173333333333339E+001,
      -1.8133333333333344E+001,
      -1.8093333333333341E+001,
      -1.8053333333333345E+001,
      -1.8013333333333343E+001,
      -1.7973333333333347E+001,
      -1.7933333333333344E+001,
      -1.7893333333333349E+001,
      -1.7853333333333342E+001,
      -1.7813333333333347E+001,
      -1.7773333333333337E+001,
      -1.7733333333333341E+001,
      -1.7693333333333339E+001,
      -1.7653333333333343E+001,
      -1.7613333333333340E+001,
      -1.7573333333333345E+001,
      -1.7533333333333342E+001,
      -1.7493333333333347E+001,
      -1.7453333333333344E+001,
      -1.7413333333333348E+001,
      -1.7373333333333338E+001,
      -1.7333333333333343E+001,
      -1.7293333333333340E+001,
      -1.7253333333333345E+001,
      -1.7213333333333342E+001,
      -1.7173333333333346E+001,
      -1.7133333333333344E+001,
      -1.7093333333333348E+001,
      -1.7053333333333342E+001,
      -1.7013333333333346E+001,
      -1.6973333333333336E+001,
      -1.6933333333333341E+001,
      -1.6893333333333338E+001,
      -1.6853333333333342E+001,
      -1.6813333333333340E+001,
      -1.6773333333333344E+001,
      -1.6733333333333341E+001,
      -1.6693333333333346E+001,
      -1.6653333333333343E+001,
      -1.6613333333333347E+001,
      -1.6573333333333338E+001,
      -1.6533333333333342E+001,
      -1.6493333333333339E+001,
      -1.6453333333333344E+001,
      -1.6413333333333341E+001,
      -1.6373333333333346E+001,
      -1.6333333333333343E+001,
      -1.6293333333333347E+001,
      -1.6253333333333341E+001,
      -1.6213333333333345E+001,
      -1.6173333333333336E+001,
      -1.6133333333333340E+001,
      -1.6093333333333337E+001,
      -1.6053333333333342E+001,
      -1.6013333333333339E+001,
      -1.5973333333333343E+001,
      -1.5933333333333341E+001,
      -1.5893333333333345E+001,
      -1.5853333333333342E+001,
      -1.5813333333333347E+001,
      -1.5773333333333335E+001,
      -1.5733333333333340E+001,
      -1.5693333333333337E+001,
      -1.5653333333333341E+001,
      -1.5613333333333339E+001,
      -1.5573333333333343E+001,
      -1.5533333333333340E+001,
      -1.5493333333333345E+001,
      -1.5453333333333342E+001,
      -1.5413333333333346E+001,
      -1.5373333333333335E+001,
      -1.5333333333333339E+001,
      -1.5293333333333337E+001,
      -1.5253333333333341E+001,
      -1.5213333333333338E+001,
      -1.5173333333333343E+001,
      -1.5133333333333340E+001,
      -1.5093333333333344E+001,
      -1.5053333333333342E+001,
      -1.5013333333333346E+001,
      -1.4973333333333334E+001,
      -1.4933333333333339E+001,
      -1.4893333333333336E+001,
      -1.4853333333333341E+001,
      -1.4813333333333338E+001,
      -1.4773333333333342E+001,
      -1.4733333333333340E+001,
      -1.4693333333333344E+001,
      -1.4653333333333341E+001,
      -1.4613333333333346E+001,
      -1.4573333333333334E+001,
      -1.4533333333333339E+001,
      -1.4493333333333343E+001,
      -1.4453333333333340E+001,
      -1.4413333333333338E+001,
      -1.4373333333333342E+001,
      -1.4333333333333346E+001,
      -1.4293333333333344E+001,
      -1.4253333333333341E+001,
      -1.4213333333333345E+001,
      -1.4173333333333350E+001,
      -1.4133333333333338E+001,
      -1.4093333333333335E+001,
      -1.4053333333333340E+001,
      -1.4013333333333344E+001,
      -1.3973333333333342E+001,
      -1.3933333333333339E+001,
      -1.3893333333333343E+001,
      -1.3853333333333348E+001,
      -1.3813333333333345E+001,
      -1.3773333333333333E+001,
      -1.3733333333333338E+001,
      -1.3693333333333342E+001,
      -1.3653333333333340E+001,
      -1.3613333333333337E+001,
      -1.3573333333333341E+001,
      -1.3533333333333346E+001,
      -1.3493333333333343E+001,
      -1.3453333333333347E+001,
      -1.3413333333333345E+001,
      -1.3373333333333349E+001,
      -1.3333333333333337E+001,
      -1.3293333333333342E+001,
      -1.3253333333333339E+001,
      -1.3213333333333344E+001,
      -1.3173333333333341E+001,
      -1.3133333333333345E+001,
      -1.3093333333333343E+001,
      -1.3053333333333347E+001,
      -1.3013333333333344E+001,
      -1.2973333333333349E+001,
      -1.2933333333333337E+001,
      -1.2893333333333342E+001,
      -1.2853333333333339E+001,
      -1.2813333333333343E+001,
      -1.2773333333333341E+001,
      -1.2733333333333345E+001,
      -1.2693333333333342E+001,
      -1.2653333333333347E+001,
      -1.2613333333333344E+001,
      -1.2573333333333348E+001,
      -1.2533333333333337E+001,
      -1.2493333333333341E+001,
      -1.2453333333333338E+001,
      -1.2413333333333343E+001,
      -1.2373333333333340E+001,
      -1.2333333333333345E+001,
      -1.2293333333333342E+001,
      -1.2253333333333346E+001,
      -1.2213333333333344E+001,
      -1.2173333333333348E+001,
      -1.2133333333333336E+001,
      -1.2093333333333341E+001,
      -1.2053333333333338E+001,
      -1.2013333333333343E+001,
      -1.1973333333333340E+001,
      -1.1933333333333344E+001,
      -1.1893333333333342E+001,
      -1.1853333333333346E+001,
      -1.1813333333333343E+001,
      -1.1773333333333348E+001,
      -1.1733333333333336E+001,
      -1.1693333333333340E+001,
      -1.1653333333333338E+001,
      -1.1613333333333342E+001,
      -1.1573333333333339E+001,
      -1.1533333333333344E+001,
      -1.1493333333333341E+001,
      -1.1453333333333346E+001,
      -1.1413333333333343E+001,
      -1.1373333333333347E+001,
      -1.1333333333333345E+001,
      -1.1293333333333349E+001,
      -1.1253333333333337E+001,
      -1.1213333333333342E+001,
      -1.1173333333333339E+001,
      -1.1133333333333344E+001,
      -1.1093333333333341E+001,
      -1.1053333333333345E+001,
      -1.1013333333333343E+001,
      -1.0973333333333347E+001,
      -1.0933333333333344E+001,
      -1.0893333333333349E+001,
      -1.0853333333333337E+001,
      -1.0813333333333341E+001,
      -1.0773333333333339E+001,
      -1.0733333333333343E+001,
      -1.0693333333333340E+001,
      -1.0653333333333345E+001,
      -1.0613333333333342E+001,
      -1.0573333333333347E+001,
      -1.0533333333333344E+001,
      -1.0493333333333348E+001,
      -1.0453333333333337E+001,
      -1.0413333333333341E+001,
      -1.0373333333333338E+001,
      -1.0333333333333343E+001,
      -1.0293333333333340E+001,
      -1.0253333333333345E+001,
      -1.0213333333333342E+001,
      -1.0173333333333346E+001,
      -1.0133333333333344E+001,
      -1.0093333333333348E+001,
      -1.0053333333333336E+001,
      -1.0013333333333341E+001,
      -9.9733333333333380E+000,
      -9.9333333333333425E+000,
      -9.8933333333333398E+000,
      -9.8533333333333442E+000,
      -9.8133333333333415E+000,
      -9.7733333333333459E+000,
      -9.7333333333333432E+000,
      -9.6933333333333476E+000,
      -9.6533333333333360E+000,
      -9.6133333333333404E+000,
      -9.5733333333333377E+000,
      -9.5333333333333421E+000,
      -9.4933333333333394E+000,
      -9.4533333333333438E+000,
      -9.4133333333333411E+000,
      -9.3733333333333455E+000,
      -9.3333333333333428E+000,
      -9.2933333333333472E+000,
      -9.2533333333333356E+000,
      -9.2133333333333400E+000,
      -9.1733333333333373E+000,
      -9.1333333333333417E+000,
      -9.0933333333333390E+000,
      -9.0533333333333434E+000,
      -9.0133333333333407E+000,
      -8.9733333333333452E+000,
      -8.9333333333333425E+000,
      -8.8933333333333469E+000,
      -8.8533333333333353E+000,
      -8.8133333333333397E+000,
      -8.7733333333333370E+000,
      -8.7333333333333414E+000,
      -8.6666666666666750E+000,
      -8.6268666666666771E+000,
      -8.5874666666666766E+000,
      -8.5484666666666733E+000,
      -8.5098666666666727E+000,
      -8.4716666666666782E+000,
      -8.4338666666666722E+000,
      -8.3964666666666758E+000,
      -8.3594666666666786E+000,
      -8.3228666666666768E+000,
      -8.2866666666666724E+000,
      -8.2508666666666723E+000,
      -8.2154666666666749E+000,
      -8.1804666666666748E+000,
      -8.1458666666666719E+000,
      -8.1116666666666735E+000,
      -8.0778666666666776E+000,
      -8.0444666666666720E+000,
      -8.0114666666666778E+000,
      -7.9788666666666730E+000,
      -7.9466666666666725E+000,
      -7.9148666666666756E+000,
      -7.8834666666666759E+000,
      -7.8524666666666727E+000,
      -7.8218666666666739E+000,
      -7.7916666666666714E+000,
      -7.7618666666666725E+000,
      -7.7324666666666708E+000,
      -7.7034666666666736E+000,
      -7.6748666666666727E+000,
      -7.6466666666666763E+000,
      -7.6188666666666762E+000,
      -7.5914666666666726E+000,
      -7.5644666666666733E+000,
      -7.5378666666666785E+000,
      -7.5116666666666720E+000,
      -7.4858666666666780E+000,
      -7.4604666666666732E+000,
      -7.4354666666666720E+000,
      -7.4108666666666752E+000,
      -7.3866666666666747E+000,
      -7.3628666666666716E+000,
      -7.3394666666666719E+000,
      -7.3164666666666767E+000,
      -7.2938666666666787E+000,
      -7.2716666666666763E+000,
      -7.2498666666666711E+000,
      -7.2284666666666775E+000,
      -7.2074666666666731E+000,
      -7.1868666666666732E+000,
      -7.1666666666666767E+000,
      -7.1468666666666776E+000,
      -7.1274666666666748E+000,
      -7.1084666666666765E+000,
      -7.0898666666666745E+000,
      -7.0716666666666761E+000,
      -7.0538666666666749E+000,
      -7.0364666666666711E+000,
      -7.0194666666666778E+000,
      -7.0028666666666739E+000,
      -6.9866666666666744E+000,
      -6.9708666666666721E+000,
      -6.9554666666666733E+000,
      -6.9404666666666781E+000,
      -6.9258666666666731E+000,
      -6.9116666666666715E+000,
      -6.8978666666666744E+000,
      -6.8844666666666745E+000,
      -6.8714666666666782E+000,
      -6.8588666666666711E+000,
      -6.8466666666666756E+000,
      -6.8348666666666764E+000,
      -6.8234666666666746E+000,
      -6.8124666666666762E+000,
      -6.8018666666666752E+000,
      -6.7916666666666776E+000,
      -6.7818666666666774E+000,
      -6.7724666666666735E+000,
      -6.7634666666666732E+000,
      -6.7548666666666781E+000,
      -6.7466666666666715E+000,
      -6.7388666666666763E+000,
      -6.7314666666666714E+000,
      -6.7244666666666770E+000,
      -6.7178666666666720E+000,
      -6.7116666666666713E+000,
      -6.7058666666666751E+000,
      -6.7004666666666752E+000,
      -6.6954666666666718E+000,
      -6.6908666666666727E+000,
      -6.6866666666666710E+000,
      -6.6828666666666727E+000,
      -6.6794666666666709E+000,
      -6.6764666666666734E+000,
      -6.6738666666666724E+000,
      -6.6716666666666757E+000,
      -6.6698666666666764E+000,
      -6.6684666666666725E+000,
      -6.6674666666666740E+000,
      -6.6668666666666709E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666666666666670E+000,
      -6.6666166666666680E+000,
      -6.6664666666666674E+000,
      -6.6662166666666671E+000,
      -6.6658666666666671E+000,
      -6.6654166666666672E+000,
      -6.6648666666666676E+000,
      -6.6642166666666673E+000,
      -6.6634666666666664E+000,
      -6.6626166666666675E+000,
      -6.6616666666666671E+000,
      -6.6606166666666669E+000,
      -6.6594666666666678E+000,
      -6.6582166666666680E+000,
      -6.6568666666666676E+000,
      -6.6554166666666674E+000,
      -6.6538666666666675E+000,
      -6.6522166666666669E+000,
      -6.6504666666666674E+000,
      -6.6486166666666673E+000,
      -6.6466666666666674E+000,
      -6.6446166666666668E+000,
      -6.6424666666666674E+000,
      -6.6402166666666673E+000,
      -6.6378666666666675E+000,
      -6.6354166666666670E+000,
      -6.6328666666666676E+000,
      -6.6302166666666675E+000,
      -6.6274666666666668E+000,
      -6.6246166666666673E+000,
      -6.6216666666666679E+000,
      -6.6186166666666670E+000,
      -6.6154666666666673E+000,
      -6.6122166666666669E+000,
      -6.6088666666666667E+000,
      -6.6054166666666676E+000,
      -6.6018666666666670E+000,
      -6.5982166666666675E+000,
      -6.5944666666666674E+000,
      -6.5906166666666675E+000,
      -6.5866666666666669E+000,
      -6.5826166666666666E+000,
      -6.5784666666666674E+000,
      -6.5742166666666666E+000,
      -6.5698666666666679E+000,
      -6.5654166666666676E+000,
      -6.5608666666666666E+000,
      -6.5562166666666677E+000,
      -6.5514666666666681E+000,
      -6.5466166666666670E+000,
      -6.5416666666666670E+000,
      -6.5366166666666672E+000,
      -6.5314666666666668E+000,
      -6.5262166666666666E+000,
      -6.5208666666666675E+000,
      -6.5154166666666669E+000,
      -6.5098666666666674E+000,
      -6.5042166666666672E+000,
      -6.4984666666666673E+000,
      -6.4926166666666676E+000,
      -6.4866666666666672E+000,
      -6.4806166666666680E+000,
      -6.4744666666666673E+000,
      -6.4682166666666676E+000,
      -6.4618666666666673E+000,
      -6.4554166666666672E+000,
      -6.4488666666666665E+000,
      -6.4422166666666669E+000,
      -6.4354666666666676E+000,
      -6.4286166666666675E+000,
      -6.4216666666666677E+000,
      -6.4146166666666673E+000,
      -6.4074666666666671E+000,
      -6.4002166666666680E+000,
      -6.3928666666666674E+000,
      -6.3854166666666679E+000,
      -6.3778666666666668E+000,
      -6.3702166666666677E+000,
      -6.3624666666666672E+000,
      -6.3546166666666677E+000,
      -6.3466666666666676E+000,
      -6.3386166666666668E+000,
      -6.3304666666666671E+000,
      -6.3222166666666677E+000,
      -6.3138666666666667E+000,
      -6.3054166666666669E+000,
      -6.2968666666666673E+000,
      -6.2882166666666679E+000,
      -6.2794666666666670E+000,
      -6.2706166666666681E+000,
      -6.2616666666666676E+000,
      -6.2526166666666674E+000,
      -6.2434666666666674E+000,
      -6.2342166666666676E+000,
      -6.2248666666666681E+000,
      -6.2154166666666670E+000,
      -6.2058666666666671E+000,
      -6.1962166666666674E+000,
      -6.1864666666666670E+000,
      -6.1766166666666669E+000,
      -6.1666666666666670E+000,
      -6.1566666666666672E+000,
      -6.1466666666666674E+000,
      -6.1366666666666676E+000,
      -6.1266666666666678E+000,
      -6.1166666666666671E+000,
      -6.1066666666666674E+000,
      -6.0966666666666676E+000,
      -6.0866666666666669E+000,
      -6.0766666666666671E+000,
      -6.0666666666666673E+000,
      -6.0566666666666666E+000,
      -6.0466666666666669E+000,
      -6.0366666666666671E+000,
      -6.0266666666666673E+000,
      -6.0166666666666675E+000,
      -6.0066666666666677E+000,
      -5.9966666666666670E+000,
      -5.9866666666666672E+000,
      -5.9766666666666675E+000,
      -5.9666666666666677E+000,
      -5.9566666666666679E+000,
      -5.9466666666666672E+000,
      -5.9366666666666674E+000,
      -5.9266666666666676E+000,
      -5.9166666666666679E+000,
      -5.9066666666666681E+000,
      -5.8966666666666665E+000,
      -5.8866666666666667E+000,
      -5.8766666666666669E+000,
      -5.8666666666666671E+000,
      -5.8566666666666674E+000,
      -5.8466666666666667E+000,
      -5.8366666666666669E+000,
      -5.8266666666666671E+000,
      -5.8166666666666673E+000,
      -5.8066666666666675E+000,
      -5.7966666666666669E+000,
      -5.7866666666666671E+000,
      -5.7766666666666673E+000,
      -5.7666666666666675E+000,
      -5.7566666666666677E+000,
      -5.7466666666666670E+000,
      -5.7366666666666672E+000,
      -5.7266666666666675E+000,
      -5.7166666666666677E+000,
      -5.7066666666666679E+000,
      -5.6966666666666663E+000,
      -5.6866666666666665E+000,
      -5.6766666666666667E+000,
      -5.6666666666666670E+000,
      -5.6566666666666672E+000,
      -5.6466666666666665E+000,
      -5.6366666666666676E+000,
      -5.6266666666666669E+000,
      -5.6166666666666671E+000,
      -5.6066666666666674E+000,
      -5.5966666666666667E+000,
      -5.5866666666666678E+000,
      -5.5766666666666671E+000,
      -5.5666666666666673E+000,
      -5.5566666666666675E+000,
      -5.5466666666666677E+000,
      -5.5366666666666680E+000,
      -5.5266666666666673E+000,
      -5.5166666666666675E+000,
      -5.5066666666666677E+000,
      -5.4966666666666679E+000,
      -5.4866666666666672E+000,
      -5.4766666666666666E+000,
      -5.4666666666666668E+000,
      -5.4566666666666670E+000,
      -5.4466666666666672E+000,
      -5.4366666666666674E+000,
      -5.4266666666666667E+000,
      -5.4166666666666670E+000,
      -5.4066666666666672E+000,
      -5.3966666666666674E+000,
      -5.3866666666666676E+000,
      -5.3766666666666669E+000,
      -5.3666666666666671E+000,
      -5.3566666666666674E+000,
      -5.3466666666666676E+000,
      -5.3366666666666678E+000,
      -5.3266666666666671E+000,
      -5.3166666666666673E+000,
      -5.3066666666666675E+000,
      -5.2966666666666677E+000,
      -5.2866666666666671E+000,
      -5.2766666666666664E+000,
      -5.2666666666666675E+000,
      -5.2566666666666668E+000,
      -5.2466666666666670E+000,
      -5.2366666666666672E+000,
      -5.2266666666666666E+000,
      -5.2166666666666677E+000,
      -5.2066666666666670E+000,
      -5.1966666666666672E+000,
      -5.1866666666666674E+000,
      -5.1766666666666667E+000,
      -5.1666666666666679E+000,
      -5.1566666666666672E+000,
      -5.1466666666666674E+000,
      -5.1366666666666676E+000,
      -5.1266666666666669E+000,
      -5.1166666666666680E+000,
      -5.1066666666666674E+000,
      -5.0966666666666676E+000,
      -5.0866666666666669E+000,
      -5.0766666666666671E+000,
      -5.0666666666666673E+000,
      -5.0566666666666666E+000,
      -5.0466666666666669E+000,
      -5.0366666666666671E+000,
      -5.0266666666666673E+000,
      -5.0166666666666675E+000,
      -5.0066666666666668E+000,
      -4.9966666666666670E+000,
      -4.9866666666666672E+000,
      -4.9766666666666675E+000,
      -4.9666666666666677E+000,
      -4.9566666666666670E+000,
      -4.9466666666666672E+000,
      -4.9366666666666674E+000,
      -4.9266666666666676E+000,
      -4.9166666666666679E+000,
      -4.9066666666666672E+000,
      -4.8966666666666665E+000,
      -4.8866666666666667E+000,
      -4.8766666666666669E+000,
      -4.8666666666666671E+000,
      -4.8566666666666665E+000,
      -4.8466666666666667E+000,
      -4.8366666666666669E+000,
      -4.8266666666666671E+000,
      -4.8166666666666673E+000,
      -4.8066666666666666E+000,
      -4.7966666666666669E+000,
      -4.7866666666666671E+000,
      -4.7766666666666673E+000,
      -4.7666666666666675E+000,
      -4.7566666666666668E+000,
      -4.7466666666666670E+000,
      -4.7366666666666672E+000,
      -4.7266666666666675E+000,
      -4.7166666666666677E+000,
      -4.7066666666666679E+000,
      -4.6966666666666681E+000,
      -4.6866666666666665E+000,
      -4.6766666666666667E+000,
      -4.6666666666666670E+000,
      -4.6566666666666672E+000,
      -4.6466666666666674E+000,
      -4.6366666666666667E+000,
      -4.6266666666666669E+000,
      -4.6166666666666671E+000,
      -4.6066666666666674E+000,
      -4.5966666666666676E+000,
      -4.5866666666666669E+000,
      -4.5766666666666671E+000,
      -4.5666666666666673E+000,
      -4.5566666666666675E+000,
      -4.5466666666666677E+000,
      -4.5366666666666671E+000,
      -4.5266666666666673E+000,
      -4.5166666666666675E+000,
      -4.5066666666666677E+000,
      -4.4966666666666679E+000,
      -4.4866666666666664E+000,
      -4.4766666666666666E+000,
      -4.4666666666666668E+000,
      -4.4566666666666670E+000,
      -4.4466666666666672E+000,
      -4.4366666666666665E+000,
      -4.4266666666666667E+000,
      -4.4166666666666670E+000,
      -4.4066666666666672E+000,
      -4.3966666666666674E+000,
      -4.3866666666666676E+000,
      -4.3766666666666678E+000,
      -4.3666666666666671E+000,
      -4.3566666666666674E+000,
      -4.3466666666666676E+000,
      -4.3366666666666678E+000,
      -4.3266666666666680E+000,
      -4.3166666666666673E+000,
      -4.3066666666666675E+000,
      -4.2966666666666677E+000,
      -4.2866666666666671E+000,
      -4.2766666666666673E+000,
      -4.2666666666666666E+000,
      -4.2566666666666668E+000,
      -4.2466666666666670E+000,
      -4.2366666666666672E+000,
      -4.2266666666666675E+000,
      -4.2166666666666668E+000,
      -4.2066666666666670E+000,
      -4.1966666666666672E+000,
      -4.1866666666666674E+000,
      -4.1766666666666676E+000,
      -4.1666666666666670E+000,
      -4.1566666666666672E+000,
      -4.1466666666666674E+000,
      -4.1366666666666676E+000,
      -4.1266666666666669E+000,
      -4.1166666666666671E+000,
      -4.1066666666666674E+000,
      -4.0966666666666676E+000,
      -4.0866666666666669E+000,
      -4.0766666666666671E+000,
      -4.0666666666666673E+000,
      -4.0566666666666675E+000,
      -4.0466666666666677E+000,
      -4.0366666666666671E+000,
      -4.0266666666666673E+000,
      -4.0166666666666675E+000,
      -4.0066666666666677E+000,
      -3.9966666666666675E+000,
      -3.9866666666666672E+000,
      -3.9766666666666675E+000,
      -3.9666666666666672E+000,
      -3.9566666666666674E+000,
      -3.9466666666666677E+000,
      -3.9366666666666670E+000,
      -3.9266666666666672E+000,
      -3.9166666666666670E+000,
      -3.9066666666666672E+000,
      -3.8966666666666674E+000,
      -3.8866666666666672E+000,
      -3.8766666666666674E+000,
      -3.8666666666666671E+000,
      -3.8566666666666674E+000,
      -3.8466666666666676E+000,
      -3.8366666666666669E+000,
      -3.8266666666666671E+000,
      -3.8166666666666669E+000,
      -3.8066666666666671E+000,
      -3.7966666666666673E+000,
      -3.7866666666666671E+000,
      -3.7766666666666673E+000,
      -3.7666666666666675E+000,
      -3.7566666666666677E+000,
      -3.7466666666666675E+000,
      -3.7366666666666672E+000,
      -3.7266666666666670E+000,
      -3.7166666666666672E+000,
      -3.7066666666666674E+000,
      -3.6966666666666672E+000,
      -3.6866666666666674E+000,
      -3.6766666666666672E+000,
      -3.6666666666666674E+000,
      -3.6566666666666676E+000,
      -3.6466666666666674E+000,
      -3.6366666666666672E+000,
      -3.6266666666666669E+000,
      -3.6166666666666671E+000,
      -3.6066666666666674E+000,
      -3.5966666666666671E+000,
      -3.5866666666666673E+000,
      -3.5766666666666671E+000,
      -3.5666666666666673E+000,
      -3.5566666666666675E+000,
      -3.5466666666666673E+000,
      -3.5366666666666671E+000,
      -3.5266666666666668E+000,
      -3.5166666666666671E+000,
      -3.5066666666666673E+000,
      -3.4966666666666670E+000,
      -3.4866666666666672E+000,
      -3.4766666666666670E+000,
      -3.4666666666666672E+000,
      -3.4566666666666674E+000,
      -3.4466666666666668E+000,
      -3.4366666666666670E+000,
      -3.4266666666666667E+000,
      -3.4166666666666670E+000,
      -3.4066666666666672E+000,
      -3.3966666666666669E+000,
      -3.3866666666666672E+000,
      -3.3766666666666669E+000,
      -3.3666666666666671E+000,
      -3.3566666666666674E+000,
      -3.3466666666666667E+000,
      -3.3366666666666669E+000,
      -3.3266666666666667E+000,
      -3.3166666666666669E+000,
      -3.3066666666666671E+000,
      -3.2966666666666669E+000,
      -3.2866666666666671E+000,
      -3.2766666666666668E+000,
      -3.2666666666666671E+000,
      -3.2566666666666673E+000,
      -3.2466666666666666E+000,
      -3.2366666666666668E+000,
      -3.2266666666666666E+000,
      -3.2166666666666668E+000,
      -3.2066666666666670E+000,
      -3.1966666666666668E+000,
      -3.1866666666666670E+000,
      -3.1766666666666667E+000,
      -3.1666666666666670E+000,
      -3.1566666666666672E+000,
      -3.1466666666666665E+000,
      -3.1366666666666667E+000,
      -3.1266666666666665E+000,
      -3.1166666666666667E+000,
      -3.1066666666666669E+000,
      -3.0966666666666667E+000,
      -3.0866666666666669E+000,
      -3.0766666666666667E+000,
      -3.0666666666666669E+000,
      -3.0566666666666671E+000,
      -3.0466666666666664E+000,
      -3.0366666666666666E+000,
      -3.0266666666666664E+000,
      -3.0166666666666666E+000,
      -3.0066666666666668E+000,
      -2.9966666666666666E+000,
      -2.9866666666666668E+000,
      -2.9766666666666666E+000,
      -2.9666666666666668E+000,
      -2.9566666666666670E+000,
      -2.9466666666666663E+000,
      -2.9366666666666665E+000,
      -2.9266666666666663E+000,
      -2.9166666666666665E+000,
      -2.9066666666666667E+000,
      -2.8966666666666665E+000,
      -2.8866666666666667E+000,
      -2.8766666666666665E+000,
      -2.8666666666666667E+000,
      -2.8566666666666669E+000,
      -2.8466666666666662E+000,
      -2.8366666666666664E+000,
      -2.8266666666666662E+000,
      -2.8166666666666664E+000,
      -2.8066666666666666E+000,
      -2.7966666666666664E+000,
      -2.7866666666666666E+000,
      -2.7766666666666664E+000,
      -2.7666666666666666E+000,
      -2.7566666666666668E+000,
      -2.7466666666666661E+000,
      -2.7366666666666664E+000,
      -2.7266666666666661E+000,
      -2.7166666666666663E+000,
      -2.7066666666666666E+000,
      -2.6966666666666663E+000,
      -2.6866666666666665E+000,
      -2.6766666666666663E+000,
      -2.6666666666666665E+000,
      -2.6566666666666667E+000,
      -2.6466666666666661E+000,
      -2.6366666666666663E+000,
      -2.6266666666666660E+000,
      -2.6166666666666663E+000,
      -2.6066666666666665E+000,
      -2.5966666666666667E+000,
      -2.5866666666666669E+000,
      -2.5766666666666671E+000,
      -2.5666666666666669E+000,
      -2.5566666666666671E+000,
      -2.5466666666666664E+000,
      -2.5366666666666666E+000,
      -2.5266666666666668E+000,
      -2.5166666666666666E+000,
      -2.5066666666666668E+000,
      -2.4966666666666666E+000,
      -2.4866666666666668E+000,
      -2.4766666666666670E+000,
      -2.4666666666666672E+000,
      -2.4566666666666666E+000,
      -2.4466666666666663E+000,
      -2.4366666666666665E+000,
      -2.4266666666666667E+000,
      -2.4166666666666670E+000,
      -2.4066666666666663E+000,
      -2.3966666666666674E+000,
      -2.3866666666666667E+000,
      -2.3766666666666669E+000,
      -2.3666666666666671E+000,
      -2.3566666666666665E+000,
      -2.3466666666666676E+000,
      -2.3366666666666664E+000,
      -2.3266666666666667E+000,
      -2.3166666666666669E+000,
      -2.3066666666666662E+000,
      -2.2966666666666673E+000,
      -2.2866666666666666E+000,
      -2.2766666666666668E+000,
      -2.2666666666666671E+000,
      -2.2566666666666673E+000,
      -2.2466666666666675E+000,
      -2.2366666666666664E+000,
      -2.2266666666666675E+000,
      -2.2166666666666668E+000,
      -2.2066666666666670E+000,
      -2.1966666666666672E+000,
      -2.1866666666666665E+000,
      -2.1766666666666676E+000,
      -2.1666666666666670E+000,
      -2.1566666666666672E+000,
      -2.1466666666666674E+000,
      -2.1366666666666663E+000,
      -2.1266666666666674E+000,
      -2.1166666666666667E+000,
      -2.1066666666666669E+000,
      -2.0966666666666671E+000,
      -2.0866666666666664E+000,
      -2.0766666666666675E+000,
      -2.0666666666666669E+000,
      -2.0566666666666671E+000,
      -2.0466666666666673E+000,
      -2.0366666666666662E+000,
      -2.0266666666666673E+000,
      -2.0166666666666666E+000,
      -2.0066666666666668E+000,
      -1.9966666666666670E+000,
      -1.9866666666666664E+000,
      -1.9766666666666675E+000,
      -1.9666666666666666E+000,
      -1.9566666666666677E+000,
      -1.9466666666666670E+000,
      -1.9366666666666663E+000,
      -1.9266666666666674E+000,
      -1.9166666666666665E+000,
      -1.9066666666666676E+000,
      -1.8966666666666669E+000,
      -1.8866666666666663E+000,
      -1.8766666666666674E+000,
      -1.8666666666666665E+000,
      -1.8566666666666676E+000,
      -1.8466666666666669E+000,
      -1.8366666666666662E+000,
      -1.8266666666666673E+000,
      -1.8166666666666664E+000,
      -1.8066666666666675E+000,
      -1.7966666666666669E+000,
      -1.7866666666666662E+000,
      -1.7766666666666673E+000,
      -1.7666666666666664E+000,
      -1.7566666666666675E+000,
      -1.7466666666666668E+000,
      -1.7366666666666661E+000,
      -1.7266666666666672E+000,
      -1.7166666666666663E+000,
      -1.7066666666666674E+000,
      -1.6966666666666668E+000,
      -1.6866666666666661E+000,
      -1.6766666666666672E+000,
      -1.6666666666666663E+000,
      -1.6566666666666674E+000,
      -1.6466666666666667E+000,
      -1.6366666666666660E+000,
      -1.6266666666666671E+000,
      -1.6166666666666663E+000,
      -1.6066666666666674E+000,
      -1.5966666666666667E+000,
      -1.5866666666666660E+000,
      -1.5766666666666671E+000,
      -1.5666666666666662E+000,
      -1.5566666666666673E+000,
      -1.5466666666666666E+000,
      -1.5366666666666660E+000,
      -1.5266666666666671E+000,
      -1.5166666666666662E+000,
      -1.5066666666666673E+000,
      -1.4966666666666666E+000,
      -1.4866666666666659E+000,
      -1.4766666666666670E+000,
      -1.4666666666666661E+000,
      -1.4566666666666672E+000,
      -1.4466666666666665E+000,
      -1.4366666666666659E+000,
      -1.4266666666666670E+000,
      -1.4166666666666661E+000,
      -1.4066666666666672E+000,
      -1.3966666666666665E+000,
      -1.3866666666666676E+000,
      -1.3766666666666669E+000,
      -1.3666666666666660E+000,
      -1.3566666666666671E+000,
      -1.3466666666666665E+000,
      -1.3366666666666676E+000,
      -1.3266666666666669E+000,
      -1.3166666666666660E+000,
      -1.3066666666666671E+000,
      -1.2966666666666664E+000,
      -1.2866666666666675E+000,
      -1.2766666666666668E+000,
      -1.2666666666666659E+000,
      -1.2566666666666670E+000,
      -1.2466666666666664E+000,
      -1.2366666666666675E+000,
      -1.2266666666666668E+000,
      -1.2166666666666659E+000,
      -1.2066666666666670E+000,
      -1.1966666666666663E+000,
      -1.1866666666666674E+000,
      -1.1766666666666667E+000,
      -1.1666666666666679E+000,
      -1.1566666666666670E+000,
      -1.1466666666666681E+000,
      -1.1366666666666656E+000,
      -1.1266666666666667E+000,
      -1.1166666666666658E+000,
      -1.1066666666666669E+000,
      -1.0966666666666680E+000,
      -1.0866666666666673E+000,
      -1.0766666666666667E+000,
      -1.0666666666666678E+000,
      -1.0566666666666669E+000,
      -1.0466666666666680E+000,
      -1.0366666666666673E+000,
      -1.0266666666666666E+000,
      -1.0166666666666677E+000,
      -1.0066666666666668E+000,
      -9.9666666666666792E-001,
      -9.8666666666666725E-001,
      -9.7666666666666646E-001,
      -9.6666666666666756E-001,
      -9.5666666666666678E-001,
      -9.4666666666666788E-001,
      -9.3666666666666720E-001,
      -9.2666666666666642E-001,
      -9.1666666666666752E-001,
      -9.0666666666666673E-001,
      -8.9666666666666783E-001,
      -8.8666666666666716E-001,
      -8.7666666666666637E-001,
      -8.6666666666666747E-001,
      -8.5666666666666669E-001,
      -8.4666666666666779E-001,
      -8.3666666666666711E-001,
      -8.2666666666666633E-001,
      -8.1666666666666743E-001,
      -8.0666666666666664E-001,
      -7.9666666666666774E-001,
      -7.8666666666666707E-001,
      -7.7666666666666628E-001,
      -7.6666666666666738E-001,
      -7.5666666666666660E-001,
      -7.4666666666666770E-001,
      -7.3666666666666702E-001,
      -7.2666666666666624E-001,
      -7.1666666666666734E-001,
      -7.0666666666666655E-001,
      -6.9666666666666766E-001,
      -6.8666666666666698E-001,
      -6.7666666666666619E-001,
      -6.6666666666666730E-001,
      -6.5666666666666651E-001,
      -6.4666666666666761E-001,
      -6.3666666666666694E-001,
      -6.2666666666666615E-001,
      -6.1666666666666725E-001,
      -6.0666666666666647E-001,
      -5.9666666666666757E-001,
      -5.8666666666666689E-001,
      -5.7666666666666611E-001,
      -5.6666666666666721E-001,
      -5.5666666666666642E-001,
      -5.4666666666666752E-001,
      -5.3666666666666685E-001,
      -5.2666666666666606E-001,
      -5.1666666666666716E-001,
      -5.0000000000000044E-001,
      -4.9004999999999932E-001,
      -4.8019999999999918E-001,
      -4.7045000000000003E-001,
      -4.6080000000000010E-001,
      -4.5124999999999937E-001,
      -4.4179999999999964E-001,
      -4.3245000000000089E-001,
      -4.2319999999999952E-001,
      -4.1404999999999914E-001,
      -4.0499999999999980E-001,
      -3.9604999999999968E-001,
      -3.8720000000000054E-001,
      -3.7845000000000056E-001,
      -3.6979999999999980E-001,
      -0.36125,
      -3.5279999999999945E-001,
      -3.4444999999999987E-001,
      -3.3619999999999950E-001,
      -3.2805000000000012E-001,
      -3.1999999999999995E-001,
      -3.1205000000000077E-001,
      -3.0420000000000080E-001,
      -0.29645,
      -2.8880000000000017E-001,
      -2.8124999999999956E-001,
      -0.2738,
      -2.6644999999999958E-001,
      -2.5920000000000021E-001,
      -0.25205,
      -2.4500000000000077E-001,
      -2.3805000000000076E-001,
      -2.3119999999999993E-001,
      -2.2445000000000012E-001,
      -2.1779999999999949E-001,
      -2.1124999999999988E-001,
      -2.0479999999999943E-001,
      -1.9845000000000002E-001,
      -1.9219999999999979E-001,
      -1.8605000000000058E-001,
      -1.8000000000000055E-001,
      -1.7404999999999968E-001,
      -1.6819999999999985E-001,
      -1.6244999999999918E-001,
      -1.5679999999999955E-001,
      -1.5124999999999908E-001,
      -1.4579999999999965E-001,
      -1.4044999999999938E-001,
      -1.3520000000000015E-001,
      -1.3005000000000008E-001,
      -1.2499999999999920E-001,
      -1.2004999999999932E-001,
      -1.1520000000000050E-001,
      -1.1045000000000083E-001,
      -1.0580000000000034E-001,
      -1.0124999999999904E-001,
      -9.6800000000000594E-002,
      -9.2449999999999477E-002,
      -8.8199999999999390E-002,
      -8.4050000000000333E-002,
      -8.0000000000000446E-002,
      -7.6049999999999729E-002,
      -7.2200000000000042E-002,
      -6.8449999999999539E-002,
      -6.4800000000000052E-002,
      -6.1249999999999735E-002,
      -5.7800000000000448E-002,
      -5.4450000000000331E-002,
      -5.1199999999999399E-002,
      -4.8049999999999482E-002,
      -4.5000000000000595E-002,
      -4.2049999999999033E-002,
      -3.9200000000000346E-002,
      -3.6449999999998983E-002,
      -3.3800000000000496E-002,
      -3.1249999999999334E-002,
      -2.8799999999999198E-002,
      -2.6450000000000085E-002,
      -2.4200000000000148E-002,
      -2.2049999999999386E-002,
      -1.9999999999999650E-002,
      -1.8049999999999088E-002,
      -1.6199999999999548E-002,
      -1.4449999999999186E-002,
      -1.2799999999999850E-002,
      -1.1249999999999687E-002,
      -9.8000000000005496E-003,
      -8.4500000000005872E-003,
      -7.1999999999997994E-003,
      -6.0500000000000371E-003,
      -4.9999999999994493E-003,
      -4.0499999999998870E-003,
      -3.1999999999994997E-003,
      -2.4500000000001374E-003,
      -1.7999999999999499E-003,
      -1.2500000000007876E-003,
      -8.0000000000080007E-004,
      -4.4999999999998747E-004,
      -2.0000000000020002E-004,
      -4.9999999999587416E-005,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0
    };

    rtDWork.Traj_pos_ref_PWORK.TimePtr = (void *) pTimeValues;
    rtDWork.Traj_pos_ref_PWORK.DataPtr = (void *) pDataValues;
  }
  {
    /* FromWorkspace Block: <S11>/Traj. vel. ref. */

    static real_T pTimeValues[] = {
      0.0,
      0.001,
      0.002,
      0.003,
      0.004,
      0.005,
      0.006,
      0.007,
      0.008,
      9.0000000000000011E-003,
      0.01,
      0.011,
      0.012,
      1.3000000000000001E-002,
      0.014,
      0.015,
      0.016,
      0.017,
      1.8000000000000002E-002,
      0.019,
      0.02,
      0.021,
      0.022,
      0.023,
      0.024,
      0.025,
      2.6000000000000002E-002,
      0.027,
      0.028,
      0.029,
      0.03,
      0.031,
      0.032,
      0.033,
      0.034,
      0.035,
      3.6000000000000004E-002,
      0.037,
      0.038,
      0.039,
      0.04,
      0.041,
      0.042,
      4.3000000000000003E-002,
      0.044,
      0.045,
      0.046,
      0.047,
      0.048,
      0.049,
      0.05,
      5.1000000000000004E-002,
      5.2000000000000005E-002,
      0.053,
      0.054,
      0.055,
      0.056,
      0.057,
      0.058,
      5.9000000000000004E-002,
      0.06,
      0.061,
      0.062,
      0.063,
      0.064,
      0.065,
      0.066,
      0.067,
      0.068,
      0.069,
      0.07,
      7.1000000000000008E-002,
      7.2000000000000008E-002,
      0.073,
      0.074,
      0.075,
      0.076,
      0.077,
      0.078,
      0.079,
      0.08,
      0.081,
      0.082,
      0.083,
      0.084,
      0.085,
      8.6000000000000007E-002,
      8.7000000000000008E-002,
      0.088,
      0.089,
      0.09,
      0.091,
      0.092,
      0.093,
      0.094,
      0.095,
      0.096,
      0.097,
      0.098,
      0.099,
      0.1,
      0.101,
      1.0200000000000001E-001,
      1.0300000000000001E-001,
      1.0400000000000001E-001,
      0.105,
      0.106,
      0.107,
      0.108,
      0.109,
      0.11,
      0.111,
      0.112,
      0.113,
      0.114,
      0.115,
      0.116,
      0.117,
      1.1800000000000001E-001,
      1.1900000000000001E-001,
      0.12,
      0.121,
      0.122,
      0.123,
      0.124,
      0.125,
      0.126,
      0.127,
      0.128,
      0.129,
      0.13,
      0.131,
      0.132,
      0.133,
      0.134,
      0.135,
      0.136,
      0.137,
      0.138,
      0.139,
      0.14,
      1.4100000000000001E-001,
      1.4200000000000002E-001,
      1.4300000000000002E-001,
      1.4400000000000002E-001,
      0.145,
      0.146,
      0.147,
      0.148,
      0.149,
      0.15,
      0.151,
      0.152,
      0.153,
      0.154,
      0.155,
      0.156,
      0.157,
      0.158,
      0.159,
      0.16,
      0.161,
      0.162,
      0.163,
      0.164,
      0.165,
      0.166,
      0.167,
      0.168,
      0.169,
      0.17,
      0.171,
      1.7200000000000001E-001,
      1.7300000000000001E-001,
      1.7400000000000002E-001,
      1.7500000000000002E-001,
      0.176,
      0.177,
      0.178,
      0.179,
      0.18,
      0.181,
      0.182,
      0.183,
      0.184,
      0.185,
      0.186,
      0.187,
      0.188,
      0.189,
      0.19,
      0.191,
      0.192,
      0.193,
      0.194,
      0.195,
      0.196,
      0.197,
      0.198,
      0.199,
      0.2,
      0.201,
      0.202,
      0.203,
      2.0400000000000001E-001,
      2.0500000000000002E-001,
      2.0600000000000002E-001,
      2.0700000000000002E-001,
      2.0800000000000002E-001,
      0.209,
      0.21,
      0.211,
      0.212,
      0.213,
      0.214,
      0.215,
      0.216,
      0.217,
      0.218,
      0.219,
      0.22,
      0.221,
      0.222,
      0.223,
      0.224,
      0.225,
      0.226,
      0.227,
      0.228,
      0.229,
      0.23,
      0.231,
      0.232,
      0.233,
      0.234,
      2.3500000000000001E-001,
      2.3600000000000002E-001,
      2.3700000000000002E-001,
      2.3800000000000002E-001,
      2.3900000000000002E-001,
      0.24,
      0.241,
      0.242,
      0.243,
      0.244,
      0.245,
      0.246,
      0.247,
      0.248,
      0.249,
      0.25,
      0.251,
      0.252,
      0.253,
      0.254,
      0.255,
      0.256,
      0.257,
      0.258,
      0.259,
      0.26,
      0.261,
      0.262,
      0.263,
      0.264,
      0.265,
      0.266,
      0.267,
      0.268,
      0.269,
      0.27,
      0.271,
      0.272,
      0.273,
      0.274,
      0.275,
      0.276,
      0.277,
      0.278,
      0.279,
      0.28,
      0.281,
      2.8200000000000003E-001,
      2.8300000000000003E-001,
      2.8400000000000003E-001,
      2.8500000000000003E-001,
      2.8600000000000003E-001,
      2.8700000000000003E-001,
      2.8800000000000003E-001,
      0.289,
      0.29,
      0.291,
      0.292,
      0.293,
      0.294,
      0.295,
      0.296,
      0.297,
      0.298,
      0.299,
      0.3,
      0.301,
      0.302,
      0.303,
      0.304,
      0.305,
      0.306,
      0.307,
      0.308,
      0.309,
      0.31,
      0.311,
      0.312,
      0.313,
      0.314,
      0.315,
      0.316,
      0.317,
      0.318,
      0.319,
      0.32,
      0.321,
      0.322,
      0.323,
      0.324,
      0.325,
      0.326,
      0.327,
      0.328,
      0.329,
      0.33,
      0.331,
      0.332,
      0.333,
      0.334,
      0.335,
      0.336,
      0.337,
      0.338,
      0.339,
      0.34,
      0.341,
      0.342,
      0.343,
      3.4400000000000003E-001,
      3.4500000000000003E-001,
      3.4600000000000003E-001,
      3.4700000000000003E-001,
      3.4800000000000003E-001,
      3.4900000000000003E-001,
      3.5000000000000003E-001,
      3.5100000000000003E-001,
      0.352,
      0.353,
      0.354,
      0.355,
      0.356,
      0.357,
      0.358,
      0.359,
      0.36,
      0.361,
      0.362,
      0.363,
      0.364,
      0.365,
      0.366,
      0.367,
      0.368,
      0.369,
      0.37,
      0.371,
      0.372,
      0.373,
      0.374,
      0.375,
      0.376,
      0.377,
      0.378,
      0.379,
      0.38,
      0.381,
      0.382,
      0.383,
      0.384,
      0.385,
      0.386,
      0.387,
      0.388,
      0.389,
      0.39,
      0.391,
      0.392,
      0.393,
      0.394,
      0.395,
      0.396,
      0.397,
      0.398,
      0.399,
      0.4,
      0.401,
      0.402,
      0.403,
      0.404,
      0.405,
      0.406,
      4.0700000000000003E-001,
      4.0800000000000003E-001,
      4.0900000000000003E-001,
      4.1000000000000003E-001,
      4.1100000000000003E-001,
      4.1200000000000003E-001,
      4.1300000000000003E-001,
      4.1400000000000003E-001,
      4.1500000000000004E-001,
      4.1600000000000004E-001,
      0.417,
      0.418,
      0.419,
      0.42,
      0.421,
      0.422,
      0.423,
      0.424,
      0.425,
      0.426,
      0.427,
      0.428,
      0.429,
      0.43,
      0.431,
      0.432,
      0.433,
      0.434,
      0.435,
      0.436,
      0.437,
      0.438,
      0.439,
      0.44,
      0.441,
      0.442,
      0.443,
      0.444,
      0.445,
      0.446,
      0.447,
      0.448,
      0.449,
      0.45,
      0.451,
      0.452,
      0.453,
      0.454,
      0.455,
      0.456,
      0.457,
      0.458,
      0.459,
      0.46,
      0.461,
      0.462,
      0.463,
      0.464,
      0.465,
      0.466,
      0.467,
      0.468,
      4.6900000000000003E-001,
      4.7000000000000003E-001,
      4.7100000000000003E-001,
      4.7200000000000003E-001,
      4.7300000000000003E-001,
      4.7400000000000003E-001,
      4.7500000000000003E-001,
      4.7600000000000003E-001,
      4.7700000000000004E-001,
      4.7800000000000004E-001,
      4.7900000000000004E-001,
      0.48,
      0.481,
      0.482,
      0.483,
      0.484,
      0.485,
      0.486,
      0.487,
      0.488,
      0.489,
      0.49,
      0.491,
      0.492,
      0.493,
      0.494,
      0.495,
      0.496,
      0.497,
      0.498,
      0.499,
      0.5,
      0.501,
      0.502,
      0.503,
      0.504,
      0.505,
      0.506,
      0.507,
      0.508,
      0.509,
      0.51,
      0.511,
      0.512,
      0.513,
      0.514,
      0.515,
      0.516,
      0.517,
      0.518,
      0.519,
      0.52,
      0.521,
      0.522,
      0.523,
      0.524,
      0.525,
      0.526,
      0.527,
      0.528,
      0.529,
      0.53,
      0.531,
      0.532,
      0.533,
      0.534,
      0.535,
      0.536,
      0.537,
      0.538,
      0.539,
      0.54,
      0.541,
      0.542,
      0.543,
      0.544,
      0.545,
      0.546,
      0.547,
      0.548,
      0.549,
      0.55,
      0.551,
      0.552,
      0.553,
      0.554,
      0.555,
      0.556,
      0.557,
      0.558,
      0.559,
      0.56,
      0.561,
      0.562,
      5.6300000000000006E-001,
      5.6400000000000006E-001,
      5.6500000000000006E-001,
      5.6600000000000006E-001,
      5.6700000000000006E-001,
      5.6800000000000006E-001,
      5.6900000000000006E-001,
      5.7000000000000006E-001,
      5.7100000000000006E-001,
      5.7200000000000006E-001,
      5.7300000000000006E-001,
      5.7400000000000007E-001,
      5.7500000000000007E-001,
      5.7600000000000007E-001,
      0.577,
      0.578,
      0.579,
      0.58,
      0.581,
      0.582,
      0.583,
      0.584,
      0.585,
      0.586,
      0.587,
      0.588,
      0.589,
      0.59,
      0.591,
      0.592,
      0.593,
      0.594,
      0.595,
      0.596,
      0.597,
      0.598,
      0.599,
      0.6,
      0.601,
      0.602,
      0.603,
      0.604,
      0.605,
      0.606,
      0.607,
      0.608,
      0.609,
      0.61,
      0.611,
      0.612,
      0.613,
      0.614,
      0.615,
      0.616,
      0.617,
      0.618,
      0.619,
      0.62,
      0.621,
      0.622,
      0.623,
      0.624,
      0.625,
      0.626,
      0.627,
      0.628,
      0.629,
      0.63,
      0.631,
      0.632,
      0.633,
      0.634,
      0.635,
      0.636,
      0.637,
      0.638,
      0.639,
      0.64,
      0.641,
      0.642,
      0.643,
      0.644,
      0.645,
      0.646,
      0.647,
      0.648,
      0.649,
      0.65,
      0.651,
      0.652,
      0.653,
      0.654,
      0.655,
      0.656,
      0.657,
      0.658,
      0.659,
      0.66,
      0.661,
      0.662,
      0.663,
      0.664,
      0.665,
      0.666,
      0.667,
      0.668,
      0.669,
      0.67,
      0.671,
      0.672,
      0.673,
      0.674,
      0.675,
      0.676,
      0.677,
      0.678,
      0.679,
      0.68,
      0.681,
      0.682,
      0.683,
      0.684,
      0.685,
      0.686,
      0.687,
      6.8800000000000006E-001,
      6.8900000000000006E-001,
      6.9000000000000006E-001,
      6.9100000000000006E-001,
      6.9200000000000006E-001,
      6.9300000000000006E-001,
      6.9400000000000006E-001,
      6.9500000000000006E-001,
      6.9600000000000006E-001,
      6.9700000000000006E-001,
      6.9800000000000006E-001,
      6.9900000000000007E-001,
      7.0000000000000007E-001,
      7.0100000000000007E-001,
      7.0200000000000007E-001,
      7.0300000000000007E-001,
      0.704,
      0.705,
      0.706,
      0.707,
      0.708,
      0.709,
      0.71,
      0.711,
      0.712,
      0.713,
      0.714,
      0.715,
      0.716,
      0.717,
      0.718,
      0.719,
      0.72,
      0.721,
      0.722,
      0.723,
      0.724,
      0.725,
      0.726,
      0.727,
      0.728,
      0.729,
      0.73,
      0.731,
      0.732,
      0.733,
      0.734,
      0.735,
      0.736,
      0.737,
      0.738,
      0.739,
      0.74,
      0.741,
      0.742,
      0.743,
      0.744,
      0.745,
      0.746,
      0.747,
      0.748,
      0.749,
      0.75,
      0.751,
      0.752,
      0.753,
      0.754,
      0.755,
      0.756,
      0.757,
      0.758,
      0.759,
      0.76,
      0.761,
      0.762,
      0.763,
      0.764,
      0.765,
      0.766,
      0.767,
      0.768,
      0.769,
      0.77,
      0.771,
      0.772,
      0.773,
      0.774,
      0.775,
      0.776,
      0.777,
      0.778,
      0.779,
      0.78,
      0.781,
      0.782,
      0.783,
      0.784,
      0.785,
      0.786,
      0.787,
      0.788,
      0.789,
      0.79,
      0.791,
      0.792,
      0.793,
      0.794,
      0.795,
      0.796,
      0.797,
      0.798,
      0.799,
      0.8,
      0.801,
      0.802,
      0.803,
      0.804,
      0.805,
      0.806,
      0.807,
      0.808,
      0.809,
      0.81,
      0.811,
      0.812,
      8.1300000000000006E-001,
      8.1400000000000006E-001,
      8.1500000000000006E-001,
      8.1600000000000006E-001,
      8.1700000000000006E-001,
      8.1800000000000006E-001,
      8.1900000000000006E-001,
      8.2000000000000006E-001,
      8.2100000000000006E-001,
      8.2200000000000006E-001,
      8.2300000000000006E-001,
      8.2400000000000007E-001,
      8.2500000000000007E-001,
      8.2600000000000007E-001,
      8.2700000000000007E-001,
      8.2800000000000007E-001,
      8.2900000000000007E-001,
      8.3000000000000007E-001,
      8.3100000000000007E-001,
      8.3200000000000007E-001,
      0.833,
      0.834,
      0.835,
      0.836,
      0.837,
      0.838,
      0.839,
      0.84,
      0.841,
      0.842,
      0.843,
      0.844,
      0.845,
      0.846,
      0.847,
      0.848,
      0.849,
      0.85,
      0.851,
      0.852,
      0.853,
      0.854,
      0.855,
      0.856,
      0.857,
      0.858,
      0.859,
      0.86,
      0.861,
      0.862,
      0.863,
      0.864,
      0.865,
      0.866,
      0.867,
      0.868,
      0.869,
      0.87,
      0.871,
      0.872,
      0.873,
      0.874,
      0.875,
      0.876,
      0.877,
      0.878,
      0.879,
      0.88,
      0.881,
      0.882,
      0.883,
      0.884,
      0.885,
      0.886,
      0.887,
      0.888,
      0.889,
      0.89,
      0.891,
      0.892,
      0.893,
      0.894,
      0.895,
      0.896,
      0.897,
      0.898,
      0.899,
      0.9,
      0.901,
      0.902,
      0.903,
      0.904,
      0.905,
      0.906,
      0.907,
      0.908,
      0.909,
      0.91,
      0.911,
      0.912,
      0.913,
      0.914,
      0.915,
      0.916,
      0.917,
      0.918,
      0.919,
      0.92,
      0.921,
      0.922,
      0.923,
      0.924,
      0.925,
      0.926,
      0.927,
      0.928,
      0.929,
      0.93,
      0.931,
      0.932,
      0.933,
      0.934,
      0.935,
      0.936,
      0.937,
      9.3800000000000006E-001,
      9.3900000000000006E-001,
      9.4000000000000006E-001,
      9.4100000000000006E-001,
      9.4200000000000006E-001,
      9.4300000000000006E-001,
      9.4400000000000006E-001,
      9.4500000000000006E-001,
      9.4600000000000006E-001,
      9.4700000000000006E-001,
      9.4800000000000006E-001,
      9.4900000000000007E-001,
      9.5000000000000007E-001,
      9.5100000000000007E-001,
      9.5200000000000007E-001,
      9.5300000000000007E-001,
      9.5400000000000007E-001,
      9.5500000000000007E-001,
      9.5600000000000007E-001,
      9.5700000000000007E-001,
      9.5800000000000007E-001,
      9.5900000000000007E-001,
      0.96,
      0.961,
      0.962,
      0.963,
      0.964,
      0.965,
      0.966,
      0.967,
      0.968,
      0.969,
      0.97,
      0.971,
      0.972,
      0.973,
      0.974,
      0.975,
      0.976,
      0.977,
      0.978,
      0.979,
      0.98,
      0.981,
      0.982,
      0.983,
      0.984,
      0.985,
      0.986,
      0.987,
      0.988,
      0.989,
      0.99,
      0.991,
      0.992,
      0.993,
      0.994,
      0.995,
      0.996,
      0.997,
      0.998,
      0.999,
      1.0,
      1.0010000000000001E+000,
      1.002,
      1.0030000000000001E+000,
      1.004,
      1.0050000000000001E+000,
      1.006,
      1.0070000000000001E+000,
      1.008,
      1.0090000000000001E+000,
      1.01,
      1.0110000000000001E+000,
      1.012,
      1.0130000000000001E+000,
      1.014,
      1.0150000000000001E+000,
      1.016,
      1.0170000000000001E+000,
      1.018,
      1.0190000000000001E+000,
      1.02,
      1.0210000000000001E+000,
      1.022,
      1.0230000000000001E+000,
      1.024,
      1.025,
      1.026,
      1.027,
      1.028,
      1.029,
      1.03,
      1.031,
      1.032,
      1.033,
      1.034,
      1.035,
      1.036,
      1.037,
      1.038,
      1.039,
      1.04,
      1.041,
      1.042,
      1.043,
      1.044,
      1.045,
      1.046,
      1.047,
      1.048,
      1.049,
      1.05,
      1.051,
      1.052,
      1.053,
      1.054,
      1.055,
      1.056,
      1.057,
      1.058,
      1.059,
      1.06,
      1.061,
      1.062,
      1.063,
      1.064,
      1.065,
      1.066,
      1.067,
      1.068,
      1.069,
      1.07,
      1.071,
      1.072,
      1.073,
      1.074,
      1.075,
      1.076,
      1.077,
      1.078,
      1.079,
      1.08,
      1.081,
      1.082,
      1.083,
      1.084,
      1.085,
      1.086,
      1.087,
      1.088,
      1.089,
      1.09,
      1.091,
      1.092,
      1.093,
      1.094,
      1.095,
      1.096,
      1.097,
      1.098,
      1.099,
      1.1,
      1.101,
      1.102,
      1.103,
      1.104,
      1.105,
      1.106,
      1.107,
      1.108,
      1.109,
      1.11,
      1.111,
      1.112,
      1.113,
      1.114,
      1.115,
      1.116,
      1.117,
      1.118,
      1.119,
      1.12,
      1.121,
      1.122,
      1.123,
      1.124,
      1.125,
      1.1260000000000001E+000,
      1.127,
      1.1280000000000001E+000,
      1.129,
      1.1300000000000001E+000,
      1.131,
      1.1320000000000001E+000,
      1.133,
      1.1340000000000001E+000,
      1.135,
      1.1360000000000001E+000,
      1.137,
      1.1380000000000001E+000,
      1.139,
      1.1400000000000001E+000,
      1.141,
      1.1420000000000001E+000,
      1.143,
      1.1440000000000001E+000,
      1.145,
      1.1460000000000001E+000,
      1.147,
      1.1480000000000001E+000,
      1.149,
      1.1500000000000001E+000,
      1.151,
      1.1520000000000001E+000,
      1.153,
      1.154,
      1.155,
      1.156,
      1.157,
      1.158,
      1.159,
      1.16,
      1.161,
      1.162,
      1.163,
      1.164,
      1.165,
      1.166,
      1.167,
      1.168,
      1.169,
      1.17,
      1.171,
      1.172,
      1.173,
      1.174,
      1.175,
      1.176,
      1.177,
      1.178,
      1.179,
      1.18,
      1.181,
      1.182,
      1.183,
      1.184,
      1.185,
      1.186,
      1.187,
      1.188,
      1.189,
      1.19,
      1.191,
      1.192,
      1.193,
      1.194,
      1.195,
      1.196,
      1.197,
      1.198,
      1.199,
      1.2,
      1.201,
      1.202,
      1.203,
      1.204,
      1.205,
      1.206,
      1.207,
      1.208,
      1.209,
      1.21,
      1.211,
      1.212,
      1.213,
      1.214,
      1.215,
      1.216,
      1.217,
      1.218,
      1.219,
      1.22,
      1.221,
      1.222,
      1.223,
      1.224,
      1.225,
      1.226,
      1.227,
      1.228,
      1.229,
      1.23,
      1.231,
      1.232,
      1.233,
      1.234,
      1.235,
      1.236,
      1.237,
      1.238,
      1.239,
      1.24,
      1.241,
      1.242,
      1.243,
      1.244,
      1.245,
      1.246,
      1.247,
      1.248,
      1.249,
      1.25,
      1.2510000000000001E+000,
      1.252,
      1.2530000000000001E+000,
      1.254,
      1.2550000000000001E+000,
      1.256,
      1.2570000000000001E+000,
      1.258,
      1.2590000000000001E+000,
      1.26,
      1.2610000000000001E+000,
      1.262,
      1.2630000000000001E+000,
      1.264,
      1.2650000000000001E+000,
      1.266,
      1.2670000000000001E+000,
      1.268,
      1.2690000000000001E+000,
      1.27,
      1.2710000000000001E+000,
      1.272,
      1.2730000000000001E+000,
      1.274,
      1.2750000000000001E+000,
      1.276,
      1.2770000000000001E+000,
      1.278,
      1.2790000000000001E+000,
      1.28,
      1.281,
      1.282,
      1.283,
      1.284,
      1.285,
      1.286,
      1.287,
      1.288,
      1.289,
      1.29,
      1.291,
      1.292,
      1.293,
      1.294,
      1.295,
      1.296,
      1.297,
      1.298,
      1.299,
      1.3,
      1.301,
      1.302,
      1.303,
      1.304,
      1.305,
      1.306,
      1.307,
      1.308,
      1.309,
      1.31,
      1.311,
      1.312,
      1.313,
      1.314,
      1.315,
      1.316,
      1.317,
      1.318,
      1.319,
      1.32,
      1.321,
      1.322,
      1.323,
      1.324,
      1.325,
      1.326,
      1.327,
      1.328,
      1.329,
      1.33,
      1.331,
      1.332,
      1.333,
      1.334,
      1.335,
      1.336,
      1.337,
      1.338,
      1.339,
      1.34,
      1.341,
      1.342,
      1.343,
      1.344,
      1.345,
      1.346,
      1.347,
      1.348,
      1.349,
      1.35,
      1.351,
      1.352,
      1.353,
      1.354,
      1.355,
      1.356,
      1.357,
      1.358,
      1.359,
      1.36,
      1.361,
      1.362,
      1.363,
      1.364,
      1.365,
      1.366,
      1.367,
      1.368,
      1.369,
      1.37,
      1.371,
      1.372,
      1.373,
      1.374,
      1.375,
      1.3760000000000001E+000,
      1.377,
      1.3780000000000001E+000,
      1.379,
      1.3800000000000001E+000,
      1.381,
      1.3820000000000001E+000,
      1.383,
      1.3840000000000001E+000,
      1.385,
      1.3860000000000001E+000,
      1.387,
      1.3880000000000001E+000,
      1.389,
      1.3900000000000001E+000,
      1.391,
      1.3920000000000001E+000,
      1.393,
      1.3940000000000001E+000,
      1.395,
      1.3960000000000001E+000,
      1.397,
      1.3980000000000001E+000,
      1.399,
      1.4000000000000001E+000,
      1.401,
      1.4020000000000001E+000,
      1.403,
      1.4040000000000001E+000,
      1.405,
      1.4060000000000001E+000,
      1.407,
      1.408,
      1.409,
      1.41,
      1.411,
      1.412,
      1.413,
      1.414,
      1.415,
      1.416,
      1.417,
      1.418,
      1.419,
      1.42,
      1.421,
      1.422,
      1.423,
      1.424,
      1.425,
      1.426,
      1.427,
      1.428,
      1.429,
      1.43,
      1.431,
      1.432,
      1.433,
      1.434,
      1.435,
      1.436,
      1.437,
      1.438,
      1.439,
      1.44,
      1.441,
      1.442,
      1.443,
      1.444,
      1.445,
      1.446,
      1.447,
      1.448,
      1.449,
      1.45,
      1.451,
      1.452,
      1.453,
      1.454,
      1.455,
      1.456,
      1.457,
      1.458,
      1.459,
      1.46,
      1.461,
      1.462,
      1.463,
      1.464,
      1.465,
      1.466,
      1.467,
      1.468,
      1.469,
      1.47,
      1.471,
      1.472,
      1.473,
      1.474,
      1.475,
      1.476,
      1.477,
      1.478,
      1.479,
      1.48,
      1.481,
      1.482,
      1.483,
      1.484,
      1.485,
      1.486,
      1.487,
      1.488,
      1.489,
      1.49,
      1.491,
      1.492,
      1.493,
      1.494,
      1.495,
      1.496,
      1.497,
      1.498,
      1.499,
      1.5,
      1.5010000000000001E+000,
      1.502,
      1.5030000000000001E+000,
      1.504,
      1.5050000000000001E+000,
      1.506,
      1.5070000000000001E+000,
      1.508,
      1.5090000000000001E+000,
      1.51,
      1.5110000000000001E+000,
      1.512,
      1.5130000000000001E+000,
      1.514,
      1.5150000000000001E+000,
      1.516,
      1.5170000000000001E+000,
      1.518,
      1.5190000000000001E+000,
      1.52,
      1.5210000000000001E+000,
      1.522,
      1.5230000000000001E+000,
      1.524,
      1.5250000000000001E+000,
      1.526,
      1.5270000000000001E+000,
      1.528,
      1.5290000000000001E+000,
      1.53,
      1.5310000000000001E+000,
      1.532,
      1.5330000000000001E+000,
      1.534,
      1.5350000000000001E+000,
      1.536,
      1.537,
      1.538,
      1.539,
      1.54,
      1.541,
      1.542,
      1.543,
      1.544,
      1.545,
      1.546,
      1.547,
      1.548,
      1.549,
      1.55,
      1.551,
      1.552,
      1.553,
      1.554,
      1.555,
      1.556,
      1.557,
      1.558,
      1.559,
      1.56,
      1.561,
      1.562,
      1.563,
      1.564,
      1.565,
      1.566,
      1.567,
      1.568,
      1.569,
      1.57,
      1.571,
      1.572,
      1.573,
      1.574,
      1.575,
      1.576,
      1.577,
      1.578,
      1.579,
      1.58,
      1.581,
      1.582,
      1.583,
      1.584,
      1.585,
      1.586,
      1.587,
      1.588,
      1.589,
      1.59,
      1.591,
      1.592,
      1.593,
      1.594,
      1.595,
      1.596,
      1.597,
      1.598,
      1.599,
      1.6,
      1.601,
      1.602,
      1.603,
      1.604,
      1.605,
      1.606,
      1.607,
      1.608,
      1.609,
      1.61,
      1.611,
      1.612,
      1.613,
      1.614,
      1.615,
      1.616,
      1.617,
      1.618,
      1.619,
      1.62,
      1.621,
      1.622,
      1.623,
      1.624,
      1.625,
      1.6260000000000001E+000,
      1.627,
      1.6280000000000001E+000,
      1.629,
      1.6300000000000001E+000,
      1.631,
      1.6320000000000001E+000,
      1.633,
      1.6340000000000001E+000,
      1.635,
      1.6360000000000001E+000,
      1.637,
      1.6380000000000001E+000,
      1.639,
      1.6400000000000001E+000,
      1.641,
      1.6420000000000001E+000,
      1.643,
      1.6440000000000001E+000,
      1.645,
      1.6460000000000001E+000,
      1.647,
      1.6480000000000001E+000,
      1.649,
      1.6500000000000001E+000,
      1.651,
      1.6520000000000001E+000,
      1.653,
      1.6540000000000001E+000,
      1.655,
      1.6560000000000001E+000,
      1.657,
      1.6580000000000001E+000,
      1.659,
      1.6600000000000001E+000,
      1.661,
      1.6620000000000001E+000,
      1.663,
      1.6640000000000001E+000,
      1.665,
      1.666,
      1.667,
      1.668,
      1.669,
      1.67,
      1.671,
      1.672,
      1.673,
      1.674,
      1.675,
      1.676,
      1.677,
      1.678,
      1.679,
      1.68,
      1.681,
      1.682,
      1.683,
      1.684,
      1.685,
      1.686,
      1.687,
      1.688,
      1.689,
      1.69,
      1.691,
      1.692,
      1.693,
      1.694,
      1.695,
      1.696,
      1.697,
      1.698,
      1.699,
      1.7,
      1.701,
      1.702,
      1.703,
      1.704,
      1.705,
      1.706,
      1.707,
      1.708,
      1.709,
      1.71,
      1.711,
      1.712,
      1.713,
      1.714,
      1.715,
      1.716,
      1.717,
      1.718,
      1.719,
      1.72,
      1.721,
      1.722,
      1.723,
      1.724,
      1.725,
      1.726,
      1.727,
      1.728,
      1.729,
      1.73,
      1.731,
      1.732,
      1.733,
      1.734,
      1.735,
      1.736,
      1.737,
      1.738,
      1.739,
      1.74,
      1.741,
      1.742,
      1.743,
      1.744,
      1.745,
      1.746,
      1.747,
      1.748,
      1.749,
      1.75,
      1.7510000000000001E+000,
      1.752,
      1.7530000000000001E+000,
      1.754,
      1.7550000000000001E+000,
      1.756,
      1.7570000000000001E+000,
      1.758,
      1.7590000000000001E+000,
      1.76,
      1.7610000000000001E+000,
      1.762,
      1.7630000000000001E+000,
      1.764,
      1.7650000000000001E+000,
      1.766,
      1.7670000000000001E+000,
      1.768,
      1.7690000000000001E+000,
      1.77,
      1.7710000000000001E+000,
      1.772,
      1.7730000000000001E+000,
      1.774,
      1.7750000000000001E+000,
      1.776,
      1.7770000000000001E+000,
      1.778,
      1.7790000000000001E+000,
      1.78,
      1.7810000000000001E+000,
      1.782,
      1.7830000000000001E+000,
      1.784,
      1.7850000000000001E+000,
      1.786,
      1.7870000000000001E+000,
      1.788,
      1.7890000000000001E+000,
      1.79,
      1.7910000000000001E+000,
      1.792,
      1.793,
      1.794,
      1.795,
      1.796,
      1.797,
      1.798,
      1.799,
      1.8,
      1.801,
      1.802,
      1.803,
      1.804,
      1.805,
      1.806,
      1.807,
      1.808,
      1.809,
      1.81,
      1.811,
      1.812,
      1.813,
      1.814,
      1.815,
      1.816,
      1.817,
      1.818,
      1.819,
      1.82,
      1.821,
      1.822,
      1.823,
      1.824,
      1.825,
      1.826,
      1.827,
      1.828,
      1.829,
      1.83,
      1.831,
      1.832,
      1.833,
      1.834,
      1.835,
      1.836,
      1.837,
      1.838,
      1.839,
      1.84,
      1.841,
      1.842,
      1.843,
      1.844,
      1.845,
      1.846,
      1.847,
      1.848,
      1.849,
      1.85,
      1.851,
      1.852,
      1.853,
      1.854,
      1.855,
      1.856,
      1.857,
      1.858,
      1.859,
      1.86,
      1.861,
      1.862,
      1.863,
      1.864,
      1.865,
      1.866,
      1.867,
      1.868,
      1.869,
      1.87,
      1.871,
      1.872,
      1.873,
      1.874,
      1.875,
      1.8760000000000001E+000,
      1.877,
      1.8780000000000001E+000,
      1.879,
      1.8800000000000001E+000,
      1.881,
      1.8820000000000001E+000,
      1.883,
      1.8840000000000001E+000,
      1.885,
      1.8860000000000001E+000,
      1.887,
      1.8880000000000001E+000,
      1.889,
      1.8900000000000001E+000,
      1.891,
      1.8920000000000001E+000,
      1.893,
      1.8940000000000001E+000,
      1.895,
      1.8960000000000001E+000,
      1.897,
      1.8980000000000001E+000,
      1.899,
      1.9000000000000001E+000,
      1.901,
      1.9020000000000001E+000,
      1.903,
      1.9040000000000001E+000,
      1.905,
      1.9060000000000001E+000,
      1.907,
      1.9080000000000001E+000,
      1.909,
      1.9100000000000001E+000,
      1.911,
      1.9120000000000001E+000,
      1.913,
      1.9140000000000001E+000,
      1.915,
      1.9160000000000001E+000,
      1.917,
      1.9180000000000001E+000,
      1.919,
      1.92,
      1.921,
      1.922,
      1.923,
      1.924,
      1.925,
      1.926,
      1.927,
      1.928,
      1.929,
      1.93,
      1.931,
      1.932,
      1.933,
      1.934,
      1.935,
      1.936,
      1.937,
      1.938,
      1.939,
      1.94,
      1.941,
      1.942,
      1.943,
      1.944,
      1.945,
      1.946,
      1.947,
      1.948,
      1.949,
      1.95,
      1.951,
      1.952,
      1.953,
      1.954,
      1.955,
      1.956,
      1.957,
      1.958,
      1.959,
      1.96,
      1.961,
      1.962,
      1.963,
      1.964,
      1.965,
      1.966,
      1.967,
      1.968,
      1.969,
      1.97,
      1.971,
      1.972,
      1.973,
      1.974,
      1.975,
      1.976,
      1.977,
      1.978,
      1.979,
      1.98,
      1.981,
      1.982,
      1.983,
      1.984,
      1.985,
      1.986,
      1.987,
      1.988,
      1.989,
      1.99,
      1.991,
      1.992,
      1.993,
      1.994,
      1.995,
      1.996,
      1.997,
      1.998,
      1.999,
      2.0,
      2.001,
      2.0020000000000002E+000,
      2.003,
      2.004,
      2.005,
      2.0060000000000002E+000,
      2.007,
      2.008,
      2.009,
      2.0100000000000002E+000,
      2.011,
      2.012,
      2.013,
      2.0140000000000002E+000,
      2.015,
      2.016,
      2.017,
      2.0180000000000002E+000,
      2.019,
      2.02,
      2.021,
      2.0220000000000002E+000,
      2.023,
      2.024,
      2.025,
      2.0260000000000002E+000,
      2.027,
      2.028,
      2.029,
      2.0300000000000002E+000,
      2.031,
      2.032,
      2.033,
      2.0340000000000003E+000,
      2.035,
      2.036,
      2.037,
      2.0380000000000003E+000,
      2.039,
      2.04,
      2.041,
      2.0420000000000003E+000,
      2.043,
      2.044,
      2.045,
      2.0460000000000003E+000,
      2.047,
      2.048,
      2.049,
      2.05,
      2.051,
      2.052,
      2.053,
      2.054,
      2.055,
      2.056,
      2.057,
      2.058,
      2.059,
      2.06,
      2.061,
      2.062,
      2.063,
      2.064,
      2.065,
      2.066,
      2.067,
      2.068,
      2.069,
      2.07,
      2.071,
      2.072,
      2.073,
      2.074,
      2.075,
      2.076,
      2.077,
      2.078,
      2.079,
      2.08,
      2.081,
      2.082,
      2.083,
      2.084,
      2.085,
      2.086,
      2.087,
      2.088,
      2.089,
      2.09,
      2.091,
      2.092,
      2.093,
      2.094,
      2.095,
      2.096,
      2.097,
      2.098,
      2.099,
      2.1,
      2.101,
      2.102,
      2.103,
      2.104,
      2.105,
      2.106,
      2.107,
      2.108,
      2.109,
      2.11,
      2.111,
      2.112,
      2.113,
      2.114,
      2.115,
      2.116,
      2.117,
      2.118,
      2.119,
      2.12,
      2.121,
      2.122,
      2.123,
      2.124,
      2.125,
      2.126,
      2.1270000000000002E+000,
      2.128,
      2.129,
      2.13,
      2.1310000000000002E+000,
      2.132,
      2.133,
      2.134,
      2.1350000000000002E+000,
      2.136,
      2.137,
      2.138,
      2.1390000000000002E+000,
      2.14,
      2.141,
      2.142,
      2.1430000000000002E+000,
      2.144,
      2.145,
      2.146,
      2.1470000000000002E+000,
      2.148,
      2.149,
      2.15,
      2.1510000000000002E+000,
      2.152,
      2.153,
      2.154,
      2.1550000000000002E+000,
      2.156,
      2.157,
      2.158,
      2.1590000000000003E+000,
      2.16,
      2.161,
      2.162,
      2.1630000000000003E+000,
      2.164,
      2.165,
      2.166,
      2.1670000000000003E+000,
      2.168,
      2.169,
      2.17,
      2.1710000000000003E+000,
      2.172,
      2.173,
      2.174,
      2.1750000000000003E+000,
      2.176,
      2.177,
      2.178,
      2.179,
      2.18,
      2.181,
      2.182,
      2.183,
      2.184,
      2.185,
      2.186,
      2.187,
      2.188,
      2.189,
      2.19,
      2.191,
      2.192,
      2.193,
      2.194,
      2.195,
      2.196,
      2.197,
      2.198,
      2.199,
      2.2,
      2.201,
      2.202,
      2.203,
      2.204,
      2.205,
      2.206,
      2.207,
      2.208,
      2.209,
      2.21,
      2.211,
      2.212,
      2.213,
      2.214,
      2.215,
      2.216,
      2.217,
      2.218,
      2.219,
      2.22,
      2.221,
      2.222,
      2.223,
      2.224,
      2.225,
      2.226,
      2.227,
      2.228,
      2.229,
      2.23,
      2.231,
      2.232,
      2.233,
      2.234,
      2.235,
      2.236,
      2.237,
      2.238,
      2.239,
      2.24,
      2.241,
      2.242,
      2.243,
      2.244,
      2.245,
      2.246,
      2.247,
      2.248,
      2.249,
      2.25,
      2.251,
      2.2520000000000002E+000,
      2.253,
      2.254,
      2.255,
      2.2560000000000002E+000,
      2.257,
      2.258,
      2.259,
      2.2600000000000002E+000,
      2.261,
      2.262,
      2.263,
      2.2640000000000002E+000,
      2.265,
      2.266,
      2.267,
      2.2680000000000002E+000,
      2.269,
      2.27,
      2.271,
      2.2720000000000002E+000,
      2.273,
      2.274,
      2.275,
      2.2760000000000002E+000,
      2.277,
      2.278,
      2.279,
      2.2800000000000002E+000,
      2.281,
      2.282,
      2.283,
      2.2840000000000003E+000,
      2.285,
      2.286,
      2.287,
      2.2880000000000003E+000,
      2.289,
      2.29,
      2.291,
      2.2920000000000003E+000,
      2.293,
      2.294,
      2.295,
      2.2960000000000003E+000,
      2.297,
      2.298,
      2.299,
      2.3000000000000003E+000,
      2.301,
      2.302,
      2.303,
      2.3040000000000003E+000,
      2.305,
      2.306,
      2.307,
      2.308,
      2.309,
      2.31,
      2.311,
      2.312,
      2.313,
      2.314,
      2.315,
      2.316,
      2.317,
      2.318,
      2.319,
      2.32,
      2.321,
      2.322,
      2.323,
      2.324,
      2.325,
      2.326,
      2.327,
      2.328,
      2.329,
      2.33,
      2.331,
      2.332,
      2.333,
      2.334,
      2.335,
      2.336,
      2.337,
      2.338,
      2.339,
      2.34,
      2.341,
      2.342,
      2.343,
      2.344,
      2.345,
      2.346,
      2.347,
      2.348,
      2.349,
      2.35,
      2.351,
      2.352,
      2.353,
      2.354,
      2.355,
      2.356,
      2.357,
      2.358,
      2.359,
      2.36,
      2.361,
      2.362,
      2.363,
      2.364,
      2.365,
      2.366,
      2.367,
      2.368,
      2.369,
      2.37,
      2.371,
      2.372,
      2.373,
      2.374,
      2.375,
      2.376,
      2.3770000000000002E+000,
      2.378,
      2.379,
      2.38,
      2.3810000000000002E+000,
      2.382,
      2.383,
      2.384,
      2.3850000000000002E+000,
      2.386,
      2.387,
      2.388,
      2.3890000000000002E+000,
      2.39,
      2.391,
      2.392,
      2.3930000000000002E+000,
      2.394,
      2.395,
      2.396,
      2.3970000000000002E+000,
      2.398,
      2.399,
      2.4,
      2.4010000000000002E+000,
      2.402,
      2.403,
      2.404,
      2.4050000000000002E+000,
      2.406,
      2.407,
      2.408,
      2.4090000000000003E+000,
      2.41,
      2.411,
      2.412,
      2.4130000000000003E+000,
      2.414,
      2.415,
      2.416,
      2.4170000000000003E+000,
      2.418,
      2.419,
      2.42,
      2.4210000000000003E+000,
      2.422,
      2.423,
      2.424,
      2.4250000000000003E+000,
      2.426,
      2.427,
      2.428,
      2.4290000000000003E+000,
      2.43,
      2.431,
      2.432,
      2.433,
      2.434,
      2.435,
      2.436,
      2.437,
      2.438,
      2.439,
      2.44,
      2.441,
      2.442,
      2.443,
      2.444,
      2.445,
      2.446,
      2.447,
      2.448,
      2.449,
      2.45,
      2.451,
      2.452,
      2.453,
      2.454,
      2.455,
      2.456,
      2.457,
      2.458,
      2.459,
      2.46,
      2.461,
      2.462,
      2.463,
      2.464,
      2.465,
      2.466,
      2.467,
      2.468,
      2.469,
      2.47,
      2.471,
      2.472,
      2.473,
      2.474,
      2.475,
      2.476,
      2.477,
      2.478,
      2.479,
      2.48,
      2.481,
      2.482,
      2.483,
      2.484,
      2.485,
      2.486,
      2.487,
      2.488,
      2.489,
      2.49,
      2.491,
      2.492,
      2.493,
      2.494,
      2.495,
      2.496,
      2.497,
      2.498,
      2.499,
      2.5,
      2.501,
      2.5020000000000002E+000,
      2.503,
      2.504,
      2.505,
      2.5060000000000002E+000,
      2.507,
      2.508,
      2.509,
      2.5100000000000002E+000,
      2.511,
      2.512,
      2.513,
      2.5140000000000002E+000,
      2.515,
      2.516,
      2.517,
      2.5180000000000002E+000,
      2.519,
      2.52,
      2.521,
      2.5220000000000002E+000,
      2.523,
      2.524,
      2.525,
      2.5260000000000002E+000,
      2.527,
      2.528,
      2.529,
      2.5300000000000002E+000,
      2.531,
      2.532,
      2.533,
      2.5340000000000003E+000,
      2.535,
      2.536,
      2.537,
      2.5380000000000003E+000,
      2.539,
      2.54,
      2.541,
      2.5420000000000003E+000,
      2.543,
      2.544,
      2.545,
      2.5460000000000003E+000,
      2.547,
      2.548,
      2.549,
      2.5500000000000003E+000,
      2.551,
      2.552,
      2.553,
      2.5540000000000003E+000,
      2.555,
      2.556,
      2.557,
      2.5580000000000003E+000,
      2.559,
      2.56,
      2.561,
      2.562,
      2.563,
      2.564,
      2.565,
      2.566,
      2.567,
      2.568,
      2.569,
      2.57,
      2.571,
      2.572,
      2.573,
      2.574,
      2.575,
      2.576,
      2.577,
      2.578,
      2.579,
      2.58,
      2.581,
      2.582,
      2.583,
      2.584,
      2.585,
      2.586,
      2.587,
      2.588,
      2.589,
      2.59,
      2.591,
      2.592,
      2.593,
      2.594,
      2.595,
      2.596,
      2.597,
      2.598,
      2.599,
      2.6,
      2.601,
      2.602,
      2.603,
      2.604,
      2.605,
      2.606,
      2.607,
      2.608,
      2.609,
      2.61,
      2.611,
      2.612,
      2.613,
      2.614,
      2.615,
      2.616,
      2.617,
      2.618,
      2.619,
      2.62,
      2.621,
      2.622,
      2.623,
      2.624,
      2.625,
      2.626,
      2.6270000000000002E+000,
      2.628,
      2.629,
      2.63,
      2.6310000000000002E+000,
      2.632,
      2.633,
      2.634,
      2.6350000000000002E+000,
      2.636,
      2.637,
      2.638,
      2.6390000000000002E+000,
      2.64,
      2.641,
      2.642,
      2.6430000000000002E+000,
      2.644,
      2.645,
      2.646,
      2.6470000000000002E+000,
      2.648,
      2.649,
      2.65,
      2.6510000000000002E+000,
      2.652,
      2.653,
      2.654,
      2.6550000000000002E+000,
      2.656,
      2.657,
      2.658,
      2.6590000000000003E+000,
      2.66,
      2.661,
      2.662,
      2.6630000000000003E+000,
      2.664,
      2.665,
      2.666,
      2.6670000000000003E+000,
      2.668,
      2.669,
      2.67,
      2.6710000000000003E+000,
      2.672,
      2.673,
      2.674,
      2.6750000000000003E+000,
      2.676,
      2.677,
      2.678,
      2.6790000000000003E+000,
      2.68,
      2.681,
      2.682,
      2.6830000000000003E+000,
      2.684,
      2.685,
      2.686,
      2.6870000000000003E+000,
      2.688,
      2.689,
      2.69,
      2.691,
      2.692,
      2.693,
      2.694,
      2.695,
      2.696,
      2.697,
      2.698,
      2.699,
      2.7,
      2.701,
      2.702,
      2.703,
      2.704,
      2.705,
      2.706,
      2.707,
      2.708,
      2.709,
      2.71,
      2.711,
      2.712,
      2.713,
      2.714,
      2.715,
      2.716,
      2.717,
      2.718,
      2.719,
      2.72,
      2.721,
      2.722,
      2.723,
      2.724,
      2.725,
      2.726,
      2.727,
      2.728,
      2.729,
      2.73,
      2.731,
      2.732,
      2.733,
      2.734,
      2.735,
      2.736,
      2.737,
      2.738,
      2.739,
      2.74,
      2.741,
      2.742,
      2.743,
      2.744,
      2.745,
      2.746,
      2.747,
      2.748,
      2.749,
      2.75,
      2.751,
      2.7520000000000002E+000,
      2.753,
      2.754,
      2.755,
      2.7560000000000002E+000,
      2.757,
      2.758,
      2.759,
      2.7600000000000002E+000,
      2.761,
      2.762,
      2.763,
      2.7640000000000002E+000,
      2.765,
      2.766,
      2.767,
      2.7680000000000002E+000,
      2.769,
      2.77,
      2.771,
      2.7720000000000002E+000,
      2.773,
      2.774,
      2.775,
      2.7760000000000002E+000,
      2.777,
      2.778,
      2.779,
      2.7800000000000002E+000,
      2.781,
      2.782,
      2.783,
      2.7840000000000003E+000,
      2.785,
      2.786,
      2.787,
      2.7880000000000003E+000,
      2.789,
      2.79,
      2.791,
      2.7920000000000003E+000,
      2.793,
      2.794,
      2.795,
      2.7960000000000003E+000,
      2.797,
      2.798,
      2.799,
      2.8000000000000003E+000,
      2.801,
      2.802,
      2.803,
      2.8040000000000003E+000,
      2.805,
      2.806,
      2.807,
      2.8080000000000003E+000,
      2.809,
      2.81,
      2.811,
      2.8120000000000003E+000,
      2.813,
      2.814,
      2.815,
      2.816,
      2.817,
      2.818,
      2.819,
      2.82,
      2.821,
      2.822,
      2.823,
      2.824,
      2.825,
      2.826,
      2.827,
      2.828,
      2.829,
      2.83,
      2.831,
      2.832,
      2.833,
      2.834,
      2.835,
      2.836,
      2.837,
      2.838,
      2.839,
      2.84,
      2.841,
      2.842,
      2.843,
      2.844,
      2.845,
      2.846,
      2.847,
      2.848,
      2.849,
      2.85,
      2.851,
      2.852,
      2.853,
      2.854,
      2.855,
      2.856,
      2.857,
      2.858,
      2.859,
      2.86,
      2.861,
      2.862,
      2.863,
      2.864,
      2.865,
      2.866,
      2.867,
      2.868,
      2.869,
      2.87,
      2.871,
      2.872,
      2.873,
      2.874,
      2.875,
      2.876,
      2.8770000000000002E+000,
      2.878,
      2.879,
      2.88,
      2.8810000000000002E+000,
      2.882,
      2.883,
      2.884,
      2.8850000000000002E+000,
      2.886,
      2.887,
      2.888,
      2.8890000000000002E+000,
      2.89,
      2.891,
      2.892,
      2.8930000000000002E+000,
      2.894,
      2.895,
      2.896,
      2.8970000000000002E+000,
      2.898,
      2.899,
      2.9,
      2.9010000000000002E+000,
      2.902,
      2.903,
      2.904,
      2.9050000000000002E+000,
      2.906,
      2.907,
      2.908,
      2.9090000000000003E+000,
      2.91,
      2.911,
      2.912,
      2.9130000000000003E+000,
      2.914,
      2.915,
      2.916,
      2.9170000000000003E+000,
      2.918,
      2.919,
      2.92,
      2.9210000000000003E+000,
      2.922,
      2.923,
      2.924,
      2.9250000000000003E+000,
      2.926,
      2.927,
      2.928,
      2.9290000000000003E+000,
      2.93,
      2.931,
      2.932,
      2.9330000000000003E+000,
      2.934,
      2.935,
      2.936,
      2.9370000000000003E+000,
      2.938,
      2.939,
      2.94,
      2.9410000000000003E+000,
      2.942,
      2.943,
      2.944,
      2.945,
      2.946,
      2.947,
      2.948,
      2.949,
      2.95,
      2.951,
      2.952,
      2.953,
      2.954,
      2.955,
      2.956,
      2.957,
      2.958,
      2.959,
      2.96,
      2.961,
      2.962,
      2.963,
      2.964,
      2.965,
      2.966,
      2.967,
      2.968,
      2.969,
      2.97,
      2.971,
      2.972,
      2.973,
      2.974,
      2.975,
      2.976,
      2.977,
      2.978,
      2.979,
      2.98,
      2.981,
      2.982,
      2.983,
      2.984,
      2.985,
      2.986,
      2.987,
      2.988,
      2.989,
      2.99,
      2.991,
      2.992,
      2.993,
      2.994,
      2.995,
      2.996,
      2.997,
      2.998,
      2.999,
      3.0,
      3.001,
      3.0020000000000002E+000,
      3.003,
      3.004,
      3.005,
      3.0060000000000002E+000,
      3.007,
      3.008,
      3.009,
      3.0100000000000002E+000,
      3.011,
      3.012,
      3.013,
      3.0140000000000002E+000,
      3.015,
      3.016,
      3.017,
      3.0180000000000002E+000,
      3.019,
      3.02,
      3.021,
      3.0220000000000002E+000,
      3.023,
      3.024,
      3.025,
      3.0260000000000002E+000,
      3.027,
      3.028,
      3.029,
      3.0300000000000002E+000,
      3.031,
      3.032,
      3.033,
      3.0340000000000003E+000,
      3.035,
      3.036,
      3.037,
      3.0380000000000003E+000,
      3.039,
      3.04,
      3.041,
      3.0420000000000003E+000,
      3.043,
      3.044,
      3.045,
      3.0460000000000003E+000,
      3.047,
      3.048,
      3.049,
      3.0500000000000003E+000,
      3.051,
      3.052,
      3.053,
      3.0540000000000003E+000,
      3.055,
      3.056,
      3.057,
      3.0580000000000003E+000,
      3.059,
      3.06,
      3.061,
      3.0620000000000003E+000,
      3.063,
      3.064,
      3.065,
      3.0660000000000003E+000,
      3.067,
      3.068,
      3.069,
      3.0700000000000003E+000,
      3.071,
      3.072,
      3.073,
      3.074,
      3.075,
      3.076,
      3.077,
      3.078,
      3.079,
      3.08,
      3.081,
      3.082,
      3.083,
      3.084,
      3.085,
      3.086,
      3.087,
      3.088,
      3.089,
      3.09,
      3.091,
      3.092,
      3.093,
      3.094,
      3.095,
      3.096,
      3.097,
      3.098,
      3.099,
      3.1,
      3.101,
      3.102,
      3.103,
      3.104,
      3.105,
      3.106,
      3.107,
      3.108,
      3.109,
      3.11,
      3.111,
      3.112,
      3.113,
      3.114,
      3.115,
      3.116,
      3.117,
      3.118,
      3.119,
      3.12,
      3.121,
      3.122,
      3.123,
      3.124,
      3.125,
      3.126,
      3.1270000000000002E+000,
      3.128,
      3.129,
      3.13,
      3.1310000000000002E+000,
      3.132,
      3.133,
      3.134,
      3.1350000000000002E+000,
      3.136,
      3.137,
      3.138,
      3.1390000000000002E+000,
      3.14,
      3.141,
      3.142,
      3.1430000000000002E+000,
      3.144,
      3.145,
      3.146,
      3.1470000000000002E+000,
      3.148,
      3.149,
      3.15,
      3.1510000000000002E+000,
      3.152,
      3.153,
      3.154,
      3.1550000000000002E+000,
      3.156,
      3.157,
      3.158,
      3.1590000000000003E+000,
      3.16,
      3.161,
      3.162,
      3.1630000000000003E+000,
      3.164,
      3.165,
      3.166,
      3.1670000000000003E+000,
      3.168,
      3.169,
      3.17,
      3.1710000000000003E+000,
      3.172,
      3.173,
      3.174,
      3.1750000000000003E+000,
      3.176,
      3.177,
      3.178,
      3.1790000000000003E+000,
      3.18,
      3.181,
      3.182,
      3.1830000000000003E+000,
      3.184,
      3.185,
      3.186,
      3.1870000000000003E+000,
      3.188,
      3.189,
      3.19,
      3.1910000000000003E+000,
      3.192,
      3.193,
      3.194,
      3.1950000000000003E+000,
      3.196,
      3.197,
      3.198,
      3.1990000000000003E+000,
      3.2,
      3.201,
      3.202,
      3.203,
      3.204,
      3.205,
      3.206,
      3.207,
      3.208,
      3.209,
      3.21,
      3.211,
      3.212,
      3.213,
      3.214,
      3.215,
      3.216,
      3.217,
      3.218,
      3.219,
      3.22,
      3.221,
      3.222,
      3.223,
      3.224,
      3.225,
      3.226,
      3.227,
      3.228,
      3.229,
      3.23,
      3.231,
      3.232,
      3.233,
      3.234,
      3.235,
      3.236,
      3.237,
      3.238,
      3.239,
      3.24,
      3.241,
      3.242,
      3.243,
      3.244,
      3.245,
      3.246,
      3.247,
      3.248,
      3.249,
      3.25,
      3.251,
      3.2520000000000002E+000,
      3.253,
      3.254,
      3.255,
      3.2560000000000002E+000,
      3.257,
      3.258,
      3.259,
      3.2600000000000002E+000,
      3.261,
      3.262,
      3.263,
      3.2640000000000002E+000,
      3.265,
      3.266,
      3.267,
      3.2680000000000002E+000,
      3.269,
      3.27,
      3.271,
      3.2720000000000002E+000,
      3.273,
      3.274,
      3.275,
      3.2760000000000002E+000,
      3.277,
      3.278,
      3.279,
      3.2800000000000002E+000,
      3.281,
      3.282,
      3.283,
      3.2840000000000003E+000,
      3.285,
      3.286,
      3.287,
      3.2880000000000003E+000,
      3.289,
      3.29,
      3.291,
      3.2920000000000003E+000,
      3.293,
      3.294,
      3.295,
      3.2960000000000003E+000,
      3.297,
      3.298,
      3.299,
      3.3000000000000003E+000,
      3.301,
      3.302,
      3.303,
      3.3040000000000003E+000,
      3.305,
      3.306,
      3.307,
      3.3080000000000003E+000,
      3.309,
      3.31,
      3.311,
      3.3120000000000003E+000,
      3.313,
      3.314,
      3.315,
      3.3160000000000003E+000,
      3.317,
      3.318,
      3.319,
      3.3200000000000003E+000,
      3.321,
      3.322,
      3.323,
      3.3240000000000003E+000,
      3.325,
      3.326,
      3.327,
      3.3280000000000003E+000,
      3.329,
      3.33,
      3.331,
      3.332,
      3.333,
      3.334,
      3.335,
      3.336,
      3.337,
      3.338,
      3.339,
      3.34,
      3.341,
      3.342,
      3.343,
      3.344,
      3.345,
      3.346,
      3.347,
      3.348,
      3.349,
      3.35,
      3.351,
      3.352,
      3.353,
      3.354,
      3.355,
      3.356,
      3.357,
      3.358,
      3.359,
      3.36,
      3.361,
      3.362,
      3.363,
      3.364,
      3.365,
      3.366,
      3.367,
      3.368,
      3.369,
      3.37,
      3.371,
      3.372,
      3.373,
      3.374,
      3.375,
      3.376,
      3.3770000000000002E+000,
      3.378,
      3.379,
      3.38,
      3.3810000000000002E+000,
      3.382,
      3.383,
      3.384,
      3.3850000000000002E+000,
      3.386,
      3.387,
      3.388,
      3.3890000000000002E+000,
      3.39,
      3.391,
      3.392,
      3.3930000000000002E+000,
      3.394,
      3.395,
      3.396,
      3.3970000000000002E+000,
      3.398,
      3.399,
      3.4,
      3.4010000000000002E+000,
      3.402,
      3.403,
      3.404,
      3.4050000000000002E+000,
      3.406,
      3.407,
      3.408,
      3.4090000000000003E+000,
      3.41,
      3.411,
      3.412,
      3.4130000000000003E+000,
      3.414,
      3.415,
      3.416,
      3.4170000000000003E+000,
      3.418,
      3.419,
      3.42,
      3.4210000000000003E+000,
      3.422,
      3.423,
      3.424,
      3.4250000000000003E+000,
      3.426,
      3.427,
      3.428,
      3.4290000000000003E+000,
      3.43,
      3.431,
      3.432,
      3.4330000000000003E+000,
      3.434,
      3.435,
      3.436,
      3.4370000000000003E+000,
      3.438,
      3.439,
      3.44,
      3.4410000000000003E+000,
      3.442,
      3.443,
      3.444,
      3.4450000000000003E+000,
      3.446,
      3.447,
      3.448,
      3.4490000000000003E+000,
      3.45,
      3.451,
      3.452,
      3.4530000000000003E+000,
      3.454,
      3.455,
      3.456,
      3.457,
      3.458,
      3.459,
      3.46,
      3.461,
      3.462,
      3.463,
      3.464,
      3.465,
      3.466,
      3.467,
      3.468,
      3.469,
      3.47,
      3.471,
      3.472,
      3.473,
      3.474,
      3.475,
      3.476,
      3.477,
      3.478,
      3.479,
      3.48,
      3.481,
      3.482,
      3.483,
      3.484,
      3.485,
      3.486,
      3.487,
      3.488,
      3.489,
      3.49,
      3.491,
      3.492,
      3.493,
      3.494,
      3.495,
      3.496,
      3.497,
      3.498,
      3.499,
      3.5,
      3.501,
      3.5020000000000002E+000,
      3.503,
      3.504,
      3.505,
      3.5060000000000002E+000,
      3.507,
      3.508,
      3.509,
      3.5100000000000002E+000,
      3.511,
      3.512,
      3.513,
      3.5140000000000002E+000,
      3.515,
      3.516,
      3.517,
      3.5180000000000002E+000,
      3.519,
      3.52,
      3.521,
      3.5220000000000002E+000,
      3.523,
      3.524,
      3.525,
      3.5260000000000002E+000,
      3.527,
      3.528,
      3.529,
      3.5300000000000002E+000,
      3.531,
      3.532,
      3.533,
      3.5340000000000003E+000,
      3.535,
      3.536,
      3.537,
      3.5380000000000003E+000,
      3.539,
      3.54,
      3.541,
      3.5420000000000003E+000,
      3.543,
      3.544,
      3.545,
      3.5460000000000003E+000,
      3.547,
      3.548,
      3.549,
      3.5500000000000003E+000,
      3.551,
      3.552,
      3.553,
      3.5540000000000003E+000,
      3.555,
      3.556,
      3.557,
      3.5580000000000003E+000,
      3.559,
      3.56,
      3.561,
      3.5620000000000003E+000,
      3.563,
      3.564,
      3.565,
      3.5660000000000003E+000,
      3.567,
      3.568,
      3.569,
      3.5700000000000003E+000,
      3.571,
      3.572,
      3.573,
      3.5740000000000003E+000,
      3.575,
      3.576,
      3.577,
      3.5780000000000003E+000,
      3.579,
      3.58,
      3.581,
      3.5820000000000003E+000,
      3.583,
      3.584,
      3.585,
      3.586,
      3.587,
      3.588,
      3.589,
      3.59,
      3.591,
      3.592,
      3.593,
      3.594,
      3.595,
      3.596,
      3.597,
      3.598,
      3.599,
      3.6,
      3.601,
      3.602,
      3.603,
      3.604,
      3.605,
      3.606,
      3.607,
      3.608,
      3.609,
      3.61,
      3.611,
      3.612,
      3.613,
      3.614,
      3.615,
      3.616,
      3.617,
      3.618,
      3.619,
      3.62,
      3.621,
      3.622,
      3.623,
      3.624,
      3.625,
      3.626,
      3.6270000000000002E+000,
      3.628,
      3.629,
      3.63,
      3.6310000000000002E+000,
      3.632,
      3.633,
      3.634,
      3.6350000000000002E+000,
      3.636,
      3.637,
      3.638,
      3.6390000000000002E+000,
      3.64,
      3.641,
      3.642,
      3.6430000000000002E+000,
      3.644,
      3.645,
      3.646,
      3.6470000000000002E+000,
      3.648,
      3.649,
      3.65,
      3.6510000000000002E+000,
      3.652,
      3.653,
      3.654,
      3.6550000000000002E+000,
      3.656,
      3.657,
      3.658,
      3.6590000000000003E+000,
      3.66,
      3.661,
      3.662,
      3.6630000000000003E+000,
      3.664,
      3.665,
      3.666,
      3.6670000000000003E+000,
      3.668,
      3.669,
      3.67,
      3.6710000000000003E+000,
      3.672,
      3.673,
      3.674,
      3.6750000000000003E+000,
      3.676,
      3.677,
      3.678,
      3.6790000000000003E+000,
      3.68,
      3.681,
      3.682,
      3.6830000000000003E+000,
      3.684,
      3.685,
      3.686,
      3.6870000000000003E+000,
      3.688,
      3.689,
      3.69,
      3.6910000000000003E+000,
      3.692,
      3.693,
      3.694,
      3.6950000000000003E+000,
      3.696,
      3.697,
      3.698,
      3.6990000000000003E+000,
      3.7,
      3.701,
      3.702,
      3.7030000000000003E+000,
      3.704,
      3.705,
      3.706,
      3.7070000000000003E+000,
      3.708,
      3.709,
      3.71,
      3.7110000000000003E+000,
      3.712,
      3.713,
      3.714,
      3.715,
      3.716,
      3.717,
      3.718,
      3.719,
      3.72,
      3.721,
      3.722,
      3.723,
      3.724,
      3.725,
      3.726,
      3.727,
      3.728,
      3.729,
      3.73,
      3.731,
      3.732,
      3.733,
      3.734,
      3.735,
      3.736,
      3.737,
      3.738,
      3.739,
      3.74,
      3.741,
      3.742,
      3.743,
      3.744,
      3.745,
      3.746,
      3.747,
      3.748,
      3.749,
      3.75,
      3.751,
      3.7520000000000002E+000,
      3.753,
      3.754,
      3.755,
      3.7560000000000002E+000,
      3.757,
      3.758,
      3.759,
      3.7600000000000002E+000,
      3.761,
      3.762,
      3.763,
      3.7640000000000002E+000,
      3.765,
      3.766,
      3.767,
      3.7680000000000002E+000,
      3.769,
      3.77,
      3.771,
      3.7720000000000002E+000,
      3.773,
      3.774,
      3.775,
      3.7760000000000002E+000,
      3.777,
      3.778,
      3.779,
      3.7800000000000002E+000,
      3.781,
      3.782,
      3.783,
      3.7840000000000003E+000,
      3.785,
      3.786,
      3.787,
      3.7880000000000003E+000,
      3.789,
      3.79,
      3.791,
      3.7920000000000003E+000,
      3.793,
      3.794,
      3.795,
      3.7960000000000003E+000,
      3.797,
      3.798,
      3.799,
      3.8000000000000003E+000,
      3.801,
      3.802,
      3.803,
      3.8040000000000003E+000,
      3.805,
      3.806,
      3.807,
      3.8080000000000003E+000,
      3.809,
      3.81,
      3.811,
      3.8120000000000003E+000,
      3.813,
      3.814,
      3.815,
      3.8160000000000003E+000,
      3.817,
      3.818,
      3.819,
      3.8200000000000003E+000,
      3.821,
      3.822,
      3.823,
      3.8240000000000003E+000,
      3.825,
      3.826,
      3.827,
      3.8280000000000003E+000,
      3.829,
      3.83,
      3.831,
      3.8320000000000003E+000,
      3.833,
      3.834,
      3.835,
      3.8360000000000003E+000,
      3.837,
      3.838,
      3.839,
      3.84,
      3.841,
      3.842,
      3.843,
      3.844,
      3.845,
      3.846,
      3.847,
      3.848,
      3.849,
      3.85,
      3.851,
      3.852,
      3.853,
      3.854,
      3.855,
      3.856,
      3.857,
      3.858,
      3.859,
      3.86,
      3.861,
      3.862,
      3.863,
      3.864,
      3.865,
      3.866,
      3.867,
      3.868,
      3.869,
      3.87,
      3.871,
      3.872,
      3.873,
      3.874,
      3.875,
      3.876,
      3.8770000000000002E+000,
      3.878,
      3.879,
      3.88,
      3.8810000000000002E+000,
      3.882,
      3.883,
      3.884,
      3.8850000000000002E+000,
      3.886,
      3.887,
      3.888,
      3.8890000000000002E+000,
      3.89,
      3.891,
      3.892,
      3.8930000000000002E+000,
      3.894,
      3.895,
      3.896,
      3.8970000000000002E+000,
      3.898,
      3.899,
      3.9,
      3.9010000000000002E+000,
      3.902,
      3.903,
      3.904,
      3.9050000000000002E+000,
      3.906,
      3.907,
      3.908,
      3.9090000000000003E+000,
      3.91,
      3.911,
      3.912,
      3.9130000000000003E+000,
      3.914,
      3.915,
      3.916,
      3.9170000000000003E+000,
      3.918,
      3.919,
      3.92,
      3.9210000000000003E+000,
      3.922,
      3.923,
      3.924,
      3.9250000000000003E+000,
      3.926,
      3.927,
      3.928,
      3.9290000000000003E+000,
      3.93,
      3.931,
      3.932,
      3.9330000000000003E+000,
      3.934,
      3.935,
      3.936,
      3.9370000000000003E+000,
      3.938,
      3.939,
      3.94,
      3.9410000000000003E+000,
      3.942,
      3.943,
      3.944,
      3.9450000000000003E+000,
      3.946,
      3.947,
      3.948,
      3.9490000000000003E+000,
      3.95,
      3.951,
      3.952,
      3.9530000000000003E+000,
      3.954,
      3.955,
      3.956,
      3.9570000000000003E+000,
      3.958,
      3.959,
      3.96,
      3.9610000000000003E+000,
      3.962,
      3.963,
      3.964,
      3.9650000000000003E+000,
      3.966,
      3.967,
      3.968,
      3.969,
      3.97,
      3.971,
      3.972,
      3.973,
      3.974,
      3.975,
      3.976,
      3.977,
      3.978,
      3.979,
      3.98,
      3.981,
      3.982,
      3.983,
      3.984,
      3.985,
      3.986,
      3.987,
      3.988,
      3.989,
      3.99,
      3.991,
      3.992,
      3.993,
      3.994,
      3.995,
      3.996,
      3.997,
      3.998,
      3.999,
      4.0,
      4.001,
      4.002,
      4.003,
      4.0040000000000004E+000,
      4.005,
      4.006,
      4.007,
      4.008,
      4.009,
      4.01,
      4.011,
      4.0120000000000005E+000,
      4.013,
      4.014,
      4.015,
      4.016,
      4.017,
      4.018,
      4.019,
      4.0200000000000005E+000,
      4.021,
      4.022,
      4.023,
      4.024,
      4.025,
      4.026,
      4.027,
      4.0280000000000005E+000,
      4.029,
      4.03,
      4.031,
      4.032,
      4.033,
      4.034,
      4.035,
      4.0360000000000005E+000,
      4.037,
      4.038,
      4.039,
      4.04,
      4.041,
      4.042,
      4.043,
      4.0440000000000005E+000,
      4.045,
      4.046,
      4.047,
      4.048,
      4.049,
      4.05,
      4.051,
      4.0520000000000005E+000,
      4.053,
      4.054,
      4.055,
      4.056,
      4.057,
      4.058,
      4.059,
      4.0600000000000005E+000,
      4.061,
      4.062,
      4.063,
      4.064,
      4.065,
      4.066,
      4.067,
      4.0680000000000005E+000,
      4.069,
      4.07,
      4.071,
      4.072,
      4.073,
      4.074,
      4.075,
      4.0760000000000005E+000,
      4.077,
      4.078,
      4.079,
      4.08,
      4.081,
      4.082,
      4.083,
      4.0840000000000005E+000,
      4.085,
      4.086,
      4.087,
      4.088,
      4.089,
      4.09,
      4.091,
      4.0920000000000005E+000,
      4.093,
      4.094,
      4.095,
      4.096,
      4.097,
      4.098,
      4.099,
      4.1,
      4.101,
      4.102,
      4.103,
      4.104,
      4.105,
      4.106,
      4.107,
      4.108,
      4.109,
      4.11,
      4.111,
      4.112,
      4.113,
      4.114,
      4.115,
      4.116,
      4.117,
      4.118,
      4.119,
      4.12,
      4.121,
      4.122,
      4.123,
      4.124,
      4.125,
      4.126,
      4.127,
      4.128,
      4.1290000000000004E+000,
      4.13,
      4.131,
      4.132,
      4.133,
      4.134,
      4.135,
      4.136,
      4.1370000000000005E+000,
      4.138,
      4.139,
      4.14,
      4.141,
      4.142,
      4.143,
      4.144,
      4.1450000000000005E+000,
      4.146,
      4.147,
      4.148,
      4.149,
      4.15,
      4.151,
      4.152,
      4.1530000000000005E+000,
      4.154,
      4.155,
      4.156,
      4.157,
      4.158,
      4.159,
      4.16,
      4.1610000000000005E+000,
      4.162,
      4.163,
      4.164,
      4.165,
      4.166,
      4.167,
      4.168,
      4.1690000000000005E+000,
      4.17,
      4.171,
      4.172,
      4.173,
      4.174,
      4.175,
      4.176,
      4.1770000000000005E+000,
      4.178,
      4.179,
      4.18,
      4.181,
      4.182,
      4.183,
      4.184,
      4.1850000000000005E+000,
      4.186,
      4.187,
      4.188,
      4.189,
      4.19,
      4.191,
      4.192,
      4.1930000000000005E+000,
      4.194,
      4.195,
      4.196,
      4.197,
      4.198,
      4.199,
      4.2,
      4.2010000000000005E+000,
      4.202,
      4.203,
      4.204,
      4.205,
      4.206,
      4.207,
      4.208,
      4.2090000000000005E+000,
      4.21,
      4.211,
      4.212,
      4.213,
      4.214,
      4.215,
      4.216,
      4.2170000000000005E+000,
      4.218,
      4.219,
      4.22,
      4.221,
      4.222,
      4.223,
      4.224,
      4.225,
      4.226,
      4.227,
      4.228,
      4.229,
      4.23,
      4.231,
      4.232,
      4.233,
      4.234,
      4.235,
      4.236,
      4.237,
      4.238,
      4.239,
      4.24,
      4.241,
      4.242,
      4.243,
      4.244,
      4.245,
      4.246,
      4.247,
      4.248,
      4.249,
      4.25,
      4.251,
      4.252,
      4.253,
      4.2540000000000004E+000,
      4.255,
      4.256,
      4.257,
      4.258,
      4.259,
      4.26,
      4.261,
      4.2620000000000005E+000,
      4.263,
      4.264,
      4.265,
      4.266,
      4.267,
      4.268,
      4.269,
      4.2700000000000005E+000,
      4.271,
      4.272,
      4.273,
      4.274,
      4.275,
      4.276,
      4.277,
      4.2780000000000005E+000,
      4.279,
      4.28,
      4.281,
      4.282,
      4.283,
      4.284,
      4.285,
      4.2860000000000005E+000,
      4.287,
      4.288,
      4.289,
      4.29,
      4.291,
      4.292,
      4.293,
      4.2940000000000005E+000,
      4.295,
      4.296,
      4.297,
      4.298,
      4.299,
      4.3,
      4.301,
      4.3020000000000005E+000,
      4.303,
      4.304,
      4.305,
      4.306,
      4.307,
      4.308,
      4.309,
      4.3100000000000005E+000,
      4.311,
      4.312,
      4.313,
      4.314,
      4.315,
      4.316,
      4.317,
      4.3180000000000005E+000,
      4.319,
      4.32,
      4.321,
      4.322,
      4.323,
      4.324,
      4.325,
      4.3260000000000005E+000,
      4.327,
      4.328,
      4.329,
      4.33,
      4.331,
      4.332,
      4.333,
      4.3340000000000005E+000,
      4.335,
      4.336,
      4.337,
      4.338,
      4.339,
      4.34,
      4.341,
      4.3420000000000005E+000,
      4.343,
      4.344,
      4.345,
      4.346,
      4.347,
      4.348,
      4.349,
      4.3500000000000005E+000,
      4.351,
      4.352,
      4.353,
      4.354,
      4.355,
      4.356,
      4.357,
      4.358,
      4.359,
      4.36,
      4.361,
      4.362,
      4.363,
      4.364,
      4.365,
      4.366,
      4.367,
      4.368,
      4.369,
      4.37,
      4.371,
      4.372,
      4.373,
      4.374,
      4.375,
      4.376,
      4.377,
      4.378,
      4.3790000000000004E+000,
      4.38,
      4.381,
      4.382,
      4.383,
      4.384,
      4.385,
      4.386,
      4.3870000000000005E+000,
      4.388,
      4.389,
      4.39,
      4.391,
      4.392,
      4.393,
      4.394,
      4.3950000000000005E+000,
      4.396,
      4.397,
      4.398,
      4.399,
      4.4,
      4.401,
      4.402,
      4.4030000000000005E+000,
      4.404,
      4.405,
      4.406,
      4.407,
      4.408,
      4.409,
      4.41,
      4.4110000000000005E+000,
      4.412,
      4.413,
      4.414,
      4.415,
      4.416,
      4.417,
      4.418,
      4.4190000000000005E+000,
      4.42,
      4.421,
      4.422,
      4.423,
      4.424,
      4.425,
      4.426,
      4.4270000000000005E+000,
      4.428,
      4.429,
      4.43,
      4.431,
      4.432,
      4.433,
      4.434,
      4.4350000000000005E+000,
      4.436,
      4.437,
      4.438,
      4.439,
      4.44,
      4.441,
      4.442,
      4.4430000000000005E+000,
      4.444,
      4.445,
      4.446,
      4.447,
      4.448,
      4.449,
      4.45,
      4.4510000000000005E+000,
      4.452,
      4.453,
      4.454,
      4.455,
      4.456,
      4.457,
      4.458,
      4.4590000000000005E+000,
      4.46,
      4.461,
      4.462,
      4.463,
      4.464,
      4.465,
      4.466,
      4.4670000000000005E+000,
      4.468,
      4.469,
      4.47,
      4.471,
      4.472,
      4.473,
      4.474,
      4.4750000000000005E+000,
      4.476,
      4.477,
      4.478,
      4.479,
      4.48,
      4.481,
      4.482,
      4.483,
      4.484,
      4.485,
      4.486,
      4.487,
      4.488,
      4.489,
      4.49,
      4.491,
      4.492,
      4.493,
      4.494,
      4.495,
      4.496,
      4.497,
      4.498,
      4.499,
      4.5,
      4.501,
      4.502,
      4.503,
      4.5040000000000004E+000,
      4.505,
      4.506,
      4.507,
      4.508,
      4.509,
      4.51,
      4.511,
      4.5120000000000005E+000,
      4.513,
      4.514,
      4.515,
      4.516,
      4.517,
      4.518,
      4.519,
      4.5200000000000005E+000,
      4.521,
      4.522,
      4.523,
      4.524,
      4.525,
      4.526,
      4.527,
      4.5280000000000005E+000,
      4.529,
      4.53,
      4.531,
      4.532,
      4.533,
      4.534,
      4.535,
      4.5360000000000005E+000,
      4.537,
      4.538,
      4.539,
      4.54,
      4.541,
      4.542,
      4.543,
      4.5440000000000005E+000,
      4.545,
      4.546,
      4.547,
      4.548,
      4.549,
      4.55,
      4.551,
      4.5520000000000005E+000,
      4.553,
      4.554,
      4.555,
      4.556,
      4.557,
      4.558,
      4.559,
      4.5600000000000005E+000,
      4.561,
      4.562,
      4.563,
      4.564,
      4.565,
      4.566,
      4.567,
      4.5680000000000005E+000,
      4.569,
      4.57,
      4.571,
      4.572,
      4.573,
      4.574,
      4.575,
      4.5760000000000005E+000,
      4.577,
      4.578,
      4.579,
      4.58,
      4.581,
      4.582,
      4.583,
      4.5840000000000005E+000,
      4.585,
      4.586,
      4.587,
      4.588,
      4.589,
      4.59,
      4.591,
      4.5920000000000005E+000,
      4.593,
      4.594,
      4.595,
      4.596,
      4.597,
      4.598,
      4.599,
      4.6000000000000005E+000,
      4.601,
      4.602,
      4.603,
      4.604,
      4.605,
      4.606,
      4.607,
      4.6080000000000005E+000,
      4.609,
      4.61,
      4.611,
      4.612,
      4.613,
      4.614,
      4.615,
      4.616,
      4.617,
      4.618,
      4.619,
      4.62,
      4.621,
      4.622,
      4.623,
      4.624,
      4.625,
      4.626,
      4.627,
      4.628,
      4.6290000000000004E+000,
      4.63,
      4.631,
      4.632,
      4.633,
      4.634,
      4.635,
      4.636,
      4.6370000000000005E+000,
      4.638,
      4.639,
      4.64,
      4.641,
      4.642,
      4.643,
      4.644,
      4.6450000000000005E+000,
      4.646,
      4.647,
      4.648,
      4.649,
      4.65,
      4.651,
      4.652,
      4.6530000000000005E+000,
      4.654,
      4.655,
      4.656,
      4.657,
      4.658,
      4.659,
      4.66,
      4.6610000000000005E+000,
      4.662,
      4.663,
      4.664,
      4.665,
      4.666,
      4.667,
      4.668,
      4.6690000000000005E+000,
      4.67,
      4.671,
      4.672,
      4.673,
      4.674,
      4.675,
      4.676,
      4.6770000000000005E+000,
      4.678,
      4.679,
      4.68,
      4.681,
      4.682,
      4.683,
      4.684,
      4.6850000000000005E+000,
      4.686,
      4.687,
      4.688,
      4.689,
      4.69,
      4.691,
      4.692,
      4.6930000000000005E+000,
      4.694,
      4.695,
      4.696,
      4.697,
      4.698,
      4.699,
      4.7,
      4.7010000000000005E+000,
      4.702,
      4.703,
      4.704,
      4.705,
      4.706,
      4.707,
      4.708,
      4.7090000000000005E+000,
      4.71,
      4.711,
      4.712,
      4.713,
      4.714,
      4.715,
      4.716,
      4.7170000000000005E+000,
      4.718,
      4.719,
      4.72,
      4.721,
      4.722,
      4.723,
      4.724,
      4.7250000000000005E+000,
      4.726,
      4.727,
      4.728,
      4.729,
      4.73,
      4.731,
      4.732,
      4.7330000000000005E+000,
      4.734,
      4.735,
      4.736,
      4.737,
      4.738,
      4.739,
      4.74,
      4.741,
      4.742,
      4.743,
      4.744,
      4.745,
      4.746,
      4.747,
      4.748,
      4.749,
      4.75,
      4.751,
      4.752,
      4.753,
      4.7540000000000004E+000,
      4.755,
      4.756,
      4.757,
      4.758,
      4.759,
      4.76,
      4.761,
      4.7620000000000005E+000,
      4.763,
      4.764,
      4.765,
      4.766,
      4.767,
      4.768,
      4.769,
      4.7700000000000005E+000,
      4.771,
      4.772,
      4.773,
      4.774,
      4.775,
      4.776,
      4.777,
      4.7780000000000005E+000,
      4.779,
      4.78,
      4.781,
      4.782,
      4.783,
      4.784,
      4.785,
      4.7860000000000005E+000,
      4.787,
      4.788,
      4.789,
      4.79,
      4.791,
      4.792,
      4.793,
      4.7940000000000005E+000,
      4.795,
      4.796,
      4.797,
      4.798,
      4.799,
      4.8,
      4.801,
      4.8020000000000005E+000,
      4.803,
      4.804,
      4.805,
      4.806,
      4.807,
      4.808,
      4.809,
      4.8100000000000005E+000,
      4.811,
      4.812,
      4.813,
      4.814,
      4.815,
      4.816,
      4.817,
      4.8180000000000005E+000,
      4.819,
      4.82,
      4.821,
      4.822,
      4.823,
      4.824,
      4.825,
      4.8260000000000005E+000,
      4.827,
      4.828,
      4.829,
      4.83,
      4.831,
      4.832,
      4.833,
      4.8340000000000005E+000,
      4.835,
      4.836,
      4.837,
      4.838,
      4.839,
      4.84,
      4.841,
      4.8420000000000005E+000,
      4.843,
      4.844,
      4.845,
      4.846,
      4.847,
      4.848,
      4.849,
      4.8500000000000005E+000,
      4.851,
      4.852,
      4.853,
      4.854,
      4.855,
      4.856,
      4.857,
      4.8580000000000005E+000,
      4.859,
      4.86,
      4.861,
      4.862,
      4.863,
      4.864,
      4.865,
      4.866,
      4.867,
      4.868,
      4.869,
      4.87,
      4.871,
      4.872,
      4.873,
      4.874,
      4.875,
      4.876,
      4.877,
      4.878,
      4.8790000000000004E+000,
      4.88,
      4.881,
      4.882,
      4.883,
      4.884,
      4.885,
      4.886,
      4.8870000000000005E+000,
      4.888,
      4.889,
      4.89,
      4.891,
      4.892,
      4.893,
      4.894,
      4.8950000000000005E+000,
      4.896,
      4.897,
      4.898,
      4.899,
      4.9,
      4.901,
      4.902,
      4.9030000000000005E+000,
      4.904,
      4.905,
      4.906,
      4.907,
      4.908,
      4.909,
      4.91,
      4.9110000000000005E+000,
      4.912,
      4.913,
      4.914,
      4.915,
      4.916,
      4.917,
      4.918,
      4.9190000000000005E+000,
      4.92,
      4.921,
      4.922,
      4.923,
      4.924,
      4.925,
      4.926,
      4.9270000000000005E+000,
      4.928,
      4.929,
      4.93,
      4.931,
      4.932,
      4.933,
      4.934,
      4.9350000000000005E+000,
      4.936,
      4.937,
      4.938,
      4.939,
      4.94,
      4.941,
      4.942,
      4.9430000000000005E+000,
      4.944,
      4.945,
      4.946,
      4.947,
      4.948,
      4.949,
      4.95,
      4.9510000000000005E+000,
      4.952,
      4.953,
      4.954,
      4.955,
      4.956,
      4.957,
      4.958,
      4.9590000000000005E+000,
      4.96,
      4.961,
      4.962,
      4.963,
      4.964,
      4.965,
      4.966,
      4.9670000000000005E+000,
      4.968,
      4.969,
      4.97,
      4.971,
      4.972,
      4.973,
      4.974,
      4.9750000000000005E+000,
      4.976,
      4.977,
      4.978,
      4.979,
      4.98,
      4.981,
      4.982,
      4.9830000000000005E+000,
      4.984,
      4.985,
      4.986,
      4.987,
      4.988,
      4.989,
      4.99,
      4.9910000000000005E+000,
      4.992,
      4.993,
      4.994,
      4.995,
      4.996,
      4.997,
      4.998,
      4.999,
      5.0,
      5.001,
      5.002,
      5.003,
      5.0040000000000004E+000,
      5.005,
      5.006,
      5.007,
      5.008,
      5.009,
      5.01,
      5.011,
      5.0120000000000005E+000,
      5.013,
      5.014,
      5.015,
      5.016,
      5.017,
      5.018,
      5.019,
      5.0200000000000005E+000,
      5.021,
      5.022,
      5.023,
      5.024,
      5.025,
      5.026,
      5.027,
      5.0280000000000005E+000,
      5.029,
      5.03,
      5.031,
      5.032,
      5.033,
      5.034,
      5.035,
      5.0360000000000005E+000,
      5.037,
      5.038,
      5.039,
      5.04,
      5.041,
      5.042,
      5.043,
      5.0440000000000005E+000,
      5.045,
      5.046,
      5.047,
      5.048,
      5.049,
      5.05,
      5.051,
      5.0520000000000005E+000,
      5.053,
      5.054,
      5.055,
      5.056,
      5.057,
      5.058,
      5.059,
      5.0600000000000005E+000,
      5.061,
      5.062,
      5.063,
      5.064,
      5.065,
      5.066,
      5.067,
      5.0680000000000005E+000,
      5.069,
      5.07,
      5.071,
      5.072,
      5.073,
      5.074,
      5.075,
      5.0760000000000005E+000,
      5.077,
      5.078,
      5.079,
      5.08,
      5.081,
      5.082,
      5.083,
      5.0840000000000005E+000,
      5.085,
      5.086,
      5.087,
      5.088,
      5.089,
      5.09,
      5.091,
      5.0920000000000005E+000,
      5.093,
      5.094,
      5.095,
      5.096,
      5.097,
      5.098,
      5.099,
      5.1000000000000005E+000,
      5.101,
      5.102,
      5.103,
      5.104,
      5.105,
      5.106,
      5.107,
      5.1080000000000005E+000,
      5.109,
      5.11,
      5.111,
      5.112,
      5.113,
      5.114,
      5.115,
      5.1160000000000005E+000,
      5.117,
      5.118,
      5.119,
      5.12,
      5.121,
      5.122,
      5.123,
      5.124,
      5.125,
      5.126,
      5.127,
      5.128,
      5.1290000000000004E+000,
      5.13,
      5.131,
      5.132,
      5.133,
      5.134,
      5.135,
      5.136,
      5.1370000000000005E+000,
      5.138,
      5.139,
      5.14,
      5.141,
      5.142,
      5.143,
      5.144,
      5.1450000000000005E+000,
      5.146,
      5.147,
      5.148,
      5.149,
      5.15,
      5.151,
      5.152,
      5.1530000000000005E+000,
      5.154,
      5.155,
      5.156,
      5.157,
      5.158,
      5.159,
      5.16,
      5.1610000000000005E+000,
      5.162,
      5.163,
      5.164,
      5.165,
      5.166,
      5.167,
      5.168,
      5.1690000000000005E+000,
      5.17,
      5.171,
      5.172,
      5.173,
      5.174,
      5.175,
      5.176,
      5.1770000000000005E+000,
      5.178,
      5.179,
      5.18,
      5.181,
      5.182,
      5.183,
      5.184,
      5.1850000000000005E+000,
      5.186,
      5.187,
      5.188,
      5.189,
      5.19,
      5.191,
      5.192,
      5.1930000000000005E+000,
      5.194,
      5.195,
      5.196,
      5.197,
      5.198,
      5.199,
      5.2,
      5.2010000000000005E+000,
      5.202,
      5.203,
      5.204,
      5.205,
      5.206,
      5.207,
      5.208,
      5.2090000000000005E+000,
      5.21,
      5.211,
      5.212,
      5.213,
      5.214,
      5.215,
      5.216,
      5.2170000000000005E+000,
      5.218,
      5.219,
      5.22,
      5.221,
      5.222,
      5.223,
      5.224,
      5.2250000000000005E+000,
      5.226,
      5.227,
      5.228,
      5.229,
      5.23,
      5.231,
      5.232,
      5.2330000000000005E+000,
      5.234,
      5.235,
      5.236,
      5.237,
      5.238,
      5.239,
      5.24,
      5.2410000000000005E+000,
      5.242,
      5.243,
      5.244,
      5.245,
      5.246,
      5.247,
      5.248,
      5.249,
      5.25,
      5.251,
      5.252,
      5.253,
      5.2540000000000004E+000,
      5.255,
      5.256,
      5.257,
      5.258,
      5.259,
      5.26,
      5.261,
      5.2620000000000005E+000,
      5.263,
      5.264,
      5.265,
      5.266,
      5.267,
      5.268,
      5.269,
      5.2700000000000005E+000,
      5.271,
      5.272,
      5.273,
      5.274,
      5.275,
      5.276,
      5.277,
      5.2780000000000005E+000,
      5.279,
      5.28,
      5.281,
      5.282,
      5.283,
      5.284,
      5.285,
      5.2860000000000005E+000,
      5.287,
      5.288,
      5.289,
      5.29,
      5.291,
      5.292,
      5.293,
      5.2940000000000005E+000,
      5.295,
      5.296,
      5.297,
      5.298,
      5.299,
      5.3,
      5.301,
      5.3020000000000005E+000,
      5.303,
      5.304,
      5.305,
      5.306,
      5.307,
      5.308,
      5.309,
      5.3100000000000005E+000,
      5.311,
      5.312,
      5.313,
      5.314,
      5.315,
      5.316,
      5.317,
      5.3180000000000005E+000,
      5.319,
      5.32,
      5.321,
      5.322,
      5.323,
      5.324,
      5.325,
      5.3260000000000005E+000,
      5.327,
      5.328,
      5.329,
      5.33,
      5.331,
      5.332,
      5.333,
      5.3340000000000005E+000,
      5.335,
      5.336,
      5.337,
      5.338,
      5.339,
      5.34,
      5.341,
      5.3420000000000005E+000,
      5.343,
      5.344,
      5.345,
      5.346,
      5.347,
      5.348,
      5.349,
      5.3500000000000005E+000,
      5.351,
      5.352,
      5.353,
      5.354,
      5.355,
      5.356,
      5.357,
      5.3580000000000005E+000,
      5.359,
      5.36,
      5.361,
      5.362,
      5.363,
      5.364,
      5.365,
      5.3660000000000005E+000,
      5.367,
      5.368,
      5.369,
      5.37,
      5.371,
      5.372,
      5.373,
      5.3740000000000006E+000,
      5.375,
      5.376,
      5.377,
      5.378,
      5.3790000000000004E+000,
      5.38,
      5.381,
      5.382,
      5.383,
      5.384,
      5.385,
      5.386,
      5.3870000000000005E+000,
      5.388,
      5.389,
      5.39,
      5.391,
      5.392,
      5.393,
      5.394,
      5.3950000000000005E+000,
      5.396,
      5.397,
      5.398,
      5.399,
      5.4,
      5.401,
      5.402,
      5.4030000000000005E+000,
      5.404,
      5.405,
      5.406,
      5.407,
      5.408,
      5.409,
      5.41,
      5.4110000000000005E+000,
      5.412,
      5.413,
      5.414,
      5.415,
      5.416,
      5.417,
      5.418,
      5.4190000000000005E+000,
      5.42,
      5.421,
      5.422,
      5.423,
      5.424,
      5.425,
      5.426,
      5.4270000000000005E+000,
      5.428,
      5.429,
      5.43,
      5.431,
      5.432,
      5.433,
      5.434,
      5.4350000000000005E+000,
      5.436,
      5.437,
      5.438,
      5.439,
      5.44,
      5.441,
      5.442,
      5.4430000000000005E+000,
      5.444,
      5.445,
      5.446,
      5.447,
      5.448,
      5.449,
      5.45,
      5.4510000000000005E+000,
      5.452,
      5.453,
      5.454,
      5.455,
      5.456,
      5.457,
      5.458,
      5.4590000000000005E+000,
      5.46,
      5.461,
      5.462,
      5.463,
      5.464,
      5.465,
      5.466,
      5.4670000000000005E+000,
      5.468,
      5.469,
      5.47,
      5.471,
      5.472,
      5.473,
      5.474,
      5.4750000000000005E+000,
      5.476,
      5.477,
      5.478,
      5.479,
      5.48,
      5.481,
      5.482,
      5.4830000000000005E+000,
      5.484,
      5.485,
      5.486,
      5.487,
      5.488,
      5.489,
      5.49,
      5.4910000000000005E+000,
      5.492,
      5.493,
      5.494,
      5.495,
      5.496,
      5.497,
      5.498,
      5.4990000000000006E+000,
      5.5,
      5.501,
      5.502,
      5.503,
      5.5040000000000004E+000,
      5.505,
      5.506,
      5.507,
      5.508,
      5.509,
      5.51,
      5.511,
      5.5120000000000005E+000,
      5.513,
      5.514,
      5.515,
      5.516,
      5.517,
      5.518,
      5.519,
      5.5200000000000005E+000,
      5.521,
      5.522,
      5.523,
      5.524,
      5.525,
      5.526,
      5.527,
      5.5280000000000005E+000,
      5.529,
      5.53,
      5.531,
      5.532,
      5.533,
      5.534,
      5.535,
      5.5360000000000005E+000,
      5.537,
      5.538,
      5.539,
      5.54,
      5.541,
      5.542,
      5.543,
      5.5440000000000005E+000,
      5.545,
      5.546,
      5.547,
      5.548,
      5.549,
      5.55,
      5.551,
      5.5520000000000005E+000,
      5.553,
      5.554,
      5.555,
      5.556,
      5.557,
      5.558,
      5.559,
      5.5600000000000005E+000,
      5.561,
      5.562,
      5.563,
      5.564,
      5.565,
      5.566,
      5.567,
      5.5680000000000005E+000,
      5.569,
      5.57,
      5.571,
      5.572,
      5.573,
      5.574,
      5.575,
      5.5760000000000005E+000,
      5.577,
      5.578,
      5.579,
      5.58,
      5.581,
      5.582,
      5.583,
      5.5840000000000005E+000,
      5.585,
      5.586,
      5.587,
      5.588,
      5.589,
      5.59,
      5.591,
      5.5920000000000005E+000,
      5.593,
      5.594,
      5.595,
      5.596,
      5.597,
      5.598,
      5.599,
      5.6000000000000005E+000,
      5.601,
      5.602,
      5.603,
      5.604,
      5.605,
      5.606,
      5.607,
      5.6080000000000005E+000,
      5.609,
      5.61,
      5.611,
      5.612,
      5.613,
      5.614,
      5.615,
      5.6160000000000005E+000,
      5.617,
      5.618,
      5.619,
      5.62,
      5.621,
      5.622,
      5.623,
      5.6240000000000006E+000,
      5.625,
      5.626,
      5.627,
      5.628,
      5.6290000000000004E+000,
      5.63,
      5.631,
      5.632,
      5.633,
      5.634,
      5.635,
      5.636,
      5.6370000000000005E+000,
      5.638,
      5.639,
      5.64,
      5.641,
      5.642,
      5.643,
      5.644,
      5.6450000000000005E+000,
      5.646,
      5.647,
      5.648,
      5.649,
      5.65,
      5.651,
      5.652,
      5.6530000000000005E+000,
      5.654,
      5.655,
      5.656,
      5.657,
      5.658,
      5.659,
      5.66,
      5.6610000000000005E+000,
      5.662,
      5.663,
      5.664,
      5.665,
      5.666,
      5.667,
      5.668,
      5.6690000000000005E+000,
      5.67,
      5.671,
      5.672,
      5.673,
      5.674,
      5.675,
      5.676,
      5.6770000000000005E+000,
      5.678,
      5.679,
      5.68,
      5.681,
      5.682,
      5.683,
      5.684,
      5.6850000000000005E+000,
      5.686,
      5.687,
      5.688,
      5.689,
      5.69,
      5.691,
      5.692,
      5.6930000000000005E+000,
      5.694,
      5.695,
      5.696,
      5.697,
      5.698,
      5.699,
      5.7,
      5.7010000000000005E+000,
      5.702,
      5.703,
      5.704,
      5.705,
      5.706,
      5.707,
      5.708,
      5.7090000000000005E+000,
      5.71,
      5.711,
      5.712,
      5.713,
      5.714,
      5.715,
      5.716,
      5.7170000000000005E+000,
      5.718,
      5.719,
      5.72,
      5.721,
      5.722,
      5.723,
      5.724,
      5.7250000000000005E+000,
      5.726,
      5.727,
      5.728,
      5.729,
      5.73,
      5.731,
      5.732,
      5.7330000000000005E+000,
      5.734,
      5.735,
      5.736,
      5.737,
      5.738,
      5.739,
      5.74,
      5.7410000000000005E+000,
      5.742,
      5.743,
      5.744,
      5.745,
      5.746,
      5.747,
      5.748,
      5.7490000000000006E+000,
      5.75,
      5.751,
      5.752,
      5.753,
      5.7540000000000004E+000,
      5.755,
      5.756,
      5.7570000000000006E+000,
      5.758,
      5.759,
      5.76,
      5.761,
      5.7620000000000005E+000,
      5.763,
      5.764,
      5.765,
      5.766,
      5.767,
      5.768,
      5.769,
      5.7700000000000005E+000,
      5.771,
      5.772,
      5.773,
      5.774,
      5.775,
      5.776,
      5.777,
      5.7780000000000005E+000,
      5.779,
      5.78,
      5.781,
      5.782,
      5.783,
      5.784,
      5.785,
      5.7860000000000005E+000,
      5.787,
      5.788,
      5.789,
      5.79,
      5.791,
      5.792,
      5.793,
      5.7940000000000005E+000,
      5.795,
      5.796,
      5.797,
      5.798,
      5.799,
      5.8,
      5.801,
      5.8020000000000005E+000,
      5.803,
      5.804,
      5.805,
      5.806,
      5.807,
      5.808,
      5.809,
      5.8100000000000005E+000,
      5.811,
      5.812,
      5.813,
      5.814,
      5.815,
      5.816,
      5.817,
      5.8180000000000005E+000,
      5.819,
      5.82,
      5.821,
      5.822,
      5.823,
      5.824,
      5.825,
      5.8260000000000005E+000,
      5.827,
      5.828,
      5.829,
      5.83,
      5.831,
      5.832,
      5.833,
      5.8340000000000005E+000,
      5.835,
      5.836,
      5.837,
      5.838,
      5.839,
      5.84,
      5.841,
      5.8420000000000005E+000,
      5.843,
      5.844,
      5.845,
      5.846,
      5.847,
      5.848,
      5.849,
      5.8500000000000005E+000,
      5.851,
      5.852,
      5.853,
      5.854,
      5.855,
      5.856,
      5.857,
      5.8580000000000005E+000,
      5.859,
      5.86,
      5.861,
      5.862,
      5.863,
      5.864,
      5.865,
      5.8660000000000005E+000,
      5.867,
      5.868,
      5.869,
      5.87,
      5.871,
      5.872,
      5.873,
      5.8740000000000006E+000,
      5.875,
      5.876,
      5.877,
      5.878,
      5.8790000000000004E+000,
      5.88,
      5.881,
      5.8820000000000006E+000,
      5.883,
      5.884,
      5.885,
      5.886,
      5.8870000000000005E+000,
      5.888,
      5.889,
      5.89,
      5.891,
      5.892,
      5.893,
      5.894,
      5.8950000000000005E+000,
      5.896,
      5.897,
      5.898,
      5.899,
      5.9,
      5.901,
      5.902,
      5.9030000000000005E+000,
      5.904,
      5.905,
      5.906,
      5.907,
      5.908,
      5.909,
      5.91,
      5.9110000000000005E+000,
      5.912,
      5.913,
      5.914,
      5.915,
      5.916,
      5.917,
      5.918,
      5.9190000000000005E+000,
      5.92,
      5.921,
      5.922,
      5.923,
      5.924,
      5.925,
      5.926,
      5.9270000000000005E+000,
      5.928,
      5.929,
      5.93,
      5.931,
      5.932,
      5.933,
      5.934,
      5.9350000000000005E+000,
      5.936,
      5.937,
      5.938,
      5.939,
      5.94,
      5.941,
      5.942,
      5.9430000000000005E+000,
      5.944,
      5.945,
      5.946,
      5.947,
      5.948,
      5.949,
      5.95,
      5.9510000000000005E+000,
      5.952,
      5.953,
      5.954,
      5.955,
      5.956,
      5.957,
      5.958,
      5.9590000000000005E+000,
      5.96,
      5.961,
      5.962,
      5.963,
      5.964,
      5.965,
      5.966,
      5.9670000000000005E+000,
      5.968,
      5.969,
      5.97,
      5.971,
      5.972,
      5.973,
      5.974,
      5.9750000000000005E+000,
      5.976,
      5.977,
      5.978,
      5.979,
      5.98,
      5.981,
      5.982,
      5.9830000000000005E+000,
      5.984,
      5.985,
      5.986,
      5.987,
      5.988,
      5.989,
      5.99,
      5.9910000000000005E+000,
      5.992,
      5.993,
      5.994,
      5.995,
      5.996,
      5.997,
      5.998,
      5.9990000000000006E+000,
      6.0,
      6.001,
      6.002,
      6.003,
      6.0040000000000004E+000,
      6.005,
      6.006,
      6.0070000000000006E+000,
      6.008,
      6.009,
      6.01,
      6.011,
      6.0120000000000005E+000,
      6.013,
      6.014,
      6.0150000000000006E+000,
      6.016,
      6.017,
      6.018,
      6.019,
      6.0200000000000005E+000,
      6.021,
      6.022,
      6.023,
      6.024,
      6.025,
      6.026,
      6.027,
      6.0280000000000005E+000,
      6.029,
      6.03,
      6.031,
      6.032,
      6.033,
      6.034,
      6.035,
      6.0360000000000005E+000,
      6.037,
      6.038,
      6.039,
      6.04,
      6.041,
      6.042,
      6.043,
      6.0440000000000005E+000,
      6.045,
      6.046,
      6.047,
      6.048,
      6.049,
      6.05,
      6.051,
      6.0520000000000005E+000,
      6.053,
      6.054,
      6.055,
      6.056,
      6.057,
      6.058,
      6.059,
      6.0600000000000005E+000,
      6.061,
      6.062,
      6.063,
      6.064,
      6.065,
      6.066,
      6.067,
      6.0680000000000005E+000,
      6.069,
      6.07,
      6.071,
      6.072,
      6.073,
      6.074,
      6.075,
      6.0760000000000005E+000,
      6.077,
      6.078,
      6.079,
      6.08,
      6.081,
      6.082,
      6.083,
      6.0840000000000005E+000,
      6.085,
      6.086,
      6.087,
      6.088,
      6.089,
      6.09,
      6.091,
      6.0920000000000005E+000,
      6.093,
      6.094,
      6.095,
      6.096,
      6.097,
      6.098,
      6.099,
      6.1000000000000005E+000,
      6.101,
      6.102,
      6.103,
      6.104,
      6.105,
      6.106,
      6.107,
      6.1080000000000005E+000,
      6.109,
      6.11,
      6.111,
      6.112,
      6.113,
      6.114,
      6.115,
      6.1160000000000005E+000,
      6.117,
      6.118,
      6.119,
      6.12,
      6.121,
      6.122,
      6.123,
      6.1240000000000006E+000,
      6.125,
      6.126,
      6.127,
      6.128,
      6.1290000000000004E+000,
      6.13,
      6.131,
      6.1320000000000006E+000,
      6.133,
      6.134,
      6.135,
      6.136,
      6.1370000000000005E+000,
      6.138,
      6.139,
      6.1400000000000006E+000,
      6.141,
      6.142,
      6.143,
      6.144,
      6.1450000000000005E+000,
      6.146,
      6.147,
      6.148,
      6.149,
      6.15,
      6.151,
      6.152,
      6.1530000000000005E+000,
      6.154,
      6.155,
      6.156,
      6.157,
      6.158,
      6.159,
      6.16,
      6.1610000000000005E+000,
      6.162,
      6.163,
      6.164,
      6.165,
      6.166,
      6.167,
      6.168,
      6.1690000000000005E+000,
      6.17,
      6.171,
      6.172,
      6.173,
      6.174,
      6.175,
      6.176,
      6.1770000000000005E+000,
      6.178,
      6.179,
      6.18,
      6.181,
      6.182,
      6.183,
      6.184,
      6.1850000000000005E+000,
      6.186,
      6.187,
      6.188,
      6.189,
      6.19,
      6.191,
      6.192,
      6.1930000000000005E+000,
      6.194,
      6.195,
      6.196,
      6.197,
      6.198,
      6.199,
      6.2,
      6.2010000000000005E+000,
      6.202,
      6.203,
      6.204,
      6.205,
      6.206,
      6.207,
      6.208,
      6.2090000000000005E+000,
      6.21,
      6.211,
      6.212,
      6.213,
      6.214,
      6.215,
      6.216,
      6.2170000000000005E+000,
      6.218,
      6.219,
      6.22,
      6.221,
      6.222,
      6.223,
      6.224,
      6.2250000000000005E+000,
      6.226,
      6.227,
      6.228,
      6.229,
      6.23,
      6.231,
      6.232,
      6.2330000000000005E+000,
      6.234,
      6.235,
      6.236,
      6.237,
      6.238,
      6.239,
      6.24,
      6.2410000000000005E+000,
      6.242,
      6.243,
      6.244,
      6.245,
      6.246,
      6.247,
      6.248,
      6.2490000000000006E+000,
      6.25,
      6.251,
      6.252,
      6.253,
      6.2540000000000004E+000,
      6.255,
      6.256,
      6.2570000000000006E+000,
      6.258,
      6.259,
      6.26,
      6.261,
      6.2620000000000005E+000,
      6.263,
      6.264,
      6.2650000000000006E+000,
      6.266,
      6.267,
      6.268,
      6.269,
      6.2700000000000005E+000,
      6.271,
      6.272,
      6.273,
      6.274,
      6.275,
      6.276,
      6.277,
      6.2780000000000005E+000,
      6.279,
      6.28,
      6.281,
      6.282,
      6.283,
      6.284,
      6.285,
      6.2860000000000005E+000,
      6.287,
      6.288,
      6.289,
      6.29,
      6.291,
      6.292,
      6.293,
      6.2940000000000005E+000,
      6.295,
      6.296,
      6.297,
      6.298,
      6.299,
      6.3,
      6.301,
      6.3020000000000005E+000,
      6.303,
      6.304,
      6.305,
      6.306,
      6.307,
      6.308,
      6.309,
      6.3100000000000005E+000,
      6.311,
      6.312,
      6.313,
      6.314,
      6.315,
      6.316,
      6.317,
      6.3180000000000005E+000,
      6.319,
      6.32,
      6.321,
      6.322,
      6.323,
      6.324,
      6.325,
      6.3260000000000005E+000,
      6.327,
      6.328,
      6.329,
      6.33,
      6.331,
      6.332,
      6.333,
      6.3340000000000005E+000,
      6.335,
      6.336,
      6.337,
      6.338,
      6.339,
      6.34,
      6.341,
      6.3420000000000005E+000,
      6.343,
      6.344,
      6.345,
      6.346,
      6.347,
      6.348,
      6.349,
      6.3500000000000005E+000,
      6.351,
      6.352,
      6.353,
      6.354,
      6.355,
      6.356,
      6.357,
      6.3580000000000005E+000,
      6.359,
      6.36,
      6.361,
      6.362,
      6.363,
      6.364,
      6.365,
      6.3660000000000005E+000,
      6.367,
      6.368,
      6.369,
      6.37,
      6.371,
      6.372,
      6.373,
      6.3740000000000006E+000,
      6.375,
      6.376,
      6.377,
      6.378,
      6.3790000000000004E+000,
      6.38,
      6.381,
      6.3820000000000006E+000,
      6.383,
      6.384,
      6.385,
      6.386,
      6.3870000000000005E+000,
      6.388,
      6.389,
      6.3900000000000006E+000,
      6.391,
      6.392,
      6.393,
      6.394,
      6.3950000000000005E+000,
      6.396,
      6.397,
      6.3980000000000006E+000,
      6.399,
      6.4,
      6.401,
      6.402,
      6.4030000000000005E+000,
      6.404,
      6.405,
      6.406,
      6.407,
      6.408,
      6.409,
      6.41,
      6.4110000000000005E+000,
      6.412,
      6.413,
      6.414,
      6.415,
      6.416,
      6.417,
      6.418,
      6.4190000000000005E+000,
      6.42,
      6.421,
      6.422,
      6.423,
      6.424,
      6.425,
      6.426,
      6.4270000000000005E+000,
      6.428,
      6.429,
      6.43,
      6.431,
      6.432,
      6.433,
      6.434,
      6.4350000000000005E+000,
      6.436,
      6.437,
      6.438,
      6.439,
      6.44,
      6.441,
      6.442,
      6.4430000000000005E+000,
      6.444,
      6.445,
      6.446,
      6.447,
      6.448,
      6.449,
      6.45,
      6.4510000000000005E+000,
      6.452,
      6.453,
      6.454,
      6.455,
      6.456,
      6.457,
      6.458,
      6.4590000000000005E+000,
      6.46,
      6.461,
      6.462,
      6.463,
      6.464,
      6.465,
      6.466,
      6.4670000000000005E+000,
      6.468,
      6.469,
      6.47,
      6.471,
      6.472,
      6.473,
      6.474,
      6.4750000000000005E+000,
      6.476,
      6.477,
      6.478,
      6.479,
      6.48,
      6.481,
      6.482,
      6.4830000000000005E+000,
      6.484,
      6.485,
      6.486,
      6.487,
      6.488,
      6.489,
      6.49,
      6.4910000000000005E+000,
      6.492,
      6.493,
      6.494,
      6.495,
      6.496,
      6.497,
      6.498,
      6.4990000000000006E+000,
      6.5,
      6.501,
      6.502,
      6.503,
      6.5040000000000004E+000,
      6.505,
      6.506,
      6.5070000000000006E+000,
      6.508,
      6.509,
      6.51,
      6.511,
      6.5120000000000005E+000,
      6.513,
      6.514,
      6.5150000000000006E+000,
      6.516,
      6.517,
      6.518,
      6.519,
      6.5200000000000005E+000,
      6.521,
      6.522,
      6.5230000000000006E+000,
      6.524,
      6.525,
      6.526,
      6.527,
      6.5280000000000005E+000,
      6.529,
      6.53,
      6.531,
      6.532,
      6.533,
      6.534,
      6.535,
      6.5360000000000005E+000,
      6.537,
      6.538,
      6.539,
      6.54,
      6.541,
      6.542,
      6.543,
      6.5440000000000005E+000,
      6.545,
      6.546,
      6.547,
      6.548,
      6.549,
      6.55,
      6.551,
      6.5520000000000005E+000,
      6.553,
      6.554,
      6.555,
      6.556,
      6.557,
      6.558,
      6.559,
      6.5600000000000005E+000,
      6.561,
      6.562,
      6.563,
      6.564,
      6.565,
      6.566,
      6.567,
      6.5680000000000005E+000,
      6.569,
      6.57,
      6.571,
      6.572,
      6.573,
      6.574,
      6.575,
      6.5760000000000005E+000,
      6.577,
      6.578,
      6.579,
      6.58,
      6.581,
      6.582,
      6.583,
      6.5840000000000005E+000,
      6.585,
      6.586,
      6.587,
      6.588,
      6.589,
      6.59,
      6.591,
      6.5920000000000005E+000,
      6.593,
      6.594,
      6.595,
      6.596,
      6.597,
      6.598,
      6.599,
      6.6000000000000005E+000,
      6.601,
      6.602,
      6.603,
      6.604,
      6.605,
      6.606,
      6.607,
      6.6080000000000005E+000,
      6.609,
      6.61,
      6.611,
      6.612,
      6.613,
      6.614,
      6.615,
      6.6160000000000005E+000,
      6.617,
      6.618,
      6.619,
      6.62,
      6.621,
      6.622,
      6.623,
      6.6240000000000006E+000,
      6.625,
      6.626,
      6.627,
      6.628,
      6.6290000000000004E+000,
      6.63,
      6.631,
      6.6320000000000006E+000,
      6.633,
      6.634,
      6.635,
      6.636,
      6.6370000000000005E+000,
      6.638,
      6.639,
      6.6400000000000006E+000,
      6.641,
      6.642,
      6.643,
      6.644,
      6.6450000000000005E+000,
      6.646,
      6.647,
      6.6480000000000006E+000,
      6.649,
      6.65,
      6.651,
      6.652,
      6.6530000000000005E+000,
      6.654,
      6.655,
      6.6560000000000006E+000,
      6.657,
      6.658,
      6.659,
      6.66,
      6.6610000000000005E+000,
      6.662,
      6.663,
      6.664,
      6.665,
      6.666,
      6.667,
      6.668,
      6.6690000000000005E+000,
      6.67,
      6.671,
      6.672,
      6.673,
      6.674,
      6.675,
      6.676,
      6.6770000000000005E+000,
      6.678,
      6.679,
      6.68,
      6.681,
      6.682,
      6.683,
      6.684,
      6.6850000000000005E+000,
      6.686,
      6.687,
      6.688,
      6.689,
      6.69,
      6.691,
      6.692,
      6.6930000000000005E+000,
      6.694,
      6.695,
      6.696,
      6.697,
      6.698,
      6.699,
      6.7,
      6.7010000000000005E+000,
      6.702,
      6.703,
      6.704,
      6.705,
      6.706,
      6.707,
      6.708,
      6.7090000000000005E+000,
      6.71,
      6.711,
      6.712,
      6.713,
      6.714,
      6.715,
      6.716,
      6.7170000000000005E+000,
      6.718,
      6.719,
      6.72,
      6.721,
      6.722,
      6.723,
      6.724,
      6.7250000000000005E+000,
      6.726,
      6.727,
      6.728,
      6.729,
      6.73,
      6.731,
      6.732,
      6.7330000000000005E+000,
      6.734,
      6.735,
      6.736,
      6.737,
      6.738,
      6.739,
      6.74,
      6.7410000000000005E+000,
      6.742,
      6.743,
      6.744,
      6.745,
      6.746,
      6.747,
      6.748,
      6.7490000000000006E+000,
      6.75,
      6.751,
      6.752,
      6.753,
      6.7540000000000004E+000,
      6.755,
      6.756,
      6.7570000000000006E+000,
      6.758,
      6.759,
      6.76,
      6.761,
      6.7620000000000005E+000,
      6.763,
      6.764,
      6.7650000000000006E+000,
      6.766,
      6.767,
      6.768,
      6.769,
      6.7700000000000005E+000,
      6.771,
      6.772,
      6.7730000000000006E+000,
      6.774,
      6.775,
      6.776,
      6.777,
      6.7780000000000005E+000,
      6.779,
      6.78,
      6.7810000000000006E+000,
      6.782,
      6.783,
      6.784,
      6.785,
      6.7860000000000005E+000,
      6.787,
      6.788,
      6.789,
      6.79,
      6.791,
      6.792,
      6.793,
      6.7940000000000005E+000,
      6.795,
      6.796,
      6.797,
      6.798,
      6.799,
      6.8,
      6.801,
      6.8020000000000005E+000,
      6.803,
      6.804,
      6.805,
      6.806,
      6.807,
      6.808,
      6.809,
      6.8100000000000005E+000,
      6.811,
      6.812,
      6.813,
      6.814,
      6.815,
      6.816,
      6.817,
      6.8180000000000005E+000,
      6.819,
      6.82,
      6.821,
      6.822,
      6.823,
      6.824,
      6.825,
      6.8260000000000005E+000,
      6.827,
      6.828,
      6.829,
      6.83,
      6.831,
      6.832,
      6.833,
      6.8340000000000005E+000,
      6.835,
      6.836,
      6.837,
      6.838,
      6.839,
      6.84,
      6.841,
      6.8420000000000005E+000,
      6.843,
      6.844,
      6.845,
      6.846,
      6.847,
      6.848,
      6.849,
      6.8500000000000005E+000,
      6.851,
      6.852,
      6.853,
      6.854,
      6.855,
      6.856,
      6.857,
      6.8580000000000005E+000,
      6.859,
      6.86,
      6.861,
      6.862,
      6.863,
      6.864,
      6.865,
      6.8660000000000005E+000,
      6.867,
      6.868,
      6.869,
      6.87,
      6.871,
      6.872,
      6.873,
      6.8740000000000006E+000,
      6.875,
      6.876,
      6.877,
      6.878,
      6.8790000000000004E+000,
      6.88,
      6.881,
      6.8820000000000006E+000,
      6.883,
      6.884,
      6.885,
      6.886,
      6.8870000000000005E+000,
      6.888,
      6.889,
      6.8900000000000006E+000,
      6.891,
      6.892,
      6.893,
      6.894,
      6.8950000000000005E+000,
      6.896,
      6.897,
      6.8980000000000006E+000,
      6.899,
      6.9,
      6.901,
      6.902,
      6.9030000000000005E+000,
      6.904,
      6.905,
      6.9060000000000006E+000,
      6.907,
      6.908,
      6.909,
      6.91,
      6.9110000000000005E+000,
      6.912,
      6.913,
      6.914,
      6.915,
      6.916,
      6.917,
      6.918,
      6.9190000000000005E+000,
      6.92,
      6.921,
      6.922,
      6.923,
      6.924,
      6.925,
      6.926,
      6.9270000000000005E+000,
      6.928,
      6.929,
      6.93,
      6.931,
      6.932,
      6.933,
      6.934,
      6.9350000000000005E+000,
      6.936,
      6.937,
      6.938,
      6.939,
      6.94,
      6.941,
      6.942,
      6.9430000000000005E+000,
      6.944,
      6.945,
      6.946,
      6.947,
      6.948,
      6.949,
      6.95,
      6.9510000000000005E+000,
      6.952,
      6.953,
      6.954,
      6.955,
      6.956,
      6.957,
      6.958,
      6.9590000000000005E+000,
      6.96,
      6.961,
      6.962,
      6.963,
      6.964,
      6.965,
      6.966,
      6.9670000000000005E+000,
      6.968,
      6.969,
      6.97,
      6.971,
      6.972,
      6.973,
      6.974,
      6.9750000000000005E+000,
      6.976,
      6.977,
      6.978,
      6.979,
      6.98,
      6.981,
      6.982,
      6.9830000000000005E+000,
      6.984,
      6.985,
      6.986,
      6.987,
      6.988,
      6.989,
      6.99,
      6.9910000000000005E+000,
      6.992,
      6.993,
      6.994,
      6.995,
      6.996,
      6.997,
      6.998,
      6.9990000000000006E+000,
      7.0,
      7.001,
      7.002,
      7.003,
      7.0040000000000004E+000,
      7.005,
      7.006,
      7.0070000000000006E+000,
      7.008,
      7.009,
      7.01,
      7.011,
      7.0120000000000005E+000,
      7.013,
      7.014,
      7.0150000000000006E+000,
      7.016,
      7.017,
      7.018,
      7.019,
      7.0200000000000005E+000,
      7.021,
      7.022,
      7.0230000000000006E+000,
      7.024,
      7.025,
      7.026,
      7.027,
      7.0280000000000005E+000,
      7.029,
      7.03,
      7.0310000000000006E+000,
      7.032,
      7.033,
      7.034,
      7.035,
      7.0360000000000005E+000,
      7.037,
      7.038,
      7.0390000000000006E+000,
      7.04,
      7.041,
      7.042,
      7.043,
      7.0440000000000005E+000,
      7.045,
      7.046,
      7.047,
      7.048,
      7.049,
      7.05,
      7.051,
      7.0520000000000005E+000,
      7.053,
      7.054,
      7.055,
      7.056,
      7.057,
      7.058,
      7.059,
      7.0600000000000005E+000,
      7.061,
      7.062,
      7.063,
      7.064,
      7.065,
      7.066,
      7.067,
      7.0680000000000005E+000,
      7.069,
      7.07,
      7.071,
      7.072,
      7.073,
      7.074,
      7.075,
      7.0760000000000005E+000,
      7.077,
      7.078,
      7.079,
      7.08,
      7.081,
      7.082,
      7.083,
      7.0840000000000005E+000,
      7.085,
      7.086,
      7.087,
      7.088,
      7.089,
      7.09,
      7.091,
      7.0920000000000005E+000,
      7.093,
      7.094,
      7.095,
      7.096,
      7.097,
      7.098,
      7.099,
      7.1000000000000005E+000,
      7.101,
      7.102,
      7.103,
      7.104,
      7.105,
      7.106,
      7.107,
      7.1080000000000005E+000,
      7.109,
      7.11,
      7.111,
      7.112,
      7.113,
      7.114,
      7.115,
      7.1160000000000005E+000,
      7.117,
      7.118,
      7.119,
      7.12,
      7.121,
      7.122,
      7.123,
      7.1240000000000006E+000,
      7.125,
      7.126,
      7.127,
      7.128,
      7.1290000000000004E+000,
      7.13,
      7.131,
      7.1320000000000006E+000,
      7.133,
      7.134,
      7.135,
      7.136,
      7.1370000000000005E+000,
      7.138,
      7.139,
      7.1400000000000006E+000,
      7.141,
      7.142,
      7.143,
      7.144,
      7.1450000000000005E+000,
      7.146,
      7.147,
      7.1480000000000006E+000,
      7.149,
      7.15,
      7.151,
      7.152,
      7.1530000000000005E+000,
      7.154,
      7.155,
      7.1560000000000006E+000,
      7.157,
      7.158,
      7.159,
      7.16,
      7.1610000000000005E+000,
      7.162,
      7.163,
      7.1640000000000006E+000,
      7.165,
      7.166,
      7.167,
      7.168,
      7.1690000000000005E+000,
      7.17,
      7.171,
      7.172,
      7.173,
      7.174,
      7.175,
      7.176,
      7.1770000000000005E+000,
      7.178,
      7.179,
      7.18,
      7.181,
      7.182,
      7.183,
      7.184,
      7.1850000000000005E+000,
      7.186,
      7.187,
      7.188,
      7.189,
      7.19,
      7.191,
      7.192,
      7.1930000000000005E+000,
      7.194,
      7.195,
      7.196,
      7.197,
      7.198,
      7.199,
      7.2,
      7.2010000000000005E+000,
      7.202,
      7.203,
      7.204,
      7.205,
      7.206,
      7.207,
      7.208,
      7.2090000000000005E+000,
      7.21,
      7.211,
      7.212,
      7.213,
      7.214,
      7.215,
      7.216,
      7.2170000000000005E+000,
      7.218,
      7.219,
      7.22,
      7.221,
      7.222,
      7.223,
      7.224,
      7.2250000000000005E+000,
      7.226,
      7.227,
      7.228,
      7.229,
      7.23,
      7.231,
      7.232,
      7.2330000000000005E+000,
      7.234,
      7.235,
      7.236,
      7.237,
      7.238,
      7.239,
      7.24,
      7.2410000000000005E+000,
      7.242,
      7.243,
      7.244,
      7.245,
      7.246,
      7.247,
      7.248,
      7.2490000000000006E+000,
      7.25,
      7.251,
      7.252,
      7.253,
      7.2540000000000004E+000,
      7.255,
      7.256,
      7.2570000000000006E+000,
      7.258,
      7.259,
      7.26,
      7.261,
      7.2620000000000005E+000,
      7.263,
      7.264,
      7.2650000000000006E+000,
      7.266,
      7.267,
      7.268,
      7.269,
      7.2700000000000005E+000,
      7.271,
      7.272,
      7.2730000000000006E+000,
      7.274,
      7.275,
      7.276,
      7.277,
      7.2780000000000005E+000,
      7.279,
      7.28,
      7.2810000000000006E+000,
      7.282,
      7.283,
      7.284,
      7.285,
      7.2860000000000005E+000,
      7.287,
      7.288,
      7.2890000000000006E+000,
      7.29,
      7.291,
      7.292,
      7.293,
      7.2940000000000005E+000,
      7.295,
      7.296,
      7.297,
      7.298,
      7.299,
      7.3,
      7.301,
      7.3020000000000005E+000,
      7.303,
      7.304,
      7.305,
      7.306,
      7.307,
      7.308,
      7.309,
      7.3100000000000005E+000,
      7.311,
      7.312,
      7.313,
      7.314,
      7.315,
      7.316,
      7.317,
      7.3180000000000005E+000,
      7.319,
      7.32,
      7.321,
      7.322,
      7.323,
      7.324,
      7.325,
      7.3260000000000005E+000,
      7.327,
      7.328,
      7.329,
      7.33,
      7.331,
      7.332,
      7.333,
      7.3340000000000005E+000,
      7.335,
      7.336,
      7.337,
      7.338,
      7.339,
      7.34,
      7.341,
      7.3420000000000005E+000,
      7.343,
      7.344,
      7.345,
      7.346,
      7.347,
      7.348,
      7.349,
      7.3500000000000005E+000,
      7.351,
      7.352,
      7.353,
      7.354,
      7.355,
      7.356,
      7.357,
      7.3580000000000005E+000,
      7.359,
      7.36,
      7.361,
      7.362,
      7.363,
      7.364,
      7.365,
      7.3660000000000005E+000,
      7.367,
      7.368,
      7.369,
      7.37,
      7.371,
      7.372,
      7.373,
      7.3740000000000006E+000,
      7.375,
      7.376,
      7.377,
      7.378,
      7.3790000000000004E+000,
      7.38,
      7.381,
      7.3820000000000006E+000,
      7.383,
      7.384,
      7.385,
      7.386,
      7.3870000000000005E+000,
      7.388,
      7.389,
      7.3900000000000006E+000,
      7.391,
      7.392,
      7.393,
      7.394,
      7.3950000000000005E+000,
      7.396,
      7.397,
      7.3980000000000006E+000,
      7.399,
      7.4,
      7.401,
      7.402,
      7.4030000000000005E+000,
      7.404,
      7.405,
      7.4060000000000006E+000,
      7.407,
      7.408,
      7.409,
      7.41,
      7.4110000000000005E+000,
      7.412,
      7.413,
      7.4140000000000006E+000,
      7.415,
      7.416,
      7.417,
      7.418,
      7.4190000000000005E+000,
      7.42,
      7.421,
      7.4220000000000006E+000,
      7.423,
      7.424,
      7.425,
      7.426,
      7.4270000000000005E+000,
      7.428,
      7.429,
      7.43,
      7.431,
      7.432,
      7.433,
      7.434,
      7.4350000000000005E+000,
      7.436,
      7.437,
      7.438,
      7.439,
      7.44,
      7.441,
      7.442,
      7.4430000000000005E+000,
      7.444,
      7.445,
      7.446,
      7.447,
      7.448,
      7.449,
      7.45,
      7.4510000000000005E+000,
      7.452,
      7.453,
      7.454,
      7.455,
      7.456,
      7.457,
      7.458,
      7.4590000000000005E+000,
      7.46,
      7.461,
      7.462,
      7.463,
      7.464,
      7.465,
      7.466,
      7.4670000000000005E+000,
      7.468,
      7.469,
      7.47,
      7.471,
      7.472,
      7.473,
      7.474,
      7.4750000000000005E+000,
      7.476,
      7.477,
      7.478,
      7.479,
      7.48,
      7.481,
      7.482,
      7.4830000000000005E+000,
      7.484,
      7.485,
      7.486,
      7.487,
      7.488,
      7.489,
      7.49,
      7.4910000000000005E+000,
      7.492,
      7.493,
      7.494,
      7.495,
      7.496,
      7.497,
      7.498,
      7.4990000000000006E+000,
      7.5,
      7.501,
      7.502,
      7.503,
      7.5040000000000004E+000,
      7.505,
      7.506,
      7.5070000000000006E+000,
      7.508,
      7.509,
      7.51,
      7.511,
      7.5120000000000005E+000,
      7.513,
      7.514,
      7.5150000000000006E+000,
      7.516,
      7.517,
      7.518,
      7.519,
      7.5200000000000005E+000,
      7.521,
      7.522,
      7.5230000000000006E+000,
      7.524,
      7.525,
      7.526,
      7.527,
      7.5280000000000005E+000,
      7.529,
      7.53,
      7.5310000000000006E+000,
      7.532,
      7.533,
      7.534,
      7.535,
      7.5360000000000005E+000,
      7.537,
      7.538,
      7.5390000000000006E+000,
      7.54,
      7.541,
      7.542,
      7.543,
      7.5440000000000005E+000,
      7.545,
      7.546,
      7.5470000000000006E+000,
      7.548,
      7.549,
      7.55,
      7.551,
      7.5520000000000005E+000,
      7.553,
      7.554,
      7.555,
      7.556,
      7.557,
      7.558,
      7.559,
      7.5600000000000005E+000,
      7.561,
      7.562,
      7.563,
      7.564,
      7.565,
      7.566,
      7.567,
      7.5680000000000005E+000,
      7.569,
      7.57,
      7.571,
      7.572,
      7.573,
      7.574,
      7.575,
      7.5760000000000005E+000,
      7.577,
      7.578,
      7.579,
      7.58,
      7.581,
      7.582,
      7.583,
      7.5840000000000005E+000,
      7.585,
      7.586,
      7.587,
      7.588,
      7.589,
      7.59,
      7.591,
      7.5920000000000005E+000,
      7.593,
      7.594,
      7.595,
      7.596,
      7.597,
      7.598,
      7.599,
      7.6000000000000005E+000,
      7.601,
      7.602,
      7.603,
      7.604,
      7.605,
      7.606,
      7.607,
      7.6080000000000005E+000,
      7.609,
      7.61,
      7.611,
      7.612,
      7.613,
      7.614,
      7.615,
      7.6160000000000005E+000,
      7.617,
      7.618,
      7.619,
      7.62,
      7.621,
      7.622,
      7.623,
      7.6240000000000006E+000,
      7.625,
      7.626,
      7.627,
      7.628,
      7.6290000000000004E+000,
      7.63,
      7.631,
      7.6320000000000006E+000,
      7.633,
      7.634,
      7.635,
      7.636,
      7.6370000000000005E+000,
      7.638,
      7.639,
      7.6400000000000006E+000,
      7.641,
      7.642,
      7.643,
      7.644,
      7.6450000000000005E+000,
      7.646,
      7.647,
      7.6480000000000006E+000,
      7.649,
      7.65,
      7.651,
      7.652,
      7.6530000000000005E+000,
      7.654,
      7.655,
      7.6560000000000006E+000,
      7.657,
      7.658,
      7.659,
      7.66,
      7.6610000000000005E+000,
      7.662,
      7.663,
      7.6640000000000006E+000,
      7.665,
      7.666,
      7.667,
      7.668,
      7.6690000000000005E+000,
      7.67,
      7.671,
      7.6720000000000006E+000,
      7.673,
      7.674,
      7.675,
      7.676,
      7.6770000000000005E+000,
      7.678,
      7.679,
      7.68,
      7.681,
      7.682,
      7.683,
      7.684,
      7.6850000000000005E+000,
      7.686,
      7.687,
      7.688,
      7.689,
      7.69,
      7.691,
      7.692,
      7.6930000000000005E+000,
      7.694,
      7.695,
      7.696,
      7.697,
      7.698,
      7.699,
      7.7,
      7.7010000000000005E+000,
      7.702,
      7.703,
      7.704,
      7.705,
      7.706,
      7.707,
      7.708,
      7.7090000000000005E+000,
      7.71,
      7.711,
      7.712,
      7.713,
      7.714,
      7.715,
      7.716,
      7.7170000000000005E+000,
      7.718,
      7.719,
      7.72,
      7.721,
      7.722,
      7.723,
      7.724,
      7.7250000000000005E+000,
      7.726,
      7.727,
      7.728,
      7.729,
      7.73,
      7.731,
      7.732,
      7.7330000000000005E+000,
      7.734,
      7.735,
      7.736,
      7.737,
      7.738,
      7.739,
      7.74,
      7.7410000000000005E+000,
      7.742,
      7.743,
      7.744,
      7.745,
      7.746,
      7.747,
      7.748,
      7.7490000000000006E+000,
      7.75,
      7.751,
      7.752,
      7.753,
      7.7540000000000004E+000,
      7.755,
      7.756,
      7.7570000000000006E+000,
      7.758,
      7.759,
      7.76,
      7.761,
      7.7620000000000005E+000,
      7.763,
      7.764,
      7.7650000000000006E+000,
      7.766,
      7.767,
      7.768,
      7.769,
      7.7700000000000005E+000,
      7.771,
      7.772,
      7.7730000000000006E+000,
      7.774,
      7.775,
      7.776,
      7.777,
      7.7780000000000005E+000,
      7.779,
      7.78,
      7.7810000000000006E+000,
      7.7820000000000018E+000,
      7.7830000000000021E+000,
      7.7840000000000025E+000,
      7.7850000000000019E+000,
      7.7860000000000023E+000,
      7.7870000000000026E+000,
      7.7880000000000020E+000,
      7.7890000000000024E+000,
      7.7900000000000018E+000,
      7.7910000000000021E+000,
      7.7920000000000025E+000,
      7.7930000000000019E+000,
      7.7940000000000023E+000,
      7.7950000000000026E+000,
      7.7960000000000020E+000,
      7.7970000000000024E+000,
      7.7980000000000018E+000,
      7.7990000000000022E+000,
      7.8000000000000025E+000,
      7.8010000000000019E+000,
      7.8020000000000023E+000,
      7.8030000000000026E+000,
      7.8040000000000020E+000,
      7.8050000000000024E+000,
      7.8060000000000018E+000,
      7.8070000000000022E+000,
      7.8080000000000025E+000,
      7.8090000000000019E+000,
      7.8100000000000023E+000,
      7.8110000000000026E+000,
      7.8120000000000021E+000,
      7.8130000000000024E+000,
      7.8140000000000018E+000,
      7.8150000000000022E+000,
      7.8160000000000025E+000,
      7.8170000000000019E+000,
      7.8180000000000023E+000,
      7.8190000000000026E+000,
      7.8200000000000021E+000,
      7.8210000000000024E+000,
      7.8220000000000018E+000,
      7.8230000000000022E+000,
      7.8240000000000025E+000,
      7.8250000000000020E+000,
      7.8260000000000023E+000,
      7.8270000000000026E+000,
      7.8280000000000021E+000,
      7.8290000000000024E+000,
      7.8300000000000018E+000,
      7.8310000000000022E+000,
      7.8320000000000025E+000,
      7.8330000000000020E+000,
      7.8340000000000023E+000,
      7.8350000000000026E+000,
      7.8360000000000021E+000,
      7.8370000000000024E+000,
      7.8380000000000019E+000,
      7.8390000000000022E+000,
      7.8400000000000025E+000,
      7.8410000000000020E+000,
      7.8420000000000023E+000,
      7.8430000000000026E+000,
      7.8440000000000021E+000,
      7.8450000000000024E+000,
      7.8460000000000019E+000,
      7.8470000000000022E+000,
      7.8480000000000025E+000,
      7.8490000000000020E+000,
      7.8500000000000023E+000,
      7.8510000000000026E+000,
      7.8520000000000021E+000,
      7.8530000000000024E+000,
      7.8540000000000019E+000,
      7.8550000000000022E+000,
      7.8560000000000025E+000,
      7.8570000000000020E+000,
      7.8580000000000023E+000,
      7.8590000000000027E+000,
      7.8600000000000021E+000,
      7.8610000000000024E+000,
      7.8620000000000019E+000,
      7.8630000000000022E+000,
      7.8640000000000025E+000,
      7.8650000000000020E+000,
      7.8660000000000023E+000,
      7.8670000000000027E+000,
      7.8680000000000021E+000,
      7.8690000000000024E+000,
      7.8700000000000019E+000,
      7.8710000000000022E+000,
      7.8720000000000026E+000,
      7.8730000000000020E+000,
      7.8740000000000023E+000,
      7.8750000000000027E+000,
      7.8760000000000021E+000,
      7.8770000000000024E+000,
      7.8780000000000019E+000,
      7.8790000000000022E+000,
      7.8800000000000026E+000,
      7.8810000000000020E+000,
      7.8820000000000023E+000,
      7.8830000000000027E+000,
      7.8840000000000021E+000,
      7.8850000000000025E+000,
      7.8860000000000019E+000,
      7.8870000000000022E+000,
      7.8880000000000026E+000,
      7.8890000000000020E+000,
      7.8900000000000023E+000,
      7.8910000000000018E+000,
      7.8920000000000021E+000,
      7.8930000000000025E+000,
      7.8940000000000019E+000,
      7.8950000000000022E+000,
      7.8960000000000026E+000,
      7.8970000000000020E+000,
      7.8980000000000024E+000,
      7.8990000000000018E+000,
      7.9000000000000021E+000,
      7.9010000000000025E+000,
      7.9020000000000019E+000,
      7.9030000000000022E+000,
      7.9040000000000026E+000,
      7.9050000000000020E+000,
      7.9060000000000024E+000,
      7.9070000000000018E+000,
      7.9080000000000021E+000,
      7.9090000000000025E+000,
      7.9100000000000019E+000,
      7.9110000000000023E+000,
      7.9120000000000026E+000,
      7.9130000000000020E+000,
      7.9140000000000024E+000,
      7.9150000000000018E+000,
      7.9160000000000021E+000,
      7.9170000000000025E+000,
      7.9180000000000019E+000,
      7.9190000000000023E+000,
      7.9200000000000026E+000,
      7.9210000000000020E+000,
      7.9220000000000024E+000,
      7.9230000000000018E+000,
      7.9240000000000022E+000,
      7.9250000000000025E+000,
      7.9260000000000019E+000,
      7.9270000000000023E+000,
      7.9280000000000026E+000,
      7.9290000000000020E+000,
      7.9300000000000024E+000,
      7.9310000000000018E+000,
      7.9320000000000022E+000,
      7.9330000000000025E+000,
      7.9340000000000019E+000,
      7.9350000000000023E+000,
      7.9360000000000026E+000,
      7.9370000000000021E+000,
      7.9380000000000024E+000,
      7.9390000000000018E+000,
      7.9400000000000022E+000,
      7.9410000000000025E+000,
      7.9420000000000019E+000,
      7.9430000000000023E+000,
      7.9440000000000026E+000,
      7.9450000000000021E+000,
      7.9460000000000024E+000,
      7.9470000000000018E+000,
      7.9480000000000022E+000,
      7.9490000000000025E+000,
      7.9500000000000020E+000,
      7.9510000000000023E+000,
      7.9520000000000026E+000,
      7.9530000000000021E+000,
      7.9540000000000024E+000,
      7.9550000000000018E+000,
      7.9560000000000022E+000,
      7.9570000000000025E+000,
      7.9580000000000020E+000,
      7.9590000000000023E+000,
      7.9600000000000026E+000,
      7.9610000000000021E+000,
      7.9620000000000024E+000,
      7.9630000000000019E+000,
      7.9640000000000022E+000,
      7.9650000000000025E+000,
      7.9660000000000020E+000,
      7.9670000000000023E+000,
      7.9680000000000026E+000,
      7.9690000000000021E+000,
      7.9700000000000024E+000,
      7.9710000000000019E+000,
      7.9720000000000022E+000,
      7.9730000000000025E+000,
      7.9740000000000020E+000,
      7.9750000000000023E+000,
      7.9760000000000026E+000,
      7.9770000000000021E+000,
      7.9780000000000024E+000,
      7.9790000000000019E+000,
      7.9800000000000022E+000,
      7.9810000000000025E+000,
      7.9820000000000020E+000,
      7.9830000000000023E+000,
      7.9840000000000027E+000,
      7.9850000000000021E+000,
      7.9860000000000024E+000,
      7.9870000000000019E+000,
      7.9880000000000022E+000,
      7.9890000000000025E+000,
      7.9900000000000020E+000,
      7.9910000000000023E+000,
      7.9920000000000027E+000,
      7.9930000000000021E+000,
      7.9940000000000024E+000,
      7.9950000000000019E+000,
      7.9960000000000022E+000,
      7.9970000000000026E+000,
      7.9980000000000020E+000,
      7.9990000000000023E+000,
      8.0000000000000036E+000,
      8.0010000000000012E+000,
      8.0020000000000024E+000,
      8.0030000000000019E+000,
      8.0040000000000013E+000,
      8.0050000000000026E+000,
      8.0060000000000020E+000,
      8.0070000000000014E+000,
      8.0080000000000027E+000,
      8.0090000000000021E+000,
      8.0100000000000016E+000,
      8.0110000000000028E+000,
      8.0120000000000022E+000,
      8.0130000000000017E+000,
      8.0140000000000029E+000,
      8.0150000000000023E+000,
      8.0160000000000018E+000,
      8.0170000000000030E+000,
      8.0180000000000025E+000,
      8.0190000000000019E+000,
      8.0200000000000031E+000,
      8.0210000000000026E+000,
      8.0220000000000020E+000,
      8.0230000000000032E+000,
      8.0240000000000009E+000,
      8.0250000000000021E+000,
      8.0260000000000034E+000,
      8.0270000000000010E+000,
      8.0280000000000022E+000,
      8.0290000000000035E+000,
      8.0300000000000011E+000,
      8.0310000000000024E+000,
      8.0320000000000018E+000,
      8.0330000000000013E+000,
      8.0340000000000025E+000,
      8.0350000000000019E+000,
      8.0360000000000014E+000,
      8.0370000000000026E+000,
      8.0380000000000020E+000,
      8.0390000000000015E+000,
      8.0400000000000027E+000,
      8.0410000000000021E+000,
      8.0420000000000016E+000,
      8.0430000000000028E+000,
      8.0440000000000023E+000,
      8.0450000000000017E+000,
      8.0460000000000029E+000,
      8.0470000000000024E+000,
      8.0480000000000018E+000,
      8.0490000000000030E+000,
      8.0500000000000025E+000,
      8.0510000000000019E+000,
      8.0520000000000032E+000,
      8.0530000000000026E+000,
      8.0540000000000020E+000,
      8.0550000000000033E+000,
      8.0560000000000009E+000,
      8.0570000000000022E+000,
      8.0580000000000034E+000,
      8.0590000000000011E+000,
      8.0600000000000023E+000,
      8.0610000000000035E+000,
      8.0620000000000012E+000,
      8.0630000000000024E+000,
      8.0640000000000018E+000,
      8.0650000000000013E+000,
      8.0660000000000025E+000,
      8.0670000000000019E+000,
      8.0680000000000014E+000,
      8.0690000000000026E+000,
      8.0700000000000021E+000,
      8.0710000000000015E+000,
      8.0720000000000027E+000,
      8.0730000000000022E+000,
      8.0740000000000016E+000,
      8.0750000000000028E+000,
      8.0760000000000023E+000,
      8.0770000000000017E+000,
      8.0780000000000030E+000,
      8.0790000000000024E+000,
      8.0800000000000018E+000,
      8.0810000000000031E+000,
      8.0820000000000025E+000,
      8.0830000000000020E+000,
      8.0840000000000032E+000,
      8.0850000000000026E+000,
      8.0860000000000021E+000,
      8.0870000000000033E+000,
      8.0880000000000010E+000,
      8.0890000000000022E+000,
      8.0900000000000034E+000,
      8.0910000000000011E+000,
      8.0920000000000023E+000,
      8.0930000000000035E+000,
      8.0940000000000012E+000,
      8.0950000000000024E+000,
      8.0960000000000019E+000,
      8.0970000000000013E+000,
      8.0980000000000025E+000,
      8.0990000000000020E+000,
      8.1000000000000014E+000,
      8.1010000000000026E+000,
      8.1020000000000021E+000,
      8.1030000000000015E+000,
      8.1040000000000028E+000,
      8.1050000000000022E+000,
      8.1060000000000016E+000,
      8.1070000000000029E+000,
      8.1080000000000023E+000,
      8.1090000000000018E+000,
      8.1100000000000030E+000,
      8.1110000000000024E+000,
      8.1120000000000019E+000,
      8.1130000000000031E+000,
      8.1140000000000025E+000,
      8.1150000000000020E+000,
      8.1160000000000032E+000,
      8.1170000000000027E+000,
      8.1180000000000021E+000,
      8.1190000000000033E+000,
      8.1200000000000010E+000,
      8.1210000000000022E+000,
      8.1220000000000034E+000,
      8.1230000000000011E+000,
      8.1240000000000023E+000,
      8.1250000000000036E+000,
      8.1260000000000012E+000,
      8.1270000000000024E+000,
      8.1280000000000019E+000,
      8.1290000000000013E+000,
      8.1300000000000026E+000,
      8.1310000000000020E+000,
      8.1320000000000014E+000,
      8.1330000000000027E+000,
      8.1340000000000021E+000,
      8.1350000000000016E+000,
      8.1360000000000028E+000,
      8.1370000000000022E+000,
      8.1380000000000017E+000,
      8.1390000000000029E+000,
      8.1400000000000023E+000,
      8.1410000000000018E+000,
      8.1420000000000030E+000,
      8.1430000000000025E+000,
      8.1440000000000019E+000,
      8.1450000000000031E+000,
      8.1460000000000026E+000,
      8.1470000000000020E+000,
      8.1480000000000032E+000,
      8.1490000000000009E+000,
      8.1500000000000021E+000,
      8.1510000000000034E+000,
      8.1520000000000010E+000,
      8.1530000000000022E+000,
      8.1540000000000035E+000,
      8.1550000000000011E+000,
      8.1560000000000024E+000,
      8.1570000000000018E+000,
      8.1580000000000013E+000,
      8.1590000000000025E+000,
      8.1600000000000019E+000,
      8.1610000000000014E+000,
      8.1620000000000026E+000,
      8.1630000000000020E+000,
      8.1640000000000015E+000,
      8.1650000000000027E+000,
      8.1660000000000021E+000,
      8.1670000000000016E+000,
      8.1680000000000028E+000,
      8.1690000000000023E+000,
      8.1700000000000017E+000,
      8.1710000000000029E+000,
      8.1720000000000024E+000,
      8.1730000000000018E+000,
      8.1740000000000030E+000,
      8.1750000000000025E+000,
      8.1760000000000019E+000,
      8.1770000000000032E+000,
      8.1780000000000026E+000,
      8.1790000000000020E+000,
      8.1800000000000033E+000,
      8.1810000000000009E+000,
      8.1820000000000022E+000,
      8.1830000000000034E+000,
      8.1840000000000011E+000,
      8.1850000000000023E+000,
      8.1860000000000035E+000,
      8.1870000000000012E+000,
      8.1880000000000024E+000,
      8.1890000000000018E+000,
      8.1900000000000013E+000,
      8.1910000000000025E+000,
      8.1920000000000019E+000,
      8.1930000000000014E+000,
      8.1940000000000026E+000,
      8.1950000000000021E+000,
      8.1960000000000015E+000,
      8.1970000000000027E+000,
      8.1980000000000022E+000,
      8.1990000000000016E+000,
      8.2000000000000028E+000,
      8.2010000000000023E+000,
      8.2020000000000017E+000,
      8.2030000000000030E+000,
      8.2040000000000024E+000,
      8.2050000000000018E+000,
      8.2060000000000031E+000,
      8.2070000000000025E+000,
      8.2080000000000020E+000,
      8.2090000000000032E+000,
      8.2100000000000026E+000,
      8.2110000000000021E+000,
      8.2120000000000033E+000,
      8.2130000000000010E+000,
      8.2140000000000022E+000,
      8.2150000000000034E+000,
      8.2160000000000011E+000,
      8.2170000000000023E+000,
      8.2180000000000035E+000,
      8.2190000000000012E+000,
      8.2200000000000024E+000,
      8.2210000000000019E+000,
      8.2220000000000013E+000,
      8.2230000000000025E+000,
      8.2240000000000020E+000,
      8.2250000000000014E+000,
      8.2260000000000026E+000,
      8.2270000000000021E+000,
      8.2280000000000015E+000,
      8.2290000000000028E+000,
      8.2300000000000022E+000,
      8.2310000000000016E+000,
      8.2320000000000029E+000,
      8.2330000000000023E+000,
      8.2340000000000018E+000,
      8.2350000000000030E+000,
      8.2360000000000024E+000,
      8.2370000000000019E+000,
      8.2380000000000031E+000,
      8.2390000000000025E+000,
      8.2400000000000020E+000,
      8.2410000000000032E+000,
      8.2420000000000027E+000,
      8.2430000000000021E+000,
      8.2440000000000033E+000,
      8.2450000000000010E+000,
      8.2460000000000022E+000,
      8.2470000000000034E+000,
      8.2480000000000011E+000,
      8.2490000000000023E+000,
      8.2500000000000036E+000,
      8.2510000000000012E+000,
      8.2520000000000024E+000,
      8.2530000000000019E+000,
      8.2540000000000013E+000,
      8.2550000000000026E+000,
      8.2560000000000020E+000,
      8.2570000000000014E+000,
      8.2580000000000027E+000,
      8.2590000000000021E+000,
      8.2600000000000016E+000,
      8.2610000000000028E+000,
      8.2620000000000022E+000,
      8.2630000000000017E+000,
      8.2640000000000029E+000,
      8.2650000000000023E+000,
      8.2660000000000018E+000,
      8.2670000000000030E+000,
      8.2680000000000025E+000,
      8.2690000000000019E+000,
      8.2700000000000031E+000,
      8.2710000000000026E+000,
      8.2720000000000020E+000,
      8.2730000000000032E+000,
      8.2740000000000009E+000,
      8.2750000000000021E+000,
      8.2760000000000034E+000,
      8.2770000000000010E+000,
      8.2780000000000022E+000,
      8.2790000000000035E+000,
      8.2800000000000011E+000,
      8.2810000000000024E+000,
      8.2820000000000018E+000,
      8.2830000000000013E+000,
      8.2840000000000025E+000,
      8.2850000000000019E+000,
      8.2860000000000014E+000,
      8.2870000000000026E+000,
      8.2880000000000020E+000,
      8.2890000000000015E+000,
      8.2900000000000027E+000,
      8.2910000000000021E+000,
      8.2920000000000016E+000,
      8.2930000000000028E+000,
      8.2940000000000023E+000,
      8.2950000000000017E+000,
      8.2960000000000029E+000,
      8.2970000000000024E+000,
      8.2980000000000018E+000,
      8.2990000000000030E+000,
      8.3000000000000025E+000,
      8.3010000000000019E+000,
      8.3020000000000032E+000,
      8.3030000000000026E+000,
      8.3040000000000020E+000,
      8.3050000000000033E+000,
      8.3060000000000009E+000,
      8.3070000000000022E+000,
      8.3080000000000034E+000,
      8.3090000000000011E+000,
      8.3100000000000023E+000,
      8.3110000000000035E+000,
      8.3120000000000012E+000,
      8.3130000000000024E+000,
      8.3140000000000018E+000,
      8.3150000000000013E+000,
      8.3160000000000025E+000,
      8.3170000000000019E+000,
      8.3180000000000014E+000,
      8.3190000000000026E+000,
      8.3200000000000021E+000,
      8.3210000000000015E+000,
      8.3220000000000027E+000,
      8.3230000000000022E+000,
      8.3240000000000016E+000,
      8.3250000000000028E+000,
      8.3260000000000023E+000,
      8.3270000000000017E+000,
      8.3280000000000030E+000,
      8.3290000000000024E+000,
      8.3300000000000018E+000,
      8.3310000000000031E+000,
      8.3320000000000025E+000,
      8.3330000000000020E+000,
      8.3340000000000032E+000,
      8.3350000000000026E+000,
      8.3360000000000021E+000,
      8.3370000000000033E+000,
      8.3380000000000010E+000,
      8.3390000000000022E+000,
      8.3400000000000034E+000,
      8.3410000000000011E+000,
      8.3420000000000023E+000,
      8.3430000000000035E+000,
      8.3440000000000012E+000,
      8.3450000000000024E+000,
      8.3460000000000019E+000,
      8.3470000000000013E+000,
      8.3480000000000025E+000,
      8.3490000000000020E+000,
      8.3500000000000014E+000,
      8.3510000000000026E+000,
      8.3520000000000021E+000,
      8.3530000000000015E+000,
      8.3540000000000028E+000,
      8.3550000000000022E+000,
      8.3560000000000016E+000,
      8.3570000000000029E+000,
      8.3580000000000023E+000,
      8.3590000000000018E+000,
      8.3600000000000030E+000,
      8.3610000000000024E+000,
      8.3620000000000019E+000,
      8.3630000000000031E+000,
      8.3640000000000025E+000,
      8.3650000000000020E+000,
      8.3660000000000032E+000,
      8.3670000000000027E+000,
      8.3680000000000021E+000,
      8.3690000000000033E+000,
      8.3700000000000010E+000,
      8.3710000000000022E+000,
      8.3720000000000034E+000,
      8.3730000000000011E+000,
      8.3740000000000023E+000,
      8.3750000000000036E+000,
      8.3760000000000012E+000,
      8.3770000000000024E+000,
      8.3780000000000019E+000,
      8.3790000000000013E+000,
      8.3800000000000026E+000,
      8.3810000000000020E+000,
      8.3820000000000014E+000,
      8.3830000000000027E+000,
      8.3840000000000021E+000,
      8.3850000000000016E+000,
      8.3860000000000028E+000,
      8.3870000000000022E+000,
      8.3880000000000017E+000,
      8.3890000000000029E+000,
      8.3900000000000023E+000,
      8.3910000000000018E+000,
      8.3920000000000030E+000,
      8.3930000000000025E+000,
      8.3940000000000019E+000,
      8.3950000000000031E+000,
      8.3960000000000026E+000,
      8.3970000000000020E+000,
      8.3980000000000032E+000,
      8.3990000000000009E+000,
      8.4000000000000021E+000,
      8.4010000000000034E+000,
      8.4020000000000010E+000,
      8.4030000000000022E+000,
      8.4040000000000035E+000,
      8.4050000000000011E+000,
      8.4060000000000024E+000,
      8.4070000000000018E+000,
      8.4080000000000013E+000,
      8.4090000000000025E+000,
      8.4100000000000019E+000,
      8.4110000000000014E+000,
      8.4120000000000026E+000,
      8.4130000000000020E+000,
      8.4140000000000015E+000,
      8.4150000000000027E+000,
      8.4160000000000021E+000,
      8.4170000000000016E+000,
      8.4180000000000028E+000,
      8.4190000000000023E+000,
      8.4200000000000017E+000,
      8.4210000000000029E+000,
      8.4220000000000024E+000,
      8.4230000000000018E+000,
      8.4240000000000030E+000,
      8.4250000000000025E+000,
      8.4260000000000019E+000,
      8.4270000000000032E+000,
      8.4280000000000026E+000,
      8.4290000000000020E+000,
      8.4300000000000033E+000,
      8.4310000000000009E+000,
      8.4320000000000022E+000,
      8.4330000000000034E+000,
      8.4340000000000011E+000,
      8.4350000000000023E+000,
      8.4360000000000035E+000,
      8.4370000000000012E+000,
      8.4380000000000024E+000,
      8.4390000000000018E+000,
      8.4400000000000013E+000,
      8.4410000000000025E+000,
      8.4420000000000019E+000,
      8.4430000000000014E+000,
      8.4440000000000026E+000,
      8.4450000000000021E+000,
      8.4460000000000015E+000,
      8.4470000000000027E+000,
      8.4480000000000022E+000,
      8.4490000000000016E+000,
      8.4500000000000028E+000,
      8.4510000000000023E+000,
      8.4520000000000017E+000,
      8.4530000000000030E+000,
      8.4540000000000024E+000,
      8.4550000000000018E+000,
      8.4560000000000031E+000,
      8.4570000000000025E+000,
      8.4580000000000020E+000,
      8.4590000000000032E+000,
      8.4600000000000026E+000,
      8.4610000000000021E+000,
      8.4620000000000033E+000,
      8.4630000000000010E+000,
      8.4640000000000022E+000,
      8.4650000000000034E+000,
      8.4660000000000011E+000,
      8.4670000000000023E+000,
      8.4680000000000035E+000,
      8.4690000000000012E+000,
      8.4700000000000024E+000,
      8.4710000000000019E+000,
      8.4720000000000013E+000,
      8.4730000000000025E+000,
      8.4740000000000020E+000,
      8.4750000000000014E+000,
      8.4760000000000026E+000,
      8.4770000000000021E+000,
      8.4780000000000015E+000,
      8.4790000000000028E+000,
      8.4800000000000022E+000,
      8.4810000000000016E+000,
      8.4820000000000029E+000,
      8.4830000000000023E+000,
      8.4840000000000018E+000,
      8.4850000000000030E+000,
      8.4860000000000024E+000,
      8.4870000000000019E+000,
      8.4880000000000031E+000,
      8.4890000000000025E+000,
      8.4900000000000020E+000,
      8.4910000000000032E+000,
      8.4920000000000027E+000,
      8.4930000000000021E+000,
      8.4940000000000033E+000,
      8.4950000000000010E+000,
      8.4960000000000022E+000,
      8.4970000000000034E+000,
      8.4980000000000011E+000,
      8.4990000000000023E+000,
      8.5000000000000036E+000,
      8.5010000000000012E+000,
      8.5020000000000024E+000,
      8.5030000000000019E+000,
      8.5040000000000013E+000,
      8.5050000000000026E+000,
      8.5060000000000020E+000,
      8.5070000000000014E+000,
      8.5080000000000027E+000,
      8.5090000000000021E+000,
      8.5100000000000016E+000,
      8.5110000000000028E+000,
      8.5120000000000022E+000,
      8.5130000000000017E+000,
      8.5140000000000029E+000,
      8.5150000000000023E+000,
      8.5160000000000018E+000,
      8.5170000000000030E+000,
      8.5180000000000025E+000,
      8.5190000000000019E+000,
      8.5200000000000031E+000,
      8.5210000000000026E+000,
      8.5220000000000020E+000,
      8.5230000000000032E+000,
      8.5240000000000009E+000,
      8.5250000000000021E+000,
      8.5260000000000034E+000,
      8.5270000000000010E+000,
      8.5280000000000022E+000,
      8.5290000000000035E+000,
      8.5300000000000011E+000,
      8.5310000000000024E+000,
      8.5320000000000018E+000,
      8.5330000000000013E+000,
      8.5340000000000025E+000,
      8.5350000000000019E+000,
      8.5360000000000014E+000,
      8.5370000000000026E+000,
      8.5380000000000020E+000,
      8.5390000000000015E+000,
      8.5400000000000027E+000,
      8.5410000000000021E+000,
      8.5420000000000016E+000,
      8.5430000000000028E+000,
      8.5440000000000023E+000,
      8.5450000000000017E+000,
      8.5460000000000029E+000,
      8.5470000000000024E+000,
      8.5480000000000018E+000,
      8.5490000000000030E+000,
      8.5500000000000025E+000,
      8.5510000000000019E+000,
      8.5520000000000032E+000,
      8.5530000000000026E+000,
      8.5540000000000020E+000,
      8.5550000000000033E+000,
      8.5560000000000009E+000,
      8.5570000000000022E+000,
      8.5580000000000034E+000,
      8.5590000000000011E+000,
      8.5600000000000023E+000,
      8.5610000000000035E+000,
      8.5620000000000012E+000,
      8.5630000000000024E+000,
      8.5640000000000018E+000,
      8.5650000000000013E+000,
      8.5660000000000025E+000,
      8.5670000000000019E+000,
      8.5680000000000014E+000,
      8.5690000000000026E+000,
      8.5700000000000021E+000,
      8.5710000000000015E+000,
      8.5720000000000027E+000,
      8.5730000000000022E+000,
      8.5740000000000016E+000,
      8.5750000000000028E+000,
      8.5760000000000023E+000,
      8.5770000000000017E+000,
      8.5780000000000030E+000,
      8.5790000000000024E+000,
      8.5800000000000018E+000,
      8.5810000000000031E+000,
      8.5820000000000025E+000,
      8.5830000000000020E+000,
      8.5840000000000032E+000,
      8.5850000000000026E+000,
      8.5860000000000021E+000,
      8.5870000000000033E+000,
      8.5880000000000010E+000,
      8.5890000000000022E+000,
      8.5900000000000034E+000,
      8.5910000000000011E+000,
      8.5920000000000023E+000,
      8.5930000000000035E+000,
      8.5940000000000012E+000,
      8.5950000000000024E+000,
      8.5960000000000019E+000,
      8.5970000000000013E+000,
      8.5980000000000025E+000,
      8.5990000000000020E+000,
      8.6000000000000014E+000,
      8.6010000000000026E+000,
      8.6020000000000021E+000,
      8.6030000000000015E+000,
      8.6040000000000028E+000,
      8.6050000000000022E+000,
      8.6060000000000016E+000,
      8.6070000000000029E+000,
      8.6080000000000023E+000,
      8.6090000000000018E+000,
      8.6100000000000030E+000,
      8.6110000000000024E+000,
      8.6120000000000019E+000,
      8.6130000000000031E+000,
      8.6140000000000025E+000,
      8.6150000000000020E+000,
      8.6160000000000032E+000,
      8.6170000000000027E+000,
      8.6180000000000021E+000,
      8.6190000000000033E+000,
      8.6200000000000010E+000,
      8.6210000000000022E+000,
      8.6220000000000034E+000,
      8.6230000000000011E+000,
      8.6240000000000023E+000,
      8.6250000000000036E+000,
      8.6260000000000012E+000,
      8.6270000000000024E+000,
      8.6280000000000019E+000,
      8.6290000000000013E+000,
      8.6300000000000026E+000,
      8.6310000000000020E+000,
      8.6320000000000014E+000,
      8.6330000000000027E+000,
      8.6340000000000021E+000,
      8.6350000000000016E+000,
      8.6360000000000028E+000,
      8.6370000000000022E+000,
      8.6380000000000017E+000,
      8.6390000000000029E+000,
      8.6400000000000023E+000,
      8.6410000000000018E+000,
      8.6420000000000030E+000,
      8.6430000000000025E+000,
      8.6440000000000019E+000,
      8.6450000000000031E+000,
      8.6460000000000026E+000,
      8.6470000000000020E+000,
      8.6480000000000032E+000,
      8.6490000000000027E+000,
      8.6500000000000021E+000,
      8.6510000000000034E+000,
      8.6520000000000010E+000,
      8.6530000000000022E+000,
      8.6540000000000035E+000,
      8.6550000000000011E+000,
      8.6560000000000024E+000,
      8.6570000000000018E+000,
      8.6580000000000013E+000,
      8.6590000000000025E+000,
      8.6600000000000019E+000,
      8.6610000000000014E+000,
      8.6620000000000026E+000,
      8.6630000000000020E+000,
      8.6640000000000015E+000,
      8.6650000000000027E+000,
      8.6660000000000021E+000,
      8.6670000000000016E+000,
      8.6680000000000028E+000,
      8.6690000000000023E+000,
      8.6700000000000017E+000,
      8.6710000000000029E+000,
      8.6720000000000024E+000,
      8.6730000000000018E+000,
      8.6740000000000030E+000,
      8.6750000000000025E+000,
      8.6760000000000019E+000,
      8.6770000000000032E+000,
      8.6780000000000026E+000,
      8.6790000000000020E+000,
      8.6800000000000033E+000,
      8.6810000000000009E+000,
      8.6820000000000022E+000,
      8.6830000000000034E+000,
      8.6840000000000011E+000,
      8.6850000000000023E+000,
      8.6860000000000035E+000,
      8.6870000000000012E+000,
      8.6880000000000024E+000,
      8.6890000000000018E+000,
      8.6900000000000013E+000,
      8.6910000000000025E+000,
      8.6920000000000019E+000,
      8.6930000000000014E+000,
      8.6940000000000026E+000,
      8.6950000000000021E+000,
      8.6960000000000015E+000,
      8.6970000000000027E+000,
      8.6980000000000022E+000,
      8.6990000000000016E+000,
      8.7000000000000028E+000,
      8.7010000000000023E+000,
      8.7020000000000017E+000,
      8.7030000000000030E+000,
      8.7040000000000024E+000,
      8.7050000000000018E+000,
      8.7060000000000031E+000,
      8.7070000000000025E+000,
      8.7080000000000020E+000,
      8.7090000000000032E+000,
      8.7100000000000026E+000,
      8.7110000000000021E+000,
      8.7120000000000033E+000,
      8.7130000000000010E+000,
      8.7140000000000022E+000,
      8.7150000000000034E+000,
      8.7160000000000011E+000,
      8.7170000000000023E+000,
      8.7180000000000035E+000,
      8.7190000000000012E+000,
      8.7200000000000024E+000,
      8.7210000000000019E+000,
      8.7220000000000013E+000,
      8.7230000000000025E+000,
      8.7240000000000020E+000,
      8.7250000000000014E+000,
      8.7260000000000026E+000,
      8.7270000000000021E+000,
      8.7280000000000015E+000,
      8.7290000000000028E+000,
      8.7300000000000022E+000,
      8.7310000000000016E+000,
      8.7320000000000029E+000,
      8.7330000000000023E+000,
      8.7340000000000018E+000,
      8.7350000000000030E+000,
      8.7360000000000024E+000,
      8.7370000000000019E+000,
      8.7380000000000031E+000,
      8.7390000000000025E+000,
      8.7400000000000020E+000,
      8.7410000000000032E+000,
      8.7420000000000027E+000,
      8.7430000000000021E+000,
      8.7440000000000033E+000,
      8.7450000000000010E+000,
      8.7460000000000022E+000,
      8.7470000000000034E+000,
      8.7480000000000011E+000,
      8.7490000000000023E+000,
      8.7500000000000036E+000,
      8.7510000000000012E+000,
      8.7520000000000024E+000,
      8.7530000000000019E+000,
      8.7540000000000013E+000,
      8.7550000000000026E+000,
      8.7560000000000020E+000,
      8.7570000000000014E+000,
      8.7580000000000027E+000,
      8.7590000000000021E+000,
      8.7600000000000016E+000,
      8.7610000000000028E+000,
      8.7620000000000022E+000,
      8.7630000000000017E+000,
      8.7640000000000029E+000,
      8.7650000000000023E+000,
      8.7660000000000018E+000,
      8.7670000000000030E+000,
      8.7680000000000025E+000,
      8.7690000000000019E+000,
      8.7700000000000031E+000,
      8.7710000000000026E+000,
      8.7720000000000020E+000,
      8.7730000000000032E+000,
      8.7740000000000027E+000,
      8.7750000000000021E+000,
      8.7760000000000034E+000,
      8.7770000000000010E+000,
      8.7780000000000022E+000,
      8.7790000000000035E+000,
      8.7800000000000011E+000,
      8.7810000000000024E+000,
      8.7820000000000018E+000,
      8.7830000000000013E+000,
      8.7840000000000025E+000,
      8.7850000000000019E+000,
      8.7860000000000014E+000,
      8.7870000000000026E+000,
      8.7880000000000020E+000,
      8.7890000000000015E+000,
      8.7900000000000027E+000,
      8.7910000000000021E+000,
      8.7920000000000016E+000,
      8.7930000000000028E+000,
      8.7940000000000023E+000,
      8.7950000000000017E+000,
      8.7960000000000029E+000,
      8.7970000000000024E+000,
      8.7980000000000018E+000,
      8.7990000000000030E+000,
      8.8000000000000025E+000,
      8.8010000000000019E+000,
      8.8020000000000032E+000,
      8.8030000000000026E+000,
      8.8040000000000020E+000,
      8.8050000000000033E+000,
      8.8060000000000009E+000,
      8.8070000000000022E+000,
      8.8080000000000034E+000,
      8.8090000000000011E+000,
      8.8100000000000023E+000,
      8.8110000000000035E+000,
      8.8120000000000012E+000,
      8.8130000000000024E+000,
      8.8140000000000018E+000,
      8.8150000000000013E+000,
      8.8160000000000025E+000,
      8.8170000000000019E+000,
      8.8180000000000014E+000,
      8.8190000000000026E+000,
      8.8200000000000021E+000,
      8.8210000000000015E+000,
      8.8220000000000027E+000,
      8.8230000000000022E+000,
      8.8240000000000016E+000,
      8.8250000000000028E+000,
      8.8260000000000023E+000,
      8.8270000000000017E+000,
      8.8280000000000030E+000,
      8.8290000000000024E+000,
      8.8300000000000018E+000,
      8.8310000000000031E+000,
      8.8320000000000025E+000,
      8.8330000000000020E+000,
      8.8340000000000032E+000,
      8.8350000000000026E+000,
      8.8360000000000021E+000,
      8.8370000000000033E+000,
      8.8380000000000010E+000,
      8.8390000000000022E+000,
      8.8400000000000034E+000,
      8.8410000000000011E+000,
      8.8420000000000023E+000,
      8.8430000000000035E+000,
      8.8440000000000012E+000,
      8.8450000000000024E+000,
      8.8460000000000019E+000,
      8.8470000000000013E+000,
      8.8480000000000025E+000,
      8.8490000000000020E+000,
      8.8500000000000014E+000,
      8.8510000000000026E+000,
      8.8520000000000021E+000,
      8.8530000000000015E+000,
      8.8540000000000028E+000,
      8.8550000000000022E+000,
      8.8560000000000016E+000,
      8.8570000000000029E+000,
      8.8580000000000023E+000,
      8.8590000000000018E+000,
      8.8600000000000030E+000,
      8.8610000000000024E+000,
      8.8620000000000019E+000,
      8.8630000000000031E+000,
      8.8640000000000025E+000,
      8.8650000000000020E+000,
      8.8660000000000032E+000,
      8.8670000000000027E+000,
      8.8680000000000021E+000,
      8.8690000000000033E+000,
      8.8700000000000010E+000,
      8.8710000000000022E+000,
      8.8720000000000034E+000,
      8.8730000000000011E+000,
      8.8740000000000023E+000,
      8.8750000000000036E+000,
      8.8760000000000012E+000,
      8.8770000000000024E+000,
      8.8780000000000019E+000,
      8.8790000000000013E+000,
      8.8800000000000026E+000,
      8.8810000000000020E+000,
      8.8820000000000014E+000,
      8.8830000000000027E+000,
      8.8840000000000021E+000,
      8.8850000000000016E+000,
      8.8860000000000028E+000,
      8.8870000000000022E+000,
      8.8880000000000017E+000,
      8.8890000000000029E+000,
      8.8900000000000023E+000,
      8.8910000000000018E+000,
      8.8920000000000030E+000,
      8.8930000000000025E+000,
      8.8940000000000019E+000,
      8.8950000000000031E+000,
      8.8960000000000026E+000,
      8.8970000000000020E+000,
      8.8980000000000032E+000,
      8.8990000000000027E+000,
      8.9000000000000021E+000,
      8.9010000000000034E+000,
      8.9020000000000010E+000,
      8.9030000000000022E+000,
      8.9040000000000035E+000,
      8.9050000000000011E+000,
      8.9060000000000024E+000,
      8.9070000000000018E+000,
      8.9080000000000013E+000,
      8.9090000000000025E+000,
      8.9100000000000019E+000,
      8.9110000000000014E+000,
      8.9120000000000026E+000,
      8.9130000000000020E+000,
      8.9140000000000015E+000,
      8.9150000000000027E+000,
      8.9160000000000021E+000,
      8.9170000000000016E+000,
      8.9180000000000028E+000,
      8.9190000000000023E+000,
      8.9200000000000017E+000,
      8.9210000000000029E+000,
      8.9220000000000024E+000,
      8.9230000000000018E+000,
      8.9240000000000030E+000,
      8.9250000000000025E+000,
      8.9260000000000019E+000,
      8.9270000000000032E+000,
      8.9280000000000026E+000,
      8.9290000000000020E+000,
      8.9300000000000033E+000,
      8.9310000000000009E+000,
      8.9320000000000022E+000,
      8.9330000000000034E+000,
      8.9340000000000011E+000,
      8.9350000000000023E+000,
      8.9360000000000035E+000,
      8.9370000000000012E+000,
      8.9380000000000024E+000,
      8.9390000000000018E+000,
      8.9400000000000013E+000,
      8.9410000000000025E+000,
      8.9420000000000019E+000,
      8.9430000000000014E+000,
      8.9440000000000026E+000,
      8.9450000000000021E+000,
      8.9460000000000015E+000,
      8.9470000000000027E+000,
      8.9480000000000022E+000,
      8.9490000000000016E+000,
      8.9500000000000028E+000,
      8.9510000000000023E+000,
      8.9520000000000017E+000,
      8.9530000000000030E+000,
      8.9540000000000024E+000,
      8.9550000000000018E+000,
      8.9560000000000031E+000,
      8.9570000000000025E+000,
      8.9580000000000020E+000,
      8.9590000000000032E+000,
      8.9600000000000026E+000,
      8.9610000000000021E+000,
      8.9620000000000033E+000,
      8.9630000000000010E+000,
      8.9640000000000022E+000,
      8.9650000000000034E+000,
      8.9660000000000011E+000,
      8.9670000000000023E+000,
      8.9680000000000035E+000,
      8.9690000000000012E+000,
      8.9700000000000024E+000,
      8.9710000000000019E+000,
      8.9720000000000013E+000,
      8.9730000000000025E+000,
      8.9740000000000020E+000,
      8.9750000000000014E+000,
      8.9760000000000026E+000,
      8.9770000000000021E+000,
      8.9780000000000015E+000,
      8.9790000000000028E+000,
      8.9800000000000022E+000,
      8.9810000000000016E+000,
      8.9820000000000029E+000,
      8.9830000000000023E+000,
      8.9840000000000018E+000,
      8.9850000000000030E+000,
      8.9860000000000024E+000,
      8.9870000000000019E+000,
      8.9880000000000031E+000,
      8.9890000000000025E+000,
      8.9900000000000020E+000,
      8.9910000000000032E+000,
      8.9920000000000027E+000,
      8.9930000000000021E+000,
      8.9940000000000033E+000,
      8.9950000000000010E+000,
      8.9960000000000022E+000,
      8.9970000000000034E+000,
      8.9980000000000011E+000,
      8.9990000000000023E+000,
      9.0000000000000036E+000,
      9.0010000000000012E+000,
      9.0020000000000024E+000,
      9.0030000000000019E+000,
      9.0040000000000013E+000,
      9.0050000000000026E+000,
      9.0060000000000020E+000,
      9.0070000000000014E+000,
      9.0080000000000027E+000,
      9.0090000000000021E+000,
      9.0100000000000016E+000,
      9.0110000000000028E+000,
      9.0120000000000022E+000,
      9.0130000000000017E+000,
      9.0140000000000029E+000,
      9.0150000000000023E+000,
      9.0160000000000018E+000,
      9.0170000000000030E+000,
      9.0180000000000025E+000,
      9.0190000000000019E+000,
      9.0200000000000031E+000,
      9.0210000000000026E+000,
      9.0220000000000020E+000,
      9.0230000000000032E+000,
      9.0240000000000027E+000,
      9.0250000000000021E+000,
      9.0260000000000034E+000,
      9.0270000000000010E+000,
      9.0280000000000022E+000,
      9.0290000000000035E+000,
      9.0300000000000011E+000,
      9.0310000000000024E+000,
      9.0320000000000036E+000,
      9.0330000000000013E+000,
      9.0340000000000025E+000,
      9.0350000000000019E+000,
      9.0360000000000014E+000,
      9.0370000000000026E+000,
      9.0380000000000020E+000,
      9.0390000000000015E+000,
      9.0400000000000027E+000,
      9.0410000000000021E+000,
      9.0420000000000016E+000,
      9.0430000000000028E+000,
      9.0440000000000023E+000,
      9.0450000000000017E+000,
      9.0460000000000029E+000,
      9.0470000000000024E+000,
      9.0480000000000018E+000,
      9.0490000000000030E+000,
      9.0500000000000025E+000,
      9.0510000000000019E+000,
      9.0520000000000032E+000,
      9.0530000000000026E+000,
      9.0540000000000020E+000,
      9.0550000000000033E+000,
      9.0560000000000009E+000,
      9.0570000000000022E+000,
      9.0580000000000034E+000,
      9.0590000000000011E+000,
      9.0600000000000023E+000,
      9.0610000000000035E+000,
      9.0620000000000012E+000,
      9.0630000000000024E+000,
      9.0640000000000018E+000,
      9.0650000000000013E+000,
      9.0660000000000025E+000,
      9.0670000000000019E+000,
      9.0680000000000014E+000,
      9.0690000000000026E+000,
      9.0700000000000021E+000,
      9.0710000000000015E+000,
      9.0720000000000027E+000,
      9.0730000000000022E+000,
      9.0740000000000016E+000,
      9.0750000000000028E+000,
      9.0760000000000023E+000,
      9.0770000000000017E+000,
      9.0780000000000030E+000,
      9.0790000000000024E+000,
      9.0800000000000018E+000,
      9.0810000000000031E+000,
      9.0820000000000025E+000,
      9.0830000000000020E+000,
      9.0840000000000032E+000,
      9.0850000000000026E+000,
      9.0860000000000021E+000,
      9.0870000000000033E+000,
      9.0880000000000010E+000,
      9.0890000000000022E+000,
      9.0900000000000034E+000,
      9.0910000000000011E+000,
      9.0920000000000023E+000,
      9.0930000000000035E+000,
      9.0940000000000012E+000,
      9.0950000000000024E+000,
      9.0960000000000019E+000,
      9.0970000000000013E+000,
      9.0980000000000025E+000,
      9.0990000000000020E+000,
      9.1000000000000014E+000,
      9.1010000000000026E+000,
      9.1020000000000021E+000,
      9.1030000000000015E+000,
      9.1040000000000028E+000,
      9.1050000000000022E+000,
      9.1060000000000016E+000,
      9.1070000000000029E+000,
      9.1080000000000023E+000,
      9.1090000000000018E+000,
      9.1100000000000030E+000,
      9.1110000000000024E+000,
      9.1120000000000019E+000,
      9.1130000000000031E+000,
      9.1140000000000025E+000,
      9.1150000000000020E+000,
      9.1160000000000032E+000,
      9.1170000000000027E+000,
      9.1180000000000021E+000,
      9.1190000000000033E+000,
      9.1200000000000010E+000,
      9.1210000000000022E+000,
      9.1220000000000034E+000,
      9.1230000000000011E+000,
      9.1240000000000023E+000,
      9.1250000000000036E+000,
      9.1260000000000012E+000,
      9.1270000000000024E+000,
      9.1280000000000019E+000,
      9.1290000000000013E+000,
      9.1300000000000026E+000,
      9.1310000000000020E+000,
      9.1320000000000014E+000,
      9.1330000000000027E+000,
      9.1340000000000021E+000,
      9.1350000000000016E+000,
      9.1360000000000028E+000,
      9.1370000000000022E+000,
      9.1380000000000017E+000,
      9.1390000000000029E+000,
      9.1400000000000023E+000,
      9.1410000000000018E+000,
      9.1420000000000030E+000,
      9.1430000000000025E+000,
      9.1440000000000019E+000,
      9.1450000000000031E+000,
      9.1460000000000026E+000,
      9.1470000000000020E+000,
      9.1480000000000032E+000,
      9.1490000000000027E+000,
      9.1500000000000021E+000,
      9.1510000000000034E+000,
      9.1520000000000010E+000,
      9.1530000000000022E+000,
      9.1540000000000035E+000,
      9.1550000000000011E+000,
      9.1560000000000024E+000,
      9.1570000000000036E+000,
      9.1580000000000013E+000,
      9.1590000000000025E+000,
      9.1600000000000019E+000,
      9.1610000000000014E+000,
      9.1620000000000026E+000,
      9.1630000000000020E+000,
      9.1640000000000015E+000,
      9.1650000000000027E+000,
      9.1660000000000021E+000,
      9.1670000000000016E+000,
      9.1680000000000028E+000,
      9.1690000000000023E+000,
      9.1700000000000017E+000,
      9.1710000000000029E+000,
      9.1720000000000024E+000,
      9.1730000000000018E+000,
      9.1740000000000030E+000,
      9.1750000000000025E+000,
      9.1760000000000019E+000,
      9.1770000000000032E+000,
      9.1780000000000026E+000,
      9.1790000000000020E+000,
      9.1800000000000033E+000,
      9.1810000000000009E+000,
      9.1820000000000022E+000,
      9.1830000000000034E+000,
      9.1840000000000011E+000,
      9.1850000000000023E+000,
      9.1860000000000035E+000,
      9.1870000000000012E+000,
      9.1880000000000024E+000,
      9.1890000000000018E+000,
      9.1900000000000013E+000,
      9.1910000000000025E+000,
      9.1920000000000019E+000,
      9.1930000000000014E+000,
      9.1940000000000026E+000,
      9.1950000000000021E+000,
      9.1960000000000015E+000,
      9.1970000000000027E+000,
      9.1980000000000022E+000,
      9.1990000000000016E+000,
      9.2000000000000028E+000,
      9.2010000000000023E+000,
      9.2020000000000017E+000,
      9.2030000000000030E+000,
      9.2040000000000024E+000,
      9.2050000000000018E+000,
      9.2060000000000031E+000,
      9.2070000000000025E+000,
      9.2080000000000020E+000,
      9.2090000000000032E+000,
      9.2100000000000026E+000,
      9.2110000000000021E+000,
      9.2120000000000033E+000,
      9.2130000000000010E+000,
      9.2140000000000022E+000,
      9.2150000000000034E+000,
      9.2160000000000011E+000,
      9.2170000000000023E+000,
      9.2180000000000035E+000,
      9.2190000000000012E+000,
      9.2200000000000024E+000,
      9.2210000000000019E+000,
      9.2220000000000013E+000,
      9.2230000000000025E+000,
      9.2240000000000020E+000,
      9.2250000000000014E+000,
      9.2260000000000026E+000,
      9.2270000000000021E+000,
      9.2280000000000015E+000,
      9.2290000000000028E+000,
      9.2300000000000022E+000,
      9.2310000000000016E+000,
      9.2320000000000029E+000,
      9.2330000000000023E+000,
      9.2340000000000018E+000,
      9.2350000000000030E+000,
      9.2360000000000024E+000,
      9.2370000000000019E+000,
      9.2380000000000031E+000,
      9.2390000000000025E+000,
      9.2400000000000020E+000,
      9.2410000000000032E+000,
      9.2420000000000027E+000,
      9.2430000000000021E+000,
      9.2440000000000033E+000,
      9.2450000000000010E+000,
      9.2460000000000022E+000,
      9.2470000000000034E+000,
      9.2480000000000011E+000,
      9.2490000000000023E+000,
      9.2500000000000036E+000,
      9.2510000000000012E+000,
      9.2520000000000024E+000,
      9.2530000000000019E+000,
      9.2540000000000013E+000,
      9.2550000000000026E+000,
      9.2560000000000020E+000,
      9.2570000000000014E+000,
      9.2580000000000027E+000,
      9.2590000000000021E+000,
      9.2600000000000016E+000,
      9.2610000000000028E+000,
      9.2620000000000022E+000,
      9.2630000000000017E+000,
      9.2640000000000029E+000,
      9.2650000000000023E+000,
      9.2660000000000018E+000,
      9.2670000000000030E+000,
      9.2680000000000025E+000,
      9.2690000000000019E+000,
      9.2700000000000031E+000,
      9.2710000000000026E+000,
      9.2720000000000020E+000,
      9.2730000000000032E+000,
      9.2740000000000027E+000,
      9.2750000000000021E+000,
      9.2760000000000034E+000,
      9.2770000000000010E+000,
      9.2780000000000022E+000,
      9.2790000000000035E+000,
      9.2800000000000011E+000,
      9.2810000000000024E+000,
      9.2820000000000036E+000,
      9.2830000000000013E+000,
      9.2840000000000025E+000,
      9.2850000000000019E+000,
      9.2860000000000014E+000,
      9.2870000000000026E+000,
      9.2880000000000020E+000,
      9.2890000000000015E+000,
      9.2900000000000027E+000,
      9.2910000000000021E+000,
      9.2920000000000016E+000,
      9.2930000000000028E+000,
      9.2940000000000023E+000,
      9.2950000000000017E+000,
      9.2960000000000029E+000,
      9.2970000000000024E+000,
      9.2980000000000018E+000,
      9.2990000000000030E+000,
      9.3000000000000025E+000,
      9.3010000000000019E+000,
      9.3020000000000032E+000,
      9.3030000000000026E+000,
      9.3040000000000020E+000,
      9.3050000000000033E+000,
      9.3060000000000009E+000,
      9.3070000000000022E+000,
      9.3080000000000034E+000,
      9.3090000000000011E+000,
      9.3100000000000023E+000,
      9.3110000000000035E+000,
      9.3120000000000012E+000,
      9.3130000000000024E+000,
      9.3140000000000018E+000,
      9.3150000000000013E+000,
      9.3160000000000025E+000,
      9.3170000000000019E+000,
      9.3180000000000014E+000,
      9.3190000000000026E+000,
      9.3200000000000021E+000,
      9.3210000000000015E+000,
      9.3220000000000027E+000,
      9.3230000000000022E+000,
      9.3240000000000016E+000,
      9.3250000000000028E+000,
      9.3260000000000023E+000,
      9.3270000000000017E+000,
      9.3280000000000030E+000,
      9.3290000000000024E+000,
      9.3300000000000018E+000,
      9.3310000000000031E+000,
      9.3320000000000025E+000,
      9.3330000000000020E+000,
      9.3340000000000032E+000,
      9.3350000000000026E+000,
      9.3360000000000021E+000,
      9.3370000000000033E+000,
      9.3380000000000010E+000,
      9.3390000000000022E+000,
      9.3400000000000034E+000,
      9.3410000000000011E+000,
      9.3420000000000023E+000,
      9.3430000000000035E+000,
      9.3440000000000012E+000,
      9.3450000000000024E+000,
      9.3460000000000019E+000,
      9.3470000000000013E+000,
      9.3480000000000025E+000,
      9.3490000000000020E+000,
      9.3500000000000014E+000,
      9.3510000000000026E+000,
      9.3520000000000021E+000,
      9.3530000000000015E+000,
      9.3540000000000028E+000,
      9.3550000000000022E+000,
      9.3560000000000016E+000,
      9.3570000000000029E+000,
      9.3580000000000023E+000,
      9.3590000000000018E+000,
      9.3600000000000030E+000,
      9.3610000000000024E+000,
      9.3620000000000019E+000,
      9.3630000000000031E+000,
      9.3640000000000025E+000,
      9.3650000000000020E+000,
      9.3660000000000032E+000,
      9.3670000000000027E+000,
      9.3680000000000021E+000,
      9.3690000000000033E+000,
      9.3700000000000010E+000,
      9.3710000000000022E+000,
      9.3720000000000034E+000,
      9.3730000000000011E+000,
      9.3740000000000023E+000,
      9.3750000000000036E+000,
      9.3760000000000012E+000,
      9.3770000000000024E+000,
      9.3780000000000019E+000,
      9.3790000000000013E+000,
      9.3800000000000026E+000,
      9.3810000000000020E+000,
      9.3820000000000014E+000,
      9.3830000000000027E+000,
      9.3840000000000021E+000,
      9.3850000000000016E+000,
      9.3860000000000028E+000,
      9.3870000000000022E+000,
      9.3880000000000017E+000,
      9.3890000000000029E+000,
      9.3900000000000023E+000,
      9.3910000000000018E+000,
      9.3920000000000030E+000,
      9.3930000000000025E+000,
      9.3940000000000019E+000,
      9.3950000000000031E+000,
      9.3960000000000026E+000,
      9.3970000000000020E+000,
      9.3980000000000032E+000,
      9.3990000000000027E+000,
      9.4000000000000021E+000,
      9.4010000000000034E+000,
      9.4020000000000010E+000,
      9.4030000000000022E+000,
      9.4040000000000035E+000,
      9.4050000000000011E+000,
      9.4060000000000024E+000,
      9.4070000000000036E+000,
      9.4080000000000013E+000,
      9.4090000000000025E+000,
      9.4100000000000019E+000,
      9.4110000000000014E+000,
      9.4120000000000026E+000,
      9.4130000000000020E+000,
      9.4140000000000015E+000,
      9.4150000000000027E+000,
      9.4160000000000021E+000,
      9.4170000000000016E+000,
      9.4180000000000028E+000,
      9.4190000000000023E+000,
      9.4200000000000017E+000,
      9.4210000000000029E+000,
      9.4220000000000024E+000,
      9.4230000000000018E+000,
      9.4240000000000030E+000,
      9.4250000000000025E+000,
      9.4260000000000019E+000,
      9.4270000000000032E+000,
      9.4280000000000026E+000,
      9.4290000000000020E+000,
      9.4300000000000033E+000,
      9.4310000000000009E+000,
      9.4320000000000022E+000,
      9.4330000000000034E+000,
      9.4340000000000011E+000,
      9.4350000000000023E+000,
      9.4360000000000035E+000,
      9.4370000000000012E+000,
      9.4380000000000024E+000,
      9.4390000000000018E+000,
      9.4400000000000013E+000,
      9.4410000000000025E+000,
      9.4420000000000019E+000,
      9.4430000000000014E+000,
      9.4440000000000026E+000,
      9.4450000000000021E+000,
      9.4460000000000015E+000,
      9.4470000000000027E+000,
      9.4480000000000022E+000,
      9.4490000000000016E+000,
      9.4500000000000028E+000,
      9.4510000000000023E+000,
      9.4520000000000017E+000,
      9.4530000000000030E+000,
      9.4540000000000024E+000,
      9.4550000000000018E+000,
      9.4560000000000031E+000,
      9.4570000000000025E+000,
      9.4580000000000020E+000,
      9.4590000000000032E+000,
      9.4600000000000026E+000,
      9.4610000000000021E+000,
      9.4620000000000033E+000,
      9.4630000000000010E+000,
      9.4640000000000022E+000,
      9.4650000000000034E+000,
      9.4660000000000011E+000,
      9.4670000000000023E+000,
      9.4680000000000035E+000,
      9.4690000000000012E+000,
      9.4700000000000024E+000,
      9.4710000000000019E+000,
      9.4720000000000013E+000,
      9.4730000000000025E+000,
      9.4740000000000020E+000,
      9.4750000000000014E+000,
      9.4760000000000026E+000,
      9.4770000000000021E+000,
      9.4780000000000015E+000,
      9.4790000000000028E+000,
      9.4800000000000022E+000,
      9.4810000000000016E+000,
      9.4820000000000029E+000,
      9.4830000000000023E+000,
      9.4840000000000018E+000,
      9.4850000000000030E+000,
      9.4860000000000024E+000,
      9.4870000000000019E+000,
      9.4880000000000031E+000,
      9.4890000000000025E+000,
      9.4900000000000020E+000,
      9.4910000000000032E+000,
      9.4920000000000027E+000,
      9.4930000000000021E+000,
      9.4940000000000033E+000,
      9.4950000000000010E+000,
      9.4960000000000022E+000,
      9.4970000000000034E+000,
      9.4980000000000011E+000,
      9.4990000000000023E+000,
      9.5000000000000036E+000,
      9.5010000000000012E+000,
      9.5020000000000024E+000,
      9.5030000000000019E+000,
      9.5040000000000013E+000,
      9.5050000000000026E+000,
      9.5060000000000020E+000,
      9.5070000000000014E+000,
      9.5080000000000027E+000,
      9.5090000000000021E+000,
      9.5100000000000016E+000,
      9.5110000000000028E+000,
      9.5120000000000022E+000,
      9.5130000000000017E+000,
      9.5140000000000029E+000,
      9.5150000000000023E+000,
      9.5160000000000018E+000,
      9.5170000000000030E+000,
      9.5180000000000025E+000,
      9.5190000000000019E+000,
      9.5200000000000031E+000,
      9.5210000000000026E+000,
      9.5220000000000020E+000,
      9.5230000000000032E+000,
      9.5240000000000027E+000,
      9.5250000000000021E+000,
      9.5260000000000034E+000,
      9.5270000000000010E+000,
      9.5280000000000022E+000,
      9.5290000000000035E+000,
      9.5300000000000011E+000,
      9.5310000000000024E+000,
      9.5320000000000036E+000,
      9.5330000000000013E+000,
      9.5340000000000025E+000,
      9.5350000000000019E+000,
      9.5360000000000014E+000,
      9.5370000000000026E+000,
      9.5380000000000020E+000,
      9.5390000000000015E+000,
      9.5400000000000027E+000,
      9.5410000000000021E+000,
      9.5420000000000016E+000,
      9.5430000000000028E+000,
      9.5440000000000023E+000,
      9.5450000000000017E+000,
      9.5460000000000029E+000,
      9.5470000000000024E+000,
      9.5480000000000018E+000,
      9.5490000000000030E+000,
      9.5500000000000025E+000,
      9.5510000000000019E+000,
      9.5520000000000032E+000,
      9.5530000000000026E+000,
      9.5540000000000020E+000,
      9.5550000000000033E+000,
      9.5560000000000009E+000,
      9.5570000000000022E+000,
      9.5580000000000034E+000,
      9.5590000000000011E+000,
      9.5600000000000023E+000,
      9.5610000000000035E+000,
      9.5620000000000012E+000,
      9.5630000000000024E+000,
      9.5640000000000018E+000,
      9.5650000000000013E+000,
      9.5660000000000025E+000,
      9.5670000000000019E+000,
      9.5680000000000014E+000,
      9.5690000000000026E+000,
      9.5700000000000021E+000,
      9.5710000000000015E+000,
      9.5720000000000027E+000,
      9.5730000000000022E+000,
      9.5740000000000016E+000,
      9.5750000000000028E+000,
      9.5760000000000023E+000,
      9.5770000000000017E+000,
      9.5780000000000030E+000,
      9.5790000000000024E+000,
      9.5800000000000018E+000,
      9.5810000000000031E+000,
      9.5820000000000025E+000,
      9.5830000000000020E+000,
      9.5840000000000032E+000,
      9.5850000000000026E+000,
      9.5860000000000021E+000,
      9.5870000000000033E+000,
      9.5880000000000010E+000,
      9.5890000000000022E+000,
      9.5900000000000034E+000,
      9.5910000000000011E+000,
      9.5920000000000023E+000,
      9.5930000000000035E+000,
      9.5940000000000012E+000,
      9.5950000000000024E+000,
      9.5960000000000019E+000,
      9.5970000000000013E+000,
      9.5980000000000025E+000,
      9.5990000000000020E+000,
      9.6000000000000014E+000,
      9.6010000000000026E+000,
      9.6020000000000021E+000,
      9.6030000000000015E+000,
      9.6040000000000028E+000,
      9.6050000000000022E+000,
      9.6060000000000016E+000,
      9.6070000000000029E+000,
      9.6080000000000023E+000,
      9.6090000000000018E+000,
      9.6100000000000030E+000,
      9.6110000000000024E+000,
      9.6120000000000019E+000,
      9.6130000000000031E+000,
      9.6140000000000025E+000,
      9.6150000000000020E+000,
      9.6160000000000032E+000,
      9.6170000000000027E+000,
      9.6180000000000021E+000,
      9.6190000000000033E+000,
      9.6200000000000010E+000,
      9.6210000000000022E+000,
      9.6220000000000034E+000,
      9.6230000000000011E+000,
      9.6240000000000023E+000,
      9.6250000000000036E+000,
      9.6260000000000012E+000,
      9.6270000000000024E+000,
      9.6280000000000019E+000,
      9.6290000000000013E+000,
      9.6300000000000026E+000,
      9.6310000000000020E+000,
      9.6320000000000014E+000,
      9.6330000000000027E+000,
      9.6340000000000021E+000,
      9.6350000000000016E+000,
      9.6360000000000028E+000,
      9.6370000000000022E+000,
      9.6380000000000017E+000,
      9.6390000000000029E+000,
      9.6400000000000023E+000,
      9.6410000000000018E+000,
      9.6420000000000030E+000,
      9.6430000000000025E+000,
      9.6440000000000019E+000,
      9.6450000000000031E+000,
      9.6460000000000026E+000,
      9.6470000000000020E+000,
      9.6480000000000032E+000,
      9.6490000000000027E+000,
      9.6500000000000021E+000,
      9.6510000000000034E+000,
      9.6520000000000010E+000,
      9.6530000000000022E+000,
      9.6540000000000035E+000,
      9.6550000000000011E+000,
      9.6560000000000024E+000,
      9.6570000000000036E+000,
      9.6580000000000013E+000,
      9.6590000000000025E+000,
      9.6600000000000019E+000,
      9.6610000000000014E+000,
      9.6620000000000026E+000,
      9.6630000000000020E+000,
      9.6640000000000015E+000,
      9.6650000000000027E+000,
      9.6660000000000021E+000,
      9.6670000000000016E+000,
      9.6680000000000028E+000,
      9.6690000000000023E+000,
      9.6700000000000017E+000,
      9.6710000000000029E+000,
      9.6720000000000024E+000,
      9.6730000000000018E+000,
      9.6740000000000030E+000,
      9.6750000000000025E+000,
      9.6760000000000019E+000,
      9.6770000000000032E+000,
      9.6780000000000026E+000,
      9.6790000000000020E+000,
      9.6800000000000033E+000,
      9.6810000000000009E+000,
      9.6820000000000022E+000,
      9.6830000000000034E+000,
      9.6840000000000011E+000,
      9.6850000000000023E+000,
      9.6860000000000035E+000,
      9.6870000000000012E+000,
      9.6880000000000024E+000,
      9.6890000000000018E+000,
      9.6900000000000013E+000,
      9.6910000000000025E+000,
      9.6920000000000019E+000,
      9.6930000000000014E+000,
      9.6940000000000026E+000,
      9.6950000000000021E+000,
      9.6960000000000015E+000,
      9.6970000000000027E+000,
      9.6980000000000022E+000,
      9.6990000000000016E+000,
      9.7000000000000028E+000,
      9.7010000000000023E+000,
      9.7020000000000017E+000,
      9.7030000000000030E+000,
      9.7040000000000024E+000,
      9.7050000000000018E+000,
      9.7060000000000031E+000,
      9.7070000000000025E+000,
      9.7080000000000020E+000,
      9.7090000000000032E+000,
      9.7100000000000026E+000,
      9.7110000000000021E+000,
      9.7120000000000033E+000,
      9.7130000000000010E+000,
      9.7140000000000022E+000,
      9.7150000000000034E+000,
      9.7160000000000011E+000,
      9.7170000000000023E+000,
      9.7180000000000035E+000,
      9.7190000000000012E+000,
      9.7200000000000024E+000,
      9.7210000000000019E+000,
      9.7220000000000013E+000,
      9.7230000000000025E+000,
      9.7240000000000020E+000,
      9.7250000000000014E+000,
      9.7260000000000026E+000,
      9.7270000000000021E+000,
      9.7280000000000015E+000,
      9.7290000000000028E+000,
      9.7300000000000022E+000,
      9.7310000000000016E+000,
      9.7320000000000029E+000,
      9.7330000000000023E+000,
      9.7340000000000018E+000,
      9.7350000000000030E+000,
      9.7360000000000024E+000,
      9.7370000000000019E+000,
      9.7380000000000031E+000,
      9.7390000000000025E+000,
      9.7400000000000020E+000,
      9.7410000000000032E+000,
      9.7420000000000027E+000,
      9.7430000000000021E+000,
      9.7440000000000033E+000,
      9.7450000000000010E+000,
      9.7460000000000022E+000,
      9.7470000000000034E+000,
      9.7480000000000011E+000,
      9.7490000000000023E+000,
      9.7500000000000036E+000,
      9.7510000000000012E+000,
      9.7520000000000024E+000,
      9.7530000000000019E+000,
      9.7540000000000013E+000,
      9.7550000000000026E+000,
      9.7560000000000020E+000,
      9.7570000000000014E+000,
      9.7580000000000027E+000,
      9.7590000000000021E+000,
      9.7600000000000016E+000,
      9.7610000000000028E+000,
      9.7620000000000022E+000,
      9.7630000000000017E+000,
      9.7640000000000029E+000,
      9.7650000000000023E+000,
      9.7660000000000018E+000,
      9.7670000000000030E+000,
      9.7680000000000025E+000,
      9.7690000000000019E+000,
      9.7700000000000031E+000,
      9.7710000000000026E+000,
      9.7720000000000020E+000,
      9.7730000000000032E+000,
      9.7740000000000027E+000,
      9.7750000000000021E+000,
      9.7760000000000034E+000,
      9.7770000000000010E+000,
      9.7780000000000022E+000,
      9.7790000000000035E+000,
      9.7800000000000011E+000,
      9.7810000000000024E+000,
      9.7820000000000036E+000,
      9.7830000000000013E+000,
      9.7840000000000025E+000,
      9.7850000000000019E+000,
      9.7860000000000014E+000,
      9.7870000000000026E+000,
      9.7880000000000020E+000,
      9.7890000000000015E+000,
      9.7900000000000027E+000,
      9.7910000000000021E+000,
      9.7920000000000016E+000,
      9.7930000000000028E+000,
      9.7940000000000023E+000,
      9.7950000000000017E+000,
      9.7960000000000029E+000,
      9.7970000000000024E+000,
      9.7980000000000018E+000,
      9.7990000000000030E+000,
      9.8000000000000025E+000,
      9.8010000000000019E+000,
      9.8020000000000032E+000,
      9.8030000000000026E+000,
      9.8040000000000020E+000,
      9.8050000000000033E+000,
      9.8060000000000009E+000,
      9.8070000000000022E+000,
      9.8080000000000034E+000,
      9.8090000000000011E+000,
      9.8100000000000023E+000,
      9.8110000000000035E+000,
      9.8120000000000012E+000,
      9.8130000000000024E+000,
      9.8140000000000018E+000,
      9.8150000000000013E+000,
      9.8160000000000025E+000,
      9.8170000000000019E+000,
      9.8180000000000014E+000,
      9.8190000000000026E+000,
      9.8200000000000021E+000,
      9.8210000000000015E+000,
      9.8220000000000027E+000,
      9.8230000000000022E+000,
      9.8240000000000016E+000,
      9.8250000000000028E+000,
      9.8260000000000023E+000,
      9.8270000000000017E+000,
      9.8280000000000030E+000,
      9.8290000000000024E+000,
      9.8300000000000018E+000,
      9.8310000000000031E+000,
      9.8320000000000025E+000,
      9.8330000000000020E+000,
      9.8340000000000032E+000,
      9.8350000000000026E+000,
      9.8360000000000021E+000,
      9.8370000000000033E+000,
      9.8380000000000010E+000,
      9.8390000000000022E+000,
      9.8400000000000034E+000,
      9.8410000000000011E+000,
      9.8420000000000023E+000,
      9.8430000000000035E+000,
      9.8440000000000012E+000,
      9.8450000000000024E+000,
      9.8460000000000019E+000,
      9.8470000000000013E+000,
      9.8480000000000025E+000,
      9.8490000000000020E+000,
      9.8500000000000014E+000,
      9.8510000000000026E+000,
      9.8520000000000021E+000,
      9.8530000000000015E+000,
      9.8540000000000028E+000,
      9.8550000000000022E+000,
      9.8560000000000016E+000,
      9.8570000000000029E+000,
      9.8580000000000023E+000,
      9.8590000000000018E+000,
      9.8600000000000030E+000,
      9.8610000000000024E+000,
      9.8620000000000019E+000,
      9.8630000000000031E+000,
      9.8640000000000025E+000,
      9.8650000000000020E+000,
      9.8660000000000032E+000,
      9.8670000000000027E+000,
      9.8680000000000021E+000,
      9.8690000000000033E+000,
      9.8700000000000010E+000,
      9.8710000000000022E+000,
      9.8720000000000034E+000,
      9.8730000000000011E+000,
      9.8740000000000023E+000,
      9.8750000000000036E+000,
      9.8760000000000012E+000,
      9.8770000000000024E+000,
      9.8780000000000019E+000,
      9.8790000000000013E+000,
      9.8800000000000026E+000,
      9.8810000000000020E+000,
      9.8820000000000014E+000,
      9.8830000000000027E+000,
      9.8840000000000021E+000,
      9.8850000000000016E+000,
      9.8860000000000028E+000,
      9.8870000000000022E+000,
      9.8880000000000017E+000,
      9.8890000000000029E+000,
      9.8900000000000023E+000,
      9.8910000000000018E+000,
      9.8920000000000030E+000,
      9.8930000000000025E+000,
      9.8940000000000019E+000,
      9.8950000000000031E+000,
      9.8960000000000026E+000,
      9.8970000000000020E+000,
      9.8980000000000032E+000,
      9.8990000000000027E+000,
      9.9000000000000021E+000,
      9.9010000000000034E+000,
      9.9020000000000010E+000,
      9.9030000000000022E+000,
      9.9040000000000035E+000,
      9.9050000000000011E+000,
      9.9060000000000024E+000,
      9.9070000000000036E+000,
      9.9080000000000013E+000,
      9.9090000000000025E+000,
      9.9100000000000019E+000,
      9.9110000000000014E+000,
      9.9120000000000026E+000,
      9.9130000000000020E+000,
      9.9140000000000015E+000,
      9.9150000000000027E+000,
      9.9160000000000021E+000,
      9.9170000000000016E+000,
      9.9180000000000028E+000,
      9.9190000000000023E+000,
      9.9200000000000017E+000,
      9.9210000000000029E+000,
      9.9220000000000024E+000,
      9.9230000000000018E+000,
      9.9240000000000030E+000,
      9.9250000000000025E+000,
      9.9260000000000019E+000,
      9.9270000000000032E+000,
      9.9280000000000026E+000,
      9.9290000000000020E+000,
      9.9300000000000033E+000,
      9.9310000000000027E+000,
      9.9320000000000022E+000,
      9.9330000000000034E+000,
      9.9340000000000011E+000,
      9.9350000000000023E+000,
      9.9360000000000035E+000,
      9.9370000000000012E+000,
      9.9380000000000024E+000,
      9.9390000000000018E+000,
      9.9400000000000013E+000,
      9.9410000000000025E+000,
      9.9420000000000019E+000,
      9.9430000000000014E+000,
      9.9440000000000026E+000,
      9.9450000000000021E+000,
      9.9460000000000015E+000,
      9.9470000000000027E+000,
      9.9480000000000022E+000,
      9.9490000000000016E+000,
      9.9500000000000028E+000,
      9.9510000000000023E+000,
      9.9520000000000017E+000,
      9.9530000000000030E+000,
      9.9540000000000024E+000,
      9.9550000000000018E+000,
      9.9560000000000031E+000,
      9.9570000000000025E+000,
      9.9580000000000020E+000,
      9.9590000000000032E+000,
      9.9600000000000026E+000,
      9.9610000000000021E+000,
      9.9620000000000033E+000,
      9.9630000000000010E+000,
      9.9640000000000022E+000,
      9.9650000000000034E+000,
      9.9660000000000011E+000,
      9.9670000000000023E+000,
      9.9680000000000035E+000,
      9.9690000000000012E+000,
      9.9700000000000024E+000,
      9.9710000000000019E+000,
      9.9720000000000013E+000,
      9.9730000000000025E+000,
      9.9740000000000020E+000,
      9.9750000000000014E+000,
      9.9760000000000026E+000,
      9.9770000000000021E+000,
      9.9780000000000015E+000,
      9.9790000000000028E+000,
      9.9800000000000022E+000,
      9.9810000000000016E+000,
      9.9820000000000029E+000,
      9.9830000000000023E+000,
      9.9840000000000018E+000,
      9.9850000000000030E+000,
      9.9860000000000024E+000,
      9.9870000000000019E+000,
      9.9880000000000031E+000,
      9.9890000000000025E+000,
      9.9900000000000020E+000,
      9.9910000000000032E+000,
      9.9920000000000027E+000,
      9.9930000000000021E+000,
      9.9940000000000033E+000,
      9.9950000000000010E+000,
      9.9960000000000022E+000,
      9.9970000000000034E+000,
      9.9980000000000011E+000,
      9.9990000000000023E+000,
      1.0000000000000004E+001,
      1.0001000000000001E+001,
      1.0002000000000002E+001,
      1.0003000000000002E+001,
      1.0004000000000001E+001,
      1.0005000000000003E+001,
      1.0006000000000002E+001,
      1.0007000000000001E+001,
      1.0008000000000003E+001,
      1.0009000000000002E+001,
      1.0010000000000002E+001,
      1.0011000000000003E+001,
      1.0012000000000002E+001,
      1.0013000000000002E+001,
      1.0014000000000003E+001,
      1.0015000000000002E+001,
      1.0016000000000002E+001,
      1.0017000000000003E+001,
      1.0018000000000002E+001,
      1.0019000000000002E+001,
      1.0020000000000003E+001,
      1.0021000000000003E+001,
      1.0022000000000002E+001,
      1.0023000000000003E+001,
      1.0024000000000003E+001,
      1.0025000000000002E+001,
      1.0026000000000003E+001,
      1.0027000000000001E+001,
      1.0028000000000002E+001,
      1.0029000000000003E+001,
      1.0030000000000001E+001,
      1.0031000000000002E+001,
      1.0032000000000004E+001,
      1.0033000000000001E+001,
      1.0034000000000002E+001,
      1.0035000000000002E+001,
      1.0036000000000001E+001,
      1.0037000000000003E+001,
      1.0038000000000002E+001,
      1.0039000000000001E+001,
      1.0040000000000003E+001,
      1.0041000000000002E+001,
      1.0042000000000002E+001,
      1.0043000000000003E+001,
      1.0044000000000002E+001,
      1.0045000000000002E+001,
      1.0046000000000003E+001,
      1.0047000000000002E+001,
      1.0048000000000002E+001,
      1.0049000000000003E+001,
      1.0050000000000002E+001,
      1.0051000000000002E+001,
      1.0052000000000003E+001,
      1.0053000000000003E+001,
      1.0054000000000002E+001,
      1.0055000000000003E+001,
      1.0056000000000003E+001,
      1.0057000000000002E+001,
      1.0058000000000003E+001,
      1.0059000000000001E+001,
      1.0060000000000002E+001,
      1.0061000000000003E+001,
      1.0062000000000001E+001,
      1.0063000000000002E+001,
      1.0064000000000002E+001,
      1.0065000000000001E+001,
      1.0066000000000003E+001,
      1.0067000000000002E+001,
      1.0068000000000001E+001,
      1.0069000000000003E+001,
      1.0070000000000002E+001,
      1.0071000000000002E+001,
      1.0072000000000003E+001,
      1.0073000000000002E+001,
      1.0074000000000002E+001,
      1.0075000000000003E+001,
      1.0076000000000002E+001,
      1.0077000000000002E+001,
      1.0078000000000003E+001,
      1.0079000000000002E+001,
      1.0080000000000002E+001,
      1.0081000000000003E+001,
      1.0082000000000003E+001,
      1.0083000000000002E+001,
      1.0084000000000003E+001,
      1.0085000000000003E+001,
      1.0086000000000002E+001,
      1.0087000000000003E+001,
      1.0088000000000001E+001,
      1.0089000000000002E+001,
      1.0090000000000003E+001,
      1.0091000000000001E+001,
      1.0092000000000002E+001,
      1.0093000000000004E+001,
      1.0094000000000001E+001,
      1.0095000000000002E+001,
      1.0096000000000002E+001,
      1.0097000000000001E+001,
      1.0098000000000003E+001,
      1.0099000000000002E+001,
      1.0100000000000001E+001,
      1.0101000000000003E+001,
      1.0102000000000002E+001,
      1.0103000000000002E+001,
      1.0104000000000003E+001,
      1.0105000000000002E+001,
      1.0106000000000002E+001,
      1.0107000000000003E+001,
      1.0108000000000002E+001,
      1.0109000000000002E+001,
      1.0110000000000003E+001,
      1.0111000000000002E+001,
      1.0112000000000002E+001,
      1.0113000000000003E+001,
      1.0114000000000003E+001,
      1.0115000000000002E+001,
      1.0116000000000003E+001,
      1.0117000000000003E+001,
      1.0118000000000002E+001,
      1.0119000000000003E+001,
      1.0120000000000001E+001,
      1.0121000000000002E+001,
      1.0122000000000003E+001,
      1.0123000000000001E+001,
      1.0124000000000002E+001,
      1.0125000000000004E+001,
      1.0126000000000001E+001,
      1.0127000000000002E+001,
      1.0128000000000002E+001,
      1.0129000000000001E+001,
      1.0130000000000003E+001,
      1.0131000000000002E+001,
      1.0132000000000001E+001,
      1.0133000000000003E+001,
      1.0134000000000002E+001,
      1.0135000000000002E+001,
      1.0136000000000003E+001,
      1.0137000000000002E+001,
      1.0138000000000002E+001,
      1.0139000000000003E+001,
      1.0140000000000002E+001,
      1.0141000000000002E+001,
      1.0142000000000003E+001,
      1.0143000000000002E+001,
      1.0144000000000002E+001,
      1.0145000000000003E+001,
      1.0146000000000003E+001,
      1.0147000000000002E+001,
      1.0148000000000003E+001,
      1.0149000000000003E+001,
      1.0150000000000002E+001,
      1.0151000000000003E+001,
      1.0152000000000001E+001,
      1.0153000000000002E+001,
      1.0154000000000003E+001,
      1.0155000000000001E+001,
      1.0156000000000002E+001,
      1.0157000000000004E+001,
      1.0158000000000001E+001,
      1.0159000000000002E+001,
      1.0160000000000002E+001,
      1.0161000000000001E+001,
      1.0162000000000003E+001,
      1.0163000000000002E+001,
      1.0164000000000001E+001,
      1.0165000000000003E+001,
      1.0166000000000002E+001,
      1.0167000000000002E+001,
      1.0168000000000003E+001,
      1.0169000000000002E+001,
      1.0170000000000002E+001,
      1.0171000000000003E+001,
      1.0172000000000002E+001,
      1.0173000000000002E+001,
      1.0174000000000003E+001,
      1.0175000000000002E+001,
      1.0176000000000002E+001,
      1.0177000000000003E+001,
      1.0178000000000003E+001,
      1.0179000000000002E+001,
      1.0180000000000003E+001,
      1.0181000000000003E+001,
      1.0182000000000002E+001,
      1.0183000000000003E+001,
      1.0184000000000001E+001,
      1.0185000000000002E+001,
      1.0186000000000003E+001,
      1.0187000000000001E+001,
      1.0188000000000002E+001,
      1.0189000000000002E+001,
      1.0190000000000001E+001,
      1.0191000000000003E+001,
      1.0192000000000002E+001,
      1.0193000000000001E+001,
      1.0194000000000003E+001,
      1.0195000000000002E+001,
      1.0196000000000002E+001,
      1.0197000000000003E+001,
      1.0198000000000002E+001,
      1.0199000000000002E+001,
      1.0200000000000003E+001,
      1.0201000000000002E+001,
      1.0202000000000002E+001,
      1.0203000000000003E+001,
      1.0204000000000002E+001,
      1.0205000000000002E+001,
      1.0206000000000003E+001,
      1.0207000000000003E+001,
      1.0208000000000002E+001,
      1.0209000000000003E+001,
      1.0210000000000003E+001,
      1.0211000000000002E+001,
      1.0212000000000003E+001,
      1.0213000000000001E+001,
      1.0214000000000002E+001,
      1.0215000000000003E+001,
      1.0216000000000001E+001,
      1.0217000000000002E+001,
      1.0218000000000004E+001,
      1.0219000000000001E+001,
      1.0220000000000002E+001,
      1.0221000000000002E+001,
      1.0222000000000001E+001,
      1.0223000000000003E+001,
      1.0224000000000002E+001,
      1.0225000000000001E+001,
      1.0226000000000003E+001,
      1.0227000000000002E+001,
      1.0228000000000002E+001,
      1.0229000000000003E+001,
      1.0230000000000002E+001,
      1.0231000000000002E+001,
      1.0232000000000003E+001,
      1.0233000000000002E+001,
      1.0234000000000002E+001,
      1.0235000000000003E+001,
      1.0236000000000002E+001,
      1.0237000000000002E+001,
      1.0238000000000003E+001,
      1.0239000000000003E+001,
      1.0240000000000002E+001,
      1.0241000000000003E+001,
      1.0242000000000003E+001,
      1.0243000000000002E+001,
      1.0244000000000003E+001,
      1.0245000000000001E+001,
      1.0246000000000002E+001,
      1.0247000000000003E+001,
      1.0248000000000001E+001,
      1.0249000000000002E+001,
      1.0250000000000004E+001,
      1.0251000000000001E+001,
      1.0252000000000002E+001,
      1.0253000000000002E+001,
      1.0254000000000001E+001,
      1.0255000000000003E+001,
      1.0256000000000002E+001,
      1.0257000000000001E+001,
      1.0258000000000003E+001,
      1.0259000000000002E+001,
      1.0260000000000002E+001,
      1.0261000000000003E+001,
      1.0262000000000002E+001,
      1.0263000000000002E+001,
      1.0264000000000003E+001,
      1.0265000000000002E+001,
      1.0266000000000002E+001,
      1.0267000000000003E+001,
      1.0268000000000002E+001,
      1.0269000000000002E+001,
      1.0270000000000003E+001,
      1.0271000000000003E+001,
      1.0272000000000002E+001,
      1.0273000000000003E+001,
      1.0274000000000003E+001,
      1.0275000000000002E+001,
      1.0276000000000003E+001,
      1.0277000000000001E+001,
      1.0278000000000002E+001,
      1.0279000000000003E+001,
      1.0280000000000001E+001,
      1.0281000000000002E+001,
      1.0282000000000004E+001,
      1.0283000000000001E+001,
      1.0284000000000002E+001,
      1.0285000000000002E+001,
      1.0286000000000001E+001,
      1.0287000000000003E+001,
      1.0288000000000002E+001,
      1.0289000000000001E+001,
      1.0290000000000003E+001,
      1.0291000000000002E+001,
      1.0292000000000002E+001,
      1.0293000000000003E+001,
      1.0294000000000002E+001,
      1.0295000000000002E+001,
      1.0296000000000003E+001,
      1.0297000000000002E+001,
      1.0298000000000002E+001,
      1.0299000000000003E+001,
      1.0300000000000002E+001,
      1.0301000000000002E+001,
      1.0302000000000003E+001,
      1.0303000000000003E+001,
      1.0304000000000002E+001,
      1.0305000000000003E+001,
      1.0306000000000003E+001,
      1.0307000000000002E+001,
      1.0308000000000003E+001,
      1.0309000000000001E+001,
      1.0310000000000002E+001,
      1.0311000000000003E+001,
      1.0312000000000001E+001,
      1.0313000000000002E+001,
      1.0314000000000004E+001,
      1.0315000000000001E+001,
      1.0316000000000003E+001,
      1.0317000000000002E+001,
      1.0318000000000001E+001,
      1.0319000000000003E+001,
      1.0320000000000002E+001,
      1.0321000000000002E+001,
      1.0322000000000003E+001,
      1.0323000000000002E+001,
      1.0324000000000002E+001,
      1.0325000000000003E+001,
      1.0326000000000002E+001,
      1.0327000000000002E+001,
      1.0328000000000003E+001,
      1.0329000000000002E+001,
      1.0330000000000002E+001,
      1.0331000000000003E+001,
      1.0332000000000003E+001,
      1.0333000000000002E+001,
      1.0334000000000003E+001,
      1.0335000000000003E+001,
      1.0336000000000002E+001,
      1.0337000000000003E+001,
      1.0338000000000001E+001,
      1.0339000000000002E+001,
      1.0340000000000003E+001,
      1.0341000000000001E+001,
      1.0342000000000002E+001,
      1.0343000000000004E+001,
      1.0344000000000001E+001,
      1.0345000000000002E+001,
      1.0346000000000002E+001,
      1.0347000000000001E+001,
      1.0348000000000003E+001,
      1.0349000000000002E+001,
      1.0350000000000001E+001,
      1.0351000000000003E+001,
      1.0352000000000002E+001,
      1.0353000000000002E+001,
      1.0354000000000003E+001,
      1.0355000000000002E+001,
      1.0356000000000002E+001,
      1.0357000000000003E+001,
      1.0358000000000002E+001,
      1.0359000000000002E+001,
      1.0360000000000003E+001,
      1.0361000000000002E+001,
      1.0362000000000002E+001,
      1.0363000000000003E+001,
      1.0364000000000003E+001,
      1.0365000000000002E+001,
      1.0366000000000003E+001,
      1.0367000000000003E+001,
      1.0368000000000002E+001,
      1.0369000000000003E+001,
      1.0370000000000001E+001,
      1.0371000000000002E+001,
      1.0372000000000003E+001,
      1.0373000000000001E+001,
      1.0374000000000002E+001,
      1.0375000000000004E+001,
      1.0376000000000001E+001,
      1.0377000000000002E+001,
      1.0378000000000002E+001,
      1.0379000000000001E+001,
      1.0380000000000003E+001,
      1.0381000000000002E+001,
      1.0382000000000001E+001,
      1.0383000000000003E+001,
      1.0384000000000002E+001,
      1.0385000000000002E+001,
      1.0386000000000003E+001,
      1.0387000000000002E+001,
      1.0388000000000002E+001,
      1.0389000000000003E+001,
      1.0390000000000002E+001,
      1.0391000000000002E+001,
      1.0392000000000003E+001,
      1.0393000000000002E+001,
      1.0394000000000002E+001,
      1.0395000000000003E+001,
      1.0396000000000003E+001,
      1.0397000000000002E+001,
      1.0398000000000003E+001,
      1.0399000000000003E+001,
      1.0400000000000002E+001,
      1.0401000000000003E+001,
      1.0402000000000001E+001,
      1.0403000000000002E+001,
      1.0404000000000003E+001,
      1.0405000000000001E+001,
      1.0406000000000002E+001,
      1.0407000000000004E+001,
      1.0408000000000001E+001,
      1.0409000000000002E+001,
      1.0410000000000002E+001,
      1.0411000000000001E+001,
      1.0412000000000003E+001,
      1.0413000000000002E+001,
      1.0414000000000001E+001,
      1.0415000000000003E+001,
      1.0416000000000002E+001,
      1.0417000000000002E+001,
      1.0418000000000003E+001,
      1.0419000000000002E+001,
      1.0420000000000002E+001,
      1.0421000000000003E+001,
      1.0422000000000002E+001,
      1.0423000000000002E+001,
      1.0424000000000003E+001,
      1.0425000000000002E+001,
      1.0426000000000002E+001,
      1.0427000000000003E+001,
      1.0428000000000003E+001,
      1.0429000000000002E+001,
      1.0430000000000003E+001,
      1.0431000000000003E+001,
      1.0432000000000002E+001,
      1.0433000000000003E+001,
      1.0434000000000001E+001,
      1.0435000000000002E+001,
      1.0436000000000003E+001,
      1.0437000000000001E+001,
      1.0438000000000002E+001,
      1.0439000000000004E+001,
      1.0440000000000001E+001,
      1.0441000000000003E+001,
      1.0442000000000002E+001,
      1.0443000000000001E+001,
      1.0444000000000003E+001,
      1.0445000000000002E+001,
      1.0446000000000002E+001,
      1.0447000000000003E+001,
      1.0448000000000002E+001,
      1.0449000000000002E+001,
      1.0450000000000003E+001,
      1.0451000000000002E+001,
      1.0452000000000002E+001,
      1.0453000000000003E+001,
      1.0454000000000002E+001,
      1.0455000000000002E+001,
      1.0456000000000003E+001,
      1.0457000000000003E+001,
      1.0458000000000002E+001,
      1.0459000000000003E+001,
      1.0460000000000003E+001,
      1.0461000000000002E+001,
      1.0462000000000003E+001,
      1.0463000000000001E+001,
      1.0464000000000002E+001,
      1.0465000000000003E+001,
      1.0466000000000001E+001,
      1.0467000000000002E+001,
      1.0468000000000004E+001,
      1.0469000000000001E+001,
      1.0470000000000002E+001,
      1.0471000000000002E+001,
      1.0472000000000001E+001,
      1.0473000000000003E+001,
      1.0474000000000002E+001,
      1.0475000000000001E+001,
      1.0476000000000003E+001,
      1.0477000000000002E+001,
      1.0478000000000002E+001,
      1.0479000000000003E+001,
      1.0480000000000002E+001,
      1.0481000000000002E+001,
      1.0482000000000003E+001,
      1.0483000000000002E+001,
      1.0484000000000002E+001,
      1.0485000000000003E+001,
      1.0486000000000002E+001,
      1.0487000000000002E+001,
      1.0488000000000003E+001,
      1.0489000000000003E+001,
      1.0490000000000002E+001,
      1.0491000000000003E+001,
      1.0492000000000003E+001,
      1.0493000000000002E+001,
      1.0494000000000003E+001,
      1.0495000000000001E+001,
      1.0496000000000002E+001,
      1.0497000000000003E+001,
      1.0498000000000001E+001,
      1.0499000000000002E+001,
      1.0500000000000004E+001,
      1.0501000000000001E+001,
      1.0502000000000002E+001,
      1.0503000000000002E+001,
      1.0504000000000001E+001,
      1.0505000000000003E+001,
      1.0506000000000002E+001,
      1.0507000000000001E+001,
      1.0508000000000003E+001,
      1.0509000000000002E+001,
      1.0510000000000002E+001,
      1.0511000000000003E+001,
      1.0512000000000002E+001,
      1.0513000000000002E+001,
      1.0514000000000003E+001,
      1.0515000000000002E+001,
      1.0516000000000002E+001,
      1.0517000000000003E+001,
      1.0518000000000002E+001,
      1.0519000000000002E+001,
      1.0520000000000003E+001,
      1.0521000000000003E+001,
      1.0522000000000002E+001,
      1.0523000000000003E+001,
      1.0524000000000003E+001,
      1.0525000000000002E+001,
      1.0526000000000003E+001,
      1.0527000000000001E+001,
      1.0528000000000002E+001,
      1.0529000000000003E+001,
      1.0530000000000001E+001,
      1.0531000000000002E+001,
      1.0532000000000004E+001,
      1.0533000000000001E+001,
      1.0534000000000002E+001,
      1.0535000000000002E+001,
      1.0536000000000001E+001,
      1.0537000000000003E+001,
      1.0538000000000002E+001,
      1.0539000000000001E+001,
      1.0540000000000003E+001,
      1.0541000000000002E+001,
      1.0542000000000002E+001,
      1.0543000000000003E+001,
      1.0544000000000002E+001,
      1.0545000000000002E+001,
      1.0546000000000003E+001,
      1.0547000000000002E+001,
      1.0548000000000002E+001,
      1.0549000000000003E+001,
      1.0550000000000002E+001,
      1.0551000000000002E+001,
      1.0552000000000003E+001,
      1.0553000000000003E+001,
      1.0554000000000002E+001,
      1.0555000000000003E+001,
      1.0556000000000003E+001,
      1.0557000000000002E+001,
      1.0558000000000003E+001,
      1.0559000000000001E+001,
      1.0560000000000002E+001,
      1.0561000000000003E+001,
      1.0562000000000001E+001,
      1.0563000000000002E+001,
      1.0564000000000004E+001,
      1.0565000000000001E+001,
      1.0566000000000003E+001,
      1.0567000000000002E+001,
      1.0568000000000001E+001,
      1.0569000000000003E+001,
      1.0570000000000002E+001,
      1.0571000000000002E+001,
      1.0572000000000003E+001,
      1.0573000000000002E+001,
      1.0574000000000002E+001,
      1.0575000000000003E+001,
      1.0576000000000002E+001,
      1.0577000000000002E+001,
      1.0578000000000003E+001,
      1.0579000000000002E+001,
      1.0580000000000002E+001,
      1.0581000000000003E+001,
      1.0582000000000003E+001,
      1.0583000000000002E+001,
      1.0584000000000003E+001,
      1.0585000000000003E+001,
      1.0586000000000002E+001,
      1.0587000000000003E+001,
      1.0588000000000001E+001,
      1.0589000000000002E+001,
      1.0590000000000003E+001,
      1.0591000000000001E+001,
      1.0592000000000002E+001,
      1.0593000000000004E+001,
      1.0594000000000001E+001,
      1.0595000000000002E+001,
      1.0596000000000002E+001,
      1.0597000000000001E+001,
      1.0598000000000003E+001,
      1.0599000000000002E+001,
      1.0600000000000001E+001,
      1.0601000000000003E+001,
      1.0602000000000002E+001,
      1.0603000000000002E+001,
      1.0604000000000003E+001,
      1.0605000000000002E+001,
      1.0606000000000002E+001,
      1.0607000000000003E+001,
      1.0608000000000002E+001,
      1.0609000000000002E+001,
      1.0610000000000003E+001,
      1.0611000000000002E+001,
      1.0612000000000002E+001,
      1.0613000000000003E+001,
      1.0614000000000003E+001,
      1.0615000000000002E+001,
      1.0616000000000003E+001,
      1.0617000000000003E+001,
      1.0618000000000002E+001,
      1.0619000000000003E+001,
      1.0620000000000001E+001,
      1.0621000000000002E+001,
      1.0622000000000003E+001,
      1.0623000000000001E+001,
      1.0624000000000002E+001,
      1.0625000000000004E+001,
      1.0626000000000001E+001,
      1.0627000000000002E+001,
      1.0628000000000002E+001,
      1.0629000000000001E+001,
      1.0630000000000003E+001,
      1.0631000000000002E+001,
      1.0632000000000001E+001,
      1.0633000000000003E+001,
      1.0634000000000002E+001,
      1.0635000000000002E+001,
      1.0636000000000003E+001,
      1.0637000000000002E+001,
      1.0638000000000002E+001,
      1.0639000000000003E+001,
      1.0640000000000002E+001,
      1.0641000000000002E+001,
      1.0642000000000003E+001,
      1.0643000000000002E+001,
      1.0644000000000002E+001,
      1.0645000000000003E+001,
      1.0646000000000003E+001,
      1.0647000000000002E+001,
      1.0648000000000003E+001,
      1.0649000000000003E+001,
      1.0650000000000002E+001,
      1.0651000000000003E+001,
      1.0652000000000001E+001,
      1.0653000000000002E+001,
      1.0654000000000003E+001,
      1.0655000000000001E+001,
      1.0656000000000002E+001,
      1.0657000000000004E+001,
      1.0658000000000001E+001,
      1.0659000000000002E+001,
      1.0660000000000002E+001,
      1.0661000000000001E+001,
      1.0662000000000003E+001,
      1.0663000000000002E+001,
      1.0664000000000001E+001,
      1.0665000000000003E+001,
      1.0666000000000002E+001,
      1.0667000000000002E+001,
      1.0668000000000003E+001,
      1.0669000000000002E+001,
      1.0670000000000002E+001,
      1.0671000000000003E+001,
      1.0672000000000002E+001,
      1.0673000000000002E+001,
      1.0674000000000003E+001,
      1.0675000000000002E+001,
      1.0676000000000002E+001,
      1.0677000000000003E+001,
      1.0678000000000003E+001,
      1.0679000000000002E+001,
      1.0680000000000003E+001,
      1.0681000000000003E+001,
      1.0682000000000002E+001,
      1.0683000000000003E+001,
      1.0684000000000001E+001,
      1.0685000000000002E+001,
      1.0686000000000003E+001,
      1.0687000000000001E+001,
      1.0688000000000002E+001,
      1.0689000000000004E+001,
      1.0690000000000001E+001,
      1.0691000000000003E+001,
      1.0692000000000002E+001,
      1.0693000000000001E+001,
      1.0694000000000003E+001,
      1.0695000000000002E+001,
      1.0696000000000002E+001,
      1.0697000000000003E+001,
      1.0698000000000002E+001,
      1.0699000000000002E+001,
      1.0700000000000003E+001,
      1.0701000000000002E+001,
      1.0702000000000002E+001,
      1.0703000000000003E+001,
      1.0704000000000002E+001,
      1.0705000000000002E+001,
      1.0706000000000003E+001,
      1.0707000000000003E+001,
      1.0708000000000002E+001,
      1.0709000000000003E+001,
      1.0710000000000003E+001,
      1.0711000000000002E+001,
      1.0712000000000003E+001,
      1.0713000000000001E+001,
      1.0714000000000002E+001,
      1.0715000000000003E+001,
      1.0716000000000001E+001,
      1.0717000000000002E+001,
      1.0718000000000004E+001,
      1.0719000000000001E+001,
      1.0720000000000002E+001,
      1.0721000000000002E+001,
      1.0722000000000001E+001,
      1.0723000000000003E+001,
      1.0724000000000002E+001,
      1.0725000000000001E+001,
      1.0726000000000003E+001,
      1.0727000000000002E+001,
      1.0728000000000002E+001,
      1.0729000000000003E+001,
      1.0730000000000002E+001,
      1.0731000000000002E+001,
      1.0732000000000003E+001,
      1.0733000000000002E+001,
      1.0734000000000002E+001,
      1.0735000000000003E+001,
      1.0736000000000002E+001,
      1.0737000000000002E+001,
      1.0738000000000003E+001,
      1.0739000000000003E+001,
      1.0740000000000002E+001,
      1.0741000000000003E+001,
      1.0742000000000003E+001,
      1.0743000000000002E+001,
      1.0744000000000003E+001,
      1.0745000000000001E+001,
      1.0746000000000002E+001,
      1.0747000000000003E+001,
      1.0748000000000001E+001,
      1.0749000000000002E+001,
      1.0750000000000004E+001,
      1.0751000000000001E+001,
      1.0752000000000002E+001,
      1.0753000000000002E+001,
      1.0754000000000001E+001,
      1.0755000000000003E+001,
      1.0756000000000002E+001,
      1.0757000000000001E+001,
      1.0758000000000003E+001,
      1.0759000000000002E+001,
      1.0760000000000002E+001,
      1.0761000000000003E+001,
      1.0762000000000002E+001,
      1.0763000000000002E+001,
      1.0764000000000003E+001,
      1.0765000000000002E+001,
      1.0766000000000002E+001,
      1.0767000000000003E+001,
      1.0768000000000002E+001,
      1.0769000000000002E+001,
      1.0770000000000003E+001,
      1.0771000000000003E+001,
      1.0772000000000002E+001,
      1.0773000000000003E+001,
      1.0774000000000003E+001,
      1.0775000000000002E+001,
      1.0776000000000003E+001,
      1.0777000000000001E+001,
      1.0778000000000002E+001,
      1.0779000000000003E+001,
      1.0780000000000001E+001,
      1.0781000000000002E+001,
      1.0782000000000004E+001,
      1.0783000000000001E+001,
      1.0784000000000002E+001,
      1.0785000000000002E+001,
      1.0786000000000001E+001,
      1.0787000000000003E+001,
      1.0788000000000002E+001,
      1.0789000000000001E+001,
      1.0790000000000003E+001,
      1.0791000000000002E+001,
      1.0792000000000002E+001,
      1.0793000000000003E+001,
      1.0794000000000002E+001,
      1.0795000000000002E+001,
      1.0796000000000003E+001,
      1.0797000000000002E+001,
      1.0798000000000002E+001,
      1.0799000000000003E+001,
      1.0800000000000002E+001,
      1.0801000000000002E+001,
      1.0802000000000003E+001,
      1.0803000000000003E+001,
      1.0804000000000002E+001,
      1.0805000000000003E+001,
      1.0806000000000003E+001,
      1.0807000000000002E+001,
      1.0808000000000003E+001,
      1.0809000000000001E+001,
      1.0810000000000002E+001,
      1.0811000000000003E+001,
      1.0812000000000001E+001,
      1.0813000000000002E+001,
      1.0814000000000004E+001,
      1.0815000000000001E+001,
      1.0816000000000003E+001,
      1.0817000000000002E+001,
      1.0818000000000001E+001,
      1.0819000000000003E+001,
      1.0820000000000002E+001,
      1.0821000000000002E+001,
      1.0822000000000003E+001,
      1.0823000000000002E+001,
      1.0824000000000002E+001,
      1.0825000000000003E+001,
      1.0826000000000002E+001,
      1.0827000000000002E+001,
      1.0828000000000003E+001,
      1.0829000000000002E+001,
      1.0830000000000002E+001,
      1.0831000000000003E+001,
      1.0832000000000003E+001,
      1.0833000000000002E+001,
      1.0834000000000003E+001,
      1.0835000000000003E+001,
      1.0836000000000002E+001,
      1.0837000000000003E+001,
      1.0838000000000001E+001,
      1.0839000000000002E+001,
      1.0840000000000003E+001,
      1.0841000000000001E+001,
      1.0842000000000002E+001,
      1.0843000000000004E+001,
      1.0844000000000001E+001,
      1.0845000000000002E+001,
      1.0846000000000002E+001,
      1.0847000000000001E+001,
      1.0848000000000003E+001,
      1.0849000000000002E+001,
      1.0850000000000001E+001,
      1.0851000000000003E+001,
      1.0852000000000002E+001,
      1.0853000000000002E+001,
      1.0854000000000003E+001,
      1.0855000000000002E+001,
      1.0856000000000002E+001,
      1.0857000000000003E+001,
      1.0858000000000002E+001,
      1.0859000000000002E+001,
      1.0860000000000003E+001,
      1.0861000000000002E+001,
      1.0862000000000002E+001,
      1.0863000000000003E+001,
      1.0864000000000003E+001,
      1.0865000000000002E+001,
      1.0866000000000003E+001,
      1.0867000000000003E+001,
      1.0868000000000002E+001,
      1.0869000000000003E+001,
      1.0870000000000001E+001,
      1.0871000000000002E+001,
      1.0872000000000003E+001,
      1.0873000000000001E+001,
      1.0874000000000002E+001,
      1.0875000000000004E+001,
      1.0876000000000001E+001,
      1.0877000000000002E+001,
      1.0878000000000002E+001,
      1.0879000000000001E+001,
      1.0880000000000003E+001,
      1.0881000000000002E+001,
      1.0882000000000001E+001,
      1.0883000000000003E+001,
      1.0884000000000002E+001,
      1.0885000000000002E+001,
      1.0886000000000003E+001,
      1.0887000000000002E+001,
      1.0888000000000002E+001,
      1.0889000000000003E+001,
      1.0890000000000002E+001,
      1.0891000000000002E+001,
      1.0892000000000003E+001,
      1.0893000000000002E+001,
      1.0894000000000002E+001,
      1.0895000000000003E+001,
      1.0896000000000003E+001,
      1.0897000000000002E+001,
      1.0898000000000003E+001,
      1.0899000000000003E+001,
      1.0900000000000002E+001,
      1.0901000000000003E+001,
      1.0902000000000001E+001,
      1.0903000000000002E+001,
      1.0904000000000003E+001,
      1.0905000000000001E+001,
      1.0906000000000002E+001,
      1.0907000000000004E+001,
      1.0908000000000001E+001,
      1.0909000000000002E+001,
      1.0910000000000002E+001,
      1.0911000000000001E+001,
      1.0912000000000003E+001,
      1.0913000000000002E+001,
      1.0914000000000001E+001,
      1.0915000000000003E+001,
      1.0916000000000002E+001,
      1.0917000000000002E+001,
      1.0918000000000003E+001,
      1.0919000000000002E+001,
      1.0920000000000002E+001,
      1.0921000000000003E+001,
      1.0922000000000002E+001,
      1.0923000000000002E+001,
      1.0924000000000003E+001,
      1.0925000000000002E+001,
      1.0926000000000002E+001,
      1.0927000000000003E+001,
      1.0928000000000003E+001,
      1.0929000000000002E+001,
      1.0930000000000003E+001,
      1.0931000000000003E+001,
      1.0932000000000002E+001,
      1.0933000000000003E+001,
      1.0934000000000001E+001,
      1.0935000000000002E+001,
      1.0936000000000003E+001,
      1.0937000000000001E+001,
      1.0938000000000002E+001,
      1.0939000000000004E+001,
      1.0940000000000001E+001,
      1.0941000000000003E+001,
      1.0942000000000002E+001,
      1.0943000000000001E+001,
      1.0944000000000003E+001,
      1.0945000000000002E+001,
      1.0946000000000002E+001,
      1.0947000000000003E+001,
      1.0948000000000002E+001,
      1.0949000000000002E+001,
      1.0950000000000003E+001,
      1.0951000000000002E+001,
      1.0952000000000002E+001,
      1.0953000000000003E+001,
      1.0954000000000002E+001,
      1.0955000000000002E+001,
      1.0956000000000003E+001,
      1.0957000000000003E+001,
      1.0958000000000002E+001,
      1.0959000000000003E+001,
      1.0960000000000003E+001,
      1.0961000000000002E+001,
      1.0962000000000003E+001,
      1.0963000000000001E+001,
      1.0964000000000002E+001,
      1.0965000000000003E+001,
      1.0966000000000001E+001,
      1.0967000000000002E+001,
      1.0968000000000004E+001,
      1.0969000000000001E+001,
      1.0970000000000002E+001,
      1.0971000000000002E+001,
      1.0972000000000001E+001,
      1.0973000000000003E+001,
      1.0974000000000002E+001,
      1.0975000000000001E+001,
      1.0976000000000003E+001,
      1.0977000000000002E+001,
      1.0978000000000002E+001,
      1.0979000000000003E+001,
      1.0980000000000002E+001,
      1.0981000000000002E+001,
      1.0982000000000003E+001,
      1.0983000000000002E+001,
      1.0984000000000002E+001,
      1.0985000000000003E+001,
      1.0986000000000002E+001,
      1.0987000000000002E+001,
      1.0988000000000003E+001,
      1.0989000000000003E+001,
      1.0990000000000002E+001,
      1.0991000000000003E+001,
      1.0992000000000003E+001,
      1.0993000000000002E+001,
      1.0994000000000003E+001,
      1.0995000000000001E+001,
      1.0996000000000002E+001,
      1.0997000000000003E+001,
      1.0998000000000001E+001,
      1.0999000000000002E+001,
      1.1000000000000004E+001,
      1.1001000000000001E+001,
      1.1002000000000002E+001,
      1.1003000000000002E+001,
      1.1004000000000001E+001,
      1.1005000000000003E+001,
      1.1006000000000002E+001,
      1.1007000000000001E+001,
      1.1008000000000003E+001,
      1.1009000000000002E+001,
      1.1010000000000002E+001,
      1.1011000000000003E+001,
      1.1012000000000002E+001,
      1.1013000000000002E+001,
      1.1014000000000003E+001,
      1.1015000000000002E+001,
      1.1016000000000002E+001,
      1.1017000000000003E+001,
      1.1018000000000002E+001,
      1.1019000000000002E+001,
      1.1020000000000003E+001,
      1.1021000000000003E+001,
      1.1022000000000002E+001,
      1.1023000000000003E+001,
      1.1024000000000003E+001,
      1.1025000000000002E+001,
      1.1026000000000003E+001,
      1.1027000000000001E+001,
      1.1028000000000002E+001,
      1.1029000000000003E+001,
      1.1030000000000001E+001,
      1.1031000000000002E+001,
      1.1032000000000004E+001,
      1.1033000000000001E+001,
      1.1034000000000002E+001,
      1.1035000000000002E+001,
      1.1036000000000001E+001,
      1.1037000000000003E+001,
      1.1038000000000002E+001,
      1.1039000000000001E+001,
      1.1040000000000003E+001,
      1.1041000000000002E+001,
      1.1042000000000002E+001,
      1.1043000000000003E+001,
      1.1044000000000002E+001,
      1.1045000000000002E+001,
      1.1046000000000003E+001,
      1.1047000000000002E+001,
      1.1048000000000002E+001,
      1.1049000000000003E+001,
      1.1050000000000002E+001,
      1.1051000000000002E+001,
      1.1052000000000003E+001,
      1.1053000000000003E+001,
      1.1054000000000002E+001,
      1.1055000000000003E+001,
      1.1056000000000003E+001,
      1.1057000000000002E+001,
      1.1058000000000003E+001,
      1.1059000000000001E+001,
      1.1060000000000002E+001,
      1.1061000000000003E+001,
      1.1062000000000001E+001,
      1.1063000000000002E+001,
      1.1064000000000004E+001,
      1.1065000000000001E+001,
      1.1066000000000003E+001,
      1.1067000000000002E+001,
      1.1068000000000001E+001,
      1.1069000000000003E+001,
      1.1070000000000002E+001,
      1.1071000000000002E+001,
      1.1072000000000003E+001,
      1.1073000000000002E+001,
      1.1074000000000002E+001,
      1.1075000000000003E+001,
      1.1076000000000002E+001,
      1.1077000000000002E+001,
      1.1078000000000003E+001,
      1.1079000000000002E+001,
      1.1080000000000002E+001,
      1.1081000000000003E+001,
      1.1082000000000003E+001,
      1.1083000000000002E+001,
      1.1084000000000003E+001,
      1.1085000000000003E+001,
      1.1086000000000002E+001,
      1.1087000000000003E+001,
      1.1088000000000001E+001,
      1.1089000000000002E+001,
      1.1090000000000003E+001,
      1.1091000000000001E+001,
      1.1092000000000002E+001,
      1.1093000000000004E+001,
      1.1094000000000001E+001,
      1.1095000000000002E+001,
      1.1096000000000002E+001,
      1.1097000000000001E+001,
      1.1098000000000003E+001,
      1.1099000000000002E+001,
      1.1100000000000001E+001,
      1.1101000000000003E+001,
      1.1102000000000002E+001,
      1.1103000000000002E+001,
      1.1104000000000003E+001,
      1.1105000000000002E+001,
      1.1106000000000002E+001,
      1.1107000000000003E+001,
      1.1108000000000002E+001,
      1.1109000000000002E+001,
      1.1110000000000003E+001,
      1.1111000000000002E+001,
      1.1112000000000002E+001,
      1.1113000000000003E+001,
      1.1114000000000003E+001,
      1.1115000000000002E+001,
      1.1116000000000003E+001,
      1.1117000000000003E+001,
      1.1118000000000002E+001,
      1.1119000000000003E+001,
      1.1120000000000001E+001,
      1.1121000000000002E+001,
      1.1122000000000003E+001,
      1.1123000000000001E+001,
      1.1124000000000002E+001,
      1.1125000000000004E+001,
      1.1126000000000001E+001,
      1.1127000000000002E+001,
      1.1128000000000002E+001,
      1.1129000000000001E+001,
      1.1130000000000003E+001,
      1.1131000000000002E+001,
      1.1132000000000001E+001,
      1.1133000000000003E+001,
      1.1134000000000002E+001,
      1.1135000000000002E+001,
      1.1136000000000003E+001,
      1.1137000000000002E+001,
      1.1138000000000002E+001,
      1.1139000000000003E+001,
      1.1140000000000002E+001,
      1.1141000000000002E+001,
      1.1142000000000003E+001,
      1.1143000000000002E+001,
      1.1144000000000002E+001,
      1.1145000000000003E+001,
      1.1146000000000003E+001,
      1.1147000000000002E+001,
      1.1148000000000003E+001,
      1.1149000000000003E+001,
      1.1150000000000002E+001,
      1.1151000000000003E+001,
      1.1152000000000001E+001,
      1.1153000000000002E+001,
      1.1154000000000003E+001,
      1.1155000000000001E+001,
      1.1156000000000002E+001,
      1.1157000000000004E+001,
      1.1158000000000001E+001,
      1.1159000000000002E+001,
      1.1160000000000002E+001,
      1.1161000000000001E+001,
      1.1162000000000003E+001,
      1.1163000000000002E+001,
      1.1164000000000001E+001,
      1.1165000000000003E+001,
      1.1166000000000002E+001,
      1.1167000000000002E+001,
      1.1168000000000003E+001,
      1.1169000000000002E+001,
      1.1170000000000002E+001,
      1.1171000000000003E+001,
      1.1172000000000002E+001,
      1.1173000000000002E+001,
      1.1174000000000003E+001,
      1.1175000000000002E+001,
      1.1176000000000002E+001,
      1.1177000000000003E+001,
      1.1178000000000003E+001,
      1.1179000000000002E+001,
      1.1180000000000003E+001,
      1.1181000000000003E+001,
      1.1182000000000002E+001,
      1.1183000000000003E+001,
      1.1184000000000001E+001,
      1.1185000000000002E+001,
      1.1186000000000003E+001,
      1.1187000000000001E+001,
      1.1188000000000002E+001,
      1.1189000000000004E+001,
      1.1190000000000001E+001,
      1.1191000000000003E+001,
      1.1192000000000002E+001,
      1.1193000000000001E+001,
      1.1194000000000003E+001,
      1.1195000000000002E+001,
      1.1196000000000002E+001,
      1.1197000000000003E+001,
      1.1198000000000002E+001,
      1.1199000000000002E+001,
      1.1200000000000003E+001,
      1.1201000000000002E+001,
      1.1202000000000002E+001,
      1.1203000000000003E+001,
      1.1204000000000002E+001,
      1.1205000000000002E+001,
      1.1206000000000003E+001,
      1.1207000000000003E+001,
      1.1208000000000002E+001,
      1.1209000000000003E+001,
      1.1210000000000003E+001,
      1.1211000000000002E+001,
      1.1212000000000003E+001,
      1.1213000000000001E+001,
      1.1214000000000002E+001,
      1.1215000000000003E+001,
      1.1216000000000001E+001,
      1.1217000000000002E+001,
      1.1218000000000004E+001,
      1.1219000000000001E+001,
      1.1220000000000002E+001,
      1.1221000000000002E+001,
      1.1222000000000001E+001,
      1.1223000000000003E+001,
      1.1224000000000002E+001,
      1.1225000000000001E+001,
      1.1226000000000003E+001,
      1.1227000000000002E+001,
      1.1228000000000002E+001,
      1.1229000000000003E+001,
      1.1230000000000002E+001,
      1.1231000000000002E+001,
      1.1232000000000003E+001,
      1.1233000000000002E+001,
      1.1234000000000002E+001,
      1.1235000000000003E+001,
      1.1236000000000002E+001,
      1.1237000000000002E+001,
      1.1238000000000003E+001,
      1.1239000000000003E+001,
      1.1240000000000002E+001,
      1.1241000000000003E+001,
      1.1242000000000003E+001,
      1.1243000000000002E+001,
      1.1244000000000003E+001,
      1.1245000000000001E+001,
      1.1246000000000002E+001,
      1.1247000000000003E+001,
      1.1248000000000001E+001,
      1.1249000000000002E+001,
      1.1250000000000004E+001,
      1.1251000000000001E+001,
      1.1252000000000002E+001,
      1.1253000000000002E+001,
      1.1254000000000001E+001,
      1.1255000000000003E+001,
      1.1256000000000002E+001,
      1.1257000000000001E+001,
      1.1258000000000003E+001,
      1.1259000000000002E+001,
      1.1260000000000002E+001,
      1.1261000000000003E+001,
      1.1262000000000002E+001,
      1.1263000000000002E+001,
      1.1264000000000003E+001,
      1.1265000000000002E+001,
      1.1266000000000002E+001,
      1.1267000000000003E+001,
      1.1268000000000002E+001,
      1.1269000000000002E+001,
      1.1270000000000003E+001,
      1.1271000000000003E+001,
      1.1272000000000002E+001,
      1.1273000000000003E+001,
      1.1274000000000003E+001,
      1.1275000000000002E+001,
      1.1276000000000003E+001,
      1.1277000000000001E+001,
      1.1278000000000002E+001,
      1.1279000000000003E+001,
      1.1280000000000001E+001,
      1.1281000000000002E+001,
      1.1282000000000004E+001,
      1.1283000000000001E+001,
      1.1284000000000002E+001,
      1.1285000000000002E+001,
      1.1286000000000001E+001,
      1.1287000000000003E+001,
      1.1288000000000002E+001,
      1.1289000000000001E+001,
      1.1290000000000003E+001,
      1.1291000000000002E+001,
      1.1292000000000002E+001,
      1.1293000000000003E+001,
      1.1294000000000002E+001,
      1.1295000000000002E+001,
      1.1296000000000003E+001,
      1.1297000000000002E+001,
      1.1298000000000002E+001,
      1.1299000000000003E+001,
      1.1300000000000002E+001,
      1.1301000000000002E+001,
      1.1302000000000003E+001,
      1.1303000000000003E+001,
      1.1304000000000002E+001,
      1.1305000000000003E+001,
      1.1306000000000003E+001,
      1.1307000000000002E+001,
      1.1308000000000003E+001,
      1.1309000000000001E+001,
      1.1310000000000002E+001,
      1.1311000000000003E+001,
      1.1312000000000001E+001,
      1.1313000000000002E+001,
      1.1314000000000004E+001,
      1.1315000000000001E+001,
      1.1316000000000003E+001,
      1.1317000000000002E+001,
      1.1318000000000001E+001,
      1.1319000000000003E+001,
      1.1320000000000002E+001,
      1.1321000000000002E+001,
      1.1322000000000003E+001,
      1.1323000000000002E+001,
      1.1324000000000002E+001,
      1.1325000000000003E+001,
      1.1326000000000002E+001,
      1.1327000000000002E+001,
      1.1328000000000003E+001,
      1.1329000000000002E+001,
      1.1330000000000002E+001,
      1.1331000000000003E+001,
      1.1332000000000003E+001,
      1.1333000000000002E+001,
      1.1334000000000003E+001,
      1.1335000000000003E+001,
      1.1336000000000002E+001,
      1.1337000000000003E+001,
      1.1338000000000003E+001,
      1.1339000000000002E+001,
      1.1340000000000003E+001,
      1.1341000000000001E+001,
      1.1342000000000002E+001,
      1.1343000000000004E+001,
      1.1344000000000001E+001,
      1.1345000000000002E+001,
      1.1346000000000002E+001,
      1.1347000000000001E+001,
      1.1348000000000003E+001,
      1.1349000000000002E+001,
      1.1350000000000001E+001,
      1.1351000000000003E+001,
      1.1352000000000002E+001,
      1.1353000000000002E+001,
      1.1354000000000003E+001,
      1.1355000000000002E+001,
      1.1356000000000002E+001,
      1.1357000000000003E+001,
      1.1358000000000002E+001,
      1.1359000000000002E+001,
      1.1360000000000003E+001,
      1.1361000000000002E+001,
      1.1362000000000002E+001,
      1.1363000000000003E+001,
      1.1364000000000003E+001,
      1.1365000000000002E+001,
      1.1366000000000003E+001,
      1.1367000000000003E+001,
      1.1368000000000002E+001,
      1.1369000000000003E+001,
      1.1370000000000001E+001,
      1.1371000000000002E+001,
      1.1372000000000003E+001,
      1.1373000000000001E+001,
      1.1374000000000002E+001,
      1.1375000000000004E+001,
      1.1376000000000001E+001,
      1.1377000000000002E+001,
      1.1378000000000002E+001,
      1.1379000000000001E+001,
      1.1380000000000003E+001,
      1.1381000000000002E+001,
      1.1382000000000001E+001,
      1.1383000000000003E+001,
      1.1384000000000002E+001,
      1.1385000000000002E+001,
      1.1386000000000003E+001,
      1.1387000000000002E+001,
      1.1388000000000002E+001,
      1.1389000000000003E+001,
      1.1390000000000002E+001,
      1.1391000000000002E+001,
      1.1392000000000003E+001,
      1.1393000000000002E+001,
      1.1394000000000002E+001,
      1.1395000000000003E+001,
      1.1396000000000003E+001,
      1.1397000000000002E+001,
      1.1398000000000003E+001,
      1.1399000000000003E+001,
      1.1400000000000002E+001,
      1.1401000000000003E+001,
      1.1402000000000001E+001,
      1.1403000000000002E+001,
      1.1404000000000003E+001,
      1.1405000000000001E+001,
      1.1406000000000002E+001,
      1.1407000000000004E+001,
      1.1408000000000001E+001,
      1.1409000000000002E+001,
      1.1410000000000002E+001,
      1.1411000000000001E+001,
      1.1412000000000003E+001,
      1.1413000000000002E+001,
      1.1414000000000001E+001,
      1.1415000000000003E+001,
      1.1416000000000002E+001,
      1.1417000000000002E+001,
      1.1418000000000003E+001,
      1.1419000000000002E+001,
      1.1420000000000002E+001,
      1.1421000000000003E+001,
      1.1422000000000002E+001,
      1.1423000000000002E+001,
      1.1424000000000003E+001,
      1.1425000000000002E+001,
      1.1426000000000002E+001,
      1.1427000000000003E+001,
      1.1428000000000003E+001,
      1.1429000000000002E+001,
      1.1430000000000003E+001,
      1.1431000000000003E+001,
      1.1432000000000002E+001,
      1.1433000000000003E+001,
      1.1434000000000001E+001,
      1.1435000000000002E+001,
      1.1436000000000003E+001,
      1.1437000000000001E+001,
      1.1438000000000002E+001,
      1.1439000000000004E+001,
      1.1440000000000001E+001,
      1.1441000000000003E+001,
      1.1442000000000002E+001,
      1.1443000000000001E+001,
      1.1444000000000003E+001,
      1.1445000000000002E+001,
      1.1446000000000002E+001,
      1.1447000000000003E+001,
      1.1448000000000002E+001,
      1.1449000000000002E+001,
      1.1450000000000003E+001,
      1.1451000000000002E+001,
      1.1452000000000002E+001,
      1.1453000000000003E+001,
      1.1454000000000002E+001,
      1.1455000000000002E+001,
      1.1456000000000003E+001,
      1.1457000000000003E+001,
      1.1458000000000002E+001,
      1.1459000000000003E+001,
      1.1460000000000003E+001,
      1.1461000000000002E+001,
      1.1462000000000003E+001,
      1.1463000000000003E+001,
      1.1464000000000002E+001,
      1.1465000000000003E+001,
      1.1466000000000001E+001,
      1.1467000000000002E+001,
      1.1468000000000004E+001,
      1.1469000000000001E+001,
      1.1470000000000002E+001,
      1.1471000000000002E+001,
      1.1472000000000001E+001,
      1.1473000000000003E+001,
      1.1474000000000002E+001,
      1.1475000000000001E+001,
      1.1476000000000003E+001,
      1.1477000000000002E+001,
      1.1478000000000002E+001,
      1.1479000000000003E+001,
      1.1480000000000002E+001,
      1.1481000000000002E+001,
      1.1482000000000003E+001,
      1.1483000000000002E+001,
      1.1484000000000002E+001,
      1.1485000000000003E+001,
      1.1486000000000002E+001,
      1.1487000000000002E+001,
      1.1488000000000003E+001,
      1.1489000000000003E+001,
      1.1490000000000002E+001,
      1.1491000000000003E+001,
      1.1492000000000003E+001,
      1.1493000000000002E+001,
      1.1494000000000003E+001,
      1.1495000000000001E+001,
      1.1496000000000002E+001,
      1.1497000000000003E+001,
      1.1498000000000001E+001,
      1.1499000000000002E+001,
      1.1500000000000004E+001,
      1.1501000000000001E+001,
      1.1502000000000002E+001,
      1.1503000000000002E+001,
      1.1504000000000001E+001,
      1.1505000000000003E+001,
      1.1506000000000002E+001,
      1.1507000000000001E+001,
      1.1508000000000003E+001,
      1.1509000000000002E+001,
      1.1510000000000002E+001,
      1.1511000000000003E+001,
      1.1512000000000002E+001,
      1.1513000000000002E+001,
      1.1514000000000003E+001,
      1.1515000000000002E+001,
      1.1516000000000002E+001,
      1.1517000000000003E+001,
      1.1518000000000002E+001,
      1.1519000000000002E+001,
      1.1520000000000003E+001,
      1.1521000000000003E+001,
      1.1522000000000002E+001,
      1.1523000000000003E+001,
      1.1524000000000003E+001,
      1.1525000000000002E+001,
      1.1526000000000003E+001,
      1.1527000000000001E+001,
      1.1528000000000002E+001,
      1.1529000000000003E+001,
      1.1530000000000001E+001,
      1.1531000000000002E+001,
      1.1532000000000004E+001,
      1.1533000000000001E+001,
      1.1534000000000002E+001,
      1.1535000000000002E+001,
      1.1536000000000001E+001,
      1.1537000000000003E+001,
      1.1538000000000002E+001,
      1.1539000000000001E+001,
      1.1540000000000003E+001,
      1.1541000000000002E+001,
      1.1542000000000002E+001,
      1.1543000000000003E+001,
      1.1544000000000002E+001,
      1.1545000000000002E+001,
      1.1546000000000003E+001,
      1.1547000000000002E+001,
      1.1548000000000002E+001,
      1.1549000000000003E+001,
      1.1550000000000002E+001,
      1.1551000000000002E+001,
      1.1552000000000003E+001,
      1.1553000000000003E+001,
      1.1554000000000002E+001,
      1.1555000000000003E+001,
      1.1556000000000003E+001,
      1.1557000000000002E+001,
      1.1558000000000003E+001,
      1.1559000000000001E+001,
      1.1560000000000002E+001,
      1.1561000000000003E+001,
      1.1562000000000001E+001,
      1.1563000000000002E+001,
      1.1564000000000002E+001,
      1.1565000000000001E+001,
      1.1566000000000003E+001,
      1.1567000000000002E+001,
      1.1568000000000001E+001,
      1.1569000000000003E+001,
      1.1570000000000002E+001,
      1.1571000000000002E+001,
      1.1572000000000003E+001,
      1.1573000000000002E+001,
      1.1574000000000002E+001,
      1.1575000000000003E+001,
      1.1576000000000002E+001,
      1.1577000000000002E+001,
      1.1578000000000003E+001,
      1.1579000000000002E+001,
      1.1580000000000002E+001,
      1.1581000000000003E+001,
      1.1582000000000003E+001,
      1.1583000000000002E+001,
      1.1584000000000003E+001,
      1.1585000000000003E+001,
      1.1586000000000002E+001,
      1.1587000000000003E+001,
      1.1588000000000003E+001,
      1.1589000000000002E+001,
      1.1590000000000003E+001,
      1.1591000000000003E+001,
      1.1592000000000002E+001,
      1.1593000000000002E+001,
      1.1594000000000003E+001,
      1.1595000000000002E+001,
      1.1596000000000002E+001,
      1.1597000000000001E+001,
      1.1598000000000003E+001,
      1.1599000000000002E+001,
      1.1600000000000001E+001,
      1.1601000000000003E+001,
      1.1602000000000002E+001,
      1.1603000000000002E+001,
      1.1604000000000003E+001,
      1.1605000000000002E+001,
      1.1606000000000002E+001,
      1.1607000000000003E+001,
      1.1608000000000002E+001,
      1.1609000000000002E+001,
      1.1610000000000003E+001,
      1.1611000000000002E+001,
      1.1612000000000002E+001,
      1.1613000000000003E+001,
      1.1614000000000003E+001,
      1.1615000000000002E+001,
      1.1616000000000003E+001,
      1.1617000000000003E+001,
      1.1618000000000002E+001,
      1.1619000000000003E+001,
      1.1620000000000003E+001,
      1.1621000000000002E+001,
      1.1622000000000002E+001,
      1.1623000000000003E+001,
      1.1624000000000002E+001,
      1.1625000000000002E+001,
      1.1626000000000001E+001,
      1.1627000000000002E+001,
      1.1628000000000002E+001,
      1.1629000000000001E+001,
      1.1630000000000003E+001,
      1.1631000000000002E+001,
      1.1632000000000001E+001,
      1.1633000000000003E+001,
      1.1634000000000002E+001,
      1.1635000000000002E+001,
      1.1636000000000003E+001,
      1.1637000000000002E+001,
      1.1638000000000002E+001,
      1.1639000000000003E+001,
      1.1640000000000002E+001,
      1.1641000000000002E+001,
      1.1642000000000003E+001,
      1.1643000000000002E+001,
      1.1644000000000002E+001,
      1.1645000000000003E+001,
      1.1646000000000003E+001,
      1.1647000000000002E+001,
      1.1648000000000003E+001,
      1.1649000000000003E+001,
      1.1650000000000002E+001,
      1.1651000000000003E+001,
      1.1652000000000003E+001,
      1.1653000000000002E+001,
      1.1654000000000002E+001,
      1.1655000000000003E+001,
      1.1656000000000002E+001,
      1.1657000000000002E+001,
      1.1658000000000001E+001,
      1.1659000000000002E+001,
      1.1660000000000002E+001,
      1.1661000000000001E+001,
      1.1662000000000003E+001,
      1.1663000000000002E+001,
      1.1664000000000001E+001,
      1.1665000000000003E+001,
      1.1666000000000002E+001,
      1.1667000000000002E+001,
      1.1668000000000003E+001,
      1.1669000000000002E+001,
      1.1670000000000002E+001,
      1.1671000000000003E+001,
      1.1672000000000002E+001,
      1.1673000000000002E+001,
      1.1674000000000003E+001,
      1.1675000000000002E+001,
      1.1676000000000002E+001,
      1.1677000000000003E+001,
      1.1678000000000003E+001,
      1.1679000000000002E+001,
      1.1680000000000003E+001,
      1.1681000000000003E+001,
      1.1682000000000002E+001,
      1.1683000000000003E+001,
      1.1684000000000003E+001,
      1.1685000000000002E+001,
      1.1686000000000002E+001,
      1.1687000000000003E+001,
      1.1688000000000002E+001,
      1.1689000000000002E+001,
      1.1690000000000001E+001,
      1.1691000000000003E+001,
      1.1692000000000002E+001,
      1.1693000000000001E+001,
      1.1694000000000003E+001,
      1.1695000000000002E+001,
      1.1696000000000002E+001,
      1.1697000000000003E+001,
      1.1698000000000002E+001,
      1.1699000000000002E+001,
      1.1700000000000003E+001,
      1.1701000000000002E+001,
      1.1702000000000002E+001,
      1.1703000000000003E+001,
      1.1704000000000002E+001,
      1.1705000000000002E+001,
      1.1706000000000003E+001,
      1.1707000000000003E+001,
      1.1708000000000002E+001,
      1.1709000000000003E+001,
      1.1710000000000003E+001,
      1.1711000000000002E+001,
      1.1712000000000003E+001,
      1.1713000000000003E+001,
      1.1714000000000002E+001,
      1.1715000000000003E+001,
      1.1716000000000003E+001,
      1.1717000000000002E+001,
      1.1718000000000002E+001,
      1.1719000000000003E+001,
      1.1720000000000002E+001,
      1.1721000000000002E+001,
      1.1722000000000001E+001,
      1.1723000000000003E+001,
      1.1724000000000002E+001,
      1.1725000000000001E+001,
      1.1726000000000003E+001,
      1.1727000000000002E+001,
      1.1728000000000002E+001,
      1.1729000000000003E+001,
      1.1730000000000002E+001,
      1.1731000000000002E+001,
      1.1732000000000003E+001,
      1.1733000000000002E+001,
      1.1734000000000002E+001,
      1.1735000000000003E+001,
      1.1736000000000002E+001,
      1.1737000000000002E+001,
      1.1738000000000003E+001,
      1.1739000000000003E+001,
      1.1740000000000002E+001,
      1.1741000000000003E+001,
      1.1742000000000003E+001,
      1.1743000000000002E+001,
      1.1744000000000003E+001,
      1.1745000000000003E+001,
      1.1746000000000002E+001,
      1.1747000000000002E+001,
      1.1748000000000003E+001,
      1.1749000000000002E+001,
      1.1750000000000002E+001,
      1.1751000000000001E+001,
      1.1752000000000002E+001,
      1.1753000000000002E+001,
      1.1754000000000001E+001,
      1.1755000000000003E+001,
      1.1756000000000002E+001,
      1.1757000000000001E+001,
      1.1758000000000003E+001,
      1.1759000000000002E+001,
      1.1760000000000002E+001,
      1.1761000000000003E+001,
      1.1762000000000002E+001,
      1.1763000000000002E+001,
      1.1764000000000003E+001,
      1.1765000000000002E+001,
      1.1766000000000002E+001,
      1.1767000000000003E+001,
      1.1768000000000002E+001,
      1.1769000000000002E+001,
      1.1770000000000003E+001,
      1.1771000000000003E+001,
      1.1772000000000002E+001,
      1.1773000000000003E+001,
      1.1774000000000003E+001,
      1.1775000000000002E+001,
      1.1776000000000003E+001,
      1.1777000000000003E+001,
      1.1778000000000002E+001,
      1.1779000000000002E+001,
      1.1780000000000003E+001,
      1.1781000000000002E+001,
      1.1782000000000002E+001,
      1.1783000000000001E+001,
      1.1784000000000002E+001,
      1.1785000000000002E+001,
      1.1786000000000001E+001,
      1.1787000000000003E+001,
      1.1788000000000002E+001,
      1.1789000000000001E+001,
      1.1790000000000003E+001,
      1.1791000000000002E+001,
      1.1792000000000002E+001,
      1.1793000000000003E+001,
      1.1794000000000002E+001,
      1.1795000000000002E+001,
      1.1796000000000003E+001,
      1.1797000000000002E+001,
      1.1798000000000002E+001,
      1.1799000000000003E+001,
      1.1800000000000002E+001,
      1.1801000000000002E+001,
      1.1802000000000003E+001,
      1.1803000000000003E+001,
      1.1804000000000002E+001,
      1.1805000000000003E+001,
      1.1806000000000003E+001,
      1.1807000000000002E+001,
      1.1808000000000003E+001,
      1.1809000000000003E+001,
      1.1810000000000002E+001,
      1.1811000000000002E+001,
      1.1812000000000003E+001,
      1.1813000000000002E+001,
      1.1814000000000002E+001,
      1.1815000000000001E+001,
      1.1816000000000003E+001,
      1.1817000000000002E+001,
      1.1818000000000001E+001,
      1.1819000000000003E+001,
      1.1820000000000002E+001,
      1.1821000000000002E+001,
      1.1822000000000003E+001,
      1.1823000000000002E+001,
      1.1824000000000002E+001,
      1.1825000000000003E+001,
      1.1826000000000002E+001,
      1.1827000000000002E+001,
      1.1828000000000003E+001,
      1.1829000000000002E+001,
      1.1830000000000002E+001,
      1.1831000000000003E+001,
      1.1832000000000003E+001,
      1.1833000000000002E+001,
      1.1834000000000003E+001,
      1.1835000000000003E+001,
      1.1836000000000002E+001,
      1.1837000000000003E+001,
      1.1838000000000003E+001,
      1.1839000000000002E+001,
      1.1840000000000003E+001,
      1.1841000000000003E+001,
      1.1842000000000002E+001,
      1.1843000000000002E+001,
      1.1844000000000003E+001,
      1.1845000000000002E+001,
      1.1846000000000002E+001,
      1.1847000000000001E+001,
      1.1848000000000003E+001,
      1.1849000000000002E+001,
      1.1850000000000001E+001,
      1.1851000000000003E+001,
      1.1852000000000002E+001,
      1.1853000000000002E+001,
      1.1854000000000003E+001,
      1.1855000000000002E+001,
      1.1856000000000002E+001,
      1.1857000000000003E+001,
      1.1858000000000002E+001,
      1.1859000000000002E+001,
      1.1860000000000003E+001,
      1.1861000000000002E+001,
      1.1862000000000002E+001,
      1.1863000000000003E+001,
      1.1864000000000003E+001,
      1.1865000000000002E+001,
      1.1866000000000003E+001,
      1.1867000000000003E+001,
      1.1868000000000002E+001,
      1.1869000000000003E+001,
      1.1870000000000003E+001,
      1.1871000000000002E+001,
      1.1872000000000002E+001,
      1.1873000000000003E+001,
      1.1874000000000002E+001,
      1.1875000000000002E+001,
      1.1876000000000001E+001,
      1.1877000000000002E+001,
      1.1878000000000002E+001,
      1.1879000000000001E+001,
      1.1880000000000003E+001,
      1.1881000000000002E+001,
      1.1882000000000001E+001,
      1.1883000000000003E+001,
      1.1884000000000002E+001,
      1.1885000000000002E+001,
      1.1886000000000003E+001,
      1.1887000000000002E+001,
      1.1888000000000002E+001,
      1.1889000000000003E+001,
      1.1890000000000002E+001,
      1.1891000000000002E+001,
      1.1892000000000003E+001,
      1.1893000000000002E+001,
      1.1894000000000002E+001,
      1.1895000000000003E+001,
      1.1896000000000003E+001,
      1.1897000000000002E+001,
      1.1898000000000003E+001,
      1.1899000000000003E+001,
      1.1900000000000002E+001,
      1.1901000000000003E+001,
      1.1902000000000003E+001,
      1.1903000000000002E+001,
      1.1904000000000002E+001,
      1.1905000000000003E+001,
      1.1906000000000002E+001,
      1.1907000000000002E+001,
      1.1908000000000001E+001,
      1.1909000000000002E+001,
      1.1910000000000002E+001,
      1.1911000000000001E+001,
      1.1912000000000003E+001,
      1.1913000000000002E+001,
      1.1914000000000001E+001,
      1.1915000000000003E+001,
      1.1916000000000002E+001,
      1.1917000000000002E+001,
      1.1918000000000003E+001,
      1.1919000000000002E+001,
      1.1920000000000002E+001,
      1.1921000000000003E+001,
      1.1922000000000002E+001,
      1.1923000000000002E+001,
      1.1924000000000003E+001,
      1.1925000000000002E+001,
      1.1926000000000002E+001,
      1.1927000000000003E+001,
      1.1928000000000003E+001,
      1.1929000000000002E+001,
      1.1930000000000003E+001,
      1.1931000000000003E+001,
      1.1932000000000002E+001,
      1.1933000000000003E+001,
      1.1934000000000003E+001,
      1.1935000000000002E+001,
      1.1936000000000002E+001,
      1.1937000000000003E+001,
      1.1938000000000002E+001,
      1.1939000000000002E+001,
      1.1940000000000001E+001,
      1.1941000000000003E+001,
      1.1942000000000002E+001,
      1.1943000000000001E+001,
      1.1944000000000003E+001,
      1.1945000000000002E+001,
      1.1946000000000002E+001,
      1.1947000000000003E+001,
      1.1948000000000002E+001,
      1.1949000000000002E+001,
      1.1950000000000003E+001,
      1.1951000000000002E+001,
      1.1952000000000002E+001,
      1.1953000000000003E+001,
      1.1954000000000002E+001,
      1.1955000000000002E+001,
      1.1956000000000003E+001,
      1.1957000000000003E+001,
      1.1958000000000002E+001,
      1.1959000000000003E+001,
      1.1960000000000003E+001,
      1.1961000000000002E+001,
      1.1962000000000003E+001,
      1.1963000000000003E+001,
      1.1964000000000002E+001,
      1.1965000000000003E+001,
      1.1966000000000003E+001,
      1.1967000000000002E+001,
      1.1968000000000002E+001,
      1.1969000000000003E+001,
      1.1970000000000002E+001,
      1.1971000000000002E+001,
      1.1972000000000001E+001,
      1.1973000000000003E+001,
      1.1974000000000002E+001,
      1.1975000000000001E+001,
      1.1976000000000003E+001,
      1.1977000000000002E+001,
      1.1978000000000002E+001,
      1.1979000000000003E+001,
      1.1980000000000002E+001,
      1.1981000000000002E+001,
      1.1982000000000003E+001,
      1.1983000000000002E+001,
      1.1984000000000002E+001,
      1.1985000000000003E+001,
      1.1986000000000002E+001,
      1.1987000000000002E+001,
      1.1988000000000003E+001,
      1.1989000000000003E+001,
      1.1990000000000002E+001,
      1.1991000000000003E+001,
      1.1992000000000003E+001,
      1.1993000000000002E+001,
      1.1994000000000003E+001,
      1.1995000000000003E+001,
      1.1996000000000002E+001,
      1.1997000000000002E+001,
      1.1998000000000003E+001,
      1.1999000000000002E+001,
      1.2000000000000002E+001,
      1.2001000000000001E+001,
      1.2002000000000002E+001,
      1.2003000000000002E+001,
      1.2004000000000001E+001,
      1.2005000000000003E+001,
      1.2006000000000002E+001,
      1.2007000000000001E+001,
      1.2008000000000003E+001,
      1.2009000000000002E+001,
      1.2010000000000002E+001,
      1.2011000000000003E+001,
      1.2012000000000002E+001,
      1.2013000000000002E+001,
      1.2014000000000003E+001,
      1.2015000000000002E+001,
      1.2016000000000002E+001,
      1.2017000000000003E+001,
      1.2018000000000002E+001,
      1.2019000000000002E+001,
      1.2020000000000003E+001,
      1.2021000000000003E+001,
      1.2022000000000002E+001,
      1.2023000000000003E+001,
      1.2024000000000003E+001,
      1.2025000000000002E+001,
      1.2026000000000003E+001,
      1.2027000000000003E+001,
      1.2028000000000002E+001,
      1.2029000000000002E+001,
      1.2030000000000003E+001,
      1.2031000000000002E+001,
      1.2032000000000002E+001,
      1.2033000000000001E+001,
      1.2034000000000002E+001,
      1.2035000000000002E+001,
      1.2036000000000001E+001,
      1.2037000000000003E+001,
      1.2038000000000002E+001,
      1.2039000000000001E+001,
      1.2040000000000003E+001,
      1.2041000000000002E+001,
      1.2042000000000002E+001,
      1.2043000000000003E+001,
      1.2044000000000002E+001,
      1.2045000000000002E+001,
      1.2046000000000003E+001,
      1.2047000000000002E+001,
      1.2048000000000002E+001,
      1.2049000000000003E+001,
      1.2050000000000002E+001,
      1.2051000000000002E+001,
      1.2052000000000003E+001,
      1.2053000000000003E+001,
      1.2054000000000002E+001,
      1.2055000000000003E+001,
      1.2056000000000003E+001,
      1.2057000000000002E+001,
      1.2058000000000003E+001,
      1.2059000000000003E+001,
      1.2060000000000002E+001,
      1.2061000000000002E+001,
      1.2062000000000003E+001,
      1.2063000000000002E+001,
      1.2064000000000002E+001,
      1.2065000000000001E+001,
      1.2066000000000003E+001,
      1.2067000000000002E+001,
      1.2068000000000001E+001,
      1.2069000000000003E+001,
      1.2070000000000002E+001,
      1.2071000000000002E+001,
      1.2072000000000003E+001,
      1.2073000000000002E+001,
      1.2074000000000002E+001,
      1.2075000000000003E+001,
      1.2076000000000002E+001,
      1.2077000000000002E+001,
      1.2078000000000003E+001,
      1.2079000000000002E+001,
      1.2080000000000002E+001,
      1.2081000000000003E+001,
      1.2082000000000003E+001,
      1.2083000000000002E+001,
      1.2084000000000003E+001,
      1.2085000000000003E+001,
      1.2086000000000002E+001,
      1.2087000000000003E+001,
      1.2088000000000003E+001,
      1.2089000000000002E+001,
      1.2090000000000003E+001,
      1.2091000000000003E+001,
      1.2092000000000002E+001,
      1.2093000000000002E+001,
      1.2094000000000003E+001,
      1.2095000000000002E+001,
      1.2096000000000002E+001,
      1.2097000000000001E+001,
      1.2098000000000003E+001,
      1.2099000000000002E+001,
      1.2100000000000001E+001,
      1.2101000000000003E+001,
      1.2102000000000002E+001,
      1.2103000000000002E+001,
      1.2104000000000003E+001,
      1.2105000000000002E+001,
      1.2106000000000002E+001,
      1.2107000000000003E+001,
      1.2108000000000002E+001,
      1.2109000000000002E+001,
      1.2110000000000003E+001,
      1.2111000000000002E+001,
      1.2112000000000002E+001,
      1.2113000000000003E+001,
      1.2114000000000003E+001,
      1.2115000000000002E+001,
      1.2116000000000003E+001,
      1.2117000000000003E+001,
      1.2118000000000002E+001,
      1.2119000000000003E+001,
      1.2120000000000003E+001,
      1.2121000000000002E+001,
      1.2122000000000002E+001,
      1.2123000000000003E+001,
      1.2124000000000002E+001,
      1.2125000000000002E+001,
      1.2126000000000001E+001,
      1.2127000000000002E+001,
      1.2128000000000002E+001,
      1.2129000000000001E+001,
      1.2130000000000003E+001,
      1.2131000000000002E+001,
      1.2132000000000001E+001,
      1.2133000000000003E+001,
      1.2134000000000002E+001,
      1.2135000000000002E+001,
      1.2136000000000003E+001,
      1.2137000000000002E+001,
      1.2138000000000002E+001,
      1.2139000000000003E+001,
      1.2140000000000002E+001,
      1.2141000000000002E+001,
      1.2142000000000003E+001,
      1.2143000000000002E+001,
      1.2144000000000002E+001,
      1.2145000000000003E+001,
      1.2146000000000003E+001,
      1.2147000000000002E+001,
      1.2148000000000003E+001,
      1.2149000000000003E+001,
      1.2150000000000002E+001,
      1.2151000000000003E+001,
      1.2152000000000003E+001,
      1.2153000000000002E+001,
      1.2154000000000002E+001,
      1.2155000000000003E+001,
      1.2156000000000002E+001,
      1.2157000000000002E+001,
      1.2158000000000001E+001,
      1.2159000000000002E+001,
      1.2160000000000002E+001,
      1.2161000000000001E+001,
      1.2162000000000003E+001,
      1.2163000000000002E+001,
      1.2164000000000001E+001,
      1.2165000000000003E+001,
      1.2166000000000002E+001,
      1.2167000000000002E+001,
      1.2168000000000003E+001,
      1.2169000000000002E+001,
      1.2170000000000002E+001,
      1.2171000000000003E+001,
      1.2172000000000002E+001,
      1.2173000000000002E+001,
      1.2174000000000003E+001,
      1.2175000000000002E+001,
      1.2176000000000002E+001,
      1.2177000000000003E+001,
      1.2178000000000003E+001,
      1.2179000000000002E+001,
      1.2180000000000003E+001,
      1.2181000000000003E+001,
      1.2182000000000002E+001,
      1.2183000000000003E+001,
      1.2184000000000003E+001,
      1.2185000000000002E+001,
      1.2186000000000002E+001,
      1.2187000000000003E+001,
      1.2188000000000002E+001,
      1.2189000000000002E+001,
      1.2190000000000001E+001,
      1.2191000000000003E+001,
      1.2192000000000002E+001,
      1.2193000000000001E+001,
      1.2194000000000003E+001,
      1.2195000000000002E+001,
      1.2196000000000002E+001,
      1.2197000000000003E+001,
      1.2198000000000002E+001,
      1.2199000000000002E+001,
      1.2200000000000003E+001,
      1.2201000000000002E+001,
      1.2202000000000002E+001,
      1.2203000000000003E+001,
      1.2204000000000002E+001,
      1.2205000000000002E+001,
      1.2206000000000003E+001,
      1.2207000000000003E+001,
      1.2208000000000002E+001,
      1.2209000000000003E+001,
      1.2210000000000003E+001,
      1.2211000000000002E+001,
      1.2212000000000003E+001,
      1.2213000000000003E+001,
      1.2214000000000002E+001,
      1.2215000000000003E+001,
      1.2216000000000003E+001,
      1.2217000000000002E+001,
      1.2218000000000002E+001,
      1.2219000000000003E+001,
      1.2220000000000002E+001,
      1.2221000000000002E+001,
      1.2222000000000001E+001,
      1.2223000000000003E+001,
      1.2224000000000002E+001,
      1.2225000000000001E+001,
      1.2226000000000003E+001,
      1.2227000000000002E+001,
      1.2228000000000002E+001,
      1.2229000000000003E+001,
      1.2230000000000002E+001,
      1.2231000000000002E+001,
      1.2232000000000003E+001,
      1.2233000000000002E+001,
      1.2234000000000002E+001,
      1.2235000000000003E+001,
      1.2236000000000002E+001,
      1.2237000000000002E+001,
      1.2238000000000003E+001,
      1.2239000000000003E+001,
      1.2240000000000002E+001,
      1.2241000000000003E+001,
      1.2242000000000003E+001,
      1.2243000000000002E+001,
      1.2244000000000003E+001,
      1.2245000000000003E+001,
      1.2246000000000002E+001,
      1.2247000000000002E+001,
      1.2248000000000003E+001,
      1.2249000000000002E+001,
      1.2250000000000002E+001,
      1.2251000000000001E+001,
      1.2252000000000002E+001,
      1.2253000000000002E+001,
      1.2254000000000001E+001,
      1.2255000000000003E+001,
      1.2256000000000002E+001,
      1.2257000000000001E+001,
      1.2258000000000003E+001,
      1.2259000000000002E+001,
      1.2260000000000002E+001,
      1.2261000000000003E+001,
      1.2262000000000002E+001,
      1.2263000000000002E+001,
      1.2264000000000003E+001,
      1.2265000000000002E+001,
      1.2266000000000002E+001,
      1.2267000000000003E+001,
      1.2268000000000002E+001,
      1.2269000000000002E+001,
      1.2270000000000003E+001,
      1.2271000000000003E+001,
      1.2272000000000002E+001,
      1.2273000000000003E+001,
      1.2274000000000003E+001,
      1.2275000000000002E+001,
      1.2276000000000003E+001,
      1.2277000000000003E+001,
      1.2278000000000002E+001,
      1.2279000000000002E+001,
      1.2280000000000003E+001,
      1.2281000000000002E+001,
      1.2282000000000002E+001,
      1.2283000000000001E+001,
      1.2284000000000002E+001,
      1.2285000000000002E+001,
      1.2286000000000001E+001,
      1.2287000000000003E+001,
      1.2288000000000002E+001,
      1.2289000000000001E+001,
      1.2290000000000003E+001,
      1.2291000000000002E+001,
      1.2292000000000002E+001,
      1.2293000000000003E+001,
      1.2294000000000002E+001,
      1.2295000000000002E+001,
      1.2296000000000003E+001,
      1.2297000000000002E+001,
      1.2298000000000002E+001,
      1.2299000000000003E+001,
      1.2300000000000002E+001,
      1.2301000000000002E+001,
      1.2302000000000003E+001,
      1.2303000000000003E+001,
      1.2304000000000002E+001,
      1.2305000000000003E+001,
      1.2306000000000003E+001,
      1.2307000000000002E+001,
      1.2308000000000003E+001,
      1.2309000000000003E+001,
      1.2310000000000002E+001,
      1.2311000000000002E+001,
      1.2312000000000003E+001,
      1.2313000000000002E+001,
      1.2314000000000002E+001,
      1.2315000000000001E+001,
      1.2316000000000003E+001,
      1.2317000000000002E+001,
      1.2318000000000001E+001,
      1.2319000000000003E+001,
      1.2320000000000002E+001,
      1.2321000000000002E+001,
      1.2322000000000003E+001,
      1.2323000000000002E+001,
      1.2324000000000002E+001,
      1.2325000000000003E+001,
      1.2326000000000002E+001,
      1.2327000000000002E+001,
      1.2328000000000003E+001,
      1.2329000000000002E+001,
      1.2330000000000002E+001,
      1.2331000000000003E+001,
      1.2332000000000003E+001,
      1.2333000000000002E+001,
      1.2334000000000003E+001,
      1.2335000000000003E+001,
      1.2336000000000002E+001,
      1.2337000000000003E+001,
      1.2338000000000003E+001,
      1.2339000000000002E+001,
      1.2340000000000003E+001,
      1.2341000000000003E+001,
      1.2342000000000002E+001,
      1.2343000000000002E+001,
      1.2344000000000003E+001,
      1.2345000000000002E+001,
      1.2346000000000002E+001,
      1.2347000000000001E+001,
      1.2348000000000003E+001,
      1.2349000000000002E+001,
      1.2350000000000001E+001,
      1.2351000000000003E+001,
      1.2352000000000002E+001,
      1.2353000000000002E+001,
      1.2354000000000003E+001,
      1.2355000000000002E+001,
      1.2356000000000002E+001,
      1.2357000000000003E+001,
      1.2358000000000002E+001,
      1.2359000000000002E+001,
      1.2360000000000003E+001,
      1.2361000000000002E+001,
      1.2362000000000002E+001,
      1.2363000000000003E+001,
      1.2364000000000003E+001,
      1.2365000000000002E+001,
      1.2366000000000003E+001,
      1.2367000000000003E+001,
      1.2368000000000002E+001,
      1.2369000000000003E+001,
      1.2370000000000003E+001,
      1.2371000000000002E+001,
      1.2372000000000002E+001,
      1.2373000000000003E+001,
      1.2374000000000002E+001,
      1.2375000000000002E+001,
      1.2376000000000001E+001,
      1.2377000000000002E+001,
      1.2378000000000002E+001,
      1.2379000000000001E+001,
      1.2380000000000003E+001,
      1.2381000000000002E+001,
      1.2382000000000001E+001,
      1.2383000000000003E+001,
      1.2384000000000002E+001,
      1.2385000000000002E+001,
      1.2386000000000003E+001,
      1.2387000000000002E+001,
      1.2388000000000002E+001,
      1.2389000000000003E+001,
      1.2390000000000002E+001,
      1.2391000000000002E+001,
      1.2392000000000003E+001,
      1.2393000000000002E+001,
      1.2394000000000002E+001,
      1.2395000000000003E+001,
      1.2396000000000003E+001,
      1.2397000000000002E+001,
      1.2398000000000003E+001,
      1.2399000000000003E+001,
      1.2400000000000002E+001,
      1.2401000000000003E+001,
      1.2402000000000003E+001,
      1.2403000000000002E+001,
      1.2404000000000002E+001,
      1.2405000000000003E+001,
      1.2406000000000002E+001,
      1.2407000000000002E+001,
      1.2408000000000001E+001,
      1.2409000000000002E+001,
      1.2410000000000002E+001,
      1.2411000000000001E+001,
      1.2412000000000003E+001,
      1.2413000000000002E+001,
      1.2414000000000001E+001,
      1.2415000000000003E+001,
      1.2416000000000002E+001,
      1.2417000000000002E+001,
      1.2418000000000003E+001,
      1.2419000000000002E+001,
      1.2420000000000002E+001,
      1.2421000000000003E+001,
      1.2422000000000002E+001,
      1.2423000000000002E+001,
      1.2424000000000003E+001,
      1.2425000000000002E+001,
      1.2426000000000002E+001,
      1.2427000000000003E+001,
      1.2428000000000003E+001,
      1.2429000000000002E+001,
      1.2430000000000003E+001,
      1.2431000000000003E+001,
      1.2432000000000002E+001,
      1.2433000000000003E+001,
      1.2434000000000003E+001,
      1.2435000000000002E+001,
      1.2436000000000002E+001,
      1.2437000000000003E+001,
      1.2438000000000002E+001,
      1.2439000000000002E+001,
      1.2440000000000001E+001,
      1.2441000000000003E+001,
      1.2442000000000002E+001,
      1.2443000000000001E+001,
      1.2444000000000003E+001,
      1.2445000000000002E+001,
      1.2446000000000002E+001,
      1.2447000000000003E+001,
      1.2448000000000002E+001,
      1.2449000000000002E+001,
      1.2450000000000003E+001,
      1.2451000000000002E+001,
      1.2452000000000002E+001,
      1.2453000000000003E+001,
      1.2454000000000002E+001,
      1.2455000000000002E+001,
      1.2456000000000003E+001,
      1.2457000000000003E+001,
      1.2458000000000002E+001,
      1.2459000000000003E+001,
      1.2460000000000003E+001,
      1.2461000000000002E+001,
      1.2462000000000003E+001,
      1.2463000000000003E+001,
      1.2464000000000002E+001,
      1.2465000000000003E+001,
      1.2466000000000003E+001,
      1.2467000000000002E+001,
      1.2468000000000002E+001,
      1.2469000000000003E+001,
      1.2470000000000002E+001,
      1.2471000000000002E+001,
      1.2472000000000001E+001,
      1.2473000000000003E+001,
      1.2474000000000002E+001,
      1.2475000000000001E+001,
      1.2476000000000003E+001,
      1.2477000000000002E+001,
      1.2478000000000002E+001,
      1.2479000000000003E+001,
      1.2480000000000002E+001,
      1.2481000000000002E+001,
      1.2482000000000003E+001,
      1.2483000000000002E+001,
      1.2484000000000002E+001,
      1.2485000000000003E+001,
      1.2486000000000002E+001,
      1.2487000000000002E+001,
      1.2488000000000003E+001,
      1.2489000000000003E+001,
      1.2490000000000002E+001,
      1.2491000000000003E+001,
      1.2492000000000003E+001,
      1.2493000000000002E+001,
      1.2494000000000003E+001,
      1.2495000000000003E+001,
      1.2496000000000002E+001,
      1.2497000000000002E+001,
      1.2498000000000003E+001,
      1.2499000000000002E+001,
      1.2500000000000002E+001,
      1.2501000000000001E+001,
      1.2502000000000002E+001,
      1.2503000000000002E+001,
      1.2504000000000001E+001,
      1.2505000000000003E+001,
      1.2506000000000002E+001,
      1.2507000000000001E+001,
      1.2508000000000003E+001,
      1.2509000000000002E+001,
      1.2510000000000002E+001,
      1.2511000000000003E+001,
      1.2512000000000002E+001,
      1.2513000000000002E+001,
      1.2514000000000003E+001,
      1.2515000000000002E+001,
      1.2516000000000002E+001,
      1.2517000000000003E+001,
      1.2518000000000002E+001,
      1.2519000000000002E+001,
      1.2520000000000003E+001,
      1.2521000000000003E+001,
      1.2522000000000002E+001,
      1.2523000000000003E+001,
      1.2524000000000003E+001,
      1.2525000000000002E+001,
      1.2526000000000003E+001,
      1.2527000000000003E+001,
      1.2528000000000002E+001,
      1.2529000000000002E+001,
      1.2530000000000003E+001,
      1.2531000000000002E+001,
      1.2532000000000002E+001,
      1.2533000000000001E+001,
      1.2534000000000002E+001,
      1.2535000000000002E+001,
      1.2536000000000001E+001,
      1.2537000000000003E+001,
      1.2538000000000002E+001,
      1.2539000000000001E+001,
      1.2540000000000003E+001,
      1.2541000000000002E+001,
      1.2542000000000002E+001,
      1.2543000000000003E+001,
      1.2544000000000002E+001,
      1.2545000000000002E+001,
      1.2546000000000003E+001,
      1.2547000000000002E+001,
      1.2548000000000002E+001,
      1.2549000000000003E+001,
      1.2550000000000002E+001,
      1.2551000000000002E+001,
      1.2552000000000003E+001,
      1.2553000000000003E+001,
      1.2554000000000002E+001,
      1.2555000000000003E+001,
      1.2556000000000003E+001,
      1.2557000000000002E+001,
      1.2558000000000003E+001,
      1.2559000000000003E+001,
      1.2560000000000002E+001,
      1.2561000000000002E+001,
      1.2562000000000003E+001,
      1.2563000000000002E+001,
      1.2564000000000002E+001,
      1.2565000000000001E+001,
      1.2566000000000003E+001,
      1.2567000000000002E+001,
      1.2568000000000001E+001,
      1.2569000000000003E+001,
      1.2570000000000002E+001,
      1.2571000000000002E+001,
      1.2572000000000003E+001,
      1.2573000000000002E+001,
      1.2574000000000002E+001,
      1.2575000000000003E+001,
      1.2576000000000002E+001,
      1.2577000000000002E+001,
      1.2578000000000003E+001,
      1.2579000000000002E+001,
      1.2580000000000002E+001,
      1.2581000000000003E+001,
      1.2582000000000003E+001,
      1.2583000000000002E+001,
      1.2584000000000003E+001,
      1.2585000000000003E+001,
      1.2586000000000002E+001,
      1.2587000000000003E+001,
      1.2588000000000003E+001,
      1.2589000000000002E+001,
      1.2590000000000003E+001,
      1.2591000000000003E+001,
      1.2592000000000002E+001,
      1.2593000000000002E+001,
      1.2594000000000003E+001,
      1.2595000000000002E+001,
      1.2596000000000002E+001,
      1.2597000000000001E+001,
      1.2598000000000003E+001,
      1.2599000000000002E+001,
      1.2600000000000001E+001,
      1.2601000000000003E+001,
      1.2602000000000002E+001,
      1.2603000000000002E+001,
      1.2604000000000003E+001,
      1.2605000000000002E+001,
      1.2606000000000002E+001,
      1.2607000000000003E+001,
      1.2608000000000002E+001,
      1.2609000000000002E+001,
      1.2610000000000003E+001,
      1.2611000000000002E+001,
      1.2612000000000002E+001,
      1.2613000000000003E+001,
      1.2614000000000003E+001,
      1.2615000000000002E+001,
      1.2616000000000003E+001,
      1.2617000000000003E+001,
      1.2618000000000002E+001,
      1.2619000000000003E+001,
      1.2620000000000003E+001,
      1.2621000000000002E+001,
      1.2622000000000002E+001,
      1.2623000000000003E+001,
      1.2624000000000002E+001,
      1.2625000000000002E+001,
      1.2626000000000001E+001,
      1.2627000000000002E+001,
      1.2628000000000002E+001,
      1.2629000000000001E+001,
      1.2630000000000003E+001,
      1.2631000000000002E+001,
      1.2632000000000001E+001,
      1.2633000000000003E+001,
      1.2634000000000002E+001,
      1.2635000000000002E+001,
      1.2636000000000003E+001,
      1.2637000000000002E+001,
      1.2638000000000002E+001,
      1.2639000000000003E+001,
      1.2640000000000002E+001,
      1.2641000000000002E+001,
      1.2642000000000003E+001,
      1.2643000000000002E+001,
      1.2644000000000002E+001,
      1.2645000000000003E+001,
      1.2646000000000003E+001,
      1.2647000000000002E+001,
      1.2648000000000003E+001,
      1.2649000000000003E+001,
      1.2650000000000002E+001,
      1.2651000000000003E+001,
      1.2652000000000003E+001,
      1.2653000000000002E+001,
      1.2654000000000002E+001,
      1.2655000000000003E+001,
      1.2656000000000002E+001,
      1.2657000000000002E+001,
      1.2658000000000001E+001,
      1.2659000000000002E+001,
      1.2660000000000002E+001,
      1.2661000000000001E+001,
      1.2662000000000003E+001,
      1.2663000000000002E+001,
      1.2664000000000001E+001,
      1.2665000000000003E+001,
      1.2666000000000002E+001,
      1.2667000000000002E+001,
      1.2668000000000003E+001,
      1.2669000000000002E+001,
      1.2670000000000002E+001,
      1.2671000000000003E+001,
      1.2672000000000002E+001,
      1.2673000000000002E+001,
      1.2674000000000003E+001,
      1.2675000000000002E+001,
      1.2676000000000002E+001,
      1.2677000000000003E+001,
      1.2678000000000003E+001,
      1.2679000000000002E+001,
      1.2680000000000003E+001,
      1.2681000000000003E+001,
      1.2682000000000002E+001,
      1.2683000000000003E+001,
      1.2684000000000003E+001,
      1.2685000000000002E+001,
      1.2686000000000002E+001,
      1.2687000000000003E+001,
      1.2688000000000002E+001,
      1.2689000000000002E+001,
      1.2690000000000001E+001,
      1.2691000000000003E+001,
      1.2692000000000002E+001,
      1.2693000000000001E+001,
      1.2694000000000003E+001,
      1.2695000000000002E+001,
      1.2696000000000002E+001,
      1.2697000000000003E+001,
      1.2698000000000002E+001,
      1.2699000000000002E+001,
      1.2700000000000003E+001,
      1.2701000000000002E+001,
      1.2702000000000002E+001,
      1.2703000000000003E+001,
      1.2704000000000002E+001,
      1.2705000000000002E+001,
      1.2706000000000003E+001,
      1.2707000000000003E+001,
      1.2708000000000002E+001,
      1.2709000000000003E+001,
      1.2710000000000003E+001,
      1.2711000000000002E+001,
      1.2712000000000003E+001,
      1.2713000000000003E+001,
      1.2714000000000002E+001,
      1.2715000000000003E+001,
      1.2716000000000003E+001,
      1.2717000000000002E+001,
      1.2718000000000002E+001,
      1.2719000000000003E+001,
      1.2720000000000002E+001,
      1.2721000000000002E+001,
      1.2722000000000001E+001,
      1.2723000000000003E+001,
      1.2724000000000002E+001,
      1.2725000000000001E+001,
      1.2726000000000003E+001,
      1.2727000000000002E+001,
      1.2728000000000002E+001,
      1.2729000000000003E+001,
      1.2730000000000002E+001,
      1.2731000000000002E+001,
      1.2732000000000003E+001,
      1.2733000000000002E+001,
      1.2734000000000002E+001,
      1.2735000000000003E+001,
      1.2736000000000002E+001,
      1.2737000000000002E+001,
      1.2738000000000003E+001,
      1.2739000000000003E+001,
      1.2740000000000002E+001,
      1.2741000000000003E+001,
      1.2742000000000003E+001,
      1.2743000000000002E+001,
      1.2744000000000003E+001,
      1.2745000000000003E+001,
      1.2746000000000002E+001,
      1.2747000000000003E+001,
      1.2748000000000003E+001,
      1.2749000000000002E+001,
      1.2750000000000002E+001,
      1.2751000000000001E+001,
      1.2752000000000002E+001,
      1.2753000000000002E+001,
      1.2754000000000001E+001,
      1.2755000000000003E+001,
      1.2756000000000002E+001,
      1.2757000000000001E+001,
      1.2758000000000003E+001,
      1.2759000000000002E+001,
      1.2760000000000002E+001,
      1.2761000000000003E+001,
      1.2762000000000002E+001,
      1.2763000000000002E+001,
      1.2764000000000003E+001,
      1.2765000000000002E+001,
      1.2766000000000002E+001,
      1.2767000000000003E+001,
      1.2768000000000002E+001,
      1.2769000000000002E+001,
      1.2770000000000003E+001,
      1.2771000000000003E+001,
      1.2772000000000002E+001,
      1.2773000000000003E+001,
      1.2774000000000003E+001,
      1.2775000000000002E+001,
      1.2776000000000003E+001,
      1.2777000000000003E+001,
      1.2778000000000002E+001,
      1.2779000000000002E+001,
      1.2780000000000003E+001,
      1.2781000000000002E+001,
      1.2782000000000002E+001,
      1.2783000000000001E+001,
      1.2784000000000002E+001,
      1.2785000000000002E+001,
      1.2786000000000001E+001,
      1.2787000000000003E+001,
      1.2788000000000002E+001,
      1.2789000000000001E+001,
      1.2790000000000003E+001,
      1.2791000000000002E+001,
      1.2792000000000002E+001,
      1.2793000000000003E+001,
      1.2794000000000002E+001,
      1.2795000000000002E+001,
      1.2796000000000003E+001,
      1.2797000000000002E+001,
      1.2798000000000002E+001,
      1.2799000000000003E+001,
      1.2800000000000002E+001,
      1.2801000000000002E+001,
      1.2802000000000003E+001,
      1.2803000000000003E+001,
      1.2804000000000002E+001,
      1.2805000000000003E+001,
      1.2806000000000003E+001,
      1.2807000000000002E+001,
      1.2808000000000003E+001,
      1.2809000000000003E+001,
      1.2810000000000002E+001,
      1.2811000000000002E+001,
      1.2812000000000003E+001,
      1.2813000000000002E+001,
      1.2814000000000002E+001,
      1.2815000000000001E+001,
      1.2816000000000003E+001,
      1.2817000000000002E+001,
      1.2818000000000001E+001,
      1.2819000000000003E+001,
      1.2820000000000002E+001,
      1.2821000000000002E+001,
      1.2822000000000003E+001,
      1.2823000000000002E+001,
      1.2824000000000002E+001,
      1.2825000000000003E+001,
      1.2826000000000002E+001,
      1.2827000000000002E+001,
      1.2828000000000003E+001,
      1.2829000000000002E+001,
      1.2830000000000002E+001,
      1.2831000000000003E+001,
      1.2832000000000003E+001,
      1.2833000000000002E+001,
      1.2834000000000003E+001,
      1.2835000000000003E+001,
      1.2836000000000002E+001,
      1.2837000000000003E+001,
      1.2838000000000003E+001,
      1.2839000000000002E+001,
      1.2840000000000003E+001,
      1.2841000000000003E+001,
      1.2842000000000002E+001,
      1.2843000000000002E+001,
      1.2844000000000003E+001,
      1.2845000000000002E+001,
      1.2846000000000002E+001,
      1.2847000000000001E+001,
      1.2848000000000003E+001,
      1.2849000000000002E+001,
      1.2850000000000001E+001,
      1.2851000000000003E+001,
      1.2852000000000002E+001,
      1.2853000000000002E+001,
      1.2854000000000003E+001,
      1.2855000000000002E+001,
      1.2856000000000002E+001,
      1.2857000000000003E+001,
      1.2858000000000002E+001,
      1.2859000000000002E+001,
      1.2860000000000003E+001,
      1.2861000000000002E+001,
      1.2862000000000002E+001,
      1.2863000000000003E+001,
      1.2864000000000003E+001,
      1.2865000000000002E+001,
      1.2866000000000003E+001,
      1.2867000000000003E+001,
      1.2868000000000002E+001,
      1.2869000000000003E+001,
      1.2870000000000003E+001,
      1.2871000000000002E+001,
      1.2872000000000003E+001,
      1.2873000000000003E+001,
      1.2874000000000002E+001,
      1.2875000000000002E+001,
      1.2876000000000001E+001,
      1.2877000000000002E+001,
      1.2878000000000002E+001,
      1.2879000000000001E+001,
      1.2880000000000003E+001,
      1.2881000000000002E+001,
      1.2882000000000001E+001,
      1.2883000000000003E+001,
      1.2884000000000002E+001,
      1.2885000000000002E+001,
      1.2886000000000003E+001,
      1.2887000000000002E+001,
      1.2888000000000002E+001,
      1.2889000000000003E+001,
      1.2890000000000002E+001,
      1.2891000000000002E+001,
      1.2892000000000003E+001,
      1.2893000000000002E+001,
      1.2894000000000002E+001,
      1.2895000000000003E+001,
      1.2896000000000003E+001,
      1.2897000000000002E+001,
      1.2898000000000003E+001,
      1.2899000000000003E+001,
      1.2900000000000002E+001,
      1.2901000000000003E+001,
      1.2902000000000003E+001,
      1.2903000000000002E+001,
      1.2904000000000002E+001,
      1.2905000000000003E+001,
      1.2906000000000002E+001,
      1.2907000000000002E+001,
      1.2908000000000001E+001,
      1.2909000000000002E+001,
      1.2910000000000002E+001,
      1.2911000000000001E+001,
      1.2912000000000003E+001,
      1.2913000000000002E+001,
      1.2914000000000001E+001,
      1.2915000000000003E+001,
      1.2916000000000002E+001,
      1.2917000000000002E+001,
      1.2918000000000003E+001,
      1.2919000000000002E+001,
      1.2920000000000002E+001,
      1.2921000000000003E+001,
      1.2922000000000002E+001,
      1.2923000000000002E+001,
      1.2924000000000003E+001,
      1.2925000000000002E+001,
      1.2926000000000002E+001,
      1.2927000000000003E+001,
      1.2928000000000003E+001,
      1.2929000000000002E+001,
      1.2930000000000003E+001,
      1.2931000000000003E+001,
      1.2932000000000002E+001,
      1.2933000000000003E+001,
      1.2934000000000003E+001,
      1.2935000000000002E+001,
      1.2936000000000002E+001,
      1.2937000000000003E+001,
      1.2938000000000002E+001,
      1.2939000000000002E+001,
      1.2940000000000001E+001,
      1.2941000000000003E+001,
      1.2942000000000002E+001,
      1.2943000000000001E+001,
      1.2944000000000003E+001,
      1.2945000000000002E+001,
      1.2946000000000002E+001,
      1.2947000000000003E+001,
      1.2948000000000002E+001,
      1.2949000000000002E+001,
      1.2950000000000003E+001,
      1.2951000000000002E+001,
      1.2952000000000002E+001,
      1.2953000000000003E+001,
      1.2954000000000002E+001,
      1.2955000000000002E+001,
      1.2956000000000003E+001,
      1.2957000000000003E+001,
      1.2958000000000002E+001,
      1.2959000000000003E+001,
      1.2960000000000003E+001,
      1.2961000000000002E+001,
      1.2962000000000003E+001,
      1.2963000000000003E+001,
      1.2964000000000002E+001,
      1.2965000000000003E+001,
      1.2966000000000003E+001,
      1.2967000000000002E+001,
      1.2968000000000002E+001,
      1.2969000000000003E+001,
      1.2970000000000002E+001,
      1.2971000000000002E+001,
      1.2972000000000001E+001,
      1.2973000000000003E+001,
      1.2974000000000002E+001,
      1.2975000000000001E+001,
      1.2976000000000003E+001,
      1.2977000000000002E+001,
      1.2978000000000002E+001,
      1.2979000000000003E+001,
      1.2980000000000002E+001,
      1.2981000000000002E+001,
      1.2982000000000003E+001,
      1.2983000000000002E+001,
      1.2984000000000002E+001,
      1.2985000000000003E+001,
      1.2986000000000002E+001,
      1.2987000000000002E+001,
      1.2988000000000003E+001,
      1.2989000000000003E+001,
      1.2990000000000002E+001,
      1.2991000000000003E+001,
      1.2992000000000003E+001,
      1.2993000000000002E+001,
      1.2994000000000003E+001,
      1.2995000000000003E+001,
      1.2996000000000002E+001,
      1.2997000000000003E+001,
      1.2998000000000003E+001,
      1.2999000000000002E+001,
      1.3000000000000002E+001,
      1.3001000000000003E+001,
      1.3002000000000002E+001,
      1.3003000000000002E+001,
      1.3004000000000001E+001,
      1.3005000000000003E+001,
      1.3006000000000002E+001,
      1.3007000000000001E+001,
      1.3008000000000003E+001,
      1.3009000000000002E+001,
      1.3010000000000002E+001,
      1.3011000000000003E+001,
      1.3012000000000002E+001,
      1.3013000000000002E+001,
      1.3014000000000003E+001,
      1.3015000000000002E+001,
      1.3016000000000002E+001,
      1.3017000000000003E+001,
      1.3018000000000002E+001,
      1.3019000000000002E+001,
      1.3020000000000003E+001,
      1.3021000000000003E+001,
      1.3022000000000002E+001,
      1.3023000000000003E+001,
      1.3024000000000003E+001,
      1.3025000000000002E+001,
      1.3026000000000003E+001,
      1.3027000000000003E+001,
      1.3028000000000002E+001,
      1.3029000000000002E+001,
      1.3030000000000003E+001,
      1.3031000000000002E+001,
      1.3032000000000002E+001,
      1.3033000000000001E+001,
      1.3034000000000002E+001,
      1.3035000000000002E+001,
      1.3036000000000001E+001,
      1.3037000000000003E+001,
      1.3038000000000002E+001,
      1.3039000000000001E+001,
      1.3040000000000003E+001,
      1.3041000000000002E+001,
      1.3042000000000002E+001,
      1.3043000000000003E+001,
      1.3044000000000002E+001,
      1.3045000000000002E+001,
      1.3046000000000003E+001,
      1.3047000000000002E+001,
      1.3048000000000002E+001,
      1.3049000000000003E+001,
      1.3050000000000002E+001,
      1.3051000000000002E+001,
      1.3052000000000003E+001,
      1.3053000000000003E+001,
      1.3054000000000002E+001,
      1.3055000000000003E+001,
      1.3056000000000003E+001,
      1.3057000000000002E+001,
      1.3058000000000003E+001,
      1.3059000000000003E+001,
      1.3060000000000002E+001,
      1.3061000000000002E+001,
      1.3062000000000003E+001,
      1.3063000000000002E+001,
      1.3064000000000002E+001,
      1.3065000000000001E+001,
      1.3066000000000003E+001,
      1.3067000000000002E+001,
      1.3068000000000001E+001,
      1.3069000000000003E+001,
      1.3070000000000002E+001,
      1.3071000000000002E+001,
      1.3072000000000003E+001,
      1.3073000000000002E+001,
      1.3074000000000002E+001,
      1.3075000000000003E+001,
      1.3076000000000002E+001,
      1.3077000000000002E+001,
      1.3078000000000003E+001,
      1.3079000000000002E+001,
      1.3080000000000002E+001,
      1.3081000000000003E+001,
      1.3082000000000003E+001,
      1.3083000000000002E+001,
      1.3084000000000003E+001,
      1.3085000000000003E+001,
      1.3086000000000002E+001,
      1.3087000000000003E+001,
      1.3088000000000003E+001,
      1.3089000000000002E+001,
      1.3090000000000003E+001,
      1.3091000000000003E+001,
      1.3092000000000002E+001,
      1.3093000000000002E+001,
      1.3094000000000003E+001,
      1.3095000000000002E+001,
      1.3096000000000002E+001,
      1.3097000000000001E+001,
      1.3098000000000003E+001,
      1.3099000000000002E+001,
      1.3100000000000001E+001,
      1.3101000000000003E+001,
      1.3102000000000002E+001,
      1.3103000000000002E+001,
      1.3104000000000003E+001,
      1.3105000000000002E+001,
      1.3106000000000002E+001,
      1.3107000000000003E+001,
      1.3108000000000002E+001,
      1.3109000000000002E+001,
      1.3110000000000003E+001,
      1.3111000000000002E+001,
      1.3112000000000002E+001,
      1.3113000000000003E+001,
      1.3114000000000003E+001,
      1.3115000000000002E+001,
      1.3116000000000003E+001,
      1.3117000000000003E+001,
      1.3118000000000002E+001,
      1.3119000000000003E+001,
      1.3120000000000003E+001,
      1.3121000000000002E+001,
      1.3122000000000003E+001,
      1.3123000000000003E+001,
      1.3124000000000002E+001,
      1.3125000000000002E+001,
      1.3126000000000003E+001,
      1.3127000000000002E+001,
      1.3128000000000002E+001,
      1.3129000000000001E+001,
      1.3130000000000003E+001,
      1.3131000000000002E+001,
      1.3132000000000001E+001,
      1.3133000000000003E+001,
      1.3134000000000002E+001,
      1.3135000000000002E+001,
      1.3136000000000003E+001,
      1.3137000000000002E+001,
      1.3138000000000002E+001,
      1.3139000000000003E+001,
      1.3140000000000002E+001,
      1.3141000000000002E+001,
      1.3142000000000003E+001,
      1.3143000000000002E+001,
      1.3144000000000002E+001,
      1.3145000000000003E+001,
      1.3146000000000003E+001,
      1.3147000000000002E+001,
      1.3148000000000003E+001,
      1.3149000000000003E+001,
      1.3150000000000002E+001,
      1.3151000000000003E+001,
      1.3152000000000003E+001,
      1.3153000000000002E+001,
      1.3154000000000002E+001,
      1.3155000000000003E+001,
      1.3156000000000002E+001,
      1.3157000000000002E+001,
      1.3158000000000001E+001,
      1.3159000000000002E+001,
      1.3160000000000002E+001,
      1.3161000000000001E+001,
      1.3162000000000003E+001,
      1.3163000000000002E+001,
      1.3164000000000001E+001,
      1.3165000000000003E+001,
      1.3166000000000002E+001,
      1.3167000000000002E+001,
      1.3168000000000003E+001,
      1.3169000000000002E+001,
      1.3170000000000002E+001,
      1.3171000000000003E+001,
      1.3172000000000002E+001,
      1.3173000000000002E+001,
      1.3174000000000003E+001,
      1.3175000000000002E+001,
      1.3176000000000002E+001,
      1.3177000000000003E+001,
      1.3178000000000003E+001,
      1.3179000000000002E+001,
      1.3180000000000003E+001,
      1.3181000000000003E+001,
      1.3182000000000002E+001,
      1.3183000000000003E+001,
      1.3184000000000003E+001,
      1.3185000000000002E+001,
      1.3186000000000002E+001,
      1.3187000000000003E+001,
      1.3188000000000002E+001,
      1.3189000000000002E+001,
      1.3190000000000001E+001,
      1.3191000000000003E+001,
      1.3192000000000002E+001,
      1.3193000000000001E+001,
      1.3194000000000003E+001,
      1.3195000000000002E+001,
      1.3196000000000002E+001,
      1.3197000000000003E+001,
      1.3198000000000002E+001,
      1.3199000000000002E+001,
      1.3200000000000003E+001,
      1.3201000000000002E+001,
      1.3202000000000002E+001,
      1.3203000000000003E+001,
      1.3204000000000002E+001,
      1.3205000000000002E+001,
      1.3206000000000003E+001,
      1.3207000000000003E+001,
      1.3208000000000002E+001,
      1.3209000000000003E+001,
      1.3210000000000003E+001,
      1.3211000000000002E+001,
      1.3212000000000003E+001,
      1.3213000000000003E+001,
      1.3214000000000002E+001,
      1.3215000000000003E+001,
      1.3216000000000003E+001,
      1.3217000000000002E+001,
      1.3218000000000002E+001,
      1.3219000000000003E+001,
      1.3220000000000002E+001,
      1.3221000000000002E+001,
      1.3222000000000001E+001,
      1.3223000000000003E+001,
      1.3224000000000002E+001,
      1.3225000000000001E+001,
      1.3226000000000003E+001,
      1.3227000000000002E+001,
      1.3228000000000002E+001,
      1.3229000000000003E+001,
      1.3230000000000002E+001,
      1.3231000000000002E+001,
      1.3232000000000003E+001,
      1.3233000000000002E+001,
      1.3234000000000002E+001,
      1.3235000000000003E+001,
      1.3236000000000002E+001,
      1.3237000000000002E+001,
      1.3238000000000003E+001,
      1.3239000000000003E+001,
      1.3240000000000002E+001,
      1.3241000000000003E+001,
      1.3242000000000003E+001,
      1.3243000000000002E+001,
      1.3244000000000003E+001,
      1.3245000000000003E+001,
      1.3246000000000002E+001,
      1.3247000000000003E+001,
      1.3248000000000003E+001,
      1.3249000000000002E+001,
      1.3250000000000002E+001,
      1.3251000000000003E+001,
      1.3252000000000002E+001,
      1.3253000000000002E+001,
      1.3254000000000001E+001,
      1.3255000000000003E+001,
      1.3256000000000002E+001,
      1.3257000000000001E+001,
      1.3258000000000003E+001,
      1.3259000000000002E+001,
      1.3260000000000002E+001,
      1.3261000000000003E+001,
      1.3262000000000002E+001,
      1.3263000000000002E+001,
      1.3264000000000003E+001,
      1.3265000000000002E+001,
      1.3266000000000002E+001,
      1.3267000000000003E+001,
      1.3268000000000002E+001,
      1.3269000000000002E+001,
      1.3270000000000003E+001,
      1.3271000000000003E+001,
      1.3272000000000002E+001,
      1.3273000000000003E+001,
      1.3274000000000003E+001,
      1.3275000000000002E+001,
      1.3276000000000003E+001,
      1.3277000000000003E+001,
      1.3278000000000002E+001,
      1.3279000000000002E+001,
      1.3280000000000003E+001,
      1.3281000000000002E+001,
      1.3282000000000002E+001,
      1.3283000000000001E+001,
      1.3284000000000002E+001,
      1.3285000000000002E+001,
      1.3286000000000001E+001,
      1.3287000000000003E+001,
      1.3288000000000002E+001,
      1.3289000000000001E+001,
      1.3290000000000003E+001,
      1.3291000000000002E+001,
      1.3292000000000002E+001,
      1.3293000000000003E+001,
      1.3294000000000002E+001,
      1.3295000000000002E+001,
      1.3296000000000003E+001,
      1.3297000000000002E+001,
      1.3298000000000002E+001,
      1.3299000000000003E+001,
      1.3300000000000002E+001,
      1.3301000000000002E+001,
      1.3302000000000003E+001,
      1.3303000000000003E+001,
      1.3304000000000002E+001,
      1.3305000000000003E+001,
      1.3306000000000003E+001,
      1.3307000000000002E+001,
      1.3308000000000003E+001,
      1.3309000000000003E+001,
      1.3310000000000002E+001,
      1.3311000000000002E+001,
      1.3312000000000003E+001,
      1.3313000000000002E+001,
      1.3314000000000002E+001,
      1.3315000000000001E+001,
      1.3316000000000003E+001,
      1.3317000000000002E+001,
      1.3318000000000001E+001,
      1.3319000000000003E+001,
      1.3320000000000002E+001,
      1.3321000000000002E+001,
      1.3322000000000003E+001,
      1.3323000000000002E+001,
      1.3324000000000002E+001,
      1.3325000000000003E+001,
      1.3326000000000002E+001,
      1.3327000000000002E+001,
      1.3328000000000003E+001,
      1.3329000000000002E+001,
      1.3330000000000002E+001,
      1.3331000000000003E+001,
      1.3332000000000003E+001,
      1.3333000000000002E+001,
      1.3334000000000003E+001,
      1.3335000000000003E+001,
      1.3336000000000002E+001,
      1.3337000000000003E+001,
      1.3338000000000003E+001,
      1.3339000000000002E+001,
      1.3340000000000003E+001,
      1.3341000000000003E+001,
      1.3342000000000002E+001,
      1.3343000000000002E+001,
      1.3344000000000003E+001,
      1.3345000000000002E+001,
      1.3346000000000002E+001,
      1.3347000000000001E+001,
      1.3348000000000003E+001,
      1.3349000000000002E+001,
      1.3350000000000001E+001,
      1.3351000000000003E+001,
      1.3352000000000002E+001,
      1.3353000000000002E+001,
      1.3354000000000003E+001,
      1.3355000000000002E+001,
      1.3356000000000002E+001,
      1.3357000000000003E+001,
      1.3358000000000002E+001,
      1.3359000000000002E+001,
      1.3360000000000003E+001,
      1.3361000000000002E+001,
      1.3362000000000002E+001,
      1.3363000000000003E+001,
      1.3364000000000003E+001,
      1.3365000000000002E+001,
      1.3366000000000003E+001,
      1.3367000000000003E+001,
      1.3368000000000002E+001,
      1.3369000000000003E+001,
      1.3370000000000003E+001,
      1.3371000000000002E+001,
      1.3372000000000003E+001,
      1.3373000000000003E+001,
      1.3374000000000002E+001,
      1.3375000000000002E+001,
      1.3376000000000003E+001,
      1.3377000000000002E+001,
      1.3378000000000002E+001,
      1.3379000000000001E+001,
      1.3380000000000003E+001,
      1.3381000000000002E+001,
      1.3382000000000001E+001,
      1.3383000000000003E+001,
      1.3384000000000002E+001,
      1.3385000000000002E+001,
      1.3386000000000003E+001,
      1.3387000000000002E+001,
      1.3388000000000002E+001,
      1.3389000000000003E+001,
      1.3390000000000002E+001,
      1.3391000000000002E+001,
      1.3392000000000003E+001,
      1.3393000000000002E+001,
      1.3394000000000002E+001,
      1.3395000000000003E+001,
      1.3396000000000003E+001,
      1.3397000000000002E+001,
      1.3398000000000003E+001,
      1.3399000000000003E+001,
      1.3400000000000002E+001,
      1.3401000000000003E+001,
      1.3402000000000003E+001,
      1.3403000000000002E+001,
      1.3404000000000002E+001,
      1.3405000000000003E+001,
      1.3406000000000002E+001,
      1.3407000000000002E+001,
      1.3408000000000001E+001,
      1.3409000000000002E+001,
      1.3410000000000002E+001,
      1.3411000000000001E+001,
      1.3412000000000003E+001,
      1.3413000000000002E+001,
      1.3414000000000001E+001,
      1.3415000000000003E+001,
      1.3416000000000002E+001,
      1.3417000000000002E+001,
      1.3418000000000003E+001,
      1.3419000000000002E+001,
      1.3420000000000002E+001,
      1.3421000000000003E+001,
      1.3422000000000002E+001,
      1.3423000000000002E+001,
      1.3424000000000003E+001,
      1.3425000000000002E+001,
      1.3426000000000002E+001,
      1.3427000000000003E+001,
      1.3428000000000003E+001,
      1.3429000000000002E+001,
      1.3430000000000003E+001,
      1.3431000000000003E+001,
      1.3432000000000002E+001,
      1.3433000000000003E+001,
      1.3434000000000003E+001,
      1.3435000000000002E+001,
      1.3436000000000002E+001,
      1.3437000000000003E+001,
      1.3438000000000002E+001,
      1.3439000000000002E+001,
      1.3440000000000001E+001,
      1.3441000000000003E+001,
      1.3442000000000002E+001,
      1.3443000000000001E+001,
      1.3444000000000003E+001,
      1.3445000000000002E+001,
      1.3446000000000002E+001,
      1.3447000000000003E+001,
      1.3448000000000002E+001,
      1.3449000000000002E+001,
      1.3450000000000003E+001,
      1.3451000000000002E+001,
      1.3452000000000002E+001,
      1.3453000000000003E+001,
      1.3454000000000002E+001,
      1.3455000000000002E+001,
      1.3456000000000003E+001,
      1.3457000000000003E+001,
      1.3458000000000002E+001,
      1.3459000000000003E+001,
      1.3460000000000003E+001,
      1.3461000000000002E+001,
      1.3462000000000003E+001,
      1.3463000000000003E+001,
      1.3464000000000002E+001,
      1.3465000000000003E+001,
      1.3466000000000003E+001,
      1.3467000000000002E+001,
      1.3468000000000002E+001,
      1.3469000000000003E+001,
      1.3470000000000002E+001,
      1.3471000000000002E+001,
      1.3472000000000001E+001,
      1.3473000000000003E+001,
      1.3474000000000002E+001,
      1.3475000000000001E+001,
      1.3476000000000003E+001,
      1.3477000000000002E+001,
      1.3478000000000002E+001,
      1.3479000000000003E+001,
      1.3480000000000002E+001,
      1.3481000000000002E+001,
      1.3482000000000003E+001,
      1.3483000000000002E+001,
      1.3484000000000002E+001,
      1.3485000000000003E+001,
      1.3486000000000002E+001,
      1.3487000000000002E+001,
      1.3488000000000003E+001,
      1.3489000000000003E+001,
      1.3490000000000002E+001,
      1.3491000000000003E+001,
      1.3492000000000003E+001,
      1.3493000000000002E+001,
      1.3494000000000003E+001,
      1.3495000000000003E+001,
      1.3496000000000002E+001,
      1.3497000000000003E+001,
      1.3498000000000003E+001,
      1.3499000000000002E+001,
      1.3500000000000002E+001,
      1.3501000000000003E+001,
      1.3502000000000002E+001,
      1.3503000000000002E+001,
      1.3504000000000001E+001,
      1.3505000000000003E+001,
      1.3506000000000002E+001,
      1.3507000000000001E+001,
      1.3508000000000003E+001,
      1.3509000000000002E+001,
      1.3510000000000002E+001,
      1.3511000000000003E+001,
      1.3512000000000002E+001,
      1.3513000000000002E+001,
      1.3514000000000003E+001,
      1.3515000000000002E+001,
      1.3516000000000002E+001,
      1.3517000000000003E+001,
      1.3518000000000002E+001,
      1.3519000000000002E+001,
      1.3520000000000003E+001,
      1.3521000000000003E+001,
      1.3522000000000002E+001,
      1.3523000000000003E+001,
      1.3524000000000003E+001,
      1.3525000000000002E+001,
      1.3526000000000003E+001,
      1.3527000000000003E+001,
      1.3528000000000002E+001,
      1.3529000000000002E+001,
      1.3530000000000003E+001,
      1.3531000000000002E+001,
      1.3532000000000002E+001,
      1.3533000000000001E+001,
      1.3534000000000002E+001,
      1.3535000000000002E+001,
      1.3536000000000001E+001,
      1.3537000000000003E+001,
      1.3538000000000002E+001,
      1.3539000000000001E+001,
      1.3540000000000003E+001,
      1.3541000000000002E+001,
      1.3542000000000002E+001,
      1.3543000000000003E+001,
      1.3544000000000002E+001,
      1.3545000000000002E+001,
      1.3546000000000003E+001,
      1.3547000000000002E+001,
      1.3548000000000002E+001,
      1.3549000000000003E+001,
      1.3550000000000002E+001,
      1.3551000000000002E+001,
      1.3552000000000003E+001,
      1.3553000000000003E+001,
      1.3554000000000002E+001,
      1.3555000000000003E+001,
      1.3556000000000003E+001,
      1.3557000000000002E+001,
      1.3558000000000003E+001,
      1.3559000000000003E+001,
      1.3560000000000002E+001,
      1.3561000000000002E+001,
      1.3562000000000003E+001,
      1.3563000000000002E+001,
      1.3564000000000002E+001,
      1.3565000000000003E+001,
      1.3566000000000003E+001,
      1.3567000000000002E+001,
      1.3568000000000001E+001,
      1.3569000000000003E+001,
      1.3570000000000002E+001,
      1.3571000000000002E+001,
      1.3572000000000003E+001,
      1.3573000000000002E+001,
      1.3574000000000002E+001,
      1.3575000000000003E+001,
      1.3576000000000002E+001,
      1.3577000000000002E+001,
      1.3578000000000003E+001,
      1.3579000000000002E+001,
      1.3580000000000002E+001,
      1.3581000000000003E+001,
      1.3582000000000003E+001,
      1.3583000000000002E+001,
      1.3584000000000003E+001,
      1.3585000000000003E+001,
      1.3586000000000002E+001,
      1.3587000000000003E+001,
      1.3588000000000003E+001,
      1.3589000000000002E+001,
      1.3590000000000002E+001,
      1.3591000000000003E+001,
      1.3592000000000002E+001,
      1.3593000000000002E+001,
      1.3594000000000003E+001,
      1.3595000000000002E+001,
      1.3596000000000002E+001,
      1.3597000000000003E+001,
      1.3598000000000003E+001,
      1.3599000000000002E+001,
      1.3600000000000001E+001,
      1.3601000000000003E+001,
      1.3602000000000002E+001,
      1.3603000000000002E+001,
      1.3604000000000003E+001,
      1.3605000000000002E+001,
      1.3606000000000002E+001,
      1.3607000000000003E+001,
      1.3608000000000002E+001,
      1.3609000000000002E+001,
      1.3610000000000003E+001,
      1.3611000000000002E+001,
      1.3612000000000002E+001,
      1.3613000000000003E+001,
      1.3614000000000003E+001,
      1.3615000000000002E+001,
      1.3616000000000003E+001,
      1.3617000000000003E+001,
      1.3618000000000002E+001,
      1.3619000000000003E+001,
      1.3620000000000003E+001,
      1.3621000000000002E+001,
      1.3622000000000002E+001,
      1.3623000000000003E+001,
      1.3624000000000002E+001,
      1.3625000000000002E+001,
      1.3626000000000003E+001,
      1.3627000000000002E+001,
      1.3628000000000002E+001,
      1.3629000000000003E+001,
      1.3630000000000003E+001,
      1.3631000000000002E+001,
      1.3632000000000001E+001,
      1.3633000000000003E+001,
      1.3634000000000002E+001,
      1.3635000000000002E+001,
      1.3636000000000003E+001,
      1.3637000000000002E+001,
      1.3638000000000002E+001,
      1.3639000000000003E+001,
      1.3640000000000002E+001,
      1.3641000000000002E+001,
      1.3642000000000003E+001,
      1.3643000000000002E+001,
      1.3644000000000002E+001,
      1.3645000000000003E+001,
      1.3646000000000003E+001,
      1.3647000000000002E+001,
      1.3648000000000003E+001,
      1.3649000000000003E+001,
      1.3650000000000002E+001,
      1.3651000000000002E+001,
      1.3652000000000003E+001,
      1.3653000000000002E+001,
      1.3654000000000002E+001,
      1.3655000000000003E+001,
      1.3656000000000002E+001,
      1.3657000000000002E+001,
      1.3658000000000003E+001,
      1.3659000000000002E+001,
      1.3660000000000002E+001,
      1.3661000000000001E+001,
      1.3662000000000003E+001,
      1.3663000000000002E+001,
      1.3664000000000001E+001,
      1.3665000000000003E+001,
      1.3666000000000002E+001,
      1.3667000000000002E+001,
      1.3668000000000003E+001,
      1.3669000000000002E+001,
      1.3670000000000002E+001,
      1.3671000000000003E+001,
      1.3672000000000002E+001,
      1.3673000000000002E+001,
      1.3674000000000003E+001,
      1.3675000000000002E+001,
      1.3676000000000002E+001,
      1.3677000000000003E+001,
      1.3678000000000003E+001,
      1.3679000000000002E+001,
      1.3680000000000003E+001,
      1.3681000000000003E+001,
      1.3682000000000002E+001,
      1.3683000000000002E+001,
      1.3684000000000003E+001,
      1.3685000000000002E+001,
      1.3686000000000002E+001,
      1.3687000000000003E+001,
      1.3688000000000002E+001,
      1.3689000000000002E+001,
      1.3690000000000003E+001,
      1.3691000000000003E+001,
      1.3692000000000002E+001,
      1.3693000000000001E+001,
      1.3694000000000003E+001,
      1.3695000000000002E+001,
      1.3696000000000002E+001,
      1.3697000000000003E+001,
      1.3698000000000002E+001,
      1.3699000000000002E+001,
      1.3700000000000003E+001,
      1.3701000000000002E+001,
      1.3702000000000002E+001,
      1.3703000000000003E+001,
      1.3704000000000002E+001,
      1.3705000000000002E+001,
      1.3706000000000003E+001,
      1.3707000000000003E+001,
      1.3708000000000002E+001,
      1.3709000000000003E+001,
      1.3710000000000003E+001,
      1.3711000000000002E+001,
      1.3712000000000003E+001,
      1.3713000000000003E+001,
      1.3714000000000002E+001,
      1.3715000000000002E+001,
      1.3716000000000003E+001,
      1.3717000000000002E+001,
      1.3718000000000002E+001,
      1.3719000000000003E+001,
      1.3720000000000002E+001,
      1.3721000000000002E+001,
      1.3722000000000003E+001,
      1.3723000000000003E+001,
      1.3724000000000002E+001,
      1.3725000000000001E+001,
      1.3726000000000003E+001,
      1.3727000000000002E+001,
      1.3728000000000002E+001,
      1.3729000000000003E+001,
      1.3730000000000002E+001,
      1.3731000000000002E+001,
      1.3732000000000003E+001,
      1.3733000000000002E+001,
      1.3734000000000002E+001,
      1.3735000000000003E+001,
      1.3736000000000002E+001,
      1.3737000000000002E+001,
      1.3738000000000003E+001,
      1.3739000000000003E+001,
      1.3740000000000002E+001,
      1.3741000000000003E+001,
      1.3742000000000003E+001,
      1.3743000000000002E+001,
      1.3744000000000003E+001,
      1.3745000000000003E+001,
      1.3746000000000002E+001,
      1.3747000000000002E+001,
      1.3748000000000003E+001,
      1.3749000000000002E+001,
      1.3750000000000002E+001,
      1.3751000000000003E+001,
      1.3752000000000002E+001,
      1.3753000000000002E+001,
      1.3754000000000003E+001,
      1.3755000000000003E+001,
      1.3756000000000002E+001,
      1.3757000000000001E+001,
      1.3758000000000003E+001,
      1.3759000000000002E+001,
      1.3760000000000002E+001,
      1.3761000000000003E+001,
      1.3762000000000002E+001,
      1.3763000000000002E+001,
      1.3764000000000003E+001,
      1.3765000000000002E+001,
      1.3766000000000002E+001,
      1.3767000000000003E+001,
      1.3768000000000002E+001,
      1.3769000000000002E+001,
      1.3770000000000003E+001,
      1.3771000000000003E+001,
      1.3772000000000002E+001,
      1.3773000000000003E+001,
      1.3774000000000003E+001,
      1.3775000000000002E+001,
      1.3776000000000002E+001,
      1.3777000000000003E+001,
      1.3778000000000002E+001,
      1.3779000000000002E+001,
      1.3780000000000003E+001,
      1.3781000000000002E+001,
      1.3782000000000002E+001,
      1.3783000000000003E+001,
      1.3784000000000002E+001,
      1.3785000000000002E+001,
      1.3786000000000001E+001,
      1.3787000000000003E+001,
      1.3788000000000002E+001,
      1.3789000000000001E+001,
      1.3790000000000003E+001,
      1.3791000000000002E+001,
      1.3792000000000002E+001,
      1.3793000000000003E+001,
      1.3794000000000002E+001,
      1.3795000000000002E+001,
      1.3796000000000003E+001,
      1.3797000000000002E+001,
      1.3798000000000002E+001,
      1.3799000000000003E+001,
      1.3800000000000002E+001,
      1.3801000000000002E+001,
      1.3802000000000003E+001,
      1.3803000000000003E+001,
      1.3804000000000002E+001,
      1.3805000000000003E+001,
      1.3806000000000003E+001,
      1.3807000000000002E+001,
      1.3808000000000002E+001,
      1.3809000000000003E+001,
      1.3810000000000002E+001,
      1.3811000000000002E+001,
      1.3812000000000003E+001,
      1.3813000000000002E+001,
      1.3814000000000002E+001,
      1.3815000000000003E+001,
      1.3816000000000003E+001,
      1.3817000000000002E+001,
      1.3818000000000001E+001,
      1.3819000000000003E+001,
      1.3820000000000002E+001,
      1.3821000000000002E+001,
      1.3822000000000003E+001,
      1.3823000000000002E+001,
      1.3824000000000002E+001,
      1.3825000000000003E+001,
      1.3826000000000002E+001,
      1.3827000000000002E+001,
      1.3828000000000003E+001,
      1.3829000000000002E+001,
      1.3830000000000002E+001,
      1.3831000000000003E+001,
      1.3832000000000003E+001,
      1.3833000000000002E+001,
      1.3834000000000003E+001,
      1.3835000000000003E+001,
      1.3836000000000002E+001,
      1.3837000000000003E+001,
      1.3838000000000003E+001,
      1.3839000000000002E+001,
      1.3840000000000002E+001,
      1.3841000000000003E+001,
      1.3842000000000002E+001,
      1.3843000000000002E+001,
      1.3844000000000003E+001,
      1.3845000000000002E+001,
      1.3846000000000002E+001,
      1.3847000000000003E+001,
      1.3848000000000003E+001,
      1.3849000000000002E+001,
      1.3850000000000001E+001,
      1.3851000000000003E+001,
      1.3852000000000002E+001,
      1.3853000000000002E+001,
      1.3854000000000003E+001,
      1.3855000000000002E+001,
      1.3856000000000002E+001,
      1.3857000000000003E+001,
      1.3858000000000002E+001,
      1.3859000000000002E+001,
      1.3860000000000003E+001,
      1.3861000000000002E+001,
      1.3862000000000002E+001,
      1.3863000000000003E+001,
      1.3864000000000003E+001,
      1.3865000000000002E+001,
      1.3866000000000003E+001,
      1.3867000000000003E+001,
      1.3868000000000002E+001,
      1.3869000000000003E+001,
      1.3870000000000003E+001,
      1.3871000000000002E+001,
      1.3872000000000002E+001,
      1.3873000000000003E+001,
      1.3874000000000002E+001,
      1.3875000000000002E+001,
      1.3876000000000003E+001,
      1.3877000000000002E+001,
      1.3878000000000002E+001,
      1.3879000000000003E+001,
      1.3880000000000003E+001,
      1.3881000000000002E+001,
      1.3882000000000001E+001,
      1.3883000000000003E+001,
      1.3884000000000002E+001,
      1.3885000000000002E+001,
      1.3886000000000003E+001,
      1.3887000000000002E+001,
      1.3888000000000002E+001,
      1.3889000000000003E+001,
      1.3890000000000002E+001,
      1.3891000000000002E+001,
      1.3892000000000003E+001,
      1.3893000000000002E+001,
      1.3894000000000002E+001,
      1.3895000000000003E+001,
      1.3896000000000003E+001,
      1.3897000000000002E+001,
      1.3898000000000003E+001,
      1.3899000000000003E+001,
      1.3900000000000002E+001,
      1.3901000000000002E+001,
      1.3902000000000003E+001,
      1.3903000000000002E+001,
      1.3904000000000002E+001,
      1.3905000000000003E+001,
      1.3906000000000002E+001,
      1.3907000000000002E+001,
      1.3908000000000003E+001,
      1.3909000000000002E+001,
      1.3910000000000002E+001,
      1.3911000000000001E+001,
      1.3912000000000003E+001,
      1.3913000000000002E+001,
      1.3914000000000001E+001,
      1.3915000000000003E+001,
      1.3916000000000002E+001,
      1.3917000000000002E+001,
      1.3918000000000003E+001,
      1.3919000000000002E+001,
      1.3920000000000002E+001,
      1.3921000000000003E+001,
      1.3922000000000002E+001,
      1.3923000000000002E+001,
      1.3924000000000003E+001,
      1.3925000000000002E+001,
      1.3926000000000002E+001,
      1.3927000000000003E+001,
      1.3928000000000003E+001,
      1.3929000000000002E+001,
      1.3930000000000003E+001,
      1.3931000000000003E+001,
      1.3932000000000002E+001,
      1.3933000000000002E+001,
      1.3934000000000003E+001,
      1.3935000000000002E+001,
      1.3936000000000002E+001,
      1.3937000000000003E+001,
      1.3938000000000002E+001,
      1.3939000000000002E+001,
      1.3940000000000003E+001,
      1.3941000000000003E+001,
      1.3942000000000002E+001,
      1.3943000000000001E+001,
      1.3944000000000003E+001,
      1.3945000000000002E+001,
      1.3946000000000002E+001,
      1.3947000000000003E+001,
      1.3948000000000002E+001,
      1.3949000000000002E+001,
      1.3950000000000003E+001,
      1.3951000000000002E+001,
      1.3952000000000002E+001,
      1.3953000000000003E+001,
      1.3954000000000002E+001,
      1.3955000000000002E+001,
      1.3956000000000003E+001,
      1.3957000000000003E+001,
      1.3958000000000002E+001,
      1.3959000000000003E+001,
      1.3960000000000003E+001,
      1.3961000000000002E+001,
      1.3962000000000003E+001,
      1.3963000000000003E+001,
      1.3964000000000002E+001,
      1.3965000000000002E+001,
      1.3966000000000003E+001,
      1.3967000000000002E+001,
      1.3968000000000002E+001,
      1.3969000000000003E+001,
      1.3970000000000002E+001,
      1.3971000000000002E+001,
      1.3972000000000003E+001,
      1.3973000000000003E+001,
      1.3974000000000002E+001,
      1.3975000000000001E+001,
      1.3976000000000003E+001,
      1.3977000000000002E+001,
      1.3978000000000002E+001,
      1.3979000000000003E+001,
      1.3980000000000002E+001,
      1.3981000000000002E+001,
      1.3982000000000003E+001,
      1.3983000000000002E+001,
      1.3984000000000002E+001,
      1.3985000000000003E+001,
      1.3986000000000002E+001,
      1.3987000000000002E+001,
      1.3988000000000003E+001,
      1.3989000000000003E+001,
      1.3990000000000002E+001,
      1.3991000000000003E+001,
      1.3992000000000003E+001,
      1.3993000000000002E+001,
      1.3994000000000003E+001,
      1.3995000000000003E+001,
      1.3996000000000002E+001,
      1.3997000000000002E+001,
      1.3998000000000003E+001,
      1.3999000000000002E+001,
      1.4000000000000002E+001,
      1.4001000000000003E+001,
      1.4002000000000002E+001,
      1.4003000000000002E+001,
      1.4004000000000003E+001,
      1.4005000000000003E+001,
      1.4006000000000002E+001,
      1.4007000000000001E+001,
      1.4008000000000003E+001,
      1.4009000000000002E+001,
      1.4010000000000002E+001,
      1.4011000000000003E+001,
      1.4012000000000002E+001,
      1.4013000000000002E+001,
      1.4014000000000003E+001,
      1.4015000000000002E+001,
      1.4016000000000002E+001,
      1.4017000000000003E+001,
      1.4018000000000002E+001,
      1.4019000000000002E+001,
      1.4020000000000003E+001,
      1.4021000000000003E+001,
      1.4022000000000002E+001,
      1.4023000000000003E+001,
      1.4024000000000003E+001,
      1.4025000000000002E+001,
      1.4026000000000003E+001,
      1.4027000000000003E+001,
      1.4028000000000002E+001,
      1.4029000000000002E+001,
      1.4030000000000003E+001,
      1.4031000000000002E+001,
      1.4032000000000002E+001,
      1.4033000000000003E+001,
      1.4034000000000002E+001,
      1.4035000000000002E+001,
      1.4036000000000001E+001,
      1.4037000000000003E+001,
      1.4038000000000002E+001,
      1.4039000000000001E+001,
      1.4040000000000003E+001,
      1.4041000000000002E+001,
      1.4042000000000002E+001,
      1.4043000000000003E+001,
      1.4044000000000002E+001,
      1.4045000000000002E+001,
      1.4046000000000003E+001,
      1.4047000000000002E+001,
      1.4048000000000002E+001,
      1.4049000000000003E+001,
      1.4050000000000002E+001,
      1.4051000000000002E+001,
      1.4052000000000003E+001,
      1.4053000000000003E+001,
      1.4054000000000002E+001,
      1.4055000000000003E+001,
      1.4056000000000003E+001,
      1.4057000000000002E+001,
      1.4058000000000002E+001,
      1.4059000000000003E+001,
      1.4060000000000002E+001,
      1.4061000000000002E+001,
      1.4062000000000003E+001,
      1.4063000000000002E+001,
      1.4064000000000002E+001,
      1.4065000000000003E+001,
      1.4066000000000003E+001,
      1.4067000000000002E+001,
      1.4068000000000001E+001,
      1.4069000000000003E+001,
      1.4070000000000002E+001,
      1.4071000000000002E+001,
      1.4072000000000003E+001,
      1.4073000000000002E+001,
      1.4074000000000002E+001,
      1.4075000000000003E+001,
      1.4076000000000002E+001,
      1.4077000000000002E+001,
      1.4078000000000003E+001,
      1.4079000000000002E+001,
      1.4080000000000002E+001,
      1.4081000000000003E+001,
      1.4082000000000003E+001,
      1.4083000000000002E+001,
      1.4084000000000003E+001,
      1.4085000000000003E+001,
      1.4086000000000002E+001,
      1.4087000000000003E+001,
      1.4088000000000003E+001,
      1.4089000000000002E+001,
      1.4090000000000002E+001,
      1.4091000000000003E+001,
      1.4092000000000002E+001,
      1.4093000000000002E+001,
      1.4094000000000003E+001,
      1.4095000000000002E+001,
      1.4096000000000002E+001,
      1.4097000000000003E+001,
      1.4098000000000003E+001,
      1.4099000000000002E+001,
      1.4100000000000001E+001,
      1.4101000000000003E+001,
      1.4102000000000002E+001,
      1.4103000000000002E+001,
      1.4104000000000003E+001,
      1.4105000000000002E+001,
      1.4106000000000002E+001,
      1.4107000000000003E+001,
      1.4108000000000002E+001,
      1.4109000000000002E+001,
      1.4110000000000003E+001,
      1.4111000000000002E+001,
      1.4112000000000002E+001,
      1.4113000000000003E+001,
      1.4114000000000003E+001,
      1.4115000000000002E+001,
      1.4116000000000003E+001,
      1.4117000000000003E+001,
      1.4118000000000002E+001,
      1.4119000000000003E+001,
      1.4120000000000003E+001,
      1.4121000000000002E+001,
      1.4122000000000002E+001,
      1.4123000000000003E+001,
      1.4124000000000002E+001,
      1.4125000000000002E+001,
      1.4126000000000003E+001,
      1.4127000000000002E+001,
      1.4128000000000002E+001,
      1.4129000000000003E+001,
      1.4130000000000003E+001,
      1.4131000000000002E+001,
      1.4132000000000001E+001,
      1.4133000000000003E+001,
      1.4134000000000002E+001,
      1.4135000000000002E+001,
      1.4136000000000003E+001,
      1.4137000000000002E+001,
      1.4138000000000002E+001,
      1.4139000000000003E+001,
      1.4140000000000002E+001,
      1.4141000000000002E+001,
      1.4142000000000003E+001,
      1.4143000000000002E+001,
      1.4144000000000002E+001,
      1.4145000000000003E+001,
      1.4146000000000003E+001,
      1.4147000000000002E+001,
      1.4148000000000003E+001,
      1.4149000000000003E+001,
      1.4150000000000002E+001,
      1.4151000000000003E+001,
      1.4152000000000003E+001,
      1.4153000000000002E+001,
      1.4154000000000002E+001,
      1.4155000000000003E+001,
      1.4156000000000002E+001,
      1.4157000000000002E+001,
      1.4158000000000003E+001,
      1.4159000000000002E+001,
      1.4160000000000002E+001,
      1.4161000000000001E+001,
      1.4162000000000003E+001,
      1.4163000000000002E+001,
      1.4164000000000001E+001,
      1.4165000000000003E+001,
      1.4166000000000002E+001,
      1.4167000000000002E+001,
      1.4168000000000003E+001,
      1.4169000000000002E+001,
      1.4170000000000002E+001,
      1.4171000000000003E+001,
      1.4172000000000002E+001,
      1.4173000000000002E+001,
      1.4174000000000003E+001,
      1.4175000000000002E+001,
      1.4176000000000002E+001,
      1.4177000000000003E+001,
      1.4178000000000003E+001,
      1.4179000000000002E+001,
      1.4180000000000003E+001,
      1.4181000000000003E+001,
      1.4182000000000002E+001,
      1.4183000000000002E+001,
      1.4184000000000003E+001,
      1.4185000000000002E+001,
      1.4186000000000002E+001,
      1.4187000000000003E+001,
      1.4188000000000002E+001,
      1.4189000000000002E+001,
      1.4190000000000003E+001,
      1.4191000000000003E+001,
      1.4192000000000002E+001,
      1.4193000000000001E+001,
      1.4194000000000003E+001,
      1.4195000000000002E+001,
      1.4196000000000002E+001,
      1.4197000000000003E+001,
      1.4198000000000002E+001,
      1.4199000000000002E+001,
      1.4200000000000003E+001,
      1.4201000000000002E+001,
      1.4202000000000002E+001,
      1.4203000000000003E+001,
      1.4204000000000002E+001,
      1.4205000000000002E+001,
      1.4206000000000003E+001,
      1.4207000000000003E+001,
      1.4208000000000002E+001,
      1.4209000000000003E+001,
      1.4210000000000003E+001,
      1.4211000000000002E+001,
      1.4212000000000003E+001,
      1.4213000000000003E+001,
      1.4214000000000002E+001,
      1.4215000000000002E+001,
      1.4216000000000003E+001,
      1.4217000000000002E+001,
      1.4218000000000002E+001,
      1.4219000000000003E+001,
      1.4220000000000002E+001,
      1.4221000000000002E+001,
      1.4222000000000003E+001,
      1.4223000000000003E+001,
      1.4224000000000002E+001,
      1.4225000000000001E+001,
      1.4226000000000003E+001,
      1.4227000000000002E+001,
      1.4228000000000002E+001,
      1.4229000000000003E+001,
      1.4230000000000002E+001,
      1.4231000000000002E+001,
      1.4232000000000003E+001,
      1.4233000000000002E+001,
      1.4234000000000002E+001,
      1.4235000000000003E+001,
      1.4236000000000002E+001,
      1.4237000000000002E+001,
      1.4238000000000003E+001,
      1.4239000000000003E+001,
      1.4240000000000002E+001,
      1.4241000000000003E+001,
      1.4242000000000003E+001,
      1.4243000000000002E+001,
      1.4244000000000003E+001,
      1.4245000000000003E+001,
      1.4246000000000002E+001,
      1.4247000000000002E+001,
      1.4248000000000003E+001,
      1.4249000000000002E+001,
      1.4250000000000002E+001,
      1.4251000000000003E+001,
      1.4252000000000002E+001,
      1.4253000000000002E+001,
      1.4254000000000003E+001,
      1.4255000000000003E+001,
      1.4256000000000002E+001,
      1.4257000000000001E+001,
      1.4258000000000003E+001,
      1.4259000000000002E+001,
      1.4260000000000002E+001,
      1.4261000000000003E+001,
      1.4262000000000002E+001,
      1.4263000000000002E+001,
      1.4264000000000003E+001,
      1.4265000000000002E+001,
      1.4266000000000002E+001,
      1.4267000000000003E+001,
      1.4268000000000002E+001,
      1.4269000000000002E+001,
      1.4270000000000003E+001,
      1.4271000000000003E+001,
      1.4272000000000002E+001,
      1.4273000000000003E+001,
      1.4274000000000003E+001,
      1.4275000000000002E+001,
      1.4276000000000003E+001,
      1.4277000000000003E+001,
      1.4278000000000002E+001,
      1.4279000000000002E+001,
      1.4280000000000003E+001,
      1.4281000000000002E+001,
      1.4282000000000002E+001,
      1.4283000000000003E+001,
      1.4284000000000002E+001,
      1.4285000000000002E+001,
      1.4286000000000001E+001,
      1.4287000000000003E+001,
      1.4288000000000002E+001,
      1.4289000000000001E+001,
      1.4290000000000003E+001,
      1.4291000000000002E+001,
      1.4292000000000002E+001,
      1.4293000000000003E+001,
      1.4294000000000002E+001,
      1.4295000000000002E+001,
      1.4296000000000003E+001,
      1.4297000000000002E+001,
      1.4298000000000002E+001,
      1.4299000000000003E+001,
      1.4300000000000002E+001,
      1.4301000000000002E+001,
      1.4302000000000003E+001,
      1.4303000000000003E+001,
      1.4304000000000002E+001,
      1.4305000000000003E+001,
      1.4306000000000003E+001,
      1.4307000000000002E+001,
      1.4308000000000002E+001,
      1.4309000000000003E+001,
      1.4310000000000002E+001,
      1.4311000000000002E+001,
      1.4312000000000003E+001,
      1.4313000000000002E+001,
      1.4314000000000002E+001,
      1.4315000000000003E+001,
      1.4316000000000003E+001,
      1.4317000000000002E+001,
      1.4318000000000001E+001,
      1.4319000000000003E+001,
      1.4320000000000002E+001,
      1.4321000000000002E+001,
      1.4322000000000003E+001,
      1.4323000000000002E+001,
      1.4324000000000002E+001,
      1.4325000000000003E+001,
      1.4326000000000002E+001,
      1.4327000000000002E+001,
      1.4328000000000003E+001,
      1.4329000000000002E+001,
      1.4330000000000002E+001,
      1.4331000000000003E+001,
      1.4332000000000003E+001,
      1.4333000000000002E+001,
      1.4334000000000003E+001,
      1.4335000000000003E+001,
      1.4336000000000002E+001,
      1.4337000000000003E+001,
      1.4338000000000003E+001,
      1.4339000000000002E+001,
      1.4340000000000002E+001,
      1.4341000000000003E+001,
      1.4342000000000002E+001,
      1.4343000000000002E+001,
      1.4344000000000003E+001,
      1.4345000000000002E+001,
      1.4346000000000002E+001,
      1.4347000000000003E+001,
      1.4348000000000003E+001,
      1.4349000000000002E+001,
      1.4350000000000001E+001,
      1.4351000000000003E+001,
      1.4352000000000002E+001,
      1.4353000000000002E+001,
      1.4354000000000003E+001,
      1.4355000000000002E+001,
      1.4356000000000002E+001,
      1.4357000000000003E+001,
      1.4358000000000002E+001,
      1.4359000000000002E+001,
      1.4360000000000003E+001,
      1.4361000000000002E+001,
      1.4362000000000002E+001,
      1.4363000000000003E+001,
      1.4364000000000003E+001,
      1.4365000000000002E+001,
      1.4366000000000003E+001,
      1.4367000000000003E+001,
      1.4368000000000002E+001,
      1.4369000000000003E+001,
      1.4370000000000003E+001,
      1.4371000000000002E+001,
      1.4372000000000002E+001,
      1.4373000000000003E+001,
      1.4374000000000002E+001,
      1.4375000000000002E+001,
      1.4376000000000003E+001,
      1.4377000000000002E+001,
      1.4378000000000002E+001,
      1.4379000000000003E+001,
      1.4380000000000003E+001,
      1.4381000000000002E+001,
      1.4382000000000001E+001,
      1.4383000000000003E+001,
      1.4384000000000002E+001,
      1.4385000000000002E+001,
      1.4386000000000003E+001,
      1.4387000000000002E+001,
      1.4388000000000002E+001,
      1.4389000000000003E+001,
      1.4390000000000002E+001,
      1.4391000000000002E+001,
      1.4392000000000003E+001,
      1.4393000000000002E+001,
      1.4394000000000002E+001,
      1.4395000000000003E+001,
      1.4396000000000003E+001,
      1.4397000000000002E+001,
      1.4398000000000003E+001,
      1.4399000000000003E+001,
      1.4400000000000002E+001,
      1.4401000000000003E+001,
      1.4402000000000003E+001,
      1.4403000000000002E+001,
      1.4404000000000002E+001,
      1.4405000000000003E+001,
      1.4406000000000002E+001,
      1.4407000000000002E+001,
      1.4408000000000003E+001,
      1.4409000000000002E+001,
      1.4410000000000002E+001,
      1.4411000000000001E+001,
      1.4412000000000003E+001,
      1.4413000000000002E+001,
      1.4414000000000001E+001,
      1.4415000000000003E+001,
      1.4416000000000002E+001,
      1.4417000000000002E+001,
      1.4418000000000003E+001,
      1.4419000000000002E+001,
      1.4420000000000002E+001,
      1.4421000000000003E+001,
      1.4422000000000002E+001,
      1.4423000000000002E+001,
      1.4424000000000003E+001,
      1.4425000000000002E+001,
      1.4426000000000002E+001,
      1.4427000000000003E+001,
      1.4428000000000003E+001,
      1.4429000000000002E+001,
      1.4430000000000003E+001,
      1.4431000000000003E+001,
      1.4432000000000002E+001,
      1.4433000000000002E+001,
      1.4434000000000003E+001,
      1.4435000000000002E+001,
      1.4436000000000002E+001,
      1.4437000000000003E+001,
      1.4438000000000002E+001,
      1.4439000000000002E+001,
      1.4440000000000003E+001,
      1.4441000000000003E+001,
      1.4442000000000002E+001,
      1.4443000000000001E+001,
      1.4444000000000003E+001,
      1.4445000000000002E+001,
      1.4446000000000002E+001,
      1.4447000000000003E+001,
      1.4448000000000002E+001,
      1.4449000000000002E+001,
      1.4450000000000003E+001,
      1.4451000000000002E+001,
      1.4452000000000002E+001,
      1.4453000000000003E+001,
      1.4454000000000002E+001,
      1.4455000000000002E+001,
      1.4456000000000003E+001,
      1.4457000000000003E+001,
      1.4458000000000002E+001,
      1.4459000000000003E+001,
      1.4460000000000003E+001,
      1.4461000000000002E+001,
      1.4462000000000003E+001,
      1.4463000000000003E+001,
      1.4464000000000002E+001,
      1.4465000000000002E+001,
      1.4466000000000003E+001,
      1.4467000000000002E+001,
      1.4468000000000002E+001,
      1.4469000000000003E+001,
      1.4470000000000002E+001,
      1.4471000000000002E+001,
      1.4472000000000003E+001,
      1.4473000000000003E+001,
      1.4474000000000002E+001,
      1.4475000000000001E+001,
      1.4476000000000003E+001,
      1.4477000000000002E+001,
      1.4478000000000002E+001,
      1.4479000000000003E+001,
      1.4480000000000002E+001,
      1.4481000000000002E+001,
      1.4482000000000003E+001,
      1.4483000000000002E+001,
      1.4484000000000002E+001,
      1.4485000000000003E+001,
      1.4486000000000002E+001,
      1.4487000000000002E+001,
      1.4488000000000003E+001,
      1.4489000000000003E+001,
      1.4490000000000002E+001,
      1.4491000000000003E+001,
      1.4492000000000003E+001,
      1.4493000000000002E+001,
      1.4494000000000003E+001,
      1.4495000000000003E+001,
      1.4496000000000002E+001,
      1.4497000000000002E+001,
      1.4498000000000003E+001,
      1.4499000000000002E+001,
      1.4500000000000002E+001,
      1.4501000000000003E+001,
      1.4502000000000002E+001,
      1.4503000000000002E+001,
      1.4504000000000003E+001,
      1.4505000000000003E+001,
      1.4506000000000002E+001,
      1.4507000000000001E+001,
      1.4508000000000003E+001,
      1.4509000000000002E+001,
      1.4510000000000002E+001,
      1.4511000000000003E+001,
      1.4512000000000002E+001,
      1.4513000000000002E+001,
      1.4514000000000003E+001,
      1.4515000000000002E+001,
      1.4516000000000002E+001,
      1.4517000000000003E+001,
      1.4518000000000002E+001,
      1.4519000000000002E+001,
      1.4520000000000003E+001,
      1.4521000000000003E+001,
      1.4522000000000002E+001,
      1.4523000000000003E+001,
      1.4524000000000003E+001,
      1.4525000000000002E+001,
      1.4526000000000003E+001,
      1.4527000000000003E+001,
      1.4528000000000002E+001,
      1.4529000000000002E+001,
      1.4530000000000003E+001,
      1.4531000000000002E+001,
      1.4532000000000002E+001,
      1.4533000000000003E+001,
      1.4534000000000002E+001,
      1.4535000000000002E+001,
      1.4536000000000003E+001,
      1.4537000000000003E+001,
      1.4538000000000002E+001,
      1.4539000000000001E+001,
      1.4540000000000003E+001,
      1.4541000000000002E+001,
      1.4542000000000002E+001,
      1.4543000000000003E+001,
      1.4544000000000002E+001,
      1.4545000000000002E+001,
      1.4546000000000003E+001,
      1.4547000000000002E+001,
      1.4548000000000002E+001,
      1.4549000000000003E+001,
      1.4550000000000002E+001,
      1.4551000000000002E+001,
      1.4552000000000003E+001,
      1.4553000000000003E+001,
      1.4554000000000002E+001,
      1.4555000000000003E+001,
      1.4556000000000003E+001,
      1.4557000000000002E+001,
      1.4558000000000002E+001,
      1.4559000000000003E+001,
      1.4560000000000002E+001,
      1.4561000000000002E+001,
      1.4562000000000003E+001,
      1.4563000000000002E+001,
      1.4564000000000002E+001,
      1.4565000000000003E+001,
      1.4566000000000003E+001,
      1.4567000000000002E+001,
      1.4568000000000003E+001,
      1.4569000000000003E+001,
      1.4570000000000002E+001,
      1.4571000000000002E+001,
      1.4572000000000003E+001,
      1.4573000000000002E+001,
      1.4574000000000002E+001,
      1.4575000000000003E+001,
      1.4576000000000002E+001,
      1.4577000000000002E+001,
      1.4578000000000003E+001,
      1.4579000000000002E+001,
      1.4580000000000002E+001,
      1.4581000000000003E+001,
      1.4582000000000003E+001,
      1.4583000000000002E+001,
      1.4584000000000003E+001,
      1.4585000000000003E+001,
      1.4586000000000002E+001,
      1.4587000000000003E+001,
      1.4588000000000003E+001,
      1.4589000000000002E+001,
      1.4590000000000002E+001,
      1.4591000000000003E+001,
      1.4592000000000002E+001,
      1.4593000000000002E+001,
      1.4594000000000003E+001,
      1.4595000000000002E+001,
      1.4596000000000002E+001,
      1.4597000000000003E+001,
      1.4598000000000003E+001,
      1.4599000000000002E+001,
      1.4600000000000003E+001,
      1.4601000000000003E+001,
      1.4602000000000002E+001,
      1.4603000000000002E+001,
      1.4604000000000003E+001,
      1.4605000000000002E+001,
      1.4606000000000002E+001,
      1.4607000000000003E+001,
      1.4608000000000002E+001,
      1.4609000000000002E+001,
      1.4610000000000003E+001,
      1.4611000000000002E+001,
      1.4612000000000002E+001,
      1.4613000000000003E+001,
      1.4614000000000003E+001,
      1.4615000000000002E+001,
      1.4616000000000003E+001,
      1.4617000000000003E+001,
      1.4618000000000002E+001,
      1.4619000000000002E+001,
      1.4620000000000003E+001,
      1.4621000000000002E+001,
      1.4622000000000002E+001,
      1.4623000000000003E+001,
      1.4624000000000002E+001,
      1.4625000000000002E+001,
      1.4626000000000003E+001,
      1.4627000000000002E+001,
      1.4628000000000002E+001,
      1.4629000000000003E+001,
      1.4630000000000003E+001,
      1.4631000000000002E+001,
      1.4632000000000001E+001,
      1.4633000000000003E+001,
      1.4634000000000002E+001,
      1.4635000000000002E+001,
      1.4636000000000003E+001,
      1.4637000000000002E+001,
      1.4638000000000002E+001,
      1.4639000000000003E+001,
      1.4640000000000002E+001,
      1.4641000000000002E+001,
      1.4642000000000003E+001,
      1.4643000000000002E+001,
      1.4644000000000002E+001,
      1.4645000000000003E+001,
      1.4646000000000003E+001,
      1.4647000000000002E+001,
      1.4648000000000003E+001,
      1.4649000000000003E+001,
      1.4650000000000002E+001,
      1.4651000000000002E+001,
      1.4652000000000003E+001,
      1.4653000000000002E+001,
      1.4654000000000002E+001,
      1.4655000000000003E+001,
      1.4656000000000002E+001,
      1.4657000000000002E+001,
      1.4658000000000003E+001,
      1.4659000000000002E+001,
      1.4660000000000002E+001,
      1.4661000000000003E+001,
      1.4662000000000003E+001,
      1.4663000000000002E+001,
      1.4664000000000001E+001,
      1.4665000000000003E+001,
      1.4666000000000002E+001,
      1.4667000000000002E+001,
      1.4668000000000003E+001,
      1.4669000000000002E+001,
      1.4670000000000002E+001,
      1.4671000000000003E+001,
      1.4672000000000002E+001,
      1.4673000000000002E+001,
      1.4674000000000003E+001,
      1.4675000000000002E+001,
      1.4676000000000002E+001,
      1.4677000000000003E+001,
      1.4678000000000003E+001,
      1.4679000000000002E+001,
      1.4680000000000003E+001,
      1.4681000000000003E+001,
      1.4682000000000002E+001,
      1.4683000000000002E+001,
      1.4684000000000003E+001,
      1.4685000000000002E+001,
      1.4686000000000002E+001,
      1.4687000000000003E+001,
      1.4688000000000002E+001,
      1.4689000000000002E+001,
      1.4690000000000003E+001,
      1.4691000000000003E+001,
      1.4692000000000002E+001,
      1.4693000000000003E+001,
      1.4694000000000003E+001,
      1.4695000000000002E+001,
      1.4696000000000002E+001,
      1.4697000000000003E+001,
      1.4698000000000002E+001,
      1.4699000000000002E+001,
      1.4700000000000003E+001,
      1.4701000000000002E+001,
      1.4702000000000002E+001,
      1.4703000000000003E+001,
      1.4704000000000002E+001,
      1.4705000000000002E+001,
      1.4706000000000003E+001,
      1.4707000000000003E+001,
      1.4708000000000002E+001,
      1.4709000000000003E+001,
      1.4710000000000003E+001,
      1.4711000000000002E+001,
      1.4712000000000003E+001,
      1.4713000000000003E+001,
      1.4714000000000002E+001,
      1.4715000000000002E+001,
      1.4716000000000003E+001,
      1.4717000000000002E+001,
      1.4718000000000002E+001,
      1.4719000000000003E+001,
      1.4720000000000002E+001,
      1.4721000000000002E+001,
      1.4722000000000003E+001,
      1.4723000000000003E+001,
      1.4724000000000002E+001,
      1.4725000000000003E+001,
      1.4726000000000003E+001,
      1.4727000000000002E+001,
      1.4728000000000002E+001,
      1.4729000000000003E+001,
      1.4730000000000002E+001,
      1.4731000000000002E+001,
      1.4732000000000003E+001,
      1.4733000000000002E+001,
      1.4734000000000002E+001,
      1.4735000000000003E+001,
      1.4736000000000002E+001,
      1.4737000000000002E+001,
      1.4738000000000003E+001,
      1.4739000000000003E+001,
      1.4740000000000002E+001,
      1.4741000000000003E+001,
      1.4742000000000003E+001,
      1.4743000000000002E+001,
      1.4744000000000002E+001,
      1.4745000000000003E+001,
      1.4746000000000002E+001,
      1.4747000000000002E+001,
      1.4748000000000003E+001,
      1.4749000000000002E+001,
      1.4750000000000002E+001,
      1.4751000000000003E+001,
      1.4752000000000002E+001,
      1.4753000000000002E+001,
      1.4754000000000003E+001,
      1.4755000000000003E+001,
      1.4756000000000002E+001,
      1.4757000000000001E+001,
      1.4758000000000003E+001,
      1.4759000000000002E+001,
      1.4760000000000002E+001,
      1.4761000000000003E+001,
      1.4762000000000002E+001,
      1.4763000000000002E+001,
      1.4764000000000003E+001,
      1.4765000000000002E+001,
      1.4766000000000002E+001,
      1.4767000000000003E+001,
      1.4768000000000002E+001,
      1.4769000000000002E+001,
      1.4770000000000003E+001,
      1.4771000000000003E+001,
      1.4772000000000002E+001,
      1.4773000000000003E+001,
      1.4774000000000003E+001,
      1.4775000000000002E+001,
      1.4776000000000002E+001,
      1.4777000000000003E+001,
      1.4778000000000002E+001,
      1.4779000000000002E+001,
      1.4780000000000003E+001,
      1.4781000000000002E+001,
      1.4782000000000002E+001,
      1.4783000000000003E+001,
      1.4784000000000002E+001,
      1.4785000000000002E+001,
      1.4786000000000003E+001,
      1.4787000000000003E+001,
      1.4788000000000002E+001,
      1.4789000000000001E+001,
      1.4790000000000003E+001,
      1.4791000000000002E+001,
      1.4792000000000002E+001,
      1.4793000000000003E+001,
      1.4794000000000002E+001,
      1.4795000000000002E+001,
      1.4796000000000003E+001,
      1.4797000000000002E+001,
      1.4798000000000002E+001,
      1.4799000000000003E+001,
      1.4800000000000002E+001,
      1.4801000000000002E+001,
      1.4802000000000003E+001,
      1.4803000000000003E+001,
      1.4804000000000002E+001,
      1.4805000000000003E+001,
      1.4806000000000003E+001,
      1.4807000000000002E+001,
      1.4808000000000002E+001,
      1.4809000000000003E+001,
      1.4810000000000002E+001,
      1.4811000000000002E+001,
      1.4812000000000003E+001,
      1.4813000000000002E+001,
      1.4814000000000002E+001,
      1.4815000000000003E+001,
      1.4816000000000003E+001,
      1.4817000000000002E+001,
      1.4818000000000003E+001,
      1.4819000000000003E+001,
      1.4820000000000002E+001,
      1.4821000000000002E+001,
      1.4822000000000003E+001,
      1.4823000000000002E+001,
      1.4824000000000002E+001,
      1.4825000000000003E+001,
      1.4826000000000002E+001,
      1.4827000000000002E+001,
      1.4828000000000003E+001,
      1.4829000000000002E+001,
      1.4830000000000002E+001,
      1.4831000000000003E+001,
      1.4832000000000003E+001,
      1.4833000000000002E+001,
      1.4834000000000003E+001,
      1.4835000000000003E+001,
      1.4836000000000002E+001,
      1.4837000000000003E+001,
      1.4838000000000003E+001,
      1.4839000000000002E+001,
      1.4840000000000002E+001,
      1.4841000000000003E+001,
      1.4842000000000002E+001,
      1.4843000000000002E+001,
      1.4844000000000003E+001,
      1.4845000000000002E+001,
      1.4846000000000002E+001,
      1.4847000000000003E+001,
      1.4848000000000003E+001,
      1.4849000000000002E+001,
      1.4850000000000003E+001,
      1.4851000000000003E+001,
      1.4852000000000002E+001,
      1.4853000000000002E+001,
      1.4854000000000003E+001,
      1.4855000000000002E+001,
      1.4856000000000002E+001,
      1.4857000000000003E+001,
      1.4858000000000002E+001,
      1.4859000000000002E+001,
      1.4860000000000003E+001,
      1.4861000000000002E+001,
      1.4862000000000002E+001,
      1.4863000000000003E+001,
      1.4864000000000003E+001,
      1.4865000000000002E+001,
      1.4866000000000003E+001,
      1.4867000000000003E+001,
      1.4868000000000002E+001,
      1.4869000000000002E+001,
      1.4870000000000003E+001,
      1.4871000000000002E+001,
      1.4872000000000002E+001,
      1.4873000000000003E+001,
      1.4874000000000002E+001,
      1.4875000000000002E+001,
      1.4876000000000003E+001,
      1.4877000000000002E+001,
      1.4878000000000002E+001,
      1.4879000000000003E+001,
      1.4880000000000003E+001,
      1.4881000000000002E+001,
      1.4882000000000001E+001,
      1.4883000000000003E+001,
      1.4884000000000002E+001,
      1.4885000000000002E+001,
      1.4886000000000003E+001,
      1.4887000000000002E+001,
      1.4888000000000002E+001,
      1.4889000000000003E+001,
      1.4890000000000002E+001,
      1.4891000000000002E+001,
      1.4892000000000003E+001,
      1.4893000000000002E+001,
      1.4894000000000002E+001,
      1.4895000000000003E+001,
      1.4896000000000003E+001,
      1.4897000000000002E+001,
      1.4898000000000003E+001,
      1.4899000000000003E+001,
      1.4900000000000002E+001,
      1.4901000000000002E+001,
      1.4902000000000003E+001,
      1.4903000000000002E+001,
      1.4904000000000002E+001,
      1.4905000000000003E+001,
      1.4906000000000002E+001,
      1.4907000000000002E+001,
      1.4908000000000003E+001,
      1.4909000000000002E+001,
      1.4910000000000002E+001,
      1.4911000000000003E+001,
      1.4912000000000003E+001,
      1.4913000000000002E+001,
      1.4914000000000001E+001,
      1.4915000000000003E+001,
      1.4916000000000002E+001,
      1.4917000000000002E+001,
      1.4918000000000003E+001,
      1.4919000000000002E+001,
      1.4920000000000002E+001,
      1.4921000000000003E+001,
      1.4922000000000002E+001,
      1.4923000000000002E+001,
      1.4924000000000003E+001,
      1.4925000000000002E+001,
      1.4926000000000002E+001,
      1.4927000000000003E+001,
      1.4928000000000003E+001,
      1.4929000000000002E+001,
      1.4930000000000003E+001,
      1.4931000000000003E+001,
      1.4932000000000002E+001,
      1.4933000000000002E+001,
      1.4934000000000003E+001,
      1.4935000000000002E+001,
      1.4936000000000002E+001,
      1.4937000000000003E+001,
      1.4938000000000002E+001,
      1.4939000000000002E+001,
      1.4940000000000003E+001,
      1.4941000000000003E+001,
      1.4942000000000002E+001,
      1.4943000000000003E+001,
      1.4944000000000003E+001,
      1.4945000000000002E+001,
      1.4946000000000002E+001,
      1.4947000000000003E+001,
      1.4948000000000002E+001,
      1.4949000000000002E+001,
      1.4950000000000003E+001,
      1.4951000000000002E+001,
      1.4952000000000002E+001,
      1.4953000000000003E+001,
      1.4954000000000002E+001,
      1.4955000000000002E+001,
      1.4956000000000003E+001,
      1.4957000000000003E+001,
      1.4958000000000002E+001,
      1.4959000000000003E+001,
      1.4960000000000003E+001,
      1.4961000000000002E+001,
      1.4962000000000003E+001,
      1.4963000000000003E+001,
      1.4964000000000002E+001,
      1.4965000000000002E+001,
      1.4966000000000003E+001,
      1.4967000000000002E+001,
      1.4968000000000002E+001,
      1.4969000000000003E+001,
      1.4970000000000002E+001,
      1.4971000000000002E+001,
      1.4972000000000003E+001,
      1.4973000000000003E+001,
      1.4974000000000002E+001,
      1.4975000000000003E+001,
      1.4976000000000003E+001,
      1.4977000000000002E+001,
      1.4978000000000002E+001,
      1.4979000000000003E+001,
      1.4980000000000002E+001,
      1.4981000000000002E+001,
      1.4982000000000003E+001,
      1.4983000000000002E+001,
      1.4984000000000002E+001,
      1.4985000000000003E+001,
      1.4986000000000002E+001,
      1.4987000000000002E+001,
      1.4988000000000003E+001,
      1.4989000000000003E+001,
      1.4990000000000002E+001,
      1.4991000000000003E+001,
      1.4992000000000003E+001,
      1.4993000000000002E+001,
      1.4994000000000002E+001,
      1.4995000000000003E+001,
      1.4996000000000002E+001,
      1.4997000000000002E+001,
      1.4998000000000003E+001,
      1.4999000000000002E+001,
      1.5000000000000002E+001,
      1.5001000000000003E+001,
      1.5002000000000002E+001,
      1.5003000000000002E+001,
      1.5004000000000003E+001,
      1.5005000000000003E+001,
      1.5006000000000002E+001,
      1.5007000000000001E+001,
      1.5008000000000003E+001,
      1.5009000000000002E+001,
      1.5010000000000002E+001,
      1.5011000000000003E+001,
      1.5012000000000002E+001,
      1.5013000000000002E+001,
      1.5014000000000003E+001,
      1.5015000000000002E+001,
      1.5016000000000002E+001,
      1.5017000000000003E+001,
      1.5018000000000002E+001,
      1.5019000000000002E+001,
      1.5020000000000003E+001,
      1.5021000000000003E+001,
      1.5022000000000002E+001,
      1.5023000000000003E+001,
      1.5024000000000003E+001,
      1.5025000000000002E+001,
      1.5026000000000002E+001,
      1.5027000000000003E+001,
      1.5028000000000002E+001,
      1.5029000000000002E+001,
      1.5030000000000003E+001,
      1.5031000000000002E+001,
      1.5032000000000002E+001,
      1.5033000000000003E+001,
      1.5034000000000002E+001,
      1.5035000000000002E+001,
      1.5036000000000003E+001,
      1.5037000000000003E+001,
      1.5038000000000002E+001,
      1.5039000000000001E+001,
      1.5040000000000003E+001,
      1.5041000000000002E+001,
      1.5042000000000002E+001,
      1.5043000000000003E+001,
      1.5044000000000002E+001,
      1.5045000000000002E+001,
      1.5046000000000003E+001,
      1.5047000000000002E+001,
      1.5048000000000002E+001,
      1.5049000000000003E+001,
      1.5050000000000002E+001,
      1.5051000000000002E+001,
      1.5052000000000003E+001,
      1.5053000000000003E+001,
      1.5054000000000002E+001,
      1.5055000000000003E+001,
      1.5056000000000003E+001,
      1.5057000000000002E+001,
      1.5058000000000002E+001,
      1.5059000000000003E+001,
      1.5060000000000002E+001,
      1.5061000000000002E+001,
      1.5062000000000003E+001,
      1.5063000000000002E+001,
      1.5064000000000002E+001,
      1.5065000000000003E+001,
      1.5066000000000003E+001,
      1.5067000000000002E+001,
      1.5068000000000003E+001,
      1.5069000000000003E+001,
      1.5070000000000002E+001,
      1.5071000000000002E+001,
      1.5072000000000003E+001,
      1.5073000000000002E+001,
      1.5074000000000002E+001,
      1.5075000000000003E+001,
      1.5076000000000002E+001,
      1.5077000000000002E+001,
      1.5078000000000003E+001,
      1.5079000000000002E+001,
      1.5080000000000002E+001,
      1.5081000000000003E+001,
      1.5082000000000003E+001,
      1.5083000000000002E+001,
      1.5084000000000003E+001,
      1.5085000000000003E+001,
      1.5086000000000002E+001,
      1.5087000000000002E+001,
      1.5088000000000003E+001,
      1.5089000000000002E+001,
      1.5090000000000002E+001,
      1.5091000000000003E+001,
      1.5092000000000002E+001,
      1.5093000000000002E+001,
      1.5094000000000003E+001,
      1.5095000000000002E+001,
      1.5096000000000002E+001,
      1.5097000000000003E+001,
      1.5098000000000003E+001,
      1.5099000000000002E+001,
      1.5100000000000003E+001,
      1.5101000000000003E+001,
      1.5102000000000002E+001,
      1.5103000000000002E+001,
      1.5104000000000003E+001,
      1.5105000000000002E+001,
      1.5106000000000002E+001,
      1.5107000000000003E+001,
      1.5108000000000002E+001,
      1.5109000000000002E+001,
      1.5110000000000003E+001,
      1.5111000000000002E+001,
      1.5112000000000002E+001,
      1.5113000000000003E+001,
      1.5114000000000003E+001,
      1.5115000000000002E+001,
      1.5116000000000003E+001,
      1.5117000000000003E+001,
      1.5118000000000002E+001,
      1.5119000000000002E+001,
      1.5120000000000003E+001,
      1.5121000000000002E+001,
      1.5122000000000002E+001,
      1.5123000000000003E+001,
      1.5124000000000002E+001,
      1.5125000000000002E+001,
      1.5126000000000003E+001,
      1.5127000000000002E+001,
      1.5128000000000002E+001,
      1.5129000000000003E+001,
      1.5130000000000003E+001,
      1.5131000000000002E+001,
      1.5132000000000003E+001,
      1.5133000000000003E+001,
      1.5134000000000002E+001,
      1.5135000000000002E+001,
      1.5136000000000003E+001,
      1.5137000000000002E+001,
      1.5138000000000002E+001,
      1.5139000000000003E+001,
      1.5140000000000002E+001,
      1.5141000000000002E+001,
      1.5142000000000003E+001,
      1.5143000000000002E+001,
      1.5144000000000002E+001,
      1.5145000000000003E+001,
      1.5146000000000003E+001,
      1.5147000000000002E+001,
      1.5148000000000003E+001,
      1.5149000000000003E+001,
      1.5150000000000002E+001,
      1.5151000000000002E+001,
      1.5152000000000003E+001,
      1.5153000000000002E+001,
      1.5154000000000002E+001,
      1.5155000000000003E+001,
      1.5156000000000002E+001,
      1.5157000000000002E+001,
      1.5158000000000003E+001,
      1.5159000000000002E+001,
      1.5160000000000002E+001,
      1.5161000000000003E+001,
      1.5162000000000003E+001,
      1.5163000000000002E+001,
      1.5164000000000001E+001,
      1.5165000000000003E+001,
      1.5166000000000002E+001,
      1.5167000000000002E+001,
      1.5168000000000003E+001,
      1.5169000000000002E+001,
      1.5170000000000002E+001,
      1.5171000000000003E+001,
      1.5172000000000002E+001,
      1.5173000000000002E+001,
      1.5174000000000003E+001,
      1.5175000000000002E+001,
      1.5176000000000002E+001,
      1.5177000000000003E+001,
      1.5178000000000003E+001,
      1.5179000000000002E+001,
      1.5180000000000003E+001,
      1.5181000000000003E+001,
      1.5182000000000002E+001,
      1.5183000000000002E+001,
      1.5184000000000003E+001,
      1.5185000000000002E+001,
      1.5186000000000002E+001,
      1.5187000000000003E+001,
      1.5188000000000002E+001,
      1.5189000000000002E+001,
      1.5190000000000003E+001,
      1.5191000000000003E+001,
      1.5192000000000002E+001,
      1.5193000000000003E+001,
      1.5194000000000003E+001,
      1.5195000000000002E+001,
      1.5196000000000002E+001,
      1.5197000000000003E+001,
      1.5198000000000002E+001,
      1.5199000000000002E+001,
      1.5200000000000003E+001,
      1.5201000000000002E+001,
      1.5202000000000002E+001,
      1.5203000000000003E+001,
      1.5204000000000002E+001,
      1.5205000000000002E+001,
      1.5206000000000003E+001,
      1.5207000000000003E+001,
      1.5208000000000002E+001,
      1.5209000000000003E+001,
      1.5210000000000003E+001,
      1.5211000000000002E+001,
      1.5212000000000002E+001,
      1.5213000000000003E+001,
      1.5214000000000002E+001,
      1.5215000000000002E+001,
      1.5216000000000003E+001,
      1.5217000000000002E+001,
      1.5218000000000002E+001,
      1.5219000000000003E+001,
      1.5220000000000002E+001,
      1.5221000000000002E+001,
      1.5222000000000003E+001,
      1.5223000000000003E+001,
      1.5224000000000002E+001,
      1.5225000000000003E+001,
      1.5226000000000003E+001,
      1.5227000000000002E+001,
      1.5228000000000002E+001,
      1.5229000000000003E+001,
      1.5230000000000002E+001,
      1.5231000000000002E+001,
      1.5232000000000003E+001,
      1.5233000000000002E+001,
      1.5234000000000002E+001,
      1.5235000000000003E+001,
      1.5236000000000002E+001,
      1.5237000000000002E+001,
      1.5238000000000003E+001,
      1.5239000000000003E+001,
      1.5240000000000002E+001,
      1.5241000000000003E+001,
      1.5242000000000003E+001,
      1.5243000000000002E+001,
      1.5244000000000002E+001,
      1.5245000000000003E+001,
      1.5246000000000002E+001,
      1.5247000000000002E+001,
      1.5248000000000003E+001,
      1.5249000000000002E+001,
      1.5250000000000002E+001,
      1.5251000000000003E+001,
      1.5252000000000002E+001,
      1.5253000000000002E+001,
      1.5254000000000003E+001,
      1.5255000000000003E+001,
      1.5256000000000002E+001,
      1.5257000000000003E+001,
      1.5258000000000003E+001,
      1.5259000000000002E+001,
      1.5260000000000002E+001,
      1.5261000000000003E+001,
      1.5262000000000002E+001,
      1.5263000000000002E+001,
      1.5264000000000003E+001,
      1.5265000000000002E+001,
      1.5266000000000002E+001,
      1.5267000000000003E+001,
      1.5268000000000002E+001,
      1.5269000000000002E+001,
      1.5270000000000003E+001,
      1.5271000000000003E+001,
      1.5272000000000002E+001,
      1.5273000000000003E+001,
      1.5274000000000003E+001,
      1.5275000000000002E+001,
      1.5276000000000002E+001,
      1.5277000000000003E+001,
      1.5278000000000002E+001,
      1.5279000000000002E+001,
      1.5280000000000003E+001,
      1.5281000000000002E+001,
      1.5282000000000002E+001,
      1.5283000000000003E+001,
      1.5284000000000002E+001,
      1.5285000000000002E+001,
      1.5286000000000003E+001,
      1.5287000000000003E+001,
      1.5288000000000002E+001,
      1.5289000000000001E+001,
      1.5290000000000003E+001,
      1.5291000000000002E+001,
      1.5292000000000002E+001,
      1.5293000000000003E+001,
      1.5294000000000002E+001,
      1.5295000000000002E+001,
      1.5296000000000003E+001,
      1.5297000000000002E+001,
      1.5298000000000002E+001,
      1.5299000000000003E+001,
      1.5300000000000002E+001,
      1.5301000000000002E+001,
      1.5302000000000003E+001,
      1.5303000000000003E+001,
      1.5304000000000002E+001,
      1.5305000000000003E+001,
      1.5306000000000003E+001,
      1.5307000000000002E+001,
      1.5308000000000002E+001,
      1.5309000000000003E+001,
      1.5310000000000002E+001,
      1.5311000000000002E+001,
      1.5312000000000003E+001,
      1.5313000000000002E+001,
      1.5314000000000002E+001,
      1.5315000000000003E+001,
      1.5316000000000003E+001,
      1.5317000000000002E+001,
      1.5318000000000003E+001,
      1.5319000000000003E+001,
      1.5320000000000002E+001,
      1.5321000000000002E+001,
      1.5322000000000003E+001,
      1.5323000000000002E+001,
      1.5324000000000002E+001,
      1.5325000000000003E+001,
      1.5326000000000002E+001,
      1.5327000000000002E+001,
      1.5328000000000003E+001,
      1.5329000000000002E+001,
      1.5330000000000002E+001,
      1.5331000000000003E+001,
      1.5332000000000003E+001,
      1.5333000000000002E+001,
      1.5334000000000003E+001,
      1.5335000000000003E+001,
      1.5336000000000002E+001,
      1.5337000000000002E+001,
      1.5338000000000003E+001,
      1.5339000000000002E+001,
      1.5340000000000002E+001,
      1.5341000000000003E+001,
      1.5342000000000002E+001,
      1.5343000000000002E+001,
      1.5344000000000003E+001,
      1.5345000000000002E+001,
      1.5346000000000002E+001,
      1.5347000000000003E+001,
      1.5348000000000003E+001,
      1.5349000000000002E+001,
      1.5350000000000003E+001,
      1.5351000000000003E+001,
      1.5352000000000002E+001,
      1.5353000000000002E+001,
      1.5354000000000003E+001,
      1.5355000000000002E+001,
      1.5356000000000002E+001,
      1.5357000000000003E+001,
      1.5358000000000002E+001,
      1.5359000000000002E+001,
      1.5360000000000003E+001,
      1.5361000000000002E+001,
      1.5362000000000002E+001,
      1.5363000000000003E+001,
      1.5364000000000003E+001,
      1.5365000000000002E+001,
      1.5366000000000003E+001,
      1.5367000000000003E+001,
      1.5368000000000002E+001,
      1.5369000000000002E+001,
      1.5370000000000003E+001,
      1.5371000000000002E+001,
      1.5372000000000002E+001,
      1.5373000000000003E+001,
      1.5374000000000002E+001,
      1.5375000000000002E+001,
      1.5376000000000003E+001,
      1.5377000000000002E+001,
      1.5378000000000002E+001,
      1.5379000000000003E+001,
      1.5380000000000003E+001,
      1.5381000000000002E+001,
      1.5382000000000003E+001,
      1.5383000000000003E+001,
      1.5384000000000002E+001,
      1.5385000000000002E+001,
      1.5386000000000003E+001,
      1.5387000000000002E+001,
      1.5388000000000002E+001,
      1.5389000000000003E+001,
      1.5390000000000002E+001,
      1.5391000000000002E+001,
      1.5392000000000003E+001,
      1.5393000000000002E+001,
      1.5394000000000002E+001,
      1.5395000000000003E+001,
      1.5396000000000003E+001,
      1.5397000000000002E+001,
      1.5398000000000003E+001,
      1.5399000000000003E+001,
      1.5400000000000002E+001,
      1.5401000000000002E+001,
      1.5402000000000003E+001,
      1.5403000000000002E+001,
      1.5404000000000002E+001,
      1.5405000000000003E+001,
      1.5406000000000002E+001,
      1.5407000000000002E+001,
      1.5408000000000003E+001,
      1.5409000000000002E+001,
      1.5410000000000002E+001,
      1.5411000000000003E+001,
      1.5412000000000003E+001,
      1.5413000000000002E+001,
      1.5414000000000003E+001,
      1.5415000000000003E+001,
      1.5416000000000002E+001,
      1.5417000000000002E+001,
      1.5418000000000003E+001,
      1.5419000000000002E+001,
      1.5420000000000002E+001,
      1.5421000000000003E+001,
      1.5422000000000002E+001,
      1.5423000000000002E+001,
      1.5424000000000003E+001,
      1.5425000000000002E+001,
      1.5426000000000002E+001,
      1.5427000000000003E+001,
      1.5428000000000003E+001,
      1.5429000000000002E+001,
      1.5430000000000003E+001,
      1.5431000000000003E+001,
      1.5432000000000002E+001,
      1.5433000000000002E+001,
      1.5434000000000003E+001,
      1.5435000000000002E+001,
      1.5436000000000002E+001,
      1.5437000000000003E+001,
      1.5438000000000002E+001,
      1.5439000000000002E+001,
      1.5440000000000003E+001,
      1.5441000000000003E+001,
      1.5442000000000002E+001,
      1.5443000000000003E+001,
      1.5444000000000003E+001,
      1.5445000000000002E+001,
      1.5446000000000002E+001,
      1.5447000000000003E+001,
      1.5448000000000002E+001,
      1.5449000000000002E+001,
      1.5450000000000003E+001,
      1.5451000000000002E+001,
      1.5452000000000002E+001,
      1.5453000000000003E+001,
      1.5454000000000002E+001,
      1.5455000000000002E+001,
      1.5456000000000003E+001,
      1.5457000000000003E+001,
      1.5458000000000002E+001,
      1.5459000000000003E+001,
      1.5460000000000003E+001,
      1.5461000000000002E+001,
      1.5462000000000002E+001,
      1.5463000000000003E+001,
      1.5464000000000002E+001,
      1.5465000000000002E+001,
      1.5466000000000003E+001,
      1.5467000000000002E+001,
      1.5468000000000002E+001,
      1.5469000000000003E+001,
      1.5470000000000002E+001,
      1.5471000000000002E+001,
      1.5472000000000003E+001,
      1.5473000000000003E+001,
      1.5474000000000002E+001,
      1.5475000000000003E+001,
      1.5476000000000003E+001,
      1.5477000000000002E+001,
      1.5478000000000002E+001,
      1.5479000000000003E+001,
      1.5480000000000002E+001,
      1.5481000000000002E+001,
      1.5482000000000003E+001,
      1.5483000000000002E+001,
      1.5484000000000002E+001,
      1.5485000000000003E+001,
      1.5486000000000002E+001,
      1.5487000000000002E+001,
      1.5488000000000003E+001,
      1.5489000000000003E+001,
      1.5490000000000002E+001,
      1.5491000000000003E+001,
      1.5492000000000003E+001,
      1.5493000000000002E+001,
      1.5494000000000002E+001,
      1.5495000000000003E+001,
      1.5496000000000002E+001,
      1.5497000000000002E+001,
      1.5498000000000003E+001,
      1.5499000000000002E+001,
      1.5500000000000002E+001,
      1.5501000000000003E+001,
      1.5502000000000002E+001,
      1.5503000000000002E+001,
      1.5504000000000003E+001,
      1.5505000000000003E+001,
      1.5506000000000002E+001,
      1.5507000000000003E+001,
      1.5508000000000003E+001,
      1.5509000000000002E+001,
      1.5510000000000002E+001,
      1.5511000000000003E+001,
      1.5512000000000002E+001,
      1.5513000000000002E+001,
      1.5514000000000003E+001,
      1.5515000000000002E+001,
      1.5516000000000002E+001,
      1.5517000000000003E+001,
      1.5518000000000002E+001,
      1.5519000000000002E+001,
      1.5520000000000003E+001,
      1.5521000000000003E+001,
      1.5522000000000002E+001,
      1.5523000000000003E+001,
      1.5524000000000003E+001,
      1.5525000000000002E+001,
      1.5526000000000002E+001,
      1.5527000000000003E+001,
      1.5528000000000002E+001,
      1.5529000000000002E+001,
      1.5530000000000003E+001,
      1.5531000000000002E+001,
      1.5532000000000002E+001,
      1.5533000000000003E+001,
      1.5534000000000002E+001,
      1.5535000000000002E+001,
      1.5536000000000003E+001,
      1.5537000000000003E+001,
      1.5538000000000002E+001,
      1.5539000000000003E+001,
      1.5540000000000003E+001,
      1.5541000000000002E+001,
      1.5542000000000002E+001,
      1.5543000000000003E+001,
      1.5544000000000002E+001,
      1.5545000000000002E+001,
      1.5546000000000003E+001,
      1.5547000000000002E+001,
      1.5548000000000002E+001,
      1.5549000000000003E+001,
      1.5550000000000002E+001,
      1.5551000000000002E+001,
      1.5552000000000003E+001,
      1.5553000000000003E+001,
      1.5554000000000002E+001,
      1.5555000000000003E+001,
      1.5556000000000003E+001,
      1.5557000000000002E+001,
      1.5558000000000002E+001,
      1.5559000000000003E+001,
      1.5560000000000002E+001,
      1.5561000000000002E+001,
      1.5562000000000003E+001,
      1.5563000000000002E+001
    };

    static real_T pDataValues[] = {
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      -9.9999999999999992E-002,
      -1.9999999999999998E-001,
      -0.3,
      -3.9999999999999997E-001,
      -4.9999999999999994E-001,
      -0.6,
      -0.7,
      -7.9999999999999993E-001,
      -0.9,
      -9.9999999999999989E-001,
      -1.0999999999999999E+000,
      -1.2,
      -1.3,
      -1.4,
      -1.4999999999999998E+000,
      -1.5999999999999999E+000,
      -1.7,
      -1.8,
      -1.8999999999999997E+000,
      -1.9999999999999998E+000,
      -2.1,
      -2.1999999999999997E+000,
      -2.3,
      -2.4,
      -2.5,
      -2.6,
      -2.6999999999999997E+000,
      -2.8,
      -2.9,
      -2.9999999999999996E+000,
      -3.0999999999999996E+000,
      -3.1999999999999997E+000,
      -3.3,
      -3.4,
      -3.5,
      -3.6,
      -3.6999999999999993E+000,
      -3.7999999999999994E+000,
      -3.8999999999999995E+000,
      -3.9999999999999996E+000,
      -4.1,
      -4.2,
      -4.3000000000000007E+000,
      -4.3999999999999995E+000,
      -4.4999999999999991E+000,
      -4.6,
      -4.6999999999999993E+000,
      -4.8,
      -4.8999999999999995E+000,
      -5.0,
      -5.1000000000000005E+000,
      -5.2,
      -5.3000000000000007E+000,
      -5.4,
      -5.5000000000000009E+000,
      -5.6,
      -5.6999999999999993E+000,
      -5.8,
      -5.8999999999999995E+000,
      -6.0,
      -6.1000000000000005E+000,
      -6.2,
      -6.2999999999999989E+000,
      -6.3999999999999995E+000,
      -6.4999999999999991E+000,
      -6.6,
      -6.6999999999999993E+000,
      -6.8,
      -6.8999999999999995E+000,
      -7.0,
      -7.1000000000000005E+000,
      -7.2,
      -7.3000000000000007E+000,
      -7.4,
      -7.5000000000000009E+000,
      -7.6000000000000005E+000,
      -7.7000000000000011E+000,
      -7.7999999999999989E+000,
      -7.8999999999999986E+000,
      -7.9999999999999991E+000,
      -8.1,
      -8.2,
      -8.2999999999999989E+000,
      -8.4,
      -8.5,
      -8.6000000000000014E+000,
      -8.7000000000000011E+000,
      -8.8,
      -8.9,
      -8.9999999999999982E+000,
      -9.1,
      -9.2,
      -9.2999999999999989E+000,
      -9.3999999999999986E+000,
      -9.5,
      -9.6,
      -9.7,
      -9.7999999999999989E+000,
      -9.9,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -10.0,
      -9.9,
      -9.7999999999999989E+000,
      -9.7,
      -9.6,
      -9.5,
      -9.3999999999999986E+000,
      -9.2999999999999989E+000,
      -9.2,
      -9.1,
      -9.0000000000000018E+000,
      -8.9,
      -8.8,
      -8.7000000000000011E+000,
      -8.6000000000000014E+000,
      -8.5,
      -8.4,
      -8.3,
      -8.2000000000000011E+000,
      -8.1,
      -8.0,
      -7.8999999999999995E+000,
      -7.8,
      -7.6999999999999993E+000,
      -7.6,
      -7.4999999999999991E+000,
      -7.3999999999999995E+000,
      -7.3000000000000007E+000,
      -7.2,
      -7.1000000000000005E+000,
      -7.0000000000000009E+000,
      -6.9000000000000012E+000,
      -6.8000000000000007E+000,
      -6.7000000000000011E+000,
      -6.6000000000000005E+000,
      -6.5000000000000009E+000,
      -6.4,
      -6.3000000000000007E+000,
      -6.2,
      -6.1000000000000005E+000,
      -6.0,
      -5.8999999999999995E+000,
      -5.8,
      -5.6999999999999993E+000,
      -5.6000000000000005E+000,
      -5.5000000000000009E+000,
      -5.4,
      -5.3000000000000007E+000,
      -5.2,
      -5.1000000000000005E+000,
      -5.0,
      -4.8999999999999995E+000,
      -4.8,
      -4.6999999999999993E+000,
      -4.6,
      -4.4999999999999991E+000,
      -4.4,
      -4.3000000000000007E+000,
      -4.2,
      -4.1000000000000005E+000,
      -4.0,
      -3.9,
      -3.8,
      -3.7000000000000006E+000,
      -3.6000000000000005E+000,
      -3.5000000000000004E+000,
      -3.4000000000000004E+000,
      -3.3000000000000003E+000,
      -3.2,
      -3.1,
      -3.0,
      -2.9,
      -2.8,
      -2.6999999999999997E+000,
      -2.5999999999999996E+000,
      -2.4999999999999996E+000,
      -2.3999999999999995E+000,
      -2.2999999999999994E+000,
      -2.2000000000000011E+000,
      -2.1000000000000010E+000,
      -2.0000000000000009E+000,
      -1.9000000000000008E+000,
      -1.8000000000000007E+000,
      -1.7000000000000006E+000,
      -1.5999999999999996E+000,
      -1.4999999999999996E+000,
      -1.3999999999999995E+000,
      -1.2999999999999994E+000,
      -1.1999999999999993E+000,
      -1.0999999999999992E+000,
      -1.0000000000000009E+000,
      -9.0000000000000080E-001,
      -8.0000000000000071E-001,
      -7.0000000000000062E-001,
      -6.0000000000000053E-001,
      -5.0000000000000044E-001,
      -4.0000000000000036E-001,
      -3.0000000000000027E-001,
      -2.0000000000000018E-001,
      -1.0000000000000009E-001,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      6.1557462199097281E-015,
      -2.1055017518554922E-001,
      -4.2109203821073765E-001,
      -6.3161727724325289E-001,
      -8.4211758110719426E-001,
      -1.0525846396109400E+000,
      -1.2630101438754573E+000,
      -1.4733857866620843E+000,
      -1.6837032627007242E+000,
      -1.8939542690174846E+000,
      -2.1041305052626740E+000,
      -2.3142236740383932E+000,
      -2.5242254812260172E+000,
      -2.7341276363138389E+000,
      -2.9439218527241251E+000,
      -3.1535998481404977E+000,
      -3.3631533448346635E+000,
      -3.5725740699934159E+000,
      -3.7818537560451411E+000,
      -3.9909841409861193E+000,
      -4.1999569687068998E+000,
      -4.4087639893180066E+000,
      -4.6173969594758546E+000,
      -4.8258476427079646E+000,
      -5.0341078097383445E+000,
      -5.2421692388121386E+000,
      -5.4500237160204179E+000,
      -5.6576630356243527E+000,
      -5.8650790003790823E+000,
      -6.0722634218575298E+000,
      -6.2792081207734336E+000,
      -6.4859049273044853E+000,
      -6.6923456814146247E+000,
      -6.8985222331764229E+000,
      -7.1044264430925885E+000,
      -7.3100501824175073E+000,
      -7.5153853334780640E+000,
      -7.7204237899940269E+000,
      -7.9251574573982726E+000,
      -8.1295782531561134E+000,
      -8.3336781070846175E+000,
      -8.5374489616709681E+000,
      -8.7408827723907638E+000,
      -8.9439715080255269E+000,
      -9.1467071509796511E+000,
      -9.3490816975971587E+000,
      -9.5510871584774062E+000,
      -9.7527155587907473E+000,
      -9.9539589385931233E+000,
      -1.0154809353140539E+001,
      -1.0355258873202484E+001,
      -1.0555299585375156E+001,
      -1.0754923592393794E+001,
      -1.0954123013444356E+001,
      -1.1152889984474838E+001,
      -1.1351216658505511E+001,
      -1.1549095205938931E+001,
      -1.1746517814868810E+001,
      -1.1943476691388646E+001,
      -1.2139964059899185E+001,
      -1.2335972163415590E+001,
      -1.2531493263873578E+001,
      -1.2726519642434830E+001,
      -1.2921043599791922E+001,
      -1.3115057456472037E+001,
      -1.3308553553140372E+001,
      -1.3501524250902298E+001,
      -1.3693961931605132E+001,
      -1.3885858998138705E+001,
      -1.4077207874735429E+001,
      -1.4268001007269321E+001,
      -1.4458230863554155E+001,
      -1.4647889933640977E+001,
      -1.4836970730114396E+001,
      -1.5025465788388381E+001,
      -1.5213367667000734E+001,
      -1.5400668947907048E+001,
      -1.5587362236773497E+001,
      -1.5773440163268651E+001,
      -1.5958895381354639E+001,
      -1.6143720569576953E+001,
      -1.6327908431353681E+001,
      -1.6511451695263371E+001,
      -1.6694343115332266E+001,
      -1.6876575471320287E+001,
      -1.7058141569006029E+001,
      -1.7239034240470815E+001,
      -1.7419246344381740E+001,
      -1.7598770766273546E+001,
      -1.7777600418829394E+001,
      -1.7955728242160859E+001,
      -1.8133147204086431E+001,
      -1.8309850300409305E+001,
      -1.8485830555193836E+001,
      -1.8661081021040825E+001,
      -1.8835594779362019E+001,
      -1.9009364940653008E+001,
      -1.9182384644765410E+001,
      -1.9354647061177509E+001,
      -1.9526145389264126E+001,
      -1.9696872858564866E+001,
      -1.9866822729051599E+001,
      -2.0035988291394467E+001,
      -2.0204362867226667E+001,
      -2.0371939809408303E+001,
      -2.0538712502288590E+001,
      -2.0704674361967221E+001,
      -2.0869818836554092E+001,
      -2.1034139406428185E+001,
      -2.1197629584494692E+001,
      -2.1360282916441371E+001,
      -2.1522092980993182E+001,
      -2.1683053390165817E+001,
      -2.1843157789517957E+001,
      -2.2002399858402022E+001,
      -2.2160773310213845E+001,
      -2.2318271892640681E+001,
      -2.2474889387908220E+001,
      -2.2630619613025875E+001,
      -2.2785456420031032E+001,
      -2.2939393696231704E+001,
      -2.3092425364447760E+001,
      -2.3244545383251015E+001,
      -2.3395747747203551E+001,
      -2.3546026487094966E+001,
      -2.3695375670177953E+001,
      -2.3843789400402457E+001,
      -2.3991261818648518E+001,
      -2.4137787102957603E+001,
      -2.4283359468762391E+001,
      -2.4427973169115102E+001,
      -2.4571622494914514E+001,
      -2.4714301775131155E+001,
      -2.4856005377031398E+001,
      -2.4996727706399636E+001,
      -2.5136463207759302E+001,
      -2.5275206364592020E+001,
      -2.5412951699555549E+001,
      -2.5549693774699946E+001,
      -2.5685427191682180E+001,
      -2.5820146591979402E+001,
      -2.5953846657100321E+001,
      -2.6086522108795346E+001,
      -2.6218167709264772E+001,
      -2.6348778261365755E+001,
      -2.6478348608817289E+001,
      -2.6606873636403947E+001,
      -2.6734348270177723E+001,
      -2.6860767477658310E+001,
      -2.6986126268031892E+001,
      -2.7110419692348049E+001,
      -2.7233642843715227E+001,
      -2.7355790857494416E+001,
      -2.7476858911491149E+001,
      -2.7596842226145995E+001,
      -2.7715736064723096E+001,
      -2.7833535733497321E+001,
      -2.7950236581939418E+001,
      -2.8065834002899749E+001,
      -2.8180323432790029E+001,
      -2.8293700351763626E+001,
      -2.8405960283893933E+001,
      -2.8517098797351000E+001,
      -2.8627111504576664E+001,
      -2.8735994062457578E+001,
      -2.8843742172496825E+001,
      -2.8950351580983479E+001,
      -2.9055818079160677E+001,
      -2.9160137503391624E+001,
      -2.9263305735324089E+001,
      -2.9365318702052946E+001,
      -2.9466172376280905E+001,
      -2.9565862776477633E+001,
      -2.9664385967036800E+001,
      -2.9761738058431565E+001,
      -2.9857915207368031E+001,
      -2.9952913616937046E+001,
      -3.0046729536764079E+001,
      -3.0139359263157235E+001,
      -3.0230799139253541E+001,
      -3.0321045555163234E+001,
      -3.0410094948112366E+001,
      -3.0497943802583361E+001,
      -3.0584588650453870E+001,
      -3.0670026071133680E+001,
      -3.0754252691699694E+001,
      -3.0837265187029143E+001,
      -3.0919060279930868E+001,
      -3.0999634741274658E+001,
      -3.1078985390118731E+001,
      -3.1157109093835359E+001,
      -3.1234002768234468E+001,
      -3.1309663377685467E+001,
      -3.1384087935237059E+001,
      -3.1457273502735127E+001,
      -3.1529217190938780E+001,
      -3.1599916159634400E+001,
      -3.1669367617747771E+001,
      -3.1737568823454225E+001,
      -3.1804517084286967E+001,
      -3.1870209757243263E+001,
      -3.1934644248888887E+001,
      -3.1997818015460439E+001,
      -3.2059728562965780E+001,
      -3.2120373447282496E+001,
      -3.2179750274254403E+001,
      -3.2237856699786050E+001,
      -3.2294690429935230E+001,
      -3.2350249221003608E+001,
      -3.2404530879625241E+001,
      -3.2457533262853190E+001,
      -3.2509254278244121E+001,
      -3.2559691883940907E+001,
      -3.2608844088753237E+001,
      -3.2656708952236222E+001,
      -3.2703284584767019E+001,
      -3.2748569147619399E+001,
      -3.2792560853036370E+001,
      -3.2835257964300716E+001,
      -3.2876658795803600E+001,
      -3.2916761713111086E+001,
      -3.2955565133028649E+001,
      -3.2993067523663740E+001,
      -3.3029267404486170E+001,
      -3.3064163346386636E+001,
      -3.3097753971733106E+001,
      -3.3130037954425198E+001,
      -3.3161014019946563E+001,
      -3.3190680945415174E+001,
      -3.3219037559631609E+001,
      -3.3246082743125285E+001,
      -3.3271815428198686E+001,
      -3.3296234598969441E+001,
      -3.3319339291410522E+001,
      -3.3341128593388227E+001,
      -3.3361601644698219E+001,
      -3.3380757637099492E+001,
      -3.3398595814346265E+001,
      -3.3415115472217835E+001,
      -3.3430315958546416E+001,
      -3.3444196673242814E+001,
      -3.3456757068320194E+001,
      -3.3467996647915662E+001,
      -3.3477914968309854E+001,
      -3.3486511637944474E+001,
      -3.3493786317437717E+001,
      -3.3499738719597694E+001,
      -3.3504368609433762E+001,
      -3.3507675804165800E+001,
      -3.3509660173231417E+001,
      -3.3510321638291131E+001,
      -3.3509660173231417E+001,
      -3.3507675804165800E+001,
      -3.3504368609433762E+001,
      -3.3499738719597694E+001,
      -3.3493786317437717E+001,
      -3.3486511637944474E+001,
      -3.3477914968309854E+001,
      -3.3467996647915662E+001,
      -3.3456757068320194E+001,
      -3.3444196673242814E+001,
      -3.3430315958546416E+001,
      -3.3415115472217835E+001,
      -3.3398595814346265E+001,
      -3.3380757637099492E+001,
      -3.3361601644698219E+001,
      -3.3341128593388227E+001,
      -3.3319339291410529E+001,
      -3.3296234598969441E+001,
      -3.3271815428198686E+001,
      -3.3246082743125292E+001,
      -3.3219037559631609E+001,
      -3.3190680945415174E+001,
      -3.3161014019946570E+001,
      -3.3130037954425198E+001,
      -3.3097753971733106E+001,
      -3.3064163346386636E+001,
      -3.3029267404486170E+001,
      -3.2993067523663740E+001,
      -3.2955565133028657E+001,
      -3.2916761713111079E+001,
      -3.2876658795803600E+001,
      -3.2835257964300723E+001,
      -3.2792560853036370E+001,
      -3.2748569147619406E+001,
      -3.2703284584767019E+001,
      -3.2656708952236222E+001,
      -3.2608844088753237E+001,
      -3.2559691883940907E+001,
      -3.2509254278244121E+001,
      -3.2457533262853190E+001,
      -3.2404530879625248E+001,
      -3.2350249221003615E+001,
      -3.2294690429935230E+001,
      -3.2237856699786057E+001,
      -3.2179750274254403E+001,
      -3.2120373447282503E+001,
      -3.2059728562965788E+001,
      -3.1997818015460442E+001,
      -3.1934644248888890E+001,
      -3.1870209757243266E+001,
      -3.1804517084286974E+001,
      -3.1737568823454232E+001,
      -3.1669367617747781E+001,
      -3.1599916159634407E+001,
      -3.1529217190938787E+001,
      -3.1457273502735134E+001,
      -3.1384087935237066E+001,
      -3.1309663377685474E+001,
      -3.1234002768234475E+001,
      -3.1157109093835366E+001,
      -3.1078985390118739E+001,
      -3.0999634741274665E+001,
      -3.0919060279930875E+001,
      -3.0837265187029150E+001,
      -3.0754252691699701E+001,
      -3.0670026071133684E+001,
      -3.0584588650453878E+001,
      -3.0497943802583368E+001,
      -3.0410094948112373E+001,
      -3.0321045555163241E+001,
      -3.0230799139253534E+001,
      -3.0139359263157242E+001,
      -3.0046729536764087E+001,
      -2.9952913616937064E+001,
      -2.9857915207368038E+001,
      -2.9761738058431558E+001,
      -2.9664385967036807E+001,
      -2.9565862776477640E+001,
      -2.9466172376280912E+001,
      -2.9365318702052939E+001,
      -2.9263305735324099E+001,
      -2.9160137503391631E+001,
      -2.9055818079160687E+001,
      -2.8950351580983494E+001,
      -2.8843742172496817E+001,
      -2.8735994062457586E+001,
      -2.8627111504576675E+001,
      -2.8517098797351007E+001,
      -2.8405960283893926E+001,
      -2.8293700351763636E+001,
      -2.8180323432790036E+001,
      -2.8065834002899756E+001,
      -2.7950236581939425E+001,
      -2.7833535733497314E+001,
      -2.7715736064723103E+001,
      -2.7596842226146002E+001,
      -2.7476858911491160E+001,
      -2.7355790857494405E+001,
      -2.7233642843715234E+001,
      -2.7110419692348056E+001,
      -2.6986126268031903E+001,
      -2.6860767477658335E+001,
      -2.6734348270177733E+001,
      -2.6606873636403957E+001,
      -2.6478348608817299E+001,
      -2.6348778261365766E+001,
      -2.6218167709264783E+001,
      -2.6086522108795336E+001,
      -2.5953846657100332E+001,
      -2.5820146591979409E+001,
      -2.5685427191682191E+001,
      -2.5549693774699957E+001,
      -2.5412951699555560E+001,
      -2.5275206364592030E+001,
      -2.5136463207759313E+001,
      -2.4996727706399646E+001,
      -2.4856005377031391E+001,
      -2.4714301775131165E+001,
      -2.4571622494914521E+001,
      -2.4427973169115116E+001,
      -2.4283359468762402E+001,
      -2.4137787102957613E+001,
      -2.3991261818648528E+001,
      -2.3843789400402468E+001,
      -2.3695375670177963E+001,
      -2.3546026487094981E+001,
      -2.3395747747203565E+001,
      -2.3244545383251026E+001,
      -2.3092425364447770E+001,
      -2.2939393696231715E+001,
      -2.2785456420031043E+001,
      -2.2630619613025885E+001,
      -2.2474889387908231E+001,
      -2.2318271892640691E+001,
      -2.2160773310213838E+001,
      -2.2002399858402033E+001,
      -2.1843157789517967E+001,
      -2.1683053390165828E+001,
      -2.1522092980993197E+001,
      -2.1360282916441381E+001,
      -2.1197629584494706E+001,
      -2.1034139406428196E+001,
      -2.0869818836554106E+001,
      -2.0704674361967211E+001,
      -2.0538712502288604E+001,
      -2.0371939809408318E+001,
      -2.0204362867226678E+001,
      -2.0035988291394453E+001,
      -1.9866822729051613E+001,
      -1.9696872858564880E+001,
      -1.9526145389264137E+001,
      -1.9354647061177527E+001,
      -1.9182384644765399E+001,
      -1.9009364940653018E+001,
      -1.8835594779362033E+001,
      -1.8661081021040840E+001,
      -1.8485830555193822E+001,
      -1.8309850300409323E+001,
      -1.8133147204086441E+001,
      -1.7955728242160873E+001,
      -1.7777600418829408E+001,
      -1.7598770766273535E+001,
      -1.7419246344381758E+001,
      -1.7239034240470829E+001,
      -1.7058141569006015E+001,
      -1.6876575471320276E+001,
      -1.6694343115332281E+001,
      -1.6511451695263386E+001,
      -1.6327908431353695E+001,
      -1.6143720569576992E+001,
      -1.5958895381354653E+001,
      -1.5773440163268665E+001,
      -1.5587362236773512E+001,
      -1.5400668947907089E+001,
      -1.5213367667000746E+001,
      -1.5025465788388368E+001,
      -1.4836970730114409E+001,
      -1.4647889933640991E+001,
      -1.4458230863554196E+001,
      -1.4268001007269337E+001,
      -1.4077207874735443E+001,
      -1.3885858998138719E+001,
      -1.3693961931605152E+001,
      -1.3501524250902312E+001,
      -1.3308553553140360E+001,
      -1.3115057456472051E+001,
      -1.2921043599791938E+001,
      -1.2726519642434873E+001,
      -1.2531493263873593E+001,
      -1.2335972163415606E+001,
      -1.2139964059899201E+001,
      -1.1943476691388661E+001,
      -1.1746517814868826E+001,
      -1.1549095205938919E+001,
      -1.1351216658505525E+001,
      -1.1152889984474854E+001,
      -1.0954123013444400E+001,
      -1.0754923592393810E+001,
      -1.0555299585375172E+001,
      -1.0355258873202500E+001,
      -1.0154809353140553E+001,
      -9.9539589385931393E+000,
      -9.7527155587907348E+000,
      -9.5510871584774222E+000,
      -9.3490816975971747E+000,
      -9.1467071509796689E+000,
      -8.9439715080255411E+000,
      -8.7408827723907816E+000,
      -8.5374489616709859E+000,
      -8.3336781070846335E+000,
      -8.1295782531561294E+000,
      -7.9251574573982593E+000,
      -7.7204237899940429E+000,
      -7.5153853334780800E+000,
      -7.3100501824175241E+000,
      -7.1044264430926045E+000,
      -6.8985222331764104E+000,
      -6.6923456814146416E+000,
      -6.4859049273045004E+000,
      -6.2792081207734487E+000,
      -6.0722634218575164E+000,
      -5.8650790003790974E+000,
      -5.6576630356243696E+000,
      -5.4500237160204348E+000,
      -5.2421692388121564E+000,
      -5.0341078097383321E+000,
      -4.8258476427079815E+000,
      -4.6173969594758706E+000,
      -4.4087639893180217E+000,
      -4.1999569687069167E+000,
      -3.9909841409861357E+000,
      -3.7818537560451575E+000,
      -3.5725740699934616E+000,
      -3.3631533448346795E+000,
      -3.1535998481404839E+000,
      -2.9439218527241411E+000,
      -2.7341276363138549E+000,
      -2.5242254812260634E+000,
      -2.3142236740384092E+000,
      -2.1041305052626900E+000,
      -1.8939542690175013E+000,
      -1.6837032627007407E+000,
      -1.4733857866621007E+000,
      -1.2630101438754440E+000,
      -1.0525846396109566E+000,
      -8.4211758110721058E-001,
      -6.3161727724329897E-001,
      -4.2109203821075408E-001,
      -2.1055017518556560E-001,
      -1.0259577033182881E-014,
      2.1055017518554511E-001,
      4.2109203821073354E-001,
      6.3161727724327854E-001,
      8.4211758110719015E-001,
      1.0525846396109357E+000,
      1.2630101438754233E+000,
      1.4733857866620801E+000,
      1.6837032627007200E+000,
      1.8939542690174809E+000,
      2.1041305052626695E+000,
      2.3142236740383892E+000,
      2.5242254812260434E+000,
      2.7341276363138345E+000,
      2.9439218527241207E+000,
      3.1535998481404635E+000,
      3.3631533448346591E+000,
      3.5725740699934412E+000,
      3.7818537560451371E+000,
      3.9909841409861153E+000,
      4.1999569687068963E+000,
      4.4087639893180315E+000,
      4.6173969594758510E+000,
      4.8258476427079611E+000,
      5.0341078097383116E+000,
      5.2421692388121057E+000,
      5.4500237160204437E+000,
      5.6576630356243491E+000,
      5.8650790003790778E+000,
      6.0722634218575555E+000,
      6.2792081207734585E+000,
      6.4859049273044800E+000,
      6.6923456814146212E+000,
      6.8985222331763900E+000,
      7.1044264430925557E+000,
      7.3100501824175330E+000,
      7.5153853334780596E+000,
      7.7204237899940233E+000,
      7.9251574573982975E+000,
      8.1295782531561400E+000,
      8.3336781070846140E+000,
      8.5374489616709646E+000,
      8.7408827723907603E+000,
      8.9439715080254931E+000,
      9.1467071509796778E+000,
      9.3490816975971551E+000,
      9.5510871584774026E+000,
      9.7527155587907721E+000,
      9.9539589385931482E+000,
      1.0154809353140536E+001,
      1.0355258873202480E+001,
      1.0555299585375153E+001,
      1.0754923592393762E+001,
      1.0954123013444381E+001,
      1.1152889984474834E+001,
      1.1351216658505507E+001,
      1.1549095205938956E+001,
      1.1746517814868833E+001,
      1.1943476691388643E+001,
      1.2139964059899182E+001,
      1.2335972163415585E+001,
      1.2531493263873545E+001,
      1.2726519642434855E+001,
      1.2921043599791918E+001,
      1.3115057456472034E+001,
      1.3308553553140396E+001,
      1.3501524250902319E+001,
      1.3693961931605129E+001,
      1.3885858998138701E+001,
      1.4077207874735425E+001,
      1.4268001007269293E+001,
      1.4458230863554176E+001,
      1.4647889933640974E+001,
      1.4836970730114393E+001,
      1.5025465788388404E+001,
      1.5213367667000757E+001,
      1.5400668947907073E+001,
      1.5587362236773494E+001,
      1.5773440163268647E+001,
      1.5958895381354608E+001,
      1.6143720569576921E+001,
      1.6327908431353677E+001,
      1.6511451695263368E+001,
      1.6694343115332263E+001,
      1.6876575471320258E+001,
      1.7058141569006025E+001,
      1.7239034240470811E+001,
      1.7419246344381737E+001,
      1.7598770766273521E+001,
      1.7777600418829365E+001,
      1.7955728242160856E+001,
      1.8133147204086427E+001,
      1.8309850300409302E+001,
      1.8485830555193804E+001,
      1.8661081021040847E+001,
      1.8835594779362015E+001,
      1.9009364940653004E+001,
      1.9182384644765378E+001,
      1.9354647061177484E+001,
      1.9526145389264123E+001,
      1.9696872858564866E+001,
      1.9866822729051595E+001,
      2.0035988291394435E+001,
      2.0204362867226685E+001,
      2.0371939809408300E+001,
      2.0538712502288586E+001,
      2.0704674361967196E+001,
      2.0869818836554067E+001,
      2.1034139406428181E+001,
      2.1197629584494688E+001,
      2.1360282916441363E+001,
      2.1522092980993204E+001,
      2.1683053390165835E+001,
      2.1843157789517953E+001,
      2.2002399858402018E+001,
      2.2160773310213823E+001,
      2.2318271892640656E+001,
      2.2474889387908217E+001,
      2.2630619613025871E+001,
      2.2785456420031029E+001,
      2.2939393696231722E+001,
      2.3092425364447777E+001,
      2.3244545383251012E+001,
      2.3395747747203551E+001,
      2.3546026487094966E+001,
      2.3695375670177928E+001,
      2.3843789400402454E+001,
      2.3991261818648514E+001,
      2.4137787102957599E+001,
      2.4283359468762406E+001,
      2.4427973169115123E+001,
      2.4571622494914507E+001,
      2.4714301775131151E+001,
      2.4856005377031376E+001,
      2.4996727706399614E+001,
      2.5136463207759295E+001,
      2.5275206364592016E+001,
      2.5412951699555546E+001,
      2.5549693774699961E+001,
      2.5685427191682194E+001,
      2.5820146591979398E+001,
      2.5953846657100321E+001,
      2.6086522108795322E+001,
      2.6218167709264755E+001,
      2.6348778261365712E+001,
      2.6478348608817289E+001,
      2.6606873636403943E+001,
      2.6734348270177740E+001,
      2.6860767477658325E+001,
      2.6986126268031892E+001,
      2.7110419692348046E+001,
      2.7233642843715224E+001,
      2.7355790857494394E+001,
      2.7476858911491131E+001,
      2.7596842226145991E+001,
      2.7715736064723092E+001,
      2.7833535733497335E+001,
      2.7950236581939432E+001,
      2.8065834002899745E+001,
      2.8180323432790026E+001,
      2.8293700351763626E+001,
      2.8405960283893915E+001,
      2.8517098797351011E+001,
      2.8627111504576664E+001,
      2.8735994062457575E+001,
      2.8843742172496835E+001,
      2.8950351580983497E+001,
      2.9055818079160677E+001,
      2.9160137503391624E+001,
      2.9263305735324085E+001,
      2.9365318702052932E+001,
      2.9466172376280920E+001,
      2.9565862776477633E+001,
      2.9664385967036800E+001,
      2.9761738058431575E+001,
      2.9857915207368041E+001,
      2.9952913616937057E+001,
      3.0046729536764079E+001,
      3.0139359263157232E+001,
      3.0230799139253527E+001,
      3.0321045555163245E+001,
      3.0410094948112363E+001,
      3.0497943802583361E+001,
      3.0584588650453892E+001,
      3.0670026071133687E+001,
      3.0754252691699694E+001,
      3.0837265187029143E+001,
      3.0919060279930864E+001,
      3.0999634741274647E+001,
      3.1078985390118742E+001,
      3.1157109093835359E+001,
      3.1234002768234468E+001,
      3.1309663377685485E+001,
      3.1384087935237066E+001,
      3.1457273502735127E+001,
      3.1529217190938780E+001,
      3.1599916159634400E+001,
      3.1669367617747756E+001,
      3.1737568823454236E+001,
      3.1804517084286967E+001,
      3.1870209757243259E+001,
      3.1934644248888901E+001,
      3.1997818015460446E+001,
      3.2059728562965780E+001,
      3.2120373447282496E+001,
      3.2179750274254403E+001,
      3.2237856699786036E+001,
      3.2294690429935223E+001,
      3.2350249221003594E+001,
      3.2404530879625241E+001,
      3.2457533262853190E+001,
      3.2509254278244128E+001,
      3.2559691883940907E+001,
      3.2608844088753237E+001,
      3.2656708952236222E+001,
      3.2703284584767019E+001,
      3.2748569147619392E+001,
      3.2792560853036356E+001,
      3.2835257964300716E+001,
      3.2876658795803600E+001,
      3.2916761713111086E+001,
      3.2955565133028657E+001,
      3.2993067523663740E+001,
      3.3029267404486170E+001,
      3.3064163346386636E+001,
      3.3097753971733098E+001,
      3.3130037954425191E+001,
      3.3161014019946563E+001,
      3.3190680945415167E+001,
      3.3219037559631609E+001,
      3.3246082743125292E+001,
      3.3271815428198686E+001,
      3.3296234598969441E+001,
      3.3319339291410522E+001,
      3.3341128593388227E+001,
      3.3361601644698212E+001,
      3.3380757637099492E+001,
      3.3398595814346265E+001,
      3.3415115472217842E+001,
      3.3430315958546416E+001,
      3.3444196673242814E+001,
      3.3456757068320194E+001,
      3.3467996647915662E+001,
      3.3477914968309854E+001,
      3.3486511637944474E+001,
      3.3493786317437717E+001,
      3.3499738719597694E+001,
      3.3504368609433762E+001,
      3.3507675804165800E+001,
      3.3509660173231417E+001,
      3.3510321638291131E+001,
      3.3509660173231417E+001,
      3.3507675804165800E+001,
      3.3504368609433762E+001,
      3.3499738719597694E+001,
      3.3493786317437717E+001,
      3.3486511637944474E+001,
      3.3477914968309854E+001,
      3.3467996647915662E+001,
      3.3456757068320194E+001,
      3.3444196673242814E+001,
      3.3430315958546423E+001,
      3.3415115472217842E+001,
      3.3398595814346265E+001,
      3.3380757637099492E+001,
      3.3361601644698212E+001,
      3.3341128593388227E+001,
      3.3319339291410529E+001,
      3.3296234598969441E+001,
      3.3271815428198686E+001,
      3.3246082743125292E+001,
      3.3219037559631616E+001,
      3.3190680945415174E+001,
      3.3161014019946570E+001,
      3.3130037954425191E+001,
      3.3097753971733106E+001,
      3.3064163346386636E+001,
      3.3029267404486170E+001,
      3.2993067523663740E+001,
      3.2955565133028657E+001,
      3.2916761713111093E+001,
      3.2876658795803600E+001,
      3.2835257964300723E+001,
      3.2792560853036363E+001,
      3.2748569147619399E+001,
      3.2703284584767019E+001,
      3.2656708952236229E+001,
      3.2608844088753244E+001,
      3.2559691883940914E+001,
      3.2509254278244128E+001,
      3.2457533262853190E+001,
      3.2404530879625248E+001,
      3.2350249221003601E+001,
      3.2294690429935230E+001,
      3.2237856699786050E+001,
      3.2179750274254410E+001,
      3.2120373447282503E+001,
      3.2059728562965788E+001,
      3.1997818015460453E+001,
      3.1934644248888894E+001,
      3.1870209757243266E+001,
      3.1804517084286957E+001,
      3.1737568823454225E+001,
      3.1669367617747771E+001,
      3.1599916159634407E+001,
      3.1529217190938787E+001,
      3.1457273502735134E+001,
      3.1384087935237076E+001,
      3.1309663377685474E+001,
      3.1234002768234475E+001,
      3.1157109093835345E+001,
      3.1078985390118728E+001,
      3.0999634741274654E+001,
      3.0919060279930875E+001,
      3.0837265187029150E+001,
      3.0754252691699701E+001,
      3.0670026071133698E+001,
      3.0584588650453878E+001,
      3.0497943802583368E+001,
      3.0410094948112349E+001,
      3.0321045555163231E+001,
      3.0230799139253538E+001,
      3.0139359263157242E+001,
      3.0046729536764090E+001,
      2.9952913616937067E+001,
      2.9857915207368055E+001,
      2.9761738058431561E+001,
      2.9664385967036811E+001,
      2.9565862776477616E+001,
      2.9466172376280902E+001,
      2.9365318702052942E+001,
      2.9263305735324099E+001,
      2.9160137503391635E+001,
      2.9055818079160687E+001,
      2.8950351580983508E+001,
      2.8843742172496853E+001,
      2.8735994062457589E+001,
      2.8627111504576675E+001,
      2.8517098797351029E+001,
      2.8405960283893926E+001,
      2.8293700351763636E+001,
      2.8180323432790036E+001,
      2.8065834002899756E+001,
      2.7950236581939450E+001,
      2.7833535733497349E+001,
      2.7715736064723107E+001,
      2.7596842226146006E+001,
      2.7476858911491146E+001,
      2.7355790857494412E+001,
      2.7233642843715238E+001,
      2.7110419692348060E+001,
      2.6986126268031907E+001,
      2.6860767477658339E+001,
      2.6734348270177755E+001,
      2.6606873636403957E+001,
      2.6478348608817306E+001,
      2.6348778261365730E+001,
      2.6218167709264769E+001,
      2.6086522108795343E+001,
      2.5953846657100335E+001,
      2.5820146591979412E+001,
      2.5685427191682209E+001,
      2.5549693774699978E+001,
      2.5412951699555563E+001,
      2.5275206364592034E+001,
      2.5136463207759274E+001,
      2.4996727706399628E+001,
      2.4856005377031394E+001,
      2.4714301775131169E+001,
      2.4571622494914525E+001,
      2.4427973169115141E+001,
      2.4283359468762423E+001,
      2.4137787102957613E+001,
      2.3991261818648532E+001,
      2.3843789400402429E+001,
      2.3695375670177942E+001,
      2.3546026487094981E+001,
      2.3395747747203565E+001,
      2.3244545383251030E+001,
      2.3092425364447795E+001,
      2.2939393696231740E+001,
      2.2785456420031046E+001,
      2.2630619613025889E+001,
      2.2474889387908188E+001,
      2.2318271892640674E+001,
      2.2160773310213841E+001,
      2.2002399858402036E+001,
      2.1843157789517971E+001,
      2.1683053390165853E+001,
      2.1522092980993225E+001,
      2.1360282916441385E+001,
      2.1197629584494710E+001,
      2.1034139406428153E+001,
      2.0869818836554089E+001,
      2.0704674361967214E+001,
      2.0538712502288607E+001,
      2.0371939809408318E+001,
      2.0204362867226703E+001,
      2.0035988291394506E+001,
      1.9866822729051616E+001,
      1.9696872858564884E+001,
      1.9526145389264094E+001,
      1.9354647061177502E+001,
      1.9182384644765403E+001,
      1.9009364940653022E+001,
      1.8835594779362033E+001,
      1.8661081021040868E+001,
      1.8485830555193875E+001,
      1.8309850300409327E+001,
      1.8133147204086445E+001,
      1.7955728242160827E+001,
      1.7777600418829387E+001,
      1.7598770766273539E+001,
      1.7419246344381762E+001,
      1.7239034240470833E+001,
      1.7058141569006047E+001,
      1.6876575471320333E+001,
      1.6694343115332284E+001,
      1.6511451695263389E+001,
      1.6327908431353645E+001,
      1.6143720569576946E+001,
      1.5958895381354631E+001,
      1.5773440163268669E+001,
      1.5587362236773515E+001,
      1.5400668947907093E+001,
      1.5213367667000780E+001,
      1.5025465788388372E+001,
      1.4836970730114412E+001,
      1.4647889933640942E+001,
      1.4458230863554146E+001,
      1.4268001007269314E+001,
      1.4077207874735446E+001,
      1.3885858998138723E+001,
      1.3693961931605156E+001,
      1.3501524250902342E+001,
      1.3308553553140364E+001,
      1.3115057456472055E+001,
      1.2921043599791888E+001,
      1.2726519642434823E+001,
      1.2531493263873569E+001,
      1.2335972163415610E+001,
      1.2139964059899206E+001,
      1.1943476691388664E+001,
      1.1746517814868858E+001,
      1.1549095205938922E+001,
      1.1351216658505530E+001,
      1.1152889984474800E+001,
      1.0954123013444347E+001,
      1.0754923592393785E+001,
      1.0555299585375176E+001,
      1.0355258873202503E+001,
      1.0154809353140557E+001,
      9.9539589385931695E+000,
      9.7527155587907384E+000,
      9.5510871584774275E+000,
      9.3490816975971214E+000,
      9.1467071509796440E+000,
      8.9439715080255162E+000,
      8.7408827723907851E+000,
      8.5374489616709894E+000,
      8.3336781070846371E+000,
      8.1295782531561649E+000,
      7.9251574573983214E+000,
      7.7204237899941051E+000,
      7.5153853334780836E+000,
      7.3100501824175570E+000,
      7.1044264430925796E+000,
      6.8985222331764140E+000,
      6.6923456814146451E+000,
      6.4859049273045049E+000,
      6.2792081207734833E+000,
      6.0722634218575795E+000,
      5.8650790003791018E+000,
      5.6576630356243731E+000,
      5.4500237160204676E+000,
      5.2421692388121297E+000,
      5.0341078097383356E+000,
      4.8258476427079851E+000,
      4.6173969594758750E+000,
      4.4087639893180555E+000,
      4.1999569687069505E+000,
      3.9909841409861397E+000,
      3.7818537560451615E+000,
      3.5725740699934661E+000,
      3.3631533448346542E+000,
      3.1535998481404883E+000,
      2.9439218527241460E+000,
      2.7341276363138594E+000,
      2.5242254812260678E+000,
      2.3142236740384430E+000,
      2.1041305052626940E+000,
      1.8939542690175053E+000,
      1.6837032627007449E+000,
      1.4733857866620750E+000,
      1.2630101438754480E+000,
      1.0525846396109604E+000,
      8.4211758110721469E-001,
      6.3161727724330319E-001,
      4.2109203821078789E-001,
      2.1055017518556973E-001,
      1.4363407846456031E-014,
      -2.1055017518560051E-001,
      -4.2109203821075913E-001,
      -6.3161727724327443E-001,
      -8.4211758110718604E-001,
      -1.0525846396109317E+000,
      -1.2630101438754193E+000,
      -1.4733857866621058E+000,
      -1.6837032627007160E+000,
      -1.8939542690175362E+000,
      -2.1041305052626660E+000,
      -2.3142236740384146E+000,
      -2.5242254812260390E+000,
      -2.7341276363138309E+000,
      -2.9439218527241171E+000,
      -3.1535998481404595E+000,
      -3.3631533448346249E+000,
      -3.5725740699934372E+000,
      -3.7818537560451335E+000,
      -3.9909841409861704E+000,
      -4.1999569687069211E+000,
      -4.4087639893180270E+000,
      -4.6173969594758466E+000,
      -4.8258476427079575E+000,
      -5.0341078097383081E+000,
      -5.2421692388121022E+000,
      -5.4500237160204392E+000,
      -5.6576630356242852E+000,
      -5.8650790003790734E+000,
      -6.0722634218574916E+000,
      -6.2792081207734540E+000,
      -6.4859049273044764E+000,
      -6.6923456814146167E+000,
      -6.8985222331763865E+000,
      -7.1044264430925512E+000,
      -7.3100501824174700E+000,
      -7.5153853334780560E+000,
      -7.7204237899940198E+000,
      -7.9251574573982939E+000,
      -8.1295782531561365E+000,
      -8.3336781070846104E+000,
      -8.5374489616709610E+000,
      -8.7408827723907567E+000,
      -8.9439715080254896E+000,
      -9.1467071509796742E+000,
      -9.3490816975970930E+000,
      -9.5510871584774559E+000,
      -9.7527155587907117E+000,
      -9.9539589385931446E+000,
      -1.0154809353140532E+001,
      -1.0355258873202477E+001,
      -1.0555299585375149E+001,
      -1.0754923592393759E+001,
      -1.0954123013444320E+001,
      -1.1152889984474829E+001,
      -1.1351216658505503E+001,
      -1.1549095205938951E+001,
      -1.1746517814868829E+001,
      -1.1943476691388639E+001,
      -1.2139964059899178E+001,
      -1.2335972163415581E+001,
      -1.2531493263873541E+001,
      -1.2726519642434852E+001,
      -1.2921043599791860E+001,
      -1.3115057456472085E+001,
      -1.3308553553140339E+001,
      -1.3501524250902316E+001,
      -1.3693961931605125E+001,
      -1.3885858998138698E+001,
      -1.4077207874735421E+001,
      -1.4268001007269287E+001,
      -1.4458230863554119E+001,
      -1.4647889933640970E+001,
      -1.4836970730114389E+001,
      -1.5025465788388400E+001,
      -1.5213367667000751E+001,
      -1.5400668947907070E+001,
      -1.5587362236773489E+001,
      -1.5773440163268642E+001,
      -1.5958895381354605E+001,
      -1.6143720569576971E+001,
      -1.6327908431353624E+001,
      -1.6511451695263418E+001,
      -1.6694343115332259E+001,
      -1.6876575471320308E+001,
      -1.7058141569006018E+001,
      -1.7239034240470808E+001,
      -1.7419246344381733E+001,
      -1.7598770766273518E+001,
      -1.7777600418829362E+001,
      -1.7955728242160852E+001,
      -1.8133147204086423E+001,
      -1.8309850300409348E+001,
      -1.8485830555193850E+001,
      -1.8661081021040843E+001,
      -1.8835594779362012E+001,
      -1.9009364940653001E+001,
      -1.9182384644765374E+001,
      -1.9354647061177531E+001,
      -1.9526145389264073E+001,
      -1.9696872858564912E+001,
      -1.9866822729051592E+001,
      -2.0035988291394482E+001,
      -2.0204362867226681E+001,
      -2.0371939809408296E+001,
      -2.0538712502288586E+001,
      -2.0704674361967189E+001,
      -2.0869818836554067E+001,
      -2.1034139406428178E+001,
      -2.1197629584494685E+001,
      -2.1360282916441406E+001,
      -2.1522092980993204E+001,
      -2.1683053390165831E+001,
      -2.1843157789517949E+001,
      -2.2002399858402015E+001,
      -2.2160773310213820E+001,
      -2.2318271892640695E+001,
      -2.2474889387908171E+001,
      -2.2630619613025914E+001,
      -2.2785456420031029E+001,
      -2.2939393696231722E+001,
      -2.3092425364447774E+001,
      -2.3244545383251008E+001,
      -2.3395747747203547E+001,
      -2.3546026487094963E+001,
      -2.3695375670177924E+001,
      -2.3843789400402450E+001,
      -2.3991261818648510E+001,
      -2.4137787102957635E+001,
      -2.4283359468762406E+001,
      -2.4427973169115120E+001,
      -2.4571622494914507E+001,
      -2.4714301775131148E+001,
      -2.4856005377031373E+001,
      -2.4996727706399650E+001,
      -2.5136463207759256E+001,
      -2.5275206364592052E+001,
      -2.5412951699555546E+001,
      -2.5549693774699961E+001,
      -2.5685427191682194E+001,
      -2.5820146591979395E+001,
      -2.5953846657100318E+001,
      -2.6086522108795322E+001,
      -2.6218167709264751E+001,
      -2.6348778261365748E+001,
      -2.6478348608817285E+001,
      -2.6606873636403979E+001,
      -2.6734348270177737E+001,
      -2.6860767477658321E+001,
      -2.6986126268031889E+001,
      -2.7110419692348042E+001,
      -2.7233642843715220E+001,
      -2.7355790857494430E+001,
      -2.7476858911491128E+001,
      -2.7596842226145952E+001,
      -2.7715736064723092E+001,
      -2.7833535733497303E+001,
      -2.7950236581939429E+001,
      -2.8065834002899742E+001,
      -2.8180323432790022E+001,
      -2.8293700351763622E+001,
      -2.8405960283893911E+001,
      -2.8517098797350982E+001,
      -2.8627111504576661E+001,
      -2.8735994062457575E+001,
      -2.8843742172496835E+001,
      -2.8950351580983494E+001,
      -2.9055818079160673E+001,
      -2.9160137503391621E+001,
      -2.9263305735324085E+001,
      -2.9365318702052928E+001,
      -2.9466172376280916E+001,
      -2.9565862776477605E+001,
      -2.9664385967036797E+001,
      -2.9761738058431547E+001,
      -2.9857915207368038E+001,
      -2.9952913616937053E+001,
      -3.0046729536764076E+001,
      -3.0139359263157232E+001,
      -3.0230799139253520E+001,
      -3.0321045555163220E+001,
      -3.0410094948112363E+001,
      -3.0497943802583357E+001,
      -3.0584588650453892E+001,
      -3.0670026071133687E+001,
      -3.0754252691699691E+001,
      -3.0837265187029139E+001,
      -3.0919060279930864E+001,
      -3.0999634741274644E+001,
      -3.1078985390118739E+001,
      -3.1157109093835334E+001,
      -3.1234002768234465E+001,
      -3.1309663377685464E+001,
      -3.1384087935237066E+001,
      -3.1457273502735120E+001,
      -3.1529217190938777E+001,
      -3.1599916159634397E+001,
      -3.1669367617747756E+001,
      -3.1737568823454215E+001,
      -3.1804517084286967E+001,
      -3.1870209757243259E+001,
      -3.1934644248888901E+001,
      -3.1997818015460442E+001,
      -3.2059728562965780E+001,
      -3.2120373447282496E+001,
      -3.2179750274254395E+001,
      -3.2237856699786036E+001,
      -3.2294690429935237E+001,
      -3.2350249221003594E+001,
      -3.2404530879625241E+001,
      -3.2457533262853190E+001,
      -3.2509254278244128E+001,
      -3.2559691883940907E+001,
      -3.2608844088753237E+001,
      -3.2656708952236222E+001,
      -3.2703284584767019E+001,
      -3.2748569147619392E+001,
      -3.2792560853036370E+001,
      -3.2835257964300716E+001,
      -3.2876658795803607E+001,
      -3.2916761713111086E+001,
      -3.2955565133028657E+001,
      -3.2993067523663740E+001,
      -3.3029267404486170E+001,
      -3.3064163346386636E+001,
      -3.3097753971733106E+001,
      -3.3130037954425191E+001,
      -3.3161014019946570E+001,
      -3.3190680945415167E+001,
      -3.3219037559631609E+001,
      -3.3246082743125292E+001,
      -3.3271815428198686E+001,
      -3.3296234598969441E+001,
      -3.3319339291410522E+001,
      -3.3341128593388227E+001,
      -3.3361601644698219E+001,
      -3.3380757637099492E+001,
      -3.3398595814346265E+001,
      -3.3415115472217835E+001,
      -3.3430315958546416E+001,
      -3.3444196673242814E+001,
      -3.3456757068320194E+001,
      -3.3467996647915662E+001,
      -3.3477914968309854E+001,
      -3.3486511637944474E+001,
      -3.3493786317437717E+001,
      -3.3499738719597694E+001,
      -3.3504368609433762E+001,
      -3.3507675804165800E+001,
      -3.3509660173231417E+001,
      -3.3510321638291131E+001,
      -3.3509660173231417E+001,
      -3.3507675804165800E+001,
      -3.3504368609433762E+001,
      -3.3499738719597694E+001,
      -3.3493786317437717E+001,
      -3.3486511637944474E+001,
      -3.3477914968309854E+001,
      -3.3467996647915662E+001,
      -3.3456757068320194E+001,
      -3.3444196673242821E+001,
      -3.3430315958546416E+001,
      -3.3415115472217842E+001,
      -3.3398595814346258E+001,
      -3.3380757637099492E+001,
      -3.3361601644698219E+001,
      -3.3341128593388227E+001,
      -3.3319339291410529E+001,
      -3.3296234598969448E+001,
      -3.3271815428198693E+001,
      -3.3246082743125292E+001,
      -3.3219037559631609E+001,
      -3.3190680945415174E+001,
      -3.3161014019946563E+001,
      -3.3130037954425205E+001,
      -3.3097753971733106E+001,
      -3.3064163346386636E+001,
      -3.3029267404486170E+001,
      -3.2993067523663747E+001,
      -3.2955565133028649E+001,
      -3.2916761713111079E+001,
      -3.2876658795803600E+001,
      -3.2835257964300723E+001,
      -3.2792560853036377E+001,
      -3.2748569147619399E+001,
      -3.2703284584767033E+001,
      -3.2656708952236229E+001,
      -3.2608844088753244E+001,
      -3.2559691883940914E+001,
      -3.2509254278244136E+001,
      -3.2457533262853197E+001,
      -3.2404530879625248E+001,
      -3.2350249221003615E+001,
      -3.2294690429935244E+001,
      -3.2237856699786050E+001,
      -3.2179750274254410E+001,
      -3.2120373447282503E+001,
      -3.2059728562965788E+001,
      -3.1997818015460435E+001,
      -3.1934644248888894E+001,
      -3.1870209757243270E+001,
      -3.1804517084286974E+001,
      -3.1737568823454225E+001,
      -3.1669367617747792E+001,
      -3.1599916159634407E+001,
      -3.1529217190938787E+001,
      -3.1457273502735134E+001,
      -3.1384087935237076E+001,
      -3.1309663377685474E+001,
      -3.1234002768234479E+001,
      -3.1157109093835366E+001,
      -3.1078985390118753E+001,
      -3.0999634741274658E+001,
      -3.0919060279930875E+001,
      -3.0837265187029153E+001,
      -3.0754252691699705E+001,
      -3.0670026071133677E+001,
      -3.0584588650453881E+001,
      -3.0497943802583372E+001,
      -3.0410094948112377E+001,
      -3.0321045555163231E+001,
      -3.0230799139253563E+001,
      -3.0139359263157250E+001,
      -3.0046729536764090E+001,
      -2.9952913616937042E+001,
      -2.9857915207368055E+001,
      -2.9761738058431565E+001,
      -2.9664385967036811E+001,
      -2.9565862776477644E+001,
      -2.9466172376280930E+001,
      -2.9365318702052942E+001,
      -2.9263305735324103E+001,
      -2.9160137503391635E+001,
      -2.9055818079160691E+001,
      -2.8950351580983479E+001,
      -2.8843742172496821E+001,
      -2.8735994062457589E+001,
      -2.8627111504576678E+001,
      -2.8517098797350997E+001,
      -2.8405960283893958E+001,
      -2.8293700351763640E+001,
      -2.8180323432790043E+001,
      -2.8065834002899727E+001,
      -2.7950236581939450E+001,
      -2.7833535733497317E+001,
      -2.7715736064723110E+001,
      -2.7596842226146009E+001,
      -2.7476858911491181E+001,
      -2.7355790857494416E+001,
      -2.7233642843715241E+001,
      -2.7110419692348067E+001,
      -2.6986126268031907E+001,
      -2.6860767477658307E+001,
      -2.6734348270177723E+001,
      -2.6606873636403961E+001,
      -2.6478348608817310E+001,
      -2.6348778261365734E+001,
      -2.6218167709264812E+001,
      -2.6086522108795343E+001,
      -2.5953846657100339E+001,
      -2.5820146591979380E+001,
      -2.5685427191682212E+001,
      -2.5549693774699943E+001,
      -2.5412951699555563E+001,
      -2.5275206364592034E+001,
      -2.5136463207759316E+001,
      -2.4996727706399632E+001,
      -2.4856005377031394E+001,
      -2.4714301775131172E+001,
      -2.4571622494914529E+001,
      -2.4427973169115099E+001,
      -2.4283359468762384E+001,
      -2.4137787102957617E+001,
      -2.3991261818648532E+001,
      -2.3843789400402432E+001,
      -2.3695375670177992E+001,
      -2.3546026487094984E+001,
      -2.3395747747203572E+001,
      -2.3244545383250991E+001,
      -2.3092425364447799E+001,
      -2.2939393696231701E+001,
      -2.2785456420031053E+001,
      -2.2630619613025889E+001,
      -2.2474889387908238E+001,
      -2.2318271892640677E+001,
      -2.2160773310213841E+001,
      -2.2002399858402040E+001,
      -2.1843157789517974E+001,
      -2.1683053390165814E+001,
      -2.1522092980993179E+001,
      -2.1360282916441388E+001,
      -2.1197629584494713E+001,
      -2.1034139406428153E+001,
      -2.0869818836554089E+001,
      -2.0704674361967218E+001,
      -2.0538712502288611E+001,
      -2.0371939809408275E+001,
      -2.0204362867226706E+001,
      -2.0035988291394464E+001,
      -1.9866822729051620E+001,
      -1.9696872858564888E+001,
      -1.9526145389264148E+001,
      -1.9354647061177506E+001,
      -1.9182384644765403E+001,
      -1.9009364940653025E+001,
      -1.8835594779362040E+001,
      -1.8661081021040818E+001,
      -1.8485830555193825E+001,
      -1.8309850300409376E+001,
      -1.8133147204086448E+001,
      -1.7955728242160877E+001,
      -1.7777600418829390E+001,
      -1.7598770766273596E+001,
      -1.7419246344381765E+001,
      -1.7239034240470836E+001,
      -1.7058141569006050E+001,
      -1.6876575471320336E+001,
      -1.6694343115332288E+001,
      -1.6511451695263393E+001,
      -1.6327908431353702E+001,
      -1.6143720569576999E+001,
      -1.5958895381354635E+001,
      -1.5773440163268672E+001,
      -1.5587362236773519E+001,
      -1.5400668947907096E+001,
      -1.5213367667000727E+001,
      -1.5025465788388431E+001,
      -1.4836970730114418E+001,
      -1.4647889933641000E+001,
      -1.4458230863554149E+001,
      -1.4268001007269371E+001,
      -1.4077207874735450E+001,
      -1.3885858998138726E+001,
      -1.3693961931605159E+001,
      -1.3501524250902346E+001,
      -1.3308553553140369E+001,
      -1.3115057456472059E+001,
      -1.2921043599791945E+001,
      -1.2726519642434880E+001,
      -1.2531493263873573E+001,
      -1.2335972163415613E+001,
      -1.2139964059899210E+001,
      -1.1943476691388668E+001,
      -1.1746517814868804E+001,
      -1.1549095205938926E+001,
      -1.1351216658505534E+001,
      -1.1152889984474861E+001,
      -1.0954123013444352E+001,
      -1.0754923592393846E+001,
      -1.0555299585375179E+001,
      -1.0355258873202507E+001,
      -1.0154809353140564E+001,
      -9.9539589385931748E+000,
      -9.7527155587907419E+000,
      -9.5510871584774311E+000,
      -9.3490816975971818E+000,
      -9.1467071509797027E+000,
      -8.9439715080255215E+000,
      -8.7408827723907887E+000,
      -8.5374489616709930E+000,
      -8.3336781070846406E+000,
      -8.1295782531561098E+000,
      -7.9251574573982682E+000,
      -7.7204237899940518E+000,
      -7.5153853334780880E+000,
      -7.3100501824175028E+000,
      -7.1044264430926409E+000,
      -6.8985222331764184E+000,
      -6.6923456814146487E+000,
      -6.4859049273045084E+000,
      -6.2792081207734869E+000,
      -6.0722634218575244E+000,
      -5.8650790003791062E+000,
      -5.6576630356243767E+000,
      -5.4500237160204721E+000,
      -5.2421692388121341E+000,
      -5.0341078097383392E+000,
      -4.8258476427079895E+000,
      -4.6173969594758786E+000,
      -4.4087639893180004E+000,
      -4.1999569687068954E+000,
      -3.9909841409861437E+000,
      -3.7818537560451659E+000,
      -3.5725740699934110E+000,
      -3.3631533448347173E+000,
      -3.1535998481404928E+000,
      -2.9439218527241500E+000,
      -2.7341276363138634E+000,
      -2.5242254812260714E+000,
      -2.3142236740383879E+000,
      -2.1041305052626984E+000,
      -1.8939542690175095E+000,
      -1.6837032627007491E+000,
      -1.4733857866620790E+000,
      -1.2630101438754522E+000,
      -1.0525846396109646E+000,
      -8.4211758110721879E-001,
      -6.3161727724324768E-001,
      -4.2109203821073249E-001,
      -2.1055017518557384E-001,
      -1.8467238659729185E-014,
      2.1055017518559643E-001,
      4.2109203821069563E-001,
      6.3161727724327021E-001,
      8.4211758110718193E-001,
      1.0525846396109872E+000,
      1.2630101438754151E+000,
      1.4733857866621016E+000,
      1.6837032627007120E+000,
      1.8939542690174724E+000,
      2.1041305052626620E+000,
      2.3142236740384110E+000,
      2.5242254812260345E+000,
      2.7341276363138265E+000,
      2.9439218527241131E+000,
      3.1535998481405150E+000,
      3.3631533448346804E+000,
      3.5725740699934332E+000,
      3.7818537560451291E+000,
      3.9909841409861659E+000,
      4.1999569687068581E+000,
      4.4087639893180226E+000,
      4.6173969594758431E+000,
      4.8258476427080117E+000,
      5.0341078097383027E+000,
      5.2421692388121572E+000,
      5.4500237160204357E+000,
      5.6576630356243403E+000,
      5.8650790003790698E+000,
      6.0722634218575466E+000,
      6.2792081207734496E+000,
      6.4859049273044729E+000,
      6.6923456814146123E+000,
      6.8985222331764398E+000,
      7.1044264430926054E+000,
      7.3100501824175250E+000,
      7.5153853334780525E+000,
      7.7204237899940740E+000,
      7.9251574573982317E+000,
      8.1295782531561311E+000,
      8.3336781070846069E+000,
      8.5374489616710143E+000,
      8.7408827723907532E+000,
      8.9439715080255429E+000,
      9.1467071509796689E+000,
      9.3490816975971462E+000,
      9.5510871584773955E+000,
      9.7527155587907650E+000,
      9.9539589385931411E+000,
      1.0154809353140529E+001,
      1.0355258873202473E+001,
      1.0555299585375201E+001,
      1.0754923592393810E+001,
      1.0954123013444372E+001,
      1.1152889984474825E+001,
      1.1351216658505555E+001,
      1.1549095205938892E+001,
      1.1746517814868826E+001,
      1.1943476691388636E+001,
      1.2139964059899230E+001,
      1.2335972163415578E+001,
      1.2531493263873593E+001,
      1.2726519642434848E+001,
      1.2921043599791911E+001,
      1.3115057456472027E+001,
      1.3308553553140388E+001,
      1.3501524250902312E+001,
      1.3693961931605122E+001,
      1.3885858998138694E+001,
      1.4077207874735471E+001,
      1.4268001007269339E+001,
      1.4458230863554169E+001,
      1.4647889933640966E+001,
      1.4836970730114437E+001,
      1.5025465788388397E+001,
      1.5213367667000748E+001,
      1.5400668947907064E+001,
      1.5587362236773540E+001,
      1.5773440163268639E+001,
      1.5958895381354653E+001,
      1.6143720569576967E+001,
      1.6327908431353670E+001,
      1.6511451695263361E+001,
      1.6694343115332309E+001,
      1.6876575471320304E+001,
      1.7058141569006018E+001,
      1.7239034240470804E+001,
      1.7419246344381783E+001,
      1.7598770766273560E+001,
      1.7777600418829408E+001,
      1.7955728242160848E+001,
      1.8133147204086470E+001,
      1.8309850300409348E+001,
      1.8485830555193793E+001,
      1.8661081021040840E+001,
      1.8835594779362008E+001,
      1.9009364940652997E+001,
      1.9182384644765371E+001,
      1.9354647061177527E+001,
      1.9526145389264116E+001,
      1.9696872858564859E+001,
      1.9866822729051588E+001,
      2.0035988291394478E+001,
      2.0204362867226678E+001,
      2.0371939809408293E+001,
      2.0538712502288583E+001,
      2.0704674361967236E+001,
      2.0869818836554064E+001,
      2.1034139406428174E+001,
      2.1197629584494685E+001,
      2.1360282916441406E+001,
      2.1522092980993147E+001,
      2.1683053390165828E+001,
      2.1843157789517942E+001,
      2.2002399858402011E+001,
      2.2160773310213816E+001,
      2.2318271892640691E+001,
      2.2474889387908210E+001,
      2.2630619613025864E+001,
      2.2785456420031025E+001,
      2.2939393696231718E+001,
      2.3092425364447770E+001,
      2.3244545383251005E+001,
      2.3395747747203544E+001,
      2.3546026487095002E+001,
      2.3695375670177963E+001,
      2.3843789400402450E+001,
      2.3991261818648510E+001,
      2.4137787102957631E+001,
      2.4283359468762360E+001,
      2.4427973169115116E+001,
      2.4571622494914504E+001,
      2.4714301775131148E+001,
      2.4856005377031373E+001,
      2.4996727706399650E+001,
      2.5136463207759292E+001,
      2.5275206364592012E+001,
      2.5412951699555542E+001,
      2.5549693774699957E+001,
      2.5685427191682191E+001,
      2.5820146591979391E+001,
      2.5953846657100314E+001,
      2.6086522108795357E+001,
      2.6218167709264783E+001,
      2.6348778261365748E+001,
      2.6478348608817281E+001,
      2.6606873636403975E+001,
      2.6734348270177701E+001,
      2.6860767477658317E+001,
      2.6986126268031889E+001,
      2.7110419692348042E+001,
      2.7233642843715220E+001,
      2.7355790857494426E+001,
      2.7476858911491160E+001,
      2.7596842226145988E+001,
      2.7715736064723089E+001,
      2.7833535733497332E+001,
      2.7950236581939429E+001,
      2.8065834002899742E+001,
      2.8180323432790022E+001,
      2.8293700351763651E+001,
      2.8405960283893940E+001,
      2.8517098797351011E+001,
      2.8627111504576661E+001,
      2.8735994062457600E+001,
      2.8843742172496800E+001,
      2.8950351580983494E+001,
      2.9055818079160673E+001,
      2.9160137503391621E+001,
      2.9263305735324082E+001,
      2.9365318702052953E+001,
      2.9466172376280916E+001,
      2.9565862776477630E+001,
      2.9664385967036797E+001,
      2.9761738058431572E+001,
      2.9857915207368038E+001,
      2.9952913616937053E+001,
      3.0046729536764076E+001,
      3.0139359263157257E+001,
      3.0230799139253548E+001,
      3.0321045555163241E+001,
      3.0410094948112359E+001,
      3.0497943802583379E+001,
      3.0584588650453867E+001,
      3.0670026071133684E+001,
      3.0754252691699691E+001,
      3.0837265187029164E+001,
      3.0919060279930864E+001,
      3.0999634741274665E+001,
      3.1078985390118739E+001,
      3.1157109093835356E+001,
      3.1234002768234465E+001,
      3.1309663377685485E+001,
      3.1384087935237066E+001,
      3.1457273502735120E+001,
      3.1529217190938777E+001,
      3.1599916159634414E+001,
      3.1669367617747781E+001,
      3.1737568823454232E+001,
      3.1804517084286964E+001,
      3.1870209757243277E+001,
      3.1934644248888883E+001,
      3.1997818015460442E+001,
      3.2059728562965780E+001,
      3.2120373447282510E+001,
      3.2179750274254395E+001,
      3.2237856699786057E+001,
      3.2294690429935237E+001,
      3.2350249221003608E+001,
      3.2404530879625241E+001,
      3.2457533262853197E+001,
      3.2509254278244121E+001,
      3.2559691883940907E+001,
      3.2608844088753237E+001,
      3.2656708952236229E+001,
      3.2703284584767026E+001,
      3.2748569147619406E+001,
      3.2792560853036370E+001,
      3.2835257964300723E+001,
      3.2876658795803593E+001,
      3.2916761713111072E+001,
      3.2955565133028657E+001,
      3.2993067523663740E+001,
      3.3029267404486170E+001,
      3.3064163346386636E+001,
      3.3097753971733106E+001,
      3.3130037954425198E+001,
      3.3161014019946563E+001,
      3.3190680945415167E+001,
      3.3219037559631609E+001,
      3.3246082743125292E+001,
      3.3271815428198686E+001,
      3.3296234598969441E+001,
      3.3319339291410529E+001,
      3.3341128593388227E+001,
      3.3361601644698219E+001,
      3.3380757637099492E+001,
      3.3398595814346258E+001,
      3.3415115472217835E+001,
      3.3430315958546416E+001,
      3.3444196673242814E+001,
      3.3456757068320194E+001,
      3.3467996647915662E+001,
      3.3477914968309854E+001,
      3.3486511637944474E+001,
      3.3493786317437717E+001,
      3.3499738719597694E+001,
      3.3504368609433762E+001,
      3.3507675804165800E+001,
      3.3509660173231417E+001,
      3.3510321638291131E+001,
      3.3509660173231417E+001,
      3.3507675804165800E+001,
      3.3504368609433762E+001,
      3.3499738719597694E+001,
      3.3493786317437717E+001,
      3.3486511637944474E+001,
      3.3477914968309854E+001,
      3.3467996647915662E+001,
      3.3456757068320194E+001,
      3.3444196673242821E+001,
      3.3430315958546416E+001,
      3.3415115472217835E+001,
      3.3398595814346265E+001,
      3.3380757637099492E+001,
      3.3361601644698219E+001,
      3.3341128593388227E+001,
      3.3319339291410529E+001,
      3.3296234598969448E+001,
      3.3271815428198686E+001,
      3.3246082743125292E+001,
      3.3219037559631609E+001,
      3.3190680945415174E+001,
      3.3161014019946563E+001,
      3.3130037954425205E+001,
      3.3097753971733106E+001,
      3.3064163346386636E+001,
      3.3029267404486177E+001,
      3.2993067523663747E+001,
      3.2955565133028649E+001,
      3.2916761713111079E+001,
      3.2876658795803607E+001,
      3.2835257964300723E+001,
      3.2792560853036363E+001,
      3.2748569147619399E+001,
      3.2703284584767026E+001,
      3.2656708952236229E+001,
      3.2608844088753230E+001,
      3.2559691883940914E+001,
      3.2509254278244121E+001,
      3.2457533262853197E+001,
      3.2404530879625234E+001,
      3.2350249221003615E+001,
      3.2294690429935230E+001,
      3.2237856699786050E+001,
      3.2179750274254410E+001,
      3.2120373447282510E+001,
      3.2059728562965752E+001,
      3.1997818015460453E+001,
      3.1934644248888876E+001,
      3.1870209757243291E+001,
      3.1804517084286960E+001,
      3.1737568823454225E+001,
      3.1669367617747771E+001,
      3.1599916159634411E+001,
      3.1529217190938791E+001,
      3.1457273502735138E+001,
      3.1384087935237080E+001,
      3.1309663377685457E+001,
      3.1234002768234458E+001,
      3.1157109093835349E+001,
      3.1078985390118731E+001,
      3.0999634741274658E+001,
      3.0919060279930878E+001,
      3.0837265187029153E+001,
      3.0754252691699659E+001,
      3.0670026071133702E+001,
      3.0584588650453860E+001,
      3.0497943802583400E+001,
      3.0410094948112352E+001,
      3.0321045555163234E+001,
      3.0230799139253541E+001,
      3.0139359263157250E+001,
      3.0046729536764094E+001,
      2.9952913616937018E+001,
      2.9857915207368059E+001,
      2.9761738058431540E+001,
      2.9664385967036786E+001,
      2.9565862776477619E+001,
      2.9466172376280905E+001,
      2.9365318702052946E+001,
      2.9263305735324103E+001,
      2.9160137503391638E+001,
      2.9055818079160630E+001,
      2.8950351580983511E+001,
      2.8843742172496789E+001,
      2.8735994062457625E+001,
      2.8627111504576650E+001,
      2.8517098797351000E+001,
      2.8405960283893929E+001,
      2.8293700351763640E+001,
      2.8180323432790047E+001,
      2.8065834002899695E+001,
      2.7950236581939453E+001,
      2.7833535733497289E+001,
      2.7715736064723078E+001,
      2.7596842226145977E+001,
      2.7476858911491217E+001,
      2.7355790857494416E+001,
      2.7233642843715241E+001,
      2.7110419692348067E+001,
      2.6986126268031910E+001,
      2.6860767477658342E+001,
      2.6734348270177684E+001,
      2.6606873636404003E+001,
      2.6478348608817271E+001,
      2.6348778261365737E+001,
      2.6218167709264772E+001,
      2.6086522108795346E+001,
      2.5953846657100339E+001,
      2.5820146591979345E+001,
      2.5685427191682216E+001,
      2.5549693774699904E+001,
      2.5412951699555610E+001,
      2.5275206364592002E+001,
      2.5136463207759355E+001,
      2.4996727706399636E+001,
      2.4856005377031398E+001,
      2.4714301775131172E+001,
      2.4571622494914532E+001,
      2.4427973169115145E+001,
      2.4283359468762345E+001,
      2.4137787102957660E+001,
      2.3991261818648496E+001,
      2.3843789400402436E+001,
      2.3695375670177953E+001,
      2.3546026487094988E+001,
      2.3395747747203576E+001,
      2.3244545383250948E+001,
      2.3092425364447799E+001,
      2.2939393696231658E+001,
      2.2785456420031100E+001,
      2.2630619613025853E+001,
      2.2474889387908281E+001,
      2.2318271892640681E+001,
      2.2160773310213845E+001,
      2.2002399858402043E+001,
      2.1843157789517981E+001,
      2.1683053390165860E+001,
      2.1522092980993136E+001,
      2.1360282916441435E+001,
      2.1197629584494670E+001,
      2.1034139406428160E+001,
      2.0869818836554092E+001,
      2.0704674361967221E+001,
      2.0538712502288611E+001,
      2.0371939809408232E+001,
      2.0204362867226710E+001,
      2.0035988291394418E+001,
      1.9866822729051673E+001,
      1.9696872858564845E+001,
      1.9526145389264197E+001,
      1.9354647061177509E+001,
      1.9182384644765406E+001,
      1.9009364940653029E+001,
      1.8835594779362044E+001,
      1.8661081021040875E+001,
      1.8485830555193779E+001,
      1.8309850300409380E+001,
      1.8133147204086406E+001,
      1.7955728242160834E+001,
      1.7777600418829394E+001,
      1.7598770766273546E+001,
      1.7419246344381765E+001,
      1.7239034240470737E+001,
      1.7058141569006054E+001,
      1.6876575471320237E+001,
      1.6694343115332344E+001,
      1.6511451695263347E+001,
      1.6327908431353759E+001,
      1.6143720569576953E+001,
      1.5958895381354639E+001,
      1.5773440163268676E+001,
      1.5587362236773522E+001,
      1.5400668947907100E+001,
      1.5213367667000679E+001,
      1.5025465788388434E+001,
      1.4836970730114368E+001,
      1.4647889933640949E+001,
      1.4458230863554153E+001,
      1.4268001007269321E+001,
      1.4077207874735453E+001,
      1.3885858998138623E+001,
      1.3693961931605163E+001,
      1.3501524250902243E+001,
      1.3308553553140426E+001,
      1.3115057456472009E+001,
      1.2921043599792005E+001,
      1.2726519642434830E+001,
      1.2531493263873577E+001,
      1.2335972163415617E+001,
      1.2139964059899214E+001,
      1.1943476691388671E+001,
      1.1746517814868753E+001,
      1.1549095205938986E+001,
      1.1351216658505480E+001,
      1.1152889984474809E+001,
      1.0954123013444356E+001,
      1.0754923592393792E+001,
      1.0555299585375183E+001,
      1.0355258873202397E+001,
      1.0154809353140568E+001,
      9.9539589385930665E+000,
      9.7527155587908041E+000,
      9.5510871584773760E+000,
      9.3490816975972439E+000,
      9.1467071509796511E+000,
      8.9439715080255251E+000,
      8.7408827723907923E+000,
      8.5374489616709965E+000,
      8.3336781070846460E+000,
      8.1295782531560565E+000,
      7.9251574573983294E+000,
      7.7204237899939967E+000,
      7.5153853334780347E+000,
      7.3100501824175064E+000,
      7.1044264430925876E+000,
      6.8985222331764220E+000,
      6.6923456814145368E+000,
      6.4859049273045128E+000,
      6.2792081207733741E+000,
      6.0722634218575866E+000,
      5.8650790003790512E+000,
      5.6576630356244397E+000,
      5.4500237160204170E+000,
      5.2421692388121377E+000,
      5.0341078097383436E+000,
      4.8258476427079930E+000,
      4.6173969594758830E+000,
      4.4087639893179453E+000,
      4.1999569687069593E+000,
      3.9909841409860887E+000,
      3.7818537560452290E+000,
      3.5725740699934150E+000,
      3.3631533448347803E+000,
      3.1535998481404963E+000,
      2.9439218527241540E+000,
      2.7341276363138673E+000,
      2.5242254812260758E+000,
      2.3142236740384514E+000,
      2.1041305052626429E+000,
      1.8939542690175728E+000,
      1.6837032627006936E+000,
      1.4733857866620834E+000,
      1.2630101438754564E+000,
      1.0525846396109688E+000,
      8.4211758110722290E-001,
      6.3161727724319228E-001,
      4.2109203821079616E-001,
      2.1055017518551841E-001,
      8.2097358505682983E-014,
      -2.1055017518559233E-001,
      -4.2109203821075103E-001,
      -6.3161727724326611E-001,
      -8.4211758110717783E-001,
      -1.0525846396109235E+000,
      -1.2630101438755301E+000,
      -1.4733857866620383E+000,
      -1.6837032627007673E+000,
      -1.8939542690175277E+000,
      -2.1041305052627166E+000,
      -2.3142236740384066E+000,
      -2.5242254812260301E+000,
      -2.7341276363138221E+000,
      -2.9439218527241087E+000,
      -3.1535998481405700E+000,
      -3.3631533448346174E+000,
      -3.5725740699934883E+000,
      -3.7818537560451837E+000,
      -3.9909841409861619E+000,
      -4.1999569687067959E+000,
      -4.4087639893180190E+000,
      -4.6173969594759567E+000,
      -4.8258476427079486E+000,
      -5.0341078097382992E+000,
      -5.2421692388122123E+000,
      -5.4500237160204899E+000,
      -5.6576630356242772E+000,
      -5.8650790003791249E+000,
      -6.0722634218574258E+000,
      -6.2792081207734460E+000,
      -6.4859049273044684E+000,
      -6.6923456814146087E+000,
      -6.8985222331764948E+000,
      -7.1044264430925432E+000,
      -7.3100501824175792E+000,
      -7.5153853334779903E+000,
      -7.7204237899940686E+000,
      -7.9251574573982859E+000,
      -8.1295782531561276E+000,
      -8.3336781070846033E+000,
      -8.5374489616709539E+000,
      -8.7408827723907496E+000,
      -8.9439715080254825E+000,
      -9.1467071509797222E+000,
      -9.3490816975970858E+000,
      -9.5510871584774488E+000,
      -9.7527155587907615E+000,
      -9.9539589385931340E+000,
      -1.0154809353140525E+001,
      -1.0355258873202470E+001,
      -1.0555299585375254E+001,
      -1.0754923592393750E+001,
      -1.0954123013444313E+001,
      -1.1152889984474877E+001,
      -1.1351216658505551E+001,
      -1.1549095205938832E+001,
      -1.1746517814868822E+001,
      -1.1943476691388520E+001,
      -1.2139964059899171E+001,
      -1.2335972163415574E+001,
      -1.2531493263873534E+001,
      -1.2726519642434900E+001,
      -1.2921043599791853E+001,
      -1.3115057456472078E+001,
      -1.3308553553140275E+001,
      -1.3501524250902309E+001,
      -1.3693961931605118E+001,
      -1.3885858998138691E+001,
      -1.4077207874735413E+001,
      -1.4268001007269280E+001,
      -1.4458230863554219E+001,
      -1.4647889933640906E+001,
      -1.4836970730114434E+001,
      -1.5025465788388287E+001,
      -1.5213367667000744E+001,
      -1.5400668947907061E+001,
      -1.5587362236773481E+001,
      -1.5773440163268742E+001,
      -1.5958895381354598E+001,
      -1.6143720569577017E+001,
      -1.6327908431353613E+001,
      -1.6511451695263410E+001,
      -1.6694343115332305E+001,
      -1.6876575471320301E+001,
      -1.7058141569006015E+001,
      -1.7239034240470801E+001,
      -1.7419246344381826E+001,
      -1.7598770766273510E+001,
      -1.7777600418829355E+001,
      -1.7955728242160795E+001,
      -1.8133147204086466E+001,
      -1.8309850300409344E+001,
      -1.8485830555193843E+001,
      -1.8661081021040935E+001,
      -1.8835594779362005E+001,
      -1.9009364940652993E+001,
      -1.9182384644765367E+001,
      -1.9354647061177474E+001,
      -1.9526145389264066E+001,
      -1.9696872858564905E+001,
      -1.9866822729051538E+001,
      -2.0035988291394478E+001,
      -2.0204362867226674E+001,
      -2.0371939809408293E+001,
      -2.0538712502288579E+001,
      -2.0704674361967182E+001,
      -2.0869818836554153E+001,
      -2.1034139406428125E+001,
      -2.1197629584494727E+001,
      -2.1360282916441403E+001,
      -2.1522092980993197E+001,
      -2.1683053390165824E+001,
      -2.1843157789517942E+001,
      -2.2002399858402011E+001,
      -2.2160773310213813E+001,
      -2.2318271892640734E+001,
      -2.2474889387908163E+001,
      -2.2630619613025903E+001,
      -2.2785456420031068E+001,
      -2.2939393696231715E+001,
      -2.3092425364447770E+001,
      -2.3244545383251005E+001,
      -2.3395747747203625E+001,
      -2.3546026487094959E+001,
      -2.3695375670178002E+001,
      -2.3843789400402486E+001,
      -2.3991261818648546E+001,
      -2.4137787102957628E+001,
      -2.4283359468762399E+001,
      -2.4427973169115031E+001,
      -2.4571622494914500E+001,
      -2.4714301775131144E+001,
      -2.4856005377031369E+001,
      -2.4996727706399689E+001,
      -2.5136463207759327E+001,
      -2.5275206364592048E+001,
      -2.5412951699555503E+001,
      -2.5549693774699954E+001,
      -2.5685427191682187E+001,
      -2.5820146591979391E+001,
      -2.5953846657100314E+001,
      -2.6086522108795315E+001,
      -2.6218167709264819E+001,
      -2.6348778261365705E+001,
      -2.6478348608817317E+001,
      -2.6606873636403900E+001,
      -2.6734348270177733E+001,
      -2.6860767477658317E+001,
      -2.6986126268031885E+001,
      -2.7110419692348110E+001,
      -2.7233642843715216E+001,
      -2.7355790857494458E+001,
      -2.7476858911491124E+001,
      -2.7596842226146016E+001,
      -2.7715736064723117E+001,
      -2.7833535733497328E+001,
      -2.7950236581939425E+001,
      -2.8065834002899738E+001,
      -2.8180323432790082E+001,
      -2.8293700351763619E+001,
      -2.8405960283893968E+001,
      -2.8517098797350975E+001,
      -2.8627111504576686E+001,
      -2.8735994062457600E+001,
      -2.8843742172496828E+001,
      -2.8950351580983547E+001,
      -2.9055818079160669E+001,
      -2.9160137503391617E+001,
      -2.9263305735324082E+001,
      -2.9365318702052924E+001,
      -2.9466172376280941E+001,
      -2.9565862776477655E+001,
      -2.9664385967036768E+001,
      -2.9761738058431572E+001,
      -2.9857915207367981E+001,
      -2.9952913616937050E+001,
      -3.0046729536764072E+001,
      -3.0139359263157228E+001,
      -3.0230799139253570E+001,
      -3.0321045555163217E+001,
      -3.0410094948112384E+001,
      -3.0497943802583329E+001,
      -3.0584588650453888E+001,
      -3.0670026071133684E+001,
      -3.0754252691699687E+001,
      -3.0837265187029139E+001,
      -3.0919060279930861E+001,
      -3.0999634741274690E+001,
      -3.1078985390118717E+001,
      -3.1157109093835377E+001,
      -3.1234002768234440E+001,
      -3.1309663377685482E+001,
      -3.1384087935237062E+001,
      -3.1457273502735120E+001,
      -3.1529217190938812E+001,
      -3.1599916159634397E+001,
      -3.1669367617747799E+001,
      -3.1737568823454215E+001,
      -3.1804517084286942E+001,
      -3.1870209757243273E+001,
      -3.1934644248888898E+001,
      -3.1997818015460403E+001,
      -3.2059728562965773E+001,
      -3.2120373447282525E+001,
      -3.2179750274254395E+001,
      -3.2237856699786036E+001,
      -3.2294690429935216E+001,
      -3.2350249221003622E+001,
      -3.2404530879625227E+001,
      -3.2457533262853197E+001,
      -3.2509254278244121E+001,
      -3.2559691883940907E+001,
      -3.2608844088753230E+001,
      -3.2656708952236215E+001,
      -3.2703284584767012E+001,
      -3.2748569147619392E+001,
      -3.2792560853036377E+001,
      -3.2835257964300702E+001,
      -3.2876658795803607E+001,
      -3.2916761713111086E+001,
      -3.2955565133028657E+001,
      -3.2993067523663740E+001,
      -3.3029267404486170E+001,
      -3.3064163346386650E+001,
      -3.3097753971733098E+001,
      -3.3130037954425205E+001,
      -3.3161014019946570E+001,
      -3.3190680945415174E+001,
      -3.3219037559631609E+001,
      -3.3246082743125292E+001,
      -3.3271815428198664E+001,
      -3.3296234598969441E+001,
      -3.3319339291410536E+001,
      -3.3341128593388220E+001,
      -3.3361601644698219E+001,
      -3.3380757637099499E+001,
      -3.3398595814346265E+001,
      -3.3415115472217828E+001,
      -3.3430315958546416E+001,
      -3.3444196673242821E+001,
      -3.3456757068320194E+001,
      -3.3467996647915662E+001,
      -3.3477914968309854E+001,
      -3.3486511637944474E+001,
      -3.3493786317437717E+001,
      -3.3499738719597701E+001,
      -3.3504368609433762E+001,
      -3.3507675804165800E+001,
      -3.3509660173231417E+001,
      -3.3510321638291131E+001,
      -3.3509660173231417E+001,
      -3.3507675804165800E+001,
      -3.3504368609433762E+001,
      -3.3499738719597701E+001,
      -3.3493786317437717E+001,
      -3.3486511637944474E+001,
      -3.3477914968309854E+001,
      -3.3467996647915662E+001,
      -3.3456757068320194E+001,
      -3.3444196673242814E+001,
      -3.3430315958546423E+001,
      -3.3415115472217835E+001,
      -3.3398595814346272E+001,
      -3.3380757637099492E+001,
      -3.3361601644698219E+001,
      -3.3341128593388227E+001,
      -3.3319339291410515E+001,
      -3.3296234598969448E+001,
      -3.3271815428198678E+001,
      -3.3246082743125292E+001,
      -3.3219037559631616E+001,
      -3.3190680945415167E+001,
      -3.3161014019946563E+001,
      -3.3130037954425212E+001,
      -3.3097753971733106E+001,
      -3.3064163346386621E+001,
      -3.3029267404486177E+001,
      -3.2993067523663747E+001,
      -3.2955565133028664E+001,
      -3.2916761713111072E+001,
      -3.2876658795803614E+001,
      -3.2835257964300709E+001,
      -3.2792560853036342E+001,
      -3.2748569147619399E+001,
      -3.2703284584767026E+001,
      -3.2656708952236229E+001,
      -3.2608844088753244E+001,
      -3.2559691883940921E+001,
      -3.2509254278244107E+001,
      -3.2457533262853211E+001,
      -3.2404530879625234E+001,
      -3.2350249221003608E+001,
      -3.2294690429935230E+001,
      -3.2237856699786050E+001,
      -3.2179750274254410E+001,
      -3.2120373447282475E+001,
      -3.2059728562965795E+001,
      -3.1997818015460421E+001,
      -3.1934644248888912E+001,
      -3.1870209757243291E+001,
      -3.1804517084286960E+001,
      -3.1737568823454229E+001,
      -3.1669367617747813E+001,
      -3.1599916159634411E+001,
      -3.1529217190938748E+001,
      -3.1457273502735138E+001,
      -3.1384087935237080E+001,
      -3.1309663377685503E+001,
      -3.1234002768234461E+001,
      -3.1157109093835395E+001,
      -3.1078985390118735E+001,
      -3.0999634741274615E+001,
      -3.0919060279930878E+001,
      -3.0837265187029161E+001,
      -3.0754252691699712E+001,
      -3.0670026071133702E+001,
      -3.0584588650453910E+001,
      -3.0497943802583350E+001,
      -3.0410094948112402E+001,
      -3.0321045555163234E+001,
      -3.0230799139253541E+001,
      -3.0139359263157250E+001,
      -3.0046729536764094E+001,
      -2.9952913616937071E+001,
      -2.9857915207368002E+001,
      -2.9761738058431593E+001,
      -2.9664385967036790E+001,
      -2.9565862776477623E+001,
      -2.9466172376280909E+001,
      -2.9365318702052946E+001,
      -2.9263305735324106E+001,
      -2.9160137503391642E+001,
      -2.9055818079160694E+001,
      -2.8950351580983455E+001,
      -2.8843742172496857E+001,
      -2.8735994062457564E+001,
      -2.8627111504576654E+001,
      -2.8517098797351000E+001,
      -2.8405960283893997E+001,
      -2.8293700351763643E+001,
      -2.8180323432789983E+001,
      -2.8065834002899763E+001,
      -2.7950236581939453E+001,
      -2.7833535733497293E+001,
      -2.7715736064723082E+001,
      -2.7596842226146048E+001,
      -2.7476858911491153E+001,
      -2.7355790857494487E+001,
      -2.7233642843715245E+001,
      -2.7110419692348071E+001,
      -2.6986126268031914E+001,
      -2.6860767477658278E+001,
      -2.6734348270177762E+001,
      -2.6606873636403932E+001,
      -2.6478348608817349E+001,
      -2.6348778261365737E+001,
      -2.6218167709264776E+001,
      -2.6086522108795350E+001,
      -2.5953846657100346E+001,
      -2.5820146591979423E+001,
      -2.5685427191682145E+001,
      -2.5549693774699985E+001,
      -2.5412951699555535E+001,
      -2.5275206364592076E+001,
      -2.5136463207759281E+001,
      -2.4996727706399639E+001,
      -2.4856005377031401E+001,
      -2.4714301775131094E+001,
      -2.4571622494914532E+001,
      -2.4427973169115063E+001,
      -2.4283359468762431E+001,
      -2.4137787102957667E+001,
      -2.3991261818648500E+001,
      -2.3843789400402439E+001,
      -2.3695375670178038E+001,
      -2.3546026487094991E+001,
      -2.3395747747203494E+001,
      -2.3244545383251037E+001,
      -2.3092425364447806E+001,
      -2.2939393696231754E+001,
      -2.2785456420031014E+001,
      -2.2630619613025942E+001,
      -2.2474889387908199E+001,
      -2.2318271892640595E+001,
      -2.2160773310213848E+001,
      -2.2002399858402043E+001,
      -2.1843157789517985E+001,
      -2.1683053390165860E+001,
      -2.1522092980993232E+001,
      -2.1360282916441342E+001,
      -2.1197629584494763E+001,
      -2.1034139406428164E+001,
      -2.0869818836554096E+001,
      -2.0704674361967225E+001,
      -2.0538712502288615E+001,
      -2.0371939809408328E+001,
      -2.0204362867226621E+001,
      -2.0035988291394514E+001,
      -1.9866822729051577E+001,
      -1.9696872858564848E+001,
      -1.9526145389264105E+001,
      -1.9354647061177513E+001,
      -1.9182384644765410E+001,
      -1.9009364940653033E+001,
      -1.8835594779362047E+001,
      -1.8661081021040779E+001,
      -1.8485830555193886E+001,
      -1.8309850300409284E+001,
      -1.8133147204086409E+001,
      -1.7955728242160838E+001,
      -1.7777600418829397E+001,
      -1.7598770766273550E+001,
      -1.7419246344381669E+001,
      -1.7239034240470840E+001,
      -1.7058141569006057E+001,
      -1.6876575471320240E+001,
      -1.6694343115332245E+001,
      -1.6511451695263453E+001,
      -1.6327908431353656E+001,
      -1.6143720569577059E+001,
      -1.5958895381354642E+001,
      -1.5773440163268681E+001,
      -1.5587362236773526E+001,
      -1.5400668947907104E+001,
      -1.5213367667000790E+001,
      -1.5025465788388329E+001,
      -1.4836970730114480E+001,
      -1.4647889933640952E+001,
      -1.4458230863554157E+001,
      -1.4268001007269325E+001,
      -1.4077207874735457E+001,
      -1.3885858998138735E+001,
      -1.3693961931605166E+001,
      -1.3501524250902353E+001,
      -1.3308553553140321E+001,
      -1.3115057456472123E+001,
      -1.2921043599791899E+001,
      -1.2726519642434834E+001,
      -1.2531493263873580E+001,
      -1.2335972163415621E+001,
      -1.2139964059899217E+001,
      -1.1943476691388566E+001,
      -1.1746517814868870E+001,
      -1.1549095205938880E+001,
      -1.1351216658505486E+001,
      -1.1152889984474813E+001,
      -1.0954123013444359E+001,
      -1.0754923592393798E+001,
      -1.0555299585375300E+001,
      -1.0355258873202516E+001,
      -1.0154809353140571E+001,
      -9.9539589385931837E+000,
      -9.7527155587906940E+000,
      -9.5510871584773831E+000,
      -9.3490816975971320E+000,
      -9.1467071509797719E+000,
      -8.9439715080255286E+000,
      -8.7408827723907958E+000,
      -8.5374489616710001E+000,
      -8.3336781070846513E+000,
      -8.1295782531561755E+000,
      -7.9251574573982184E+000,
      -7.7204237899941166E+000,
      -7.5153853334780383E+000,
      -7.3100501824176263E+000,
      -7.1044264430925912E+000,
      -6.8985222331764264E+000,
      -6.6923456814146567E+000,
      -6.4859049273044009E+000,
      -6.2792081207734949E+000,
      -6.0722634218574738E+000,
      -5.8650790003791728E+000,
      -5.6576630356243269E+000,
      -5.4500237160204215E+000,
      -5.2421692388121430E+000,
      -5.0341078097383472E+000,
      -4.8258476427079966E+000,
      -4.6173969594757702E+000,
      -4.4087639893180670E+000,
      -4.1999569687068448E+000,
      -3.9909841409862108E+000,
      -3.7818537560451149E+000,
      -3.5725740699934190E+000,
      -3.3631533448346662E+000,
      -3.1535998481403817E+000,
      -2.9439218527241580E+000,
      -2.7341276363138718E+000,
      -2.5242254812260798E+000,
      -2.3142236740384554E+000,
      -2.1041305052626469E+000,
      -1.8939542690174584E+000,
      -1.6837032627008166E+000,
      -1.4733857866620876E+000,
      -1.2630101438754602E+000,
      -1.0525846396109728E+000,
      -8.4211758110722701E-001,
      -6.3161727724331540E-001,
      -4.2109203821068114E-001,
      -2.1055017518564156E-001,
      3.2851388746405165E-014,
      2.1055017518558825E-001,
      4.2109203821074692E-001,
      6.3161727724326211E-001,
      8.4211758110717372E-001,
      1.0525846396109195E+000,
      1.2630101438754071E+000,
      1.4733857866621531E+000,
      1.6837032627006445E+000,
      1.8939542690175240E+000,
      2.1041305052627126E+000,
      2.3142236740384026E+000,
      2.5242254812260265E+000,
      2.7341276363138181E+000,
      2.9439218527242232E+000,
      3.1535998481404475E+000,
      3.3631533448347319E+000,
      3.5725740699934838E+000,
      3.7818537560451801E+000,
      3.9909841409861579E+000,
      4.1999569687069096E+000,
      4.4087639893178974E+000,
      4.6173969594758342E+000,
      4.8258476427080614E+000,
      5.0341078097382947E+000,
      5.2421692388120897E+000,
      5.4500237160204854E+000,
      5.6576630356243909E+000,
      5.8650790003790032E+000,
      6.0722634218575378E+000,
      6.2792081207734425E+000,
      6.4859049273044649E+000,
      6.6923456814146052E+000,
      6.8985222331763740E+000,
      7.1044264430926560E+000,
      7.3100501824174584E+000,
      7.5153853334781022E+000,
      7.7204237899939487E+000,
      7.9251574573982815E+000,
      8.1295782531561240E+000,
      8.3336781070845980E+000,
      8.5374489616709504E+000,
      8.7408827723907443E+000,
      8.9439715080255908E+000,
      9.1467071509796032E+000,
      9.3490816975971942E+000,
      9.5510871584774435E+000,
      9.7527155587907579E+000,
      9.9539589385930185E+000,
      1.0154809353140520E+001,
      1.0355258873202578E+001,
      1.0555299585375137E+001,
      1.0754923592393862E+001,
      1.0954123013444310E+001,
      1.1152889984474873E+001,
      1.1351216658505434E+001,
      1.1549095205938940E+001,
      1.1746517814868707E+001,
      1.1943476691388627E+001,
      1.2139964059899279E+001,
      1.2335972163415571E+001,
      1.2531493263873640E+001,
      1.2726519642434784E+001,
      1.2921043599791957E+001,
      1.3115057456471964E+001,
      1.3308553553140381E+001,
      1.3501524250902415E+001,
      1.3693961931605115E+001,
      1.3885858998138794E+001,
      1.4077207874735409E+001,
      1.4268001007269385E+001,
      1.4458230863554109E+001,
      1.4647889933641013E+001,
      1.4836970730114324E+001,
      1.5025465788388390E+001,
      1.5213367667000847E+001,
      1.5400668947907057E+001,
      1.5587362236773375E+001,
      1.5773440163268630E+001,
      1.5958895381354701E+001,
      1.6143720569576907E+001,
      1.6327908431353716E+001,
      1.6511451695263510E+001,
      1.6694343115332302E+001,
      1.6876575471320194E+001,
      1.7058141569006011E+001,
      1.7239034240470900E+001,
      1.7419246344381722E+001,
      1.7598770766273606E+001,
      1.7777600418829351E+001,
      1.7955728242160895E+001,
      1.8133147204086363E+001,
      1.8309850300409341E+001,
      1.8485830555193740E+001,
      1.8661081021040836E+001,
      1.8835594779362101E+001,
      1.9009364940652990E+001,
      1.9182384644765463E+001,
      1.9354647061177470E+001,
      1.9526145389264158E+001,
      1.9696872858564802E+001,
      1.9866822729051631E+001,
      2.0035988291394567E+001,
      2.0204362867226674E+001,
      2.0371939809408381E+001,
      2.0538712502288575E+001,
      2.0704674361967086E+001,
      2.0869818836554057E+001,
      2.1034139406428213E+001,
      2.1197629584494631E+001,
      2.1360282916441399E+001,
      2.1522092980993285E+001,
      2.1683053390165824E+001,
      2.1843157789517850E+001,
      2.2002399858402008E+001,
      2.2160773310213898E+001,
      2.2318271892640645E+001,
      2.2474889387908249E+001,
      2.2630619613025988E+001,
      2.2785456420031064E+001,
      2.2939393696231626E+001,
      2.3092425364447767E+001,
      2.3244545383250916E+001,
      2.3395747747203540E+001,
      2.3546026487095038E+001,
      2.3695375670177917E+001,
      2.3843789400402482E+001,
      2.3991261818648461E+001,
      2.4137787102957628E+001,
      2.4283359468762313E+001,
      2.4427973169115109E+001,
      2.4571622494914582E+001,
      2.4714301775131140E+001,
      2.4856005377031448E+001,
      2.4996727706399604E+001,
      2.5136463207759324E+001,
      2.5275206364591966E+001,
      2.5412951699555578E+001,
      2.5549693774699875E+001,
      2.5685427191682187E+001,
      2.5820146591979466E+001,
      2.5953846657100311E+001,
      2.6086522108795389E+001,
      2.6218167709264744E+001,
      2.6348778261365776E+001,
      2.6478348608817242E+001,
      2.6606873636403972E+001,
      2.6734348270177801E+001,
      2.6860767477658314E+001,
      2.6986126268031811E+001,
      2.7110419692348035E+001,
      2.7233642843715284E+001,
      2.7355790857494387E+001,
      2.7476858911491192E+001,
      2.7596842226145945E+001,
      2.7715736064723117E+001,
      2.7833535733497261E+001,
      2.7950236581939421E+001,
      2.8065834002899670E+001,
      2.8180323432790019E+001,
      2.8293700351763679E+001,
      2.8405960283893904E+001,
      2.8517098797351039E+001,
      2.8627111504576625E+001,
      2.8735994062457596E+001,
      2.8843742172496768E+001,
      2.8950351580983483E+001,
      2.9055818079160723E+001,
      2.9160137503391613E+001,
      2.9263305735324138E+001,
      2.9365318702052921E+001,
      2.9466172376280937E+001,
      2.9565862776477598E+001,
      2.9664385967036818E+001,
      2.9761738058431519E+001,
      2.9857915207368034E+001,
      2.9952913616937103E+001,
      3.0046729536764072E+001,
      3.0139359263157171E+001,
      3.0230799139253516E+001,
      3.0321045555163263E+001,
      3.0410094948112334E+001,
      3.0497943802583375E+001,
      3.0584588650453934E+001,
      3.0670026071133684E+001,
      3.0754252691699641E+001,
      3.0837265187029136E+001,
      3.0919060279930903E+001,
      3.0999634741274640E+001,
      3.1078985390118756E+001,
      3.1157109093835331E+001,
      3.1234002768234483E+001,
      3.1309663377685442E+001,
      3.1384087935237062E+001,
      3.1457273502735077E+001,
      3.1529217190938773E+001,
      3.1599916159634436E+001,
      3.1669367617747753E+001,
      3.1737568823454247E+001,
      3.1804517084286942E+001,
      3.1870209757243273E+001,
      3.1934644248888858E+001,
      3.1997818015460442E+001,
      3.2059728562965809E+001,
      3.2120373447282489E+001,
      3.2179750274254431E+001,
      3.2237856699786036E+001,
      3.2294690429935251E+001,
      3.2350249221003594E+001,
      3.2404530879625256E+001,
      3.2457533262853168E+001,
      3.2509254278244121E+001,
      3.2559691883940935E+001,
      3.2608844088753230E+001,
      3.2656708952236187E+001,
      3.2703284584767012E+001,
      3.2748569147619413E+001,
      3.2792560853036356E+001,
      3.2835257964300723E+001,
      3.2876658795803628E+001,
      3.2916761713111086E+001,
      3.2955565133028628E+001,
      3.2993067523663740E+001,
      3.3029267404486149E+001,
      3.3064163346386628E+001,
      3.3097753971733113E+001,
      3.3130037954425191E+001,
      3.3161014019946570E+001,
      3.3190680945415160E+001,
      3.3219037559631609E+001,
      3.3246082743125271E+001,
      3.3271815428198686E+001,
      3.3296234598969455E+001,
      3.3319339291410522E+001,
      3.3341128593388234E+001,
      3.3361601644698212E+001,
      3.3380757637099492E+001,
      3.3398595814346258E+001,
      3.3415115472217835E+001,
      3.3430315958546409E+001,
      3.3444196673242814E+001,
      3.3456757068320201E+001,
      3.3467996647915662E+001,
      3.3477914968309854E+001,
      3.3486511637944474E+001,
      3.3493786317437717E+001,
      3.3499738719597694E+001,
      3.3504368609433762E+001,
      3.3507675804165800E+001,
      3.3509660173231417E+001,
      3.3510321638291131E+001,
      3.3509660173231417E+001,
      3.3507675804165800E+001,
      3.3504368609433762E+001,
      3.3499738719597694E+001,
      3.3493786317437717E+001,
      3.3486511637944474E+001,
      3.3477914968309861E+001,
      3.3467996647915662E+001,
      3.3456757068320186E+001,
      3.3444196673242821E+001,
      3.3430315958546416E+001,
      3.3415115472217842E+001,
      3.3398595814346258E+001,
      3.3380757637099499E+001,
      3.3361601644698219E+001,
      3.3341128593388241E+001,
      3.3319339291410529E+001,
      3.3296234598969434E+001,
      3.3271815428198693E+001,
      3.3246082743125278E+001,
      3.3219037559631616E+001,
      3.3190680945415167E+001,
      3.3161014019946577E+001,
      3.3130037954425198E+001,
      3.3097753971733127E+001,
      3.3064163346386643E+001,
      3.3029267404486156E+001,
      3.2993067523663747E+001,
      3.2955565133028642E+001,
      3.2916761713111093E+001,
      3.2876658795803593E+001,
      3.2835257964300737E+001,
      3.2792560853036363E+001,
      3.2748569147619378E+001,
      3.2703284584767026E+001,
      3.2656708952236201E+001,
      3.2608844088753244E+001,
      3.2559691883940893E+001,
      3.2509254278244136E+001,
      3.2457533262853183E+001,
      3.2404530879625270E+001,
      3.2350249221003608E+001,
      3.2294690429935265E+001,
      3.2237856699786050E+001,
      3.2179750274254452E+001,
      3.2120373447282510E+001,
      3.2059728562965752E+001,
      3.1997818015460457E+001,
      3.1934644248888880E+001,
      3.1870209757243295E+001,
      3.1804517084286960E+001,
      3.1737568823454268E+001,
      3.1669367617747778E+001,
      3.1599916159634375E+001,
      3.1529217190938791E+001,
      3.1457273502735099E+001,
      3.1384087935237080E+001,
      3.1309663377685460E+001,
      3.1234002768234504E+001,
      3.1157109093835352E+001,
      3.1078985390118778E+001,
      3.0999634741274662E+001,
      3.0919060279930832E+001,
      3.0837265187029161E+001,
      3.0754252691699662E+001,
      3.0670026071133705E+001,
      3.0584588650453860E+001,
      3.0497943802583404E+001,
      3.0410094948112356E+001,
      3.0321045555163185E+001,
      3.0230799139253545E+001,
      3.0139359263157200E+001,
      3.0046729536764097E+001,
      2.9952913616937021E+001,
      2.9857915207368062E+001,
      2.9761738058431543E+001,
      2.9664385967036846E+001,
      2.9565862776477623E+001,
      2.9466172376280852E+001,
      2.9365318702052949E+001,
      2.9263305735324163E+001,
      2.9160137503391642E+001,
      2.9055818079160634E+001,
      2.8950351580983515E+001,
      2.8843742172496793E+001,
      2.8735994062457628E+001,
      2.8627111504576654E+001,
      2.8517098797351068E+001,
      2.8405960283893936E+001,
      2.8293700351763583E+001,
      2.8180323432790050E+001,
      2.8065834002899702E+001,
      2.7950236581939457E+001,
      2.7833535733497293E+001,
      2.7715736064723153E+001,
      2.7596842226145981E+001,
      2.7476858911491220E+001,
      2.7355790857494423E+001,
      2.7233642843715177E+001,
      2.7110419692348071E+001,
      2.6986126268031846E+001,
      2.6860767477658346E+001,
      2.6734348270177694E+001,
      2.6606873636404007E+001,
      2.6478348608817278E+001,
      2.6348778261365815E+001,
      2.6218167709264780E+001,
      2.6086522108795275E+001,
      2.5953846657100350E+001,
      2.5820146591979348E+001,
      2.5685427191682219E+001,
      2.5549693774699911E+001,
      2.5412951699555613E+001,
      2.5275206364592005E+001,
      2.5136463207759206E+001,
      2.4996727706399643E+001,
      2.4856005377031483E+001,
      2.4714301775131180E+001,
      2.4571622494914450E+001,
      2.4427973169115152E+001,
      2.4283359468762352E+001,
      2.4137787102957667E+001,
      2.3991261818648503E+001,
      2.3843789400402525E+001,
      2.3695375670177960E+001,
      2.3546026487094910E+001,
      2.3395747747203579E+001,
      2.3244545383250955E+001,
      2.3092425364447809E+001,
      2.2939393696231665E+001,
      2.2785456420031103E+001,
      2.2630619613025857E+001,
      2.2474889387908288E+001,
      2.2318271892640684E+001,
      2.2160773310213763E+001,
      2.2002399858402050E+001,
      2.1843157789517893E+001,
      2.1683053390165863E+001,
      2.1522092980993140E+001,
      2.1360282916441442E+001,
      2.1197629584494674E+001,
      2.1034139406428260E+001,
      2.0869818836554099E+001,
      2.0704674361967133E+001,
      2.0538712502288618E+001,
      2.0371939809408424E+001,
      2.0204362867226720E+001,
      2.0035988291394421E+001,
      1.9866822729051680E+001,
      1.9696872858564852E+001,
      1.9526145389264013E+001,
      1.9354647061177520E+001,
      1.9182384644765509E+001,
      1.9009364940653036E+001,
      1.8835594779361955E+001,
      1.8661081021040879E+001,
      1.8485830555193786E+001,
      1.8309850300409387E+001,
      1.8133147204086413E+001,
      1.7955728242160944E+001,
      1.7777600418829401E+001,
      1.7598770766273653E+001,
      1.7419246344381772E+001,
      1.7239034240470744E+001,
      1.7058141569006061E+001,
      1.6876575471320244E+001,
      1.6694343115332348E+001,
      1.6511451695263354E+001,
      1.6327908431353766E+001,
      1.6143720569576960E+001,
      1.5958895381354539E+001,
      1.5773440163268685E+001,
      1.5587362236773425E+001,
      1.5400668947907107E+001,
      1.5213367667000684E+001,
      1.5025465788388439E+001,
      1.4836970730114377E+001,
      1.4647889933641062E+001,
      1.4458230863554160E+001,
      1.4268001007269220E+001,
      1.4077207874735461E+001,
      1.3885858998138847E+001,
      1.3693961931605170E+001,
      1.3501524250902250E+001,
      1.3308553553140433E+001,
      1.3115057456472016E+001,
      1.2921043599791794E+001,
      1.2726519642434837E+001,
      1.2531493263873696E+001,
      1.2335972163415624E+001,
      1.2139964059899109E+001,
      1.1943476691388682E+001,
      1.1746517814868760E+001,
      1.1549095205938993E+001,
      1.1351216658505489E+001,
      1.1152889984474930E+001,
      1.0954123013444363E+001,
      1.0754923592393915E+001,
      1.0555299585375192E+001,
      1.0355258873202404E+001,
      1.0154809353140575E+001,
      9.9539589385930736E+000,
      9.7527155587908112E+000,
      9.5510871584773867E+000,
      9.3490816975972511E+000,
      9.1467071509796583E+000,
      8.9439715080254185E+000,
      8.7408827723907994E+000,
      8.5374489616708882E+000,
      8.3336781070846548E+000,
      8.1295782531560636E+000,
      7.9251574573983374E+000,
      7.7204237899940047E+000,
      7.5153853334781591E+000,
      7.3100501824175153E+000,
      7.1044264430924793E+000,
      6.8985222331764309E+000,
      6.6923456814147784E+000,
      6.4859049273045200E+000,
      6.2792081207733821E+000,
      6.0722634218575955E+000,
      5.8650790003790600E+000,
      5.6576630356242132E+000,
      5.4500237160204259E+000,
      5.2421692388122638E+000,
      5.0341078097383516E+000,
      4.8258476427078829E+000,
      4.6173969594758910E+000,
      4.4087639893179533E+000,
      4.1999569687069664E+000,
      3.9909841409860971E+000,
      3.7818537560452370E+000,
      3.5725740699934234E+000,
      3.3631533448347888E+000,
      3.1535998481405048E+000,
      2.9439218527240429E+000,
      2.7341276363138753E+000,
      2.5242254812259652E+000,
      2.3142236740384594E+000,
      2.1041305052626513E+000,
      1.8939542690175810E+000,
      1.6837032627007018E+000,
      1.4733857866619726E+000,
      1.2630101438754644E+000,
      1.0525846396108580E+000,
      8.4211758110723123E-001,
      6.3161727724320049E-001,
      4.2109203821080438E-001,
      2.1055017518552660E-001,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      -3.9999999999999997E-001,
      -7.9999999999999993E-001,
      -1.2,
      -1.5999999999999999E+000,
      -1.9999999999999998E+000,
      -2.4,
      -2.8,
      -3.1999999999999997E+000,
      -3.6,
      -3.9999999999999996E+000,
      -4.3999999999999995E+000,
      -4.8,
      -5.2,
      -5.6,
      -5.9999999999999991E+000,
      -6.3999999999999995E+000,
      -6.8,
      -7.2,
      -7.5999999999999988E+000,
      -7.9999999999999991E+000,
      -8.4,
      -8.7999999999999989E+000,
      -9.2,
      -9.6,
      -10.0,
      -10.4,
      -1.0799999999999999E+001,
      -11.2,
      -11.6,
      -1.1999999999999998E+001,
      -1.2399999999999999E+001,
      -1.2799999999999999E+001,
      -13.2,
      -13.6,
      -14.0,
      -14.4,
      -1.4799999999999997E+001,
      -1.5199999999999998E+001,
      -1.5599999999999998E+001,
      -1.5999999999999998E+001,
      -16.4,
      -16.8,
      -1.7200000000000003E+001,
      -1.7599999999999998E+001,
      -1.7999999999999996E+001,
      -18.4,
      -1.8799999999999997E+001,
      -19.2,
      -1.9599999999999998E+001,
      -20.0,
      -2.0400000000000002E+001,
      -20.8,
      -2.1200000000000003E+001,
      -21.6,
      -2.2000000000000004E+001,
      -22.4,
      -2.2799999999999997E+001,
      -23.2,
      -2.3599999999999998E+001,
      -24.0,
      -2.4400000000000002E+001,
      -24.8,
      -2.5199999999999996E+001,
      -2.5599999999999998E+001,
      -2.5999999999999996E+001,
      -26.4,
      -2.6799999999999997E+001,
      -27.2,
      -2.7599999999999998E+001,
      -28.0,
      -2.8400000000000002E+001,
      -28.8,
      -2.9200000000000003E+001,
      -29.6,
      -3.0000000000000004E+001,
      -3.0400000000000002E+001,
      -3.0800000000000004E+001,
      -3.1199999999999996E+001,
      -3.1599999999999994E+001,
      -3.1999999999999996E+001,
      -32.4,
      -32.8,
      -3.3199999999999996E+001,
      -33.6,
      -34.0,
      -3.4400000000000006E+001,
      -3.4800000000000004E+001,
      -35.2,
      -35.6,
      -3.5999999999999993E+001,
      -36.4,
      -36.8,
      -3.7199999999999996E+001,
      -3.7599999999999994E+001,
      -38.0,
      -38.4,
      -38.8,
      -3.9199999999999996E+001,
      -39.6,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -40.0,
      -39.6,
      -3.9199999999999996E+001,
      -38.8,
      -38.4,
      -38.0,
      -3.7599999999999994E+001,
      -3.7199999999999996E+001,
      -36.8,
      -36.4,
      -3.6000000000000007E+001,
      -35.6,
      -35.2,
      -3.4800000000000004E+001,
      -3.4400000000000006E+001,
      -34.0,
      -33.6,
      -33.2,
      -3.2800000000000004E+001,
      -32.4,
      -32.0,
      -3.1599999999999998E+001,
      -31.2,
      -3.0799999999999997E+001,
      -30.4,
      -2.9999999999999996E+001,
      -2.9599999999999998E+001,
      -2.9200000000000003E+001,
      -28.8,
      -2.8400000000000002E+001,
      -2.8000000000000004E+001,
      -2.7600000000000005E+001,
      -2.7200000000000003E+001,
      -2.6800000000000004E+001,
      -2.6400000000000002E+001,
      -2.6000000000000004E+001,
      -25.6,
      -2.5200000000000003E+001,
      -24.8,
      -2.4400000000000002E+001,
      -24.0,
      -2.3599999999999998E+001,
      -23.2,
      -2.2799999999999997E+001,
      -2.2400000000000002E+001,
      -2.2000000000000004E+001,
      -21.6,
      -2.1200000000000003E+001,
      -20.8,
      -2.0400000000000002E+001,
      -20.0,
      -1.9599999999999998E+001,
      -19.2,
      -1.8799999999999997E+001,
      -18.4,
      -1.7999999999999996E+001,
      -17.6,
      -1.7200000000000003E+001,
      -16.8,
      -1.6400000000000002E+001,
      -16.0,
      -15.6,
      -15.2,
      -1.4800000000000002E+001,
      -1.4400000000000002E+001,
      -1.4000000000000002E+001,
      -1.3600000000000001E+001,
      -1.3200000000000001E+001,
      -12.8,
      -12.4,
      -12.0,
      -11.6,
      -11.2,
      -1.0799999999999999E+001,
      -1.0399999999999999E+001,
      -9.9999999999999982E+000,
      -9.5999999999999979E+000,
      -9.1999999999999975E+000,
      -8.8000000000000043E+000,
      -8.4000000000000039E+000,
      -8.0000000000000036E+000,
      -7.6000000000000032E+000,
      -7.2000000000000028E+000,
      -6.8000000000000025E+000,
      -6.3999999999999986E+000,
      -5.9999999999999982E+000,
      -5.5999999999999979E+000,
      -5.1999999999999975E+000,
      -4.7999999999999972E+000,
      -4.3999999999999968E+000,
      -4.0000000000000036E+000,
      -3.6000000000000032E+000,
      -3.2000000000000028E+000,
      -2.8000000000000025E+000,
      -2.4000000000000021E+000,
      -2.0000000000000018E+000,
      -1.6000000000000014E+000,
      -1.2000000000000011E+000,
      -8.0000000000000071E-001,
      -4.0000000000000036E-001,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      -2.0519154066365764E-015,
      2.1055017518556821E-001,
      4.2109203821074176E-001,
      6.3161727724326444E-001,
      8.4211758110719082E-001,
      1.0525846396109517E+000,
      1.2630101438754540E+000,
      1.4733857866620885E+000,
      1.6837032627007134E+000,
      1.8939542690174889E+000,
      2.1041305052626926E+000,
      2.3142236740383901E+000,
      2.5242254812260283E+000,
      2.7341276363138358E+000,
      2.9439218527241366E+000,
      3.1535998481404870E+000,
      3.3631533448346671E+000,
      3.5725740699934350E+000,
      3.7818537560451455E+000,
      3.9909841409861309E+000,
      4.1999569687068972E+000,
      4.4087639893180173E+000,
      4.6173969594758510E+000,
      4.8258476427079691E+000,
      5.0341078097383338E+000,
      5.2421692388121439E+000,
      5.4500237160204366E+000,
      5.6576630356243562E+000,
      5.8650790003790929E+000,
      6.0722634218575262E+000,
      6.2792081207734443E+000,
      6.4859049273044738E+000,
      6.6923456814146292E+000,
      6.8985222331764131E+000,
      7.1044264430925921E+000,
      7.3100501824175259E+000,
      7.5153853334780676E+000,
      7.7204237899940384E+000,
      7.9251574573982699E+000,
      8.1295782531561258E+000,
      8.3336781070846087E+000,
      8.5374489616709717E+000,
      8.7408827723907834E+000,
      8.9439715080255304E+000,
      9.1467071509796618E+000,
      9.3490816975971569E+000,
      9.5510871584774168E+000,
      9.7527155587907437E+000,
      9.9539589385931269E+000,
      1.0154809353140529E+001,
      1.0355258873202487E+001,
      1.0555299585375174E+001,
      1.0754923592393800E+001,
      1.0954123013444367E+001,
      1.1152889984474834E+001,
      1.1351216658505521E+001,
      1.1549095205938922E+001,
      1.1746517814868813E+001,
      1.1943476691388637E+001,
      1.2139964059899189E+001,
      1.2335972163415608E+001,
      1.2531493263873575E+001,
      1.2726519642434843E+001,
      1.2921043599791918E+001,
      1.3115057456472048E+001,
      1.3308553553140362E+001,
      1.3501524250902301E+001,
      1.3693961931605124E+001,
      1.3885858998138708E+001,
      1.4077207874735445E+001,
      1.4268001007269325E+001,
      1.4458230863554171E+001,
      1.4647889933640981E+001,
      1.4836970730114400E+001,
      1.5025465788388370E+001,
      1.5213367667000737E+001,
      1.5400668947907064E+001,
      1.5587362236773501E+001,
      1.5773440163268667E+001,
      1.5958895381354642E+001,
      1.6143720569576956E+001,
      1.6327908431353674E+001,
      1.6511451695263375E+001,
      1.6694343115332281E+001,
      1.6876575471320290E+001,
      1.7058141569006018E+001,
      1.7239034240470819E+001,
      1.7419246344381758E+001,
      1.7598770766273539E+001,
      1.7777600418829397E+001,
      1.7955728242160848E+001,
      1.8133147204086434E+001,
      1.8309850300409323E+001,
      1.8485830555193836E+001,
      1.8661081021040843E+001,
      1.8835594779362022E+001,
      1.9009364940653011E+001,
      1.9182384644765410E+001,
      1.9354647061177513E+001,
      1.9526145389264116E+001,
      1.9696872858564870E+001,
      1.9866822729051616E+001,
      2.0035988291394471E+001,
      2.0204362867226681E+001,
      2.0371939809408307E+001,
      2.0538712502288593E+001,
      2.0704674361967214E+001,
      2.0869818836554096E+001,
      2.1034139406428174E+001,
      2.1197629584494699E+001,
      2.1360282916441385E+001,
      2.1522092980993186E+001,
      2.1683053390165817E+001,
      2.1843157789517960E+001,
      2.2002399858402026E+001,
      2.2160773310213838E+001,
      2.2318271892640684E+001,
      2.2474889387908213E+001,
      2.2630619613025875E+001,
      2.2785456420031046E+001,
      2.2939393696231708E+001,
      2.3092425364447763E+001,
      2.3244545383251008E+001,
      2.3395747747203554E+001,
      2.3546026487094981E+001,
      2.3695375670177956E+001,
      2.3843789400402450E+001,
      2.3991261818648521E+001,
      2.4137787102957613E+001,
      2.4283359468762391E+001,
      2.4427973169115106E+001,
      2.4571622494914504E+001,
      2.4714301775131158E+001,
      2.4856005377031394E+001,
      2.4996727706399639E+001,
      2.5136463207759292E+001,
      2.5275206364592023E+001,
      2.5412951699555563E+001,
      2.5549693774699950E+001,
      2.5685427191682184E+001,
      2.5820146591979402E+001,
      2.5953846657100325E+001,
      2.6086522108795336E+001,
      2.6218167709264776E+001,
      2.6348778261365748E+001,
      2.6478348608817292E+001,
      2.6606873636403950E+001,
      2.6734348270177719E+001,
      2.6860767477658310E+001,
      2.6986126268031889E+001,
      2.7110419692348049E+001,
      2.7233642843715238E+001,
      2.7355790857494419E+001,
      2.7476858911491153E+001,
      2.7596842226145995E+001,
      2.7715736064723099E+001,
      2.7833535733497317E+001,
      2.7950236581939421E+001,
      2.8065834002899742E+001,
      2.8180323432790029E+001,
      2.8293700351763636E+001,
      2.8405960283893933E+001,
      2.8517098797351004E+001,
      2.8627111504576668E+001,
      2.8735994062457578E+001,
      2.8843742172496825E+001,
      2.8950351580983483E+001,
      2.9055818079160673E+001,
      2.9160137503391628E+001,
      2.9263305735324099E+001,
      2.9365318702052946E+001,
      2.9466172376280909E+001,
      2.9565862776477637E+001,
      2.9664385967036804E+001,
      2.9761738058431568E+001,
      2.9857915207368031E+001,
      2.9952913616937046E+001,
      3.0046729536764083E+001,
      3.0139359263157235E+001,
      3.0230799139253541E+001,
      3.0321045555163234E+001,
      3.0410094948112363E+001,
      3.0497943802583364E+001,
      3.0584588650453878E+001,
      3.0670026071133680E+001,
      3.0754252691699691E+001,
      3.0837265187029146E+001,
      3.0919060279930868E+001,
      3.0999634741274662E+001,
      3.1078985390118735E+001,
      3.1157109093835356E+001,
      3.1234002768234472E+001,
      3.1309663377685474E+001,
      3.1384087935237059E+001,
      3.1457273502735120E+001,
      3.1529217190938780E+001,
      3.1599916159634404E+001,
      3.1669367617747778E+001,
      3.1737568823454229E+001,
      3.1804517084286971E+001,
      3.1870209757243263E+001,
      3.1934644248888890E+001,
      3.1997818015460439E+001,
      3.2059728562965780E+001,
      3.2120373447282496E+001,
      3.2179750274254403E+001,
      3.2237856699786050E+001,
      3.2294690429935230E+001,
      3.2350249221003615E+001,
      3.2404530879625241E+001,
      3.2457533262853190E+001,
      3.2509254278244121E+001,
      3.2559691883940907E+001,
      3.2608844088753237E+001,
      3.2656708952236222E+001,
      3.2703284584767019E+001,
      3.2748569147619406E+001,
      3.2792560853036370E+001,
      3.2835257964300716E+001,
      3.2876658795803600E+001,
      3.2916761713111086E+001,
      3.2955565133028649E+001,
      3.2993067523663740E+001,
      3.3029267404486170E+001,
      3.3064163346386636E+001,
      3.3097753971733106E+001,
      3.3130037954425198E+001,
      3.3161014019946563E+001,
      3.3190680945415174E+001,
      3.3219037559631609E+001,
      3.3246082743125285E+001,
      3.3271815428198686E+001,
      3.3296234598969441E+001,
      3.3319339291410529E+001,
      3.3341128593388227E+001,
      3.3361601644698219E+001,
      3.3380757637099492E+001,
      3.3398595814346265E+001,
      3.3415115472217835E+001,
      3.3430315958546416E+001,
      3.3444196673242814E+001,
      3.3456757068320194E+001,
      3.3467996647915662E+001,
      3.3477914968309854E+001,
      3.3486511637944474E+001,
      3.3493786317437717E+001,
      3.3499738719597694E+001,
      3.3504368609433762E+001,
      3.3507675804165800E+001,
      3.3509660173231417E+001,
      3.3510321638291131E+001,
      3.3509660173231417E+001,
      3.3507675804165800E+001,
      3.3504368609433762E+001,
      3.3499738719597694E+001,
      3.3493786317437717E+001,
      3.3486511637944474E+001,
      3.3477914968309854E+001,
      3.3467996647915662E+001,
      3.3456757068320194E+001,
      3.3444196673242814E+001,
      3.3430315958546416E+001,
      3.3415115472217835E+001,
      3.3398595814346265E+001,
      3.3380757637099492E+001,
      3.3361601644698219E+001,
      3.3341128593388227E+001,
      3.3319339291410529E+001,
      3.3296234598969441E+001,
      3.3271815428198686E+001,
      3.3246082743125292E+001,
      3.3219037559631609E+001,
      3.3190680945415174E+001,
      3.3161014019946570E+001,
      3.3130037954425198E+001,
      3.3097753971733106E+001,
      3.3064163346386636E+001,
      3.3029267404486170E+001,
      3.2993067523663740E+001,
      3.2955565133028657E+001,
      3.2916761713111079E+001,
      3.2876658795803600E+001,
      3.2835257964300716E+001,
      3.2792560853036370E+001,
      3.2748569147619406E+001,
      3.2703284584767026E+001,
      3.2656708952236222E+001,
      3.2608844088753237E+001,
      3.2559691883940907E+001,
      3.2509254278244121E+001,
      3.2457533262853197E+001,
      3.2404530879625248E+001,
      3.2350249221003615E+001,
      3.2294690429935230E+001,
      3.2237856699786057E+001,
      3.2179750274254403E+001,
      3.2120373447282496E+001,
      3.2059728562965780E+001,
      3.1997818015460442E+001,
      3.1934644248888894E+001,
      3.1870209757243266E+001,
      3.1804517084286971E+001,
      3.1737568823454232E+001,
      3.1669367617747778E+001,
      3.1599916159634404E+001,
      3.1529217190938784E+001,
      3.1457273502735127E+001,
      3.1384087935237062E+001,
      3.1309663377685478E+001,
      3.1234002768234475E+001,
      3.1157109093835359E+001,
      3.1078985390118735E+001,
      3.0999634741274662E+001,
      3.0919060279930871E+001,
      3.0837265187029150E+001,
      3.0754252691699694E+001,
      3.0670026071133684E+001,
      3.0584588650453881E+001,
      3.0497943802583364E+001,
      3.0410094948112363E+001,
      3.0321045555163238E+001,
      3.0230799139253541E+001,
      3.0139359263157250E+001,
      3.0046729536764087E+001,
      2.9952913616937057E+001,
      2.9857915207368034E+001,
      2.9761738058431565E+001,
      2.9664385967036807E+001,
      2.9565862776477633E+001,
      2.9466172376280912E+001,
      2.9365318702052946E+001,
      2.9263305735324096E+001,
      2.9160137503391631E+001,
      2.9055818079160677E+001,
      2.8950351580983490E+001,
      2.8843742172496821E+001,
      2.8735994062457586E+001,
      2.8627111504576664E+001,
      2.8517098797351007E+001,
      2.8405960283893929E+001,
      2.8293700351763633E+001,
      2.8180323432790033E+001,
      2.8065834002899745E+001,
      2.7950236581939425E+001,
      2.7833535733497321E+001,
      2.7715736064723103E+001,
      2.7596842226145991E+001,
      2.7476858911491156E+001,
      2.7355790857494416E+001,
      2.7233642843715234E+001,
      2.7110419692348053E+001,
      2.6986126268031892E+001,
      2.6860767477658325E+001,
      2.6734348270177730E+001,
      2.6606873636403964E+001,
      2.6478348608817299E+001,
      2.6348778261365752E+001,
      2.6218167709264780E+001,
      2.6086522108795346E+001,
      2.5953846657100332E+001,
      2.5820146591979398E+001,
      2.5685427191682187E+001,
      2.5549693774699954E+001,
      2.5412951699555567E+001,
      2.5275206364592027E+001,
      2.5136463207759299E+001,
      2.4996727706399643E+001,
      2.4856005377031398E+001,
      2.4714301775131162E+001,
      2.4571622494914511E+001,
      2.4427973169115116E+001,
      2.4283359468762399E+001,
      2.4137787102957617E+001,
      2.3991261818648525E+001,
      2.3843789400402457E+001,
      2.3695375670177963E+001,
      2.3546026487094988E+001,
      2.3395747747203561E+001,
      2.3244545383251012E+001,
      2.3092425364447770E+001,
      2.2939393696231715E+001,
      2.2785456420031057E+001,
      2.2630619613025882E+001,
      2.2474889387908217E+001,
      2.2318271892640688E+001,
      2.2160773310213845E+001,
      2.2002399858402029E+001,
      2.1843157789517964E+001,
      2.1683053390165824E+001,
      2.1522092980993197E+001,
      2.1360282916441378E+001,
      2.1197629584494706E+001,
      2.1034139406428192E+001,
      2.0869818836554103E+001,
      2.0704674361967207E+001,
      2.0538712502288600E+001,
      2.0371939809408314E+001,
      2.0204362867226674E+001,
      2.0035988291394450E+001,
      1.9866822729051606E+001,
      1.9696872858564877E+001,
      1.9526145389264137E+001,
      1.9354647061177523E+001,
      1.9182384644765396E+001,
      1.9009364940653015E+001,
      1.8835594779362030E+001,
      1.8661081021040836E+001,
      1.8485830555193818E+001,
      1.8309850300409320E+001,
      1.8133147204086438E+001,
      1.7955728242160870E+001,
      1.7777600418829405E+001,
      1.7598770766273532E+001,
      1.7419246344381754E+001,
      1.7239034240470826E+001,
      1.7058141569006011E+001,
      1.6876575471320272E+001,
      1.6694343115332277E+001,
      1.6511451695263382E+001,
      1.6327908431353691E+001,
      1.6143720569576988E+001,
      1.5958895381354649E+001,
      1.5773440163268662E+001,
      1.5587362236773508E+001,
      1.5400668947907086E+001,
      1.5213367667000743E+001,
      1.5025465788388365E+001,
      1.4836970730114407E+001,
      1.4647889933640988E+001,
      1.4458230863554192E+001,
      1.4268001007269332E+001,
      1.4077207874735439E+001,
      1.3885858998138715E+001,
      1.3693961931605148E+001,
      1.3501524250902309E+001,
      1.3308553553140356E+001,
      1.3115057456472048E+001,
      1.2921043599791934E+001,
      1.2726519642434869E+001,
      1.2531493263873589E+001,
      1.2335972163415603E+001,
      1.2139964059899196E+001,
      1.1943476691388657E+001,
      1.1746517814868820E+001,
      1.1549095205938915E+001,
      1.1351216658505521E+001,
      1.1152889984474850E+001,
      1.0954123013444395E+001,
      1.0754923592393807E+001,
      1.0555299585375169E+001,
      1.0355258873202494E+001,
      1.0154809353140550E+001,
      9.9539589385931340E+000,
      9.7527155587907313E+000,
      9.5510871584774186E+000,
      9.3490816975971711E+000,
      9.1467071509796654E+000,
      8.9439715080255375E+000,
      8.7408827723907763E+000,
      8.5374489616709806E+000,
      8.3336781070846300E+000,
      8.1295782531561258E+000,
      7.9251574573982557E+000,
      7.7204237899940393E+000,
      7.5153853334780765E+000,
      7.3100501824175197E+000,
      7.1044264430926010E+000,
      6.8985222331764069E+000,
      6.6923456814146363E+000,
      6.4859049273044969E+000,
      6.2792081207734451E+000,
      6.0722634218575120E+000,
      5.8650790003790938E+000,
      5.6576630356243642E+000,
      5.4500237160204303E+000,
      5.2421692388121519E+000,
      5.0341078097383276E+000,
      4.8258476427079779E+000,
      4.6173969594758670E+000,
      4.4087639893180182E+000,
      4.1999569687069123E+000,
      3.9909841409861313E+000,
      3.7818537560451535E+000,
      3.5725740699934576E+000,
      3.3631533448346755E+000,
      3.1535998481404799E+000,
      2.9439218527241371E+000,
      2.7341276363138514E+000,
      2.5242254812260594E+000,
      2.3142236740384057E+000,
      2.1041305052626864E+000,
      1.8939542690174971E+000,
      1.6837032627007367E+000,
      1.4733857866620965E+000,
      1.2630101438754400E+000,
      1.0525846396109524E+000,
      8.4211758110720658E-001,
      6.3161727724329486E-001,
      4.2109203821074997E-001,
      2.1055017518556152E-001,
      6.1557462199097281E-015,
      -2.1055017518554922E-001,
      -4.2109203821073765E-001,
      -6.3161727724328254E-001,
      -8.4211758110719426E-001,
      -1.0525846396109400E+000,
      -1.2630101438754273E+000,
      -1.4733857866620843E+000,
      -1.6837032627007242E+000,
      -1.8939542690174846E+000,
      -2.1041305052626740E+000,
      -2.3142236740383932E+000,
      -2.5242254812260474E+000,
      -2.7341276363138389E+000,
      -2.9439218527241251E+000,
      -3.1535998481404679E+000,
      -3.3631533448346635E+000,
      -3.5725740699934456E+000,
      -3.7818537560451411E+000,
      -3.9909841409861193E+000,
      -4.1999569687068998E+000,
      -4.4087639893180350E+000,
      -4.6173969594758546E+000,
      -4.8258476427079646E+000,
      -5.0341078097383152E+000,
      -5.2421692388121386E+000,
      -5.4500237160204481E+000,
      -5.6576630356243527E+000,
      -5.8650790003790823E+000,
      -6.0722634218575298E+000,
      -6.2792081207734620E+000,
      -6.4859049273044853E+000,
      -6.6923456814146247E+000,
      -6.8985222331763945E+000,
      -7.1044264430925885E+000,
      -7.3100501824175375E+000,
      -7.5153853334780640E+000,
      -7.7204237899940269E+000,
      -7.9251574573982726E+000,
      -8.1295782531561436E+000,
      -8.3336781070846175E+000,
      -8.5374489616709681E+000,
      -8.7408827723907638E+000,
      -8.9439715080255269E+000,
      -9.1467071509796813E+000,
      -9.3490816975971587E+000,
      -9.5510871584774062E+000,
      -9.7527155587907473E+000,
      -9.9539589385931517E+000,
      -1.0154809353140539E+001,
      -1.0355258873202484E+001,
      -1.0555299585375185E+001,
      -1.0754923592393794E+001,
      -1.0954123013444384E+001,
      -1.1152889984474838E+001,
      -1.1351216658505511E+001,
      -1.1549095205938931E+001,
      -1.1746517814868836E+001,
      -1.1943476691388646E+001,
      -1.2139964059899185E+001,
      -1.2335972163415617E+001,
      -1.2531493263873578E+001,
      -1.2726519642434859E+001,
      -1.2921043599791922E+001,
      -1.3115057456472037E+001,
      -1.3308553553140372E+001,
      -1.3501524250902323E+001,
      -1.3693961931605132E+001,
      -1.3885858998138705E+001,
      -1.4077207874735453E+001,
      -1.4268001007269321E+001,
      -1.4458230863554180E+001,
      -1.4647889933640977E+001,
      -1.4836970730114396E+001,
      -1.5025465788388381E+001,
      -1.5213367667000760E+001,
      -1.5400668947907077E+001,
      -1.5587362236773497E+001,
      -1.5773440163268651E+001,
      -1.5958895381354612E+001,
      -1.6143720569576953E+001,
      -1.6327908431353681E+001,
      -1.6511451695263371E+001,
      -1.6694343115332266E+001,
      -1.6876575471320262E+001,
      -1.7058141569006004E+001,
      -1.7239034240470815E+001,
      -1.7419246344381740E+001,
      -1.7598770766273521E+001,
      -1.7777600418829394E+001,
      -1.7955728242160859E+001,
      -1.8133147204086431E+001,
      -1.8309850300409305E+001,
      -1.8485830555193807E+001,
      -1.8661081021040825E+001,
      -1.8835594779362019E+001,
      -1.9009364940653008E+001,
      -1.9182384644765381E+001,
      -1.9354647061177509E+001,
      -1.9526145389264126E+001,
      -1.9696872858564866E+001,
      -1.9866822729051599E+001,
      -2.0035988291394439E+001,
      -2.0204362867226667E+001,
      -2.0371939809408303E+001,
      -2.0538712502288590E+001,
      -2.0704674361967200E+001,
      -2.0869818836554092E+001,
      -2.1034139406428185E+001,
      -2.1197629584494692E+001,
      -2.1360282916441371E+001,
      -2.1522092980993182E+001,
      -2.1683053390165817E+001,
      -2.1843157789517957E+001,
      -2.2002399858402022E+001,
      -2.2160773310213823E+001,
      -2.2318271892640681E+001,
      -2.2474889387908220E+001,
      -2.2630619613025875E+001,
      -2.2785456420031032E+001,
      -2.2939393696231704E+001,
      -2.3092425364447760E+001,
      -2.3244545383251015E+001,
      -2.3395747747203551E+001,
      -2.3546026487094966E+001,
      -2.3695375670177953E+001,
      -2.3843789400402457E+001,
      -2.3991261818648518E+001,
      -2.4137787102957603E+001,
      -2.4283359468762391E+001,
      -2.4427973169115102E+001,
      -2.4571622494914514E+001,
      -2.4714301775131155E+001,
      -2.4856005377031380E+001,
      -2.4996727706399636E+001,
      -2.5136463207759302E+001,
      -2.5275206364592020E+001,
      -2.5412951699555549E+001,
      -2.5549693774699946E+001,
      -2.5685427191682180E+001,
      -2.5820146591979402E+001,
      -2.5953846657100321E+001,
      -2.6086522108795346E+001,
      -2.6218167709264772E+001,
      -2.6348778261365737E+001,
      -2.6478348608817289E+001,
      -2.6606873636403947E+001,
      -2.6734348270177723E+001,
      -2.6860767477658310E+001,
      -2.6986126268031892E+001,
      -2.7110419692348049E+001,
      -2.7233642843715241E+001,
      -2.7355790857494416E+001,
      -2.7476858911491149E+001,
      -2.7596842226145995E+001,
      -2.7715736064723096E+001,
      -2.7833535733497321E+001,
      -2.7950236581939418E+001,
      -2.8065834002899749E+001,
      -2.8180323432790029E+001,
      -2.8293700351763640E+001,
      -2.8405960283893933E+001,
      -2.8517098797351014E+001,
      -2.8627111504576664E+001,
      -2.8735994062457578E+001,
      -2.8843742172496825E+001,
      -2.8950351580983479E+001,
      -2.9055818079160677E+001,
      -2.9160137503391624E+001,
      -2.9263305735324106E+001,
      -2.9365318702052946E+001,
      -2.9466172376280920E+001,
      -2.9565862776477633E+001,
      -2.9664385967036800E+001,
      -2.9761738058431565E+001,
      -2.9857915207368031E+001,
      -2.9952913616937057E+001,
      -3.0046729536764079E+001,
      -3.0139359263157250E+001,
      -3.0230799139253541E+001,
      -3.0321045555163245E+001,
      -3.0410094948112366E+001,
      -3.0497943802583361E+001,
      -3.0584588650453881E+001,
      -3.0670026071133680E+001,
      -3.0754252691699694E+001,
      -3.0837265187029143E+001,
      -3.0919060279930878E+001,
      -3.0999634741274658E+001,
      -3.1078985390118742E+001,
      -3.1157109093835359E+001,
      -3.1234002768234468E+001,
      -3.1309663377685478E+001,
      -3.1384087935237059E+001,
      -3.1457273502735127E+001,
      -3.1529217190938780E+001,
      -3.1599916159634411E+001,
      -3.1669367617747771E+001,
      -3.1737568823454236E+001,
      -3.1804517084286967E+001,
      -3.1870209757243263E+001,
      -3.1934644248888894E+001,
      -3.1997818015460439E+001,
      -3.2059728562965780E+001,
      -3.2120373447282489E+001,
      -3.2179750274254403E+001,
      -3.2237856699786043E+001,
      -3.2294690429935230E+001,
      -3.2350249221003601E+001,
      -3.2404530879625241E+001,
      -3.2457533262853190E+001,
      -3.2509254278244121E+001,
      -3.2559691883940907E+001,
      -3.2608844088753230E+001,
      -3.2656708952236222E+001,
      -3.2703284584767019E+001,
      -3.2748569147619399E+001,
      -3.2792560853036363E+001,
      -3.2835257964300716E+001,
      -3.2876658795803600E+001,
      -3.2916761713111086E+001,
      -3.2955565133028649E+001,
      -3.2993067523663740E+001,
      -3.3029267404486170E+001,
      -3.3064163346386636E+001,
      -3.3097753971733106E+001,
      -3.3130037954425198E+001,
      -3.3161014019946563E+001,
      -3.3190680945415174E+001,
      -3.3219037559631609E+001,
      -3.3246082743125285E+001,
      -3.3271815428198686E+001,
      -3.3296234598969441E+001,
      -3.3319339291410522E+001,
      -3.3341128593388227E+001,
      -3.3361601644698219E+001,
      -3.3380757637099492E+001,
      -3.3398595814346265E+001,
      -3.3415115472217835E+001,
      -3.3430315958546416E+001,
      -3.3444196673242814E+001,
      -3.3456757068320194E+001,
      -3.3467996647915662E+001,
      -3.3477914968309854E+001,
      -3.3486511637944474E+001,
      -3.3493786317437717E+001,
      -3.3499738719597694E+001,
      -3.3504368609433762E+001,
      -3.3507675804165800E+001,
      -3.3509660173231417E+001,
      -3.3510321638291131E+001,
      -3.3509660173231417E+001,
      -3.3507675804165800E+001,
      -3.3504368609433762E+001,
      -3.3499738719597694E+001,
      -3.3493786317437717E+001,
      -3.3486511637944474E+001,
      -3.3477914968309854E+001,
      -3.3467996647915662E+001,
      -3.3456757068320194E+001,
      -3.3444196673242814E+001,
      -3.3430315958546416E+001,
      -3.3415115472217835E+001,
      -3.3398595814346265E+001,
      -3.3380757637099492E+001,
      -3.3361601644698219E+001,
      -3.3341128593388227E+001,
      -3.3319339291410529E+001,
      -3.3296234598969441E+001,
      -3.3271815428198686E+001,
      -3.3246082743125292E+001,
      -3.3219037559631609E+001,
      -3.3190680945415174E+001,
      -3.3161014019946570E+001,
      -3.3130037954425198E+001,
      -3.3097753971733106E+001,
      -3.3064163346386636E+001,
      -3.3029267404486170E+001,
      -3.2993067523663740E+001,
      -3.2955565133028657E+001,
      -3.2916761713111086E+001,
      -3.2876658795803600E+001,
      -3.2835257964300723E+001,
      -3.2792560853036370E+001,
      -3.2748569147619406E+001,
      -3.2703284584767019E+001,
      -3.2656708952236222E+001,
      -3.2608844088753237E+001,
      -3.2559691883940907E+001,
      -3.2509254278244121E+001,
      -3.2457533262853190E+001,
      -3.2404530879625248E+001,
      -3.2350249221003608E+001,
      -3.2294690429935230E+001,
      -3.2237856699786050E+001,
      -3.2179750274254403E+001,
      -3.2120373447282489E+001,
      -3.2059728562965773E+001,
      -3.1997818015460442E+001,
      -3.1934644248888890E+001,
      -3.1870209757243266E+001,
      -3.1804517084286964E+001,
      -3.1737568823454232E+001,
      -3.1669367617747767E+001,
      -3.1599916159634407E+001,
      -3.1529217190938777E+001,
      -3.1457273502735120E+001,
      -3.1384087935237066E+001,
      -3.1309663377685474E+001,
      -3.1234002768234475E+001,
      -3.1157109093835356E+001,
      -3.1078985390118739E+001,
      -3.0999634741274654E+001,
      -3.0919060279930875E+001,
      -3.0837265187029139E+001,
      -3.0754252691699691E+001,
      -3.0670026071133684E+001,
      -3.0584588650453878E+001,
      -3.0497943802583368E+001,
      -3.0410094948112359E+001,
      -3.0321045555163241E+001,
      -3.0230799139253534E+001,
      -3.0139359263157242E+001,
      -3.0046729536764076E+001,
      -2.9952913616937053E+001,
      -2.9857915207368038E+001,
      -2.9761738058431558E+001,
      -2.9664385967036807E+001,
      -2.9565862776477630E+001,
      -2.9466172376280912E+001,
      -2.9365318702052939E+001,
      -2.9263305735324099E+001,
      -2.9160137503391617E+001,
      -2.9055818079160687E+001,
      -2.8950351580983494E+001,
      -2.8843742172496832E+001,
      -2.8735994062457586E+001,
      -2.8627111504576675E+001,
      -2.8517098797351025E+001,
      -2.8405960283893940E+001,
      -2.8293700351763651E+001,
      -2.8180323432790036E+001,
      -2.8065834002899756E+001,
      -2.7950236581939425E+001,
      -2.7833535733497332E+001,
      -2.7715736064723103E+001,
      -2.7596842226146002E+001,
      -2.7476858911491160E+001,
      -2.7355790857494426E+001,
      -2.7233642843715252E+001,
      -2.7110419692348056E+001,
      -2.6986126268031903E+001,
      -2.6860767477658317E+001,
      -2.6734348270177733E+001,
      -2.6606873636403957E+001,
      -2.6478348608817299E+001,
      -2.6348778261365748E+001,
      -2.6218167709264783E+001,
      -2.6086522108795357E+001,
      -2.5953846657100332E+001,
      -2.5820146591979409E+001,
      -2.5685427191682191E+001,
      -2.5549693774699957E+001,
      -2.5412951699555560E+001,
      -2.5275206364592030E+001,
      -2.5136463207759292E+001,
      -2.4996727706399646E+001,
      -2.4856005377031412E+001,
      -2.4714301775131165E+001,
      -2.4571622494914521E+001,
      -2.4427973169115116E+001,
      -2.4283359468762402E+001,
      -2.4137787102957613E+001,
      -2.3991261818648528E+001,
      -2.3843789400402446E+001,
      -2.3695375670177963E+001,
      -2.3546026487094998E+001,
      -2.3395747747203565E+001,
      -2.3244545383251026E+001,
      -2.3092425364447770E+001,
      -2.2939393696231715E+001,
      -2.2785456420031043E+001,
      -2.2630619613025885E+001,
      -2.2474889387908210E+001,
      -2.2318271892640691E+001,
      -2.2160773310213859E+001,
      -2.2002399858402033E+001,
      -2.1843157789517967E+001,
      -2.1683053390165828E+001,
      -2.1522092980993197E+001,
      -2.1360282916441381E+001,
      -2.1197629584494706E+001,
      -2.1034139406428174E+001,
      -2.0869818836554106E+001,
      -2.0704674361967236E+001,
      -2.0538712502288604E+001,
      -2.0371939809408318E+001,
      -2.0204362867226678E+001,
      -2.0035988291394478E+001,
      -1.9866822729051613E+001,
      -1.9696872858564880E+001,
      -1.9526145389264116E+001,
      -1.9354647061177527E+001,
      -1.9182384644765420E+001,
      -1.9009364940653018E+001,
      -1.8835594779362033E+001,
      -1.8661081021040840E+001,
      -1.8485830555193846E+001,
      -1.8309850300409323E+001,
      -1.8133147204086441E+001,
      -1.7955728242160848E+001,
      -1.7777600418829408E+001,
      -1.7598770766273535E+001,
      -1.7419246344381758E+001,
      -1.7239034240470829E+001,
      -1.7058141569006015E+001,
      -1.6876575471320304E+001,
      -1.6694343115332281E+001,
      -1.6511451695263386E+001,
      -1.6327908431353670E+001,
      -1.6143720569576967E+001,
      -1.5958895381354626E+001,
      -1.5773440163268665E+001,
      -1.5587362236773512E+001,
      -1.5400668947907063E+001,
      -1.5213367667000746E+001,
      -1.5025465788388368E+001,
      -1.4836970730114409E+001,
      -1.4647889933640965E+001,
      -1.4458230863554167E+001,
      -1.4268001007269310E+001,
      -1.4077207874735443E+001,
      -1.3885858998138719E+001,
      -1.3693961931605122E+001,
      -1.3501524250902312E+001,
      -1.3308553553140360E+001,
      -1.3115057456472051E+001,
      -1.2921043599791910E+001,
      -1.2726519642434848E+001,
      -1.2531493263873566E+001,
      -1.2335972163415606E+001,
      -1.2139964059899201E+001,
      -1.1943476691388632E+001,
      -1.1746517814868826E+001,
      -1.1549095205938919E+001,
      -1.1351216658505525E+001,
      -1.1152889984474825E+001,
      -1.0954123013444370E+001,
      -1.0754923592393782E+001,
      -1.0555299585375172E+001,
      -1.0355258873202500E+001,
      -1.0154809353140527E+001,
      -9.9539589385931393E+000,
      -9.7527155587907348E+000,
      -9.5510871584774222E+000,
      -9.3490816975971445E+000,
      -9.1467071509796689E+000,
      -8.9439715080255127E+000,
      -8.7408827723907816E+000,
      -8.5374489616709859E+000,
      -8.3336781070846335E+000,
      -8.1295782531561294E+000,
      -7.9251574573982886E+000,
      -7.7204237899940713E+000,
      -7.5153853334780800E+000,
      -7.3100501824175526E+000,
      -7.1044264430926045E+000,
      -6.8985222331764389E+000,
      -6.6923456814146416E+000,
      -6.4859049273045004E+000,
      -6.2792081207734487E+000,
      -6.0722634218575458E+000,
      -5.8650790003790974E+000,
      -5.6576630356243696E+000,
      -5.4500237160204632E+000,
      -5.2421692388121564E+000,
      -5.0341078097383605E+000,
      -4.8258476427079815E+000,
      -4.6173969594758706E+000,
      -4.4087639893180217E+000,
      -4.1999569687069167E+000,
      -3.9909841409861357E+000,
      -3.7818537560451575E+000,
      -3.5725740699934616E+000,
      -3.3631533448346795E+000,
      -3.1535998481405141E+000,
      -2.9439218527241411E+000,
      -2.7341276363138549E+000,
      -2.5242254812260336E+000,
      -2.3142236740384092E+000,
      -2.1041305052626900E+000,
      -1.8939542690175013E+000,
      -1.6837032627007407E+000,
      -1.4733857866621007E+000,
      -1.2630101438754737E+000,
      -1.0525846396109566E+000,
      -8.4211758110721058E-001,
      -6.3161727724326922E-001,
      -4.2109203821075408E-001,
      -2.1055017518556560E-001,
      -1.0259577033182881E-014,
      2.1055017518557484E-001,
      4.2109203821073354E-001,
      6.3161727724327854E-001,
      8.4211758110719015E-001,
      1.0525846396109655E+000,
      1.2630101438754531E+000,
      1.4733857866621101E+000,
      1.6837032627007200E+000,
      1.8939542690175104E+000,
      2.1041305052626695E+000,
      2.3142236740384186E+000,
      2.5242254812260132E+000,
      2.7341276363138642E+000,
      2.9439218527241207E+000,
      3.1535998481404937E+000,
      3.3631533448346591E+000,
      3.5725740699934412E+000,
      3.7818537560451371E+000,
      3.9909841409861451E+000,
      4.1999569687068963E+000,
      4.4087639893180315E+000,
      4.6173969594758510E+000,
      4.8258476427079904E+000,
      5.0341078097383116E+000,
      5.2421692388121057E+000,
      5.4500237160204437E+000,
      5.6576630356242896E+000,
      5.8650790003790778E+000,
      6.0722634218574960E+000,
      6.2792081207734585E+000,
      6.4859049273044800E+000,
      6.6923456814146212E+000,
      6.8985222331763900E+000,
      7.1044264430925557E+000,
      7.3100501824174744E+000,
      7.5153853334780596E+000,
      7.7204237899940233E+000,
      7.9251574573982975E+000,
      8.1295782531561400E+000,
      8.3336781070846140E+000,
      8.5374489616709646E+000,
      8.7408827723907603E+000,
      8.9439715080254931E+000,
      9.1467071509796778E+000,
      9.3490816975970965E+000,
      9.5510871584774595E+000,
      9.7527155587907153E+000,
      9.9539589385931482E+000,
      1.0154809353140536E+001,
      1.0355258873202480E+001,
      1.0555299585375153E+001,
      1.0754923592393762E+001,
      1.0954123013444324E+001,
      1.1152889984474834E+001,
      1.1351216658505507E+001,
      1.1549095205938956E+001,
      1.1746517814868833E+001,
      1.1943476691388643E+001,
      1.2139964059899182E+001,
      1.2335972163415585E+001,
      1.2531493263873545E+001,
      1.2726519642434855E+001,
      1.2921043599791863E+001,
      1.3115057456472089E+001,
      1.3308553553140342E+001,
      1.3501524250902319E+001,
      1.3693961931605129E+001,
      1.3885858998138701E+001,
      1.4077207874735425E+001,
      1.4268001007269293E+001,
      1.4458230863554123E+001,
      1.4647889933640974E+001,
      1.4836970730114393E+001,
      1.5025465788388404E+001,
      1.5213367667000757E+001,
      1.5400668947907073E+001,
      1.5587362236773494E+001,
      1.5773440163268647E+001,
      1.5958895381354608E+001,
      1.6143720569576974E+001,
      1.6327908431353627E+001,
      1.6511451695263421E+001,
      1.6694343115332263E+001,
      1.6876575471320312E+001,
      1.7058141569006025E+001,
      1.7239034240470811E+001,
      1.7419246344381737E+001,
      1.7598770766273521E+001,
      1.7777600418829365E+001,
      1.7955728242160856E+001,
      1.8133147204086427E+001,
      1.8309850300409352E+001,
      1.8485830555193854E+001,
      1.8661081021040847E+001,
      1.8835594779362015E+001,
      1.9009364940653004E+001,
      1.9182384644765378E+001,
      1.9354647061177534E+001,
      1.9526145389264077E+001,
      1.9696872858564912E+001,
      1.9866822729051595E+001,
      2.0035988291394485E+001,
      2.0204362867226685E+001,
      2.0371939809408300E+001,
      2.0538712502288586E+001,
      2.0704674361967196E+001,
      2.0869818836554067E+001,
      2.1034139406428181E+001,
      2.1197629584494688E+001,
      2.1360282916441410E+001,
      2.1522092980993204E+001,
      2.1683053390165835E+001,
      2.1843157789517953E+001,
      2.2002399858402018E+001,
      2.2160773310213823E+001,
      2.2318271892640698E+001,
      2.2474889387908171E+001,
      2.2630619613025917E+001,
      2.2785456420031029E+001,
      2.2939393696231722E+001,
      2.3092425364447777E+001,
      2.3244545383251012E+001,
      2.3395747747203551E+001,
      2.3546026487094966E+001,
      2.3695375670177928E+001,
      2.3843789400402454E+001,
      2.3991261818648514E+001,
      2.4137787102957638E+001,
      2.4283359468762406E+001,
      2.4427973169115123E+001,
      2.4571622494914507E+001,
      2.4714301775131151E+001,
      2.4856005377031376E+001,
      2.4996727706399653E+001,
      2.5136463207759256E+001,
      2.5275206364592055E+001,
      2.5412951699555546E+001,
      2.5549693774699961E+001,
      2.5685427191682194E+001,
      2.5820146591979398E+001,
      2.5953846657100321E+001,
      2.6086522108795322E+001,
      2.6218167709264755E+001,
      2.6348778261365752E+001,
      2.6478348608817289E+001,
      2.6606873636403979E+001,
      2.6734348270177740E+001,
      2.6860767477658325E+001,
      2.6986126268031892E+001,
      2.7110419692348046E+001,
      2.7233642843715224E+001,
      2.7355790857494430E+001,
      2.7476858911491131E+001,
      2.7596842226145959E+001,
      2.7715736064723092E+001,
      2.7833535733497303E+001,
      2.7950236581939432E+001,
      2.8065834002899745E+001,
      2.8180323432790026E+001,
      2.8293700351763626E+001,
      2.8405960283893915E+001,
      2.8517098797350982E+001,
      2.8627111504576664E+001,
      2.8735994062457575E+001,
      2.8843742172496835E+001,
      2.8950351580983497E+001,
      2.9055818079160677E+001,
      2.9160137503391624E+001,
      2.9263305735324085E+001,
      2.9365318702052932E+001,
      2.9466172376280920E+001,
      2.9565862776477605E+001,
      2.9664385967036800E+001,
      2.9761738058431551E+001,
      2.9857915207368041E+001,
      2.9952913616937057E+001,
      3.0046729536764079E+001,
      3.0139359263157232E+001,
      3.0230799139253527E+001,
      3.0321045555163220E+001,
      3.0410094948112363E+001,
      3.0497943802583361E+001,
      3.0584588650453892E+001,
      3.0670026071133687E+001,
      3.0754252691699694E+001,
      3.0837265187029143E+001,
      3.0919060279930864E+001,
      3.0999634741274647E+001,
      3.1078985390118742E+001,
      3.1157109093835338E+001,
      3.1234002768234468E+001,
      3.1309663377685467E+001,
      3.1384087935237066E+001,
      3.1457273502735127E+001,
      3.1529217190938780E+001,
      3.1599916159634400E+001,
      3.1669367617747756E+001,
      3.1737568823454218E+001,
      3.1804517084286967E+001,
      3.1870209757243259E+001,
      3.1934644248888901E+001,
      3.1997818015460446E+001,
      3.2059728562965780E+001,
      3.2120373447282496E+001,
      3.2179750274254403E+001,
      3.2237856699786036E+001,
      3.2294690429935237E+001,
      3.2350249221003594E+001,
      3.2404530879625241E+001,
      3.2457533262853190E+001,
      3.2509254278244128E+001,
      3.2559691883940907E+001,
      3.2608844088753237E+001,
      3.2656708952236222E+001,
      3.2703284584767019E+001,
      3.2748569147619392E+001,
      3.2792560853036370E+001,
      3.2835257964300716E+001,
      3.2876658795803607E+001,
      3.2916761713111086E+001,
      3.2955565133028657E+001,
      3.2993067523663740E+001,
      3.3029267404486170E+001,
      3.3064163346386636E+001,
      3.3097753971733106E+001,
      3.3130037954425191E+001,
      3.3161014019946570E+001,
      3.3190680945415167E+001,
      3.3219037559631609E+001,
      3.3246082743125292E+001,
      3.3271815428198686E+001,
      3.3296234598969441E+001,
      3.3319339291410522E+001,
      3.3341128593388227E+001,
      3.3361601644698219E+001,
      3.3380757637099492E+001,
      3.3398595814346265E+001,
      3.3415115472217842E+001,
      3.3430315958546416E+001,
      3.3444196673242814E+001,
      3.3456757068320194E+001,
      3.3467996647915662E+001,
      3.3477914968309854E+001,
      3.3486511637944474E+001,
      3.3493786317437717E+001,
      3.3499738719597694E+001,
      3.3504368609433762E+001,
      3.3507675804165800E+001,
      3.3509660173231417E+001,
      3.3510321638291131E+001,
      3.3509660173231417E+001,
      3.3507675804165800E+001,
      3.3504368609433762E+001,
      3.3499738719597694E+001,
      3.3493786317437717E+001,
      3.3486511637944474E+001,
      3.3477914968309854E+001,
      3.3467996647915662E+001,
      3.3456757068320194E+001,
      3.3444196673242814E+001,
      3.3430315958546416E+001,
      3.3415115472217842E+001,
      3.3398595814346258E+001,
      3.3380757637099492E+001,
      3.3361601644698212E+001,
      3.3341128593388227E+001,
      3.3319339291410529E+001,
      3.3296234598969441E+001,
      3.3271815428198686E+001,
      3.3246082743125292E+001,
      3.3219037559631602E+001,
      3.3190680945415174E+001,
      3.3161014019946563E+001,
      3.3130037954425205E+001,
      3.3097753971733106E+001,
      3.3064163346386636E+001,
      3.3029267404486170E+001,
      3.2993067523663740E+001,
      3.2955565133028649E+001,
      3.2916761713111079E+001,
      3.2876658795803600E+001,
      3.2835257964300723E+001,
      3.2792560853036377E+001,
      3.2748569147619399E+001,
      3.2703284584767033E+001,
      3.2656708952236229E+001,
      3.2608844088753244E+001,
      3.2559691883940914E+001,
      3.2509254278244128E+001,
      3.2457533262853190E+001,
      3.2404530879625248E+001,
      3.2350249221003615E+001,
      3.2294690429935244E+001,
      3.2237856699786050E+001,
      3.2179750274254410E+001,
      3.2120373447282503E+001,
      3.2059728562965788E+001,
      3.1997818015460435E+001,
      3.1934644248888894E+001,
      3.1870209757243266E+001,
      3.1804517084286974E+001,
      3.1737568823454225E+001,
      3.1669367617747792E+001,
      3.1599916159634407E+001,
      3.1529217190938787E+001,
      3.1457273502735134E+001,
      3.1384087935237076E+001,
      3.1309663377685474E+001,
      3.1234002768234475E+001,
      3.1157109093835366E+001,
      3.1078985390118749E+001,
      3.0999634741274654E+001,
      3.0919060279930875E+001,
      3.0837265187029150E+001,
      3.0754252691699701E+001,
      3.0670026071133677E+001,
      3.0584588650453878E+001,
      3.0497943802583368E+001,
      3.0410094948112373E+001,
      3.0321045555163231E+001,
      3.0230799139253563E+001,
      3.0139359263157242E+001,
      3.0046729536764090E+001,
      2.9952913616937039E+001,
      2.9857915207368055E+001,
      2.9761738058431561E+001,
      2.9664385967036811E+001,
      2.9565862776477644E+001,
      2.9466172376280930E+001,
      2.9365318702052942E+001,
      2.9263305735324099E+001,
      2.9160137503391635E+001,
      2.9055818079160687E+001,
      2.8950351580983476E+001,
      2.8843742172496817E+001,
      2.8735994062457589E+001,
      2.8627111504576675E+001,
      2.8517098797350997E+001,
      2.8405960283893958E+001,
      2.8293700351763636E+001,
      2.8180323432790036E+001,
      2.8065834002899727E+001,
      2.7950236581939450E+001,
      2.7833535733497317E+001,
      2.7715736064723107E+001,
      2.7596842226146006E+001,
      2.7476858911491181E+001,
      2.7355790857494412E+001,
      2.7233642843715238E+001,
      2.7110419692348060E+001,
      2.6986126268031907E+001,
      2.6860767477658303E+001,
      2.6734348270177719E+001,
      2.6606873636403957E+001,
      2.6478348608817306E+001,
      2.6348778261365730E+001,
      2.6218167709264808E+001,
      2.6086522108795343E+001,
      2.5953846657100335E+001,
      2.5820146591979377E+001,
      2.5685427191682209E+001,
      2.5549693774699939E+001,
      2.5412951699555563E+001,
      2.5275206364592034E+001,
      2.5136463207759313E+001,
      2.4996727706399628E+001,
      2.4856005377031394E+001,
      2.4714301775131169E+001,
      2.4571622494914525E+001,
      2.4427973169115095E+001,
      2.4283359468762381E+001,
      2.4137787102957613E+001,
      2.3991261818648532E+001,
      2.3843789400402429E+001,
      2.3695375670177988E+001,
      2.3546026487094981E+001,
      2.3395747747203565E+001,
      2.3244545383250987E+001,
      2.3092425364447795E+001,
      2.2939393696231701E+001,
      2.2785456420031046E+001,
      2.2630619613025889E+001,
      2.2474889387908235E+001,
      2.2318271892640674E+001,
      2.2160773310213841E+001,
      2.2002399858402036E+001,
      2.1843157789517971E+001,
      2.1683053390165806E+001,
      2.1522092980993175E+001,
      2.1360282916441385E+001,
      2.1197629584494710E+001,
      2.1034139406428153E+001,
      2.0869818836554089E+001,
      2.0704674361967214E+001,
      2.0538712502288607E+001,
      2.0371939809408271E+001,
      2.0204362867226703E+001,
      2.0035988291394457E+001,
      1.9866822729051616E+001,
      1.9696872858564884E+001,
      1.9526145389264141E+001,
      1.9354647061177502E+001,
      1.9182384644765403E+001,
      1.9009364940653022E+001,
      1.8835594779362033E+001,
      1.8661081021040815E+001,
      1.8485830555193822E+001,
      1.8309850300409373E+001,
      1.8133147204086445E+001,
      1.7955728242160873E+001,
      1.7777600418829387E+001,
      1.7598770766273589E+001,
      1.7419246344381762E+001,
      1.7239034240470833E+001,
      1.7058141569006047E+001,
      1.6876575471320333E+001,
      1.6694343115332284E+001,
      1.6511451695263389E+001,
      1.6327908431353698E+001,
      1.6143720569576995E+001,
      1.5958895381354631E+001,
      1.5773440163268669E+001,
      1.5587362236773515E+001,
      1.5400668947907093E+001,
      1.5213367667000723E+001,
      1.5025465788388427E+001,
      1.4836970730114412E+001,
      1.4647889933640995E+001,
      1.4458230863554146E+001,
      1.4268001007269367E+001,
      1.4077207874735446E+001,
      1.3885858998138723E+001,
      1.3693961931605156E+001,
      1.3501524250902342E+001,
      1.3308553553140364E+001,
      1.3115057456472055E+001,
      1.2921043599791942E+001,
      1.2726519642434877E+001,
      1.2531493263873569E+001,
      1.2335972163415610E+001,
      1.2139964059899206E+001,
      1.1943476691388664E+001,
      1.1746517814868801E+001,
      1.1549095205938922E+001,
      1.1351216658505530E+001,
      1.1152889984474857E+001,
      1.0954123013444347E+001,
      1.0754923592393842E+001,
      1.0555299585375176E+001,
      1.0355258873202503E+001,
      1.0154809353140557E+001,
      9.9539589385931695E+000,
      9.7527155587907384E+000,
      9.5510871584774275E+000,
      9.3490816975971782E+000,
      9.1467071509796991E+000,
      8.9439715080255162E+000,
      8.7408827723907851E+000,
      8.5374489616709894E+000,
      8.3336781070846371E+000,
      8.1295782531561045E+000,
      7.9251574573982646E+000,
      7.7204237899940473E+000,
      7.5153853334780836E+000,
      7.3100501824174993E+000,
      7.1044264430926374E+000,
      6.8985222331764140E+000,
      6.6923456814146451E+000,
      6.4859049273045049E+000,
      6.2792081207734833E+000,
      6.0722634218575200E+000,
      5.8650790003791018E+000,
      5.6576630356243731E+000,
      5.4500237160204676E+000,
      5.2421692388121297E+000,
      5.0341078097383356E+000,
      4.8258476427079851E+000,
      4.6173969594758750E+000,
      4.4087639893179968E+000,
      4.1999569687068909E+000,
      3.9909841409861397E+000,
      3.7818537560451615E+000,
      3.5725740699934061E+000,
      3.3631533448347128E+000,
      3.1535998481404883E+000,
      2.9439218527241460E+000,
      2.7341276363138594E+000,
      2.5242254812260678E+000,
      2.3142236740383839E+000,
      2.1041305052626940E+000,
      1.8939542690175053E+000,
      1.6837032627007449E+000,
      1.4733857866620750E+000,
      1.2630101438754480E+000,
      1.0525846396109604E+000,
      8.4211758110721469E-001,
      6.3161727724324357E-001,
      4.2109203821072844E-001,
      2.1055017518556973E-001,
      1.4363407846456031E-014,
      -2.1055017518560051E-001,
      -4.2109203821069968E-001,
      -6.3161727724327443E-001,
      -8.4211758110718604E-001,
      -1.0525846396109915E+000,
      -1.2630101438754193E+000,
      -1.4733857866621058E+000,
      -1.6837032627007160E+000,
      -1.8939542690174767E+000,
      -2.1041305052626660E+000,
      -2.3142236740384146E+000,
      -2.5242254812260390E+000,
      -2.7341276363138309E+000,
      -2.9439218527241171E+000,
      -3.1535998481405190E+000,
      -3.3631533448346849E+000,
      -3.5725740699934372E+000,
      -3.7818537560451335E+000,
      -3.9909841409861704E+000,
      -4.1999569687068634E+000,
      -4.4087639893180270E+000,
      -4.6173969594758466E+000,
      -4.8258476427080153E+000,
      -5.0341078097383081E+000,
      -5.2421692388121608E+000,
      -5.4500237160204392E+000,
      -5.6576630356243438E+000,
      -5.8650790003790734E+000,
      -6.0722634218575502E+000,
      -6.2792081207734540E+000,
      -6.4859049273044764E+000,
      -6.6923456814146167E+000,
      -6.8985222331764442E+000,
      -7.1044264430926098E+000,
      -7.3100501824175286E+000,
      -7.5153853334780560E+000,
      -7.7204237899940775E+000,
      -7.9251574573982362E+000,
      -8.1295782531561365E+000,
      -8.3336781070846104E+000,
      -8.5374489616710179E+000,
      -8.7408827723907567E+000,
      -8.9439715080255464E+000,
      -9.1467071509796742E+000,
      -9.3490816975971498E+000,
      -9.5510871584773991E+000,
      -9.7527155587907686E+000,
      -9.9539589385931446E+000,
      -1.0154809353140532E+001,
      -1.0355258873202477E+001,
      -1.0555299585375206E+001,
      -1.0754923592393816E+001,
      -1.0954123013444377E+001,
      -1.1152889984474829E+001,
      -1.1351216658505560E+001,
      -1.1549095205938896E+001,
      -1.1746517814868829E+001,
      -1.1943476691388639E+001,
      -1.2139964059899233E+001,
      -1.2335972163415581E+001,
      -1.2531493263873598E+001,
      -1.2726519642434852E+001,
      -1.2921043599791915E+001,
      -1.3115057456472030E+001,
      -1.3308553553140392E+001,
      -1.3501524250902316E+001,
      -1.3693961931605125E+001,
      -1.3885858998138698E+001,
      -1.4077207874735475E+001,
      -1.4268001007269342E+001,
      -1.4458230863554173E+001,
      -1.4647889933640970E+001,
      -1.4836970730114441E+001,
      -1.5025465788388400E+001,
      -1.5213367667000751E+001,
      -1.5400668947907070E+001,
      -1.5587362236773544E+001,
      -1.5773440163268642E+001,
      -1.5958895381354656E+001,
      -1.6143720569576971E+001,
      -1.6327908431353674E+001,
      -1.6511451695263364E+001,
      -1.6694343115332313E+001,
      -1.6876575471320308E+001,
      -1.7058141569006018E+001,
      -1.7239034240470808E+001,
      -1.7419246344381786E+001,
      -1.7598770766273564E+001,
      -1.7777600418829412E+001,
      -1.7955728242160852E+001,
      -1.8133147204086473E+001,
      -1.8309850300409348E+001,
      -1.8485830555193797E+001,
      -1.8661081021040843E+001,
      -1.8835594779362012E+001,
      -1.9009364940653001E+001,
      -1.9182384644765374E+001,
      -1.9354647061177531E+001,
      -1.9526145389264119E+001,
      -1.9696872858564863E+001,
      -1.9866822729051592E+001,
      -2.0035988291394482E+001,
      -2.0204362867226681E+001,
      -2.0371939809408296E+001,
      -2.0538712502288586E+001,
      -2.0704674361967236E+001,
      -2.0869818836554067E+001,
      -2.1034139406428178E+001,
      -2.1197629584494685E+001,
      -2.1360282916441406E+001,
      -2.1522092980993150E+001,
      -2.1683053390165831E+001,
      -2.1843157789517949E+001,
      -2.2002399858402015E+001,
      -2.2160773310213820E+001,
      -2.2318271892640695E+001,
      -2.2474889387908213E+001,
      -2.2630619613025868E+001,
      -2.2785456420031029E+001,
      -2.2939393696231722E+001,
      -2.3092425364447774E+001,
      -2.3244545383251008E+001,
      -2.3395747747203547E+001,
      -2.3546026487095002E+001,
      -2.3695375670177967E+001,
      -2.3843789400402450E+001,
      -2.3991261818648510E+001,
      -2.4137787102957635E+001,
      -2.4283359468762363E+001,
      -2.4427973169115120E+001,
      -2.4571622494914507E+001,
      -2.4714301775131148E+001,
      -2.4856005377031373E+001,
      -2.4996727706399650E+001,
      -2.5136463207759295E+001,
      -2.5275206364592012E+001,
      -2.5412951699555546E+001,
      -2.5549693774699961E+001,
      -2.5685427191682194E+001,
      -2.5820146591979395E+001,
      -2.5953846657100318E+001,
      -2.6086522108795361E+001,
      -2.6218167709264787E+001,
      -2.6348778261365748E+001,
      -2.6478348608817285E+001,
      -2.6606873636403979E+001,
      -2.6734348270177701E+001,
      -2.6860767477658321E+001,
      -2.6986126268031889E+001,
      -2.7110419692348042E+001,
      -2.7233642843715220E+001,
      -2.7355790857494430E+001,
      -2.7476858911491160E+001,
      -2.7596842226145988E+001,
      -2.7715736064723092E+001,
      -2.7833535733497332E+001,
      -2.7950236581939429E+001,
      -2.8065834002899742E+001,
      -2.8180323432790022E+001,
      -2.8293700351763654E+001,
      -2.8405960283893943E+001,
      -2.8517098797351011E+001,
      -2.8627111504576661E+001,
      -2.8735994062457603E+001,
      -2.8843742172496800E+001,
      -2.8950351580983494E+001,
      -2.9055818079160673E+001,
      -2.9160137503391621E+001,
      -2.9263305735324085E+001,
      -2.9365318702052956E+001,
      -2.9466172376280916E+001,
      -2.9565862776477630E+001,
      -2.9664385967036797E+001,
      -2.9761738058431575E+001,
      -2.9857915207368038E+001,
      -2.9952913616937053E+001,
      -3.0046729536764076E+001,
      -3.0139359263157260E+001,
      -3.0230799139253548E+001,
      -3.0321045555163241E+001,
      -3.0410094948112363E+001,
      -3.0497943802583382E+001,
      -3.0584588650453867E+001,
      -3.0670026071133687E+001,
      -3.0754252691699691E+001,
      -3.0837265187029168E+001,
      -3.0919060279930864E+001,
      -3.0999634741274665E+001,
      -3.1078985390118739E+001,
      -3.1157109093835356E+001,
      -3.1234002768234465E+001,
      -3.1309663377685485E+001,
      -3.1384087935237066E+001,
      -3.1457273502735120E+001,
      -3.1529217190938777E+001,
      -3.1599916159634422E+001,
      -3.1669367617747781E+001,
      -3.1737568823454232E+001,
      -3.1804517084286967E+001,
      -3.1870209757243277E+001,
      -3.1934644248888883E+001,
      -3.1997818015460442E+001,
      -3.2059728562965780E+001,
      -3.2120373447282510E+001,
      -3.2179750274254395E+001,
      -3.2237856699786057E+001,
      -3.2294690429935237E+001,
      -3.2350249221003608E+001,
      -3.2404530879625241E+001,
      -3.2457533262853197E+001,
      -3.2509254278244128E+001,
      -3.2559691883940907E+001,
      -3.2608844088753237E+001,
      -3.2656708952236237E+001,
      -3.2703284584767026E+001,
      -3.2748569147619406E+001,
      -3.2792560853036370E+001,
      -3.2835257964300723E+001,
      -3.2876658795803600E+001,
      -3.2916761713111079E+001,
      -3.2955565133028657E+001,
      -3.2993067523663740E+001,
      -3.3029267404486170E+001,
      -3.3064163346386636E+001,
      -3.3097753971733106E+001,
      -3.3130037954425198E+001,
      -3.3161014019946563E+001,
      -3.3190680945415167E+001,
      -3.3219037559631609E+001,
      -3.3246082743125292E+001,
      -3.3271815428198686E+001,
      -3.3296234598969441E+001,
      -3.3319339291410529E+001,
      -3.3341128593388227E+001,
      -3.3361601644698219E+001,
      -3.3380757637099492E+001,
      -3.3398595814346265E+001,
      -3.3415115472217835E+001,
      -3.3430315958546416E+001,
      -3.3444196673242814E+001,
      -3.3456757068320194E+001,
      -3.3467996647915662E+001,
      -3.3477914968309854E+001,
      -3.3486511637944474E+001,
      -3.3493786317437717E+001,
      -3.3499738719597694E+001,
      -3.3504368609433762E+001,
      -3.3507675804165800E+001,
      -3.3509660173231417E+001,
      -3.3510321638291131E+001,
      -3.3509660173231417E+001,
      -3.3507675804165800E+001,
      -3.3504368609433762E+001,
      -3.3499738719597694E+001,
      -3.3493786317437717E+001,
      -3.3486511637944474E+001,
      -3.3477914968309854E+001,
      -3.3467996647915662E+001,
      -3.3456757068320194E+001,
      -3.3444196673242821E+001,
      -3.3430315958546416E+001,
      -3.3415115472217835E+001,
      -3.3398595814346265E+001,
      -3.3380757637099492E+001,
      -3.3361601644698219E+001,
      -3.3341128593388227E+001,
      -3.3319339291410529E+001,
      -3.3296234598969448E+001,
      -3.3271815428198686E+001,
      -3.3246082743125292E+001,
      -3.3219037559631609E+001,
      -3.3190680945415174E+001,
      -3.3161014019946563E+001,
      -3.3130037954425205E+001,
      -3.3097753971733106E+001,
      -3.3064163346386636E+001,
      -3.3029267404486170E+001,
      -3.2993067523663747E+001,
      -3.2955565133028649E+001,
      -3.2916761713111079E+001,
      -3.2876658795803600E+001,
      -3.2835257964300723E+001,
      -3.2792560853036363E+001,
      -3.2748569147619399E+001,
      -3.2703284584767026E+001,
      -3.2656708952236229E+001,
      -3.2608844088753230E+001,
      -3.2559691883940914E+001,
      -3.2509254278244121E+001,
      -3.2457533262853197E+001,
      -3.2404530879625234E+001,
      -3.2350249221003615E+001,
      -3.2294690429935230E+001,
      -3.2237856699786050E+001,
      -3.2179750274254410E+001,
      -3.2120373447282503E+001,
      -3.2059728562965773E+001,
      -3.1997818015460435E+001,
      -3.1934644248888894E+001,
      -3.1870209757243270E+001,
      -3.1804517084286957E+001,
      -3.1737568823454225E+001,
      -3.1669367617747771E+001,
      -3.1599916159634407E+001,
      -3.1529217190938766E+001,
      -3.1457273502735134E+001,
      -3.1384087935237059E+001,
      -3.1309663377685474E+001,
      -3.1234002768234458E+001,
      -3.1157109093835366E+001,
      -3.1078985390118731E+001,
      -3.0999634741274658E+001,
      -3.0919060279930875E+001,
      -3.0837265187029153E+001,
      -3.0754252691699680E+001,
      -3.0670026071133677E+001,
      -3.0584588650453881E+001,
      -3.0497943802583372E+001,
      -3.0410094948112352E+001,
      -3.0321045555163231E+001,
      -3.0230799139253538E+001,
      -3.0139359263157250E+001,
      -3.0046729536764065E+001,
      -2.9952913616937042E+001,
      -2.9857915207368027E+001,
      -2.9761738058431565E+001,
      -2.9664385967036786E+001,
      -2.9565862776477644E+001,
      -2.9466172376280905E+001,
      -2.9365318702052942E+001,
      -2.9263305735324103E+001,
      -2.9160137503391635E+001,
      -2.9055818079160659E+001,
      -2.8950351580983479E+001,
      -2.8843742172496821E+001,
      -2.8735994062457589E+001,
      -2.8627111504576650E+001,
      -2.8517098797350997E+001,
      -2.8405960283893929E+001,
      -2.8293700351763640E+001,
      -2.8180323432790008E+001,
      -2.8065834002899727E+001,
      -2.7950236581939414E+001,
      -2.7833535733497317E+001,
      -2.7715736064723078E+001,
      -2.7596842226146009E+001,
      -2.7476858911491181E+001,
      -2.7355790857494416E+001,
      -2.7233642843715241E+001,
      -2.7110419692348067E+001,
      -2.6986126268031907E+001,
      -2.6860767477658307E+001,
      -2.6734348270177723E+001,
      -2.6606873636403961E+001,
      -2.6478348608817310E+001,
      -2.6348778261365734E+001,
      -2.6218167709264812E+001,
      -2.6086522108795343E+001,
      -2.5953846657100339E+001,
      -2.5820146591979380E+001,
      -2.5685427191682212E+001,
      -2.5549693774699943E+001,
      -2.5412951699555563E+001,
      -2.5275206364592034E+001,
      -2.5136463207759316E+001,
      -2.4996727706399632E+001,
      -2.4856005377031394E+001,
      -2.4714301775131172E+001,
      -2.4571622494914529E+001,
      -2.4427973169115099E+001,
      -2.4283359468762384E+001,
      -2.4137787102957617E+001,
      -2.3991261818648532E+001,
      -2.3843789400402432E+001,
      -2.3695375670177992E+001,
      -2.3546026487094984E+001,
      -2.3395747747203572E+001,
      -2.3244545383250991E+001,
      -2.3092425364447799E+001,
      -2.2939393696231701E+001,
      -2.2785456420031053E+001,
      -2.2630619613025889E+001,
      -2.2474889387908238E+001,
      -2.2318271892640677E+001,
      -2.2160773310213841E+001,
      -2.2002399858402040E+001,
      -2.1843157789517974E+001,
      -2.1683053390165814E+001,
      -2.1522092980993179E+001,
      -2.1360282916441388E+001,
      -2.1197629584494713E+001,
      -2.1034139406428153E+001,
      -2.0869818836554089E+001,
      -2.0704674361967218E+001,
      -2.0538712502288611E+001,
      -2.0371939809408275E+001,
      -2.0204362867226706E+001,
      -2.0035988291394464E+001,
      -1.9866822729051620E+001,
      -1.9696872858564888E+001,
      -1.9526145389264148E+001,
      -1.9354647061177506E+001,
      -1.9182384644765403E+001,
      -1.9009364940653025E+001,
      -1.8835594779362040E+001,
      -1.8661081021040818E+001,
      -1.8485830555193825E+001,
      -1.8309850300409327E+001,
      -1.8133147204086448E+001,
      -1.7955728242160831E+001,
      -1.7777600418829390E+001,
      -1.7598770766273542E+001,
      -1.7419246344381765E+001,
      -1.7239034240470787E+001,
      -1.7058141569006050E+001,
      -1.6876575471320283E+001,
      -1.6694343115332288E+001,
      -1.6511451695263393E+001,
      -1.6327908431353702E+001,
      -1.6143720569576949E+001,
      -1.5958895381354635E+001,
      -1.5773440163268672E+001,
      -1.5587362236773519E+001,
      -1.5400668947907045E+001,
      -1.5213367667000727E+001,
      -1.5025465788388376E+001,
      -1.4836970730114418E+001,
      -1.4647889933640945E+001,
      -1.4458230863554149E+001,
      -1.4268001007269318E+001,
      -1.4077207874735450E+001,
      -1.3885858998138673E+001,
      -1.3693961931605159E+001,
      -1.3501524250902293E+001,
      -1.3308553553140369E+001,
      -1.3115057456472005E+001,
      -1.2921043599791945E+001,
      -1.2726519642434827E+001,
      -1.2531493263873573E+001,
      -1.2335972163415613E+001,
      -1.2139964059899210E+001,
      -1.1943476691388613E+001,
      -1.1746517814868804E+001,
      -1.1549095205938926E+001,
      -1.1351216658505534E+001,
      -1.1152889984474806E+001,
      -1.0954123013444352E+001,
      -1.0754923592393789E+001,
      -1.0555299585375179E+001,
      -1.0355258873202450E+001,
      -1.0154809353140564E+001,
      -9.9539589385931180E+000,
      -9.7527155587907419E+000,
      -9.5510871584773724E+000,
      -9.3490816975971818E+000,
      -9.1467071509796476E+000,
      -8.9439715080255215E+000,
      -8.7408827723907887E+000,
      -8.5374489616709930E+000,
      -8.3336781070845838E+000,
      -8.1295782531561098E+000,
      -7.9251574573982682E+000,
      -7.7204237899940518E+000,
      -7.5153853334780303E+000,
      -7.3100501824175028E+000,
      -7.1044264430925841E+000,
      -6.8985222331764184E+000,
      -6.6923456814145910E+000,
      -6.4859049273045084E+000,
      -6.2792081207734283E+000,
      -6.0722634218575244E+000,
      -5.8650790003790476E+000,
      -5.6576630356243767E+000,
      -5.4500237160204126E+000,
      -5.2421692388121341E+000,
      -5.0341078097383392E+000,
      -4.8258476427079895E+000,
      -4.6173969594758786E+000,
      -4.4087639893180004E+000,
      -4.1999569687068954E+000,
      -3.9909841409861437E+000,
      -3.7818537560451659E+000,
      -3.5725740699934110E+000,
      -3.3631533448347173E+000,
      -3.1535998481404928E+000,
      -2.9439218527241500E+000,
      -2.7341276363138634E+000,
      -2.5242254812260714E+000,
      -2.3142236740383879E+000,
      -2.1041305052626984E+000,
      -1.8939542690175095E+000,
      -1.6837032627007491E+000,
      -1.4733857866620790E+000,
      -1.2630101438754522E+000,
      -1.0525846396109646E+000,
      -8.4211758110721879E-001,
      -6.3161727724324768E-001,
      -4.2109203821073249E-001,
      -2.1055017518557384E-001,
      -1.8467238659729185E-014,
      2.1055017518559643E-001,
      4.2109203821075514E-001,
      6.3161727724327021E-001,
      8.4211758110718193E-001,
      1.0525846396109275E+000,
      1.2630101438754746E+000,
      1.4733857866621016E+000,
      1.6837032627007120E+000,
      1.8939542690175319E+000,
      2.1041305052627211E+000,
      2.3142236740384110E+000,
      2.5242254812260345E+000,
      2.7341276363138265E+000,
      2.9439218527241722E+000,
      3.1535998481405150E+000,
      3.3631533448346804E+000,
      3.5725740699934923E+000,
      3.7818537560451886E+000,
      3.9909841409861659E+000,
      4.1999569687068581E+000,
      4.4087639893179640E+000,
      4.6173969594759008E+000,
      4.8258476427080117E+000,
      5.0341078097383027E+000,
      5.2421692388122159E+000,
      5.4500237160204943E+000,
      5.6576630356243403E+000,
      5.8650790003790698E+000,
      6.0722634218574880E+000,
      6.2792081207734496E+000,
      6.4859049273044729E+000,
      6.6923456814146123E+000,
      6.8985222331764984E+000,
      7.1044264430926054E+000,
      7.3100501824175250E+000,
      7.5153853334780525E+000,
      7.7204237899940145E+000,
      7.9251574573982895E+000,
      8.1295782531561311E+000,
      8.3336781070846069E+000,
      8.5374489616709575E+000,
      8.7408827723907532E+000,
      8.9439715080255429E+000,
      9.1467071509796689E+000,
      9.3490816975971462E+000,
      9.5510871584774524E+000,
      9.7527155587907650E+000,
      9.9539589385931411E+000,
      1.0154809353140529E+001,
      1.0355258873202413E+001,
      1.0555299585375201E+001,
      1.0754923592393810E+001,
      1.0954123013444317E+001,
      1.1152889984474882E+001,
      1.1351216658505555E+001,
      1.1549095205938892E+001,
      1.1746517814868771E+001,
      1.1943476691388579E+001,
      1.2139964059899230E+001,
      1.2335972163415578E+001,
      1.2531493263873537E+001,
      1.2726519642434903E+001,
      1.2921043599791911E+001,
      1.3115057456472027E+001,
      1.3308553553140335E+001,
      1.3501524250902259E+001,
      1.3693961931605122E+001,
      1.3885858998138694E+001,
      1.4077207874735416E+001,
      1.4268001007269339E+001,
      1.4458230863554169E+001,
      1.4647889933640966E+001,
      1.4836970730114386E+001,
      1.5025465788388344E+001,
      1.5213367667000748E+001,
      1.5400668947907064E+001,
      1.5587362236773485E+001,
      1.5773440163268692E+001,
      1.5958895381354653E+001,
      1.6143720569576967E+001,
      1.6327908431353670E+001,
      1.6511451695263361E+001,
      1.6694343115332309E+001,
      1.6876575471320304E+001,
      1.7058141569006018E+001,
      1.7239034240470858E+001,
      1.7419246344381783E+001,
      1.7598770766273560E+001,
      1.7777600418829358E+001,
      1.7955728242160799E+001,
      1.8133147204086470E+001,
      1.8309850300409348E+001,
      1.8485830555193793E+001,
      1.8661081021040889E+001,
      1.8835594779362058E+001,
      1.9009364940652997E+001,
      1.9182384644765371E+001,
      1.9354647061177477E+001,
      1.9526145389264116E+001,
      1.9696872858564859E+001,
      1.9866822729051588E+001,
      2.0035988291394524E+001,
      2.0204362867226678E+001,
      2.0371939809408293E+001,
      2.0538712502288583E+001,
      2.0704674361967186E+001,
      2.0869818836554106E+001,
      2.1034139406428174E+001,
      2.1197629584494685E+001,
      2.1360282916441406E+001,
      2.1522092980993200E+001,
      2.1683053390165828E+001,
      2.1843157789517942E+001,
      2.2002399858402011E+001,
      2.2160773310213859E+001,
      2.2318271892640691E+001,
      2.2474889387908210E+001,
      2.2630619613025910E+001,
      2.2785456420031068E+001,
      2.2939393696231718E+001,
      2.3092425364447770E+001,
      2.3244545383250962E+001,
      2.3395747747203586E+001,
      2.3546026487095002E+001,
      2.3695375670177963E+001,
      2.3843789400402489E+001,
      2.3991261818648550E+001,
      2.4137787102957631E+001,
      2.4283359468762360E+001,
      2.4427973169115077E+001,
      2.4571622494914543E+001,
      2.4714301775131148E+001,
      2.4856005377031373E+001,
      2.4996727706399689E+001,
      2.5136463207759331E+001,
      2.5275206364592012E+001,
      2.5412951699555542E+001,
      2.5549693774699918E+001,
      2.5685427191682191E+001,
      2.5820146591979391E+001,
      2.5953846657100314E+001,
      2.6086522108795357E+001,
      2.6218167709264783E+001,
      2.6348778261365748E+001,
      2.6478348608817281E+001,
      2.6606873636403940E+001,
      2.6734348270177733E+001,
      2.6860767477658317E+001,
      2.6986126268031889E+001,
      2.7110419692348078E+001,
      2.7233642843715252E+001,
      2.7355790857494426E+001,
      2.7476858911491160E+001,
      2.7596842226145988E+001,
      2.7715736064723121E+001,
      2.7833535733497332E+001,
      2.7950236581939429E+001,
      2.8065834002899773E+001,
      2.8180323432790054E+001,
      2.8293700351763651E+001,
      2.8405960283893940E+001,
      2.8517098797350979E+001,
      2.8627111504576689E+001,
      2.8735994062457600E+001,
      2.8843742172496800E+001,
      2.8950351580983522E+001,
      2.9055818079160641E+001,
      2.9160137503391621E+001,
      2.9263305735324082E+001,
      2.9365318702052924E+001,
      2.9466172376280941E+001,
      2.9565862776477630E+001,
      2.9664385967036797E+001,
      2.9761738058431547E+001,
      2.9857915207368009E+001,
      2.9952913616937053E+001,
      3.0046729536764076E+001,
      3.0139359263157228E+001,
      3.0230799139253548E+001,
      3.0321045555163241E+001,
      3.0410094948112359E+001,
      3.0497943802583357E+001,
      3.0584588650453867E+001,
      3.0670026071133684E+001,
      3.0754252691699691E+001,
      3.0837265187029139E+001,
      3.0919060279930886E+001,
      3.0999634741274665E+001,
      3.1078985390118739E+001,
      3.1157109093835356E+001,
      3.1234002768234440E+001,
      3.1309663377685485E+001,
      3.1384087935237066E+001,
      3.1457273502735120E+001,
      3.1529217190938795E+001,
      3.1599916159634414E+001,
      3.1669367617747781E+001,
      3.1737568823454215E+001,
      3.1804517084286942E+001,
      3.1870209757243277E+001,
      3.1934644248888883E+001,
      3.1997818015460425E+001,
      3.2059728562965795E+001,
      3.2120373447282510E+001,
      3.2179750274254395E+001,
      3.2237856699786036E+001,
      3.2294690429935216E+001,
      3.2350249221003608E+001,
      3.2404530879625241E+001,
      3.2457533262853183E+001,
      3.2509254278244121E+001,
      3.2559691883940907E+001,
      3.2608844088753237E+001,
      3.2656708952236222E+001,
      3.2703284584767012E+001,
      3.2748569147619406E+001,
      3.2792560853036370E+001,
      3.2835257964300716E+001,
      3.2876658795803607E+001,
      3.2916761713111086E+001,
      3.2955565133028657E+001,
      3.2993067523663740E+001,
      3.3029267404486170E+001,
      3.3064163346386643E+001,
      3.3097753971733106E+001,
      3.3130037954425198E+001,
      3.3161014019946570E+001,
      3.3190680945415174E+001,
      3.3219037559631609E+001,
      3.3246082743125292E+001,
      3.3271815428198678E+001,
      3.3296234598969448E+001,
      3.3319339291410529E+001,
      3.3341128593388227E+001,
      3.3361601644698233E+001,
      3.3380757637099499E+001,
      3.3398595814346258E+001,
      3.3415115472217835E+001,
      3.3430315958546416E+001,
      3.3444196673242821E+001,
      3.3456757068320194E+001,
      3.3467996647915662E+001,
      3.3477914968309854E+001,
      3.3486511637944474E+001,
      3.3493786317437717E+001,
      3.3499738719597694E+001,
      3.3504368609433762E+001,
      3.3507675804165800E+001,
      3.3509660173231417E+001,
      3.3510321638291131E+001,
      3.3509660173231417E+001,
      3.3507675804165800E+001,
      3.3504368609433762E+001,
      3.3499738719597694E+001,
      3.3493786317437717E+001,
      3.3486511637944474E+001,
      3.3477914968309854E+001,
      3.3467996647915662E+001,
      3.3456757068320194E+001,
      3.3444196673242814E+001,
      3.3430315958546416E+001,
      3.3415115472217835E+001,
      3.3398595814346265E+001,
      3.3380757637099492E+001,
      3.3361601644698219E+001,
      3.3341128593388227E+001,
      3.3319339291410522E+001,
      3.3296234598969441E+001,
      3.3271815428198686E+001,
      3.3246082743125292E+001,
      3.3219037559631616E+001,
      3.3190680945415167E+001,
      3.3161014019946563E+001,
      3.3130037954425205E+001,
      3.3097753971733098E+001,
      3.3064163346386628E+001,
      3.3029267404486177E+001,
      3.2993067523663747E+001,
      3.2955565133028664E+001,
      3.2916761713111079E+001,
      3.2876658795803607E+001,
      3.2835257964300723E+001,
      3.2792560853036356E+001,
      3.2748569147619399E+001,
      3.2703284584767026E+001,
      3.2656708952236229E+001,
      3.2608844088753244E+001,
      3.2559691883940907E+001,
      3.2509254278244121E+001,
      3.2457533262853197E+001,
      3.2404530879625234E+001,
      3.2350249221003601E+001,
      3.2294690429935230E+001,
      3.2237856699786050E+001,
      3.2179750274254410E+001,
      3.2120373447282489E+001,
      3.2059728562965752E+001,
      3.1997818015460453E+001,
      3.1934644248888876E+001,
      3.1870209757243291E+001,
      3.1804517084286960E+001,
      3.1737568823454225E+001,
      3.1669367617747771E+001,
      3.1599916159634372E+001,
      3.1529217190938791E+001,
      3.1457273502735138E+001,
      3.1384087935237080E+001,
      3.1309663377685503E+001,
      3.1234002768234458E+001,
      3.1157109093835349E+001,
      3.1078985390118774E+001,
      3.0999634741274658E+001,
      3.0919060279930878E+001,
      3.0837265187029153E+001,
      3.0754252691699705E+001,
      3.0670026071133702E+001,
      3.0584588650453860E+001,
      3.0497943802583400E+001,
      3.0410094948112352E+001,
      3.0321045555163234E+001,
      3.0230799139253541E+001,
      3.0139359263157250E+001,
      3.0046729536764094E+001,
      2.9952913616937071E+001,
      2.9857915207368059E+001,
      2.9761738058431540E+001,
      2.9664385967036843E+001,
      2.9565862776477619E+001,
      2.9466172376280905E+001,
      2.9365318702052946E+001,
      2.9263305735324103E+001,
      2.9160137503391638E+001,
      2.9055818079160630E+001,
      2.8950351580983511E+001,
      2.8843742172496789E+001,
      2.8735994062457564E+001,
      2.8627111504576650E+001,
      2.8517098797351000E+001,
      2.8405960283893929E+001,
      2.8293700351763707E+001,
      2.8180323432790047E+001,
      2.8065834002899695E+001,
      2.7950236581939453E+001,
      2.7833535733497289E+001,
      2.7715736064723078E+001,
      2.7596842226145977E+001,
      2.7476858911491217E+001,
      2.7355790857494416E+001,
      2.7233642843715241E+001,
      2.7110419692348067E+001,
      2.6986126268031910E+001,
      2.6860767477658275E+001,
      2.6734348270177684E+001,
      2.6606873636404003E+001,
      2.6478348608817271E+001,
      2.6348778261365805E+001,
      2.6218167709264772E+001,
      2.6086522108795346E+001,
      2.5953846657100339E+001,
      2.5820146591979345E+001,
      2.5685427191682216E+001,
      2.5549693774699904E+001,
      2.5412951699555610E+001,
      2.5275206364592002E+001,
      2.5136463207759277E+001,
      2.4996727706399636E+001,
      2.4856005377031398E+001,
      2.4714301775131172E+001,
      2.4571622494914447E+001,
      2.4427973169115145E+001,
      2.4283359468762345E+001,
      2.4137787102957660E+001,
      2.3991261818648496E+001,
      2.3843789400402436E+001,
      2.3695375670177953E+001,
      2.3546026487094903E+001,
      2.3395747747203576E+001,
      2.3244545383250948E+001,
      2.3092425364447799E+001,
      2.2939393696231750E+001,
      2.2785456420031011E+001,
      2.2630619613025853E+001,
      2.2474889387908281E+001,
      2.2318271892640681E+001,
      2.2160773310213756E+001,
      2.2002399858402043E+001,
      2.1843157789517981E+001,
      2.1683053390165860E+001,
      2.1522092980993136E+001,
      2.1360282916441435E+001,
      2.1197629584494670E+001,
      2.1034139406428160E+001,
      2.0869818836554092E+001,
      2.0704674361967221E+001,
      2.0538712502288611E+001,
      2.0371939809408325E+001,
      2.0204362867226710E+001,
      2.0035988291394418E+001,
      1.9866822729051673E+001,
      1.9696872858564845E+001,
      1.9526145389264101E+001,
      1.9354647061177509E+001,
      1.9182384644765406E+001,
      1.9009364940653029E+001,
      1.8835594779361944E+001,
      1.8661081021040875E+001,
      1.8485830555193779E+001,
      1.8309850300409281E+001,
      1.8133147204086406E+001,
      1.7955728242160834E+001,
      1.7777600418829394E+001,
      1.7598770766273645E+001,
      1.7419246344381765E+001,
      1.7239034240470737E+001,
      1.7058141569006054E+001,
      1.6876575471320237E+001,
      1.6694343115332241E+001,
      1.6511451695263347E+001,
      1.6327908431353759E+001,
      1.6143720569576953E+001,
      1.5958895381354532E+001,
      1.5773440163268676E+001,
      1.5587362236773522E+001,
      1.5400668947907100E+001,
      1.5213367667000787E+001,
      1.5025465788388434E+001,
      1.4836970730114368E+001,
      1.4647889933641055E+001,
      1.4458230863554153E+001,
      1.4268001007269321E+001,
      1.4077207874735453E+001,
      1.3885858998138730E+001,
      1.3693961931605163E+001,
      1.3501524250902243E+001,
      1.3308553553140426E+001,
      1.3115057456472009E+001,
      1.2921043599791895E+001,
      1.2726519642434830E+001,
      1.2531493263873577E+001,
      1.2335972163415617E+001,
      1.2139964059899324E+001,
      1.1943476691388671E+001,
      1.1746517814868753E+001,
      1.1549095205938986E+001,
      1.1351216658505480E+001,
      1.1152889984474809E+001,
      1.0954123013444356E+001,
      1.0754923592393908E+001,
      1.0555299585375183E+001,
      1.0355258873202397E+001,
      1.0154809353140568E+001,
      9.9539589385931784E+000,
      9.7527155587906904E+000,
      9.5510871584773760E+000,
      9.3490816975972439E+000,
      9.1467071509796511E+000,
      8.9439715080256388E+000,
      8.7408827723907923E+000,
      8.5374489616709965E+000,
      8.3336781070846460E+000,
      8.1295782531560565E+000,
      7.9251574573983294E+000,
      7.7204237899939967E+000,
      7.5153853334781502E+000,
      7.3100501824175064E+000,
      7.1044264430925876E+000,
      6.8985222331764220E+000,
      6.6923456814146531E+000,
      6.4859049273045128E+000,
      6.2792081207733741E+000,
      6.0722634218575866E+000,
      5.8650790003790512E+000,
      5.6576630356244397E+000,
      5.4500237160204170E+000,
      5.2421692388121377E+000,
      5.0341078097383436E+000,
      4.8258476427078749E+000,
      4.6173969594758830E+000,
      4.4087639893179453E+000,
      4.1999569687069593E+000,
      3.9909841409862072E+000,
      3.7818537560451109E+000,
      3.5725740699934150E+000,
      3.3631533448347803E+000,
      3.1535998481404963E+000,
      2.9439218527240354E+000,
      2.7341276363138673E+000,
      2.5242254812260758E+000,
      2.3142236740384514E+000,
      2.1041305052626429E+000,
      1.8939542690175728E+000,
      1.6837032627006936E+000,
      1.4733857866619644E+000,
      1.2630101438754564E+000,
      1.0525846396109688E+000,
      8.4211758110722290E-001,
      6.3161727724331129E-001,
      4.2109203821079616E-001,
      2.1055017518551841E-001,
      8.2097358505682983E-014,
      -2.1055017518559233E-001,
      -4.2109203821075103E-001,
      -6.3161727724326611E-001,
      -8.4211758110717783E-001,
      -1.0525846396109235E+000,
      -1.2630101438755301E+000,
      -1.4733857866620383E+000,
      -1.6837032627007673E+000,
      -1.8939542690175277E+000,
      -2.1041305052627166E+000,
      -2.3142236740384066E+000,
      -2.5242254812260301E+000,
      -2.7341276363138221E+000,
      -2.9439218527241087E+000,
      -3.1535998481405700E+000,
      -3.3631533448346174E+000,
      -3.5725740699934883E+000,
      -3.7818537560451837E+000,
      -3.9909841409861619E+000,
      -4.1999569687067959E+000,
      -4.4087639893180190E+000,
      -4.6173969594759567E+000,
      -4.8258476427079486E+000,
      -5.0341078097382992E+000,
      -5.2421692388120933E+000,
      -5.4500237160204899E+000,
      -5.6576630356242772E+000,
      -5.8650790003791249E+000,
      -6.0722634218574258E+000,
      -6.2792081207734460E+000,
      -6.4859049273044684E+000,
      -6.6923456814146087E+000,
      -6.8985222331763785E+000,
      -7.1044264430925432E+000,
      -7.3100501824175792E+000,
      -7.5153853334779903E+000,
      -7.7204237899940686E+000,
      -7.9251574573982859E+000,
      -8.1295782531561276E+000,
      -8.3336781070846033E+000,
      -8.5374489616709539E+000,
      -8.7408827723908651E+000,
      -8.9439715080254825E+000,
      -9.1467071509797222E+000,
      -9.3490816975970858E+000,
      -9.5510871584774488E+000,
      -9.7527155587906460E+000,
      -9.9539589385931340E+000,
      -1.0154809353140411E+001,
      -1.0355258873202470E+001,
      -1.0555299585375254E+001,
      -1.0754923592393750E+001,
      -1.0954123013444425E+001,
      -1.1152889984474767E+001,
      -1.1351216658505551E+001,
      -1.1549095205938832E+001,
      -1.1746517814868822E+001,
      -1.1943476691388742E+001,
      -1.2139964059899171E+001,
      -1.2335972163415686E+001,
      -1.2531493263873534E+001,
      -1.2726519642434900E+001,
      -1.2921043599791853E+001,
      -1.3115057456472078E+001,
      -1.3308553553140275E+001,
      -1.3501524250902309E+001,
      -1.3693961931605230E+001,
      -1.3885858998138691E+001,
      -1.4077207874735521E+001,
      -1.4268001007269280E+001,
      -1.4458230863554219E+001,
      -1.4647889933640906E+001,
      -1.4836970730114434E+001,
      -1.5025465788388500E+001,
      -1.5213367667000744E+001,
      -1.5400668947906956E+001,
      -1.5587362236773481E+001,
      -1.5773440163268742E+001,
      -1.5958895381354598E+001,
      -1.6143720569577017E+001,
      -1.6327908431353613E+001,
      -1.6511451695263410E+001,
      -1.6694343115332199E+001,
      -1.6876575471320301E+001,
      -1.7058141569005912E+001,
      -1.7239034240470801E+001,
      -1.7419246344381826E+001,
      -1.7598770766273510E+001,
      -1.7777600418829458E+001,
      -1.7955728242160795E+001,
      -1.8133147204086466E+001,
      -1.8309850300409245E+001,
      -1.8485830555193843E+001,
      -1.8661081021040935E+001,
      -1.8835594779362005E+001,
      -1.9009364940653089E+001,
      -1.9182384644765367E+001,
      -1.9354647061177570E+001,
      -1.9526145389264066E+001,
      -1.9696872858564905E+001,
      -1.9866822729051538E+001,
      -2.0035988291394478E+001,
      -2.0204362867226770E+001,
      -2.0371939809408293E+001,
      -2.0538712502288671E+001,
      -2.0704674361967182E+001,
      -2.0869818836554153E+001,
      -2.1034139406428125E+001,
      -2.1197629584494727E+001,
      -2.1360282916441491E+001,
      -2.1522092980993197E+001,
      -2.1683053390165732E+001,
      -2.1843157789517942E+001,
      -2.2002399858401919E+001,
      -2.2160773310213813E+001,
      -2.2318271892640734E+001,
      -2.2474889387908163E+001,
      -2.2630619613025903E+001,
      -2.2785456420030979E+001,
      -2.2939393696231715E+001,
      -2.3092425364447681E+001,
      -2.3244545383251005E+001,
      -2.3395747747203625E+001,
      -2.3546026487094959E+001,
      -2.3695375670178002E+001,
      -2.3843789400402400E+001,
      -2.3991261818648546E+001,
      -2.4137787102957546E+001,
      -2.4283359468762399E+001,
      -2.4427973169115031E+001,
      -2.4571622494914500E+001,
      -2.4714301775131226E+001,
      -2.4856005377031369E+001,
      -2.4996727706399689E+001,
      -2.5136463207759249E+001,
      -2.5275206364592048E+001,
      -2.5412951699555503E+001,
      -2.5549693774699954E+001,
      -2.5685427191682265E+001,
      -2.5820146591979391E+001,
      -2.5953846657100389E+001,
      -2.6086522108795315E+001,
      -2.6218167709264819E+001,
      -2.6348778261365705E+001,
      -2.6478348608817317E+001,
      -2.6606873636403900E+001,
      -2.6734348270177733E+001,
      -2.6860767477658388E+001,
      -2.6986126268031885E+001,
      -2.7110419692347968E+001,
      -2.7233642843715216E+001,
      -2.7355790857494458E+001,
      -2.7476858911491124E+001,
      -2.7596842226146016E+001,
      -2.7715736064723057E+001,
      -2.7833535733497328E+001,
      -2.7950236581939361E+001,
      -2.8065834002899738E+001,
      -2.8180323432790082E+001,
      -2.8293700351763619E+001,
      -2.8405960283893968E+001,
      -2.8517098797350975E+001,
      -2.8627111504576686E+001,
      -2.8735994062457539E+001,
      -2.8843742172496828E+001,
      -2.8950351580983430E+001,
      -2.9055818079160669E+001,
      -2.9160137503391674E+001,
      -2.9263305735324082E+001,
      -2.9365318702052978E+001,
      -2.9466172376280888E+001,
      -2.9565862776477655E+001,
      -2.9664385967036768E+001,
      -2.9761738058431572E+001,
      -2.9857915207368091E+001,
      -2.9952913616937050E+001,
      -3.0046729536764129E+001,
      -3.0139359263157228E+001,
      -3.0230799139253570E+001,
      -3.0321045555163217E+001,
      -3.0410094948112384E+001,
      -3.0497943802583329E+001,
      -3.0584588650453888E+001,
      -3.0670026071133730E+001,
      -3.0754252691699687E+001,
      -3.0837265187029093E+001,
      -3.0919060279930861E+001,
      -3.0999634741274690E+001,
      -3.1078985390118717E+001,
      -3.1157109093835377E+001,
      -3.1234002768234525E+001,
      -3.1309663377685482E+001,
      -3.1384087935237019E+001,
      -3.1457273502735120E+001,
      -3.1529217190938812E+001,
      -3.1599916159634397E+001,
      -3.1669367617747799E+001,
      -3.1737568823454215E+001,
      -3.1804517084286982E+001,
      -3.1870209757243238E+001,
      -3.1934644248888898E+001,
      -3.1997818015460403E+001,
      -3.2059728562965773E+001,
      -3.2120373447282525E+001,
      -3.2179750274254395E+001,
      -3.2237856699786072E+001,
      -3.2294690429935216E+001,
      -3.2350249221003622E+001,
      -3.2404530879625227E+001,
      -3.2457533262853197E+001,
      -3.2509254278244157E+001,
      -3.2559691883940907E+001,
      -3.2608844088753258E+001,
      -3.2656708952236215E+001,
      -3.2703284584766990E+001,
      -3.2748569147619392E+001,
      -3.2792560853036377E+001,
      -3.2835257964300702E+001,
      -3.2876658795803607E+001,
      -3.2916761713111107E+001,
      -3.2955565133028657E+001,
      -3.2993067523663719E+001,
      -3.3029267404486170E+001,
      -3.3064163346386650E+001,
      -3.3097753971733098E+001,
      -3.3130037954425205E+001,
      -3.3161014019946585E+001,
      -3.3190680945415174E+001,
      -3.3219037559631595E+001,
      -3.3246082743125292E+001,
      -3.3271815428198664E+001,
      -3.3296234598969441E+001,
      -3.3319339291410536E+001,
      -3.3341128593388220E+001,
      -3.3361601644698219E+001,
      -3.3380757637099485E+001,
      -3.3398595814346265E+001,
      -3.3415115472217828E+001,
      -3.3430315958546416E+001,
      -3.3444196673242821E+001,
      -3.3456757068320194E+001,
      -3.3467996647915662E+001,
      -3.3477914968309854E+001,
      -3.3486511637944474E+001,
      -3.3493786317437717E+001,
      -3.3499738719597701E+001,
      -3.3504368609433762E+001,
      -3.3507675804165800E+001,
      -3.3509660173231417E+001,
      -3.3510321638291131E+001,
      -3.3509660173231417E+001,
      -3.3507675804165800E+001,
      -3.3504368609433762E+001,
      -3.3499738719597701E+001,
      -3.3493786317437717E+001,
      -3.3486511637944467E+001,
      -3.3477914968309854E+001,
      -3.3467996647915669E+001,
      -3.3456757068320194E+001,
      -3.3444196673242814E+001,
      -3.3430315958546423E+001,
      -3.3415115472217835E+001,
      -3.3398595814346272E+001,
      -3.3380757637099492E+001,
      -3.3361601644698233E+001,
      -3.3341128593388227E+001,
      -3.3319339291410536E+001,
      -3.3296234598969448E+001,
      -3.3271815428198678E+001,
      -3.3246082743125292E+001,
      -3.3219037559631602E+001,
      -3.3190680945415181E+001,
      -3.3161014019946563E+001,
      -3.3130037954425212E+001,
      -3.3097753971733106E+001,
      -3.3064163346386621E+001,
      -3.3029267404486177E+001,
      -3.2993067523663726E+001,
      -3.2955565133028664E+001,
      -3.2916761713111072E+001,
      -3.2876658795803614E+001,
      -3.2835257964300709E+001,
      -3.2792560853036392E+001,
      -3.2748569147619399E+001,
      -3.2703284584766998E+001,
      -3.2656708952236229E+001,
      -3.2608844088753273E+001,
      -3.2559691883940921E+001,
      -3.2509254278244107E+001,
      -3.2457533262853211E+001,
      -3.2404530879625234E+001,
      -3.2350249221003573E+001,
      -3.2294690429935230E+001,
      -3.2237856699786086E+001,
      -3.2179750274254410E+001,
      -3.2120373447282475E+001,
      -3.2059728562965795E+001,
      -3.1997818015460421E+001,
      -3.1934644248888912E+001,
      -3.1870209757243252E+001,
      -3.1804517084286996E+001,
      -3.1737568823454229E+001,
      -3.1669367617747813E+001,
      -3.1599916159634411E+001,
      -3.1529217190938748E+001,
      -3.1457273502735138E+001,
      -3.1384087935237037E+001,
      -3.1309663377685503E+001,
      -3.1234002768234461E+001,
      -3.1157109093835395E+001,
      -3.1078985390118735E+001,
      -3.0999634741274615E+001,
      -3.0919060279930878E+001,
      -3.0837265187029111E+001,
      -3.0754252691699712E+001,
      -3.0670026071133655E+001,
      -3.0584588650453910E+001,
      -3.0497943802583350E+001,
      -3.0410094948112402E+001,
      -3.0321045555163234E+001,
      -3.0230799139253488E+001,
      -3.0139359263157250E+001,
      -3.0046729536764147E+001,
      -2.9952913616937071E+001,
      -2.9857915207368002E+001,
      -2.9761738058431593E+001,
      -2.9664385967036790E+001,
      -2.9565862776477566E+001,
      -2.9466172376280909E+001,
      -2.9365318702053006E+001,
      -2.9263305735324106E+001,
      -2.9160137503391582E+001,
      -2.9055818079160694E+001,
      -2.8950351580983455E+001,
      -2.8843742172496857E+001,
      -2.8735994062457564E+001,
      -2.8627111504576714E+001,
      -2.8517098797351000E+001,
      -2.8405960283893997E+001,
      -2.8293700351763643E+001,
      -2.8180323432789983E+001,
      -2.8065834002899763E+001,
      -2.7950236581939389E+001,
      -2.7833535733497357E+001,
      -2.7715736064723082E+001,
      -2.7596842226146048E+001,
      -2.7476858911491153E+001,
      -2.7355790857494348E+001,
      -2.7233642843715245E+001,
      -2.7110419692348000E+001,
      -2.6986126268031914E+001,
      -2.6860767477658278E+001,
      -2.6734348270177762E+001,
      -2.6606873636403932E+001,
      -2.6478348608817349E+001,
      -2.6348778261365737E+001,
      -2.6218167709264701E+001,
      -2.6086522108795350E+001,
      -2.5953846657100417E+001,
      -2.5820146591979423E+001,
      -2.5685427191682145E+001,
      -2.5549693774699985E+001,
      -2.5412951699555535E+001,
      -2.5275206364592076E+001,
      -2.5136463207759281E+001,
      -2.4996727706399717E+001,
      -2.4856005377031401E+001,
      -2.4714301775131094E+001,
      -2.4571622494914532E+001,
      -2.4427973169115063E+001,
      -2.4283359468762431E+001,
      -2.4137787102957585E+001,
      -2.3991261818648582E+001,
      -2.3843789400402439E+001,
      -2.3695375670178038E+001,
      -2.3546026487094991E+001,
      -2.3395747747203494E+001,
      -2.3244545383251037E+001,
      -2.3092425364447720E+001,
      -2.2939393696231754E+001,
      -2.2785456420031014E+001,
      -2.2630619613025942E+001,
      -2.2474889387908199E+001,
      -2.2318271892640769E+001,
      -2.2160773310213848E+001,
      -2.2002399858401954E+001,
      -2.1843157789517985E+001,
      -2.1683053390165767E+001,
      -2.1522092980993232E+001,
      -2.1360282916441342E+001,
      -2.1197629584494763E+001,
      -2.1034139406428164E+001,
      -2.0869818836554003E+001,
      -2.0704674361967225E+001,
      -2.0538712502288710E+001,
      -2.0371939809408328E+001,
      -2.0204362867226621E+001,
      -2.0035988291394514E+001,
      -1.9866822729051577E+001,
      -1.9696872858564941E+001,
      -1.9526145389264105E+001,
      -1.9354647061177612E+001,
      -1.9182384644765410E+001,
      -1.9009364940653132E+001,
      -1.8835594779362047E+001,
      -1.8661081021040779E+001,
      -1.8485830555193886E+001,
      -1.8309850300409284E+001,
      -1.8133147204086509E+001,
      -1.7955728242160838E+001,
      -1.7777600418829497E+001,
      -1.7598770766273550E+001,
      -1.7419246344381669E+001,
      -1.7239034240470840E+001,
      -1.7058141569005951E+001,
      -1.6876575471320344E+001,
      -1.6694343115332245E+001,
      -1.6511451695263453E+001,
      -1.6327908431353656E+001,
      -1.6143720569577059E+001,
      -1.5958895381354642E+001,
      -1.5773440163268573E+001,
      -1.5587362236773526E+001,
      -1.5400668947906999E+001,
      -1.5213367667000790E+001,
      -1.5025465788388329E+001,
      -1.4836970730114480E+001,
      -1.4647889933640952E+001,
      -1.4458230863554048E+001,
      -1.4268001007269325E+001,
      -1.4077207874735565E+001,
      -1.3885858998138735E+001,
      -1.3693961931605056E+001,
      -1.3501524250902353E+001,
      -1.3308553553140321E+001,
      -1.3115057456472123E+001,
      -1.2921043599791899E+001,
      -1.2726519642434946E+001,
      -1.2531493263873580E+001,
      -1.2335972163415731E+001,
      -1.2139964059899217E+001,
      -1.1943476691388566E+001,
      -1.1746517814868870E+001,
      -1.1549095205938880E+001,
      -1.1351216658505599E+001,
      -1.1152889984474813E+001,
      -1.0954123013444471E+001,
      -1.0754923592393798E+001,
      -1.0555299585375074E+001,
      -1.0355258873202516E+001,
      -1.0154809353140458E+001,
      -9.9539589385931837E+000,
      -9.7527155587906940E+000,
      -9.5510871584774950E+000,
      -9.3490816975971320E+000,
      -9.1467071509797719E+000,
      -8.9439715080255286E+000,
      -8.7408827723906803E+000,
      -8.5374489616710001E+000,
      -8.3336781070845358E+000,
      -8.1295782531561755E+000,
      -7.9251574573982184E+000,
      -7.7204237899941166E+000,
      -7.5153853334780383E+000,
      -7.3100501824173945E+000,
      -7.1044264430925912E+000,
      -6.8985222331763092E+000,
      -6.6923456814146567E+000,
      -6.4859049273044009E+000,
      -6.2792081207734949E+000,
      -6.0722634218574738E+000,
      -5.8650790003791728E+000,
      -5.6576630356243269E+000,
      -5.4500237160205387E+000,
      -5.2421692388121430E+000,
      -5.0341078097384662E+000,
      -4.8258476427079966E+000,
      -4.6173969594757702E+000,
      -4.4087639893180670E+000,
      -4.1999569687068448E+000,
      -3.9909841409862108E+000,
      -3.7818537560451149E+000,
      -3.5725740699935371E+000,
      -3.3631533448346662E+000,
      -3.1535998481403817E+000,
      -2.9439218527241580E+000,
      -2.7341276363137528E+000,
      -2.5242254812260798E+000,
      -2.3142236740383368E+000,
      -2.1041305052627659E+000,
      -1.8939542690174584E+000,
      -1.6837032627008166E+000,
      -1.4733857866620876E+000,
      -1.2630101438753414E+000,
      -1.0525846396109728E+000,
      -8.4211758110710799E-001,
      -6.3161727724331540E-001,
      -4.2109203821068114E-001,
      -2.1055017518564156E-001,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      3.9999999999999997E-001,
      7.9999999999999993E-001,
      1.2,
      1.5999999999999999E+000,
      1.9999999999999998E+000,
      2.4,
      2.8,
      3.1999999999999997E+000,
      3.6,
      3.9999999999999996E+000,
      4.3999999999999995E+000,
      4.8,
      5.2,
      5.6,
      5.9999999999999991E+000,
      6.3999999999999995E+000,
      6.8,
      7.2,
      7.5999999999999988E+000,
      7.9999999999999991E+000,
      8.4,
      8.7999999999999989E+000,
      9.2,
      9.6,
      10.0,
      10.4,
      1.0799999999999999E+001,
      11.2,
      11.6,
      1.1999999999999998E+001,
      1.2399999999999999E+001,
      1.2799999999999999E+001,
      13.2,
      13.6,
      14.0,
      14.4,
      1.4799999999999997E+001,
      1.5199999999999998E+001,
      1.5599999999999998E+001,
      1.5999999999999998E+001,
      16.4,
      16.8,
      1.7200000000000003E+001,
      1.7599999999999998E+001,
      1.7999999999999996E+001,
      18.4,
      1.8799999999999997E+001,
      19.2,
      1.9599999999999998E+001,
      20.0,
      2.0400000000000002E+001,
      20.8,
      2.1200000000000003E+001,
      21.6,
      2.2000000000000004E+001,
      22.4,
      2.2799999999999997E+001,
      23.2,
      2.3599999999999998E+001,
      24.0,
      2.4400000000000002E+001,
      24.8,
      2.5199999999999996E+001,
      2.5599999999999998E+001,
      2.5999999999999996E+001,
      26.4,
      2.6799999999999997E+001,
      27.2,
      2.7599999999999998E+001,
      28.0,
      2.8400000000000002E+001,
      28.8,
      2.9200000000000003E+001,
      29.6,
      3.0000000000000004E+001,
      3.0400000000000002E+001,
      3.0800000000000004E+001,
      3.1199999999999996E+001,
      3.1599999999999994E+001,
      3.1999999999999996E+001,
      32.4,
      32.8,
      3.3199999999999996E+001,
      33.6,
      34.0,
      3.4400000000000006E+001,
      3.4800000000000004E+001,
      35.2,
      35.6,
      3.5999999999999993E+001,
      36.4,
      36.8,
      3.7199999999999996E+001,
      3.7599999999999994E+001,
      38.0,
      38.4,
      38.8,
      3.9199999999999996E+001,
      39.6,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      40.0,
      39.6,
      3.9199999999999996E+001,
      38.8,
      38.4,
      38.0,
      3.7599999999999994E+001,
      3.7199999999999996E+001,
      36.8,
      36.4,
      3.6000000000000007E+001,
      35.6,
      35.2,
      3.4800000000000004E+001,
      3.4400000000000006E+001,
      34.0,
      33.6,
      33.2,
      3.2800000000000004E+001,
      32.4,
      32.0,
      3.1599999999999998E+001,
      31.2,
      3.0799999999999997E+001,
      30.4,
      2.9999999999999996E+001,
      2.9599999999999998E+001,
      2.9200000000000003E+001,
      28.8,
      2.8400000000000002E+001,
      2.8000000000000004E+001,
      2.7600000000000005E+001,
      2.7200000000000003E+001,
      2.6800000000000004E+001,
      2.6400000000000002E+001,
      2.6000000000000004E+001,
      25.6,
      2.5200000000000003E+001,
      24.8,
      2.4400000000000002E+001,
      24.0,
      2.3599999999999998E+001,
      23.2,
      2.2799999999999997E+001,
      2.2400000000000002E+001,
      2.2000000000000004E+001,
      21.6,
      2.1200000000000003E+001,
      20.8,
      2.0400000000000002E+001,
      20.0,
      1.9599999999999998E+001,
      19.2,
      1.8799999999999997E+001,
      18.4,
      1.7999999999999996E+001,
      17.6,
      1.7200000000000003E+001,
      16.8,
      1.6400000000000002E+001,
      16.0,
      15.6,
      15.2,
      1.4800000000000002E+001,
      1.4400000000000002E+001,
      1.4000000000000002E+001,
      1.3600000000000001E+001,
      1.3200000000000001E+001,
      12.8,
      12.4,
      12.0,
      11.6,
      11.2,
      1.0799999999999999E+001,
      1.0399999999999999E+001,
      9.9999999999999982E+000,
      9.5999999999999979E+000,
      9.1999999999999975E+000,
      8.8000000000000043E+000,
      8.4000000000000039E+000,
      8.0000000000000036E+000,
      7.6000000000000032E+000,
      7.2000000000000028E+000,
      6.8000000000000025E+000,
      6.3999999999999986E+000,
      5.9999999999999982E+000,
      5.5999999999999979E+000,
      5.1999999999999975E+000,
      4.7999999999999972E+000,
      4.3999999999999968E+000,
      4.0000000000000036E+000,
      3.6000000000000032E+000,
      3.2000000000000028E+000,
      2.8000000000000025E+000,
      2.4000000000000021E+000,
      2.0000000000000018E+000,
      1.6000000000000014E+000,
      1.2000000000000011E+000,
      8.0000000000000071E-001,
      4.0000000000000036E-001,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      9.9999999999999992E-002,
      1.9999999999999998E-001,
      0.3,
      3.9999999999999997E-001,
      4.9999999999999994E-001,
      0.6,
      0.7,
      7.9999999999999993E-001,
      0.9,
      9.9999999999999989E-001,
      1.0999999999999999E+000,
      1.2,
      1.3,
      1.4,
      1.4999999999999998E+000,
      1.5999999999999999E+000,
      1.7,
      1.8,
      1.8999999999999997E+000,
      1.9999999999999998E+000,
      2.1,
      2.1999999999999997E+000,
      2.3,
      2.4,
      2.5,
      2.6,
      2.6999999999999997E+000,
      2.8,
      2.9,
      2.9999999999999996E+000,
      3.0999999999999996E+000,
      3.1999999999999997E+000,
      3.3,
      3.4,
      3.5,
      3.6,
      3.6999999999999993E+000,
      3.7999999999999994E+000,
      3.8999999999999995E+000,
      3.9999999999999996E+000,
      4.1,
      4.2,
      4.3000000000000007E+000,
      4.3999999999999995E+000,
      4.4999999999999991E+000,
      4.6,
      4.6999999999999993E+000,
      4.8,
      4.8999999999999995E+000,
      5.0,
      5.1000000000000005E+000,
      5.2,
      5.3000000000000007E+000,
      5.4,
      5.5000000000000009E+000,
      5.6,
      5.6999999999999993E+000,
      5.8,
      5.8999999999999995E+000,
      6.0,
      6.1000000000000005E+000,
      6.2,
      6.2999999999999989E+000,
      6.3999999999999995E+000,
      6.4999999999999991E+000,
      6.6,
      6.6999999999999993E+000,
      6.8,
      6.8999999999999995E+000,
      7.0,
      7.1000000000000005E+000,
      7.2,
      7.3000000000000007E+000,
      7.4,
      7.5000000000000009E+000,
      7.6000000000000005E+000,
      7.7000000000000011E+000,
      7.7999999999999989E+000,
      7.8999999999999986E+000,
      7.9999999999999991E+000,
      8.1,
      8.2,
      8.2999999999999989E+000,
      8.4,
      8.5,
      8.6000000000000014E+000,
      8.7000000000000011E+000,
      8.8,
      8.9,
      8.9999999999999982E+000,
      9.1,
      9.2,
      9.2999999999999989E+000,
      9.3999999999999986E+000,
      9.5,
      9.6,
      9.7,
      9.7999999999999989E+000,
      9.9,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      10.0,
      9.9,
      9.7999999999999989E+000,
      9.7,
      9.6,
      9.5,
      9.3999999999999986E+000,
      9.2999999999999989E+000,
      9.2,
      9.1,
      9.0000000000000018E+000,
      8.9,
      8.8,
      8.7000000000000011E+000,
      8.6000000000000014E+000,
      8.5,
      8.4,
      8.3,
      8.2000000000000011E+000,
      8.1,
      8.0,
      7.8999999999999995E+000,
      7.8,
      7.6999999999999993E+000,
      7.6,
      7.4999999999999991E+000,
      7.3999999999999995E+000,
      7.3000000000000007E+000,
      7.2,
      7.1000000000000005E+000,
      7.0000000000000009E+000,
      6.9000000000000012E+000,
      6.8000000000000007E+000,
      6.7000000000000011E+000,
      6.6000000000000005E+000,
      6.5000000000000009E+000,
      6.4,
      6.3000000000000007E+000,
      6.2,
      6.1000000000000005E+000,
      6.0,
      5.8999999999999995E+000,
      5.8,
      5.6999999999999993E+000,
      5.6000000000000005E+000,
      5.5000000000000009E+000,
      5.4,
      5.3000000000000007E+000,
      5.2,
      5.1000000000000005E+000,
      5.0,
      4.8999999999999995E+000,
      4.8,
      4.6999999999999993E+000,
      4.6,
      4.4999999999999991E+000,
      4.4,
      4.3000000000000007E+000,
      4.2,
      4.1000000000000005E+000,
      4.0,
      3.9,
      3.8,
      3.7000000000000006E+000,
      3.6000000000000005E+000,
      3.5000000000000004E+000,
      3.4000000000000004E+000,
      3.3000000000000003E+000,
      3.2,
      3.1,
      3.0,
      2.9,
      2.8,
      2.6999999999999997E+000,
      2.5999999999999996E+000,
      2.4999999999999996E+000,
      2.3999999999999995E+000,
      2.2999999999999994E+000,
      2.2000000000000011E+000,
      2.1000000000000010E+000,
      2.0000000000000009E+000,
      1.9000000000000008E+000,
      1.8000000000000007E+000,
      1.7000000000000006E+000,
      1.5999999999999996E+000,
      1.4999999999999996E+000,
      1.3999999999999995E+000,
      1.2999999999999994E+000,
      1.1999999999999993E+000,
      1.0999999999999992E+000,
      1.0000000000000009E+000,
      9.0000000000000080E-001,
      8.0000000000000071E-001,
      7.0000000000000062E-001,
      6.0000000000000053E-001,
      5.0000000000000044E-001,
      4.0000000000000036E-001,
      3.0000000000000027E-001,
      2.0000000000000018E-001,
      1.0000000000000009E-001,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0
    };

    rtDWork.Traj_vel_ref_PWORK.TimePtr = (void *) pTimeValues;
    rtDWork.Traj_vel_ref_PWORK.DataPtr = (void *) pDataValues;
  }

  /* child S-Function registration */
  ssSetNumSFunctions(rtS, 1);

  /* register each child */
  {
    static SimStruct childSFunctions[1];
    static SimStruct *childSFunctionPtrs[1];

    (void)memset((char_T *)&childSFunctions[0], 0, sizeof(childSFunctions));
    ssSetSFunctions(rtS, &childSFunctionPtrs[0]);
    {
      int_T i;

      for(i = 0; i < 1; i++) {
        ssSetSFunction(rtS, i, &childSFunctions[i]);
      }
    }

    /* Level2 S-Function Block: comparison/<Root>/EKF (joint_ekf_R_ib) */
    {
      SimStruct *rts = ssGetSFunction(rtS, 0);
      /* timing info */
      static time_T sfcnPeriod[1];
      static time_T sfcnOffset[1];
      static int_T sfcnTsMap[1];

      {
        int_T i;

        for(i = 0; i < 1; i++) {
          sfcnPeriod[i] = sfcnOffset[i] = 0.0;
        }
      }
      ssSetSampleTimePtr(rts, &sfcnPeriod[0]);
      ssSetOffsetTimePtr(rts, &sfcnOffset[0]);
      ssSetSampleTimeTaskIDPtr(rts, sfcnTsMap);
      ssSetMdlInfoPtr(rts, ssGetMdlInfoPtr(rtS));
      /* Allocate memory of model methodes 2 */
      {
        static struct _ssSFcnModelMethods2 methodes2;
        ssSetModelMethods2(rts, &methodes2);
      }

      /* inputs */
      {
        static struct _ssPortInputs inputPortInfo[2];

        _ssSetNumInputPorts(rts, 2);
        ssSetPortInfoForInputs(rts, &inputPortInfo[0]);

        /* port 0 */
        {

          ssSetInputPortRequiredContiguous(rts, 0, 1);
          ssSetInputPortSignal(rts, 0, &rtB.Sum1_c);
          _ssSetInputPortNumDimensions(rts, 0, 1);
          ssSetInputPortWidth(rts, 0, 1);
        }

        /* port 1 */
        {

          ssSetInputPortRequiredContiguous(rts, 1, 1);
          ssSetInputPortSignal(rts, 1, &rtB.TmpHiddenBuf1_Driving_EKF_AtInp[0]);
          _ssSetInputPortNumDimensions(rts, 1, 1);
          ssSetInputPortWidth(rts, 1, 2);
        }
      }

      /* outputs */
      {
        static struct _ssPortOutputs outputPortInfo[1];
        _ssSetNumOutputPorts(rts, 1);
        ssSetPortInfoForOutputs(rts, &outputPortInfo[0]);
        /* port 0 */
        {
          _ssSetOutputPortNumDimensions(rts, 0, 1);
          ssSetOutputPortWidth(rts, 0, 8);
          ssSetOutputPortSignal(rts, 0, ((real_T *) &rtB.EKF[0]));
        }
      }

      /* states */
      ssSetDiscStates(rts, (real_T *) &rtDWork.EKF_DSTATE[0]);
      /* path info */
      ssSetModelName(rts, "EKF");
      ssSetPath(rts, "comparison/EKF");
      ssSetParentSS(rts, rtS);
      ssSetRootSS(rts, ssGetRootSS(rtS));
      ssSetVersion(rts, SIMSTRUCT_VERSION_LEVEL2);

      /* parameters */
      {
        static mxArray *sfcnParams[2];

        ssSetSFcnParamsCount(rts, 2);
        ssSetSFcnParamsPtr(rts, &sfcnParams[0]);

        ssSetSFcnParam(rts, 0, &rtP.EKF_P1_Size[0]);
        ssSetSFcnParam(rts, 1, &rtP.EKF_P2_Size[0]);
      }

      /* work vectors */
      ssSetPWork(rts, (void **) &rtDWork.EKF_PWORK[0]);
      {
        static struct _ssDWorkRecord dWorkRecord[2];

        ssSetSFcnDWork(rts, dWorkRecord);
        _ssSetNumDWork(rts, 2);

        /* PWORK */
        ssSetDWorkWidth(rts, 0, 13);
        ssSetDWorkDataType(rts, 0, SS_POINTER);
        ssSetDWorkComplexSignal(rts, 0, 0);
        ssSetDWork(rts, 0, &rtDWork.EKF_PWORK[0]);

        /* DSTATE */
        ssSetDWorkWidth(rts, 1, 8);
        ssSetDWorkDataType(rts, 1, SS_DOUBLE);
        ssSetDWorkComplexSignal(rts, 1, 0);
        ssSetDWorkUsedAsDState(rts, 1, 1);
        ssSetDWork(rts, 1, &rtDWork.EKF_DSTATE[0]);
      }

      /* registration */
      joint_ekf_R_ib(rts);

      sfcnInitializeSizes(rts);
      sfcnInitializeSampleTimes(rts);

      /* adjust sample time */
      ssSetSampleTime(rts, 0, 0.001);
      ssSetOffsetTime(rts, 0, 0.0);
      sfcnTsMap[0] = 1;
      /* Update connectivity flags for each port */
      _ssSetInputPortConnected(rts, 0, 1);
      _ssSetInputPortConnected(rts, 1, 1);
      _ssSetOutputPortConnected(rts, 0, 1);
      _ssSetOutputPortBeingMerged(rts, 0, 0);
      /* Update the BufferDstPort flags for each input port */
      ssSetInputPortBufferDstPort(rts, 0, -1);
      ssSetInputPortBufferDstPort(rts, 1, -1);
    }
  }

  return rtS;
}

/* [EOF] comparison_reg.h */
