/*
 * kalman_R_K_ib_reg.h
 *
 * Real-Time Workshop code generation for Simulink model "kalman_R_K_ib.mdl".
 *
 * Model Version                        : 1.601
 * Real-Time Workshop file version      : 4.1 $Date: 2001/05/16 13:59:43 $
 * Real-Time Workshop file generated on : Mon Jul 09 16:41:54 2007
 * TLC version                          : 4.1 (May 19 2001)
 * C source code generated on           : Mon Jul 09 16:41:54 2007
 *
 * Relevant TLC Options:
 *   InlineParameters      = 0
 *   RollThreshold         = 5
 *   CodeFormat            = RealTime
 *
 * Simulink model settings:
 *   Solver     : FixedStep
 *   StartTime  : 0.0 s
 *   StopTime   : 1.0 s
 *   FixedStep  : 0.0005 s
 *
 * SOURCES: kalman_R_K_ib.c 
 */

#include "kalman_R_K_ib_dt.c"

/* Function to initialize sizes */
void MdlInitializeSizes(void)
{
  ssSetNumContStates(rtS, 0);           /* Number of continuous states */
  ssSetNumOutputs(rtS, 0);              /* Number of model outputs */
  ssSetNumInputs(rtS, 0);               /* Number of model inputs */
  ssSetDirectFeedThrough(rtS, 0);       /* The model is not direct feedthrough */
  ssSetNumSampleTimes(rtS, 2);          /* Number of sample times */
  ssSetNumBlocks(rtS, 119);             /* Number of blocks */
  ssSetNumBlockIO(rtS, 99);             /* Number of block outputs */
  ssSetNumBlockParams(rtS, 955);        /* Sum of parameter "widths" */
}

/* Function to initialize sample times */
void MdlInitializeSampleTimes(void)
{
  /* task periods */
  ssSetSampleTime(rtS, 0, 0.0);
  ssSetSampleTime(rtS, 1, 0.0005);

  /* task offsets */
  ssSetOffsetTime(rtS, 0, 0.0);
  ssSetOffsetTime(rtS, 1, 0.0);
}

/* Function to register the model */
SimStruct *kalman_R_K_ib(void)
{
  static struct _ssMdlInfo mdlInfo;

  (void)memset((char *)rtS, 0, sizeof(SimStruct));
  (void)memset((char *)&mdlInfo, 0, sizeof(struct _ssMdlInfo));

  ssSetMdlInfoPtr(rtS, &mdlInfo);

  /* timing info */
  {
    static time_T mdlPeriod[NSAMPLE_TIMES];
    static time_T mdlOffset[NSAMPLE_TIMES];
    static time_T mdlTaskTimes[NSAMPLE_TIMES];
    static int_T mdlTsMap[NSAMPLE_TIMES];
    static int_T mdlSampleHits[NSAMPLE_TIMES];

    {
      int_T i;

      for(i = 0; i < NSAMPLE_TIMES; i++) {
        mdlPeriod[i] = 0.0;
        mdlOffset[i] = 0.0;
        mdlTaskTimes[i] = 0.0;
      }
    }
    (void)memset((char_T *)&mdlTsMap[0], 0, 2 * sizeof(int_T));
    (void)memset((char_T *)&mdlSampleHits[0], 0, 2 * sizeof(int_T));

    ssSetSampleTimePtr(rtS, &mdlPeriod[0]);
    ssSetOffsetTimePtr(rtS, &mdlOffset[0]);
    ssSetSampleTimeTaskIDPtr(rtS, &mdlTsMap[0]);
    ssSetTPtr(rtS, &mdlTaskTimes[0]);
    ssSetSampleHitPtr(rtS, &mdlSampleHits[0]);
  }
  ssSetSolverMode(rtS, SOLVER_MODE_SINGLETASKING);

  /*
   * initialize model vectors and cache them in SimStruct
   */

  /* block I/O */
  {
    void *b = (void *) &rtB;

    ssSetBlockIO(rtS, b);

    (void)memset(b, 0, sizeof(BlockIO));
    {
      int_T i;

      for (i = 0; i < 111; i++) {
        ((real_T*) b)[i] = 0.0;
      }
    }
  }

  /* parameters */
  ssSetDefaultParam(rtS, (real_T *) &rtP);

  /* data type work */
  {
    void *dwork = (void *) &rtDWork;
    ssSetRootDWork(rtS, dwork);
    (void)memset((char_T *) dwork, 0, sizeof(D_Work));
    {
      int_T i;
      real_T *dwork_ptr = (real_T *) &rtDWork.Difference_DSTATE;

      for (i = 0; i < 22; i++) {
        dwork_ptr[i] = 0.0;
      }
    }
  }

  /* data type transition information (for external mode) */
  {
    static DataTypeTransInfo dtInfo;

    (void)memset((char_T *) &dtInfo, 0, sizeof(dtInfo));
    ssSetModelMappingInfo(rtS, &dtInfo);

    dtInfo.numDataTypes = 13;
    dtInfo.dataTypeSizes = &rtDataTypeSizes[0];
    dtInfo.dataTypeNames = &rtDataTypeNames[0];

    /* Block I/O transition table */
    dtInfo.B = &rtBTransTable;

    /* Parameters transition table */
    dtInfo.P = &rtPTransTable;
  }

  /* Model specific registration */
  ssSetRootSS(rtS, rtS);
  ssSetVersion(rtS, SIMSTRUCT_VERSION_LEVEL2);

  ssSetModelName(rtS, "kalman_R_K_ib");
  ssSetPath(rtS, "kalman_R_K_ib");

  ssSetTStart(rtS, 0.0);
  ssSetTFinal(rtS, 1.0);
  ssSetStepSize(rtS, 0.0005);
  ssSetFixedStepSize(rtS, 0.0005);

  ssSetChecksum0(rtS, 687560014U);
  ssSetChecksum1(rtS, 3365923026U);
  ssSetChecksum2(rtS, 2580296478U);
  ssSetChecksum3(rtS, 1172401556U);

  {
    static const EnableStates rtAlwaysEnabled = SUBSYS_ENABLED;
    static const void *sysModes[1];

    sysModes[0] = &rtAlwaysEnabled;

    ssSetSubSystemModeVectorAddresses(rtS, ((void*)sysModes));
  }

  /* block instance data */
  {
    /* FromWorkspace Block: <S5>/From Workspace */

    static real_T pTimeValues[] = {
      0.0,
      0.0005,
      0.001,
      0.0015,
      0.002,
      0.0025,
      0.003,
      0.0035,
      0.004,
      4.5000000000000005E-003,
      0.005,
      0.0055,
      0.006,
      6.5000000000000006E-003,
      0.007,
      0.0075,
      0.008,
      0.0085,
      9.0000000000000011E-003,
      0.0095,
      0.01,
      0.0105,
      0.011,
      0.0115,
      0.012,
      0.0125,
      1.3000000000000001E-002,
      0.0135,
      0.014,
      0.0145,
      0.015,
      0.0155,
      0.016,
      0.0165,
      0.017,
      0.0175,
      1.8000000000000002E-002,
      0.0185,
      0.019,
      0.0195,
      0.02,
      0.0205,
      0.021,
      2.1500000000000002E-002,
      0.022,
      0.0225,
      0.023,
      0.0235,
      0.024,
      0.0245,
      0.025,
      2.5500000000000002E-002,
      2.6000000000000002E-002,
      0.0265,
      0.027,
      0.0275,
      0.028,
      0.0285,
      0.029,
      2.9500000000000002E-002,
      0.03,
      0.0305,
      0.031,
      0.0315,
      0.032,
      0.0325,
      0.033,
      0.0335,
      0.034,
      0.0345,
      0.035,
      3.5500000000000004E-002,
      3.6000000000000004E-002,
      0.0365,
      0.037,
      0.0375,
      0.038,
      0.0385,
      0.039,
      0.0395,
      0.04,
      0.0405,
      0.041,
      0.0415,
      0.042,
      0.0425,
      4.3000000000000003E-002,
      4.3500000000000004E-002,
      0.044,
      0.0445,
      0.045,
      0.0455,
      0.046,
      0.0465,
      0.047,
      0.0475,
      0.048,
      0.0485,
      0.049,
      0.0495,
      0.05,
      0.0505,
      5.1000000000000004E-002,
      5.1500000000000004E-002,
      5.2000000000000005E-002,
      0.0525,
      0.053,
      0.0535,
      0.054,
      0.0545,
      0.055,
      0.0555,
      0.056,
      0.0565,
      0.057,
      0.0575,
      0.058,
      0.0585,
      5.9000000000000004E-002,
      5.9500000000000004E-002,
      0.06,
      0.0605,
      0.061,
      0.0615,
      0.062,
      0.0625,
      0.063,
      0.0635,
      0.064,
      0.0645,
      0.065,
      0.0655,
      0.066,
      0.0665,
      0.067,
      0.0675,
      0.068,
      0.0685,
      0.069,
      0.0695,
      0.07,
      7.0500000000000007E-002,
      7.1000000000000008E-002,
      7.1500000000000008E-002,
      7.2000000000000008E-002,
      0.0725,
      0.073,
      0.0735,
      0.074,
      0.0745,
      0.075,
      0.0755,
      0.076,
      0.0765,
      0.077,
      0.0775,
      0.078,
      0.0785,
      0.079,
      0.0795,
      0.08,
      0.0805,
      0.081,
      0.0815,
      0.082,
      0.0825,
      0.083,
      0.0835,
      0.084,
      0.0845,
      0.085,
      0.0855,
      8.6000000000000007E-002,
      8.6500000000000007E-002,
      8.7000000000000008E-002,
      8.7500000000000008E-002,
      0.088,
      0.0885,
      0.089,
      0.0895,
      0.09,
      0.0905,
      0.091,
      0.0915,
      0.092,
      0.0925,
      0.093,
      0.0935,
      0.094,
      0.0945,
      0.095,
      0.0955,
      0.096,
      0.0965,
      0.097,
      0.0975,
      0.098,
      0.0985,
      0.099,
      0.0995,
      0.1,
      0.1005,
      0.101,
      0.1015,
      1.0200000000000001E-001,
      1.0250000000000001E-001,
      1.0300000000000001E-001,
      1.0350000000000001E-001,
      1.0400000000000001E-001,
      0.1045,
      0.105,
      0.1055,
      0.106,
      0.1065,
      0.107,
      0.1075,
      0.108,
      0.1085,
      0.109,
      0.1095,
      0.11,
      0.1105,
      0.111,
      0.1115,
      0.112,
      0.1125,
      0.113,
      0.1135,
      0.114,
      0.1145,
      0.115,
      0.1155,
      0.116,
      0.1165,
      0.117,
      1.1750000000000001E-001,
      1.1800000000000001E-001,
      1.1850000000000001E-001,
      1.1900000000000001E-001,
      1.1950000000000001E-001,
      0.12,
      0.1205,
      0.121,
      0.1215,
      0.122,
      0.1225,
      0.123,
      0.1235,
      0.124,
      0.1245,
      0.125,
      0.1255,
      0.126,
      0.1265,
      0.127,
      0.1275,
      0.128,
      0.1285,
      0.129,
      0.1295,
      0.13,
      0.1305,
      0.131,
      0.1315,
      0.132,
      0.1325,
      0.133,
      0.1335,
      0.134,
      0.1345,
      0.135,
      0.1355,
      0.136,
      0.1365,
      0.137,
      0.1375,
      0.138,
      0.1385,
      0.139,
      0.1395,
      0.14,
      0.1405,
      1.4100000000000001E-001,
      1.4150000000000001E-001,
      1.4200000000000002E-001,
      1.4250000000000002E-001,
      1.4300000000000002E-001,
      1.4350000000000002E-001,
      1.4400000000000002E-001,
      0.1445,
      0.145,
      0.1455,
      0.146,
      0.1465,
      0.147,
      0.1475,
      0.148,
      0.1485,
      0.149,
      0.1495,
      0.15,
      0.1505,
      0.151,
      0.1515,
      0.152,
      0.1525,
      0.153,
      0.1535,
      0.154,
      0.1545,
      0.155,
      0.1555,
      0.156,
      0.1565,
      0.157,
      0.1575,
      0.158,
      0.1585,
      0.159,
      0.1595,
      0.16,
      0.1605,
      0.161,
      0.1615,
      0.162,
      0.1625,
      0.163,
      0.1635,
      0.164,
      0.1645,
      0.165,
      0.1655,
      0.166,
      0.1665,
      0.167,
      0.1675,
      0.168,
      0.1685,
      0.169,
      0.1695,
      0.17,
      0.1705,
      0.171,
      0.1715,
      1.7200000000000001E-001,
      1.7250000000000001E-001,
      1.7300000000000001E-001,
      1.7350000000000002E-001,
      1.7400000000000002E-001,
      1.7450000000000002E-001,
      1.7500000000000002E-001,
      1.7550000000000002E-001,
      0.176,
      0.1765,
      0.177,
      0.1775,
      0.178,
      0.1785,
      0.179,
      0.1795,
      0.18,
      0.1805,
      0.181,
      0.1815,
      0.182,
      0.1825,
      0.183,
      0.1835,
      0.184,
      0.1845,
      0.185,
      0.1855,
      0.186,
      0.1865,
      0.187,
      0.1875,
      0.188,
      0.1885,
      0.189,
      0.1895,
      0.19,
      0.1905,
      0.191,
      0.1915,
      0.192,
      0.1925,
      0.193,
      0.1935,
      0.194,
      0.1945,
      0.195,
      0.1955,
      0.196,
      0.1965,
      0.197,
      0.1975,
      0.198,
      0.1985,
      0.199,
      0.1995,
      0.2,
      0.2005,
      0.201,
      0.2015,
      0.202,
      0.2025,
      0.203,
      2.0350000000000001E-001,
      2.0400000000000001E-001,
      2.0450000000000002E-001,
      2.0500000000000002E-001,
      2.0550000000000002E-001,
      2.0600000000000002E-001,
      2.0650000000000002E-001,
      2.0700000000000002E-001,
      2.0750000000000002E-001,
      2.0800000000000002E-001,
      0.2085,
      0.209,
      0.2095,
      0.21,
      0.2105,
      0.211,
      0.2115,
      0.212,
      0.2125,
      0.213,
      0.2135,
      0.214,
      0.2145,
      0.215,
      0.2155,
      0.216,
      0.2165,
      0.217,
      0.2175,
      0.218,
      0.2185,
      0.219,
      0.2195,
      0.22,
      0.2205,
      0.221,
      0.2215,
      0.222,
      0.2225,
      0.223,
      0.2235,
      0.224,
      0.2245,
      0.225,
      0.2255,
      0.226,
      0.2265,
      0.227,
      0.2275,
      0.228,
      0.2285,
      0.229,
      0.2295,
      0.23,
      0.2305,
      0.231,
      0.2315,
      0.232,
      0.2325,
      0.233,
      0.2335,
      0.234,
      2.3450000000000001E-001,
      2.3500000000000001E-001,
      2.3550000000000001E-001,
      2.3600000000000002E-001,
      2.3650000000000002E-001,
      2.3700000000000002E-001,
      2.3750000000000002E-001,
      2.3800000000000002E-001,
      2.3850000000000002E-001,
      2.3900000000000002E-001,
      2.3950000000000002E-001,
      0.24,
      0.2405,
      0.241,
      0.2415,
      0.242,
      0.2425,
      0.243,
      0.2435,
      0.244,
      0.2445,
      0.245,
      0.2455,
      0.246,
      0.2465,
      0.247,
      0.2475,
      0.248,
      0.2485,
      0.249,
      0.2495,
      0.25,
      0.2505,
      0.251,
      0.2515,
      0.252,
      0.2525,
      0.253,
      0.2535,
      0.254,
      0.2545,
      0.255,
      0.2555,
      0.256,
      0.2565,
      0.257,
      0.2575,
      0.258,
      0.2585,
      0.259,
      0.2595,
      0.26,
      0.2605,
      0.261,
      0.2615,
      0.262,
      0.2625,
      0.263,
      0.2635,
      0.264,
      0.2645,
      0.265,
      0.2655,
      0.266,
      0.2665,
      0.267,
      0.2675,
      0.268,
      0.2685,
      0.269,
      0.2695,
      0.27,
      0.2705,
      0.271,
      0.2715,
      0.272,
      0.2725,
      0.273,
      0.2735,
      0.274,
      0.2745,
      0.275,
      0.2755,
      0.276,
      0.2765,
      0.277,
      0.2775,
      0.278,
      0.2785,
      0.279,
      0.2795,
      0.28,
      0.2805,
      0.281,
      2.8150000000000003E-001,
      2.8200000000000003E-001,
      2.8250000000000003E-001,
      2.8300000000000003E-001,
      2.8350000000000003E-001,
      2.8400000000000003E-001,
      2.8450000000000003E-001,
      2.8500000000000003E-001,
      2.8550000000000003E-001,
      2.8600000000000003E-001,
      2.8650000000000003E-001,
      2.8700000000000003E-001,
      2.8750000000000003E-001,
      2.8800000000000003E-001,
      0.2885,
      0.289,
      0.2895,
      0.29,
      0.2905,
      0.291,
      0.2915,
      0.292,
      0.2925,
      0.293,
      0.2935,
      0.294,
      0.2945,
      0.295,
      0.2955,
      0.296,
      0.2965,
      0.297,
      0.2975,
      0.298,
      0.2985,
      0.299,
      0.2995,
      0.3,
      0.3005,
      0.301,
      0.3015,
      0.302,
      0.3025,
      0.303,
      0.3035,
      0.304,
      0.3045,
      0.305,
      0.3055,
      0.306,
      0.3065,
      0.307,
      0.3075,
      0.308,
      0.3085,
      0.309,
      0.3095,
      0.31,
      0.3105,
      0.311,
      0.3115,
      0.312,
      0.3125,
      0.313,
      0.3135,
      0.314,
      0.3145,
      0.315,
      0.3155,
      0.316,
      0.3165,
      0.317,
      0.3175,
      0.318,
      0.3185,
      0.319,
      0.3195,
      0.32,
      0.3205,
      0.321,
      0.3215,
      0.322,
      0.3225,
      0.323,
      0.3235,
      0.324,
      0.3245,
      0.325,
      0.3255,
      0.326,
      0.3265,
      0.327,
      0.3275,
      0.328,
      0.3285,
      0.329,
      0.3295,
      0.33,
      0.3305,
      0.331,
      0.3315,
      0.332,
      0.3325,
      0.333,
      0.3335,
      0.334,
      0.3345,
      0.335,
      0.3355,
      0.336,
      0.3365,
      0.337,
      0.3375,
      0.338,
      0.3385,
      0.339,
      0.3395,
      0.34,
      0.3405,
      0.341,
      0.3415,
      0.342,
      0.3425,
      0.343,
      0.3435,
      3.4400000000000003E-001,
      3.4450000000000003E-001,
      3.4500000000000003E-001,
      3.4550000000000003E-001,
      3.4600000000000003E-001,
      3.4650000000000003E-001,
      3.4700000000000003E-001,
      3.4750000000000003E-001,
      3.4800000000000003E-001,
      3.4850000000000003E-001,
      3.4900000000000003E-001,
      3.4950000000000003E-001,
      3.5000000000000003E-001,
      3.5050000000000003E-001,
      3.5100000000000003E-001,
      3.5150000000000003E-001,
      0.352,
      0.3525,
      0.353,
      0.3535,
      0.354,
      0.3545,
      0.355,
      0.3555,
      0.356,
      0.3565,
      0.357,
      0.3575,
      0.358,
      0.3585,
      0.359,
      0.3595,
      0.36,
      0.3605,
      0.361,
      0.3615,
      0.362,
      0.3625,
      0.363,
      0.3635,
      0.364,
      0.3645,
      0.365,
      0.3655,
      0.366,
      0.3665,
      0.367,
      0.3675,
      0.368,
      0.3685,
      0.369,
      0.3695,
      0.37,
      0.3705,
      0.371,
      0.3715,
      0.372,
      0.3725,
      0.373,
      0.3735,
      0.374,
      0.3745,
      0.375,
      0.3755,
      0.376,
      0.3765,
      0.377,
      0.3775,
      0.378,
      0.3785,
      0.379,
      0.3795,
      0.38,
      0.3805,
      0.381,
      0.3815,
      0.382,
      0.3825,
      0.383,
      0.3835,
      0.384,
      0.3845,
      0.385,
      0.3855,
      0.386,
      0.3865,
      0.387,
      0.3875,
      0.388,
      0.3885,
      0.389,
      0.3895,
      0.39,
      0.3905,
      0.391,
      0.3915,
      0.392,
      0.3925,
      0.393,
      0.3935,
      0.394,
      0.3945,
      0.395,
      0.3955,
      0.396,
      0.3965,
      0.397,
      0.3975,
      0.398,
      0.3985,
      0.399,
      0.3995,
      0.4,
      0.4005,
      0.401,
      0.4015,
      0.402,
      0.4025,
      0.403,
      0.4035,
      0.404,
      0.4045,
      0.405,
      0.4055,
      0.406,
      4.0650000000000003E-001,
      4.0700000000000003E-001,
      4.0750000000000003E-001,
      4.0800000000000003E-001,
      4.0850000000000003E-001,
      4.0900000000000003E-001,
      4.0950000000000003E-001,
      4.1000000000000003E-001,
      4.1050000000000003E-001,
      4.1100000000000003E-001,
      4.1150000000000003E-001,
      4.1200000000000003E-001,
      4.1250000000000003E-001,
      4.1300000000000003E-001,
      4.1350000000000003E-001,
      4.1400000000000003E-001,
      4.1450000000000004E-001,
      4.1500000000000004E-001,
      4.1550000000000004E-001,
      4.1600000000000004E-001,
      0.4165,
      0.417,
      0.4175,
      0.418,
      0.4185,
      0.419,
      0.4195,
      0.42,
      0.4205,
      0.421,
      0.4215,
      0.422,
      0.4225,
      0.423,
      0.4235,
      0.424,
      0.4245,
      0.425,
      0.4255,
      0.426,
      0.4265,
      0.427,
      0.4275,
      0.428,
      0.4285,
      0.429,
      0.4295,
      0.43,
      0.4305,
      0.431,
      0.4315,
      0.432,
      0.4325,
      0.433,
      0.4335,
      0.434,
      0.4345,
      0.435,
      0.4355,
      0.436,
      0.4365,
      0.437,
      0.4375,
      0.438,
      0.4385,
      0.439,
      0.4395,
      0.44,
      0.4405,
      0.441,
      0.4415,
      0.442,
      0.4425,
      0.443,
      0.4435,
      0.444,
      0.4445,
      0.445,
      0.4455,
      0.446,
      0.4465,
      0.447,
      0.4475,
      0.448,
      0.4485,
      0.449,
      0.4495,
      0.45,
      0.4505,
      0.451,
      0.4515,
      0.452,
      0.4525,
      0.453,
      0.4535,
      0.454,
      0.4545,
      0.455,
      0.4555,
      0.456,
      0.4565,
      0.457,
      0.4575,
      0.458,
      0.4585,
      0.459,
      0.4595,
      0.46,
      0.4605,
      0.461,
      0.4615,
      0.462,
      0.4625,
      0.463,
      0.4635,
      0.464,
      0.4645,
      0.465,
      0.4655,
      0.466,
      0.4665,
      0.467,
      0.4675,
      0.468,
      0.4685,
      4.6900000000000003E-001,
      4.6950000000000003E-001,
      4.7000000000000003E-001,
      4.7050000000000003E-001,
      4.7100000000000003E-001,
      4.7150000000000003E-001,
      4.7200000000000003E-001,
      4.7250000000000003E-001,
      4.7300000000000003E-001,
      4.7350000000000003E-001,
      4.7400000000000003E-001,
      4.7450000000000003E-001,
      4.7500000000000003E-001,
      4.7550000000000003E-001,
      4.7600000000000003E-001,
      4.7650000000000003E-001,
      4.7700000000000004E-001,
      4.7750000000000004E-001,
      4.7800000000000004E-001,
      4.7850000000000004E-001,
      4.7900000000000004E-001,
      4.7950000000000004E-001,
      0.48,
      0.4805,
      0.481,
      0.4815,
      0.482,
      0.4825,
      0.483,
      0.4835,
      0.484,
      0.4845,
      0.485,
      0.4855,
      0.486,
      0.4865,
      0.487,
      0.4875,
      0.488,
      0.4885,
      0.489,
      0.4895,
      0.49,
      0.4905,
      0.491,
      0.4915,
      0.492,
      0.4925,
      0.493,
      0.4935,
      0.494,
      0.4945,
      0.495,
      0.4955,
      0.496,
      0.4965,
      0.497,
      0.4975,
      0.498,
      0.4985,
      0.499,
      0.4995,
      0.5,
      5.0050000000000006E-001,
      0.501,
      5.0150000000000006E-001,
      0.502,
      5.0250000000000006E-001,
      0.503,
      5.0350000000000006E-001,
      0.504,
      5.0450000000000006E-001,
      0.505,
      5.0550000000000006E-001,
      0.506,
      5.0650000000000006E-001,
      0.507,
      5.0750000000000006E-001,
      0.508,
      5.0850000000000006E-001,
      0.509,
      5.0950000000000006E-001,
      0.51,
      5.1050000000000006E-001,
      0.511,
      5.1150000000000007E-001,
      0.512,
      0.5125,
      0.513,
      0.5135,
      0.514,
      0.5145,
      0.515,
      0.5155,
      0.516,
      0.5165,
      0.517,
      0.5175,
      0.518,
      0.5185,
      0.519,
      0.5195,
      0.52,
      0.5205,
      0.521,
      0.5215,
      0.522,
      0.5225,
      0.523,
      0.5235,
      0.524,
      0.5245,
      0.525,
      0.5255,
      0.526,
      0.5265,
      0.527,
      0.5275,
      0.528,
      0.5285,
      0.529,
      0.5295,
      0.53,
      0.5305,
      0.531,
      0.5315,
      0.532,
      0.5325,
      0.533,
      0.5335,
      0.534,
      0.5345,
      0.535,
      0.5355,
      0.536,
      0.5365,
      0.537,
      0.5375,
      0.538,
      0.5385,
      0.539,
      0.5395,
      0.54,
      0.5405,
      0.541,
      0.5415,
      0.542,
      0.5425,
      0.543,
      0.5435,
      0.544,
      0.5445,
      0.545,
      0.5455,
      0.546,
      0.5465,
      0.547,
      0.5475,
      0.548,
      0.5485,
      0.549,
      0.5495,
      0.55,
      0.5505,
      0.551,
      0.5515,
      0.552,
      0.5525,
      0.553,
      0.5535,
      0.554,
      0.5545,
      0.555,
      0.5555,
      0.556,
      0.5565,
      0.557,
      0.5575,
      0.558,
      0.5585,
      0.559,
      0.5595,
      0.56,
      0.5605,
      0.561,
      0.5615,
      0.562,
      0.5625,
      5.6300000000000006E-001,
      0.5635,
      5.6400000000000006E-001,
      0.5645,
      5.6500000000000006E-001,
      0.5655,
      5.6600000000000006E-001,
      0.5665,
      5.6700000000000006E-001,
      0.5675,
      5.6800000000000006E-001,
      0.5685,
      5.6900000000000006E-001,
      0.5695,
      5.7000000000000006E-001,
      0.5705,
      5.7100000000000006E-001,
      0.5715,
      5.7200000000000006E-001,
      0.5725,
      5.7300000000000006E-001,
      0.5735,
      5.7400000000000007E-001,
      0.5745,
      5.7500000000000007E-001,
      0.5755,
      5.7600000000000007E-001,
      0.5765,
      0.577,
      0.5775,
      0.578,
      0.5785,
      0.579,
      0.5795,
      0.58,
      0.5805,
      0.581,
      0.5815,
      0.582,
      0.5825,
      0.583,
      0.5835,
      0.584,
      0.5845,
      0.585,
      0.5855,
      0.586,
      0.5865,
      0.587,
      0.5875,
      0.588,
      0.5885,
      0.589,
      0.5895,
      0.59,
      0.5905,
      0.591,
      0.5915,
      0.592,
      0.5925,
      0.593,
      0.5935,
      0.594,
      0.5945,
      0.595,
      0.5955,
      0.596,
      0.5965,
      0.597,
      0.5975,
      0.598,
      0.5985,
      0.599,
      0.5995,
      0.6,
      0.6005,
      0.601,
      0.6015,
      0.602,
      0.6025,
      0.603,
      0.6035,
      0.604,
      0.6045,
      0.605,
      0.6055,
      0.606,
      0.6065,
      0.607,
      0.6075,
      0.608,
      0.6085,
      0.609,
      0.6095,
      0.61,
      0.6105,
      0.611,
      0.6115,
      0.612,
      0.6125,
      0.613,
      0.6135,
      0.614,
      0.6145,
      0.615,
      0.6155,
      0.616,
      0.6165,
      0.617,
      0.6175,
      0.618,
      0.6185,
      0.619,
      0.6195,
      0.62,
      0.6205,
      0.621,
      0.6215,
      0.622,
      0.6225,
      0.623,
      0.6235,
      0.624,
      0.6245,
      0.625,
      6.2550000000000006E-001,
      0.626,
      6.2650000000000006E-001,
      0.627,
      6.2750000000000006E-001,
      0.628,
      6.2850000000000006E-001,
      0.629,
      6.2950000000000006E-001,
      0.63,
      6.3050000000000006E-001,
      0.631,
      6.3150000000000006E-001,
      0.632,
      6.3250000000000006E-001,
      0.633,
      6.3350000000000006E-001,
      0.634,
      6.3450000000000006E-001,
      0.635,
      6.3550000000000006E-001,
      0.636,
      6.3650000000000007E-001,
      0.637,
      6.3750000000000007E-001,
      0.638,
      6.3850000000000007E-001,
      0.639,
      6.3950000000000007E-001,
      0.64,
      0.6405,
      0.641,
      0.6415,
      0.642,
      0.6425,
      0.643,
      0.6435,
      0.644,
      0.6445,
      0.645,
      0.6455,
      0.646,
      0.6465,
      0.647,
      0.6475,
      0.648,
      0.6485,
      0.649,
      0.6495,
      0.65,
      0.6505,
      0.651,
      0.6515,
      0.652,
      0.6525,
      0.653,
      0.6535,
      0.654,
      0.6545,
      0.655,
      0.6555,
      0.656,
      0.6565,
      0.657,
      0.6575,
      0.658,
      0.6585,
      0.659,
      0.6595,
      0.66,
      0.6605,
      0.661,
      0.6615,
      0.662,
      0.6625,
      0.663,
      0.6635,
      0.664,
      0.6645,
      0.665,
      0.6655,
      0.666,
      0.6665,
      0.667,
      0.6675,
      0.668,
      0.6685,
      0.669,
      0.6695,
      0.67,
      0.6705,
      0.671,
      0.6715,
      0.672,
      0.6725,
      0.673,
      0.6735,
      0.674,
      0.6745,
      0.675,
      0.6755,
      0.676,
      0.6765,
      0.677,
      0.6775,
      0.678,
      0.6785,
      0.679,
      0.6795,
      0.68,
      0.6805,
      0.681,
      0.6815,
      0.682,
      0.6825,
      0.683,
      0.6835,
      0.684,
      0.6845,
      0.685,
      0.6855,
      0.686,
      0.6865,
      0.687,
      0.6875,
      6.8800000000000006E-001,
      0.6885,
      6.8900000000000006E-001,
      0.6895,
      6.9000000000000006E-001,
      0.6905,
      6.9100000000000006E-001,
      0.6915,
      6.9200000000000006E-001,
      0.6925,
      6.9300000000000006E-001,
      0.6935,
      6.9400000000000006E-001,
      0.6945,
      6.9500000000000006E-001,
      0.6955,
      6.9600000000000006E-001,
      0.6965,
      6.9700000000000006E-001,
      0.6975,
      6.9800000000000006E-001,
      0.6985,
      6.9900000000000007E-001,
      0.6995,
      7.0000000000000007E-001,
      0.7005,
      7.0100000000000007E-001,
      0.7015,
      7.0200000000000007E-001,
      0.7025,
      7.0300000000000007E-001,
      0.7035,
      0.704,
      0.7045,
      0.705,
      0.7055,
      0.706,
      0.7065,
      0.707,
      0.7075,
      0.708,
      0.7085,
      0.709,
      0.7095,
      0.71,
      0.7105,
      0.711,
      0.7115,
      0.712,
      0.7125,
      0.713,
      0.7135,
      0.714,
      0.7145,
      0.715,
      0.7155,
      0.716,
      0.7165,
      0.717,
      0.7175,
      0.718,
      0.7185,
      0.719,
      0.7195,
      0.72,
      0.7205,
      0.721,
      0.7215,
      0.722,
      0.7225,
      0.723,
      0.7235,
      0.724,
      0.7245,
      0.725,
      0.7255,
      0.726,
      0.7265,
      0.727,
      0.7275,
      0.728,
      0.7285,
      0.729,
      0.7295,
      0.73,
      0.7305,
      0.731,
      0.7315,
      0.732,
      0.7325,
      0.733,
      0.7335,
      0.734,
      0.7345,
      0.735,
      0.7355,
      0.736,
      0.7365,
      0.737,
      0.7375,
      0.738,
      0.7385,
      0.739,
      0.7395,
      0.74,
      0.7405,
      0.741,
      0.7415,
      0.742,
      0.7425,
      0.743,
      0.7435,
      0.744,
      0.7445,
      0.745,
      0.7455,
      0.746,
      0.7465,
      0.747,
      0.7475,
      0.748,
      0.7485,
      0.749,
      0.7495,
      0.75,
      7.5050000000000006E-001,
      0.751,
      7.5150000000000006E-001,
      0.752,
      7.5250000000000006E-001,
      0.753,
      7.5350000000000006E-001,
      0.754,
      7.5450000000000006E-001,
      0.755,
      7.5550000000000006E-001,
      0.756,
      7.5650000000000006E-001,
      0.757,
      7.5750000000000006E-001,
      0.758,
      7.5850000000000006E-001,
      0.759,
      7.5950000000000006E-001,
      0.76,
      7.6050000000000006E-001,
      0.761,
      7.6150000000000007E-001,
      0.762,
      7.6250000000000007E-001,
      0.763,
      7.6350000000000007E-001,
      0.764,
      7.6450000000000007E-001,
      0.765,
      7.6550000000000007E-001,
      0.766,
      7.6650000000000007E-001,
      0.767,
      7.6750000000000007E-001,
      0.768,
      0.7685,
      0.769,
      0.7695,
      0.77,
      0.7705,
      0.771,
      0.7715,
      0.772,
      0.7725,
      0.773,
      0.7735,
      0.774,
      0.7745,
      0.775,
      0.7755,
      0.776,
      0.7765,
      0.777,
      0.7775,
      0.778,
      0.7785,
      0.779,
      0.7795,
      0.78,
      0.7805,
      0.781,
      0.7815,
      0.782,
      0.7825,
      0.783,
      0.7835,
      0.784,
      0.7845,
      0.785,
      0.7855,
      0.786,
      0.7865,
      0.787,
      0.7875,
      0.788,
      0.7885,
      0.789,
      0.7895,
      0.79,
      0.7905,
      0.791,
      0.7915,
      0.792,
      0.7925,
      0.793,
      0.7935,
      0.794,
      0.7945,
      0.795,
      0.7955,
      0.796,
      0.7965,
      0.797,
      0.7975,
      0.798,
      0.7985,
      0.799,
      0.7995,
      0.8,
      0.8005,
      0.801,
      0.8015,
      0.802,
      0.8025,
      0.803,
      0.8035,
      0.804,
      0.8045,
      0.805,
      0.8055,
      0.806,
      0.8065,
      0.807,
      0.8075,
      0.808,
      0.8085,
      0.809,
      0.8095,
      0.81,
      0.8105,
      0.811,
      0.8115,
      0.812,
      0.8125,
      8.1300000000000006E-001,
      0.8135,
      8.1400000000000006E-001,
      0.8145,
      8.1500000000000006E-001,
      0.8155,
      8.1600000000000006E-001,
      0.8165,
      8.1700000000000006E-001,
      0.8175,
      8.1800000000000006E-001,
      0.8185,
      8.1900000000000006E-001,
      0.8195,
      8.2000000000000006E-001,
      0.8205,
      8.2100000000000006E-001,
      0.8215,
      8.2200000000000006E-001,
      0.8225,
      8.2300000000000006E-001,
      0.8235,
      8.2400000000000007E-001,
      0.8245,
      8.2500000000000007E-001,
      0.8255,
      8.2600000000000007E-001,
      0.8265,
      8.2700000000000007E-001,
      0.8275,
      8.2800000000000007E-001,
      0.8285,
      8.2900000000000007E-001,
      0.8295,
      8.3000000000000007E-001,
      0.8305,
      8.3100000000000007E-001,
      0.8315,
      8.3200000000000007E-001,
      0.8325,
      0.833,
      0.8335,
      0.834,
      0.8345,
      0.835,
      0.8355,
      0.836,
      0.8365,
      0.837,
      0.8375,
      0.838,
      0.8385,
      0.839,
      0.8395,
      0.84,
      0.8405,
      0.841,
      0.8415,
      0.842,
      0.8425,
      0.843,
      0.8435,
      0.844,
      0.8445,
      0.845,
      0.8455,
      0.846,
      0.8465,
      0.847,
      0.8475,
      0.848,
      0.8485,
      0.849,
      0.8495,
      0.85,
      0.8505,
      0.851,
      0.8515,
      0.852,
      0.8525,
      0.853,
      0.8535,
      0.854,
      0.8545,
      0.855,
      0.8555,
      0.856,
      0.8565,
      0.857,
      0.8575,
      0.858,
      0.8585,
      0.859,
      0.8595,
      0.86,
      0.8605,
      0.861,
      0.8615,
      0.862,
      0.8625,
      0.863,
      0.8635,
      0.864,
      0.8645,
      0.865,
      0.8655,
      0.866,
      0.8665,
      0.867,
      0.8675,
      0.868,
      0.8685,
      0.869,
      0.8695,
      0.87,
      0.8705,
      0.871,
      0.8715,
      0.872,
      0.8725,
      0.873,
      0.8735,
      0.874,
      0.8745,
      0.875,
      8.7550000000000006E-001,
      0.876,
      8.7650000000000006E-001,
      0.877,
      8.7750000000000006E-001,
      0.878,
      8.7850000000000006E-001,
      0.879,
      8.7950000000000006E-001,
      0.88,
      8.8050000000000006E-001,
      0.881,
      8.8150000000000006E-001,
      0.882,
      8.8250000000000006E-001,
      0.883,
      8.8350000000000006E-001,
      0.884,
      8.8450000000000006E-001,
      0.885,
      8.8550000000000006E-001,
      0.886,
      8.8650000000000007E-001,
      0.887,
      8.8750000000000007E-001,
      0.888,
      8.8850000000000007E-001,
      0.889,
      8.8950000000000007E-001,
      0.89,
      8.9050000000000007E-001,
      0.891,
      8.9150000000000007E-001,
      0.892,
      8.9250000000000007E-001,
      0.893,
      8.9350000000000007E-001,
      0.894,
      8.9450000000000007E-001,
      0.895,
      8.9550000000000007E-001,
      0.896,
      0.8965,
      0.897,
      0.8975,
      0.898,
      0.8985,
      0.899,
      0.8995,
      0.9,
      0.9005,
      0.901,
      0.9015,
      0.902,
      0.9025,
      0.903,
      0.9035,
      0.904,
      0.9045,
      0.905,
      0.9055,
      0.906,
      0.9065,
      0.907,
      0.9075,
      0.908,
      0.9085,
      0.909,
      0.9095,
      0.91,
      0.9105,
      0.911,
      0.9115,
      0.912,
      0.9125,
      0.913,
      0.9135,
      0.914,
      0.9145,
      0.915,
      0.9155,
      0.916,
      0.9165,
      0.917,
      0.9175,
      0.918,
      0.9185,
      0.919,
      0.9195,
      0.92,
      0.9205,
      0.921,
      0.9215,
      0.922,
      0.9225,
      0.923,
      0.9235,
      0.924,
      0.9245,
      0.925,
      0.9255,
      0.926,
      0.9265,
      0.927,
      0.9275,
      0.928,
      0.9285,
      0.929,
      0.9295,
      0.93,
      0.9305,
      0.931,
      0.9315,
      0.932,
      0.9325,
      0.933,
      0.9335,
      0.934,
      0.9345,
      0.935,
      0.9355,
      0.936,
      0.9365,
      0.937,
      0.9375,
      9.3800000000000006E-001,
      0.9385,
      9.3900000000000006E-001,
      0.9395,
      9.4000000000000006E-001,
      0.9405,
      9.4100000000000006E-001,
      0.9415,
      9.4200000000000006E-001,
      0.9425,
      9.4300000000000006E-001,
      0.9435,
      9.4400000000000006E-001,
      0.9445,
      9.4500000000000006E-001,
      0.9455,
      9.4600000000000006E-001,
      0.9465,
      9.4700000000000006E-001,
      0.9475,
      9.4800000000000006E-001,
      0.9485,
      9.4900000000000007E-001,
      0.9495,
      9.5000000000000007E-001,
      0.9505,
      9.5100000000000007E-001,
      0.9515,
      9.5200000000000007E-001,
      0.9525,
      9.5300000000000007E-001,
      0.9535,
      9.5400000000000007E-001,
      0.9545,
      9.5500000000000007E-001,
      0.9555,
      9.5600000000000007E-001,
      0.9565,
      9.5700000000000007E-001,
      0.9575,
      9.5800000000000007E-001,
      0.9585,
      9.5900000000000007E-001,
      0.9595,
      0.96,
      0.9605,
      0.961,
      0.9615,
      0.962,
      0.9625,
      0.963,
      0.9635,
      0.964,
      0.9645,
      0.965,
      0.9655,
      0.966,
      0.9665,
      0.967,
      0.9675,
      0.968,
      0.9685,
      0.969,
      0.9695,
      0.97,
      0.9705,
      0.971,
      0.9715,
      0.972,
      0.9725,
      0.973,
      0.9735,
      0.974,
      0.9745,
      0.975,
      0.9755,
      0.976,
      0.9765,
      0.977,
      0.9775,
      0.978,
      0.9785,
      0.979,
      0.9795,
      0.98,
      0.9805,
      0.981,
      0.9815,
      0.982,
      0.9825,
      0.983,
      0.9835,
      0.984,
      0.9845,
      0.985,
      0.9855,
      0.986,
      0.9865,
      0.987,
      0.9875,
      0.988,
      0.9885,
      0.989,
      0.9895,
      0.99,
      0.9905,
      0.991,
      0.9915,
      0.992,
      0.9925,
      0.993,
      0.9935,
      0.994,
      0.9945,
      0.995,
      0.9955,
      0.996,
      0.9965,
      0.997,
      0.9975,
      0.998,
      0.9985,
      0.999,
      0.9995,
      1.0,
      1.0005,
      1.0010000000000001E+000,
      1.0015,
      1.002,
      1.0025,
      1.0030000000000001E+000,
      1.0035,
      1.004,
      1.0045,
      1.0050000000000001E+000,
      1.0055,
      1.006,
      1.0065,
      1.0070000000000001E+000,
      1.0075,
      1.008,
      1.0085,
      1.0090000000000001E+000,
      1.0095,
      1.01,
      1.0105,
      1.0110000000000001E+000,
      1.0115,
      1.012,
      1.0125,
      1.0130000000000001E+000,
      1.0135,
      1.014,
      1.0145,
      1.0150000000000001E+000,
      1.0155,
      1.016,
      1.0165,
      1.0170000000000001E+000,
      1.0175,
      1.018,
      1.0185,
      1.0190000000000001E+000,
      1.0195,
      1.02,
      1.0205,
      1.0210000000000001E+000,
      1.0215,
      1.022,
      1.0225,
      1.0230000000000001E+000,
      1.0235,
      1.024,
      1.0245,
      1.025,
      1.0255,
      1.026,
      1.0265,
      1.027,
      1.0275,
      1.028,
      1.0285,
      1.029,
      1.0295,
      1.03,
      1.0305,
      1.031,
      1.0315,
      1.032,
      1.0325,
      1.033,
      1.0335,
      1.034,
      1.0345,
      1.035,
      1.0355,
      1.036,
      1.0365,
      1.037,
      1.0375,
      1.038,
      1.0385,
      1.039,
      1.0395,
      1.04,
      1.0405,
      1.041,
      1.0415,
      1.042,
      1.0425,
      1.043,
      1.0435,
      1.044,
      1.0445,
      1.045,
      1.0455,
      1.046,
      1.0465,
      1.047,
      1.0475,
      1.048,
      1.0485,
      1.049,
      1.0495,
      1.05,
      1.0505,
      1.051,
      1.0515,
      1.052,
      1.0525,
      1.053,
      1.0535,
      1.054,
      1.0545,
      1.055,
      1.0555,
      1.056,
      1.0565,
      1.057,
      1.0575,
      1.058,
      1.0585,
      1.059,
      1.0595,
      1.06,
      1.0605,
      1.061,
      1.0615,
      1.062,
      1.0625,
      1.063,
      1.0635000000000001E+000,
      1.064,
      1.0645,
      1.065,
      1.0655000000000001E+000,
      1.066,
      1.0665,
      1.067,
      1.0675000000000001E+000,
      1.068,
      1.0685,
      1.069,
      1.0695000000000001E+000,
      1.07,
      1.0705,
      1.071,
      1.0715000000000001E+000,
      1.072,
      1.0725,
      1.073,
      1.0735000000000001E+000,
      1.074,
      1.0745,
      1.075,
      1.0755000000000001E+000,
      1.076,
      1.0765,
      1.077,
      1.0775000000000001E+000,
      1.078,
      1.0785,
      1.079,
      1.0795000000000001E+000,
      1.08,
      1.0805,
      1.081,
      1.0815000000000001E+000,
      1.082,
      1.0825,
      1.083,
      1.0835000000000001E+000,
      1.084,
      1.0845,
      1.085,
      1.0855000000000001E+000,
      1.086,
      1.0865,
      1.087,
      1.0875000000000001E+000,
      1.088,
      1.0885,
      1.089,
      1.0895,
      1.09,
      1.0905,
      1.091,
      1.0915,
      1.092,
      1.0925,
      1.093,
      1.0935,
      1.094,
      1.0945,
      1.095,
      1.0955,
      1.096,
      1.0965,
      1.097,
      1.0975,
      1.098,
      1.0985,
      1.099,
      1.0995,
      1.1,
      1.1005,
      1.101,
      1.1015,
      1.102,
      1.1025,
      1.103,
      1.1035,
      1.104,
      1.1045,
      1.105,
      1.1055,
      1.106,
      1.1065,
      1.107,
      1.1075,
      1.108,
      1.1085,
      1.109,
      1.1095,
      1.11,
      1.1105,
      1.111,
      1.1115,
      1.112,
      1.1125,
      1.113,
      1.1135,
      1.114,
      1.1145,
      1.115,
      1.1155,
      1.116,
      1.1165,
      1.117,
      1.1175,
      1.118,
      1.1185,
      1.119,
      1.1195,
      1.12,
      1.1205,
      1.121,
      1.1215,
      1.122,
      1.1225,
      1.123,
      1.1235,
      1.124,
      1.1245,
      1.125,
      1.1255,
      1.1260000000000001E+000,
      1.1265,
      1.127,
      1.1275,
      1.1280000000000001E+000,
      1.1285,
      1.129,
      1.1295,
      1.1300000000000001E+000,
      1.1305,
      1.131,
      1.1315,
      1.1320000000000001E+000,
      1.1325,
      1.133,
      1.1335,
      1.1340000000000001E+000,
      1.1345,
      1.135,
      1.1355,
      1.1360000000000001E+000,
      1.1365,
      1.137,
      1.1375,
      1.1380000000000001E+000,
      1.1385,
      1.139,
      1.1395,
      1.1400000000000001E+000,
      1.1405,
      1.141,
      1.1415,
      1.1420000000000001E+000,
      1.1425,
      1.143,
      1.1435,
      1.1440000000000001E+000,
      1.1445,
      1.145,
      1.1455,
      1.1460000000000001E+000,
      1.1465,
      1.147,
      1.1475,
      1.1480000000000001E+000,
      1.1485,
      1.149,
      1.1495,
      1.1500000000000001E+000,
      1.1505,
      1.151,
      1.1515,
      1.1520000000000001E+000,
      1.1525,
      1.153,
      1.1535,
      1.154,
      1.1545,
      1.155,
      1.1555,
      1.156,
      1.1565,
      1.157,
      1.1575,
      1.158,
      1.1585,
      1.159,
      1.1595,
      1.16,
      1.1605,
      1.161,
      1.1615,
      1.162,
      1.1625,
      1.163,
      1.1635,
      1.164,
      1.1645,
      1.165,
      1.1655,
      1.166,
      1.1665,
      1.167,
      1.1675,
      1.168,
      1.1685,
      1.169,
      1.1695,
      1.17,
      1.1705,
      1.171,
      1.1715,
      1.172,
      1.1725,
      1.173,
      1.1735,
      1.174,
      1.1745,
      1.175,
      1.1755,
      1.176,
      1.1765,
      1.177,
      1.1775,
      1.178,
      1.1785,
      1.179,
      1.1795,
      1.18,
      1.1805,
      1.181,
      1.1815,
      1.182,
      1.1825,
      1.183,
      1.1835,
      1.184,
      1.1845,
      1.185,
      1.1855,
      1.186,
      1.1865,
      1.187,
      1.1875,
      1.188,
      1.1885000000000001E+000,
      1.189,
      1.1895,
      1.19,
      1.1905000000000001E+000,
      1.191,
      1.1915,
      1.192,
      1.1925000000000001E+000,
      1.193,
      1.1935,
      1.194,
      1.1945000000000001E+000,
      1.195,
      1.1955,
      1.196,
      1.1965000000000001E+000,
      1.197,
      1.1975,
      1.198,
      1.1985000000000001E+000,
      1.199,
      1.1995,
      1.2,
      1.2005000000000001E+000,
      1.201,
      1.2015,
      1.202,
      1.2025000000000001E+000,
      1.203,
      1.2035,
      1.204,
      1.2045000000000001E+000,
      1.205,
      1.2055,
      1.206,
      1.2065000000000001E+000,
      1.207,
      1.2075,
      1.208,
      1.2085000000000001E+000,
      1.209,
      1.2095,
      1.21,
      1.2105000000000001E+000,
      1.211,
      1.2115,
      1.212,
      1.2125000000000001E+000,
      1.213,
      1.2135,
      1.214,
      1.2145000000000001E+000,
      1.215,
      1.2155,
      1.216,
      1.2165,
      1.217,
      1.2175,
      1.218,
      1.2185,
      1.219,
      1.2195,
      1.22,
      1.2205,
      1.221,
      1.2215,
      1.222,
      1.2225,
      1.223,
      1.2235,
      1.224,
      1.2245,
      1.225,
      1.2255,
      1.226,
      1.2265,
      1.227,
      1.2275,
      1.228,
      1.2285,
      1.229,
      1.2295,
      1.23,
      1.2305,
      1.231,
      1.2315,
      1.232,
      1.2325,
      1.233,
      1.2335,
      1.234,
      1.2345,
      1.235,
      1.2355,
      1.236,
      1.2365,
      1.237,
      1.2375,
      1.238,
      1.2385,
      1.239,
      1.2395,
      1.24,
      1.2405,
      1.241,
      1.2415,
      1.242,
      1.2425,
      1.243,
      1.2435,
      1.244,
      1.2445,
      1.245,
      1.2455,
      1.246,
      1.2465,
      1.247,
      1.2475,
      1.248,
      1.2485,
      1.249,
      1.2495,
      1.25,
      1.2505,
      1.2510000000000001E+000,
      1.2515,
      1.252,
      1.2525,
      1.2530000000000001E+000,
      1.2535,
      1.254,
      1.2545,
      1.2550000000000001E+000,
      1.2555,
      1.256,
      1.2565,
      1.2570000000000001E+000,
      1.2575,
      1.258,
      1.2585,
      1.2590000000000001E+000,
      1.2595,
      1.26,
      1.2605,
      1.2610000000000001E+000,
      1.2615,
      1.262,
      1.2625,
      1.2630000000000001E+000,
      1.2635,
      1.264,
      1.2645,
      1.2650000000000001E+000,
      1.2655,
      1.266,
      1.2665,
      1.2670000000000001E+000,
      1.2675,
      1.268,
      1.2685,
      1.2690000000000001E+000,
      1.2695,
      1.27,
      1.2705,
      1.2710000000000001E+000,
      1.2715,
      1.272,
      1.2725,
      1.2730000000000001E+000,
      1.2735,
      1.274,
      1.2745,
      1.2750000000000001E+000,
      1.2755,
      1.276,
      1.2765,
      1.2770000000000001E+000,
      1.2775,
      1.278,
      1.2785,
      1.2790000000000001E+000,
      1.2795,
      1.28,
      1.2805,
      1.281,
      1.2815,
      1.282,
      1.2825,
      1.283,
      1.2835,
      1.284,
      1.2845,
      1.285,
      1.2855,
      1.286,
      1.2865,
      1.287,
      1.2875,
      1.288,
      1.2885,
      1.289,
      1.2895,
      1.29,
      1.2905,
      1.291,
      1.2915,
      1.292,
      1.2925,
      1.293,
      1.2935,
      1.294,
      1.2945,
      1.295,
      1.2955,
      1.296,
      1.2965,
      1.297,
      1.2975,
      1.298,
      1.2985,
      1.299,
      1.2995,
      1.3,
      1.3005,
      1.301,
      1.3015,
      1.302,
      1.3025,
      1.303,
      1.3035,
      1.304,
      1.3045,
      1.305,
      1.3055,
      1.306,
      1.3065,
      1.307,
      1.3075,
      1.308,
      1.3085,
      1.309,
      1.3095,
      1.31,
      1.3105,
      1.311,
      1.3115,
      1.312,
      1.3125,
      1.313,
      1.3135000000000001E+000,
      1.314,
      1.3145,
      1.315,
      1.3155000000000001E+000,
      1.316,
      1.3165,
      1.317,
      1.3175000000000001E+000,
      1.318,
      1.3185,
      1.319,
      1.3195000000000001E+000,
      1.32,
      1.3205,
      1.321,
      1.3215000000000001E+000,
      1.322,
      1.3225,
      1.323,
      1.3235000000000001E+000,
      1.324,
      1.3245,
      1.325,
      1.3255000000000001E+000,
      1.326,
      1.3265,
      1.327,
      1.3275000000000001E+000,
      1.328,
      1.3285,
      1.329,
      1.3295000000000001E+000,
      1.33,
      1.3305,
      1.331,
      1.3315000000000001E+000,
      1.332,
      1.3325,
      1.333,
      1.3335000000000001E+000,
      1.334,
      1.3345,
      1.335,
      1.3355000000000001E+000,
      1.336,
      1.3365,
      1.337,
      1.3375000000000001E+000,
      1.338,
      1.3385,
      1.339,
      1.3395000000000001E+000,
      1.34,
      1.3405,
      1.341,
      1.3415000000000001E+000,
      1.342,
      1.3425,
      1.343,
      1.3435000000000001E+000,
      1.344,
      1.3445,
      1.345,
      1.3455,
      1.346,
      1.3465,
      1.347,
      1.3475,
      1.348,
      1.3485,
      1.349,
      1.3495,
      1.35,
      1.3505,
      1.351,
      1.3515,
      1.352,
      1.3525,
      1.353,
      1.3535,
      1.354,
      1.3545,
      1.355,
      1.3555,
      1.356,
      1.3565,
      1.357,
      1.3575,
      1.358,
      1.3585,
      1.359,
      1.3595,
      1.36,
      1.3605,
      1.361,
      1.3615,
      1.362,
      1.3625,
      1.363,
      1.3635,
      1.364,
      1.3645,
      1.365,
      1.3655,
      1.366,
      1.3665,
      1.367,
      1.3675,
      1.368,
      1.3685,
      1.369,
      1.3695,
      1.37,
      1.3705,
      1.371,
      1.3715,
      1.372,
      1.3725,
      1.373,
      1.3735,
      1.374,
      1.3745,
      1.375,
      1.3755,
      1.3760000000000001E+000,
      1.3765,
      1.377,
      1.3775,
      1.3780000000000001E+000,
      1.3785,
      1.379,
      1.3795,
      1.3800000000000001E+000,
      1.3805,
      1.381,
      1.3815,
      1.3820000000000001E+000,
      1.3825,
      1.383,
      1.3835,
      1.3840000000000001E+000,
      1.3845,
      1.385,
      1.3855,
      1.3860000000000001E+000,
      1.3865,
      1.387,
      1.3875,
      1.3880000000000001E+000,
      1.3885,
      1.389,
      1.3895,
      1.3900000000000001E+000,
      1.3905,
      1.391,
      1.3915,
      1.3920000000000001E+000,
      1.3925,
      1.393,
      1.3935,
      1.3940000000000001E+000,
      1.3945,
      1.395,
      1.3955,
      1.3960000000000001E+000,
      1.3965,
      1.397,
      1.3975,
      1.3980000000000001E+000,
      1.3985,
      1.399,
      1.3995,
      1.4000000000000001E+000,
      1.4005,
      1.401,
      1.4015,
      1.4020000000000001E+000,
      1.4025,
      1.403,
      1.4035,
      1.4040000000000001E+000,
      1.4045,
      1.405,
      1.4055,
      1.4060000000000001E+000,
      1.4065,
      1.407,
      1.4075,
      1.408,
      1.4085,
      1.409,
      1.4095,
      1.41,
      1.4105,
      1.411,
      1.4115,
      1.412,
      1.4125,
      1.413,
      1.4135,
      1.414,
      1.4145,
      1.415,
      1.4155,
      1.416,
      1.4165,
      1.417,
      1.4175,
      1.418,
      1.4185,
      1.419,
      1.4195,
      1.42,
      1.4205,
      1.421,
      1.4215,
      1.422,
      1.4225,
      1.423,
      1.4235,
      1.424,
      1.4245,
      1.425,
      1.4255,
      1.426,
      1.4265,
      1.427,
      1.4275,
      1.428,
      1.4285,
      1.429,
      1.4295,
      1.43,
      1.4305,
      1.431,
      1.4315,
      1.432,
      1.4325,
      1.433,
      1.4335,
      1.434,
      1.4345,
      1.435,
      1.4355,
      1.436,
      1.4365,
      1.437,
      1.4375,
      1.438,
      1.4385000000000001E+000,
      1.439,
      1.4395,
      1.44,
      1.4405000000000001E+000,
      1.441,
      1.4415,
      1.442,
      1.4425000000000001E+000,
      1.443,
      1.4435,
      1.444,
      1.4445000000000001E+000,
      1.445,
      1.4455,
      1.446,
      1.4465000000000001E+000,
      1.447,
      1.4475,
      1.448,
      1.4485000000000001E+000,
      1.449,
      1.4495,
      1.45,
      1.4505000000000001E+000,
      1.451,
      1.4515,
      1.452,
      1.4525000000000001E+000,
      1.453,
      1.4535,
      1.454,
      1.4545000000000001E+000,
      1.455,
      1.4555,
      1.456,
      1.4565000000000001E+000,
      1.457,
      1.4575,
      1.458,
      1.4585000000000001E+000,
      1.459,
      1.4595,
      1.46,
      1.4605000000000001E+000,
      1.461,
      1.4615,
      1.462,
      1.4625000000000001E+000,
      1.463,
      1.4635,
      1.464,
      1.4645000000000001E+000,
      1.465,
      1.4655,
      1.466,
      1.4665000000000001E+000,
      1.467,
      1.4675,
      1.468,
      1.4685000000000001E+000,
      1.469,
      1.4695,
      1.47,
      1.4705000000000001E+000,
      1.471,
      1.4715,
      1.472,
      1.4725,
      1.473,
      1.4735,
      1.474,
      1.4745,
      1.475,
      1.4755,
      1.476,
      1.4765,
      1.477,
      1.4775,
      1.478,
      1.4785,
      1.479,
      1.4795,
      1.48,
      1.4805,
      1.481,
      1.4815,
      1.482,
      1.4825,
      1.483,
      1.4835,
      1.484,
      1.4845,
      1.485,
      1.4855,
      1.486,
      1.4865,
      1.487,
      1.4875,
      1.488,
      1.4885,
      1.489,
      1.4895,
      1.49,
      1.4905,
      1.491,
      1.4915,
      1.492,
      1.4925,
      1.493,
      1.4935,
      1.494,
      1.4945,
      1.495,
      1.4955,
      1.496,
      1.4965,
      1.497,
      1.4975,
      1.498,
      1.4985,
      1.499,
      1.4995,
      1.5,
      1.5005,
      1.5010000000000001E+000,
      1.5015,
      1.502,
      1.5025,
      1.5030000000000001E+000,
      1.5035,
      1.504,
      1.5045,
      1.5050000000000001E+000,
      1.5055,
      1.506,
      1.5065,
      1.5070000000000001E+000,
      1.5075,
      1.508,
      1.5085,
      1.5090000000000001E+000,
      1.5095,
      1.51,
      1.5105,
      1.5110000000000001E+000,
      1.5115,
      1.512,
      1.5125,
      1.5130000000000001E+000,
      1.5135,
      1.514,
      1.5145,
      1.5150000000000001E+000,
      1.5155,
      1.516,
      1.5165,
      1.5170000000000001E+000,
      1.5175,
      1.518,
      1.5185,
      1.5190000000000001E+000,
      1.5195,
      1.52,
      1.5205,
      1.5210000000000001E+000,
      1.5215,
      1.522,
      1.5225,
      1.5230000000000001E+000,
      1.5235,
      1.524,
      1.5245,
      1.5250000000000001E+000,
      1.5255,
      1.526,
      1.5265,
      1.5270000000000001E+000,
      1.5275,
      1.528,
      1.5285,
      1.5290000000000001E+000,
      1.5295,
      1.53,
      1.5305,
      1.5310000000000001E+000,
      1.5315,
      1.532,
      1.5325,
      1.5330000000000001E+000,
      1.5335,
      1.534,
      1.5345,
      1.5350000000000001E+000,
      1.5355,
      1.536,
      1.5365,
      1.537,
      1.5375,
      1.538,
      1.5385,
      1.539,
      1.5395,
      1.54,
      1.5405,
      1.541,
      1.5415,
      1.542,
      1.5425,
      1.543,
      1.5435,
      1.544,
      1.5445,
      1.545,
      1.5455,
      1.546,
      1.5465,
      1.547,
      1.5475,
      1.548,
      1.5485,
      1.549,
      1.5495,
      1.55,
      1.5505,
      1.551,
      1.5515,
      1.552,
      1.5525,
      1.553,
      1.5535,
      1.554,
      1.5545,
      1.555,
      1.5555,
      1.556,
      1.5565,
      1.557,
      1.5575,
      1.558,
      1.5585,
      1.559,
      1.5595,
      1.56,
      1.5605,
      1.561,
      1.5615,
      1.562,
      1.5625,
      1.563,
      1.5635000000000001E+000,
      1.564,
      1.5645,
      1.565,
      1.5655000000000001E+000,
      1.566,
      1.5665,
      1.567,
      1.5675000000000001E+000,
      1.568,
      1.5685,
      1.569,
      1.5695000000000001E+000,
      1.57,
      1.5705,
      1.571,
      1.5715000000000001E+000,
      1.572,
      1.5725,
      1.573,
      1.5735000000000001E+000,
      1.574,
      1.5745,
      1.575,
      1.5755000000000001E+000,
      1.576,
      1.5765,
      1.577,
      1.5775000000000001E+000,
      1.578,
      1.5785,
      1.579,
      1.5795000000000001E+000,
      1.58,
      1.5805,
      1.581,
      1.5815000000000001E+000,
      1.582,
      1.5825,
      1.583,
      1.5835000000000001E+000,
      1.584,
      1.5845,
      1.585,
      1.5855000000000001E+000,
      1.586,
      1.5865,
      1.587,
      1.5875000000000001E+000,
      1.588,
      1.5885,
      1.589,
      1.5895000000000001E+000,
      1.59,
      1.5905,
      1.591,
      1.5915000000000001E+000,
      1.592,
      1.5925,
      1.593,
      1.5935000000000001E+000,
      1.594,
      1.5945,
      1.595,
      1.5955000000000001E+000,
      1.596,
      1.5965,
      1.597,
      1.5975000000000001E+000,
      1.598,
      1.5985,
      1.599,
      1.5995000000000001E+000,
      1.6,
      1.6005,
      1.601,
      1.6015,
      1.602,
      1.6025,
      1.603,
      1.6035,
      1.604,
      1.6045,
      1.605,
      1.6055,
      1.606,
      1.6065,
      1.607,
      1.6075,
      1.608,
      1.6085,
      1.609,
      1.6095,
      1.61,
      1.6105,
      1.611,
      1.6115,
      1.612,
      1.6125,
      1.613,
      1.6135,
      1.614,
      1.6145,
      1.615,
      1.6155,
      1.616,
      1.6165,
      1.617,
      1.6175,
      1.618,
      1.6185,
      1.619,
      1.6195,
      1.62,
      1.6205,
      1.621,
      1.6215,
      1.622,
      1.6225,
      1.623,
      1.6235,
      1.624,
      1.6245,
      1.625,
      1.6255,
      1.6260000000000001E+000,
      1.6265,
      1.627,
      1.6275,
      1.6280000000000001E+000,
      1.6285,
      1.629,
      1.6295,
      1.6300000000000001E+000,
      1.6305,
      1.631,
      1.6315,
      1.6320000000000001E+000,
      1.6325,
      1.633,
      1.6335,
      1.6340000000000001E+000,
      1.6345,
      1.635,
      1.6355,
      1.6360000000000001E+000,
      1.6365,
      1.637,
      1.6375,
      1.6380000000000001E+000,
      1.6385,
      1.639,
      1.6395,
      1.6400000000000001E+000,
      1.6405,
      1.641,
      1.6415,
      1.6420000000000001E+000,
      1.6425,
      1.643,
      1.6435,
      1.6440000000000001E+000,
      1.6445,
      1.645,
      1.6455,
      1.6460000000000001E+000,
      1.6465,
      1.647,
      1.6475,
      1.6480000000000001E+000,
      1.6485,
      1.649,
      1.6495,
      1.6500000000000001E+000,
      1.6505,
      1.651,
      1.6515,
      1.6520000000000001E+000,
      1.6525,
      1.653,
      1.6535,
      1.6540000000000001E+000,
      1.6545,
      1.655,
      1.6555,
      1.6560000000000001E+000,
      1.6565,
      1.657,
      1.6575,
      1.6580000000000001E+000,
      1.6585,
      1.659,
      1.6595,
      1.6600000000000001E+000,
      1.6605,
      1.661,
      1.6615,
      1.6620000000000001E+000,
      1.6625,
      1.663,
      1.6635,
      1.6640000000000001E+000,
      1.6645,
      1.665,
      1.6655,
      1.666,
      1.6665,
      1.667,
      1.6675,
      1.668,
      1.6685,
      1.669,
      1.6695,
      1.67,
      1.6705,
      1.671,
      1.6715,
      1.672,
      1.6725,
      1.673,
      1.6735,
      1.674,
      1.6745,
      1.675,
      1.6755,
      1.676,
      1.6765,
      1.677,
      1.6775,
      1.678,
      1.6785,
      1.679,
      1.6795,
      1.68,
      1.6805,
      1.681,
      1.6815,
      1.682,
      1.6825,
      1.683,
      1.6835,
      1.684,
      1.6845,
      1.685,
      1.6855,
      1.686,
      1.6865,
      1.687,
      1.6875,
      1.688,
      1.6885000000000001E+000,
      1.689,
      1.6895,
      1.69,
      1.6905000000000001E+000,
      1.691,
      1.6915,
      1.692,
      1.6925000000000001E+000,
      1.693,
      1.6935,
      1.694,
      1.6945000000000001E+000,
      1.695,
      1.6955,
      1.696,
      1.6965000000000001E+000,
      1.697,
      1.6975,
      1.698,
      1.6985000000000001E+000,
      1.699,
      1.6995,
      1.7,
      1.7005000000000001E+000,
      1.701,
      1.7015,
      1.702,
      1.7025000000000001E+000,
      1.703,
      1.7035,
      1.704,
      1.7045000000000001E+000,
      1.705,
      1.7055,
      1.706,
      1.7065000000000001E+000,
      1.707,
      1.7075,
      1.708,
      1.7085000000000001E+000,
      1.709,
      1.7095,
      1.71,
      1.7105000000000001E+000,
      1.711,
      1.7115,
      1.712,
      1.7125000000000001E+000,
      1.713,
      1.7135,
      1.714,
      1.7145000000000001E+000,
      1.715,
      1.7155,
      1.716,
      1.7165000000000001E+000,
      1.717,
      1.7175,
      1.718,
      1.7185000000000001E+000,
      1.719,
      1.7195,
      1.72,
      1.7205000000000001E+000,
      1.721,
      1.7215,
      1.722,
      1.7225000000000001E+000,
      1.723,
      1.7235,
      1.724,
      1.7245000000000001E+000,
      1.725,
      1.7255,
      1.726,
      1.7265000000000001E+000,
      1.727,
      1.7275,
      1.728,
      1.7285,
      1.729,
      1.7295,
      1.73,
      1.7305,
      1.731,
      1.7315,
      1.732,
      1.7325,
      1.733,
      1.7335,
      1.734,
      1.7345,
      1.735,
      1.7355,
      1.736,
      1.7365,
      1.737,
      1.7375,
      1.738,
      1.7385,
      1.739,
      1.7395,
      1.74,
      1.7405,
      1.741,
      1.7415,
      1.742,
      1.7425,
      1.743,
      1.7435,
      1.744,
      1.7445,
      1.745,
      1.7455,
      1.746,
      1.7465,
      1.747,
      1.7475,
      1.748,
      1.7485,
      1.749,
      1.7495,
      1.75,
      1.7505,
      1.7510000000000001E+000,
      1.7515,
      1.752,
      1.7525,
      1.7530000000000001E+000,
      1.7535,
      1.754,
      1.7545,
      1.7550000000000001E+000,
      1.7555,
      1.756,
      1.7565,
      1.7570000000000001E+000,
      1.7575,
      1.758,
      1.7585,
      1.7590000000000001E+000,
      1.7595,
      1.76,
      1.7605,
      1.7610000000000001E+000,
      1.7615,
      1.762,
      1.7625,
      1.7630000000000001E+000,
      1.7635,
      1.764,
      1.7645,
      1.7650000000000001E+000,
      1.7655,
      1.766,
      1.7665,
      1.7670000000000001E+000,
      1.7675,
      1.768,
      1.7685,
      1.7690000000000001E+000,
      1.7695,
      1.77,
      1.7705,
      1.7710000000000001E+000,
      1.7715,
      1.772,
      1.7725,
      1.7730000000000001E+000,
      1.7735,
      1.774,
      1.7745,
      1.7750000000000001E+000,
      1.7755,
      1.776,
      1.7765,
      1.7770000000000001E+000,
      1.7775,
      1.778,
      1.7785,
      1.7790000000000001E+000,
      1.7795,
      1.78,
      1.7805,
      1.7810000000000001E+000,
      1.7815,
      1.782,
      1.7825,
      1.7830000000000001E+000,
      1.7835,
      1.784,
      1.7845,
      1.7850000000000001E+000,
      1.7855,
      1.786,
      1.7865,
      1.7870000000000001E+000,
      1.7875,
      1.788,
      1.7885,
      1.7890000000000001E+000,
      1.7895,
      1.79,
      1.7905,
      1.7910000000000001E+000,
      1.7915,
      1.792,
      1.7925,
      1.793,
      1.7935,
      1.794,
      1.7945,
      1.795,
      1.7955,
      1.796,
      1.7965,
      1.797,
      1.7975,
      1.798,
      1.7985,
      1.799,
      1.7995,
      1.8,
      1.8005,
      1.801,
      1.8015,
      1.802,
      1.8025,
      1.803,
      1.8035,
      1.804,
      1.8045,
      1.805,
      1.8055,
      1.806,
      1.8065,
      1.807,
      1.8075,
      1.808,
      1.8085,
      1.809,
      1.8095,
      1.81,
      1.8105,
      1.811,
      1.8115,
      1.812,
      1.8125,
      1.813,
      1.8135000000000001E+000,
      1.814,
      1.8145,
      1.815,
      1.8155000000000001E+000,
      1.816,
      1.8165,
      1.817,
      1.8175000000000001E+000,
      1.818,
      1.8185,
      1.819,
      1.8195000000000001E+000,
      1.82,
      1.8205,
      1.821,
      1.8215000000000001E+000,
      1.822,
      1.8225,
      1.823,
      1.8235000000000001E+000,
      1.824,
      1.8245,
      1.825,
      1.8255000000000001E+000,
      1.826,
      1.8265,
      1.827,
      1.8275000000000001E+000,
      1.828,
      1.8285,
      1.829,
      1.8295000000000001E+000,
      1.83,
      1.8305,
      1.831,
      1.8315000000000001E+000,
      1.832,
      1.8325,
      1.833,
      1.8335000000000001E+000,
      1.834,
      1.8345,
      1.835,
      1.8355000000000001E+000,
      1.836,
      1.8365,
      1.837,
      1.8375000000000001E+000,
      1.838,
      1.8385,
      1.839,
      1.8395000000000001E+000,
      1.84,
      1.8405,
      1.841,
      1.8415000000000001E+000,
      1.842,
      1.8425,
      1.843,
      1.8435000000000001E+000,
      1.844,
      1.8445,
      1.845,
      1.8455000000000001E+000,
      1.846,
      1.8465,
      1.847,
      1.8475000000000001E+000,
      1.848,
      1.8485,
      1.849,
      1.8495000000000001E+000,
      1.85,
      1.8505,
      1.851,
      1.8515000000000001E+000,
      1.852,
      1.8525,
      1.853,
      1.8535000000000001E+000,
      1.854,
      1.8545,
      1.855,
      1.8555000000000001E+000,
      1.856,
      1.8565,
      1.857,
      1.8575,
      1.858,
      1.8585,
      1.859,
      1.8595,
      1.86,
      1.8605,
      1.861,
      1.8615,
      1.862,
      1.8625,
      1.863,
      1.8635,
      1.864,
      1.8645,
      1.865,
      1.8655,
      1.866,
      1.8665,
      1.867,
      1.8675,
      1.868,
      1.8685,
      1.869,
      1.8695,
      1.87,
      1.8705,
      1.871,
      1.8715,
      1.872,
      1.8725,
      1.873,
      1.8735,
      1.874,
      1.8745,
      1.875,
      1.8755,
      1.8760000000000001E+000,
      1.8765,
      1.877,
      1.8775,
      1.8780000000000001E+000,
      1.8785,
      1.879,
      1.8795,
      1.8800000000000001E+000,
      1.8805,
      1.881,
      1.8815,
      1.8820000000000001E+000,
      1.8825,
      1.883,
      1.8835,
      1.8840000000000001E+000,
      1.8845,
      1.885,
      1.8855,
      1.8860000000000001E+000,
      1.8865,
      1.887,
      1.8875,
      1.8880000000000001E+000,
      1.8885,
      1.889,
      1.8895,
      1.8900000000000001E+000,
      1.8905,
      1.891,
      1.8915,
      1.8920000000000001E+000,
      1.8925,
      1.893,
      1.8935,
      1.8940000000000001E+000,
      1.8945,
      1.895,
      1.8955,
      1.8960000000000001E+000,
      1.8965,
      1.897,
      1.8975,
      1.8980000000000001E+000,
      1.8985,
      1.899,
      1.8995,
      1.9000000000000001E+000,
      1.9005,
      1.901,
      1.9015,
      1.9020000000000001E+000,
      1.9025,
      1.903,
      1.9035,
      1.9040000000000001E+000,
      1.9045,
      1.905,
      1.9055,
      1.9060000000000001E+000,
      1.9065,
      1.907,
      1.9075,
      1.9080000000000001E+000,
      1.9085,
      1.909,
      1.9095,
      1.9100000000000001E+000,
      1.9105,
      1.911,
      1.9115,
      1.9120000000000001E+000,
      1.9125,
      1.913,
      1.9135,
      1.9140000000000001E+000,
      1.9145,
      1.915,
      1.9155,
      1.9160000000000001E+000,
      1.9165,
      1.917,
      1.9175,
      1.9180000000000001E+000,
      1.9185,
      1.919,
      1.9195,
      1.92,
      1.9205,
      1.921,
      1.9215,
      1.922,
      1.9225,
      1.923,
      1.9235,
      1.924,
      1.9245,
      1.925,
      1.9255,
      1.926,
      1.9265,
      1.927,
      1.9275,
      1.928,
      1.9285,
      1.929,
      1.9295,
      1.93,
      1.9305,
      1.931,
      1.9315,
      1.932,
      1.9325,
      1.933,
      1.9335,
      1.934,
      1.9345,
      1.935,
      1.9355,
      1.936,
      1.9365,
      1.937,
      1.9375,
      1.938,
      1.9385000000000001E+000,
      1.939,
      1.9395,
      1.94,
      1.9405000000000001E+000,
      1.941,
      1.9415,
      1.942,
      1.9425000000000001E+000,
      1.943,
      1.9435,
      1.944,
      1.9445000000000001E+000,
      1.945,
      1.9455,
      1.946,
      1.9465000000000001E+000,
      1.947,
      1.9475,
      1.948,
      1.9485000000000001E+000,
      1.949,
      1.9495,
      1.95,
      1.9505000000000001E+000,
      1.951,
      1.9515,
      1.952,
      1.9525000000000001E+000,
      1.953,
      1.9535,
      1.954,
      1.9545000000000001E+000,
      1.955,
      1.9555,
      1.956,
      1.9565000000000001E+000,
      1.957,
      1.9575,
      1.958,
      1.9585000000000001E+000,
      1.959,
      1.9595,
      1.96,
      1.9605000000000001E+000,
      1.961,
      1.9615,
      1.962,
      1.9625000000000001E+000,
      1.963,
      1.9635,
      1.964,
      1.9645000000000001E+000,
      1.965,
      1.9655,
      1.966,
      1.9665000000000001E+000,
      1.967,
      1.9675,
      1.968,
      1.9685000000000001E+000,
      1.969,
      1.9695,
      1.97,
      1.9705000000000001E+000,
      1.971,
      1.9715,
      1.972,
      1.9725000000000001E+000,
      1.973,
      1.9735,
      1.974,
      1.9745000000000001E+000,
      1.975,
      1.9755,
      1.976,
      1.9765000000000001E+000,
      1.977,
      1.9775,
      1.978,
      1.9785000000000001E+000,
      1.979,
      1.9795,
      1.98,
      1.9805000000000001E+000,
      1.981,
      1.9815,
      1.982,
      1.9825000000000002E+000,
      1.983,
      1.9835,
      1.984,
      1.9845,
      1.985,
      1.9855,
      1.986,
      1.9865,
      1.987,
      1.9875,
      1.988,
      1.9885,
      1.989,
      1.9895,
      1.99,
      1.9905,
      1.991,
      1.9915,
      1.992,
      1.9925,
      1.993,
      1.9935,
      1.994,
      1.9945,
      1.995,
      1.9955,
      1.996,
      1.9965,
      1.997,
      1.9975,
      1.998,
      1.9985,
      1.999,
      1.9995,
      2.0,
      2.0005,
      2.001,
      2.0015,
      2.0020000000000002E+000,
      2.0025,
      2.003,
      2.0035,
      2.004,
      2.0045,
      2.005,
      2.0055,
      2.0060000000000002E+000,
      2.0065,
      2.007,
      2.0075,
      2.008,
      2.0085,
      2.009,
      2.0095,
      2.0100000000000002E+000,
      2.0105,
      2.011,
      2.0115,
      2.012,
      2.0125,
      2.013,
      2.0135,
      2.0140000000000002E+000,
      2.0145,
      2.015,
      2.0155,
      2.016,
      2.0165,
      2.017,
      2.0175,
      2.0180000000000002E+000,
      2.0185,
      2.019,
      2.0195,
      2.02,
      2.0205,
      2.021,
      2.0215,
      2.0220000000000002E+000,
      2.0225,
      2.023,
      2.0235,
      2.024,
      2.0245,
      2.025,
      2.0255,
      2.0260000000000002E+000,
      2.0265,
      2.027,
      2.0275,
      2.028,
      2.0285,
      2.029,
      2.0295,
      2.0300000000000002E+000,
      2.0305,
      2.031,
      2.0315,
      2.032,
      2.0325,
      2.033,
      2.0335,
      2.0340000000000003E+000,
      2.0345,
      2.035,
      2.0355,
      2.036,
      2.0365,
      2.037,
      2.0375,
      2.0380000000000003E+000,
      2.0385,
      2.039,
      2.0395,
      2.04,
      2.0405,
      2.041,
      2.0415,
      2.0420000000000003E+000,
      2.0425,
      2.043,
      2.0435,
      2.044,
      2.0445,
      2.045,
      2.0455,
      2.0460000000000003E+000,
      2.0465,
      2.047,
      2.0475,
      2.048,
      2.0485,
      2.049,
      2.0495,
      2.05,
      2.0505,
      2.051,
      2.0515,
      2.052,
      2.0525,
      2.053,
      2.0535,
      2.054,
      2.0545,
      2.055,
      2.0555,
      2.056,
      2.0565,
      2.057,
      2.0575,
      2.058,
      2.0585,
      2.059,
      2.0595,
      2.06,
      2.0605,
      2.061,
      2.0615,
      2.062,
      2.0625,
      2.063,
      2.0635,
      2.064,
      2.0645000000000002E+000,
      2.065,
      2.0655,
      2.066,
      2.0665,
      2.067,
      2.0675,
      2.068,
      2.0685000000000002E+000,
      2.069,
      2.0695,
      2.07,
      2.0705,
      2.071,
      2.0715,
      2.072,
      2.0725000000000002E+000,
      2.073,
      2.0735,
      2.074,
      2.0745,
      2.075,
      2.0755,
      2.076,
      2.0765000000000002E+000,
      2.077,
      2.0775,
      2.078,
      2.0785,
      2.079,
      2.0795,
      2.08,
      2.0805000000000002E+000,
      2.081,
      2.0815,
      2.082,
      2.0825,
      2.083,
      2.0835,
      2.084,
      2.0845000000000002E+000,
      2.085,
      2.0855,
      2.086,
      2.0865,
      2.087,
      2.0875,
      2.088,
      2.0885000000000002E+000,
      2.089,
      2.0895,
      2.09,
      2.0905,
      2.091,
      2.0915,
      2.092,
      2.0925000000000002E+000,
      2.093,
      2.0935,
      2.094,
      2.0945,
      2.095,
      2.0955,
      2.096,
      2.0965000000000003E+000,
      2.097,
      2.0975,
      2.098,
      2.0985,
      2.099,
      2.0995,
      2.1,
      2.1005000000000003E+000,
      2.101,
      2.1015,
      2.102,
      2.1025,
      2.103,
      2.1035,
      2.104,
      2.1045000000000003E+000,
      2.105,
      2.1055,
      2.106,
      2.1065,
      2.107,
      2.1075,
      2.108,
      2.1085000000000003E+000,
      2.109,
      2.1095,
      2.11,
      2.1105,
      2.111,
      2.1115,
      2.112,
      2.1125,
      2.113,
      2.1135,
      2.114,
      2.1145,
      2.115,
      2.1155,
      2.116,
      2.1165,
      2.117,
      2.1175,
      2.118,
      2.1185,
      2.119,
      2.1195,
      2.12,
      2.1205,
      2.121,
      2.1215,
      2.122,
      2.1225,
      2.123,
      2.1235,
      2.124,
      2.1245,
      2.125,
      2.1255,
      2.126,
      2.1265,
      2.1270000000000002E+000,
      2.1275,
      2.128,
      2.1285,
      2.129,
      2.1295,
      2.13,
      2.1305,
      2.1310000000000002E+000,
      2.1315,
      2.132,
      2.1325,
      2.133,
      2.1335,
      2.134,
      2.1345,
      2.1350000000000002E+000,
      2.1355,
      2.136,
      2.1365,
      2.137,
      2.1375,
      2.138,
      2.1385,
      2.1390000000000002E+000,
      2.1395,
      2.14,
      2.1405,
      2.141,
      2.1415,
      2.142,
      2.1425,
      2.1430000000000002E+000,
      2.1435,
      2.144,
      2.1445,
      2.145,
      2.1455,
      2.146,
      2.1465,
      2.1470000000000002E+000,
      2.1475,
      2.148,
      2.1485,
      2.149,
      2.1495,
      2.15,
      2.1505,
      2.1510000000000002E+000,
      2.1515,
      2.152,
      2.1525,
      2.153,
      2.1535,
      2.154,
      2.1545,
      2.1550000000000002E+000,
      2.1555,
      2.156,
      2.1565,
      2.157,
      2.1575,
      2.158,
      2.1585,
      2.1590000000000003E+000,
      2.1595,
      2.16,
      2.1605,
      2.161,
      2.1615,
      2.162,
      2.1625,
      2.1630000000000003E+000,
      2.1635,
      2.164,
      2.1645,
      2.165,
      2.1655,
      2.166,
      2.1665,
      2.1670000000000003E+000,
      2.1675,
      2.168,
      2.1685,
      2.169,
      2.1695,
      2.17,
      2.1705,
      2.1710000000000003E+000,
      2.1715,
      2.172,
      2.1725,
      2.173,
      2.1735,
      2.174,
      2.1745,
      2.1750000000000003E+000,
      2.1755,
      2.176,
      2.1765,
      2.177,
      2.1775,
      2.178,
      2.1785,
      2.179,
      2.1795,
      2.18,
      2.1805,
      2.181,
      2.1815,
      2.182,
      2.1825,
      2.183,
      2.1835,
      2.184,
      2.1845,
      2.185,
      2.1855,
      2.186,
      2.1865,
      2.187,
      2.1875,
      2.188,
      2.1885,
      2.189,
      2.1895000000000002E+000,
      2.19,
      2.1905,
      2.191,
      2.1915,
      2.192,
      2.1925,
      2.193,
      2.1935000000000002E+000,
      2.194,
      2.1945,
      2.195,
      2.1955,
      2.196,
      2.1965,
      2.197,
      2.1975000000000002E+000,
      2.198,
      2.1985,
      2.199,
      2.1995,
      2.2,
      2.2005,
      2.201,
      2.2015000000000002E+000,
      2.202,
      2.2025,
      2.203,
      2.2035,
      2.204,
      2.2045,
      2.205,
      2.2055000000000002E+000,
      2.206,
      2.2065,
      2.207,
      2.2075,
      2.208,
      2.2085,
      2.209,
      2.2095000000000002E+000,
      2.21,
      2.2105,
      2.211,
      2.2115,
      2.212,
      2.2125,
      2.213,
      2.2135000000000002E+000,
      2.214,
      2.2145,
      2.215,
      2.2155,
      2.216,
      2.2165,
      2.217,
      2.2175000000000002E+000,
      2.218,
      2.2185,
      2.219,
      2.2195,
      2.22,
      2.2205,
      2.221,
      2.2215000000000003E+000,
      2.222,
      2.2225,
      2.223,
      2.2235,
      2.224,
      2.2245,
      2.225,
      2.2255000000000003E+000,
      2.226,
      2.2265,
      2.227,
      2.2275,
      2.228,
      2.2285,
      2.229,
      2.2295000000000003E+000,
      2.23,
      2.2305,
      2.231,
      2.2315,
      2.232,
      2.2325,
      2.233,
      2.2335000000000003E+000,
      2.234,
      2.2345,
      2.235,
      2.2355,
      2.236,
      2.2365,
      2.237,
      2.2375000000000003E+000,
      2.238,
      2.2385,
      2.239,
      2.2395,
      2.24,
      2.2405,
      2.241,
      2.2415,
      2.242,
      2.2425,
      2.243,
      2.2435,
      2.244,
      2.2445,
      2.245,
      2.2455,
      2.246,
      2.2465,
      2.247,
      2.2475,
      2.248,
      2.2485,
      2.249,
      2.2495,
      2.25,
      2.2505,
      2.251,
      2.2515,
      2.2520000000000002E+000,
      2.2525,
      2.253,
      2.2535,
      2.254,
      2.2545,
      2.255,
      2.2555,
      2.2560000000000002E+000,
      2.2565,
      2.257,
      2.2575,
      2.258,
      2.2585,
      2.259,
      2.2595,
      2.2600000000000002E+000,
      2.2605,
      2.261,
      2.2615,
      2.262,
      2.2625,
      2.263,
      2.2635,
      2.2640000000000002E+000,
      2.2645,
      2.265,
      2.2655,
      2.266,
      2.2665,
      2.267,
      2.2675,
      2.2680000000000002E+000,
      2.2685,
      2.269,
      2.2695,
      2.27,
      2.2705,
      2.271,
      2.2715,
      2.2720000000000002E+000,
      2.2725,
      2.273,
      2.2735,
      2.274,
      2.2745,
      2.275,
      2.2755,
      2.2760000000000002E+000,
      2.2765,
      2.277,
      2.2775,
      2.278,
      2.2785,
      2.279,
      2.2795,
      2.2800000000000002E+000,
      2.2805,
      2.281,
      2.2815,
      2.282,
      2.2825,
      2.283,
      2.2835,
      2.2840000000000003E+000,
      2.2845,
      2.285,
      2.2855,
      2.286,
      2.2865,
      2.287,
      2.2875,
      2.2880000000000003E+000,
      2.2885,
      2.289,
      2.2895,
      2.29,
      2.2905,
      2.291,
      2.2915,
      2.2920000000000003E+000,
      2.2925,
      2.293,
      2.2935,
      2.294,
      2.2945,
      2.295,
      2.2955,
      2.2960000000000003E+000,
      2.2965,
      2.297,
      2.2975,
      2.298,
      2.2985,
      2.299,
      2.2995,
      2.3000000000000003E+000,
      2.3005,
      2.301,
      2.3015,
      2.302,
      2.3025,
      2.303,
      2.3035,
      2.3040000000000003E+000,
      2.3045,
      2.305,
      2.3055,
      2.306,
      2.3065,
      2.307,
      2.3075,
      2.308,
      2.3085,
      2.309,
      2.3095,
      2.31,
      2.3105,
      2.311,
      2.3115,
      2.312,
      2.3125,
      2.313,
      2.3135,
      2.314,
      2.3145000000000002E+000,
      2.315,
      2.3155,
      2.316,
      2.3165,
      2.317,
      2.3175,
      2.318,
      2.3185000000000002E+000,
      2.319,
      2.3195,
      2.32,
      2.3205,
      2.321,
      2.3215,
      2.322,
      2.3225000000000002E+000,
      2.323,
      2.3235,
      2.324,
      2.3245,
      2.325,
      2.3255,
      2.326,
      2.3265000000000002E+000,
      2.327,
      2.3275,
      2.328,
      2.3285,
      2.329,
      2.3295,
      2.33,
      2.3305000000000002E+000,
      2.331,
      2.3315,
      2.332,
      2.3325,
      2.333,
      2.3335,
      2.334,
      2.3345000000000002E+000,
      2.335,
      2.3355,
      2.336,
      2.3365,
      2.337,
      2.3375,
      2.338,
      2.3385000000000002E+000,
      2.339,
      2.3395,
      2.34,
      2.3405,
      2.341,
      2.3415,
      2.342,
      2.3425000000000002E+000,
      2.343,
      2.3435,
      2.344,
      2.3445,
      2.345,
      2.3455,
      2.346,
      2.3465000000000003E+000,
      2.347,
      2.3475,
      2.348,
      2.3485,
      2.349,
      2.3495,
      2.35,
      2.3505000000000003E+000,
      2.351,
      2.3515,
      2.352,
      2.3525,
      2.353,
      2.3535,
      2.354,
      2.3545000000000003E+000,
      2.355,
      2.3555,
      2.356,
      2.3565,
      2.357,
      2.3575,
      2.358,
      2.3585000000000003E+000,
      2.359,
      2.3595,
      2.36,
      2.3605,
      2.361,
      2.3615,
      2.362,
      2.3625000000000003E+000,
      2.363,
      2.3635,
      2.364,
      2.3645,
      2.365,
      2.3655,
      2.366,
      2.3665000000000003E+000,
      2.367,
      2.3675,
      2.368,
      2.3685,
      2.369,
      2.3695,
      2.37,
      2.3705,
      2.371,
      2.3715,
      2.372,
      2.3725,
      2.373,
      2.3735,
      2.374,
      2.3745,
      2.375,
      2.3755,
      2.376,
      2.3765,
      2.3770000000000002E+000,
      2.3775,
      2.378,
      2.3785,
      2.379,
      2.3795,
      2.38,
      2.3805,
      2.3810000000000002E+000,
      2.3815,
      2.382,
      2.3825,
      2.383,
      2.3835,
      2.384,
      2.3845,
      2.3850000000000002E+000,
      2.3855,
      2.386,
      2.3865,
      2.387,
      2.3875,
      2.388,
      2.3885,
      2.3890000000000002E+000,
      2.3895,
      2.39,
      2.3905,
      2.391,
      2.3915,
      2.392,
      2.3925,
      2.3930000000000002E+000,
      2.3935,
      2.394,
      2.3945,
      2.395,
      2.3955,
      2.396,
      2.3965,
      2.3970000000000002E+000,
      2.3975,
      2.398,
      2.3985,
      2.399,
      2.3995,
      2.4,
      2.4005,
      2.4010000000000002E+000,
      2.4015,
      2.402,
      2.4025,
      2.403,
      2.4035,
      2.404,
      2.4045,
      2.4050000000000002E+000,
      2.4055,
      2.406,
      2.4065,
      2.407,
      2.4075,
      2.408,
      2.4085,
      2.4090000000000003E+000,
      2.4095,
      2.41,
      2.4105,
      2.411,
      2.4115,
      2.412,
      2.4125,
      2.4130000000000003E+000,
      2.4135,
      2.414,
      2.4145,
      2.415,
      2.4155,
      2.416,
      2.4165,
      2.4170000000000003E+000,
      2.4175,
      2.418,
      2.4185,
      2.419,
      2.4195,
      2.42,
      2.4205,
      2.4210000000000003E+000,
      2.4215,
      2.422,
      2.4225,
      2.423,
      2.4235,
      2.424,
      2.4245,
      2.4250000000000003E+000,
      2.4255,
      2.426,
      2.4265,
      2.427,
      2.4275,
      2.428,
      2.4285,
      2.4290000000000003E+000,
      2.4295,
      2.43,
      2.4305,
      2.431,
      2.4315,
      2.432,
      2.4325,
      2.433,
      2.4335,
      2.434,
      2.4345,
      2.435,
      2.4355,
      2.436,
      2.4365,
      2.437,
      2.4375,
      2.438,
      2.4385,
      2.439,
      2.4395000000000002E+000,
      2.44,
      2.4405,
      2.441,
      2.4415,
      2.442,
      2.4425,
      2.443,
      2.4435000000000002E+000,
      2.444,
      2.4445,
      2.445,
      2.4455,
      2.446,
      2.4465,
      2.447,
      2.4475000000000002E+000,
      2.448,
      2.4485,
      2.449,
      2.4495,
      2.45,
      2.4505,
      2.451,
      2.4515000000000002E+000,
      2.452,
      2.4525,
      2.453,
      2.4535,
      2.454,
      2.4545,
      2.455,
      2.4555000000000002E+000,
      2.456,
      2.4565,
      2.457,
      2.4575,
      2.458,
      2.4585,
      2.459,
      2.4595000000000002E+000,
      2.46,
      2.4605,
      2.461,
      2.4615,
      2.462,
      2.4625,
      2.463,
      2.4635000000000002E+000,
      2.464,
      2.4645,
      2.465,
      2.4655,
      2.466,
      2.4665,
      2.467,
      2.4675000000000002E+000,
      2.468,
      2.4685,
      2.469,
      2.4695,
      2.47,
      2.4705,
      2.471,
      2.4715000000000003E+000,
      2.472,
      2.4725,
      2.473,
      2.4735,
      2.474,
      2.4745,
      2.475,
      2.4755000000000003E+000,
      2.476,
      2.4765,
      2.477,
      2.4775,
      2.478,
      2.4785,
      2.479,
      2.4795000000000003E+000,
      2.48,
      2.4805,
      2.481,
      2.4815,
      2.482,
      2.4825,
      2.483,
      2.4835000000000003E+000,
      2.484,
      2.4845,
      2.485,
      2.4855,
      2.486,
      2.4865,
      2.487,
      2.4875000000000003E+000,
      2.488,
      2.4885,
      2.489,
      2.4895,
      2.49,
      2.4905,
      2.491,
      2.4915000000000003E+000,
      2.492,
      2.4925,
      2.493,
      2.4935,
      2.494,
      2.4945,
      2.495,
      2.4955000000000003E+000,
      2.496,
      2.4965,
      2.497,
      2.4975,
      2.498,
      2.4985,
      2.499,
      2.4995,
      2.5,
      2.5005,
      2.501,
      2.5015,
      2.5020000000000002E+000,
      2.5025,
      2.503,
      2.5035,
      2.504,
      2.5045,
      2.505,
      2.5055,
      2.5060000000000002E+000,
      2.5065,
      2.507,
      2.5075,
      2.508,
      2.5085,
      2.509,
      2.5095,
      2.5100000000000002E+000,
      2.5105,
      2.511,
      2.5115,
      2.512,
      2.5125,
      2.513,
      2.5135,
      2.5140000000000002E+000,
      2.5145,
      2.515,
      2.5155,
      2.516,
      2.5165,
      2.517,
      2.5175,
      2.5180000000000002E+000,
      2.5185,
      2.519,
      2.5195,
      2.52,
      2.5205,
      2.521,
      2.5215,
      2.5220000000000002E+000,
      2.5225,
      2.523,
      2.5235,
      2.524,
      2.5245,
      2.525,
      2.5255,
      2.5260000000000002E+000,
      2.5265,
      2.527,
      2.5275,
      2.528,
      2.5285,
      2.529,
      2.5295,
      2.5300000000000002E+000,
      2.5305,
      2.531,
      2.5315,
      2.532,
      2.5325,
      2.533,
      2.5335,
      2.5340000000000003E+000,
      2.5345,
      2.535,
      2.5355,
      2.536,
      2.5365,
      2.537,
      2.5375,
      2.5380000000000003E+000,
      2.5385,
      2.539,
      2.5395,
      2.54,
      2.5405,
      2.541,
      2.5415,
      2.5420000000000003E+000,
      2.5425,
      2.543,
      2.5435,
      2.544,
      2.5445,
      2.545,
      2.5455,
      2.5460000000000003E+000,
      2.5465,
      2.547,
      2.5475,
      2.548,
      2.5485,
      2.549,
      2.5495,
      2.55,
      2.5505,
      2.5509999999999997E+000,
      2.5515,
      2.552,
      2.5524999999999998E+000,
      2.553,
      2.5534999999999997E+000,
      2.554,
      2.5545,
      2.5549999999999997E+000,
      2.5555,
      2.556,
      2.5564999999999998E+000,
      2.557,
      2.5574999999999997E+000,
      2.558,
      2.5585,
      2.5589999999999997E+000,
      2.5595,
      2.56,
      2.5604999999999998E+000,
      2.561,
      2.5614999999999997E+000,
      2.562,
      2.5625,
      2.5629999999999997E+000,
      2.5635,
      2.564,
      2.5645,
      2.565,
      2.5654999999999997E+000,
      2.566,
      2.5665,
      2.5669999999999997E+000,
      2.5675,
      2.568,
      2.5685,
      2.569,
      2.5694999999999997E+000,
      2.57,
      2.5705,
      2.5709999999999997E+000,
      2.5715,
      2.572,
      2.5725,
      2.573,
      2.5734999999999997E+000,
      2.574,
      2.5745,
      2.5749999999999997E+000,
      2.5755,
      2.576,
      2.5765,
      2.577,
      2.5774999999999997E+000,
      2.578,
      2.5785,
      2.5789999999999997E+000,
      2.5795,
      2.58,
      2.5805,
      2.581,
      2.5814999999999997E+000,
      2.582,
      2.5825,
      2.5829999999999997E+000,
      2.5835,
      2.584,
      2.5845,
      2.585,
      2.5854999999999997E+000,
      2.586,
      2.5865,
      2.5869999999999997E+000,
      2.5875,
      2.588,
      2.5885,
      2.589,
      2.5894999999999997E+000,
      2.59,
      2.5905,
      2.5909999999999997E+000,
      2.5915,
      2.592,
      2.5925,
      2.593,
      2.5934999999999997E+000,
      2.594,
      2.5945,
      2.5949999999999998E+000,
      2.5955,
      2.596,
      2.5965,
      2.597,
      2.5974999999999997E+000,
      2.598,
      2.5985,
      2.5989999999999998E+000,
      2.5995,
      2.6,
      2.6005,
      2.601,
      2.6014999999999997E+000,
      2.602,
      2.6025,
      2.6029999999999998E+000,
      2.6035,
      2.6039999999999996E+000,
      2.6045,
      2.605,
      2.6054999999999997E+000,
      2.606,
      2.6065,
      2.6069999999999998E+000,
      2.6075,
      2.6079999999999997E+000,
      2.6085,
      2.609,
      2.6094999999999997E+000,
      2.61,
      2.6105,
      2.6109999999999998E+000,
      2.6115,
      2.6119999999999997E+000,
      2.6125,
      2.613,
      2.6134999999999997E+000,
      2.614,
      2.6145,
      2.6149999999999998E+000,
      2.6155,
      2.6159999999999997E+000,
      2.6165,
      2.617,
      2.6174999999999997E+000,
      2.618,
      2.6185,
      2.6189999999999998E+000,
      2.6195,
      2.6199999999999997E+000,
      2.6205,
      2.621,
      2.6214999999999997E+000,
      2.622,
      2.6225,
      2.6229999999999998E+000,
      2.6235,
      2.6239999999999997E+000,
      2.6245,
      2.625,
      2.6254999999999997E+000,
      2.626,
      2.6265,
      2.627,
      2.6275,
      2.6279999999999997E+000,
      2.6285,
      2.629,
      2.6294999999999997E+000,
      2.63,
      2.6305,
      2.631,
      2.6315,
      2.6319999999999997E+000,
      2.6325,
      2.633,
      2.6334999999999997E+000,
      2.634,
      2.6345,
      2.635,
      2.6355,
      2.6359999999999997E+000,
      2.6365,
      2.637,
      2.6374999999999997E+000,
      2.638,
      2.6385,
      2.639,
      2.6395,
      2.6399999999999997E+000,
      2.6405,
      2.641,
      2.6414999999999997E+000,
      2.642,
      2.6425,
      2.643,
      2.6435,
      2.6439999999999997E+000,
      2.6445,
      2.645,
      2.6454999999999997E+000,
      2.646,
      2.6465,
      2.647,
      2.6475,
      2.6479999999999997E+000,
      2.6485,
      2.649,
      2.6494999999999997E+000,
      2.65,
      2.6505,
      2.651,
      2.6515,
      2.6519999999999997E+000,
      2.6525,
      2.653,
      2.6534999999999997E+000,
      2.654,
      2.6545,
      2.655,
      2.6555,
      2.6559999999999997E+000,
      2.6565,
      2.657,
      2.6574999999999998E+000,
      2.658,
      2.6585,
      2.659,
      2.6595,
      2.6599999999999997E+000,
      2.6605,
      2.661,
      2.6614999999999998E+000,
      2.662,
      2.6625,
      2.663,
      2.6635,
      2.6639999999999997E+000,
      2.6645,
      2.665,
      2.6654999999999998E+000,
      2.666,
      2.6665,
      2.667,
      2.6675,
      2.6679999999999997E+000,
      2.6685,
      2.669,
      2.6694999999999998E+000,
      2.67,
      2.6704999999999997E+000,
      2.671,
      2.6715,
      2.6719999999999997E+000,
      2.6725,
      2.673,
      2.6734999999999998E+000,
      2.674,
      2.6744999999999997E+000,
      2.675,
      2.6755,
      2.6759999999999997E+000,
      2.6765,
      2.677,
      2.6774999999999998E+000,
      2.678,
      2.6784999999999997E+000,
      2.679,
      2.6795,
      2.6799999999999997E+000,
      2.6805,
      2.681,
      2.6814999999999998E+000,
      2.682,
      2.6824999999999997E+000,
      2.683,
      2.6835,
      2.6839999999999997E+000,
      2.6845,
      2.685,
      2.6854999999999998E+000,
      2.686,
      2.6864999999999997E+000,
      2.687,
      2.6875,
      2.6879999999999997E+000,
      2.6885,
      2.689,
      2.6895,
      2.69,
      2.6904999999999997E+000,
      2.691,
      2.6915,
      2.6919999999999997E+000,
      2.6925,
      2.693,
      2.6935,
      2.694,
      2.6944999999999997E+000,
      2.695,
      2.6955,
      2.6959999999999997E+000,
      2.6965,
      2.697,
      2.6975,
      2.698,
      2.6984999999999997E+000,
      2.699,
      2.6995,
      2.6999999999999997E+000,
      2.7005,
      2.701,
      2.7015,
      2.702,
      2.7024999999999997E+000,
      2.703,
      2.7035,
      2.7039999999999997E+000,
      2.7045,
      2.705,
      2.7055,
      2.706,
      2.7064999999999997E+000,
      2.707,
      2.7075,
      2.7079999999999997E+000,
      2.7085,
      2.709,
      2.7095,
      2.71,
      2.7104999999999997E+000,
      2.711,
      2.7115,
      2.7119999999999997E+000,
      2.7125,
      2.713,
      2.7135,
      2.714,
      2.7144999999999997E+000,
      2.715,
      2.7155,
      2.7159999999999997E+000,
      2.7165,
      2.717,
      2.7175,
      2.718,
      2.7184999999999997E+000,
      2.719,
      2.7195,
      2.7199999999999998E+000,
      2.7205,
      2.721,
      2.7215,
      2.722,
      2.7224999999999997E+000,
      2.723,
      2.7235,
      2.7239999999999998E+000,
      2.7245,
      2.725,
      2.7255,
      2.726,
      2.7264999999999997E+000,
      2.727,
      2.7275,
      2.7279999999999998E+000,
      2.7285,
      2.729,
      2.7295,
      2.73,
      2.7304999999999997E+000,
      2.731,
      2.7315,
      2.7319999999999998E+000,
      2.7325,
      2.7329999999999997E+000,
      2.7335,
      2.734,
      2.7344999999999997E+000,
      2.735,
      2.7355,
      2.7359999999999998E+000,
      2.7365,
      2.7369999999999997E+000,
      2.7375,
      2.738,
      2.7384999999999997E+000,
      2.739,
      2.7395,
      2.7399999999999998E+000,
      2.7405,
      2.7409999999999997E+000,
      2.7415,
      2.742,
      2.7424999999999997E+000,
      2.743,
      2.7435,
      2.7439999999999998E+000,
      2.7445,
      2.7449999999999997E+000,
      2.7455,
      2.746,
      2.7464999999999997E+000,
      2.747,
      2.7475,
      2.7479999999999998E+000,
      2.7485,
      2.7489999999999997E+000,
      2.7495,
      2.75,
      2.7504999999999997E+000,
      2.751,
      2.7515,
      2.752,
      2.7525,
      2.7529999999999997E+000,
      2.7535,
      2.754,
      2.7544999999999997E+000,
      2.755,
      2.7555,
      2.756,
      2.7565,
      2.7569999999999997E+000,
      2.7575,
      2.758,
      2.7584999999999997E+000,
      2.759,
      2.7595,
      2.76,
      2.7605,
      2.7609999999999997E+000,
      2.7615,
      2.762,
      2.7624999999999997E+000,
      2.763,
      2.7635,
      2.764,
      2.7645,
      2.7649999999999997E+000,
      2.7655,
      2.766,
      2.7664999999999997E+000,
      2.767,
      2.7675,
      2.768,
      2.7685,
      2.7689999999999997E+000,
      2.7695,
      2.77,
      2.7704999999999997E+000,
      2.771,
      2.7715,
      2.772,
      2.7725,
      2.7729999999999997E+000,
      2.7735,
      2.774,
      2.7744999999999997E+000,
      2.775,
      2.7755,
      2.776,
      2.7765,
      2.7769999999999997E+000,
      2.7775,
      2.778,
      2.7784999999999997E+000,
      2.779,
      2.7795,
      2.78,
      2.7805,
      2.7809999999999997E+000,
      2.7815,
      2.782,
      2.7824999999999998E+000,
      2.783,
      2.7835,
      2.784,
      2.7845,
      2.7849999999999997E+000,
      2.7855,
      2.786,
      2.7864999999999998E+000,
      2.787,
      2.7875,
      2.788,
      2.7885,
      2.7889999999999997E+000,
      2.7895,
      2.79,
      2.7904999999999998E+000,
      2.791,
      2.7915,
      2.792,
      2.7925,
      2.7929999999999997E+000,
      2.7935,
      2.794,
      2.7944999999999998E+000,
      2.795,
      2.7954999999999997E+000,
      2.796,
      2.7965,
      2.7969999999999997E+000,
      2.7975,
      2.798,
      2.7984999999999998E+000,
      2.799,
      2.7994999999999997E+000,
      2.8,
      2.8005,
      2.8009999999999997E+000,
      2.8015,
      2.802,
      2.8024999999999998E+000,
      2.803,
      2.8034999999999997E+000,
      2.804,
      2.8045,
      2.8049999999999997E+000,
      2.8055,
      2.806,
      2.8064999999999998E+000,
      2.807,
      2.8074999999999997E+000,
      2.808,
      2.8085,
      2.8089999999999997E+000,
      2.8095,
      2.81,
      2.8104999999999998E+000,
      2.811,
      2.8114999999999997E+000,
      2.812,
      2.8125,
      2.8129999999999997E+000,
      2.8135,
      2.814,
      2.8145,
      2.815,
      2.8154999999999997E+000,
      2.816,
      2.8165,
      2.8169999999999997E+000,
      2.8175,
      2.818,
      2.8185,
      2.819,
      2.8194999999999997E+000,
      2.82,
      2.8205,
      2.8209999999999997E+000,
      2.8215,
      2.822,
      2.8225,
      2.823,
      2.8234999999999997E+000,
      2.824,
      2.8245,
      2.8249999999999997E+000,
      2.8255,
      2.826,
      2.8265,
      2.827,
      2.8274999999999997E+000,
      2.828,
      2.8285,
      2.8289999999999997E+000,
      2.8295,
      2.83,
      2.8305,
      2.831,
      2.8314999999999997E+000,
      2.832,
      2.8325,
      2.8329999999999997E+000,
      2.8335,
      2.834,
      2.8345,
      2.835,
      2.8354999999999997E+000,
      2.836,
      2.8365,
      2.8369999999999997E+000,
      2.8375,
      2.838,
      2.8385,
      2.839,
      2.8394999999999997E+000,
      2.84,
      2.8405,
      2.8409999999999997E+000,
      2.8415,
      2.842,
      2.8425,
      2.843,
      2.8434999999999997E+000,
      2.844,
      2.8445,
      2.8449999999999998E+000,
      2.8455,
      2.846,
      2.8465,
      2.847,
      2.8474999999999997E+000,
      2.848,
      2.8485,
      2.8489999999999998E+000,
      2.8495,
      2.85,
      2.8505,
      2.851,
      2.8514999999999997E+000,
      2.852,
      2.8525,
      2.8529999999999998E+000,
      2.8535,
      2.854,
      2.8545,
      2.855,
      2.8554999999999997E+000,
      2.856,
      2.8565,
      2.8569999999999998E+000,
      2.8575,
      2.858,
      2.8585,
      2.859,
      2.8594999999999997E+000,
      2.86,
      2.8605,
      2.8609999999999998E+000,
      2.8615,
      2.8619999999999997E+000,
      2.8625,
      2.863,
      2.8634999999999997E+000,
      2.864,
      2.8645,
      2.8649999999999998E+000,
      2.8655,
      2.8659999999999997E+000,
      2.8665,
      2.867,
      2.8674999999999997E+000,
      2.868,
      2.8685,
      2.8689999999999998E+000,
      2.8695,
      2.8699999999999997E+000,
      2.8705,
      2.871,
      2.8714999999999997E+000,
      2.872,
      2.8725,
      2.8729999999999998E+000,
      2.8735,
      2.8739999999999997E+000,
      2.8745,
      2.875,
      2.8754999999999997E+000,
      2.876,
      2.8765,
      2.877,
      2.8775,
      2.8779999999999997E+000,
      2.8785,
      2.879,
      2.8794999999999997E+000,
      2.88,
      2.8805,
      2.881,
      2.8815,
      2.8819999999999997E+000,
      2.8825,
      2.883,
      2.8834999999999997E+000,
      2.884,
      2.8845,
      2.885,
      2.8855,
      2.8859999999999997E+000,
      2.8865,
      2.887,
      2.8874999999999997E+000,
      2.888,
      2.8885,
      2.889,
      2.8895,
      2.8899999999999997E+000,
      2.8905,
      2.891,
      2.8914999999999997E+000,
      2.892,
      2.8925,
      2.893,
      2.8935,
      2.8939999999999997E+000,
      2.8945,
      2.895,
      2.8954999999999997E+000,
      2.896,
      2.8965,
      2.897,
      2.8975,
      2.8979999999999997E+000,
      2.8985,
      2.899,
      2.8994999999999997E+000,
      2.9,
      2.9005,
      2.901,
      2.9015,
      2.9019999999999997E+000,
      2.9025,
      2.903,
      2.9034999999999997E+000,
      2.904,
      2.9045,
      2.905,
      2.9055,
      2.9059999999999997E+000,
      2.9065,
      2.907,
      2.9074999999999998E+000,
      2.908,
      2.9085,
      2.909,
      2.9095,
      2.9099999999999997E+000,
      2.9105,
      2.911,
      2.9114999999999998E+000,
      2.912,
      2.9125,
      2.913,
      2.9135,
      2.9139999999999997E+000,
      2.9145,
      2.915,
      2.9154999999999998E+000,
      2.916,
      2.9165,
      2.917,
      2.9175,
      2.9179999999999997E+000,
      2.9185,
      2.919,
      2.9194999999999998E+000,
      2.92,
      2.9205,
      2.921,
      2.9215,
      2.9219999999999997E+000,
      2.9225,
      2.923,
      2.9234999999999998E+000,
      2.924,
      2.9244999999999997E+000,
      2.925,
      2.9255,
      2.9259999999999997E+000,
      2.9265,
      2.927,
      2.9274999999999998E+000,
      2.928,
      2.9284999999999997E+000,
      2.929,
      2.9295,
      2.9299999999999997E+000,
      2.9305,
      2.931,
      2.9314999999999998E+000,
      2.932,
      2.9324999999999997E+000,
      2.933,
      2.9335,
      2.9339999999999997E+000,
      2.9345,
      2.935,
      2.9354999999999998E+000,
      2.936,
      2.9364999999999997E+000,
      2.937,
      2.9375,
      2.9379999999999997E+000,
      2.9385,
      2.939,
      2.9395,
      2.94,
      2.9404999999999997E+000,
      2.941,
      2.9415,
      2.9419999999999997E+000,
      2.9425,
      2.943,
      2.9435,
      2.944,
      2.9444999999999997E+000,
      2.945,
      2.9455,
      2.9459999999999997E+000,
      2.9465,
      2.947,
      2.9475,
      2.948,
      2.9484999999999997E+000,
      2.949,
      2.9495,
      2.9499999999999997E+000,
      2.9505,
      2.951,
      2.9515,
      2.952,
      2.9524999999999997E+000,
      2.953,
      2.9535,
      2.9539999999999997E+000,
      2.9545,
      2.955,
      2.9555,
      2.956,
      2.9564999999999997E+000,
      2.957,
      2.9575,
      2.9579999999999997E+000,
      2.9585,
      2.959,
      2.9595,
      2.96,
      2.9604999999999997E+000,
      2.961,
      2.9615,
      2.9619999999999997E+000,
      2.9625,
      2.963,
      2.9635,
      2.964,
      2.9644999999999997E+000,
      2.965,
      2.9655,
      2.9659999999999997E+000,
      2.9665,
      2.967,
      2.9675,
      2.968,
      2.9684999999999997E+000,
      2.969,
      2.9695,
      2.9699999999999998E+000,
      2.9705,
      2.971,
      2.9715,
      2.972,
      2.9724999999999997E+000,
      2.973,
      2.9735,
      2.9739999999999998E+000,
      2.9745,
      2.975,
      2.9755,
      2.976,
      2.9764999999999997E+000,
      2.977,
      2.9775,
      2.9779999999999998E+000,
      2.9785,
      2.979,
      2.9795,
      2.98,
      2.9804999999999997E+000,
      2.981,
      2.9815,
      2.9819999999999998E+000,
      2.9825,
      2.983,
      2.9835,
      2.984,
      2.9844999999999997E+000,
      2.985,
      2.9855,
      2.9859999999999998E+000,
      2.9865,
      2.987,
      2.9875,
      2.988,
      2.9884999999999997E+000,
      2.989,
      2.9895,
      2.9899999999999998E+000,
      2.9905,
      2.9909999999999997E+000,
      2.9915,
      2.992,
      2.9924999999999997E+000,
      2.993,
      2.9935,
      2.9939999999999998E+000,
      2.9945,
      2.9949999999999997E+000,
      2.9955,
      2.996,
      2.9964999999999997E+000,
      2.997,
      2.9975,
      2.9979999999999998E+000,
      2.9985,
      2.9989999999999997E+000,
      2.9995,
      3.0,
      3.0004999999999997E+000,
      3.001,
      3.0015,
      3.002,
      3.0025,
      3.0029999999999997E+000,
      3.0035,
      3.004,
      3.0044999999999997E+000,
      3.005,
      3.0055,
      3.006,
      3.0065,
      3.0069999999999997E+000,
      3.0075,
      3.008,
      3.0084999999999997E+000,
      3.009,
      3.0095,
      3.01,
      3.0105,
      3.0109999999999997E+000,
      3.0115,
      3.012,
      3.0124999999999997E+000,
      3.013,
      3.0135,
      3.014,
      3.0145,
      3.0149999999999997E+000,
      3.0155,
      3.016,
      3.0164999999999997E+000,
      3.017,
      3.0175,
      3.018,
      3.0185,
      3.0189999999999997E+000,
      3.0195,
      3.02,
      3.0204999999999997E+000,
      3.021,
      3.0215,
      3.022,
      3.0225,
      3.0229999999999997E+000,
      3.0235,
      3.024,
      3.0244999999999997E+000,
      3.025,
      3.0255,
      3.026,
      3.0265,
      3.0269999999999997E+000,
      3.0275,
      3.028,
      3.0284999999999997E+000,
      3.029,
      3.0295,
      3.03,
      3.0305,
      3.0309999999999997E+000,
      3.0315,
      3.032,
      3.0324999999999998E+000,
      3.033,
      3.0335,
      3.034,
      3.0345,
      3.0349999999999997E+000,
      3.0355,
      3.036,
      3.0364999999999998E+000,
      3.037,
      3.0375,
      3.038,
      3.0385,
      3.0389999999999997E+000,
      3.0395,
      3.04,
      3.0404999999999998E+000,
      3.041,
      3.0415,
      3.042,
      3.0425,
      3.0429999999999997E+000,
      3.0435,
      3.044,
      3.0444999999999998E+000,
      3.045,
      3.0455,
      3.046,
      3.0465,
      3.0469999999999997E+000,
      3.0475,
      3.048,
      3.0484999999999998E+000,
      3.049,
      3.0495,
      3.05,
      3.0505,
      3.0509999999999997E+000,
      3.0515,
      3.052,
      3.0524999999999998E+000,
      3.053,
      3.0534999999999997E+000,
      3.054,
      3.0545,
      3.0549999999999997E+000,
      3.0555,
      3.056,
      3.0564999999999998E+000,
      3.057,
      3.0574999999999997E+000,
      3.058,
      3.0585,
      3.0589999999999997E+000,
      3.0595,
      3.06,
      3.0604999999999998E+000,
      3.061,
      3.0614999999999997E+000,
      3.062,
      3.0625,
      3.0629999999999997E+000,
      3.0635,
      3.064,
      3.0645,
      3.065,
      3.0654999999999997E+000,
      3.066,
      3.0665,
      3.0669999999999997E+000,
      3.0675,
      3.068,
      3.0685,
      3.069,
      3.0694999999999997E+000,
      3.07,
      3.0705,
      3.0709999999999997E+000,
      3.0715,
      3.072,
      3.0725,
      3.073,
      3.0734999999999997E+000,
      3.074,
      3.0745,
      3.0749999999999997E+000,
      3.0755,
      3.076,
      3.0765,
      3.077,
      3.0774999999999997E+000,
      3.078,
      3.0785,
      3.0789999999999997E+000,
      3.0795,
      3.08,
      3.0805,
      3.081,
      3.0814999999999997E+000,
      3.082,
      3.0825,
      3.0829999999999997E+000,
      3.0835,
      3.084,
      3.0845,
      3.085,
      3.0854999999999997E+000,
      3.086,
      3.0865,
      3.0869999999999997E+000,
      3.0875,
      3.088,
      3.0885,
      3.089,
      3.0894999999999997E+000,
      3.09,
      3.0905,
      3.0909999999999997E+000,
      3.0915,
      3.092,
      3.0925,
      3.093,
      3.0934999999999997E+000,
      3.094,
      3.0945,
      3.0949999999999998E+000,
      3.0955,
      3.096,
      3.0965,
      3.097,
      3.0974999999999997E+000,
      3.098,
      3.0985,
      3.0989999999999998E+000,
      3.0995,
      3.0999999999999996E+000,
      3.1005,
      3.101,
      3.1014999999999997E+000,
      3.102,
      3.1025,
      3.1029999999999998E+000,
      3.1035,
      3.104,
      3.1045,
      3.105,
      3.1055,
      3.106,
      3.1064999999999996E+000,
      3.107,
      3.1075,
      3.1079999999999997E+000,
      3.1085,
      3.109,
      3.1094999999999997E+000,
      3.11,
      3.1105,
      3.1109999999999998E+000,
      3.1115,
      3.112,
      3.1125,
      3.113,
      3.1135,
      3.114,
      3.1144999999999996E+000,
      3.115,
      3.1155,
      3.1159999999999997E+000,
      3.1165,
      3.117,
      3.1174999999999997E+000,
      3.118,
      3.1185,
      3.1189999999999998E+000,
      3.1195,
      3.12,
      3.1205,
      3.1209999999999996E+000,
      3.1215,
      3.122,
      3.1224999999999996E+000,
      3.1229999999999998E+000,
      3.1235,
      3.1239999999999997E+000,
      3.1245,
      3.125,
      3.1254999999999997E+000,
      3.126,
      3.1265,
      3.127,
      3.1275,
      3.128,
      3.1285,
      3.1289999999999996E+000,
      3.1295,
      3.13,
      3.1304999999999996E+000,
      3.131,
      3.1315,
      3.1319999999999997E+000,
      3.1325,
      3.133,
      3.1334999999999997E+000,
      3.134,
      3.1345,
      3.135,
      3.1355,
      3.136,
      3.1365,
      3.1369999999999996E+000,
      3.1375,
      3.138,
      3.1384999999999996E+000,
      3.139,
      3.1395,
      3.1399999999999997E+000,
      3.1405,
      3.141,
      3.1414999999999997E+000,
      3.142,
      3.1425,
      3.143,
      3.1435,
      3.144,
      3.1445,
      3.1449999999999996E+000,
      3.1455,
      3.146,
      3.1464999999999996E+000,
      3.147,
      3.1475,
      3.1479999999999997E+000,
      3.1485,
      3.149,
      3.1494999999999997E+000,
      3.15,
      3.1505,
      3.151,
      3.1515,
      3.152,
      3.1525,
      3.1529999999999996E+000,
      3.1535,
      3.154,
      3.1544999999999996E+000,
      3.155,
      3.1555,
      3.1559999999999997E+000,
      3.1565,
      3.157,
      3.1574999999999998E+000,
      3.158,
      3.1585,
      3.159,
      3.1595,
      3.16,
      3.1605,
      3.1609999999999996E+000,
      3.1615,
      3.162,
      3.1624999999999996E+000,
      3.163,
      3.1635,
      3.1639999999999997E+000,
      3.1645,
      3.165,
      3.1654999999999998E+000,
      3.166,
      3.1665,
      3.167,
      3.1675,
      3.168,
      3.1685,
      3.1689999999999996E+000,
      3.1695,
      3.17,
      3.1704999999999997E+000,
      3.171,
      3.1715,
      3.1719999999999997E+000,
      3.1725,
      3.173,
      3.1734999999999998E+000,
      3.174,
      3.1745,
      3.175,
      3.1755,
      3.176,
      3.1765,
      3.1769999999999996E+000,
      3.1775,
      3.178,
      3.1784999999999997E+000,
      3.179,
      3.1795,
      3.1799999999999997E+000,
      3.1805,
      3.181,
      3.1814999999999998E+000,
      3.182,
      3.1825,
      3.183,
      3.1834999999999996E+000,
      3.184,
      3.1845,
      3.1849999999999996E+000,
      3.1854999999999998E+000,
      3.186,
      3.1864999999999997E+000,
      3.187,
      3.1875,
      3.1879999999999997E+000,
      3.1885,
      3.189,
      3.1895,
      3.19,
      3.1905,
      3.191,
      3.1914999999999996E+000,
      3.192,
      3.1925,
      3.1929999999999996E+000,
      3.1935,
      3.194,
      3.1944999999999997E+000,
      3.195,
      3.1955,
      3.1959999999999997E+000,
      3.1965,
      3.197,
      3.1975,
      3.198,
      3.1985,
      3.199,
      3.1994999999999996E+000,
      3.2,
      3.2005,
      3.2009999999999996E+000,
      3.2015,
      3.202,
      3.2024999999999997E+000,
      3.203,
      3.2035,
      3.2039999999999997E+000,
      3.2045,
      3.205,
      3.2055,
      3.206,
      3.2065,
      3.207,
      3.2074999999999996E+000,
      3.208,
      3.2085,
      3.2089999999999996E+000,
      3.2095,
      3.21,
      3.2104999999999997E+000,
      3.211,
      3.2115,
      3.2119999999999997E+000,
      3.2125,
      3.213,
      3.2135,
      3.214,
      3.2145,
      3.215,
      3.2154999999999996E+000,
      3.216,
      3.2165,
      3.2169999999999996E+000,
      3.2175,
      3.218,
      3.2184999999999997E+000,
      3.219,
      3.2195,
      3.2199999999999998E+000,
      3.2205,
      3.221,
      3.2215,
      3.222,
      3.2225,
      3.223,
      3.2234999999999996E+000,
      3.224,
      3.2245,
      3.2249999999999996E+000,
      3.2255,
      3.226,
      3.2264999999999997E+000,
      3.227,
      3.2275,
      3.2279999999999998E+000,
      3.2285,
      3.229,
      3.2295,
      3.23,
      3.2305,
      3.231,
      3.2314999999999996E+000,
      3.232,
      3.2325,
      3.2329999999999997E+000,
      3.2335,
      3.234,
      3.2344999999999997E+000,
      3.235,
      3.2355,
      3.2359999999999998E+000,
      3.2365,
      3.237,
      3.2375,
      3.238,
      3.2385,
      3.239,
      3.2394999999999996E+000,
      3.24,
      3.2405,
      3.2409999999999997E+000,
      3.2415,
      3.242,
      3.2424999999999997E+000,
      3.243,
      3.2435,
      3.2439999999999998E+000,
      3.2445,
      3.245,
      3.2455,
      3.2459999999999996E+000,
      3.2465,
      3.247,
      3.2474999999999996E+000,
      3.2479999999999998E+000,
      3.2485,
      3.2489999999999997E+000,
      3.2495,
      3.25,
      3.2504999999999997E+000,
      3.251,
      3.2515,
      3.252,
      3.2525,
      3.253,
      3.2535,
      3.2539999999999996E+000,
      3.2545,
      3.255,
      3.2554999999999996E+000,
      3.256,
      3.2565,
      3.2569999999999997E+000,
      3.2575,
      3.258,
      3.2584999999999997E+000,
      3.259,
      3.2595,
      3.26,
      3.2605,
      3.261,
      3.2615,
      3.2619999999999996E+000,
      3.2625,
      3.263,
      3.2634999999999996E+000,
      3.264,
      3.2645,
      3.2649999999999997E+000,
      3.2655,
      3.266,
      3.2664999999999997E+000,
      3.267,
      3.2675,
      3.268,
      3.2685,
      3.269,
      3.2695,
      3.2699999999999996E+000,
      3.2705,
      3.271,
      3.2714999999999996E+000,
      3.272,
      3.2725,
      3.2729999999999997E+000,
      3.2735,
      3.274,
      3.2744999999999997E+000,
      3.275,
      3.2755,
      3.276,
      3.2765,
      3.277,
      3.2775,
      3.2779999999999996E+000,
      3.2785,
      3.279,
      3.2794999999999996E+000,
      3.28,
      3.2805,
      3.2809999999999997E+000,
      3.2815,
      3.282,
      3.2824999999999998E+000,
      3.283,
      3.2835,
      3.284,
      3.2845,
      3.285,
      3.2855,
      3.2859999999999996E+000,
      3.2865,
      3.287,
      3.2874999999999996E+000,
      3.288,
      3.2885,
      3.2889999999999997E+000,
      3.2895,
      3.29,
      3.2904999999999998E+000,
      3.291,
      3.2915,
      3.292,
      3.2925,
      3.293,
      3.2935,
      3.2939999999999996E+000,
      3.2945,
      3.295,
      3.2954999999999997E+000,
      3.296,
      3.2965,
      3.2969999999999997E+000,
      3.2975,
      3.298,
      3.2984999999999998E+000,
      3.299,
      3.2995,
      3.3,
      3.3005,
      3.301,
      3.3015,
      3.3019999999999996E+000,
      3.3025,
      3.303,
      3.3034999999999997E+000,
      3.304,
      3.3045,
      3.3049999999999997E+000,
      3.3055,
      3.306,
      3.3064999999999998E+000,
      3.307,
      3.3075,
      3.308,
      3.3084999999999996E+000,
      3.309,
      3.3095,
      3.3099999999999996E+000,
      3.3104999999999998E+000,
      3.311,
      3.3114999999999997E+000,
      3.312,
      3.3125,
      3.3129999999999997E+000,
      3.3135,
      3.314,
      3.3145,
      3.315,
      3.3155,
      3.316,
      3.3164999999999996E+000,
      3.317,
      3.3175,
      3.3179999999999996E+000,
      3.3185,
      3.319,
      3.3194999999999997E+000,
      3.32,
      3.3205,
      3.3209999999999997E+000,
      3.3215,
      3.322,
      3.3225,
      3.323,
      3.3235,
      3.324,
      3.3244999999999996E+000,
      3.325,
      3.3255,
      3.3259999999999996E+000,
      3.3265,
      3.327,
      3.3274999999999997E+000,
      3.328,
      3.3285,
      3.3289999999999997E+000,
      3.3295,
      3.33,
      3.3305,
      3.331,
      3.3315,
      3.332,
      3.3324999999999996E+000,
      3.333,
      3.3335,
      3.3339999999999996E+000,
      3.3345,
      3.335,
      3.3354999999999997E+000,
      3.336,
      3.3365,
      3.3369999999999997E+000,
      3.3375,
      3.338,
      3.3385,
      3.339,
      3.3395,
      3.34,
      3.3404999999999996E+000,
      3.341,
      3.3415,
      3.3419999999999996E+000,
      3.3425,
      3.343,
      3.3434999999999997E+000,
      3.344,
      3.3445,
      3.3449999999999998E+000,
      3.3455,
      3.346,
      3.3465,
      3.347,
      3.3475,
      3.348,
      3.3484999999999996E+000,
      3.349,
      3.3495,
      3.3499999999999996E+000,
      3.3505,
      3.351,
      3.3514999999999997E+000,
      3.352,
      3.3525,
      3.3529999999999998E+000,
      3.3535,
      3.354,
      3.3545,
      3.355,
      3.3555,
      3.356,
      3.3564999999999996E+000,
      3.357,
      3.3575,
      3.3579999999999997E+000,
      3.3585,
      3.359,
      3.3594999999999997E+000,
      3.36,
      3.3605,
      3.3609999999999998E+000,
      3.3615,
      3.362,
      3.3625,
      3.363,
      3.3635,
      3.364,
      3.3644999999999996E+000,
      3.365,
      3.3655,
      3.3659999999999997E+000,
      3.3665,
      3.367,
      3.3674999999999997E+000,
      3.368,
      3.3685,
      3.3689999999999998E+000,
      3.3695,
      3.37,
      3.3705,
      3.371,
      3.3715,
      3.372,
      3.3724999999999996E+000,
      3.3729999999999998E+000,
      3.3735,
      3.3739999999999997E+000,
      3.3745,
      3.375,
      3.3754999999999997E+000,
      3.376,
      3.3765,
      3.377,
      3.3775,
      3.378,
      3.3785,
      3.3789999999999996E+000,
      3.3795,
      3.38,
      3.3804999999999996E+000,
      3.381,
      3.3815,
      3.3819999999999997E+000,
      3.3825,
      3.383,
      3.3834999999999997E+000,
      3.384,
      3.3845,
      3.385,
      3.3855,
      3.386,
      3.3865,
      3.3869999999999996E+000,
      3.3875,
      3.388,
      3.3884999999999996E+000,
      3.389,
      3.3895,
      3.3899999999999997E+000,
      3.3905,
      3.391,
      3.3914999999999997E+000,
      3.392,
      3.3925,
      3.393,
      3.3935,
      3.394,
      3.3945,
      3.3949999999999996E+000,
      3.3955,
      3.396,
      3.3964999999999996E+000,
      3.397,
      3.3975,
      3.3979999999999997E+000,
      3.3985,
      3.399,
      3.3994999999999997E+000,
      3.4,
      3.4005,
      3.401,
      3.4015,
      3.402,
      3.4025,
      3.4029999999999996E+000,
      3.4035,
      3.404,
      3.4044999999999996E+000,
      3.405,
      3.4055,
      3.4059999999999997E+000,
      3.4065,
      3.407,
      3.4074999999999998E+000,
      3.408,
      3.4085,
      3.409,
      3.4095,
      3.41,
      3.4105,
      3.4109999999999996E+000,
      3.4115,
      3.412,
      3.4124999999999996E+000,
      3.413,
      3.4135,
      3.4139999999999997E+000,
      3.4145,
      3.415,
      3.4154999999999998E+000,
      3.416,
      3.4165,
      3.417,
      3.4175,
      3.418,
      3.4185,
      3.4189999999999996E+000,
      3.4195,
      3.42,
      3.4204999999999997E+000,
      3.421,
      3.4215,
      3.4219999999999997E+000,
      3.4225,
      3.423,
      3.4234999999999998E+000,
      3.424,
      3.4245,
      3.425,
      3.4255,
      3.426,
      3.4265,
      3.4269999999999996E+000,
      3.4275,
      3.428,
      3.4284999999999997E+000,
      3.429,
      3.4295,
      3.4299999999999997E+000,
      3.4305,
      3.431,
      3.4314999999999998E+000,
      3.432,
      3.4325,
      3.433,
      3.4335,
      3.434,
      3.4345,
      3.4349999999999996E+000,
      3.4354999999999998E+000,
      3.436,
      3.4364999999999997E+000,
      3.437,
      3.4375,
      3.4379999999999997E+000,
      3.4385,
      3.439,
      3.4395,
      3.44,
      3.4405,
      3.441,
      3.4414999999999996E+000,
      3.442,
      3.4425,
      3.4429999999999996E+000,
      3.4435,
      3.444,
      3.4444999999999997E+000,
      3.445,
      3.4455,
      3.4459999999999997E+000,
      3.4465,
      3.447,
      3.4475,
      3.448,
      3.4485,
      3.449,
      3.4494999999999996E+000,
      3.45,
      3.4505,
      3.4509999999999996E+000,
      3.4515,
      3.452,
      3.4524999999999997E+000,
      3.453,
      3.4535,
      3.4539999999999997E+000,
      3.4545,
      3.455,
      3.4555,
      3.456,
      3.4565,
      3.457,
      3.4574999999999996E+000,
      3.458,
      3.4585,
      3.4589999999999996E+000,
      3.4595,
      3.46,
      3.4604999999999997E+000,
      3.461,
      3.4615,
      3.4619999999999997E+000,
      3.4625,
      3.463,
      3.4635,
      3.464,
      3.4645,
      3.465,
      3.4654999999999996E+000,
      3.466,
      3.4665,
      3.4669999999999996E+000,
      3.4675,
      3.468,
      3.4684999999999997E+000,
      3.469,
      3.4695,
      3.4699999999999998E+000,
      3.4705,
      3.471,
      3.4715,
      3.472,
      3.4725,
      3.473,
      3.4734999999999996E+000,
      3.474,
      3.4745,
      3.4749999999999996E+000,
      3.4755,
      3.476,
      3.4764999999999997E+000,
      3.477,
      3.4775,
      3.4779999999999998E+000,
      3.4785,
      3.479,
      3.4795,
      3.48,
      3.4805,
      3.481,
      3.4814999999999996E+000,
      3.482,
      3.4825,
      3.4829999999999997E+000,
      3.4835,
      3.484,
      3.4844999999999997E+000,
      3.485,
      3.4855,
      3.4859999999999998E+000,
      3.4865,
      3.487,
      3.4875,
      3.488,
      3.4885,
      3.489,
      3.4894999999999996E+000,
      3.49,
      3.4905,
      3.4909999999999997E+000,
      3.4915,
      3.492,
      3.4924999999999997E+000,
      3.493,
      3.4935,
      3.4939999999999998E+000,
      3.4945,
      3.495,
      3.4955,
      3.496,
      3.4965,
      3.497,
      3.4974999999999996E+000,
      3.498,
      3.4985,
      3.4989999999999997E+000,
      3.4995,
      3.5,
      3.5004999999999997E+000,
      3.501,
      3.5015,
      3.502,
      3.5025,
      3.503,
      3.5035,
      3.5039999999999996E+000,
      3.5045,
      3.505,
      3.5054999999999996E+000,
      3.506,
      3.5065,
      3.5069999999999997E+000,
      3.5075,
      3.508,
      3.5084999999999997E+000,
      3.509,
      3.5095,
      3.51,
      3.5105,
      3.511,
      3.5115,
      3.5119999999999996E+000,
      3.5125,
      3.513,
      3.5134999999999996E+000,
      3.514,
      3.5145,
      3.5149999999999997E+000,
      3.5155,
      3.516,
      3.5164999999999997E+000,
      3.517,
      3.5175,
      3.518,
      3.5185,
      3.519,
      3.5195,
      3.5199999999999996E+000,
      3.5205,
      3.521,
      3.5214999999999996E+000,
      3.522,
      3.5225,
      3.5229999999999997E+000,
      3.5235,
      3.524,
      3.5244999999999997E+000,
      3.525,
      3.5255,
      3.526,
      3.5265,
      3.527,
      3.5275,
      3.5279999999999996E+000,
      3.5285,
      3.529,
      3.5294999999999996E+000,
      3.53,
      3.5305,
      3.5309999999999997E+000,
      3.5315,
      3.532,
      3.5324999999999998E+000,
      3.533,
      3.5335,
      3.534,
      3.5345,
      3.535,
      3.5355,
      3.5359999999999996E+000,
      3.5365,
      3.537,
      3.5374999999999996E+000,
      3.538,
      3.5385,
      3.5389999999999997E+000,
      3.5395,
      3.54,
      3.5404999999999998E+000,
      3.541,
      3.5415,
      3.542,
      3.5425,
      3.543,
      3.5435,
      3.5439999999999996E+000,
      3.5445,
      3.545,
      3.5454999999999997E+000,
      3.546,
      3.5465,
      3.5469999999999997E+000,
      3.5475,
      3.548,
      3.5484999999999998E+000,
      3.549,
      3.5495,
      3.55,
      3.5505,
      3.551,
      3.5515,
      3.5519999999999996E+000,
      3.5525,
      3.553,
      3.5534999999999997E+000,
      3.554,
      3.5545,
      3.5549999999999997E+000,
      3.5555,
      3.556,
      3.5564999999999998E+000,
      3.557,
      3.5575,
      3.558,
      3.5585,
      3.559,
      3.5595,
      3.5599999999999996E+000,
      3.5605,
      3.561,
      3.5614999999999997E+000,
      3.562,
      3.5625,
      3.5629999999999997E+000,
      3.5635,
      3.564,
      3.5645,
      3.565,
      3.5655,
      3.566,
      3.5664999999999996E+000,
      3.567,
      3.5675,
      3.5679999999999996E+000,
      3.5685,
      3.569,
      3.5694999999999997E+000,
      3.57,
      3.5705,
      3.5709999999999997E+000,
      3.5715,
      3.572,
      3.5725,
      3.573,
      3.5735,
      3.574,
      3.5744999999999996E+000,
      3.575,
      3.5755,
      3.5759999999999996E+000,
      3.5765,
      3.577,
      3.5774999999999997E+000,
      3.578,
      3.5785,
      3.5789999999999997E+000,
      3.5795,
      3.58,
      3.5805,
      3.581,
      3.5815,
      3.582,
      3.5824999999999996E+000,
      3.583,
      3.5835,
      3.5839999999999996E+000,
      3.5845,
      3.585,
      3.5854999999999997E+000,
      3.586,
      3.5865,
      3.5869999999999997E+000,
      3.5875,
      3.588,
      3.5885,
      3.589,
      3.5895,
      3.59,
      3.5904999999999996E+000,
      3.591,
      3.5915,
      3.5919999999999996E+000,
      3.5925,
      3.593,
      3.5934999999999997E+000,
      3.594,
      3.5945,
      3.5949999999999998E+000,
      3.5955,
      3.596,
      3.5965,
      3.597,
      3.5975,
      3.598,
      3.5984999999999996E+000,
      3.599,
      3.5995,
      3.5999999999999996E+000,
      3.6005,
      3.601,
      3.6014999999999997E+000,
      3.602,
      3.6025,
      3.6029999999999998E+000,
      3.6035,
      3.604,
      3.6045,
      3.605,
      3.6055,
      3.606,
      3.6064999999999996E+000,
      3.607,
      3.6075,
      3.6079999999999997E+000,
      3.6085,
      3.609,
      3.6094999999999997E+000,
      3.61,
      3.6105,
      3.6109999999999998E+000,
      3.6115,
      3.612,
      3.6125,
      3.613,
      3.6135,
      3.614,
      3.6144999999999996E+000,
      3.615,
      3.6155,
      3.6159999999999997E+000,
      3.6165,
      3.617,
      3.6174999999999997E+000,
      3.618,
      3.6185,
      3.6189999999999998E+000,
      3.6195,
      3.62,
      3.6205,
      3.621,
      3.6215,
      3.622,
      3.6224999999999996E+000,
      3.623,
      3.6235,
      3.6239999999999997E+000,
      3.6245,
      3.625,
      3.6254999999999997E+000,
      3.626,
      3.6265,
      3.627,
      3.6275,
      3.628,
      3.6285,
      3.6289999999999996E+000,
      3.6295,
      3.63,
      3.6304999999999996E+000,
      3.631,
      3.6315,
      3.6319999999999997E+000,
      3.6325,
      3.633,
      3.6334999999999997E+000,
      3.634,
      3.6345,
      3.635,
      3.6355,
      3.636,
      3.6365,
      3.6369999999999996E+000,
      3.6375,
      3.638,
      3.6384999999999996E+000,
      3.639,
      3.6395,
      3.6399999999999997E+000,
      3.6405,
      3.641,
      3.6414999999999997E+000,
      3.642,
      3.6425,
      3.643,
      3.6435,
      3.644,
      3.6445,
      3.6449999999999996E+000,
      3.6455,
      3.646,
      3.6464999999999996E+000,
      3.647,
      3.6475,
      3.6479999999999997E+000,
      3.6485,
      3.649,
      3.6494999999999997E+000,
      3.65,
      3.6505,
      3.651,
      3.6515,
      3.652,
      3.6525,
      3.6529999999999996E+000,
      3.6535,
      3.654,
      3.6544999999999996E+000,
      3.655,
      3.6555,
      3.6559999999999997E+000,
      3.6565,
      3.657,
      3.6574999999999998E+000,
      3.658,
      3.6585,
      3.659,
      3.6595,
      3.66,
      3.6605,
      3.6609999999999996E+000,
      3.6615,
      3.662,
      3.6624999999999996E+000,
      3.663,
      3.6635,
      3.6639999999999997E+000,
      3.6645,
      3.665,
      3.6654999999999998E+000,
      3.666,
      3.6665,
      3.667,
      3.6675,
      3.668,
      3.6685,
      3.6689999999999996E+000,
      3.6695,
      3.67,
      3.6704999999999997E+000,
      3.671,
      3.6715,
      3.6719999999999997E+000,
      3.6725,
      3.673,
      3.6734999999999998E+000,
      3.674,
      3.6745,
      3.675,
      3.6755,
      3.676,
      3.6765,
      3.6769999999999996E+000,
      3.6775,
      3.678,
      3.6784999999999997E+000,
      3.679,
      3.6795,
      3.6799999999999997E+000,
      3.6805,
      3.681,
      3.6814999999999998E+000,
      3.682,
      3.6825,
      3.683,
      3.6835,
      3.684,
      3.6845,
      3.6849999999999996E+000,
      3.6855,
      3.686,
      3.6864999999999997E+000,
      3.687,
      3.6875,
      3.6879999999999997E+000,
      3.6885,
      3.689,
      3.6895,
      3.69,
      3.6905,
      3.691,
      3.6915,
      3.692,
      3.6925,
      3.6929999999999996E+000,
      3.6935,
      3.694,
      3.6944999999999997E+000,
      3.695,
      3.6955,
      3.6959999999999997E+000,
      3.6965,
      3.697,
      3.6975,
      3.698,
      3.6985,
      3.699,
      3.6994999999999996E+000,
      3.7,
      3.7005,
      3.7009999999999996E+000,
      3.7015,
      3.702,
      3.7024999999999997E+000,
      3.703,
      3.7035,
      3.7039999999999997E+000,
      3.7045,
      3.705,
      3.7055,
      3.706,
      3.7065,
      3.707,
      3.7074999999999996E+000,
      3.708,
      3.7085,
      3.7089999999999996E+000,
      3.7095,
      3.71,
      3.7104999999999997E+000,
      3.711,
      3.7115,
      3.7119999999999997E+000,
      3.7125,
      3.713,
      3.7135,
      3.714,
      3.7145,
      3.715,
      3.7154999999999996E+000,
      3.716,
      3.7165,
      3.7169999999999996E+000,
      3.7175,
      3.718,
      3.7184999999999997E+000,
      3.719,
      3.7195,
      3.7199999999999998E+000,
      3.7205,
      3.721,
      3.7215,
      3.722,
      3.7225,
      3.723,
      3.7234999999999996E+000,
      3.724,
      3.7245,
      3.7249999999999996E+000,
      3.7255,
      3.726,
      3.7264999999999997E+000,
      3.727,
      3.7275,
      3.7279999999999998E+000,
      3.7285,
      3.729,
      3.7295,
      3.73,
      3.7305,
      3.731,
      3.7314999999999996E+000,
      3.732,
      3.7325,
      3.7329999999999997E+000,
      3.7335,
      3.734,
      3.7344999999999997E+000,
      3.735,
      3.7355,
      3.7359999999999998E+000,
      3.7365,
      3.737,
      3.7375,
      3.738,
      3.7385,
      3.739,
      3.7394999999999996E+000,
      3.74,
      3.7405,
      3.7409999999999997E+000,
      3.7415,
      3.742,
      3.7424999999999997E+000,
      3.743,
      3.7435,
      3.7439999999999998E+000,
      3.7445,
      3.745,
      3.7455,
      3.746,
      3.7465,
      3.747,
      3.7474999999999996E+000,
      3.748,
      3.7485,
      3.7489999999999997E+000,
      3.7495,
      3.75,
      3.7504999999999997E+000,
      3.751,
      3.7515,
      3.752,
      3.7525,
      3.753,
      3.7535,
      3.754,
      3.7545,
      3.755,
      3.7554999999999996E+000,
      3.756,
      3.7565,
      3.7569999999999997E+000,
      3.7575,
      3.758,
      3.7584999999999997E+000,
      3.759,
      3.7595,
      3.76,
      3.7605,
      3.761,
      3.7615,
      3.7619999999999996E+000,
      3.7625,
      3.763,
      3.7634999999999996E+000,
      3.764,
      3.7645,
      3.7649999999999997E+000,
      3.7655,
      3.766,
      3.7664999999999997E+000,
      3.767,
      3.7675,
      3.768,
      3.7685,
      3.769,
      3.7695,
      3.7699999999999996E+000,
      3.7705,
      3.771,
      3.7714999999999996E+000,
      3.772,
      3.7725,
      3.7729999999999997E+000,
      3.7735,
      3.774,
      3.7744999999999997E+000,
      3.775,
      3.7755,
      3.776,
      3.7765,
      3.777,
      3.7775,
      3.7779999999999996E+000,
      3.7785,
      3.779,
      3.7794999999999996E+000,
      3.78,
      3.7805,
      3.7809999999999997E+000,
      3.7815,
      3.782,
      3.7824999999999998E+000,
      3.783,
      3.7835,
      3.784,
      3.7845,
      3.785,
      3.7855,
      3.7859999999999996E+000,
      3.7865,
      3.787,
      3.7874999999999996E+000,
      3.788,
      3.7885,
      3.7889999999999997E+000,
      3.7895,
      3.79,
      3.7904999999999998E+000,
      3.791,
      3.7915,
      3.792,
      3.7925,
      3.793,
      3.7935,
      3.7939999999999996E+000,
      3.7945,
      3.795,
      3.7954999999999997E+000,
      3.796,
      3.7965,
      3.7969999999999997E+000,
      3.7975,
      3.798,
      3.7984999999999998E+000,
      3.799,
      3.7995,
      3.8,
      3.8005,
      3.801,
      3.8015,
      3.8019999999999996E+000,
      3.8025,
      3.803,
      3.8034999999999997E+000,
      3.804,
      3.8045,
      3.8049999999999997E+000,
      3.8055,
      3.806,
      3.8064999999999998E+000,
      3.807,
      3.8075,
      3.808,
      3.8085,
      3.809,
      3.8095,
      3.8099999999999996E+000,
      3.8105,
      3.811,
      3.8114999999999997E+000,
      3.812,
      3.8125,
      3.8129999999999997E+000,
      3.8135,
      3.814,
      3.8145,
      3.815,
      3.8155,
      3.816,
      3.8165,
      3.817,
      3.8175,
      3.8179999999999996E+000,
      3.8185000000000002E+000,
      3.819,
      3.8194999999999997E+000,
      3.82,
      3.8205,
      3.8209999999999997E+000,
      3.8215,
      3.822,
      3.8225,
      3.823,
      3.8235,
      3.824,
      3.8244999999999996E+000,
      3.825,
      3.8255,
      3.8259999999999996E+000,
      3.8265,
      3.827,
      3.8274999999999997E+000,
      3.828,
      3.8285,
      3.8289999999999997E+000,
      3.8295,
      3.83,
      3.8305,
      3.831,
      3.8315,
      3.832,
      3.8324999999999996E+000,
      3.833,
      3.8335,
      3.8339999999999996E+000,
      3.8345,
      3.835,
      3.8354999999999997E+000,
      3.836,
      3.8365,
      3.8369999999999997E+000,
      3.8375,
      3.838,
      3.8385,
      3.839,
      3.8395,
      3.84,
      3.8404999999999996E+000,
      3.841,
      3.8415,
      3.8419999999999996E+000,
      3.8425,
      3.843,
      3.8434999999999997E+000,
      3.844,
      3.8445,
      3.8449999999999998E+000,
      3.8455,
      3.846,
      3.8465,
      3.847,
      3.8475,
      3.848,
      3.8484999999999996E+000,
      3.849,
      3.8495,
      3.8499999999999996E+000,
      3.8505,
      3.851,
      3.8514999999999997E+000,
      3.852,
      3.8525,
      3.8529999999999998E+000,
      3.8535,
      3.854,
      3.8545,
      3.855,
      3.8555,
      3.856,
      3.8564999999999996E+000,
      3.857,
      3.8575,
      3.8579999999999997E+000,
      3.8585,
      3.859,
      3.8594999999999997E+000,
      3.86,
      3.8605,
      3.8609999999999998E+000,
      3.8615,
      3.862,
      3.8625,
      3.863,
      3.8635,
      3.864,
      3.8644999999999996E+000,
      3.865,
      3.8655,
      3.8659999999999997E+000,
      3.8665,
      3.867,
      3.8674999999999997E+000,
      3.868,
      3.8685,
      3.8689999999999998E+000,
      3.8695,
      3.87,
      3.8705,
      3.871,
      3.8715,
      3.872,
      3.8724999999999996E+000,
      3.873,
      3.8735,
      3.8739999999999997E+000,
      3.8745,
      3.875,
      3.8754999999999997E+000,
      3.876,
      3.8765,
      3.877,
      3.8775,
      3.878,
      3.8785,
      3.879,
      3.8795,
      3.88,
      3.8804999999999996E+000,
      3.8810000000000002E+000,
      3.8815,
      3.8819999999999997E+000,
      3.8825,
      3.883,
      3.8834999999999997E+000,
      3.884,
      3.8845,
      3.885,
      3.8855,
      3.886,
      3.8865,
      3.8869999999999996E+000,
      3.8875,
      3.888,
      3.8884999999999996E+000,
      3.889,
      3.8895,
      3.8899999999999997E+000,
      3.8905,
      3.891,
      3.8914999999999997E+000,
      3.892,
      3.8925,
      3.893,
      3.8935,
      3.894,
      3.8945,
      3.8949999999999996E+000,
      3.8955,
      3.896,
      3.8964999999999996E+000,
      3.897,
      3.8975,
      3.8979999999999997E+000,
      3.8985,
      3.899,
      3.8994999999999997E+000,
      3.9,
      3.9005,
      3.901,
      3.9015,
      3.902,
      3.9025,
      3.9029999999999996E+000,
      3.9035,
      3.904,
      3.9044999999999996E+000,
      3.905,
      3.9055,
      3.9059999999999997E+000,
      3.9065,
      3.907,
      3.9074999999999998E+000,
      3.908,
      3.9085,
      3.909,
      3.9095,
      3.91,
      3.9105,
      3.9109999999999996E+000,
      3.9115,
      3.912,
      3.9124999999999996E+000,
      3.913,
      3.9135,
      3.9139999999999997E+000,
      3.9145,
      3.915,
      3.9154999999999998E+000,
      3.916,
      3.9165,
      3.917,
      3.9175,
      3.918,
      3.9185,
      3.9189999999999996E+000,
      3.9195,
      3.92,
      3.9204999999999997E+000,
      3.921,
      3.9215,
      3.9219999999999997E+000,
      3.9225,
      3.923,
      3.9234999999999998E+000,
      3.924,
      3.9245,
      3.925,
      3.9255,
      3.926,
      3.9265,
      3.9269999999999996E+000,
      3.9275,
      3.928,
      3.9284999999999997E+000,
      3.929,
      3.9295,
      3.9299999999999997E+000,
      3.9305,
      3.931,
      3.9314999999999998E+000,
      3.932,
      3.9325,
      3.933,
      3.9335,
      3.934,
      3.9345,
      3.9349999999999996E+000,
      3.9355,
      3.936,
      3.9364999999999997E+000,
      3.937,
      3.9375,
      3.9379999999999997E+000,
      3.9385,
      3.939,
      3.9395,
      3.94,
      3.9405,
      3.941,
      3.9415,
      3.942,
      3.9425,
      3.9429999999999996E+000,
      3.9435000000000002E+000,
      3.944,
      3.9444999999999997E+000,
      3.945,
      3.9455,
      3.9459999999999997E+000,
      3.9465,
      3.947,
      3.9475,
      3.948,
      3.9485,
      3.949,
      3.9494999999999996E+000,
      3.95,
      3.9505,
      3.9509999999999996E+000,
      3.9515,
      3.952,
      3.9524999999999997E+000,
      3.953,
      3.9535,
      3.9539999999999997E+000,
      3.9545,
      3.955,
      3.9555,
      3.956,
      3.9565,
      3.957,
      3.9574999999999996E+000,
      3.958,
      3.9585,
      3.9589999999999996E+000,
      3.9595,
      3.96,
      3.9604999999999997E+000,
      3.961,
      3.9615,
      3.9619999999999997E+000,
      3.9625,
      3.963,
      3.9635,
      3.964,
      3.9645,
      3.965,
      3.9654999999999996E+000,
      3.966,
      3.9665,
      3.9669999999999996E+000,
      3.9675,
      3.968,
      3.9684999999999997E+000,
      3.969,
      3.9695,
      3.9699999999999998E+000,
      3.9705,
      3.971,
      3.9715,
      3.972,
      3.9725,
      3.973,
      3.9734999999999996E+000,
      3.974,
      3.9745,
      3.9749999999999996E+000,
      3.9755,
      3.976,
      3.9764999999999997E+000,
      3.977,
      3.9775,
      3.9779999999999998E+000,
      3.9785,
      3.979,
      3.9795,
      3.98,
      3.9805,
      3.981,
      3.9814999999999996E+000,
      3.982,
      3.9825,
      3.9829999999999997E+000,
      3.9835,
      3.984,
      3.9844999999999997E+000,
      3.985,
      3.9855,
      3.9859999999999998E+000,
      3.9865,
      3.987,
      3.9875,
      3.988,
      3.9885,
      3.989,
      3.9894999999999996E+000,
      3.99,
      3.9905,
      3.9909999999999997E+000,
      3.9915,
      3.992,
      3.9924999999999997E+000,
      3.993,
      3.9935,
      3.9939999999999998E+000,
      3.9945,
      3.995,
      3.9955,
      3.996,
      3.9965,
      3.997,
      3.9974999999999996E+000,
      3.998,
      3.9985,
      3.9989999999999997E+000,
      3.9995,
      4.0,
      4.0005,
      4.0009999999999994E+000,
      4.0015,
      4.002,
      4.0024999999999995E+000,
      4.003,
      4.0035,
      4.004,
      4.0045,
      4.005,
      4.0055,
      4.006,
      4.0065,
      4.007,
      4.0075,
      4.008,
      4.0085,
      4.009,
      4.0095,
      4.01,
      4.0105,
      4.011,
      4.0115,
      4.012,
      4.0125,
      4.013,
      4.0135,
      4.0139999999999993E+000,
      4.0145,
      4.015,
      4.0154999999999994E+000,
      4.016,
      4.0165,
      4.0169999999999995E+000,
      4.0175,
      4.018,
      4.0184999999999995E+000,
      4.019,
      4.0195,
      4.02,
      4.0205,
      4.021,
      4.0215,
      4.022,
      4.0225,
      4.023,
      4.0235,
      4.024,
      4.0245,
      4.025,
      4.0255,
      4.026,
      4.0265,
      4.027,
      4.0275,
      4.028,
      4.0285,
      4.029,
      4.0295,
      4.0299999999999994E+000,
      4.0305,
      4.031,
      4.0314999999999994E+000,
      4.032,
      4.0325,
      4.0329999999999995E+000,
      4.0335,
      4.034,
      4.0344999999999995E+000,
      4.035,
      4.0355,
      4.036,
      4.0365,
      4.037,
      4.0375,
      4.038,
      4.0385,
      4.039,
      4.0395,
      4.04,
      4.0405,
      4.041,
      4.0415,
      4.042,
      4.0425,
      4.043,
      4.0435,
      4.044,
      4.0445,
      4.045,
      4.0455,
      4.0459999999999994E+000,
      4.0465,
      4.047,
      4.0474999999999994E+000,
      4.048,
      4.0485,
      4.0489999999999995E+000,
      4.0495,
      4.05,
      4.0504999999999995E+000,
      4.051,
      4.0515,
      4.052,
      4.0525,
      4.053,
      4.0535,
      4.054,
      4.0545,
      4.055,
      4.0555,
      4.056,
      4.0565,
      4.057,
      4.0575,
      4.058,
      4.0585,
      4.059,
      4.0595,
      4.06,
      4.0605,
      4.061,
      4.0615,
      4.0619999999999994E+000,
      4.0625,
      4.063,
      4.0634999999999994E+000,
      4.064,
      4.0645,
      4.0649999999999995E+000,
      4.0655,
      4.066,
      4.0665,
      4.067,
      4.0675,
      4.068,
      4.0685,
      4.069,
      4.0695,
      4.07,
      4.0705,
      4.071,
      4.0715,
      4.072,
      4.0725,
      4.073,
      4.0735,
      4.074,
      4.0745000000000005E+000,
      4.075,
      4.0755,
      4.076,
      4.0764999999999993E+000,
      4.077,
      4.0775,
      4.0779999999999994E+000,
      4.0785,
      4.079,
      4.0794999999999995E+000,
      4.08,
      4.0805,
      4.0809999999999995E+000,
      4.0815,
      4.082,
      4.0825,
      4.083,
      4.0835,
      4.084,
      4.0845,
      4.085,
      4.0855,
      4.086,
      4.0865,
      4.087,
      4.0875,
      4.088,
      4.0885,
      4.089,
      4.0895,
      4.09,
      4.0905,
      4.091,
      4.0915,
      4.092,
      4.0924999999999994E+000,
      4.093,
      4.0935,
      4.0939999999999994E+000,
      4.0945,
      4.095,
      4.0954999999999995E+000,
      4.096,
      4.0965,
      4.0969999999999995E+000,
      4.0975,
      4.098,
      4.0985,
      4.099,
      4.0995,
      4.1,
      4.1005,
      4.101,
      4.1015,
      4.102,
      4.1025,
      4.103,
      4.1035,
      4.104,
      4.1045,
      4.1049999999999995E+000,
      4.1055,
      4.106,
      4.1065,
      4.107,
      4.1075,
      4.108,
      4.1085,
      4.109,
      4.1095,
      4.1099999999999994E+000,
      4.1105,
      4.111,
      4.1114999999999995E+000,
      4.112,
      4.1125,
      4.1129999999999995E+000,
      4.1135,
      4.114,
      4.1145,
      4.115,
      4.1155,
      4.116,
      4.1165,
      4.117,
      4.1175,
      4.118,
      4.1185,
      4.119,
      4.1195,
      4.12,
      4.1205,
      4.1209999999999996E+000,
      4.1215,
      4.122,
      4.1225,
      4.123,
      4.1235,
      4.124,
      4.1245,
      4.125,
      4.1255,
      4.1259999999999994E+000,
      4.1265,
      4.127,
      4.1274999999999995E+000,
      4.128,
      4.1285,
      4.129,
      4.1295,
      4.13,
      4.1305,
      4.131,
      4.1315,
      4.132,
      4.1325,
      4.133,
      4.1335,
      4.134,
      4.1345,
      4.135,
      4.1355,
      4.136,
      4.1365,
      4.137,
      4.1375,
      4.138,
      4.1385,
      4.139,
      4.1395,
      4.14,
      4.1404999999999994E+000,
      4.141,
      4.1415,
      4.1419999999999995E+000,
      4.1425,
      4.143,
      4.1434999999999995E+000,
      4.144,
      4.1445,
      4.145,
      4.1455,
      4.146,
      4.1465,
      4.147,
      4.1475,
      4.148,
      4.1485,
      4.149,
      4.1495,
      4.15,
      4.1505,
      4.151,
      4.1514999999999995E+000,
      4.152,
      4.1525,
      4.153,
      4.1535,
      4.154,
      4.1545,
      4.155,
      4.1555,
      4.156,
      4.1564999999999994E+000,
      4.157,
      4.1575,
      4.1579999999999995E+000,
      4.1585,
      4.159,
      4.1594999999999995E+000,
      4.16,
      4.1605,
      4.161,
      4.1615,
      4.162,
      4.1625,
      4.163,
      4.1635,
      4.164,
      4.1645,
      4.165,
      4.1655,
      4.166,
      4.1665,
      4.167,
      4.1674999999999995E+000,
      4.168,
      4.1685,
      4.169,
      4.1695,
      4.17,
      4.1705,
      4.171,
      4.1715,
      4.172,
      4.1724999999999994E+000,
      4.173,
      4.1735,
      4.1739999999999995E+000,
      4.1745,
      4.175,
      4.1754999999999995E+000,
      4.176,
      4.1765,
      4.177,
      4.1775,
      4.178,
      4.1785,
      4.179,
      4.1795,
      4.18,
      4.1805,
      4.181,
      4.1815,
      4.182,
      4.1825,
      4.183,
      4.1834999999999996E+000,
      4.184,
      4.1845,
      4.185,
      4.1855,
      4.186,
      4.1865,
      4.187,
      4.1875,
      4.188,
      4.1884999999999994E+000,
      4.189,
      4.1895,
      4.1899999999999995E+000,
      4.1905,
      4.191,
      4.1915,
      4.192,
      4.1925,
      4.193,
      4.1935,
      4.194,
      4.1945,
      4.195,
      4.1955,
      4.196,
      4.1965,
      4.197,
      4.1975,
      4.198,
      4.1985,
      4.199,
      4.1995,
      4.2,
      4.2005,
      4.201,
      4.2015,
      4.202,
      4.2025,
      4.203,
      4.2035,
      4.204,
      4.2044999999999995E+000,
      4.205,
      4.2055,
      4.2059999999999995E+000,
      4.2065,
      4.207,
      4.2075,
      4.208,
      4.2085,
      4.209,
      4.2095,
      4.21,
      4.2105,
      4.211,
      4.2115,
      4.212,
      4.2125,
      4.213,
      4.2135,
      4.2139999999999995E+000,
      4.2145,
      4.215,
      4.2155,
      4.216,
      4.2165,
      4.217,
      4.2175,
      4.218,
      4.2185,
      4.2189999999999994E+000,
      4.2195,
      4.22,
      4.2204999999999995E+000,
      4.221,
      4.2215,
      4.2219999999999995E+000,
      4.2225,
      4.223,
      4.2235,
      4.224,
      4.2245,
      4.225,
      4.2255,
      4.226,
      4.2265,
      4.227,
      4.2275,
      4.228,
      4.2285,
      4.229,
      4.2295,
      4.2299999999999995E+000,
      4.2305,
      4.231,
      4.2315,
      4.232,
      4.2325,
      4.233,
      4.2335,
      4.234,
      4.2345,
      4.2349999999999994E+000,
      4.2355,
      4.236,
      4.2364999999999995E+000,
      4.237,
      4.2375,
      4.2379999999999995E+000,
      4.2385,
      4.239,
      4.2395,
      4.24,
      4.2405,
      4.241,
      4.2415,
      4.242,
      4.2425,
      4.243,
      4.2435,
      4.244,
      4.2445,
      4.245,
      4.2455,
      4.2459999999999996E+000,
      4.2465,
      4.247,
      4.2475,
      4.248,
      4.2485,
      4.249,
      4.2495,
      4.25,
      4.2505,
      4.2509999999999994E+000,
      4.2515,
      4.252,
      4.2524999999999995E+000,
      4.253,
      4.2535,
      4.254,
      4.2545,
      4.255,
      4.2555,
      4.256,
      4.2565,
      4.257,
      4.2575,
      4.258,
      4.2585,
      4.259,
      4.2595,
      4.26,
      4.2605,
      4.261,
      4.2615,
      4.262,
      4.2625,
      4.263,
      4.2635,
      4.264,
      4.2645,
      4.265,
      4.2655,
      4.266,
      4.2665,
      4.2669999999999995E+000,
      4.2675,
      4.268,
      4.2684999999999995E+000,
      4.269,
      4.2695,
      4.27,
      4.2705,
      4.271,
      4.2715,
      4.272,
      4.2725,
      4.273,
      4.2735,
      4.274,
      4.2745,
      4.275,
      4.2755,
      4.276,
      4.2764999999999995E+000,
      4.277,
      4.2775,
      4.278,
      4.2785,
      4.279,
      4.2795,
      4.28,
      4.2805,
      4.281,
      4.2814999999999994E+000,
      4.282,
      4.2825,
      4.2829999999999995E+000,
      4.2835,
      4.284,
      4.2844999999999995E+000,
      4.285,
      4.2855,
      4.286,
      4.2865,
      4.287,
      4.2875,
      4.288,
      4.2885,
      4.289,
      4.2895,
      4.29,
      4.2905,
      4.291,
      4.2915,
      4.292,
      4.2924999999999995E+000,
      4.293,
      4.2935,
      4.294,
      4.2945,
      4.295,
      4.2955,
      4.296,
      4.2965,
      4.297,
      4.2974999999999994E+000,
      4.298,
      4.2985,
      4.2989999999999995E+000,
      4.2995,
      4.3,
      4.3004999999999995E+000,
      4.301,
      4.3015,
      4.302,
      4.3025,
      4.303,
      4.3035,
      4.304,
      4.3045,
      4.305,
      4.3055,
      4.306,
      4.3065,
      4.307,
      4.3075,
      4.308,
      4.3084999999999996E+000,
      4.309,
      4.3095,
      4.31,
      4.3105,
      4.311,
      4.3115,
      4.312,
      4.3125,
      4.313,
      4.3134999999999994E+000,
      4.314,
      4.3145,
      4.3149999999999995E+000,
      4.3155,
      4.316,
      4.3165,
      4.317,
      4.3175,
      4.318,
      4.3185,
      4.319,
      4.3195,
      4.32,
      4.3205,
      4.321,
      4.3215,
      4.322,
      4.3225,
      4.323,
      4.3235,
      4.324,
      4.3245,
      4.325,
      4.3255,
      4.326,
      4.3265,
      4.327,
      4.3275,
      4.328,
      4.3285,
      4.329,
      4.3294999999999995E+000,
      4.33,
      4.3305,
      4.3309999999999995E+000,
      4.3315,
      4.332,
      4.3325,
      4.333,
      4.3335,
      4.334,
      4.3345,
      4.335,
      4.3355,
      4.336,
      4.3365,
      4.337,
      4.3375,
      4.338,
      4.3385,
      4.3389999999999995E+000,
      4.3395,
      4.34,
      4.3405,
      4.341,
      4.3415,
      4.342,
      4.3425,
      4.343,
      4.3435,
      4.3439999999999994E+000,
      4.3445,
      4.345,
      4.3454999999999995E+000,
      4.346,
      4.3465,
      4.3469999999999995E+000,
      4.3475,
      4.348,
      4.3485,
      4.349,
      4.3495,
      4.35,
      4.3505,
      4.351,
      4.3515,
      4.352,
      4.3525,
      4.353,
      4.3535,
      4.354,
      4.3545,
      4.3549999999999995E+000,
      4.3555,
      4.356,
      4.3565,
      4.357,
      4.3575,
      4.358,
      4.3585,
      4.359,
      4.3595,
      4.3599999999999994E+000,
      4.3605,
      4.361,
      4.3614999999999995E+000,
      4.362,
      4.3625,
      4.3629999999999995E+000,
      4.3635,
      4.364,
      4.3645,
      4.365,
      4.3655,
      4.366,
      4.3665,
      4.367,
      4.3675,
      4.368,
      4.3685,
      4.369,
      4.3695,
      4.37,
      4.3705,
      4.3709999999999996E+000,
      4.3715,
      4.372,
      4.3725,
      4.373,
      4.3735,
      4.374,
      4.3745,
      4.375,
      4.3755,
      4.3759999999999994E+000,
      4.3765,
      4.377,
      4.3774999999999995E+000,
      4.378,
      4.3785,
      4.379,
      4.3795,
      4.38,
      4.3805,
      4.381,
      4.3815,
      4.382,
      4.3825,
      4.383,
      4.3835,
      4.384,
      4.3845,
      4.385,
      4.3855,
      4.386,
      4.3865,
      4.387,
      4.3875,
      4.388,
      4.3885,
      4.389,
      4.3895,
      4.39,
      4.3905,
      4.391,
      4.3915,
      4.3919999999999995E+000,
      4.3925,
      4.393,
      4.3934999999999995E+000,
      4.394,
      4.3945,
      4.395,
      4.3955,
      4.396,
      4.3965,
      4.397,
      4.3975,
      4.398,
      4.3985,
      4.399,
      4.3995,
      4.4,
      4.4005,
      4.401,
      4.4014999999999995E+000,
      4.402,
      4.4025,
      4.403,
      4.4035,
      4.404,
      4.4045,
      4.405,
      4.4055,
      4.406,
      4.4064999999999994E+000,
      4.407,
      4.4075,
      4.4079999999999995E+000,
      4.4085,
      4.409,
      4.4094999999999995E+000,
      4.41,
      4.4105,
      4.411,
      4.4115,
      4.412,
      4.4125,
      4.413,
      4.4135,
      4.414,
      4.4145,
      4.415,
      4.4155,
      4.416,
      4.4165,
      4.417,
      4.4174999999999995E+000,
      4.418,
      4.4185,
      4.419,
      4.4195,
      4.42,
      4.4205,
      4.421,
      4.4215,
      4.422,
      4.4224999999999994E+000,
      4.423,
      4.4235,
      4.4239999999999995E+000,
      4.4245,
      4.425,
      4.4254999999999995E+000,
      4.426,
      4.4265,
      4.427,
      4.4275,
      4.428,
      4.4285,
      4.429,
      4.4295,
      4.43,
      4.4305,
      4.431,
      4.4315,
      4.432,
      4.4325,
      4.433,
      4.4334999999999996E+000,
      4.434,
      4.4345,
      4.435,
      4.4355,
      4.436,
      4.4365,
      4.437,
      4.4375,
      4.438,
      4.4384999999999994E+000,
      4.439,
      4.4395,
      4.4399999999999995E+000,
      4.4405,
      4.441,
      4.4415,
      4.442,
      4.4425,
      4.443,
      4.4435,
      4.444,
      4.4445,
      4.445,
      4.4455,
      4.446,
      4.4465,
      4.447,
      4.4475,
      4.448,
      4.4485,
      4.449,
      4.4495,
      4.45,
      4.4505,
      4.451,
      4.4515,
      4.452,
      4.4525,
      4.453,
      4.4535,
      4.454,
      4.4544999999999995E+000,
      4.455,
      4.4555,
      4.4559999999999995E+000,
      4.4565,
      4.457,
      4.4575,
      4.458,
      4.4585,
      4.459,
      4.4595,
      4.46,
      4.4605,
      4.461,
      4.4615,
      4.462,
      4.4625,
      4.463,
      4.4635,
      4.4639999999999995E+000,
      4.4645,
      4.465,
      4.4655,
      4.466,
      4.4665,
      4.467,
      4.4675,
      4.468,
      4.4685,
      4.4689999999999994E+000,
      4.4695,
      4.47,
      4.4704999999999995E+000,
      4.471,
      4.4715,
      4.4719999999999995E+000,
      4.4725,
      4.473,
      4.4735,
      4.474,
      4.4745,
      4.475,
      4.4755,
      4.476,
      4.4765,
      4.477,
      4.4775,
      4.478,
      4.4785,
      4.479,
      4.4795,
      4.4799999999999995E+000,
      4.4805,
      4.481,
      4.4815,
      4.482,
      4.4825,
      4.483,
      4.4835,
      4.484,
      4.4845,
      4.4849999999999994E+000,
      4.4855,
      4.486,
      4.4864999999999995E+000,
      4.487,
      4.4875,
      4.4879999999999995E+000,
      4.4885,
      4.489,
      4.4895,
      4.49,
      4.4905,
      4.491,
      4.4915,
      4.492,
      4.4925,
      4.493,
      4.4935,
      4.494,
      4.4945,
      4.495,
      4.4955,
      4.4959999999999996E+000,
      4.4965,
      4.497,
      4.4975,
      4.498,
      4.4985,
      4.499,
      4.4995,
      4.5,
      4.5005,
      4.5009999999999994E+000,
      4.5015,
      4.502,
      4.5024999999999995E+000,
      4.503,
      4.5035,
      4.504,
      4.5045,
      4.505,
      4.5055,
      4.506,
      4.5065,
      4.507,
      4.5075,
      4.508,
      4.5085,
      4.509,
      4.5095,
      4.51,
      4.5105,
      4.511,
      4.5115,
      4.512,
      4.5125,
      4.513,
      4.5135,
      4.514,
      4.5145,
      4.515,
      4.5155,
      4.516,
      4.5165,
      4.5169999999999995E+000,
      4.5175,
      4.518,
      4.5184999999999995E+000,
      4.519,
      4.5195,
      4.52,
      4.5205,
      4.521,
      4.5215,
      4.522,
      4.5225,
      4.523,
      4.5235,
      4.524,
      4.5245,
      4.525,
      4.5255,
      4.526,
      4.5264999999999995E+000,
      4.527,
      4.5275,
      4.528,
      4.5285,
      4.529,
      4.5295,
      4.53,
      4.5305,
      4.531,
      4.5314999999999994E+000,
      4.532,
      4.5325,
      4.5329999999999995E+000,
      4.5335,
      4.534,
      4.5344999999999995E+000,
      4.535,
      4.5355,
      4.536,
      4.5365,
      4.537,
      4.5375,
      4.538,
      4.5385,
      4.539,
      4.5395,
      4.54,
      4.5405,
      4.541,
      4.5415,
      4.542,
      4.5424999999999995E+000,
      4.543,
      4.5435,
      4.544,
      4.5445,
      4.545,
      4.5455,
      4.546,
      4.5465,
      4.547,
      4.5474999999999994E+000,
      4.548,
      4.5485,
      4.5489999999999995E+000,
      4.5495,
      4.55,
      4.5504999999999995E+000,
      4.551,
      4.5515,
      4.552,
      4.5525,
      4.553,
      4.5535,
      4.554,
      4.5545,
      4.555,
      4.5555,
      4.556,
      4.5565,
      4.557,
      4.5575,
      4.558,
      4.5584999999999996E+000,
      4.559,
      4.5595,
      4.56,
      4.5605,
      4.561,
      4.5615,
      4.562,
      4.5625,
      4.563,
      4.5634999999999994E+000,
      4.564,
      4.5645,
      4.5649999999999995E+000,
      4.5655,
      4.566,
      4.5665,
      4.567,
      4.5675,
      4.568,
      4.5685,
      4.569,
      4.5695,
      4.57,
      4.5705,
      4.571,
      4.5715,
      4.572,
      4.5725,
      4.573,
      4.5735,
      4.574,
      4.5745,
      4.575,
      4.5755,
      4.576,
      4.5765,
      4.577,
      4.5775,
      4.578,
      4.5785,
      4.579,
      4.5794999999999995E+000,
      4.58,
      4.5805,
      4.5809999999999995E+000,
      4.5815,
      4.582,
      4.5825,
      4.583,
      4.5835,
      4.584,
      4.5845,
      4.585,
      4.5855,
      4.586,
      4.5865,
      4.587,
      4.5875,
      4.588,
      4.5885,
      4.5889999999999995E+000,
      4.5895,
      4.59,
      4.5905,
      4.591,
      4.5915,
      4.592,
      4.5925,
      4.593,
      4.5935,
      4.5939999999999994E+000,
      4.5945,
      4.595,
      4.5954999999999995E+000,
      4.596,
      4.5965,
      4.5969999999999995E+000,
      4.5975,
      4.598,
      4.5985,
      4.599,
      4.5995,
      4.6,
      4.6005,
      4.601,
      4.6015,
      4.602,
      4.6025,
      4.603,
      4.6035,
      4.604,
      4.6045,
      4.6049999999999995E+000,
      4.6055,
      4.606,
      4.6065,
      4.607,
      4.6075,
      4.608,
      4.6085,
      4.609,
      4.6095,
      4.61,
      4.6105,
      4.611,
      4.6114999999999995E+000,
      4.612,
      4.6125,
      4.6129999999999995E+000,
      4.6135,
      4.614,
      4.6145,
      4.615,
      4.6155,
      4.616,
      4.6165,
      4.617,
      4.6175,
      4.618,
      4.6185,
      4.619,
      4.6195,
      4.62,
      4.6205,
      4.6209999999999996E+000,
      4.6215,
      4.622,
      4.6225,
      4.623,
      4.6235,
      4.624,
      4.6245,
      4.625,
      4.6255,
      4.6259999999999994E+000,
      4.6265,
      4.627,
      4.6274999999999995E+000,
      4.628,
      4.6285,
      4.629,
      4.6295,
      4.63,
      4.6305,
      4.631,
      4.6315,
      4.632,
      4.6325,
      4.633,
      4.6335,
      4.634,
      4.6345,
      4.635,
      4.6354999999999995E+000,
      4.636,
      4.6365,
      4.637,
      4.6375,
      4.638,
      4.6385,
      4.639,
      4.6395,
      4.64,
      4.6405,
      4.641,
      4.6415,
      4.6419999999999995E+000,
      4.6425,
      4.643,
      4.6434999999999995E+000,
      4.644,
      4.6445,
      4.645,
      4.6455,
      4.646,
      4.6465,
      4.647,
      4.6475,
      4.648,
      4.6485,
      4.649,
      4.6495,
      4.65,
      4.6505,
      4.651,
      4.6514999999999995E+000,
      4.652,
      4.6525,
      4.653,
      4.6535,
      4.654,
      4.6545,
      4.655,
      4.6555,
      4.656,
      4.6565,
      4.657,
      4.6575,
      4.6579999999999995E+000,
      4.6585,
      4.659,
      4.6594999999999995E+000,
      4.66,
      4.6605,
      4.661,
      4.6615,
      4.662,
      4.6625,
      4.663,
      4.6635,
      4.664,
      4.6645,
      4.665,
      4.6655,
      4.666,
      4.6665,
      4.667,
      4.6674999999999995E+000,
      4.668,
      4.6685,
      4.669,
      4.6695,
      4.67,
      4.6705,
      4.671,
      4.6715,
      4.672,
      4.6725,
      4.673,
      4.6735,
      4.6739999999999995E+000,
      4.6745,
      4.675,
      4.6754999999999995E+000,
      4.676,
      4.6765,
      4.677,
      4.6775,
      4.678,
      4.6785,
      4.679,
      4.6795,
      4.68,
      4.6805,
      4.681,
      4.6815,
      4.682,
      4.6825,
      4.683,
      4.6834999999999996E+000,
      4.684,
      4.6845,
      4.685,
      4.6855,
      4.686,
      4.6865,
      4.687,
      4.6875,
      4.688,
      4.6884999999999994E+000,
      4.689,
      4.6895,
      4.6899999999999995E+000,
      4.6905,
      4.691,
      4.6915,
      4.692,
      4.6925,
      4.693,
      4.6935,
      4.694,
      4.6945,
      4.695,
      4.6955,
      4.696,
      4.6965,
      4.697,
      4.6975,
      4.6979999999999995E+000,
      4.6985,
      4.699,
      4.6995,
      4.7,
      4.7005,
      4.701,
      4.7015,
      4.702,
      4.7025,
      4.703,
      4.7035,
      4.704,
      4.7044999999999995E+000,
      4.705,
      4.7055,
      4.7059999999999995E+000,
      4.7065,
      4.707,
      4.7075,
      4.708,
      4.7085,
      4.709,
      4.7095,
      4.71,
      4.7105,
      4.711,
      4.7115,
      4.712,
      4.7125,
      4.713,
      4.7135,
      4.7139999999999995E+000,
      4.7145,
      4.715,
      4.7155,
      4.716,
      4.7165,
      4.717,
      4.7175,
      4.718,
      4.7185,
      4.719,
      4.7195,
      4.72,
      4.7204999999999995E+000,
      4.721,
      4.7215,
      4.7219999999999995E+000,
      4.7225,
      4.723,
      4.7235,
      4.724,
      4.7245,
      4.725,
      4.7255,
      4.726,
      4.7265,
      4.727,
      4.7275,
      4.728,
      4.7285,
      4.729,
      4.7295,
      4.7299999999999995E+000,
      4.7305,
      4.731,
      4.7315,
      4.732,
      4.7325,
      4.733,
      4.7335,
      4.734,
      4.7345,
      4.735,
      4.7355,
      4.736,
      4.7364999999999995E+000,
      4.737,
      4.7375,
      4.7379999999999995E+000,
      4.7385,
      4.739,
      4.7395,
      4.74,
      4.7405,
      4.741,
      4.7415,
      4.742,
      4.7425,
      4.743,
      4.7435,
      4.744,
      4.7445,
      4.745,
      4.7455,
      4.7459999999999996E+000,
      4.7465,
      4.747,
      4.7475,
      4.748,
      4.7485,
      4.749,
      4.7495,
      4.75,
      4.7505,
      4.7509999999999994E+000,
      4.7515,
      4.752,
      4.7524999999999995E+000,
      4.753,
      4.7535,
      4.754,
      4.7545,
      4.755,
      4.7555,
      4.756,
      4.7565,
      4.757,
      4.7575,
      4.758,
      4.7585,
      4.759,
      4.7595,
      4.76,
      4.7604999999999995E+000,
      4.761,
      4.7615,
      4.762,
      4.7625,
      4.763,
      4.7635,
      4.764,
      4.7645,
      4.765,
      4.7655,
      4.766,
      4.7665,
      4.7669999999999995E+000,
      4.7675,
      4.768,
      4.7684999999999995E+000,
      4.769,
      4.7695,
      4.77,
      4.7705,
      4.771,
      4.7715,
      4.772,
      4.7725,
      4.773,
      4.7735,
      4.774,
      4.7745,
      4.775,
      4.7755,
      4.776,
      4.7764999999999995E+000,
      4.777,
      4.7775,
      4.778,
      4.7785,
      4.779,
      4.7795,
      4.78,
      4.7805,
      4.781,
      4.7815,
      4.782,
      4.7825,
      4.7829999999999995E+000,
      4.7835,
      4.784,
      4.7844999999999995E+000,
      4.785,
      4.7855,
      4.786,
      4.7865,
      4.787,
      4.7875,
      4.788,
      4.7885,
      4.789,
      4.7895,
      4.79,
      4.7905,
      4.791,
      4.7915,
      4.792,
      4.7924999999999995E+000,
      4.793,
      4.7935,
      4.794,
      4.7945,
      4.795,
      4.7955,
      4.796,
      4.7965,
      4.797,
      4.7975,
      4.798,
      4.7985,
      4.7989999999999995E+000,
      4.7995,
      4.8,
      4.8004999999999995E+000,
      4.801,
      4.8015,
      4.802,
      4.8025,
      4.803,
      4.8035,
      4.804,
      4.8045,
      4.805,
      4.8055,
      4.806,
      4.8065,
      4.807,
      4.8075,
      4.808,
      4.8084999999999996E+000,
      4.809,
      4.8095,
      4.81,
      4.8105,
      4.811,
      4.8115,
      4.812,
      4.8125,
      4.813,
      4.8134999999999994E+000,
      4.814,
      4.8145,
      4.8149999999999995E+000,
      4.8155,
      4.816,
      4.8165,
      4.817,
      4.8175,
      4.818,
      4.8185,
      4.819,
      4.8195,
      4.82,
      4.8205,
      4.821,
      4.8215,
      4.822,
      4.8225,
      4.8229999999999995E+000,
      4.8235,
      4.824,
      4.8245,
      4.825,
      4.8255,
      4.826,
      4.8265,
      4.827,
      4.8275,
      4.828,
      4.8285,
      4.829,
      4.8294999999999995E+000,
      4.83,
      4.8305,
      4.8309999999999995E+000,
      4.8315,
      4.832,
      4.8325,
      4.833,
      4.8335,
      4.834,
      4.8345,
      4.835,
      4.8355,
      4.836,
      4.8365,
      4.837,
      4.8375,
      4.838,
      4.8385,
      4.8389999999999995E+000,
      4.8395,
      4.84,
      4.8405,
      4.841,
      4.8415,
      4.842,
      4.8425,
      4.843,
      4.8435,
      4.844,
      4.8445,
      4.845,
      4.8454999999999995E+000,
      4.846,
      4.8465,
      4.8469999999999995E+000,
      4.8475,
      4.848,
      4.8485,
      4.849,
      4.8495,
      4.85,
      4.8505,
      4.851,
      4.8515,
      4.852,
      4.8525,
      4.853,
      4.8535,
      4.854,
      4.8545,
      4.8549999999999995E+000,
      4.8555,
      4.856,
      4.8565,
      4.857,
      4.8575,
      4.858,
      4.8585,
      4.859,
      4.8595,
      4.86,
      4.8605,
      4.861,
      4.8614999999999995E+000,
      4.862,
      4.8625,
      4.8629999999999995E+000,
      4.8635,
      4.864,
      4.8645,
      4.865,
      4.8655,
      4.866,
      4.8665,
      4.867,
      4.8675,
      4.868,
      4.8685,
      4.869,
      4.8694999999999995E+000,
      4.87,
      4.8705,
      4.8709999999999996E+000,
      4.8715,
      4.872,
      4.8725,
      4.873,
      4.8735,
      4.874,
      4.8745,
      4.875,
      4.8755,
      4.876,
      4.8765,
      4.877,
      4.8774999999999995E+000,
      4.878,
      4.8785,
      4.879,
      4.8795,
      4.88,
      4.8805,
      4.881,
      4.8815,
      4.882,
      4.8825,
      4.883,
      4.8835,
      4.884,
      4.8845,
      4.885,
      4.8854999999999995E+000,
      4.886,
      4.8865,
      4.887,
      4.8875,
      4.888,
      4.8885,
      4.889,
      4.8895,
      4.89,
      4.8905,
      4.891,
      4.8915,
      4.8919999999999995E+000,
      4.8925,
      4.893,
      4.8934999999999995E+000,
      4.894,
      4.8945,
      4.895,
      4.8955,
      4.896,
      4.8965,
      4.897,
      4.8975,
      4.898,
      4.8985,
      4.899,
      4.8995,
      4.9,
      4.9005,
      4.901,
      4.9014999999999995E+000,
      4.902,
      4.9025,
      4.903,
      4.9035,
      4.904,
      4.9045,
      4.905,
      4.9055,
      4.906,
      4.9065,
      4.907,
      4.9075,
      4.9079999999999995E+000,
      4.9085,
      4.909,
      4.9094999999999995E+000,
      4.91,
      4.9105,
      4.911,
      4.9115,
      4.912,
      4.9125,
      4.913,
      4.9135,
      4.914,
      4.9145,
      4.915,
      4.9155,
      4.916,
      4.9165,
      4.917,
      4.9174999999999995E+000,
      4.918,
      4.9185,
      4.919,
      4.9195,
      4.92,
      4.9205,
      4.921,
      4.9215,
      4.922,
      4.9225,
      4.923,
      4.9235,
      4.9239999999999995E+000,
      4.9245,
      4.925,
      4.9254999999999995E+000,
      4.926,
      4.9265,
      4.927,
      4.9275,
      4.928,
      4.9285,
      4.929,
      4.9295,
      4.93,
      4.9305,
      4.931,
      4.9315,
      4.9319999999999995E+000,
      4.9325,
      4.933,
      4.9334999999999996E+000,
      4.934,
      4.9345,
      4.935,
      4.9355,
      4.936,
      4.9365,
      4.937,
      4.9375,
      4.938,
      4.9385,
      4.939,
      4.9395,
      4.9399999999999995E+000,
      4.9405,
      4.941,
      4.9415,
      4.942,
      4.9425,
      4.943,
      4.9435,
      4.944,
      4.9445,
      4.945,
      4.9455,
      4.946,
      4.9465,
      4.947,
      4.9475,
      4.9479999999999995E+000,
      4.9485,
      4.949,
      4.9495,
      4.95,
      4.9505,
      4.951,
      4.9515,
      4.952,
      4.9525,
      4.953,
      4.9535,
      4.954,
      4.9545,
      4.955,
      4.9555,
      4.9559999999999995E+000,
      4.9565,
      4.957,
      4.9575,
      4.958,
      4.9585,
      4.959,
      4.9595,
      4.96,
      4.9605,
      4.961,
      4.9615,
      4.962,
      4.9625,
      4.963,
      4.9635,
      4.9639999999999995E+000,
      4.9645,
      4.965,
      4.9655,
      4.966,
      4.9665,
      4.967,
      4.9675,
      4.968,
      4.9685,
      4.969,
      4.9695,
      4.97,
      4.9704999999999995E+000,
      4.971,
      4.9715,
      4.9719999999999995E+000,
      4.9725,
      4.973,
      4.9735,
      4.974,
      4.9745,
      4.975,
      4.9755,
      4.976,
      4.9765,
      4.977,
      4.9775,
      4.978,
      4.9785,
      4.979,
      4.9795,
      4.9799999999999995E+000,
      4.9805,
      4.981,
      4.9815,
      4.982,
      4.9825,
      4.983,
      4.9835,
      4.984,
      4.9845,
      4.985,
      4.9855,
      4.986,
      4.9864999999999995E+000,
      4.987,
      4.9875,
      4.9879999999999995E+000,
      4.9885,
      4.989,
      4.9895,
      4.99,
      4.9905,
      4.991,
      4.9915,
      4.992,
      4.9925,
      4.993,
      4.9935,
      4.994,
      4.9944999999999995E+000,
      4.995,
      4.9955,
      4.9959999999999996E+000,
      4.9965,
      4.997,
      4.9975,
      4.998,
      4.9985,
      4.999,
      4.9995,
      5.0,
      5.0005,
      5.001,
      5.0015,
      5.002,
      5.0024999999999995E+000,
      5.003,
      5.0035,
      5.004,
      5.0045,
      5.005,
      5.0055,
      5.006,
      5.0065,
      5.007,
      5.0075,
      5.008,
      5.0085,
      5.009,
      5.0095,
      5.01,
      5.0104999999999995E+000,
      5.011,
      5.0115,
      5.012,
      5.0125,
      5.013,
      5.0135,
      5.014,
      5.0145,
      5.015,
      5.0155,
      5.016,
      5.0165,
      5.017,
      5.0175,
      5.018,
      5.0184999999999995E+000,
      5.019,
      5.0195,
      5.02,
      5.0205,
      5.021,
      5.0215,
      5.022,
      5.0225,
      5.023,
      5.0235,
      5.024,
      5.0245,
      5.025,
      5.0255,
      5.026,
      5.0264999999999995E+000,
      5.027,
      5.0275,
      5.028,
      5.0285,
      5.029,
      5.0295,
      5.03,
      5.0305,
      5.031,
      5.0315,
      5.032,
      5.0325,
      5.0329999999999995E+000,
      5.0335,
      5.034,
      5.0344999999999995E+000,
      5.035,
      5.0355,
      5.036,
      5.0365,
      5.037,
      5.0375,
      5.038,
      5.0385,
      5.039,
      5.0395,
      5.04,
      5.0405,
      5.0409999999999995E+000,
      5.0415,
      5.042,
      5.0424999999999995E+000,
      5.043,
      5.0435,
      5.044,
      5.0445,
      5.045,
      5.0455,
      5.046,
      5.0465,
      5.047,
      5.0475,
      5.048,
      5.0485,
      5.0489999999999995E+000,
      5.0495,
      5.05,
      5.0504999999999995E+000,
      5.051,
      5.0515,
      5.052,
      5.0525,
      5.053,
      5.0535,
      5.054,
      5.0545,
      5.055,
      5.0555,
      5.056,
      5.0565,
      5.0569999999999995E+000,
      5.0575,
      5.058,
      5.0584999999999996E+000,
      5.059,
      5.0595,
      5.06,
      5.0605,
      5.061,
      5.0615,
      5.062,
      5.0625,
      5.063,
      5.0635,
      5.064,
      5.0645,
      5.0649999999999995E+000,
      5.0655,
      5.066,
      5.0665,
      5.067,
      5.0675,
      5.068,
      5.0685,
      5.069,
      5.0695,
      5.07,
      5.0705,
      5.071,
      5.0715,
      5.072,
      5.0725,
      5.0729999999999995E+000,
      5.0735,
      5.074,
      5.0745,
      5.075,
      5.0755,
      5.076,
      5.0765,
      5.077,
      5.0775,
      5.078,
      5.0785,
      5.079,
      5.0795,
      5.08,
      5.0805,
      5.0809999999999995E+000,
      5.0815,
      5.082,
      5.0825,
      5.083,
      5.0835,
      5.084,
      5.0845,
      5.085,
      5.0855,
      5.086,
      5.0865,
      5.087,
      5.0875,
      5.088,
      5.0885,
      5.0889999999999995E+000,
      5.0895,
      5.09,
      5.0905,
      5.091,
      5.0915,
      5.092,
      5.0925,
      5.093,
      5.0935,
      5.094,
      5.0945,
      5.095,
      5.0955,
      5.096,
      5.0965,
      5.0969999999999995E+000,
      5.0975,
      5.098,
      5.0985,
      5.099,
      5.0995
    };

    static real_T pDataValues[] = {
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      -1.2499999999999997E-005,
      -4.9999999999999989E-005,
      -1.1249999999999998E-004,
      -1.9999999999999996E-004,
      -0.0003125,
      -4.4999999999999993E-004,
      -0.0006125,
      -7.9999999999999982E-004,
      -1.0125000000000002E-003,
      -0.00125,
      -1.5124999999999997E-003,
      -1.7999999999999997E-003,
      -2.1125000000000002E-003,
      -0.00245,
      -0.0028125,
      -3.1999999999999993E-003,
      -0.0036125,
      -4.0500000000000006E-003,
      -4.5124999999999992E-003,
      -0.005,
      -0.0055125,
      -6.0499999999999990E-003,
      -6.6124999999999986E-003,
      -7.1999999999999989E-003,
      -7.8125000000000017E-003,
      -8.4500000000000009E-003,
      -9.1124999999999991E-003,
      -0.0098,
      -0.0105125,
      -0.01125,
      -1.2012499999999997E-002,
      -1.2799999999999997E-002,
      -0.0136125,
      -0.01445,
      -0.0153125,
      -1.6200000000000003E-002,
      -1.7112499999999996E-002,
      -1.8049999999999997E-002,
      -1.9012499999999998E-002,
      -0.02,
      -0.0210125,
      -0.02205,
      -2.3112500000000005E-002,
      -2.4199999999999996E-002,
      -2.5312499999999995E-002,
      -2.6449999999999994E-002,
      -2.7612499999999998E-002,
      -2.8799999999999996E-002,
      -0.0300125,
      -3.1250000000000007E-002,
      -0.0325125,
      -3.3800000000000004E-002,
      -0.0351125,
      -3.6449999999999996E-002,
      -3.7812499999999992E-002,
      -0.0392,
      -4.0612499999999996E-002,
      -0.04205,
      -0.0435125,
      -0.045,
      -4.6512499999999991E-002,
      -4.8049999999999989E-002,
      -0.0496125,
      -5.1199999999999989E-002,
      -0.0528125,
      -0.05445,
      -0.0561125,
      -0.0578,
      -5.9512499999999996E-002,
      -0.06125,
      -6.3012500000000013E-002,
      -6.4800000000000010E-002,
      -6.6612499999999991E-002,
      -6.8449999999999983E-002,
      -7.0312499999999986E-002,
      -7.2199999999999986E-002,
      -0.0741125,
      -7.6049999999999993E-002,
      -7.8012499999999985E-002,
      -0.08,
      -8.2012499999999988E-002,
      -0.08405,
      -8.6112500000000008E-002,
      -0.0882,
      -0.0903125,
      -9.2450000000000018E-002,
      -9.4612500000000016E-002,
      -9.6799999999999983E-002,
      -9.9012499999999976E-002,
      -1.0124999999999998E-001,
      -0.1035125,
      -1.0579999999999998E-001,
      -0.1081125,
      -1.1044999999999999E-001,
      -1.1281249999999998E-001,
      -1.1519999999999998E-001,
      -0.1176125,
      -0.12005,
      -0.1225125,
      -1.2500000000000003E-001,
      -0.1275125,
      -0.13005,
      -1.3261250000000002E-001,
      -1.3520000000000001E-001,
      -0.1378125,
      -1.4045000000000002E-001,
      -0.1431125,
      -0.1458,
      -1.4851250000000002E-001,
      -1.5125000000000002E-001,
      -1.5401250000000002E-001,
      -0.1568,
      -0.1596125,
      -1.6244999999999998E-001,
      -1.6531249999999997E-001,
      -0.1682,
      -0.1711125,
      -0.17405,
      -1.7701250000000002E-001,
      -1.8000000000000002E-001,
      -1.8301250000000002E-001,
      -1.8605000000000002E-001,
      -1.8911250000000002E-001,
      -0.1922,
      -1.9531249999999997E-001,
      -0.19845,
      -2.0161249999999997E-001,
      -2.0479999999999995E-001,
      -2.0801249999999996E-001,
      -0.21125,
      -2.1451250000000002E-001,
      -0.2178,
      -2.2111250000000002E-001,
      -0.22445,
      -2.2781249999999997E-001,
      -0.2312,
      -2.3461250000000003E-001,
      -2.3804999999999998E-001,
      -2.4151250000000005E-001,
      -0.245,
      -2.4851250000000003E-001,
      -2.5205000000000005E-001,
      -0.2556125,
      -2.5920000000000004E-001,
      -2.6281250000000006E-001,
      -0.26645,
      -2.7011250000000003E-001,
      -2.7380000000000004E-001,
      -2.7751250000000005E-001,
      -2.8125000000000006E-001,
      -2.8501250000000006E-001,
      -2.8880000000000006E-001,
      -2.9261250000000005E-001,
      -2.9645000000000010E-001,
      -3.0031250000000009E-001,
      -3.0419999999999997E-001,
      -3.0811249999999996E-001,
      -3.1204999999999994E-001,
      -0.3160125,
      -0.32,
      -0.3240125,
      -3.2804999999999995E-001,
      -3.3211250000000003E-001,
      -0.3362,
      -0.3403125,
      -3.4445000000000003E-001,
      -3.4861250000000005E-001,
      -0.3528,
      -0.3570125,
      -0.36125,
      -0.3655125,
      -3.6980000000000007E-001,
      -0.3741125,
      -3.7845000000000006E-001,
      -3.8281250000000006E-001,
      -3.8720000000000004E-001,
      -3.9161250000000009E-001,
      -0.39605,
      -0.4005125,
      -4.0499999999999997E-001,
      -4.0951249999999995E-001,
      -0.41405,
      -4.1861249999999989E-001,
      -4.2319999999999991E-001,
      -4.2781249999999993E-001,
      -0.43245,
      -4.3711249999999996E-001,
      -4.4179999999999997E-001,
      -0.4465125,
      -4.5124999999999993E-001,
      -4.5601249999999993E-001,
      -4.6079999999999993E-001,
      -4.6561250000000004E-001,
      -0.47045,
      -0.4753125,
      -0.4802,
      -4.8511249999999995E-001,
      -0.49005,
      -4.9501249999999997E-001,
      -0.5,
      -0.505,
      -0.51,
      -0.515,
      -0.52,
      -0.525,
      -0.53,
      -5.3499999999999992E-001,
      -0.54,
      -0.545,
      -0.55,
      -5.5499999999999994E-001,
      -5.5999999999999994E-001,
      -5.6500000000000006E-001,
      -5.7000000000000006E-001,
      -0.575,
      -0.58,
      -0.585,
      -5.9000000000000008E-001,
      -0.595,
      -0.6,
      -0.605,
      -0.61,
      -6.1500000000000010E-001,
      -0.62,
      -0.625,
      -0.63,
      -6.3499999999999990E-001,
      -0.64,
      -0.645,
      -0.65,
      -0.655,
      -6.5999999999999992E-001,
      -0.665,
      -0.67,
      -0.675,
      -0.68,
      -6.8499999999999994E-001,
      -6.9000000000000006E-001,
      -6.9500000000000006E-001,
      -0.7,
      -0.705,
      -0.71,
      -7.1500000000000008E-001,
      -0.72,
      -0.725,
      -0.73,
      -0.735,
      -0.74,
      -0.745,
      -0.75,
      -0.755,
      -0.76,
      -0.765,
      -0.77,
      -0.775,
      -7.7999999999999992E-001,
      -0.785,
      -0.79,
      -0.795,
      -0.8,
      -8.0499999999999994E-001,
      -8.0999999999999994E-001,
      -8.1500000000000006E-001,
      -0.82,
      -8.2500000000000007E-001,
      -0.83,
      -0.835,
      -8.4000000000000008E-001,
      -0.845,
      -8.5000000000000009E-001,
      -0.855,
      -0.86,
      -8.6500000000000010E-001,
      -0.87,
      -0.875,
      -0.88,
      -8.8499999999999990E-001,
      -8.9000000000000012E-001,
      -0.895,
      -0.9,
      -0.905,
      -9.0999999999999992E-001,
      -9.1500000000000015E-001,
      -0.92,
      -0.925,
      -0.93,
      -9.3499999999999994E-001,
      -0.94,
      -9.4500000000000006E-001,
      -0.95,
      -0.955,
      -0.96,
      -0.965,
      -9.7000000000000008E-001,
      -0.975,
      -0.98,
      -0.985,
      -0.99,
      -9.9500000000000011E-001,
      -1.0,
      -1.0050000000000001E+000,
      -1.01,
      -1.015,
      -1.02,
      -1.0250000000000001E+000,
      -1.03,
      -1.035,
      -1.04,
      -1.0450000000000002E+000,
      -1.05,
      -1.055,
      -1.0599999999999998E+000,
      -1.065,
      -1.07,
      -1.0750000000000002E+000,
      -1.08,
      -1.085,
      -1.09,
      -1.0950000000000002E+000,
      -1.1,
      -1.105,
      -1.1099999999999999E+000,
      -1.1149999999999998E+000,
      -1.1199999999999999E+000,
      -1.1250000000000002E+000,
      -1.1300000000000001E+000,
      -1.135,
      -1.14,
      -1.145,
      -1.1500000000000001E+000,
      -1.155,
      -1.16,
      -1.1649999999999998E+000,
      -1.17,
      -1.1750000000000003E+000,
      -1.1800000000000002E+000,
      -1.185,
      -1.19,
      -1.195,
      -1.2000000000000002E+000,
      -1.205,
      -1.21,
      -1.2149999999999999E+000,
      -1.22,
      -1.2249999999999999E+000,
      -1.2300000000000002E+000,
      -1.235,
      -1.24,
      -1.2449999999999999E+000,
      -1.25,
      -1.2550000000000001E+000,
      -1.26,
      -1.265,
      -1.2699999999999998E+000,
      -1.2750000000000001E+000,
      -1.2800000000000002E+000,
      -1.2850000000000001E+000,
      -1.29,
      -1.295,
      -1.3,
      -1.3050000000000002E+000,
      -1.31,
      -1.315,
      -1.3199999999999998E+000,
      -1.3250000000000002E+000,
      -1.3300000000000003E+000,
      -1.3350000000000002E+000,
      -1.34,
      -1.345,
      -1.35,
      -1.3550000000000002E+000,
      -1.36,
      -1.365,
      -1.3699999999999999E+000,
      -1.3750000000000002E+000,
      -1.38,
      -1.385,
      -1.3900000000000001E+000,
      -1.395,
      -1.4,
      -1.4049999999999998E+000,
      -1.41,
      -1.415,
      -1.42,
      -1.4249999999999998E+000,
      -1.43,
      -1.435,
      -1.4400000000000002E+000,
      -1.445,
      -1.45,
      -1.4549999999999998E+000,
      -1.46,
      -1.465,
      -1.47,
      -1.4749999999999999E+000,
      -1.48,
      -1.485,
      -1.4900000000000002E+000,
      -1.495,
      -1.5,
      -1.505,
      -1.51,
      -1.5150000000000001E+000,
      -1.52,
      -1.5250000000000001E+000,
      -1.53,
      -1.5350000000000001E+000,
      -1.5400000000000003E+000,
      -1.545,
      -1.55,
      -1.555,
      -1.5599999999999998E+000,
      -1.565,
      -1.5699999999999998E+000,
      -1.5750000000000002E+000,
      -1.58,
      -1.585,
      -1.59,
      -1.595,
      -1.6,
      -1.605,
      -1.6099999999999999E+000,
      -1.615,
      -1.6199999999999999E+000,
      -1.6250000000000002E+000,
      -1.6300000000000001E+000,
      -1.635,
      -1.6400000000000001E+000,
      -1.645,
      -1.6500000000000001E+000,
      -1.655,
      -1.66,
      -1.665,
      -1.67,
      -1.6750000000000003E+000,
      -1.6800000000000002E+000,
      -1.685,
      -1.6900000000000002E+000,
      -1.695,
      -1.7,
      -1.7049999999999998E+000,
      -1.71,
      -1.7149999999999999E+000,
      -1.72,
      -1.7249999999999999E+000,
      -1.73,
      -1.735,
      -1.74,
      -1.745,
      -1.75,
      -1.755,
      -1.76,
      -1.765,
      -1.77,
      -1.7750000000000001E+000,
      -1.78,
      -1.7850000000000001E+000,
      -1.79,
      -1.7950000000000002E+000,
      -1.8,
      -1.805,
      -1.81,
      -1.815,
      -1.82,
      -1.8250000000000002E+000,
      -1.83,
      -1.8350000000000002E+000,
      -1.84,
      -1.8450000000000002E+000,
      -1.85,
      -1.855,
      -1.86,
      -1.865,
      -1.87,
      -1.8750000000000002E+000,
      -1.8800000000000001E+000,
      -1.8850000000000002E+000,
      -1.8900000000000001E+000,
      -1.8950000000000002E+000,
      -1.9000000000000001E+000,
      -1.905,
      -1.9100000000000001E+000,
      -1.915,
      -1.9200000000000002E+000,
      -1.9250000000000003E+000,
      -1.9300000000000002E+000,
      -1.9350000000000003E+000,
      -1.9400000000000002E+000,
      -1.9449999999999998E+000,
      -1.95,
      -1.9549999999999998E+000,
      -1.96,
      -1.9649999999999999E+000,
      -1.9699999999999998E+000,
      -1.9749999999999999E+000,
      -1.98,
      -1.985,
      -1.99,
      -1.9949999999999999E+000,
      -2.0,
      -2.005,
      -2.0100000000000002E+000,
      -2.015,
      -2.02,
      -2.025,
      -2.03,
      -2.035,
      -2.04,
      -2.045,
      -2.0500000000000003E+000,
      -2.055,
      -2.06,
      -2.065,
      -2.07,
      -2.075,
      -2.08,
      -2.085,
      -2.0900000000000003E+000,
      -2.0949999999999998E+000,
      -2.1,
      -2.105,
      -2.11,
      -2.115,
      -2.1199999999999997E+000,
      -2.125,
      -2.13,
      -2.135,
      -2.14,
      -2.1449999999999996E+000,
      -2.1500000000000004E+000,
      -2.1550000000000002E+000,
      -2.16,
      -2.1650000000000005E+000,
      -2.17,
      -2.1750000000000003E+000,
      -2.18,
      -2.185,
      -2.1900000000000004E+000,
      -2.195,
      -2.2,
      -2.205,
      -2.21,
      -2.2150000000000003E+000,
      -2.2199999999999998E+000,
      -2.225,
      -2.23,
      -2.235,
      -2.24,
      -2.2449999999999997E+000,
      -2.2500000000000004E+000,
      -2.2550000000000003E+000,
      -2.2600000000000002E+000,
      -2.265,
      -2.27,
      -2.2750000000000004E+000,
      -2.28,
      -2.285,
      -2.29,
      -2.295,
      -2.3000000000000003E+000,
      -2.3049999999999997E+000,
      -2.31,
      -2.315,
      -2.32,
      -2.325,
      -2.3299999999999996E+000,
      -2.335,
      -2.34,
      -2.3449999999999998E+000,
      -2.3500000000000005E+000,
      -2.355,
      -2.3600000000000003E+000,
      -2.365,
      -2.37,
      -2.375,
      -2.38,
      -2.3850000000000002E+000,
      -2.39,
      -2.395,
      -2.4,
      -2.405,
      -2.41,
      -2.415,
      -2.42,
      -2.425,
      -2.4299999999999997E+000,
      -2.435,
      -2.44,
      -2.445,
      -2.4499999999999997E+000,
      -2.455,
      -2.4600000000000004E+000,
      -2.4650000000000003E+000,
      -2.47,
      -2.475,
      -2.48,
      -2.4850000000000003E+000,
      -2.49,
      -2.495,
      -2.5,
      -2.505,
      -2.5100000000000002E+000,
      -2.515,
      -2.52,
      -2.525,
      -2.53,
      -2.535,
      -2.54,
      -2.545,
      -2.5500000000000003E+000,
      -2.555,
      -2.5600000000000005E+000,
      -2.5650000000000004E+000,
      -2.5700000000000003E+000,
      -2.575,
      -2.58,
      -2.585,
      -2.59,
      -2.5949999999999998E+000,
      -2.6,
      -2.605,
      -2.61,
      -2.6149999999999998E+000,
      -2.6199999999999997E+000,
      -2.625,
      -2.63,
      -2.635,
      -2.6399999999999997E+000,
      -2.6449999999999996E+000,
      -2.6500000000000004E+000,
      -2.6550000000000002E+000,
      -2.66,
      -2.665,
      -2.67,
      -2.6750000000000003E+000,
      -2.68,
      -2.685,
      -2.69,
      -2.695,
      -2.7,
      -2.705,
      -2.71,
      -2.715,
      -2.7199999999999998E+000,
      -2.725,
      -2.73,
      -2.735,
      -2.7399999999999998E+000,
      -2.7449999999999997E+000,
      -2.7500000000000004E+000,
      -2.7550000000000003E+000,
      -2.7600000000000002E+000,
      -2.765,
      -2.77,
      -2.7750000000000004E+000,
      -2.7800000000000002E+000,
      -2.785,
      -2.79,
      -2.795,
      -2.8000000000000003E+000,
      -2.805,
      -2.81,
      -2.815,
      -2.82,
      -2.825,
      -2.83,
      -2.835,
      -2.84,
      -2.8449999999999998E+000,
      -2.8500000000000005E+000,
      -2.8550000000000004E+000,
      -2.8600000000000003E+000,
      -2.865,
      -2.87,
      -2.8750000000000004E+000,
      -2.8800000000000003E+000,
      -2.8850000000000002E+000,
      -2.89,
      -2.895,
      -2.9,
      -2.905,
      -2.9099999999999997E+000,
      -2.915,
      -2.92,
      -2.925,
      -2.9299999999999997E+000,
      -2.9349999999999996E+000,
      -2.94,
      -2.945,
      -2.9499999999999997E+000,
      -2.955,
      -2.96,
      -2.9650000000000003E+000,
      -2.97,
      -2.975,
      -2.98,
      -2.985,
      -2.99,
      -2.995,
      -3.0,
      -3.005,
      -3.01,
      -3.015,
      -3.02,
      -3.025,
      -3.03,
      -3.0349999999999997E+000,
      -3.04,
      -3.045,
      -3.0500000000000003E+000,
      -3.055,
      -3.06,
      -3.0650000000000004E+000,
      -3.0700000000000003E+000,
      -3.075,
      -3.08,
      -3.085,
      -3.0900000000000003E+000,
      -3.095,
      -3.1,
      -3.105,
      -3.11,
      -3.115,
      -3.12,
      -3.125,
      -3.13,
      -3.135,
      -3.14,
      -3.145,
      -3.1500000000000004E+000,
      -3.1550000000000002E+000,
      -3.16,
      -3.1650000000000005E+000,
      -3.1700000000000004E+000,
      -3.1750000000000003E+000,
      -3.18,
      -3.185,
      -3.1900000000000004E+000,
      -3.1950000000000003E+000,
      -3.2,
      -3.205,
      -3.21,
      -3.2150000000000003E+000,
      -3.22,
      -3.225,
      -3.23,
      -3.235,
      -3.24,
      -3.245,
      -3.2500000000000004E+000,
      -3.2550000000000003E+000,
      -3.2600000000000002E+000,
      -3.2650000000000006E+000,
      -3.2700000000000005E+000,
      -3.2750000000000004E+000,
      -3.2800000000000002E+000,
      -3.285,
      -3.2900000000000005E+000,
      -3.2950000000000004E+000,
      -3.3000000000000003E+000,
      -3.305,
      -3.31,
      -3.3150000000000004E+000,
      -3.3200000000000003E+000,
      -3.325,
      -3.33,
      -3.335,
      -3.3400000000000003E+000,
      -3.345,
      -3.3500000000000005E+000,
      -3.3550000000000004E+000,
      -3.3600000000000003E+000,
      -3.3650000000000007E+000,
      -3.3700000000000006E+000,
      -3.3750000000000004E+000,
      -3.3800000000000003E+000,
      -3.385,
      -3.3899999999999997E+000,
      -3.395,
      -3.4,
      -3.405,
      -3.4099999999999997E+000,
      -3.4149999999999996E+000,
      -3.42,
      -3.425,
      -3.4299999999999997E+000,
      -3.4349999999999996E+000,
      -3.4399999999999995E+000,
      -3.445,
      -3.4499999999999997E+000,
      -3.455,
      -3.46,
      -3.465,
      -3.47,
      -3.475,
      -3.48,
      -3.485,
      -3.4899999999999998E+000,
      -3.495,
      -3.5,
      -3.505,
      -3.51,
      -3.5149999999999997E+000,
      -3.52,
      -3.525,
      -3.53,
      -3.5349999999999997E+000,
      -3.5399999999999996E+000,
      -3.545,
      -3.5500000000000003E+000,
      -3.555,
      -3.56,
      -3.565,
      -3.5700000000000003E+000,
      -3.575,
      -3.58,
      -3.585,
      -3.59,
      -3.595,
      -3.6,
      -3.605,
      -3.61,
      -3.6149999999999998E+000,
      -3.62,
      -3.625,
      -3.63,
      -3.635,
      -3.6399999999999997E+000,
      -3.645,
      -3.6500000000000004E+000,
      -3.6550000000000002E+000,
      -3.66,
      -3.665,
      -3.6700000000000004E+000,
      -3.6750000000000003E+000,
      -3.68,
      -3.685,
      -3.69,
      -3.6950000000000003E+000,
      -3.7,
      -3.705,
      -3.71,
      -3.715,
      -3.72,
      -3.725,
      -3.73,
      -3.735,
      -3.7399999999999998E+000,
      -3.745,
      -3.7500000000000004E+000,
      -3.7550000000000003E+000,
      -3.7600000000000002E+000,
      -3.765,
      -3.7700000000000005E+000,
      -3.7750000000000004E+000,
      -3.7800000000000002E+000,
      -3.785,
      -3.79,
      -3.7950000000000004E+000,
      -3.8000000000000003E+000,
      -3.805,
      -3.81,
      -3.815,
      -3.8200000000000003E+000,
      -3.825,
      -3.83,
      -3.835,
      -3.84,
      -3.845,
      -3.8500000000000005E+000,
      -3.8550000000000004E+000,
      -3.8600000000000003E+000,
      -3.865,
      -3.8700000000000006E+000,
      -3.8750000000000004E+000,
      -3.8800000000000003E+000,
      -3.8850000000000002E+000,
      -3.89,
      -3.8950000000000005E+000,
      -3.9000000000000004E+000,
      -3.9050000000000002E+000,
      -3.91,
      -3.915,
      -3.9200000000000004E+000,
      -3.9250000000000003E+000,
      -3.93,
      -3.935,
      -3.94,
      -3.9450000000000003E+000,
      -3.9500000000000006E+000,
      -3.9550000000000005E+000,
      -3.9600000000000004E+000,
      -3.9650000000000003E+000,
      -3.9700000000000006E+000,
      -3.9750000000000005E+000,
      -3.9800000000000004E+000,
      -3.9850000000000003E+000,
      -3.99,
      -3.9950000000000006E+000,
      -4.0000000000000009E+000,
      -4.0050000000000008E+000,
      -4.0100000000000007E+000,
      -4.0150000000000006E+000,
      -4.02,
      -4.025,
      -4.03,
      -4.035,
      -4.04,
      -4.045,
      -4.05,
      -4.055,
      -4.06,
      -4.0649999999999995E+000,
      -4.0699999999999994E+000,
      -4.075,
      -4.08,
      -4.085,
      -4.09,
      -4.095,
      -4.1000000000000005E+000,
      -4.105,
      -4.11,
      -4.115,
      -4.12,
      -4.125,
      -4.13,
      -4.135,
      -4.14,
      -4.145,
      -4.15,
      -4.155,
      -4.16,
      -4.165,
      -4.17,
      -4.175,
      -4.1800000000000006E+000,
      -4.185,
      -4.1899999999999995E+000,
      -4.1949999999999994E+000,
      -4.2,
      -4.205,
      -4.21,
      -4.2150000000000007E+000,
      -4.22,
      -4.2250000000000005E+000,
      -4.23,
      -4.235,
      -4.2399999999999993E+000,
      -4.245,
      -4.25,
      -4.255,
      -4.26,
      -4.2650000000000006E+000,
      -4.27,
      -4.2749999999999995E+000,
      -4.28,
      -4.285,
      -4.2899999999999991E+000,
      -4.295,
      -4.3000000000000007E+000,
      -4.305,
      -4.3100000000000005E+000,
      -4.315,
      -4.32,
      -4.3249999999999993E+000,
      -4.3300000000000010E+000,
      -4.335,
      -4.34,
      -4.345,
      -4.3500000000000005E+000,
      -4.3549999999999995E+000,
      -4.36,
      -4.365,
      -4.37,
      -4.3749999999999991E+000,
      -4.3800000000000008E+000,
      -4.385,
      -4.39,
      -4.395,
      -4.4,
      -4.405,
      -4.41,
      -4.4150000000000009E+000,
      -4.42,
      -4.425,
      -4.4300000000000006E+000,
      -4.4350000000000005E+000,
      -4.4399999999999995E+000,
      -4.445,
      -4.45,
      -4.455,
      -4.46,
      -4.4650000000000007E+000,
      -4.47,
      -4.475,
      -4.48,
      -4.485,
      -4.4899999999999993E+000,
      -4.495,
      -4.5000000000000009E+000,
      -4.505,
      -4.5100000000000007E+000,
      -4.5150000000000006E+000,
      -4.5200000000000005E+000,
      -4.5249999999999995E+000,
      -4.5300000000000011E+000,
      -4.535,
      -4.54,
      -4.545,
      -4.5500000000000007E+000,
      -4.555,
      -4.5600000000000005E+000,
      -4.565,
      -4.57,
      -4.5749999999999993E+000,
      -4.5800000000000010E+000,
      -4.585,
      -4.59,
      -4.595,
      -4.6000000000000005E+000,
      -4.605,
      -4.61,
      -4.6150000000000011E+000,
      -4.62,
      -4.625,
      -4.6300000000000008E+000,
      -4.6350000000000007E+000,
      -4.64,
      -4.6450000000000005E+000,
      -4.65,
      -4.655,
      -4.66,
      -4.665,
      -4.67,
      -4.675,
      -4.6799999999999988E+000,
      -4.6850000000000005E+000,
      -4.6899999999999995E+000,
      -4.6949999999999994E+000,
      -4.7000000000000011E+000,
      -4.705,
      -4.71,
      -4.7149999999999990E+000,
      -4.7200000000000006E+000,
      -4.725,
      -4.7299999999999995E+000,
      -4.735,
      -4.74,
      -4.7449999999999992E+000,
      -4.7500000000000009E+000,
      -4.755,
      -4.76,
      -4.7649999999999988E+000,
      -4.7700000000000005E+000,
      -4.7749999999999995E+000,
      -4.7799999999999994E+000,
      -4.785,
      -4.79,
      -4.7949999999999990E+000,
      -4.8000000000000007E+000,
      -4.8050000000000006E+000,
      -4.81,
      -4.8149999999999995E+000,
      -4.82,
      -4.825,
      -4.8299999999999992E+000,
      -4.8350000000000009E+000,
      -4.84,
      -4.845,
      -4.8500000000000005E+000,
      -4.855,
      -4.8599999999999994E+000,
      -4.8649999999999993E+000,
      -4.87,
      -4.875,
      -4.8799999999999990E+000,
      -4.8850000000000007E+000,
      -4.89,
      -4.895,
      -4.9000000000000012E+000,
      -4.905,
      -4.91,
      -4.9149999999999991E+000,
      -4.9200000000000008E+000,
      -4.925,
      -4.93,
      -4.9350000000000005E+000,
      -4.94,
      -4.9449999999999994E+000,
      -4.9500000000000011E+000,
      -4.955,
      -4.96,
      -4.9649999999999990E+000,
      -4.9700000000000006E+000,
      -4.975,
      -4.9799999999999995E+000,
      -4.985,
      -4.99,
      -4.9949999999999992E+000,
      -5.0000000000000009E+000,
      -5.0050000000000008E+000,
      -5.01,
      -5.015,
      -5.0200000000000005E+000,
      -5.025,
      -5.0299999999999994E+000,
      -5.0350000000000010E+000,
      -5.04,
      -5.045,
      -5.0500000000000007E+000,
      -5.0550000000000006E+000,
      -5.06,
      -5.0649999999999995E+000,
      -5.07,
      -5.075,
      -5.0799999999999992E+000,
      -5.0850000000000009E+000,
      -5.09,
      -5.095,
      -5.1000000000000014E+000,
      -5.105,
      -5.11,
      -5.1149999999999993E+000,
      -5.1200000000000010E+000,
      -5.125,
      -5.13,
      -5.1350000000000007E+000,
      -5.1400000000000006E+000,
      -5.145,
      -5.1500000000000012E+000,
      -5.155,
      -5.16,
      -5.1649999999999991E+000,
      -5.1700000000000008E+000,
      -5.175,
      -5.18,
      -5.1850000000000005E+000,
      -5.19,
      -5.1949999999999994E+000,
      -5.2000000000000011E+000,
      -5.2050000000000010E+000,
      -5.21,
      -5.215,
      -5.2200000000000006E+000,
      -5.2250000000000005E+000,
      -5.2299999999999995E+000,
      -5.2350000000000012E+000,
      -5.24,
      -5.245,
      -5.2500000000000009E+000,
      -5.2550000000000008E+000,
      -5.26,
      -5.265,
      -5.2700000000000005E+000,
      -5.275,
      -5.2799999999999994E+000,
      -5.2850000000000010E+000,
      -5.29,
      -5.295,
      -5.2999999999999989E+000,
      -5.3050000000000006E+000,
      -5.3100000000000005E+000,
      -5.3149999999999995E+000,
      -5.3199999999999994E+000,
      -5.325,
      -5.33,
      -5.3349999999999991E+000,
      -5.3400000000000007E+000,
      -5.345,
      -5.35,
      -5.355,
      -5.36,
      -5.3649999999999993E+000,
      -5.3699999999999992E+000,
      -5.375,
      -5.38,
      -5.3849999999999989E+000,
      -5.3900000000000006E+000,
      -5.395,
      -5.3999999999999995E+000,
      -5.4050000000000011E+000,
      -5.41,
      -5.415,
      -5.4199999999999990E+000,
      -5.4250000000000007E+000,
      -5.43,
      -5.435,
      -5.44,
      -5.445,
      -5.4499999999999993E+000,
      -5.4550000000000010E+000,
      -5.46,
      -5.465,
      -5.4699999999999989E+000,
      -5.4750000000000005E+000,
      -5.4799999999999995E+000,
      -5.4849999999999994E+000,
      -5.49,
      -5.495,
      -5.4999999999999991E+000,
      -5.5050000000000008E+000,
      -5.5100000000000007E+000,
      -5.515,
      -5.52,
      -5.525,
      -5.53,
      -5.5350000000000010E+000,
      -5.5400000000000009E+000,
      -5.545,
      -5.55,
      -5.5550000000000006E+000,
      -5.5600000000000005E+000,
      -5.5649999999999995E+000,
      -5.5699999999999994E+000,
      -5.575,
      -5.58,
      -5.5850000000000009E+000,
      -5.5900000000000007E+000,
      -5.595,
      -5.6,
      -5.6050000000000013E+000,
      -5.61,
      -5.615,
      -5.6199999999999992E+000,
      -5.6249999999999991E+000,
      -5.63,
      -5.635,
      -5.6400000000000006E+000,
      -5.6450000000000005E+000,
      -5.6499999999999995E+000,
      -5.6549999999999994E+000,
      -5.66,
      -5.665,
      -5.6699999999999990E+000,
      -5.6749999999999989E+000,
      -5.68,
      -5.685,
      -5.69,
      -5.695,
      -5.6999999999999993E+000,
      -5.7049999999999992E+000,
      -5.7100000000000009E+000,
      -5.715,
      -5.72,
      -5.7249999999999988E+000,
      -5.73,
      -5.7349999999999994E+000,
      -5.7400000000000011E+000,
      -5.745,
      -5.75,
      -5.7549999999999990E+000,
      -5.7600000000000007E+000,
      -5.765,
      -5.77,
      -5.7749999999999986E+000,
      -5.78,
      -5.7849999999999993E+000,
      -5.7900000000000009E+000,
      -5.795,
      -5.8,
      -5.8049999999999988E+000,
      -5.8100000000000005E+000,
      -5.815,
      -5.8199999999999994E+000,
      -5.8249999999999993E+000,
      -5.83,
      -5.835,
      -5.8400000000000007E+000,
      -5.8450000000000006E+000,
      -5.85,
      -5.8549999999999995E+000,
      -5.86,
      -5.865,
      -5.8699999999999992E+000,
      -5.8749999999999991E+000,
      -5.88,
      -5.885,
      -5.8900000000000006E+000,
      -5.8950000000000005E+000,
      -5.8999999999999995E+000,
      -5.9049999999999994E+000,
      -5.9100000000000010E+000,
      -5.915,
      -5.92,
      -5.9249999999999989E+000,
      -5.9300000000000006E+000,
      -5.935,
      -5.9400000000000013E+000,
      -5.945,
      -5.95,
      -5.9549999999999992E+000,
      -5.9600000000000009E+000,
      -5.965,
      -5.97,
      -5.9749999999999988E+000,
      -5.98,
      -5.9849999999999994E+000,
      -5.9900000000000011E+000,
      -5.995,
      -6.0,
      -6.005,
      -6.0100000000000007E+000,
      -6.0150000000000006E+000,
      -6.02,
      -6.0249999999999995E+000,
      -6.03,
      -6.035,
      -6.0400000000000009E+000,
      -6.0450000000000008E+000,
      -6.05,
      -6.055,
      -6.0600000000000005E+000,
      -6.065,
      -6.0699999999999994E+000,
      -6.0749999999999993E+000,
      -6.08,
      -6.085,
      -6.0900000000000016E+000,
      -6.0950000000000006E+000,
      -6.1000000000000005E+000,
      -6.1049999999999995E+000,
      -6.1100000000000012E+000,
      -6.115,
      -6.12,
      -6.1249999999999991E+000,
      -6.1300000000000008E+000,
      -6.135,
      -6.1400000000000015E+000,
      -6.1450000000000005E+000,
      -6.15,
      -6.1549999999999994E+000,
      -6.1600000000000010E+000,
      -6.165,
      -6.17,
      -6.1749999999999989E+000,
      -6.1800000000000006E+000,
      -6.185,
      -6.1900000000000013E+000,
      -6.1950000000000012E+000,
      -6.2,
      -6.205,
      -6.2100000000000009E+000,
      -6.2150000000000007E+000,
      -6.22,
      -6.225,
      -6.23,
      -6.235,
      -6.2400000000000011E+000,
      -6.2450000000000010E+000,
      -6.25,
      -6.255,
      -6.2600000000000007E+000,
      -6.2650000000000006E+000,
      -6.27,
      -6.2749999999999995E+000,
      -6.2799999999999985E+000,
      -6.285,
      -6.2899999999999991E+000,
      -6.2950000000000008E+000,
      -6.3000000000000007E+000,
      -6.305,
      -6.31,
      -6.315,
      -6.32,
      -6.3249999999999993E+000,
      -6.3299999999999992E+000,
      -6.335,
      -6.34,
      -6.3450000000000006E+000,
      -6.3500000000000005E+000,
      -6.3549999999999995E+000,
      -6.3599999999999994E+000,
      -6.365,
      -6.37,
      -6.3749999999999991E+000,
      -6.3799999999999990E+000,
      -6.385,
      -6.39,
      -6.3950000000000014E+000,
      -6.4,
      -6.405,
      -6.4099999999999993E+000,
      -6.4150000000000009E+000,
      -6.42,
      -6.425,
      -6.4299999999999988E+000,
      -6.4350000000000005E+000,
      -6.4399999999999995E+000,
      -6.4450000000000012E+000,
      -6.45,
      -6.455,
      -6.4599999999999991E+000,
      -6.4650000000000007E+000,
      -6.47,
      -6.475,
      -6.4799999999999986E+000,
      -6.485,
      -6.4899999999999993E+000,
      -6.4950000000000010E+000,
      -6.5000000000000009E+000,
      -6.505,
      -6.51,
      -6.5150000000000006E+000,
      -6.5200000000000005E+000,
      -6.5249999999999995E+000,
      -6.5299999999999994E+000,
      -6.535,
      -6.54,
      -6.5450000000000008E+000,
      -6.5500000000000007E+000,
      -6.555,
      -6.56,
      -6.565,
      -6.57,
      -6.5749999999999993E+000,
      -6.5799999999999992E+000,
      -6.585,
      -6.59,
      -6.5950000000000015E+000,
      -6.6000000000000005E+000,
      -6.605,
      -6.6099999999999994E+000,
      -6.6150000000000011E+000,
      -6.62,
      -6.625,
      -6.6299999999999990E+000,
      -6.6350000000000007E+000,
      -6.64,
      -6.6450000000000014E+000,
      -6.65,
      -6.655,
      -6.6599999999999993E+000,
      -6.6650000000000009E+000,
      -6.67,
      -6.675,
      -6.6799999999999988E+000,
      -6.6850000000000005E+000,
      -6.6899999999999995E+000,
      -6.6950000000000012E+000,
      -6.7000000000000011E+000,
      -6.705,
      -6.71,
      -6.7150000000000007E+000,
      -6.7200000000000006E+000,
      -6.725,
      -6.7299999999999995E+000,
      -6.735,
      -6.74,
      -6.7450000000000010E+000,
      -6.7500000000000009E+000,
      -6.755,
      -6.76,
      -6.7650000000000006E+000,
      -6.7700000000000005E+000,
      -6.7749999999999995E+000,
      -6.7799999999999994E+000,
      -6.785,
      -6.79,
      -6.7950000000000017E+000,
      -6.8000000000000007E+000,
      -6.8050000000000006E+000,
      -6.81,
      -6.8150000000000013E+000,
      -6.82,
      -6.825,
      -6.8299999999999992E+000,
      -6.8350000000000009E+000,
      -6.84,
      -6.8450000000000015E+000,
      -6.8500000000000005E+000,
      -6.855,
      -6.8599999999999994E+000,
      -6.8650000000000011E+000,
      -6.87,
      -6.875,
      -6.8799999999999990E+000,
      -6.8850000000000007E+000,
      -6.89,
      -6.8950000000000014E+000,
      -6.9000000000000012E+000,
      -6.905,
      -6.91,
      -6.9149999999999991E+000,
      -6.9200000000000008E+000,
      -6.925,
      -6.93,
      -6.9349999999999987E+000,
      -6.94,
      -6.9449999999999994E+000,
      -6.9500000000000011E+000,
      -6.955,
      -6.96,
      -6.9649999999999990E+000,
      -6.9700000000000006E+000,
      -6.975,
      -6.9799999999999995E+000,
      -6.9849999999999985E+000,
      -6.99,
      -6.9949999999999992E+000,
      -7.0000000000000009E+000,
      -7.0050000000000008E+000,
      -7.01,
      -7.015,
      -7.0200000000000005E+000,
      -7.025,
      -7.0299999999999994E+000,
      -7.0349999999999993E+000,
      -7.04,
      -7.045,
      -7.0500000000000007E+000,
      -7.0550000000000006E+000,
      -7.06,
      -7.0649999999999995E+000,
      -7.07,
      -7.075,
      -7.0799999999999992E+000,
      -7.0849999999999991E+000,
      -7.09,
      -7.095,
      -7.1000000000000014E+000,
      -7.105,
      -7.11,
      -7.1149999999999993E+000,
      -7.1200000000000010E+000,
      -7.125,
      -7.13,
      -7.1349999999999989E+000,
      -7.1400000000000006E+000,
      -7.145,
      -7.1500000000000012E+000,
      -7.155,
      -7.16,
      -7.1649999999999991E+000,
      -7.1700000000000008E+000,
      -7.175,
      -7.18,
      -7.1849999999999987E+000,
      -7.19,
      -7.1949999999999994E+000,
      -7.2000000000000011E+000,
      -7.2050000000000010E+000,
      -7.21,
      -7.215,
      -7.2200000000000006E+000,
      -7.2250000000000005E+000,
      -7.2299999999999995E+000,
      -7.2349999999999994E+000,
      -7.24,
      -7.245,
      -7.2500000000000009E+000,
      -7.2550000000000008E+000,
      -7.26,
      -7.265,
      -7.2700000000000005E+000,
      -7.275,
      -7.2799999999999994E+000,
      -7.2849999999999993E+000,
      -7.29,
      -7.295,
      -7.3000000000000016E+000,
      -7.3050000000000006E+000,
      -7.3100000000000005E+000,
      -7.3149999999999995E+000,
      -7.3200000000000012E+000,
      -7.325,
      -7.33,
      -7.3349999999999991E+000,
      -7.3400000000000007E+000,
      -7.345,
      -7.3500000000000014E+000,
      -7.355,
      -7.36,
      -7.3649999999999993E+000,
      -7.3700000000000010E+000,
      -7.375,
      -7.38,
      -7.3849999999999989E+000,
      -7.3900000000000006E+000,
      -7.395,
      -7.4000000000000012E+000,
      -7.4050000000000011E+000,
      -7.41,
      -7.415,
      -7.4200000000000008E+000,
      -7.4250000000000007E+000,
      -7.43,
      -7.435,
      -7.44,
      -7.445,
      -7.4500000000000011E+000,
      -7.4550000000000010E+000,
      -7.46,
      -7.465,
      -7.4700000000000006E+000,
      -7.4750000000000005E+000,
      -7.4799999999999995E+000,
      -7.4849999999999994E+000,
      -7.49,
      -7.495,
      -7.5000000000000018E+000,
      -7.5050000000000008E+000,
      -7.5100000000000007E+000,
      -7.515,
      -7.5200000000000014E+000,
      -7.525,
      -7.53,
      -7.5349999999999993E+000,
      -7.5399999999999991E+000,
      -7.545,
      -7.55,
      -7.5550000000000006E+000,
      -7.5600000000000005E+000,
      -7.5649999999999995E+000,
      -7.5699999999999994E+000,
      -7.575,
      -7.58,
      -7.5849999999999991E+000,
      -7.5899999999999990E+000,
      -7.595,
      -7.6,
      -7.6050000000000013E+000,
      -7.61,
      -7.615,
      -7.6199999999999992E+000,
      -7.6250000000000009E+000,
      -7.63,
      -7.635,
      -7.6399999999999988E+000,
      -7.6450000000000005E+000,
      -7.6499999999999995E+000,
      -7.6550000000000011E+000,
      -7.66,
      -7.665,
      -7.6699999999999990E+000,
      -7.6750000000000007E+000,
      -7.68,
      -7.685,
      -7.6899999999999986E+000,
      -7.695,
      -7.6999999999999993E+000,
      -7.7050000000000010E+000,
      -7.7100000000000009E+000,
      -7.715,
      -7.72,
      -7.7250000000000005E+000,
      -7.73,
      -7.7349999999999994E+000,
      -7.7399999999999993E+000,
      -7.745,
      -7.75,
      -7.7550000000000008E+000,
      -7.7600000000000007E+000,
      -7.765,
      -7.77,
      -7.775,
      -7.78,
      -7.7849999999999993E+000,
      -7.7899999999999991E+000,
      -7.795,
      -7.8,
      -7.8050000000000015E+000,
      -7.8100000000000005E+000,
      -7.815,
      -7.8199999999999994E+000,
      -7.8250000000000011E+000,
      -7.83,
      -7.835,
      -7.8399999999999990E+000,
      -7.8450000000000006E+000,
      -7.85,
      -7.8550000000000013E+000,
      -7.86,
      -7.865,
      -7.8699999999999992E+000,
      -7.8750000000000009E+000,
      -7.88,
      -7.885,
      -7.8899999999999988E+000,
      -7.8950000000000005E+000,
      -7.8999999999999995E+000,
      -7.9050000000000011E+000,
      -7.9100000000000010E+000,
      -7.915,
      -7.92,
      -7.9250000000000007E+000,
      -7.9300000000000006E+000,
      -7.935,
      -7.9399999999999995E+000,
      -7.945,
      -7.95,
      -7.9550000000000010E+000,
      -7.9600000000000009E+000,
      -7.965,
      -7.97,
      -7.9750000000000005E+000,
      -7.98,
      -7.9849999999999994E+000,
      -7.9899999999999993E+000,
      -7.995,
      -8.0,
      -8.005,
      -8.0100000000000016E+000,
      -8.015,
      -8.02,
      -8.025,
      -8.0300000000000011E+000,
      -8.035,
      -8.04,
      -8.045,
      -8.05,
      -8.0550000000000015E+000,
      -8.06,
      -8.065,
      -8.07,
      -8.0750000000000011E+000,
      -8.08,
      -8.0849999999999991E+000,
      -8.09,
      -8.095,
      -8.1,
      -8.1050000000000022E+000,
      -8.1100000000000012E+000,
      -8.115,
      -8.12,
      -8.1250000000000018E+000,
      -8.13,
      -8.135,
      -8.1399999999999988E+000,
      -8.1450000000000014E+000,
      -8.15,
      -8.1550000000000011E+000,
      -8.16,
      -8.1650000000000009E+000,
      -8.17,
      -8.175,
      -8.18,
      -8.185,
      -8.19,
      -8.1949999999999985E+000,
      -8.2000000000000011E+000,
      -8.205,
      -8.21,
      -8.215,
      -8.22,
      -8.225,
      -8.23,
      -8.235,
      -8.24,
      -8.245,
      -8.25,
      -8.2549999999999990E+000,
      -8.2600000000000016E+000,
      -8.265,
      -8.27,
      -8.2749999999999986E+000,
      -8.2800000000000011E+000,
      -8.285,
      -8.29,
      -8.2949999999999982E+000,
      -8.3,
      -8.305,
      -8.31,
      -8.3150000000000013E+000,
      -8.32,
      -8.325,
      -8.33,
      -8.335,
      -8.34,
      -8.3449999999999989E+000,
      -8.35,
      -8.355,
      -8.3600000000000012E+000,
      -8.365,
      -8.37,
      -8.375,
      -8.38,
      -8.385,
      -8.3899999999999988E+000,
      -8.395,
      -8.4,
      -8.405,
      -8.4100000000000019E+000,
      -8.4150000000000009E+000,
      -8.42,
      -8.4249999999999989E+000,
      -8.4300000000000015E+000,
      -8.435,
      -8.44,
      -8.4449999999999985E+000,
      -8.4500000000000011E+000,
      -8.455,
      -8.46,
      -8.465,
      -8.47,
      -8.475,
      -8.48,
      -8.485,
      -8.49,
      -8.495,
      -8.5,
      -8.505,
      -8.5100000000000016E+000,
      -8.515,
      -8.52,
      -8.525,
      -8.5300000000000011E+000,
      -8.535,
      -8.54,
      -8.545,
      -8.55,
      -8.555,
      -8.56,
      -8.5650000000000013E+000,
      -8.57,
      -8.575,
      -8.58,
      -8.585,
      -8.59,
      -8.5949999999999989E+000,
      -8.6000000000000014E+000,
      -8.605,
      -8.6100000000000012E+000,
      -8.615,
      -8.6200000000000010E+000,
      -8.625,
      -8.63,
      -8.635,
      -8.64,
      -8.645,
      -8.65,
      -8.655,
      -8.6600000000000019E+000,
      -8.6650000000000009E+000,
      -8.67,
      -8.6749999999999989E+000,
      -8.6800000000000015E+000,
      -8.685,
      -8.69,
      -8.6949999999999985E+000,
      -8.7000000000000011E+000,
      -8.705,
      -8.71,
      -8.7150000000000016E+000,
      -8.72,
      -8.725,
      -8.73,
      -8.7350000000000012E+000,
      -8.74,
      -8.745,
      -8.75,
      -8.755,
      -8.7600000000000016E+000,
      -8.765,
      -8.77,
      -8.775,
      -8.7800000000000011E+000,
      -8.785,
      -8.79,
      -8.795,
      -8.8,
      -8.805,
      -8.8100000000000023E+000,
      -8.8150000000000013E+000,
      -8.82,
      -8.825,
      -8.83,
      -8.835,
      -8.84,
      -8.845,
      -8.8500000000000014E+000,
      -8.855,
      -8.86,
      -8.865,
      -8.8700000000000010E+000,
      -8.875,
      -8.8799999999999990E+000,
      -8.885,
      -8.89,
      -8.8950000000000014E+000,
      -8.9,
      -8.9050000000000011E+000,
      -8.91,
      -8.9150000000000009E+000,
      -8.92,
      -8.925,
      -8.93,
      -8.935,
      -8.94,
      -8.9450000000000021E+000,
      -8.9500000000000011E+000,
      -8.955,
      -8.9599999999999991E+000,
      -8.9650000000000016E+000,
      -8.97,
      -8.975,
      -8.9799999999999986E+000,
      -8.9850000000000012E+000,
      -8.99,
      -8.9950000000000010E+000,
      -9.0000000000000018E+000,
      -9.005,
      -9.01,
      -9.015,
      -9.0200000000000014E+000,
      -9.025,
      -9.03,
      -9.035,
      -9.0400000000000009E+000,
      -9.0450000000000017E+000,
      -9.05,
      -9.055,
      -9.06,
      -9.0650000000000013E+000,
      -9.07,
      -9.075,
      -9.08,
      -9.085,
      -9.09,
      -9.0950000000000024E+000,
      -9.1000000000000014E+000,
      -9.105,
      -9.11,
      -9.1150000000000020E+000,
      -9.1200000000000010E+000,
      -9.125,
      -9.1299999999999990E+000,
      -9.1350000000000016E+000,
      -9.14,
      -9.1450000000000014E+000,
      -9.15,
      -9.1550000000000011E+000,
      -9.16,
      -9.1650000000000009E+000,
      -9.17,
      -9.175,
      -9.18,
      -9.185,
      -9.19,
      -9.1950000000000021E+000,
      -9.2000000000000011E+000,
      -9.205,
      -9.21,
      -9.2150000000000016E+000,
      -9.22,
      -9.225,
      -9.23,
      -9.2350000000000012E+000,
      -9.24,
      -9.2450000000000010E+000,
      -9.2500000000000018E+000,
      -9.255,
      -9.26,
      -9.265,
      -9.2700000000000014E+000,
      -9.275,
      -9.28,
      -9.285,
      -9.2900000000000009E+000,
      -9.2950000000000017E+000,
      -9.3,
      -9.3050000000000015E+000,
      -9.31,
      -9.3150000000000013E+000,
      -9.32,
      -9.3250000000000011E+000,
      -9.33,
      -9.335,
      -9.34,
      -9.3450000000000024E+000,
      -9.3500000000000014E+000,
      -9.355,
      -9.36,
      -9.3650000000000020E+000,
      -9.3700000000000010E+000,
      -9.375,
      -9.3799999999999990E+000,
      -9.3850000000000016E+000,
      -9.39,
      -9.3950000000000014E+000,
      -9.4000000000000021E+000,
      -9.4050000000000011E+000,
      -9.41,
      -9.4150000000000009E+000,
      -9.4200000000000017E+000,
      -9.425,
      -9.43,
      -9.435,
      -9.4400000000000013E+000,
      -9.4450000000000021E+000,
      -9.4500000000000011E+000,
      -9.455,
      -9.46,
      -9.465,
      -9.47,
      -9.475,
      -9.48,
      -9.485,
      -9.49,
      -9.495,
      -9.5000000000000018E+000,
      -9.505,
      -9.51,
      -9.515,
      -9.5200000000000014E+000,
      -9.525,
      -9.53,
      -9.535,
      -9.5400000000000009E+000,
      -9.545,
      -9.55,
      -9.5550000000000015E+000,
      -9.56,
      -9.565,
      -9.57,
      -9.5750000000000011E+000,
      -9.58,
      -9.5849999999999991E+000,
      -9.59,
      -9.595,
      -9.6000000000000014E+000,
      -9.605,
      -9.6100000000000012E+000,
      -9.615,
      -9.6200000000000010E+000,
      -9.625,
      -9.63,
      -9.635,
      -9.64,
      -9.645,
      -9.6500000000000021E+000,
      -9.6550000000000011E+000,
      -9.66,
      -9.665,
      -9.6700000000000017E+000,
      -9.675,
      -9.68,
      -9.6849999999999987E+000,
      -9.6900000000000013E+000,
      -9.695,
      -9.7000000000000011E+000,
      -9.7050000000000018E+000,
      -9.71,
      -9.715,
      -9.72,
      -9.7250000000000014E+000,
      -9.73,
      -9.735,
      -9.74,
      -9.7450000000000010E+000,
      -9.7500000000000018E+000,
      -9.755,
      -9.76,
      -9.765,
      -9.7700000000000014E+000,
      -9.775,
      -9.78,
      -9.785,
      -9.7900000000000009E+000,
      -9.795,
      -9.8000000000000025E+000,
      -9.8050000000000015E+000,
      -9.81,
      -9.815,
      -9.8200000000000021E+000,
      -9.8250000000000011E+000,
      -9.83,
      -9.8349999999999991E+000,
      -9.8400000000000016E+000,
      -9.845,
      -9.8500000000000014E+000,
      -9.855,
      -9.8600000000000012E+000,
      -9.865,
      -9.8700000000000010E+000,
      -9.875,
      -9.88,
      -9.885,
      -9.89,
      -9.895,
      -9.9000000000000021E+000,
      -9.9050000000000011E+000,
      -9.91,
      -9.9150000000000009E+000,
      -9.9200000000000017E+000,
      -9.925,
      -9.93,
      -9.935,
      -9.9400000000000013E+000,
      -9.945,
      -9.9500000000000011E+000,
      -9.9550000000000018E+000,
      -9.96,
      -9.965,
      -9.97,
      -9.9750000000000014E+000,
      -9.98,
      -9.985,
      -9.99,
      -9.9950000000000010E+000,
      -1.0000000000000002E+001,
      -10.005,
      -1.0010000000000002E+001,
      -10.015,
      -1.0020000000000001E+001,
      -10.025,
      -1.0030000000000001E+001,
      -10.035,
      -1.0040000000000001E+001,
      -10.045,
      -1.0050000000000002E+001,
      -1.0055000000000001E+001,
      -10.06,
      -10.065,
      -1.0070000000000002E+001,
      -1.0075000000000001E+001,
      -10.08,
      -1.0084999999999999E+001,
      -1.0090000000000002E+001,
      -10.095,
      -10.1,
      -1.0105000000000002E+001,
      -1.0110000000000001E+001,
      -10.115,
      -10.12,
      -1.0125000000000002E+001,
      -10.13,
      -10.135,
      -1.0139999999999999E+001,
      -1.0145000000000001E+001,
      -10.15,
      -1.0155000000000001E+001,
      -10.16,
      -1.0165000000000001E+001,
      -10.17,
      -10.175,
      -10.18,
      -10.185,
      -10.19,
      -10.195,
      -1.0200000000000001E+001,
      -1.0205000000000002E+001,
      -10.21,
      -10.215,
      -10.22,
      -1.0225000000000001E+001,
      -10.23,
      -10.235,
      -10.24,
      -1.0245000000000001E+001,
      -10.25,
      -10.255,
      -1.0260000000000002E+001,
      -10.265,
      -10.27,
      -10.275,
      -1.0280000000000001E+001,
      -10.285,
      -10.29,
      -1.0295000000000002E+001,
      -10.3,
      -1.0305000000000001E+001,
      -10.31,
      -1.0315000000000001E+001,
      -10.32,
      -1.0325000000000001E+001,
      -10.33,
      -10.335,
      -10.34,
      -10.345,
      -10.35,
      -1.0355000000000002E+001,
      -1.0360000000000001E+001,
      -10.365,
      -10.37,
      -1.0375000000000002E+001,
      -10.38,
      -10.385,
      -1.0389999999999999E+001,
      -1.0395000000000001E+001,
      -10.4,
      -1.0405000000000001E+001,
      -1.0410000000000002E+001,
      -1.0415000000000001E+001,
      -10.42,
      -10.425,
      -1.0430000000000001E+001,
      -10.435,
      -10.44,
      -10.445,
      -1.0450000000000001E+001,
      -1.0455000000000002E+001,
      -10.46,
      -10.465,
      -10.47,
      -1.0475000000000001E+001,
      -10.48,
      -10.485,
      -10.49,
      -1.0495000000000001E+001,
      -10.5,
      -10.505,
      -1.0510000000000002E+001,
      -10.515,
      -10.52,
      -10.525,
      -1.0530000000000001E+001,
      -10.535,
      -10.54,
      -10.545,
      -1.0550000000000002E+001,
      -1.0555000000000001E+001,
      -10.56,
      -1.0565000000000001E+001,
      -1.0570000000000002E+001,
      -1.0575000000000001E+001,
      -10.58,
      -10.585,
      -1.0590000000000002E+001,
      -10.595,
      -1.0600000000000001E+001,
      -10.605,
      -1.0610000000000001E+001,
      -10.615,
      -1.0620000000000001E+001,
      -10.625,
      -10.63,
      -10.635,
      -10.64,
      -10.645,
      -1.0650000000000002E+001,
      -1.0655000000000001E+001,
      -1.0660000000000002E+001,
      -1.0665000000000001E+001,
      -1.0670000000000002E+001,
      -10.675,
      -1.0680000000000001E+001,
      -10.685,
      -1.0690000000000001E+001,
      -1.0695000000000002E+001,
      -1.0700000000000001E+001,
      -10.705,
      -10.71,
      -1.0715000000000002E+001,
      -10.72,
      -10.725,
      -10.73,
      -1.0735000000000001E+001,
      -10.74,
      -10.745,
      -1.0749999999999998E+001,
      -1.0755000000000003E+001,
      -1.0760000000000002E+001,
      -10.765,
      -10.77,
      -1.0775000000000002E+001,
      -1.0780000000000001E+001,
      -10.785,
      -10.79,
      -1.0795000000000002E+001,
      -10.8,
      -10.805,
      -10.81,
      -1.0815000000000001E+001,
      -10.82,
      -10.825,
      -10.83,
      -10.835,
      -10.84,
      -1.0844999999999999E+001,
      -10.85,
      -1.0855000000000002E+001,
      -1.0860000000000001E+001,
      -10.865,
      -1.0870000000000001E+001,
      -1.0875000000000002E+001,
      -10.88,
      -10.885,
      -10.89,
      -1.0895000000000001E+001,
      -10.9,
      -1.0905000000000001E+001,
      -10.91,
      -1.0915000000000001E+001,
      -10.92,
      -10.925,
      -10.93,
      -10.935,
      -10.94,
      -10.945,
      -10.95,
      -1.0955000000000002E+001,
      -10.96,
      -1.0965000000000002E+001,
      -10.97,
      -1.0975000000000001E+001,
      -10.98,
      -1.0985000000000001E+001,
      -10.99,
      -1.0995000000000001E+001,
      -1.1000000000000002E+001,
      -11.005,
      -11.01,
      -11.015,
      -1.1020000000000001E+001,
      -11.025,
      -11.03,
      -11.035,
      -1.1040000000000001E+001,
      -11.045,
      -1.1049999999999999E+001,
      -1.1055000000000001E+001,
      -1.1060000000000002E+001,
      -1.1065000000000001E+001,
      -11.07,
      -1.1075000000000001E+001,
      -1.1080000000000002E+001,
      -11.085,
      -11.09,
      -1.1095000000000002E+001,
      -1.1100000000000001E+001,
      -11.105,
      -11.11,
      -1.1115000000000002E+001,
      -1.1120000000000001E+001,
      -11.125,
      -1.1129999999999999E+001,
      -1.1135000000000002E+001,
      -11.14,
      -11.145,
      -1.1149999999999999E+001,
      -1.1155000000000003E+001,
      -1.1160000000000002E+001,
      -1.1165000000000001E+001,
      -11.17,
      -1.1175000000000002E+001,
      -1.1180000000000001E+001,
      -11.185,
      -11.19,
      -1.1195000000000002E+001,
      -1.1200000000000001E+001,
      -11.205,
      -11.21,
      -1.1215000000000002E+001,
      -11.22,
      -11.225,
      -11.23,
      -1.1235000000000001E+001,
      -11.24,
      -11.245,
      -11.25,
      -1.1255000000000003E+001,
      -1.1260000000000002E+001,
      -11.265,
      -1.1270000000000001E+001,
      -1.1275000000000002E+001,
      -1.1280000000000001E+001,
      -11.285,
      -1.1290000000000001E+001,
      -1.1295000000000002E+001,
      -11.3,
      -1.1305000000000001E+001,
      -11.31,
      -1.1315000000000001E+001,
      -11.32,
      -1.1325000000000001E+001,
      -11.33,
      -11.335,
      -11.34,
      -11.345,
      -11.35,
      -1.1355000000000002E+001,
      -1.1360000000000001E+001,
      -1.1365000000000002E+001,
      -1.1370000000000001E+001,
      -1.1375000000000002E+001,
      -11.38,
      -1.1385000000000002E+001,
      -11.39,
      -11.395,
      -1.1400000000000002E+001,
      -1.1405000000000001E+001,
      -11.41,
      -11.415,
      -1.1420000000000002E+001,
      -11.425,
      -11.43,
      -1.1434999999999999E+001,
      -1.1440000000000001E+001,
      -11.445,
      -11.45,
      -1.1454999999999998E+001,
      -1.1460000000000003E+001,
      -1.1465000000000002E+001,
      -11.47,
      -11.475,
      -1.1480000000000002E+001,
      -1.1485000000000001E+001,
      -11.49,
      -11.495,
      -1.1500000000000002E+001,
      -11.505,
      -11.51,
      -11.515,
      -1.1520000000000001E+001,
      -11.525,
      -11.53,
      -11.535,
      -1.1540000000000001E+001,
      -11.545,
      -1.1549999999999999E+001,
      -11.555,
      -1.1560000000000002E+001,
      -1.1565000000000001E+001,
      -11.57,
      -1.1575000000000001E+001,
      -1.1580000000000002E+001,
      -11.585,
      -11.59,
      -11.595,
      -1.1600000000000001E+001,
      -11.605,
      -1.1610000000000001E+001,
      -11.615,
      -1.1620000000000001E+001,
      -11.625,
      -11.63,
      -11.635,
      -11.64,
      -11.645,
      -11.65,
      -11.655,
      -1.1660000000000002E+001,
      -1.1665000000000001E+001,
      -1.1670000000000002E+001,
      -11.675,
      -1.1680000000000001E+001,
      -11.685,
      -1.1690000000000001E+001,
      -11.695,
      -1.1700000000000001E+001,
      -1.1705000000000002E+001,
      -11.71,
      -11.715,
      -11.72,
      -1.1725000000000001E+001,
      -11.73,
      -11.735,
      -11.74,
      -1.1745000000000001E+001,
      -11.75,
      -1.1754999999999999E+001,
      -1.1760000000000002E+001,
      -1.1765000000000002E+001,
      -1.1770000000000001E+001,
      -11.775,
      -1.1780000000000001E+001,
      -1.1785000000000002E+001,
      -1.1790000000000001E+001,
      -11.795,
      -1.1800000000000002E+001,
      -1.1805000000000001E+001,
      -11.81,
      -11.815,
      -1.1820000000000002E+001,
      -1.1825000000000001E+001,
      -11.83,
      -1.1834999999999999E+001,
      -1.1840000000000002E+001,
      -11.845,
      -11.85,
      -1.1854999999999999E+001,
      -1.1860000000000003E+001,
      -1.1865000000000002E+001,
      -1.1870000000000001E+001,
      -11.875,
      -1.1880000000000003E+001,
      -1.1885000000000002E+001,
      -11.89,
      -11.895,
      -1.1900000000000002E+001,
      -1.1905000000000001E+001,
      -11.91,
      -1.1915000000000001E+001,
      -1.1920000000000002E+001,
      -11.925,
      -11.93,
      -11.935,
      -1.1940000000000001E+001,
      -11.945,
      -11.95,
      -11.955,
      -1.1960000000000003E+001,
      -1.1965000000000002E+001,
      -11.97,
      -1.1975000000000001E+001,
      -1.1980000000000002E+001,
      -1.1985000000000001E+001,
      -11.99,
      -1.1995000000000001E+001,
      -1.2000000000000002E+001,
      -12.005,
      -1.2010000000000002E+001,
      -12.015,
      -1.2020000000000001E+001,
      -12.025,
      -1.2030000000000001E+001,
      -12.035,
      -12.04,
      -12.045,
      -12.05,
      -12.055,
      -1.2059999999999999E+001,
      -1.2065000000000001E+001,
      -1.2070000000000002E+001,
      -1.2075000000000001E+001,
      -12.08,
      -1.2085000000000003E+001,
      -1.2090000000000002E+001,
      -12.095,
      -12.1,
      -1.2105000000000002E+001,
      -1.2110000000000001E+001,
      -12.115,
      -12.12,
      -1.2125000000000002E+001,
      -12.13,
      -12.135,
      -1.2139999999999999E+001,
      -1.2145000000000001E+001,
      -12.15,
      -12.155,
      -1.2159999999999998E+001,
      -1.2165000000000003E+001,
      -1.2170000000000002E+001,
      -12.175,
      -12.18,
      -1.2185000000000002E+001,
      -1.2190000000000001E+001,
      -12.195,
      -1.2200000000000001E+001,
      -1.2205000000000002E+001,
      -12.21,
      -12.215,
      -12.22,
      -1.2225000000000001E+001,
      -12.23,
      -12.235,
      -12.24,
      -1.2245000000000001E+001,
      -12.25,
      -1.2254999999999999E+001,
      -12.26,
      -1.2265000000000002E+001,
      -1.2270000000000001E+001,
      -12.275,
      -1.2280000000000001E+001,
      -1.2285000000000002E+001,
      -1.2290000000000001E+001,
      -1.2295000000000002E+001,
      -12.3,
      -1.2305000000000001E+001,
      -12.31,
      -1.2315000000000001E+001,
      -12.32,
      -1.2325000000000001E+001,
      -12.33,
      -12.335,
      -12.34,
      -12.345,
      -12.35,
      -12.355,
      -12.36,
      -1.2365000000000002E+001,
      -1.2370000000000001E+001,
      -1.2375000000000002E+001,
      -12.38,
      -1.2385000000000002E+001,
      -1.2390000000000002E+001,
      -1.2395000000000001E+001,
      -12.4,
      -1.2405000000000001E+001,
      -1.2410000000000002E+001,
      -1.2415000000000001E+001,
      -12.42,
      -12.425,
      -1.2430000000000001E+001,
      -12.435,
      -12.44,
      -12.445,
      -1.2450000000000001E+001,
      -12.455,
      -1.2459999999999999E+001,
      -1.2465000000000002E+001,
      -1.2470000000000002E+001,
      -1.2475000000000001E+001,
      -12.48,
      -1.2485000000000003E+001,
      -1.2490000000000002E+001,
      -1.2495000000000001E+001,
      -12.5,
      -1.2505000000000003E+001,
      -1.2510000000000002E+001,
      -12.515,
      -12.52,
      -1.2525000000000002E+001,
      -1.2530000000000001E+001,
      -12.535,
      -12.54,
      -1.2545000000000002E+001,
      -12.55,
      -12.555,
      -1.2559999999999999E+001,
      -1.2565000000000003E+001,
      -1.2570000000000002E+001,
      -1.2575000000000001E+001,
      -12.58,
      -1.2585000000000003E+001,
      -1.2590000000000002E+001,
      -12.595,
      -1.2600000000000001E+001,
      -1.2605000000000002E+001,
      -1.2610000000000001E+001,
      -12.615,
      -1.2620000000000001E+001,
      -1.2625000000000002E+001,
      -12.63,
      -12.635,
      -12.64,
      -1.2645000000000001E+001,
      -12.65,
      -12.655,
      -12.66,
      -12.665,
      -1.2670000000000002E+001,
      -12.675,
      -1.2680000000000001E+001,
      -12.685,
      -1.2690000000000001E+001,
      -1.2695000000000002E+001,
      -1.2700000000000001E+001,
      -12.705,
      -12.71,
      -1.2715000000000002E+001,
      -12.72,
      -12.725,
      -12.73,
      -1.2735000000000001E+001,
      -12.74,
      -12.745,
      -12.75,
      -12.755,
      -12.76,
      -1.2764999999999999E+001,
      -1.2770000000000001E+001,
      -1.2775000000000002E+001,
      -1.2780000000000001E+001,
      -12.785,
      -1.2790000000000003E+001,
      -1.2795000000000002E+001,
      -12.8,
      -12.805,
      -1.2810000000000002E+001,
      -1.2815000000000001E+001,
      -12.82,
      -12.825,
      -1.2830000000000002E+001,
      -12.835,
      -12.84,
      -1.2844999999999999E+001,
      -1.2850000000000001E+001,
      -12.855,
      -12.86,
      -1.2864999999999998E+001,
      -1.2870000000000003E+001,
      -1.2875000000000002E+001,
      -12.88,
      -12.885,
      -1.2890000000000002E+001,
      -1.2895000000000001E+001,
      -12.9,
      -1.2905000000000001E+001,
      -1.2910000000000002E+001,
      -1.2915000000000001E+001,
      -12.92,
      -12.925,
      -1.2930000000000001E+001,
      -12.935,
      -12.94,
      -12.945,
      -1.2950000000000001E+001,
      -12.955,
      -1.2959999999999999E+001,
      -12.965,
      -1.2970000000000002E+001,
      -1.2975000000000001E+001,
      -12.98,
      -1.2985000000000001E+001,
      -1.2990000000000002E+001,
      -1.2995000000000001E+001,
      -1.3000000000000002E+001,
      -13.005,
      -1.3010000000000002E+001,
      -13.015,
      -1.3020000000000001E+001,
      -13.025,
      -1.3030000000000001E+001,
      -13.035,
      -1.3040000000000001E+001,
      -13.045,
      -13.05,
      -13.055,
      -13.06,
      -13.065,
      -1.3070000000000002E+001,
      -1.3075000000000001E+001,
      -1.3080000000000002E+001,
      -13.085,
      -1.3090000000000002E+001,
      -1.3095000000000002E+001,
      -1.3100000000000001E+001,
      -13.105,
      -1.3110000000000001E+001,
      -1.3115000000000002E+001,
      -1.3120000000000001E+001,
      -13.125,
      -13.13,
      -1.3135000000000002E+001,
      -13.14,
      -13.145,
      -13.15,
      -1.3155000000000001E+001,
      -13.16,
      -13.165,
      -1.3170000000000002E+001,
      -1.3175000000000002E+001,
      -1.3180000000000001E+001,
      -13.185,
      -1.3190000000000003E+001,
      -1.3195000000000002E+001,
      -1.3200000000000001E+001,
      -13.205,
      -1.3210000000000003E+001,
      -1.3215000000000002E+001,
      -13.22,
      -13.225,
      -1.3230000000000002E+001,
      -1.3235000000000001E+001,
      -13.24,
      -13.245,
      -1.3250000000000002E+001,
      -13.255,
      -13.26,
      -1.3264999999999999E+001,
      -1.3270000000000003E+001,
      -1.3275000000000002E+001,
      -1.3280000000000001E+001,
      -13.285,
      -1.3290000000000003E+001,
      -1.3295000000000002E+001,
      -13.3,
      -1.3305000000000001E+001,
      -13.31,
      -1.3315000000000001E+001,
      -13.32,
      -1.3325000000000001E+001,
      -13.33,
      -13.335,
      -13.34,
      -13.345,
      -13.35,
      -13.355,
      -13.36,
      -13.365,
      -13.37,
      -1.3375000000000002E+001,
      -13.38,
      -1.3385000000000002E+001,
      -13.39,
      -1.3395000000000001E+001,
      -1.3400000000000002E+001,
      -1.3405000000000001E+001,
      -13.41,
      -1.3415000000000001E+001,
      -1.3420000000000002E+001,
      -13.425,
      -13.43,
      -13.435,
      -1.3440000000000001E+001,
      -13.445,
      -13.45,
      -13.455,
      -13.46,
      -13.465,
      -1.3469999999999999E+001,
      -1.3475000000000001E+001,
      -1.3480000000000002E+001,
      -1.3485000000000001E+001,
      -13.49,
      -1.3495000000000003E+001,
      -1.3500000000000002E+001,
      -13.505,
      -13.51,
      -1.3515000000000002E+001,
      -1.3520000000000001E+001,
      -13.525,
      -13.53,
      -1.3535000000000002E+001,
      -1.3540000000000001E+001,
      -13.545,
      -1.3549999999999999E+001,
      -1.3555000000000001E+001,
      -13.56,
      -13.565,
      -1.3569999999999999E+001,
      -1.3575000000000003E+001,
      -1.3580000000000002E+001,
      -13.585,
      -13.59,
      -1.3595000000000002E+001,
      -1.3600000000000001E+001,
      -13.605,
      -1.3610000000000001E+001,
      -1.3615000000000002E+001,
      -1.3620000000000001E+001,
      -13.625,
      -13.63,
      -1.3635000000000002E+001,
      -13.64,
      -13.645,
      -13.65,
      -1.3655000000000001E+001,
      -13.66,
      -13.665,
      -13.67,
      -1.3675000000000002E+001,
      -1.3680000000000001E+001,
      -13.685,
      -1.3690000000000001E+001,
      -1.3695000000000002E+001,
      -1.3700000000000001E+001,
      -1.3705000000000002E+001,
      -13.71,
      -1.3715000000000002E+001,
      -13.72,
      -1.3725000000000001E+001,
      -13.73,
      -1.3735000000000001E+001,
      -13.74,
      -1.3745000000000001E+001,
      -13.75,
      -13.755,
      -13.76,
      -13.765,
      -13.77,
      -1.3775000000000002E+001,
      -1.3780000000000001E+001,
      -1.3785000000000002E+001,
      -1.3790000000000001E+001,
      -1.3795000000000002E+001,
      -1.3800000000000002E+001,
      -1.3805000000000001E+001,
      -13.81,
      -1.3815000000000001E+001,
      -1.3820000000000002E+001,
      -1.3825000000000001E+001,
      -13.83,
      -13.835,
      -1.3840000000000002E+001,
      -13.845,
      -13.85,
      -13.855,
      -1.3860000000000001E+001,
      -13.865,
      -13.87,
      -1.3875000000000002E+001,
      -1.3880000000000003E+001,
      -1.3885000000000002E+001,
      -13.89,
      -1.3895000000000003E+001,
      -1.3900000000000002E+001,
      -1.3905000000000001E+001,
      -13.91,
      -1.3915000000000003E+001,
      -1.3920000000000002E+001,
      -13.925,
      -13.93,
      -1.3935000000000002E+001,
      -1.3940000000000001E+001,
      -13.945,
      -13.95,
      -13.955,
      -13.96,
      -13.965,
      -1.3969999999999999E+001,
      -13.975,
      -1.3980000000000002E+001,
      -1.3985000000000001E+001,
      -13.99,
      -1.3995000000000001E+001,
      -1.4000000000000002E+001,
      -14.005,
      -1.4010000000000002E+001,
      -14.015,
      -1.4020000000000001E+001,
      -14.025,
      -1.4030000000000001E+001,
      -14.035,
      -1.4040000000000001E+001,
      -14.045,
      -14.05,
      -14.055,
      -14.06,
      -14.065,
      -14.07,
      -14.075,
      -1.4080000000000002E+001,
      -1.4085000000000003E+001,
      -1.4090000000000002E+001,
      -14.095,
      -1.4100000000000001E+001,
      -1.4105000000000002E+001,
      -1.4110000000000001E+001,
      -14.115,
      -1.4120000000000001E+001,
      -1.4125000000000002E+001,
      -14.13,
      -14.135,
      -14.14,
      -1.4145000000000001E+001,
      -14.15,
      -14.155,
      -14.16,
      -1.4165000000000001E+001,
      -14.17,
      -1.4174999999999999E+001,
      -1.4180000000000003E+001,
      -1.4185000000000002E+001,
      -1.4190000000000001E+001,
      -14.195,
      -1.4200000000000003E+001,
      -1.4205000000000002E+001,
      -14.21,
      -14.215,
      -1.4220000000000002E+001,
      -1.4225000000000001E+001,
      -14.23,
      -14.235,
      -1.4240000000000002E+001,
      -1.4245000000000001E+001,
      -14.25,
      -1.4254999999999999E+001,
      -1.4260000000000002E+001,
      -14.265,
      -14.27,
      -1.4274999999999999E+001,
      -1.4280000000000003E+001,
      -1.4285000000000002E+001,
      -1.4290000000000001E+001,
      -1.4295000000000002E+001,
      -1.4300000000000002E+001,
      -1.4305000000000001E+001,
      -14.31,
      -1.4315000000000001E+001,
      -1.4320000000000002E+001,
      -1.4325000000000001E+001,
      -14.33,
      -14.335,
      -1.4340000000000002E+001,
      -14.345,
      -14.35,
      -14.355,
      -1.4360000000000001E+001,
      -14.365,
      -14.37,
      -14.375,
      -1.4380000000000003E+001,
      -1.4385000000000002E+001,
      -1.4390000000000002E+001,
      -1.4395000000000001E+001,
      -1.4400000000000002E+001,
      -1.4405000000000001E+001,
      -1.4410000000000002E+001,
      -1.4415000000000001E+001,
      -1.4420000000000002E+001,
      -14.425,
      -1.4430000000000001E+001,
      -14.435,
      -1.4440000000000001E+001,
      -14.445,
      -1.4450000000000001E+001,
      -14.455,
      -14.46,
      -14.465,
      -14.47,
      -14.475,
      -1.4480000000000002E+001,
      -1.4485000000000003E+001,
      -1.4490000000000002E+001,
      -1.4495000000000001E+001,
      -1.4500000000000002E+001,
      -1.4505000000000003E+001,
      -1.4510000000000002E+001,
      -14.515,
      -1.4520000000000001E+001,
      -1.4525000000000002E+001,
      -1.4530000000000001E+001,
      -14.535,
      -1.4540000000000001E+001,
      -1.4545000000000002E+001,
      -14.55,
      -14.555,
      -14.56,
      -1.4565000000000001E+001,
      -14.57,
      -14.575,
      -1.4579999999999998E+001,
      -1.4585000000000003E+001,
      -1.4590000000000002E+001,
      -14.595,
      -1.4600000000000001E+001,
      -1.4605000000000002E+001,
      -1.4610000000000001E+001,
      -14.615,
      -1.4620000000000001E+001,
      -1.4625000000000002E+001,
      -14.63,
      -14.635,
      -14.64,
      -1.4645000000000001E+001,
      -14.65,
      -14.655,
      -14.66,
      -1.4665000000000001E+001,
      -14.67,
      -1.4674999999999999E+001,
      -14.68,
      -1.4685000000000002E+001,
      -1.4690000000000001E+001,
      -1.4695000000000002E+001,
      -1.4700000000000001E+001,
      -1.4705000000000002E+001,
      -14.71,
      -1.4715000000000002E+001,
      -14.72,
      -1.4725000000000001E+001,
      -14.73,
      -1.4735000000000001E+001,
      -14.74,
      -1.4745000000000001E+001,
      -14.75,
      -14.755,
      -14.76,
      -14.765,
      -14.77,
      -14.775,
      -14.78,
      -1.4785000000000002E+001,
      -1.4790000000000003E+001,
      -1.4795000000000002E+001,
      -14.8,
      -1.4805000000000001E+001,
      -1.4810000000000002E+001,
      -1.4815000000000001E+001,
      -14.82,
      -1.4825000000000001E+001,
      -1.4830000000000002E+001,
      -14.835,
      -14.84,
      -14.845,
      -1.4850000000000001E+001,
      -14.855,
      -14.86,
      -14.865,
      -1.4870000000000001E+001,
      -14.875,
      -1.4879999999999999E+001,
      -1.4885000000000003E+001,
      -1.4890000000000002E+001,
      -1.4895000000000001E+001,
      -14.9,
      -1.4905000000000003E+001,
      -1.4910000000000002E+001,
      -1.4915000000000001E+001,
      -14.92,
      -1.4925000000000002E+001,
      -1.4930000000000001E+001,
      -14.935,
      -14.94,
      -1.4945000000000002E+001,
      -1.4950000000000001E+001,
      -14.955,
      -1.4959999999999999E+001,
      -1.4965000000000002E+001,
      -14.97,
      -14.975,
      -1.4979999999999999E+001,
      -1.4985000000000003E+001,
      -1.4990000000000002E+001,
      -1.4995000000000001E+001,
      -1.5000000000000002E+001,
      -1.5005000000000003E+001,
      -1.5010000000000002E+001,
      -15.015,
      -1.5020000000000001E+001,
      -1.5025000000000002E+001,
      -1.5030000000000001E+001,
      -15.035,
      -1.5040000000000001E+001,
      -1.5045000000000002E+001,
      -15.05,
      -15.055,
      -15.06,
      -1.5065000000000001E+001,
      -15.07,
      -15.075,
      -15.08,
      -1.5085000000000003E+001,
      -1.5090000000000002E+001,
      -1.5095000000000002E+001,
      -1.5100000000000001E+001,
      -1.5105000000000002E+001,
      -1.5110000000000001E+001,
      -1.5115000000000002E+001,
      -1.5120000000000001E+001,
      -1.5125000000000002E+001,
      -15.13,
      -1.5135000000000002E+001,
      -15.14,
      -1.5145000000000001E+001,
      -15.15,
      -1.5155000000000001E+001,
      -15.16,
      -1.5165000000000001E+001,
      -15.17,
      -15.175,
      -15.18,
      -1.5185000000000002E+001,
      -1.5190000000000003E+001,
      -1.5195000000000002E+001,
      -1.5200000000000001E+001,
      -1.5205000000000002E+001,
      -1.5210000000000003E+001,
      -1.5215000000000002E+001,
      -15.22,
      -15.225,
      -1.5230000000000002E+001,
      -1.5235000000000001E+001,
      -15.24,
      -15.245,
      -1.5250000000000002E+001,
      -15.255,
      -15.26,
      -1.5264999999999999E+001,
      -1.5270000000000001E+001,
      -15.275,
      -15.28,
      -1.5284999999999998E+001,
      -1.5290000000000003E+001,
      -1.5295000000000002E+001,
      -15.3,
      -1.5305000000000001E+001,
      -1.5310000000000002E+001,
      -1.5315000000000001E+001,
      -15.32,
      -1.5325000000000001E+001,
      -1.5330000000000002E+001,
      -15.335,
      -15.34,
      -15.345,
      -1.5350000000000001E+001,
      -15.355,
      -15.36,
      -15.365,
      -1.5370000000000001E+001,
      -15.375,
      -1.5379999999999999E+001,
      -15.385,
      -1.5390000000000002E+001,
      -1.5395000000000001E+001,
      -1.5400000000000002E+001,
      -1.5405000000000001E+001,
      -1.5410000000000002E+001,
      -1.5415000000000001E+001,
      -1.5420000000000002E+001,
      -15.425,
      -1.5430000000000001E+001,
      -15.435,
      -1.5440000000000001E+001,
      -15.445,
      -1.5450000000000001E+001,
      -15.455,
      -15.46,
      -15.465,
      -15.47,
      -15.475,
      -15.48,
      -15.485,
      -1.5490000000000002E+001,
      -1.5495000000000003E+001,
      -15.5,
      -1.5504999999999999E+001,
      -1.5510000000000002E+001,
      -1.5515000000000002E+001,
      -1.5520000000000001E+001,
      -15.525,
      -1.5530000000000001E+001,
      -1.5535000000000002E+001,
      -1.5540000000000001E+001,
      -15.545,
      -15.55,
      -1.5555000000000001E+001,
      -15.56,
      -15.565,
      -15.57,
      -1.5575000000000001E+001,
      -15.58,
      -1.5584999999999999E+001,
      -15.59,
      -15.595,
      -15.6,
      -1.5604999999999999E+001,
      -1.5610000000000003E+001,
      -1.5615000000000002E+001,
      -1.5620000000000001E+001,
      -15.625,
      -1.5630000000000003E+001,
      -1.5635000000000002E+001,
      -15.64,
      -15.645,
      -1.5650000000000002E+001,
      -1.5655000000000001E+001,
      -15.66,
      -15.665,
      -1.5670000000000002E+001,
      -15.675,
      -15.68,
      -1.5684999999999999E+001,
      -1.5690000000000001E+001,
      -15.695,
      -15.7,
      -1.5704999999999998E+001,
      -1.5710000000000003E+001,
      -1.5715000000000002E+001,
      -15.72,
      -1.5725000000000001E+001,
      -1.5730000000000002E+001,
      -1.5735000000000001E+001,
      -15.74,
      -1.5745000000000001E+001,
      -1.5750000000000002E+001,
      -15.755,
      -15.76,
      -15.765,
      -1.5770000000000001E+001,
      -15.775,
      -15.78,
      -15.785,
      -1.5790000000000001E+001,
      -15.795,
      -1.5799999999999999E+001,
      -15.805,
      -1.5810000000000002E+001,
      -1.5815000000000001E+001,
      -1.5820000000000002E+001,
      -1.5825000000000001E+001,
      -1.5830000000000002E+001,
      -15.835,
      -1.5840000000000002E+001,
      -15.845,
      -1.5850000000000001E+001,
      -15.855,
      -1.5860000000000001E+001,
      -15.865,
      -15.87,
      -15.875,
      -15.88,
      -15.885,
      -1.5889999999999999E+001,
      -15.895,
      -15.9,
      -15.905,
      -1.5909999999999998E+001,
      -1.5915000000000003E+001,
      -1.5920000000000002E+001,
      -15.925,
      -15.93,
      -1.5935000000000002E+001,
      -1.5940000000000001E+001,
      -15.945,
      -15.95,
      -1.5955000000000002E+001,
      -15.96,
      -15.965,
      -1.5969999999999999E+001,
      -1.5975000000000001E+001,
      -15.98,
      -15.985,
      -1.5989999999999998E+001,
      -1.5995000000000001E+001,
      -16.0,
      -16.005,
      -1.6009999999999998E+001,
      -16.015,
      -1.6020000000000003E+001,
      -1.6025000000000002E+001,
      -16.03,
      -16.035,
      -1.6040000000000003E+001,
      -16.045,
      -16.05,
      -16.055,
      -1.6060000000000002E+001,
      -16.065,
      -16.07,
      -16.075,
      -1.6080000000000002E+001,
      -16.085,
      -16.09,
      -1.6095000000000002E+001,
      -16.1,
      -16.105,
      -16.11,
      -1.6115000000000002E+001,
      -16.12,
      -16.125,
      -16.13,
      -16.135,
      -16.14,
      -16.145,
      -16.15,
      -16.155,
      -16.16,
      -16.165,
      -1.6169999999999998E+001,
      -16.175,
      -16.18,
      -16.185,
      -1.6189999999999998E+001,
      -16.195,
      -16.2,
      -16.205,
      -16.21,
      -1.6215000000000003E+001,
      -1.6220000000000002E+001,
      -16.225,
      -16.23,
      -1.6235000000000003E+001,
      -1.6240000000000002E+001,
      -16.245,
      -16.25,
      -1.6255000000000003E+001,
      -16.26,
      -16.265,
      -16.27,
      -1.6275000000000002E+001,
      -16.28,
      -16.285,
      -16.29,
      -16.295,
      -16.3,
      -16.305,
      -16.31,
      -16.315,
      -16.32,
      -1.6325000000000003E+001,
      -1.6330000000000002E+001,
      -16.335,
      -16.34,
      -1.6345000000000002E+001,
      -16.35,
      -16.355,
      -16.36,
      -1.6365000000000002E+001,
      -16.37,
      -16.375,
      -16.38,
      -16.385,
      -16.39,
      -16.395,
      -1.6400000000000002E+001,
      -16.405,
      -16.41,
      -1.6415000000000003E+001,
      -16.42,
      -16.425,
      -16.43,
      -1.6435000000000002E+001,
      -16.44,
      -16.445,
      -16.45,
      -1.6455000000000002E+001,
      -16.46,
      -16.465,
      -16.47,
      -16.475,
      -16.48,
      -16.485,
      -16.49,
      -16.495,
      -16.5,
      -16.505,
      -1.6509999999999998E+001,
      -16.515,
      -1.6520000000000003E+001,
      -1.6525000000000002E+001,
      -16.53,
      -16.535,
      -1.6540000000000003E+001,
      -16.545,
      -16.55,
      -16.555,
      -1.6560000000000002E+001,
      -16.565,
      -16.57,
      -16.575,
      -1.6580000000000002E+001,
      -16.585,
      -16.59,
      -16.595,
      -16.6,
      -16.605,
      -16.61,
      -16.615,
      -16.62,
      -16.625,
      -1.6630000000000003E+001,
      -16.635,
      -16.64,
      -16.645,
      -1.6650000000000002E+001,
      -16.655,
      -16.66,
      -16.665,
      -16.67,
      -16.675,
      -16.68,
      -16.685,
      -1.6689999999999998E+001,
      -1.6694999999999997E+001,
      -16.7,
      -1.6705000000000002E+001,
      -16.71,
      -16.715,
      -1.6720000000000002E+001,
      -16.725,
      -16.73,
      -16.735,
      -16.74,
      -16.745,
      -16.75,
      -16.755,
      -16.76,
      -16.765,
      -16.77,
      -16.775,
      -1.6779999999999998E+001,
      -16.785,
      -16.79,
      -1.6794999999999998E+001,
      -16.8,
      -16.805,
      -16.81,
      -1.6814999999999998E+001,
      -1.6820000000000004E+001,
      -1.6825000000000003E+001,
      -1.6830000000000002E+001,
      -16.835,
      -16.84,
      -16.845,
      -1.6849999999999998E+001,
      -1.6854999999999997E+001,
      -1.6860000000000003E+001,
      -1.6865000000000002E+001,
      -16.87,
      -16.875,
      -16.88,
      -1.6884999999999998E+001,
      -1.6889999999999997E+001,
      -1.6894999999999996E+001,
      -1.6900000000000002E+001,
      -16.905,
      -16.91,
      -16.915,
      -16.92,
      -16.925,
      -16.93,
      -1.6935000000000002E+001,
      -16.94,
      -16.945,
      -16.95,
      -16.955,
      -16.96,
      -16.965,
      -16.97,
      -16.975,
      -16.98,
      -16.985,
      -16.99,
      -1.6994999999999997E+001,
      -17.0,
      -17.005,
      -17.01,
      -17.015,
      -1.7020000000000003E+001,
      -1.7025000000000002E+001,
      -17.03,
      -17.035,
      -17.04,
      -1.7044999999999998E+001,
      -17.05,
      -17.055,
      -1.7060000000000002E+001,
      -17.065,
      -17.07,
      -17.075,
      -17.08,
      -1.7084999999999997E+001,
      -17.09,
      -17.095,
      -17.1,
      -17.105,
      -17.11,
      -17.115,
      -17.12,
      -1.7125000000000004E+001,
      -1.7130000000000003E+001,
      -17.135,
      -17.14,
      -17.145,
      -17.15,
      -1.7154999999999998E+001,
      -1.7159999999999997E+001,
      -1.7165000000000003E+001,
      -17.17,
      -17.175,
      -17.18,
      -1.7185000000000002E+001,
      -17.19,
      -17.195,
      -1.7200000000000003E+001,
      -1.7205000000000002E+001,
      -17.21,
      -17.215,
      -17.22,
      -17.225,
      -17.23,
      -17.235,
      -1.7240000000000002E+001,
      -17.245,
      -17.25,
      -17.255,
      -1.7259999999999998E+001,
      -17.265,
      -17.27,
      -17.275,
      -17.28,
      -1.7285000000000004E+001,
      -1.7290000000000003E+001,
      -17.295,
      -17.3,
      -17.305,
      -17.31,
      -17.315,
      -17.32,
      -1.7325000000000003E+001,
      -1.7330000000000002E+001,
      -17.335,
      -17.34,
      -17.345,
      -1.7349999999999998E+001,
      -17.355,
      -17.36,
      -1.7365000000000002E+001,
      -17.37,
      -17.375,
      -17.38,
      -17.385,
      -1.7390000000000004E+001,
      -1.7395000000000003E+001,
      -1.7400000000000002E+001,
      -17.405,
      -17.41,
      -17.415,
      -1.7419999999999998E+001,
      -17.425,
      -1.7430000000000003E+001,
      -1.7435000000000002E+001,
      -17.44,
      -17.445,
      -17.45,
      -17.455,
      -1.7459999999999997E+001,
      -17.465,
      -1.7470000000000002E+001,
      -17.475,
      -17.48,
      -1.7485000000000003E+001,
      -1.7490000000000002E+001,
      -17.495,
      -17.5,
      -1.7505000000000003E+001,
      -17.51,
      -17.515,
      -17.52,
      -1.7525000000000002E+001,
      -17.53,
      -17.535,
      -17.54,
      -17.545,
      -17.55,
      -17.555,
      -17.56,
      -17.565,
      -17.57,
      -17.575,
      -17.58,
      -1.7585000000000004E+001,
      -1.7590000000000003E+001,
      -1.7595000000000002E+001,
      -17.6,
      -17.605,
      -17.61,
      -17.615,
      -17.62,
      -1.7625000000000004E+001,
      -1.7630000000000003E+001,
      -17.635,
      -17.64,
      -17.645,
      -17.65,
      -1.7654999999999998E+001,
      -17.66,
      -1.7665000000000003E+001,
      -17.67,
      -17.675,
      -17.68,
      -1.7685000000000002E+001,
      -17.69,
      -1.7695000000000004E+001,
      -1.7700000000000003E+001,
      -1.7705000000000002E+001,
      -17.71,
      -17.715,
      -17.72,
      -17.725,
      -17.73,
      -1.7735000000000003E+001,
      -1.7740000000000002E+001,
      -17.745,
      -17.75,
      -17.755,
      -1.7759999999999998E+001,
      -17.765,
      -17.77,
      -1.7775000000000002E+001,
      -17.78,
      -17.785,
      -1.7790000000000003E+001,
      -17.795,
      -17.8,
      -17.805,
      -1.7810000000000002E+001,
      -17.815,
      -17.82,
      -17.825,
      -1.7830000000000002E+001,
      -17.835,
      -17.84,
      -17.845,
      -17.85,
      -17.855,
      -17.86,
      -17.865,
      -17.87,
      -17.875,
      -17.88,
      -1.7884999999999998E+001,
      -1.7890000000000004E+001,
      -1.7895000000000003E+001,
      -1.7900000000000002E+001,
      -17.905,
      -17.91,
      -17.915,
      -1.7919999999999998E+001,
      -17.925,
      -1.7930000000000003E+001,
      -1.7935000000000002E+001,
      -17.94,
      -17.945,
      -17.95,
      -17.955,
      -1.7959999999999997E+001,
      -17.965,
      -1.7970000000000002E+001,
      -17.975,
      -17.98,
      -17.985,
      -1.7990000000000002E+001,
      -17.995,
      -1.8000000000000004E+001,
      -1.8005000000000003E+001,
      -18.01,
      -18.015,
      -18.02,
      -18.025,
      -18.03,
      -18.035,
      -1.8040000000000003E+001,
      -18.045,
      -18.05,
      -18.055,
      -18.06,
      -1.8064999999999998E+001,
      -18.07,
      -18.075,
      -1.8080000000000002E+001,
      -18.085,
      -1.8090000000000003E+001,
      -1.8095000000000002E+001,
      -18.1,
      -18.105,
      -18.11,
      -1.8115000000000002E+001,
      -18.12,
      -18.125,
      -1.8130000000000003E+001,
      -18.135,
      -18.14,
      -18.145,
      -18.15,
      -18.155,
      -18.16,
      -18.165,
      -18.17,
      -18.175,
      -18.18,
      -18.185,
      -1.8190000000000005E+001,
      -1.8195000000000004E+001,
      -1.8200000000000003E+001,
      -1.8205000000000002E+001,
      -18.21,
      -18.215,
      -18.22,
      -1.8224999999999998E+001,
      -1.8230000000000004E+001,
      -1.8235000000000003E+001,
      -1.8240000000000002E+001,
      -18.245,
      -18.25,
      -18.255,
      -1.8259999999999998E+001,
      -1.8264999999999997E+001,
      -1.8270000000000003E+001,
      -1.8275000000000002E+001,
      -18.28,
      -18.285,
      -1.8290000000000003E+001,
      -18.295,
      -18.3,
      -1.8305000000000003E+001,
      -1.8310000000000002E+001,
      -18.315,
      -18.32,
      -18.325,
      -1.8330000000000002E+001,
      -18.335,
      -18.34,
      -1.8345000000000002E+001,
      -18.35,
      -18.355,
      -18.36,
      -18.365,
      -18.37,
      -18.375,
      -18.38,
      -18.385,
      -1.8390000000000004E+001,
      -1.8395000000000003E+001,
      -1.8400000000000002E+001,
      -18.405,
      -18.41,
      -18.415,
      -18.42,
      -18.425,
      -18.43,
      -1.8435000000000002E+001,
      -18.44,
      -18.445,
      -18.45,
      -18.455,
      -18.46,
      -18.465,
      -18.47,
      -18.475,
      -18.48,
      -18.485,
      -18.49,
      -1.8495000000000005E+001,
      -1.8500000000000004E+001,
      -1.8505000000000003E+001,
      -18.51,
      -18.515,
      -18.52,
      -18.525,
      -1.8529999999999998E+001,
      -1.8535000000000004E+001,
      -1.8540000000000003E+001,
      -18.545,
      -18.55,
      -18.555,
      -18.56,
      -1.8564999999999998E+001,
      -1.8569999999999997E+001,
      -1.8575000000000003E+001,
      -1.8580000000000002E+001,
      -18.585,
      -18.59,
      -1.8595000000000002E+001,
      -18.6,
      -18.605,
      -1.8610000000000003E+001,
      -1.8615000000000002E+001,
      -18.62,
      -18.625,
      -18.63,
      -18.635,
      -18.64,
      -18.645,
      -1.8650000000000002E+001,
      -18.655,
      -18.66,
      -18.665,
      -1.8669999999999998E+001,
      -18.675,
      -18.68,
      -18.685,
      -18.69,
      -1.8695000000000004E+001,
      -1.8700000000000003E+001,
      -1.8705000000000002E+001,
      -18.71,
      -18.715,
      -18.72,
      -18.725,
      -18.73,
      -1.8735000000000003E+001,
      -1.8740000000000002E+001,
      -18.745,
      -18.75,
      -18.755,
      -1.8759999999999998E+001,
      -18.765,
      -18.77,
      -1.8775000000000002E+001,
      -18.78,
      -18.785,
      -18.79,
      -18.795,
      -1.8800000000000004E+001,
      -1.8805000000000003E+001,
      -1.8810000000000002E+001,
      -18.815,
      -18.82,
      -18.825,
      -18.83,
      -18.835,
      -1.8840000000000003E+001,
      -1.8845000000000002E+001,
      -18.85,
      -18.855,
      -18.86,
      -18.865,
      -1.8869999999999997E+001,
      -18.875,
      -1.8880000000000003E+001,
      -18.885,
      -18.89,
      -1.8895000000000003E+001,
      -1.8900000000000002E+001,
      -18.905,
      -18.91,
      -1.8915000000000003E+001,
      -18.92,
      -18.925,
      -18.93,
      -1.8935000000000002E+001,
      -18.94,
      -18.945,
      -18.95,
      -1.8955000000000002E+001,
      -18.96,
      -18.965,
      -18.97,
      -18.975,
      -18.98,
      -18.985,
      -18.99,
      -1.8995000000000005E+001,
      -1.9000000000000004E+001,
      -1.9005000000000003E+001,
      -19.01,
      -19.015,
      -19.02,
      -19.025,
      -19.03,
      -1.9035000000000004E+001,
      -1.9040000000000003E+001,
      -19.045,
      -19.05,
      -19.055,
      -19.06,
      -1.9064999999999998E+001,
      -19.07,
      -19.075,
      -1.9080000000000002E+001,
      -19.085,
      -19.09,
      -19.095,
      -19.1,
      -1.9105000000000004E+001,
      -1.9110000000000003E+001,
      -1.9115000000000002E+001,
      -19.12,
      -19.125,
      -19.13,
      -1.9134999999999998E+001,
      -19.14,
      -1.9145000000000003E+001,
      -1.9150000000000002E+001,
      -19.155,
      -19.16,
      -19.165,
      -1.9169999999999998E+001,
      -1.9174999999999997E+001,
      -19.18,
      -1.9185000000000002E+001,
      -19.19,
      -19.195,
      -1.9200000000000003E+001,
      -1.9205000000000002E+001,
      -19.21,
      -19.215,
      -1.9220000000000002E+001,
      -19.225,
      -19.23,
      -19.235,
      -1.9240000000000002E+001,
      -19.245,
      -19.25,
      -19.255,
      -19.26,
      -19.265,
      -19.27,
      -19.275,
      -19.28,
      -19.285,
      -19.29,
      -1.9294999999999998E+001,
      -1.9300000000000004E+001,
      -1.9305000000000003E+001,
      -1.9310000000000002E+001,
      -19.315,
      -19.32,
      -19.325,
      -19.33,
      -19.335,
      -1.9340000000000003E+001,
      -1.9345000000000002E+001,
      -19.35,
      -19.355,
      -19.36,
      -19.365,
      -1.9369999999999997E+001,
      -19.375,
      -1.9380000000000003E+001,
      -19.385,
      -19.39,
      -19.395,
      -1.9400000000000002E+001,
      -19.405,
      -1.9410000000000004E+001,
      -1.9415000000000003E+001,
      -19.42,
      -19.425,
      -19.43,
      -19.435,
      -19.44,
      -19.445,
      -1.9450000000000003E+001,
      -1.9455000000000002E+001,
      -19.46,
      -19.465,
      -19.47,
      -1.9474999999999998E+001,
      -19.48,
      -19.485,
      -1.9490000000000002E+001,
      -19.495,
      -1.9500000000000004E+001,
      -1.9505000000000003E+001,
      -19.51,
      -19.515,
      -19.52,
      -1.9525000000000002E+001,
      -19.53,
      -19.535,
      -1.9540000000000003E+001,
      -19.545,
      -19.55,
      -19.555,
      -19.56,
      -19.565,
      -19.57,
      -19.575,
      -1.9580000000000002E+001,
      -19.585,
      -19.59,
      -19.595,
      -1.9600000000000005E+001,
      -1.9605000000000004E+001,
      -1.9610000000000003E+001,
      -1.9615000000000002E+001,
      -19.62,
      -19.625,
      -19.63,
      -1.9634999999999998E+001,
      -1.9640000000000004E+001,
      -1.9645000000000003E+001,
      -1.9650000000000002E+001,
      -19.655,
      -19.66,
      -19.665,
      -1.9669999999999998E+001,
      -1.9674999999999997E+001,
      -1.9680000000000003E+001,
      -1.9685000000000002E+001,
      -19.69,
      -19.695,
      -19.7,
      -1.9705000000000002E+001,
      -19.71,
      -1.9715000000000003E+001,
      -1.9720000000000002E+001,
      -19.725,
      -19.73,
      -19.735,
      -19.74,
      -19.745,
      -19.75,
      -1.9755000000000003E+001,
      -19.76,
      -19.765,
      -19.77,
      -19.775,
      -1.9779999999999998E+001,
      -19.785,
      -19.79,
      -19.795,
      -19.8,
      -1.9805000000000003E+001,
      -1.9810000000000002E+001,
      -19.815,
      -19.82,
      -19.825,
      -1.9830000000000002E+001,
      -19.835,
      -19.84,
      -1.9845000000000002E+001,
      -19.85,
      -19.855,
      -19.86,
      -19.865,
      -19.87,
      -19.875,
      -19.88,
      -19.885,
      -19.89,
      -19.895,
      -19.9,
      -1.9905000000000005E+001,
      -1.9910000000000004E+001,
      -1.9915000000000003E+001,
      -19.92,
      -19.925,
      -19.93,
      -19.935,
      -1.9939999999999998E+001,
      -1.9945000000000004E+001,
      -1.9950000000000003E+001,
      -1.9955000000000002E+001,
      -19.96,
      -19.965,
      -19.97,
      -1.9974999999999998E+001,
      -1.9979999999999997E+001,
      -1.9985000000000003E+001,
      -1.9990000000000002E+001,
      -19.995,
      -1.9999999999999996E+001,
      -2.0004999999999995E+001,
      -2.0009999999999994E+001,
      -2.0014999999999997E+001,
      -20.02,
      -20.025,
      -2.0029999999999998E+001,
      -20.035,
      -20.04,
      -2.0044999999999998E+001,
      -2.0049999999999997E+001,
      -2.0054999999999996E+001,
      -20.06,
      -2.0064999999999998E+001,
      -2.0069999999999997E+001,
      -20.075,
      -20.08,
      -2.0084999999999997E+001,
      -2.0089999999999996E+001,
      -2.0094999999999995E+001,
      -2.0099999999999998E+001,
      -2.0104999999999997E+001,
      -2.0109999999999996E+001,
      -20.115,
      -2.0119999999999997E+001,
      -2.0124999999999996E+001,
      -2.0129999999999995E+001,
      -20.135,
      -20.14,
      -20.145,
      -20.15,
      -2.0154999999999998E+001,
      -2.0159999999999997E+001,
      -2.0164999999999996E+001,
      -2.0169999999999995E+001,
      -20.175,
      -20.18,
      -20.185,
      -2.0189999999999998E+001,
      -2.0194999999999997E+001,
      -2.0199999999999996E+001,
      -2.0204999999999995E+001,
      -2.0209999999999994E+001,
      -20.215,
      -20.22,
      -2.0224999999999998E+001,
      -2.0229999999999997E+001,
      -20.235,
      -20.24,
      -2.0244999999999997E+001,
      -20.25,
      -20.255,
      -2.0259999999999998E+001,
      -2.0264999999999997E+001,
      -2.0269999999999996E+001,
      -20.275,
      -2.0279999999999998E+001,
      -2.0284999999999997E+001,
      -20.29,
      -2.0294999999999998E+001,
      -2.0299999999999997E+001,
      -2.0304999999999996E+001,
      -2.0309999999999995E+001,
      -2.0314999999999994E+001,
      -2.0319999999999997E+001,
      -20.325,
      -20.33,
      -2.0334999999999997E+001,
      -20.34,
      -20.345,
      -2.0349999999999998E+001,
      -2.0354999999999997E+001,
      -2.0359999999999996E+001,
      -20.365,
      -2.0369999999999997E+001,
      -2.0374999999999996E+001,
      -20.38,
      -2.0384999999999998E+001,
      -2.0389999999999997E+001,
      -2.0394999999999996E+001,
      -2.0399999999999995E+001,
      -2.0404999999999998E+001,
      -2.0409999999999997E+001,
      -2.0414999999999996E+001,
      -2.0419999999999998E+001,
      -2.0424999999999997E+001,
      -2.0429999999999996E+001,
      -2.0434999999999995E+001,
      -20.44,
      -20.445,
      -20.45,
      -20.455,
      -2.0459999999999997E+001,
      -2.0464999999999996E+001,
      -2.0469999999999995E+001,
      -2.0474999999999994E+001,
      -20.48,
      -20.485,
      -20.49,
      -2.0494999999999997E+001,
      -2.0499999999999996E+001,
      -2.0504999999999995E+001,
      -2.0509999999999994E+001,
      -2.0514999999999993E+001,
      -20.52,
      -2.0524999999999995E+001,
      -2.0529999999999998E+001,
      -20.535,
      -2.0539999999999996E+001,
      -2.0544999999999998E+001,
      -2.0549999999999997E+001,
      -20.555,
      -20.56,
      -20.565,
      -2.0569999999999997E+001,
      -2.0574999999999996E+001,
      -20.58,
      -2.0584999999999997E+001,
      -2.0589999999999993E+001,
      -20.595,
      -2.0599999999999998E+001,
      -2.0604999999999997E+001,
      -2.0609999999999996E+001,
      -20.615,
      -2.0619999999999994E+001,
      -2.0624999999999996E+001,
      -2.0630000000000003E+001,
      -2.0634999999999998E+001,
      -20.64,
      -20.645,
      -20.65,
      -2.0654999999999994E+001,
      -20.66,
      -2.0664999999999996E+001,
      -2.0669999999999998E+001,
      -2.0674999999999997E+001,
      -20.68,
      -2.0684999999999995E+001,
      -2.0689999999999998E+001,
      -2.0694999999999997E+001,
      -2.0699999999999996E+001,
      -2.0704999999999995E+001,
      -20.71,
      -2.0714999999999996E+001,
      -20.72,
      -20.725,
      -2.0729999999999997E+001,
      -2.0734999999999992E+001,
      -20.74,
      -20.745,
      -2.0749999999999996E+001,
      -20.755,
      -2.0759999999999998E+001,
      -2.0764999999999997E+001,
      -2.0769999999999996E+001,
      -20.775,
      -2.0779999999999994E+001,
      -20.785,
      -20.79,
      -2.0794999999999998E+001,
      -2.0799999999999997E+001,
      -20.805,
      -2.0809999999999995E+001,
      -2.0814999999999994E+001,
      -2.0820000000000004E+001,
      -20.825,
      -2.0829999999999995E+001,
      -2.0834999999999997E+001,
      -20.84,
      -2.0844999999999995E+001,
      -2.0849999999999998E+001,
      -2.0854999999999997E+001,
      -20.86,
      -20.865,
      -20.87,
      -2.0874999999999996E+001,
      -20.88,
      -2.0884999999999998E+001,
      -2.0889999999999997E+001,
      -2.0894999999999992E+001,
      -2.0900000000000002E+001,
      -2.0904999999999998E+001,
      -2.0909999999999997E+001,
      -2.0914999999999996E+001,
      -2.0919999999999998E+001,
      -2.0924999999999994E+001,
      -2.0929999999999996E+001,
      -2.0935000000000002E+001,
      -2.0939999999999998E+001,
      -20.945,
      -20.95,
      -20.955,
      -2.0959999999999994E+001,
      -20.965,
      -2.0969999999999995E+001,
      -2.0974999999999998E+001,
      -2.0979999999999997E+001,
      -20.985,
      -2.0989999999999995E+001,
      -2.0994999999999997E+001,
      -2.0999999999999996E+001,
      -2.1004999999999995E+001,
      -2.1009999999999994E+001,
      -21.015,
      -2.1019999999999996E+001,
      -21.025,
      -21.03,
      -2.1034999999999997E+001,
      -2.1039999999999992E+001,
      -2.1044999999999998E+001,
      -21.05,
      -2.1054999999999996E+001,
      -21.06,
      -2.1064999999999998E+001,
      -2.1069999999999997E+001,
      -2.1074999999999996E+001,
      -21.08,
      -2.1084999999999994E+001,
      -21.09,
      -21.095,
      -2.1099999999999998E+001,
      -2.1104999999999997E+001,
      -21.11,
      -2.1114999999999995E+001,
      -2.1119999999999994E+001,
      -2.1125000000000004E+001,
      -21.13,
      -2.1134999999999994E+001,
      -2.1139999999999997E+001,
      -21.145,
      -2.1149999999999995E+001,
      -2.1154999999999998E+001,
      -2.1159999999999997E+001,
      -21.165,
      -2.1169999999999998E+001,
      -21.175,
      -2.1179999999999996E+001,
      -21.185,
      -2.1189999999999998E+001,
      -2.1194999999999997E+001,
      -2.1199999999999992E+001,
      -2.1205000000000002E+001,
      -2.1209999999999997E+001,
      -2.1214999999999996E+001,
      -2.1219999999999995E+001,
      -2.1224999999999998E+001,
      -2.1229999999999993E+001,
      -2.1234999999999996E+001,
      -2.1240000000000002E+001,
      -2.1244999999999997E+001,
      -21.25,
      -21.255,
      -2.1259999999999998E+001,
      -2.1264999999999997E+001,
      -21.27,
      -2.1274999999999995E+001,
      -2.1279999999999998E+001,
      -21.285,
      -21.29,
      -2.1294999999999995E+001,
      -2.1299999999999997E+001,
      -2.1304999999999996E+001,
      -2.1309999999999995E+001,
      -2.1314999999999994E+001,
      -21.32,
      -2.1324999999999996E+001,
      -21.33,
      -21.335,
      -2.1339999999999996E+001,
      -21.345,
      -2.1349999999999998E+001,
      -21.355,
      -2.1359999999999996E+001,
      -2.1365000000000002E+001,
      -2.1369999999999997E+001,
      -2.1374999999999996E+001,
      -2.1379999999999995E+001,
      -2.1384999999999998E+001,
      -2.1389999999999993E+001,
      -21.395,
      -21.4,
      -2.1404999999999998E+001,
      -2.1409999999999997E+001,
      -21.415,
      -2.1419999999999995E+001,
      -2.1424999999999997E+001,
      -2.1430000000000003E+001,
      -21.435,
      -2.1439999999999994E+001,
      -21.445,
      -21.45,
      -2.1454999999999995E+001,
      -2.1459999999999997E+001,
      -2.1464999999999996E+001,
      -21.47,
      -2.1474999999999998E+001,
      -21.48,
      -2.1484999999999996E+001,
      -21.49,
      -2.1494999999999997E+001,
      -2.1499999999999996E+001,
      -2.1504999999999995E+001,
      -21.51,
      -2.1514999999999997E+001,
      -2.1519999999999996E+001,
      -2.1525000000000002E+001,
      -2.1529999999999998E+001,
      -2.1534999999999993E+001,
      -2.1539999999999996E+001,
      -21.545,
      -2.1549999999999997E+001,
      -21.555,
      -21.56,
      -2.1564999999999998E+001,
      -2.1569999999999997E+001,
      -21.575,
      -2.1579999999999995E+001,
      -2.1584999999999997E+001,
      -21.59,
      -21.595,
      -2.1599999999999994E+001,
      -2.1604999999999997E+001,
      -2.1609999999999996E+001,
      -2.1614999999999995E+001,
      -2.1619999999999994E+001,
      -21.625,
      -2.1629999999999995E+001,
      -2.1634999999999998E+001,
      -21.64,
      -2.1644999999999996E+001,
      -21.65,
      -2.1654999999999998E+001,
      -21.66,
      -2.1664999999999996E+001,
      -21.67,
      -2.1674999999999997E+001,
      -2.1679999999999996E+001,
      -2.1684999999999995E+001,
      -2.1689999999999998E+001,
      -2.1694999999999993E+001,
      -21.7,
      -21.705,
      -2.1709999999999997E+001,
      -2.1714999999999996E+001,
      -21.72,
      -2.1724999999999994E+001,
      -2.1729999999999997E+001,
      -2.1735000000000003E+001,
      -21.74,
      -2.1744999999999994E+001,
      -21.75,
      -21.755,
      -2.1759999999999994E+001,
      -2.1764999999999997E+001,
      -2.1769999999999996E+001,
      -21.775,
      -2.1779999999999998E+001,
      -21.785,
      -2.1789999999999996E+001,
      -2.1794999999999998E+001,
      -2.1799999999999997E+001,
      -2.1804999999999996E+001,
      -2.1809999999999995E+001,
      -21.815,
      -2.1819999999999997E+001,
      -2.1824999999999996E+001,
      -2.1830000000000002E+001,
      -2.1834999999999997E+001,
      -2.1839999999999993E+001,
      -2.1844999999999995E+001,
      -21.85,
      -2.1854999999999997E+001,
      -21.86,
      -21.865,
      -2.1869999999999997E+001,
      -2.1874999999999996E+001,
      -21.88,
      -2.1884999999999994E+001,
      -21.89,
      -21.895,
      -21.9,
      -2.1904999999999994E+001,
      -21.91,
      -2.1914999999999996E+001,
      -2.1919999999999995E+001,
      -2.1924999999999994E+001,
      -21.93,
      -2.1934999999999995E+001,
      -2.1939999999999998E+001,
      -21.945,
      -2.1949999999999996E+001,
      -21.955,
      -2.1959999999999997E+001,
      -21.965,
      -21.97,
      -21.975,
      -2.1979999999999997E+001,
      -2.1984999999999996E+001,
      -21.99,
      -2.1994999999999997E+001,
      -2.1999999999999993E+001,
      -22.005,
      -2.2009999999999998E+001,
      -2.2014999999999997E+001,
      -2.2019999999999996E+001,
      -22.025,
      -2.2029999999999994E+001,
      -2.2034999999999997E+001,
      -2.2040000000000003E+001,
      -2.2044999999999998E+001,
      -22.05,
      -22.055,
      -22.06,
      -2.2064999999999994E+001,
      -22.07,
      -2.2074999999999996E+001,
      -22.08,
      -2.2084999999999997E+001,
      -22.09,
      -2.2094999999999995E+001,
      -2.2099999999999998E+001,
      -2.2104999999999997E+001,
      -2.2109999999999996E+001,
      -2.2114999999999995E+001,
      -22.12,
      -2.2124999999999996E+001,
      -22.13,
      -22.135,
      -2.2139999999999997E+001,
      -2.2144999999999992E+001,
      -22.15,
      -22.155,
      -2.2159999999999997E+001,
      -22.165,
      -2.2169999999999998E+001,
      -2.2174999999999997E+001,
      -2.2179999999999996E+001,
      -22.185,
      -2.2189999999999994E+001,
      -22.195,
      -22.2,
      -22.205,
      -2.2209999999999997E+001,
      -22.215,
      -2.2219999999999995E+001,
      -2.2224999999999994E+001,
      -2.2229999999999993E+001,
      -22.235,
      -2.2239999999999995E+001,
      -2.2244999999999997E+001,
      -22.25,
      -2.2254999999999995E+001,
      -2.2259999999999998E+001,
      -2.2264999999999997E+001,
      -22.27,
      -22.275,
      -22.28,
      -2.2284999999999997E+001,
      -2.2289999999999996E+001,
      -2.2294999999999998E+001,
      -2.2299999999999997E+001,
      -2.2304999999999993E+001,
      -22.31,
      -2.2314999999999998E+001,
      -2.2319999999999997E+001,
      -2.2324999999999996E+001,
      -22.33,
      -2.2334999999999994E+001,
      -2.2339999999999996E+001,
      -2.2345000000000002E+001,
      -2.2349999999999998E+001,
      -22.355,
      -22.36,
      -22.365,
      -2.2369999999999994E+001,
      -22.375,
      -2.2379999999999995E+001,
      -2.2384999999999998E+001,
      -2.2389999999999997E+001,
      -22.395,
      -2.2399999999999995E+001,
      -2.2404999999999998E+001,
      -2.2409999999999997E+001,
      -2.2414999999999996E+001,
      -2.2419999999999995E+001,
      -22.425,
      -2.2429999999999996E+001,
      -22.435,
      -22.44,
      -2.2444999999999997E+001,
      -2.2449999999999992E+001,
      -22.455,
      -22.46,
      -2.2464999999999996E+001,
      -22.47,
      -2.2474999999999998E+001,
      -2.2479999999999997E+001,
      -2.2484999999999996E+001,
      -22.49,
      -2.2494999999999994E+001,
      -22.5,
      -22.505,
      -2.2509999999999998E+001,
      -2.2514999999999997E+001,
      -22.52,
      -2.2524999999999995E+001,
      -2.2529999999999994E+001,
      -2.2535000000000004E+001,
      -22.54,
      -2.2544999999999995E+001,
      -2.2549999999999997E+001,
      -22.555,
      -2.2559999999999995E+001,
      -2.2564999999999998E+001,
      -2.2569999999999997E+001,
      -22.575,
      -22.58,
      -22.585,
      -2.2589999999999996E+001,
      -22.595,
      -2.2599999999999998E+001,
      -2.2604999999999997E+001,
      -2.2609999999999992E+001,
      -2.2615000000000002E+001,
      -2.2619999999999997E+001,
      -2.2624999999999996E+001,
      -2.2629999999999995E+001,
      -2.2634999999999998E+001,
      -2.2639999999999993E+001,
      -2.2644999999999996E+001,
      -2.2650000000000002E+001,
      -2.2654999999999998E+001,
      -22.66,
      -22.665,
      -2.2669999999999998E+001,
      -2.2674999999999997E+001,
      -22.68,
      -2.2684999999999995E+001,
      -2.2689999999999998E+001,
      -22.695,
      -22.7,
      -2.2704999999999995E+001,
      -2.2709999999999997E+001,
      -2.2714999999999996E+001,
      -2.2719999999999995E+001,
      -2.2724999999999994E+001,
      -22.73,
      -2.2734999999999996E+001,
      -22.74,
      -22.745,
      -2.2749999999999996E+001,
      -22.755,
      -2.2759999999999998E+001,
      -22.765,
      -2.2769999999999996E+001,
      -2.2775000000000002E+001,
      -2.2779999999999998E+001,
      -2.2784999999999997E+001,
      -2.2789999999999996E+001,
      -2.2794999999999998E+001,
      -2.2799999999999994E+001,
      -22.805,
      -22.81,
      -2.2814999999999998E+001,
      -2.2819999999999997E+001,
      -22.825,
      -2.2829999999999995E+001,
      -2.2834999999999997E+001,
      -2.2840000000000003E+001,
      -22.845,
      -2.2849999999999994E+001,
      -2.2854999999999997E+001,
      -22.86,
      -2.2864999999999995E+001,
      -2.2869999999999997E+001,
      -2.2874999999999996E+001,
      -22.88,
      -2.2884999999999998E+001,
      -22.89,
      -2.2894999999999996E+001,
      -22.9,
      -2.2904999999999998E+001,
      -2.2909999999999997E+001,
      -2.2914999999999992E+001,
      -22.92,
      -2.2924999999999997E+001,
      -2.2929999999999996E+001,
      -2.2934999999999995E+001,
      -2.2939999999999998E+001,
      -2.2944999999999993E+001,
      -2.2949999999999996E+001,
      -2.2955000000000002E+001,
      -2.2959999999999997E+001,
      -22.965,
      -22.97,
      -2.2974999999999998E+001,
      -2.2979999999999997E+001,
      -22.985,
      -2.2989999999999995E+001,
      -2.2994999999999997E+001,
      -23.0,
      -23.005,
      -2.3009999999999994E+001,
      -2.3014999999999997E+001,
      -2.3019999999999996E+001,
      -2.3024999999999995E+001,
      -2.3029999999999994E+001,
      -23.035,
      -2.3039999999999996E+001,
      -2.3044999999999998E+001,
      -23.05,
      -2.3054999999999996E+001,
      -23.06,
      -2.3064999999999998E+001,
      -23.07,
      -2.3074999999999996E+001,
      -2.3080000000000002E+001,
      -2.3084999999999997E+001,
      -2.3089999999999996E+001,
      -2.3094999999999995E+001,
      -2.3099999999999998E+001,
      -2.3104999999999993E+001,
      -23.11,
      -23.115,
      -2.3119999999999997E+001,
      -2.3124999999999996E+001,
      -23.13,
      -2.3134999999999994E+001,
      -2.3139999999999997E+001,
      -2.3145000000000003E+001,
      -23.15,
      -2.3154999999999994E+001,
      -23.16,
      -23.165,
      -2.3169999999999995E+001,
      -2.3174999999999997E+001,
      -2.3179999999999996E+001,
      -23.185,
      -2.3189999999999998E+001,
      -23.195,
      -2.3199999999999996E+001,
      -23.205,
      -2.3209999999999997E+001,
      -2.3214999999999996E+001,
      -2.3219999999999995E+001,
      -23.225,
      -2.3229999999999997E+001,
      -2.3234999999999996E+001,
      -2.3240000000000002E+001,
      -2.3244999999999997E+001,
      -2.3249999999999993E+001,
      -2.3254999999999995E+001,
      -23.26,
      -2.3264999999999997E+001,
      -23.27,
      -23.275,
      -2.3279999999999998E+001,
      -2.3284999999999997E+001,
      -23.29,
      -2.3294999999999995E+001,
      -23.3,
      -23.305,
      -23.31,
      -2.3314999999999994E+001,
      -23.32,
      -2.3324999999999996E+001,
      -2.3329999999999995E+001,
      -2.3334999999999994E+001,
      -23.34,
      -2.3344999999999995E+001,
      -2.3349999999999998E+001,
      -23.355,
      -2.3359999999999996E+001,
      -23.365,
      -2.3369999999999997E+001,
      -23.375,
      -23.38,
      -23.385,
      -2.3389999999999997E+001,
      -2.3394999999999996E+001,
      -23.4,
      -2.3404999999999998E+001,
      -2.3409999999999993E+001,
      -23.415,
      -2.3419999999999998E+001,
      -2.3424999999999997E+001,
      -2.3429999999999996E+001,
      -23.435,
      -2.3439999999999994E+001,
      -2.3444999999999997E+001,
      -2.3450000000000003E+001,
      -23.455,
      -23.46,
      -23.465,
      -23.47,
      -2.3474999999999994E+001,
      -23.48,
      -2.3484999999999996E+001,
      -23.49,
      -2.3494999999999997E+001,
      -23.5,
      -2.3504999999999995E+001,
      -2.3509999999999998E+001,
      -2.3514999999999997E+001,
      -2.3519999999999996E+001,
      -2.3524999999999995E+001,
      -23.53,
      -2.3534999999999997E+001,
      -2.3539999999999996E+001,
      -23.545,
      -2.3549999999999997E+001,
      -2.3554999999999993E+001,
      -2.3559999999999995E+001,
      -23.565,
      -2.3569999999999997E+001,
      -23.575,
      -23.58,
      -2.3584999999999997E+001,
      -2.3589999999999996E+001,
      -23.595,
      -2.3599999999999994E+001,
      -23.605,
      -23.61,
      -23.615,
      -2.3619999999999994E+001,
      -23.625,
      -2.3629999999999995E+001,
      -2.3634999999999994E+001,
      -2.3639999999999993E+001,
      -23.645,
      -2.3649999999999995E+001,
      -2.3654999999999998E+001,
      -23.66,
      -2.3664999999999996E+001,
      -2.3669999999999998E+001,
      -2.3674999999999997E+001,
      -23.68,
      -23.685,
      -23.69,
      -2.3694999999999997E+001,
      -2.3699999999999996E+001,
      -23.705,
      -2.3709999999999997E+001,
      -2.3714999999999993E+001,
      -23.72,
      -2.3724999999999998E+001,
      -2.3729999999999997E+001,
      -2.3734999999999996E+001,
      -23.74,
      -2.3744999999999994E+001,
      -2.3749999999999996E+001,
      -2.3755000000000003E+001,
      -2.3759999999999998E+001,
      -23.765,
      -23.77,
      -23.775,
      -2.3779999999999994E+001,
      -23.785,
      -2.3789999999999996E+001,
      -2.3794999999999998E+001,
      -2.3799999999999997E+001,
      -23.805,
      -2.3809999999999995E+001,
      -2.3814999999999998E+001,
      -2.3819999999999997E+001,
      -2.3824999999999996E+001,
      -2.3829999999999995E+001,
      -23.835,
      -2.3839999999999996E+001,
      -23.845,
      -23.85,
      -2.3854999999999997E+001,
      -2.3859999999999992E+001,
      -23.865,
      -23.87,
      -2.3874999999999996E+001,
      -23.88,
      -2.3884999999999998E+001,
      -2.3889999999999997E+001,
      -2.3894999999999996E+001,
      -23.9,
      -2.3904999999999994E+001,
      -23.91,
      -23.915,
      -2.3919999999999998E+001,
      -2.3924999999999997E+001,
      -23.93,
      -2.3934999999999995E+001,
      -2.3939999999999994E+001,
      -2.3945000000000004E+001,
      -23.95,
      -2.3954999999999995E+001,
      -2.3959999999999997E+001,
      -23.965,
      -2.3969999999999995E+001,
      -2.3974999999999998E+001,
      -2.3979999999999997E+001,
      -23.985,
      -23.99,
      -23.995,
      -2.3999999999999996E+001,
      -24.005,
      -2.4009999999999998E+001,
      -2.4014999999999997E+001,
      -2.4019999999999992E+001,
      -2.4025000000000002E+001,
      -2.4029999999999998E+001,
      -2.4034999999999997E+001,
      -2.4039999999999996E+001,
      -2.4044999999999998E+001,
      -2.4049999999999994E+001,
      -2.4054999999999996E+001,
      -2.4060000000000002E+001,
      -2.4064999999999998E+001,
      -24.07,
      -24.075,
      -24.08,
      -2.4084999999999997E+001,
      -24.09,
      -2.4094999999999995E+001,
      -2.4099999999999998E+001,
      -24.105,
      -24.11,
      -2.4114999999999995E+001,
      -2.4119999999999997E+001,
      -2.4124999999999996E+001,
      -2.4129999999999995E+001,
      -2.4134999999999998E+001,
      -24.14,
      -2.4144999999999996E+001,
      -24.15,
      -24.155,
      -2.4159999999999997E+001,
      -2.4164999999999992E+001,
      -2.4169999999999998E+001,
      -24.175,
      -2.4179999999999996E+001,
      -24.185,
      -2.4189999999999998E+001,
      -2.4194999999999997E+001,
      -2.4199999999999996E+001,
      -24.205,
      -2.4209999999999994E+001,
      -24.215,
      -24.22,
      -2.4224999999999998E+001,
      -2.4229999999999997E+001,
      -24.235,
      -2.4239999999999995E+001,
      -2.4244999999999994E+001,
      -2.4250000000000004E+001,
      -24.255,
      -2.4259999999999994E+001,
      -2.4264999999999997E+001,
      -24.27,
      -2.4274999999999995E+001,
      -2.4279999999999998E+001,
      -2.4284999999999997E+001,
      -24.29,
      -2.4294999999999998E+001,
      -24.3,
      -2.4304999999999996E+001,
      -24.31,
      -2.4314999999999998E+001,
      -2.4319999999999997E+001,
      -2.4324999999999992E+001,
      -2.4330000000000002E+001,
      -2.4334999999999997E+001,
      -2.4339999999999996E+001,
      -2.4344999999999995E+001,
      -2.4349999999999998E+001,
      -2.4354999999999993E+001,
      -2.4359999999999996E+001,
      -2.4365000000000002E+001,
      -2.4369999999999997E+001,
      -24.375,
      -24.38,
      -2.4384999999999998E+001,
      -2.4389999999999997E+001,
      -24.395,
      -2.4399999999999995E+001,
      -2.4404999999999998E+001,
      -24.41,
      -24.415,
      -2.4419999999999995E+001,
      -2.4424999999999997E+001,
      -2.4429999999999996E+001,
      -2.4434999999999995E+001,
      -2.4439999999999998E+001,
      -24.445,
      -2.4449999999999996E+001,
      -24.455,
      -24.46,
      -2.4464999999999996E+001,
      -24.47,
      -2.4474999999999998E+001,
      -24.48,
      -2.4484999999999996E+001,
      -2.4490000000000002E+001,
      -2.4494999999999997E+001,
      -2.4499999999999996E+001,
      -2.4504999999999995E+001,
      -2.4509999999999998E+001,
      -2.4514999999999993E+001,
      -24.52,
      -24.525,
      -2.4529999999999998E+001,
      -2.4534999999999997E+001,
      -24.54,
      -2.4544999999999995E+001,
      -2.4549999999999997E+001,
      -2.4555000000000003E+001,
      -24.56,
      -2.4564999999999994E+001,
      -24.57,
      -24.575,
      -2.4579999999999995E+001,
      -2.4584999999999997E+001,
      -2.4589999999999996E+001,
      -24.595,
      -2.4599999999999998E+001,
      -24.605,
      -2.4609999999999996E+001,
      -24.615,
      -2.4619999999999997E+001,
      -2.4624999999999996E+001,
      -24.63,
      -24.635,
      -2.4639999999999997E+001,
      -2.4644999999999996E+001,
      -2.4650000000000002E+001,
      -2.4654999999999998E+001,
      -2.4659999999999993E+001,
      -2.4664999999999996E+001,
      -24.67,
      -2.4674999999999997E+001,
      -24.68,
      -24.685,
      -2.4689999999999998E+001,
      -2.4694999999999997E+001,
      -24.7,
      -2.4704999999999995E+001,
      -24.71,
      -24.715,
      -24.72,
      -2.4724999999999994E+001,
      -24.73,
      -2.4734999999999996E+001,
      -2.4739999999999995E+001,
      -2.4744999999999997E+001,
      -24.75,
      -2.4754999999999995E+001,
      -2.4759999999999998E+001,
      -24.765,
      -2.4769999999999996E+001,
      -24.775,
      -2.4779999999999998E+001,
      -24.785,
      -2.4789999999999996E+001,
      -24.795,
      -2.4799999999999997E+001,
      -2.4804999999999996E+001,
      -2.4809999999999995E+001,
      -2.4814999999999998E+001,
      -2.4819999999999993E+001,
      -24.825,
      -24.83,
      -2.4834999999999997E+001,
      -2.4839999999999996E+001,
      -24.845,
      -2.4849999999999994E+001,
      -2.4854999999999997E+001,
      -2.4860000000000003E+001,
      -24.865,
      -2.4869999999999994E+001,
      -24.875,
      -24.88,
      -2.4884999999999994E+001,
      -2.4889999999999997E+001,
      -2.4894999999999996E+001,
      -24.9,
      -2.4904999999999998E+001,
      -24.91,
      -2.4914999999999996E+001,
      -2.4919999999999998E+001,
      -2.4924999999999997E+001,
      -2.4929999999999996E+001,
      -24.935,
      -24.94,
      -2.4944999999999997E+001,
      -2.4949999999999996E+001,
      -2.4955000000000002E+001,
      -2.4959999999999997E+001,
      -2.4964999999999993E+001,
      -2.4969999999999995E+001,
      -24.975,
      -2.4979999999999997E+001,
      -24.985,
      -24.99,
      -2.4994999999999997E+001,
      -2.4999999999999996E+001,
      -25.005,
      -2.5009999999999994E+001,
      -25.015,
      -25.02,
      -25.025,
      -2.5029999999999994E+001,
      -25.035,
      -2.5039999999999996E+001,
      -2.5044999999999995E+001,
      -2.5049999999999997E+001,
      -25.055,
      -2.5059999999999995E+001,
      -2.5064999999999998E+001,
      -25.07,
      -2.5074999999999996E+001,
      -25.08,
      -2.5084999999999997E+001,
      -25.09,
      -25.095,
      -25.1,
      -2.5104999999999997E+001,
      -2.5109999999999996E+001,
      -25.115,
      -2.5119999999999997E+001,
      -2.5124999999999993E+001,
      -25.13,
      -2.5134999999999998E+001,
      -2.5139999999999997E+001,
      -2.5144999999999996E+001,
      -25.15,
      -2.5154999999999994E+001,
      -2.5159999999999997E+001,
      -2.5165000000000003E+001,
      -2.5169999999999998E+001,
      -25.175,
      -25.18,
      -25.185,
      -2.5189999999999994E+001,
      -25.195,
      -2.5199999999999996E+001,
      -25.205,
      -2.5209999999999997E+001,
      -25.215,
      -2.5219999999999995E+001,
      -2.5224999999999998E+001,
      -2.5229999999999997E+001,
      -2.5234999999999996E+001,
      -25.24,
      -25.245,
      -2.5249999999999996E+001,
      -25.255,
      -25.26,
      -2.5264999999999997E+001,
      -2.5269999999999992E+001,
      -25.275,
      -25.28,
      -2.5284999999999997E+001,
      -25.29,
      -2.5294999999999998E+001,
      -2.5299999999999997E+001,
      -2.5304999999999996E+001,
      -25.31,
      -2.5314999999999994E+001,
      -25.32,
      -25.325,
      -25.33,
      -2.5334999999999997E+001,
      -25.34,
      -2.5344999999999995E+001,
      -2.5349999999999994E+001,
      -2.5355000000000004E+001,
      -25.36,
      -2.5364999999999995E+001,
      -2.5369999999999997E+001,
      -25.375,
      -2.5379999999999995E+001,
      -2.5384999999999998E+001,
      -2.5389999999999997E+001,
      -25.395,
      -25.4,
      -25.405,
      -2.5409999999999997E+001,
      -25.415,
      -2.5419999999999998E+001,
      -2.5424999999999997E+001,
      -2.5429999999999993E+001,
      -25.435,
      -2.5439999999999998E+001,
      -2.5444999999999997E+001,
      -2.5449999999999996E+001,
      -25.455,
      -2.5459999999999994E+001,
      -2.5464999999999996E+001,
      -2.5470000000000002E+001,
      -2.5474999999999998E+001,
      -25.48,
      -25.485,
      -25.49,
      -2.5494999999999994E+001,
      -25.5,
      -2.5504999999999995E+001,
      -2.5509999999999998E+001,
      -2.5514999999999997E+001,
      -25.52,
      -2.5524999999999995E+001,
      -2.5529999999999998E+001,
      -2.5534999999999997E+001,
      -2.5539999999999996E+001,
      -2.5544999999999998E+001,
      -25.55,
      -2.5554999999999996E+001,
      -25.56,
      -25.565,
      -2.5569999999999997E+001,
      -2.5574999999999992E+001,
      -25.58,
      -25.585,
      -2.5589999999999996E+001,
      -25.595,
      -2.5599999999999998E+001,
      -2.5604999999999997E+001,
      -2.5609999999999996E+001,
      -25.615,
      -2.5619999999999994E+001,
      -25.625,
      -25.63,
      -2.5634999999999998E+001,
      -2.5639999999999997E+001,
      -25.645,
      -2.5649999999999995E+001,
      -2.5654999999999994E+001,
      -2.5660000000000004E+001,
      -25.665,
      -2.5669999999999995E+001,
      -2.5674999999999997E+001,
      -25.68,
      -2.5684999999999995E+001,
      -2.5689999999999998E+001,
      -2.5694999999999997E+001,
      -25.7,
      -25.705,
      -25.71,
      -2.5714999999999996E+001,
      -25.72,
      -2.5724999999999998E+001,
      -2.5729999999999997E+001,
      -2.5734999999999992E+001,
      -2.5740000000000002E+001,
      -2.5744999999999997E+001,
      -2.5749999999999996E+001,
      -2.5754999999999995E+001,
      -2.5759999999999998E+001,
      -2.5764999999999993E+001,
      -2.5769999999999996E+001,
      -2.5775000000000002E+001,
      -2.5779999999999998E+001,
      -25.785,
      -25.79,
      -2.5794999999999998E+001,
      -2.5799999999999997E+001,
      -25.805,
      -2.5809999999999995E+001,
      -2.5814999999999998E+001,
      -25.82,
      -25.825,
      -2.5829999999999995E+001,
      -2.5834999999999997E+001,
      -2.5839999999999996E+001,
      -2.5844999999999995E+001,
      -2.5849999999999998E+001,
      -25.855,
      -2.5859999999999996E+001,
      -25.865,
      -25.87,
      -2.5874999999999996E+001,
      -25.88,
      -2.5884999999999998E+001,
      -25.89,
      -2.5894999999999996E+001,
      -2.5900000000000002E+001,
      -2.5904999999999998E+001,
      -2.5909999999999997E+001,
      -2.5914999999999996E+001,
      -2.5919999999999998E+001,
      -2.5924999999999994E+001,
      -25.93,
      -25.935,
      -2.5939999999999998E+001,
      -2.5944999999999997E+001,
      -25.95,
      -2.5954999999999995E+001,
      -2.5959999999999997E+001,
      -2.5965000000000003E+001,
      -25.97,
      -2.5974999999999994E+001,
      -25.98,
      -25.985,
      -2.5989999999999995E+001,
      -2.5994999999999997E+001,
      -2.5999999999999996E+001,
      -26.005,
      -2.6009999999999998E+001,
      -26.015,
      -2.6019999999999996E+001,
      -26.025,
      -2.6029999999999998E+001,
      -2.6034999999999997E+001,
      -26.04,
      -26.045,
      -2.6049999999999997E+001,
      -2.6054999999999996E+001,
      -2.6059999999999995E+001,
      -2.6064999999999998E+001,
      -2.6069999999999993E+001,
      -2.6074999999999996E+001,
      -2.6080000000000002E+001,
      -2.6084999999999997E+001,
      -26.09,
      -26.095,
      -2.6099999999999998E+001,
      -2.6104999999999997E+001,
      -26.11,
      -2.6114999999999995E+001,
      -2.6119999999999997E+001,
      -26.125,
      -26.13,
      -2.6134999999999994E+001,
      -2.6139999999999997E+001,
      -2.6144999999999996E+001,
      -2.6149999999999995E+001,
      -2.6154999999999998E+001,
      -26.16,
      -2.6164999999999996E+001,
      -2.6169999999999998E+001,
      -26.175,
      -2.6179999999999996E+001,
      -26.185,
      -2.6189999999999998E+001,
      -26.195,
      -2.6199999999999996E+001,
      -2.6205000000000002E+001,
      -2.6209999999999997E+001,
      -2.6214999999999996E+001,
      -2.6219999999999995E+001,
      -2.6224999999999998E+001,
      -2.6229999999999993E+001,
      -26.235,
      -26.24,
      -2.6244999999999997E+001,
      -2.6249999999999996E+001,
      -26.255,
      -2.6259999999999994E+001,
      -2.6264999999999997E+001,
      -2.6270000000000003E+001,
      -26.275,
      -2.6279999999999994E+001,
      -26.285,
      -26.29,
      -2.6294999999999995E+001,
      -2.6299999999999997E+001,
      -2.6304999999999996E+001,
      -26.31,
      -2.6314999999999998E+001,
      -26.32,
      -2.6324999999999996E+001,
      -26.33,
      -2.6334999999999997E+001,
      -2.6339999999999996E+001,
      -26.345,
      -26.35,
      -2.6354999999999997E+001,
      -2.6359999999999996E+001,
      -2.6365000000000002E+001,
      -2.6369999999999997E+001,
      -2.6374999999999993E+001,
      -2.6379999999999995E+001,
      -26.385,
      -2.6389999999999997E+001,
      -26.395,
      -26.4,
      -2.6404999999999998E+001,
      -2.6409999999999997E+001,
      -26.415,
      -2.6419999999999995E+001,
      -26.425,
      -26.43,
      -26.435,
      -2.6439999999999994E+001,
      -26.445,
      -2.6449999999999996E+001,
      -2.6454999999999995E+001,
      -2.6459999999999997E+001,
      -26.465,
      -2.6469999999999995E+001,
      -2.6474999999999998E+001,
      -26.48,
      -2.6484999999999996E+001,
      -26.49,
      -2.6494999999999997E+001,
      -26.5,
      -26.505,
      -26.51,
      -2.6514999999999997E+001,
      -2.6519999999999996E+001,
      -26.525,
      -2.6529999999999998E+001,
      -2.6534999999999993E+001,
      -26.54,
      -2.6544999999999998E+001,
      -2.6549999999999997E+001,
      -2.6554999999999996E+001,
      -26.56,
      -2.6564999999999994E+001,
      -2.6569999999999997E+001,
      -2.6575000000000003E+001,
      -26.58,
      -26.585,
      -26.59,
      -26.595,
      -2.6599999999999994E+001,
      -26.605,
      -2.6609999999999996E+001,
      -26.615,
      -2.6619999999999997E+001,
      -26.625,
      -2.6629999999999995E+001,
      -2.6634999999999998E+001,
      -2.6639999999999997E+001,
      -2.6644999999999996E+001,
      -26.65,
      -26.655,
      -2.6659999999999997E+001,
      -26.665,
      -26.67,
      -2.6674999999999997E+001,
      -2.6679999999999993E+001,
      -26.685,
      -26.69,
      -2.6694999999999997E+001,
      -26.7,
      -26.705,
      -2.6709999999999997E+001,
      -2.6714999999999996E+001,
      -26.72,
      -2.6724999999999994E+001,
      -26.73,
      -26.735,
      -26.74,
      -2.6744999999999994E+001,
      -26.75,
      -2.6754999999999995E+001,
      -2.6759999999999994E+001,
      -2.6764999999999997E+001,
      -26.77,
      -2.6774999999999995E+001,
      -2.6779999999999998E+001,
      -26.785,
      -2.6789999999999996E+001,
      -2.6794999999999998E+001,
      -2.6799999999999997E+001,
      -26.805,
      -26.81,
      -26.815,
      -2.6819999999999997E+001,
      -2.6824999999999996E+001,
      -26.83,
      -2.6834999999999997E+001,
      -2.6839999999999993E+001,
      -26.845,
      -2.6849999999999998E+001,
      -2.6854999999999997E+001,
      -2.6859999999999996E+001,
      -26.865,
      -2.6869999999999994E+001,
      -2.6874999999999996E+001,
      -2.6880000000000003E+001,
      -2.6884999999999998E+001,
      -26.89,
      -26.895,
      -26.9,
      -2.6904999999999994E+001,
      -26.91,
      -2.6914999999999996E+001,
      -2.6919999999999998E+001,
      -2.6924999999999997E+001,
      -26.93,
      -2.6934999999999995E+001,
      -2.6939999999999998E+001,
      -2.6944999999999997E+001,
      -2.6949999999999996E+001,
      -26.955,
      -26.96,
      -2.6964999999999996E+001,
      -26.97,
      -26.975,
      -2.6979999999999997E+001,
      -2.6984999999999992E+001,
      -26.99,
      -26.995,
      -2.6999999999999996E+001,
      -27.005,
      -2.7009999999999998E+001,
      -2.7014999999999997E+001,
      -2.7019999999999996E+001,
      -27.025,
      -2.7029999999999994E+001,
      -27.035,
      -27.04,
      -2.7044999999999998E+001,
      -2.7049999999999997E+001,
      -27.055,
      -2.7059999999999995E+001,
      -2.7064999999999994E+001,
      -2.7070000000000004E+001,
      -27.075,
      -2.7079999999999995E+001,
      -2.7084999999999997E+001,
      -27.09,
      -2.7094999999999995E+001,
      -2.7099999999999998E+001,
      -2.7104999999999997E+001,
      -27.11,
      -27.115,
      -27.12,
      -2.7124999999999996E+001,
      -27.13,
      -2.7134999999999998E+001,
      -2.7139999999999997E+001,
      -2.7144999999999992E+001,
      -2.7150000000000002E+001,
      -2.7154999999999998E+001,
      -2.7159999999999997E+001,
      -2.7164999999999996E+001,
      -2.7169999999999998E+001,
      -2.7174999999999994E+001,
      -2.7179999999999996E+001,
      -2.7185000000000002E+001,
      -2.7189999999999998E+001,
      -27.195,
      -27.2,
      -27.205,
      -2.7209999999999997E+001,
      -27.215,
      -2.7219999999999995E+001,
      -2.7224999999999998E+001,
      -27.23,
      -27.235,
      -2.7239999999999995E+001,
      -2.7244999999999997E+001,
      -2.7249999999999996E+001,
      -2.7254999999999995E+001,
      -2.7259999999999998E+001,
      -27.265,
      -2.7269999999999996E+001,
      -27.275,
      -27.28,
      -2.7284999999999997E+001,
      -27.29,
      -2.7294999999999998E+001,
      -27.3,
      -2.7304999999999996E+001,
      -2.7310000000000002E+001,
      -2.7314999999999998E+001,
      -2.7319999999999997E+001,
      -2.7324999999999996E+001,
      -27.33,
      -2.7334999999999994E+001,
      -27.34,
      -27.345,
      -2.7349999999999998E+001,
      -2.7354999999999997E+001,
      -27.36,
      -2.7364999999999995E+001,
      -2.7369999999999994E+001,
      -2.7375000000000004E+001,
      -27.38,
      -2.7384999999999994E+001,
      -2.7389999999999997E+001,
      -27.395,
      -2.7399999999999995E+001,
      -2.7404999999999998E+001,
      -2.7409999999999997E+001,
      -27.415,
      -2.7419999999999998E+001,
      -27.425,
      -2.7429999999999996E+001,
      -27.435,
      -2.7439999999999998E+001,
      -2.7444999999999997E+001,
      -2.7449999999999992E+001,
      -2.7455000000000002E+001,
      -2.7459999999999997E+001,
      -2.7464999999999996E+001,
      -2.7469999999999995E+001,
      -2.7474999999999998E+001,
      -2.7479999999999993E+001,
      -2.7484999999999996E+001,
      -2.7490000000000002E+001,
      -2.7494999999999997E+001,
      -27.5,
      -27.505,
      -2.7509999999999998E+001,
      -2.7514999999999997E+001,
      -27.52,
      -2.7524999999999995E+001,
      -2.7529999999999998E+001,
      -27.535,
      -27.54,
      -2.7544999999999995E+001,
      -2.7549999999999997E+001,
      -2.7554999999999996E+001,
      -2.7559999999999995E+001,
      -2.7564999999999998E+001,
      -27.57,
      -2.7574999999999996E+001,
      -27.58,
      -27.585,
      -2.7589999999999996E+001,
      -27.595,
      -2.7599999999999998E+001,
      -27.605,
      -2.7609999999999996E+001,
      -2.7615000000000002E+001,
      -2.7619999999999997E+001,
      -2.7624999999999996E+001,
      -2.7629999999999995E+001,
      -2.7634999999999998E+001,
      -2.7639999999999993E+001,
      -27.645,
      -27.65,
      -2.7654999999999998E+001,
      -2.7659999999999997E+001,
      -27.665,
      -2.7669999999999995E+001,
      -2.7674999999999997E+001,
      -2.7680000000000003E+001,
      -27.685,
      -2.7689999999999994E+001,
      -27.695,
      -27.7,
      -2.7704999999999995E+001,
      -2.7709999999999997E+001,
      -2.7714999999999996E+001,
      -27.72,
      -2.7724999999999998E+001,
      -27.73,
      -2.7734999999999996E+001,
      -27.74,
      -2.7744999999999997E+001,
      -2.7749999999999996E+001,
      -27.755,
      -27.76,
      -2.7764999999999997E+001,
      -2.7769999999999996E+001,
      -2.7775000000000002E+001,
      -2.7779999999999998E+001,
      -2.7784999999999993E+001,
      -2.7789999999999996E+001,
      -27.795,
      -2.7799999999999997E+001,
      -27.805,
      -27.81,
      -2.7814999999999998E+001,
      -2.7819999999999997E+001,
      -27.825,
      -2.7829999999999995E+001,
      -27.835,
      -27.84,
      -27.845,
      -2.7849999999999994E+001,
      -27.855,
      -2.7859999999999996E+001,
      -2.7864999999999995E+001,
      -2.7869999999999997E+001,
      -27.875,
      -2.7879999999999995E+001,
      -2.7884999999999998E+001,
      -27.89,
      -2.7894999999999996E+001,
      -27.9,
      -2.7904999999999998E+001,
      -27.91,
      -27.915,
      -27.92,
      -2.7924999999999997E+001,
      -2.7929999999999996E+001,
      -27.935,
      -2.7939999999999998E+001,
      -2.7944999999999993E+001,
      -27.95,
      -27.955,
      -2.7959999999999997E+001,
      -2.7964999999999996E+001,
      -27.97,
      -2.7974999999999994E+001,
      -2.7979999999999997E+001,
      -2.7985000000000003E+001,
      -27.99,
      -2.7994999999999994E+001,
      -28.0,
      -28.005,
      -2.8009999999999994E+001,
      -2.8014999999999997E+001,
      -28.02,
      -28.025,
      -2.8029999999999998E+001,
      -28.035,
      -2.8039999999999996E+001,
      -2.8044999999999998E+001,
      -2.8049999999999997E+001,
      -2.8054999999999996E+001,
      -28.06,
      -28.065,
      -2.8069999999999997E+001,
      -2.8074999999999996E+001,
      -2.8080000000000002E+001,
      -2.8084999999999997E+001,
      -2.8089999999999993E+001,
      -2.8094999999999995E+001,
      -28.1,
      -2.8104999999999997E+001,
      -28.11,
      -28.115,
      -2.8119999999999997E+001,
      -2.8124999999999996E+001,
      -28.13,
      -2.8134999999999998E+001,
      -28.14,
      -28.145,
      -28.15,
      -2.8154999999999994E+001,
      -28.16,
      -2.8164999999999996E+001,
      -2.8169999999999995E+001,
      -2.8174999999999997E+001,
      -28.18,
      -2.8184999999999995E+001,
      -2.8189999999999998E+001,
      -28.195,
      -2.8199999999999996E+001,
      -28.205,
      -28.21,
      -28.215,
      -28.22,
      -28.225,
      -2.8229999999999997E+001,
      -2.8234999999999996E+001,
      -28.24,
      -2.8244999999999997E+001,
      -2.8249999999999996E+001,
      -28.255,
      -2.8259999999999998E+001,
      -2.8264999999999997E+001,
      -2.8269999999999996E+001,
      -28.275,
      -2.8279999999999994E+001,
      -2.8284999999999997E+001,
      -2.8290000000000003E+001,
      -2.8294999999999998E+001,
      -28.3,
      -28.305,
      -28.31,
      -2.8314999999999994E+001,
      -28.32,
      -28.325,
      -28.33,
      -2.8334999999999997E+001,
      -28.34,
      -2.8344999999999995E+001,
      -2.8349999999999998E+001,
      -2.8354999999999997E+001,
      -2.8359999999999996E+001,
      -28.365,
      -28.37,
      -2.8374999999999996E+001,
      -28.38,
      -28.385,
      -2.8389999999999997E+001,
      -2.8394999999999992E+001,
      -2.8400000000000002E+001,
      -28.405,
      -2.8409999999999997E+001,
      -28.415,
      -2.8419999999999998E+001,
      -2.8424999999999997E+001,
      -2.8429999999999996E+001,
      -28.435,
      -2.8439999999999998E+001,
      -28.445,
      -28.45,
      -28.455,
      -2.8459999999999997E+001,
      -28.465,
      -2.8469999999999995E+001,
      -2.8474999999999994E+001,
      -2.8480000000000004E+001,
      -28.485,
      -2.8489999999999995E+001,
      -2.8494999999999997E+001,
      -28.5,
      -2.8504999999999995E+001,
      -2.8509999999999998E+001,
      -28.515,
      -28.52,
      -28.525,
      -28.53,
      -2.8534999999999997E+001,
      -28.54,
      -2.8544999999999998E+001,
      -2.8549999999999997E+001,
      -2.8554999999999996E+001,
      -2.8560000000000002E+001,
      -2.8564999999999998E+001,
      -2.8569999999999997E+001,
      -2.8574999999999996E+001,
      -28.58,
      -2.8584999999999994E+001,
      -2.8589999999999996E+001,
      -2.8595000000000002E+001,
      -2.8599999999999998E+001,
      -28.605,
      -28.61,
      -28.615,
      -2.8619999999999994E+001,
      -28.625,
      -28.63,
      -2.8634999999999998E+001,
      -2.8639999999999997E+001,
      -28.645,
      -2.8649999999999995E+001,
      -2.8654999999999998E+001,
      -2.8659999999999997E+001,
      -2.8664999999999996E+001,
      -2.8669999999999998E+001,
      -28.675,
      -2.8679999999999996E+001,
      -28.685,
      -28.69,
      -2.8694999999999997E+001,
      -2.8699999999999992E+001,
      -2.8705000000000002E+001,
      -28.71,
      -2.8714999999999996E+001,
      -28.72,
      -2.8724999999999998E+001,
      -2.8729999999999997E+001,
      -2.8734999999999996E+001,
      -28.74,
      -2.8744999999999997E+001,
      -28.75,
      -28.755,
      -2.8759999999999998E+001,
      -2.8764999999999997E+001,
      -28.77,
      -2.8774999999999995E+001,
      -2.8779999999999994E+001,
      -2.8785000000000004E+001,
      -28.79,
      -2.8794999999999995E+001,
      -2.8799999999999997E+001,
      -28.805,
      -2.8809999999999995E+001,
      -2.8814999999999998E+001,
      -28.82,
      -28.825,
      -28.83,
      -28.835,
      -2.8839999999999996E+001,
      -28.845,
      -2.8849999999999998E+001,
      -2.8854999999999997E+001,
      -2.8859999999999996E+001,
      -2.8865000000000002E+001,
      -2.8869999999999997E+001,
      -2.8874999999999996E+001,
      -2.8879999999999995E+001,
      -2.8884999999999998E+001,
      -2.8889999999999993E+001,
      -2.8894999999999996E+001,
      -2.8900000000000002E+001,
      -2.8904999999999998E+001,
      -28.91,
      -28.915,
      -2.8919999999999998E+001,
      -2.8924999999999997E+001,
      -28.93,
      -28.935,
      -2.8939999999999998E+001,
      -28.945,
      -28.95,
      -2.8954999999999995E+001,
      -2.8959999999999997E+001,
      -2.8964999999999996E+001,
      -2.8969999999999995E+001,
      -2.8974999999999998E+001,
      -28.98,
      -2.8984999999999996E+001,
      -28.99,
      -28.995,
      -2.8999999999999996E+001,
      -29.005,
      -29.01,
      -29.015,
      -2.9019999999999996E+001,
      -2.9025000000000002E+001,
      -2.9029999999999998E+001,
      -2.9034999999999997E+001,
      -2.9039999999999996E+001,
      -2.9044999999999998E+001,
      -2.9049999999999997E+001,
      -29.055,
      -29.06,
      -2.9064999999999998E+001,
      -2.9069999999999997E+001,
      -29.075,
      -2.9079999999999995E+001,
      -2.9084999999999997E+001,
      -2.9090000000000003E+001,
      -29.095,
      -2.9099999999999994E+001,
      -29.105,
      -29.11,
      -2.9114999999999995E+001,
      -2.9119999999999997E+001,
      -29.125,
      -29.13,
      -2.9134999999999998E+001,
      -29.14,
      -2.9144999999999996E+001,
      -29.15,
      -2.9154999999999998E+001,
      -2.9159999999999997E+001,
      -29.165,
      -29.17,
      -2.9174999999999997E+001,
      -2.9179999999999996E+001,
      -2.9185000000000002E+001,
      -2.9189999999999998E+001,
      -2.9194999999999993E+001,
      -2.9199999999999996E+001,
      -2.9205000000000002E+001,
      -2.9209999999999997E+001,
      -29.215,
      -29.22,
      -2.9224999999999998E+001,
      -2.9229999999999997E+001,
      -29.235,
      -29.24,
      -29.245,
      -29.25,
      -29.255,
      -2.9259999999999994E+001,
      -2.9264999999999997E+001,
      -2.9269999999999996E+001,
      -2.9274999999999995E+001,
      -2.9279999999999998E+001,
      -29.285,
      -2.9289999999999996E+001,
      -2.9294999999999998E+001,
      -29.3,
      -2.9304999999999996E+001,
      -29.31,
      -29.315,
      -29.32,
      -2.9324999999999996E+001,
      -2.9330000000000002E+001,
      -2.9334999999999997E+001,
      -2.9339999999999996E+001,
      -2.9344999999999995E+001,
      -2.9349999999999998E+001,
      -2.9354999999999997E+001,
      -29.36,
      -29.365,
      -2.9369999999999997E+001,
      -2.9374999999999996E+001,
      -29.38,
      -2.9384999999999994E+001,
      -2.9389999999999997E+001,
      -2.9395000000000003E+001,
      -29.4,
      -2.9404999999999994E+001,
      -29.41,
      -29.415,
      -2.9419999999999995E+001,
      -2.9424999999999997E+001,
      -29.43,
      -29.435,
      -2.9439999999999998E+001,
      -29.445,
      -2.9449999999999996E+001,
      -29.455,
      -2.9459999999999997E+001,
      -2.9464999999999996E+001,
      -29.47,
      -29.475,
      -2.9479999999999997E+001,
      -2.9484999999999996E+001,
      -2.9490000000000002E+001,
      -2.9494999999999997E+001,
      -2.9499999999999993E+001,
      -2.9504999999999995E+001,
      -29.51,
      -2.9514999999999997E+001,
      -29.52,
      -29.525,
      -2.9529999999999998E+001,
      -2.9534999999999997E+001,
      -29.54,
      -2.9544999999999998E+001,
      -29.55,
      -29.555,
      -29.56,
      -2.9564999999999998E+001,
      -2.9569999999999997E+001,
      -2.9574999999999996E+001,
      -2.9579999999999995E+001,
      -2.9584999999999997E+001,
      -29.59,
      -2.9594999999999995E+001,
      -2.9599999999999998E+001,
      -29.605,
      -2.9609999999999996E+001,
      -29.615,
      -29.62,
      -29.625,
      -29.63,
      -29.635,
      -2.9639999999999997E+001,
      -29.645,
      -2.9649999999999995E+001,
      -2.9654999999999998E+001,
      -2.9659999999999997E+001,
      -29.665,
      -2.9669999999999998E+001,
      -2.9674999999999997E+001,
      -2.9679999999999996E+001,
      -29.685,
      -2.9689999999999994E+001,
      -2.9694999999999997E+001,
      -2.9700000000000003E+001,
      -29.705,
      -29.71,
      -29.715,
      -29.72,
      -2.9724999999999998E+001,
      -2.9729999999999997E+001,
      -29.735,
      -29.74,
      -2.9744999999999997E+001,
      -29.75,
      -2.9754999999999995E+001,
      -2.9759999999999998E+001,
      -2.9764999999999997E+001,
      -2.9769999999999996E+001,
      -29.775,
      -29.78,
      -2.9784999999999997E+001,
      -29.79,
      -29.795,
      -2.9799999999999997E+001,
      -29.805,
      -2.9809999999999995E+001,
      -29.815,
      -2.9819999999999997E+001,
      -29.825,
      -29.83,
      -2.9834999999999997E+001,
      -2.9839999999999996E+001,
      -29.845,
      -2.9849999999999998E+001,
      -29.855,
      -29.86,
      -29.865,
      -2.9869999999999997E+001,
      -29.875,
      -2.9879999999999995E+001,
      -2.9884999999999998E+001,
      -2.9889999999999997E+001,
      -29.895,
      -2.9899999999999995E+001,
      -2.9904999999999998E+001,
      -29.91,
      -2.9914999999999996E+001,
      -2.9919999999999998E+001,
      -29.925,
      -29.93,
      -29.935,
      -29.94,
      -2.9944999999999997E+001,
      -29.95,
      -2.9954999999999995E+001,
      -2.9959999999999997E+001,
      -2.9964999999999996E+001,
      -29.97,
      -2.9974999999999998E+001,
      -2.9979999999999997E+001,
      -2.9984999999999996E+001,
      -29.99,
      -2.9994999999999994E+001,
      -2.9999999999999996E+001,
      -3.0005000000000003E+001,
      -3.0009999999999998E+001,
      -30.015,
      -30.02,
      -30.025,
      -3.0029999999999998E+001,
      -3.0034999999999997E+001,
      -30.04,
      -3.0044999999999998E+001,
      -3.0049999999999997E+001,
      -30.055,
      -3.0059999999999995E+001,
      -3.0064999999999998E+001,
      -3.0069999999999997E+001,
      -3.0074999999999996E+001,
      -30.08,
      -30.085,
      -3.0089999999999996E+001,
      -30.095,
      -30.1,
      -3.0104999999999997E+001,
      -30.11,
      -3.0114999999999995E+001,
      -30.12,
      -3.0124999999999996E+001,
      -30.13,
      -3.0134999999999998E+001,
      -3.0139999999999997E+001,
      -3.0144999999999996E+001,
      -30.15,
      -3.0154999999999998E+001,
      -30.16,
      -30.165,
      -3.0169999999999998E+001,
      -3.0174999999999997E+001,
      -30.18,
      -3.0184999999999995E+001,
      -3.0189999999999998E+001,
      -3.0194999999999997E+001,
      -30.2,
      -3.0204999999999995E+001,
      -3.0209999999999997E+001,
      -30.215,
      -3.0219999999999995E+001,
      -3.0224999999999998E+001,
      -30.23,
      -30.235,
      -30.24,
      -30.245,
      -3.0249999999999996E+001,
      -30.255,
      -3.0259999999999998E+001,
      -3.0264999999999997E+001,
      -30.27,
      -30.275,
      -3.0279999999999998E+001,
      -3.0284999999999997E+001,
      -3.0289999999999996E+001,
      -3.0294999999999998E+001,
      -3.0299999999999994E+001,
      -3.0304999999999996E+001,
      -3.0310000000000002E+001,
      -3.0314999999999998E+001,
      -30.32,
      -30.325,
      -30.33,
      -3.0334999999999997E+001,
      -30.34,
      -30.345,
      -30.35,
      -3.0354999999999997E+001,
      -30.36,
      -3.0364999999999995E+001,
      -3.0369999999999997E+001,
      -3.0374999999999996E+001,
      -3.0379999999999995E+001,
      -3.0384999999999998E+001,
      -30.39,
      -3.0394999999999996E+001,
      -30.4,
      -30.405,
      -3.0409999999999997E+001,
      -30.415,
      -30.42,
      -30.425,
      -30.43,
      -30.435,
      -3.0439999999999998E+001,
      -3.0444999999999997E+001,
      -3.0449999999999996E+001,
      -30.455,
      -3.0459999999999997E+001,
      -30.465,
      -30.47,
      -3.0474999999999998E+001,
      -3.0479999999999997E+001,
      -30.485,
      -3.0489999999999995E+001,
      -3.0494999999999997E+001,
      -30.5,
      -30.505,
      -3.0509999999999998E+001,
      -3.0514999999999997E+001,
      -3.0519999999999996E+001,
      -3.0524999999999995E+001,
      -3.0529999999999994E+001,
      -30.535,
      -3.0539999999999996E+001,
      -3.0544999999999998E+001,
      -30.55,
      -3.0554999999999996E+001,
      -30.56,
      -3.0564999999999998E+001,
      -3.0569999999999997E+001,
      -30.575,
      -30.58,
      -3.0584999999999997E+001,
      -3.0589999999999996E+001,
      -3.0594999999999995E+001,
      -3.0599999999999998E+001,
      -3.0604999999999993E+001,
      -3.0609999999999996E+001,
      -30.615,
      -3.0619999999999997E+001,
      -3.0624999999999996E+001,
      -30.63,
      -3.0634999999999994E+001,
      -3.0639999999999997E+001,
      -30.645,
      -30.65,
      -30.655,
      -3.0659999999999997E+001,
      -30.665,
      -3.0669999999999995E+001,
      -3.0674999999999997E+001,
      -3.0679999999999996E+001,
      -3.0684999999999995E+001,
      -3.0689999999999998E+001,
      -30.695,
      -3.0699999999999996E+001,
      -30.705,
      -3.0709999999999997E+001,
      -3.0714999999999996E+001,
      -3.0719999999999995E+001,
      -30.725,
      -3.0729999999999997E+001,
      -30.735,
      -3.0739999999999995E+001,
      -3.0744999999999997E+001,
      -3.0749999999999993E+001,
      -3.0754999999999995E+001,
      -3.0759999999999998E+001,
      -3.0764999999999997E+001,
      -30.77,
      -30.775,
      -3.0779999999999998E+001,
      -3.0784999999999997E+001,
      -30.79,
      -3.0794999999999995E+001,
      -3.0799999999999997E+001,
      -30.805,
      -30.81,
      -3.0814999999999998E+001,
      -3.0819999999999997E+001,
      -3.0824999999999996E+001,
      -3.0829999999999995E+001,
      -3.0834999999999994E+001,
      -30.84,
      -3.0844999999999995E+001,
      -3.0849999999999998E+001,
      -30.855,
      -3.0859999999999996E+001,
      -30.865,
      -3.0869999999999997E+001,
      -3.0874999999999996E+001,
      -30.88,
      -30.885,
      -3.0889999999999997E+001,
      -30.895,
      -3.0899999999999995E+001,
      -3.0904999999999998E+001,
      -3.0909999999999993E+001,
      -3.0914999999999996E+001,
      -3.0919999999999998E+001,
      -3.0924999999999997E+001,
      -3.0929999999999996E+001,
      -30.935,
      -3.0939999999999994E+001,
      -3.0944999999999997E+001,
      -30.95,
      -30.955,
      -30.96,
      -30.965,
      -30.97,
      -3.0974999999999998E+001,
      -3.0979999999999997E+001,
      -3.0984999999999996E+001,
      -3.0989999999999995E+001,
      -3.0994999999999997E+001,
      -31.0,
      -3.1004999999999995E+001,
      -3.1009999999999998E+001,
      -3.1014999999999997E+001,
      -3.1019999999999996E+001,
      -3.1024999999999995E+001,
      -31.03,
      -3.1034999999999997E+001,
      -31.04,
      -31.045,
      -3.1049999999999997E+001,
      -31.055,
      -3.1059999999999995E+001,
      -3.1064999999999998E+001,
      -3.1069999999999997E+001,
      -31.075,
      -31.08,
      -3.1084999999999997E+001,
      -3.1089999999999996E+001,
      -31.095,
      -3.1099999999999994E+001,
      -3.1104999999999997E+001,
      -31.11,
      -31.115,
      -3.1119999999999997E+001,
      -31.125,
      -3.1129999999999995E+001,
      -3.1134999999999998E+001,
      -3.1139999999999993E+001,
      -31.145,
      -3.1149999999999995E+001,
      -3.1154999999999998E+001,
      -31.16,
      -3.1164999999999996E+001,
      -3.1169999999999998E+001,
      -3.1174999999999997E+001,
      -3.1179999999999996E+001,
      -31.185,
      -31.19,
      -3.1194999999999997E+001,
      -31.2,
      -3.1204999999999995E+001,
      -3.1209999999999997E+001,
      -3.1214999999999993E+001,
      -3.1219999999999995E+001,
      -3.1224999999999998E+001,
      -3.1229999999999997E+001,
      -3.1234999999999996E+001,
      -31.24,
      -3.1244999999999994E+001,
      -3.1249999999999996E+001,
      -31.255,
      -3.1259999999999998E+001,
      -31.265,
      -31.27,
      -31.275,
      -3.1279999999999998E+001,
      -3.1284999999999997E+001,
      -3.1289999999999996E+001,
      -3.1294999999999995E+001,
      -3.1299999999999997E+001,
      -31.305,
      -3.1309999999999995E+001,
      -3.1314999999999998E+001,
      -3.1319999999999997E+001,
      -3.1324999999999996E+001,
      -3.1329999999999995E+001,
      -31.335,
      -3.1339999999999996E+001,
      -31.345,
      -31.35,
      -3.1354999999999997E+001,
      -31.36,
      -3.1364999999999995E+001,
      -3.1369999999999997E+001,
      -3.1374999999999996E+001,
      -31.38,
      -3.1384999999999998E+001,
      -3.1389999999999997E+001,
      -3.1394999999999996E+001,
      -31.4,
      -3.1404999999999994E+001,
      -3.1409999999999997E+001,
      -31.415,
      -3.1419999999999998E+001,
      -3.1424999999999997E+001,
      -31.43,
      -3.1434999999999995E+001,
      -3.1439999999999998E+001,
      -3.1444999999999993E+001,
      -31.45,
      -3.1454999999999995E+001,
      -3.1459999999999997E+001,
      -31.465,
      -3.1469999999999995E+001,
      -3.1474999999999998E+001,
      -3.1479999999999997E+001,
      -3.1484999999999996E+001,
      -31.49,
      -31.495,
      -3.1499999999999996E+001,
      -31.505,
      -3.1509999999999998E+001,
      -3.1514999999999997E+001,
      -3.1519999999999996E+001,
      -3.1524999999999995E+001,
      -3.1529999999999998E+001,
      -3.1534999999999997E+001,
      -3.1539999999999996E+001,
      -3.1544999999999998E+001,
      -3.1549999999999994E+001,
      -3.1554999999999996E+001,
      -31.56,
      -3.1564999999999998E+001,
      -31.57,
      -31.575,
      -31.58,
      -3.1584999999999997E+001,
      -31.59,
      -3.1594999999999995E+001,
      -3.1599999999999998E+001,
      -3.1604999999999997E+001,
      -31.61,
      -3.1614999999999995E+001,
      -3.1619999999999997E+001,
      -3.1624999999999996E+001,
      -3.1629999999999995E+001,
      -3.1634999999999994E+001,
      -31.64,
      -3.1644999999999996E+001,
      -31.65,
      -31.655,
      -3.1659999999999997E+001,
      -31.665,
      -3.1669999999999998E+001,
      -3.1674999999999997E+001,
      -31.68,
      -31.685,
      -3.1689999999999998E+001,
      -3.1694999999999997E+001,
      -3.1699999999999996E+001,
      -31.705,
      -3.1709999999999994E+001,
      -3.1714999999999996E+001,
      -31.72,
      -3.1724999999999998E+001,
      -3.1729999999999997E+001,
      -31.735,
      -3.1739999999999995E+001,
      -3.1744999999999997E+001,
      -31.75,
      -31.755,
      -31.76,
      -3.1764999999999997E+001,
      -31.77,
      -3.1774999999999995E+001,
      -3.1779999999999998E+001,
      -3.1784999999999997E+001,
      -3.1789999999999996E+001,
      -3.1794999999999998E+001,
      -31.8,
      -3.1804999999999996E+001,
      -31.81,
      -3.1814999999999998E+001,
      -3.1819999999999997E+001,
      -3.1824999999999996E+001,
      -3.1829999999999995E+001,
      -3.1834999999999997E+001,
      -3.1839999999999996E+001,
      -3.1844999999999995E+001,
      -3.1849999999999998E+001,
      -3.1854999999999993E+001,
      -3.1859999999999996E+001,
      -31.865,
      -3.1869999999999997E+001,
      -31.875,
      -31.88,
      -3.1884999999999998E+001,
      -3.1889999999999997E+001,
      -31.895,
      -3.1899999999999995E+001,
      -3.1904999999999998E+001,
      -3.1909999999999997E+001,
      -31.915,
      -3.1919999999999995E+001,
      -3.1924999999999997E+001,
      -3.1929999999999996E+001,
      -3.1934999999999995E+001,
      -3.1939999999999994E+001,
      -31.945,
      -3.1949999999999996E+001,
      -31.955,
      -31.96,
      -3.1964999999999996E+001,
      -31.97,
      -3.1974999999999998E+001,
      -3.1979999999999997E+001,
      -31.985,
      -31.99,
      -3.1994999999999997E+001,
      -3.1999999999999996E+001,
      -3.2004999999999995E+001,
      -32.01,
      -3.2014999999999993E+001,
      -3.2019999999999996E+001,
      -32.025,
      -3.2029999999999994E+001,
      -32.035,
      -32.04,
      -3.2044999999999995E+001,
      -32.05,
      -32.055,
      -3.2059999999999995E+001,
      -32.065,
      -3.2069999999999993E+001,
      -3.2074999999999996E+001,
      -32.08,
      -32.085,
      -3.2089999999999996E+001,
      -32.095,
      -3.2099999999999994E+001,
      -32.105,
      -3.2109999999999992E+001,
      -32.115,
      -32.12,
      -32.125,
      -3.2129999999999995E+001,
      -32.135,
      -3.2139999999999993E+001,
      -3.2144999999999996E+001,
      -3.2149999999999991E+001,
      -32.155,
      -32.16,
      -32.165,
      -32.17,
      -32.175,
      -32.18,
      -3.2184999999999995E+001,
      -32.19,
      -32.195,
      -32.2,
      -32.205,
      -32.21,
      -3.2214999999999996E+001,
      -32.22,
      -3.2224999999999994E+001,
      -32.23,
      -32.235,
      -3.2239999999999995E+001,
      -32.245,
      -32.25,
      -3.2254999999999995E+001,
      -32.26,
      -32.265,
      -3.2269999999999996E+001,
      -32.275,
      -32.28,
      -32.285,
      -32.29,
      -32.295,
      -32.3,
      -32.305,
      -3.2309999999999995E+001,
      -32.315,
      -3.2319999999999993E+001,
      -3.2324999999999996E+001,
      -32.33,
      -3.2334999999999994E+001,
      -3.2339999999999996E+001,
      -32.345,
      -3.2349999999999994E+001,
      -32.355,
      -32.36,
      -3.2364999999999995E+001,
      -32.37,
      -32.375,
      -3.2379999999999995E+001,
      -32.385,
      -32.39,
      -3.2394999999999996E+001,
      -32.4,
      -3.2404999999999994E+001,
      -32.41,
      -3.2414999999999992E+001,
      -32.42,
      -32.425,
      -32.43,
      -3.2434999999999995E+001,
      -32.44,
      -3.2444999999999993E+001,
      -3.2449999999999996E+001,
      -32.455,
      -32.46,
      -3.2464999999999996E+001,
      -32.47,
      -32.475,
      -32.48,
      -32.485,
      -3.2489999999999995E+001,
      -32.495,
      -32.5,
      -32.505,
      -32.51,
      -32.515,
      -3.2519999999999996E+001,
      -32.525,
      -3.2529999999999994E+001,
      -32.535,
      -32.54,
      -3.2544999999999995E+001,
      -32.55,
      -32.555,
      -3.2559999999999995E+001,
      -32.565,
      -32.57,
      -3.2574999999999996E+001,
      -32.58,
      -32.585,
      -3.2589999999999996E+001,
      -32.595,
      -32.6,
      -32.605,
      -32.61,
      -3.2614999999999995E+001,
      -32.62,
      -3.2624999999999993E+001,
      -3.2629999999999995E+001,
      -32.635,
      -3.2639999999999993E+001,
      -3.2644999999999996E+001,
      -32.65,
      -3.2654999999999994E+001,
      -32.66,
      -32.665,
      -3.2669999999999995E+001,
      -32.675,
      -32.68,
      -3.2684999999999995E+001,
      -32.69,
      -32.695,
      -3.2699999999999996E+001,
      -32.705,
      -3.2709999999999994E+001,
      -3.2714999999999996E+001,
      -3.2719999999999992E+001,
      -32.725,
      -32.73,
      -32.735,
      -3.2739999999999995E+001,
      -32.745,
      -3.2749999999999993E+001,
      -3.2754999999999995E+001,
      -32.76,
      -32.765,
      -32.77,
      -32.775,
      -32.78,
      -32.785,
      -32.79,
      -3.2794999999999995E+001,
      -32.8,
      -32.805,
      -32.81,
      -32.815,
      -32.82,
      -3.2824999999999996E+001,
      -32.83,
      -3.2834999999999994E+001,
      -32.84,
      -32.845,
      -32.85,
      -32.855,
      -32.86,
      -3.2864999999999995E+001,
      -32.87,
      -32.875,
      -3.2879999999999995E+001,
      -32.885,
      -32.89,
      -3.2894999999999996E+001,
      -32.9,
      -32.905,
      -32.91,
      -32.915,
      -32.92,
      -32.925,
      -32.93,
      -3.2934999999999995E+001,
      -32.94,
      -3.2944999999999993E+001,
      -3.2949999999999996E+001,
      -32.955,
      -3.2959999999999994E+001,
      -3.2964999999999996E+001,
      -32.97,
      -3.2974999999999994E+001,
      -32.98,
      -32.985,
      -3.2989999999999995E+001,
      -32.995,
      -33.0,
      -3.3004999999999995E+001,
      -33.01,
      -3.3014999999999993E+001,
      -3.3019999999999996E+001,
      -3.3024999999999991E+001,
      -33.03,
      -33.035,
      -33.04,
      -3.3044999999999995E+001,
      -33.05,
      -3.3054999999999993E+001,
      -3.3059999999999995E+001,
      -33.065,
      -33.07,
      -33.075,
      -33.08,
      -33.085,
      -3.3089999999999996E+001,
      -33.095,
      -3.3099999999999994E+001,
      -33.105,
      -33.11,
      -33.115,
      -33.12,
      -33.125,
      -3.3129999999999995E+001,
      -33.135,
      -3.3139999999999993E+001,
      -33.145,
      -33.15,
      -33.155,
      -33.16,
      -33.165,
      -3.3169999999999995E+001,
      -33.175,
      -33.18,
      -3.3184999999999995E+001,
      -33.19,
      -33.195,
      -3.3199999999999996E+001,
      -33.205,
      -33.21,
      -3.3214999999999996E+001,
      -33.22,
      -33.225,
      -33.23,
      -33.235,
      -3.3239999999999995E+001,
      -33.245,
      -3.3249999999999993E+001,
      -3.3254999999999995E+001,
      -33.26,
      -3.3264999999999993E+001,
      -3.3269999999999996E+001,
      -33.275,
      -3.3279999999999994E+001,
      -33.285,
      -33.29,
      -3.3294999999999995E+001,
      -33.3,
      -33.305,
      -3.3309999999999995E+001,
      -33.315,
      -3.3319999999999993E+001,
      -3.3324999999999996E+001,
      -3.3329999999999991E+001,
      -33.335,
      -3.3339999999999996E+001,
      -33.345,
      -3.3349999999999994E+001,
      -33.355,
      -3.3359999999999992E+001,
      -3.3364999999999995E+001,
      -33.37,
      -3.3374999999999993E+001,
      -3.3379999999999995E+001,
      -33.385,
      -3.3389999999999993E+001,
      -3.3394999999999996E+001,
      -3.3399999999999991E+001,
      -3.3404999999999994E+001,
      -3.3409999999999989E+001,
      -33.415,
      -33.42,
      -33.425,
      -33.43,
      -3.3434999999999995E+001,
      -33.44,
      -3.3444999999999993E+001,
      -3.3449999999999996E+001,
      -3.3454999999999991E+001,
      -3.3459999999999994E+001,
      -3.3464999999999996E+001,
      -3.3469999999999992E+001,
      -3.3474999999999994E+001,
      -3.3479999999999990E+001,
      -3.3484999999999992E+001,
      -3.3489999999999995E+001,
      -33.495,
      -33.5,
      -3.3504999999999995E+001,
      -33.51,
      -33.515,
      -3.3519999999999996E+001,
      -33.525,
      -3.3529999999999994E+001,
      -33.535,
      -3.3539999999999992E+001,
      -3.3544999999999995E+001,
      -3.3549999999999990E+001,
      -3.3554999999999993E+001,
      -3.3559999999999988E+001,
      -33.565,
      -3.3569999999999993E+001,
      -3.3574999999999996E+001,
      -33.58,
      -3.3584999999999994E+001,
      -3.3589999999999996E+001,
      -33.595,
      -3.3599999999999994E+001,
      -33.605,
      -33.61,
      -3.3614999999999995E+001,
      -33.62,
      -3.3624999999999993E+001,
      -3.3629999999999995E+001,
      -3.3634999999999991E+001,
      -33.64,
      -3.3644999999999996E+001,
      -33.65,
      -3.3654999999999994E+001,
      -33.66,
      -3.3664999999999992E+001,
      -3.3669999999999995E+001,
      -33.675,
      -3.3679999999999993E+001,
      -3.3684999999999995E+001,
      -33.69,
      -3.3694999999999993E+001,
      -3.3699999999999996E+001,
      -33.705,
      -3.3709999999999994E+001,
      -33.715,
      -33.72,
      -33.725,
      -33.73,
      -33.735,
      -3.3739999999999995E+001,
      -33.745,
      -3.3749999999999993E+001,
      -3.3754999999999995E+001,
      -3.3759999999999991E+001,
      -3.3764999999999993E+001,
      -3.3769999999999996E+001,
      -3.3774999999999991E+001,
      -3.3779999999999994E+001,
      -3.3784999999999989E+001,
      -3.3789999999999992E+001,
      -3.3794999999999995E+001,
      -33.8,
      -33.805,
      -3.3809999999999995E+001,
      -33.815,
      -33.82,
      -3.3824999999999996E+001,
      -33.83,
      -3.3834999999999994E+001,
      -3.3839999999999989E+001,
      -3.3844999999999992E+001,
      -3.3849999999999994E+001,
      -3.3854999999999990E+001,
      -3.3859999999999992E+001,
      -3.3864999999999988E+001,
      -33.87,
      -3.3874999999999993E+001,
      -3.3879999999999995E+001,
      -33.885,
      -3.3889999999999993E+001,
      -3.3894999999999996E+001,
      -33.9,
      -3.3904999999999994E+001,
      -33.91,
      -3.3914999999999992E+001,
      -3.3919999999999995E+001,
      -3.3924999999999990E+001,
      -3.3929999999999993E+001,
      -3.3934999999999988E+001,
      -3.3939999999999991E+001,
      -3.3944999999999986E+001,
      -3.3949999999999996E+001,
      -3.3954999999999991E+001,
      -3.3959999999999994E+001,
      -3.3964999999999996E+001,
      -3.3969999999999992E+001,
      -3.3974999999999994E+001,
      -33.98,
      -3.3984999999999992E+001,
      -3.3989999999999995E+001,
      -33.995,
      -3.3999999999999993E+001,
      -3.4004999999999995E+001,
      -3.4009999999999991E+001,
      -3.4014999999999993E+001,
      -3.4019999999999989E+001,
      -34.025,
      -3.4029999999999994E+001,
      -34.035,
      -3.4039999999999992E+001,
      -3.4044999999999995E+001,
      -3.4049999999999990E+001,
      -3.4054999999999993E+001,
      -3.4059999999999995E+001,
      -3.4064999999999991E+001,
      -3.4069999999999993E+001,
      -3.4074999999999996E+001,
      -3.4079999999999991E+001,
      -3.4084999999999994E+001,
      -3.4089999999999996E+001,
      -3.4094999999999992E+001,
      -34.1,
      -34.105,
      -34.11,
      -3.4114999999999995E+001,
      -34.12,
      -3.4124999999999993E+001,
      -3.4129999999999995E+001,
      -3.4134999999999991E+001,
      -3.4139999999999993E+001,
      -3.4144999999999989E+001,
      -3.4149999999999991E+001,
      -3.4154999999999994E+001,
      -3.4159999999999989E+001,
      -3.4164999999999992E+001,
      -3.4169999999999995E+001,
      -34.175,
      -34.18,
      -3.4184999999999995E+001,
      -34.19,
      -3.4194999999999993E+001,
      -3.4199999999999996E+001,
      -34.205,
      -3.4209999999999994E+001,
      -3.4214999999999996E+001,
      -3.4219999999999992E+001,
      -3.4224999999999994E+001,
      -3.4229999999999990E+001,
      -3.4234999999999992E+001,
      -3.4239999999999988E+001,
      -3.4244999999999990E+001,
      -34.25,
      -3.4254999999999995E+001,
      -34.26,
      -3.4264999999999993E+001,
      -3.4269999999999996E+001,
      -3.4274999999999991E+001,
      -3.4279999999999994E+001,
      -34.285,
      -3.4289999999999992E+001,
      -3.4294999999999995E+001,
      -34.3,
      -3.4304999999999993E+001,
      -3.4309999999999995E+001,
      -3.4314999999999991E+001,
      -3.4319999999999993E+001,
      -3.4324999999999989E+001,
      -34.33,
      -3.4334999999999994E+001,
      -3.4339999999999996E+001,
      -3.4344999999999992E+001,
      -3.4349999999999994E+001,
      -3.4354999999999990E+001,
      -3.4359999999999992E+001,
      -3.4364999999999995E+001,
      -3.4369999999999990E+001,
      -3.4374999999999993E+001,
      -3.4379999999999995E+001,
      -3.4384999999999991E+001,
      -3.4389999999999993E+001,
      -3.4394999999999996E+001,
      -3.4399999999999991E+001,
      -34.405,
      -34.41,
      -34.415,
      -3.4419999999999995E+001,
      -34.425,
      -3.4429999999999993E+001,
      -3.4434999999999995E+001,
      -3.4439999999999991E+001,
      -3.4444999999999993E+001,
      -3.4449999999999989E+001,
      -3.4454999999999991E+001,
      -3.4459999999999994E+001,
      -3.4464999999999989E+001,
      -3.4469999999999992E+001,
      -3.4474999999999994E+001,
      -34.48,
      -34.485,
      -3.4489999999999995E+001,
      -34.495,
      -34.5,
      -3.4504999999999995E+001,
      -34.51,
      -3.4514999999999993E+001,
      -3.4519999999999996E+001,
      -3.4524999999999991E+001,
      -3.4529999999999994E+001,
      -3.4534999999999989E+001,
      -3.4539999999999992E+001,
      -3.4544999999999987E+001,
      -3.4549999999999990E+001,
      -34.555,
      -3.4559999999999995E+001,
      -34.565,
      -3.4569999999999993E+001,
      -3.4574999999999996E+001,
      -34.58,
      -3.4584999999999994E+001,
      -3.4589999999999996E+001,
      -3.4594999999999992E+001,
      -3.4599999999999994E+001,
      -34.605,
      -3.4609999999999992E+001,
      -3.4614999999999995E+001,
      -3.4619999999999990E+001,
      -3.4624999999999993E+001,
      -3.4629999999999988E+001,
      -34.635,
      -3.4639999999999993E+001,
      -3.4644999999999996E+001,
      -3.4649999999999991E+001,
      -3.4654999999999994E+001,
      -34.66,
      -3.4664999999999992E+001,
      -3.4669999999999995E+001,
      -3.4674999999999990E+001,
      -3.4679999999999993E+001,
      -3.4684999999999995E+001,
      -3.4689999999999991E+001,
      -3.4694999999999993E+001,
      -3.4699999999999996E+001,
      -3.4704999999999991E+001,
      -34.71,
      -3.4714999999999996E+001,
      -34.72,
      -3.4724999999999994E+001,
      -34.73,
      -3.4734999999999992E+001,
      -3.4739999999999995E+001,
      -3.4744999999999990E+001,
      -3.4749999999999993E+001,
      -3.4754999999999988E+001,
      -3.4759999999999991E+001,
      -3.4764999999999993E+001,
      -3.4769999999999989E+001,
      -3.4774999999999991E+001,
      -3.4779999999999994E+001,
      -34.785,
      -34.79,
      -3.4794999999999995E+001,
      -34.8,
      -34.805,
      -3.4809999999999995E+001,
      -34.815,
      -3.4819999999999993E+001,
      -3.4824999999999996E+001,
      -3.4829999999999991E+001,
      -3.4834999999999994E+001,
      -3.4839999999999989E+001,
      -3.4844999999999992E+001,
      -3.4849999999999987E+001,
      -3.4854999999999990E+001,
      -34.86,
      -3.4864999999999995E+001,
      -34.87,
      -3.4874999999999993E+001,
      -3.4879999999999995E+001,
      -34.885,
      -3.4889999999999993E+001,
      -3.4894999999999996E+001,
      -3.4899999999999991E+001,
      -3.4904999999999994E+001,
      -34.91,
      -3.4914999999999992E+001,
      -3.4919999999999995E+001,
      -3.4924999999999990E+001,
      -3.4929999999999993E+001,
      -3.4934999999999988E+001,
      -34.94,
      -3.4944999999999993E+001,
      -3.4949999999999996E+001,
      -3.4954999999999991E+001,
      -3.4959999999999994E+001,
      -3.4964999999999996E+001,
      -3.4969999999999992E+001,
      -3.4974999999999994E+001,
      -3.4979999999999990E+001,
      -3.4984999999999992E+001,
      -3.4989999999999995E+001,
      -3.4994999999999990E+001,
      -3.4999999999999993E+001,
      -3.5004999999999995E+001,
      -3.5009999999999991E+001,
      -35.015,
      -3.5019999999999996E+001,
      -35.025,
      -3.5029999999999994E+001,
      -35.035,
      -3.5039999999999992E+001,
      -3.5044999999999995E+001,
      -3.5049999999999990E+001,
      -3.5054999999999993E+001,
      -3.5059999999999988E+001,
      -3.5064999999999991E+001,
      -3.5069999999999993E+001,
      -3.5074999999999989E+001,
      -3.5079999999999991E+001,
      -3.5084999999999994E+001,
      -3.5089999999999996E+001,
      -35.095,
      -35.1,
      -35.105,
      -35.11,
      -3.5114999999999995E+001,
      -35.12,
      -3.5124999999999993E+001,
      -3.5129999999999995E+001,
      -3.5134999999999991E+001,
      -3.5139999999999993E+001,
      -3.5144999999999989E+001,
      -3.5149999999999991E+001,
      -3.5154999999999987E+001,
      -3.5159999999999989E+001,
      -35.165,
      -3.5169999999999995E+001,
      -35.175,
      -35.18,
      -3.5184999999999995E+001,
      -35.19,
      -3.5194999999999993E+001,
      -3.5199999999999996E+001,
      -35.205,
      -3.5209999999999994E+001,
      -3.5214999999999996E+001,
      -3.5219999999999992E+001,
      -3.5224999999999994E+001,
      -3.5229999999999990E+001,
      -3.5234999999999992E+001,
      -3.5239999999999988E+001,
      -35.245,
      -3.5249999999999993E+001,
      -3.5254999999999995E+001,
      -35.26,
      -3.5264999999999993E+001,
      -3.5269999999999996E+001,
      -3.5274999999999991E+001,
      -3.5279999999999994E+001,
      -35.285,
      -3.5289999999999992E+001,
      -3.5294999999999995E+001,
      -3.5299999999999990E+001,
      -3.5304999999999993E+001,
      -3.5309999999999995E+001,
      -3.5314999999999991E+001,
      -35.32,
      -3.5324999999999996E+001,
      -35.33,
      -3.5334999999999994E+001,
      -3.5339999999999996E+001,
      -3.5344999999999992E+001,
      -3.5349999999999994E+001,
      -3.5354999999999990E+001,
      -3.5359999999999992E+001,
      -3.5364999999999988E+001,
      -3.5369999999999990E+001,
      -3.5374999999999993E+001,
      -3.5379999999999988E+001,
      -3.5384999999999991E+001,
      -3.5389999999999993E+001,
      -3.5394999999999996E+001,
      -35.4,
      -35.405,
      -35.41,
      -35.415,
      -3.5419999999999995E+001,
      -35.425,
      -3.5429999999999993E+001,
      -3.5434999999999995E+001,
      -3.5439999999999991E+001,
      -3.5444999999999993E+001,
      -3.5449999999999989E+001,
      -3.5454999999999991E+001,
      -3.5459999999999987E+001,
      -3.5464999999999989E+001,
      -35.47,
      -3.5474999999999994E+001,
      -35.48,
      -35.485,
      -3.5489999999999995E+001,
      -35.495,
      -3.5499999999999993E+001,
      -3.5504999999999995E+001,
      -35.51,
      -3.5514999999999993E+001,
      -3.5519999999999996E+001,
      -3.5524999999999991E+001,
      -3.5529999999999994E+001,
      -3.5534999999999989E+001,
      -3.5539999999999992E+001,
      -3.5544999999999987E+001,
      -35.55,
      -3.5554999999999993E+001,
      -3.5559999999999995E+001,
      -35.565,
      -3.5569999999999993E+001,
      -3.5574999999999996E+001,
      -3.5579999999999991E+001,
      -3.5584999999999994E+001,
      -3.5589999999999996E+001,
      -3.5594999999999992E+001,
      -3.5599999999999994E+001,
      -3.5604999999999990E+001,
      -3.5609999999999992E+001,
      -3.5614999999999995E+001,
      -3.5619999999999990E+001,
      -35.625,
      -3.5629999999999995E+001,
      -35.635,
      -3.5639999999999993E+001,
      -3.5644999999999996E+001,
      -3.5649999999999991E+001,
      -3.5654999999999994E+001,
      -3.5659999999999989E+001,
      -3.5664999999999992E+001,
      -3.5669999999999995E+001,
      -3.5674999999999990E+001,
      -3.5679999999999993E+001,
      -3.5684999999999988E+001,
      -3.5689999999999991E+001,
      -3.5694999999999993E+001,
      -3.5699999999999996E+001,
      -35.705,
      -35.71,
      -3.5714999999999996E+001,
      -35.72,
      -3.5724999999999994E+001,
      -35.73,
      -3.5734999999999992E+001,
      -3.5739999999999995E+001,
      -3.5744999999999990E+001,
      -3.5749999999999993E+001,
      -3.5754999999999988E+001,
      -3.5759999999999991E+001,
      -3.5764999999999986E+001,
      -3.5769999999999989E+001,
      -35.775,
      -3.5779999999999994E+001,
      -35.785,
      -35.79,
      -3.5794999999999995E+001,
      -35.8,
      -35.805,
      -3.5809999999999995E+001,
      -35.815,
      -3.5819999999999993E+001,
      -3.5824999999999996E+001,
      -3.5829999999999991E+001,
      -3.5834999999999994E+001,
      -3.5839999999999989E+001,
      -3.5844999999999992E+001,
      -3.5849999999999987E+001,
      -35.855,
      -3.5859999999999992E+001,
      -3.5864999999999995E+001,
      -35.87,
      -3.5874999999999993E+001,
      -3.5879999999999995E+001,
      -35.885,
      -3.5889999999999993E+001,
      -3.5894999999999996E+001,
      -3.5899999999999991E+001,
      -3.5904999999999994E+001,
      -35.91,
      -3.5914999999999992E+001,
      -3.5919999999999995E+001,
      -3.5924999999999990E+001,
      -35.93,
      -3.5934999999999995E+001,
      -35.94,
      -3.5944999999999993E+001,
      -3.5949999999999996E+001,
      -3.5954999999999991E+001,
      -3.5959999999999994E+001,
      -3.5964999999999996E+001,
      -3.5969999999999992E+001,
      -3.5974999999999994E+001,
      -3.5979999999999990E+001,
      -3.5984999999999992E+001,
      -3.5989999999999988E+001,
      -3.5994999999999990E+001,
      -3.5999999999999993E+001,
      -3.6004999999999995E+001,
      -36.01,
      -36.015,
      -3.6019999999999996E+001,
      -36.025,
      -3.6029999999999994E+001,
      -36.035,
      -3.6039999999999992E+001,
      -3.6044999999999995E+001,
      -3.6049999999999990E+001,
      -3.6054999999999993E+001,
      -3.6059999999999988E+001,
      -3.6064999999999991E+001,
      -3.6069999999999986E+001,
      -3.6074999999999989E+001,
      -36.08,
      -3.6084999999999994E+001,
      -3.6089999999999996E+001,
      -36.095,
      -3.6099999999999994E+001,
      -36.105,
      -36.11,
      -3.6114999999999995E+001,
      -36.12,
      -3.6124999999999993E+001,
      -3.6129999999999995E+001,
      -3.6134999999999991E+001,
      -3.6139999999999993E+001,
      -3.6144999999999989E+001,
      -3.6149999999999991E+001,
      -3.6154999999999987E+001,
      -36.16,
      -3.6164999999999992E+001,
      -3.6169999999999995E+001,
      -36.175,
      -3.6179999999999993E+001,
      -3.6184999999999995E+001,
      -36.19,
      -3.6194999999999993E+001,
      -3.6199999999999996E+001,
      -3.6204999999999991E+001,
      -3.6209999999999994E+001,
      -3.6214999999999996E+001,
      -3.6219999999999992E+001,
      -3.6224999999999994E+001,
      -3.6229999999999990E+001,
      -36.235,
      -3.6239999999999995E+001,
      -36.245,
      -3.6249999999999993E+001,
      -3.6254999999999995E+001,
      -3.6259999999999991E+001,
      -3.6264999999999993E+001,
      -3.6269999999999996E+001,
      -3.6274999999999991E+001,
      -3.6279999999999994E+001,
      -3.6284999999999989E+001,
      -3.6289999999999992E+001,
      -3.6294999999999995E+001,
      -3.6299999999999990E+001,
      -3.6304999999999993E+001,
      -3.6309999999999995E+001,
      -36.315,
      -36.32,
      -3.6324999999999996E+001,
      -36.33,
      -3.6334999999999994E+001,
      -3.6339999999999996E+001,
      -3.6344999999999992E+001,
      -3.6349999999999994E+001,
      -3.6354999999999990E+001,
      -3.6359999999999992E+001,
      -3.6364999999999988E+001,
      -3.6369999999999990E+001,
      -3.6374999999999993E+001,
      -3.6379999999999988E+001,
      -36.385,
      -3.6389999999999993E+001,
      -3.6394999999999996E+001,
      -36.4,
      -3.6404999999999994E+001,
      -36.41,
      -36.415,
      -3.6419999999999995E+001,
      -36.425,
      -3.6429999999999993E+001,
      -3.6434999999999995E+001,
      -3.6439999999999991E+001,
      -3.6444999999999993E+001,
      -3.6449999999999989E+001,
      -3.6454999999999991E+001,
      -3.6459999999999987E+001,
      -3.6464999999999996E+001,
      -3.6469999999999992E+001,
      -3.6474999999999994E+001,
      -36.48,
      -3.6484999999999992E+001,
      -3.6489999999999995E+001,
      -36.495,
      -3.6499999999999993E+001,
      -3.6504999999999995E+001,
      -36.51,
      -3.6514999999999993E+001,
      -3.6519999999999996E+001,
      -3.6524999999999991E+001,
      -3.6529999999999994E+001,
      -3.6534999999999989E+001,
      -36.54,
      -3.6544999999999995E+001,
      -36.55,
      -3.6554999999999993E+001,
      -3.6559999999999995E+001,
      -3.6564999999999991E+001,
      -3.6569999999999993E+001,
      -3.6574999999999996E+001,
      -3.6579999999999991E+001,
      -3.6584999999999994E+001,
      -3.6589999999999996E+001,
      -3.6594999999999992E+001,
      -3.6599999999999994E+001,
      -3.6604999999999990E+001,
      -3.6609999999999992E+001,
      -3.6614999999999995E+001,
      -36.62,
      -36.625,
      -3.6629999999999995E+001,
      -36.635,
      -3.6639999999999993E+001,
      -3.6644999999999996E+001,
      -3.6649999999999991E+001,
      -3.6654999999999994E+001,
      -3.6659999999999989E+001,
      -3.6664999999999992E+001,
      -3.6669999999999987E+001,
      -3.6674999999999990E+001,
      -3.6679999999999993E+001,
      -3.6684999999999988E+001,
      -36.69,
      -3.6694999999999993E+001,
      -3.6699999999999996E+001,
      -36.705,
      -3.6709999999999994E+001,
      -3.6714999999999996E+001,
      -36.72,
      -3.6724999999999994E+001,
      -36.73,
      -3.6734999999999992E+001,
      -3.6739999999999995E+001,
      -3.6744999999999990E+001,
      -3.6749999999999993E+001,
      -3.6754999999999988E+001,
      -3.6759999999999991E+001,
      -3.6764999999999986E+001,
      -3.6769999999999996E+001,
      -3.6774999999999991E+001,
      -3.6779999999999994E+001,
      -36.785,
      -3.6789999999999992E+001,
      -3.6794999999999995E+001,
      -36.8,
      -3.6804999999999993E+001,
      -3.6809999999999995E+001,
      -36.815,
      -3.6819999999999993E+001,
      -3.6824999999999996E+001,
      -3.6829999999999991E+001,
      -3.6834999999999994E+001,
      -3.6839999999999989E+001,
      -36.845,
      -3.6849999999999994E+001,
      -36.855,
      -3.6859999999999992E+001,
      -3.6864999999999995E+001,
      -3.6869999999999990E+001,
      -3.6874999999999993E+001,
      -3.6879999999999995E+001,
      -3.6884999999999991E+001,
      -3.6889999999999993E+001,
      -3.6894999999999996E+001,
      -3.6899999999999991E+001,
      -3.6904999999999994E+001,
      -3.6909999999999989E+001,
      -3.6914999999999992E+001,
      -36.92,
      -36.925,
      -36.93,
      -3.6934999999999995E+001,
      -36.94,
      -3.6944999999999993E+001,
      -3.6949999999999996E+001,
      -3.6954999999999991E+001,
      -3.6959999999999994E+001,
      -3.6964999999999989E+001,
      -3.6969999999999992E+001,
      -3.6974999999999994E+001,
      -3.6979999999999990E+001,
      -3.6984999999999992E+001,
      -3.6989999999999988E+001,
      -36.995,
      -37.0,
      -3.7004999999999995E+001,
      -37.01,
      -3.7014999999999993E+001,
      -3.7019999999999996E+001,
      -37.025,
      -3.7029999999999994E+001,
      -37.035,
      -3.7039999999999992E+001,
      -3.7044999999999995E+001,
      -3.7049999999999990E+001,
      -3.7054999999999993E+001,
      -3.7059999999999988E+001,
      -3.7064999999999991E+001,
      -3.7069999999999986E+001,
      -3.7074999999999996E+001,
      -37.08,
      -3.7084999999999994E+001,
      -3.7089999999999996E+001,
      -3.7094999999999992E+001,
      -3.7099999999999994E+001,
      -37.105,
      -3.7109999999999992E+001,
      -3.7114999999999995E+001,
      -37.12,
      -3.7124999999999993E+001,
      -3.7129999999999995E+001,
      -3.7134999999999991E+001,
      -3.7139999999999993E+001,
      -3.7144999999999989E+001,
      -37.15,
      -3.7154999999999994E+001,
      -37.16,
      -3.7164999999999992E+001,
      -3.7169999999999995E+001,
      -3.7174999999999990E+001,
      -3.7179999999999993E+001,
      -3.7184999999999995E+001,
      -3.7189999999999991E+001,
      -3.7194999999999993E+001,
      -3.7199999999999996E+001,
      -3.7204999999999991E+001,
      -3.7209999999999994E+001,
      -3.7214999999999989E+001,
      -3.7219999999999992E+001,
      -37.225,
      -37.23,
      -37.235,
      -3.7239999999999995E+001,
      -37.245,
      -3.7249999999999993E+001,
      -3.7254999999999995E+001,
      -3.7259999999999991E+001,
      -3.7264999999999993E+001,
      -3.7269999999999989E+001,
      -3.7274999999999991E+001,
      -3.7279999999999994E+001,
      -3.7284999999999989E+001,
      -3.7289999999999992E+001,
      -3.7294999999999987E+001,
      -37.3,
      -37.305,
      -3.7309999999999995E+001,
      -37.315,
      -37.32,
      -3.7324999999999996E+001,
      -37.33,
      -3.7334999999999994E+001,
      -3.7339999999999996E+001,
      -3.7344999999999992E+001,
      -3.7349999999999994E+001,
      -3.7354999999999990E+001,
      -3.7359999999999992E+001,
      -3.7364999999999988E+001,
      -3.7369999999999990E+001,
      -3.7374999999999986E+001,
      -3.7379999999999995E+001,
      -37.385,
      -3.7389999999999993E+001,
      -3.7394999999999996E+001,
      -37.4,
      -3.7404999999999994E+001,
      -37.41,
      -3.7414999999999992E+001,
      -3.7419999999999995E+001,
      -37.425,
      -3.7429999999999993E+001,
      -3.7434999999999995E+001,
      -3.7439999999999991E+001,
      -3.7444999999999993E+001,
      -3.7449999999999989E+001,
      -37.455,
      -3.7459999999999994E+001,
      -3.7464999999999996E+001,
      -3.7469999999999992E+001,
      -3.7474999999999994E+001,
      -3.7479999999999990E+001,
      -3.7484999999999992E+001,
      -3.7489999999999995E+001,
      -3.7494999999999990E+001,
      -3.7499999999999993E+001,
      -3.7504999999999995E+001,
      -3.7509999999999991E+001,
      -3.7514999999999993E+001,
      -3.7519999999999996E+001,
      -3.7524999999999991E+001,
      -37.53,
      -37.535,
      -37.54,
      -3.7544999999999995E+001,
      -37.55,
      -3.7554999999999993E+001,
      -3.7559999999999995E+001,
      -3.7564999999999991E+001,
      -3.7569999999999993E+001,
      -3.7574999999999989E+001,
      -3.7579999999999991E+001,
      -3.7584999999999994E+001,
      -3.7589999999999989E+001,
      -3.7594999999999992E+001,
      -3.7599999999999994E+001,
      -37.605,
      -37.61,
      -3.7614999999999995E+001,
      -37.62,
      -37.625,
      -3.7629999999999995E+001,
      -37.635,
      -3.7639999999999993E+001,
      -3.7644999999999996E+001,
      -3.7649999999999991E+001,
      -3.7654999999999994E+001,
      -3.7659999999999989E+001,
      -3.7664999999999992E+001,
      -3.7669999999999987E+001,
      -3.7674999999999990E+001,
      -37.68,
      -3.7684999999999995E+001,
      -37.69,
      -3.7694999999999993E+001,
      -3.7699999999999996E+001,
      -37.705,
      -3.7709999999999994E+001,
      -3.7714999999999996E+001,
      -3.7719999999999992E+001,
      -3.7724999999999994E+001,
      -37.73,
      -3.7734999999999992E+001,
      -3.7739999999999995E+001,
      -3.7744999999999990E+001,
      -3.7749999999999993E+001,
      -3.7754999999999988E+001,
      -37.76,
      -3.7764999999999993E+001,
      -3.7769999999999996E+001,
      -3.7774999999999991E+001,
      -3.7779999999999994E+001,
      -37.785,
      -3.7789999999999992E+001,
      -3.7794999999999995E+001,
      -3.7799999999999990E+001,
      -3.7804999999999993E+001,
      -3.7809999999999995E+001,
      -3.7814999999999991E+001,
      -3.7819999999999993E+001,
      -3.7824999999999996E+001,
      -3.7829999999999991E+001,
      -37.835,
      -3.7839999999999996E+001,
      -37.845,
      -3.7849999999999994E+001,
      -37.855,
      -3.7859999999999992E+001,
      -3.7864999999999995E+001,
      -3.7869999999999990E+001,
      -3.7874999999999993E+001,
      -3.7879999999999988E+001,
      -3.7884999999999991E+001,
      -3.7889999999999993E+001,
      -3.7894999999999989E+001,
      -3.7899999999999991E+001,
      -3.7904999999999994E+001,
      -37.91,
      -37.915,
      -3.7919999999999995E+001,
      -37.925,
      -37.93,
      -3.7934999999999995E+001,
      -37.94,
      -3.7944999999999993E+001,
      -3.7949999999999996E+001,
      -3.7954999999999991E+001,
      -3.7959999999999994E+001,
      -3.7964999999999989E+001,
      -3.7969999999999992E+001,
      -3.7974999999999987E+001,
      -3.7979999999999990E+001,
      -37.985,
      -3.7989999999999995E+001,
      -37.995,
      -3.7999999999999993E+001,
      -3.8004999999999995E+001,
      -38.01,
      -3.8014999999999993E+001,
      -3.8019999999999996E+001,
      -38.025,
      -3.8029999999999994E+001,
      -38.035,
      -3.8039999999999992E+001,
      -3.8044999999999995E+001,
      -3.8049999999999990E+001,
      -3.8054999999999993E+001,
      -3.8059999999999988E+001,
      -38.065,
      -3.8069999999999993E+001,
      -3.8074999999999996E+001,
      -3.8079999999999991E+001,
      -3.8084999999999994E+001,
      -3.8089999999999996E+001,
      -3.8094999999999992E+001,
      -3.8099999999999994E+001,
      -3.8104999999999990E+001,
      -3.8109999999999992E+001,
      -3.8114999999999995E+001,
      -3.8119999999999990E+001,
      -3.8124999999999993E+001,
      -3.8129999999999995E+001,
      -3.8134999999999991E+001,
      -38.14,
      -3.8144999999999996E+001,
      -38.15,
      -3.8154999999999994E+001,
      -38.16,
      -3.8164999999999992E+001,
      -3.8169999999999995E+001,
      -3.8174999999999990E+001,
      -3.8179999999999993E+001,
      -3.8184999999999988E+001,
      -3.8189999999999991E+001,
      -3.8194999999999993E+001,
      -3.8199999999999989E+001,
      -3.8204999999999991E+001,
      -3.8209999999999994E+001,
      -3.8214999999999996E+001,
      -38.22,
      -38.225,
      -38.23,
      -38.235,
      -3.8239999999999995E+001,
      -38.245,
      -3.8249999999999993E+001,
      -3.8254999999999995E+001,
      -3.8259999999999991E+001,
      -3.8264999999999993E+001,
      -3.8269999999999989E+001,
      -3.8274999999999991E+001,
      -3.8279999999999987E+001,
      -3.8284999999999989E+001,
      -38.29,
      -3.8294999999999995E+001,
      -38.3,
      -3.8304999999999993E+001,
      -3.8309999999999995E+001,
      -38.315,
      -3.8319999999999993E+001,
      -3.8324999999999996E+001,
      -38.33,
      -3.8334999999999994E+001,
      -3.8339999999999996E+001,
      -3.8344999999999992E+001,
      -3.8349999999999994E+001,
      -3.8354999999999990E+001,
      -3.8359999999999992E+001,
      -3.8364999999999988E+001,
      -38.37,
      -3.8374999999999993E+001,
      -3.8379999999999995E+001,
      -3.8384999999999991E+001,
      -3.8389999999999993E+001,
      -3.8394999999999996E+001,
      -3.8399999999999991E+001,
      -3.8404999999999994E+001,
      -38.41,
      -3.8414999999999992E+001,
      -3.8419999999999995E+001,
      -3.8424999999999990E+001,
      -3.8429999999999993E+001,
      -3.8434999999999995E+001,
      -3.8439999999999991E+001,
      -38.445,
      -3.8449999999999996E+001,
      -38.455,
      -3.8459999999999994E+001,
      -3.8464999999999996E+001,
      -3.8469999999999992E+001,
      -3.8474999999999994E+001,
      -3.8479999999999990E+001,
      -3.8484999999999992E+001,
      -3.8489999999999995E+001,
      -3.8494999999999990E+001,
      -3.8499999999999993E+001,
      -3.8504999999999988E+001,
      -3.8509999999999991E+001,
      -3.8514999999999993E+001,
      -3.8519999999999996E+001,
      -38.525,
      -38.53,
      -38.535,
      -38.54,
      -3.8544999999999995E+001,
      -38.55,
      -3.8554999999999993E+001,
      -3.8559999999999995E+001,
      -3.8564999999999991E+001,
      -3.8569999999999993E+001,
      -3.8574999999999989E+001,
      -3.8579999999999991E+001,
      -3.8584999999999987E+001,
      -3.8589999999999989E+001,
      -38.595,
      -3.8599999999999994E+001,
      -38.605,
      -38.61,
      -3.8614999999999995E+001,
      -38.62,
      -3.8624999999999993E+001,
      -3.8629999999999995E+001,
      -38.635,
      -3.8639999999999993E+001,
      -3.8644999999999996E+001,
      -3.8649999999999991E+001,
      -3.8654999999999994E+001,
      -3.8659999999999989E+001,
      -3.8664999999999992E+001,
      -3.8669999999999987E+001,
      -38.675,
      -3.8679999999999993E+001,
      -3.8684999999999995E+001,
      -38.69,
      -3.8694999999999993E+001,
      -3.8699999999999996E+001,
      -3.8704999999999991E+001,
      -3.8709999999999994E+001,
      -3.8714999999999996E+001,
      -3.8719999999999992E+001,
      -3.8724999999999994E+001,
      -38.73,
      -3.8734999999999992E+001,
      -3.8739999999999995E+001,
      -3.8744999999999990E+001,
      -38.75,
      -3.8754999999999995E+001,
      -38.76,
      -3.8764999999999993E+001,
      -3.8769999999999996E+001,
      -3.8774999999999991E+001,
      -3.8779999999999994E+001,
      -3.8784999999999989E+001,
      -3.8789999999999992E+001,
      -3.8794999999999995E+001,
      -3.8799999999999990E+001,
      -3.8804999999999993E+001,
      -3.8809999999999988E+001,
      -3.8814999999999991E+001,
      -3.8819999999999993E+001,
      -3.8824999999999996E+001,
      -38.83,
      -38.835,
      -3.8839999999999996E+001,
      -38.845,
      -3.8849999999999994E+001,
      -38.855,
      -3.8859999999999992E+001,
      -3.8864999999999995E+001,
      -3.8869999999999990E+001,
      -3.8874999999999993E+001,
      -3.8879999999999988E+001,
      -3.8884999999999991E+001,
      -3.8889999999999986E+001,
      -3.8894999999999989E+001,
      -38.9,
      -3.8904999999999994E+001,
      -38.91,
      -38.915,
      -3.8919999999999995E+001,
      -38.925,
      -3.8929999999999993E+001,
      -3.8934999999999995E+001,
      -38.94,
      -3.8944999999999993E+001,
      -3.8949999999999996E+001,
      -3.8954999999999991E+001,
      -3.8959999999999994E+001,
      -3.8964999999999989E+001,
      -3.8969999999999992E+001,
      -3.8974999999999987E+001,
      -38.98,
      -3.8984999999999992E+001,
      -3.8989999999999995E+001,
      -38.995,
      -3.8999999999999993E+001,
      -3.9004999999999995E+001,
      -3.9009999999999991E+001,
      -3.9014999999999993E+001,
      -3.9019999999999996E+001,
      -3.9024999999999991E+001,
      -3.9029999999999994E+001,
      -39.035,
      -3.9039999999999992E+001,
      -3.9044999999999995E+001,
      -3.9049999999999990E+001,
      -39.055,
      -3.9059999999999995E+001,
      -39.065,
      -3.9069999999999993E+001,
      -3.9074999999999996E+001,
      -3.9079999999999991E+001,
      -3.9084999999999994E+001,
      -3.9089999999999989E+001,
      -3.9094999999999992E+001,
      -3.9099999999999994E+001,
      -3.9104999999999990E+001,
      -3.9109999999999992E+001,
      -3.9114999999999995E+001,
      -3.9119999999999990E+001,
      -3.9124999999999993E+001,
      -3.9129999999999995E+001,
      -39.135,
      -39.14,
      -3.9144999999999996E+001,
      -39.15,
      -3.9154999999999994E+001,
      -39.16,
      -3.9164999999999992E+001,
      -3.9169999999999995E+001,
      -3.9174999999999990E+001,
      -3.9179999999999993E+001,
      -3.9184999999999988E+001,
      -3.9189999999999991E+001,
      -3.9194999999999993E+001,
      -3.9199999999999989E+001,
      -39.205,
      -3.9209999999999994E+001,
      -3.9214999999999996E+001,
      -39.22,
      -3.9224999999999994E+001,
      -39.23,
      -39.235,
      -3.9239999999999995E+001,
      -39.245,
      -3.9249999999999993E+001,
      -3.9254999999999995E+001,
      -3.9259999999999991E+001,
      -3.9264999999999993E+001,
      -3.9269999999999989E+001,
      -3.9274999999999991E+001,
      -3.9279999999999987E+001,
      -39.285,
      -3.9289999999999992E+001,
      -3.9294999999999995E+001,
      -39.3,
      -3.9304999999999993E+001,
      -3.9309999999999995E+001,
      -39.315,
      -3.9319999999999993E+001,
      -3.9324999999999996E+001,
      -3.9329999999999991E+001,
      -3.9334999999999994E+001,
      -3.9339999999999996E+001,
      -3.9344999999999992E+001,
      -3.9349999999999994E+001,
      -3.9354999999999990E+001,
      -39.36,
      -3.9364999999999995E+001,
      -39.37,
      -3.9374999999999993E+001,
      -3.9379999999999995E+001,
      -3.9384999999999991E+001,
      -3.9389999999999993E+001,
      -3.9394999999999996E+001,
      -3.9399999999999991E+001,
      -3.9404999999999994E+001,
      -3.9409999999999989E+001,
      -3.9414999999999992E+001,
      -3.9419999999999995E+001,
      -3.9424999999999990E+001,
      -3.9429999999999993E+001,
      -39.435,
      -39.44,
      -39.445,
      -3.9449999999999996E+001,
      -39.455,
      -3.9459999999999994E+001,
      -3.9464999999999996E+001,
      -3.9469999999999992E+001,
      -3.9474999999999994E+001,
      -3.9479999999999990E+001,
      -3.9484999999999992E+001,
      -3.9489999999999988E+001,
      -3.9494999999999990E+001,
      -3.9499999999999993E+001,
      -3.9504987499999991E+001,
      -3.9509949999999996E+001,
      -3.9514887499999993E+001,
      -39.5198,
      -3.9524687499999992E+001,
      -3.9529549999999993E+001,
      -3.9534387499999994E+001,
      -39.5392,
      -39.5439875,
      -3.9548749999999991E+001,
      -3.9553487499999996E+001,
      -39.5582,
      -3.9562887499999995E+001,
      -3.9567549999999990E+001,
      -3.9572187499999991E+001,
      -39.5768,
      -3.9581387499999991E+001,
      -39.58595,
      -39.5904875,
      -39.595,
      -3.9599487499999995E+001,
      -39.60395,
      -39.6083875,
      -39.6128,
      -3.9617187499999993E+001,
      -39.62155,
      -39.6258875,
      -3.9630199999999995E+001,
      -39.6344875,
      -3.9638749999999995E+001,
      -39.6429875,
      -39.6472,
      -39.6513875,
      -3.9655549999999991E+001,
      -39.6596875,
      -39.6638,
      -39.6678875,
      -3.9671949999999995E+001,
      -39.6759875,
      -39.68,
      -3.9683987499999994E+001,
      -39.68795,
      -39.6918875,
      -3.9695799999999991E+001,
      -3.9699687499999996E+001,
      -3.9703549999999993E+001,
      -3.9707387499999996E+001,
      -3.9711199999999991E+001,
      -3.9714987499999992E+001,
      -39.71875,
      -39.7224875,
      -3.9726199999999992E+001,
      -39.7298875,
      -3.9733549999999994E+001,
      -39.7371875,
      -3.9740799999999993E+001,
      -3.9744387499999995E+001,
      -3.9747949999999996E+001,
      -3.9751487499999996E+001,
      -3.9754999999999995E+001,
      -3.9758487499999994E+001,
      -39.76195,
      -3.9765387499999996E+001,
      -39.7688,
      -3.9772187499999994E+001,
      -3.9775549999999996E+001,
      -3.9778887499999996E+001,
      -3.9782199999999996E+001,
      -3.9785487499999995E+001,
      -3.9788749999999993E+001,
      -3.9791987499999991E+001,
      -3.9795199999999994E+001,
      -3.9798387499999990E+001,
      -3.9801549999999992E+001,
      -3.9804687499999993E+001,
      -3.9807799999999993E+001,
      -3.9810887499999993E+001,
      -39.81395,
      -3.9816987499999996E+001,
      -39.82,
      -3.9822987499999996E+001,
      -3.9825949999999992E+001,
      -3.9828887499999993E+001,
      -3.9831799999999994E+001,
      -3.9834687499999994E+001,
      -3.9837549999999993E+001,
      -3.9840387499999991E+001,
      -3.9843199999999996E+001,
      -3.9845987499999993E+001,
      -3.9848749999999995E+001,
      -39.8514875,
      -39.8542,
      -39.8568875,
      -39.85955,
      -39.8621875,
      -3.9864799999999995E+001,
      -3.9867387499999992E+001,
      -3.9869949999999996E+001,
      -39.8724875,
      -3.9874999999999993E+001,
      -39.8774875,
      -39.87995,
      -3.9882387499999993E+001,
      -39.8848,
      -3.9887187499999996E+001,
      -3.9889549999999993E+001,
      -3.9891887499999996E+001,
      -39.8942,
      -39.8964875,
      -39.89875,
      -39.9009875,
      -39.9032,
      -3.9905387499999996E+001,
      -3.9907549999999993E+001,
      -39.9096875,
      -3.9911799999999992E+001,
      -3.9913887499999994E+001,
      -3.9915949999999995E+001,
      -3.9917987499999995E+001,
      -3.9919999999999995E+001,
      -3.9921987499999993E+001,
      -39.92395,
      -39.9258875,
      -39.9278,
      -39.9296875,
      -3.9931549999999994E+001,
      -3.9933387499999995E+001,
      -3.9935199999999995E+001,
      -3.9936987499999994E+001,
      -3.9938749999999992E+001,
      -3.9940487499999996E+001,
      -3.9942199999999993E+001,
      -3.9943887499999995E+001,
      -39.94555,
      -3.9947187499999991E+001,
      -3.9948799999999991E+001,
      -39.9503875,
      -39.95195,
      -3.9953487499999994E+001,
      -3.9954999999999991E+001,
      -39.9564875,
      -39.95795,
      -39.9593875,
      -39.9608,
      -39.9621875,
      -39.96355,
      -3.9964887499999996E+001,
      -39.9662,
      -39.9674875,
      -39.96875,
      -3.9969987499999995E+001,
      -3.9971199999999996E+001,
      -3.9972387499999989E+001,
      -3.9973549999999996E+001,
      -3.9974687499999995E+001,
      -3.9975799999999992E+001,
      -3.9976887499999989E+001,
      -39.97795,
      -3.9978987499999995E+001,
      -39.98,
      -39.9809875,
      -3.9981949999999991E+001,
      -39.9828875,
      -3.9983799999999995E+001,
      -3.9984687499999993E+001,
      -3.9985549999999996E+001,
      -3.9986387499999992E+001,
      -3.9987199999999994E+001,
      -3.9987987499999996E+001,
      -3.9988749999999996E+001,
      -3.9989487499999996E+001,
      -39.9902,
      -3.9990887499999992E+001,
      -39.99155,
      -3.9992187499999993E+001,
      -3.9992799999999995E+001,
      -39.9933875,
      -39.99395,
      -39.9944875,
      -39.995,
      -3.9995487499999996E+001,
      -3.9995949999999993E+001,
      -39.9963875,
      -3.9996799999999993E+001,
      -3.9997187499999995E+001,
      -39.99755,
      -39.9978875,
      -3.9998199999999990E+001,
      -3.9998487499999996E+001,
      -3.9998749999999994E+001,
      -39.9989875,
      -39.9992,
      -39.9993875,
      -39.99955,
      -39.9996875,
      -3.9999799999999993E+001,
      -3.9999887499999993E+001,
      -3.9999949999999991E+001,
      -3.9999987499999996E+001
    };

    rtDWork.From_Workspace_PWORK.TimePtr = (void *) pTimeValues;
    rtDWork.From_Workspace_PWORK.DataPtr = (void *) pDataValues;
  }

  /* child S-Function registration */
  ssSetNumSFunctions(rtS, 1);

  /* register each child */
  {
    static SimStruct childSFunctions[1];
    static SimStruct *childSFunctionPtrs[1];

    (void)memset((char_T *)&childSFunctions[0], 0, sizeof(childSFunctions));
    ssSetSFunctions(rtS, &childSFunctionPtrs[0]);
    {
      int_T i;

      for(i = 0; i < 1; i++) {
        ssSetSFunction(rtS, i, &childSFunctions[i]);
      }
    }

    /* Level2 S-Function Block: kalman_R_K_ib/<Root>/Kalman, R (joint_ekf_R_K_ib) */
    {
      SimStruct *rts = ssGetSFunction(rtS, 0);
      /* timing info */
      static time_T sfcnPeriod[1];
      static time_T sfcnOffset[1];
      static int_T sfcnTsMap[1];

      {
        int_T i;

        for(i = 0; i < 1; i++) {
          sfcnPeriod[i] = sfcnOffset[i] = 0.0;
        }
      }
      ssSetSampleTimePtr(rts, &sfcnPeriod[0]);
      ssSetOffsetTimePtr(rts, &sfcnOffset[0]);
      ssSetSampleTimeTaskIDPtr(rts, sfcnTsMap);
      ssSetMdlInfoPtr(rts, ssGetMdlInfoPtr(rtS));
      /* Allocate memory of model methodes 2 */
      {
        static struct _ssSFcnModelMethods2 methodes2;
        ssSetModelMethods2(rts, &methodes2);
      }

      /* inputs */
      {
        static struct _ssPortInputs inputPortInfo[2];

        _ssSetNumInputPorts(rts, 2);
        ssSetPortInfoForInputs(rts, &inputPortInfo[0]);

        /* port 0 */
        {

          ssSetInputPortRequiredContiguous(rts, 0, 1);
          ssSetInputPortSignal(rts, 0, &rtB.Sum1_d);
          _ssSetInputPortNumDimensions(rts, 0, 1);
          ssSetInputPortWidth(rts, 0, 1);
        }

        /* port 1 */
        {

          ssSetInputPortRequiredContiguous(rts, 1, 1);
          ssSetInputPortSignal(rts, 1, &rtB.TmpHiddenBuf1_Driving_Kalman_R[0]);
          _ssSetInputPortNumDimensions(rts, 1, 1);
          ssSetInputPortWidth(rts, 1, 2);
        }
      }

      /* outputs */
      {
        static struct _ssPortOutputs outputPortInfo[1];
        _ssSetNumOutputPorts(rts, 1);
        ssSetPortInfoForOutputs(rts, &outputPortInfo[0]);
        /* port 0 */
        {
          _ssSetOutputPortNumDimensions(rts, 0, 1);
          ssSetOutputPortWidth(rts, 0, 9);
          ssSetOutputPortSignal(rts, 0, ((real_T *) &rtB.Kalman_R[0]));
        }
      }

      /* states */
      ssSetDiscStates(rts, (real_T *) &rtDWork.Kalman_R_DSTATE[0]);
      /* path info */
      ssSetModelName(rts, "Kalman, R");
      ssSetPath(rts, "kalman_R_K_ib/Kalman, R");
      ssSetParentSS(rts, rtS);
      ssSetRootSS(rts, ssGetRootSS(rtS));
      ssSetVersion(rts, SIMSTRUCT_VERSION_LEVEL2);

      /* parameters */
      {
        static mxArray *sfcnParams[2];

        ssSetSFcnParamsCount(rts, 2);
        ssSetSFcnParamsPtr(rts, &sfcnParams[0]);

        ssSetSFcnParam(rts, 0, &rtP.Kalman_R_P1_Size[0]);
        ssSetSFcnParam(rts, 1, &rtP.Kalman_R_P2_Size[0]);
      }

      /* work vectors */
      ssSetPWork(rts, (void **) &rtDWork.Kalman_R_PWORK[0]);
      {
        static struct _ssDWorkRecord dWorkRecord[2];

        ssSetSFcnDWork(rts, dWorkRecord);
        _ssSetNumDWork(rts, 2);

        /* PWORK */
        ssSetDWorkWidth(rts, 0, 15);
        ssSetDWorkDataType(rts, 0, SS_POINTER);
        ssSetDWorkComplexSignal(rts, 0, 0);
        ssSetDWork(rts, 0, &rtDWork.Kalman_R_PWORK[0]);

        /* DSTATE */
        ssSetDWorkWidth(rts, 1, 9);
        ssSetDWorkDataType(rts, 1, SS_DOUBLE);
        ssSetDWorkComplexSignal(rts, 1, 0);
        ssSetDWorkUsedAsDState(rts, 1, 1);
        ssSetDWork(rts, 1, &rtDWork.Kalman_R_DSTATE[0]);
      }

      /* registration */
      joint_ekf_R_K_ib(rts);

      sfcnInitializeSizes(rts);
      sfcnInitializeSampleTimes(rts);

      /* adjust sample time */
      ssSetSampleTime(rts, 0, 0.0005);
      ssSetOffsetTime(rts, 0, 0.0);
      sfcnTsMap[0] = 1;
      /* Update connectivity flags for each port */
      _ssSetInputPortConnected(rts, 0, 1);
      _ssSetInputPortConnected(rts, 1, 1);
      _ssSetOutputPortConnected(rts, 0, 1);
      _ssSetOutputPortBeingMerged(rts, 0, 0);
      /* Update the BufferDstPort flags for each input port */
      ssSetInputPortBufferDstPort(rts, 0, -1);
      ssSetInputPortBufferDstPort(rts, 1, -1);
    }
  }

  return rtS;
}

/* [EOF] kalman_R_K_ib_reg.h */
