/*
 * kalman_R_ib_reg.h
 *
 * Real-Time Workshop code generation for Simulink model "kalman_R_ib.mdl".
 *
 * Model Version                        : 1.593
 * Real-Time Workshop file version      : 4.1 $Date: 2001/05/16 13:59:43 $
 * Real-Time Workshop file generated on : Fri Jul 13 02:38:30 2007
 * TLC version                          : 4.1 (May 19 2001)
 * C source code generated on           : Fri Jul 13 02:38:30 2007
 *
 * Relevant TLC Options:
 *   InlineParameters      = 0
 *   RollThreshold         = 5
 *   CodeFormat            = RealTime
 *
 * Simulink model settings:
 *   Solver     : FixedStep
 *   StartTime  : 0.0 s
 *   StopTime   : 1.0 s
 *   FixedStep  : 0.001 s
 *
 * SOURCES: kalman_R_ib.c 
 */

#include "kalman_R_ib_dt.c"

/* Function to initialize sizes */
void MdlInitializeSizes(void)
{
  ssSetNumContStates(rtS, 0);           /* Number of continuous states */
  ssSetNumOutputs(rtS, 0);              /* Number of model outputs */
  ssSetNumInputs(rtS, 0);               /* Number of model inputs */
  ssSetDirectFeedThrough(rtS, 0);       /* The model is not direct feedthrough */
  ssSetNumSampleTimes(rtS, 2);          /* Number of sample times */
  ssSetNumBlocks(rtS, 142);             /* Number of blocks */
  ssSetNumBlockIO(rtS, 122);            /* Number of block outputs */
  ssSetNumBlockParams(rtS, 965);        /* Sum of parameter "widths" */
}

/* Function to initialize sample times */
void MdlInitializeSampleTimes(void)
{
  /* task periods */
  ssSetSampleTime(rtS, 0, 0.0);
  ssSetSampleTime(rtS, 1, 0.001);

  /* task offsets */
  ssSetOffsetTime(rtS, 0, 0.0);
  ssSetOffsetTime(rtS, 1, 0.0);
}

/* Function to register the model */
SimStruct *kalman_R_ib(void)
{
  static struct _ssMdlInfo mdlInfo;

  (void)memset((char *)rtS, 0, sizeof(SimStruct));
  (void)memset((char *)&mdlInfo, 0, sizeof(struct _ssMdlInfo));

  ssSetMdlInfoPtr(rtS, &mdlInfo);

  /* timing info */
  {
    static time_T mdlPeriod[NSAMPLE_TIMES];
    static time_T mdlOffset[NSAMPLE_TIMES];
    static time_T mdlTaskTimes[NSAMPLE_TIMES];
    static int_T mdlTsMap[NSAMPLE_TIMES];
    static int_T mdlSampleHits[NSAMPLE_TIMES];

    {
      int_T i;

      for(i = 0; i < NSAMPLE_TIMES; i++) {
        mdlPeriod[i] = 0.0;
        mdlOffset[i] = 0.0;
        mdlTaskTimes[i] = 0.0;
      }
    }
    (void)memset((char_T *)&mdlTsMap[0], 0, 2 * sizeof(int_T));
    (void)memset((char_T *)&mdlSampleHits[0], 0, 2 * sizeof(int_T));

    ssSetSampleTimePtr(rtS, &mdlPeriod[0]);
    ssSetOffsetTimePtr(rtS, &mdlOffset[0]);
    ssSetSampleTimeTaskIDPtr(rtS, &mdlTsMap[0]);
    ssSetTPtr(rtS, &mdlTaskTimes[0]);
    ssSetSampleHitPtr(rtS, &mdlSampleHits[0]);
  }
  ssSetSolverMode(rtS, SOLVER_MODE_SINGLETASKING);

  /*
   * initialize model vectors and cache them in SimStruct
   */

  /* block I/O */
  {
    void *b = (void *) &rtB;

    ssSetBlockIO(rtS, b);

    (void)memset(b, 0, sizeof(BlockIO));
    {
      int_T i;

      for (i = 0; i < 133; i++) {
        ((real_T*) b)[i] = 0.0;
      }
    }
  }

  /* parameters */
  ssSetDefaultParam(rtS, (real_T *) &rtP);

  /* data type work */
  {
    void *dwork = (void *) &rtDWork;
    ssSetRootDWork(rtS, dwork);
    (void)memset((char_T *) dwork, 0, sizeof(D_Work));
    {
      int_T i;
      real_T *dwork_ptr = (real_T *) &rtDWork.Difference_DSTATE;

      for (i = 0; i < 23; i++) {
        dwork_ptr[i] = 0.0;
      }
    }
  }

  /* data type transition information (for external mode) */
  {
    static DataTypeTransInfo dtInfo;

    (void)memset((char_T *) &dtInfo, 0, sizeof(dtInfo));
    ssSetModelMappingInfo(rtS, &dtInfo);

    dtInfo.numDataTypes = 13;
    dtInfo.dataTypeSizes = &rtDataTypeSizes[0];
    dtInfo.dataTypeNames = &rtDataTypeNames[0];

    /* Block I/O transition table */
    dtInfo.B = &rtBTransTable;

    /* Parameters transition table */
    dtInfo.P = &rtPTransTable;
  }

  /* Model specific registration */
  ssSetRootSS(rtS, rtS);
  ssSetVersion(rtS, SIMSTRUCT_VERSION_LEVEL2);

  ssSetModelName(rtS, "kalman_R_ib");
  ssSetPath(rtS, "kalman_R_ib");

  ssSetTStart(rtS, 0.0);
  ssSetTFinal(rtS, 1.0);
  ssSetStepSize(rtS, 0.001);
  ssSetFixedStepSize(rtS, 0.001);

  ssSetChecksum0(rtS, 1288515858U);
  ssSetChecksum1(rtS, 1546531215U);
  ssSetChecksum2(rtS, 3782265458U);
  ssSetChecksum3(rtS, 2007024101U);

  {
    static const EnableStates rtAlwaysEnabled = SUBSYS_ENABLED;
    static const void *sysModes[1];

    sysModes[0] = &rtAlwaysEnabled;

    ssSetSubSystemModeVectorAddresses(rtS, ((void*)sysModes));
  }

  /* block instance data */
  {
    /* FromWorkspace Block: <S6>/From Workspace */

    static real_T pTimeValues[] = {
      0.0,
      0.001,
      0.002,
      0.003,
      0.004,
      0.005,
      0.006,
      0.007,
      0.008,
      9.0000000000000011E-003,
      0.01,
      0.011,
      0.012,
      1.3000000000000001E-002,
      0.014,
      0.015,
      0.016,
      0.017,
      1.8000000000000002E-002,
      0.019,
      0.02,
      0.021,
      0.022,
      0.023,
      0.024,
      0.025,
      2.6000000000000002E-002,
      0.027,
      0.028,
      0.029,
      0.03,
      0.031,
      0.032,
      0.033,
      0.034,
      0.035,
      3.6000000000000004E-002,
      0.037,
      0.038,
      0.039,
      0.04,
      0.041,
      0.042,
      4.3000000000000003E-002,
      0.044,
      0.045,
      0.046,
      0.047,
      0.048,
      0.049,
      0.05,
      5.1000000000000004E-002,
      5.2000000000000005E-002,
      0.053,
      0.054,
      0.055,
      0.056,
      0.057,
      0.058,
      5.9000000000000004E-002,
      0.06,
      0.061,
      0.062,
      0.063,
      0.064,
      0.065,
      0.066,
      0.067,
      0.068,
      0.069,
      0.07,
      7.1000000000000008E-002,
      7.2000000000000008E-002,
      0.073,
      0.074,
      0.075,
      0.076,
      0.077,
      0.078,
      0.079,
      0.08,
      0.081,
      0.082,
      0.083,
      0.084,
      0.085,
      8.6000000000000007E-002,
      8.7000000000000008E-002,
      0.088,
      0.089,
      0.09,
      0.091,
      0.092,
      0.093,
      0.094,
      0.095,
      0.096,
      0.097,
      0.098,
      0.099,
      0.1,
      0.101,
      1.0200000000000001E-001,
      1.0300000000000001E-001,
      1.0400000000000001E-001,
      0.105,
      0.106,
      0.107,
      0.108,
      0.109,
      0.11,
      0.111,
      0.112,
      0.113,
      0.114,
      0.115,
      0.116,
      0.117,
      1.1800000000000001E-001,
      1.1900000000000001E-001,
      0.12,
      0.121,
      0.122,
      0.123,
      0.124,
      0.125,
      0.126,
      0.127,
      0.128,
      0.129,
      0.13,
      0.131,
      0.132,
      0.133,
      0.134,
      0.135,
      0.136,
      0.137,
      0.138,
      0.139,
      0.14,
      1.4100000000000001E-001,
      1.4200000000000002E-001,
      1.4300000000000002E-001,
      1.4400000000000002E-001,
      0.145,
      0.146,
      0.147,
      0.148,
      0.149,
      0.15,
      0.151,
      0.152,
      0.153,
      0.154,
      0.155,
      0.156,
      0.157,
      0.158,
      0.159,
      0.16,
      0.161,
      0.162,
      0.163,
      0.164,
      0.165,
      0.166,
      0.167,
      0.168,
      0.169,
      0.17,
      0.171,
      1.7200000000000001E-001,
      1.7300000000000001E-001,
      1.7400000000000002E-001,
      1.7500000000000002E-001,
      0.176,
      0.177,
      0.178,
      0.179,
      0.18,
      0.181,
      0.182,
      0.183,
      0.184,
      0.185,
      0.186,
      0.187,
      0.188,
      0.189,
      0.19,
      0.191,
      0.192,
      0.193,
      0.194,
      0.195,
      0.196,
      0.197,
      0.198,
      0.199,
      0.2,
      0.201,
      0.202,
      0.203,
      2.0400000000000001E-001,
      2.0500000000000002E-001,
      2.0600000000000002E-001,
      2.0700000000000002E-001,
      2.0800000000000002E-001,
      0.209,
      0.21,
      0.211,
      0.212,
      0.213,
      0.214,
      0.215,
      0.216,
      0.217,
      0.218,
      0.219,
      0.22,
      0.221,
      0.222,
      0.223,
      0.224,
      0.225,
      0.226,
      0.227,
      0.228,
      0.229,
      0.23,
      0.231,
      0.232,
      0.233,
      0.234,
      2.3500000000000001E-001,
      2.3600000000000002E-001,
      2.3700000000000002E-001,
      2.3800000000000002E-001,
      2.3900000000000002E-001,
      0.24,
      0.241,
      0.242,
      0.243,
      0.244,
      0.245,
      0.246,
      0.247,
      0.248,
      0.249,
      0.25,
      0.251,
      0.252,
      0.253,
      0.254,
      0.255,
      0.256,
      0.257,
      0.258,
      0.259,
      0.26,
      0.261,
      0.262,
      0.263,
      0.264,
      0.265,
      0.266,
      0.267,
      0.268,
      0.269,
      0.27,
      0.271,
      0.272,
      0.273,
      0.274,
      0.275,
      0.276,
      0.277,
      0.278,
      0.279,
      0.28,
      0.281,
      2.8200000000000003E-001,
      2.8300000000000003E-001,
      2.8400000000000003E-001,
      2.8500000000000003E-001,
      2.8600000000000003E-001,
      2.8700000000000003E-001,
      2.8800000000000003E-001,
      0.289,
      0.29,
      0.291,
      0.292,
      0.293,
      0.294,
      0.295,
      0.296,
      0.297,
      0.298,
      0.299,
      0.3,
      0.301,
      0.302,
      0.303,
      0.304,
      0.305,
      0.306,
      0.307,
      0.308,
      0.309,
      0.31,
      0.311,
      0.312,
      0.313,
      0.314,
      0.315,
      0.316,
      0.317,
      0.318,
      0.319,
      0.32,
      0.321,
      0.322,
      0.323,
      0.324,
      0.325,
      0.326,
      0.327,
      0.328,
      0.329,
      0.33,
      0.331,
      0.332,
      0.333,
      0.334,
      0.335,
      0.336,
      0.337,
      0.338,
      0.339,
      0.34,
      0.341,
      0.342,
      0.343,
      3.4400000000000003E-001,
      3.4500000000000003E-001,
      3.4600000000000003E-001,
      3.4700000000000003E-001,
      3.4800000000000003E-001,
      3.4900000000000003E-001,
      3.5000000000000003E-001,
      3.5100000000000003E-001,
      0.352,
      0.353,
      0.354,
      0.355,
      0.356,
      0.357,
      0.358,
      0.359,
      0.36,
      0.361,
      0.362,
      0.363,
      0.364,
      0.365,
      0.366,
      0.367,
      0.368,
      0.369,
      0.37,
      0.371,
      0.372,
      0.373,
      0.374,
      0.375,
      0.376,
      0.377,
      0.378,
      0.379,
      0.38,
      0.381,
      0.382,
      0.383,
      0.384,
      0.385,
      0.386,
      0.387,
      0.388,
      0.389,
      0.39,
      0.391,
      0.392,
      0.393,
      0.394,
      0.395,
      0.396,
      0.397,
      0.398,
      0.399,
      0.4,
      0.401,
      0.402,
      0.403,
      0.404,
      0.405,
      0.406,
      4.0700000000000003E-001,
      4.0800000000000003E-001,
      4.0900000000000003E-001,
      4.1000000000000003E-001,
      4.1100000000000003E-001,
      4.1200000000000003E-001,
      4.1300000000000003E-001,
      4.1400000000000003E-001,
      4.1500000000000004E-001,
      4.1600000000000004E-001,
      0.417,
      0.418,
      0.419,
      0.42,
      0.421,
      0.422,
      0.423,
      0.424,
      0.425,
      0.426,
      0.427,
      0.428,
      0.429,
      0.43,
      0.431,
      0.432,
      0.433,
      0.434,
      0.435,
      0.436,
      0.437,
      0.438,
      0.439,
      0.44,
      0.441,
      0.442,
      0.443,
      0.444,
      0.445,
      0.446,
      0.447,
      0.448,
      0.449,
      0.45,
      0.451,
      0.452,
      0.453,
      0.454,
      0.455,
      0.456,
      0.457,
      0.458,
      0.459,
      0.46,
      0.461,
      0.462,
      0.463,
      0.464,
      0.465,
      0.466,
      0.467,
      0.468,
      4.6900000000000003E-001,
      4.7000000000000003E-001,
      4.7100000000000003E-001,
      4.7200000000000003E-001,
      4.7300000000000003E-001,
      4.7400000000000003E-001,
      4.7500000000000003E-001,
      4.7600000000000003E-001,
      4.7700000000000004E-001,
      4.7800000000000004E-001,
      4.7900000000000004E-001,
      0.48,
      0.481,
      0.482,
      0.483,
      0.484,
      0.485,
      0.486,
      0.487,
      0.488,
      0.489,
      0.49,
      0.491,
      0.492,
      0.493,
      0.494,
      0.495,
      0.496,
      0.497,
      0.498,
      0.499,
      0.5,
      0.501,
      0.502,
      0.503,
      0.504,
      0.505,
      0.506,
      0.507,
      0.508,
      0.509,
      0.51,
      0.511,
      0.512,
      0.513,
      0.514,
      0.515,
      0.516,
      0.517,
      0.518,
      0.519,
      0.52,
      0.521,
      0.522,
      0.523,
      0.524,
      0.525,
      0.526,
      0.527,
      0.528,
      0.529,
      0.53,
      0.531,
      0.532,
      0.533,
      0.534,
      0.535,
      0.536,
      0.537,
      0.538,
      0.539,
      0.54,
      0.541,
      0.542,
      0.543,
      0.544,
      0.545,
      0.546,
      0.547,
      0.548,
      0.549,
      0.55,
      0.551,
      0.552,
      0.553,
      0.554,
      0.555,
      0.556,
      0.557,
      0.558,
      0.559,
      0.56,
      0.561,
      0.562,
      5.6300000000000006E-001,
      5.6400000000000006E-001,
      5.6500000000000006E-001,
      5.6600000000000006E-001,
      5.6700000000000006E-001,
      5.6800000000000006E-001,
      5.6900000000000006E-001,
      5.7000000000000006E-001,
      5.7100000000000006E-001,
      5.7200000000000006E-001,
      5.7300000000000006E-001,
      5.7400000000000007E-001,
      5.7500000000000007E-001,
      5.7600000000000007E-001,
      0.577,
      0.578,
      0.579,
      0.58,
      0.581,
      0.582,
      0.583,
      0.584,
      0.585,
      0.586,
      0.587,
      0.588,
      0.589,
      0.59,
      0.591,
      0.592,
      0.593,
      0.594,
      0.595,
      0.596,
      0.597,
      0.598,
      0.599,
      0.6,
      0.601,
      0.602,
      0.603,
      0.604,
      0.605,
      0.606,
      0.607,
      0.608,
      0.609,
      0.61,
      0.611,
      0.612,
      0.613,
      0.614,
      0.615,
      0.616,
      0.617,
      0.618,
      0.619,
      0.62,
      0.621,
      0.622,
      0.623,
      0.624,
      0.625,
      0.626,
      0.627,
      0.628,
      0.629,
      0.63,
      0.631,
      0.632,
      0.633,
      0.634,
      0.635,
      0.636,
      0.637,
      0.638,
      0.639,
      0.64,
      0.641,
      0.642,
      0.643,
      0.644,
      0.645,
      0.646,
      0.647,
      0.648,
      0.649,
      0.65,
      0.651,
      0.652,
      0.653,
      0.654,
      0.655,
      0.656,
      0.657,
      0.658,
      0.659,
      0.66,
      0.661,
      0.662,
      0.663,
      0.664,
      0.665,
      0.666,
      0.667,
      0.668,
      0.669,
      0.67,
      0.671,
      0.672,
      0.673,
      0.674,
      0.675,
      0.676,
      0.677,
      0.678,
      0.679,
      0.68,
      0.681,
      0.682,
      0.683,
      0.684,
      0.685,
      0.686,
      0.687,
      6.8800000000000006E-001,
      6.8900000000000006E-001,
      6.9000000000000006E-001,
      6.9100000000000006E-001,
      6.9200000000000006E-001,
      6.9300000000000006E-001,
      6.9400000000000006E-001,
      6.9500000000000006E-001,
      6.9600000000000006E-001,
      6.9700000000000006E-001,
      6.9800000000000006E-001,
      6.9900000000000007E-001,
      7.0000000000000007E-001,
      7.0100000000000007E-001,
      7.0200000000000007E-001,
      7.0300000000000007E-001,
      0.704,
      0.705,
      0.706,
      0.707,
      0.708,
      0.709,
      0.71,
      0.711,
      0.712,
      0.713,
      0.714,
      0.715,
      0.716,
      0.717,
      0.718,
      0.719,
      0.72,
      0.721,
      0.722,
      0.723,
      0.724,
      0.725,
      0.726,
      0.727,
      0.728,
      0.729,
      0.73,
      0.731,
      0.732,
      0.733,
      0.734,
      0.735,
      0.736,
      0.737,
      0.738,
      0.739,
      0.74,
      0.741,
      0.742,
      0.743,
      0.744,
      0.745,
      0.746,
      0.747,
      0.748,
      0.749,
      0.75,
      0.751,
      0.752,
      0.753,
      0.754,
      0.755,
      0.756,
      0.757,
      0.758,
      0.759,
      0.76,
      0.761,
      0.762,
      0.763,
      0.764,
      0.765,
      0.766,
      0.767,
      0.768,
      0.769,
      0.77,
      0.771,
      0.772,
      0.773,
      0.774,
      0.775,
      0.776,
      0.777,
      0.778,
      0.779,
      0.78,
      0.781,
      0.782,
      0.783,
      0.784,
      0.785,
      0.786,
      0.787,
      0.788,
      0.789,
      0.79,
      0.791,
      0.792,
      0.793,
      0.794,
      0.795,
      0.796,
      0.797,
      0.798,
      0.799,
      0.8,
      0.801,
      0.802,
      0.803,
      0.804,
      0.805,
      0.806,
      0.807,
      0.808,
      0.809,
      0.81,
      0.811,
      0.812,
      8.1300000000000006E-001,
      8.1400000000000006E-001,
      8.1500000000000006E-001,
      8.1600000000000006E-001,
      8.1700000000000006E-001,
      8.1800000000000006E-001,
      8.1900000000000006E-001,
      8.2000000000000006E-001,
      8.2100000000000006E-001,
      8.2200000000000006E-001,
      8.2300000000000006E-001,
      8.2400000000000007E-001,
      8.2500000000000007E-001,
      8.2600000000000007E-001,
      8.2700000000000007E-001,
      8.2800000000000007E-001,
      8.2900000000000007E-001,
      8.3000000000000007E-001,
      8.3100000000000007E-001,
      8.3200000000000007E-001,
      0.833,
      0.834,
      0.835,
      0.836,
      0.837,
      0.838,
      0.839,
      0.84,
      0.841,
      0.842,
      0.843,
      0.844,
      0.845,
      0.846,
      0.847,
      0.848,
      0.849,
      0.85,
      0.851,
      0.852,
      0.853,
      0.854,
      0.855,
      0.856,
      0.857,
      0.858,
      0.859,
      0.86,
      0.861,
      0.862,
      0.863,
      0.864,
      0.865,
      0.866,
      0.867,
      0.868,
      0.869,
      0.87,
      0.871,
      0.872,
      0.873,
      0.874,
      0.875,
      0.876,
      0.877,
      0.878,
      0.879,
      0.88,
      0.881,
      0.882,
      0.883,
      0.884,
      0.885,
      0.886,
      0.887,
      0.888,
      0.889,
      0.89,
      0.891,
      0.892,
      0.893,
      0.894,
      0.895,
      0.896,
      0.897,
      0.898,
      0.899,
      0.9,
      0.901,
      0.902,
      0.903,
      0.904,
      0.905,
      0.906,
      0.907,
      0.908,
      0.909,
      0.91,
      0.911,
      0.912,
      0.913,
      0.914,
      0.915,
      0.916,
      0.917,
      0.918,
      0.919,
      0.92,
      0.921,
      0.922,
      0.923,
      0.924,
      0.925,
      0.926,
      0.927,
      0.928,
      0.929,
      0.93,
      0.931,
      0.932,
      0.933,
      0.934,
      0.935,
      0.936,
      0.937,
      9.3800000000000006E-001,
      9.3900000000000006E-001,
      9.4000000000000006E-001,
      9.4100000000000006E-001,
      9.4200000000000006E-001,
      9.4300000000000006E-001,
      9.4400000000000006E-001,
      9.4500000000000006E-001,
      9.4600000000000006E-001,
      9.4700000000000006E-001,
      9.4800000000000006E-001,
      9.4900000000000007E-001,
      9.5000000000000007E-001,
      9.5100000000000007E-001,
      9.5200000000000007E-001,
      9.5300000000000007E-001,
      9.5400000000000007E-001,
      9.5500000000000007E-001,
      9.5600000000000007E-001,
      9.5700000000000007E-001,
      9.5800000000000007E-001,
      9.5900000000000007E-001,
      0.96,
      0.961,
      0.962,
      0.963,
      0.964,
      0.965,
      0.966,
      0.967,
      0.968,
      0.969,
      0.97,
      0.971,
      0.972,
      0.973,
      0.974,
      0.975,
      0.976,
      0.977,
      0.978,
      0.979,
      0.98,
      0.981,
      0.982,
      0.983,
      0.984,
      0.985,
      0.986,
      0.987,
      0.988,
      0.989,
      0.99,
      0.991,
      0.992,
      0.993,
      0.994,
      0.995,
      0.996,
      0.997,
      0.998,
      0.999,
      1.0,
      1.0010000000000001E+000,
      1.002,
      1.0030000000000001E+000,
      1.004,
      1.0050000000000001E+000,
      1.006,
      1.0070000000000001E+000,
      1.008,
      1.0090000000000001E+000,
      1.01,
      1.0110000000000001E+000,
      1.012,
      1.0130000000000001E+000,
      1.014,
      1.0150000000000001E+000,
      1.016,
      1.0170000000000001E+000,
      1.018,
      1.0190000000000001E+000,
      1.02,
      1.0210000000000001E+000,
      1.022,
      1.0230000000000001E+000,
      1.024,
      1.025,
      1.026,
      1.027,
      1.028,
      1.029,
      1.03,
      1.031,
      1.032,
      1.033,
      1.034,
      1.035,
      1.036,
      1.037,
      1.038,
      1.039,
      1.04,
      1.041,
      1.042,
      1.043,
      1.044,
      1.045,
      1.046,
      1.047,
      1.048,
      1.049,
      1.05,
      1.051,
      1.052,
      1.053,
      1.054,
      1.055,
      1.056,
      1.057,
      1.058,
      1.059,
      1.06,
      1.061,
      1.062,
      1.063,
      1.064,
      1.065,
      1.066,
      1.067,
      1.068,
      1.069,
      1.07,
      1.071,
      1.072,
      1.073,
      1.074,
      1.075,
      1.076,
      1.077,
      1.078,
      1.079,
      1.08,
      1.081,
      1.082,
      1.083,
      1.084,
      1.085,
      1.086,
      1.087,
      1.088,
      1.089,
      1.09,
      1.091,
      1.092,
      1.093,
      1.094,
      1.095,
      1.096,
      1.097,
      1.098,
      1.099,
      1.1,
      1.101,
      1.102,
      1.103,
      1.104,
      1.105,
      1.106,
      1.107,
      1.108,
      1.109,
      1.11,
      1.111,
      1.112,
      1.113,
      1.114,
      1.115,
      1.116,
      1.117,
      1.118,
      1.119,
      1.12,
      1.121,
      1.122,
      1.123,
      1.124,
      1.125,
      1.1260000000000001E+000,
      1.127,
      1.1280000000000001E+000,
      1.129,
      1.1300000000000001E+000,
      1.131,
      1.1320000000000001E+000,
      1.133,
      1.1340000000000001E+000,
      1.135,
      1.1360000000000001E+000,
      1.137,
      1.1380000000000001E+000,
      1.139,
      1.1400000000000001E+000,
      1.141,
      1.1420000000000001E+000,
      1.143,
      1.1440000000000001E+000,
      1.145,
      1.1460000000000001E+000,
      1.147,
      1.1480000000000001E+000,
      1.149,
      1.1500000000000001E+000,
      1.151,
      1.1520000000000001E+000,
      1.153,
      1.154,
      1.155,
      1.156,
      1.157,
      1.158,
      1.159,
      1.16,
      1.161,
      1.162,
      1.163,
      1.164,
      1.165,
      1.166,
      1.167,
      1.168,
      1.169,
      1.17,
      1.171,
      1.172,
      1.173,
      1.174,
      1.175,
      1.176,
      1.177,
      1.178,
      1.179,
      1.18,
      1.181,
      1.182,
      1.183,
      1.184,
      1.185,
      1.186,
      1.187,
      1.188,
      1.189,
      1.19,
      1.191,
      1.192,
      1.193,
      1.194,
      1.195,
      1.196,
      1.197,
      1.198,
      1.199,
      1.2,
      1.201,
      1.202,
      1.203,
      1.204,
      1.205,
      1.206,
      1.207,
      1.208,
      1.209,
      1.21,
      1.211,
      1.212,
      1.213,
      1.214,
      1.215,
      1.216,
      1.217,
      1.218,
      1.219,
      1.22,
      1.221,
      1.222,
      1.223,
      1.224,
      1.225,
      1.226,
      1.227,
      1.228,
      1.229,
      1.23,
      1.231,
      1.232,
      1.233,
      1.234,
      1.235,
      1.236,
      1.237,
      1.238,
      1.239,
      1.24,
      1.241,
      1.242,
      1.243,
      1.244,
      1.245,
      1.246,
      1.247,
      1.248,
      1.249,
      1.25,
      1.2510000000000001E+000,
      1.252,
      1.2530000000000001E+000,
      1.254,
      1.2550000000000001E+000,
      1.256,
      1.2570000000000001E+000,
      1.258,
      1.2590000000000001E+000,
      1.26,
      1.2610000000000001E+000,
      1.262,
      1.2630000000000001E+000,
      1.264,
      1.2650000000000001E+000,
      1.266,
      1.2670000000000001E+000,
      1.268,
      1.2690000000000001E+000,
      1.27,
      1.2710000000000001E+000,
      1.272,
      1.2730000000000001E+000,
      1.274,
      1.2750000000000001E+000,
      1.276,
      1.2770000000000001E+000,
      1.278,
      1.2790000000000001E+000,
      1.28,
      1.281,
      1.282,
      1.283,
      1.284,
      1.285,
      1.286,
      1.287,
      1.288,
      1.289,
      1.29,
      1.291,
      1.292,
      1.293,
      1.294,
      1.295,
      1.296,
      1.297,
      1.298,
      1.299,
      1.3,
      1.301,
      1.302,
      1.303,
      1.304,
      1.305,
      1.306,
      1.307,
      1.308,
      1.309,
      1.31,
      1.311,
      1.312,
      1.313,
      1.314,
      1.315,
      1.316,
      1.317,
      1.318,
      1.319,
      1.32,
      1.321,
      1.322,
      1.323,
      1.324,
      1.325,
      1.326,
      1.327,
      1.328,
      1.329,
      1.33,
      1.331,
      1.332,
      1.333,
      1.334,
      1.335,
      1.336,
      1.337,
      1.338,
      1.339,
      1.34,
      1.341,
      1.342,
      1.343,
      1.344,
      1.345,
      1.346,
      1.347,
      1.348,
      1.349,
      1.35,
      1.351,
      1.352,
      1.353,
      1.354,
      1.355,
      1.356,
      1.357,
      1.358,
      1.359,
      1.36,
      1.361,
      1.362,
      1.363,
      1.364,
      1.365,
      1.366,
      1.367,
      1.368,
      1.369,
      1.37,
      1.371,
      1.372,
      1.373,
      1.374,
      1.375,
      1.3760000000000001E+000,
      1.377,
      1.3780000000000001E+000,
      1.379,
      1.3800000000000001E+000,
      1.381,
      1.3820000000000001E+000,
      1.383,
      1.3840000000000001E+000,
      1.385,
      1.3860000000000001E+000,
      1.387,
      1.3880000000000001E+000,
      1.389,
      1.3900000000000001E+000,
      1.391,
      1.3920000000000001E+000,
      1.393,
      1.3940000000000001E+000,
      1.395,
      1.3960000000000001E+000,
      1.397,
      1.3980000000000001E+000,
      1.399,
      1.4000000000000001E+000,
      1.401,
      1.4020000000000001E+000,
      1.403,
      1.4040000000000001E+000,
      1.405,
      1.4060000000000001E+000,
      1.407,
      1.408,
      1.409,
      1.41,
      1.411,
      1.412,
      1.413,
      1.414,
      1.415,
      1.416,
      1.417,
      1.418,
      1.419,
      1.42,
      1.421,
      1.422,
      1.423,
      1.424,
      1.425,
      1.426,
      1.427,
      1.428,
      1.429,
      1.43,
      1.431,
      1.432,
      1.433,
      1.434,
      1.435,
      1.436,
      1.437,
      1.438,
      1.439,
      1.44,
      1.441,
      1.442,
      1.443,
      1.444,
      1.445,
      1.446,
      1.447,
      1.448,
      1.449,
      1.45,
      1.451,
      1.452,
      1.453,
      1.454,
      1.455,
      1.456,
      1.457,
      1.458,
      1.459,
      1.46,
      1.461,
      1.462,
      1.463,
      1.464,
      1.465,
      1.466,
      1.467,
      1.468,
      1.469,
      1.47,
      1.471,
      1.472,
      1.473,
      1.474,
      1.475,
      1.476,
      1.477,
      1.478,
      1.479,
      1.48,
      1.481,
      1.482,
      1.483,
      1.484,
      1.485,
      1.486,
      1.487,
      1.488,
      1.489,
      1.49,
      1.491,
      1.492,
      1.493,
      1.494,
      1.495,
      1.496,
      1.497,
      1.498,
      1.499,
      1.5,
      1.5010000000000001E+000,
      1.502,
      1.5030000000000001E+000,
      1.504,
      1.5050000000000001E+000,
      1.506,
      1.5070000000000001E+000,
      1.508,
      1.5090000000000001E+000,
      1.51,
      1.5110000000000001E+000,
      1.512,
      1.5130000000000001E+000,
      1.514,
      1.5150000000000001E+000,
      1.516,
      1.5170000000000001E+000,
      1.518,
      1.5190000000000001E+000,
      1.52,
      1.5210000000000001E+000,
      1.522,
      1.5230000000000001E+000,
      1.524,
      1.5250000000000001E+000,
      1.526,
      1.5270000000000001E+000,
      1.528,
      1.5290000000000001E+000,
      1.53,
      1.5310000000000001E+000,
      1.532,
      1.5330000000000001E+000,
      1.534,
      1.5350000000000001E+000,
      1.536,
      1.537,
      1.538,
      1.539,
      1.54,
      1.541,
      1.542,
      1.543,
      1.544,
      1.545,
      1.546,
      1.547,
      1.548,
      1.549,
      1.55,
      1.551,
      1.552,
      1.553,
      1.554,
      1.555,
      1.556,
      1.557,
      1.558,
      1.559,
      1.56,
      1.561,
      1.562,
      1.563,
      1.564,
      1.565,
      1.566,
      1.567,
      1.568,
      1.569,
      1.57,
      1.571,
      1.572,
      1.573,
      1.574,
      1.575,
      1.576,
      1.577,
      1.578,
      1.579,
      1.58,
      1.581,
      1.582,
      1.583,
      1.584,
      1.585,
      1.586,
      1.587,
      1.588,
      1.589,
      1.59,
      1.591,
      1.592,
      1.593,
      1.594,
      1.595,
      1.596,
      1.597,
      1.598,
      1.599,
      1.6,
      1.601,
      1.602,
      1.603,
      1.604,
      1.605,
      1.606,
      1.607,
      1.608,
      1.609,
      1.61,
      1.611,
      1.612,
      1.613,
      1.614,
      1.615,
      1.616,
      1.617,
      1.618,
      1.619,
      1.62,
      1.621,
      1.622,
      1.623,
      1.624,
      1.625,
      1.6260000000000001E+000,
      1.627,
      1.6280000000000001E+000,
      1.629,
      1.6300000000000001E+000,
      1.631,
      1.6320000000000001E+000,
      1.633,
      1.6340000000000001E+000,
      1.635,
      1.6360000000000001E+000,
      1.637,
      1.6380000000000001E+000,
      1.639,
      1.6400000000000001E+000,
      1.641,
      1.6420000000000001E+000,
      1.643,
      1.6440000000000001E+000,
      1.645,
      1.6460000000000001E+000,
      1.647,
      1.6480000000000001E+000,
      1.649,
      1.6500000000000001E+000,
      1.651,
      1.6520000000000001E+000,
      1.653,
      1.6540000000000001E+000,
      1.655,
      1.6560000000000001E+000,
      1.657,
      1.6580000000000001E+000,
      1.659,
      1.6600000000000001E+000,
      1.661,
      1.6620000000000001E+000,
      1.663,
      1.6640000000000001E+000,
      1.665,
      1.666,
      1.667,
      1.668,
      1.669,
      1.67,
      1.671,
      1.672,
      1.673,
      1.674,
      1.675,
      1.676,
      1.677,
      1.678,
      1.679,
      1.68,
      1.681,
      1.682,
      1.683,
      1.684,
      1.685,
      1.686,
      1.687,
      1.688,
      1.689,
      1.69,
      1.691,
      1.692,
      1.693,
      1.694,
      1.695,
      1.696,
      1.697,
      1.698,
      1.699,
      1.7,
      1.701,
      1.702,
      1.703,
      1.704,
      1.705,
      1.706,
      1.707,
      1.708,
      1.709,
      1.71,
      1.711,
      1.712,
      1.713,
      1.714,
      1.715,
      1.716,
      1.717,
      1.718,
      1.719,
      1.72,
      1.721,
      1.722,
      1.723,
      1.724,
      1.725,
      1.726,
      1.727,
      1.728,
      1.729,
      1.73,
      1.731,
      1.732,
      1.733,
      1.734,
      1.735,
      1.736,
      1.737,
      1.738,
      1.739,
      1.74,
      1.741,
      1.742,
      1.743,
      1.744,
      1.745,
      1.746,
      1.747,
      1.748,
      1.749,
      1.75,
      1.7510000000000001E+000,
      1.752,
      1.7530000000000001E+000,
      1.754,
      1.7550000000000001E+000,
      1.756,
      1.7570000000000001E+000,
      1.758,
      1.7590000000000001E+000,
      1.76,
      1.7610000000000001E+000,
      1.762,
      1.7630000000000001E+000,
      1.764,
      1.7650000000000001E+000,
      1.766,
      1.7670000000000001E+000,
      1.768,
      1.7690000000000001E+000,
      1.77,
      1.7710000000000001E+000,
      1.772,
      1.7730000000000001E+000,
      1.774,
      1.7750000000000001E+000,
      1.776,
      1.7770000000000001E+000,
      1.778,
      1.7790000000000001E+000,
      1.78,
      1.7810000000000001E+000,
      1.782,
      1.7830000000000001E+000,
      1.784,
      1.7850000000000001E+000,
      1.786,
      1.7870000000000001E+000,
      1.788,
      1.7890000000000001E+000,
      1.79,
      1.7910000000000001E+000,
      1.792,
      1.793,
      1.794,
      1.795,
      1.796,
      1.797,
      1.798,
      1.799,
      1.8,
      1.801,
      1.802,
      1.803,
      1.804,
      1.805,
      1.806,
      1.807,
      1.808,
      1.809,
      1.81,
      1.811,
      1.812,
      1.813,
      1.814,
      1.815,
      1.816,
      1.817,
      1.818,
      1.819,
      1.82,
      1.821,
      1.822,
      1.823,
      1.824,
      1.825,
      1.826,
      1.827,
      1.828,
      1.829,
      1.83,
      1.831,
      1.832,
      1.833,
      1.834,
      1.835,
      1.836,
      1.837,
      1.838,
      1.839,
      1.84,
      1.841,
      1.842,
      1.843,
      1.844,
      1.845,
      1.846,
      1.847,
      1.848,
      1.849,
      1.85,
      1.851,
      1.852,
      1.853,
      1.854,
      1.855,
      1.856,
      1.857,
      1.858,
      1.859,
      1.86,
      1.861,
      1.862,
      1.863,
      1.864,
      1.865,
      1.866,
      1.867,
      1.868,
      1.869,
      1.87,
      1.871,
      1.872,
      1.873,
      1.874,
      1.875,
      1.8760000000000001E+000,
      1.877,
      1.8780000000000001E+000,
      1.879,
      1.8800000000000001E+000,
      1.881,
      1.8820000000000001E+000,
      1.883,
      1.8840000000000001E+000,
      1.885,
      1.8860000000000001E+000,
      1.887,
      1.8880000000000001E+000,
      1.889,
      1.8900000000000001E+000,
      1.891,
      1.8920000000000001E+000,
      1.893,
      1.8940000000000001E+000,
      1.895,
      1.8960000000000001E+000,
      1.897,
      1.8980000000000001E+000,
      1.899,
      1.9000000000000001E+000,
      1.901,
      1.9020000000000001E+000,
      1.903,
      1.9040000000000001E+000,
      1.905,
      1.9060000000000001E+000,
      1.907,
      1.9080000000000001E+000,
      1.909,
      1.9100000000000001E+000,
      1.911,
      1.9120000000000001E+000,
      1.913,
      1.9140000000000001E+000,
      1.915,
      1.9160000000000001E+000,
      1.917,
      1.9180000000000001E+000,
      1.919,
      1.92,
      1.921,
      1.922,
      1.923,
      1.924,
      1.925,
      1.926,
      1.927,
      1.928,
      1.929,
      1.93,
      1.931,
      1.932,
      1.933,
      1.934,
      1.935,
      1.936,
      1.937,
      1.938,
      1.939,
      1.94,
      1.941,
      1.942,
      1.943,
      1.944,
      1.945,
      1.946,
      1.947,
      1.948,
      1.949,
      1.95,
      1.951,
      1.952,
      1.953,
      1.954,
      1.955,
      1.956,
      1.957,
      1.958,
      1.959,
      1.96,
      1.961,
      1.962,
      1.963,
      1.964,
      1.965,
      1.966,
      1.967,
      1.968,
      1.969,
      1.97,
      1.971,
      1.972,
      1.973,
      1.974,
      1.975,
      1.976,
      1.977,
      1.978,
      1.979,
      1.98,
      1.981,
      1.982,
      1.983,
      1.984,
      1.985,
      1.986,
      1.987,
      1.988,
      1.989,
      1.99,
      1.991,
      1.992,
      1.993,
      1.994,
      1.995,
      1.996,
      1.997,
      1.998,
      1.999,
      2.0,
      2.001,
      2.0020000000000002E+000,
      2.003,
      2.004,
      2.005,
      2.0060000000000002E+000,
      2.007,
      2.008,
      2.009,
      2.0100000000000002E+000,
      2.011,
      2.012,
      2.013,
      2.0140000000000002E+000,
      2.015,
      2.016,
      2.017,
      2.0180000000000002E+000,
      2.019,
      2.02,
      2.021,
      2.0220000000000002E+000,
      2.023,
      2.024,
      2.025,
      2.0260000000000002E+000,
      2.027,
      2.028,
      2.029,
      2.0300000000000002E+000,
      2.031,
      2.032,
      2.033,
      2.0340000000000003E+000,
      2.035,
      2.036,
      2.037,
      2.0380000000000003E+000,
      2.039,
      2.04,
      2.041,
      2.0420000000000003E+000,
      2.043,
      2.044,
      2.045,
      2.0460000000000003E+000,
      2.047,
      2.048,
      2.049,
      2.05,
      2.051,
      2.052,
      2.053,
      2.054,
      2.055,
      2.056,
      2.057,
      2.058,
      2.059,
      2.06,
      2.061,
      2.062,
      2.063,
      2.064,
      2.065,
      2.066,
      2.067,
      2.068,
      2.069,
      2.07,
      2.071,
      2.072,
      2.073,
      2.074,
      2.075,
      2.076,
      2.077,
      2.078,
      2.079,
      2.08,
      2.081,
      2.082,
      2.083,
      2.084,
      2.085,
      2.086,
      2.087,
      2.088,
      2.089,
      2.09,
      2.091,
      2.092,
      2.093,
      2.094,
      2.095,
      2.096,
      2.097,
      2.098,
      2.099,
      2.1,
      2.101,
      2.102,
      2.103,
      2.104,
      2.105,
      2.106,
      2.107,
      2.108,
      2.109,
      2.11,
      2.111,
      2.112,
      2.113,
      2.114,
      2.115,
      2.116,
      2.117,
      2.118,
      2.119,
      2.12,
      2.121,
      2.122,
      2.123,
      2.124,
      2.125,
      2.126,
      2.1270000000000002E+000,
      2.128,
      2.129,
      2.13,
      2.1310000000000002E+000,
      2.132,
      2.133,
      2.134,
      2.1350000000000002E+000,
      2.136,
      2.137,
      2.138,
      2.1390000000000002E+000,
      2.14,
      2.141,
      2.142,
      2.1430000000000002E+000,
      2.144,
      2.145,
      2.146,
      2.1470000000000002E+000,
      2.148,
      2.149,
      2.15,
      2.1510000000000002E+000,
      2.152,
      2.153,
      2.154,
      2.1550000000000002E+000,
      2.156,
      2.157,
      2.158,
      2.1590000000000003E+000,
      2.16,
      2.161,
      2.162,
      2.1630000000000003E+000,
      2.164,
      2.165,
      2.166,
      2.1670000000000003E+000,
      2.168,
      2.169,
      2.17,
      2.1710000000000003E+000,
      2.172,
      2.173,
      2.174,
      2.1750000000000003E+000,
      2.176,
      2.177,
      2.178,
      2.179,
      2.18,
      2.181,
      2.182,
      2.183,
      2.184,
      2.185,
      2.186,
      2.187,
      2.188,
      2.189,
      2.19,
      2.191,
      2.192,
      2.193,
      2.194,
      2.195,
      2.196,
      2.197,
      2.198,
      2.199,
      2.2,
      2.201,
      2.202,
      2.203,
      2.204,
      2.205,
      2.206,
      2.207,
      2.208,
      2.209,
      2.21,
      2.211,
      2.212,
      2.213,
      2.214,
      2.215,
      2.216,
      2.217,
      2.218,
      2.219,
      2.22,
      2.221,
      2.222,
      2.223,
      2.224,
      2.225,
      2.226,
      2.227,
      2.228,
      2.229,
      2.23,
      2.231,
      2.232,
      2.233,
      2.234,
      2.235,
      2.236,
      2.237,
      2.238,
      2.239,
      2.24,
      2.241,
      2.242,
      2.243,
      2.244,
      2.245,
      2.246,
      2.247,
      2.248,
      2.249,
      2.25,
      2.251,
      2.2520000000000002E+000,
      2.253,
      2.254,
      2.255,
      2.2560000000000002E+000,
      2.257,
      2.258,
      2.259,
      2.2600000000000002E+000,
      2.261,
      2.262,
      2.263,
      2.2640000000000002E+000,
      2.265,
      2.266,
      2.267,
      2.2680000000000002E+000,
      2.269,
      2.27,
      2.271,
      2.2720000000000002E+000,
      2.273,
      2.274,
      2.275,
      2.2760000000000002E+000,
      2.277,
      2.278,
      2.279,
      2.2800000000000002E+000,
      2.281,
      2.282,
      2.283,
      2.2840000000000003E+000,
      2.285,
      2.286,
      2.287,
      2.2880000000000003E+000,
      2.289,
      2.29,
      2.291,
      2.2920000000000003E+000,
      2.293,
      2.294,
      2.295,
      2.2960000000000003E+000,
      2.297,
      2.298,
      2.299,
      2.3000000000000003E+000,
      2.301,
      2.302,
      2.303,
      2.3040000000000003E+000,
      2.305,
      2.306,
      2.307,
      2.308,
      2.309,
      2.31,
      2.311,
      2.312,
      2.313,
      2.314,
      2.315,
      2.316,
      2.317,
      2.318,
      2.319,
      2.32,
      2.321,
      2.322,
      2.323,
      2.324,
      2.325,
      2.326,
      2.327,
      2.328,
      2.329,
      2.33,
      2.331,
      2.332,
      2.333,
      2.334,
      2.335,
      2.336,
      2.337,
      2.338,
      2.339,
      2.34,
      2.341,
      2.342,
      2.343,
      2.344,
      2.345,
      2.346,
      2.347,
      2.348,
      2.349,
      2.35,
      2.351,
      2.352,
      2.353,
      2.354,
      2.355,
      2.356,
      2.357,
      2.358,
      2.359,
      2.36,
      2.361,
      2.362,
      2.363,
      2.364,
      2.365,
      2.366,
      2.367,
      2.368,
      2.369,
      2.37,
      2.371,
      2.372,
      2.373,
      2.374,
      2.375,
      2.376,
      2.3770000000000002E+000,
      2.378,
      2.379,
      2.38,
      2.3810000000000002E+000,
      2.382,
      2.383,
      2.384,
      2.3850000000000002E+000,
      2.386,
      2.387,
      2.388,
      2.3890000000000002E+000,
      2.39,
      2.391,
      2.392,
      2.3930000000000002E+000,
      2.394,
      2.395,
      2.396,
      2.3970000000000002E+000,
      2.398,
      2.399,
      2.4,
      2.4010000000000002E+000,
      2.402,
      2.403,
      2.404,
      2.4050000000000002E+000,
      2.406,
      2.407,
      2.408,
      2.4090000000000003E+000,
      2.41,
      2.411,
      2.412,
      2.4130000000000003E+000,
      2.414,
      2.415,
      2.416,
      2.4170000000000003E+000,
      2.418,
      2.419,
      2.42,
      2.4210000000000003E+000,
      2.422,
      2.423,
      2.424,
      2.4250000000000003E+000,
      2.426,
      2.427,
      2.428,
      2.4290000000000003E+000,
      2.43,
      2.431,
      2.432,
      2.433,
      2.434,
      2.435,
      2.436,
      2.437,
      2.438,
      2.439,
      2.44,
      2.441,
      2.442,
      2.443,
      2.444,
      2.445,
      2.446,
      2.447,
      2.448,
      2.449,
      2.45,
      2.451,
      2.452,
      2.453,
      2.454,
      2.455,
      2.456,
      2.457,
      2.458,
      2.459,
      2.46,
      2.461,
      2.462,
      2.463,
      2.464,
      2.465,
      2.466,
      2.467,
      2.468,
      2.469,
      2.47,
      2.471,
      2.472,
      2.473,
      2.474,
      2.475,
      2.476,
      2.477,
      2.478,
      2.479,
      2.48,
      2.481,
      2.482,
      2.483,
      2.484,
      2.485,
      2.486,
      2.487,
      2.488,
      2.489,
      2.49,
      2.491,
      2.492,
      2.493,
      2.494,
      2.495,
      2.496,
      2.497,
      2.498,
      2.499,
      2.5,
      2.501,
      2.5020000000000002E+000,
      2.503,
      2.504,
      2.505,
      2.5060000000000002E+000,
      2.507,
      2.508,
      2.509,
      2.5100000000000002E+000,
      2.511,
      2.512,
      2.513,
      2.5140000000000002E+000,
      2.515,
      2.516,
      2.517,
      2.5180000000000002E+000,
      2.519,
      2.52,
      2.521,
      2.5220000000000002E+000,
      2.523,
      2.524,
      2.525,
      2.5260000000000002E+000,
      2.527,
      2.528,
      2.529,
      2.5300000000000002E+000,
      2.531,
      2.532,
      2.533,
      2.5340000000000003E+000,
      2.535,
      2.536,
      2.537,
      2.5380000000000003E+000,
      2.539,
      2.54,
      2.541,
      2.5420000000000003E+000,
      2.543,
      2.544,
      2.545,
      2.5460000000000003E+000,
      2.547,
      2.548,
      2.549,
      2.5499999999999994E+000,
      2.5509999999999993E+000,
      2.5519999999999992E+000,
      2.5529999999999990E+000,
      2.5539999999999994E+000,
      2.5549999999999993E+000,
      2.5559999999999992E+000,
      2.5569999999999991E+000,
      2.5579999999999994E+000,
      2.5589999999999993E+000,
      2.5599999999999992E+000,
      2.5609999999999991E+000,
      2.5619999999999994E+000,
      2.5629999999999993E+000,
      2.5639999999999992E+000,
      2.5649999999999991E+000,
      2.5659999999999994E+000,
      2.5669999999999993E+000,
      2.5679999999999992E+000,
      2.5689999999999991E+000,
      2.5699999999999994E+000,
      2.5709999999999993E+000,
      2.5719999999999992E+000,
      2.5729999999999991E+000,
      2.5739999999999994E+000,
      2.5749999999999993E+000,
      2.5759999999999992E+000,
      2.5769999999999991E+000,
      2.5779999999999994E+000,
      2.5789999999999993E+000,
      2.5799999999999992E+000,
      2.5809999999999991E+000,
      2.5819999999999994E+000,
      2.5829999999999993E+000,
      2.5839999999999992E+000,
      2.5849999999999991E+000,
      2.5859999999999994E+000,
      2.5869999999999993E+000,
      2.5879999999999992E+000,
      2.5889999999999991E+000,
      2.5899999999999994E+000,
      2.5909999999999993E+000,
      2.5919999999999992E+000,
      2.5929999999999991E+000,
      2.5939999999999994E+000,
      2.5949999999999993E+000,
      2.5959999999999992E+000,
      2.5969999999999991E+000,
      2.5979999999999994E+000,
      2.5989999999999993E+000,
      2.5999999999999992E+000,
      2.6009999999999991E+000,
      2.6019999999999994E+000,
      2.6029999999999993E+000,
      2.6039999999999992E+000,
      2.6049999999999991E+000,
      2.6059999999999994E+000,
      2.6069999999999993E+000,
      2.6079999999999992E+000,
      2.6089999999999991E+000,
      2.6099999999999994E+000,
      2.6109999999999993E+000,
      2.6119999999999992E+000,
      2.6129999999999991E+000,
      2.6139999999999994E+000,
      2.6149999999999993E+000,
      2.6159999999999992E+000,
      2.6169999999999991E+000,
      2.6179999999999994E+000,
      2.6189999999999993E+000,
      2.6199999999999992E+000,
      2.6209999999999991E+000,
      2.6219999999999994E+000,
      2.6229999999999993E+000,
      2.6239999999999992E+000,
      2.6249999999999991E+000,
      2.6259999999999994E+000,
      2.6269999999999993E+000,
      2.6279999999999992E+000,
      2.6289999999999991E+000,
      2.6299999999999994E+000,
      2.6309999999999993E+000,
      2.6319999999999992E+000,
      2.6329999999999991E+000,
      2.6339999999999995E+000,
      2.6349999999999993E+000,
      2.6359999999999992E+000,
      2.6369999999999991E+000,
      2.6379999999999995E+000,
      2.6389999999999993E+000,
      2.6399999999999992E+000,
      2.6409999999999991E+000,
      2.6419999999999995E+000,
      2.6429999999999993E+000,
      2.6439999999999992E+000,
      2.6449999999999991E+000,
      2.6459999999999995E+000,
      2.6469999999999994E+000,
      2.6479999999999992E+000,
      2.6489999999999991E+000,
      2.6499999999999995E+000,
      2.6509999999999994E+000,
      2.6519999999999992E+000,
      2.6529999999999991E+000,
      2.6539999999999995E+000,
      2.6549999999999994E+000,
      2.6559999999999993E+000,
      2.6569999999999991E+000,
      2.6579999999999995E+000,
      2.6589999999999994E+000,
      2.6599999999999993E+000,
      2.6609999999999991E+000,
      2.6619999999999995E+000,
      2.6629999999999994E+000,
      2.6639999999999993E+000,
      2.6649999999999991E+000,
      2.6659999999999995E+000,
      2.6669999999999994E+000,
      2.6679999999999993E+000,
      2.6689999999999992E+000,
      2.6699999999999990E+000,
      2.6709999999999994E+000,
      2.6719999999999993E+000,
      2.6729999999999992E+000,
      2.6739999999999990E+000,
      2.6749999999999994E+000,
      2.6759999999999993E+000,
      2.6769999999999992E+000,
      2.6779999999999990E+000,
      2.6789999999999994E+000,
      2.6799999999999993E+000,
      2.6809999999999992E+000,
      2.6819999999999991E+000,
      2.6829999999999994E+000,
      2.6839999999999993E+000,
      2.6849999999999992E+000,
      2.6859999999999991E+000,
      2.6869999999999994E+000,
      2.6879999999999993E+000,
      2.6889999999999992E+000,
      2.6899999999999991E+000,
      2.6909999999999994E+000,
      2.6919999999999993E+000,
      2.6929999999999992E+000,
      2.6939999999999991E+000,
      2.6949999999999994E+000,
      2.6959999999999993E+000,
      2.6969999999999992E+000,
      2.6979999999999991E+000,
      2.6989999999999994E+000,
      2.6999999999999993E+000,
      2.7009999999999992E+000,
      2.7019999999999991E+000,
      2.7029999999999994E+000,
      2.7039999999999993E+000,
      2.7049999999999992E+000,
      2.7059999999999991E+000,
      2.7069999999999994E+000,
      2.7079999999999993E+000,
      2.7089999999999992E+000,
      2.7099999999999991E+000,
      2.7109999999999994E+000,
      2.7119999999999993E+000,
      2.7129999999999992E+000,
      2.7139999999999991E+000,
      2.7149999999999994E+000,
      2.7159999999999993E+000,
      2.7169999999999992E+000,
      2.7179999999999991E+000,
      2.7189999999999994E+000,
      2.7199999999999993E+000,
      2.7209999999999992E+000,
      2.7219999999999991E+000,
      2.7229999999999994E+000,
      2.7239999999999993E+000,
      2.7249999999999992E+000,
      2.7259999999999991E+000,
      2.7269999999999994E+000,
      2.7279999999999993E+000,
      2.7289999999999992E+000,
      2.7299999999999991E+000,
      2.7309999999999994E+000,
      2.7319999999999993E+000,
      2.7329999999999992E+000,
      2.7339999999999991E+000,
      2.7349999999999994E+000,
      2.7359999999999993E+000,
      2.7369999999999992E+000,
      2.7379999999999991E+000,
      2.7389999999999994E+000,
      2.7399999999999993E+000,
      2.7409999999999992E+000,
      2.7419999999999991E+000,
      2.7429999999999994E+000,
      2.7439999999999993E+000,
      2.7449999999999992E+000,
      2.7459999999999991E+000,
      2.7469999999999994E+000,
      2.7479999999999993E+000,
      2.7489999999999992E+000,
      2.7499999999999991E+000,
      2.7509999999999994E+000,
      2.7519999999999993E+000,
      2.7529999999999992E+000,
      2.7539999999999991E+000,
      2.7549999999999994E+000,
      2.7559999999999993E+000,
      2.7569999999999992E+000,
      2.7579999999999991E+000,
      2.7589999999999995E+000,
      2.7599999999999993E+000,
      2.7609999999999992E+000,
      2.7619999999999991E+000,
      2.7629999999999995E+000,
      2.7639999999999993E+000,
      2.7649999999999992E+000,
      2.7659999999999991E+000,
      2.7669999999999995E+000,
      2.7679999999999993E+000,
      2.7689999999999992E+000,
      2.7699999999999991E+000,
      2.7709999999999995E+000,
      2.7719999999999994E+000,
      2.7729999999999992E+000,
      2.7739999999999991E+000,
      2.7749999999999995E+000,
      2.7759999999999994E+000,
      2.7769999999999992E+000,
      2.7779999999999991E+000,
      2.7789999999999995E+000,
      2.7799999999999994E+000,
      2.7809999999999993E+000,
      2.7819999999999991E+000,
      2.7829999999999995E+000,
      2.7839999999999994E+000,
      2.7849999999999993E+000,
      2.7859999999999991E+000,
      2.7869999999999995E+000,
      2.7879999999999994E+000,
      2.7889999999999993E+000,
      2.7899999999999991E+000,
      2.7909999999999995E+000,
      2.7919999999999994E+000,
      2.7929999999999993E+000,
      2.7939999999999992E+000,
      2.7949999999999990E+000,
      2.7959999999999994E+000,
      2.7969999999999993E+000,
      2.7979999999999992E+000,
      2.7989999999999990E+000,
      2.7999999999999994E+000,
      2.8009999999999993E+000,
      2.8019999999999992E+000,
      2.8029999999999990E+000,
      2.8039999999999994E+000,
      2.8049999999999993E+000,
      2.8059999999999992E+000,
      2.8069999999999991E+000,
      2.8079999999999994E+000,
      2.8089999999999993E+000,
      2.8099999999999992E+000,
      2.8109999999999991E+000,
      2.8119999999999994E+000,
      2.8129999999999993E+000,
      2.8139999999999992E+000,
      2.8149999999999991E+000,
      2.8159999999999994E+000,
      2.8169999999999993E+000,
      2.8179999999999992E+000,
      2.8189999999999991E+000,
      2.8199999999999994E+000,
      2.8209999999999993E+000,
      2.8219999999999992E+000,
      2.8229999999999991E+000,
      2.8239999999999994E+000,
      2.8249999999999993E+000,
      2.8259999999999992E+000,
      2.8269999999999991E+000,
      2.8279999999999994E+000,
      2.8289999999999993E+000,
      2.8299999999999992E+000,
      2.8309999999999991E+000,
      2.8319999999999994E+000,
      2.8329999999999993E+000,
      2.8339999999999992E+000,
      2.8349999999999991E+000,
      2.8359999999999994E+000,
      2.8369999999999993E+000,
      2.8379999999999992E+000,
      2.8389999999999991E+000,
      2.8399999999999994E+000,
      2.8409999999999993E+000,
      2.8419999999999992E+000,
      2.8429999999999991E+000,
      2.8439999999999994E+000,
      2.8449999999999993E+000,
      2.8459999999999992E+000,
      2.8469999999999991E+000,
      2.8479999999999994E+000,
      2.8489999999999993E+000,
      2.8499999999999992E+000,
      2.8509999999999991E+000,
      2.8519999999999994E+000,
      2.8529999999999993E+000,
      2.8539999999999992E+000,
      2.8549999999999991E+000,
      2.8559999999999994E+000,
      2.8569999999999993E+000,
      2.8579999999999992E+000,
      2.8589999999999991E+000,
      2.8599999999999994E+000,
      2.8609999999999993E+000,
      2.8619999999999992E+000,
      2.8629999999999991E+000,
      2.8639999999999994E+000,
      2.8649999999999993E+000,
      2.8659999999999992E+000,
      2.8669999999999991E+000,
      2.8679999999999994E+000,
      2.8689999999999993E+000,
      2.8699999999999992E+000,
      2.8709999999999991E+000,
      2.8719999999999994E+000,
      2.8729999999999993E+000,
      2.8739999999999992E+000,
      2.8749999999999991E+000,
      2.8759999999999994E+000,
      2.8769999999999993E+000,
      2.8779999999999992E+000,
      2.8789999999999991E+000,
      2.8799999999999994E+000,
      2.8809999999999993E+000,
      2.8819999999999992E+000,
      2.8829999999999991E+000,
      2.8839999999999995E+000,
      2.8849999999999993E+000,
      2.8859999999999992E+000,
      2.8869999999999991E+000,
      2.8879999999999995E+000,
      2.8889999999999993E+000,
      2.8899999999999992E+000,
      2.8909999999999991E+000,
      2.8919999999999995E+000,
      2.8929999999999993E+000,
      2.8939999999999992E+000,
      2.8949999999999991E+000,
      2.8959999999999995E+000,
      2.8969999999999994E+000,
      2.8979999999999992E+000,
      2.8989999999999991E+000,
      2.8999999999999995E+000,
      2.9009999999999994E+000,
      2.9019999999999992E+000,
      2.9029999999999991E+000,
      2.9039999999999995E+000,
      2.9049999999999994E+000,
      2.9059999999999993E+000,
      2.9069999999999991E+000,
      2.9079999999999995E+000,
      2.9089999999999994E+000,
      2.9099999999999993E+000,
      2.9109999999999991E+000,
      2.9119999999999995E+000,
      2.9129999999999994E+000,
      2.9139999999999993E+000,
      2.9149999999999991E+000,
      2.9159999999999995E+000,
      2.9169999999999994E+000,
      2.9179999999999993E+000,
      2.9189999999999992E+000,
      2.9199999999999995E+000,
      2.9209999999999994E+000,
      2.9219999999999993E+000,
      2.9229999999999992E+000,
      2.9239999999999990E+000,
      2.9249999999999994E+000,
      2.9259999999999993E+000,
      2.9269999999999992E+000,
      2.9279999999999990E+000,
      2.9289999999999994E+000,
      2.9299999999999993E+000,
      2.9309999999999992E+000,
      2.9319999999999991E+000,
      2.9329999999999994E+000,
      2.9339999999999993E+000,
      2.9349999999999992E+000,
      2.9359999999999991E+000,
      2.9369999999999994E+000,
      2.9379999999999993E+000,
      2.9389999999999992E+000,
      2.9399999999999991E+000,
      2.9409999999999994E+000,
      2.9419999999999993E+000,
      2.9429999999999992E+000,
      2.9439999999999991E+000,
      2.9449999999999994E+000,
      2.9459999999999993E+000,
      2.9469999999999992E+000,
      2.9479999999999991E+000,
      2.9489999999999994E+000,
      2.9499999999999993E+000,
      2.9509999999999992E+000,
      2.9519999999999991E+000,
      2.9529999999999994E+000,
      2.9539999999999993E+000,
      2.9549999999999992E+000,
      2.9559999999999991E+000,
      2.9569999999999994E+000,
      2.9579999999999993E+000,
      2.9589999999999992E+000,
      2.9599999999999991E+000,
      2.9609999999999994E+000,
      2.9619999999999993E+000,
      2.9629999999999992E+000,
      2.9639999999999991E+000,
      2.9649999999999994E+000,
      2.9659999999999993E+000,
      2.9669999999999992E+000,
      2.9679999999999991E+000,
      2.9689999999999994E+000,
      2.9699999999999993E+000,
      2.9709999999999992E+000,
      2.9719999999999991E+000,
      2.9729999999999994E+000,
      2.9739999999999993E+000,
      2.9749999999999992E+000,
      2.9759999999999991E+000,
      2.9769999999999994E+000,
      2.9779999999999993E+000,
      2.9789999999999992E+000,
      2.9799999999999991E+000,
      2.9809999999999994E+000,
      2.9819999999999993E+000,
      2.9829999999999992E+000,
      2.9839999999999991E+000,
      2.9849999999999994E+000,
      2.9859999999999993E+000,
      2.9869999999999992E+000,
      2.9879999999999991E+000,
      2.9889999999999994E+000,
      2.9899999999999993E+000,
      2.9909999999999992E+000,
      2.9919999999999991E+000,
      2.9929999999999994E+000,
      2.9939999999999993E+000,
      2.9949999999999992E+000,
      2.9959999999999991E+000,
      2.9969999999999994E+000,
      2.9979999999999993E+000,
      2.9989999999999992E+000,
      2.9999999999999991E+000,
      3.0009999999999994E+000,
      3.0019999999999993E+000,
      3.0029999999999992E+000,
      3.0039999999999991E+000,
      3.0049999999999994E+000,
      3.0059999999999993E+000,
      3.0069999999999992E+000,
      3.0079999999999991E+000,
      3.0089999999999995E+000,
      3.0099999999999993E+000,
      3.0109999999999992E+000,
      3.0119999999999991E+000,
      3.0129999999999995E+000,
      3.0139999999999993E+000,
      3.0149999999999992E+000,
      3.0159999999999991E+000,
      3.0169999999999995E+000,
      3.0179999999999993E+000,
      3.0189999999999992E+000,
      3.0199999999999991E+000,
      3.0209999999999995E+000,
      3.0219999999999994E+000,
      3.0229999999999992E+000,
      3.0239999999999991E+000,
      3.0249999999999995E+000,
      3.0259999999999994E+000,
      3.0269999999999992E+000,
      3.0279999999999991E+000,
      3.0289999999999995E+000,
      3.0299999999999994E+000,
      3.0309999999999993E+000,
      3.0319999999999991E+000,
      3.0329999999999995E+000,
      3.0339999999999994E+000,
      3.0349999999999993E+000,
      3.0359999999999991E+000,
      3.0369999999999995E+000,
      3.0379999999999994E+000,
      3.0389999999999993E+000,
      3.0399999999999991E+000,
      3.0409999999999995E+000,
      3.0419999999999994E+000,
      3.0429999999999993E+000,
      3.0439999999999992E+000,
      3.0449999999999995E+000,
      3.0459999999999994E+000,
      3.0469999999999993E+000,
      3.0479999999999992E+000,
      3.0489999999999995E+000,
      3.0499999999999994E+000,
      3.0509999999999993E+000,
      3.0519999999999992E+000,
      3.0529999999999990E+000,
      3.0539999999999994E+000,
      3.0549999999999993E+000,
      3.0559999999999992E+000,
      3.0569999999999991E+000,
      3.0579999999999994E+000,
      3.0589999999999993E+000,
      3.0599999999999992E+000,
      3.0609999999999991E+000,
      3.0619999999999994E+000,
      3.0629999999999993E+000,
      3.0639999999999992E+000,
      3.0649999999999991E+000,
      3.0659999999999994E+000,
      3.0669999999999993E+000,
      3.0679999999999992E+000,
      3.0689999999999991E+000,
      3.0699999999999994E+000,
      3.0709999999999993E+000,
      3.0719999999999992E+000,
      3.0729999999999991E+000,
      3.0739999999999994E+000,
      3.0749999999999993E+000,
      3.0759999999999992E+000,
      3.0769999999999991E+000,
      3.0779999999999994E+000,
      3.0789999999999993E+000,
      3.0799999999999992E+000,
      3.0809999999999991E+000,
      3.0819999999999994E+000,
      3.0829999999999993E+000,
      3.0839999999999992E+000,
      3.0849999999999991E+000,
      3.0859999999999994E+000,
      3.0869999999999993E+000,
      3.0879999999999992E+000,
      3.0889999999999991E+000,
      3.0899999999999994E+000,
      3.0909999999999993E+000,
      3.0919999999999992E+000,
      3.0929999999999991E+000,
      3.0939999999999994E+000,
      3.0949999999999993E+000,
      3.0959999999999992E+000,
      3.0969999999999991E+000,
      3.0979999999999994E+000,
      3.0989999999999993E+000,
      3.0999999999999992E+000,
      3.1009999999999991E+000,
      3.1019999999999994E+000,
      3.1029999999999993E+000,
      3.1039999999999992E+000,
      3.1049999999999995E+000,
      3.1059999999999990E+000,
      3.1069999999999993E+000,
      3.1079999999999992E+000,
      3.1089999999999991E+000,
      3.1099999999999994E+000,
      3.1109999999999993E+000,
      3.1119999999999992E+000,
      3.1129999999999995E+000,
      3.1139999999999990E+000,
      3.1149999999999993E+000,
      3.1159999999999992E+000,
      3.1169999999999991E+000,
      3.1179999999999994E+000,
      3.1189999999999993E+000,
      3.1199999999999992E+000,
      3.1209999999999996E+000,
      3.1219999999999990E+000,
      3.1229999999999993E+000,
      3.1239999999999992E+000,
      3.1249999999999991E+000,
      3.1259999999999994E+000,
      3.1269999999999993E+000,
      3.1279999999999992E+000,
      3.1289999999999996E+000,
      3.1299999999999990E+000,
      3.1309999999999993E+000,
      3.1319999999999992E+000,
      3.1329999999999991E+000,
      3.1339999999999995E+000,
      3.1349999999999993E+000,
      3.1359999999999992E+000,
      3.1369999999999996E+000,
      3.1379999999999990E+000,
      3.1389999999999993E+000,
      3.1399999999999992E+000,
      3.1409999999999991E+000,
      3.1419999999999995E+000,
      3.1429999999999993E+000,
      3.1439999999999992E+000,
      3.1449999999999996E+000,
      3.1459999999999990E+000,
      3.1469999999999994E+000,
      3.1479999999999992E+000,
      3.1489999999999991E+000,
      3.1499999999999995E+000,
      3.1509999999999994E+000,
      3.1519999999999992E+000,
      3.1529999999999996E+000,
      3.1539999999999990E+000,
      3.1549999999999994E+000,
      3.1559999999999993E+000,
      3.1569999999999991E+000,
      3.1579999999999995E+000,
      3.1589999999999994E+000,
      3.1599999999999993E+000,
      3.1609999999999996E+000,
      3.1619999999999990E+000,
      3.1629999999999994E+000,
      3.1639999999999993E+000,
      3.1649999999999991E+000,
      3.1659999999999995E+000,
      3.1669999999999994E+000,
      3.1679999999999993E+000,
      3.1689999999999996E+000,
      3.1699999999999990E+000,
      3.1709999999999994E+000,
      3.1719999999999993E+000,
      3.1729999999999992E+000,
      3.1739999999999995E+000,
      3.1749999999999994E+000,
      3.1759999999999993E+000,
      3.1769999999999996E+000,
      3.1779999999999990E+000,
      3.1789999999999994E+000,
      3.1799999999999993E+000,
      3.1809999999999992E+000,
      3.1819999999999995E+000,
      3.1829999999999989E+000,
      3.1839999999999993E+000,
      3.1849999999999992E+000,
      3.1859999999999991E+000,
      3.1869999999999994E+000,
      3.1879999999999993E+000,
      3.1889999999999992E+000,
      3.1899999999999995E+000,
      3.1909999999999989E+000,
      3.1919999999999993E+000,
      3.1929999999999992E+000,
      3.1939999999999991E+000,
      3.1949999999999994E+000,
      3.1959999999999993E+000,
      3.1969999999999992E+000,
      3.1979999999999995E+000,
      3.1989999999999990E+000,
      3.1999999999999993E+000,
      3.2009999999999992E+000,
      3.2019999999999991E+000,
      3.2029999999999994E+000,
      3.2039999999999993E+000,
      3.2049999999999992E+000,
      3.2059999999999995E+000,
      3.2069999999999990E+000,
      3.2079999999999993E+000,
      3.2089999999999992E+000,
      3.2099999999999991E+000,
      3.2109999999999994E+000,
      3.2119999999999993E+000,
      3.2129999999999992E+000,
      3.2139999999999995E+000,
      3.2149999999999990E+000,
      3.2159999999999993E+000,
      3.2169999999999992E+000,
      3.2179999999999991E+000,
      3.2189999999999994E+000,
      3.2199999999999993E+000,
      3.2209999999999992E+000,
      3.2219999999999995E+000,
      3.2229999999999990E+000,
      3.2239999999999993E+000,
      3.2249999999999992E+000,
      3.2259999999999991E+000,
      3.2269999999999994E+000,
      3.2279999999999993E+000,
      3.2289999999999992E+000,
      3.2299999999999995E+000,
      3.2309999999999990E+000,
      3.2319999999999993E+000,
      3.2329999999999992E+000,
      3.2339999999999991E+000,
      3.2349999999999994E+000,
      3.2359999999999993E+000,
      3.2369999999999992E+000,
      3.2379999999999995E+000,
      3.2389999999999990E+000,
      3.2399999999999993E+000,
      3.2409999999999992E+000,
      3.2419999999999991E+000,
      3.2429999999999994E+000,
      3.2439999999999993E+000,
      3.2449999999999992E+000,
      3.2459999999999996E+000,
      3.2469999999999990E+000,
      3.2479999999999993E+000,
      3.2489999999999992E+000,
      3.2499999999999991E+000,
      3.2509999999999994E+000,
      3.2519999999999993E+000,
      3.2529999999999992E+000,
      3.2539999999999996E+000,
      3.2549999999999990E+000,
      3.2559999999999993E+000,
      3.2569999999999992E+000,
      3.2579999999999991E+000,
      3.2589999999999995E+000,
      3.2599999999999993E+000,
      3.2609999999999992E+000,
      3.2619999999999996E+000,
      3.2629999999999990E+000,
      3.2639999999999993E+000,
      3.2649999999999992E+000,
      3.2659999999999991E+000,
      3.2669999999999995E+000,
      3.2679999999999993E+000,
      3.2689999999999992E+000,
      3.2699999999999996E+000,
      3.2709999999999990E+000,
      3.2719999999999994E+000,
      3.2729999999999992E+000,
      3.2739999999999991E+000,
      3.2749999999999995E+000,
      3.2759999999999994E+000,
      3.2769999999999992E+000,
      3.2779999999999996E+000,
      3.2789999999999990E+000,
      3.2799999999999994E+000,
      3.2809999999999993E+000,
      3.2819999999999991E+000,
      3.2829999999999995E+000,
      3.2839999999999994E+000,
      3.2849999999999993E+000,
      3.2859999999999996E+000,
      3.2869999999999990E+000,
      3.2879999999999994E+000,
      3.2889999999999993E+000,
      3.2899999999999991E+000,
      3.2909999999999995E+000,
      3.2919999999999994E+000,
      3.2929999999999993E+000,
      3.2939999999999996E+000,
      3.2949999999999990E+000,
      3.2959999999999994E+000,
      3.2969999999999993E+000,
      3.2979999999999992E+000,
      3.2989999999999995E+000,
      3.2999999999999994E+000,
      3.3009999999999993E+000,
      3.3019999999999996E+000,
      3.3029999999999990E+000,
      3.3039999999999994E+000,
      3.3049999999999993E+000,
      3.3059999999999992E+000,
      3.3069999999999995E+000,
      3.3079999999999989E+000,
      3.3089999999999993E+000,
      3.3099999999999992E+000,
      3.3109999999999991E+000,
      3.3119999999999994E+000,
      3.3129999999999993E+000,
      3.3139999999999992E+000,
      3.3149999999999995E+000,
      3.3159999999999989E+000,
      3.3169999999999993E+000,
      3.3179999999999992E+000,
      3.3189999999999991E+000,
      3.3199999999999994E+000,
      3.3209999999999993E+000,
      3.3219999999999992E+000,
      3.3229999999999995E+000,
      3.3239999999999990E+000,
      3.3249999999999993E+000,
      3.3259999999999992E+000,
      3.3269999999999991E+000,
      3.3279999999999994E+000,
      3.3289999999999993E+000,
      3.3299999999999992E+000,
      3.3309999999999995E+000,
      3.3319999999999990E+000,
      3.3329999999999993E+000,
      3.3339999999999992E+000,
      3.3349999999999991E+000,
      3.3359999999999994E+000,
      3.3369999999999993E+000,
      3.3379999999999992E+000,
      3.3389999999999995E+000,
      3.3399999999999990E+000,
      3.3409999999999993E+000,
      3.3419999999999992E+000,
      3.3429999999999991E+000,
      3.3439999999999994E+000,
      3.3449999999999993E+000,
      3.3459999999999992E+000,
      3.3469999999999995E+000,
      3.3479999999999990E+000,
      3.3489999999999993E+000,
      3.3499999999999992E+000,
      3.3509999999999991E+000,
      3.3519999999999994E+000,
      3.3529999999999993E+000,
      3.3539999999999992E+000,
      3.3549999999999995E+000,
      3.3559999999999990E+000,
      3.3569999999999993E+000,
      3.3579999999999992E+000,
      3.3589999999999991E+000,
      3.3599999999999994E+000,
      3.3609999999999993E+000,
      3.3619999999999992E+000,
      3.3629999999999995E+000,
      3.3639999999999990E+000,
      3.3649999999999993E+000,
      3.3659999999999992E+000,
      3.3669999999999991E+000,
      3.3679999999999994E+000,
      3.3689999999999993E+000,
      3.3699999999999992E+000,
      3.3709999999999996E+000,
      3.3719999999999990E+000,
      3.3729999999999993E+000,
      3.3739999999999992E+000,
      3.3749999999999991E+000,
      3.3759999999999994E+000,
      3.3769999999999993E+000,
      3.3779999999999992E+000,
      3.3789999999999996E+000,
      3.3799999999999990E+000,
      3.3809999999999993E+000,
      3.3819999999999992E+000,
      3.3829999999999991E+000,
      3.3839999999999995E+000,
      3.3849999999999993E+000,
      3.3859999999999992E+000,
      3.3869999999999996E+000,
      3.3879999999999990E+000,
      3.3889999999999993E+000,
      3.3899999999999992E+000,
      3.3909999999999991E+000,
      3.3919999999999995E+000,
      3.3929999999999993E+000,
      3.3939999999999992E+000,
      3.3949999999999996E+000,
      3.3959999999999990E+000,
      3.3969999999999994E+000,
      3.3979999999999992E+000,
      3.3989999999999991E+000,
      3.3999999999999995E+000,
      3.4009999999999994E+000,
      3.4019999999999992E+000,
      3.4029999999999996E+000,
      3.4039999999999990E+000,
      3.4049999999999994E+000,
      3.4059999999999993E+000,
      3.4069999999999991E+000,
      3.4079999999999995E+000,
      3.4089999999999994E+000,
      3.4099999999999993E+000,
      3.4109999999999996E+000,
      3.4119999999999990E+000,
      3.4129999999999994E+000,
      3.4139999999999993E+000,
      3.4149999999999991E+000,
      3.4159999999999995E+000,
      3.4169999999999994E+000,
      3.4179999999999993E+000,
      3.4189999999999996E+000,
      3.4199999999999990E+000,
      3.4209999999999994E+000,
      3.4219999999999993E+000,
      3.4229999999999992E+000,
      3.4239999999999995E+000,
      3.4249999999999994E+000,
      3.4259999999999993E+000,
      3.4269999999999996E+000,
      3.4279999999999990E+000,
      3.4289999999999994E+000,
      3.4299999999999993E+000,
      3.4309999999999992E+000,
      3.4319999999999995E+000,
      3.4329999999999994E+000,
      3.4339999999999993E+000,
      3.4349999999999992E+000,
      3.4359999999999991E+000,
      3.4369999999999994E+000,
      3.4379999999999993E+000,
      3.4389999999999992E+000,
      3.4399999999999995E+000,
      3.4409999999999989E+000,
      3.4419999999999993E+000,
      3.4429999999999992E+000,
      3.4439999999999991E+000,
      3.4449999999999994E+000,
      3.4459999999999993E+000,
      3.4469999999999992E+000,
      3.4479999999999995E+000,
      3.4489999999999990E+000,
      3.4499999999999993E+000,
      3.4509999999999992E+000,
      3.4519999999999991E+000,
      3.4529999999999994E+000,
      3.4539999999999993E+000,
      3.4549999999999992E+000,
      3.4559999999999995E+000,
      3.4569999999999990E+000,
      3.4579999999999993E+000,
      3.4589999999999992E+000,
      3.4599999999999991E+000,
      3.4609999999999994E+000,
      3.4619999999999993E+000,
      3.4629999999999992E+000,
      3.4639999999999995E+000,
      3.4649999999999990E+000,
      3.4659999999999993E+000,
      3.4669999999999992E+000,
      3.4679999999999991E+000,
      3.4689999999999994E+000,
      3.4699999999999993E+000,
      3.4709999999999992E+000,
      3.4719999999999995E+000,
      3.4729999999999990E+000,
      3.4739999999999993E+000,
      3.4749999999999992E+000,
      3.4759999999999991E+000,
      3.4769999999999994E+000,
      3.4779999999999993E+000,
      3.4789999999999992E+000,
      3.4799999999999995E+000,
      3.4809999999999990E+000,
      3.4819999999999993E+000,
      3.4829999999999992E+000,
      3.4839999999999991E+000,
      3.4849999999999994E+000,
      3.4859999999999993E+000,
      3.4869999999999992E+000,
      3.4879999999999995E+000,
      3.4889999999999990E+000,
      3.4899999999999993E+000,
      3.4909999999999992E+000,
      3.4919999999999991E+000,
      3.4929999999999994E+000,
      3.4939999999999993E+000,
      3.4949999999999992E+000,
      3.4959999999999996E+000,
      3.4969999999999990E+000,
      3.4979999999999993E+000,
      3.4989999999999992E+000,
      3.4999999999999991E+000,
      3.5009999999999994E+000,
      3.5019999999999993E+000,
      3.5029999999999992E+000,
      3.5039999999999996E+000,
      3.5049999999999990E+000,
      3.5059999999999993E+000,
      3.5069999999999992E+000,
      3.5079999999999991E+000,
      3.5089999999999995E+000,
      3.5099999999999993E+000,
      3.5109999999999992E+000,
      3.5119999999999996E+000,
      3.5129999999999990E+000,
      3.5139999999999993E+000,
      3.5149999999999992E+000,
      3.5159999999999991E+000,
      3.5169999999999995E+000,
      3.5179999999999993E+000,
      3.5189999999999992E+000,
      3.5199999999999996E+000,
      3.5209999999999990E+000,
      3.5219999999999994E+000,
      3.5229999999999992E+000,
      3.5239999999999991E+000,
      3.5249999999999995E+000,
      3.5259999999999994E+000,
      3.5269999999999992E+000,
      3.5279999999999996E+000,
      3.5289999999999990E+000,
      3.5299999999999994E+000,
      3.5309999999999993E+000,
      3.5319999999999991E+000,
      3.5329999999999995E+000,
      3.5339999999999994E+000,
      3.5349999999999993E+000,
      3.5359999999999996E+000,
      3.5369999999999990E+000,
      3.5379999999999994E+000,
      3.5389999999999993E+000,
      3.5399999999999991E+000,
      3.5409999999999995E+000,
      3.5419999999999994E+000,
      3.5429999999999993E+000,
      3.5439999999999996E+000,
      3.5449999999999990E+000,
      3.5459999999999994E+000,
      3.5469999999999993E+000,
      3.5479999999999992E+000,
      3.5489999999999995E+000,
      3.5499999999999994E+000,
      3.5509999999999993E+000,
      3.5519999999999996E+000,
      3.5529999999999990E+000,
      3.5539999999999994E+000,
      3.5549999999999993E+000,
      3.5559999999999992E+000,
      3.5569999999999995E+000,
      3.5579999999999994E+000,
      3.5589999999999993E+000,
      3.5599999999999996E+000,
      3.5609999999999991E+000,
      3.5619999999999994E+000,
      3.5629999999999993E+000,
      3.5639999999999992E+000,
      3.5649999999999995E+000,
      3.5659999999999989E+000,
      3.5669999999999993E+000,
      3.5679999999999992E+000,
      3.5689999999999991E+000,
      3.5699999999999994E+000,
      3.5709999999999993E+000,
      3.5719999999999992E+000,
      3.5729999999999995E+000,
      3.5739999999999990E+000,
      3.5749999999999993E+000,
      3.5759999999999992E+000,
      3.5769999999999991E+000,
      3.5779999999999994E+000,
      3.5789999999999993E+000,
      3.5799999999999992E+000,
      3.5809999999999995E+000,
      3.5819999999999990E+000,
      3.5829999999999993E+000,
      3.5839999999999992E+000,
      3.5849999999999991E+000,
      3.5859999999999994E+000,
      3.5869999999999993E+000,
      3.5879999999999992E+000,
      3.5889999999999995E+000,
      3.5899999999999990E+000,
      3.5909999999999993E+000,
      3.5919999999999992E+000,
      3.5929999999999991E+000,
      3.5939999999999994E+000,
      3.5949999999999993E+000,
      3.5959999999999992E+000,
      3.5969999999999995E+000,
      3.5979999999999990E+000,
      3.5989999999999993E+000,
      3.5999999999999992E+000,
      3.6009999999999991E+000,
      3.6019999999999994E+000,
      3.6029999999999993E+000,
      3.6039999999999992E+000,
      3.6049999999999995E+000,
      3.6059999999999990E+000,
      3.6069999999999993E+000,
      3.6079999999999992E+000,
      3.6089999999999991E+000,
      3.6099999999999994E+000,
      3.6109999999999993E+000,
      3.6119999999999992E+000,
      3.6129999999999995E+000,
      3.6139999999999990E+000,
      3.6149999999999993E+000,
      3.6159999999999992E+000,
      3.6169999999999991E+000,
      3.6179999999999994E+000,
      3.6189999999999993E+000,
      3.6199999999999992E+000,
      3.6209999999999996E+000,
      3.6219999999999990E+000,
      3.6229999999999993E+000,
      3.6239999999999992E+000,
      3.6249999999999991E+000,
      3.6259999999999994E+000,
      3.6269999999999993E+000,
      3.6279999999999992E+000,
      3.6289999999999996E+000,
      3.6299999999999990E+000,
      3.6309999999999993E+000,
      3.6319999999999992E+000,
      3.6329999999999991E+000,
      3.6339999999999995E+000,
      3.6349999999999993E+000,
      3.6359999999999992E+000,
      3.6369999999999996E+000,
      3.6379999999999990E+000,
      3.6389999999999993E+000,
      3.6399999999999992E+000,
      3.6409999999999991E+000,
      3.6419999999999995E+000,
      3.6429999999999993E+000,
      3.6439999999999992E+000,
      3.6449999999999996E+000,
      3.6459999999999990E+000,
      3.6469999999999994E+000,
      3.6479999999999992E+000,
      3.6489999999999991E+000,
      3.6499999999999995E+000,
      3.6509999999999994E+000,
      3.6519999999999992E+000,
      3.6529999999999996E+000,
      3.6539999999999990E+000,
      3.6549999999999994E+000,
      3.6559999999999993E+000,
      3.6569999999999991E+000,
      3.6579999999999995E+000,
      3.6589999999999994E+000,
      3.6599999999999993E+000,
      3.6609999999999996E+000,
      3.6619999999999990E+000,
      3.6629999999999994E+000,
      3.6639999999999993E+000,
      3.6649999999999991E+000,
      3.6659999999999995E+000,
      3.6669999999999994E+000,
      3.6679999999999993E+000,
      3.6689999999999996E+000,
      3.6699999999999990E+000,
      3.6709999999999994E+000,
      3.6719999999999993E+000,
      3.6729999999999992E+000,
      3.6739999999999995E+000,
      3.6749999999999994E+000,
      3.6759999999999993E+000,
      3.6769999999999996E+000,
      3.6779999999999990E+000,
      3.6789999999999994E+000,
      3.6799999999999993E+000,
      3.6809999999999992E+000,
      3.6819999999999995E+000,
      3.6829999999999994E+000,
      3.6839999999999993E+000,
      3.6849999999999996E+000,
      3.6859999999999991E+000,
      3.6869999999999994E+000,
      3.6879999999999993E+000,
      3.6889999999999992E+000,
      3.6899999999999995E+000,
      3.6909999999999994E+000,
      3.6919999999999993E+000,
      3.6929999999999992E+000,
      3.6939999999999991E+000,
      3.6949999999999994E+000,
      3.6959999999999993E+000,
      3.6969999999999992E+000,
      3.6979999999999995E+000,
      3.6989999999999990E+000,
      3.6999999999999993E+000,
      3.7009999999999992E+000,
      3.7019999999999991E+000,
      3.7029999999999994E+000,
      3.7039999999999993E+000,
      3.7049999999999992E+000,
      3.7059999999999995E+000,
      3.7069999999999990E+000,
      3.7079999999999993E+000,
      3.7089999999999992E+000,
      3.7099999999999991E+000,
      3.7109999999999994E+000,
      3.7119999999999993E+000,
      3.7129999999999992E+000,
      3.7139999999999995E+000,
      3.7149999999999990E+000,
      3.7159999999999993E+000,
      3.7169999999999992E+000,
      3.7179999999999991E+000,
      3.7189999999999994E+000,
      3.7199999999999993E+000,
      3.7209999999999992E+000,
      3.7219999999999995E+000,
      3.7229999999999990E+000,
      3.7239999999999993E+000,
      3.7249999999999992E+000,
      3.7259999999999991E+000,
      3.7269999999999994E+000,
      3.7279999999999993E+000,
      3.7289999999999992E+000,
      3.7299999999999995E+000,
      3.7309999999999990E+000,
      3.7319999999999993E+000,
      3.7329999999999992E+000,
      3.7339999999999991E+000,
      3.7349999999999994E+000,
      3.7359999999999993E+000,
      3.7369999999999992E+000,
      3.7379999999999995E+000,
      3.7389999999999990E+000,
      3.7399999999999993E+000,
      3.7409999999999992E+000,
      3.7419999999999991E+000,
      3.7429999999999994E+000,
      3.7439999999999993E+000,
      3.7449999999999992E+000,
      3.7459999999999996E+000,
      3.7469999999999990E+000,
      3.7479999999999993E+000,
      3.7489999999999992E+000,
      3.7499999999999991E+000,
      3.7509999999999994E+000,
      3.7519999999999993E+000,
      3.7529999999999992E+000,
      3.7539999999999996E+000,
      3.7549999999999990E+000,
      3.7559999999999993E+000,
      3.7569999999999992E+000,
      3.7579999999999991E+000,
      3.7589999999999995E+000,
      3.7599999999999993E+000,
      3.7609999999999992E+000,
      3.7619999999999996E+000,
      3.7629999999999990E+000,
      3.7639999999999993E+000,
      3.7649999999999992E+000,
      3.7659999999999991E+000,
      3.7669999999999995E+000,
      3.7679999999999993E+000,
      3.7689999999999992E+000,
      3.7699999999999996E+000,
      3.7709999999999990E+000,
      3.7719999999999994E+000,
      3.7729999999999992E+000,
      3.7739999999999991E+000,
      3.7749999999999995E+000,
      3.7759999999999994E+000,
      3.7769999999999992E+000,
      3.7779999999999996E+000,
      3.7789999999999990E+000,
      3.7799999999999994E+000,
      3.7809999999999993E+000,
      3.7819999999999991E+000,
      3.7829999999999995E+000,
      3.7839999999999994E+000,
      3.7849999999999993E+000,
      3.7859999999999996E+000,
      3.7869999999999990E+000,
      3.7879999999999994E+000,
      3.7889999999999993E+000,
      3.7899999999999991E+000,
      3.7909999999999995E+000,
      3.7919999999999994E+000,
      3.7929999999999993E+000,
      3.7939999999999996E+000,
      3.7949999999999990E+000,
      3.7959999999999994E+000,
      3.7969999999999993E+000,
      3.7979999999999992E+000,
      3.7989999999999995E+000,
      3.7999999999999994E+000,
      3.8009999999999993E+000,
      3.8019999999999996E+000,
      3.8029999999999990E+000,
      3.8039999999999994E+000,
      3.8049999999999993E+000,
      3.8059999999999992E+000,
      3.8069999999999995E+000,
      3.8079999999999994E+000,
      3.8089999999999993E+000,
      3.8099999999999996E+000,
      3.8109999999999991E+000,
      3.8119999999999994E+000,
      3.8129999999999993E+000,
      3.8139999999999992E+000,
      3.8149999999999995E+000,
      3.8159999999999994E+000,
      3.8169999999999993E+000,
      3.8179999999999996E+000,
      3.8189999999999991E+000,
      3.8199999999999994E+000,
      3.8209999999999993E+000,
      3.8219999999999992E+000,
      3.8229999999999995E+000,
      3.8239999999999990E+000,
      3.8249999999999993E+000,
      3.8259999999999992E+000,
      3.8269999999999991E+000,
      3.8279999999999994E+000,
      3.8289999999999993E+000,
      3.8299999999999992E+000,
      3.8309999999999995E+000,
      3.8319999999999990E+000,
      3.8329999999999993E+000,
      3.8339999999999992E+000,
      3.8349999999999991E+000,
      3.8359999999999994E+000,
      3.8369999999999993E+000,
      3.8379999999999992E+000,
      3.8389999999999995E+000,
      3.8399999999999990E+000,
      3.8409999999999993E+000,
      3.8419999999999992E+000,
      3.8429999999999991E+000,
      3.8439999999999994E+000,
      3.8449999999999993E+000,
      3.8459999999999992E+000,
      3.8469999999999995E+000,
      3.8479999999999990E+000,
      3.8489999999999993E+000,
      3.8499999999999992E+000,
      3.8509999999999991E+000,
      3.8519999999999994E+000,
      3.8529999999999993E+000,
      3.8539999999999992E+000,
      3.8549999999999995E+000,
      3.8559999999999990E+000,
      3.8569999999999993E+000,
      3.8579999999999992E+000,
      3.8589999999999991E+000,
      3.8599999999999994E+000,
      3.8609999999999993E+000,
      3.8619999999999992E+000,
      3.8629999999999995E+000,
      3.8639999999999990E+000,
      3.8649999999999993E+000,
      3.8659999999999992E+000,
      3.8669999999999991E+000,
      3.8679999999999994E+000,
      3.8689999999999993E+000,
      3.8699999999999992E+000,
      3.8709999999999996E+000,
      3.8719999999999990E+000,
      3.8729999999999993E+000,
      3.8739999999999992E+000,
      3.8749999999999991E+000,
      3.8759999999999994E+000,
      3.8769999999999993E+000,
      3.8779999999999992E+000,
      3.8789999999999996E+000,
      3.8799999999999990E+000,
      3.8809999999999993E+000,
      3.8819999999999992E+000,
      3.8829999999999991E+000,
      3.8839999999999995E+000,
      3.8849999999999993E+000,
      3.8859999999999992E+000,
      3.8869999999999996E+000,
      3.8879999999999990E+000,
      3.8889999999999993E+000,
      3.8899999999999992E+000,
      3.8909999999999991E+000,
      3.8919999999999995E+000,
      3.8929999999999993E+000,
      3.8939999999999992E+000,
      3.8949999999999996E+000,
      3.8959999999999990E+000,
      3.8969999999999994E+000,
      3.8979999999999992E+000,
      3.8989999999999991E+000,
      3.8999999999999995E+000,
      3.9009999999999994E+000,
      3.9019999999999992E+000,
      3.9029999999999996E+000,
      3.9039999999999990E+000,
      3.9049999999999994E+000,
      3.9059999999999993E+000,
      3.9069999999999991E+000,
      3.9079999999999995E+000,
      3.9089999999999994E+000,
      3.9099999999999993E+000,
      3.9109999999999996E+000,
      3.9119999999999990E+000,
      3.9129999999999994E+000,
      3.9139999999999993E+000,
      3.9149999999999991E+000,
      3.9159999999999995E+000,
      3.9169999999999994E+000,
      3.9179999999999993E+000,
      3.9189999999999996E+000,
      3.9199999999999990E+000,
      3.9209999999999994E+000,
      3.9219999999999993E+000,
      3.9229999999999992E+000,
      3.9239999999999995E+000,
      3.9249999999999994E+000,
      3.9259999999999993E+000,
      3.9269999999999996E+000,
      3.9279999999999990E+000,
      3.9289999999999994E+000,
      3.9299999999999993E+000,
      3.9309999999999992E+000,
      3.9319999999999995E+000,
      3.9329999999999994E+000,
      3.9339999999999993E+000,
      3.9349999999999996E+000,
      3.9359999999999991E+000,
      3.9369999999999994E+000,
      3.9379999999999993E+000,
      3.9389999999999992E+000,
      3.9399999999999995E+000,
      3.9409999999999994E+000,
      3.9419999999999993E+000,
      3.9429999999999996E+000,
      3.9439999999999991E+000,
      3.9449999999999994E+000,
      3.9459999999999993E+000,
      3.9469999999999992E+000,
      3.9479999999999995E+000,
      3.9489999999999990E+000,
      3.9499999999999993E+000,
      3.9509999999999992E+000,
      3.9519999999999991E+000,
      3.9529999999999994E+000,
      3.9539999999999993E+000,
      3.9549999999999992E+000,
      3.9559999999999995E+000,
      3.9569999999999990E+000,
      3.9579999999999993E+000,
      3.9589999999999992E+000,
      3.9599999999999991E+000,
      3.9609999999999994E+000,
      3.9619999999999993E+000,
      3.9629999999999992E+000,
      3.9639999999999995E+000,
      3.9649999999999990E+000,
      3.9659999999999993E+000,
      3.9669999999999992E+000,
      3.9679999999999991E+000,
      3.9689999999999994E+000,
      3.9699999999999993E+000,
      3.9709999999999992E+000,
      3.9719999999999995E+000,
      3.9729999999999990E+000,
      3.9739999999999993E+000,
      3.9749999999999992E+000,
      3.9759999999999991E+000,
      3.9769999999999994E+000,
      3.9779999999999993E+000,
      3.9789999999999992E+000,
      3.9799999999999995E+000,
      3.9809999999999990E+000,
      3.9819999999999993E+000,
      3.9829999999999992E+000,
      3.9839999999999991E+000,
      3.9849999999999994E+000,
      3.9859999999999993E+000,
      3.9869999999999992E+000,
      3.9879999999999995E+000,
      3.9889999999999990E+000,
      3.9899999999999993E+000,
      3.9909999999999992E+000,
      3.9919999999999991E+000,
      3.9929999999999994E+000,
      3.9939999999999993E+000,
      3.9949999999999992E+000,
      3.9959999999999996E+000,
      3.9969999999999990E+000,
      3.9979999999999993E+000,
      3.9989999999999992E+000,
      3.9999999999999991E+000,
      4.0009999999999994E+000,
      4.0019999999999989E+000,
      4.0029999999999992E+000,
      4.004,
      4.0049999999999990E+000,
      4.0059999999999993E+000,
      4.007,
      4.0079999999999991E+000,
      4.0089999999999995E+000,
      4.01,
      4.0109999999999992E+000,
      4.012,
      4.0129999999999990E+000,
      4.0139999999999993E+000,
      4.0149999999999988E+000,
      4.0159999999999991E+000,
      4.0169999999999995E+000,
      4.0179999999999989E+000,
      4.0189999999999992E+000,
      4.02,
      4.0209999999999990E+000,
      4.0219999999999994E+000,
      4.023,
      4.0239999999999991E+000,
      4.0249999999999995E+000,
      4.026,
      4.0269999999999992E+000,
      4.028,
      4.0289999999999990E+000,
      4.0299999999999994E+000,
      4.0309999999999988E+000,
      4.0319999999999991E+000,
      4.0329999999999995E+000,
      4.0339999999999989E+000,
      4.0349999999999993E+000,
      4.036,
      4.0369999999999990E+000,
      4.0379999999999994E+000,
      4.039,
      4.0399999999999991E+000,
      4.0409999999999995E+000,
      4.042,
      4.0429999999999993E+000,
      4.044,
      4.0449999999999990E+000,
      4.0459999999999994E+000,
      4.0469999999999988E+000,
      4.0479999999999992E+000,
      4.0489999999999995E+000,
      4.0499999999999989E+000,
      4.0509999999999993E+000,
      4.052,
      4.0529999999999990E+000,
      4.0539999999999994E+000,
      4.055,
      4.0559999999999992E+000,
      4.0569999999999995E+000,
      4.058,
      4.0589999999999993E+000,
      4.06,
      4.0609999999999991E+000,
      4.0619999999999994E+000,
      4.0629999999999988E+000,
      4.0639999999999992E+000,
      4.0649999999999995E+000,
      4.0659999999999989E+000,
      4.0669999999999993E+000,
      4.068,
      4.0689999999999991E+000,
      4.0699999999999994E+000,
      4.071,
      4.0719999999999992E+000,
      4.0729999999999995E+000,
      4.074,
      4.0749999999999993E+000,
      4.0759999999999987E+000,
      4.0769999999999991E+000,
      4.0779999999999994E+000,
      4.0789999999999988E+000,
      4.0799999999999992E+000,
      4.0809999999999995E+000,
      4.0819999999999990E+000,
      4.0829999999999993E+000,
      4.084,
      4.0849999999999991E+000,
      4.0859999999999994E+000,
      4.087,
      4.0879999999999992E+000,
      4.0889999999999995E+000,
      4.0899999999999990E+000,
      4.0909999999999993E+000,
      4.0919999999999987E+000,
      4.0929999999999991E+000,
      4.0939999999999994E+000,
      4.0949999999999989E+000,
      4.0959999999999992E+000,
      4.0969999999999995E+000,
      4.0979999999999990E+000,
      4.0989999999999993E+000,
      4.1,
      4.1009999999999991E+000,
      4.1019999999999994E+000,
      4.103,
      4.1039999999999992E+000,
      4.1049999999999995E+000,
      4.1059999999999990E+000,
      4.1069999999999993E+000,
      4.108,
      4.1089999999999991E+000,
      4.1099999999999994E+000,
      4.1109999999999989E+000,
      4.1119999999999992E+000,
      4.1129999999999995E+000,
      4.1139999999999990E+000,
      4.1149999999999993E+000,
      4.116,
      4.1169999999999991E+000,
      4.1179999999999994E+000,
      4.119,
      4.1199999999999992E+000,
      4.1209999999999996E+000,
      4.1219999999999990E+000,
      4.1229999999999993E+000,
      4.124,
      4.1249999999999991E+000,
      4.1259999999999994E+000,
      4.1269999999999989E+000,
      4.1279999999999992E+000,
      4.129,
      4.1299999999999990E+000,
      4.1309999999999993E+000,
      4.132,
      4.1329999999999991E+000,
      4.1339999999999995E+000,
      4.135,
      4.1359999999999992E+000,
      4.137,
      4.1379999999999990E+000,
      4.1389999999999993E+000,
      4.1399999999999988E+000,
      4.1409999999999991E+000,
      4.1419999999999995E+000,
      4.1429999999999989E+000,
      4.1439999999999992E+000,
      4.145,
      4.1459999999999990E+000,
      4.1469999999999994E+000,
      4.148,
      4.1489999999999991E+000,
      4.1499999999999995E+000,
      4.1509999999999989E+000,
      4.1519999999999992E+000,
      4.153,
      4.1539999999999990E+000,
      4.1549999999999994E+000,
      4.1559999999999988E+000,
      4.1569999999999991E+000,
      4.1579999999999995E+000,
      4.1589999999999989E+000,
      4.1599999999999993E+000,
      4.161,
      4.1619999999999990E+000,
      4.1629999999999994E+000,
      4.164,
      4.1649999999999991E+000,
      4.1659999999999995E+000,
      4.1669999999999989E+000,
      4.1679999999999993E+000,
      4.169,
      4.1699999999999990E+000,
      4.1709999999999994E+000,
      4.1719999999999988E+000,
      4.1729999999999992E+000,
      4.1739999999999995E+000,
      4.1749999999999989E+000,
      4.1759999999999993E+000,
      4.177,
      4.1779999999999990E+000,
      4.1789999999999994E+000,
      4.18,
      4.1809999999999992E+000,
      4.1819999999999995E+000,
      4.1829999999999989E+000,
      4.1839999999999993E+000,
      4.185,
      4.1859999999999991E+000,
      4.1869999999999994E+000,
      4.1879999999999988E+000,
      4.1889999999999992E+000,
      4.1899999999999995E+000,
      4.1909999999999989E+000,
      4.1919999999999993E+000,
      4.193,
      4.1939999999999991E+000,
      4.1949999999999994E+000,
      4.196,
      4.1969999999999992E+000,
      4.1979999999999995E+000,
      4.1989999999999990E+000,
      4.1999999999999993E+000,
      4.201,
      4.2019999999999991E+000,
      4.2029999999999994E+000,
      4.2039999999999988E+000,
      4.2049999999999992E+000,
      4.2059999999999995E+000,
      4.2069999999999990E+000,
      4.2079999999999993E+000,
      4.209,
      4.2099999999999991E+000,
      4.2109999999999994E+000,
      4.212,
      4.2129999999999992E+000,
      4.2139999999999995E+000,
      4.2149999999999990E+000,
      4.2159999999999993E+000,
      4.217,
      4.2179999999999991E+000,
      4.2189999999999994E+000,
      4.2199999999999989E+000,
      4.2209999999999992E+000,
      4.2219999999999995E+000,
      4.2229999999999990E+000,
      4.2239999999999993E+000,
      4.225,
      4.2259999999999991E+000,
      4.2269999999999994E+000,
      4.228,
      4.2289999999999992E+000,
      4.2299999999999995E+000,
      4.2309999999999990E+000,
      4.2319999999999993E+000,
      4.233,
      4.2339999999999991E+000,
      4.2349999999999994E+000,
      4.2359999999999989E+000,
      4.2369999999999992E+000,
      4.2379999999999995E+000,
      4.2389999999999990E+000,
      4.2399999999999993E+000,
      4.241,
      4.2419999999999991E+000,
      4.2429999999999994E+000,
      4.244,
      4.2449999999999992E+000,
      4.2459999999999996E+000,
      4.2469999999999990E+000,
      4.2479999999999993E+000,
      4.249,
      4.2499999999999991E+000,
      4.2509999999999994E+000,
      4.2519999999999989E+000,
      4.2529999999999992E+000,
      4.254,
      4.2549999999999990E+000,
      4.2559999999999993E+000,
      4.257,
      4.2579999999999991E+000,
      4.2589999999999995E+000,
      4.26,
      4.2609999999999992E+000,
      4.262,
      4.2629999999999990E+000,
      4.2639999999999993E+000,
      4.265,
      4.2659999999999991E+000,
      4.2669999999999995E+000,
      4.2679999999999989E+000,
      4.2689999999999992E+000,
      4.27,
      4.2709999999999990E+000,
      4.2719999999999994E+000,
      4.273,
      4.2739999999999991E+000,
      4.2749999999999995E+000,
      4.2759999999999989E+000,
      4.2769999999999992E+000,
      4.278,
      4.2789999999999990E+000,
      4.2799999999999994E+000,
      4.2809999999999988E+000,
      4.2819999999999991E+000,
      4.2829999999999995E+000,
      4.2839999999999989E+000,
      4.2849999999999993E+000,
      4.286,
      4.2869999999999990E+000,
      4.2879999999999994E+000,
      4.289,
      4.2899999999999991E+000,
      4.2909999999999995E+000,
      4.2919999999999989E+000,
      4.2929999999999993E+000,
      4.294,
      4.2949999999999990E+000,
      4.2959999999999994E+000,
      4.2969999999999988E+000,
      4.2979999999999992E+000,
      4.2989999999999995E+000,
      4.2999999999999989E+000,
      4.3009999999999993E+000,
      4.302,
      4.3029999999999990E+000,
      4.3039999999999994E+000,
      4.305,
      4.3059999999999992E+000,
      4.3069999999999995E+000,
      4.3079999999999989E+000,
      4.3089999999999993E+000,
      4.31,
      4.3109999999999991E+000,
      4.3119999999999994E+000,
      4.3129999999999988E+000,
      4.3139999999999992E+000,
      4.3149999999999995E+000,
      4.3159999999999989E+000,
      4.3169999999999993E+000,
      4.318,
      4.3189999999999991E+000,
      4.3199999999999994E+000,
      4.321,
      4.3219999999999992E+000,
      4.3229999999999995E+000,
      4.3239999999999990E+000,
      4.3249999999999993E+000,
      4.326,
      4.3269999999999991E+000,
      4.3279999999999994E+000,
      4.3289999999999988E+000,
      4.3299999999999992E+000,
      4.3309999999999995E+000,
      4.3319999999999990E+000,
      4.3329999999999993E+000,
      4.334,
      4.3349999999999991E+000,
      4.3359999999999994E+000,
      4.337,
      4.3379999999999992E+000,
      4.3389999999999995E+000,
      4.3399999999999990E+000,
      4.3409999999999993E+000,
      4.342,
      4.3429999999999991E+000,
      4.3439999999999994E+000,
      4.3449999999999989E+000,
      4.3459999999999992E+000,
      4.3469999999999995E+000,
      4.3479999999999990E+000,
      4.3489999999999993E+000,
      4.35,
      4.3509999999999991E+000,
      4.3519999999999994E+000,
      4.353,
      4.3539999999999992E+000,
      4.3549999999999995E+000,
      4.3559999999999990E+000,
      4.3569999999999993E+000,
      4.358,
      4.3589999999999991E+000,
      4.3599999999999994E+000,
      4.3609999999999989E+000,
      4.3619999999999992E+000,
      4.3629999999999995E+000,
      4.3639999999999990E+000,
      4.3649999999999993E+000,
      4.366,
      4.3669999999999991E+000,
      4.3679999999999994E+000,
      4.369,
      4.3699999999999992E+000,
      4.3709999999999996E+000,
      4.3719999999999990E+000,
      4.3729999999999993E+000,
      4.374,
      4.3749999999999991E+000,
      4.3759999999999994E+000,
      4.3769999999999989E+000,
      4.3779999999999992E+000,
      4.379,
      4.3799999999999990E+000,
      4.3809999999999993E+000,
      4.382,
      4.3829999999999991E+000,
      4.3839999999999995E+000,
      4.385,
      4.3859999999999992E+000,
      4.387,
      4.3879999999999990E+000,
      4.3889999999999993E+000,
      4.39,
      4.3909999999999991E+000,
      4.3919999999999995E+000,
      4.3929999999999989E+000,
      4.3939999999999992E+000,
      4.395,
      4.3959999999999990E+000,
      4.3969999999999994E+000,
      4.398,
      4.3989999999999991E+000,
      4.3999999999999995E+000,
      4.4009999999999989E+000,
      4.4019999999999992E+000,
      4.403,
      4.4039999999999990E+000,
      4.4049999999999994E+000,
      4.4059999999999988E+000,
      4.4069999999999991E+000,
      4.4079999999999995E+000,
      4.4089999999999989E+000,
      4.4099999999999993E+000,
      4.411,
      4.4119999999999990E+000,
      4.4129999999999994E+000,
      4.414,
      4.4149999999999991E+000,
      4.4159999999999995E+000,
      4.4169999999999989E+000,
      4.4179999999999993E+000,
      4.419,
      4.4199999999999990E+000,
      4.4209999999999994E+000,
      4.4219999999999988E+000,
      4.4229999999999992E+000,
      4.4239999999999995E+000,
      4.4249999999999989E+000,
      4.4259999999999993E+000,
      4.427,
      4.4279999999999990E+000,
      4.4289999999999994E+000,
      4.43,
      4.4309999999999992E+000,
      4.4319999999999995E+000,
      4.4329999999999989E+000,
      4.4339999999999993E+000,
      4.435,
      4.4359999999999991E+000,
      4.4369999999999994E+000,
      4.4379999999999988E+000,
      4.4389999999999992E+000,
      4.4399999999999995E+000,
      4.4409999999999989E+000,
      4.4419999999999993E+000,
      4.443,
      4.4439999999999991E+000,
      4.4449999999999994E+000,
      4.446,
      4.4469999999999992E+000,
      4.4479999999999995E+000,
      4.4489999999999990E+000,
      4.4499999999999993E+000,
      4.451,
      4.4519999999999991E+000,
      4.4529999999999994E+000,
      4.4539999999999988E+000,
      4.4549999999999992E+000,
      4.4559999999999995E+000,
      4.4569999999999990E+000,
      4.4579999999999993E+000,
      4.459,
      4.4599999999999991E+000,
      4.4609999999999994E+000,
      4.462,
      4.4629999999999992E+000,
      4.4639999999999995E+000,
      4.4649999999999990E+000,
      4.4659999999999993E+000,
      4.467,
      4.4679999999999991E+000,
      4.4689999999999994E+000,
      4.4699999999999989E+000,
      4.4709999999999992E+000,
      4.4719999999999995E+000,
      4.4729999999999990E+000,
      4.4739999999999993E+000,
      4.475,
      4.4759999999999991E+000,
      4.4769999999999994E+000,
      4.478,
      4.4789999999999992E+000,
      4.4799999999999995E+000,
      4.4809999999999990E+000,
      4.4819999999999993E+000,
      4.483,
      4.4839999999999991E+000,
      4.4849999999999994E+000,
      4.4859999999999989E+000,
      4.4869999999999992E+000,
      4.4879999999999995E+000,
      4.4889999999999990E+000,
      4.4899999999999993E+000,
      4.491,
      4.4919999999999991E+000,
      4.4929999999999994E+000,
      4.494,
      4.4949999999999992E+000,
      4.4959999999999996E+000,
      4.4969999999999990E+000,
      4.4979999999999993E+000,
      4.499,
      4.4999999999999991E+000,
      4.5009999999999994E+000,
      4.5019999999999989E+000,
      4.5029999999999992E+000,
      4.504,
      4.5049999999999990E+000,
      4.5059999999999993E+000,
      4.507,
      4.5079999999999991E+000,
      4.5089999999999995E+000,
      4.51,
      4.5109999999999992E+000,
      4.512,
      4.5129999999999990E+000,
      4.5139999999999993E+000,
      4.515,
      4.5159999999999991E+000,
      4.5169999999999995E+000,
      4.5179999999999989E+000,
      4.5189999999999992E+000,
      4.52,
      4.5209999999999990E+000,
      4.5219999999999994E+000,
      4.523,
      4.5239999999999991E+000,
      4.5249999999999995E+000,
      4.5259999999999989E+000,
      4.5269999999999992E+000,
      4.528,
      4.5289999999999990E+000,
      4.5299999999999994E+000,
      4.5309999999999988E+000,
      4.5319999999999991E+000,
      4.5329999999999995E+000,
      4.5339999999999989E+000,
      4.5349999999999993E+000,
      4.536,
      4.5369999999999990E+000,
      4.5379999999999994E+000,
      4.539,
      4.5399999999999991E+000,
      4.5409999999999995E+000,
      4.5419999999999989E+000,
      4.5429999999999993E+000,
      4.544,
      4.5449999999999990E+000,
      4.5459999999999994E+000,
      4.5469999999999988E+000,
      4.5479999999999992E+000,
      4.5489999999999995E+000,
      4.5499999999999989E+000,
      4.5509999999999993E+000,
      4.552,
      4.5529999999999990E+000,
      4.5539999999999994E+000,
      4.555,
      4.5559999999999992E+000,
      4.5569999999999995E+000,
      4.5579999999999989E+000,
      4.5589999999999993E+000,
      4.56,
      4.5609999999999991E+000,
      4.5619999999999994E+000,
      4.5629999999999988E+000,
      4.5639999999999992E+000,
      4.5649999999999995E+000,
      4.5659999999999989E+000,
      4.5669999999999993E+000,
      4.568,
      4.5689999999999991E+000,
      4.5699999999999994E+000,
      4.571,
      4.5719999999999992E+000,
      4.5729999999999995E+000,
      4.5739999999999990E+000,
      4.5749999999999993E+000,
      4.576,
      4.5769999999999991E+000,
      4.5779999999999994E+000,
      4.5789999999999988E+000,
      4.5799999999999992E+000,
      4.5809999999999995E+000,
      4.5819999999999990E+000,
      4.5829999999999993E+000,
      4.584,
      4.5849999999999991E+000,
      4.5859999999999994E+000,
      4.587,
      4.5879999999999992E+000,
      4.5889999999999995E+000,
      4.5899999999999990E+000,
      4.5909999999999993E+000,
      4.592,
      4.5929999999999991E+000,
      4.5939999999999994E+000,
      4.5949999999999989E+000,
      4.5959999999999992E+000,
      4.5969999999999995E+000,
      4.5979999999999990E+000,
      4.5989999999999993E+000,
      4.6,
      4.6009999999999991E+000,
      4.6019999999999994E+000,
      4.603,
      4.6039999999999992E+000,
      4.6049999999999995E+000,
      4.6059999999999990E+000,
      4.6069999999999993E+000,
      4.608,
      4.6089999999999991E+000,
      4.6099999999999994E+000,
      4.6109999999999989E+000,
      4.6119999999999992E+000,
      4.6129999999999995E+000,
      4.6139999999999990E+000,
      4.6149999999999993E+000,
      4.616,
      4.6169999999999991E+000,
      4.6179999999999994E+000,
      4.619,
      4.6199999999999992E+000,
      4.6209999999999996E+000,
      4.6219999999999990E+000,
      4.6229999999999993E+000,
      4.624,
      4.6249999999999991E+000,
      4.6259999999999994E+000,
      4.6269999999999989E+000,
      4.6279999999999992E+000,
      4.629,
      4.6299999999999990E+000,
      4.6309999999999993E+000,
      4.632,
      4.6329999999999991E+000,
      4.6339999999999995E+000,
      4.6349999999999989E+000,
      4.6359999999999992E+000,
      4.637,
      4.6379999999999990E+000,
      4.6389999999999993E+000,
      4.64,
      4.6409999999999991E+000,
      4.6419999999999995E+000,
      4.6429999999999989E+000,
      4.6439999999999992E+000,
      4.645,
      4.6459999999999990E+000,
      4.6469999999999994E+000,
      4.648,
      4.6489999999999991E+000,
      4.6499999999999995E+000,
      4.6509999999999989E+000,
      4.6519999999999992E+000,
      4.653,
      4.6539999999999990E+000,
      4.6549999999999994E+000,
      4.656,
      4.6569999999999991E+000,
      4.6579999999999995E+000,
      4.6589999999999989E+000,
      4.6599999999999993E+000,
      4.661,
      4.6619999999999990E+000,
      4.6629999999999994E+000,
      4.664,
      4.6649999999999991E+000,
      4.6659999999999995E+000,
      4.6669999999999989E+000,
      4.6679999999999993E+000,
      4.669,
      4.6699999999999990E+000,
      4.6709999999999994E+000,
      4.672,
      4.6729999999999992E+000,
      4.6739999999999995E+000,
      4.6749999999999989E+000,
      4.6759999999999993E+000,
      4.677,
      4.6779999999999990E+000,
      4.6789999999999994E+000,
      4.68,
      4.6809999999999992E+000,
      4.6819999999999995E+000,
      4.6829999999999989E+000,
      4.6839999999999993E+000,
      4.685,
      4.6859999999999991E+000,
      4.6869999999999994E+000,
      4.6879999999999988E+000,
      4.6889999999999992E+000,
      4.6899999999999995E+000,
      4.6909999999999989E+000,
      4.6919999999999993E+000,
      4.693,
      4.6939999999999991E+000,
      4.6949999999999994E+000,
      4.696,
      4.6969999999999992E+000,
      4.6979999999999995E+000,
      4.6989999999999990E+000,
      4.6999999999999993E+000,
      4.701,
      4.7019999999999991E+000,
      4.7029999999999994E+000,
      4.7039999999999988E+000,
      4.7049999999999992E+000,
      4.7059999999999995E+000,
      4.7069999999999990E+000,
      4.7079999999999993E+000,
      4.709,
      4.7099999999999991E+000,
      4.7109999999999994E+000,
      4.712,
      4.7129999999999992E+000,
      4.7139999999999995E+000,
      4.7149999999999990E+000,
      4.7159999999999993E+000,
      4.717,
      4.7179999999999991E+000,
      4.7189999999999994E+000,
      4.7199999999999989E+000,
      4.7209999999999992E+000,
      4.7219999999999995E+000,
      4.7229999999999990E+000,
      4.7239999999999993E+000,
      4.725,
      4.7259999999999991E+000,
      4.7269999999999994E+000,
      4.728,
      4.7289999999999992E+000,
      4.7299999999999995E+000,
      4.7309999999999990E+000,
      4.7319999999999993E+000,
      4.733,
      4.7339999999999991E+000,
      4.7349999999999994E+000,
      4.7359999999999989E+000,
      4.7369999999999992E+000,
      4.7379999999999995E+000,
      4.7389999999999990E+000,
      4.7399999999999993E+000,
      4.741,
      4.7419999999999991E+000,
      4.7429999999999994E+000,
      4.744,
      4.7449999999999992E+000,
      4.7459999999999996E+000,
      4.7469999999999990E+000,
      4.7479999999999993E+000,
      4.749,
      4.7499999999999991E+000,
      4.7509999999999994E+000,
      4.7519999999999989E+000,
      4.7529999999999992E+000,
      4.754,
      4.7549999999999990E+000,
      4.7559999999999993E+000,
      4.757,
      4.7579999999999991E+000,
      4.7589999999999995E+000,
      4.7599999999999989E+000,
      4.7609999999999992E+000,
      4.762,
      4.7629999999999990E+000,
      4.7639999999999993E+000,
      4.765,
      4.7659999999999991E+000,
      4.7669999999999995E+000,
      4.7679999999999989E+000,
      4.7689999999999992E+000,
      4.77,
      4.7709999999999990E+000,
      4.7719999999999994E+000,
      4.773,
      4.7739999999999991E+000,
      4.7749999999999995E+000,
      4.7759999999999989E+000,
      4.7769999999999992E+000,
      4.778,
      4.7789999999999990E+000,
      4.7799999999999994E+000,
      4.781,
      4.7819999999999991E+000,
      4.7829999999999995E+000,
      4.7839999999999989E+000,
      4.7849999999999993E+000,
      4.786,
      4.7869999999999990E+000,
      4.7879999999999994E+000,
      4.789,
      4.7899999999999991E+000,
      4.7909999999999995E+000,
      4.7919999999999989E+000,
      4.7929999999999993E+000,
      4.794,
      4.7949999999999990E+000,
      4.7959999999999994E+000,
      4.797,
      4.7979999999999992E+000,
      4.7989999999999995E+000,
      4.7999999999999989E+000,
      4.8009999999999993E+000,
      4.802,
      4.8029999999999990E+000,
      4.8039999999999994E+000,
      4.805,
      4.8059999999999992E+000,
      4.8069999999999995E+000,
      4.8079999999999989E+000,
      4.8089999999999993E+000,
      4.81,
      4.8109999999999991E+000,
      4.8119999999999994E+000,
      4.8129999999999988E+000,
      4.8139999999999992E+000,
      4.8149999999999995E+000,
      4.8159999999999989E+000,
      4.8169999999999993E+000,
      4.818,
      4.8189999999999991E+000,
      4.8199999999999994E+000,
      4.821,
      4.8219999999999992E+000,
      4.8229999999999995E+000,
      4.8239999999999990E+000,
      4.8249999999999993E+000,
      4.826,
      4.8269999999999991E+000,
      4.8279999999999994E+000,
      4.8289999999999988E+000,
      4.8299999999999992E+000,
      4.8309999999999995E+000,
      4.8319999999999990E+000,
      4.8329999999999993E+000,
      4.834,
      4.8349999999999991E+000,
      4.8359999999999994E+000,
      4.837,
      4.8379999999999992E+000,
      4.8389999999999995E+000,
      4.8399999999999990E+000,
      4.8409999999999993E+000,
      4.842,
      4.8429999999999991E+000,
      4.8439999999999994E+000,
      4.8449999999999989E+000,
      4.8459999999999992E+000,
      4.8469999999999995E+000,
      4.8479999999999990E+000,
      4.8489999999999993E+000,
      4.85,
      4.8509999999999991E+000,
      4.8519999999999994E+000,
      4.853,
      4.8539999999999992E+000,
      4.8549999999999995E+000,
      4.8559999999999990E+000,
      4.8569999999999993E+000,
      4.858,
      4.8589999999999991E+000,
      4.8599999999999994E+000,
      4.8609999999999989E+000,
      4.8619999999999992E+000,
      4.8629999999999995E+000,
      4.8639999999999990E+000,
      4.8649999999999993E+000,
      4.866,
      4.8669999999999991E+000,
      4.8679999999999994E+000,
      4.8689999999999989E+000,
      4.8699999999999992E+000,
      4.8709999999999996E+000,
      4.8719999999999990E+000,
      4.8729999999999993E+000,
      4.874,
      4.8749999999999991E+000,
      4.8759999999999994E+000,
      4.8769999999999989E+000,
      4.8779999999999992E+000,
      4.879,
      4.8799999999999990E+000,
      4.8809999999999993E+000,
      4.882,
      4.8829999999999991E+000,
      4.8839999999999995E+000,
      4.8849999999999989E+000,
      4.8859999999999992E+000,
      4.887,
      4.8879999999999990E+000,
      4.8889999999999993E+000,
      4.89,
      4.8909999999999991E+000,
      4.8919999999999995E+000,
      4.8929999999999989E+000,
      4.8939999999999992E+000,
      4.895,
      4.8959999999999990E+000,
      4.8969999999999994E+000,
      4.898,
      4.8989999999999991E+000,
      4.8999999999999995E+000,
      4.9009999999999989E+000,
      4.9019999999999992E+000,
      4.903,
      4.9039999999999990E+000,
      4.9049999999999994E+000,
      4.906,
      4.9069999999999991E+000,
      4.9079999999999995E+000,
      4.9089999999999989E+000,
      4.9099999999999993E+000,
      4.911,
      4.9119999999999990E+000,
      4.9129999999999994E+000,
      4.914,
      4.9149999999999991E+000,
      4.9159999999999995E+000,
      4.9169999999999989E+000,
      4.9179999999999993E+000,
      4.919,
      4.9199999999999990E+000,
      4.9209999999999994E+000,
      4.922,
      4.9229999999999992E+000,
      4.9239999999999995E+000,
      4.9249999999999989E+000,
      4.9259999999999993E+000,
      4.927,
      4.9279999999999990E+000,
      4.9289999999999994E+000,
      4.93,
      4.9309999999999992E+000,
      4.9319999999999995E+000,
      4.9329999999999989E+000,
      4.9339999999999993E+000,
      4.935,
      4.9359999999999991E+000,
      4.9369999999999994E+000,
      4.938,
      4.9389999999999992E+000,
      4.9399999999999995E+000,
      4.9409999999999989E+000,
      4.9419999999999993E+000,
      4.943,
      4.9439999999999991E+000,
      4.9449999999999994E+000,
      4.946,
      4.9469999999999992E+000,
      4.9479999999999995E+000,
      4.9489999999999990E+000,
      4.9499999999999993E+000,
      4.951,
      4.9519999999999991E+000,
      4.9529999999999994E+000,
      4.954,
      4.9549999999999992E+000,
      4.9559999999999995E+000,
      4.9569999999999990E+000,
      4.9579999999999993E+000,
      4.959,
      4.9599999999999991E+000,
      4.9609999999999994E+000,
      4.962,
      4.9629999999999992E+000,
      4.9639999999999995E+000,
      4.9649999999999990E+000,
      4.9659999999999993E+000,
      4.967,
      4.9679999999999991E+000,
      4.9689999999999994E+000,
      4.9699999999999989E+000,
      4.9709999999999992E+000,
      4.9719999999999995E+000,
      4.9729999999999990E+000,
      4.9739999999999993E+000,
      4.975,
      4.9759999999999991E+000,
      4.9769999999999994E+000,
      4.978,
      4.9789999999999992E+000,
      4.9799999999999995E+000,
      4.9809999999999990E+000,
      4.9819999999999993E+000,
      4.983,
      4.9839999999999991E+000,
      4.9849999999999994E+000,
      4.9859999999999989E+000,
      4.9869999999999992E+000,
      4.9879999999999995E+000,
      4.9889999999999990E+000,
      4.9899999999999993E+000,
      4.991,
      4.9919999999999991E+000,
      4.9929999999999994E+000,
      4.9939999999999989E+000,
      4.9949999999999992E+000,
      4.9959999999999996E+000,
      4.9969999999999990E+000,
      4.9979999999999993E+000,
      4.999,
      4.9999999999999991E+000,
      5.0009999999999994E+000,
      5.0019999999999989E+000,
      5.0029999999999992E+000,
      5.004,
      5.0049999999999990E+000,
      5.0059999999999993E+000,
      5.007,
      5.0079999999999991E+000,
      5.0089999999999995E+000,
      5.0099999999999989E+000,
      5.0109999999999992E+000,
      5.012,
      5.0129999999999990E+000,
      5.0139999999999993E+000,
      5.015,
      5.0159999999999991E+000,
      5.0169999999999995E+000,
      5.0179999999999989E+000,
      5.0189999999999992E+000,
      5.02,
      5.0209999999999990E+000,
      5.0219999999999994E+000,
      5.023,
      5.0239999999999991E+000,
      5.0249999999999995E+000,
      5.0259999999999989E+000,
      5.0269999999999992E+000,
      5.028,
      5.0289999999999990E+000,
      5.0299999999999994E+000,
      5.031,
      5.0319999999999991E+000,
      5.0329999999999995E+000,
      5.0339999999999989E+000,
      5.0349999999999993E+000,
      5.036,
      5.0369999999999990E+000,
      5.0379999999999994E+000,
      5.039,
      5.0399999999999991E+000,
      5.0409999999999995E+000,
      5.0419999999999989E+000,
      5.0429999999999993E+000,
      5.044,
      5.0449999999999990E+000,
      5.0459999999999994E+000,
      5.047,
      5.0479999999999992E+000,
      5.0489999999999995E+000,
      5.0499999999999989E+000,
      5.0509999999999993E+000,
      5.052,
      5.0529999999999990E+000,
      5.0539999999999994E+000,
      5.055,
      5.0559999999999992E+000,
      5.0569999999999995E+000,
      5.0579999999999989E+000,
      5.0589999999999993E+000,
      5.06,
      5.0609999999999991E+000,
      5.0619999999999994E+000,
      5.063,
      5.0639999999999992E+000,
      5.0649999999999995E+000,
      5.0659999999999989E+000,
      5.0669999999999993E+000,
      5.068,
      5.0689999999999991E+000,
      5.0699999999999994E+000,
      5.071,
      5.0719999999999992E+000,
      5.0729999999999995E+000,
      5.0739999999999990E+000,
      5.0749999999999993E+000,
      5.076,
      5.0769999999999991E+000,
      5.0779999999999994E+000,
      5.079,
      5.0799999999999992E+000,
      5.0809999999999995E+000,
      5.0819999999999990E+000,
      5.0829999999999993E+000,
      5.084,
      5.0849999999999991E+000,
      5.0859999999999994E+000,
      5.087,
      5.0879999999999992E+000,
      5.0889999999999995E+000,
      5.0899999999999990E+000,
      5.0909999999999993E+000,
      5.092,
      5.0929999999999991E+000,
      5.0939999999999994E+000,
      5.095,
      5.0959999999999992E+000,
      5.0969999999999995E+000,
      5.0979999999999990E+000,
      5.0989999999999993E+000
    };

    static real_T pDataValues[] = {
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      -4.9999999999999989E-005,
      -1.9999999999999996E-004,
      -4.4999999999999993E-004,
      -7.9999999999999982E-004,
      -0.00125,
      -1.7999999999999997E-003,
      -0.00245,
      -3.1999999999999993E-003,
      -4.0500000000000006E-003,
      -0.005,
      -6.0499999999999990E-003,
      -7.1999999999999989E-003,
      -8.4500000000000009E-003,
      -0.0098,
      -0.01125,
      -1.2799999999999997E-002,
      -0.01445,
      -1.6200000000000003E-002,
      -1.8049999999999997E-002,
      -0.02,
      -0.02205,
      -2.4199999999999996E-002,
      -2.6449999999999994E-002,
      -2.8799999999999996E-002,
      -3.1250000000000007E-002,
      -3.3800000000000004E-002,
      -3.6449999999999996E-002,
      -0.0392,
      -0.04205,
      -0.045,
      -4.8049999999999989E-002,
      -5.1199999999999989E-002,
      -0.05445,
      -0.0578,
      -0.06125,
      -6.4800000000000010E-002,
      -6.8449999999999983E-002,
      -7.2199999999999986E-002,
      -7.6049999999999993E-002,
      -0.08,
      -0.08405,
      -0.0882,
      -9.2450000000000018E-002,
      -9.6799999999999983E-002,
      -1.0124999999999998E-001,
      -1.0579999999999998E-001,
      -1.1044999999999999E-001,
      -1.1519999999999998E-001,
      -0.12005,
      -1.2500000000000003E-001,
      -0.13005,
      -1.3520000000000001E-001,
      -1.4045000000000002E-001,
      -0.1458,
      -1.5125000000000002E-001,
      -0.1568,
      -1.6244999999999998E-001,
      -0.1682,
      -0.17405,
      -1.8000000000000002E-001,
      -1.8605000000000002E-001,
      -0.1922,
      -0.19845,
      -2.0479999999999995E-001,
      -0.21125,
      -0.2178,
      -0.22445,
      -0.2312,
      -2.3804999999999998E-001,
      -0.245,
      -2.5205000000000005E-001,
      -2.5920000000000004E-001,
      -0.26645,
      -2.7380000000000004E-001,
      -2.8125000000000006E-001,
      -2.8880000000000006E-001,
      -2.9645000000000010E-001,
      -3.0419999999999997E-001,
      -3.1204999999999994E-001,
      -0.32,
      -3.2804999999999995E-001,
      -0.3362,
      -3.4445000000000003E-001,
      -0.3528,
      -0.36125,
      -3.6980000000000007E-001,
      -3.7845000000000006E-001,
      -3.8720000000000004E-001,
      -0.39605,
      -4.0499999999999992E-001,
      -0.41405,
      -4.2319999999999991E-001,
      -0.43245,
      -4.4179999999999997E-001,
      -4.5124999999999993E-001,
      -4.6079999999999993E-001,
      -0.47045,
      -0.4802,
      -0.49005,
      -0.5,
      -0.51,
      -0.52,
      -0.53,
      -0.54,
      -0.55,
      -5.5999999999999994E-001,
      -5.7000000000000006E-001,
      -0.58,
      -5.9000000000000008E-001,
      -0.6,
      -0.61,
      -0.62,
      -0.63,
      -0.64,
      -0.65,
      -6.5999999999999992E-001,
      -0.67,
      -0.68,
      -6.9000000000000006E-001,
      -0.7,
      -0.71,
      -0.72,
      -0.73,
      -0.74,
      -0.75,
      -0.76,
      -0.77,
      -7.7999999999999992E-001,
      -0.79,
      -0.8,
      -8.0999999999999994E-001,
      -0.82,
      -0.83,
      -8.4000000000000008E-001,
      -8.5000000000000009E-001,
      -0.86,
      -0.87,
      -0.88,
      -8.9000000000000012E-001,
      -0.9,
      -9.0999999999999992E-001,
      -0.92,
      -0.93,
      -0.94,
      -0.95,
      -0.96,
      -9.7000000000000008E-001,
      -0.98,
      -0.99,
      -1.0,
      -1.01,
      -1.02,
      -1.03,
      -1.04,
      -1.05,
      -1.0599999999999998E+000,
      -1.07,
      -1.08,
      -1.09,
      -1.1,
      -1.1099999999999999E+000,
      -1.1199999999999999E+000,
      -1.1300000000000001E+000,
      -1.14,
      -1.1500000000000001E+000,
      -1.16,
      -1.17,
      -1.1800000000000002E+000,
      -1.19,
      -1.2000000000000002E+000,
      -1.21,
      -1.22,
      -1.2300000000000002E+000,
      -1.24,
      -1.25,
      -1.26,
      -1.2699999999999998E+000,
      -1.2800000000000002E+000,
      -1.29,
      -1.3,
      -1.31,
      -1.3199999999999998E+000,
      -1.3300000000000003E+000,
      -1.34,
      -1.35,
      -1.36,
      -1.3699999999999999E+000,
      -1.38,
      -1.3900000000000001E+000,
      -1.4,
      -1.41,
      -1.42,
      -1.43,
      -1.4400000000000002E+000,
      -1.45,
      -1.46,
      -1.47,
      -1.48,
      -1.4900000000000002E+000,
      -1.5,
      -1.51,
      -1.52,
      -1.53,
      -1.5400000000000003E+000,
      -1.55,
      -1.5599999999999998E+000,
      -1.5699999999999998E+000,
      -1.58,
      -1.59,
      -1.6,
      -1.6099999999999999E+000,
      -1.6199999999999999E+000,
      -1.6300000000000001E+000,
      -1.6400000000000001E+000,
      -1.6500000000000001E+000,
      -1.66,
      -1.67,
      -1.6800000000000002E+000,
      -1.6900000000000002E+000,
      -1.7,
      -1.71,
      -1.72,
      -1.73,
      -1.74,
      -1.75,
      -1.76,
      -1.77,
      -1.78,
      -1.79,
      -1.8,
      -1.81,
      -1.82,
      -1.83,
      -1.84,
      -1.85,
      -1.86,
      -1.87,
      -1.8800000000000001E+000,
      -1.8900000000000001E+000,
      -1.9000000000000001E+000,
      -1.9100000000000001E+000,
      -1.9200000000000002E+000,
      -1.9300000000000002E+000,
      -1.9400000000000002E+000,
      -1.95,
      -1.96,
      -1.9699999999999998E+000,
      -1.98,
      -1.99,
      -2.0,
      -2.0100000000000002E+000,
      -2.02,
      -2.03,
      -2.04,
      -2.0500000000000003E+000,
      -2.06,
      -2.07,
      -2.08,
      -2.0900000000000003E+000,
      -2.1,
      -2.11,
      -2.1199999999999997E+000,
      -2.13,
      -2.14,
      -2.1500000000000004E+000,
      -2.16,
      -2.17,
      -2.18,
      -2.1900000000000004E+000,
      -2.2,
      -2.21,
      -2.2199999999999998E+000,
      -2.23,
      -2.24,
      -2.2500000000000004E+000,
      -2.2600000000000002E+000,
      -2.27,
      -2.28,
      -2.29,
      -2.3000000000000003E+000,
      -2.31,
      -2.32,
      -2.3299999999999996E+000,
      -2.34,
      -2.3500000000000005E+000,
      -2.3600000000000003E+000,
      -2.37,
      -2.38,
      -2.39,
      -2.4,
      -2.41,
      -2.42,
      -2.4299999999999997E+000,
      -2.44,
      -2.4499999999999997E+000,
      -2.4600000000000004E+000,
      -2.47,
      -2.48,
      -2.49,
      -2.5,
      -2.5100000000000002E+000,
      -2.52,
      -2.53,
      -2.54,
      -2.5500000000000003E+000,
      -2.5600000000000005E+000,
      -2.5700000000000003E+000,
      -2.58,
      -2.59,
      -2.6,
      -2.61,
      -2.6199999999999997E+000,
      -2.63,
      -2.6399999999999997E+000,
      -2.6500000000000004E+000,
      -2.66,
      -2.67,
      -2.68,
      -2.69,
      -2.7,
      -2.71,
      -2.7199999999999998E+000,
      -2.73,
      -2.7399999999999998E+000,
      -2.7500000000000004E+000,
      -2.7600000000000002E+000,
      -2.77,
      -2.7800000000000002E+000,
      -2.79,
      -2.8000000000000003E+000,
      -2.81,
      -2.82,
      -2.83,
      -2.84,
      -2.8500000000000005E+000,
      -2.8600000000000003E+000,
      -2.87,
      -2.8800000000000003E+000,
      -2.89,
      -2.9,
      -2.9099999999999997E+000,
      -2.92,
      -2.9299999999999997E+000,
      -2.94,
      -2.9499999999999997E+000,
      -2.96,
      -2.97,
      -2.98,
      -2.99,
      -3.0,
      -3.01,
      -3.02,
      -3.03,
      -3.04,
      -3.0500000000000003E+000,
      -3.06,
      -3.0700000000000003E+000,
      -3.08,
      -3.0900000000000003E+000,
      -3.1,
      -3.11,
      -3.12,
      -3.13,
      -3.14,
      -3.1500000000000004E+000,
      -3.16,
      -3.1700000000000004E+000,
      -3.18,
      -3.1900000000000004E+000,
      -3.2,
      -3.21,
      -3.22,
      -3.23,
      -3.24,
      -3.2500000000000004E+000,
      -3.2600000000000002E+000,
      -3.2700000000000005E+000,
      -3.2800000000000002E+000,
      -3.2900000000000005E+000,
      -3.3000000000000003E+000,
      -3.31,
      -3.3200000000000003E+000,
      -3.33,
      -3.3400000000000003E+000,
      -3.3500000000000005E+000,
      -3.3600000000000003E+000,
      -3.3700000000000006E+000,
      -3.3800000000000003E+000,
      -3.3899999999999997E+000,
      -3.4,
      -3.4099999999999997E+000,
      -3.42,
      -3.4299999999999997E+000,
      -3.4399999999999995E+000,
      -3.4499999999999997E+000,
      -3.46,
      -3.47,
      -3.48,
      -3.4899999999999998E+000,
      -3.5,
      -3.51,
      -3.52,
      -3.53,
      -3.5399999999999996E+000,
      -3.5500000000000003E+000,
      -3.56,
      -3.5700000000000003E+000,
      -3.58,
      -3.59,
      -3.6,
      -3.61,
      -3.62,
      -3.63,
      -3.6399999999999997E+000,
      -3.6500000000000004E+000,
      -3.66,
      -3.6700000000000004E+000,
      -3.68,
      -3.69,
      -3.7,
      -3.71,
      -3.72,
      -3.73,
      -3.7399999999999998E+000,
      -3.7500000000000004E+000,
      -3.7600000000000002E+000,
      -3.7700000000000005E+000,
      -3.7800000000000002E+000,
      -3.79,
      -3.8000000000000003E+000,
      -3.81,
      -3.8200000000000003E+000,
      -3.83,
      -3.84,
      -3.8500000000000005E+000,
      -3.8600000000000003E+000,
      -3.8700000000000006E+000,
      -3.8800000000000003E+000,
      -3.89,
      -3.9000000000000004E+000,
      -3.91,
      -3.9200000000000004E+000,
      -3.93,
      -3.94,
      -3.9500000000000006E+000,
      -3.9600000000000004E+000,
      -3.9700000000000006E+000,
      -3.9800000000000004E+000,
      -3.99,
      -4.0000000000000009E+000,
      -4.0100000000000007E+000,
      -4.02,
      -4.03,
      -4.04,
      -4.05,
      -4.06,
      -4.0699999999999994E+000,
      -4.08,
      -4.09,
      -4.1000000000000005E+000,
      -4.11,
      -4.12,
      -4.13,
      -4.14,
      -4.15,
      -4.16,
      -4.17,
      -4.1800000000000006E+000,
      -4.1899999999999995E+000,
      -4.2,
      -4.21,
      -4.22,
      -4.23,
      -4.2399999999999993E+000,
      -4.25,
      -4.26,
      -4.27,
      -4.28,
      -4.2899999999999991E+000,
      -4.3000000000000007E+000,
      -4.3100000000000005E+000,
      -4.32,
      -4.3300000000000010E+000,
      -4.34,
      -4.3500000000000005E+000,
      -4.36,
      -4.37,
      -4.3800000000000008E+000,
      -4.39,
      -4.4,
      -4.41,
      -4.42,
      -4.4300000000000006E+000,
      -4.4399999999999995E+000,
      -4.45,
      -4.46,
      -4.47,
      -4.48,
      -4.4899999999999993E+000,
      -4.5000000000000009E+000,
      -4.5100000000000007E+000,
      -4.5200000000000005E+000,
      -4.5300000000000011E+000,
      -4.54,
      -4.5500000000000007E+000,
      -4.5600000000000005E+000,
      -4.57,
      -4.5800000000000010E+000,
      -4.59,
      -4.6000000000000005E+000,
      -4.61,
      -4.62,
      -4.6300000000000008E+000,
      -4.64,
      -4.65,
      -4.66,
      -4.67,
      -4.6799999999999988E+000,
      -4.6899999999999995E+000,
      -4.7000000000000011E+000,
      -4.71,
      -4.7200000000000006E+000,
      -4.7299999999999995E+000,
      -4.74,
      -4.7500000000000009E+000,
      -4.76,
      -4.7700000000000005E+000,
      -4.7799999999999994E+000,
      -4.79,
      -4.8000000000000007E+000,
      -4.81,
      -4.82,
      -4.8299999999999992E+000,
      -4.84,
      -4.8500000000000005E+000,
      -4.8599999999999994E+000,
      -4.87,
      -4.8799999999999990E+000,
      -4.89,
      -4.9000000000000012E+000,
      -4.91,
      -4.9200000000000008E+000,
      -4.93,
      -4.94,
      -4.9500000000000011E+000,
      -4.96,
      -4.9700000000000006E+000,
      -4.9799999999999995E+000,
      -4.99,
      -5.0000000000000009E+000,
      -5.01,
      -5.0200000000000005E+000,
      -5.0299999999999994E+000,
      -5.04,
      -5.0500000000000007E+000,
      -5.06,
      -5.07,
      -5.0799999999999992E+000,
      -5.09,
      -5.1000000000000014E+000,
      -5.11,
      -5.1200000000000010E+000,
      -5.13,
      -5.1400000000000006E+000,
      -5.1500000000000012E+000,
      -5.16,
      -5.1700000000000008E+000,
      -5.18,
      -5.19,
      -5.2000000000000011E+000,
      -5.21,
      -5.2200000000000006E+000,
      -5.2299999999999995E+000,
      -5.24,
      -5.2500000000000009E+000,
      -5.26,
      -5.2700000000000005E+000,
      -5.2799999999999994E+000,
      -5.29,
      -5.2999999999999989E+000,
      -5.3100000000000005E+000,
      -5.3199999999999994E+000,
      -5.33,
      -5.3400000000000007E+000,
      -5.35,
      -5.36,
      -5.3699999999999992E+000,
      -5.38,
      -5.3900000000000006E+000,
      -5.3999999999999995E+000,
      -5.41,
      -5.4199999999999990E+000,
      -5.43,
      -5.44,
      -5.4499999999999993E+000,
      -5.46,
      -5.4699999999999989E+000,
      -5.4799999999999995E+000,
      -5.49,
      -5.4999999999999991E+000,
      -5.5100000000000007E+000,
      -5.52,
      -5.53,
      -5.5400000000000009E+000,
      -5.55,
      -5.5600000000000005E+000,
      -5.5699999999999994E+000,
      -5.58,
      -5.5900000000000007E+000,
      -5.6,
      -5.61,
      -5.6199999999999992E+000,
      -5.63,
      -5.6400000000000006E+000,
      -5.6499999999999995E+000,
      -5.66,
      -5.6699999999999990E+000,
      -5.68,
      -5.69,
      -5.6999999999999993E+000,
      -5.7100000000000009E+000,
      -5.72,
      -5.73,
      -5.7400000000000011E+000,
      -5.75,
      -5.7600000000000007E+000,
      -5.77,
      -5.78,
      -5.7900000000000009E+000,
      -5.8,
      -5.8100000000000005E+000,
      -5.8199999999999994E+000,
      -5.83,
      -5.8400000000000007E+000,
      -5.85,
      -5.86,
      -5.8699999999999992E+000,
      -5.88,
      -5.8900000000000006E+000,
      -5.8999999999999995E+000,
      -5.9100000000000010E+000,
      -5.92,
      -5.9300000000000006E+000,
      -5.9400000000000013E+000,
      -5.95,
      -5.9600000000000009E+000,
      -5.97,
      -5.98,
      -5.9900000000000011E+000,
      -6.0,
      -6.0100000000000007E+000,
      -6.02,
      -6.03,
      -6.0400000000000009E+000,
      -6.05,
      -6.0600000000000005E+000,
      -6.0699999999999994E+000,
      -6.08,
      -6.0900000000000016E+000,
      -6.1000000000000005E+000,
      -6.1100000000000012E+000,
      -6.12,
      -6.1300000000000008E+000,
      -6.1400000000000015E+000,
      -6.15,
      -6.1600000000000010E+000,
      -6.17,
      -6.1800000000000006E+000,
      -6.1900000000000013E+000,
      -6.2,
      -6.2100000000000009E+000,
      -6.22,
      -6.23,
      -6.2400000000000011E+000,
      -6.25,
      -6.2600000000000007E+000,
      -6.27,
      -6.2799999999999985E+000,
      -6.2899999999999991E+000,
      -6.3000000000000007E+000,
      -6.31,
      -6.32,
      -6.3299999999999992E+000,
      -6.34,
      -6.3500000000000005E+000,
      -6.3599999999999994E+000,
      -6.37,
      -6.3799999999999990E+000,
      -6.39,
      -6.4,
      -6.4099999999999993E+000,
      -6.42,
      -6.4299999999999988E+000,
      -6.4399999999999995E+000,
      -6.45,
      -6.4599999999999991E+000,
      -6.47,
      -6.4799999999999986E+000,
      -6.4899999999999993E+000,
      -6.5000000000000009E+000,
      -6.51,
      -6.5200000000000005E+000,
      -6.5299999999999994E+000,
      -6.54,
      -6.5500000000000007E+000,
      -6.56,
      -6.57,
      -6.5799999999999992E+000,
      -6.59,
      -6.6000000000000005E+000,
      -6.6099999999999994E+000,
      -6.62,
      -6.6299999999999990E+000,
      -6.64,
      -6.65,
      -6.6599999999999993E+000,
      -6.67,
      -6.6799999999999988E+000,
      -6.6899999999999995E+000,
      -6.7000000000000011E+000,
      -6.71,
      -6.7200000000000006E+000,
      -6.7299999999999995E+000,
      -6.74,
      -6.7500000000000009E+000,
      -6.76,
      -6.7700000000000005E+000,
      -6.7799999999999994E+000,
      -6.79,
      -6.8000000000000007E+000,
      -6.81,
      -6.82,
      -6.8299999999999992E+000,
      -6.84,
      -6.8500000000000005E+000,
      -6.8599999999999994E+000,
      -6.87,
      -6.8799999999999990E+000,
      -6.89,
      -6.9000000000000012E+000,
      -6.91,
      -6.9200000000000008E+000,
      -6.93,
      -6.94,
      -6.9500000000000011E+000,
      -6.96,
      -6.9700000000000006E+000,
      -6.9799999999999995E+000,
      -6.99,
      -7.0000000000000009E+000,
      -7.01,
      -7.0200000000000005E+000,
      -7.0299999999999994E+000,
      -7.04,
      -7.0500000000000007E+000,
      -7.06,
      -7.07,
      -7.0799999999999992E+000,
      -7.09,
      -7.1000000000000014E+000,
      -7.11,
      -7.1200000000000010E+000,
      -7.13,
      -7.1400000000000006E+000,
      -7.1500000000000012E+000,
      -7.16,
      -7.1700000000000008E+000,
      -7.18,
      -7.19,
      -7.2000000000000011E+000,
      -7.21,
      -7.2200000000000006E+000,
      -7.2299999999999995E+000,
      -7.24,
      -7.2500000000000009E+000,
      -7.26,
      -7.2700000000000005E+000,
      -7.2799999999999994E+000,
      -7.29,
      -7.3000000000000016E+000,
      -7.3100000000000005E+000,
      -7.3200000000000012E+000,
      -7.33,
      -7.3400000000000007E+000,
      -7.3500000000000014E+000,
      -7.36,
      -7.3700000000000010E+000,
      -7.38,
      -7.3900000000000006E+000,
      -7.4000000000000012E+000,
      -7.41,
      -7.4200000000000008E+000,
      -7.43,
      -7.44,
      -7.4500000000000011E+000,
      -7.46,
      -7.4700000000000006E+000,
      -7.4799999999999995E+000,
      -7.49,
      -7.5000000000000018E+000,
      -7.5100000000000007E+000,
      -7.5200000000000014E+000,
      -7.53,
      -7.5399999999999991E+000,
      -7.55,
      -7.5600000000000005E+000,
      -7.5699999999999994E+000,
      -7.58,
      -7.5899999999999990E+000,
      -7.6,
      -7.61,
      -7.6199999999999992E+000,
      -7.63,
      -7.6399999999999988E+000,
      -7.6499999999999995E+000,
      -7.66,
      -7.6699999999999990E+000,
      -7.68,
      -7.6899999999999986E+000,
      -7.6999999999999993E+000,
      -7.7100000000000009E+000,
      -7.72,
      -7.73,
      -7.7399999999999993E+000,
      -7.75,
      -7.7600000000000007E+000,
      -7.77,
      -7.78,
      -7.7899999999999991E+000,
      -7.8,
      -7.8100000000000005E+000,
      -7.8199999999999994E+000,
      -7.83,
      -7.8399999999999990E+000,
      -7.85,
      -7.86,
      -7.8699999999999992E+000,
      -7.88,
      -7.8899999999999988E+000,
      -7.8999999999999995E+000,
      -7.9100000000000010E+000,
      -7.92,
      -7.9300000000000006E+000,
      -7.9399999999999995E+000,
      -7.95,
      -7.9600000000000009E+000,
      -7.97,
      -7.98,
      -7.9899999999999993E+000,
      -8.0,
      -8.0100000000000016E+000,
      -8.02,
      -8.0300000000000011E+000,
      -8.04,
      -8.05,
      -8.06,
      -8.07,
      -8.08,
      -8.09,
      -8.1,
      -8.1100000000000012E+000,
      -8.12,
      -8.13,
      -8.1399999999999988E+000,
      -8.15,
      -8.16,
      -8.17,
      -8.18,
      -8.19,
      -8.2000000000000011E+000,
      -8.21,
      -8.22,
      -8.23,
      -8.24,
      -8.25,
      -8.2600000000000016E+000,
      -8.27,
      -8.2800000000000011E+000,
      -8.29,
      -8.3,
      -8.31,
      -8.32,
      -8.33,
      -8.34,
      -8.35,
      -8.3600000000000012E+000,
      -8.37,
      -8.38,
      -8.3899999999999988E+000,
      -8.4,
      -8.4100000000000019E+000,
      -8.42,
      -8.4300000000000015E+000,
      -8.44,
      -8.4500000000000011E+000,
      -8.46,
      -8.47,
      -8.48,
      -8.49,
      -8.5,
      -8.5100000000000016E+000,
      -8.52,
      -8.5300000000000011E+000,
      -8.54,
      -8.55,
      -8.56,
      -8.57,
      -8.58,
      -8.59,
      -8.6000000000000014E+000,
      -8.6100000000000012E+000,
      -8.6200000000000010E+000,
      -8.63,
      -8.64,
      -8.65,
      -8.6600000000000019E+000,
      -8.67,
      -8.6800000000000015E+000,
      -8.69,
      -8.7000000000000011E+000,
      -8.71,
      -8.72,
      -8.73,
      -8.74,
      -8.75,
      -8.7600000000000016E+000,
      -8.77,
      -8.7800000000000011E+000,
      -8.79,
      -8.8,
      -8.8100000000000023E+000,
      -8.82,
      -8.83,
      -8.84,
      -8.8500000000000014E+000,
      -8.86,
      -8.8700000000000010E+000,
      -8.8799999999999990E+000,
      -8.89,
      -8.9,
      -8.91,
      -8.92,
      -8.93,
      -8.94,
      -8.9500000000000011E+000,
      -8.9599999999999991E+000,
      -8.97,
      -8.9799999999999986E+000,
      -8.99,
      -9.0000000000000018E+000,
      -9.01,
      -9.0200000000000014E+000,
      -9.03,
      -9.0400000000000009E+000,
      -9.05,
      -9.06,
      -9.07,
      -9.08,
      -9.09,
      -9.1000000000000014E+000,
      -9.11,
      -9.1200000000000010E+000,
      -9.1299999999999990E+000,
      -9.14,
      -9.15,
      -9.16,
      -9.17,
      -9.18,
      -9.19,
      -9.2000000000000011E+000,
      -9.21,
      -9.22,
      -9.23,
      -9.24,
      -9.2500000000000018E+000,
      -9.26,
      -9.2700000000000014E+000,
      -9.28,
      -9.2900000000000009E+000,
      -9.3,
      -9.31,
      -9.32,
      -9.33,
      -9.34,
      -9.3500000000000014E+000,
      -9.36,
      -9.3700000000000010E+000,
      -9.3799999999999990E+000,
      -9.39,
      -9.4000000000000021E+000,
      -9.41,
      -9.4200000000000017E+000,
      -9.43,
      -9.4400000000000013E+000,
      -9.4500000000000011E+000,
      -9.46,
      -9.47,
      -9.48,
      -9.49,
      -9.5000000000000018E+000,
      -9.51,
      -9.5200000000000014E+000,
      -9.53,
      -9.5400000000000009E+000,
      -9.55,
      -9.56,
      -9.57,
      -9.58,
      -9.59,
      -9.6000000000000014E+000,
      -9.6100000000000012E+000,
      -9.6200000000000010E+000,
      -9.63,
      -9.64,
      -9.6500000000000021E+000,
      -9.66,
      -9.6700000000000017E+000,
      -9.68,
      -9.6900000000000013E+000,
      -9.7000000000000011E+000,
      -9.71,
      -9.72,
      -9.73,
      -9.74,
      -9.7500000000000018E+000,
      -9.76,
      -9.7700000000000014E+000,
      -9.78,
      -9.7900000000000009E+000,
      -9.8000000000000025E+000,
      -9.81,
      -9.8200000000000021E+000,
      -9.83,
      -9.8400000000000016E+000,
      -9.8500000000000014E+000,
      -9.8600000000000012E+000,
      -9.8700000000000010E+000,
      -9.88,
      -9.89,
      -9.9000000000000021E+000,
      -9.91,
      -9.9200000000000017E+000,
      -9.93,
      -9.9400000000000013E+000,
      -9.9500000000000011E+000,
      -9.96,
      -9.97,
      -9.98,
      -9.99,
      -1.0000000000000002E+001,
      -1.0010000000000002E+001,
      -1.0020000000000001E+001,
      -1.0030000000000001E+001,
      -1.0040000000000001E+001,
      -1.0050000000000002E+001,
      -10.06,
      -1.0070000000000002E+001,
      -10.08,
      -1.0090000000000002E+001,
      -10.1,
      -1.0110000000000001E+001,
      -10.12,
      -10.13,
      -1.0139999999999999E+001,
      -10.15,
      -10.16,
      -10.17,
      -10.18,
      -10.19,
      -1.0200000000000001E+001,
      -10.21,
      -10.22,
      -10.23,
      -10.24,
      -10.25,
      -1.0260000000000002E+001,
      -10.27,
      -1.0280000000000001E+001,
      -10.29,
      -10.3,
      -10.31,
      -10.32,
      -10.33,
      -10.34,
      -10.35,
      -1.0360000000000001E+001,
      -10.37,
      -10.38,
      -1.0389999999999999E+001,
      -10.4,
      -1.0410000000000002E+001,
      -10.42,
      -1.0430000000000001E+001,
      -10.44,
      -1.0450000000000001E+001,
      -10.46,
      -10.47,
      -10.48,
      -10.49,
      -10.5,
      -1.0510000000000002E+001,
      -10.52,
      -1.0530000000000001E+001,
      -10.54,
      -1.0550000000000002E+001,
      -10.56,
      -1.0570000000000002E+001,
      -10.58,
      -1.0590000000000002E+001,
      -1.0600000000000001E+001,
      -1.0610000000000001E+001,
      -1.0620000000000001E+001,
      -10.63,
      -10.64,
      -1.0650000000000002E+001,
      -1.0660000000000002E+001,
      -1.0670000000000002E+001,
      -1.0680000000000001E+001,
      -1.0690000000000001E+001,
      -1.0700000000000001E+001,
      -10.71,
      -10.72,
      -10.73,
      -10.74,
      -1.0749999999999998E+001,
      -1.0760000000000002E+001,
      -10.77,
      -1.0780000000000001E+001,
      -10.79,
      -10.8,
      -10.81,
      -10.82,
      -10.83,
      -10.84,
      -10.85,
      -1.0860000000000001E+001,
      -1.0870000000000001E+001,
      -10.88,
      -10.89,
      -10.9,
      -10.91,
      -10.92,
      -10.93,
      -10.94,
      -10.95,
      -10.96,
      -10.97,
      -10.98,
      -10.99,
      -1.1000000000000002E+001,
      -11.01,
      -1.1020000000000001E+001,
      -11.03,
      -1.1040000000000001E+001,
      -1.1049999999999999E+001,
      -1.1060000000000002E+001,
      -11.07,
      -1.1080000000000002E+001,
      -11.09,
      -1.1100000000000001E+001,
      -11.11,
      -1.1120000000000001E+001,
      -1.1129999999999999E+001,
      -11.14,
      -1.1149999999999999E+001,
      -1.1160000000000002E+001,
      -11.17,
      -1.1180000000000001E+001,
      -11.19,
      -1.1200000000000001E+001,
      -11.21,
      -11.22,
      -11.23,
      -11.24,
      -11.25,
      -1.1260000000000002E+001,
      -1.1270000000000001E+001,
      -1.1280000000000001E+001,
      -1.1290000000000001E+001,
      -11.3,
      -11.31,
      -11.32,
      -11.33,
      -11.34,
      -11.35,
      -1.1360000000000001E+001,
      -1.1370000000000001E+001,
      -11.38,
      -11.39,
      -1.1400000000000002E+001,
      -11.41,
      -1.1420000000000002E+001,
      -11.43,
      -1.1440000000000001E+001,
      -11.45,
      -1.1460000000000003E+001,
      -11.47,
      -1.1480000000000002E+001,
      -11.49,
      -1.1500000000000002E+001,
      -11.51,
      -1.1520000000000001E+001,
      -11.53,
      -1.1540000000000001E+001,
      -1.1549999999999999E+001,
      -1.1560000000000002E+001,
      -11.57,
      -1.1580000000000002E+001,
      -11.59,
      -1.1600000000000001E+001,
      -1.1610000000000001E+001,
      -1.1620000000000001E+001,
      -11.63,
      -11.64,
      -11.65,
      -1.1660000000000002E+001,
      -1.1670000000000002E+001,
      -1.1680000000000001E+001,
      -1.1690000000000001E+001,
      -1.1700000000000001E+001,
      -11.71,
      -11.72,
      -11.73,
      -11.74,
      -11.75,
      -1.1760000000000002E+001,
      -1.1770000000000001E+001,
      -1.1780000000000001E+001,
      -1.1790000000000001E+001,
      -1.1800000000000002E+001,
      -11.81,
      -1.1820000000000002E+001,
      -11.83,
      -1.1840000000000002E+001,
      -11.85,
      -1.1860000000000003E+001,
      -1.1870000000000001E+001,
      -1.1880000000000003E+001,
      -11.89,
      -1.1900000000000002E+001,
      -11.91,
      -1.1920000000000002E+001,
      -11.93,
      -1.1940000000000001E+001,
      -11.95,
      -1.1960000000000003E+001,
      -11.97,
      -1.1980000000000002E+001,
      -11.99,
      -1.2000000000000002E+001,
      -1.2010000000000002E+001,
      -1.2020000000000001E+001,
      -1.2030000000000001E+001,
      -12.04,
      -12.05,
      -1.2059999999999999E+001,
      -1.2070000000000002E+001,
      -12.08,
      -1.2090000000000002E+001,
      -12.1,
      -1.2110000000000001E+001,
      -12.12,
      -12.13,
      -1.2139999999999999E+001,
      -12.15,
      -1.2159999999999998E+001,
      -1.2170000000000002E+001,
      -12.18,
      -1.2190000000000001E+001,
      -1.2200000000000001E+001,
      -12.21,
      -12.22,
      -12.23,
      -12.24,
      -12.25,
      -12.26,
      -1.2270000000000001E+001,
      -1.2280000000000001E+001,
      -1.2290000000000001E+001,
      -12.3,
      -12.31,
      -12.32,
      -12.33,
      -12.34,
      -12.35,
      -12.36,
      -1.2370000000000001E+001,
      -12.38,
      -1.2390000000000002E+001,
      -12.4,
      -1.2410000000000002E+001,
      -12.42,
      -1.2430000000000001E+001,
      -12.44,
      -1.2450000000000001E+001,
      -1.2459999999999999E+001,
      -1.2470000000000002E+001,
      -12.48,
      -1.2490000000000002E+001,
      -12.5,
      -1.2510000000000002E+001,
      -12.52,
      -1.2530000000000001E+001,
      -12.54,
      -12.55,
      -1.2559999999999999E+001,
      -1.2570000000000002E+001,
      -12.58,
      -1.2590000000000002E+001,
      -1.2600000000000001E+001,
      -1.2610000000000001E+001,
      -1.2620000000000001E+001,
      -12.63,
      -12.64,
      -12.65,
      -12.66,
      -1.2670000000000002E+001,
      -1.2680000000000001E+001,
      -1.2690000000000001E+001,
      -1.2700000000000001E+001,
      -12.71,
      -12.72,
      -12.73,
      -12.74,
      -12.75,
      -12.76,
      -1.2770000000000001E+001,
      -1.2780000000000001E+001,
      -1.2790000000000003E+001,
      -12.8,
      -1.2810000000000002E+001,
      -12.82,
      -1.2830000000000002E+001,
      -12.84,
      -1.2850000000000001E+001,
      -12.86,
      -1.2870000000000003E+001,
      -12.88,
      -1.2890000000000002E+001,
      -12.9,
      -1.2910000000000002E+001,
      -12.92,
      -1.2930000000000001E+001,
      -12.94,
      -1.2950000000000001E+001,
      -1.2959999999999999E+001,
      -1.2970000000000002E+001,
      -12.98,
      -1.2990000000000002E+001,
      -1.3000000000000002E+001,
      -1.3010000000000002E+001,
      -1.3020000000000001E+001,
      -1.3030000000000001E+001,
      -1.3040000000000001E+001,
      -13.05,
      -13.06,
      -1.3070000000000002E+001,
      -1.3080000000000002E+001,
      -1.3090000000000002E+001,
      -1.3100000000000001E+001,
      -1.3110000000000001E+001,
      -1.3120000000000001E+001,
      -13.13,
      -13.14,
      -13.15,
      -13.16,
      -1.3170000000000002E+001,
      -1.3180000000000001E+001,
      -1.3190000000000003E+001,
      -1.3200000000000001E+001,
      -1.3210000000000003E+001,
      -13.22,
      -1.3230000000000002E+001,
      -13.24,
      -1.3250000000000002E+001,
      -13.26,
      -1.3270000000000003E+001,
      -1.3280000000000001E+001,
      -1.3290000000000003E+001,
      -13.3,
      -13.31,
      -13.32,
      -13.33,
      -13.34,
      -13.35,
      -13.36,
      -13.37,
      -13.38,
      -13.39,
      -1.3400000000000002E+001,
      -13.41,
      -1.3420000000000002E+001,
      -13.43,
      -1.3440000000000001E+001,
      -13.45,
      -13.46,
      -1.3469999999999999E+001,
      -1.3480000000000002E+001,
      -13.49,
      -1.3500000000000002E+001,
      -13.51,
      -1.3520000000000001E+001,
      -13.53,
      -1.3540000000000001E+001,
      -1.3549999999999999E+001,
      -13.56,
      -1.3569999999999999E+001,
      -1.3580000000000002E+001,
      -13.59,
      -1.3600000000000001E+001,
      -1.3610000000000001E+001,
      -1.3620000000000001E+001,
      -13.63,
      -13.64,
      -13.65,
      -13.66,
      -13.67,
      -1.3680000000000001E+001,
      -1.3690000000000001E+001,
      -1.3700000000000001E+001,
      -13.71,
      -13.72,
      -13.73,
      -13.74,
      -13.75,
      -13.76,
      -13.77,
      -1.3780000000000001E+001,
      -1.3790000000000001E+001,
      -1.3800000000000002E+001,
      -13.81,
      -1.3820000000000002E+001,
      -13.83,
      -1.3840000000000002E+001,
      -13.85,
      -1.3860000000000001E+001,
      -13.87,
      -1.3880000000000003E+001,
      -13.89,
      -1.3900000000000002E+001,
      -13.91,
      -1.3920000000000002E+001,
      -13.93,
      -1.3940000000000001E+001,
      -13.95,
      -13.96,
      -1.3969999999999999E+001,
      -1.3980000000000002E+001,
      -13.99,
      -1.4000000000000002E+001,
      -1.4010000000000002E+001,
      -1.4020000000000001E+001,
      -1.4030000000000001E+001,
      -1.4040000000000001E+001,
      -14.05,
      -14.06,
      -14.07,
      -1.4080000000000002E+001,
      -1.4090000000000002E+001,
      -1.4100000000000001E+001,
      -1.4110000000000001E+001,
      -1.4120000000000001E+001,
      -14.13,
      -14.14,
      -14.15,
      -14.16,
      -14.17,
      -1.4180000000000003E+001,
      -1.4190000000000001E+001,
      -1.4200000000000003E+001,
      -14.21,
      -1.4220000000000002E+001,
      -14.23,
      -1.4240000000000002E+001,
      -14.25,
      -1.4260000000000002E+001,
      -14.27,
      -1.4280000000000003E+001,
      -1.4290000000000001E+001,
      -1.4300000000000002E+001,
      -14.31,
      -1.4320000000000002E+001,
      -14.33,
      -1.4340000000000002E+001,
      -14.35,
      -1.4360000000000001E+001,
      -14.37,
      -1.4380000000000003E+001,
      -1.4390000000000002E+001,
      -1.4400000000000002E+001,
      -1.4410000000000002E+001,
      -1.4420000000000002E+001,
      -1.4430000000000001E+001,
      -1.4440000000000001E+001,
      -1.4450000000000001E+001,
      -14.46,
      -14.47,
      -1.4480000000000002E+001,
      -1.4490000000000002E+001,
      -1.4500000000000002E+001,
      -1.4510000000000002E+001,
      -1.4520000000000001E+001,
      -1.4530000000000001E+001,
      -1.4540000000000001E+001,
      -14.55,
      -14.56,
      -14.57,
      -1.4579999999999998E+001,
      -1.4590000000000002E+001,
      -1.4600000000000001E+001,
      -1.4610000000000001E+001,
      -1.4620000000000001E+001,
      -14.63,
      -14.64,
      -14.65,
      -14.66,
      -14.67,
      -14.68,
      -1.4690000000000001E+001,
      -1.4700000000000001E+001,
      -14.71,
      -14.72,
      -14.73,
      -14.74,
      -14.75,
      -14.76,
      -14.77,
      -14.78,
      -1.4790000000000003E+001,
      -14.8,
      -1.4810000000000002E+001,
      -14.82,
      -1.4830000000000002E+001,
      -14.84,
      -1.4850000000000001E+001,
      -14.86,
      -1.4870000000000001E+001,
      -1.4879999999999999E+001,
      -1.4890000000000002E+001,
      -14.9,
      -1.4910000000000002E+001,
      -14.92,
      -1.4930000000000001E+001,
      -14.94,
      -1.4950000000000001E+001,
      -1.4959999999999999E+001,
      -14.97,
      -1.4979999999999999E+001,
      -1.4990000000000002E+001,
      -1.5000000000000002E+001,
      -1.5010000000000002E+001,
      -1.5020000000000001E+001,
      -1.5030000000000001E+001,
      -1.5040000000000001E+001,
      -15.05,
      -15.06,
      -15.07,
      -15.08,
      -1.5090000000000002E+001,
      -1.5100000000000001E+001,
      -1.5110000000000001E+001,
      -1.5120000000000001E+001,
      -15.13,
      -15.14,
      -15.15,
      -15.16,
      -15.17,
      -15.18,
      -1.5190000000000003E+001,
      -1.5200000000000001E+001,
      -1.5210000000000003E+001,
      -15.22,
      -1.5230000000000002E+001,
      -15.24,
      -1.5250000000000002E+001,
      -15.26,
      -1.5270000000000001E+001,
      -15.28,
      -1.5290000000000003E+001,
      -15.3,
      -1.5310000000000002E+001,
      -15.32,
      -1.5330000000000002E+001,
      -15.34,
      -1.5350000000000001E+001,
      -15.36,
      -1.5370000000000001E+001,
      -1.5379999999999999E+001,
      -1.5390000000000002E+001,
      -1.5400000000000002E+001,
      -1.5410000000000002E+001,
      -1.5420000000000002E+001,
      -1.5430000000000001E+001,
      -1.5440000000000001E+001,
      -1.5450000000000001E+001,
      -15.46,
      -15.47,
      -15.48,
      -1.5490000000000002E+001,
      -15.5,
      -1.5510000000000002E+001,
      -1.5520000000000001E+001,
      -1.5530000000000001E+001,
      -1.5540000000000001E+001,
      -15.55,
      -15.56,
      -15.57,
      -15.58,
      -15.59,
      -15.6,
      -1.5610000000000003E+001,
      -1.5620000000000001E+001,
      -1.5630000000000003E+001,
      -15.64,
      -1.5650000000000002E+001,
      -15.66,
      -1.5670000000000002E+001,
      -15.68,
      -1.5690000000000001E+001,
      -15.7,
      -1.5710000000000003E+001,
      -15.72,
      -1.5730000000000002E+001,
      -15.74,
      -1.5750000000000002E+001,
      -15.76,
      -1.5770000000000001E+001,
      -15.78,
      -1.5790000000000001E+001,
      -1.5799999999999999E+001,
      -1.5810000000000002E+001,
      -1.5820000000000002E+001,
      -1.5830000000000002E+001,
      -1.5840000000000002E+001,
      -1.5850000000000001E+001,
      -1.5860000000000001E+001,
      -15.87,
      -15.88,
      -1.5889999999999999E+001,
      -15.9,
      -1.5909999999999998E+001,
      -1.5920000000000002E+001,
      -15.93,
      -1.5940000000000001E+001,
      -15.95,
      -15.96,
      -1.5969999999999999E+001,
      -15.98,
      -1.5989999999999998E+001,
      -16.0,
      -1.6009999999999998E+001,
      -1.6020000000000003E+001,
      -16.03,
      -1.6040000000000003E+001,
      -16.05,
      -1.6060000000000002E+001,
      -16.07,
      -1.6080000000000002E+001,
      -16.09,
      -16.1,
      -16.11,
      -16.12,
      -16.13,
      -16.14,
      -16.15,
      -16.16,
      -1.6169999999999998E+001,
      -16.18,
      -1.6189999999999998E+001,
      -16.2,
      -16.21,
      -1.6220000000000002E+001,
      -16.23,
      -1.6240000000000002E+001,
      -16.25,
      -16.26,
      -16.27,
      -16.28,
      -16.29,
      -16.3,
      -16.31,
      -16.32,
      -1.6330000000000002E+001,
      -16.34,
      -16.35,
      -16.36,
      -16.37,
      -16.38,
      -16.39,
      -1.6400000000000002E+001,
      -16.41,
      -16.42,
      -16.43,
      -16.44,
      -16.45,
      -16.46,
      -16.47,
      -16.48,
      -16.49,
      -16.5,
      -1.6509999999999998E+001,
      -1.6520000000000003E+001,
      -16.53,
      -1.6540000000000003E+001,
      -16.55,
      -1.6560000000000002E+001,
      -16.57,
      -1.6580000000000002E+001,
      -16.59,
      -16.6,
      -16.61,
      -16.62,
      -1.6630000000000003E+001,
      -16.64,
      -1.6650000000000002E+001,
      -16.66,
      -16.67,
      -16.68,
      -1.6689999999999998E+001,
      -16.7,
      -16.71,
      -1.6720000000000002E+001,
      -16.73,
      -16.74,
      -16.75,
      -16.76,
      -16.77,
      -1.6779999999999998E+001,
      -16.79,
      -16.8,
      -16.81,
      -1.6820000000000004E+001,
      -1.6830000000000002E+001,
      -16.84,
      -1.6849999999999998E+001,
      -1.6860000000000003E+001,
      -16.87,
      -16.88,
      -1.6889999999999997E+001,
      -1.6900000000000002E+001,
      -16.91,
      -16.92,
      -16.93,
      -16.94,
      -16.95,
      -16.96,
      -16.97,
      -16.98,
      -16.99,
      -17.0,
      -17.01,
      -1.7020000000000003E+001,
      -17.03,
      -17.04,
      -17.05,
      -1.7060000000000002E+001,
      -17.07,
      -17.08,
      -17.09,
      -17.1,
      -17.11,
      -17.12,
      -1.7130000000000003E+001,
      -17.14,
      -17.15,
      -1.7159999999999997E+001,
      -17.17,
      -17.18,
      -17.19,
      -1.7200000000000003E+001,
      -17.21,
      -17.22,
      -17.23,
      -1.7240000000000002E+001,
      -17.25,
      -1.7259999999999998E+001,
      -17.27,
      -17.28,
      -1.7290000000000003E+001,
      -17.3,
      -17.31,
      -17.32,
      -1.7330000000000002E+001,
      -17.34,
      -1.7349999999999998E+001,
      -17.36,
      -17.37,
      -17.38,
      -1.7390000000000004E+001,
      -1.7400000000000002E+001,
      -17.41,
      -1.7419999999999998E+001,
      -1.7430000000000003E+001,
      -17.44,
      -17.45,
      -1.7459999999999997E+001,
      -1.7470000000000002E+001,
      -17.48,
      -1.7490000000000002E+001,
      -17.5,
      -17.51,
      -17.52,
      -17.53,
      -17.54,
      -17.55,
      -17.56,
      -17.57,
      -17.58,
      -1.7590000000000003E+001,
      -17.6,
      -17.61,
      -17.62,
      -1.7630000000000003E+001,
      -17.64,
      -17.65,
      -17.66,
      -17.67,
      -17.68,
      -17.69,
      -1.7700000000000003E+001,
      -17.71,
      -17.72,
      -17.73,
      -1.7740000000000002E+001,
      -17.75,
      -1.7759999999999998E+001,
      -17.77,
      -17.78,
      -1.7790000000000003E+001,
      -17.8,
      -1.7810000000000002E+001,
      -17.82,
      -1.7830000000000002E+001,
      -17.84,
      -17.85,
      -17.86,
      -17.87,
      -17.88,
      -1.7890000000000004E+001,
      -1.7900000000000002E+001,
      -17.91,
      -1.7919999999999998E+001,
      -1.7930000000000003E+001,
      -17.94,
      -17.95,
      -1.7959999999999997E+001,
      -1.7970000000000002E+001,
      -17.98,
      -1.7990000000000002E+001,
      -1.8000000000000004E+001,
      -18.01,
      -18.02,
      -18.03,
      -1.8040000000000003E+001,
      -18.05,
      -18.06,
      -18.07,
      -1.8080000000000002E+001,
      -1.8090000000000003E+001,
      -18.1,
      -18.11,
      -18.12,
      -1.8130000000000003E+001,
      -18.14,
      -18.15,
      -18.16,
      -18.17,
      -18.18,
      -1.8190000000000005E+001,
      -1.8200000000000003E+001,
      -18.21,
      -18.22,
      -1.8230000000000004E+001,
      -1.8240000000000002E+001,
      -18.25,
      -1.8259999999999998E+001,
      -1.8270000000000003E+001,
      -18.28,
      -1.8290000000000003E+001,
      -18.3,
      -1.8310000000000002E+001,
      -18.32,
      -1.8330000000000002E+001,
      -18.34,
      -18.35,
      -18.36,
      -18.37,
      -18.38,
      -1.8390000000000004E+001,
      -1.8400000000000002E+001,
      -18.41,
      -18.42,
      -18.43,
      -18.44,
      -18.45,
      -18.46,
      -18.47,
      -18.48,
      -18.49,
      -1.8500000000000004E+001,
      -18.51,
      -18.52,
      -1.8529999999999998E+001,
      -1.8540000000000003E+001,
      -18.55,
      -18.56,
      -1.8569999999999997E+001,
      -1.8580000000000002E+001,
      -18.59,
      -18.6,
      -1.8610000000000003E+001,
      -18.62,
      -18.63,
      -18.64,
      -1.8650000000000002E+001,
      -18.66,
      -1.8669999999999998E+001,
      -18.68,
      -18.69,
      -1.8700000000000003E+001,
      -18.71,
      -18.72,
      -18.73,
      -1.8740000000000002E+001,
      -18.75,
      -1.8759999999999998E+001,
      -18.77,
      -18.78,
      -18.79,
      -1.8800000000000004E+001,
      -1.8810000000000002E+001,
      -18.82,
      -18.83,
      -1.8840000000000003E+001,
      -18.85,
      -18.86,
      -1.8869999999999997E+001,
      -1.8880000000000003E+001,
      -18.89,
      -1.8900000000000002E+001,
      -18.91,
      -18.92,
      -18.93,
      -18.94,
      -18.95,
      -18.96,
      -18.97,
      -18.98,
      -18.99,
      -1.9000000000000004E+001,
      -19.01,
      -19.02,
      -19.03,
      -1.9040000000000003E+001,
      -19.05,
      -19.06,
      -19.07,
      -1.9080000000000002E+001,
      -19.09,
      -19.1,
      -1.9110000000000003E+001,
      -19.12,
      -19.13,
      -19.14,
      -1.9150000000000002E+001,
      -19.16,
      -1.9169999999999998E+001,
      -19.18,
      -19.19,
      -1.9200000000000003E+001,
      -19.21,
      -1.9220000000000002E+001,
      -19.23,
      -1.9240000000000002E+001,
      -19.25,
      -19.26,
      -19.27,
      -19.28,
      -19.29,
      -1.9300000000000004E+001,
      -1.9310000000000002E+001,
      -19.32,
      -19.33,
      -1.9340000000000003E+001,
      -19.35,
      -19.36,
      -1.9369999999999997E+001,
      -1.9380000000000003E+001,
      -19.39,
      -1.9400000000000002E+001,
      -1.9410000000000004E+001,
      -19.42,
      -19.43,
      -19.44,
      -1.9450000000000003E+001,
      -19.46,
      -19.47,
      -19.48,
      -1.9490000000000002E+001,
      -1.9500000000000004E+001,
      -19.51,
      -19.52,
      -19.53,
      -1.9540000000000003E+001,
      -19.55,
      -19.56,
      -19.57,
      -1.9580000000000002E+001,
      -19.59,
      -1.9600000000000005E+001,
      -1.9610000000000003E+001,
      -19.62,
      -19.63,
      -1.9640000000000004E+001,
      -1.9650000000000002E+001,
      -19.66,
      -1.9669999999999998E+001,
      -1.9680000000000003E+001,
      -19.69,
      -19.7,
      -19.71,
      -1.9720000000000002E+001,
      -19.73,
      -19.74,
      -19.75,
      -19.76,
      -19.77,
      -1.9779999999999998E+001,
      -19.79,
      -19.8,
      -1.9810000000000002E+001,
      -19.82,
      -1.9830000000000002E+001,
      -19.84,
      -19.85,
      -19.86,
      -19.87,
      -19.88,
      -19.89,
      -19.9,
      -1.9910000000000004E+001,
      -19.92,
      -19.93,
      -1.9939999999999998E+001,
      -1.9950000000000003E+001,
      -19.96,
      -19.97,
      -1.9979999999999997E+001,
      -1.9990000000000002E+001,
      -20.0,
      -20.01,
      -2.0020000000000003E+001,
      -20.03,
      -20.04,
      -20.05,
      -2.0060000000000002E+001,
      -20.07,
      -20.08,
      -20.09,
      -20.1,
      -2.0110000000000003E+001,
      -20.12,
      -20.13,
      -20.14,
      -2.0150000000000002E+001,
      -20.16,
      -2.0169999999999998E+001,
      -20.18,
      -20.19,
      -20.2,
      -2.0210000000000004E+001,
      -2.0220000000000002E+001,
      -20.23,
      -20.24,
      -2.0250000000000004E+001,
      -20.26,
      -20.27,
      -2.0279999999999998E+001,
      -2.0290000000000003E+001,
      -20.3,
      -20.31,
      -20.32,
      -2.0330000000000002E+001,
      -20.34,
      -2.0349999999999998E+001,
      -20.36,
      -20.37,
      -20.38,
      -2.0389999999999997E+001,
      -2.0400000000000002E+001,
      -20.41,
      -20.42,
      -20.43,
      -20.44,
      -20.45,
      -20.46,
      -20.47,
      -20.48,
      -20.49,
      -20.5,
      -2.0509999999999998E+001,
      -20.52,
      -20.53,
      -20.54,
      -2.0549999999999997E+001,
      -2.0560000000000002E+001,
      -2.0569999999999997E+001,
      -20.58,
      -2.0589999999999996E+001,
      -2.0599999999999998E+001,
      -2.0610000000000003E+001,
      -20.62,
      -2.0630000000000003E+001,
      -2.0640000000000004E+001,
      -20.65,
      -20.66,
      -20.67,
      -20.68,
      -20.69,
      -20.7,
      -20.71,
      -2.0720000000000002E+001,
      -2.0729999999999997E+001,
      -20.74,
      -20.75,
      -2.0759999999999998E+001,
      -20.77,
      -2.0779999999999998E+001,
      -20.79,
      -2.0800000000000004E+001,
      -2.0809999999999995E+001,
      -2.0820000000000004E+001,
      -2.0830000000000002E+001,
      -20.84,
      -20.85,
      -2.0860000000000003E+001,
      -20.87,
      -2.0880000000000003E+001,
      -2.0889999999999997E+001,
      -2.0900000000000002E+001,
      -20.91,
      -2.0919999999999998E+001,
      -20.93,
      -20.94,
      -20.95,
      -20.96,
      -2.0969999999999995E+001,
      -20.98,
      -20.99,
      -2.0999999999999996E+001,
      -2.1010000000000005E+001,
      -2.1020000000000003E+001,
      -21.03,
      -2.1040000000000003E+001,
      -21.05,
      -2.1060000000000002E+001,
      -21.07,
      -21.08,
      -2.1090000000000003E+001,
      -21.1,
      -21.11,
      -21.12,
      -21.13,
      -21.14,
      -21.15,
      -2.1159999999999997E+001,
      -21.17,
      -21.18,
      -2.1189999999999998E+001,
      -2.1200000000000006E+001,
      -2.1209999999999997E+001,
      -2.1220000000000002E+001,
      -21.23,
      -2.1240000000000002E+001,
      -2.1250000000000004E+001,
      -21.26,
      -21.27,
      -2.1280000000000005E+001,
      -21.29,
      -21.3,
      -21.31,
      -21.32,
      -2.1330000000000002E+001,
      -21.34,
      -2.1349999999999998E+001,
      -2.1360000000000003E+001,
      -2.1369999999999997E+001,
      -21.38,
      -2.1389999999999997E+001,
      -21.4,
      -2.1410000000000004E+001,
      -21.42,
      -2.1430000000000003E+001,
      -2.1440000000000005E+001,
      -21.45,
      -21.46,
      -2.1470000000000002E+001,
      -21.48,
      -2.1490000000000002E+001,
      -21.5,
      -21.51,
      -2.1520000000000003E+001,
      -2.1529999999999998E+001,
      -21.54,
      -21.55,
      -21.56,
      -21.57,
      -2.1579999999999995E+001,
      -21.59,
      -2.1599999999999998E+001,
      -2.1609999999999996E+001,
      -2.1620000000000005E+001,
      -2.1630000000000003E+001,
      -21.64,
      -2.1650000000000002E+001,
      -21.66,
      -21.67,
      -21.68,
      -2.1689999999999998E+001,
      -2.1700000000000003E+001,
      -21.71,
      -21.72,
      -21.73,
      -21.74,
      -21.75,
      -2.1759999999999998E+001,
      -2.1769999999999996E+001,
      -21.78,
      -21.79,
      -2.1799999999999997E+001,
      -2.1810000000000006E+001,
      -2.1819999999999997E+001,
      -2.1830000000000002E+001,
      -21.84,
      -21.85,
      -2.1860000000000003E+001,
      -21.87,
      -21.88,
      -2.1890000000000004E+001,
      -21.9,
      -21.91,
      -2.1919999999999998E+001,
      -21.93,
      -21.94,
      -21.95,
      -2.1959999999999997E+001,
      -2.1970000000000002E+001,
      -2.1979999999999997E+001,
      -21.99,
      -2.1999999999999996E+001,
      -2.2009999999999998E+001,
      -2.2020000000000003E+001,
      -22.03,
      -2.2040000000000003E+001,
      -2.2050000000000004E+001,
      -22.06,
      -22.07,
      -2.2080000000000002E+001,
      -22.09,
      -22.1,
      -22.11,
      -22.12,
      -2.2130000000000003E+001,
      -2.2139999999999997E+001,
      -22.15,
      -22.16,
      -2.2169999999999998E+001,
      -22.18,
      -2.2189999999999998E+001,
      -22.2,
      -2.2210000000000004E+001,
      -2.2219999999999995E+001,
      -2.2230000000000004E+001,
      -2.2240000000000002E+001,
      -22.25,
      -22.26,
      -2.2270000000000003E+001,
      -22.28,
      -2.2290000000000003E+001,
      -2.2299999999999997E+001,
      -2.2310000000000002E+001,
      -22.32,
      -22.33,
      -22.34,
      -22.35,
      -22.36,
      -22.37,
      -2.2379999999999995E+001,
      -22.39,
      -22.4,
      -2.2409999999999997E+001,
      -2.2420000000000005E+001,
      -2.2430000000000003E+001,
      -22.44,
      -2.2450000000000003E+001,
      -22.46,
      -2.2470000000000002E+001,
      -22.48,
      -22.49,
      -2.2500000000000004E+001,
      -22.51,
      -22.52,
      -22.53,
      -22.54,
      -22.55,
      -22.56,
      -2.2569999999999997E+001,
      -2.2580000000000002E+001,
      -22.59,
      -2.2599999999999998E+001,
      -2.2610000000000007E+001,
      -2.2619999999999997E+001,
      -2.2630000000000003E+001,
      -22.64,
      -2.2650000000000002E+001,
      -2.2660000000000004E+001,
      -22.67,
      -22.68,
      -2.2690000000000005E+001,
      -22.7,
      -22.71,
      -22.72,
      -22.73,
      -2.2740000000000002E+001,
      -22.75,
      -2.2759999999999998E+001,
      -2.2770000000000003E+001,
      -2.2779999999999998E+001,
      -22.79,
      -2.2799999999999997E+001,
      -22.81,
      -2.2820000000000004E+001,
      -2.2830000000000002E+001,
      -2.2840000000000003E+001,
      -22.85,
      -22.86,
      -22.87,
      -2.2880000000000003E+001,
      -22.89,
      -2.2900000000000002E+001,
      -2.2909999999999997E+001,
      -22.92,
      -22.93,
      -2.2939999999999998E+001,
      -22.95,
      -22.96,
      -22.97,
      -22.98,
      -2.2989999999999995E+001,
      -23.0,
      -2.3009999999999998E+001,
      -2.3019999999999996E+001,
      -2.3030000000000005E+001,
      -2.3040000000000003E+001,
      -23.05,
      -2.3060000000000002E+001,
      -23.07,
      -2.3080000000000002E+001,
      -23.09,
      -2.3099999999999998E+001,
      -2.3110000000000003E+001,
      -23.12,
      -23.13,
      -23.14,
      -23.15,
      -23.16,
      -2.3169999999999998E+001,
      -2.3179999999999996E+001,
      -23.19,
      -23.2,
      -2.3209999999999997E+001,
      -2.3220000000000006E+001,
      -2.3229999999999997E+001,
      -2.3240000000000002E+001,
      -23.25,
      -23.26,
      -2.3270000000000003E+001,
      -23.28,
      -23.29,
      -2.3300000000000004E+001,
      -23.31,
      -23.32,
      -23.33,
      -23.34,
      -23.35,
      -23.36,
      -2.3369999999999997E+001,
      -2.3380000000000003E+001,
      -2.3389999999999997E+001,
      -23.4,
      -2.3409999999999997E+001,
      -2.3419999999999998E+001,
      -2.3430000000000003E+001,
      -23.44,
      -2.3450000000000003E+001,
      -2.3460000000000004E+001,
      -23.47,
      -23.48,
      -2.3490000000000002E+001,
      -23.5,
      -23.51,
      -23.52,
      -23.53,
      -2.3540000000000003E+001,
      -2.3549999999999997E+001,
      -23.56,
      -23.57,
      -23.58,
      -23.59,
      -2.3599999999999998E+001,
      -23.61,
      -2.3620000000000005E+001,
      -2.3629999999999995E+001,
      -2.3640000000000004E+001,
      -2.3650000000000002E+001,
      -23.66,
      -23.67,
      -2.3680000000000003E+001,
      -23.69,
      -2.3700000000000003E+001,
      -2.3709999999999997E+001,
      -2.3720000000000002E+001,
      -23.73,
      -23.74,
      -23.75,
      -23.76,
      -23.77,
      -23.78,
      -2.3789999999999996E+001,
      -23.8,
      -23.81,
      -2.3819999999999997E+001,
      -2.3830000000000005E+001,
      -2.3840000000000003E+001,
      -23.85,
      -2.3860000000000003E+001,
      -23.87,
      -2.3880000000000003E+001,
      -23.89,
      -23.9,
      -2.3910000000000004E+001,
      -23.92,
      -23.93,
      -23.94,
      -23.95,
      -23.96,
      -23.97,
      -2.3979999999999997E+001,
      -2.3990000000000002E+001,
      -24.0,
      -2.4009999999999998E+001,
      -2.4020000000000007E+001,
      -2.4029999999999998E+001,
      -2.4040000000000003E+001,
      -24.05,
      -2.4060000000000002E+001,
      -2.4070000000000004E+001,
      -2.4080000000000002E+001,
      -24.09,
      -2.4100000000000005E+001,
      -24.11,
      -24.12,
      -24.13,
      -24.14,
      -2.4150000000000002E+001,
      -2.4159999999999997E+001,
      -2.4169999999999998E+001,
      -24.18,
      -2.4189999999999998E+001,
      -24.2,
      -24.21,
      -24.22,
      -2.4230000000000004E+001,
      -2.4239999999999995E+001,
      -2.4250000000000004E+001,
      -24.26,
      -24.27,
      -24.28,
      -2.4290000000000003E+001,
      -24.3,
      -2.4310000000000002E+001,
      -2.4319999999999997E+001,
      -2.4330000000000002E+001,
      -24.34,
      -2.4349999999999998E+001,
      -24.36,
      -24.37,
      -24.38,
      -24.39,
      -2.4399999999999995E+001,
      -24.41,
      -2.4419999999999998E+001,
      -2.4429999999999996E+001,
      -2.4440000000000005E+001,
      -2.4450000000000003E+001,
      -24.46,
      -2.4470000000000002E+001,
      -24.48,
      -2.4490000000000002E+001,
      -24.5,
      -2.4509999999999998E+001,
      -2.4520000000000003E+001,
      -24.53,
      -24.54,
      -24.55,
      -24.56,
      -24.57,
      -24.58,
      -2.4589999999999996E+001,
      -24.6,
      -24.61,
      -2.4619999999999997E+001,
      -2.4630000000000006E+001,
      -2.4639999999999997E+001,
      -2.4650000000000002E+001,
      -24.66,
      -24.67,
      -2.4680000000000003E+001,
      -24.69,
      -24.7,
      -2.4710000000000004E+001,
      -24.72,
      -24.73,
      -24.74,
      -24.75,
      -24.76,
      -24.77,
      -2.4779999999999998E+001,
      -2.4790000000000003E+001,
      -2.4799999999999997E+001,
      -24.81,
      -24.82,
      -24.83,
      -2.4840000000000003E+001,
      -24.85,
      -2.4860000000000003E+001,
      -2.4870000000000005E+001,
      -24.88,
      -24.89,
      -2.4900000000000002E+001,
      -24.91,
      -24.92,
      -24.93,
      -24.94,
      -2.4950000000000003E+001,
      -2.4959999999999997E+001,
      -24.97,
      -24.98,
      -24.99,
      -25.0,
      -25.01,
      -25.02,
      -2.5030000000000005E+001,
      -2.5039999999999996E+001,
      -2.5050000000000004E+001,
      -2.5060000000000002E+001,
      -25.07,
      -2.5080000000000002E+001,
      -2.5090000000000003E+001,
      -25.1,
      -2.5110000000000003E+001,
      -2.5119999999999997E+001,
      -2.5130000000000003E+001,
      -25.14,
      -25.15,
      -25.16,
      -25.17,
      -25.18,
      -25.19,
      -2.5199999999999996E+001,
      -25.21,
      -25.22,
      -2.5229999999999997E+001,
      -2.5240000000000006E+001,
      -2.5250000000000004E+001,
      -25.26,
      -2.5270000000000003E+001,
      -25.28,
      -2.5290000000000003E+001,
      -25.3,
      -25.31,
      -2.5320000000000004E+001,
      -2.5330000000000002E+001,
      -25.34,
      -25.35,
      -25.36,
      -25.37,
      -25.38,
      -2.5389999999999997E+001,
      -2.5400000000000002E+001,
      -25.41,
      -2.5419999999999998E+001,
      -25.43,
      -2.5439999999999998E+001,
      -2.5450000000000003E+001,
      -25.46,
      -2.5470000000000002E+001,
      -2.5480000000000004E+001,
      -25.49,
      -25.5,
      -25.51,
      -25.52,
      -25.53,
      -25.54,
      -25.55,
      -2.5560000000000002E+001,
      -2.5569999999999997E+001,
      -25.58,
      -25.59,
      -2.5599999999999998E+001,
      -25.61,
      -25.62,
      -25.63,
      -2.5640000000000004E+001,
      -2.5649999999999995E+001,
      -2.5660000000000004E+001,
      -25.67,
      -25.68,
      -25.69,
      -2.5700000000000003E+001,
      -25.71,
      -2.5720000000000002E+001,
      -2.5729999999999997E+001,
      -2.5740000000000002E+001,
      -25.75,
      -2.5759999999999998E+001,
      -25.77,
      -25.78,
      -25.79,
      -25.8,
      -2.5809999999999995E+001,
      -25.82,
      -25.83,
      -2.5839999999999996E+001,
      -2.5850000000000005E+001,
      -2.5860000000000003E+001,
      -25.87,
      -2.5880000000000003E+001,
      -25.89,
      -2.5900000000000002E+001,
      -25.91,
      -2.5919999999999998E+001,
      -2.5930000000000003E+001,
      -25.94,
      -25.95,
      -25.96,
      -25.97,
      -25.98,
      -25.99,
      -2.5999999999999996E+001,
      -26.01,
      -26.02,
      -2.6029999999999998E+001,
      -2.6040000000000006E+001,
      -2.6049999999999997E+001,
      -2.6060000000000002E+001,
      -26.07,
      -2.6080000000000002E+001,
      -2.6090000000000003E+001,
      -26.1,
      -26.11,
      -2.6120000000000005E+001,
      -26.13,
      -26.14,
      -26.15,
      -26.16,
      -26.17,
      -26.18,
      -2.6189999999999998E+001,
      -2.6200000000000003E+001,
      -2.6209999999999997E+001,
      -26.22,
      -26.23,
      -26.24,
      -2.6250000000000004E+001,
      -26.26,
      -2.6270000000000003E+001,
      -2.6280000000000005E+001,
      -26.29,
      -26.3,
      -2.6310000000000002E+001,
      -26.32,
      -2.6330000000000002E+001,
      -26.34,
      -26.35,
      -2.6360000000000003E+001,
      -2.6369999999999997E+001,
      -26.38,
      -26.39,
      -26.4,
      -26.41,
      -26.42,
      -26.43,
      -2.6440000000000005E+001,
      -2.6449999999999996E+001,
      -2.6460000000000004E+001,
      -2.6470000000000002E+001,
      -26.48,
      -2.6490000000000002E+001,
      -2.6500000000000004E+001,
      -26.51,
      -2.6520000000000003E+001,
      -2.6529999999999998E+001,
      -2.6540000000000003E+001,
      -26.55,
      -26.56,
      -26.57,
      -2.6580000000000002E+001,
      -26.59,
      -26.6,
      -2.6609999999999996E+001,
      -26.62,
      -26.63,
      -2.6639999999999997E+001,
      -2.6650000000000006E+001,
      -2.6660000000000004E+001,
      -26.67,
      -2.6680000000000003E+001,
      -26.69,
      -2.6700000000000003E+001,
      -26.71,
      -26.72,
      -2.6730000000000004E+001,
      -26.74,
      -26.75,
      -2.6759999999999998E+001,
      -26.77,
      -26.78,
      -26.79,
      -2.6799999999999997E+001,
      -2.6810000000000002E+001,
      -2.6819999999999997E+001,
      -26.83,
      -26.84,
      -2.6849999999999998E+001,
      -2.6860000000000003E+001,
      -26.87,
      -2.6880000000000003E+001,
      -2.6890000000000004E+001,
      -26.9,
      -26.91,
      -26.92,
      -26.93,
      -26.94,
      -26.95,
      -26.96,
      -2.6970000000000002E+001,
      -2.6979999999999997E+001,
      -26.99,
      -27.0,
      -2.7009999999999998E+001,
      -27.02,
      -27.03,
      -27.04,
      -2.7050000000000004E+001,
      -2.7059999999999995E+001,
      -2.7070000000000004E+001,
      -2.7080000000000002E+001,
      -27.09,
      -27.1,
      -2.7110000000000003E+001,
      -27.12,
      -2.7130000000000003E+001,
      -2.7139999999999997E+001,
      -2.7150000000000002E+001,
      -27.16,
      -2.7169999999999998E+001,
      -27.18,
      -27.19,
      -27.2,
      -27.21,
      -2.7219999999999995E+001,
      -27.23,
      -27.24,
      -2.7249999999999996E+001,
      -2.7260000000000005E+001,
      -2.7270000000000003E+001,
      -27.28,
      -2.7290000000000003E+001,
      -27.3,
      -2.7310000000000002E+001,
      -27.32,
      -27.33,
      -2.7340000000000003E+001,
      -27.35,
      -27.36,
      -27.37,
      -27.38,
      -27.39,
      -27.4,
      -2.7409999999999997E+001,
      -27.42,
      -27.43,
      -2.7439999999999998E+001,
      -2.7450000000000006E+001,
      -2.7459999999999997E+001,
      -2.7470000000000002E+001,
      -27.48,
      -2.7490000000000002E+001,
      -2.7500000000000004E+001,
      -27.51,
      -27.52,
      -2.7530000000000005E+001,
      -27.54,
      -27.55,
      -27.56,
      -27.57,
      -2.7580000000000002E+001,
      -27.59,
      -2.7599999999999998E+001,
      -2.7610000000000003E+001,
      -2.7619999999999997E+001,
      -27.63,
      -27.64,
      -27.65,
      -2.7660000000000004E+001,
      -27.67,
      -2.7680000000000003E+001,
      -2.7690000000000005E+001,
      -27.7,
      -27.71,
      -2.7720000000000002E+001,
      -27.73,
      -2.7740000000000002E+001,
      -27.75,
      -27.76,
      -2.7770000000000003E+001,
      -2.7779999999999998E+001,
      -27.79,
      -27.8,
      -27.81,
      -27.82,
      -2.7830000000000002E+001,
      -27.84,
      -2.7850000000000005E+001,
      -2.7859999999999996E+001,
      -2.7870000000000005E+001,
      -2.7880000000000003E+001,
      -27.89,
      -2.7900000000000002E+001,
      -2.7910000000000004E+001,
      -27.92,
      -2.7930000000000003E+001,
      -2.7939999999999998E+001,
      -2.7950000000000003E+001,
      -27.96,
      -27.97,
      -27.98,
      -27.99,
      -28.0,
      -2.8009999999999998E+001,
      -28.02,
      -28.03,
      -28.04,
      -2.8049999999999997E+001,
      -2.8060000000000006E+001,
      -2.8069999999999997E+001,
      -2.8080000000000002E+001,
      -28.09,
      -28.1,
      -2.8110000000000003E+001,
      -28.12,
      -28.13,
      -2.8140000000000004E+001,
      -28.15,
      -28.16,
      -2.8169999999999998E+001,
      -28.18,
      -28.19,
      -28.2,
      -28.21,
      -2.8220000000000002E+001,
      -2.8229999999999997E+001,
      -28.24,
      -28.25,
      -2.8259999999999998E+001,
      -2.8270000000000003E+001,
      -28.28,
      -2.8290000000000003E+001,
      -2.8300000000000004E+001,
      -28.31,
      -28.32,
      -2.8330000000000002E+001,
      -28.34,
      -28.35,
      -28.36,
      -28.37,
      -2.8380000000000003E+001,
      -2.8389999999999997E+001,
      -2.8400000000000002E+001,
      -28.41,
      -2.8419999999999998E+001,
      -28.43,
      -28.44,
      -28.45,
      -2.8460000000000004E+001,
      -2.8469999999999995E+001,
      -2.8480000000000004E+001,
      -2.8490000000000002E+001,
      -28.5,
      -28.51,
      -2.8520000000000003E+001,
      -28.53,
      -2.8540000000000003E+001,
      -2.8549999999999997E+001,
      -2.8560000000000002E+001,
      -28.57,
      -28.58,
      -2.8590000000000003E+001,
      -28.6,
      -28.61,
      -28.62,
      -28.63,
      -28.64,
      -28.65,
      -2.8659999999999997E+001,
      -2.8670000000000005E+001,
      -2.8680000000000003E+001,
      -28.69,
      -2.8700000000000003E+001,
      -28.71,
      -2.8720000000000002E+001,
      -28.73,
      -28.74,
      -2.8750000000000004E+001,
      -28.76,
      -28.77,
      -2.8780000000000005E+001,
      -28.79,
      -28.8,
      -28.81,
      -28.82,
      -2.8830000000000002E+001,
      -28.84,
      -2.8849999999999998E+001,
      -2.8860000000000007E+001,
      -2.8869999999999997E+001,
      -2.8880000000000003E+001,
      -28.89,
      -2.8900000000000002E+001,
      -2.8910000000000004E+001,
      -28.92,
      -28.93,
      -2.8940000000000005E+001,
      -28.95,
      -28.96,
      -28.97,
      -28.98,
      -2.8990000000000002E+001,
      -29.0,
      -29.01,
      -2.9020000000000003E+001,
      -2.9029999999999998E+001,
      -29.04,
      -29.05,
      -29.06,
      -2.9070000000000004E+001,
      -2.9080000000000002E+001,
      -2.9090000000000003E+001,
      -2.9100000000000005E+001,
      -29.11,
      -29.12,
      -2.9130000000000003E+001,
      -29.14,
      -2.9150000000000002E+001,
      -29.16,
      -29.17,
      -2.9180000000000003E+001,
      -2.9189999999999998E+001,
      -2.9200000000000003E+001,
      -29.21,
      -29.22,
      -29.23,
      -2.9240000000000002E+001,
      -29.25,
      -2.9259999999999998E+001,
      -2.9269999999999996E+001,
      -2.9280000000000005E+001,
      -2.9290000000000003E+001,
      -29.3,
      -2.9310000000000002E+001,
      -29.32,
      -2.9330000000000002E+001,
      -29.34,
      -2.9349999999999998E+001,
      -2.9360000000000003E+001,
      -29.37,
      -29.38,
      -2.9390000000000004E+001,
      -29.4,
      -29.41,
      -2.9419999999999998E+001,
      -29.43,
      -29.44,
      -29.45,
      -2.9459999999999997E+001,
      -2.9470000000000006E+001,
      -2.9479999999999997E+001,
      -2.9490000000000002E+001,
      -29.5,
      -29.51,
      -2.9520000000000003E+001,
      -29.53,
      -29.54,
      -2.9550000000000004E+001,
      -2.9560000000000002E+001,
      -29.57,
      -29.58,
      -29.59,
      -29.6,
      -29.61,
      -29.62,
      -2.9630000000000003E+001,
      -29.64,
      -29.65,
      -29.66,
      -2.9669999999999998E+001,
      -2.9680000000000003E+001,
      -29.69,
      -2.9700000000000003E+001,
      -2.9710000000000004E+001,
      -2.9720000000000002E+001,
      -29.73,
      -2.9740000000000002E+001,
      -29.75,
      -29.76,
      -29.77,
      -29.78,
      -2.9790000000000003E+001,
      -29.8,
      -2.9810000000000002E+001,
      -29.82,
      -29.83,
      -29.84,
      -29.85,
      -29.86,
      -2.9870000000000005E+001,
      -2.9880000000000003E+001,
      -2.9890000000000004E+001,
      -2.9900000000000002E+001,
      -29.91,
      -29.92,
      -2.9930000000000003E+001,
      -29.94,
      -29.95,
      -2.9959999999999997E+001,
      -2.9970000000000002E+001,
      -29.98,
      -29.99,
      -3.0000000000000004E+001,
      -30.01,
      -30.02,
      -3.0029999999999998E+001,
      -30.04,
      -30.05,
      -30.06,
      -3.0069999999999997E+001,
      -3.0080000000000005E+001,
      -3.0090000000000003E+001,
      -30.1,
      -30.11,
      -30.12,
      -3.0130000000000003E+001,
      -30.14,
      -30.15,
      -3.0160000000000004E+001,
      -30.17,
      -30.18,
      -3.0189999999999998E+001,
      -30.2,
      -30.21,
      -30.22,
      -30.23,
      -3.0240000000000002E+001,
      -30.25,
      -3.0259999999999998E+001,
      -30.27,
      -3.0279999999999998E+001,
      -3.0290000000000003E+001,
      -30.3,
      -3.0310000000000002E+001,
      -3.0320000000000004E+001,
      -3.0330000000000002E+001,
      -30.34,
      -30.35,
      -30.36,
      -30.37,
      -30.38,
      -30.39,
      -3.0400000000000002E+001,
      -30.41,
      -30.42,
      -30.43,
      -3.0439999999999998E+001,
      -30.45,
      -30.46,
      -30.47,
      -3.0480000000000004E+001,
      -3.0490000000000002E+001,
      -30.5,
      -3.0509999999999998E+001,
      -3.0519999999999996E+001,
      -30.53,
      -3.0540000000000003E+001,
      -30.55,
      -3.0560000000000002E+001,
      -30.57,
      -3.0580000000000002E+001,
      -30.59,
      -3.0599999999999998E+001,
      -3.0610000000000003E+001,
      -30.62,
      -30.63,
      -30.64,
      -3.0650000000000002E+001,
      -30.66,
      -3.0669999999999998E+001,
      -3.0679999999999996E+001,
      -30.69,
      -30.7,
      -3.0709999999999997E+001,
      -3.0720000000000002E+001,
      -3.0730000000000004E+001,
      -3.0740000000000002E+001,
      -30.75,
      -3.0759999999999998E+001,
      -3.0770000000000003E+001,
      -30.78,
      -30.79,
      -3.0800000000000004E+001,
      -3.0810000000000002E+001,
      -30.82,
      -30.83,
      -30.84,
      -30.85,
      -30.86,
      -3.0869999999999997E+001,
      -3.0880000000000003E+001,
      -30.89,
      -30.9,
      -3.0909999999999997E+001,
      -3.0919999999999998E+001,
      -3.0930000000000003E+001,
      -30.94,
      -30.95,
      -3.0960000000000004E+001,
      -3.0970000000000002E+001,
      -30.98,
      -30.99,
      -31.0,
      -31.01,
      -31.02,
      -31.03,
      -3.1040000000000003E+001,
      -31.05,
      -31.06,
      -31.07,
      -31.08,
      -31.09,
      -3.1099999999999998E+001,
      -31.11,
      -3.1120000000000005E+001,
      -3.1130000000000003E+001,
      -31.14,
      -3.1150000000000002E+001,
      -31.16,
      -31.17,
      -31.18,
      -31.19,
      -31.2,
      -3.1209999999999997E+001,
      -3.1220000000000002E+001,
      -31.23,
      -31.24,
      -31.25,
      -31.26,
      -31.27,
      -3.1279999999999998E+001,
      -3.1289999999999996E+001,
      -31.3,
      -31.31,
      -3.1319999999999997E+001,
      -3.1330000000000002E+001,
      -3.1340000000000003E+001,
      -31.35,
      -31.36,
      -3.1369999999999997E+001,
      -3.1380000000000003E+001,
      -31.39,
      -31.4,
      -3.1410000000000004E+001,
      -31.42,
      -31.43,
      -3.1439999999999998E+001,
      -31.45,
      -31.46,
      -31.47,
      -3.1479999999999997E+001,
      -3.1490000000000002E+001,
      -31.5,
      -3.1509999999999998E+001,
      -3.1519999999999996E+001,
      -3.1529999999999998E+001,
      -3.1540000000000003E+001,
      -31.55,
      -31.56,
      -3.1570000000000004E+001,
      -3.1580000000000002E+001,
      -31.59,
      -3.1599999999999998E+001,
      -31.61,
      -31.62,
      -31.63,
      -31.64,
      -3.1650000000000002E+001,
      -31.66,
      -3.1669999999999998E+001,
      -31.68,
      -3.1689999999999998E+001,
      -31.7,
      -3.1709999999999997E+001,
      -31.72,
      -3.1730000000000004E+001,
      -3.1740000000000002E+001,
      -31.75,
      -31.76,
      -31.77,
      -31.78,
      -31.79,
      -31.8,
      -3.1810000000000002E+001,
      -31.82,
      -3.1830000000000002E+001,
      -31.84,
      -3.1849999999999998E+001,
      -31.86,
      -31.87,
      -31.88,
      -31.89,
      -31.9,
      -31.91,
      -3.1919999999999998E+001,
      -3.1929999999999996E+001,
      -31.94,
      -3.1950000000000003E+001,
      -31.96,
      -3.1970000000000002E+001,
      -31.98,
      -3.1990000000000002E+001,
      -32.0,
      -32.01,
      -32.02,
      -32.03,
      -32.04,
      -3.2050000000000004E+001,
      -32.06,
      -32.07,
      -32.08,
      -3.2089999999999996E+001,
      -32.1,
      -32.11,
      -32.12,
      -32.13,
      -32.14,
      -32.15,
      -3.2160000000000004E+001,
      -32.17,
      -32.18,
      -3.2190000000000005E+001,
      -32.2,
      -32.21,
      -32.22,
      -3.2230000000000004E+001,
      -32.24,
      -32.25,
      -32.26,
      -32.27,
      -32.28,
      -32.29,
      -32.3,
      -32.31,
      -32.32,
      -32.33,
      -32.34,
      -32.35,
      -32.36,
      -3.2370000000000005E+001,
      -32.38,
      -32.39,
      -32.4,
      -32.41,
      -32.42,
      -32.43,
      -32.44,
      -32.45,
      -32.46,
      -32.47,
      -32.48,
      -3.2489999999999995E+001,
      -32.5,
      -32.51,
      -3.2519999999999996E+001,
      -3.2529999999999994E+001,
      -32.54,
      -3.2550000000000004E+001,
      -32.56,
      -32.57,
      -3.2580000000000005E+001,
      -32.59,
      -32.6,
      -32.61,
      -32.62,
      -32.63,
      -32.64,
      -32.65,
      -3.2660000000000004E+001,
      -32.67,
      -32.68,
      -32.69,
      -3.2699999999999996E+001,
      -32.71,
      -32.72,
      -32.73,
      -32.74,
      -32.75,
      -32.76,
      -32.77,
      -32.78,
      -32.79,
      -3.2800000000000004E+001,
      -32.81,
      -32.82,
      -32.83,
      -32.84,
      -32.85,
      -32.86,
      -32.87,
      -32.88,
      -32.89,
      -32.9,
      -32.91,
      -32.92,
      -32.93,
      -32.94,
      -32.95,
      -32.96,
      -32.97,
      -3.2980000000000004E+001,
      -32.99,
      -33.0,
      -33.01,
      -3.3019999999999996E+001,
      -33.03,
      -33.04,
      -33.05,
      -33.06,
      -33.07,
      -33.08,
      -3.3089999999999996E+001,
      -3.3099999999999994E+001,
      -33.11,
      -33.12,
      -3.3129999999999995E+001,
      -33.14,
      -3.3150000000000006E+001,
      -3.3160000000000004E+001,
      -33.17,
      -33.18,
      -3.3190000000000005E+001,
      -33.2,
      -33.21,
      -3.3220000000000006E+001,
      -3.3230000000000004E+001,
      -33.24,
      -33.25,
      -33.26,
      -33.27,
      -33.28,
      -33.29,
      -3.3300000000000004E+001,
      -33.31,
      -33.32,
      -33.33,
      -3.3339999999999996E+001,
      -33.35,
      -33.36,
      -33.37,
      -33.38,
      -33.39,
      -33.4,
      -3.3410000000000004E+001,
      -33.42,
      -33.43,
      -33.44,
      -3.3449999999999996E+001,
      -33.46,
      -33.47,
      -33.48,
      -33.49,
      -33.5,
      -33.51,
      -3.3519999999999996E+001,
      -3.3529999999999994E+001,
      -33.54,
      -33.55,
      -3.3559999999999995E+001,
      -33.57,
      -33.58,
      -33.59,
      -33.6,
      -33.61,
      -33.62,
      -3.3629999999999995E+001,
      -33.64,
      -33.65,
      -33.66,
      -33.67,
      -33.68,
      -33.69,
      -3.3699999999999996E+001,
      -3.3709999999999994E+001,
      -33.72,
      -33.73,
      -3.3739999999999995E+001,
      -33.75,
      -33.76,
      -3.3769999999999996E+001,
      -3.3779999999999994E+001,
      -3.3789999999999992E+001,
      -3.3800000000000004E+001,
      -33.81,
      -33.82,
      -33.83,
      -3.3839999999999996E+001,
      -3.3849999999999994E+001,
      -3.3859999999999992E+001,
      -33.87,
      -33.88,
      -33.89,
      -33.9,
      -33.91,
      -3.3919999999999995E+001,
      -3.3929999999999993E+001,
      -3.3939999999999991E+001,
      -3.3949999999999996E+001,
      -33.96,
      -33.97,
      -33.98,
      -3.3989999999999995E+001,
      -3.3999999999999993E+001,
      -3.4009999999999991E+001,
      -3.4019999999999989E+001,
      -3.4029999999999994E+001,
      -34.04,
      -34.05,
      -3.4059999999999995E+001,
      -34.07,
      -34.08,
      -3.4089999999999996E+001,
      -34.1,
      -34.11,
      -34.12,
      -3.4129999999999995E+001,
      -3.4139999999999993E+001,
      -34.15,
      -34.16,
      -3.4169999999999995E+001,
      -34.18,
      -34.19,
      -3.4199999999999996E+001,
      -3.4209999999999994E+001,
      -3.4219999999999992E+001,
      -34.23,
      -3.4239999999999995E+001,
      -34.25,
      -34.26,
      -3.4269999999999996E+001,
      -34.28,
      -34.29,
      -34.3,
      -3.4309999999999995E+001,
      -3.4319999999999993E+001,
      -34.33,
      -3.4339999999999996E+001,
      -3.4349999999999994E+001,
      -34.36,
      -34.37,
      -3.4379999999999995E+001,
      -3.4389999999999993E+001,
      -3.4399999999999991E+001,
      -34.41,
      -3.4419999999999995E+001,
      -3.4429999999999993E+001,
      -34.44,
      -3.4449999999999996E+001,
      -3.4459999999999994E+001,
      -34.47,
      -3.4480000000000004E+001,
      -34.49,
      -34.5,
      -34.51,
      -3.4519999999999996E+001,
      -3.4529999999999994E+001,
      -3.4539999999999992E+001,
      -34.55,
      -34.56,
      -34.57,
      -34.58,
      -3.4589999999999996E+001,
      -3.4599999999999994E+001,
      -3.4609999999999992E+001,
      -3.4619999999999990E+001,
      -34.63,
      -34.64,
      -34.65,
      -34.66,
      -3.4669999999999995E+001,
      -34.68,
      -34.69,
      -3.4699999999999996E+001,
      -34.71,
      -34.72,
      -34.73,
      -3.4739999999999995E+001,
      -3.4749999999999993E+001,
      -34.76,
      -3.4769999999999996E+001,
      -3.4779999999999994E+001,
      -34.79,
      -34.8,
      -3.4809999999999995E+001,
      -3.4819999999999993E+001,
      -3.4829999999999991E+001,
      -3.4839999999999996E+001,
      -3.4849999999999994E+001,
      -34.86,
      -34.87,
      -34.88,
      -34.89,
      -34.9,
      -34.91,
      -3.4919999999999995E+001,
      -3.4929999999999993E+001,
      -34.94,
      -3.4949999999999996E+001,
      -34.96,
      -34.97,
      -34.98,
      -3.4989999999999995E+001,
      -3.4999999999999993E+001,
      -3.5009999999999991E+001,
      -3.5019999999999996E+001,
      -3.5029999999999994E+001,
      -35.04,
      -35.05,
      -3.5059999999999995E+001,
      -3.5069999999999993E+001,
      -35.08,
      -35.09,
      -35.1,
      -35.11,
      -35.12,
      -3.5129999999999995E+001,
      -3.5139999999999993E+001,
      -3.5149999999999991E+001,
      -35.16,
      -35.17,
      -35.18,
      -35.19,
      -3.5199999999999996E+001,
      -3.5209999999999994E+001,
      -3.5219999999999992E+001,
      -3.5229999999999990E+001,
      -35.24,
      -35.25,
      -35.26,
      -3.5269999999999996E+001,
      -35.28,
      -35.29,
      -35.3,
      -3.5309999999999995E+001,
      -35.32,
      -35.33,
      -3.5339999999999996E+001,
      -3.5349999999999994E+001,
      -3.5359999999999992E+001,
      -35.37,
      -3.5379999999999995E+001,
      -3.5389999999999993E+001,
      -35.4,
      -35.41,
      -3.5419999999999995E+001,
      -3.5429999999999993E+001,
      -3.5439999999999991E+001,
      -3.5449999999999996E+001,
      -3.5459999999999994E+001,
      -35.47,
      -3.5480000000000004E+001,
      -35.49,
      -35.5,
      -35.51,
      -3.5519999999999996E+001,
      -3.5529999999999994E+001,
      -3.5539999999999992E+001,
      -35.55,
      -35.56,
      -35.57,
      -35.58,
      -3.5589999999999996E+001,
      -3.5599999999999994E+001,
      -3.5609999999999992E+001,
      -3.5619999999999990E+001,
      -3.5629999999999995E+001,
      -35.64,
      -35.65,
      -35.66,
      -3.5669999999999995E+001,
      -3.5679999999999993E+001,
      -35.69,
      -35.7,
      -35.71,
      -35.72,
      -35.73,
      -3.5739999999999995E+001,
      -3.5749999999999993E+001,
      -3.5759999999999991E+001,
      -3.5769999999999996E+001,
      -35.78,
      -35.79,
      -35.8,
      -3.5809999999999995E+001,
      -3.5819999999999993E+001,
      -3.5829999999999991E+001,
      -3.5839999999999989E+001,
      -35.85,
      -35.86,
      -35.87,
      -35.88,
      -35.89,
      -35.9,
      -35.91,
      -3.5919999999999995E+001,
      -35.93,
      -35.94,
      -3.5949999999999996E+001,
      -35.96,
      -35.97,
      -35.98,
      -3.5989999999999995E+001,
      -3.5999999999999993E+001,
      -36.01,
      -3.6019999999999996E+001,
      -3.6029999999999994E+001,
      -3.6039999999999992E+001,
      -36.05,
      -3.6059999999999995E+001,
      -3.6069999999999993E+001,
      -36.08,
      -36.09,
      -36.1,
      -36.11,
      -36.12,
      -3.6129999999999995E+001,
      -3.6139999999999993E+001,
      -3.6149999999999991E+001,
      -36.16,
      -36.17,
      -36.18,
      -36.19,
      -3.6199999999999996E+001,
      -3.6209999999999994E+001,
      -3.6219999999999992E+001,
      -3.6229999999999990E+001,
      -3.6239999999999995E+001,
      -36.25,
      -36.26,
      -3.6269999999999996E+001,
      -3.6279999999999994E+001,
      -36.29,
      -36.3,
      -36.31,
      -36.32,
      -36.33,
      -3.6339999999999996E+001,
      -3.6349999999999994E+001,
      -3.6359999999999992E+001,
      -36.37,
      -3.6379999999999995E+001,
      -36.39,
      -36.4,
      -36.41,
      -3.6419999999999995E+001,
      -3.6429999999999993E+001,
      -3.6439999999999991E+001,
      -3.6449999999999996E+001,
      -36.46,
      -36.47,
      -36.48,
      -36.49,
      -36.5,
      -36.51,
      -3.6519999999999996E+001,
      -3.6529999999999994E+001,
      -36.54,
      -36.55,
      -3.6559999999999995E+001,
      -36.57,
      -36.58,
      -3.6589999999999996E+001,
      -3.6599999999999994E+001,
      -3.6609999999999992E+001,
      -36.62,
      -3.6629999999999995E+001,
      -3.6639999999999993E+001,
      -36.65,
      -36.66,
      -3.6669999999999995E+001,
      -3.6679999999999993E+001,
      -36.69,
      -36.7,
      -36.71,
      -36.72,
      -36.73,
      -3.6739999999999995E+001,
      -3.6749999999999993E+001,
      -3.6759999999999991E+001,
      -3.6769999999999996E+001,
      -36.78,
      -36.79,
      -36.8,
      -3.6809999999999995E+001,
      -3.6819999999999993E+001,
      -3.6829999999999991E+001,
      -3.6839999999999989E+001,
      -3.6849999999999994E+001,
      -36.86,
      -36.87,
      -3.6879999999999995E+001,
      -36.89,
      -36.9,
      -36.91,
      -36.92,
      -36.93,
      -36.94,
      -3.6949999999999996E+001,
      -3.6959999999999994E+001,
      -36.97,
      -36.98,
      -3.6989999999999995E+001,
      -37.0,
      -37.01,
      -3.7019999999999996E+001,
      -3.7029999999999994E+001,
      -3.7039999999999992E+001,
      -37.05,
      -3.7059999999999995E+001,
      -37.07,
      -37.08,
      -3.7089999999999996E+001,
      -37.1,
      -37.11,
      -37.12,
      -3.7129999999999995E+001,
      -3.7139999999999993E+001,
      -37.15,
      -37.16,
      -3.7169999999999995E+001,
      -37.18,
      -37.19,
      -3.7199999999999996E+001,
      -3.7209999999999994E+001,
      -3.7219999999999992E+001,
      -37.23,
      -3.7239999999999995E+001,
      -3.7249999999999993E+001,
      -37.26,
      -3.7269999999999996E+001,
      -3.7279999999999994E+001,
      -3.7289999999999992E+001,
      -3.7300000000000004E+001,
      -37.31,
      -37.32,
      -37.33,
      -3.7339999999999996E+001,
      -3.7349999999999994E+001,
      -3.7359999999999992E+001,
      -3.7369999999999990E+001,
      -37.38,
      -37.39,
      -37.4,
      -37.41,
      -3.7419999999999995E+001,
      -3.7429999999999993E+001,
      -3.7439999999999991E+001,
      -3.7449999999999989E+001,
      -37.46,
      -37.47,
      -37.48,
      -3.7489999999999995E+001,
      -37.5,
      -37.51,
      -3.7519999999999996E+001,
      -37.53,
      -37.54,
      -37.55,
      -3.7559999999999995E+001,
      -3.7569999999999993E+001,
      -37.58,
      -3.7589999999999996E+001,
      -3.7599999999999994E+001,
      -37.61,
      -37.62,
      -3.7629999999999995E+001,
      -3.7639999999999993E+001,
      -3.7649999999999991E+001,
      -37.66,
      -3.7669999999999995E+001,
      -37.68,
      -37.69,
      -37.7,
      -37.71,
      -37.72,
      -37.73,
      -3.7739999999999995E+001,
      -3.7749999999999993E+001,
      -37.76,
      -3.7769999999999996E+001,
      -37.78,
      -37.79,
      -37.8,
      -3.7809999999999995E+001,
      -3.7819999999999993E+001,
      -3.7829999999999991E+001,
      -3.7839999999999996E+001,
      -3.7849999999999994E+001,
      -37.86,
      -37.87,
      -3.7879999999999995E+001,
      -3.7889999999999993E+001,
      -37.9,
      -3.7910000000000004E+001,
      -37.92,
      -37.93,
      -37.94,
      -3.7949999999999996E+001,
      -3.7959999999999994E+001,
      -3.7969999999999992E+001,
      -37.98,
      -37.99,
      -38.0,
      -38.01,
      -3.8019999999999996E+001,
      -3.8029999999999994E+001,
      -3.8039999999999992E+001,
      -3.8049999999999990E+001,
      -38.06,
      -38.07,
      -38.08,
      -3.8089999999999996E+001,
      -3.8099999999999994E+001,
      -38.11,
      -38.12,
      -3.8129999999999995E+001,
      -38.14,
      -38.15,
      -38.16,
      -3.8169999999999995E+001,
      -3.8179999999999993E+001,
      -38.19,
      -3.8199999999999996E+001,
      -3.8209999999999994E+001,
      -38.22,
      -38.23,
      -3.8239999999999995E+001,
      -3.8249999999999993E+001,
      -3.8259999999999991E+001,
      -3.8269999999999996E+001,
      -3.8279999999999994E+001,
      -38.29,
      -38.3,
      -38.31,
      -38.32,
      -38.33,
      -3.8339999999999996E+001,
      -3.8349999999999994E+001,
      -3.8359999999999992E+001,
      -38.37,
      -3.8379999999999995E+001,
      -38.39,
      -38.4,
      -38.41,
      -3.8419999999999995E+001,
      -3.8429999999999993E+001,
      -3.8439999999999991E+001,
      -3.8449999999999996E+001,
      -3.8459999999999994E+001,
      -38.47,
      -38.48,
      -3.8489999999999995E+001,
      -3.8499999999999993E+001,
      -38.51,
      -38.52,
      -38.53,
      -38.54,
      -38.55,
      -3.8559999999999995E+001,
      -3.8569999999999993E+001,
      -3.8579999999999991E+001,
      -3.8589999999999996E+001,
      -38.6,
      -38.61,
      -38.62,
      -3.8629999999999995E+001,
      -3.8639999999999993E+001,
      -3.8649999999999991E+001,
      -3.8659999999999989E+001,
      -38.67,
      -38.68,
      -38.69,
      -3.8699999999999996E+001,
      -38.71,
      -38.72,
      -38.73,
      -3.8739999999999995E+001,
      -38.75,
      -38.76,
      -3.8769999999999996E+001,
      -3.8779999999999994E+001,
      -38.79,
      -38.8,
      -3.8809999999999995E+001,
      -3.8819999999999993E+001,
      -38.83,
      -3.8839999999999996E+001,
      -3.8849999999999994E+001,
      -3.8859999999999992E+001,
      -38.87,
      -3.8879999999999995E+001,
      -3.8889999999999993E+001,
      -38.9,
      -3.8910000000000004E+001,
      -38.92,
      -38.93,
      -38.94,
      -3.8949999999999996E+001,
      -3.8959999999999994E+001,
      -3.8969999999999992E+001,
      -38.98,
      -38.99,
      -39.0,
      -39.01,
      -3.9019999999999996E+001,
      -3.9029999999999994E+001,
      -3.9039999999999992E+001,
      -3.9049999999999990E+001,
      -3.9059999999999995E+001,
      -39.07,
      -39.08,
      -3.9089999999999996E+001,
      -3.9099999999999994E+001,
      -39.11,
      -39.12,
      -39.13,
      -39.14,
      -39.15,
      -39.16,
      -3.9169999999999995E+001,
      -3.9179999999999993E+001,
      -39.19,
      -3.9199999999999996E+001,
      -39.21,
      -39.22,
      -39.23,
      -3.9239999999999995E+001,
      -3.9249999999999993E+001,
      -3.9259999999999991E+001,
      -3.9269999999999996E+001,
      -39.28,
      -39.29,
      -39.3,
      -39.31,
      -39.32,
      -39.33,
      -3.9339999999999996E+001,
      -3.9349999999999994E+001,
      -39.36,
      -39.37,
      -3.9379999999999995E+001,
      -39.39,
      -39.4,
      -39.41,
      -3.9419999999999995E+001,
      -3.9429999999999993E+001,
      -39.44,
      -3.9449999999999996E+001,
      -3.9459999999999994E+001,
      -39.47,
      -39.48,
      -3.9489999999999995E+001,
      -3.9499999999999993E+001,
      -3.9509949999999996E+001,
      -39.5198,
      -3.9529549999999993E+001,
      -39.5392,
      -3.9548749999999991E+001,
      -39.5582,
      -3.9567549999999990E+001,
      -39.5768,
      -39.58595,
      -39.595,
      -39.60395,
      -39.6128,
      -39.62155,
      -3.9630199999999995E+001,
      -3.9638749999999995E+001,
      -39.6472,
      -3.9655549999999991E+001,
      -39.6638,
      -3.9671949999999995E+001,
      -39.68,
      -39.68795,
      -3.9695799999999991E+001,
      -3.9703549999999993E+001,
      -3.9711199999999991E+001,
      -39.71875,
      -3.9726199999999992E+001,
      -3.9733549999999994E+001,
      -3.9740799999999993E+001,
      -3.9747949999999996E+001,
      -3.9754999999999995E+001,
      -39.76195,
      -39.7688,
      -3.9775549999999996E+001,
      -3.9782199999999996E+001,
      -3.9788749999999993E+001,
      -3.9795199999999994E+001,
      -3.9801549999999992E+001,
      -3.9807799999999993E+001,
      -39.81395,
      -39.82,
      -3.9825949999999992E+001,
      -3.9831799999999994E+001,
      -3.9837549999999993E+001,
      -3.9843199999999996E+001,
      -3.9848749999999995E+001,
      -39.8542,
      -39.85955,
      -3.9864799999999995E+001,
      -3.9869949999999996E+001,
      -3.9874999999999993E+001,
      -39.87995,
      -39.8848,
      -3.9889549999999993E+001,
      -39.8942,
      -39.89875,
      -39.9032,
      -3.9907549999999993E+001,
      -3.9911799999999992E+001,
      -3.9915949999999995E+001,
      -3.9919999999999995E+001,
      -39.92395,
      -39.9278,
      -3.9931549999999994E+001,
      -3.9935199999999995E+001,
      -3.9938749999999992E+001,
      -3.9942199999999993E+001,
      -39.94555,
      -3.9948799999999991E+001,
      -39.95195,
      -3.9954999999999991E+001,
      -39.95795,
      -39.9608,
      -39.96355,
      -39.9662,
      -39.96875,
      -3.9971199999999996E+001,
      -3.9973549999999996E+001,
      -3.9975799999999992E+001,
      -39.97795,
      -39.98,
      -3.9981949999999991E+001,
      -3.9983799999999995E+001,
      -3.9985549999999996E+001,
      -3.9987199999999994E+001,
      -3.9988749999999996E+001,
      -39.9902,
      -39.99155,
      -3.9992799999999995E+001,
      -39.99395,
      -39.995,
      -3.9995949999999993E+001,
      -3.9996799999999993E+001,
      -39.99755,
      -3.9998199999999990E+001,
      -3.9998749999999994E+001,
      -39.9992,
      -39.99955,
      -3.9999799999999993E+001,
      -3.9999949999999991E+001
    };

    rtDWork.From_Workspace_a_PWORK.TimePtr = (void *) pTimeValues;
    rtDWork.From_Workspace_a_PWORK.DataPtr = (void *) pDataValues;
  }
  {
    /* FromWorkspace Block: <Root>/From Workspace */

    static real_T pDataValues[] = {
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      -4.9999999999999989E-005,
      -1.9999999999999996E-004,
      -4.4999999999999993E-004,
      -7.9999999999999982E-004,
      -0.00125,
      -1.7999999999999997E-003,
      -0.00245,
      -3.1999999999999993E-003,
      -4.0500000000000006E-003,
      -0.005,
      -6.0499999999999990E-003,
      -7.1999999999999989E-003,
      -8.4500000000000009E-003,
      -0.0098,
      -0.01125,
      -1.2799999999999997E-002,
      -0.01445,
      -1.6200000000000003E-002,
      -1.8049999999999997E-002,
      -0.02,
      -0.02205,
      -2.4199999999999996E-002,
      -2.6449999999999994E-002,
      -2.8799999999999996E-002,
      -3.1250000000000007E-002,
      -3.3800000000000004E-002,
      -3.6449999999999996E-002,
      -0.0392,
      -0.04205,
      -0.045,
      -4.8049999999999989E-002,
      -5.1199999999999989E-002,
      -0.05445,
      -0.0578,
      -0.06125,
      -6.4800000000000010E-002,
      -6.8449999999999983E-002,
      -7.2199999999999986E-002,
      -7.6049999999999993E-002,
      -0.08,
      -0.08405,
      -0.0882,
      -9.2450000000000018E-002,
      -9.6799999999999983E-002,
      -1.0124999999999998E-001,
      -1.0579999999999998E-001,
      -1.1044999999999999E-001,
      -1.1519999999999998E-001,
      -0.12005,
      -1.2500000000000003E-001,
      -0.13005,
      -1.3520000000000001E-001,
      -1.4045000000000002E-001,
      -0.1458,
      -1.5125000000000002E-001,
      -0.1568,
      -1.6244999999999998E-001,
      -0.1682,
      -0.17405,
      -1.8000000000000002E-001,
      -1.8605000000000002E-001,
      -0.1922,
      -0.19845,
      -2.0479999999999995E-001,
      -0.21125,
      -0.2178,
      -0.22445,
      -0.2312,
      -2.3804999999999998E-001,
      -0.245,
      -2.5205000000000005E-001,
      -2.5920000000000004E-001,
      -0.26645,
      -2.7380000000000004E-001,
      -2.8125000000000006E-001,
      -2.8880000000000006E-001,
      -2.9645000000000010E-001,
      -3.0419999999999997E-001,
      -3.1204999999999994E-001,
      -0.32,
      -3.2804999999999995E-001,
      -0.3362,
      -3.4445000000000003E-001,
      -0.3528,
      -0.36125,
      -3.6980000000000007E-001,
      -3.7845000000000006E-001,
      -3.8720000000000004E-001,
      -0.39605,
      -4.0499999999999992E-001,
      -0.41405,
      -4.2319999999999991E-001,
      -0.43245,
      -4.4179999999999997E-001,
      -4.5124999999999993E-001,
      -4.6079999999999993E-001,
      -0.47045,
      -0.4802,
      -0.49005,
      -0.5,
      -0.51,
      -0.52,
      -0.53,
      -0.54,
      -0.55,
      -5.5999999999999994E-001,
      -5.7000000000000006E-001,
      -0.58,
      -5.9000000000000008E-001,
      -0.6,
      -0.61,
      -0.62,
      -0.63,
      -0.64,
      -0.65,
      -6.5999999999999992E-001,
      -0.67,
      -0.68,
      -6.9000000000000006E-001,
      -0.7,
      -0.71,
      -0.72,
      -0.73,
      -0.74,
      -0.75,
      -0.76,
      -0.77,
      -7.7999999999999992E-001,
      -0.79,
      -0.8,
      -8.0999999999999994E-001,
      -0.82,
      -0.83,
      -8.4000000000000008E-001,
      -8.5000000000000009E-001,
      -0.86,
      -0.87,
      -0.88,
      -8.9000000000000012E-001,
      -0.9,
      -9.0999999999999992E-001,
      -0.92,
      -0.93,
      -0.94,
      -0.95,
      -0.96,
      -9.7000000000000008E-001,
      -0.98,
      -0.99,
      -1.0,
      -1.01,
      -1.02,
      -1.03,
      -1.04,
      -1.05,
      -1.0599999999999998E+000,
      -1.07,
      -1.08,
      -1.09,
      -1.1,
      -1.1099999999999999E+000,
      -1.12,
      -1.1300000000000001E+000,
      -1.14,
      -1.1500000000000001E+000,
      -1.16,
      -1.17,
      -1.1800000000000002E+000,
      -1.19,
      -1.2000000000000002E+000,
      -1.21,
      -1.22,
      -1.2300000000000002E+000,
      -1.24,
      -1.2500000000000002E+000,
      -1.26,
      -1.27,
      -1.2800000000000002E+000,
      -1.29,
      -1.3,
      -1.31,
      -1.3199999999999998E+000,
      -1.3300000000000003E+000,
      -1.34,
      -1.35,
      -1.36,
      -1.3699999999999999E+000,
      -1.3800000000000003E+000,
      -1.3900000000000001E+000,
      -1.4,
      -1.41,
      -1.42,
      -1.43,
      -1.4400000000000002E+000,
      -1.45,
      -1.46,
      -1.47,
      -1.48,
      -1.4900000000000002E+000,
      -1.5,
      -1.50995,
      -1.5197999999999998E+000,
      -1.52955,
      -1.5392,
      -1.5487499999999998E+000,
      -1.5582,
      -1.56755,
      -1.5768,
      -1.58595,
      -1.595,
      -1.60395,
      -1.6128,
      -1.6215499999999998E+000,
      -1.6302,
      -1.63875,
      -1.6472000000000002E+000,
      -1.65555,
      -1.6638000000000002E+000,
      -1.6719499999999998E+000,
      -1.6800000000000002E+000,
      -1.6879499999999998E+000,
      -1.6958,
      -1.7035500000000001E+000,
      -1.7112,
      -1.71875,
      -1.7262,
      -1.73355,
      -1.7408000000000001E+000,
      -1.7479500000000001E+000,
      -1.755,
      -1.76195,
      -1.7688000000000001E+000,
      -1.7755500000000002E+000,
      -1.7822,
      -1.78875,
      -1.7952000000000001E+000,
      -1.80155,
      -1.8078,
      -1.81395,
      -1.8199999999999998E+000,
      -1.8259500000000002E+000,
      -1.8318,
      -1.8375499999999998E+000,
      -1.8432,
      -1.84875,
      -1.8541999999999998E+000,
      -1.8595500000000003E+000,
      -1.8648,
      -1.86995,
      -1.8749999999999998E+000,
      -1.87995,
      -1.8848,
      -1.88955,
      -1.8942,
      -1.89875,
      -1.9031999999999998E+000,
      -1.90755,
      -1.9118000000000002E+000,
      -1.91595,
      -1.92,
      -1.92395,
      -1.9278,
      -1.93155,
      -1.9352,
      -1.93875,
      -1.9422,
      -1.9455500000000001E+000,
      -1.9488,
      -1.95195,
      -1.955,
      -1.95795,
      -1.9608,
      -1.9635500000000001E+000,
      -1.9662,
      -1.9687500000000002E+000,
      -1.9712,
      -1.97355,
      -1.9758,
      -1.97795,
      -1.9800000000000002E+000,
      -1.9819499999999999E+000,
      -1.9838,
      -1.9855500000000001E+000,
      -1.9872,
      -1.98875,
      -1.9902,
      -1.9915500000000002E+000,
      -1.9928000000000001E+000,
      -1.99395,
      -1.995,
      -1.9959500000000001E+000,
      -1.9968000000000001E+000,
      -1.99755,
      -1.9982,
      -1.99875,
      -1.9992,
      -1.99955,
      -1.9998,
      -1.99995,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0001052754339352E+000,
      -2.0004210975796477E+000,
      -2.0009474539690193E+000,
      -2.0016843238224005E+000,
      -2.0026316780494318E+000,
      -2.0037894792501909E+000,
      -2.0051576817166685E+000,
      -2.0067362314345734E+000,
      -2.0085250660854665E+000,
      -2.0105241150492179E+000,
      -2.0127332994067983E+000,
      -2.0151525319433929E+000,
      -2.0177817171518408E+000,
      -2.0206207512364136E+000,
      -2.0236695221169065E+000,
      -2.0269279094330654E+000,
      -2.0303957845493392E+000,
      -2.0340730105599549E+000,
      -2.0379594422943264E+000,
      -2.0420549263227850E+000,
      -2.0463593009626311E+000,
      -2.0508723962845274E+000,
      -2.0555940341191943E+000,
      -2.0605240280644588E+000,
      -2.0656621834925986E+000,
      -2.0710082975580368E+000,
      -2.0765621592053436E+000,
      -2.0823235491775711E+000,
      -2.0882922400249084E+000,
      -2.0944679961136599E+000,
      -2.1008505736355514E+000,
      -2.1074397206173501E+000,
      -2.1142351769308161E+000,
      -2.1212366743029678E+000,
      -2.1284439363266796E+000,
      -2.1358566784715891E+000,
      -2.1434746080953251E+000,
      -2.1512974244550724E+000,
      -2.1593248187194352E+000,
      -2.1675564739806346E+000,
      -2.1759920652670131E+000,
      -2.1846312595558710E+000,
      -2.1934737157866149E+000,
      -2.2025190848742078E+000,
      -2.2117670097229705E+000,
      -2.2212171252406607E+000,
      -2.2308690583529041E+000,
      -2.2407224280179032E+000,
      -2.2507768452414996E+000,
      -2.2610319130925141E+000,
      -2.2714872267184272E+000,
      -2.2821423733613631E+000,
      -2.2929969323743733E+000,
      -2.3040504752380566E+000,
      -2.3153025655774635E+000,
      -2.3267527591793384E+000,
      -2.3384006040096401E+000,
      -2.3502456402314031E+000,
      -2.3622874002228742E+000,
      -2.3745254085959919E+000,
      -2.3869591822151390E+000,
      -2.3995882302162226E+000,
      -2.4124120540260550E+000,
      -2.4254301473820239E+000,
      -2.4386419963521018E+000,
      -2.4520470793551059E+000,
      -2.4656448671813185E+000,
      -2.4794348230133556E+000,
      -2.4934164024473757E+000,
      -2.5075890535145624E+000,
      -2.5219522167029171E+000,
      -2.5365053249793545E+000,
      -2.5512478038120743E+000,
      -2.5661790711932606E+000,
      -2.5812985376620374E+000,
      -2.5966056063277612E+000,
      -2.6120996728935717E+000,
      -2.6277801256802475E+000,
      -2.6436463456503674E+000,
      -2.6596977064327261E+000,
      -2.6759335743470931E+000,
      -2.6923533084291953E+000,
      -2.7089562604560515E+000,
      -2.7257417749715445E+000,
      -2.7427091893123019E+000,
      -2.7598578336338546E+000,
      -2.7771870309370912E+000,
      -2.7946960970949770E+000,
      -2.8123843408795546E+000,
      -2.8302510639892531E+000,
      -2.8482955610764304E+000,
      -2.8665171197752426E+000,
      -2.8849150207297529E+000,
      -2.9034885376223314E+000,
      -2.9222369372023373E+000,
      -2.9411594793150524E+000,
      -2.9602554169309210E+000,
      -2.9795239961750180E+000,
      -2.9989644563568332E+000,
      -3.0185760300002800E+000,
      -3.0383579428740140E+000,
      -3.0583094140219917E+000,
      -3.0784296557942867E+000,
      -3.0987178738782113E+000,
      -3.1191732673296504E+000,
      -3.1397950286047003E+000,
      -3.1605823435915292E+000,
      -3.1815343916425429E+000,
      -3.2026503456067523E+000,
      -3.2239293718624555E+000,
      -3.2453706303501346E+000,
      -3.2669732746056099E+000,
      -3.2887364517934841E+000,
      -3.3106593027407789E+000,
      -3.3327409619708828E+000,
      -3.3549805577376941E+000,
      -3.3773772120600589E+000,
      -3.3999300407564053E+000,
      -3.4226381534796784E+000,
      -3.4455006537524717E+000,
      -3.4685166390024165E+000,
      -3.4916852005978307E+000,
      -3.5150054238835664E+000,
      -3.5384763882171426E+000,
      -3.5620971670050792E+000,
      -3.5858668277394719E+000,
      -3.6097844320348123E+000,
      -3.6338490356650381E+000,
      -3.6580596886008081E+000,
      -3.6824154350469924E+000,
      -3.7069153134804314E+000,
      -3.7315583566878683E+000,
      -3.7563435918041610E+000,
      -3.7812700403506572E+000,
      -3.8063367182738581E+000,
      -3.8315426359842317E+000,
      -3.8568867983953110E+000,
      -3.8823682049629640E+000,
      -3.9079858497248821E+000,
      -3.9337387213403221E+000,
      -3.9596258031300020E+000,
      -3.9856460731162655E+000,
      -4.0117985040633997E+000,
      -4.0380820635182184E+000,
      -4.0644957138507918E+000,
      -4.0910384122954362E+000,
      -4.1177091109918686E+000,
      -4.1445067570265648E+000,
      -4.1714302924743514E+000,
      -4.1984786544401418E+000,
      -4.2256507751009256E+000,
      -4.2529455817479063E+000,
      -4.2803619968288462E+000,
      -4.3078989379906325E+000,
      -4.3355553181219681E+000,
      -4.3633300453963315E+000,
      -4.3912220233150370E+000,
      -4.4192301507505656E+000,
      -4.4473533219899943E+000,
      -4.4755904267786830E+000,
      -4.5039403503640854E+000,
      -4.5324019735397538E+000,
      -4.5609741726895496E+000,
      -4.5896558198319637E+000,
      -4.6184457826646872E+000,
      -4.6473429246092754E+000,
      -4.6763461048560497E+000,
      -4.7054541784091111E+000,
      -4.7346659961315591E+000,
      -4.7639804047908516E+000,
      -4.7933962471043223E+000,
      -4.8229123617848932E+000,
      -4.8525275835868875E+000,
      -4.8822407433520656E+000,
      -4.9120506680557492E+000,
      -4.9419561808531585E+000,
      -4.9719561011258575E+000,
      -5.0020492445283562E+000,
      -5.0322344230348852E+000,
      -5.0625104449862777E+000,
      -5.0928761151370336E+000,
      -5.1233302347024834E+000,
      -5.1538716014061352E+000,
      -5.1844990095271308E+000,
      -5.2152112499478376E+000,
      -5.2460071102015879E+000,
      -5.2768853745205497E+000,
      -5.3078448238837277E+000,
      -5.3388842360650628E+000,
      -5.3700023856817181E+000,
      -5.4011980442424221E+000,
      -5.4324699801959930E+000,
      -5.4638169589799510E+000,
      -5.4952377430692447E+000,
      -5.5267310920251127E+000,
      -5.5582957625440690E+000,
      -5.5899305085069741E+000,
      -5.6216340810282146E+000,
      -5.6534052285050418E+000,
      -5.6852426966669460E+000,
      -5.7171452286252027E+000,
      -5.7491115649224804E+000,
      -5.7811404435825517E+000,
      -5.8132306001601268E+000,
      -5.8453807677907754E+000,
      -5.8775896772409331E+000,
      -5.9098560569579952E+000,
      -5.9421786331205508E+000,
      -5.9745561296886276E+000,
      -6.0069872684541048E+000,
      -6.0394707690911602E+000,
      -6.0720053492067994E+000,
      -6.1045897243915173E+000,
      -6.1372226082699655E+000,
      -6.1699027125517691E+000,
      -6.2026287470823736E+000,
      -6.2353994198939677E+000,
      -6.2682134372564953E+000,
      -6.3010695037287423E+000,
      -6.3339663222094691E+000,
      -6.3669025939885984E+000,
      -6.3998770187985281E+000,
      -6.4328882948654176E+000,
      -6.4659351189606173E+000,
      -6.4990161864521001E+000,
      -6.5321301913559635E+000,
      -6.5652758263879880E+000,
      -6.5984517830152614E+000,
      -6.6316567515078271E+000,
      -6.6648894209903755E+000,
      -6.6981484794940283E+000,
      -6.7314326140080967E+000,
      -6.7647405105319436E+000,
      -6.7980708541268537E+000,
      -6.8314223289679257E+000,
      -6.8647936183960363E+000,
      -6.8981834049698243E+000,
      -6.9315903705176920E+000,
      -6.9650131961898349E+000,
      -6.9984505625103299E+000,
      -7.0319011494292010E+000,
      -7.0653636363745589E+000,
      -7.0988367023047196E+000,
      -7.1323190257603457E+000,
      -7.1658092849166488E+000,
      -7.1993061576355313E+000,
      -7.2328083215178234E+000,
      -7.2663144539554505E+000,
      -7.2998232321836873E+000,
      -7.3333333333333330E+000,
      -7.3668434344829787E+000,
      -7.4003522127112138E+000,
      -7.4338583451488409E+000,
      -7.4673605090311330E+000,
      -7.5008573817500155E+000,
      -7.5343476409063177E+000,
      -7.5678299643619447E+000,
      -7.6013030302921063E+000,
      -7.6347655172374633E+000,
      -7.6682161041563353E+000,
      -7.7016534704768311E+000,
      -7.7350762961489723E+000,
      -7.7684832616968409E+000,
      -7.8018730482706280E+000,
      -7.8352443376987440E+000,
      -7.8685958125398123E+000,
      -7.9019261561347207E+000,
      -7.9352340526585685E+000,
      -7.9685181871726352E+000,
      -8.0017772456762888E+000,
      -8.0350099151588381E+000,
      -8.0682148836514038E+000,
      -8.1013908402786772E+000,
      -8.1345364753107052E+000,
      -8.1676504802145633E+000,
      -8.2007315477060470E+000,
      -8.2337783718012467E+000,
      -8.2667896478681371E+000,
      -8.2997640726780659E+000,
      -8.3327003444571996E+000,
      -8.3655971629379220E+000,
      -8.3984532294101690E+000,
      -8.4312672467727001E+000,
      -8.4640379195842907E+000,
      -8.4967639541148952E+000,
      -8.5294440583967006E+000,
      -8.5620769422751479E+000,
      -8.5946613174598667E+000,
      -8.6271958975755059E+000,
      -8.6596793982125586E+000,
      -8.6921105369780367E+000,
      -8.7244880335461144E+000,
      -8.7568106097086691E+000,
      -8.7890769894257321E+000,
      -8.8212858988758907E+000,
      -8.8534360665065375E+000,
      -8.8855262230841134E+000,
      -8.9175551017441848E+000,
      -8.9495214380414616E+000,
      -8.9814239699997174E+000,
      -9.0132614381616225E+000,
      -9.0450325856384506E+000,
      -9.0767361581596919E+000,
      -9.1083709041225944E+000,
      -9.1399355746415516E+000,
      -9.1714289235974213E+000,
      -9.2028497076867133E+000,
      -9.2341966864706713E+000,
      -9.2654686224242422E+000,
      -9.2966642809849453E+000,
      -9.3277824306016015E+000,
      -9.3588218427829375E+000,
      -9.3897812921461163E+000,
      -9.4206595564650772E+000,
      -9.4514554167188276E+000,
      -9.4821676571395326E+000,
      -9.5127950652605300E+000,
      -9.5433364319641818E+000,
      -9.5737905515296298E+000,
      -9.6041562216803857E+000,
      -9.6344322436317835E+000,
      -9.6646174221383099E+000,
      -9.6947105655408059E+000,
      -9.7247104858135014E+000,
      -9.7546159986109160E+000,
      -9.7844259233146040E+000,
      -9.8141390830797768E+000,
      -9.8437543048817737E+000,
      -9.8732704195623420E+000,
      -9.9026862618758162E+000,
      -9.9320006705351052E+000,
      -9.9612124882575532E+000,
      -9.9903205618106146E+000,
      -1.0019323742057392E+001,
      -1.0048220884001983E+001,
      -1.0077010846834700E+001,
      -1.0105692493977115E+001,
      -1.0134264693126912E+001,
      -1.0162726316302583E+001,
      -1.0191076239887982E+001,
      -1.0219313344676669E+001,
      -1.0247436515916098E+001,
      -1.0275444643351628E+001,
      -1.0303336621270340E+001,
      -1.0331111348544697E+001,
      -1.0358767728676034E+001,
      -1.0386304669837816E+001,
      -1.0413721084918762E+001,
      -1.0441015891565741E+001,
      -1.0468188012226523E+001,
      -1.0495236374192315E+001,
      -1.0522159909640099E+001,
      -1.0548957555674795E+001,
      -1.0575628254371228E+001,
      -1.0602170952815875E+001,
      -1.0628584603148447E+001,
      -1.0654868162603266E+001,
      -1.0681020593550402E+001,
      -1.0707040863536662E+001,
      -1.0732927945326344E+001,
      -1.0758680816941784E+001,
      -1.0784298461703701E+001,
      -1.0809779868271354E+001,
      -1.0835124030682435E+001,
      -1.0860329948392808E+001,
      -1.0885396626316009E+001,
      -1.0910323074862509E+001,
      -1.0935108309978796E+001,
      -1.0959751353186235E+001,
      -1.0984251231619673E+001,
      -1.1008606978065856E+001,
      -1.1032817631001627E+001,
      -1.1056882234631853E+001,
      -1.1080799838927193E+001,
      -1.1104569499661588E+001,
      -1.1128190278449523E+001,
      -1.1151661242783099E+001,
      -1.1174981466068834E+001,
      -1.1198150027664248E+001,
      -1.1221166012914193E+001,
      -1.1244028513186988E+001,
      -1.1266736625910260E+001,
      -1.1289289454606607E+001,
      -1.1311686108928972E+001,
      -1.1333925704695785E+001,
      -1.1356007363925887E+001,
      -1.1377930214873182E+001,
      -1.1399693392061057E+001,
      -1.1421296036316530E+001,
      -1.1442737294804211E+001,
      -1.1464016321059912E+001,
      -1.1485132275024124E+001,
      -1.1506084323075136E+001,
      -1.1526871638061968E+001,
      -1.1547493399337014E+001,
      -1.1567948792788455E+001,
      -1.1588237010872378E+001,
      -1.1608357252644678E+001,
      -1.1628308723792651E+001,
      -1.1648090636666387E+001,
      -1.1667702210309834E+001,
      -1.1687142670491646E+001,
      -1.1706411249735748E+001,
      -1.1725507187351614E+001,
      -1.1744429729464329E+001,
      -1.1763178129044334E+001,
      -1.1781751645936914E+001,
      -1.1800149546891422E+001,
      -1.1818371105590234E+001,
      -1.1836415602677413E+001,
      -1.1854282325787111E+001,
      -1.1871970569571692E+001,
      -1.1889479635729575E+001,
      -1.1906808833032812E+001,
      -1.1923957477354367E+001,
      -1.1940924891695122E+001,
      -1.1957710406210614E+001,
      -1.1974313358237469E+001,
      -1.1990733092319573E+001,
      -1.2006968960233937E+001,
      -1.2023020321016299E+001,
      -1.2038886540986418E+001,
      -1.2054566993773093E+001,
      -1.2070061060338903E+001,
      -1.2085368129004630E+001,
      -1.2100487595473409E+001,
      -1.2115418862854591E+001,
      -1.2130161341687311E+001,
      -1.2144714449963745E+001,
      -1.2159077613152103E+001,
      -1.2173250264219291E+001,
      -1.2187231843653310E+001,
      -1.2201021799485348E+001,
      -1.2214619587311560E+001,
      -1.2228024670314568E+001,
      -1.2241236519284641E+001,
      -1.2254254612640612E+001,
      -1.2267078436450442E+001,
      -1.2279707484451526E+001,
      -1.2292141258070675E+001,
      -1.2304379266443792E+001,
      -1.2316421026435263E+001,
      -1.2328266062657027E+001,
      -1.2339913907487329E+001,
      -1.2351364101089203E+001,
      -1.2362616191428611E+001,
      -1.2373669734292292E+001,
      -1.2384524293305303E+001,
      -1.2395179439948238E+001,
      -1.2405634753574153E+001,
      -1.2415889821425168E+001,
      -1.2425944238648764E+001,
      -1.2435797608313763E+001,
      -1.2445449541426006E+001,
      -1.2454899656943697E+001,
      -1.2464147581792458E+001,
      -1.2473192950880053E+001,
      -1.2482035407110795E+001,
      -1.2490674601399654E+001,
      -1.2499110192686032E+001,
      -1.2507341847947233E+001,
      -1.2515369242211595E+001,
      -1.2523192058571343E+001,
      -1.2530809988195077E+001,
      -1.2538222730339989E+001,
      -1.2545429992363699E+001,
      -1.2552431489735854E+001,
      -1.2559226946049318E+001,
      -1.2565816093031115E+001,
      -1.2572198670553007E+001,
      -1.2578374426641759E+001,
      -1.2584343117489095E+001,
      -1.2590104507461323E+001,
      -1.2595658369108632E+001,
      -1.2601004483174069E+001,
      -1.2606142638602210E+001,
      -1.2611072632547472E+001,
      -1.2615794270382139E+001,
      -1.2620307365704035E+001,
      -1.2624611740343884E+001,
      -1.2628707224372341E+001,
      -1.2632593656106714E+001,
      -1.2636270882117326E+001,
      -1.2639738757233603E+001,
      -1.2642997144549762E+001,
      -1.2646045915430253E+001,
      -1.2648884949514828E+001,
      -1.2651514134723275E+001,
      -1.2653933367259869E+001,
      -1.2656142551617448E+001,
      -1.2658141600581201E+001,
      -1.2659930435232095E+001,
      -1.2661508984949998E+001,
      -1.2662877187416477E+001,
      -1.2664034988617235E+001,
      -1.2664982342844267E+001,
      -1.2665719212697649E+001,
      -1.2666245569087021E+001,
      -1.2666561391232731E+001,
      -1.2666666666666668E+001,
      -1.2666561391232731E+001,
      -1.2666245569087021E+001,
      -1.2665719212697649E+001,
      -1.2664982342844267E+001,
      -1.2664034988617235E+001,
      -1.2662877187416477E+001,
      -1.2661508984949998E+001,
      -1.2659930435232095E+001,
      -1.2658141600581201E+001,
      -1.2656142551617448E+001,
      -1.2653933367259869E+001,
      -1.2651514134723275E+001,
      -1.2648884949514828E+001,
      -1.2646045915430253E+001,
      -1.2642997144549762E+001,
      -1.2639738757233603E+001,
      -1.2636270882117330E+001,
      -1.2632593656106714E+001,
      -1.2628707224372341E+001,
      -1.2624611740343884E+001,
      -1.2620307365704035E+001,
      -1.2615794270382139E+001,
      -1.2611072632547474E+001,
      -1.2606142638602210E+001,
      -1.2601004483174069E+001,
      -1.2595658369108632E+001,
      -1.2590104507461323E+001,
      -1.2584343117489096E+001,
      -1.2578374426641759E+001,
      -1.2572198670553007E+001,
      -1.2565816093031117E+001,
      -1.2559226946049318E+001,
      -1.2552431489735854E+001,
      -1.2545429992363699E+001,
      -1.2538222730339985E+001,
      -1.2530809988195081E+001,
      -1.2523192058571343E+001,
      -1.2515369242211595E+001,
      -1.2507341847947231E+001,
      -1.2499110192686032E+001,
      -1.2490674601399654E+001,
      -1.2482035407110796E+001,
      -1.2473192950880055E+001,
      -1.2464147581792458E+001,
      -1.2454899656943697E+001,
      -1.2445449541426006E+001,
      -1.2435797608313763E+001,
      -1.2425944238648762E+001,
      -1.2415889821425168E+001,
      -1.2405634753574153E+001,
      -1.2395179439948240E+001,
      -1.2384524293305306E+001,
      -1.2373669734292292E+001,
      -1.2362616191428611E+001,
      -1.2351364101089205E+001,
      -1.2339913907487327E+001,
      -1.2328266062657026E+001,
      -1.2316421026435265E+001,
      -1.2304379266443792E+001,
      -1.2292141258070677E+001,
      -1.2279707484451530E+001,
      -1.2267078436450443E+001,
      -1.2254254612640615E+001,
      -1.2241236519284643E+001,
      -1.2228024670314564E+001,
      -1.2214619587311560E+001,
      -1.2201021799485350E+001,
      -1.2187231843653313E+001,
      -1.2173250264219293E+001,
      -1.2159077613152107E+001,
      -1.2144714449963748E+001,
      -1.2130161341687312E+001,
      -1.2115418862854591E+001,
      -1.2100487595473405E+001,
      -1.2085368129004628E+001,
      -1.2070061060338903E+001,
      -1.2054566993773095E+001,
      -1.2038886540986420E+001,
      -1.2023020321016304E+001,
      -1.2006968960233944E+001,
      -1.1990733092319575E+001,
      -1.1974313358237472E+001,
      -1.1957710406210616E+001,
      -1.1940924891695126E+001,
      -1.1923957477354367E+001,
      -1.1906808833032812E+001,
      -1.1889479635729575E+001,
      -1.1871970569571692E+001,
      -1.1854282325787114E+001,
      -1.1836415602677414E+001,
      -1.1818371105590236E+001,
      -1.1800149546891426E+001,
      -1.1781751645936916E+001,
      -1.1763178129044334E+001,
      -1.1744429729464331E+001,
      -1.1725507187351614E+001,
      -1.1706411249735750E+001,
      -1.1687142670491653E+001,
      -1.1667702210309836E+001,
      -1.1648090636666387E+001,
      -1.1628308723792655E+001,
      -1.1608357252644678E+001,
      -1.1588237010872378E+001,
      -1.1567948792788457E+001,
      -1.1547493399337016E+001,
      -1.1526871638061971E+001,
      -1.1506084323075141E+001,
      -1.1485132275024124E+001,
      -1.1464016321059916E+001,
      -1.1442737294804212E+001,
      -1.1421296036316530E+001,
      -1.1399693392061055E+001,
      -1.1377930214873185E+001,
      -1.1356007363925890E+001,
      -1.1333925704695787E+001,
      -1.1311686108928976E+001,
      -1.1289289454606610E+001,
      -1.1266736625910260E+001,
      -1.1244028513186990E+001,
      -1.1221166012914193E+001,
      -1.1198150027664248E+001,
      -1.1174981466068838E+001,
      -1.1151661242783103E+001,
      -1.1128190278449523E+001,
      -1.1104569499661592E+001,
      -1.1080799838927195E+001,
      -1.1056882234631857E+001,
      -1.1032817631001627E+001,
      -1.1008606978065856E+001,
      -1.0984251231619673E+001,
      -1.0959751353186235E+001,
      -1.0935108309978800E+001,
      -1.0910323074862511E+001,
      -1.0885396626316012E+001,
      -1.0860329948392812E+001,
      -1.0835124030682435E+001,
      -1.0809779868271356E+001,
      -1.0784298461703701E+001,
      -1.0758680816941784E+001,
      -1.0732927945326347E+001,
      -1.0707040863536665E+001,
      -1.0681020593550405E+001,
      -1.0654868162603270E+001,
      -1.0628584603148457E+001,
      -1.0602170952815875E+001,
      -1.0575628254371232E+001,
      -1.0548957555674795E+001,
      -1.0522159909640099E+001,
      -1.0495236374192315E+001,
      -1.0468188012226525E+001,
      -1.0441015891565742E+001,
      -1.0413721084918766E+001,
      -1.0386304669837825E+001,
      -1.0358767728676037E+001,
      -1.0331111348544699E+001,
      -1.0303336621270331E+001,
      -1.0275444643351626E+001,
      -1.0247436515916101E+001,
      -1.0219313344676673E+001,
      -1.0191076239887986E+001,
      -1.0162726316302589E+001,
      -1.0134264693126909E+001,
      -1.0105692493977118E+001,
      -1.0077010846834703E+001,
      -1.0048220884001976E+001,
      -1.0019323742057388E+001,
      -9.9903205618106181E+000,
      -9.9612124882575586E+000,
      -9.9320006705351087E+000,
      -9.9026862618758198E+000,
      -9.8732704195623420E+000,
      -9.8437543048817737E+000,
      -9.8141390830797803E+000,
      -9.7844259233145987E+000,
      -9.7546159986109124E+000,
      -9.7247104858135032E+000,
      -9.6947105655408095E+000,
      -9.6646174221383117E+000,
      -9.6344322436317853E+000,
      -9.6041562216803857E+000,
      -9.5737905515296333E+000,
      -9.5433364319641854E+000,
      -9.5127950652605229E+000,
      -9.4821676571395326E+000,
      -9.4514554167188294E+000,
      -9.4206595564650808E+000,
      -9.3897812921461199E+000,
      -9.3588218427829446E+000,
      -9.3277824306015997E+000,
      -9.2966642809849489E+000,
      -9.2654686224242457E+000,
      -9.2341966864706659E+000,
      -9.2028497076867115E+000,
      -9.1714289235974249E+000,
      -9.1399355746415551E+000,
      -9.1083709041225980E+000,
      -9.0767361581596990E+000,
      -9.0450325856384506E+000,
      -9.0132614381616261E+000,
      -8.9814239699997209E+000,
      -8.9495214380414563E+000,
      -8.9175551017441830E+000,
      -8.8855262230841152E+000,
      -8.8534360665065410E+000,
      -8.8212858988758942E+000,
      -8.7890769894257392E+000,
      -8.7568106097086762E+000,
      -8.7244880335461268E+000,
      -8.6921105369780420E+000,
      -8.6596793982125622E+000,
      -8.6271958975755041E+000,
      -8.5946613174598632E+000,
      -8.5620769422751515E+000,
      -8.5294440583967042E+000,
      -8.4967639541148987E+000,
      -8.4640379195842979E+000,
      -8.4312672467727090E+000,
      -8.3984532294101726E+000,
      -8.3655971629379255E+000,
      -8.3327003444571943E+000,
      -8.2997640726780642E+000,
      -8.2667896478681389E+000,
      -8.2337783718012503E+000,
      -8.2007315477060505E+000,
      -8.1676504802145722E+000,
      -8.1345364753107123E+000,
      -8.1013908402786790E+000,
      -8.0682148836514074E+000,
      -8.0350099151588363E+000,
      -8.0017772456762870E+000,
      -7.9685181871726387E+000,
      -7.9352340526585712E+000,
      -7.9019261561347234E+000,
      -7.8685958125398194E+000,
      -7.8352443376987519E+000,
      -7.8018730482706324E+000,
      -7.7684832616968444E+000,
      -7.7350762961489705E+000,
      -7.7016534704768294E+000,
      -7.6682161041563388E+000,
      -7.6347655172374669E+000,
      -7.6013030302921090E+000,
      -7.5678299643619527E+000,
      -7.5343476409063257E+000,
      -7.5008573817500181E+000,
      -7.4673605090311366E+000,
      -7.4338583451488400E+000,
      -7.4003522127112120E+000,
      -7.3668434344829814E+000,
      -7.3333333333333357E+000,
      -7.2998232321836900E+000,
      -7.2663144539554594E+000,
      -7.2328083215178323E+000,
      -7.1993061576355339E+000,
      -7.1658092849166524E+000,
      -7.1323190257603448E+000,
      -7.0988367023047187E+000,
      -7.0653636363745624E+000,
      -7.0319011494292045E+000,
      -6.9984505625103326E+000,
      -6.9650131961898420E+000,
      -6.9315903705177009E+000,
      -6.8981834049698270E+000,
      -6.8647936183960390E+000,
      -6.8314223289679195E+000,
      -6.7980708541268511E+000,
      -6.7647405105319471E+000,
      -6.7314326140080993E+000,
      -6.6981484794940318E+000,
      -6.6648894209903835E+000,
      -6.6316567515078342E+000,
      -6.5984517830152649E+000,
      -6.5652758263879916E+000,
      -6.5321301913559582E+000,
      -6.4990161864520992E+000,
      -6.4659351189606200E+000,
      -6.4328882948654211E+000,
      -6.3998770187985317E+000,
      -6.3669025939886073E+000,
      -6.3339663222094762E+000,
      -6.3010695037287459E+000,
      -6.2682134372564979E+000,
      -6.2353994198939615E+000,
      -6.2026287470823727E+000,
      -6.1699027125517727E+000,
      -6.1372226082699681E+000,
      -6.1045897243915199E+000,
      -6.0720053492068073E+000,
      -6.0394707690911673E+000,
      -6.0069872684541084E+000,
      -5.9745561296886311E+000,
      -5.9421786331205446E+000,
      -5.9098560569579943E+000,
      -5.8775896772409313E+000,
      -5.8453807677907781E+000,
      -5.8132306001601313E+000,
      -5.7811404435825553E+000,
      -5.7491115649224875E+000,
      -5.7171452286252054E+000,
      -5.6852426966669487E+000,
      -5.6534052285050356E+000,
      -5.6216340810282137E+000,
      -5.5899305085069724E+000,
      -5.5582957625440725E+000,
      -5.5267310920251154E+000,
      -5.4952377430692474E+000,
      -5.4638169589799590E+000,
      -5.4324699801959957E+000,
      -5.4011980442424257E+000,
      -5.3700023856817127E+000,
      -5.3388842360650610E+000,
      -5.3078448238837268E+000,
      -5.2768853745205524E+000,
      -5.2460071102015897E+000,
      -5.2152112499478411E+000,
      -5.1844990095271379E+000,
      -5.1538716014061388E+000,
      -5.1233302347024861E+000,
      -5.0928761151370274E+000,
      -5.0625104449862759E+000,
      -5.0322344230348843E+000,
      -5.0020492445283580E+000,
      -4.9719561011258611E+000,
      -4.9419561808531656E+000,
      -4.9120506680557563E+000,
      -4.8822407433520638E+000,
      -4.8525275835868911E+000,
      -4.8229123617848879E+000,
      -4.7933962471043223E+000,
      -4.7639804047908498E+000,
      -4.7346659961315618E+000,
      -4.7054541784091128E+000,
      -4.6763461048560533E+000,
      -4.6473429246092808E+000,
      -4.6184457826646943E+000,
      -4.5896558198319672E+000,
      -4.5609741726895523E+000,
      -4.5324019735397609E+000,
      -4.5039403503640827E+000,
      -4.4755904267786857E+000,
      -4.4473533219899979E+000,
      -4.4192301507505682E+000,
      -4.3912220233150450E+000,
      -4.3633300453963377E+000,
      -4.3355553181219708E+000,
      -4.3078989379906352E+000,
      -4.2803619968288444E+000,
      -4.2529455817479045E+000,
      -4.2256507751009282E+000,
      -4.1984786544401445E+000,
      -4.1714302924743540E+000,
      -4.1445067570265710E+000,
      -4.1177091109918749E+000,
      -4.0910384122954389E+000,
      -4.0644957138507944E+000,
      -4.0380820635182131E+000,
      -4.0117985040633988E+000,
      -3.9856460731162642E+000,
      -3.9596258031300042E+000,
      -3.9337387213403252E+000,
      -3.9079858497248878E+000,
      -3.8823682049629702E+000,
      -3.8568867983953141E+000,
      -3.8315426359842344E+000,
      -3.8063367182738537E+000,
      -3.7812700403506563E+000,
      -3.7563435918041597E+000,
      -3.7315583566878709E+000,
      -3.7069153134804340E+000,
      -3.6824154350469982E+000,
      -3.6580596886008139E+000,
      -3.6338490356650408E+000,
      -3.6097844320348145E+000,
      -3.5858668277394674E+000,
      -3.5620971670050783E+000,
      -3.5384763882171444E+000,
      -3.5150054238835677E+000,
      -3.4916852005978321E+000,
      -3.4685166390024218E+000,
      -3.4455006537524770E+000,
      -3.4226381534796806E+000,
      -3.3999300407564079E+000,
      -3.3773772120600545E+000,
      -3.3549805577376932E+000,
      -3.3327409619708819E+000,
      -3.3106593027407807E+000,
      -3.2887364517934854E+000,
      -3.2669732746056153E+000,
      -3.2453706303501391E+000,
      -3.2239293718624582E+000,
      -3.2026503456067550E+000,
      -3.1815343916425385E+000,
      -3.1605823435915283E+000,
      -3.1397950286046981E+000,
      -3.1191732673296522E+000,
      -3.0987178738782135E+000,
      -3.0784296557942912E+000,
      -3.0583094140219962E+000,
      -3.0383579428740157E+000,
      -3.0185760300002817E+000,
      -2.9989644563568296E+000,
      -2.9795239961750171E+000,
      -2.9602554169309201E+000,
      -2.9411594793150542E+000,
      -2.9222369372023382E+000,
      -2.9034885376223349E+000,
      -2.8849150207297578E+000,
      -2.8665171197752444E+000,
      -2.8482955610764322E+000,
      -2.8302510639892504E+000,
      -2.8123843408795546E+000,
      -2.7946960970949757E+000,
      -2.7771870309370934E+000,
      -2.7598578336338564E+000,
      -2.7427091893123028E+000,
      -2.7257417749715489E+000,
      -2.7089562604560533E+000,
      -2.6923533084291971E+000,
      -2.6759335743470891E+000,
      -2.6596977064327261E+000,
      -2.6436463456503660E+000,
      -2.6277801256802498E+000,
      -2.6120996728935735E+000,
      -2.5966056063277647E+000,
      -2.5812985376620414E+000,
      -2.5661790711932597E+000,
      -2.5512478038120761E+000,
      -2.5365053249793519E+000,
      -2.5219522167029162E+000,
      -2.5075890535145611E+000,
      -2.4934164024473766E+000,
      -2.4794348230133574E+000,
      -2.4656448671813207E+000,
      -2.4520470793551086E+000,
      -2.4386419963521004E+000,
      -2.4254301473820248E+000,
      -2.4124120540260523E+000,
      -2.3995882302162217E+000,
      -2.3869591822151390E+000,
      -2.3745254085959928E+000,
      -2.3622874002228751E+000,
      -2.3502456402314040E+000,
      -2.3384006040096432E+000,
      -2.3267527591793375E+000,
      -2.3153025655774653E+000,
      -2.3040504752380535E+000,
      -2.2929969323743733E+000,
      -2.2821423733613631E+000,
      -2.2714872267184290E+000,
      -2.2610319130925149E+000,
      -2.2507768452415018E+000,
      -2.2407224280179059E+000,
      -2.2308690583529041E+000,
      -2.2212171252406616E+000,
      -2.2117670097229687E+000,
      -2.2025190848742069E+000,
      -2.1934737157866149E+000,
      -2.1846312595558732E+000,
      -2.1759920652670131E+000,
      -2.1675564739806346E+000,
      -2.1593248187194374E+000,
      -2.1512974244550742E+000,
      -2.1434746080953277E+000,
      -2.1358566784715891E+000,
      -2.1284439363266814E+000,
      -2.1212366743029678E+000,
      -2.1142351769308161E+000,
      -2.1074397206173510E+000,
      -2.1008505736355527E+000,
      -2.0944679961136607E+000,
      -2.0882922400249102E+000,
      -2.0823235491775720E+000,
      -2.0765621592053445E+000,
      -2.0710082975580377E+000,
      -2.0656621834925986E+000,
      -2.0605240280644579E+000,
      -2.0555940341191952E+000,
      -2.0508723962845274E+000,
      -2.0463593009626329E+000,
      -2.0420549263227858E+000,
      -2.0379594422943264E+000,
      -2.0340730105599549E+000,
      -2.0303957845493401E+000,
      -2.0269279094330654E+000,
      -2.0236695221169065E+000,
      -2.0206207512364136E+000,
      -2.0177817171518408E+000,
      -2.0151525319433929E+000,
      -2.0127332994067992E+000,
      -2.0105241150492179E+000,
      -2.0085250660854665E+000,
      -2.0067362314345734E+000,
      -2.0051576817166685E+000,
      -2.0037894792501909E+000,
      -2.0026316780494318E+000,
      -2.0016843238224005E+000,
      -2.0009474539690193E+000,
      -2.0004210975796477E+000,
      -2.0001052754339352E+000,
      -2.0,
      -2.0001052754339352E+000,
      -2.0004210975796477E+000,
      -2.0009474539690193E+000,
      -2.0016843238224005E+000,
      -2.0026316780494318E+000,
      -2.0037894792501900E+000,
      -2.0051576817166685E+000,
      -2.0067362314345734E+000,
      -2.0085250660854665E+000,
      -2.0105241150492179E+000,
      -2.0127332994067992E+000,
      -2.0151525319433929E+000,
      -2.0177817171518408E+000,
      -2.0206207512364136E+000,
      -2.0236695221169065E+000,
      -2.0269279094330646E+000,
      -2.0303957845493392E+000,
      -2.0340730105599549E+000,
      -2.0379594422943277E+000,
      -2.0420549263227850E+000,
      -2.0463593009626311E+000,
      -2.0508723962845274E+000,
      -2.0555940341191943E+000,
      -2.0605240280644579E+000,
      -2.0656621834925977E+000,
      -2.0710082975580368E+000,
      -2.0765621592053418E+000,
      -2.0823235491775698E+000,
      -2.0882922400249075E+000,
      -2.0944679961136607E+000,
      -2.1008505736355514E+000,
      -2.1074397206173492E+000,
      -2.1142351769308139E+000,
      -2.1212366743029669E+000,
      -2.1284439363266787E+000,
      -2.1358566784715882E+000,
      -2.1434746080953242E+000,
      -2.1512974244550733E+000,
      -2.1593248187194352E+000,
      -2.1675564739806337E+000,
      -2.1759920652670122E+000,
      -2.1846312595558710E+000,
      -2.1934737157866131E+000,
      -2.2025190848742087E+000,
      -2.2117670097229674E+000,
      -2.2212171252406638E+000,
      -2.2308690583529023E+000,
      -2.2407224280179050E+000,
      -2.2507768452414996E+000,
      -2.2610319130925132E+000,
      -2.2714872267184272E+000,
      -2.2821423733613613E+000,
      -2.2929969323743711E+000,
      -2.3040504752380557E+000,
      -2.3153025655774635E+000,
      -2.3267527591793393E+000,
      -2.3384006040096423E+000,
      -2.3502456402314023E+000,
      -2.3622874002228733E+000,
      -2.3745254085959910E+000,
      -2.3869591822151373E+000,
      -2.3995882302162248E+000,
      -2.4124120540260501E+000,
      -2.4254301473820279E+000,
      -2.4386419963520987E+000,
      -2.4520470793551077E+000,
      -2.4656448671813185E+000,
      -2.4794348230133556E+000,
      -2.4934164024473748E+000,
      -2.5075890535145602E+000,
      -2.5219522167029145E+000,
      -2.5365053249793545E+000,
      -2.5512478038120743E+000,
      -2.5661790711932615E+000,
      -2.5812985376620396E+000,
      -2.5966056063277629E+000,
      -2.6120996728935717E+000,
      -2.6277801256802475E+000,
      -2.6436463456503634E+000,
      -2.6596977064327278E+000,
      -2.6759335743470873E+000,
      -2.6923533084292002E+000,
      -2.7089562604560506E+000,
      -2.7257417749715462E+000,
      -2.7427091893123006E+000,
      -2.7598578336338537E+000,
      -2.7771870309370903E+000,
      -2.7946960970949739E+000,
      -2.8123843408795519E+000,
      -2.8302510639892522E+000,
      -2.8482955610764296E+000,
      -2.8665171197752470E+000,
      -2.8849150207297551E+000,
      -2.9034885376223332E+000,
      -2.9222369372023365E+000,
      -2.9411594793150524E+000,
      -2.9602554169309183E+000,
      -2.9795239961750202E+000,
      -2.9989644563568270E+000,
      -3.0185760300002844E+000,
      -3.0383579428740140E+000,
      -3.0583094140219935E+000,
      -3.0784296557942885E+000,
      -3.0987178738782104E+000,
      -3.1191732673296495E+000,
      -3.1397950286046963E+000,
      -3.1605823435915257E+000,
      -3.1815343916425420E+000,
      -3.2026503456067514E+000,
      -3.2239293718624609E+000,
      -3.2453706303501360E+000,
      -3.2669732746056117E+000,
      -3.2887364517934827E+000,
      -3.3106593027407776E+000,
      -3.3327409619708792E+000,
      -3.3549805577376968E+000,
      -3.3773772120600509E+000,
      -3.3999300407564110E+000,
      -3.4226381534796770E+000,
      -3.4455006537524739E+000,
      -3.4685166390024187E+000,
      -3.4916852005978289E+000,
      -3.5150054238835651E+000,
      -3.5384763882171417E+000,
      -3.5620971670050747E+000,
      -3.5858668277394710E+000,
      -3.6097844320348109E+000,
      -3.6338490356650439E+000,
      -3.6580596886008103E+000,
      -3.6824154350469946E+000,
      -3.7069153134804300E+000,
      -3.7315583566878678E+000,
      -3.7563435918041566E+000,
      -3.7812700403506603E+000,
      -3.8063367182738497E+000,
      -3.8315426359842384E+000,
      -3.8568867983953101E+000,
      -3.8823682049629666E+000,
      -3.9079858497248847E+000,
      -3.9337387213403217E+000,
      -3.9596258031300007E+000,
      -3.9856460731162606E+000,
      -4.0117985040633952E+000,
      -4.0380820635182175E+000,
      -4.0644957138507909E+000,
      -4.0910384122954433E+000,
      -4.1177091109918713E+000,
      -4.1445067570265675E+000,
      -4.1714302924743505E+000,
      -4.1984786544401409E+000,
      -4.2256507751009238E+000,
      -4.2529455817479080E+000,
      -4.2803619968288409E+000,
      -4.3078989379906227E+000,
      -4.3355553181219681E+000,
      -4.3633300453963262E+000,
      -4.3912220233150414E+000,
      -4.4192301507505647E+000,
      -4.4473533219899943E+000,
      -4.4755904267786804E+000,
      -4.5039403503640791E+000,
      -4.5324019735397494E+000,
      -4.5609741726895487E+000,
      -4.5896558198319637E+000,
      -4.6184457826646899E+000,
      -4.6473429246092781E+000,
      -4.6763461048560497E+000,
      -4.7054541784091093E+000,
      -4.7346659961315583E+000,
      -4.7639804047908463E+000,
      -4.7933962471043259E+000,
      -4.8229123617848835E+000,
      -4.8525275835868866E+000,
      -4.8822407433520603E+000,
      -4.9120506680557527E+000,
      -4.9419561808531611E+000,
      -4.9719561011258575E+000,
      -5.0020492445283544E+000,
      -5.0322344230348799E+000,
      -5.0625104449862715E+000,
      -5.0928761151370336E+000,
      -5.1233302347024816E+000,
      -5.1538716014061423E+000,
      -5.1844990095271344E+000,
      -5.2152112499478376E+000,
      -5.2460071102015862E+000,
      -5.2768853745205488E+000,
      -5.3078448238837224E+000,
      -5.3388842360650663E+000,
      -5.3700023856817083E+000,
      -5.4011980442424203E+000,
      -5.4324699801959921E+000,
      -5.4638169589799537E+000,
      -5.4952377430692438E+000,
      -5.5267310920251109E+000,
      -5.5582957625440681E+000,
      -5.5899305085069688E+000,
      -5.6216340810282084E+000,
      -5.6534052285050409E+000,
      -5.6852426966669443E+000,
      -5.7171452286252098E+000,
      -5.7491115649224831E+000,
      -5.7811404435825509E+000,
      -5.8132306001601259E+000,
      -5.8453807677907736E+000,
      -5.8775896772409268E+000,
      -5.9098560569579988E+000,
      -5.9421786331205402E+000,
      -5.9745561296886258E+000,
      -6.0069872684541030E+000,
      -6.0394707690911638E+000,
      -6.0720053492068020E+000,
      -6.1045897243915155E+000,
      -6.1372226082699637E+000,
      -6.1699027125517683E+000,
      -6.2026287470823682E+000,
      -6.2353994198939668E+000,
      -6.2682134372564944E+000,
      -6.3010695037287503E+000,
      -6.3339663222094726E+000,
      -6.3669025939886019E+000,
      -6.3998770187985272E+000,
      -6.4328882948654167E+000,
      -6.4659351189606165E+000,
      -6.4990161864521037E+000,
      -6.5321301913559537E+000,
      -6.5652758263879960E+000,
      -6.5984517830152596E+000,
      -6.6316567515078297E+000,
      -6.6648894209903791E+000,
      -6.6981484794940274E+000,
      -6.7314326140080949E+000,
      -6.7647405105319427E+000,
      -6.7980708541268466E+000,
      -6.8314223289679248E+000,
      -6.8647936183960354E+000,
      -6.8981834049698323E+000,
      -6.9315903705176956E+000,
      -6.9650131961898376E+000,
      -6.9984505625103282E+000,
      -7.0319011494292001E+000,
      -7.0653636363745571E+000,
      -7.0988367023047232E+000,
      -7.1323190257603404E+000,
      -7.1658092849166568E+000,
      -7.1993061576355304E+000,
      -7.2328083215178269E+000,
      -7.2663144539554549E+000,
      -7.2998232321836856E+000,
      -7.3333333333333313E+000,
      -7.3668434344829761E+000,
      -7.4003522127112067E+000,
      -7.4338583451488445E+000,
      -7.4673605090311321E+000,
      -7.5008573817500244E+000,
      -7.5343476409063213E+000,
      -7.5678299643619482E+000,
      -7.6013030302921045E+000,
      -7.6347655172374624E+000,
      -7.6682161041563335E+000,
      -7.7016534704768347E+000,
      -7.7350762961489670E+000,
      -7.7684832616968489E+000,
      -7.8018730482706262E+000,
      -7.8352443376987475E+000,
      -7.8685958125398150E+000,
      -7.9019261561347198E+000,
      -7.9352340526585667E+000,
      -7.9685181871726343E+000,
      -8.0017772456762835E+000,
      -8.0350099151588417E+000,
      -8.0682148836514020E+000,
      -8.1013908402786843E+000,
      -8.1345364753106999E+000,
      -8.1676504802145669E+000,
      -8.2007315477060470E+000,
      -8.2337783718012449E+000,
      -8.2667896478681353E+000,
      -8.2997640726780695E+000,
      -8.3327003444571996E+000,
      -8.3655971629379220E+000,
      -8.3984532294101673E+000,
      -8.4312672467726966E+000,
      -8.4640379195842943E+000,
      -8.4967639541148845E+000,
      -8.5294440583966971E+000,
      -8.5620769422751479E+000,
      -8.5946613174598578E+000,
      -8.6271958975754988E+000,
      -8.6596793982125568E+000,
      -8.6921105369780349E+000,
      -8.7244880335461126E+000,
      -8.7568106097086638E+000,
      -8.7890769894257357E+000,
      -8.8212858988758871E+000,
      -8.8534360665065375E+000,
      -8.8855262230841099E+000,
      -8.9175551017441883E+000,
      -8.9495214380414598E+000,
      -8.9814239699997174E+000,
      -9.0132614381616207E+000,
      -9.0450325856384541E+000,
      -9.0767361581596866E+000,
      -9.1083709041225944E+000,
      -9.1399355746415516E+000,
      -9.1714289235974196E+000,
      -9.2028497076867080E+000,
      -9.2341966864706713E+000,
      -9.2654686224242404E+000,
      -9.2966642809849453E+000,
      -9.3277824306015962E+000,
      -9.3588218427829410E+000,
      -9.3897812921461146E+000,
      -9.4206595564650755E+000,
      -9.4514554167188258E+000,
      -9.4821676571395361E+000,
      -9.5127950652605264E+000,
      -9.5433364319641818E+000,
      -9.5737905515296298E+000,
      -9.6041562216803893E+000,
      -9.6344322436317746E+000,
      -9.6646174221383081E+000,
      -9.6947105655408059E+000,
      -9.7247104858135103E+000,
      -9.7546159986109089E+000,
      -9.7844259233146040E+000,
      -9.8141390830797768E+000,
      -9.8437543048817684E+000,
      -9.8732704195623384E+000,
      -9.9026862618758145E+000,
      -9.9320006705351052E+000,
      -9.9612124882575532E+000,
      -9.9903205618106146E+000,
      -1.0019323742057392E+001,
      -1.0048220884001980E+001,
      -1.0077010846834700E+001,
      -1.0105692493977115E+001,
      -1.0134264693126914E+001,
      -1.0162726316302575E+001,
      -1.0191076239887982E+001,
      -1.0219313344676669E+001,
      -1.0247436515916105E+001,
      -1.0275444643351623E+001,
      -1.0303336621270336E+001,
      -1.0331111348544695E+001,
      -1.0358767728676034E+001,
      -1.0386304669837813E+001,
      -1.0413721084918762E+001,
      -1.0441015891565739E+001,
      -1.0468188012226520E+001,
      -1.0495236374192311E+001,
      -1.0522159909640102E+001,
      -1.0548957555674798E+001,
      -1.0575628254371228E+001,
      -1.0602170952815870E+001,
      -1.0628584603148454E+001,
      -1.0654868162603259E+001,
      -1.0681020593550402E+001,
      -1.0707040863536662E+001,
      -1.0732927945326351E+001,
      -1.0758680816941780E+001,
      -1.0784298461703704E+001,
      -1.0809779868271352E+001,
      -1.0835124030682431E+001,
      -1.0860329948392808E+001,
      -1.0885396626316009E+001,
      -1.0910323074862509E+001,
      -1.0935108309978796E+001,
      -1.0959751353186231E+001,
      -1.0984251231619677E+001,
      -1.1008606978065860E+001,
      -1.1032817631001627E+001,
      -1.1056882234631853E+001,
      -1.1080799838927199E+001,
      -1.1104569499661583E+001,
      -1.1128190278449523E+001,
      -1.1151661242783099E+001,
      -1.1174981466068841E+001,
      -1.1198150027664244E+001,
      -1.1221166012914196E+001,
      -1.1244028513186986E+001,
      -1.1266736625910260E+001,
      -1.1289289454606607E+001,
      -1.1311686108928972E+001,
      -1.1333925704695783E+001,
      -1.1356007363925887E+001,
      -1.1377930214873182E+001,
      -1.1399693392061058E+001,
      -1.1421296036316535E+001,
      -1.1442737294804211E+001,
      -1.1464016321059912E+001,
      -1.1485132275024128E+001,
      -1.1506084323075140E+001,
      -1.1526871638061968E+001,
      -1.1547493399337014E+001,
      -1.1567948792788460E+001,
      -1.1588237010872374E+001,
      -1.1608357252644677E+001,
      -1.1628308723792651E+001,
      -1.1648090636666387E+001,
      -1.1667702210309832E+001,
      -1.1687142670491649E+001,
      -1.1706411249735746E+001,
      -1.1725507187351612E+001,
      -1.1744429729464327E+001,
      -1.1763178129044336E+001,
      -1.1781751645936914E+001,
      -1.1800149546891419E+001,
      -1.1818371105590234E+001,
      -1.1836415602677413E+001,
      -1.1854282325787114E+001,
      -1.1871970569571685E+001,
      -1.1889479635729574E+001,
      -1.1906808833032812E+001,
      -1.1923957477354364E+001,
      -1.1940924891695119E+001,
      -1.1957710406210612E+001,
      -1.1974313358237469E+001,
      -1.1990733092319573E+001,
      -1.2006968960233937E+001,
      -1.2023020321016302E+001,
      -1.2038886540986418E+001,
      -1.2054566993773093E+001,
      -1.2070061060338903E+001,
      -1.2085368129004630E+001,
      -1.2100487595473403E+001,
      -1.2115418862854591E+001,
      -1.2130161341687311E+001,
      -1.2144714449963748E+001,
      -1.2159077613152100E+001,
      -1.2173250264219289E+001,
      -1.2187231843653310E+001,
      -1.2201021799485346E+001,
      -1.2214619587311558E+001,
      -1.2228024670314568E+001,
      -1.2241236519284641E+001,
      -1.2254254612640610E+001,
      -1.2267078436450442E+001,
      -1.2279707484451528E+001,
      -1.2292141258070673E+001,
      -1.2304379266443792E+001,
      -1.2316421026435263E+001,
      -1.2328266062657027E+001,
      -1.2339913907487329E+001,
      -1.2351364101089203E+001,
      -1.2362616191428611E+001,
      -1.2373669734292294E+001,
      -1.2384524293305299E+001,
      -1.2395179439948238E+001,
      -1.2405634753574152E+001,
      -1.2415889821425166E+001,
      -1.2425944238648761E+001,
      -1.2435797608313763E+001,
      -1.2445449541426006E+001,
      -1.2454899656943697E+001,
      -1.2464147581792457E+001,
      -1.2473192950880053E+001,
      -1.2482035407110795E+001,
      -1.2490674601399654E+001,
      -1.2499110192686032E+001,
      -1.2507341847947233E+001,
      -1.2515369242211595E+001,
      -1.2523192058571343E+001,
      -1.2530809988195077E+001,
      -1.2538222730339989E+001,
      -1.2545429992363697E+001,
      -1.2552431489735852E+001,
      -1.2559226946049316E+001,
      -1.2565816093031115E+001,
      -1.2572198670553007E+001,
      -1.2578374426641759E+001,
      -1.2584343117489095E+001,
      -1.2590104507461323E+001,
      -1.2595658369108630E+001,
      -1.2601004483174069E+001,
      -1.2606142638602208E+001,
      -1.2611072632547472E+001,
      -1.2615794270382139E+001,
      -1.2620307365704035E+001,
      -1.2624611740343884E+001,
      -1.2628707224372340E+001,
      -1.2632593656106714E+001,
      -1.2636270882117330E+001,
      -1.2639738757233602E+001,
      -1.2642997144549762E+001,
      -1.2646045915430253E+001,
      -1.2648884949514828E+001,
      -1.2651514134723275E+001,
      -1.2653933367259869E+001,
      -1.2656142551617448E+001,
      -1.2658141600581201E+001,
      -1.2659930435232095E+001,
      -1.2661508984949998E+001,
      -1.2662877187416477E+001,
      -1.2664034988617235E+001,
      -1.2664982342844267E+001,
      -1.2665719212697651E+001,
      -1.2666245569087021E+001,
      -1.2666561391232731E+001,
      -1.2666666666666668E+001,
      -1.2666561391232731E+001,
      -1.2666245569087021E+001,
      -1.2665719212697649E+001,
      -1.2664982342844267E+001,
      -1.2664034988617235E+001,
      -1.2662877187416477E+001,
      -1.2661508984949998E+001,
      -1.2659930435232095E+001,
      -1.2658141600581201E+001,
      -1.2656142551617448E+001,
      -1.2653933367259869E+001,
      -1.2651514134723275E+001,
      -1.2648884949514828E+001,
      -1.2646045915430253E+001,
      -1.2642997144549762E+001,
      -1.2639738757233603E+001,
      -1.2636270882117330E+001,
      -1.2632593656106714E+001,
      -1.2628707224372340E+001,
      -1.2624611740343884E+001,
      -1.2620307365704035E+001,
      -1.2615794270382143E+001,
      -1.2611072632547472E+001,
      -1.2606142638602210E+001,
      -1.2601004483174069E+001,
      -1.2595658369108632E+001,
      -1.2590104507461323E+001,
      -1.2584343117489098E+001,
      -1.2578374426641759E+001,
      -1.2572198670553007E+001,
      -1.2565816093031117E+001,
      -1.2559226946049318E+001,
      -1.2552431489735852E+001,
      -1.2545429992363699E+001,
      -1.2538222730339989E+001,
      -1.2530809988195081E+001,
      -1.2523192058571340E+001,
      -1.2515369242211596E+001,
      -1.2507341847947233E+001,
      -1.2499110192686032E+001,
      -1.2490674601399652E+001,
      -1.2482035407110796E+001,
      -1.2473192950880053E+001,
      -1.2464147581792458E+001,
      -1.2454899656943697E+001,
      -1.2445449541426006E+001,
      -1.2435797608313763E+001,
      -1.2425944238648762E+001,
      -1.2415889821425168E+001,
      -1.2405634753574153E+001,
      -1.2395179439948238E+001,
      -1.2384524293305303E+001,
      -1.2373669734292292E+001,
      -1.2362616191428611E+001,
      -1.2351364101089203E+001,
      -1.2339913907487333E+001,
      -1.2328266062657027E+001,
      -1.2316421026435265E+001,
      -1.2304379266443791E+001,
      -1.2292141258070677E+001,
      -1.2279707484451526E+001,
      -1.2267078436450445E+001,
      -1.2254254612640615E+001,
      -1.2241236519284644E+001,
      -1.2228024670314566E+001,
      -1.2214619587311560E+001,
      -1.2201021799485350E+001,
      -1.2187231843653313E+001,
      -1.2173250264219289E+001,
      -1.2159077613152103E+001,
      -1.2144714449963748E+001,
      -1.2130161341687314E+001,
      -1.2115418862854588E+001,
      -1.2100487595473405E+001,
      -1.2085368129004628E+001,
      -1.2070061060338904E+001,
      -1.2054566993773092E+001,
      -1.2038886540986420E+001,
      -1.2023020321016299E+001,
      -1.2006968960233941E+001,
      -1.1990733092319577E+001,
      -1.1974313358237472E+001,
      -1.1957710406210612E+001,
      -1.1940924891695122E+001,
      -1.1923957477354367E+001,
      -1.1906808833032814E+001,
      -1.1889479635729572E+001,
      -1.1871970569571689E+001,
      -1.1854282325787111E+001,
      -1.1836415602677416E+001,
      -1.1818371105590231E+001,
      -1.1800149546891422E+001,
      -1.1781751645936918E+001,
      -1.1763178129044334E+001,
      -1.1744429729464331E+001,
      -1.1725507187351615E+001,
      -1.1706411249735750E+001,
      -1.1687142670491646E+001,
      -1.1667702210309836E+001,
      -1.1648090636666389E+001,
      -1.1628308723792655E+001,
      -1.1608357252644675E+001,
      -1.1588237010872378E+001,
      -1.1567948792788457E+001,
      -1.1547493399337020E+001,
      -1.1526871638061964E+001,
      -1.1506084323075143E+001,
      -1.1485132275024128E+001,
      -1.1464016321059916E+001,
      -1.1442737294804207E+001,
      -1.1421296036316539E+001,
      -1.1399693392061057E+001,
      -1.1377930214873185E+001,
      -1.1356007363925890E+001,
      -1.1333925704695787E+001,
      -1.1311686108928972E+001,
      -1.1289289454606610E+001,
      -1.1266736625910264E+001,
      -1.1244028513186992E+001,
      -1.1221166012914193E+001,
      -1.1198150027664248E+001,
      -1.1174981466068838E+001,
      -1.1151661242783103E+001,
      -1.1128190278449519E+001,
      -1.1104569499661588E+001,
      -1.1080799838927195E+001,
      -1.1056882234631857E+001,
      -1.1032817631001624E+001,
      -1.1008606978065865E+001,
      -1.0984251231619673E+001,
      -1.0959751353186238E+001,
      -1.0935108309978800E+001,
      -1.0910323074862513E+001,
      -1.0885396626316007E+001,
      -1.0860329948392812E+001,
      -1.0835124030682437E+001,
      -1.0809779868271356E+001,
      -1.0784298461703701E+001,
      -1.0758680816941784E+001,
      -1.0732927945326347E+001,
      -1.0707040863536665E+001,
      -1.0681020593550398E+001,
      -1.0654868162603266E+001,
      -1.0628584603148450E+001,
      -1.0602170952815879E+001,
      -1.0575628254371225E+001,
      -1.0548957555674804E+001,
      -1.0522159909640100E+001,
      -1.0495236374192318E+001,
      -1.0468188012226527E+001,
      -1.0441015891565746E+001,
      -1.0413721084918759E+001,
      -1.0386304669837816E+001,
      -1.0358767728676037E+001,
      -1.0331111348544701E+001,
      -1.0303336621270335E+001,
      -1.0275444643351628E+001,
      -1.0247436515916101E+001,
      -1.0219313344676673E+001,
      -1.0191076239887979E+001,
      -1.0162726316302580E+001,
      -1.0134264693126912E+001,
      -1.0105692493977118E+001,
      -1.0077010846834696E+001,
      -1.0048220884001987E+001,
      -1.0019323742057390E+001,
      -9.9903205618106181E+000,
      -9.9612124882575586E+000,
      -9.9320006705351087E+000,
      -9.9026862618758109E+000,
      -9.8732704195623420E+000,
      -9.8437543048817773E+000,
      -9.8141390830797821E+000,
      -9.7844259233145987E+000,
      -9.7546159986109160E+000,
      -9.7247104858135085E+000,
      -9.6947105655408095E+000,
      -9.6646174221383045E+000,
      -9.6344322436317782E+000,
      -9.6041562216803857E+000,
      -9.5737905515296333E+000,
      -9.5433364319641782E+000,
      -9.5127950652605335E+000,
      -9.4821676571395326E+000,
      -9.4514554167188312E+000,
      -9.4206595564650737E+000,
      -9.3897812921461199E+000,
      -9.3588218427829375E+000,
      -9.3277824306016015E+000,
      -9.2966642809849507E+000,
      -9.2654686224242493E+000,
      -9.2341966864706677E+000,
      -9.2028497076867133E+000,
      -9.1714289235974249E+000,
      -9.1399355746415551E+000,
      -9.1083709041225909E+000,
      -9.0767361581596919E+000,
      -9.0450325856384506E+000,
      -9.0132614381616278E+000,
      -8.9814239699997138E+000,
      -8.9495214380414669E+000,
      -8.9175551017441848E+000,
      -8.8855262230841170E+000,
      -8.8534360665065339E+000,
      -8.8212858988758942E+000,
      -8.7890769894257321E+000,
      -8.7568106097086691E+000,
      -8.7244880335461179E+000,
      -8.6921105369780420E+000,
      -8.6596793982125533E+000,
      -8.6271958975755059E+000,
      -8.5946613174598667E+000,
      -8.5620769422751515E+000,
      -8.5294440583966935E+000,
      -8.4967639541148916E+000,
      -8.4640379195842907E+000,
      -8.4312672467727001E+000,
      -8.3984532294101637E+000,
      -8.3655971629379273E+000,
      -8.3327003444572068E+000,
      -8.2997640726780659E+000,
      -8.2667896478681406E+000,
      -8.2337783718012503E+000,
      -8.2007315477060523E+000,
      -8.1676504802145633E+000,
      -8.1345364753107052E+000,
      -8.1013908402786807E+000,
      -8.0682148836514092E+000,
      -8.0350099151588381E+000,
      -8.0017772456762888E+000,
      -7.9685181871726414E+000,
      -7.9352340526585721E+000,
      -7.9019261561347163E+000,
      -7.8685958125398212E+000,
      -7.8352443376987440E+000,
      -7.8018730482706333E+000,
      -7.7684832616968453E+000,
      -7.7350762961489812E+000,
      -7.7016534704768311E+000,
      -7.6682161041563397E+000,
      -7.6347655172374678E+000,
      -7.6013030302921099E+000,
      -7.5678299643619447E+000,
      -7.5343476409063177E+000,
      -7.5008573817500208E+000,
      -7.4673605090311383E+000,
      -7.4338583451488409E+000,
      -7.4003522127112138E+000,
      -7.3668434344829823E+000,
      -7.3333333333333366E+000,
      -7.2998232321836811E+000,
      -7.2663144539554603E+000,
      -7.2328083215178234E+000,
      -7.1993061576355357E+000,
      -7.1658092849166444E+000,
      -7.1323190257603555E+000,
      -7.0988367023047196E+000,
      -7.0653636363745642E+000,
      -7.0319011494292063E+000,
      -6.9984505625103344E+000,
      -6.9650131961898332E+000,
      -6.9315903705176920E+000,
      -6.8981834049698287E+000,
      -6.8647936183960407E+000,
      -6.8314223289679203E+000,
      -6.7980708541268537E+000,
      -6.7647405105319480E+000,
      -6.7314326140081002E+000,
      -6.6981484794940247E+000,
      -6.6648894209903853E+000,
      -6.6316567515078271E+000,
      -6.5984517830152658E+000,
      -6.5652758263879836E+000,
      -6.5321301913559680E+000,
      -6.4990161864521001E+000,
      -6.4659351189606218E+000,
      -6.4328882948654229E+000,
      -6.3998770187985325E+000,
      -6.3669025939885984E+000,
      -6.3339663222094691E+000,
      -6.3010695037287467E+000,
      -6.2682134372564997E+000,
      -6.2353994198939633E+000,
      -6.2026287470823736E+000,
      -6.1699027125517736E+000,
      -6.1372226082699690E+000,
      -6.1045897243915128E+000,
      -6.0720053492068091E+000,
      -6.0394707690911602E+000,
      -6.0069872684541101E+000,
      -5.9745561296886223E+000,
      -5.9421786331205553E+000,
      -5.9098560569579952E+000,
      -5.8775896772409331E+000,
      -5.8453807677907790E+000,
      -5.8132306001601322E+000,
      -5.7811404435825384E+000,
      -5.7491115649224893E+000,
      -5.7171452286251982E+000,
      -5.6852426966669594E+000,
      -5.6534052285050373E+000,
      -5.6216340810282146E+000,
      -5.5899305085069741E+000,
      -5.5582957625440734E+000,
      -5.5267310920251171E+000,
      -5.4952377430692483E+000,
      -5.4638169589799599E+000,
      -5.4324699801959886E+000,
      -5.4011980442424168E+000,
      -5.3700023856817145E+000,
      -5.3388842360650628E+000,
      -5.3078448238837277E+000,
      -5.2768853745205533E+000,
      -5.2460071102015915E+000,
      -5.2152112499478251E+000,
      -5.1844990095271406E+000,
      -5.1538716014061317E+000,
      -5.1233302347024967E+000,
      -5.0928761151370292E+000,
      -5.0625104449862777E+000,
      -5.0322344230348852E+000,
      -5.0020492445283598E+000,
      -4.9719561011258619E+000,
      -4.9419561808531505E+000,
      -4.9120506680557581E+000,
      -4.8822407433520567E+000,
      -4.8525275835868840E+000,
      -4.8229123617848888E+000,
      -4.7933962471043223E+000,
      -4.7639804047908516E+000,
      -4.7346659961315627E+000,
      -4.7054541784091155E+000,
      -4.6763461048560373E+000,
      -4.6473429246092826E+000,
      -4.6184457826646783E+000,
      -4.5896558198319761E+000,
      -4.5609741726895452E+000,
      -4.5324019735397538E+000,
      -4.5039403503640854E+000,
      -4.4755904267786866E+000,
      -4.4473533219899988E+000,
      -4.4192301507505549E+000,
      -4.3912220233150450E+000,
      -4.3633300453963235E+000,
      -4.3355553181219646E+000,
      -4.3078989379906281E+000,
      -4.2803619968288613E+000,
      -4.2529455817479063E+000,
      -4.2256507751009291E+000,
      -4.1984786544401462E+000,
      -4.1714302924743549E+000,
      -4.1445067570265719E+000,
      -4.1177091109918607E+000,
      -4.0910384122954477E+000,
      -4.0644957138507882E+000,
      -4.0380820635182149E+000,
      -4.0117985040633997E+000,
      -3.9856460731162646E+000,
      -3.9596258031300056E+000,
      -3.9337387213403110E+000,
      -3.9079858497248892E+000,
      -3.8823682049629564E+000,
      -3.8568867983953217E+000,
      -3.8315426359842282E+000,
      -3.8063367182738688E+000,
      -3.7812700403506572E+000,
      -3.7563435918041610E+000,
      -3.7315583566878723E+000,
      -3.7069153134804349E+000,
      -3.6824154350469991E+000,
      -3.6580596886008010E+000,
      -3.6338490356650488E+000,
      -3.6097844320348087E+000,
      -3.5858668277394687E+000,
      -3.5620971670050792E+000,
      -3.5384763882171457E+000,
      -3.5150054238835695E+000,
      -3.4916852005978205E+000,
      -3.4685166390024231E+000,
      -3.4455006537524651E+000,
      -3.4226381534796877E+000,
      -3.3999300407564021E+000,
      -3.3773772120600678E+000,
      -3.3549805577376941E+000,
      -3.3327409619708828E+000,
      -3.3106593027407811E+000,
      -3.2887364517934867E+000,
      -3.2669732746056162E+000,
      -3.2453706303501275E+000,
      -3.2239293718624644E+000,
      -3.2026503456067492E+000,
      -3.1815343916425389E+000,
      -3.1605823435915292E+000,
      -3.1397950286047003E+000,
      -3.1191732673296531E+000,
      -3.0987178738782033E+000,
      -3.0784296557942921E+000,
      -3.0583094140219851E+000,
      -3.0383579428740224E+000,
      -3.0185760300002769E+000,
      -2.9989644563568416E+000,
      -2.9795239961750180E+000,
      -2.9602554169309210E+000,
      -2.9411594793150551E+000,
      -2.9222369372023391E+000,
      -2.9034885376223358E+000,
      -2.8849150207297485E+000,
      -2.8665171197752497E+000,
      -2.8482955610764287E+000,
      -2.8302510639892504E+000,
      -2.8123843408795546E+000,
      -2.7946960970949770E+000,
      -2.7771870309370943E+000,
      -2.7598578336338471E+000,
      -2.7427091893123046E+000,
      -2.7257417749715400E+000,
      -2.7089562604560582E+000,
      -2.6923533084291935E+000,
      -2.6759335743470993E+000,
      -2.6596977064327261E+000,
      -2.6436463456503674E+000,
      -2.6277801256802507E+000,
      -2.6120996728935735E+000,
      -2.5966056063277647E+000,
      -2.5812985376620330E+000,
      -2.5661790711932642E+000,
      -2.5512478038120725E+000,
      -2.5365053249793528E+000,
      -2.5219522167029171E+000,
      -2.5075890535145624E+000,
      -2.4934164024473775E+000,
      -2.4794348230133498E+000,
      -2.4656448671813216E+000,
      -2.4520470793551019E+000,
      -2.4386419963521044E+000,
      -2.4254301473820221E+000,
      -2.4124120540260594E+000,
      -2.3995882302162226E+000,
      -2.3869591822151390E+000,
      -2.3745254085959928E+000,
      -2.3622874002228760E+000,
      -2.3502456402314040E+000,
      -2.3384006040096366E+000,
      -2.3267527591793420E+000,
      -2.3153025655774613E+000,
      -2.3040504752380548E+000,
      -2.2929969323743733E+000,
      -2.2821423733613631E+000,
      -2.2714872267184290E+000,
      -2.2610319130925096E+000,
      -2.2507768452415018E+000,
      -2.2407224280179006E+000,
      -2.2308690583529072E+000,
      -2.2212171252406598E+000,
      -2.2117670097229740E+000,
      -2.2025190848742078E+000,
      -2.1934737157866149E+000,
      -2.1846312595558732E+000,
      -2.1759920652670139E+000,
      -2.1675564739806354E+000,
      -2.1593248187194325E+000,
      -2.1512974244550742E+000,
      -2.1434746080953233E+000,
      -2.1358566784715873E+000,
      -2.1284439363266796E+000,
      -2.1212366743029678E+000,
      -2.1142351769308161E+000,
      -2.1074397206173474E+000,
      -2.1008505736355527E+000,
      -2.0944679961136581E+000,
      -2.0882922400249102E+000,
      -2.0823235491775698E+000,
      -2.0765621592053467E+000,
      -2.0710082975580368E+000,
      -2.0656621834925986E+000,
      -2.0605240280644588E+000,
      -2.0555940341191952E+000,
      -2.0508723962845274E+000,
      -2.0463593009626302E+000,
      -2.0420549263227858E+000,
      -2.0379594422943264E+000,
      -2.0340730105599567E+000,
      -2.0303957845493392E+000,
      -2.0269279094330677E+000,
      -2.0236695221169065E+000,
      -2.0206207512364136E+000,
      -2.0177817171518417E+000,
      -2.0151525319433929E+000,
      -2.0127332994067992E+000,
      -2.0105241150492179E+000,
      -2.0085250660854665E+000,
      -2.0067362314345734E+000,
      -2.0051576817166685E+000,
      -2.0037894792501909E+000,
      -2.0026316780494327E+000,
      -2.0016843238224005E+000,
      -2.0009474539690180E+000,
      -2.0004210975796477E+000,
      -2.0001052754339352E+000,
      -2.0,
      -2.0001052754339352E+000,
      -2.0004210975796477E+000,
      -2.0009474539690193E+000,
      -2.0016843238224005E+000,
      -2.0026316780494318E+000,
      -2.0037894792501909E+000,
      -2.0051576817166676E+000,
      -2.0067362314345734E+000,
      -2.0085250660854665E+000,
      -2.0105241150492179E+000,
      -2.0127332994067983E+000,
      -2.0151525319433929E+000,
      -2.0177817171518408E+000,
      -2.0206207512364136E+000,
      -2.0236695221169083E+000,
      -2.0269279094330646E+000,
      -2.0303957845493401E+000,
      -2.0340730105599558E+000,
      -2.0379594422943277E+000,
      -2.0420549263227832E+000,
      -2.0463593009626311E+000,
      -2.0508723962845292E+000,
      -2.0555940341191943E+000,
      -2.0605240280644579E+000,
      -2.0656621834926003E+000,
      -2.0710082975580386E+000,
      -2.0765621592053418E+000,
      -2.0823235491775720E+000,
      -2.0882922400249053E+000,
      -2.0944679961136599E+000,
      -2.1008505736355505E+000,
      -2.1074397206173492E+000,
      -2.1142351769308179E+000,
      -2.1212366743029669E+000,
      -2.1284439363266832E+000,
      -2.1358566784715856E+000,
      -2.1434746080953260E+000,
      -2.1512974244550733E+000,
      -2.1593248187194352E+000,
      -2.1675564739806337E+000,
      -2.1759920652670122E+000,
      -2.1846312595558710E+000,
      -2.1934737157866131E+000,
      -2.2025190848742113E+000,
      -2.2117670097229665E+000,
      -2.2212171252406638E+000,
      -2.2308690583529049E+000,
      -2.2407224280179041E+000,
      -2.2507768452414996E+000,
      -2.2610319130925132E+000,
      -2.2714872267184330E+000,
      -2.2821423733613613E+000,
      -2.2929969323743711E+000,
      -2.3040504752380584E+000,
      -2.3153025655774662E+000,
      -2.3267527591793331E+000,
      -2.3384006040096410E+000,
      -2.3502456402313947E+000,
      -2.3622874002228733E+000,
      -2.3745254085959902E+000,
      -2.3869591822151373E+000,
      -2.3995882302162275E+000,
      -2.4124120540260492E+000,
      -2.4254301473820266E+000,
      -2.4386419963520942E+000,
      -2.4520470793551068E+000,
      -2.4656448671813176E+000,
      -2.4794348230133556E+000,
      -2.4934164024473739E+000,
      -2.5075890535145593E+000,
      -2.5219522167029220E+000,
      -2.5365053249793492E+000,
      -2.5512478038120783E+000,
      -2.5661790711932531E+000,
      -2.5812985376620383E+000,
      -2.5966056063277621E+000,
      -2.6120996728935708E+000,
      -2.6277801256802560E+000,
      -2.6436463456503634E+000,
      -2.6596977064327327E+000,
      -2.6759335743470865E+000,
      -2.6923533084291988E+000,
      -2.7089562604560551E+000,
      -2.7257417749715454E+000,
      -2.7427091893122997E+000,
      -2.7598578336338537E+000,
      -2.7771870309370996E+000,
      -2.7946960970949730E+000,
      -2.8123843408795519E+000,
      -2.8302510639892469E+000,
      -2.8482955610764353E+000,
      -2.8665171197752461E+000,
      -2.8849150207297551E+000,
      -2.9034885376223425E+000,
      -2.9222369372023356E+000,
      -2.9411594793150502E+000,
      -2.9602554169309174E+000,
      -2.9795239961750135E+000,
      -2.9989644563568256E+000,
      -3.0185760300002835E+000,
      -3.0383579428740077E+000,
      -3.0583094140219926E+000,
      -3.0784296557942876E+000,
      -3.0987178738782104E+000,
      -3.1191732673296486E+000,
      -3.1397950286046954E+000,
      -3.1605823435915368E+000,
      -3.1815343916425349E+000,
      -3.2026503456067572E+000,
      -3.2239293718624600E+000,
      -3.2453706303501355E+000,
      -3.2669732746056113E+000,
      -3.2887364517934814E+000,
      -3.3106593027407767E+000,
      -3.3327409619708783E+000,
      -3.3549805577377021E+000,
      -3.3773772120600505E+000,
      -3.3999300407564101E+000,
      -3.4226381534796828E+000,
      -3.4455006537524731E+000,
      -3.4685166390024178E+000,
      -3.4916852005978285E+000,
      -3.5150054238835775E+000,
      -3.5384763882171404E+000,
      -3.5620971670050876E+000,
      -3.5858668277394772E+000,
      -3.6097844320348171E+000,
      -3.6338490356650435E+000,
      -3.6580596886008099E+000,
      -3.6824154350469800E+000,
      -3.7069153134804296E+000,
      -3.7315583566878665E+000,
      -3.7563435918041552E+000,
      -3.7812700403506661E+000,
      -3.8063367182738626E+000,
      -3.8315426359842375E+000,
      -3.8568867983953026E+000,
      -3.8823682049629653E+000,
      -3.9079858497248834E+000,
      -3.9337387213403199E+000,
      -3.9596258031300002E+000,
      -3.9856460731162597E+000,
      -4.0117985040634085E+000,
      -4.0380820635182086E+000,
      -4.0644957138507971E+000,
      -4.0910384122954264E+000,
      -4.1177091109918704E+000,
      -4.1445067570265666E+000,
      -4.1714302924743496E+000,
      -4.1984786544401560E+000,
      -4.2256507751009229E+000,
      -4.2529455817479151E+000,
      -4.2803619968288409E+000,
      -4.3078989379906378E+000,
      -4.3355553181219735E+000,
      -4.3633300453963324E+000,
      -4.3912220233150387E+000,
      -4.4192301507505638E+000,
      -4.4473533219900094E+000,
      -4.4755904267786795E+000,
      -4.5039403503640942E+000,
      -4.5324019735397476E+000,
      -4.5609741726895567E+000,
      -4.5896558198319699E+000,
      -4.6184457826646899E+000,
      -4.6473429246092923E+000,
      -4.6763461048560480E+000,
      -4.7054541784091093E+000,
      -4.7346659961315565E+000,
      -4.7639804047908445E+000,
      -4.7933962471043330E+000,
      -4.8229123617849003E+000,
      -4.8525275835868760E+000,
      -4.8822407433520674E+000,
      -4.9120506680557341E+000,
      -4.9419561808531602E+000,
      -4.9719561011258557E+000,
      -5.0020492445283526E+000,
      -5.0322344230348968E+000,
      -5.0625104449862706E+000,
      -5.0928761151370407E+000,
      -5.1233302347024727E+000,
      -5.1538716014061414E+000,
      -5.1844990095271335E+000,
      -5.2152112499478358E+000,
      -5.2460071102015835E+000,
      -5.2768853745205480E+000,
      -5.3078448238837383E+000,
      -5.3388842360650557E+000,
      -5.3700023856817252E+000,
      -5.4011980442424106E+000,
      -5.4324699801959992E+000,
      -5.4638169589799528E+000,
      -5.4952377430692412E+000,
      -5.5267310920251278E+000,
      -5.5582957625440672E+000,
      -5.5899305085069848E+000,
      -5.6216340810282075E+000,
      -5.6534052285050311E+000,
      -5.6852426966669523E+000,
      -5.7171452286252089E+000,
      -5.7491115649224636E+000,
      -5.7811404435825500E+000,
      -5.8132306001601428E+000,
      -5.8453807677907728E+000,
      -5.8775896772409251E+000,
      -5.9098560569579890E+000,
      -5.9421786331205579E+000,
      -5.9745561296886160E+000,
      -6.0069872684541119E+000,
      -6.0394707690911620E+000,
      -6.0720053492068011E+000,
      -6.1045897243915146E+000,
      -6.1372226082699628E+000,
      -6.1699027125517674E+000,
      -6.2026287470823673E+000,
      -6.2353994198939739E+000,
      -6.2682134372564837E+000,
      -6.3010695037287494E+000,
      -6.3339663222094709E+000,
      -6.3669025939886001E+000,
      -6.3998770187985263E+000,
      -6.4328882948654149E+000,
      -6.4659351189606324E+000,
      -6.4990161864520939E+000,
      -6.5321301913559706E+000,
      -6.5652758263879951E+000,
      -6.5984517830152685E+000,
      -6.6316567515078289E+000,
      -6.6648894209903782E+000,
      -6.6981484794940078E+000,
      -6.7314326140080940E+000,
      -6.7647405105319605E+000,
      -6.7980708541268458E+000,
      -6.8314223289679328E+000,
      -6.8647936183960425E+000,
      -6.8981834049698305E+000,
      -6.9315903705176751E+000,
      -6.9650131961898367E+000,
      -6.9984505625103459E+000,
      -7.0319011494291983E+000,
      -7.0653636363745562E+000,
      -7.0988367023047312E+000,
      -7.1323190257603581E+000,
      -7.1658092849166364E+000,
      -7.1993061576355384E+000,
      -7.2328083215178065E+000,
      -7.2663144539554532E+000,
      -7.2998232321836847E+000,
      -7.3333333333333304E+000,
      -7.3668434344829938E+000,
      -7.4003522127112058E+000,
      -7.4338583451488534E+000,
      -7.4673605090311215E+000,
      -7.5008573817500226E+000,
      -7.5343476409063204E+000,
      -7.5678299643619473E+000,
      -7.6013030302921027E+000,
      -7.6347655172374616E+000,
      -7.6682161041563512E+000,
      -7.7016534704768231E+000,
      -7.7350762961489830E+000,
      -7.7684832616968285E+000,
      -7.8018730482706360E+000,
      -7.8352443376987457E+000,
      -7.8685958125398141E+000,
      -7.9019261561347367E+000,
      -7.9352340526585659E+000,
      -7.9685181871726520E+000,
      -8.0017772456762817E+000,
      -8.0350099151588310E+000,
      -8.0682148836514109E+000,
      -8.1013908402786825E+000,
      -8.1345364753106892E+000,
      -8.1676504802145669E+000,
      -8.2007315477060647E+000,
      -8.2337783718012449E+000,
      -8.2667896478681335E+000,
      -8.2997640726780588E+000,
      -8.3327003444572085E+000,
      -8.3655971629379096E+000,
      -8.3984532294101761E+000,
      -8.4312672467727232E+000,
      -8.4640379195842925E+000,
      -8.4967639541148934E+000,
      -8.5294440583966953E+000,
      -8.5620769422751444E+000,
      -8.5946613174598578E+000,
      -8.6271958975755165E+000,
      -8.6596793982125480E+000,
      -8.6921105369780456E+000,
      -8.7244880335461197E+000,
      -8.7568106097086709E+000,
      -8.7890769894257339E+000,
      -8.8212858988758853E+000,
      -8.8534360665065517E+000,
      -8.8855262230841099E+000,
      -8.9175551017441954E+000,
      -8.9495214380414509E+000,
      -8.9814239699997067E+000,
      -9.0132614381616278E+000,
      -9.0450325856384524E+000,
      -9.0767361581596742E+000,
      -9.1083709041225926E+000,
      -9.1399355746415676E+000,
      -9.1714289235974178E+000,
      -9.2028497076867080E+000,
      -9.2341966864706606E+000,
      -9.2654686224242493E+000,
      -9.2966642809849347E+000,
      -9.3277824306016033E+000,
      -9.3588218427829570E+000,
      -9.3897812921461128E+000,
      -9.4206595564650755E+000,
      -9.4514554167188241E+000,
      -9.4821676571395273E+000,
      -9.5127950652605193E+000,
      -9.5433364319641889E+000,
      -9.5737905515296191E+000,
      -9.6041562216803893E+000,
      -9.6344322436317817E+000,
      -9.6646174221383081E+000,
      -9.6947105655408059E+000,
      -9.7247104858134996E+000,
      -9.7546159986109267E+000,
      -9.7844259233145916E+000,
      -9.8141390830797839E+000,
      -9.8437543048817773E+000,
      -9.8732704195623455E+000,
      -9.9026862618758145E+000,
      -9.9320006705351052E+000,
      -9.9612124882575497E+000,
      -9.9903205618106146E+000,
      -1.0019323742057400E+001,
      -1.0048220884001973E+001,
      -1.0077010846834707E+001,
      -1.0105692493977122E+001,
      -1.0134264693126912E+001,
      -1.0162726316302566E+001,
      -1.0191076239887980E+001,
      -1.0219313344676683E+001,
      -1.0247436515916098E+001,
      -1.0275444643351621E+001,
      -1.0303336621270343E+001,
      -1.0331111348544701E+001,
      -1.0358767728676021E+001,
      -1.0386304669837820E+001,
      -1.0413721084918745E+001,
      -1.0441015891565739E+001,
      -1.0468188012226520E+001,
      -1.0495236374192311E+001,
      -1.0522159909640109E+001,
      -1.0548957555674791E+001,
      -1.0575628254371235E+001,
      -1.0602170952815863E+001,
      -1.0628584603148452E+001,
      -1.0654868162603266E+001,
      -1.0681020593550402E+001,
      -1.0707040863536662E+001,
      -1.0732927945326342E+001,
      -1.0758680816941792E+001,
      -1.0784298461703697E+001,
      -1.0809779868271360E+001,
      -1.0835124030682424E+001,
      -1.0860329948392812E+001,
      -1.0885396626316009E+001,
      -1.0910323074862506E+001,
      -1.0935108309978810E+001,
      -1.0959751353186231E+001,
      -1.0984251231619680E+001,
      -1.1008606978065853E+001,
      -1.1032817631001619E+001,
      -1.1056882234631859E+001,
      -1.1080799838927199E+001,
      -1.1104569499661572E+001,
      -1.1128190278449519E+001,
      -1.1151661242783110E+001,
      -1.1174981466068834E+001,
      -1.1198150027664244E+001,
      -1.1221166012914189E+001,
      -1.1244028513186992E+001,
      -1.1266736625910253E+001,
      -1.1289289454606610E+001,
      -1.1311686108928985E+001,
      -1.1333925704695783E+001,
      -1.1356007363925885E+001,
      -1.1377930214873180E+001,
      -1.1399693392061049E+001,
      -1.1421296036316527E+001,
      -1.1442737294804214E+001,
      -1.1464016321059905E+001,
      -1.1485132275024128E+001,
      -1.1506084323075140E+001,
      -1.1526871638061968E+001,
      -1.1547493399337013E+001,
      -1.1567948792788451E+001,
      -1.1588237010872387E+001,
      -1.1608357252644671E+001,
      -1.1628308723792655E+001,
      -1.1648090636666391E+001,
      -1.1667702210309837E+001,
      -1.1687142670491649E+001,
      -1.1706411249735746E+001,
      -1.1725507187351612E+001,
      -1.1744429729464327E+001,
      -1.1763178129044343E+001,
      -1.1781751645936907E+001,
      -1.1800149546891426E+001,
      -1.1818371105590238E+001,
      -1.1836415602677416E+001,
      -1.1854282325787112E+001,
      -1.1871970569571689E+001,
      -1.1889479635729582E+001,
      -1.1906808833032811E+001,
      -1.1923957477354364E+001,
      -1.1940924891695126E+001,
      -1.1957710406210618E+001,
      -1.1974313358237465E+001,
      -1.1990733092319577E+001,
      -1.2006968960233930E+001,
      -1.2023020321016300E+001,
      -1.2038886540986416E+001,
      -1.2054566993773093E+001,
      -1.2070061060338901E+001,
      -1.2085368129004626E+001,
      -1.2100487595473412E+001,
      -1.2115418862854586E+001,
      -1.2130161341687314E+001,
      -1.2144714449963748E+001,
      -1.2159077613152103E+001,
      -1.2173250264219289E+001,
      -1.2187231843653310E+001,
      -1.2201021799485346E+001,
      -1.2214619587311557E+001,
      -1.2228024670314570E+001,
      -1.2241236519284637E+001,
      -1.2254254612640615E+001,
      -1.2267078436450445E+001,
      -1.2279707484451526E+001,
      -1.2292141258070673E+001,
      -1.2304379266443791E+001,
      -1.2316421026435268E+001,
      -1.2328266062657024E+001,
      -1.2339913907487333E+001,
      -1.2351364101089207E+001,
      -1.2362616191428613E+001,
      -1.2373669734292292E+001,
      -1.2384524293305303E+001,
      -1.2395179439948231E+001,
      -1.2405634753574150E+001,
      -1.2415889821425166E+001,
      -1.2425944238648761E+001,
      -1.2435797608313766E+001,
      -1.2445449541426008E+001,
      -1.2454899656943697E+001,
      -1.2464147581792455E+001,
      -1.2473192950880053E+001,
      -1.2482035407110795E+001,
      -1.2490674601399654E+001,
      -1.2499110192686032E+001,
      -1.2507341847947229E+001,
      -1.2515369242211598E+001,
      -1.2523192058571338E+001,
      -1.2530809988195081E+001,
      -1.2538222730339983E+001,
      -1.2545429992363699E+001,
      -1.2552431489735852E+001,
      -1.2559226946049316E+001,
      -1.2565816093031119E+001,
      -1.2572198670553005E+001,
      -1.2578374426641759E+001,
      -1.2584343117489095E+001,
      -1.2590104507461323E+001,
      -1.2595658369108632E+001,
      -1.2601004483174069E+001,
      -1.2606142638602208E+001,
      -1.2611072632547472E+001,
      -1.2615794270382143E+001,
      -1.2620307365704035E+001,
      -1.2624611740343884E+001,
      -1.2628707224372338E+001,
      -1.2632593656106714E+001,
      -1.2636270882117330E+001,
      -1.2639738757233603E+001,
      -1.2642997144549762E+001,
      -1.2646045915430253E+001,
      -1.2648884949514825E+001,
      -1.2651514134723275E+001,
      -1.2653933367259867E+001,
      -1.2656142551617448E+001,
      -1.2658141600581201E+001,
      -1.2659930435232093E+001,
      -1.2661508984949998E+001,
      -1.2662877187416477E+001,
      -1.2664034988617235E+001,
      -1.2664982342844267E+001,
      -1.2665719212697649E+001,
      -1.2666245569087021E+001,
      -1.2666561391232731E+001,
      -1.2666666666666668E+001,
      -1.2666561391232731E+001,
      -1.2666245569087021E+001,
      -1.2665719212697649E+001,
      -1.2664982342844267E+001,
      -1.2664034988617235E+001,
      -1.2662877187416477E+001,
      -1.2661508984949998E+001,
      -1.2659930435232095E+001,
      -1.2658141600581201E+001,
      -1.2656142551617448E+001,
      -1.2653933367259869E+001,
      -1.2651514134723275E+001,
      -1.2648884949514828E+001,
      -1.2646045915430253E+001,
      -1.2642997144549762E+001,
      -1.2639738757233602E+001,
      -1.2636270882117326E+001,
      -1.2632593656106712E+001,
      -1.2628707224372340E+001,
      -1.2624611740343884E+001,
      -1.2620307365704038E+001,
      -1.2615794270382143E+001,
      -1.2611072632547472E+001,
      -1.2606142638602210E+001,
      -1.2601004483174069E+001,
      -1.2595658369108628E+001,
      -1.2590104507461323E+001,
      -1.2584343117489098E+001,
      -1.2578374426641759E+001,
      -1.2572198670553007E+001,
      -1.2565816093031117E+001,
      -1.2559226946049318E+001,
      -1.2552431489735854E+001,
      -1.2545429992363696E+001,
      -1.2538222730339990E+001,
      -1.2530809988195076E+001,
      -1.2523192058571347E+001,
      -1.2515369242211595E+001,
      -1.2507341847947233E+001,
      -1.2499110192686032E+001,
      -1.2490674601399654E+001,
      -1.2482035407110796E+001,
      -1.2473192950880049E+001,
      -1.2464147581792462E+001,
      -1.2454899656943695E+001,
      -1.2445449541426006E+001,
      -1.2435797608313763E+001,
      -1.2425944238648768E+001,
      -1.2415889821425168E+001,
      -1.2405634753574148E+001,
      -1.2395179439948240E+001,
      -1.2384524293305299E+001,
      -1.2373669734292296E+001,
      -1.2362616191428609E+001,
      -1.2351364101089210E+001,
      -1.2339913907487329E+001,
      -1.2328266062657034E+001,
      -1.2316421026435265E+001,
      -1.2304379266443789E+001,
      -1.2292141258070677E+001,
      -1.2279707484451523E+001,
      -1.2267078436450449E+001,
      -1.2254254612640610E+001,
      -1.2241236519284650E+001,
      -1.2228024670314566E+001,
      -1.2214619587311553E+001,
      -1.2201021799485350E+001,
      -1.2187231843653306E+001,
      -1.2173250264219293E+001,
      -1.2159077613152100E+001,
      -1.2144714449963752E+001,
      -1.2130161341687311E+001,
      -1.2115418862854600E+001,
      -1.2100487595473405E+001,
      -1.2085368129004621E+001,
      -1.2070061060338906E+001,
      -1.2054566993773104E+001,
      -1.2038886540986422E+001,
      -1.2023020321016295E+001,
      -1.2006968960233944E+001,
      -1.1990733092319573E+001,
      -1.1974313358237458E+001,
      -1.1957710406210612E+001,
      -1.1940924891695131E+001,
      -1.1923957477354367E+001,
      -1.1906808833032805E+001,
      -1.1889479635729577E+001,
      -1.1871970569571685E+001,
      -1.1854282325787118E+001,
      -1.1836415602677411E+001,
      -1.1818371105590241E+001,
      -1.1800149546891422E+001,
      -1.1781751645936922E+001,
      -1.1763178129044334E+001,
      -1.1744429729464322E+001,
      -1.1725507187351617E+001,
      -1.1706411249735741E+001,
      -1.1687142670491653E+001,
      -1.1667702210309832E+001,
      -1.1648090636666394E+001,
      -1.1628308723792649E+001,
      -1.1608357252644664E+001,
      -1.1588237010872378E+001,
      -1.1567948792788444E+001,
      -1.1547493399337020E+001,
      -1.1526871638061984E+001,
      -1.1506084323075143E+001,
      -1.1485132275024121E+001,
      -1.1464016321059923E+001,
      -1.1442737294804207E+001,
      -1.1421296036316519E+001,
      -1.1399693392061058E+001,
      -1.1377930214873196E+001,
      -1.1356007363925890E+001,
      -1.1333925704695776E+001,
      -1.1311686108928980E+001,
      -1.1289289454606603E+001,
      -1.1266736625910246E+001,
      -1.1244028513186985E+001,
      -1.1221166012914209E+001,
      -1.1198150027664248E+001,
      -1.1174981466068854E+001,
      -1.1151661242783103E+001,
      -1.1128190278449512E+001,
      -1.1104569499661595E+001,
      -1.1080799838927192E+001,
      -1.1056882234631864E+001,
      -1.1032817631001624E+001,
      -1.1008606978065872E+001,
      -1.0984251231619673E+001,
      -1.0959751353186224E+001,
      -1.0935108309978801E+001,
      -1.0910323074862498E+001,
      -1.0885396626316018E+001,
      -1.0860329948392804E+001,
      -1.0835124030682445E+001,
      -1.0809779868271352E+001,
      -1.0784298461703717E+001,
      -1.0758680816941784E+001,
      -1.0732927945326331E+001,
      -1.0707040863536667E+001,
      -1.0681020593550395E+001,
      -1.0654868162603275E+001,
      -1.0628584603148443E+001,
      -1.0602170952815886E+001,
      -1.0575628254371226E+001,
      -1.0548957555674782E+001,
      -1.0522159909640102E+001,
      -1.0495236374192334E+001,
      -1.0468188012226529E+001,
      -1.0441015891565730E+001,
      -1.0413721084918766E+001,
      -1.0386304669837813E+001,
      -1.0358767728676046E+001,
      -1.0331111348544693E+001,
      -1.0303336621270351E+001,
      -1.0275444643351628E+001,
      -1.0247436515916119E+001,
      -1.0219313344676676E+001,
      -1.0191076239887972E+001,
      -1.0162726316302589E+001,
      -1.0134264693126905E+001,
      -1.0105692493977129E+001,
      -1.0077010846834696E+001,
      -1.0048220884001994E+001,
      -1.0019323742057392E+001,
      -9.9903205618106021E+000,
      -9.9612124882575586E+000,
      -9.9320006705350945E+000,
      -9.9026862618758233E+000,
      -9.8732704195623349E+000,
      -9.8437543048817844E+000,
      -9.8141390830797750E+000,
      -9.7844259233146182E+000,
      -9.7546159986109160E+000,
      -9.7247104858134890E+000,
      -9.6947105655408130E+000,
      -9.6646174221383312E+000,
      -9.6344322436317889E+000,
      -9.6041562216803786E+000,
      -9.5737905515296458E+000,
      -9.5433364319641782E+000,
      -9.5127950652605087E+000,
      -9.4821676571395344E+000,
      -9.4514554167188507E+000,
      -9.4206595564650826E+000,
      -9.3897812921461021E+000,
      -9.3588218427829464E+000,
      -9.3277824306015944E+000,
      -9.2966642809849613E+000,
      -9.2654686224242386E+000,
      -9.2341966864706855E+000,
      -9.2028497076867151E+000,
      -9.1714289235974427E+000,
      -9.1399355746415569E+000,
      -9.1083709041225838E+000,
      -9.0767361581597008E+000,
      -9.0450325856384435E+000,
      -9.0132614381616367E+000,
      -8.9814239699997156E+000,
      -8.9495214380414758E+000,
      -8.9175551017441865E+000,
      -8.8855262230840992E+000,
      -8.8534360665065428E+000,
      -8.8212858988758764E+000,
      -8.7890769894257410E+000,
      -8.7568106097086620E+000,
      -8.7244880335461303E+000,
      -8.6921105369780332E+000,
      -8.6596793982125764E+000,
      -8.6271958975755059E+000,
      -8.5946613174598472E+000,
      -8.5620769422751550E+000,
      -8.5294440583967237E+000,
      -8.4967639541149023E+000,
      -8.4640379195842819E+000,
      -8.4312672467727108E+000,
      -8.3984532294101655E+000,
      -8.3655971629378989E+000,
      -8.3327003444571961E+000,
      -8.2997640726780855E+000,
      -8.2667896478681424E+000,
      -8.2337783718012716E+000,
      -8.2007315477060523E+000,
      -8.1676504802145562E+000,
      -8.1345364753107159E+000,
      -8.1013908402786736E+000,
      -8.0682148836514180E+000,
      -8.0350099151588399E+000,
      -8.0017772456763101E+000,
      -7.9685181871726423E+000,
      -7.9352340526585561E+000,
      -7.9019261561347269E+000,
      -7.8685958125398026E+000,
      -7.8352443376987546E+000,
      -7.8018730482706244E+000,
      -7.7684832616968551E+000,
      -7.7350762961489732E+000,
      -7.7016534704768516E+000,
      -7.6682161041563415E+000,
      -7.6347655172374500E+000,
      -7.6013030302921116E+000,
      -7.5678299643619367E+000,
      -7.5343476409063284E+000,
      -7.5008573817500119E+000,
      -7.4673605090311490E+000,
      -7.4338583451488418E+000,
      -7.4003522127111960E+000,
      -7.3668434344829841E+000,
      -7.3333333333333570E+000,
      -7.2998232321836927E+000,
      -7.2663144539554425E+000,
      -7.2328083215178349E+000,
      -7.1993061576355277E+000,
      -7.1658092849166648E+000,
      -7.1323190257603475E+000,
      -7.0988367023047401E+000,
      -7.0653636363745651E+000,
      -7.0319011494291885E+000,
      -6.9984505625103353E+000,
      -6.9650131961898252E+000,
      -6.9315903705177035E+000,
      -6.8981834049698199E+000,
      -6.8647936183960514E+000,
      -6.8314223289679212E+000,
      -6.7980708541268733E+000,
      -6.7647405105319489E+000,
      -6.7314326140080833E+000,
      -6.6981484794940345E+000,
      -6.6648894209903666E+000,
      -6.6316567515078377E+000,
      -6.5984517830152578E+000,
      -6.5652758263880031E+000,
      -6.5321301913559600E+000,
      -6.4990161864521205E+000,
      -6.4659351189606236E+000,
      -6.4328882948654051E+000,
      -6.3998770187985334E+000,
      -6.3669025939885904E+000,
      -6.3339663222094789E+000,
      -6.3010695037287396E+000,
      -6.2682134372565104E+000,
      -6.2353994198939642E+000,
      -6.2026287470823567E+000,
      -6.1699027125517745E+000,
      -6.1372226082699530E+000,
      -6.1045897243915226E+000,
      -6.0720053492067914E+000,
      -6.0394707690911700E+000,
      -6.0069872684541012E+000,
      -5.9745561296886427E+000,
      -5.9421786331205473E+000,
      -5.9098560569580147E+000,
      -5.8775896772409340E+000,
      -5.8453807677907994E+000,
      -5.8132306001601330E+000,
      -5.7811404435825402E+000,
      -5.7491115649224902E+000,
      -5.7171452286251991E+000,
      -5.6852426966669611E+000,
      -5.6534052285050382E+000,
      -5.6216340810282341E+000,
      -5.5899305085069750E+000,
      -5.5582957625440566E+000,
      -5.5267310920251189E+000,
      -5.4952377430692314E+000,
      -5.4638169589799617E+000,
      -5.4324699801959895E+000,
      -5.4011980442424363E+000,
      -5.3700023856817154E+000,
      -5.3388842360650814E+000,
      -5.3078448238837286E+000,
      -5.2768853745205373E+000,
      -5.2460071102015924E+000,
      -5.2152112499478269E+000,
      -5.1844990095271424E+000,
      -5.1538716014061317E+000,
      -5.1233302347024967E+000,
      -5.0928761151370310E+000,
      -5.0625104449862608E+000,
      -5.0322344230348870E+000,
      -5.0020492445283438E+000,
      -4.9719561011258628E+000,
      -4.9419561808531505E+000,
      -4.9120506680557590E+000,
      -4.8822407433520585E+000,
      -4.8525275835869008E+000,
      -4.8229123617848906E+000,
      -4.7933962471043072E+000,
      -4.7639804047908516E+000,
      -4.7346659961315805E+000,
      -4.7054541784091173E+000,
      -4.6763461048560382E+000,
      -4.6473429246092834E+000,
      -4.6184457826646801E+000,
      -4.5896558198319770E+000,
      -4.5609741726895470E+000,
      -4.5324019735397707E+000,
      -4.5039403503640862E+000,
      -4.4755904267786715E+000,
      -4.4473533219899997E+000,
      -4.4192301507505549E+000,
      -4.3912220233150467E+000,
      -4.3633300453963244E+000,
      -4.3355553181219806E+000,
      -4.3078989379906290E+000,
      -4.2803619968288631E+000,
      -4.2529455817479063E+000,
      -4.2256507751009140E+000,
      -4.1984786544401462E+000,
      -4.1714302924743416E+000,
      -4.1445067570265737E+000,
      -4.1177091109918624E+000,
      -4.0910384122954477E+000,
      -4.0644957138507891E+000,
      -4.0380820635182308E+000,
      -4.0117985040634006E+000,
      -3.9856460731162513E+000,
      -3.9596258031300064E+000,
      -3.9337387213403123E+000,
      -3.9079858497248905E+000,
      -3.8823682049629578E+000,
      -3.8568867983953234E+000,
      -3.8315426359842295E+000,
      -3.8063367182738408E+000,
      -3.7812700403506585E+000,
      -3.7563435918041757E+000,
      -3.7315583566878732E+000,
      -3.7069153134804220E+000,
      -3.6824154350470000E+000,
      -3.6580596886008019E+000,
      -3.6338490356650492E+000,
      -3.6097844320348100E+000,
      -3.5858668277394825E+000,
      -3.5620971670050796E+000,
      -3.5384763882171333E+000,
      -3.5150054238835700E+000,
      -3.4916852005978214E+000,
      -3.4685166390024236E+000,
      -3.4455006537524655E+000,
      -3.4226381534796890E+000,
      -3.3999300407564026E+000,
      -3.3773772120600691E+000,
      -3.3549805577376950E+000,
      -3.3327409619708712E+000,
      -3.3106593027407820E+000,
      -3.2887364517934747E+000,
      -3.2669732746056166E+000,
      -3.2453706303501288E+000,
      -3.2239293718624658E+000,
      -3.2026503456067501E+000,
      -3.1815343916425527E+000,
      -3.1605823435915292E+000,
      -3.1397950286046892E+000,
      -3.1191732673296539E+000,
      -3.0987178738782273E+000,
      -3.0784296557942934E+000,
      -3.0583094140219869E+000,
      -3.0383579428740242E+000,
      -3.0185760300002782E+000,
      -2.9989644563568203E+000,
      -2.9795239961750180E+000,
      -2.9602554169309330E+000,
      -2.9411594793150559E+000,
      -2.9222369372023289E+000,
      -2.9034885376223367E+000,
      -2.8849150207297485E+000,
      -2.8665171197752510E+000,
      -2.8482955610764287E+000,
      -2.8302510639892615E+000,
      -2.8123843408795555E+000,
      -2.7946960970949881E+000,
      -2.7771870309370943E+000,
      -2.7598578336338480E+000,
      -2.7427091893123046E+000,
      -2.7257417749715409E+000,
      -2.7089562604560591E+000,
      -2.6923533084291944E+000,
      -2.6759335743471002E+000,
      -2.6596977064327270E+000,
      -2.6436463456503581E+000,
      -2.6277801256802515E+000,
      -2.6120996728935659E+000,
      -2.5966056063277660E+000,
      -2.5812985376620339E+000,
      -2.5661790711932650E+000,
      -2.5512478038120725E+000,
      -2.5365053249793612E+000,
      -2.5219522167029171E+000,
      -2.5075890535145549E+000,
      -2.4934164024473775E+000,
      -2.4794348230133667E+000,
      -2.4656448671813216E+000,
      -2.4520470793551019E+000,
      -2.4386419963521053E+000,
      -2.4254301473820230E+000,
      -2.4124120540260456E+000,
      -2.3995882302162226E+000,
      -2.3869591822151475E+000,
      -2.3745254085959937E+000,
      -2.3622874002228698E+000,
      -2.3502456402314049E+000,
      -2.3384006040096375E+000,
      -2.3267527591793420E+000,
      -2.3153025655774622E+000,
      -2.3040504752380611E+000,
      -2.2929969323743742E+000,
      -2.2821423733613697E+000,
      -2.2714872267184298E+000,
      -2.2610319130925096E+000,
      -2.2507768452415018E+000,
      -2.2407224280179014E+000,
      -2.2308690583529072E+000,
      -2.2212171252406607E+000,
      -2.2117670097229740E+000,
      -2.2025190848742087E+000,
      -2.1934737157866100E+000,
      -2.1846312595558732E+000,
      -2.1759920652670091E+000,
      -2.1675564739806354E+000,
      -2.1593248187194325E+000,
      -2.1512974244550751E+000,
      -2.1434746080953233E+000,
      -2.1358566784715918E+000,
      -2.1284439363266805E+000,
      -2.1212366743029647E+000,
      -2.1142351769308161E+000,
      -2.1074397206173545E+000,
      -2.1008505736355527E+000,
      -2.0944679961136581E+000,
      -2.0882922400249102E+000,
      -2.0823235491775698E+000,
      -2.0765621592053400E+000,
      -2.0710082975580368E+000,
      -2.0656621834926012E+000,
      -2.0605240280644588E+000,
      -2.0555940341191921E+000,
      -2.0508723962845274E+000,
      -2.0463593009626302E+000,
      -2.0420549263227867E+000,
      -2.0379594422943264E+000,
      -2.0340730105599567E+000,
      -2.0303957845493392E+000,
      -2.0269279094330677E+000,
      -2.0236695221169065E+000,
      -2.0206207512364118E+000,
      -2.0177817171518417E+000,
      -2.0151525319433921E+000,
      -2.0127332994067992E+000,
      -2.0105241150492179E+000,
      -2.0085250660854665E+000,
      -2.0067362314345734E+000,
      -2.0051576817166676E+000,
      -2.0037894792501909E+000,
      -2.0026316780494318E+000,
      -2.0016843238224005E+000,
      -2.0009474539690180E+000,
      -2.0004210975796477E+000,
      -2.0001052754339352E+000,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.00005,
      -2.0002,
      -2.00045,
      -2.0008,
      -2.00125,
      -2.0018,
      -2.00245,
      -2.0032,
      -2.00405,
      -2.005,
      -2.00605,
      -2.0072,
      -2.00845,
      -2.0098000000000003E+000,
      -2.01125,
      -2.0128,
      -2.01445,
      -2.0162,
      -2.01805,
      -2.02,
      -2.02205,
      -2.0242,
      -2.02645,
      -2.0288,
      -2.03125,
      -2.0338,
      -2.03645,
      -2.0391999999999997E+000,
      -2.04205,
      -2.045,
      -2.04805,
      -2.0512,
      -2.05445,
      -2.0578,
      -2.06125,
      -2.0648,
      -2.06845,
      -2.0722,
      -2.07605,
      -2.08,
      -2.08405,
      -2.0882,
      -2.09245,
      -2.0968,
      -2.10125,
      -2.1058,
      -2.1104499999999997E+000,
      -2.1152,
      -2.12005,
      -2.125,
      -2.13005,
      -2.1352,
      -2.14045,
      -2.1458,
      -2.15125,
      -2.1568,
      -2.16245,
      -2.1681999999999997E+000,
      -2.1740500000000003E+000,
      -2.18,
      -2.1860500000000003E+000,
      -2.1921999999999997E+000,
      -2.1984500000000002E+000,
      -2.2048,
      -2.2112499999999997E+000,
      -2.2178,
      -2.22445,
      -2.2312,
      -2.23805,
      -2.2449999999999997E+000,
      -2.25205,
      -2.2592000000000003E+000,
      -2.26645,
      -2.2738,
      -2.28125,
      -2.2888,
      -2.29645,
      -2.3042,
      -2.3120499999999997E+000,
      -2.32,
      -2.32805,
      -2.3362,
      -2.3444499999999997E+000,
      -2.3528,
      -2.36125,
      -2.3698,
      -2.37845,
      -2.3872,
      -2.3960500000000002E+000,
      -2.405,
      -2.41405,
      -2.4232,
      -2.43245,
      -2.4418,
      -2.45125,
      -2.4608000000000003E+000,
      -2.47045,
      -2.4802,
      -2.49005,
      -2.5,
      -2.51,
      -2.52,
      -2.53,
      -2.5399999999999996E+000,
      -2.5500000000000003E+000,
      -2.56,
      -2.5700000000000003E+000,
      -2.58,
      -2.59,
      -2.6,
      -2.61,
      -2.62,
      -2.63,
      -2.6399999999999997E+000,
      -2.6500000000000004E+000,
      -2.66,
      -2.6700000000000004E+000,
      -2.68,
      -2.69,
      -2.6999999999999997E+000,
      -2.71,
      -2.7199999999999998E+000,
      -2.73,
      -2.7399999999999998E+000,
      -2.7499999999999996E+000,
      -2.7600000000000002E+000,
      -2.77,
      -2.7800000000000002E+000,
      -2.79,
      -2.8,
      -2.81,
      -2.82,
      -2.83,
      -2.84,
      -2.8499999999999996E+000,
      -2.8600000000000003E+000,
      -2.87,
      -2.8800000000000003E+000,
      -2.89,
      -2.9,
      -2.9099999999999997E+000,
      -2.92,
      -2.93,
      -2.94,
      -2.9499999999999997E+000,
      -2.96,
      -2.97,
      -2.98,
      -2.99,
      -3.0,
      -3.01,
      -3.02,
      -3.03,
      -3.04,
      -3.0500000000000003E+000,
      -3.06,
      -3.0700000000000003E+000,
      -3.08,
      -3.0900000000000003E+000,
      -3.1,
      -3.11,
      -3.1199999999999997E+000,
      -3.13,
      -3.1399999999999997E+000,
      -3.1500000000000004E+000,
      -3.16,
      -3.17,
      -3.18,
      -3.19,
      -3.2,
      -3.21,
      -3.2199999999999998E+000,
      -3.23,
      -3.2399999999999998E+000,
      -3.2500000000000004E+000,
      -3.2600000000000002E+000,
      -3.27,
      -3.2800000000000002E+000,
      -3.29,
      -3.3000000000000003E+000,
      -3.31,
      -3.32,
      -3.33,
      -3.34,
      -3.3500000000000005E+000,
      -3.3600000000000003E+000,
      -3.37,
      -3.38,
      -3.39,
      -3.4,
      -3.41,
      -3.42,
      -3.4299999999999997E+000,
      -3.44,
      -3.4499999999999997E+000,
      -3.4600000000000004E+000,
      -3.47,
      -3.48,
      -3.49,
      -3.5,
      -3.5100000000000002E+000,
      -3.52,
      -3.53,
      -3.54,
      -3.5500000000000003E+000,
      -3.56,
      -3.5700000000000003E+000,
      -3.58,
      -3.59,
      -3.6,
      -3.61,
      -3.62,
      -3.63,
      -3.6399999999999997E+000,
      -3.6500000000000004E+000,
      -3.66,
      -3.6700000000000004E+000,
      -3.68,
      -3.69,
      -3.6999999999999997E+000,
      -3.71,
      -3.72,
      -3.73,
      -3.7399999999999998E+000,
      -3.7499999999999996E+000,
      -3.7600000000000002E+000,
      -3.7700000000000005E+000,
      -3.7800000000000002E+000,
      -3.79,
      -3.8,
      -3.81,
      -3.8200000000000003E+000,
      -3.83,
      -3.84,
      -3.8499999999999996E+000,
      -3.8600000000000003E+000,
      -3.8700000000000006E+000,
      -3.8800000000000003E+000,
      -3.89,
      -3.9,
      -3.91,
      -3.9200000000000004E+000,
      -3.93,
      -3.94,
      -3.9499999999999997E+000,
      -3.96,
      -3.9699999999999998E+000,
      -3.98,
      -3.99,
      -4.0,
      -4.01,
      -4.02,
      -4.03,
      -4.04,
      -4.05,
      -4.06,
      -4.0699999999999994E+000,
      -4.08,
      -4.09,
      -4.1000000000000005E+000,
      -4.11,
      -4.12,
      -4.13,
      -4.1400000000000006E+000,
      -4.15,
      -4.16,
      -4.17,
      -4.1800000000000006E+000,
      -4.19,
      -4.2,
      -4.21,
      -4.22,
      -4.23,
      -4.24,
      -4.25,
      -4.26,
      -4.27,
      -4.2799999999999994E+000,
      -4.2899999999999991E+000,
      -4.3000000000000007E+000,
      -4.3100000000000005E+000,
      -4.32,
      -4.33,
      -4.34,
      -4.3500000000000005E+000,
      -4.36,
      -4.37,
      -4.38,
      -4.39,
      -4.4,
      -4.41,
      -4.42,
      -4.43,
      -4.4399999999999995E+000,
      -4.45,
      -4.46,
      -4.47,
      -4.4799999999999995E+000,
      -4.4899999999999993E+000,
      -4.5000000000000009E+000,
      -4.5100000000000007E+000,
      -4.5200000000000005E+000,
      -4.53,
      -4.54,
      -4.5500000000000007E+000,
      -4.5600000000000005E+000,
      -4.57,
      -4.58,
      -4.59,
      -4.6000000000000005E+000,
      -4.6099999999999994E+000,
      -4.62,
      -4.63,
      -4.64,
      -4.65,
      -4.6599999999999993E+000,
      -4.67,
      -4.68,
      -4.6899999999999995E+000,
      -4.7000000000000011E+000,
      -4.71,
      -4.7200000000000006E+000,
      -4.73,
      -4.74,
      -4.7500000000000009E+000,
      -4.76,
      -4.7700000000000005E+000,
      -4.78,
      -4.79,
      -4.8000000000000007E+000,
      -4.81,
      -4.82,
      -4.83,
      -4.84,
      -4.8500000000000005E+000,
      -4.8599999999999994E+000,
      -4.87,
      -4.88,
      -4.89,
      -4.8999999999999995E+000,
      -4.91,
      -4.9200000000000008E+000,
      -4.93,
      -4.94,
      -4.95,
      -4.96,
      -4.9700000000000006E+000,
      -4.9799999999999995E+000,
      -4.99,
      -5.0,
      -5.01,
      -5.0200000000000005E+000,
      -5.0299999999999994E+000,
      -5.04,
      -5.05,
      -5.06,
      -5.07,
      -5.0799999999999992E+000,
      -5.09,
      -5.1000000000000005E+000,
      -5.11,
      -5.1200000000000010E+000,
      -5.13,
      -5.1400000000000006E+000,
      -5.15,
      -5.16,
      -5.1700000000000008E+000,
      -5.18,
      -5.19,
      -5.2,
      -5.21,
      -5.2200000000000006E+000,
      -5.2299999999999995E+000,
      -5.24,
      -5.25,
      -5.26,
      -5.2700000000000005E+000,
      -5.2799999999999994E+000,
      -5.29,
      -5.3000000000000007E+000,
      -5.3100000000000005E+000,
      -5.3200000000000012E+000,
      -5.33,
      -5.3400000000000007E+000,
      -5.3500000000000005E+000,
      -5.36,
      -5.3700000000000010E+000,
      -5.38,
      -5.39,
      -5.3999999999999995E+000,
      -5.41,
      -5.42,
      -5.43,
      -5.4399999999999995E+000,
      -5.4499999999999993E+000,
      -5.46,
      -5.47,
      -5.4799999999999995E+000,
      -5.4899999999999993E+000,
      -5.4999999999999991E+000,
      -5.5100000000000007E+000,
      -5.5200000000000005E+000,
      -5.53,
      -5.54,
      -5.55,
      -5.5600000000000005E+000,
      -5.57,
      -5.58,
      -5.59,
      -5.6,
      -5.61,
      -5.62,
      -5.63,
      -5.64,
      -5.6499999999999995E+000,
      -5.66,
      -5.67,
      -5.68,
      -5.6899999999999995E+000,
      -5.6999999999999993E+000,
      -5.7100000000000009E+000,
      -5.7200000000000006E+000,
      -5.73,
      -5.74,
      -5.75,
      -5.7600000000000007E+000,
      -5.7700000000000005E+000,
      -5.78,
      -5.79,
      -5.8,
      -5.8100000000000005E+000,
      -5.82,
      -5.83,
      -5.84,
      -5.85,
      -5.86,
      -5.87,
      -5.88,
      -5.89,
      -5.8999999999999995E+000,
      -5.9100000000000010E+000,
      -5.9200000000000008E+000,
      -5.9300000000000006E+000,
      -5.94,
      -5.95,
      -5.9600000000000009E+000,
      -5.9700000000000006E+000,
      -5.98,
      -5.99,
      -6.0,
      -6.0100000000000007E+000,
      -6.02,
      -6.03,
      -6.0399999999999991E+000,
      -6.05,
      -6.06,
      -6.0699999999999994E+000,
      -6.08,
      -6.0899999999999990E+000,
      -6.1000000000000005E+000,
      -6.11,
      -6.12,
      -6.1300000000000008E+000,
      -6.14,
      -6.15,
      -6.16,
      -6.17,
      -6.1800000000000006E+000,
      -6.1899999999999995E+000,
      -6.2,
      -6.21,
      -6.22,
      -6.23,
      -6.2399999999999993E+000,
      -6.25,
      -6.26,
      -6.27,
      -6.28,
      -6.2899999999999991E+000,
      -6.3000000000000007E+000,
      -6.3100000000000005E+000,
      -6.32,
      -6.3300000000000010E+000,
      -6.34,
      -6.3500000000000005E+000,
      -6.36,
      -6.37,
      -6.3800000000000008E+000,
      -6.39,
      -6.4,
      -6.41,
      -6.42,
      -6.4300000000000006E+000,
      -6.4399999999999995E+000,
      -6.45,
      -6.46,
      -6.47,
      -6.48,
      -6.4899999999999993E+000,
      -6.5000000000000009E+000,
      -6.5100000000000007E+000,
      -6.5200000000000005E+000,
      -6.5300000000000011E+000,
      -6.54,
      -6.5500000000000007E+000,
      -6.5600000000000005E+000,
      -6.57,
      -6.5800000000000010E+000,
      -6.59,
      -6.6000000000000005E+000,
      -6.61,
      -6.62,
      -6.6300000000000008E+000,
      -6.64,
      -6.65,
      -6.66,
      -6.67,
      -6.6799999999999988E+000,
      -6.6899999999999995E+000,
      -6.7000000000000011E+000,
      -6.71,
      -6.7200000000000006E+000,
      -6.7299999999999995E+000,
      -6.74,
      -6.7500000000000009E+000,
      -6.76,
      -6.7700000000000005E+000,
      -6.7799999999999994E+000,
      -6.79,
      -6.8000000000000007E+000,
      -6.81,
      -6.82,
      -6.8299999999999992E+000,
      -6.84,
      -6.8500000000000005E+000,
      -6.8599999999999994E+000,
      -6.87,
      -6.8799999999999990E+000,
      -6.89,
      -6.9000000000000012E+000,
      -6.91,
      -6.9200000000000008E+000,
      -6.93,
      -6.94,
      -6.9500000000000011E+000,
      -6.96,
      -6.9700000000000006E+000,
      -6.9799999999999995E+000,
      -6.99,
      -7.0000000000000009E+000,
      -7.01,
      -7.0200000000000005E+000,
      -7.0299999999999994E+000,
      -7.04,
      -7.0500000000000007E+000,
      -7.06,
      -7.07,
      -7.0799999999999992E+000,
      -7.09,
      -7.1000000000000014E+000,
      -7.11,
      -7.1200000000000010E+000,
      -7.13,
      -7.1400000000000006E+000,
      -7.1500000000000012E+000,
      -7.16,
      -7.1700000000000008E+000,
      -7.18,
      -7.19,
      -7.2000000000000011E+000,
      -7.21,
      -7.2200000000000006E+000,
      -7.2299999999999995E+000,
      -7.24,
      -7.2500000000000009E+000,
      -7.26,
      -7.2700000000000005E+000,
      -7.2799999999999994E+000,
      -7.29,
      -7.2999999999999989E+000,
      -7.3100000000000005E+000,
      -7.3199999999999994E+000,
      -7.33,
      -7.3400000000000007E+000,
      -7.35,
      -7.36,
      -7.3699999999999992E+000,
      -7.38,
      -7.3900000000000006E+000,
      -7.3999999999999995E+000,
      -7.41,
      -7.4199999999999990E+000,
      -7.43,
      -7.44,
      -7.4499999999999993E+000,
      -7.46,
      -7.4699999999999989E+000,
      -7.4799999999999995E+000,
      -7.49,
      -7.4999999999999991E+000,
      -7.5100000000000007E+000,
      -7.52,
      -7.53,
      -7.5400000000000009E+000,
      -7.55,
      -7.5600000000000005E+000,
      -7.5699999999999994E+000,
      -7.58,
      -7.5900000000000007E+000,
      -7.6,
      -7.61,
      -7.6199999999999992E+000,
      -7.63,
      -7.6400000000000006E+000,
      -7.6499999999999995E+000,
      -7.66,
      -7.6699999999999990E+000,
      -7.68,
      -7.69,
      -7.6999999999999993E+000,
      -7.7100000000000009E+000,
      -7.72,
      -7.73,
      -7.7400000000000011E+000,
      -7.75,
      -7.7600000000000007E+000,
      -7.77,
      -7.78,
      -7.7900000000000009E+000,
      -7.8,
      -7.8100000000000005E+000,
      -7.8199999999999994E+000,
      -7.83,
      -7.8400000000000007E+000,
      -7.85,
      -7.86,
      -7.8699999999999992E+000,
      -7.88,
      -7.8900000000000006E+000,
      -7.8999999999999995E+000,
      -7.9100000000000010E+000,
      -7.92,
      -7.9300000000000006E+000,
      -7.9400000000000013E+000,
      -7.95,
      -7.9600000000000009E+000,
      -7.97,
      -7.98,
      -7.9900000000000011E+000,
      -8.0,
      -8.0100000000000016E+000,
      -8.02,
      -8.0300000000000011E+000,
      -8.0400000000000009E+000,
      -8.05,
      -8.06,
      -8.07,
      -8.08,
      -8.0900000000000016E+000,
      -8.1,
      -8.1100000000000012E+000,
      -8.12,
      -8.13,
      -8.14,
      -8.15,
      -8.16,
      -8.17,
      -8.18,
      -8.1900000000000013E+000,
      -8.2000000000000011E+000,
      -8.21,
      -8.22,
      -8.23,
      -8.2400000000000020E+000,
      -8.25,
      -8.2600000000000016E+000,
      -8.27,
      -8.28,
      -8.29,
      -8.3,
      -8.3099999999999987E+000,
      -8.32,
      -8.3299999999999983E+000,
      -8.34,
      -8.35,
      -8.36,
      -8.37,
      -8.3799999999999990E+000,
      -8.3899999999999988E+000,
      -8.4,
      -8.41,
      -8.42,
      -8.43,
      -8.44,
      -8.4500000000000011E+000,
      -8.4599999999999991E+000,
      -8.47,
      -8.4799999999999986E+000,
      -8.49,
      -8.5,
      -8.51,
      -8.52,
      -8.53,
      -8.54,
      -8.55,
      -8.5599999999999987E+000,
      -8.57,
      -8.5799999999999983E+000,
      -8.59,
      -8.6000000000000014E+000,
      -8.61,
      -8.6200000000000010E+000,
      -8.6299999999999990E+000,
      -8.64,
      -8.65,
      -8.66,
      -8.67,
      -8.68,
      -8.69,
      -8.7000000000000011E+000,
      -8.7099999999999991E+000,
      -8.72,
      -8.7299999999999986E+000,
      -8.74,
      -8.75,
      -8.76,
      -8.77,
      -8.78,
      -8.79,
      -8.8,
      -8.81,
      -8.82,
      -8.83,
      -8.84,
      -8.8500000000000014E+000,
      -8.86,
      -8.8700000000000010E+000,
      -8.8799999999999990E+000,
      -8.89,
      -8.9,
      -8.91,
      -8.92,
      -8.93,
      -8.94,
      -8.9500000000000011E+000,
      -8.9599999999999991E+000,
      -8.97,
      -8.9799999999999986E+000,
      -8.99,
      -9.0000000000000018E+000,
      -9.01,
      -9.0200000000000014E+000,
      -9.03,
      -9.0400000000000009E+000,
      -9.05,
      -9.06,
      -9.07,
      -9.08,
      -9.09,
      -9.1000000000000014E+000,
      -9.11,
      -9.1200000000000010E+000,
      -9.1299999999999990E+000,
      -9.14,
      -9.15,
      -9.16,
      -9.17,
      -9.18,
      -9.19,
      -9.2000000000000011E+000,
      -9.21,
      -9.22,
      -9.23,
      -9.24,
      -9.2500000000000018E+000,
      -9.26,
      -9.2700000000000014E+000,
      -9.28,
      -9.2900000000000009E+000,
      -9.3,
      -9.31,
      -9.32,
      -9.33,
      -9.34,
      -9.3500000000000014E+000,
      -9.36,
      -9.3700000000000010E+000,
      -9.3799999999999990E+000,
      -9.39,
      -9.4000000000000021E+000,
      -9.41,
      -9.4200000000000017E+000,
      -9.43,
      -9.4400000000000013E+000,
      -9.4500000000000011E+000,
      -9.46,
      -9.47,
      -9.48,
      -9.49,
      -9.5000000000000018E+000,
      -9.51,
      -9.5200000000000014E+000,
      -9.53,
      -9.54,
      -9.5499999999999989E+000,
      -9.56,
      -9.5699999999999985E+000,
      -9.58,
      -9.5899999999999981E+000,
      -9.6,
      -9.6100000000000012E+000,
      -9.62,
      -9.63,
      -9.6399999999999988E+000,
      -9.65,
      -9.66,
      -9.67,
      -9.68,
      -9.69,
      -9.7,
      -9.71,
      -9.7199999999999989E+000,
      -9.73,
      -9.7399999999999984E+000,
      -9.75,
      -9.76,
      -9.77,
      -9.78,
      -9.79,
      -9.7999999999999989E+000,
      -9.81,
      -9.82,
      -9.83,
      -9.84,
      -9.85,
      -9.8600000000000012E+000,
      -9.87,
      -9.88,
      -9.8899999999999988E+000,
      -9.9,
      -9.91,
      -9.92,
      -9.93,
      -9.94,
      -9.95,
      -9.96,
      -9.9699999999999989E+000,
      -9.98,
      -9.9899999999999984E+000,
      -10.0,
      -1.0010000000000002E+001,
      -10.02,
      -1.0030000000000001E+001,
      -10.04,
      -10.05,
      -10.06,
      -10.07,
      -10.08,
      -10.09,
      -10.1,
      -1.0110000000000001E+001,
      -10.12,
      -10.13,
      -1.0139999999999999E+001,
      -10.15,
      -10.16,
      -10.17,
      -10.18,
      -10.19,
      -1.0200000000000001E+001,
      -10.21,
      -10.22,
      -10.23,
      -10.24,
      -10.25,
      -1.0260000000000002E+001,
      -10.27,
      -1.0280000000000001E+001,
      -10.29,
      -10.3,
      -10.31,
      -10.32,
      -10.33,
      -10.34,
      -10.35,
      -1.0360000000000001E+001,
      -10.37,
      -10.38,
      -1.0389999999999999E+001,
      -10.4,
      -1.0410000000000002E+001,
      -10.42,
      -1.0430000000000001E+001,
      -10.44,
      -1.0450000000000001E+001,
      -10.46,
      -10.47,
      -10.48,
      -10.49,
      -10.5,
      -1.0510000000000002E+001,
      -10.52,
      -1.0530000000000001E+001,
      -10.54,
      -10.55,
      -10.56,
      -10.57,
      -10.58,
      -10.59,
      -1.0600000000000001E+001,
      -1.0610000000000001E+001,
      -1.0620000000000001E+001,
      -10.63,
      -10.64,
      -10.65,
      -1.0660000000000002E+001,
      -10.67,
      -1.0680000000000001E+001,
      -10.69,
      -1.0700000000000001E+001,
      -10.71,
      -10.72,
      -10.73,
      -10.74,
      -10.75,
      -1.0760000000000002E+001,
      -10.77,
      -1.0780000000000001E+001,
      -10.79,
      -10.8,
      -1.0810000000000002E+001,
      -10.82,
      -10.83,
      -10.84,
      -1.0850000000000001E+001,
      -10.86,
      -1.0870000000000001E+001,
      -1.0879999999999999E+001,
      -10.89,
      -10.9,
      -10.91,
      -10.92,
      -10.93,
      -10.94,
      -1.0950000000000001E+001,
      -1.0959999999999999E+001,
      -10.97,
      -1.0979999999999999E+001,
      -10.99,
      -1.1000000000000002E+001,
      -11.01,
      -1.1020000000000001E+001,
      -11.03,
      -1.1040000000000001E+001,
      -11.05,
      -11.06,
      -11.07,
      -11.08,
      -11.09,
      -1.1100000000000001E+001,
      -11.11,
      -1.1120000000000001E+001,
      -1.1129999999999999E+001,
      -11.14,
      -11.15,
      -11.16,
      -11.17,
      -11.18,
      -11.19,
      -1.1200000000000001E+001,
      -11.21,
      -11.22,
      -11.23,
      -11.24,
      -1.1250000000000002E+001,
      -11.26,
      -1.1270000000000001E+001,
      -11.28,
      -1.1290000000000001E+001,
      -11.3,
      -11.31,
      -11.32,
      -11.33,
      -11.34,
      -1.1350000000000001E+001,
      -11.36,
      -1.1370000000000001E+001,
      -1.1379999999999999E+001,
      -11.39,
      -1.1400000000000002E+001,
      -11.41,
      -1.1420000000000002E+001,
      -11.43,
      -1.1440000000000001E+001,
      -1.1450000000000001E+001,
      -11.46,
      -11.47,
      -11.48,
      -11.49,
      -1.1500000000000002E+001,
      -11.51,
      -1.1520000000000001E+001,
      -11.53,
      -1.1540000000000001E+001,
      -11.55,
      -11.56,
      -11.57,
      -11.58,
      -11.59,
      -1.1600000000000001E+001,
      -1.1610000000000001E+001,
      -1.1620000000000001E+001,
      -11.63,
      -11.64,
      -1.1650000000000002E+001,
      -11.66,
      -1.1670000000000002E+001,
      -11.68,
      -1.1690000000000001E+001,
      -1.1700000000000001E+001,
      -11.71,
      -11.72,
      -11.73,
      -11.74,
      -1.1750000000000002E+001,
      -11.76,
      -1.1770000000000001E+001,
      -11.78,
      -1.1790000000000001E+001,
      -1.1800000000000002E+001,
      -11.81,
      -1.1820000000000002E+001,
      -11.83,
      -1.1840000000000002E+001,
      -1.1850000000000001E+001,
      -1.1860000000000001E+001,
      -1.1870000000000001E+001,
      -11.88,
      -11.89,
      -1.1900000000000002E+001,
      -11.91,
      -1.1920000000000002E+001,
      -11.93,
      -1.1940000000000001E+001,
      -1.1950000000000001E+001,
      -11.96,
      -11.97,
      -11.98,
      -11.99,
      -1.2000000000000002E+001,
      -1.2010000000000002E+001,
      -1.2020000000000001E+001,
      -1.2030000000000001E+001,
      -1.2040000000000001E+001,
      -1.2050000000000002E+001,
      -12.06,
      -1.2070000000000002E+001,
      -12.08,
      -1.2090000000000002E+001,
      -12.1,
      -1.2110000000000001E+001,
      -12.12,
      -12.13,
      -1.2139999999999999E+001,
      -12.15,
      -12.16,
      -12.17,
      -12.18,
      -12.19,
      -1.2200000000000001E+001,
      -12.21,
      -12.22,
      -12.23,
      -12.24,
      -12.25,
      -1.2260000000000002E+001,
      -12.27,
      -1.2280000000000001E+001,
      -12.29,
      -12.3,
      -12.31,
      -12.32,
      -12.33,
      -12.34,
      -12.35,
      -1.2360000000000001E+001,
      -12.37,
      -12.38,
      -1.2389999999999999E+001,
      -12.4,
      -1.2410000000000002E+001,
      -12.42,
      -1.2430000000000001E+001,
      -12.44,
      -1.2450000000000001E+001,
      -12.46,
      -12.47,
      -12.48,
      -12.49,
      -12.5,
      -1.2510000000000002E+001,
      -12.52,
      -1.2530000000000001E+001,
      -12.54,
      -1.2550000000000002E+001,
      -12.56,
      -1.2570000000000002E+001,
      -12.58,
      -1.2590000000000002E+001,
      -1.2600000000000001E+001,
      -1.2610000000000001E+001,
      -1.2620000000000001E+001,
      -12.63,
      -12.64,
      -1.2650000000000002E+001,
      -1.2660000000000002E+001,
      -1.2670000000000002E+001,
      -1.2680000000000001E+001,
      -1.2690000000000001E+001,
      -1.2700000000000001E+001,
      -12.71,
      -12.72,
      -12.73,
      -12.74,
      -1.2749999999999998E+001,
      -1.2760000000000002E+001,
      -12.77,
      -1.2780000000000001E+001,
      -12.79,
      -12.8,
      -12.81,
      -12.82,
      -12.83,
      -12.84,
      -12.85,
      -1.2860000000000001E+001,
      -1.2870000000000001E+001,
      -12.88,
      -12.89,
      -12.9,
      -12.91,
      -12.92,
      -12.93,
      -12.94,
      -12.95,
      -12.96,
      -12.97,
      -12.98,
      -12.99,
      -1.3000000000000002E+001,
      -13.01,
      -1.3020000000000001E+001,
      -13.03,
      -1.3040000000000001E+001,
      -1.3049999999999999E+001,
      -1.3060000000000002E+001,
      -13.07,
      -1.3080000000000002E+001,
      -13.09,
      -1.3100000000000001E+001,
      -13.11,
      -1.3120000000000001E+001,
      -1.3129999999999999E+001,
      -13.14,
      -1.3149999999999999E+001,
      -1.3160000000000002E+001,
      -13.17,
      -1.3180000000000001E+001,
      -13.19,
      -1.3200000000000001E+001,
      -13.21,
      -13.22,
      -13.23,
      -13.24,
      -13.25,
      -1.3260000000000002E+001,
      -1.3270000000000001E+001,
      -1.3280000000000001E+001,
      -1.3290000000000001E+001,
      -13.3,
      -13.31,
      -13.32,
      -13.33,
      -13.34,
      -13.35,
      -1.3360000000000001E+001,
      -1.3370000000000001E+001,
      -13.38,
      -13.39,
      -1.3400000000000002E+001,
      -13.41,
      -1.3420000000000002E+001,
      -13.43,
      -1.3440000000000001E+001,
      -13.45,
      -1.3460000000000003E+001,
      -13.47,
      -1.3480000000000002E+001,
      -13.49,
      -1.3500000000000002E+001,
      -13.51,
      -1.3520000000000001E+001,
      -13.53,
      -1.3540000000000001E+001,
      -1.3549999999999999E+001,
      -1.3560000000000002E+001,
      -13.57,
      -1.3580000000000002E+001,
      -13.59,
      -1.3600000000000001E+001,
      -1.3610000000000001E+001,
      -1.3620000000000001E+001,
      -13.63,
      -13.64,
      -13.65,
      -1.3660000000000002E+001,
      -1.3670000000000002E+001,
      -1.3680000000000001E+001,
      -1.3690000000000001E+001,
      -1.3700000000000001E+001,
      -13.71,
      -13.72,
      -13.73,
      -13.74,
      -13.75,
      -1.3760000000000002E+001,
      -1.3770000000000001E+001,
      -1.3780000000000001E+001,
      -1.3790000000000001E+001,
      -1.3800000000000002E+001,
      -13.81,
      -1.3820000000000002E+001,
      -13.83,
      -1.3840000000000002E+001,
      -13.85,
      -1.3860000000000003E+001,
      -1.3870000000000001E+001,
      -1.3880000000000003E+001,
      -13.89,
      -1.3900000000000002E+001,
      -13.91,
      -1.3920000000000002E+001,
      -13.93,
      -1.3940000000000001E+001,
      -13.95,
      -1.3960000000000003E+001,
      -13.97,
      -1.3980000000000002E+001,
      -13.99,
      -1.4000000000000002E+001,
      -1.4010000000000002E+001,
      -1.4020000000000001E+001,
      -1.4030000000000001E+001,
      -14.04,
      -14.05,
      -1.4059999999999999E+001,
      -1.4070000000000002E+001,
      -14.08,
      -1.4090000000000002E+001,
      -14.1,
      -1.4110000000000001E+001,
      -14.12,
      -14.13,
      -1.4139999999999999E+001,
      -14.15,
      -1.4159999999999998E+001,
      -1.4170000000000002E+001,
      -14.18,
      -1.4190000000000001E+001,
      -1.4200000000000001E+001,
      -14.21,
      -14.22,
      -14.23,
      -14.24,
      -14.25,
      -14.26,
      -1.4270000000000001E+001,
      -1.4280000000000001E+001,
      -1.4290000000000001E+001,
      -14.3,
      -14.31,
      -14.32,
      -14.33,
      -14.34,
      -14.35,
      -14.36,
      -1.4370000000000001E+001,
      -14.38,
      -1.4390000000000002E+001,
      -14.4,
      -1.4410000000000002E+001,
      -14.42,
      -1.4430000000000001E+001,
      -14.44,
      -1.4450000000000001E+001,
      -1.4459999999999999E+001,
      -1.4470000000000002E+001,
      -14.48,
      -1.4490000000000002E+001,
      -14.5,
      -1.4510000000000002E+001,
      -14.52,
      -1.4530000000000001E+001,
      -14.54,
      -14.55,
      -1.4559999999999999E+001,
      -1.4570000000000002E+001,
      -14.58,
      -1.4590000000000002E+001,
      -1.4600000000000001E+001,
      -1.4610000000000001E+001,
      -1.4620000000000001E+001,
      -14.63,
      -14.64,
      -14.65,
      -14.66,
      -1.4670000000000002E+001,
      -1.4680000000000001E+001,
      -1.4690000000000001E+001,
      -1.4700000000000001E+001,
      -14.71,
      -14.72,
      -14.73,
      -14.74,
      -14.75,
      -14.76,
      -1.4770000000000001E+001,
      -1.4780000000000001E+001,
      -1.4790000000000003E+001,
      -14.8,
      -1.4810000000000002E+001,
      -14.82,
      -1.4830000000000002E+001,
      -14.84,
      -1.4850000000000001E+001,
      -14.86,
      -1.4870000000000003E+001,
      -14.88,
      -1.4890000000000002E+001,
      -14.9,
      -1.4910000000000002E+001,
      -14.92,
      -1.4930000000000001E+001,
      -14.94,
      -1.4950000000000001E+001,
      -1.4959999999999999E+001,
      -1.4970000000000002E+001,
      -14.98,
      -1.4990000000000002E+001,
      -1.5000000000000002E+001,
      -1.5010000000000002E+001,
      -1.5020000000000001E+001,
      -1.5030000000000001E+001,
      -1.5040000000000001E+001,
      -15.05,
      -15.06,
      -1.5070000000000002E+001,
      -1.5080000000000002E+001,
      -1.5090000000000002E+001,
      -1.5100000000000001E+001,
      -1.5110000000000001E+001,
      -1.5120000000000001E+001,
      -15.13,
      -15.14,
      -15.15,
      -15.16,
      -1.5170000000000002E+001,
      -1.5180000000000001E+001,
      -1.5190000000000003E+001,
      -1.5200000000000001E+001,
      -1.5210000000000003E+001,
      -15.22,
      -1.5230000000000002E+001,
      -15.24,
      -1.5250000000000002E+001,
      -15.26,
      -1.5270000000000003E+001,
      -1.5280000000000001E+001,
      -1.5290000000000003E+001,
      -15.3,
      -15.31,
      -15.32,
      -15.33,
      -15.34,
      -15.35,
      -15.36,
      -15.37,
      -15.38,
      -15.39,
      -1.5400000000000002E+001,
      -15.41,
      -1.5420000000000002E+001,
      -15.43,
      -1.5440000000000001E+001,
      -15.45,
      -15.46,
      -1.5469999999999999E+001,
      -1.5480000000000002E+001,
      -15.49,
      -1.5500000000000002E+001,
      -15.51,
      -1.5520000000000001E+001,
      -15.53,
      -1.5540000000000001E+001,
      -1.5549999999999999E+001,
      -15.56,
      -1.5569999999999999E+001,
      -1.5580000000000002E+001,
      -15.59,
      -1.5600000000000001E+001,
      -1.5610000000000001E+001,
      -1.5620000000000001E+001,
      -15.63,
      -15.64,
      -15.65,
      -15.66,
      -15.67,
      -1.5680000000000001E+001,
      -1.5690000000000001E+001,
      -1.5700000000000001E+001,
      -15.71,
      -15.72,
      -15.73,
      -15.74,
      -15.75,
      -15.76,
      -15.77,
      -1.5780000000000001E+001,
      -1.5790000000000001E+001,
      -1.5800000000000002E+001,
      -15.81,
      -1.5820000000000002E+001,
      -15.83,
      -1.5840000000000002E+001,
      -15.85,
      -1.5860000000000001E+001,
      -15.87,
      -1.5880000000000003E+001,
      -15.89,
      -1.5900000000000002E+001,
      -15.91,
      -1.5920000000000002E+001,
      -15.93,
      -1.5940000000000001E+001,
      -15.95,
      -15.96,
      -1.5969999999999999E+001,
      -1.5980000000000002E+001,
      -15.99,
      -1.6000000000000004E+001,
      -16.01,
      -1.6020000000000003E+001,
      -16.03,
      -1.6040000000000003E+001,
      -16.05,
      -1.6060000000000002E+001,
      -16.07,
      -1.6080000000000002E+001,
      -16.09,
      -16.1,
      -16.11,
      -16.12,
      -16.13,
      -16.14,
      -16.15,
      -16.16,
      -1.6169999999999998E+001,
      -1.6180000000000003E+001,
      -16.19,
      -1.6200000000000003E+001,
      -16.21,
      -1.6220000000000002E+001,
      -16.23,
      -1.6240000000000002E+001,
      -16.25,
      -16.26,
      -16.27,
      -16.28,
      -1.6290000000000003E+001,
      -16.3,
      -1.6310000000000002E+001,
      -16.32,
      -1.6330000000000002E+001,
      -16.34,
      -16.35,
      -16.36,
      -16.37,
      -1.6380000000000003E+001,
      -16.39,
      -1.6400000000000002E+001,
      -16.41,
      -16.42,
      -16.43,
      -16.44,
      -16.45,
      -16.46,
      -16.47,
      -1.6480000000000004E+001,
      -1.6490000000000002E+001,
      -1.6500000000000004E+001,
      -16.51,
      -1.6520000000000003E+001,
      -16.53,
      -1.6540000000000003E+001,
      -16.55,
      -1.6560000000000002E+001,
      -16.57,
      -16.58,
      -1.6590000000000003E+001,
      -16.6,
      -1.6610000000000003E+001,
      -16.62,
      -1.6630000000000003E+001,
      -16.64,
      -1.6650000000000002E+001,
      -16.66,
      -16.67,
      -16.68,
      -16.69,
      -16.7,
      -1.6710000000000004E+001,
      -1.6720000000000002E+001,
      -16.73,
      -16.74,
      -16.75,
      -1.6759999999999998E+001,
      -16.77,
      -1.6779999999999998E+001,
      -1.6790000000000003E+001,
      -16.8,
      -16.81,
      -16.82,
      -1.6830000000000002E+001,
      -16.84,
      -16.85,
      -1.6860000000000003E+001,
      -16.87,
      -16.88,
      -16.89,
      -1.6900000000000002E+001,
      -1.6910000000000004E+001,
      -16.92,
      -16.93,
      -16.94,
      -16.95,
      -1.6959999999999997E+001,
      -16.97,
      -16.98,
      -1.6990000000000002E+001,
      -17.0,
      -17.01,
      -17.02,
      -17.03,
      -17.04,
      -1.7050000000000004E+001,
      -1.7060000000000002E+001,
      -17.07,
      -17.08,
      -1.7090000000000003E+001,
      -17.1,
      -1.7110000000000003E+001,
      -17.12,
      -1.7130000000000003E+001,
      -17.14,
      -17.15,
      -1.7159999999999997E+001,
      -17.17,
      -17.18,
      -17.19,
      -1.7200000000000003E+001,
      -17.21,
      -17.22,
      -17.23,
      -1.7240000000000002E+001,
      -1.7250000000000004E+001,
      -17.26,
      -17.27,
      -17.28,
      -1.7290000000000003E+001,
      -17.3,
      -1.7310000000000002E+001,
      -1.7320000000000004E+001,
      -1.7330000000000002E+001,
      -17.34,
      -1.7349999999999998E+001,
      -17.36,
      -17.37,
      -17.38,
      -1.7390000000000004E+001,
      -1.7400000000000002E+001,
      -17.41,
      -1.7419999999999998E+001,
      -1.7430000000000003E+001,
      -17.44,
      -1.7450000000000003E+001,
      -17.46,
      -1.7470000000000002E+001,
      -17.48,
      -1.7490000000000002E+001,
      -1.7499999999999996E+001,
      -1.7510000000000005E+001,
      -1.7520000000000003E+001,
      -17.53,
      -17.54,
      -17.55,
      -17.56,
      -17.57,
      -17.58,
      -1.7590000000000003E+001,
      -17.6,
      -17.61,
      -17.62,
      -1.7630000000000003E+001,
      -17.64,
      -1.7650000000000002E+001,
      -1.7660000000000004E+001,
      -17.67,
      -17.68,
      -1.7689999999999998E+001,
      -17.7,
      -1.7710000000000004E+001,
      -1.7720000000000002E+001,
      -17.73,
      -1.7740000000000002E+001,
      -17.75,
      -1.7759999999999998E+001,
      -17.77,
      -17.78,
      -1.7790000000000003E+001,
      -17.8,
      -1.7810000000000002E+001,
      -17.82,
      -1.7830000000000002E+001,
      -17.84,
      -1.7850000000000005E+001,
      -1.7860000000000003E+001,
      -17.87,
      -17.88,
      -17.89,
      -17.9,
      -1.7909999999999997E+001,
      -17.92,
      -1.7930000000000003E+001,
      -17.94,
      -17.95,
      -1.7959999999999997E+001,
      -17.97,
      -17.98,
      -17.99,
      -1.8000000000000004E+001,
      -18.01,
      -18.02,
      -1.8029999999999998E+001,
      -1.8040000000000003E+001,
      -18.05,
      -1.8060000000000002E+001,
      -18.07,
      -1.8080000000000002E+001,
      -18.09,
      -1.8099999999999998E+001,
      -1.8109999999999996E+001,
      -1.8120000000000005E+001,
      -1.8130000000000003E+001,
      -18.14,
      -18.15,
      -18.16,
      -1.8169999999999998E+001,
      -18.18,
      -1.8189999999999998E+001,
      -1.8200000000000003E+001,
      -18.21,
      -18.22,
      -18.23,
      -1.8240000000000002E+001,
      -18.25,
      -18.26,
      -1.8270000000000003E+001,
      -18.28,
      -18.29,
      -1.8299999999999997E+001,
      -18.31,
      -1.8320000000000004E+001,
      -1.8330000000000002E+001,
      -18.34,
      -18.35,
      -18.36,
      -1.8369999999999997E+001,
      -18.38,
      -18.39,
      -1.8400000000000002E+001,
      -18.41,
      -18.42,
      -18.43,
      -18.44,
      -18.45,
      -1.8460000000000004E+001,
      -1.8470000000000002E+001,
      -18.48,
      -18.49,
      -18.5,
      -1.8509999999999998E+001,
      -1.8520000000000003E+001,
      -18.53,
      -1.8540000000000003E+001,
      -18.55,
      -18.56,
      -1.8569999999999997E+001,
      -1.8580000000000002E+001,
      -18.59,
      -18.6,
      -1.8610000000000003E+001,
      -18.62,
      -18.63,
      -18.64,
      -1.8650000000000002E+001,
      -1.8660000000000004E+001,
      -18.67,
      -18.68,
      -18.69,
      -18.7,
      -1.8709999999999997E+001,
      -1.8720000000000002E+001,
      -1.8730000000000004E+001,
      -1.8740000000000002E+001,
      -18.75,
      -1.8759999999999998E+001,
      -18.77,
      -1.8779999999999998E+001,
      -1.8789999999999996E+001,
      -1.8800000000000004E+001,
      -1.8810000000000002E+001,
      -18.82,
      -18.83,
      -18.84,
      -1.8849999999999998E+001,
      -1.8860000000000003E+001,
      -18.87,
      -1.8880000000000003E+001,
      -18.89,
      -18.9,
      -1.8909999999999997E+001,
      -1.8920000000000005E+001,
      -1.8930000000000003E+001,
      -18.94,
      -18.95,
      -18.96,
      -18.97,
      -1.8979999999999997E+001,
      -1.8989999999999995E+001,
      -1.9000000000000004E+001,
      -19.01,
      -19.02,
      -19.03,
      -19.04,
      -1.9049999999999997E+001,
      -1.9060000000000002E+001,
      -1.9070000000000004E+001,
      -1.9080000000000002E+001,
      -19.09,
      -1.9099999999999998E+001,
      -19.11,
      -1.9120000000000005E+001,
      -1.9130000000000003E+001,
      -19.14,
      -1.9150000000000002E+001,
      -19.16,
      -1.9169999999999998E+001,
      -1.9179999999999996E+001,
      -1.9190000000000005E+001,
      -1.9200000000000003E+001,
      -19.21,
      -1.9220000000000002E+001,
      -19.23,
      -19.24,
      -1.9249999999999996E+001,
      -1.9259999999999998E+001,
      -1.9270000000000003E+001,
      -19.28,
      -19.29,
      -19.3,
      -19.31,
      -1.9319999999999997E+001,
      -1.9330000000000002E+001,
      -1.9340000000000003E+001,
      -19.35,
      -19.36,
      -1.9369999999999997E+001,
      -19.38,
      -1.9390000000000004E+001,
      -1.9400000000000002E+001,
      -1.9410000000000004E+001,
      -19.42,
      -19.43,
      -1.9439999999999998E+001,
      -19.45,
      -1.9459999999999997E+001,
      -1.9470000000000002E+001,
      -19.48,
      -1.9490000000000002E+001,
      -19.5,
      -1.9509999999999998E+001,
      -1.9519999999999996E+001,
      -1.9530000000000005E+001,
      -1.9540000000000003E+001,
      -19.55,
      -19.56,
      -19.57,
      -19.58,
      -1.9590000000000003E+001,
      -1.9600000000000005E+001,
      -1.9610000000000003E+001,
      -19.62,
      -19.63,
      -19.64,
      -19.65,
      -1.9659999999999997E+001,
      -19.67,
      -1.9680000000000003E+001,
      -19.69,
      -19.7,
      -1.9709999999999997E+001,
      -19.72,
      -1.9730000000000004E+001,
      -1.9740000000000002E+001,
      -19.75,
      -19.76,
      -19.77,
      -1.9779999999999998E+001,
      -1.9790000000000006E+001,
      -1.9800000000000004E+001,
      -1.9810000000000002E+001,
      -19.82,
      -1.9830000000000002E+001,
      -19.84,
      -1.9849999999999998E+001,
      -1.9859999999999996E+001,
      -1.9870000000000005E+001,
      -1.9880000000000003E+001,
      -19.89,
      -19.9,
      -19.91,
      -1.9919999999999998E+001,
      -1.9930000000000003E+001,
      -19.94,
      -1.9950000000000003E+001,
      -19.96,
      -19.97,
      -1.9979999999999997E+001,
      -1.9990000000000006E+001,
      -2.0000000000000004E+001,
      -20.01,
      -2.0020000000000003E+001,
      -20.03,
      -20.04,
      -2.0049999999999997E+001,
      -20.06,
      -2.0070000000000004E+001,
      -2.0080000000000002E+001,
      -20.09,
      -20.1,
      -20.11,
      -2.0119999999999997E+001,
      -2.0130000000000003E+001,
      -2.0140000000000004E+001,
      -2.0150000000000002E+001,
      -20.16,
      -2.0169999999999998E+001,
      -20.18,
      -2.0190000000000005E+001,
      -2.0200000000000003E+001,
      -2.0210000000000004E+001,
      -2.0220000000000002E+001,
      -20.23,
      -20.24,
      -20.25,
      -2.0259999999999998E+001,
      -2.0270000000000003E+001,
      -20.28,
      -2.0290000000000003E+001,
      -20.3,
      -20.31,
      -2.0319999999999997E+001,
      -2.0330000000000005E+001,
      -2.0340000000000003E+001,
      -20.35,
      -20.36,
      -20.37,
      -20.38,
      -2.0390000000000004E+001,
      -2.0400000000000006E+001,
      -2.0410000000000004E+001,
      -20.42,
      -20.43,
      -20.44,
      -20.45,
      -2.0459999999999997E+001,
      -2.0469999999999995E+001,
      -2.0480000000000004E+001,
      -2.0490000000000002E+001,
      -20.5,
      -2.0509999999999998E+001,
      -20.52,
      -2.0529999999999998E+001,
      -2.0540000000000003E+001,
      -20.55,
      -2.0560000000000002E+001,
      -20.57,
      -20.58,
      -2.0589999999999996E+001,
      -2.0600000000000005E+001,
      -2.0610000000000003E+001,
      -20.62,
      -2.0630000000000003E+001,
      -20.64,
      -20.65,
      -2.0659999999999997E+001,
      -2.0669999999999998E+001,
      -2.0680000000000003E+001,
      -20.69,
      -20.7,
      -20.71,
      -20.72,
      -2.0729999999999997E+001,
      -2.0740000000000002E+001,
      -2.0750000000000004E+001,
      -20.76,
      -20.77,
      -2.0779999999999998E+001,
      -20.79,
      -2.0800000000000004E+001,
      -2.0810000000000002E+001,
      -2.0820000000000004E+001,
      -2.0830000000000002E+001,
      -20.84,
      -2.0849999999999998E+001,
      -20.86,
      -2.0869999999999997E+001,
      -2.0880000000000003E+001,
      -20.89,
      -2.0900000000000002E+001,
      -20.91,
      -2.0919999999999998E+001,
      -2.0929999999999996E+001,
      -2.0940000000000005E+001,
      -2.0950000000000003E+001,
      -20.96,
      -20.97,
      -20.98,
      -20.99,
      -2.1000000000000004E+001,
      -2.1010000000000005E+001,
      -2.1020000000000003E+001,
      -21.03,
      -21.04,
      -21.05,
      -21.06,
      -2.1069999999999997E+001,
      -2.1080000000000002E+001,
      -2.1090000000000003E+001,
      -21.1,
      -21.11,
      -2.1119999999999997E+001,
      -21.13,
      -2.1140000000000004E+001,
      -2.1150000000000002E+001,
      -21.16,
      -21.17,
      -21.18,
      -2.1189999999999998E+001,
      -2.1200000000000006E+001,
      -2.1210000000000004E+001,
      -2.1220000000000002E+001,
      -21.23,
      -2.1240000000000002E+001,
      -21.25,
      -2.1259999999999998E+001,
      -2.1269999999999996E+001,
      -2.1280000000000005E+001,
      -2.1290000000000003E+001,
      -21.3,
      -21.31,
      -21.32,
      -21.33,
      -2.1340000000000003E+001,
      -21.35,
      -2.1360000000000003E+001,
      -21.37,
      -21.38,
      -2.1389999999999997E+001,
      -2.1400000000000006E+001,
      -2.1410000000000004E+001,
      -21.42,
      -2.1430000000000003E+001,
      -21.44,
      -21.45,
      -2.1459999999999997E+001,
      -21.47,
      -2.1480000000000004E+001,
      -2.1490000000000002E+001,
      -21.5,
      -21.51,
      -21.52,
      -2.1529999999999998E+001,
      -2.1540000000000003E+001,
      -2.1550000000000004E+001,
      -2.1560000000000002E+001,
      -21.57,
      -21.58,
      -21.59,
      -2.1600000000000005E+001,
      -2.1610000000000003E+001,
      -2.1620000000000005E+001,
      -2.1630000000000003E+001,
      -21.64,
      -21.65,
      -21.66,
      -2.1669999999999998E+001,
      -2.1680000000000003E+001,
      -21.69,
      -2.1700000000000003E+001,
      -21.71,
      -21.72,
      -2.1729999999999997E+001,
      -21.74,
      -2.1750000000000004E+001,
      -21.76,
      -21.77,
      -21.78,
      -21.79,
      -2.1799999999999997E+001,
      -2.1810000000000006E+001,
      -2.1820000000000004E+001,
      -2.1830000000000002E+001,
      -21.84,
      -21.85,
      -21.86,
      -2.1869999999999997E+001,
      -2.1879999999999995E+001,
      -2.1890000000000004E+001,
      -2.1900000000000002E+001,
      -21.91,
      -2.1919999999999998E+001,
      -21.93,
      -2.1939999999999998E+001,
      -2.1950000000000003E+001,
      -21.96,
      -2.1970000000000002E+001,
      -21.98,
      -21.99,
      -2.1999999999999996E+001,
      -2.2010000000000005E+001,
      -2.2020000000000003E+001,
      -22.03,
      -2.2040000000000003E+001,
      -22.05,
      -22.06,
      -2.2069999999999997E+001,
      -22.08,
      -2.2090000000000003E+001,
      -22.1,
      -22.11,
      -22.12,
      -22.13,
      -2.2139999999999997E+001,
      -2.2150000000000002E+001,
      -2.2160000000000004E+001,
      -22.17,
      -22.18,
      -2.2189999999999998E+001,
      -22.2,
      -2.2210000000000004E+001,
      -2.2220000000000002E+001,
      -2.2230000000000004E+001,
      -2.2240000000000002E+001,
      -22.25,
      -2.2259999999999998E+001,
      -22.27,
      -2.2279999999999998E+001,
      -2.2290000000000003E+001,
      -22.3,
      -2.2310000000000002E+001,
      -22.32,
      -22.33,
      -2.2339999999999996E+001,
      -2.2350000000000005E+001,
      -2.2360000000000003E+001,
      -22.37,
      -22.38,
      -22.39,
      -22.4,
      -2.2410000000000004E+001,
      -2.2420000000000005E+001,
      -2.2430000000000003E+001,
      -22.44,
      -22.45,
      -22.46,
      -22.47,
      -2.2479999999999997E+001,
      -2.2490000000000002E+001,
      -2.2500000000000004E+001,
      -22.51,
      -22.52,
      -2.2529999999999998E+001,
      -22.54,
      -2.2549999999999997E+001,
      -2.2560000000000002E+001,
      -22.57,
      -2.2580000000000002E+001,
      -22.59,
      -2.2600000000000005E+001,
      -2.2610000000000007E+001,
      -2.2620000000000005E+001,
      -2.2630000000000003E+001,
      -22.64,
      -2.2650000000000002E+001,
      -22.66,
      -2.2669999999999998E+001,
      -2.2680000000000003E+001,
      -2.2690000000000005E+001,
      -2.2700000000000003E+001,
      -22.71,
      -22.72,
      -22.73,
      -22.74,
      -2.2749999999999996E+001,
      -22.76,
      -2.2770000000000003E+001,
      -22.78,
      -22.79,
      -2.2800000000000008E+001,
      -2.2810000000000006E+001,
      -2.2820000000000004E+001,
      -2.2830000000000002E+001,
      -2.2840000000000003E+001,
      -22.85,
      -22.86,
      -2.2869999999999997E+001,
      -2.2880000000000006E+001,
      -2.2890000000000004E+001,
      -2.2900000000000002E+001,
      -22.91,
      -22.92,
      -22.93,
      -2.2939999999999998E+001,
      -2.2949999999999996E+001,
      -2.2960000000000004E+001,
      -2.2970000000000002E+001,
      -22.98,
      -22.99,
      -23.0,
      -2.3010000000000005E+001,
      -2.3020000000000003E+001,
      -2.3030000000000005E+001,
      -2.3040000000000003E+001,
      -23.05,
      -23.06,
      -23.07,
      -23.08,
      -2.3090000000000003E+001,
      -23.1,
      -2.3110000000000003E+001,
      -23.12,
      -23.13,
      -2.3139999999999997E+001,
      -23.15,
      -2.3159999999999997E+001,
      -23.17,
      -23.18,
      -23.19,
      -23.2,
      -2.3210000000000004E+001,
      -2.3220000000000006E+001,
      -2.3230000000000004E+001,
      -2.3240000000000002E+001,
      -23.25,
      -23.26,
      -23.27,
      -2.3279999999999998E+001,
      -2.3290000000000003E+001,
      -2.3300000000000004E+001,
      -2.3310000000000002E+001,
      -23.32,
      -23.33,
      -23.34,
      -2.3349999999999998E+001,
      -2.3359999999999996E+001,
      -23.37,
      -2.3380000000000003E+001,
      -23.39,
      -23.4,
      -2.3410000000000007E+001,
      -2.3420000000000005E+001,
      -2.3430000000000003E+001,
      -23.44,
      -2.3450000000000003E+001,
      -23.46,
      -23.47,
      -2.3479999999999997E+001,
      -2.3490000000000006E+001,
      -2.3500000000000004E+001,
      -23.51,
      -23.52,
      -23.53,
      -23.54,
      -2.3549999999999997E+001,
      -2.3559999999999995E+001,
      -2.3570000000000004E+001,
      -2.3580000000000002E+001,
      -23.59,
      -2.3599999999999998E+001,
      -2.3610000000000007E+001,
      -2.3620000000000005E+001,
      -2.3630000000000003E+001,
      -2.3640000000000004E+001,
      -2.3650000000000002E+001,
      -23.66,
      -2.3669999999999998E+001,
      -23.68,
      -2.3690000000000005E+001,
      -2.3700000000000003E+001,
      -23.71,
      -2.3720000000000002E+001,
      -23.73,
      -23.74,
      -2.3749999999999996E+001,
      -2.3759999999999998E+001,
      -2.3770000000000003E+001,
      -23.78,
      -23.79,
      -23.8,
      -2.3810000000000006E+001,
      -2.3820000000000004E+001,
      -2.3830000000000005E+001,
      -2.3840000000000003E+001,
      -23.85,
      -23.86,
      -23.87,
      -23.88,
      -2.3890000000000004E+001,
      -2.3900000000000002E+001,
      -2.3910000000000004E+001,
      -23.92,
      -23.93,
      -2.3939999999999998E+001,
      -23.95,
      -2.3959999999999997E+001,
      -2.3970000000000002E+001,
      -23.98,
      -2.3990000000000002E+001,
      -24.0,
      -2.4010000000000005E+001,
      -2.4020000000000007E+001,
      -2.4030000000000005E+001,
      -2.4040000000000003E+001,
      -24.05,
      -2.4060000000000002E+001,
      -24.07,
      -24.08,
      -2.4090000000000003E+001,
      -2.4100000000000005E+001,
      -2.4110000000000003E+001,
      -24.12,
      -24.13,
      -24.14,
      -24.15,
      -2.4159999999999997E+001,
      -2.4170000000000005E+001,
      -2.4180000000000003E+001,
      -24.19,
      -24.2,
      -2.4210000000000008E+001,
      -2.4220000000000006E+001,
      -2.4230000000000004E+001,
      -2.4240000000000002E+001,
      -2.4250000000000004E+001,
      -24.26,
      -24.27,
      -2.4279999999999998E+001,
      -24.29,
      -2.4300000000000004E+001,
      -2.4310000000000002E+001,
      -24.32,
      -2.4330000000000002E+001,
      -24.34,
      -2.4349999999999998E+001,
      -2.4359999999999996E+001,
      -2.4369999999999997E+001,
      -2.4380000000000003E+001,
      -24.39,
      -2.4400000000000002E+001,
      -24.41,
      -2.4420000000000005E+001,
      -2.4430000000000003E+001,
      -2.4440000000000005E+001,
      -2.4450000000000003E+001,
      -24.46,
      -24.47,
      -24.48,
      -24.49,
      -2.4500000000000004E+001,
      -24.51,
      -2.4520000000000003E+001,
      -24.53,
      -24.54,
      -2.4549999999999997E+001,
      -24.56,
      -2.4569999999999997E+001,
      -2.4580000000000002E+001,
      -2.4590000000000003E+001,
      -24.6,
      -24.61,
      -2.4620000000000005E+001,
      -2.4630000000000006E+001,
      -2.4640000000000004E+001,
      -2.4650000000000002E+001,
      -24.66,
      -24.67,
      -24.68,
      -2.4689999999999998E+001,
      -2.4700000000000003E+001,
      -2.4710000000000004E+001,
      -2.4720000000000002E+001,
      -24.73,
      -24.74,
      -24.75,
      -2.4759999999999998E+001,
      -2.4769999999999996E+001,
      -2.4780000000000005E+001,
      -2.4790000000000003E+001,
      -24.8,
      -24.81,
      -2.4820000000000007E+001,
      -2.4830000000000005E+001,
      -2.4840000000000003E+001,
      -24.85,
      -2.4860000000000003E+001,
      -24.87,
      -24.88,
      -2.4889999999999997E+001,
      -2.4900000000000006E+001,
      -2.4910000000000004E+001,
      -24.92,
      -24.93,
      -24.94,
      -24.95,
      -2.4959999999999997E+001,
      -2.4969999999999995E+001,
      -2.4980000000000004E+001,
      -2.4990000000000002E+001,
      -25.0,
      -25.01,
      -2.5020000000000007E+001,
      -2.5030000000000005E+001,
      -2.5040000000000003E+001,
      -2.5050000000000004E+001,
      -2.5060000000000002E+001,
      -25.07,
      -25.08,
      -25.09,
      -2.5100000000000005E+001,
      -2.5110000000000003E+001,
      -25.12,
      -2.5130000000000003E+001,
      -25.14,
      -25.15,
      -2.5159999999999997E+001,
      -2.5169999999999998E+001,
      -2.5180000000000003E+001,
      -25.19,
      -2.5200000000000003E+001,
      -25.21,
      -2.5220000000000006E+001,
      -2.5230000000000004E+001,
      -2.5240000000000006E+001,
      -2.5250000000000004E+001,
      -25.26,
      -25.27,
      -25.28,
      -25.29,
      -2.5300000000000004E+001,
      -2.5310000000000002E+001,
      -2.5320000000000004E+001,
      -2.5330000000000002E+001,
      -25.34,
      -2.5349999999999998E+001,
      -25.36,
      -2.5369999999999997E+001,
      -2.5380000000000003E+001,
      -2.5390000000000004E+001,
      -2.5400000000000002E+001,
      -25.41,
      -2.5420000000000005E+001,
      -2.5430000000000007E+001,
      -2.5440000000000005E+001,
      -2.5450000000000003E+001,
      -25.46,
      -2.5470000000000002E+001,
      -25.48,
      -25.49,
      -2.5500000000000004E+001,
      -2.5510000000000005E+001,
      -2.5520000000000003E+001,
      -25.53,
      -25.54,
      -25.55,
      -25.56,
      -2.5569999999999997E+001,
      -2.5579999999999995E+001,
      -2.5590000000000003E+001,
      -25.6,
      -25.61,
      -25.62,
      -2.5630000000000006E+001,
      -2.5640000000000004E+001,
      -2.5650000000000002E+001,
      -2.5660000000000004E+001,
      -25.67,
      -25.68,
      -2.5689999999999998E+001,
      -25.7,
      -2.5710000000000004E+001,
      -2.5720000000000002E+001,
      -25.73,
      -2.5740000000000002E+001,
      -25.75,
      -2.5759999999999998E+001,
      -2.5769999999999996E+001,
      -2.5779999999999998E+001,
      -2.5790000000000003E+001,
      -25.8,
      -2.5810000000000002E+001,
      -25.82,
      -2.5830000000000005E+001,
      -2.5840000000000003E+001,
      -2.5850000000000005E+001,
      -2.5860000000000003E+001,
      -25.87,
      -25.88,
      -25.89,
      -25.9,
      -2.5910000000000004E+001,
      -25.92,
      -2.5930000000000003E+001,
      -25.94,
      -25.95,
      -2.5959999999999997E+001,
      -25.97,
      -2.5979999999999997E+001,
      -2.5990000000000002E+001,
      -2.6000000000000004E+001,
      -26.01,
      -26.02,
      -2.6030000000000005E+001,
      -2.6040000000000006E+001,
      -2.6050000000000004E+001,
      -2.6060000000000002E+001,
      -26.07,
      -2.6080000000000002E+001,
      -26.09,
      -2.6099999999999998E+001,
      -2.6110000000000003E+001,
      -2.6120000000000005E+001,
      -2.6130000000000003E+001,
      -26.14,
      -26.15,
      -26.16,
      -2.6169999999999998E+001,
      -2.6179999999999996E+001,
      -2.6190000000000005E+001,
      -2.6200000000000003E+001,
      -26.21,
      -26.22,
      -2.6230000000000008E+001,
      -2.6240000000000006E+001,
      -2.6250000000000004E+001,
      -26.26,
      -2.6270000000000003E+001,
      -26.28,
      -26.29,
      -2.6299999999999997E+001,
      -2.6310000000000006E+001,
      -2.6320000000000004E+001,
      -2.6330000000000002E+001,
      -26.34,
      -26.35,
      -26.36,
      -2.6369999999999997E+001,
      -2.6379999999999995E+001,
      -2.6390000000000004E+001,
      -2.6400000000000002E+001,
      -26.41,
      -26.42,
      -2.6430000000000007E+001,
      -2.6440000000000005E+001,
      -2.6450000000000003E+001,
      -2.6460000000000004E+001,
      -2.6470000000000002E+001,
      -26.48,
      -26.49,
      -26.5,
      -2.6510000000000005E+001,
      -2.6520000000000003E+001,
      -26.53,
      -2.6540000000000003E+001,
      -26.55,
      -26.56,
      -2.6569999999999997E+001,
      -26.58,
      -2.6590000000000003E+001,
      -26.6,
      -2.6610000000000003E+001,
      -26.62,
      -2.6630000000000006E+001,
      -2.6640000000000004E+001,
      -2.6650000000000006E+001,
      -2.6660000000000004E+001,
      -26.67,
      -26.68,
      -26.69,
      -26.7,
      -2.6710000000000004E+001,
      -2.6720000000000002E+001,
      -2.6730000000000004E+001,
      -2.6740000000000002E+001,
      -26.75,
      -2.6759999999999998E+001,
      -26.77,
      -2.6779999999999998E+001,
      -2.6790000000000003E+001,
      -2.6800000000000004E+001,
      -2.6810000000000002E+001,
      -26.82,
      -26.83,
      -2.6840000000000007E+001,
      -2.6850000000000005E+001,
      -2.6860000000000003E+001,
      -26.87,
      -2.6880000000000003E+001,
      -26.89,
      -26.9,
      -2.6909999999999997E+001,
      -2.6920000000000005E+001,
      -2.6930000000000003E+001,
      -26.94,
      -26.95,
      -26.96,
      -26.97,
      -2.6979999999999997E+001,
      -2.6989999999999995E+001,
      -2.7000000000000004E+001,
      -27.01,
      -27.02,
      -27.03,
      -2.7040000000000006E+001,
      -2.7050000000000004E+001,
      -2.7060000000000002E+001,
      -2.7070000000000004E+001,
      -2.7080000000000002E+001,
      -27.09,
      -2.7099999999999998E+001,
      -27.11,
      -2.7120000000000005E+001,
      -2.7130000000000003E+001,
      -27.14,
      -2.7150000000000002E+001,
      -27.16,
      -2.7169999999999998E+001,
      -2.7179999999999996E+001,
      -2.7189999999999998E+001,
      -2.7200000000000003E+001,
      -27.21,
      -2.7220000000000002E+001,
      -27.23,
      -2.7240000000000006E+001,
      -2.7250000000000004E+001,
      -2.7260000000000005E+001,
      -2.7270000000000003E+001,
      -27.28,
      -27.29,
      -27.3,
      -27.31,
      -2.7320000000000004E+001,
      -2.7330000000000002E+001,
      -2.7340000000000003E+001,
      -27.35,
      -27.36,
      -2.7369999999999997E+001,
      -27.38,
      -2.7389999999999997E+001,
      -2.7400000000000002E+001,
      -2.7410000000000004E+001,
      -27.42,
      -27.43,
      -2.7440000000000005E+001,
      -2.7450000000000006E+001,
      -2.7460000000000004E+001,
      -2.7470000000000002E+001,
      -27.48,
      -2.7490000000000002E+001,
      -27.5,
      -2.7509999999999998E+001,
      -2.7520000000000003E+001,
      -2.7530000000000005E+001,
      -2.7540000000000003E+001,
      -27.55,
      -27.56,
      -27.57,
      -27.58,
      -2.7589999999999996E+001,
      -2.7600000000000005E+001,
      -2.7610000000000003E+001,
      -27.62,
      -27.63,
      -2.7640000000000008E+001,
      -2.7650000000000006E+001,
      -2.7660000000000004E+001,
      -27.67,
      -2.7680000000000003E+001,
      -27.69,
      -27.7,
      -2.7709999999999997E+001,
      -2.7720000000000006E+001,
      -2.7730000000000004E+001,
      -2.7740000000000002E+001,
      -27.75,
      -27.76,
      -27.77,
      -2.7779999999999998E+001,
      -2.7789999999999996E+001,
      -2.7800000000000004E+001,
      -2.7810000000000002E+001,
      -27.82,
      -2.7830000000000002E+001,
      -2.7840000000000007E+001,
      -2.7850000000000005E+001,
      -2.7860000000000003E+001,
      -2.7870000000000005E+001,
      -2.7880000000000003E+001,
      -27.89,
      -27.9,
      -27.91,
      -2.7920000000000005E+001,
      -2.7930000000000003E+001,
      -27.94,
      -2.7950000000000003E+001,
      -27.96,
      -27.97,
      -2.7979999999999997E+001,
      -27.99,
      -2.8000000000000004E+001,
      -28.01,
      -2.8020000000000003E+001,
      -28.03,
      -2.8040000000000006E+001,
      -2.8050000000000004E+001,
      -2.8060000000000006E+001,
      -2.8070000000000004E+001,
      -2.8080000000000002E+001,
      -28.09,
      -28.1,
      -28.11,
      -2.8119999999999997E+001,
      -2.8130000000000003E+001,
      -2.8140000000000004E+001,
      -2.8150000000000002E+001,
      -28.16,
      -2.8169999999999998E+001,
      -28.18,
      -2.8189999999999998E+001,
      -2.8199999999999996E+001,
      -2.8210000000000004E+001,
      -2.8220000000000002E+001,
      -28.23,
      -28.24,
      -2.8250000000000007E+001,
      -2.8260000000000005E+001,
      -2.8270000000000003E+001,
      -28.28,
      -2.8290000000000003E+001,
      -28.3,
      -28.31,
      -2.8319999999999997E+001,
      -2.8330000000000005E+001,
      -2.8340000000000003E+001,
      -28.35,
      -28.36,
      -28.37,
      -28.38,
      -2.8389999999999997E+001,
      -2.8399999999999995E+001,
      -2.8410000000000004E+001,
      -28.42,
      -28.43,
      -28.44,
      -2.8450000000000006E+001,
      -2.8460000000000004E+001,
      -2.8470000000000002E+001,
      -2.8480000000000004E+001,
      -2.8490000000000002E+001,
      -28.5,
      -2.8509999999999998E+001,
      -28.52,
      -2.8530000000000005E+001,
      -2.8540000000000003E+001,
      -28.55,
      -2.8560000000000002E+001,
      -28.57,
      -28.58,
      -2.8589999999999996E+001,
      -2.8599999999999998E+001,
      -2.8610000000000003E+001,
      -28.62,
      -2.8630000000000003E+001,
      -28.64,
      -2.8650000000000006E+001,
      -2.8660000000000004E+001,
      -2.8670000000000005E+001,
      -2.8680000000000003E+001,
      -28.69,
      -28.7,
      -28.71,
      -28.72,
      -2.8730000000000004E+001,
      -2.8740000000000002E+001,
      -2.8750000000000004E+001,
      -28.76,
      -28.77,
      -2.8779999999999998E+001,
      -28.79,
      -2.8799999999999997E+001,
      -2.8810000000000002E+001,
      -2.8820000000000004E+001,
      -2.8830000000000002E+001,
      -28.84,
      -2.8850000000000005E+001,
      -2.8860000000000007E+001,
      -2.8870000000000005E+001,
      -2.8880000000000003E+001,
      -28.89,
      -2.8900000000000002E+001,
      -28.91,
      -2.8919999999999998E+001,
      -2.8930000000000003E+001,
      -2.8940000000000005E+001,
      -2.8950000000000003E+001,
      -28.96,
      -28.97,
      -28.98,
      -28.99,
      -2.8999999999999996E+001,
      -2.9010000000000005E+001,
      -2.9020000000000003E+001,
      -29.03,
      -29.04,
      -2.9050000000000008E+001,
      -2.9060000000000006E+001,
      -2.9070000000000004E+001,
      -2.9080000000000002E+001,
      -2.9090000000000003E+001,
      -29.1,
      -29.11,
      -2.9119999999999997E+001,
      -2.9130000000000006E+001,
      -2.9140000000000004E+001,
      -2.9150000000000002E+001,
      -29.16,
      -29.17,
      -29.18,
      -2.9189999999999998E+001,
      -2.9199999999999996E+001,
      -2.9210000000000004E+001,
      -2.9220000000000002E+001,
      -29.23,
      -2.9240000000000002E+001,
      -2.9250000000000007E+001,
      -2.9260000000000005E+001,
      -2.9270000000000003E+001,
      -2.9280000000000005E+001,
      -2.9290000000000003E+001,
      -29.3,
      -29.31,
      -29.32,
      -2.9330000000000005E+001,
      -2.9340000000000003E+001,
      -29.35,
      -2.9360000000000003E+001,
      -29.37,
      -29.38,
      -2.9389999999999997E+001,
      -29.4,
      -2.9409999999999997E+001,
      -29.42,
      -2.9430000000000003E+001,
      -29.44,
      -29.45,
      -2.9460000000000004E+001,
      -2.9470000000000006E+001,
      -2.9480000000000004E+001,
      -2.9490000000000002E+001,
      -29.5,
      -29.51,
      -29.52,
      -2.9529999999999998E+001,
      -2.9540000000000003E+001,
      -2.9550000000000004E+001,
      -2.9560000000000002E+001,
      -29.57,
      -29.58,
      -29.59,
      -2.9599999999999998E+001,
      -2.9609999999999996E+001,
      -2.9620000000000005E+001,
      -2.9630000000000003E+001,
      -29.64,
      -29.65,
      -2.9660000000000007E+001,
      -2.9670000000000005E+001,
      -2.9680000000000003E+001,
      -29.69,
      -2.9700000000000003E+001,
      -29.71,
      -29.72,
      -2.9729999999999997E+001,
      -2.9740000000000006E+001,
      -2.9750000000000004E+001,
      -29.76,
      -29.77,
      -29.78,
      -29.79,
      -2.9799999999999997E+001,
      -2.9809999999999995E+001,
      -2.9820000000000004E+001,
      -2.9830000000000002E+001,
      -29.84,
      -29.85,
      -2.9860000000000007E+001,
      -2.9870000000000005E+001,
      -2.9880000000000003E+001,
      -2.9890000000000004E+001,
      -2.9900000000000002E+001,
      -29.91,
      -2.9919999999999998E+001,
      -29.93,
      -2.9940000000000005E+001,
      -2.9950000000000003E+001,
      -29.96,
      -2.9970000000000002E+001,
      -29.98,
      -29.99,
      -2.9999999999999996E+001,
      -3.0009999999999998E+001,
      -3.0020000000000003E+001,
      -30.03,
      -3.0040000000000003E+001,
      -30.05,
      -3.0060000000000006E+001,
      -3.0070000000000004E+001,
      -3.0080000000000005E+001,
      -3.0090000000000003E+001,
      -30.1,
      -30.11,
      -30.12,
      -30.13,
      -3.0140000000000004E+001,
      -3.0150000000000002E+001,
      -3.0160000000000004E+001,
      -30.17,
      -30.18,
      -3.0189999999999998E+001,
      -30.2,
      -3.0209999999999997E+001,
      -3.0220000000000002E+001,
      -3.0230000000000004E+001,
      -3.0240000000000002E+001,
      -30.25,
      -3.0260000000000005E+001,
      -3.0270000000000007E+001,
      -3.0280000000000005E+001,
      -3.0290000000000003E+001,
      -30.3,
      -3.0310000000000002E+001,
      -30.32,
      -30.33,
      -3.0340000000000003E+001,
      -3.0350000000000005E+001,
      -3.0360000000000003E+001,
      -30.37,
      -30.38,
      -30.39,
      -30.4,
      -3.0409999999999997E+001,
      -3.0420000000000005E+001,
      -3.0430000000000003E+001,
      -30.44,
      -30.45,
      -3.0460000000000008E+001,
      -3.0470000000000006E+001,
      -3.0480000000000004E+001,
      -3.0490000000000002E+001,
      -3.0500000000000004E+001,
      -30.51,
      -30.52,
      -3.0529999999999998E+001,
      -3.0540000000000006E+001,
      -3.0550000000000004E+001,
      -3.0560000000000002E+001,
      -30.57,
      -3.0580000000000002E+001,
      -30.59,
      -3.0599999999999998E+001,
      -3.0609999999999996E+001,
      -3.0620000000000005E+001,
      -3.0630000000000003E+001,
      -30.64,
      -3.0650000000000002E+001,
      -30.66,
      -3.0670000000000005E+001,
      -3.0680000000000003E+001,
      -3.0690000000000005E+001,
      -3.0700000000000003E+001,
      -30.71,
      -30.72,
      -30.73,
      -30.74,
      -3.0750000000000004E+001,
      -30.76,
      -3.0770000000000003E+001,
      -30.78,
      -30.79,
      -3.0799999999999997E+001,
      -30.81,
      -3.0819999999999997E+001,
      -3.0830000000000002E+001,
      -3.0840000000000003E+001,
      -30.85,
      -30.86,
      -3.0870000000000005E+001,
      -3.0880000000000006E+001,
      -3.0890000000000004E+001,
      -3.0900000000000002E+001,
      -30.91,
      -30.92,
      -30.93,
      -3.0939999999999998E+001,
      -3.0950000000000003E+001,
      -3.0960000000000004E+001,
      -3.0970000000000002E+001,
      -30.98,
      -30.99,
      -31.0,
      -3.1009999999999998E+001,
      -3.1019999999999996E+001,
      -3.1030000000000005E+001,
      -3.1040000000000003E+001,
      -31.05,
      -31.06,
      -3.1070000000000007E+001,
      -3.1080000000000005E+001,
      -3.1090000000000003E+001,
      -31.1,
      -3.1110000000000003E+001,
      -31.12,
      -31.13,
      -3.1139999999999997E+001,
      -3.1150000000000006E+001,
      -3.1160000000000004E+001,
      -31.17,
      -31.18,
      -31.19,
      -31.2,
      -3.1209999999999997E+001,
      -3.1219999999999995E+001,
      -3.1230000000000004E+001,
      -3.1240000000000002E+001,
      -31.25,
      -31.26,
      -3.1270000000000007E+001,
      -3.1280000000000005E+001,
      -3.1290000000000003E+001,
      -3.1300000000000004E+001,
      -3.1310000000000002E+001,
      -31.32,
      -31.33,
      -31.34,
      -3.1350000000000005E+001,
      -3.1360000000000003E+001,
      -31.37,
      -3.1380000000000003E+001,
      -31.39,
      -31.4,
      -3.1409999999999997E+001,
      -3.1419999999999998E+001,
      -3.1430000000000003E+001,
      -31.44,
      -3.1450000000000003E+001,
      -31.46,
      -3.1470000000000006E+001,
      -3.1480000000000004E+001,
      -3.1490000000000006E+001,
      -3.1500000000000004E+001,
      -31.51,
      -31.52,
      -31.53,
      -31.54,
      -3.1550000000000004E+001,
      -3.1560000000000002E+001,
      -3.1570000000000004E+001,
      -3.1580000000000002E+001,
      -31.59,
      -3.1599999999999998E+001,
      -31.61,
      -3.1619999999999997E+001,
      -3.1630000000000003E+001,
      -3.1640000000000004E+001,
      -3.1650000000000002E+001,
      -31.66,
      -3.1670000000000005E+001,
      -3.1680000000000007E+001,
      -3.1690000000000005E+001,
      -3.1700000000000003E+001,
      -31.71,
      -3.1720000000000002E+001,
      -31.73,
      -31.74,
      -3.1750000000000004E+001,
      -3.1760000000000005E+001,
      -3.1770000000000003E+001,
      -31.78,
      -31.79,
      -31.8,
      -31.81,
      -3.1819999999999997E+001,
      -3.1830000000000005E+001,
      -3.1840000000000003E+001,
      -31.85,
      -31.86,
      -3.1870000000000008E+001,
      -3.1880000000000006E+001,
      -3.1890000000000004E+001,
      -3.1900000000000002E+001,
      -3.1910000000000004E+001,
      -31.92,
      -31.93,
      -3.1939999999999998E+001,
      -31.95,
      -3.1960000000000004E+001,
      -3.1970000000000002E+001,
      -31.98,
      -3.1990000000000002E+001,
      -32.0,
      -32.01,
      -3.2019999999999996E+001,
      -3.2029999999999994E+001,
      -3.2040000000000006E+001,
      -3.2050000000000004E+001,
      -32.06,
      -32.07,
      -3.2080000000000005E+001,
      -32.09,
      -32.1,
      -32.11,
      -3.2120000000000005E+001,
      -32.13,
      -32.14,
      -32.15,
      -3.2160000000000004E+001,
      -32.17,
      -32.18,
      -3.2190000000000005E+001,
      -32.2,
      -32.21,
      -32.22,
      -32.23,
      -32.24,
      -32.25,
      -32.26,
      -32.27,
      -3.2280000000000008E+001,
      -3.2290000000000006E+001,
      -3.2300000000000004E+001,
      -32.31,
      -32.32,
      -32.33,
      -3.2339999999999996E+001,
      -32.35,
      -3.2360000000000007E+001,
      -3.2370000000000005E+001,
      -32.38,
      -32.39,
      -32.4,
      -32.41,
      -32.42,
      -32.43,
      -3.2440000000000005E+001,
      -32.45,
      -32.46,
      -32.47,
      -3.2480000000000004E+001,
      -32.49,
      -32.5,
      -32.51,
      -32.52,
      -32.53,
      -32.54,
      -32.55,
      -32.56,
      -3.2570000000000007E+001,
      -3.2580000000000005E+001,
      -32.59,
      -32.6,
      -32.61,
      -32.62,
      -3.2629999999999995E+001,
      -32.64,
      -3.2650000000000006E+001,
      -3.2660000000000004E+001,
      -32.67,
      -32.68,
      -32.69,
      -3.2699999999999996E+001,
      -3.2709999999999994E+001,
      -32.72,
      -3.2730000000000004E+001,
      -32.74,
      -32.75,
      -3.2760000000000005E+001,
      -32.77,
      -32.78,
      -32.79,
      -3.2800000000000004E+001,
      -32.81,
      -32.82,
      -32.83,
      -32.84,
      -32.85,
      -32.86,
      -32.87,
      -32.88,
      -32.89,
      -32.9,
      -32.91,
      -32.92,
      -32.93,
      -32.94,
      -3.2949999999999996E+001,
      -3.2960000000000008E+001,
      -3.2970000000000006E+001,
      -3.2980000000000004E+001,
      -32.99,
      -33.0,
      -33.01,
      -3.3019999999999996E+001,
      -33.03,
      -3.3040000000000006E+001,
      -3.3050000000000004E+001,
      -33.06,
      -33.07,
      -33.08,
      -3.3089999999999996E+001,
      -3.3099999999999994E+001,
      -33.11,
      -3.3120000000000005E+001,
      -33.13,
      -33.14,
      -33.15,
      -3.3160000000000004E+001,
      -33.17,
      -3.3180000000000007E+001,
      -3.3190000000000005E+001,
      -33.2,
      -33.21,
      -33.22,
      -33.23,
      -3.3239999999999995E+001,
      -33.25,
      -3.3260000000000005E+001,
      -33.27,
      -33.28,
      -33.29,
      -33.3,
      -3.3309999999999995E+001,
      -3.3319999999999993E+001,
      -33.33,
      -33.34,
      -33.35,
      -33.36,
      -3.3370000000000005E+001,
      -33.38,
      -33.39,
      -33.4,
      -3.3410000000000004E+001,
      -33.42,
      -33.43,
      -33.44,
      -33.45,
      -33.46,
      -33.47,
      -33.48,
      -33.49,
      -33.5,
      -33.51,
      -3.3519999999999996E+001,
      -33.53,
      -33.54,
      -33.55,
      -3.3559999999999995E+001,
      -3.3570000000000007E+001,
      -3.3580000000000005E+001,
      -33.59,
      -33.6,
      -33.61,
      -33.62,
      -3.3629999999999995E+001,
      -33.64,
      -3.3650000000000006E+001,
      -3.3660000000000004E+001,
      -33.67,
      -33.68,
      -33.69,
      -3.3699999999999996E+001,
      -3.3709999999999994E+001,
      -33.72,
      -3.3730000000000004E+001,
      -33.74,
      -33.75,
      -33.76,
      -33.77,
      -33.78,
      -3.3790000000000006E+001,
      -3.3800000000000004E+001,
      -33.81,
      -33.82,
      -33.83,
      -3.3839999999999996E+001,
      -33.85,
      -33.86,
      -3.3870000000000005E+001,
      -33.88,
      -33.89,
      -33.9,
      -33.91,
      -3.3919999999999995E+001,
      -33.93,
      -33.94,
      -33.95,
      -33.96,
      -3.3970000000000006E+001,
      -3.3980000000000004E+001,
      -33.99,
      -34.0,
      -34.01,
      -34.02,
      -34.03,
      -34.04,
      -3.4050000000000004E+001,
      -34.06,
      -34.07,
      -34.08,
      -3.4089999999999996E+001,
      -34.1,
      -34.11,
      -34.12,
      -34.13,
      -34.14,
      -34.15,
      -34.16,
      -3.4170000000000009E+001,
      -3.4180000000000007E+001,
      -3.4190000000000005E+001,
      -34.2,
      -34.21,
      -34.22,
      -34.23,
      -3.4239999999999995E+001,
      -3.4250000000000007E+001,
      -3.4260000000000005E+001,
      -34.27,
      -34.28,
      -34.29,
      -34.3,
      -3.4309999999999995E+001,
      -3.4319999999999993E+001,
      -3.4330000000000005E+001,
      -34.34,
      -34.35,
      -34.36,
      -3.4370000000000005E+001,
      -34.38,
      -34.39,
      -3.4400000000000006E+001,
      -3.4410000000000004E+001,
      -34.42,
      -34.43,
      -34.44,
      -34.45,
      -34.46,
      -34.47,
      -3.4480000000000004E+001,
      -34.49,
      -34.5,
      -34.51,
      -3.4519999999999996E+001,
      -3.4529999999999994E+001,
      -34.54,
      -34.55,
      -34.56,
      -34.57,
      -3.4580000000000005E+001,
      -34.59,
      -34.6,
      -34.61,
      -34.62,
      -34.63,
      -34.64,
      -34.65,
      -3.4660000000000004E+001,
      -34.67,
      -34.68,
      -34.69,
      -3.4699999999999996E+001,
      -34.71,
      -34.72,
      -34.73,
      -34.74,
      -34.75,
      -34.76,
      -3.4769999999999996E+001,
      -3.4780000000000008E+001,
      -3.4790000000000006E+001,
      -3.4800000000000004E+001,
      -34.81,
      -34.82,
      -34.83,
      -3.4839999999999996E+001,
      -3.4849999999999994E+001,
      -3.4860000000000007E+001,
      -3.4870000000000005E+001,
      -34.88,
      -34.89,
      -34.9,
      -34.91,
      -3.4919999999999995E+001,
      -3.4929999999999993E+001,
      -3.4940000000000005E+001,
      -34.95,
      -34.96,
      -34.97,
      -3.4980000000000004E+001,
      -34.99,
      -35.0,
      -3.5010000000000005E+001,
      -35.02,
      -35.03,
      -35.04,
      -35.05,
      -35.06,
      -35.07,
      -35.08,
      -35.09,
      -35.1,
      -35.11,
      -35.12,
      -3.5129999999999995E+001,
      -35.14,
      -35.15,
      -35.16,
      -35.17,
      -3.5180000000000007E+001,
      -3.5190000000000005E+001,
      -35.2,
      -35.21,
      -35.22,
      -35.23,
      -35.24,
      -35.25,
      -3.5260000000000005E+001,
      -35.27,
      -35.28,
      -35.29,
      -35.3,
      -3.5309999999999995E+001,
      -35.32,
      -35.33,
      -35.34,
      -35.35,
      -35.36,
      -35.37,
      -35.38,
      -3.5390000000000008E+001,
      -3.5400000000000006E+001,
      -3.5410000000000004E+001,
      -35.42,
      -35.43,
      -35.44,
      -3.5449999999999996E+001,
      -35.46,
      -3.5470000000000006E+001,
      -3.5480000000000004E+001,
      -35.49,
      -35.5,
      -35.51,
      -3.5519999999999996E+001,
      -3.5529999999999994E+001,
      -35.54,
      -3.5550000000000004E+001,
      -35.56,
      -35.57,
      -3.5580000000000005E+001,
      -35.59,
      -35.6,
      -35.61,
      -3.5620000000000005E+001,
      -35.63,
      -35.64,
      -35.65,
      -3.5660000000000004E+001,
      -35.67,
      -35.68,
      -35.69,
      -35.7,
      -35.71,
      -35.72,
      -35.73,
      -35.74,
      -35.75,
      -35.76,
      -3.5769999999999996E+001,
      -3.5780000000000008E+001,
      -3.5790000000000006E+001,
      -3.5800000000000004E+001,
      -35.81,
      -35.82,
      -35.83,
      -3.5839999999999996E+001,
      -35.85,
      -35.86,
      -3.5870000000000005E+001,
      -35.88,
      -35.89,
      -35.9,
      -35.91,
      -3.5919999999999995E+001,
      -35.93,
      -35.94,
      -35.95,
      -35.96,
      -35.97,
      -35.98,
      -3.5989999999999995E+001,
      -3.5999999999999993E+001,
      -36.01,
      -3.6019999999999996E+001,
      -36.03,
      -36.04,
      -36.05,
      -3.6059999999999995E+001,
      -36.07,
      -3.6080000000000005E+001,
      -36.09,
      -36.1,
      -36.11,
      -36.12,
      -3.6129999999999995E+001,
      -3.6139999999999993E+001,
      -36.15,
      -3.6160000000000004E+001,
      -36.17,
      -36.18,
      -36.19,
      -3.6199999999999996E+001,
      -3.6209999999999994E+001,
      -3.6219999999999992E+001,
      -3.6230000000000004E+001,
      -36.24,
      -36.25,
      -36.26,
      -36.27,
      -36.28,
      -36.29,
      -36.3,
      -36.31,
      -36.32,
      -36.33,
      -3.6339999999999996E+001,
      -36.35,
      -36.36,
      -36.37,
      -3.6379999999999995E+001,
      -36.39,
      -36.4,
      -36.41,
      -3.6419999999999995E+001,
      -36.43,
      -36.44,
      -3.6449999999999996E+001,
      -36.46,
      -3.6470000000000006E+001,
      -3.6480000000000004E+001,
      -36.49,
      -36.5,
      -36.51,
      -3.6519999999999996E+001,
      -3.6529999999999994E+001,
      -36.54,
      -3.6550000000000004E+001,
      -36.56,
      -36.57,
      -36.58,
      -3.6589999999999996E+001,
      -3.6599999999999994E+001,
      -3.6609999999999992E+001,
      -36.62,
      -36.63,
      -36.64,
      -36.65,
      -36.66,
      -36.67,
      -36.68,
      -3.6690000000000005E+001,
      -36.7,
      -36.71,
      -36.72,
      -36.73,
      -3.6739999999999995E+001,
      -36.75,
      -36.76,
      -36.77,
      -36.78,
      -36.79,
      -36.8,
      -3.6809999999999995E+001,
      -3.6819999999999993E+001,
      -36.83,
      -36.84,
      -36.85,
      -36.86,
      -3.6870000000000005E+001,
      -36.88,
      -36.89,
      -36.9,
      -36.91,
      -36.92,
      -36.93,
      -36.94,
      -36.95,
      -36.96,
      -36.97,
      -36.98,
      -3.6989999999999995E+001,
      -37.0,
      -37.01,
      -3.7019999999999996E+001,
      -37.03,
      -37.04,
      -37.05,
      -3.7059999999999995E+001,
      -37.07,
      -3.7080000000000005E+001,
      -37.09,
      -37.1,
      -37.11,
      -37.12,
      -3.7129999999999995E+001,
      -3.7139999999999993E+001,
      -37.15,
      -3.7160000000000004E+001,
      -37.17,
      -37.18,
      -37.19,
      -3.7199999999999996E+001,
      -3.7209999999999994E+001,
      -3.7219999999999992E+001,
      -37.23,
      -37.24,
      -37.25,
      -37.26,
      -3.7269999999999996E+001,
      -37.28,
      -37.29,
      -3.7300000000000004E+001,
      -37.31,
      -37.32,
      -37.33,
      -3.7339999999999996E+001,
      -3.7349999999999994E+001,
      -37.36,
      -37.37,
      -37.38,
      -37.39,
      -37.4,
      -37.41,
      -3.7419999999999995E+001,
      -3.7429999999999993E+001,
      -37.44,
      -37.45,
      -37.46,
      -37.47,
      -3.7480000000000004E+001,
      -37.49,
      -37.5,
      -37.51,
      -3.7519999999999996E+001,
      -37.53,
      -37.54,
      -37.55,
      -37.56,
      -37.57,
      -37.58,
      -3.7589999999999996E+001,
      -3.7599999999999994E+001,
      -37.61,
      -37.62,
      -3.7629999999999995E+001,
      -37.64,
      -37.65,
      -37.66,
      -3.7669999999999995E+001,
      -3.7680000000000007E+001,
      -3.7690000000000005E+001,
      -37.7,
      -37.71,
      -37.72,
      -37.73,
      -3.7739999999999995E+001,
      -3.7749999999999993E+001,
      -3.7760000000000005E+001,
      -37.77,
      -37.78,
      -37.79,
      -37.8,
      -3.7809999999999995E+001,
      -3.7819999999999993E+001,
      -3.7829999999999991E+001,
      -37.84,
      -37.85,
      -37.86,
      -37.87,
      -37.88,
      -37.89,
      -37.9,
      -3.7910000000000004E+001,
      -37.92,
      -37.93,
      -37.94,
      -3.7949999999999996E+001,
      -37.96,
      -37.97,
      -37.98,
      -37.99,
      -38.0,
      -38.01,
      -3.8019999999999996E+001,
      -3.8029999999999994E+001,
      -38.04,
      -38.05,
      -38.06,
      -38.07,
      -3.8080000000000005E+001,
      -38.09,
      -38.1,
      -38.11,
      -38.12,
      -3.8129999999999995E+001,
      -38.14,
      -38.15,
      -3.8160000000000004E+001,
      -38.17,
      -38.18,
      -38.19,
      -3.8199999999999996E+001,
      -3.8209999999999994E+001,
      -38.22,
      -38.23,
      -38.24,
      -38.25,
      -38.26,
      -3.8269999999999996E+001,
      -38.28,
      -3.8290000000000006E+001,
      -3.8300000000000004E+001,
      -38.31,
      -38.32,
      -38.33,
      -3.8339999999999996E+001,
      -3.8349999999999994E+001,
      -3.8359999999999992E+001,
      -3.8370000000000005E+001,
      -38.38,
      -38.39,
      -38.4,
      -38.41,
      -3.8419999999999995E+001,
      -3.8429999999999993E+001,
      -3.8439999999999991E+001,
      -38.45,
      -38.46,
      -38.47,
      -38.48,
      -38.49,
      -38.5,
      -38.51,
      -38.52,
      -38.53,
      -38.54,
      -38.55,
      -3.8559999999999995E+001,
      -38.57,
      -38.58,
      -3.8589999999999996E+001,
      -38.6,
      -38.61,
      -38.62,
      -3.8629999999999995E+001,
      -3.8639999999999993E+001,
      -38.65,
      -38.66,
      -38.67,
      -38.68,
      -3.8690000000000005E+001,
      -38.7,
      -38.71,
      -38.72,
      -38.73,
      -3.8739999999999995E+001,
      -38.75,
      -38.76,
      -38.77,
      -38.78,
      -38.79,
      -38.8,
      -3.8809999999999995E+001,
      -3.8819999999999993E+001,
      -38.83,
      -3.8839999999999996E+001,
      -38.85,
      -38.86,
      -38.87,
      -3.8879999999999995E+001,
      -38.89,
      -3.8900000000000006E+001,
      -3.8910000000000004E+001,
      -38.92,
      -38.93,
      -38.94,
      -3.8949999999999996E+001,
      -3.8959999999999994E+001,
      -38.97,
      -3.8980000000000004E+001,
      -38.99,
      -39.0,
      -39.01,
      -3.9019999999999996E+001,
      -3.9029999999999994E+001,
      -3.9039999999999992E+001,
      -3.9050000000000004E+001,
      -39.06,
      -39.07,
      -39.08,
      -39.09,
      -39.1,
      -39.11,
      -39.12,
      -39.13,
      -39.14,
      -39.15,
      -39.16,
      -39.17,
      -39.18,
      -39.19,
      -3.9199999999999996E+001,
      -39.21,
      -39.22,
      -39.23,
      -3.9239999999999995E+001,
      -39.25,
      -39.26,
      -3.9269999999999996E+001,
      -39.28,
      -3.9290000000000006E+001,
      -3.9300000000000004E+001,
      -39.31,
      -39.32,
      -39.33,
      -3.9339999999999996E+001,
      -3.9349999999999994E+001,
      -39.36,
      -3.9370000000000005E+001,
      -39.38,
      -39.39,
      -39.4,
      -39.41,
      -3.9419999999999995E+001,
      -3.9429999999999993E+001,
      -39.44,
      -39.45,
      -39.46,
      -39.47,
      -39.48,
      -39.49,
      -39.5,
      -3.9510000000000005E+001,
      -39.52,
      -39.53,
      -39.54,
      -39.55,
      -3.9559999999999995E+001,
      -39.57,
      -39.58,
      -39.59,
      -39.6,
      -39.61,
      -39.62,
      -3.9629999999999995E+001,
      -3.9639999999999993E+001,
      -3.9649999999999991E+001,
      -3.9660000000000004E+001,
      -39.67,
      -39.68,
      -39.69,
      -39.7,
      -39.71,
      -39.72,
      -39.73,
      -39.74,
      -39.75,
      -39.76,
      -3.9769999999999996E+001,
      -39.78,
      -39.79,
      -39.8,
      -3.9809999999999995E+001,
      -39.82,
      -39.83,
      -3.9839999999999996E+001,
      -3.9849999999999994E+001,
      -39.86,
      -39.87,
      -3.9879999999999995E+001,
      -39.89,
      -3.9900000000000006E+001,
      -3.9910000000000004E+001,
      -39.92,
      -39.93,
      -39.94,
      -3.9949999999999996E+001,
      -3.9959999999999994E+001,
      -39.97,
      -3.9980000000000004E+001,
      -39.99,
      -40.0,
      -40.01,
      -4.0019999999999996E+001,
      -4.0029999999999994E+001,
      -40.04,
      -40.05,
      -40.06,
      -40.07,
      -40.08,
      -4.0089999999999996E+001,
      -40.1,
      -40.11,
      -4.0120000000000005E+001,
      -40.13,
      -40.14,
      -40.15,
      -40.16,
      -4.0169999999999995E+001,
      -40.18,
      -4.0190000000000005E+001,
      -40.2,
      -40.21,
      -40.22,
      -40.23,
      -4.0239999999999995E+001,
      -4.0249999999999993E+001,
      -40.26,
      -40.27,
      -40.28,
      -40.29,
      -4.0300000000000004E+001,
      -40.31,
      -40.32,
      -40.33,
      -4.0339999999999996E+001,
      -40.35,
      -40.36,
      -40.37,
      -40.38,
      -40.39,
      -40.4,
      -40.41,
      -40.42,
      -40.43,
      -40.44,
      -4.0449999999999996E+001,
      -40.46,
      -40.47,
      -40.48,
      -4.0489999999999995E+001,
      -4.0500000000000007E+001,
      -4.0510000000000005E+001,
      -40.52,
      -40.53,
      -40.54,
      -40.55,
      -4.0559999999999995E+001,
      -4.0569999999999993E+001,
      -4.0580000000000005E+001,
      -40.59,
      -40.6,
      -40.61,
      -40.62,
      -4.0629999999999995E+001,
      -4.0639999999999993E+001,
      -40.65,
      -4.0660000000000004E+001,
      -40.67,
      -40.68,
      -40.69,
      -40.7,
      -40.71,
      -40.72,
      -4.0730000000000004E+001,
      -40.74,
      -40.75,
      -40.76,
      -4.0769999999999996E+001,
      -40.78,
      -40.79,
      -4.0800000000000004E+001,
      -40.81,
      -40.82,
      -40.83,
      -4.0839999999999996E+001,
      -4.0849999999999994E+001,
      -40.86,
      -40.87,
      -40.88,
      -40.89,
      -40.9,
      -4.0910000000000004E+001,
      -40.92,
      -40.93,
      -40.94,
      -4.0949999999999996E+001,
      -40.96,
      -40.97,
      -40.98,
      -40.99,
      -4.0999999999999993E+001,
      -41.01,
      -4.1019999999999996E+001,
      -41.03,
      -41.04,
      -41.05,
      -4.1059999999999995E+001,
      -4.1069999999999993E+001,
      -4.1079999999999991E+001,
      -4.1089999999999996E+001,
      -4.1099999999999994E+001,
      -41.11,
      -41.12,
      -4.1129999999999995E+001,
      -41.14,
      -41.15,
      -41.16,
      -4.1169999999999995E+001,
      -4.1179999999999993E+001,
      -41.19,
      -4.1199999999999996E+001,
      -4.1209999999999994E+001,
      -41.22,
      -41.23,
      -4.1239999999999995E+001,
      -4.1249999999999993E+001,
      -41.26,
      -4.1269999999999996E+001,
      -4.1279999999999994E+001,
      -4.1289999999999992E+001,
      -41.3,
      -4.1309999999999995E+001,
      -4.1319999999999993E+001,
      -4.1329999999999991E+001,
      -41.34,
      -41.35,
      -41.36,
      -41.37,
      -4.1379999999999995E+001,
      -4.1389999999999993E+001,
      -4.1399999999999991E+001,
      -4.1409999999999989E+001,
      -41.42,
      -41.43,
      -41.44,
      -4.1449999999999996E+001,
      -4.1459999999999994E+001,
      -4.1469999999999992E+001,
      -4.1479999999999990E+001,
      -4.1489999999999995E+001,
      -41.5,
      -41.51,
      -4.1519999999999996E+001,
      -4.1529999999999994E+001,
      -41.54,
      -41.55,
      -4.1559999999999995E+001,
      -41.57,
      -41.58,
      -4.1589999999999996E+001,
      -4.1599999999999994E+001,
      -4.1609999999999992E+001,
      -41.62,
      -4.1629999999999995E+001,
      -41.64,
      -41.65,
      -41.66,
      -4.1669999999999995E+001,
      -4.1679999999999993E+001,
      -4.1689999999999991E+001,
      -4.1699999999999996E+001,
      -4.1709999999999994E+001,
      -41.72,
      -41.73,
      -41.74,
      -41.75,
      -41.76,
      -4.1769999999999996E+001,
      -4.1779999999999994E+001,
      -4.1789999999999992E+001,
      -41.8,
      -4.1809999999999995E+001,
      -41.82,
      -41.83,
      -4.1839999999999996E+001,
      -4.1849999999999994E+001,
      -4.1859999999999992E+001,
      -41.87,
      -4.1879999999999995E+001,
      -4.1889999999999993E+001,
      -41.9,
      -41.91,
      -4.1919999999999995E+001,
      -4.1929999999999993E+001,
      -41.94,
      -41.95,
      -41.96,
      -41.97,
      -41.98,
      -4.1989999999999995E+001,
      -4.1999999999999993E+001,
      -4.2009999999999991E+001,
      -42.02,
      -42.03,
      -42.04,
      -42.05,
      -4.2059999999999995E+001,
      -4.2069999999999993E+001,
      -4.2079999999999991E+001,
      -4.2089999999999989E+001,
      -42.1,
      -42.11,
      -42.12,
      -4.2129999999999995E+001,
      -42.14,
      -42.15,
      -42.16,
      -4.2169999999999995E+001,
      -42.18,
      -42.19,
      -4.2199999999999996E+001,
      -4.2209999999999994E+001,
      -42.22,
      -42.23,
      -4.2239999999999995E+001,
      -42.25,
      -42.26,
      -4.2269999999999996E+001,
      -4.2279999999999994E+001,
      -4.2289999999999992E+001,
      -42.3,
      -4.2309999999999995E+001,
      -4.2319999999999993E+001,
      -42.33,
      -42.34,
      -42.35,
      -42.36,
      -42.37,
      -4.2379999999999995E+001,
      -4.2389999999999993E+001,
      -4.2399999999999991E+001,
      -42.41,
      -4.2419999999999995E+001,
      -42.43,
      -42.44,
      -4.2449999999999996E+001,
      -4.2459999999999994E+001,
      -4.2469999999999992E+001,
      -42.48,
      -4.2489999999999995E+001,
      -4.2499999999999993E+001,
      -4.2509999999999991E+001,
      -4.2519999999999996E+001,
      -42.53,
      -4.2539999999999992E+001,
      -42.55,
      -42.56,
      -42.57,
      -4.2579999999999991E+001,
      -42.59,
      -4.2599999999999994E+001,
      -4.2609999999999992E+001,
      -4.2619999999999990E+001,
      -42.63,
      -4.2639999999999993E+001,
      -42.65,
      -42.66,
      -4.2669999999999995E+001,
      -4.2679999999999993E+001,
      -42.69,
      -4.2699999999999989E+001,
      -42.71,
      -4.2720000000000006E+001,
      -42.73,
      -4.2739999999999988E+001,
      -42.75,
      -42.76,
      -4.2769999999999989E+001,
      -4.2779999999999994E+001,
      -42.79,
      -42.8,
      -4.2809999999999995E+001,
      -42.82,
      -4.2829999999999991E+001,
      -4.2839999999999996E+001,
      -4.2849999999999994E+001,
      -42.86,
      -42.87,
      -42.88,
      -4.2889999999999993E+001,
      -4.2899999999999991E+001,
      -4.2910000000000004E+001,
      -4.2919999999999995E+001,
      -4.2929999999999986E+001,
      -42.94,
      -42.95,
      -4.2959999999999994E+001,
      -42.97,
      -42.98,
      -4.2989999999999995E+001,
      -4.2999999999999993E+001,
      -4.3010000000000005E+001,
      -4.3019999999999996E+001,
      -43.03,
      -43.04,
      -43.05,
      -4.3059999999999988E+001,
      -43.07,
      -4.3079999999999991E+001,
      -4.3089999999999996E+001,
      -4.3099999999999994E+001,
      -43.11,
      -4.3119999999999990E+001,
      -4.3129999999999995E+001,
      -43.14,
      -4.3149999999999991E+001,
      -43.16,
      -43.17,
      -43.18,
      -43.19,
      -43.2,
      -4.3209999999999994E+001,
      -4.3219999999999992E+001,
      -43.23,
      -43.24,
      -4.3249999999999993E+001,
      -43.26,
      -4.3269999999999996E+001,
      -4.3279999999999994E+001,
      -4.3289999999999992E+001,
      -43.3,
      -4.3309999999999988E+001,
      -43.32,
      -4.3330000000000005E+001,
      -4.3339999999999996E+001,
      -43.35,
      -43.36,
      -43.37,
      -4.3379999999999988E+001,
      -4.3390000000000008E+001,
      -43.4,
      -43.41,
      -4.3419999999999995E+001,
      -43.43,
      -4.3439999999999991E+001,
      -4.3449999999999996E+001,
      -4.3459999999999994E+001,
      -43.47,
      -43.48,
      -43.49,
      -4.3499999999999993E+001,
      -43.51,
      -43.52,
      -4.3529999999999994E+001,
      -4.3539999999999985E+001,
      -4.3550000000000004E+001,
      -43.56,
      -4.3569999999999993E+001,
      -43.58,
      -4.3589999999999996E+001,
      -4.3599999999999994E+001,
      -4.3609999999999992E+001,
      -4.3620000000000005E+001,
      -4.3629999999999995E+001,
      -43.64,
      -43.65,
      -43.66,
      -4.3669999999999987E+001,
      -43.68,
      -4.3689999999999991E+001,
      -4.3699999999999996E+001,
      -4.3709999999999994E+001,
      -43.72,
      -4.3729999999999990E+001,
      -4.3739999999999995E+001,
      -43.75,
      -4.3759999999999991E+001,
      -4.3769999999999996E+001,
      -43.78,
      -43.79,
      -43.8,
      -43.81,
      -4.3819999999999993E+001,
      -4.3829999999999991E+001,
      -4.3839999999999996E+001,
      -43.85,
      -4.3859999999999992E+001,
      -43.87,
      -4.3879999999999995E+001,
      -4.3889999999999993E+001,
      -4.3899999999999991E+001,
      -43.91,
      -4.3919999999999987E+001,
      -43.93,
      -4.3940000000000005E+001,
      -4.3949999999999996E+001,
      -43.96,
      -43.97,
      -43.98,
      -4.3989999999999988E+001,
      -4.4000000000000007E+001,
      -44.01,
      -4.4019999999999996E+001,
      -4.4029999999999994E+001,
      -44.04,
      -4.4049999999999990E+001,
      -4.4059999999999995E+001,
      -4.4069999999999993E+001,
      -44.08,
      -4.4089999999999996E+001,
      -44.1,
      -4.4109999999999992E+001,
      -44.12,
      -44.13,
      -4.4139999999999993E+001,
      -4.4149999999999984E+001,
      -4.4160000000000004E+001,
      -44.17,
      -4.4179999999999993E+001,
      -44.19,
      -4.4199999999999996E+001,
      -4.4209999999999994E+001,
      -4.4219999999999992E+001,
      -4.4230000000000004E+001,
      -4.4239999999999995E+001,
      -44.25,
      -44.26,
      -4.4269999999999996E+001,
      -4.4279999999999994E+001,
      -44.29,
      -4.4299999999999990E+001,
      -4.4309999999999995E+001,
      -4.4320000000000007E+001,
      -44.33,
      -4.4339999999999989E+001,
      -4.4349999999999994E+001,
      -44.36,
      -4.4369999999999990E+001,
      -4.4379999999999995E+001,
      -44.39,
      -44.4,
      -44.41,
      -44.42,
      -4.4429999999999993E+001,
      -44.44,
      -4.4449999999999996E+001,
      -44.46,
      -4.4469999999999992E+001,
      -4.4480000000000004E+001,
      -4.4489999999999995E+001,
      -4.4499999999999993E+001,
      -4.4509999999999991E+001,
      -4.4519999999999996E+001,
      -4.4529999999999987E+001,
      -44.54,
      -4.4550000000000004E+001,
      -4.4559999999999995E+001,
      -44.57,
      -44.58,
      -4.4589999999999996E+001,
      -4.4599999999999994E+001,
      -4.4610000000000007E+001,
      -44.62,
      -4.4629999999999995E+001,
      -44.64,
      -44.65,
      -4.4659999999999989E+001,
      -4.4669999999999995E+001,
      -4.4679999999999993E+001,
      -44.69,
      -4.4699999999999996E+001,
      -44.71,
      -4.4719999999999992E+001,
      -44.73,
      -44.74,
      -4.4749999999999993E+001,
      -44.76,
      -44.77,
      -44.78,
      -4.4789999999999992E+001,
      -4.4800000000000004E+001,
      -4.4809999999999995E+001,
      -4.4819999999999993E+001,
      -4.4829999999999991E+001,
      -44.84,
      -4.4849999999999994E+001,
      -44.86,
      -44.87,
      -4.4879999999999995E+001,
      -4.4889999999999993E+001,
      -44.9,
      -4.4909999999999989E+001,
      -44.92,
      -4.4930000000000007E+001,
      -44.94,
      -4.4949999999999989E+001,
      -4.4959999999999994E+001,
      -44.97,
      -4.4979999999999990E+001,
      -4.4989999999999995E+001,
      -45.0,
      -45.01,
      -4.5019999999999996E+001,
      -45.03,
      -4.5039999999999992E+001,
      -45.05,
      -4.5059999999999995E+001,
      -45.07,
      -4.5079999999999991E+001,
      -45.09,
      -4.5099999999999994E+001,
      -4.5109999999999992E+001,
      -4.5119999999999990E+001,
      -4.5129999999999995E+001,
      -4.5139999999999986E+001,
      -45.15,
      -4.5160000000000004E+001,
      -4.5169999999999995E+001,
      -45.18,
      -45.19,
      -4.5199999999999996E+001,
      -4.5209999999999994E+001,
      -4.5220000000000006E+001,
      -45.23,
      -4.5239999999999995E+001,
      -45.25,
      -45.26,
      -4.5269999999999989E+001,
      -4.5279999999999994E+001,
      -4.5289999999999992E+001,
      -45.3,
      -4.5309999999999995E+001,
      -45.32,
      -4.5329999999999991E+001,
      -4.5339999999999996E+001,
      -45.35,
      -4.5359999999999992E+001,
      -45.37,
      -45.38,
      -45.39,
      -4.5399999999999991E+001,
      -4.5410000000000004E+001,
      -4.5419999999999995E+001,
      -4.5429999999999993E+001,
      -4.5439999999999991E+001,
      -45.45,
      -4.5459999999999994E+001,
      -45.47,
      -45.48,
      -4.5489999999999995E+001,
      -4.5499999999999993E+001,
      -45.51,
      -4.5519999999999989E+001,
      -45.53,
      -4.5540000000000006E+001,
      -45.55,
      -4.5559999999999988E+001,
      -45.57,
      -45.58,
      -4.5589999999999989E+001,
      -4.5599999999999994E+001,
      -45.61,
      -45.62,
      -4.5629999999999995E+001,
      -45.64,
      -4.5649999999999991E+001,
      -45.66,
      -4.5669999999999995E+001,
      -45.68,
      -45.69,
      -45.7,
      -4.5709999999999994E+001,
      -4.5719999999999992E+001,
      -4.5730000000000004E+001,
      -4.5739999999999995E+001,
      -4.5749999999999986E+001,
      -45.76,
      -45.77,
      -4.5779999999999994E+001,
      -45.79,
      -45.8,
      -4.5809999999999995E+001,
      -4.5819999999999993E+001,
      -4.5830000000000005E+001,
      -4.5839999999999996E+001,
      -45.85,
      -45.86,
      -45.87,
      -4.5879999999999988E+001,
      -45.89,
      -4.5899999999999991E+001,
      -45.91,
      -4.5919999999999995E+001,
      -45.93,
      -4.5939999999999991E+001,
      -4.5949999999999996E+001,
      -45.96,
      -4.5969999999999992E+001,
      -45.98,
      -45.99,
      -46.0,
      -46.01,
      -46.02,
      -4.6029999999999994E+001,
      -4.6039999999999992E+001,
      -46.05,
      -46.06,
      -4.6069999999999993E+001,
      -46.08,
      -4.6089999999999996E+001,
      -4.6099999999999994E+001,
      -4.6109999999999992E+001,
      -46.12,
      -4.6129999999999988E+001,
      -46.14,
      -4.6150000000000006E+001,
      -46.16,
      -46.17,
      -46.18,
      -46.19,
      -4.6199999999999989E+001,
      -4.6209999999999994E+001,
      -46.22,
      -46.23,
      -4.6239999999999995E+001,
      -46.25,
      -4.6259999999999991E+001,
      -4.6269999999999996E+001,
      -4.6279999999999994E+001,
      -46.29,
      -46.3,
      -46.31,
      -4.6319999999999993E+001,
      -4.6329999999999991E+001,
      -46.34,
      -4.6349999999999994E+001,
      -4.6359999999999985E+001,
      -46.37,
      -46.38,
      -4.6389999999999993E+001,
      -46.4,
      -46.41,
      -4.6419999999999995E+001,
      -4.6429999999999993E+001,
      -4.6440000000000005E+001,
      -4.6449999999999996E+001,
      -46.46,
      -46.47,
      -46.48,
      -4.6489999999999988E+001,
      -46.5,
      -4.6509999999999991E+001,
      -4.6519999999999996E+001,
      -4.6529999999999994E+001,
      -46.54,
      -4.6549999999999990E+001,
      -4.6559999999999995E+001,
      -46.57,
      -4.6579999999999991E+001,
      -4.6589999999999996E+001,
      -46.6,
      -46.61,
      -46.62,
      -46.63,
      -4.6639999999999993E+001,
      -4.6649999999999991E+001,
      -46.66,
      -46.67,
      -4.6679999999999993E+001,
      -46.69,
      -4.6699999999999996E+001,
      -4.6709999999999994E+001,
      -4.6719999999999992E+001,
      -46.73,
      -4.6739999999999988E+001,
      -46.75,
      -4.6760000000000005E+001,
      -4.6769999999999996E+001,
      -46.78,
      -46.79,
      -46.8,
      -4.6809999999999988E+001,
      -4.6820000000000007E+001,
      -46.83,
      -4.6839999999999996E+001,
      -4.6849999999999994E+001,
      -46.86,
      -4.6869999999999990E+001,
      -4.6879999999999995E+001,
      -4.6889999999999993E+001,
      -46.9,
      -46.91,
      -46.92,
      -4.6929999999999993E+001,
      -46.94,
      -46.95,
      -4.6959999999999994E+001,
      -4.6969999999999985E+001,
      -4.6980000000000004E+001,
      -46.99,
      -4.6999999999999993E+001,
      -47.01,
      -4.7019999999999996E+001,
      -4.7029999999999994E+001,
      -4.7039999999999992E+001,
      -4.7050000000000004E+001,
      -4.7059999999999995E+001,
      -47.07,
      -47.08,
      -4.7089999999999996E+001,
      -4.7099999999999994E+001,
      -47.11,
      -4.7119999999999990E+001,
      -4.7129999999999995E+001,
      -4.7140000000000008E+001,
      -47.15,
      -4.7159999999999989E+001,
      -4.7169999999999995E+001,
      -47.18,
      -4.7189999999999991E+001,
      -4.7199999999999996E+001,
      -47.21,
      -47.22,
      -47.23,
      -47.24,
      -4.7249999999999993E+001,
      -47.26,
      -4.7269999999999996E+001,
      -47.28,
      -4.7289999999999992E+001,
      -4.7300000000000004E+001,
      -4.7309999999999995E+001,
      -4.7319999999999993E+001,
      -4.7329999999999991E+001,
      -4.7339999999999996E+001,
      -4.7349999999999987E+001,
      -47.36,
      -4.7370000000000005E+001,
      -4.7379999999999995E+001,
      -47.39,
      -47.4,
      -47.41,
      -4.7419999999999995E+001,
      -4.7430000000000007E+001,
      -47.44,
      -4.7449999999999996E+001,
      -47.46,
      -47.47,
      -4.7479999999999990E+001,
      -4.7489999999999995E+001,
      -4.7499999999999993E+001,
      -47.51,
      -4.7519999999999996E+001,
      -47.53,
      -4.7539999999999992E+001,
      -47.55,
      -47.56,
      -4.7569999999999993E+001,
      -4.7579999999999984E+001,
      -47.59,
      -47.6,
      -4.7609999999999992E+001,
      -47.62,
      -4.7629999999999995E+001,
      -4.7639999999999993E+001,
      -4.7649999999999991E+001,
      -4.7660000000000004E+001,
      -4.7669999999999995E+001,
      -47.68,
      -47.69,
      -4.7699999999999996E+001,
      -4.7709999999999994E+001,
      -47.72,
      -4.7729999999999990E+001,
      -4.7739999999999995E+001,
      -4.7750000000000007E+001,
      -47.76,
      -4.7769999999999989E+001,
      -4.7779999999999994E+001,
      -47.79,
      -4.7799999999999990E+001,
      -4.7809999999999995E+001,
      -47.82,
      -47.83,
      -4.7839999999999996E+001,
      -47.85,
      -4.7859999999999992E+001,
      -47.87,
      -4.7879999999999995E+001,
      -47.89,
      -4.7899999999999991E+001,
      -4.7910000000000004E+001,
      -4.7919999999999995E+001,
      -4.7929999999999993E+001,
      -4.7939999999999991E+001,
      -4.7949999999999996E+001,
      -4.7959999999999987E+001,
      -47.97,
      -4.7980000000000004E+001,
      -4.7989999999999995E+001,
      -48.0,
      -48.01,
      -4.8019999999999996E+001,
      -4.8029999999999994E+001,
      -4.8040000000000006E+001,
      -48.05,
      -4.8059999999999995E+001,
      -48.07,
      -48.08,
      -4.8089999999999989E+001,
      -4.8099999999999994E+001,
      -4.8109999999999992E+001,
      -48.12,
      -4.8129999999999995E+001,
      -48.14,
      -4.8149999999999991E+001,
      -48.16,
      -48.17,
      -4.8179999999999993E+001,
      -4.8190000000000005E+001,
      -48.2,
      -48.21,
      -4.8219999999999992E+001,
      -4.8230000000000004E+001,
      -4.8239999999999995E+001,
      -4.8249999999999993E+001,
      -4.8259999999999991E+001,
      -48.27,
      -4.8279999999999994E+001,
      -48.29,
      -48.3,
      -4.8309999999999995E+001,
      -4.8319999999999993E+001,
      -48.33,
      -4.8339999999999989E+001,
      -48.35,
      -4.8360000000000007E+001,
      -48.37,
      -4.8379999999999988E+001,
      -48.39,
      -48.4,
      -4.8409999999999989E+001,
      -48.42,
      -48.43,
      -48.44,
      -4.8449999999999996E+001,
      -48.46,
      -4.8469999999999992E+001,
      -48.48,
      -4.8489999999999995E+001,
      -48.5,
      -48.51,
      -48.52,
      -4.8529999999999994E+001,
      -4.8539999999999992E+001,
      -4.8550000000000004E+001,
      -4.8559999999999995E+001,
      -4.8569999999999986E+001,
      -48.58,
      -48.59,
      -4.8599999999999994E+001,
      -48.61,
      -48.62,
      -4.8629999999999995E+001,
      -4.8639999999999993E+001,
      -4.8650000000000006E+001,
      -48.66,
      -48.67,
      -48.68,
      -48.69,
      -4.8699999999999989E+001,
      -48.71,
      -4.8719999999999992E+001,
      -48.73,
      -4.8739999999999995E+001,
      -48.75,
      -4.8759999999999991E+001,
      -4.8769999999999996E+001,
      -48.78,
      -4.8789999999999992E+001,
      -4.8800000000000004E+001,
      -48.81,
      -48.82,
      -4.8829999999999991E+001,
      -48.84,
      -4.8849999999999994E+001,
      -4.8859999999999992E+001,
      -4.8869999999999990E+001,
      -48.88,
      -4.8889999999999993E+001,
      -48.9,
      -48.91,
      -4.8919999999999995E+001,
      -4.8929999999999993E+001,
      -48.94,
      -4.8949999999999989E+001,
      -48.96,
      -4.8970000000000006E+001,
      -48.98,
      -4.8989999999999988E+001,
      -49.0,
      -49.01,
      -4.9019999999999989E+001,
      -49.03,
      -49.04,
      -49.05,
      -4.9059999999999995E+001,
      -49.07,
      -4.9079999999999991E+001,
      -4.9089999999999996E+001,
      -4.9099999999999994E+001,
      -49.11,
      -49.12,
      -49.13,
      -4.9139999999999993E+001,
      -4.9149999999999991E+001,
      -4.9160000000000004E+001,
      -4.9169999999999995E+001,
      -4.9179999999999986E+001,
      -49.19,
      -49.2,
      -4.9209999999999994E+001,
      -49.22,
      -49.23,
      -4.9239999999999995E+001,
      -4.9249999999999993E+001,
      -4.9260000000000005E+001,
      -4.9269999999999996E+001,
      -49.28,
      -49.29,
      -49.3,
      -4.9309999999999988E+001,
      -49.32,
      -4.9329999999999991E+001,
      -4.9339999999999996E+001,
      -4.9349999999999994E+001,
      -49.36,
      -4.9369999999999990E+001,
      -4.9379999999999995E+001,
      -49.39,
      -4.9399999999999991E+001,
      -4.9410000000000004E+001,
      -49.42,
      -49.43,
      -49.44,
      -49.45,
      -4.9459999999999994E+001,
      -4.9469999999999992E+001,
      -49.48,
      -49.49,
      -4.9499999999999993E+001,
      -49.51,
      -4.9519999999999996E+001,
      -4.9529999999999994E+001,
      -4.9539999999999992E+001,
      -49.55,
      -4.9559999999999988E+001,
      -49.57,
      -4.9580000000000005E+001,
      -4.9589999999999996E+001,
      -49.6,
      -49.61,
      -49.62,
      -4.9629999999999988E+001,
      -4.9640000000000008E+001,
      -49.65,
      -49.66,
      -4.9669999999999995E+001,
      -49.68,
      -4.9689999999999991E+001,
      -4.9699999999999996E+001,
      -4.9709999999999994E+001,
      -49.72,
      -49.73,
      -49.74,
      -4.9749999999999993E+001,
      -49.76,
      -49.77,
      -4.9779999999999994E+001,
      -4.9789999999999985E+001,
      -4.9800000000000004E+001,
      -49.81,
      -4.9819999999999993E+001,
      -49.83,
      -4.9839999999999996E+001,
      -4.9849999999999994E+001,
      -4.9859999999999992E+001,
      -4.9870000000000005E+001,
      -4.9879999999999995E+001,
      -49.89,
      -49.9,
      -49.91,
      -4.9919999999999995E+001,
      -49.93,
      -4.9939999999999991E+001,
      -4.9949999999999996E+001,
      -4.9960000000000008E+001,
      -49.97,
      -4.9979999999999990E+001,
      -4.9989999999999995E+001,
      -50.0,
      -5.0009999999999991E+001,
      -50.02,
      -50.03,
      -50.04,
      -50.05,
      -50.06,
      -5.0069999999999993E+001,
      -5.0079999999999991E+001,
      -5.0089999999999996E+001,
      -50.1,
      -5.0109999999999992E+001,
      -50.12,
      -5.0129999999999995E+001,
      -5.0139999999999993E+001,
      -5.0149999999999991E+001,
      -50.16,
      -5.0169999999999987E+001,
      -50.18,
      -5.0190000000000005E+001,
      -5.0199999999999996E+001,
      -50.21,
      -50.22,
      -50.23,
      -5.0239999999999988E+001,
      -5.0250000000000007E+001,
      -50.26,
      -5.0269999999999996E+001,
      -5.0279999999999994E+001,
      -50.29,
      -5.0299999999999990E+001,
      -5.0309999999999995E+001,
      -5.0319999999999993E+001,
      -50.33,
      -5.0339999999999996E+001,
      -50.35,
      -5.0359999999999992E+001,
      -50.37,
      -50.38,
      -5.0389999999999993E+001,
      -5.0399999999999984E+001,
      -5.0410000000000004E+001,
      -50.42,
      -5.0429999999999993E+001,
      -50.44,
      -5.0449999999999996E+001,
      -5.0459999999999994E+001,
      -5.0469999999999992E+001,
      -5.0480000000000004E+001,
      -5.0489999999999995E+001,
      -50.5,
      -50.51,
      -5.0519999999999996E+001,
      -5.0529999999999994E+001,
      -50.54,
      -5.0549999999999990E+001,
      -5.0559999999999995E+001,
      -5.0570000000000007E+001,
      -50.58,
      -5.0589999999999989E+001,
      -5.0599999999999994E+001,
      -50.61,
      -5.0619999999999990E+001,
      -50.63,
      -50.64,
      -50.65,
      -50.66,
      -50.67,
      -5.0679999999999993E+001,
      -50.69,
      -5.0699999999999996E+001,
      -50.71,
      -5.0719999999999992E+001,
      -5.0730000000000004E+001,
      -5.0739999999999995E+001,
      -5.0749999999999993E+001,
      -5.0759999999999991E+001,
      -5.0769999999999996E+001,
      -5.0779999999999987E+001,
      -50.79,
      -5.0800000000000004E+001,
      -5.0809999999999995E+001,
      -50.82,
      -50.83,
      -5.0839999999999996E+001,
      -5.0849999999999994E+001,
      -5.0860000000000007E+001,
      -50.87,
      -5.0879999999999995E+001,
      -50.89,
      -50.9,
      -5.0909999999999989E+001,
      -5.0919999999999995E+001,
      -5.0929999999999993E+001,
      -50.94,
      -5.0949999999999996E+001,
      -50.96,
      -5.0969999999999992E+001,
      -50.98,
      -50.99,
      -5.0999999999999993E+001,
      -5.1010000000000005E+001,
      -51.02,
      -51.03,
      -5.1039999999999992E+001,
      -5.1050000000000004E+001,
      -5.1059999999999995E+001,
      -5.1069999999999993E+001,
      -5.1079999999999991E+001,
      -51.09,
      -5.1099999999999994E+001,
      -51.11,
      -51.12,
      -5.1129999999999995E+001,
      -5.1139999999999993E+001,
      -51.15,
      -5.1159999999999989E+001,
      -51.17,
      -5.1180000000000007E+001,
      -51.19,
      -5.1199999999999989E+001,
      -51.21,
      -51.22,
      -5.1229999999999990E+001,
      -51.24,
      -51.25,
      -51.26,
      -5.1269999999999996E+001,
      -51.28,
      -5.1289999999999992E+001,
      -51.3,
      -5.1309999999999995E+001,
      -51.32,
      -51.33,
      -51.34,
      -5.1349999999999994E+001,
      -5.1359999999999992E+001,
      -5.1369999999999990E+001,
      -5.1379999999999995E+001,
      -5.1389999999999986E+001,
      -51.4,
      -5.1410000000000004E+001,
      -5.1419999999999995E+001,
      -51.43,
      -51.44,
      -5.1449999999999996E+001,
      -5.1459999999999994E+001,
      -5.1470000000000006E+001,
      -51.48,
      -5.1489999999999995E+001,
      -51.5,
      -51.51,
      -5.1519999999999989E+001,
      -5.1529999999999994E+001,
      -5.1539999999999992E+001,
      -51.55,
      -5.1559999999999995E+001,
      -51.57,
      -5.1579999999999991E+001,
      -5.1589999999999996E+001,
      -51.6,
      -5.1609999999999992E+001,
      -5.1620000000000005E+001,
      -51.63,
      -51.64,
      -5.1649999999999991E+001,
      -5.1660000000000004E+001,
      -5.1669999999999995E+001,
      -5.1679999999999993E+001,
      -5.1689999999999991E+001,
      -51.7,
      -5.1709999999999994E+001,
      -51.72,
      -51.73,
      -5.1739999999999995E+001,
      -5.1749999999999993E+001,
      -51.76,
      -5.1769999999999989E+001,
      -51.78,
      -5.1790000000000006E+001,
      -51.8,
      -5.1809999999999988E+001,
      -51.82,
      -51.83,
      -5.1839999999999989E+001,
      -51.85,
      -51.86,
      -51.87,
      -5.1879999999999995E+001,
      -51.89,
      -5.1899999999999991E+001,
      -51.91,
      -5.1919999999999995E+001,
      -51.93,
      -51.94,
      -51.95,
      -5.1959999999999994E+001,
      -5.1969999999999992E+001,
      -5.1980000000000004E+001,
      -5.1989999999999995E+001,
      -5.1999999999999986E+001,
      -52.01,
      -52.02,
      -5.2029999999999994E+001,
      -52.04,
      -52.05,
      -5.2059999999999995E+001,
      -5.2069999999999993E+001,
      -5.2080000000000005E+001,
      -5.2089999999999996E+001,
      -52.1,
      -52.11,
      -52.12,
      -5.2129999999999988E+001,
      -52.14,
      -5.2149999999999991E+001,
      -52.16,
      -5.2169999999999995E+001,
      -52.18,
      -5.2189999999999991E+001,
      -5.2199999999999996E+001,
      -52.21,
      -5.2219999999999992E+001,
      -5.2230000000000004E+001,
      -52.24,
      -52.25,
      -52.26,
      -52.27,
      -5.2279999999999994E+001,
      -5.2289999999999992E+001,
      -52.3,
      -52.31,
      -5.2319999999999993E+001,
      -52.33,
      -5.2339999999999996E+001,
      -5.2349999999999994E+001,
      -5.2359999999999992E+001,
      -52.37,
      -5.2379999999999988E+001,
      -52.39,
      -5.2400000000000006E+001,
      -52.41,
      -52.42,
      -52.43,
      -52.44,
      -5.2449999999999989E+001,
      -5.2460000000000008E+001,
      -52.47,
      -52.48,
      -5.2489999999999995E+001,
      -52.5,
      -5.2509999999999991E+001,
      -5.2519999999999996E+001,
      -5.2529999999999994E+001,
      -52.54,
      -52.55,
      -52.56,
      -5.2569999999999993E+001,
      -52.58,
      -52.59,
      -5.2599999999999994E+001,
      -5.2609999999999985E+001,
      -52.62,
      -52.63,
      -5.2639999999999993E+001,
      -52.65,
      -52.66,
      -5.2669999999999995E+001,
      -5.2679999999999993E+001,
      -5.2690000000000005E+001,
      -5.2699999999999996E+001,
      -52.71,
      -52.72,
      -52.73,
      -5.2739999999999988E+001,
      -52.75,
      -5.2759999999999991E+001,
      -5.2769999999999996E+001,
      -5.2779999999999994E+001,
      -52.79,
      -5.2799999999999990E+001,
      -5.2809999999999995E+001,
      -52.82,
      -5.2829999999999991E+001,
      -52.84,
      -52.85,
      -52.86,
      -52.87,
      -52.88,
      -5.2889999999999993E+001,
      -5.2899999999999991E+001,
      -52.91,
      -52.92,
      -5.2929999999999993E+001,
      -52.94,
      -5.2949999999999996E+001,
      -5.2959999999999994E+001,
      -5.2969999999999992E+001,
      -52.98,
      -5.2989999999999988E+001,
      -53.0,
      -5.3010000000000005E+001,
      -5.3019999999999996E+001,
      -53.03,
      -53.04,
      -53.05,
      -5.3059999999999988E+001,
      -5.3070000000000007E+001,
      -53.08,
      -5.3089999999999996E+001,
      -5.3099999999999994E+001,
      -53.11,
      -5.3119999999999990E+001,
      -5.3129999999999995E+001,
      -5.3139999999999993E+001,
      -53.15,
      -53.16,
      -53.17,
      -5.3179999999999993E+001,
      -53.19,
      -53.2,
      -5.3209999999999994E+001,
      -5.3219999999999985E+001,
      -5.3230000000000004E+001,
      -53.24,
      -5.3249999999999993E+001,
      -53.26,
      -5.3269999999999996E+001,
      -5.3279999999999994E+001,
      -5.3289999999999992E+001,
      -5.3300000000000004E+001,
      -5.3309999999999995E+001,
      -53.32,
      -53.33,
      -5.3339999999999996E+001,
      -5.3349999999999994E+001,
      -53.36,
      -5.3369999999999990E+001,
      -5.3379999999999995E+001,
      -5.3390000000000008E+001,
      -53.4,
      -5.3409999999999989E+001,
      -5.3419999999999995E+001,
      -53.43,
      -5.3439999999999991E+001,
      -53.45,
      -53.46,
      -53.47,
      -53.48,
      -53.49,
      -5.3499999999999993E+001,
      -53.51,
      -5.3519999999999996E+001,
      -53.53,
      -5.3539999999999992E+001,
      -5.3550000000000004E+001,
      -5.3559999999999995E+001,
      -5.3569999999999993E+001,
      -5.3579999999999991E+001,
      -5.3589999999999996E+001,
      -5.3599999999999987E+001,
      -53.61,
      -5.3620000000000005E+001,
      -5.3629999999999995E+001,
      -53.64,
      -53.65,
      -53.66,
      -5.3669999999999995E+001,
      -5.3680000000000007E+001,
      -53.69,
      -5.3699999999999996E+001,
      -53.71,
      -53.72,
      -5.3729999999999990E+001,
      -5.3739999999999995E+001,
      -5.3749999999999993E+001,
      -53.76,
      -5.3769999999999996E+001,
      -53.78,
      -5.3789999999999992E+001,
      -53.8,
      -53.81,
      -5.3819999999999993E+001,
      -5.3830000000000005E+001,
      -53.84,
      -53.85,
      -5.3859999999999992E+001,
      -5.3870000000000005E+001,
      -5.3879999999999995E+001,
      -5.3889999999999993E+001,
      -5.3899999999999991E+001,
      -5.3910000000000004E+001,
      -5.3919999999999995E+001,
      -53.93,
      -53.94,
      -5.3949999999999996E+001,
      -5.3959999999999994E+001,
      -53.97,
      -5.3979999999999990E+001,
      -5.3989999999999995E+001,
      -5.4000000000000007E+001,
      -54.01,
      -5.4019999999999989E+001,
      -5.4029999999999994E+001,
      -54.04,
      -5.4049999999999990E+001,
      -54.06,
      -54.07,
      -54.08,
      -5.4089999999999996E+001,
      -54.1,
      -5.4109999999999992E+001,
      -54.12,
      -5.4129999999999995E+001,
      -54.14,
      -5.4149999999999991E+001,
      -5.4160000000000004E+001,
      -5.4169999999999995E+001,
      -5.4179999999999993E+001,
      -5.4189999999999991E+001,
      -5.4199999999999996E+001,
      -5.4209999999999987E+001,
      -54.22,
      -5.4230000000000004E+001,
      -5.4239999999999995E+001,
      -54.25,
      -54.26,
      -5.4269999999999996E+001,
      -5.4279999999999994E+001,
      -5.4290000000000006E+001,
      -54.3,
      -5.4309999999999995E+001,
      -54.32,
      -54.33,
      -5.4339999999999989E+001,
      -5.4349999999999994E+001,
      -5.4359999999999992E+001,
      -54.37,
      -5.4379999999999995E+001,
      -54.39,
      -5.4399999999999991E+001,
      -54.41,
      -54.42,
      -5.4429999999999993E+001,
      -5.4440000000000005E+001,
      -54.45,
      -54.46,
      -5.4469999999999992E+001,
      -5.4480000000000004E+001,
      -5.4489999999999995E+001,
      -5.4499999999999993E+001,
      -5.4509999999999991E+001,
      -54.52,
      -5.4529999999999994E+001,
      -54.54,
      -54.55,
      -5.4559999999999995E+001,
      -5.4569999999999993E+001,
      -54.58,
      -5.4589999999999989E+001,
      -54.6,
      -5.4610000000000007E+001,
      -54.62,
      -5.4629999999999988E+001,
      -54.64,
      -54.65,
      -5.4659999999999989E+001,
      -54.67,
      -54.68,
      -54.69,
      -5.4699999999999996E+001,
      -54.71,
      -5.4719999999999992E+001,
      -54.73,
      -5.4739999999999995E+001,
      -54.75,
      -54.76,
      -54.77,
      -5.4779999999999994E+001,
      -5.4789999999999992E+001,
      -5.4800000000000004E+001,
      -5.4809999999999995E+001,
      -5.4819999999999986E+001,
      -54.83,
      -54.84,
      -5.4849999999999994E+001,
      -54.86,
      -54.87,
      -5.4879999999999995E+001,
      -5.4889999999999993E+001,
      -5.4900000000000006E+001,
      -54.91,
      -54.92,
      -54.93,
      -54.94,
      -5.4949999999999989E+001,
      -54.96,
      -5.4969999999999992E+001,
      -54.98,
      -5.4989999999999995E+001,
      -55.0,
      -5.5009999999999991E+001,
      -5.5019999999999996E+001,
      -55.03,
      -5.5039999999999992E+001,
      -5.5050000000000004E+001,
      -55.06,
      -55.07,
      -55.08,
      -55.09,
      -5.5099999999999994E+001,
      -5.5109999999999992E+001,
      -55.12,
      -55.13,
      -5.5139999999999993E+001,
      -55.15,
      -55.16,
      -5.5169999999999995E+001,
      -5.5179999999999993E+001,
      -55.19,
      -5.5199999999999989E+001,
      -55.21,
      -5.5220000000000006E+001,
      -55.23,
      -5.5239999999999988E+001,
      -55.25,
      -55.26,
      -5.5269999999999989E+001,
      -55.28,
      -55.29,
      -55.3,
      -5.5309999999999995E+001,
      -55.32,
      -5.5329999999999991E+001,
      -5.5339999999999996E+001,
      -5.5349999999999994E+001,
      -55.36,
      -55.37,
      -55.38,
      -5.5389999999999993E+001,
      -5.5399999999999991E+001,
      -5.5410000000000004E+001,
      -5.5419999999999995E+001,
      -5.5429999999999986E+001,
      -55.44,
      -55.45,
      -5.5459999999999994E+001,
      -55.47,
      -55.48,
      -5.5489999999999995E+001,
      -5.5499999999999993E+001,
      -5.5510000000000005E+001,
      -5.5519999999999996E+001,
      -55.53,
      -55.54,
      -55.55,
      -5.5559999999999988E+001,
      -55.57,
      -5.5579999999999991E+001,
      -5.5589999999999996E+001,
      -5.5599999999999994E+001,
      -55.61,
      -5.5619999999999990E+001,
      -5.5629999999999995E+001,
      -55.64,
      -5.5649999999999991E+001,
      -5.5660000000000004E+001,
      -55.67,
      -55.68,
      -55.69,
      -55.7,
      -5.5709999999999994E+001,
      -5.5719999999999992E+001,
      -55.73,
      -55.74,
      -5.5749999999999993E+001,
      -55.76,
      -5.5769999999999996E+001,
      -5.5779999999999994E+001,
      -5.5789999999999992E+001,
      -55.8,
      -5.5809999999999988E+001,
      -55.82,
      -5.5830000000000005E+001,
      -5.5839999999999996E+001,
      -55.85,
      -55.86,
      -55.87,
      -5.5879999999999988E+001,
      -5.5890000000000008E+001,
      -55.9,
      -55.91,
      -5.5919999999999995E+001,
      -55.93,
      -5.5939999999999991E+001,
      -5.5949999999999996E+001,
      -5.5959999999999994E+001,
      -55.97,
      -55.98,
      -55.99,
      -5.5999999999999993E+001,
      -56.01,
      -56.02,
      -5.6029999999999994E+001,
      -5.6039999999999985E+001,
      -5.6050000000000004E+001,
      -56.06,
      -5.6069999999999993E+001,
      -56.08,
      -5.6089999999999996E+001,
      -5.6099999999999994E+001,
      -5.6109999999999992E+001,
      -5.6120000000000005E+001,
      -5.6129999999999995E+001,
      -56.14,
      -56.15,
      -56.16,
      -5.6169999999999995E+001,
      -56.18,
      -5.6189999999999991E+001,
      -5.6199999999999996E+001,
      -5.6210000000000008E+001,
      -56.22,
      -5.6229999999999990E+001,
      -5.6239999999999995E+001,
      -56.25,
      -5.6259999999999991E+001,
      -56.27,
      -56.28,
      -56.29,
      -56.3,
      -56.31,
      -5.6319999999999993E+001,
      -56.33,
      -5.6339999999999996E+001,
      -56.35,
      -5.6359999999999992E+001,
      -5.6370000000000005E+001,
      -5.6379999999999995E+001,
      -5.6389999999999993E+001,
      -5.6399999999999991E+001,
      -56.41,
      -5.6419999999999987E+001,
      -56.43,
      -5.6440000000000005E+001,
      -5.6449999999999996E+001,
      -56.46,
      -56.47,
      -56.48,
      -5.6489999999999988E+001,
      -5.6500000000000007E+001,
      -56.51,
      -5.6519999999999996E+001,
      -5.6529999999999994E+001,
      -56.54,
      -5.6549999999999990E+001,
      -5.6559999999999995E+001,
      -5.6569999999999993E+001,
      -56.58,
      -5.6589999999999996E+001,
      -56.6,
      -5.6609999999999992E+001,
      -56.62,
      -56.63,
      -5.6639999999999993E+001,
      -5.6649999999999984E+001,
      -5.6660000000000004E+001,
      -56.67,
      -5.6679999999999993E+001,
      -56.69,
      -5.6699999999999996E+001,
      -5.6709999999999994E+001,
      -5.6719999999999992E+001,
      -5.6730000000000004E+001,
      -5.6739999999999995E+001,
      -56.75,
      -56.76,
      -5.6769999999999996E+001,
      -5.6779999999999994E+001,
      -56.79,
      -5.6799999999999990E+001,
      -5.6809999999999995E+001,
      -5.6820000000000007E+001,
      -56.83,
      -5.6839999999999989E+001,
      -5.6849999999999994E+001,
      -56.86,
      -5.6869999999999990E+001,
      -56.88,
      -56.89,
      -56.9,
      -56.91,
      -56.92,
      -5.6929999999999993E+001,
      -56.94,
      -5.6949999999999996E+001,
      -56.96,
      -5.6969999999999992E+001,
      -5.6980000000000004E+001,
      -5.6989999999999995E+001,
      -5.6999999999999993E+001,
      -5.7009999999999991E+001,
      -5.7019999999999996E+001,
      -5.7029999999999987E+001,
      -57.04,
      -5.7050000000000004E+001,
      -5.7059999999999995E+001,
      -57.07,
      -57.08,
      -5.7089999999999996E+001,
      -5.7099999999999994E+001,
      -5.7110000000000007E+001,
      -57.12,
      -5.7129999999999995E+001,
      -57.14,
      -57.15,
      -5.7159999999999989E+001,
      -5.7169999999999995E+001,
      -5.7179999999999993E+001,
      -57.19,
      -5.7199999999999996E+001,
      -57.21,
      -5.7219999999999992E+001,
      -57.23,
      -57.24,
      -5.7249999999999993E+001,
      -5.7260000000000005E+001,
      -57.27,
      -57.28,
      -5.7289999999999992E+001,
      -5.7300000000000004E+001,
      -5.7309999999999995E+001,
      -5.7319999999999993E+001,
      -5.7329999999999991E+001,
      -57.34,
      -5.7349999999999994E+001,
      -57.36,
      -57.37,
      -5.7379999999999995E+001,
      -5.7389999999999993E+001,
      -57.4,
      -5.7409999999999989E+001,
      -57.42,
      -5.7430000000000007E+001,
      -57.44,
      -5.7449999999999989E+001,
      -57.46,
      -57.47,
      -5.7479999999999990E+001,
      -57.49,
      -57.5,
      -57.51,
      -5.7519999999999996E+001,
      -57.53,
      -5.7539999999999992E+001,
      -57.55,
      -5.7559999999999995E+001,
      -57.57,
      -57.58,
      -57.59,
      -5.7599999999999994E+001,
      -5.7609999999999992E+001,
      -5.7620000000000005E+001,
      -5.7629999999999995E+001,
      -5.7639999999999986E+001,
      -57.65,
      -5.7660000000000004E+001,
      -5.7669999999999995E+001,
      -57.68,
      -57.69,
      -5.7699999999999996E+001,
      -5.7709999999999994E+001,
      -5.7720000000000006E+001,
      -57.73,
      -5.7739999999999995E+001,
      -57.75,
      -57.76,
      -5.7769999999999989E+001,
      -5.7779999999999994E+001,
      -5.7789999999999992E+001,
      -57.8,
      -5.7809999999999995E+001,
      -57.82,
      -5.7829999999999991E+001,
      -5.7839999999999996E+001,
      -57.85,
      -5.7859999999999992E+001,
      -5.7870000000000005E+001,
      -57.88,
      -57.89,
      -5.7899999999999991E+001,
      -5.7910000000000004E+001,
      -5.7919999999999995E+001,
      -5.7929999999999993E+001,
      -5.7939999999999991E+001,
      -57.95,
      -5.7959999999999994E+001,
      -57.97,
      -57.98,
      -5.7989999999999995E+001,
      -5.7999999999999993E+001,
      -58.01,
      -5.8019999999999989E+001,
      -58.03,
      -5.8040000000000006E+001,
      -58.05,
      -5.8059999999999988E+001,
      -58.07,
      -58.08,
      -5.8089999999999989E+001,
      -58.1,
      -58.11,
      -58.12,
      -5.8129999999999995E+001,
      -58.14,
      -5.8149999999999991E+001,
      -58.16,
      -5.8169999999999995E+001,
      -58.18,
      -58.19,
      -58.2,
      -5.8209999999999994E+001,
      -5.8219999999999992E+001,
      -5.8230000000000004E+001,
      -5.8239999999999995E+001,
      -5.8249999999999986E+001,
      -58.26,
      -58.27,
      -5.8279999999999994E+001,
      -58.29,
      -58.3,
      -5.8309999999999995E+001,
      -5.8319999999999993E+001,
      -5.8330000000000005E+001,
      -5.8339999999999996E+001,
      -58.35,
      -58.36,
      -58.37,
      -5.8379999999999988E+001,
      -58.39,
      -5.8399999999999991E+001,
      -58.41,
      -5.8419999999999995E+001,
      -58.43,
      -5.8439999999999991E+001,
      -5.8449999999999996E+001,
      -58.46,
      -5.8469999999999992E+001,
      -5.8480000000000004E+001,
      -58.49,
      -58.5,
      -58.51,
      -58.52,
      -5.8529999999999994E+001,
      -5.8539999999999992E+001,
      -58.55,
      -58.56,
      -5.8569999999999993E+001,
      -58.58,
      -5.8589999999999996E+001,
      -5.8599999999999994E+001,
      -5.8609999999999992E+001,
      -58.62,
      -5.8629999999999988E+001,
      -58.64,
      -5.8650000000000006E+001,
      -58.66,
      -58.67,
      -58.68,
      -58.69,
      -5.8699999999999989E+001,
      -5.8710000000000008E+001,
      -58.72,
      -58.73,
      -5.8739999999999995E+001,
      -58.75,
      -5.8759999999999991E+001,
      -5.8769999999999996E+001,
      -5.8779999999999994E+001,
      -58.79,
      -58.8,
      -58.81,
      -5.8819999999999993E+001,
      -58.83,
      -58.84,
      -5.8849999999999994E+001,
      -5.8859999999999985E+001,
      -5.8870000000000005E+001,
      -58.88,
      -5.8889999999999993E+001,
      -58.9,
      -58.91,
      -5.8919999999999995E+001,
      -5.8929999999999993E+001,
      -5.8940000000000005E+001,
      -5.8949999999999996E+001,
      -58.96,
      -58.97,
      -58.98,
      -5.8989999999999995E+001,
      -59.0,
      -5.9009999999999991E+001,
      -5.9019999999999996E+001,
      -5.9029999999999994E+001,
      -59.04,
      -5.9049999999999990E+001,
      -5.9059999999999995E+001,
      -59.07,
      -5.9079999999999991E+001,
      -59.09,
      -59.1,
      -59.11,
      -59.12,
      -59.13,
      -5.9139999999999993E+001,
      -5.9149999999999991E+001,
      -59.16,
      -59.17,
      -5.9179999999999993E+001,
      -59.19,
      -5.9199999999999996E+001,
      -5.9209999999999994E+001,
      -5.9219999999999992E+001,
      -59.23,
      -5.9239999999999988E+001,
      -59.25,
      -5.9260000000000005E+001,
      -5.9269999999999996E+001,
      -59.28,
      -59.29,
      -59.3,
      -5.9309999999999988E+001,
      -5.9320000000000007E+001,
      -59.33,
      -5.9339999999999996E+001,
      -5.9349999999999994E+001,
      -59.36,
      -5.9369999999999990E+001,
      -5.9379999999999995E+001,
      -5.9389999999999993E+001,
      -59.4,
      -59.41,
      -59.42,
      -5.9429999999999993E+001,
      -59.44,
      -59.45,
      -5.9459999999999994E+001,
      -5.9469999999999985E+001,
      -5.9480000000000004E+001,
      -59.49,
      -5.9499999999999993E+001,
      -59.51,
      -5.9519999999999996E+001,
      -5.9529999999999994E+001,
      -5.9539999999999992E+001,
      -5.9550000000000004E+001,
      -5.9559999999999995E+001,
      -59.57,
      -59.58,
      -5.9589999999999996E+001,
      -5.9599999999999994E+001,
      -59.61,
      -5.9619999999999990E+001,
      -59.63,
      -5.9639999999999993E+001,
      -59.65,
      -5.9659999999999989E+001,
      -5.9669999999999995E+001,
      -59.68,
      -5.9689999999999991E+001,
      -59.7,
      -59.71,
      -59.72,
      -59.73,
      -59.74,
      -5.9749999999999993E+001,
      -59.76,
      -5.9769999999999996E+001,
      -59.78,
      -59.79,
      -59.8,
      -5.9809999999999995E+001,
      -5.9819999999999993E+001,
      -5.9829999999999991E+001,
      -5.9839999999999996E+001,
      -5.9849999999999987E+001,
      -59.86,
      -5.9870000000000005E+001,
      -5.9879999999999995E+001,
      -59.89,
      -59.9,
      -59.91,
      -5.9919999999999995E+001,
      -5.9930000000000007E+001,
      -59.94,
      -59.95,
      -5.9959999999999994E+001,
      -59.97,
      -5.9979999999999990E+001,
      -5.9989999999999995E+001,
      -5.9999999999999993E+001,
      -60.01,
      -6.0019999999999996E+001,
      -60.03,
      -6.0039999999999992E+001,
      -60.05,
      -60.06,
      -6.0069999999999993E+001,
      -6.0080000000000005E+001,
      -60.09,
      -60.1,
      -60.11,
      -60.12,
      -6.0129999999999995E+001,
      -6.0139999999999993E+001,
      -6.0149999999999991E+001,
      -6.0160000000000004E+001,
      -6.0169999999999995E+001,
      -60.18,
      -60.19,
      -6.0199999999999996E+001,
      -6.0209999999999994E+001,
      -60.22,
      -6.0229999999999990E+001,
      -60.24,
      -6.0250000000000007E+001,
      -60.26,
      -60.27,
      -6.0279999999999994E+001,
      -60.29,
      -6.0299999999999990E+001,
      -60.31,
      -60.32,
      -60.33,
      -6.0339999999999996E+001,
      -60.35,
      -6.0359999999999992E+001,
      -60.37,
      -6.0379999999999995E+001,
      -60.39,
      -60.4,
      -60.41,
      -6.0419999999999995E+001,
      -6.0429999999999993E+001,
      -6.0439999999999991E+001,
      -6.0449999999999996E+001,
      -6.0459999999999987E+001,
      -60.47,
      -6.0480000000000004E+001,
      -6.0489999999999995E+001,
      -60.5,
      -60.51,
      -6.0519999999999996E+001,
      -6.0529999999999994E+001,
      -6.0540000000000006E+001,
      -60.55,
      -60.56,
      -6.0569999999999993E+001,
      -60.58,
      -6.0589999999999989E+001,
      -6.0599999999999994E+001,
      -6.0609999999999992E+001,
      -60.62,
      -6.0629999999999995E+001,
      -60.64,
      -6.0649999999999991E+001,
      -60.66,
      -60.67,
      -6.0679999999999993E+001,
      -6.0690000000000005E+001,
      -60.7,
      -60.71,
      -60.72,
      -60.73,
      -6.0739999999999995E+001,
      -6.0749999999999993E+001,
      -6.0759999999999991E+001,
      -60.77,
      -6.0779999999999994E+001,
      -60.79,
      -60.8,
      -6.0809999999999995E+001,
      -6.0819999999999993E+001,
      -60.83,
      -6.0839999999999989E+001,
      -60.85,
      -6.0860000000000007E+001,
      -60.87,
      -60.88,
      -6.0889999999999993E+001,
      -60.9,
      -6.0909999999999989E+001,
      -60.92,
      -60.93,
      -60.94,
      -6.0949999999999996E+001,
      -60.96,
      -6.0969999999999992E+001,
      -60.98,
      -6.0989999999999995E+001,
      -61.0,
      -61.01,
      -61.02,
      -6.1029999999999994E+001,
      -61.04,
      -6.1049999999999990E+001,
      -6.1059999999999995E+001,
      -6.1069999999999986E+001,
      -61.08,
      -61.09,
      -6.1099999999999994E+001,
      -61.11,
      -61.12,
      -6.1129999999999995E+001,
      -6.1139999999999993E+001,
      -6.1150000000000006E+001,
      -61.16,
      -61.17,
      -61.18,
      -61.19,
      -6.1199999999999996E+001,
      -6.1209999999999994E+001,
      -6.1219999999999992E+001,
      -61.23,
      -6.1239999999999995E+001,
      -61.25,
      -6.1259999999999991E+001,
      -6.1269999999999996E+001,
      -61.28,
      -6.1289999999999992E+001,
      -6.1300000000000004E+001,
      -61.31,
      -61.32,
      -61.33,
      -61.34,
      -6.1349999999999994E+001,
      -61.36,
      -6.1369999999999990E+001,
      -61.38,
      -6.1389999999999993E+001,
      -61.4,
      -61.41,
      -6.1419999999999995E+001,
      -6.1429999999999993E+001,
      -61.44,
      -6.1449999999999989E+001,
      -61.46,
      -6.1470000000000006E+001,
      -61.48,
      -61.49,
      -61.5,
      -61.51,
      -6.1519999999999996E+001,
      -61.53,
      -61.54,
      -61.55,
      -6.1559999999999995E+001,
      -61.57,
      -6.1579999999999991E+001,
      -6.1589999999999996E+001,
      -6.1599999999999994E+001,
      -61.61,
      -61.62,
      -61.63,
      -6.1639999999999993E+001,
      -61.65,
      -6.1659999999999989E+001,
      -6.1669999999999995E+001,
      -6.1679999999999986E+001,
      -61.69,
      -61.7,
      -6.1709999999999994E+001,
      -61.72,
      -61.73,
      -6.1739999999999995E+001,
      -6.1749999999999993E+001,
      -6.1760000000000005E+001,
      -6.1769999999999996E+001,
      -61.78,
      -61.79,
      -61.8,
      -6.1809999999999995E+001,
      -6.1819999999999993E+001,
      -6.1829999999999991E+001,
      -6.1839999999999996E+001,
      -6.1849999999999994E+001,
      -61.86,
      -6.1869999999999990E+001,
      -6.1879999999999995E+001,
      -61.89,
      -6.1899999999999991E+001,
      -6.1910000000000004E+001,
      -61.92,
      -61.93,
      -61.94,
      -61.95,
      -6.1959999999999994E+001,
      -61.97,
      -6.1979999999999990E+001,
      -61.99,
      -6.1999999999999993E+001,
      -62.01,
      -6.2019999999999996E+001,
      -6.2029999999999994E+001,
      -6.2039999999999992E+001,
      -62.05,
      -6.2059999999999988E+001,
      -62.07,
      -6.2080000000000005E+001,
      -6.2089999999999996E+001,
      -62.1,
      -62.11,
      -62.12,
      -6.2129999999999995E+001,
      -62.14,
      -62.15,
      -62.16,
      -6.2169999999999995E+001,
      -62.18,
      -6.2189999999999991E+001,
      -6.2199999999999996E+001,
      -6.2209999999999994E+001,
      -62.22,
      -62.23,
      -62.24,
      -6.2249999999999993E+001,
      -62.26,
      -62.27,
      -6.2279999999999994E+001,
      -6.2290000000000006E+001,
      -62.3,
      -62.31,
      -6.2319999999999993E+001,
      -62.33,
      -6.2339999999999996E+001,
      -6.2349999999999994E+001,
      -6.2359999999999992E+001,
      -6.2370000000000005E+001,
      -6.2379999999999995E+001,
      -62.39,
      -62.4,
      -62.41,
      -6.2419999999999995E+001,
      -62.43,
      -6.2439999999999991E+001,
      -62.45,
      -6.2459999999999994E+001,
      -62.47,
      -6.2479999999999990E+001,
      -6.2489999999999995E+001,
      -6.2499999999999993E+001,
      -6.2509999999999991E+001,
      -6.2519999999999996E+001,
      -62.53,
      -6.2539999999999992E+001,
      -62.55,
      -62.56,
      -6.2569999999999993E+001,
      -62.58,
      -6.2589999999999996E+001,
      -62.6,
      -62.61,
      -62.62,
      -6.2629999999999995E+001,
      -6.2639999999999993E+001,
      -6.2649999999999991E+001,
      -62.66,
      -6.2669999999999987E+001,
      -62.68,
      -62.69,
      -6.2699999999999996E+001,
      -6.2709999999999994E+001,
      -62.72,
      -6.2729999999999990E+001,
      -6.2739999999999995E+001,
      -6.2750000000000007E+001,
      -62.76,
      -62.77,
      -6.2779999999999994E+001,
      -62.79,
      -6.2799999999999990E+001,
      -6.2809999999999995E+001,
      -6.2819999999999993E+001,
      -62.83,
      -6.2839999999999996E+001,
      -62.85,
      -6.2859999999999992E+001,
      -62.87,
      -6.2879999999999995E+001,
      -6.2889999999999993E+001,
      -62.9,
      -62.91,
      -6.2919999999999995E+001,
      -6.2929999999999993E+001,
      -6.2939999999999991E+001,
      -6.2949999999999996E+001,
      -6.2959999999999987E+001,
      -6.2969999999999992E+001,
      -6.2980000000000004E+001,
      -6.2989999999999995E+001,
      -63.0,
      -63.01,
      -6.3019999999999996E+001,
      -6.3029999999999994E+001,
      -63.04,
      -6.3049999999999990E+001,
      -63.06,
      -6.3069999999999993E+001,
      -63.08,
      -6.3089999999999989E+001,
      -6.3099999999999994E+001,
      -6.3109999999999992E+001,
      -6.3119999999999990E+001,
      -6.3129999999999995E+001,
      -63.14,
      -6.3149999999999991E+001,
      -63.16,
      -63.17,
      -6.3179999999999993E+001,
      -63.19,
      -6.3199999999999996E+001,
      -63.21,
      -63.22,
      -63.23,
      -6.3239999999999995E+001,
      -6.3249999999999993E+001,
      -6.3259999999999991E+001,
      -6.3269999999999996E+001,
      -6.3279999999999987E+001,
      -63.29,
      -63.3,
      -6.3309999999999995E+001,
      -6.3319999999999993E+001,
      -63.33,
      -6.3339999999999989E+001,
      -6.3349999999999994E+001,
      -6.3360000000000007E+001,
      -63.37,
      -63.38,
      -6.3389999999999993E+001,
      -63.4,
      -6.3409999999999989E+001,
      -6.3419999999999995E+001,
      -6.3429999999999993E+001,
      -63.44,
      -6.3449999999999996E+001,
      -63.46,
      -6.3469999999999992E+001,
      -63.48,
      -6.3489999999999995E+001,
      -6.3499999999999993E+001,
      -63.51,
      -63.52,
      -6.3529999999999994E+001,
      -63.54,
      -6.3549999999999990E+001,
      -6.3559999999999995E+001,
      -6.3569999999999986E+001,
      -6.3579999999999991E+001,
      -63.59,
      -6.3599999999999994E+001,
      -63.61,
      -63.62,
      -6.3629999999999995E+001,
      -6.3639999999999993E+001,
      -63.65,
      -6.3659999999999989E+001,
      -63.67,
      -63.68,
      -63.69,
      -6.3699999999999996E+001,
      -6.3709999999999994E+001,
      -6.3719999999999992E+001,
      -6.3729999999999990E+001,
      -6.3739999999999995E+001,
      -63.75,
      -6.3759999999999991E+001,
      -6.3769999999999996E+001,
      -63.78,
      -6.3789999999999992E+001,
      -63.8,
      -6.3809999999999995E+001,
      -63.82,
      -63.83,
      -63.84,
      -6.3849999999999994E+001,
      -63.86,
      -6.3869999999999990E+001,
      -6.3879999999999995E+001,
      -6.3889999999999986E+001,
      -63.9,
      -63.91,
      -6.3919999999999995E+001,
      -6.3929999999999993E+001,
      -63.94,
      -6.3949999999999989E+001,
      -6.3959999999999994E+001,
      -6.3970000000000006E+001,
      -63.98,
      -63.99,
      -64.0,
      -6.401E+001,
      -64.02,
      -64.03,
      -6.4039999999999992E+001,
      -64.05,
      -6.4059999999999988E+001,
      -6.407E+001,
      -64.08,
      -64.09,
      -6.41E+001,
      -64.11,
      -6.4119999999999990E+001,
      -64.13,
      -6.4139999999999986E+001,
      -6.4149999999999991E+001,
      -64.16,
      -64.17,
      -6.4179999999999993E+001,
      -64.19,
      -64.2,
      -6.421E+001,
      -64.22,
      -64.23,
      -64.24,
      -64.25,
      -6.426E+001,
      -64.27,
      -64.28,
      -6.4289999999999992E+001,
      -64.3,
      -64.31,
      -6.432E+001,
      -64.33,
      -6.4339999999999989E+001,
      -6.435E+001,
      -64.36,
      -6.4369999999999990E+001,
      -64.38,
      -64.39,
      -6.4399999999999991E+001,
      -64.41,
      -64.42,
      -6.4429999999999993E+001,
      -64.44,
      -64.45,
      -6.446E+001,
      -64.47,
      -6.4479999999999990E+001,
      -64.49,
      -6.4499999999999986E+001,
      -6.4509999999999991E+001,
      -64.52,
      -6.4529999999999987E+001,
      -6.4539999999999992E+001,
      -64.55,
      -6.4559999999999988E+001,
      -6.457E+001,
      -64.58,
      -6.4589999999999989E+001,
      -6.46E+001,
      -64.61,
      -6.462E+001,
      -64.63,
      -64.64,
      -6.4649999999999991E+001,
      -64.66,
      -6.4669999999999987E+001,
      -6.4679999999999993E+001,
      -64.69,
      -64.7,
      -6.471E+001,
      -64.72,
      -6.4729999999999990E+001,
      -64.74,
      -6.4749999999999986E+001,
      -6.4759999999999991E+001,
      -6.4770000000000010E+001,
      -64.78,
      -6.479E+001,
      -64.8,
      -64.81,
      -6.482E+001,
      -64.83,
      -64.84,
      -6.485E+001,
      -64.86,
      -6.487E+001,
      -64.88,
      -64.89,
      -6.4899999999999991E+001,
      -64.91,
      -64.92,
      -6.493E+001,
      -64.94,
      -64.95,
      -6.496E+001,
      -64.97,
      -6.4979999999999990E+001,
      -64.99,
      -65.0,
      -6.5009999999999991E+001,
      -65.02,
      -65.03,
      -6.5039999999999992E+001,
      -65.05,
      -65.06,
      -6.507E+001,
      -65.08,
      -65.09,
      -6.51E+001,
      -65.11,
      -6.5119999999999990E+001,
      -65.13,
      -6.5139999999999986E+001,
      -6.5149999999999991E+001,
      -65.16,
      -6.5169999999999987E+001,
      -6.5179999999999993E+001,
      -65.19,
      -6.5199999999999989E+001,
      -6.521E+001,
      -65.22,
      -65.23,
      -65.24,
      -65.25,
      -6.5259999999999991E+001,
      -65.27,
      -6.5279999999999987E+001,
      -6.5289999999999992E+001,
      -65.3,
      -65.31,
      -6.532E+001,
      -65.33,
      -6.5339999999999989E+001,
      -6.535E+001,
      -6.5359999999999985E+001,
      -6.5369999999999990E+001,
      -6.5380000000000010E+001,
      -65.39,
      -6.54E+001,
      -65.41,
      -65.42,
      -6.5429999999999993E+001,
      -65.44,
      -65.45,
      -6.546E+001,
      -65.47,
      -65.48,
      -65.49,
      -65.5,
      -6.5509999999999991E+001,
      -65.52,
      -65.53,
      -6.554E+001,
      -65.55,
      -65.56,
      -6.557E+001,
      -65.58,
      -6.5589999999999989E+001,
      -6.56E+001,
      -65.61,
      -6.5619999999999990E+001,
      -65.63,
      -65.64,
      -6.5649999999999991E+001,
      -65.66,
      -65.67,
      -6.5679999999999993E+001,
      -65.69,
      -65.7,
      -6.571E+001,
      -65.72,
      -6.5729999999999990E+001,
      -65.74,
      -6.5749999999999986E+001,
      -6.5759999999999991E+001,
      -65.77,
      -6.5779999999999987E+001,
      -6.5789999999999992E+001,
      -65.8,
      -6.5809999999999988E+001,
      -6.582E+001,
      -65.83,
      -65.84,
      -6.585E+001,
      -65.86,
      -6.5869999999999990E+001,
      -65.88,
      -6.5889999999999986E+001,
      -6.5899999999999991E+001,
      -65.91,
      -65.92,
      -6.5929999999999993E+001,
      -65.94,
      -6.5949999999999989E+001,
      -6.596E+001,
      -6.5969999999999985E+001,
      -6.5979999999999990E+001,
      -6.5990000000000009E+001,
      -66.0,
      -6.601E+001,
      -66.02,
      -66.03,
      -6.6039999999999992E+001,
      -66.05,
      -66.06,
      -6.607E+001,
      -66.08,
      -66.09,
      -6.61E+001,
      -66.11,
      -6.6119999999999990E+001,
      -66.13,
      -66.14,
      -6.615E+001,
      -66.16,
      -66.17,
      -6.618E+001,
      -66.19,
      -66.2,
      -6.621E+001,
      -66.22,
      -6.6229999999999990E+001,
      -66.24,
      -66.25,
      -6.6259999999999991E+001,
      -66.27,
      -66.28,
      -6.6289999999999992E+001,
      -66.3,
      -66.31,
      -6.632E+001,
      -66.33,
      -66.34,
      -6.635E+001,
      -66.36,
      -6.6369999999999990E+001,
      -66.38,
      -6.6389999999999986E+001,
      -6.6399999999999991E+001,
      -66.41,
      -6.6419999999999987E+001,
      -6.6429999999999993E+001,
      -66.44,
      -66.45,
      -6.646E+001,
      -66.47,
      -6.6479999999999990E+001,
      -66.49,
      -66.5,
      -6.6509999999999991E+001,
      -66.52,
      -66.53,
      -6.6539999999999992E+001,
      -66.55,
      -6.6559999999999988E+001,
      -6.657E+001,
      -6.6579999999999984E+001,
      -6.6589999999999989E+001,
      -6.6600000000000009E+001,
      -66.61,
      -6.662E+001,
      -66.63,
      -66.64,
      -6.6649999999999991E+001,
      -66.66,
      -66.67,
      -6.668E+001,
      -66.69,
      -66.7,
      -6.671E+001,
      -66.72,
      -6.6729999999999990E+001,
      -66.74,
      -6.6749999999999986E+001,
      -6.6759999999999991E+001,
      -6.6769999999999982E+001,
      -6.6779999999999987E+001,
      -6.6789999999999992E+001,
      -6.6799999999999983E+001,
      -6.6809999999999988E+001,
      -6.6819999999999979E+001,
      -66.83,
      -6.6839999999999989E+001,
      -6.685E+001,
      -66.86,
      -6.6869999999999990E+001,
      -66.88,
      -66.89,
      -6.6899999999999991E+001,
      -66.91,
      -6.6919999999999987E+001,
      -6.6929999999999993E+001,
      -6.6939999999999984E+001,
      -6.6949999999999989E+001,
      -6.6959999999999980E+001,
      -6.6969999999999985E+001,
      -6.6979999999999990E+001,
      -66.99,
      -6.6999999999999986E+001,
      -6.7009999999999991E+001,
      -67.02,
      -6.7029999999999987E+001,
      -6.7039999999999992E+001,
      -67.05,
      -6.7059999999999988E+001,
      -6.707E+001,
      -67.08,
      -6.7089999999999989E+001,
      -6.71E+001,
      -6.7109999999999985E+001,
      -6.7119999999999990E+001,
      -67.13,
      -67.14,
      -6.7149999999999991E+001,
      -67.16,
      -6.7169999999999987E+001,
      -6.7179999999999993E+001,
      -6.7189999999999984E+001,
      -6.7199999999999989E+001,
      -6.721E+001,
      -6.7219999999999985E+001,
      -6.7229999999999990E+001,
      -67.24,
      -6.7249999999999986E+001,
      -6.7259999999999991E+001,
      -67.27,
      -67.28,
      -6.729E+001,
      -67.3,
      -67.31,
      -6.732E+001,
      -67.33,
      -6.7339999999999989E+001,
      -6.735E+001,
      -6.7359999999999985E+001,
      -6.7369999999999990E+001,
      -6.7379999999999981E+001,
      -6.7389999999999986E+001,
      -6.7399999999999991E+001,
      -6.7409999999999982E+001,
      -6.7419999999999987E+001,
      -6.743E+001,
      -67.44,
      -67.45,
      -6.746E+001,
      -67.47,
      -6.7479999999999990E+001,
      -67.49,
      -67.5,
      -6.7509999999999991E+001,
      -67.52,
      -6.7529999999999987E+001,
      -6.7539999999999992E+001,
      -6.7549999999999983E+001,
      -6.7559999999999988E+001,
      -6.7569999999999979E+001,
      -6.7579999999999984E+001,
      -67.59,
      -6.76E+001,
      -67.61,
      -6.7619999999999990E+001,
      -67.63,
      -6.7639999999999986E+001,
      -6.7649999999999991E+001,
      -67.66,
      -6.7669999999999987E+001,
      -6.7679999999999993E+001,
      -67.69,
      -6.7699999999999989E+001,
      -6.771E+001,
      -6.7719999999999985E+001,
      -6.7729999999999990E+001,
      -67.74,
      -67.75,
      -6.7759999999999991E+001,
      -67.77,
      -6.7779999999999987E+001,
      -6.7789999999999992E+001,
      -6.7799999999999983E+001,
      -6.7809999999999988E+001,
      -6.782E+001,
      -6.7829999999999984E+001,
      -6.7839999999999989E+001,
      -6.785E+001,
      -6.7859999999999985E+001,
      -6.7869999999999990E+001,
      -67.88,
      -67.89,
      -6.79E+001,
      -67.91,
      -67.92,
      -6.7929999999999993E+001,
      -67.94,
      -6.7949999999999989E+001,
      -6.796E+001,
      -6.7969999999999985E+001,
      -6.7979999999999990E+001,
      -6.7989999999999981E+001,
      -6.7999999999999986E+001,
      -6.8009999999999991E+001,
      -6.8019999999999982E+001,
      -6.8029999999999987E+001,
      -6.804E+001,
      -68.05,
      -68.06,
      -6.807E+001,
      -68.08,
      -6.8089999999999989E+001,
      -6.81E+001,
      -68.11,
      -6.8119999999999990E+001,
      -68.13,
      -6.8139999999999986E+001,
      -6.8149999999999991E+001,
      -6.8159999999999982E+001,
      -6.8169999999999987E+001,
      -6.8179999999999978E+001,
      -6.8189999999999984E+001,
      -68.2,
      -6.821E+001,
      -68.22,
      -6.8229999999999990E+001,
      -68.24,
      -6.8249999999999986E+001,
      -6.8259999999999991E+001,
      -68.27,
      -6.8279999999999987E+001,
      -6.8289999999999992E+001,
      -68.3,
      -6.8309999999999988E+001,
      -6.832E+001,
      -6.8329999999999984E+001,
      -6.8339999999999989E+001,
      -6.835E+001,
      -68.36,
      -6.8369999999999990E+001,
      -68.38,
      -6.8389999999999986E+001,
      -6.8399999999999991E+001,
      -6.8409999999999982E+001,
      -6.8419999999999987E+001,
      -6.8429999999999993E+001,
      -6.8439999999999984E+001,
      -6.8449999999999989E+001,
      -6.846E+001,
      -6.8469999999999985E+001,
      -6.8479999999999990E+001,
      -68.49,
      -68.5,
      -6.851E+001,
      -68.52,
      -68.53,
      -6.8539999999999992E+001,
      -68.55,
      -6.8559999999999988E+001,
      -6.857E+001,
      -6.8579999999999984E+001,
      -6.8589999999999989E+001,
      -6.8599999999999980E+001,
      -6.8609999999999985E+001,
      -6.8619999999999990E+001,
      -6.8629999999999981E+001,
      -6.8639999999999986E+001,
      -6.865E+001,
      -68.66,
      -68.67,
      -6.868E+001,
      -68.69,
      -68.7,
      -6.871E+001,
      -68.72,
      -6.8729999999999990E+001,
      -68.74,
      -68.75,
      -6.8759999999999991E+001,
      -68.77,
      -68.78,
      -6.8789999999999992E+001,
      -6.8800000000000011E+001,
      -6.8810000000000016E+001,
      -6.8820000000000007E+001,
      -6.8830000000000013E+001,
      -68.84,
      -6.8850000000000009E+001,
      -68.86,
      -6.887E+001,
      -68.88,
      -68.89,
      -6.8899999999999991E+001,
      -68.91,
      -6.8919999999999987E+001,
      -6.8929999999999993E+001,
      -68.94,
      -6.8949999999999989E+001,
      -6.8960000000000008E+001,
      -6.8970000000000013E+001,
      -68.98,
      -6.8990000000000009E+001,
      -6.9000000000000014E+001,
      -6.901E+001,
      -6.9020000000000010E+001,
      -69.03,
      -6.904E+001,
      -69.05,
      -69.06,
      -6.907E+001,
      -69.08,
      -6.9089999999999989E+001,
      -6.91E+001,
      -69.11,
      -6.912E+001,
      -6.9130000000000010E+001,
      -69.14,
      -6.915E+001,
      -6.9160000000000011E+001,
      -69.17,
      -6.918E+001,
      -69.19,
      -69.2,
      -6.921E+001,
      -69.22,
      -69.23,
      -69.24,
      -69.25,
      -6.9260000000000019E+001,
      -6.9270000000000010E+001,
      -6.9280000000000015E+001,
      -6.929E+001,
      -6.9300000000000011E+001,
      -69.31,
      -6.9320000000000007E+001,
      -69.33,
      -69.34,
      -6.935E+001,
      -69.36,
      -6.9369999999999990E+001,
      -69.38,
      -69.39,
      -6.9399999999999991E+001,
      -6.9410000000000011E+001,
      -6.9420000000000016E+001,
      -6.943E+001,
      -6.9440000000000012E+001,
      -6.9450000000000017E+001,
      -6.9460000000000008E+001,
      -6.9470000000000013E+001,
      -69.48,
      -6.9490000000000009E+001,
      -69.5,
      -6.951E+001,
      -69.52,
      -69.53,
      -6.9539999999999992E+001,
      -69.55,
      -6.9559999999999988E+001,
      -6.9570000000000007E+001,
      -6.9580000000000013E+001,
      -69.59,
      -6.9600000000000009E+001,
      -6.9610000000000014E+001,
      -6.962E+001,
      -6.9630000000000010E+001,
      -69.64,
      -6.965E+001,
      -6.9660000000000011E+001,
      -69.67,
      -6.968E+001,
      -69.69,
      -69.7,
      -6.971E+001,
      -6.9720000000000013E+001,
      -69.73,
      -6.9740000000000009E+001,
      -69.75,
      -6.976E+001,
      -6.9770000000000010E+001,
      -69.78,
      -6.979E+001,
      -69.8,
      -69.81,
      -6.9820000000000007E+001,
      -69.83,
      -69.84,
      -6.985E+001,
      -69.86,
      -6.9870000000000019E+001,
      -6.9880000000000010E+001,
      -6.9890000000000015E+001,
      -6.99E+001,
      -6.9910000000000011E+001,
      -69.92,
      -6.993E+001,
      -69.94,
      -69.95,
      -6.996E+001,
      -69.97,
      -6.9979999999999990E+001,
      -69.99,
      -70.0,
      -7.0009999999999991E+001,
      -7.0020000000000010E+001,
      -7.0030000000000015E+001,
      -7.004E+001,
      -7.0050000000000011E+001,
      -7.0060000000000016E+001,
      -7.0070000000000007E+001,
      -7.0080000000000013E+001,
      -70.09,
      -7.0100000000000009E+001,
      -70.11,
      -7.012E+001,
      -70.13,
      -70.14,
      -7.0149999999999991E+001,
      -70.16,
      -7.0169999999999987E+001,
      -7.018E+001,
      -7.0190000000000012E+001,
      -70.2,
      -7.0210000000000008E+001,
      -7.0220000000000013E+001,
      -70.23,
      -7.0240000000000009E+001,
      -70.25,
      -7.026E+001,
      -7.0270000000000010E+001,
      -70.28,
      -7.029E+001,
      -70.3,
      -70.31,
      -7.032E+001,
      -7.0330000000000013E+001,
      -70.34,
      -7.0350000000000009E+001,
      -70.36,
      -7.037E+001,
      -7.0380000000000010E+001,
      -70.39,
      -7.04E+001,
      -70.41,
      -70.42,
      -7.043E+001,
      -70.44,
      -70.45,
      -7.046E+001,
      -70.47,
      -7.0480000000000018E+001,
      -7.0490000000000009E+001,
      -7.0500000000000014E+001,
      -7.051E+001,
      -7.0520000000000010E+001,
      -70.53,
      -7.054E+001,
      -70.55,
      -70.56,
      -7.057E+001,
      -70.58,
      -70.59,
      -7.06E+001,
      -70.61,
      -7.0619999999999990E+001,
      -7.0630000000000010E+001,
      -7.0640000000000015E+001,
      -7.065E+001,
      -7.0660000000000011E+001,
      -7.0670000000000016E+001,
      -7.068E+001,
      -7.0690000000000012E+001,
      -70.7,
      -7.0710000000000008E+001,
      -70.72,
      -70.73,
      -70.74,
      -70.75,
      -7.0759999999999991E+001,
      -70.77,
      -7.0779999999999987E+001,
      -7.079E+001,
      -7.0800000000000011E+001,
      -70.81,
      -7.0820000000000007E+001,
      -7.0830000000000013E+001,
      -70.84,
      -7.0850000000000009E+001,
      -7.0860000000000014E+001,
      -7.087E+001,
      -7.0880000000000010E+001,
      -70.89,
      -7.09E+001,
      -70.91,
      -70.92,
      -7.0929999999999993E+001,
      -7.0940000000000012E+001,
      -70.95,
      -7.0960000000000008E+001,
      -70.97,
      -70.98,
      -7.0990000000000009E+001,
      -71.0,
      -7.101E+001,
      -7.1020000000000010E+001,
      -71.03,
      -7.104E+001,
      -71.05,
      -71.06,
      -7.1070000000000007E+001,
      -71.08,
      -7.1090000000000018E+001,
      -7.1100000000000009E+001,
      -7.1110000000000014E+001,
      -7.112E+001,
      -7.1130000000000010E+001,
      -71.14,
      -7.115E+001,
      -71.16,
      -71.17,
      -7.1179999999999993E+001,
      -71.19,
      -71.2,
      -7.121E+001,
      -71.22,
      -7.1229999999999990E+001,
      -7.1240000000000009E+001,
      -7.1250000000000014E+001,
      -7.126E+001,
      -7.1270000000000010E+001,
      -7.1280000000000015E+001,
      -7.129E+001,
      -7.1300000000000011E+001,
      -71.31,
      -7.1320000000000007E+001,
      -71.33,
      -71.34,
      -7.135E+001,
      -71.36,
      -7.1369999999999990E+001,
      -71.38,
      -7.1389999999999986E+001,
      -7.14E+001,
      -7.1410000000000011E+001,
      -71.42,
      -7.143E+001,
      -7.1440000000000012E+001,
      -71.45,
      -7.1460000000000008E+001,
      -7.1470000000000013E+001,
      -71.48,
      -7.1490000000000009E+001,
      -71.5,
      -7.151E+001,
      -71.52,
      -71.53,
      -7.1539999999999992E+001,
      -7.1550000000000011E+001,
      -71.56,
      -7.1570000000000007E+001,
      -71.58,
      -71.59,
      -7.1600000000000009E+001,
      -71.61,
      -7.162E+001,
      -7.1630000000000010E+001,
      -71.64,
      -7.165E+001,
      -71.66,
      -71.67,
      -7.168E+001,
      -71.69,
      -7.1700000000000017E+001,
      -7.1710000000000008E+001,
      -7.1720000000000013E+001,
      -71.73,
      -7.1740000000000009E+001,
      -71.75,
      -7.176E+001,
      -71.77,
      -71.78,
      -7.179E+001,
      -71.8,
      -71.81,
      -7.182E+001,
      -71.83,
      -71.84,
      -7.1850000000000009E+001,
      -7.1860000000000014E+001,
      -7.187E+001,
      -7.1880000000000010E+001,
      -7.1890000000000015E+001,
      -7.19E+001,
      -7.1910000000000011E+001,
      -71.92,
      -7.193E+001,
      -71.94,
      -71.95,
      -7.196E+001,
      -71.97,
      -7.1979999999999990E+001,
      -71.99,
      -7.2000000000000014E+001,
      -7.201E+001,
      -7.2020000000000010E+001,
      -72.03,
      -7.204E+001,
      -7.2050000000000011E+001,
      -72.06,
      -7.2070000000000007E+001,
      -7.2080000000000013E+001,
      -72.09,
      -7.2100000000000009E+001,
      -72.11,
      -7.212E+001,
      -72.13,
      -72.14,
      -7.2149999999999991E+001,
      -7.2160000000000011E+001,
      -72.17,
      -7.218E+001,
      -72.19,
      -72.2,
      -7.2210000000000008E+001,
      -72.22,
      -72.23,
      -7.2240000000000009E+001,
      -72.25,
      -7.226E+001,
      -7.2270000000000010E+001,
      -72.28,
      -7.229E+001,
      -72.3,
      -7.2310000000000016E+001,
      -7.2320000000000007E+001,
      -7.2330000000000013E+001,
      -72.34,
      -7.2350000000000009E+001,
      -72.36,
      -7.237E+001,
      -72.38,
      -72.39,
      -7.24E+001,
      -72.41,
      -72.42,
      -7.243E+001,
      -72.44,
      -72.45,
      -7.2460000000000008E+001,
      -7.2470000000000013E+001,
      -72.48,
      -7.2490000000000009E+001,
      -7.2500000000000014E+001,
      -7.251E+001,
      -7.2520000000000010E+001,
      -72.53,
      -7.254E+001,
      -72.55,
      -72.56,
      -7.257E+001,
      -72.58,
      -7.2589999999999989E+001,
      -7.26E+001,
      -7.2610000000000014E+001,
      -7.262E+001,
      -7.2630000000000010E+001,
      -72.64,
      -7.265E+001,
      -7.2660000000000011E+001,
      -72.67,
      -7.268E+001,
      -7.2690000000000012E+001,
      -72.7,
      -7.2710000000000008E+001,
      -72.72,
      -72.73,
      -72.74,
      -72.75,
      -7.2759999999999991E+001,
      -7.2770000000000010E+001,
      -72.78,
      -7.279E+001,
      -72.8,
      -72.81,
      -7.2820000000000007E+001,
      -72.83,
      -72.84,
      -7.2850000000000009E+001,
      -72.86,
      -7.287E+001,
      -7.2880000000000010E+001,
      -72.89,
      -7.29E+001,
      -72.91,
      -7.2920000000000016E+001,
      -7.293E+001,
      -7.2940000000000012E+001,
      -72.95,
      -7.2960000000000008E+001,
      -72.97,
      -72.98,
      -72.99,
      -73.0,
      -7.301E+001,
      -73.02,
      -73.03,
      -7.304E+001,
      -73.05,
      -73.06,
      -7.3070000000000007E+001,
      -7.3080000000000013E+001,
      -7.3090000000000018E+001,
      -7.3100000000000009E+001,
      -7.3110000000000014E+001,
      -7.312E+001,
      -7.3130000000000010E+001,
      -73.14,
      -7.315E+001,
      -73.16,
      -73.17,
      -7.3179999999999993E+001,
      -73.19,
      -73.2,
      -7.321E+001,
      -7.3220000000000013E+001,
      -73.23,
      -7.3240000000000009E+001,
      -7.3250000000000014E+001,
      -7.326E+001,
      -7.3270000000000010E+001,
      -73.28,
      -7.329E+001,
      -7.3300000000000011E+001,
      -73.31,
      -7.3320000000000007E+001,
      -73.33,
      -73.34,
      -7.335E+001,
      -73.36,
      -7.3369999999999990E+001,
      -7.3380000000000010E+001,
      -73.39,
      -7.34E+001,
      -7.3410000000000011E+001,
      -73.42,
      -7.343E+001,
      -73.44,
      -73.45,
      -7.3460000000000008E+001,
      -73.47,
      -73.48,
      -7.3490000000000009E+001,
      -73.5,
      -7.351E+001,
      -73.52,
      -7.3530000000000015E+001,
      -7.354E+001,
      -7.3550000000000011E+001,
      -73.56,
      -7.3570000000000007E+001,
      -73.58,
      -73.59,
      -7.36E+001,
      -73.61,
      -7.362E+001,
      -73.63,
      -73.64,
      -7.365E+001,
      -73.66,
      -73.67,
      -7.3680000000000021E+001,
      -7.3690000000000012E+001,
      -7.3700000000000017E+001,
      -7.3710000000000008E+001,
      -7.3720000000000013E+001,
      -73.73,
      -7.3740000000000009E+001,
      -73.75,
      -7.376E+001,
      -73.77,
      -73.78,
      -7.3789999999999992E+001,
      -73.8,
      -73.81,
      -7.382E+001,
      -7.3830000000000013E+001,
      -73.84,
      -7.3850000000000009E+001,
      -7.3860000000000014E+001,
      -7.387E+001,
      -7.3880000000000010E+001,
      -73.89,
      -7.39E+001,
      -7.3910000000000011E+001,
      -73.92,
      -7.393E+001,
      -73.94,
      -73.95,
      -7.396E+001,
      -73.97,
      -7.3979999999999990E+001,
      -7.3990000000000009E+001,
      -74.0,
      -7.401E+001,
      -7.4020000000000010E+001,
      -74.03,
      -7.404E+001,
      -74.05,
      -74.06,
      -7.4070000000000007E+001,
      -74.08,
      -74.09,
      -7.4100000000000009E+001,
      -74.11,
      -7.412E+001,
      -74.13,
      -7.4140000000000015E+001,
      -7.415E+001,
      -7.4160000000000011E+001,
      -74.17,
      -7.418E+001,
      -74.19,
      -74.2,
      -7.421E+001,
      -74.22,
      -74.23,
      -74.24,
      -74.25,
      -7.426E+001,
      -74.27,
      -74.28,
      -7.4290000000000020E+001,
      -7.4300000000000011E+001,
      -7.4310000000000016E+001,
      -7.4320000000000007E+001,
      -7.4330000000000013E+001,
      -74.34,
      -7.4350000000000009E+001,
      -74.36,
      -7.437E+001,
      -74.38,
      -74.39,
      -7.4399999999999991E+001,
      -74.41,
      -74.42,
      -7.4429999999999993E+001,
      -7.4440000000000012E+001,
      -7.4450000000000017E+001,
      -7.4460000000000008E+001,
      -7.4470000000000013E+001,
      -74.48,
      -7.4490000000000009E+001,
      -7.4500000000000014E+001,
      -7.451E+001,
      -7.4520000000000010E+001,
      -74.53,
      -7.454E+001,
      -74.55,
      -74.56,
      -7.457E+001,
      -74.58,
      -7.4589999999999989E+001,
      -7.4600000000000009E+001,
      -7.4610000000000014E+001,
      -7.462E+001,
      -7.4630000000000010E+001,
      -74.64,
      -7.465E+001,
      -7.4660000000000011E+001,
      -74.67,
      -7.468E+001,
      -74.69,
      -74.7,
      -7.4710000000000008E+001,
      -74.72,
      -74.73,
      -74.74,
      -7.4750000000000014E+001,
      -7.476E+001,
      -7.4770000000000010E+001,
      -74.78,
      -7.479E+001,
      -74.8,
      -74.81,
      -7.4820000000000007E+001,
      -74.83,
      -74.84,
      -7.485E+001,
      -74.86,
      -7.487E+001,
      -74.88,
      -74.89,
      -7.4900000000000020E+001,
      -7.4910000000000011E+001,
      -7.4920000000000016E+001,
      -7.493E+001,
      -7.4940000000000012E+001,
      -74.95,
      -7.4960000000000008E+001,
      -74.97,
      -74.98,
      -74.99,
      -75.0,
      -7.5009999999999991E+001,
      -75.02,
      -75.03,
      -7.5039999999999992E+001,
      -7.5050000000000011E+001,
      -7.5060000000000016E+001,
      -7.5070000000000007E+001,
      -7.5080000000000013E+001,
      -75.09,
      -7.5100000000000009E+001,
      -7.5110000000000014E+001,
      -7.512E+001,
      -7.5130000000000010E+001,
      -75.14,
      -7.515E+001,
      -75.16,
      -75.17,
      -7.5179999999999993E+001,
      -75.19,
      -7.5199999999999989E+001,
      -7.5210000000000008E+001,
      -7.5220000000000013E+001,
      -75.23,
      -7.5240000000000009E+001,
      -75.25,
      -7.526E+001,
      -7.5270000000000010E+001,
      -75.28,
      -7.529E+001,
      -7.5300000000000011E+001,
      -75.31,
      -7.5320000000000007E+001,
      -75.33,
      -75.34,
      -7.535E+001,
      -7.5360000000000014E+001,
      -7.537E+001,
      -7.5380000000000010E+001,
      -75.39,
      -7.54E+001,
      -75.41,
      -75.42,
      -7.543E+001,
      -75.44,
      -75.45,
      -7.546E+001,
      -75.47,
      -75.48,
      -75.49,
      -75.5,
      -7.5510000000000019E+001,
      -7.5520000000000010E+001,
      -7.5530000000000015E+001,
      -7.554E+001,
      -7.5550000000000011E+001,
      -75.56,
      -7.5570000000000007E+001,
      -75.58,
      -75.59,
      -7.56E+001,
      -75.61,
      -7.5619999999999990E+001,
      -75.63,
      -75.64,
      -7.5649999999999991E+001,
      -7.5660000000000011E+001,
      -7.5670000000000016E+001,
      -7.568E+001,
      -7.5690000000000012E+001,
      -7.5700000000000017E+001,
      -7.5710000000000008E+001,
      -7.5720000000000013E+001,
      -75.73,
      -7.5740000000000009E+001,
      -75.75,
      -7.576E+001,
      -75.77,
      -75.78,
      -7.5789999999999992E+001,
      -75.8,
      -7.5809999999999988E+001,
      -7.5820000000000007E+001,
      -7.5830000000000013E+001,
      -75.84,
      -7.5850000000000009E+001,
      -7.5860000000000014E+001,
      -7.587E+001,
      -7.5880000000000010E+001,
      -75.89,
      -7.59E+001,
      -7.5910000000000011E+001,
      -75.92,
      -7.593E+001,
      -75.94,
      -75.95,
      -7.596E+001,
      -7.5970000000000013E+001,
      -75.98,
      -7.5990000000000009E+001,
      -76.0,
      -7.601E+001,
      -76.02,
      -76.03,
      -7.604E+001,
      -76.05,
      -76.06,
      -7.6070000000000007E+001,
      -76.08,
      -76.09,
      -7.61E+001,
      -76.11,
      -7.6120000000000019E+001,
      -7.6130000000000010E+001,
      -7.6140000000000015E+001,
      -7.615E+001,
      -7.6160000000000011E+001,
      -76.17,
      -7.618E+001,
      -76.19,
      -76.2,
      -7.621E+001,
      -76.22,
      -76.23,
      -76.24,
      -76.25,
      -7.6259999999999991E+001,
      -7.6270000000000010E+001,
      -7.6280000000000015E+001,
      -7.629E+001,
      -7.6300000000000011E+001,
      -7.6310000000000016E+001,
      -7.6320000000000007E+001,
      -7.6330000000000013E+001,
      -76.34,
      -7.6350000000000009E+001,
      -76.36,
      -7.637E+001,
      -76.38,
      -76.39,
      -7.6399999999999991E+001,
      -76.41,
      -7.6419999999999987E+001,
      -7.643E+001,
      -7.6440000000000012E+001,
      -76.45,
      -7.6460000000000008E+001,
      -7.6470000000000013E+001,
      -76.48,
      -7.6490000000000009E+001,
      -76.5,
      -7.651E+001,
      -7.6520000000000010E+001,
      -76.53,
      -7.654E+001,
      -76.55,
      -76.56,
      -7.657E+001,
      -7.6580000000000013E+001,
      -76.59,
      -7.6600000000000009E+001,
      -76.61,
      -7.662E+001,
      -7.6630000000000010E+001,
      -76.64,
      -7.665E+001,
      -76.66,
      -76.67,
      -7.668E+001,
      -76.69,
      -76.7,
      -7.671E+001,
      -76.72,
      -7.6730000000000018E+001,
      -7.6740000000000009E+001,
      -7.6750000000000014E+001,
      -7.676E+001,
      -7.6770000000000010E+001,
      -76.78,
      -7.679E+001,
      -76.8,
      -76.81,
      -7.682E+001,
      -76.83,
      -76.84,
      -7.685E+001,
      -76.86,
      -7.6869999999999990E+001,
      -7.6880000000000010E+001,
      -7.6890000000000015E+001,
      -7.69E+001,
      -7.6910000000000011E+001,
      -7.6920000000000016E+001,
      -7.693E+001,
      -7.6940000000000012E+001,
      -76.95,
      -7.6960000000000008E+001,
      -76.97,
      -76.98,
      -76.99,
      -77.0,
      -7.7009999999999991E+001,
      -77.02,
      -7.7029999999999987E+001,
      -7.704E+001,
      -7.7050000000000011E+001,
      -77.06,
      -7.7070000000000007E+001,
      -7.7080000000000013E+001,
      -77.09,
      -7.7100000000000009E+001,
      -77.11,
      -7.712E+001,
      -7.7130000000000010E+001,
      -77.14,
      -7.715E+001,
      -77.16,
      -77.17,
      -7.7179999999999993E+001,
      -7.7190000000000012E+001,
      -77.2,
      -7.7210000000000008E+001,
      -77.22,
      -77.23,
      -7.7240000000000009E+001,
      -77.25,
      -7.726E+001,
      -77.27,
      -77.28,
      -7.729E+001,
      -77.3,
      -77.31,
      -7.7320000000000007E+001,
      -77.33,
      -7.7340000000000018E+001,
      -7.7350000000000009E+001,
      -7.7360000000000014E+001,
      -7.737E+001,
      -7.7380000000000010E+001,
      -77.39,
      -7.74E+001,
      -77.41,
      -77.42,
      -7.7429999999999993E+001,
      -77.44,
      -77.45,
      -7.746E+001,
      -77.47,
      -77.48,
      -7.7490000000000009E+001,
      -7.7500000000000014E+001,
      -7.751E+001,
      -7.7520000000000010E+001,
      -7.7530000000000015E+001,
      -7.754E+001,
      -7.7550000000000011E+001,
      -77.56,
      -7.7570000000000007E+001,
      -77.58,
      -77.59,
      -7.76E+001,
      -77.61,
      -7.7619999999999990E+001,
      -77.63,
      -7.7640000000000015E+001,
      -7.765E+001,
      -7.7660000000000011E+001,
      -77.67,
      -7.768E+001,
      -7.7690000000000012E+001,
      -77.7,
      -7.7710000000000008E+001,
      -7.7720000000000013E+001,
      -77.73,
      -7.7740000000000009E+001,
      -77.75,
      -7.776E+001,
      -77.77,
      -77.78,
      -7.7789999999999992E+001,
      -7.7800000000000011E+001,
      -77.81,
      -7.7820000000000007E+001,
      -77.83,
      -77.84,
      -7.7850000000000009E+001,
      -77.86,
      -7.787E+001,
      -7.7880000000000010E+001,
      -77.89,
      -7.79E+001,
      -77.91,
      -77.92,
      -7.793E+001,
      -77.94,
      -7.7950000000000017E+001,
      -7.7960000000000008E+001,
      -7.7970000000000013E+001,
      -77.98,
      -7.7990000000000009E+001,
      -78.0,
      -7.801E+001,
      -78.02,
      -78.03,
      -7.804E+001,
      -78.05,
      -78.06,
      -7.807E+001,
      -78.08,
      -78.09,
      -7.8100000000000009E+001,
      -7.8110000000000014E+001,
      -7.812E+001,
      -7.8130000000000010E+001,
      -7.8140000000000015E+001,
      -7.815E+001,
      -7.8160000000000011E+001,
      -78.17,
      -7.818E+001,
      -78.19,
      -78.2,
      -7.821E+001,
      -78.22,
      -7.8229999999999990E+001,
      -78.24,
      -7.8250000000000014E+001,
      -7.826E+001,
      -7.8270000000000010E+001,
      -78.28,
      -7.829E+001,
      -7.8300000000000011E+001,
      -78.31,
      -7.8320000000000007E+001,
      -7.8330000000000013E+001,
      -78.34,
      -7.8350000000000009E+001,
      -78.36,
      -7.837E+001,
      -78.38,
      -78.39,
      -7.8399999999999991E+001,
      -7.8410000000000011E+001,
      -78.42,
      -7.843E+001,
      -78.44,
      -78.45,
      -7.8460000000000008E+001,
      -78.47,
      -78.48,
      -7.8490000000000009E+001,
      -78.5,
      -7.851E+001,
      -78.52,
      -78.53,
      -7.854E+001,
      -78.55,
      -7.8560000000000016E+001,
      -7.8570000000000007E+001,
      -7.8580000000000013E+001,
      -78.59,
      -7.8600000000000009E+001,
      -78.61,
      -7.862E+001,
      -78.63,
      -78.64,
      -7.865E+001,
      -78.66,
      -78.67,
      -7.8679999999999993E+001,
      -78.69,
      -78.7,
      -7.8710000000000008E+001,
      -7.8720000000000013E+001,
      -7.8730000000000018E+001,
      -7.8740000000000009E+001,
      -7.8750000000000014E+001,
      -7.876E+001,
      -7.8770000000000010E+001,
      -78.78,
      -7.879E+001,
      -78.8,
      -78.81,
      -7.882E+001,
      -78.83,
      -7.8839999999999989E+001,
      -7.885E+001,
      -7.8860000000000014E+001,
      -7.887E+001,
      -7.8880000000000010E+001,
      -7.8890000000000015E+001,
      -7.89E+001,
      -7.8910000000000011E+001,
      -78.92,
      -7.893E+001,
      -7.8940000000000012E+001,
      -78.95,
      -7.8960000000000008E+001,
      -78.97,
      -78.98,
      -78.99,
      -79.0,
      -7.9009999999999991E+001,
      -7.9020000000000010E+001,
      -79.03,
      -7.904E+001,
      -7.9050000000000011E+001,
      -79.06,
      -7.9070000000000007E+001,
      -79.08,
      -79.09,
      -7.9100000000000009E+001,
      -79.11,
      -7.912E+001,
      -7.9130000000000010E+001,
      -79.14,
      -7.915E+001,
      -79.16,
      -7.9170000000000016E+001,
      -7.918E+001,
      -7.9190000000000012E+001,
      -79.2,
      -7.9210000000000008E+001,
      -79.22,
      -79.23,
      -79.24,
      -79.25,
      -7.926E+001,
      -79.27,
      -79.28,
      -7.929E+001,
      -79.3,
      -79.31,
      -7.9320000000000007E+001,
      -7.9330000000000013E+001,
      -7.9340000000000018E+001,
      -7.9350000000000009E+001,
      -7.9360000000000014E+001,
      -7.937E+001,
      -7.9380000000000010E+001,
      -79.39,
      -7.94E+001,
      -79.41,
      -79.42,
      -7.9429999999999993E+001,
      -79.44,
      -79.45,
      -7.946E+001,
      -7.9470000000000013E+001,
      -79.48,
      -7.9490000000000009E+001,
      -7.9500000000000014E+001,
      -79.50995,
      -79.5198,
      -7.9529550000000015E+001,
      -7.9539200000000008E+001,
      -7.9548750000000013E+001,
      -79.5582,
      -7.9567550000000011E+001,
      -7.9576800000000020E+001,
      -7.9585950000000011E+001,
      -7.9595000000000013E+001,
      -79.60395,
      -7.9612800000000007E+001,
      -7.9621550000000013E+001,
      -7.9630200000000016E+001,
      -7.9638750000000016E+001,
      -7.9647200000000012E+001,
      -7.965555E+001,
      -7.9663800000000009E+001,
      -7.9671950000000010E+001,
      -7.968E+001,
      -79.68795,
      -7.96958E+001,
      -7.970355E+001,
      -7.9711200000000019E+001,
      -79.71875,
      -7.97262E+001,
      -7.9733550000000008E+001,
      -7.9740800000000007E+001,
      -7.9747950000000017E+001,
      -7.9755000000000010E+001,
      -7.9761950000000013E+001,
      -7.9768800000000013E+001,
      -7.9775550000000010E+001,
      -79.7822,
      -7.9788750000000007E+001,
      -7.9795200000000023E+001,
      -7.9801550000000020E+001,
      -7.9807800000000015E+001,
      -7.9813950000000020E+001,
      -7.9820000000000007E+001,
      -7.982595E+001,
      -7.9831800000000015E+001,
      -7.9837550000000022E+001,
      -7.9843200000000010E+001,
      -7.9848750000000010E+001,
      -7.98542E+001,
      -7.9859550000000013E+001,
      -79.8648,
      -7.9869950000000017E+001,
      -7.9875000000000014E+001,
      -7.9879950000000008E+001,
      -7.9884800000000013E+001,
      -7.9889550000000014E+001,
      -7.9894200000000012E+001,
      -7.989875E+001,
      -7.9903200000000012E+001,
      -7.9907550000000015E+001,
      -7.9911800000000014E+001,
      -7.9915950000000009E+001,
      -79.92,
      -7.9923950000000019E+001,
      -7.99278E+001,
      -7.9931550000000016E+001,
      -7.9935200000000023E+001,
      -7.9938750000000013E+001,
      -7.9942200000000014E+001,
      -7.9945550000000011E+001,
      -7.99488E+001,
      -7.9951950000000011E+001,
      -7.9955000000000013E+001,
      -7.9957950000000011E+001,
      -7.99608E+001,
      -7.9963550000000012E+001,
      -7.9966200000000015E+001,
      -7.9968750000000014E+001,
      -7.9971200000000010E+001,
      -79.97355,
      -7.99758E+001,
      -7.997795E+001,
      -7.9980000000000018E+001,
      -7.9981950000000012E+001,
      -7.9983800000000016E+001,
      -79.98555,
      -7.9987200000000016E+001,
      -7.9988750000000010E+001,
      -79.9902,
      -7.9991550000000018E+001,
      -7.9992800000000017E+001,
      -7.9993950000000012E+001,
      -7.9995E+001,
      -7.9995950000000008E+001,
      -7.9996800000000007E+001,
      -7.9997550000000018E+001,
      -7.9998200000000011E+001,
      -7.9998750000000015E+001,
      -79.9992,
      -7.9999550000000013E+001,
      -7.9999800000000022E+001,
      -7.9999950000000013E+001,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -7.9999894724566062E+001,
      -7.9999578902420353E+001,
      -7.9999052546030967E+001,
      -7.9998315676177597E+001,
      -7.9997368321950560E+001,
      -7.9996210520749798E+001,
      -7.9994842318283318E+001,
      -7.9993263768565413E+001,
      -7.9991474933914517E+001,
      -7.9989475884950778E+001,
      -7.9987266700593196E+001,
      -7.9984847468056600E+001,
      -7.9982218282848152E+001,
      -7.9979379248763578E+001,
      -7.9976330477883096E+001,
      -7.9973072090566930E+001,
      -7.9969604215450659E+001,
      -7.9965926989440050E+001,
      -7.9962040557705677E+001,
      -7.9957945073677209E+001,
      -7.9953640699037365E+001,
      -7.9949127603715468E+001,
      -7.9944405965880790E+001,
      -7.9939475971935536E+001,
      -7.9934337816507394E+001,
      -7.9928991702441962E+001,
      -7.9923437840794662E+001,
      -7.9917676450822427E+001,
      -7.9911707759975087E+001,
      -7.9905532003886336E+001,
      -7.9899149426364446E+001,
      -7.9892560279382636E+001,
      -7.9885764823069181E+001,
      -7.9878763325697022E+001,
      -7.9871556063673310E+001,
      -7.9864143321528402E+001,
      -7.9856525391904668E+001,
      -7.9848702575544920E+001,
      -7.9840675181280560E+001,
      -7.9832443526019361E+001,
      -7.9824007934732975E+001,
      -7.9815368740444114E+001,
      -7.9806526284213376E+001,
      -7.9797480915125789E+001,
      -7.9788232990277024E+001,
      -7.9778782874759330E+001,
      -7.9769130941647092E+001,
      -7.9759277571982082E+001,
      -7.9749223154758496E+001,
      -7.9738968086907477E+001,
      -7.9728512773281565E+001,
      -7.9717857626638633E+001,
      -7.9707003067625621E+001,
      -7.9695949524761943E+001,
      -7.9684697434422532E+001,
      -7.9673247240820672E+001,
      -7.9661599395990351E+001,
      -7.9649754359768593E+001,
      -7.9637712599777117E+001,
      -7.9625474591404000E+001,
      -7.9613040817784849E+001,
      -7.9600411769783761E+001,
      -7.9587587945973937E+001,
      -7.9574569852617969E+001,
      -7.9561358003647896E+001,
      -7.9547952920644889E+001,
      -7.9534355132818675E+001,
      -7.9520565176986636E+001,
      -7.9506583597552620E+001,
      -7.9492410946485435E+001,
      -7.9478047783297086E+001,
      -7.9463494675020641E+001,
      -7.9448752196187925E+001,
      -7.9433820928806739E+001,
      -7.9418701462337950E+001,
      -7.9403394393672230E+001,
      -7.9387900327106422E+001,
      -7.9372219874319740E+001,
      -7.9356353654349633E+001,
      -7.9340302293567277E+001,
      -7.9324066425652902E+001,
      -7.9307646691570795E+001,
      -7.9291043739543952E+001,
      -7.9274258225028447E+001,
      -7.9257290810687692E+001,
      -7.9240142166366141E+001,
      -7.9222812969062915E+001,
      -7.9205303902905015E+001,
      -7.9187615659120439E+001,
      -7.9169748936010734E+001,
      -7.9151704438923574E+001,
      -7.9133482880224761E+001,
      -7.9115084979270250E+001,
      -7.9096511462377663E+001,
      -7.9077763062797658E+001,
      -7.9058840520684939E+001,
      -7.9039744583069080E+001,
      -7.9020476003824982E+001,
      -7.9001035543643169E+001,
      -7.8981423969999710E+001,
      -7.8961642057125985E+001,
      -7.8941690585978009E+001,
      -7.8921570344205705E+001,
      -7.8901282126121771E+001,
      -7.8880826732670343E+001,
      -7.8860204971395305E+001,
      -7.8839417656408472E+001,
      -7.8818465608357457E+001,
      -7.8797349654393244E+001,
      -7.8776070628137532E+001,
      -7.8754629369649862E+001,
      -7.8733026725394396E+001,
      -7.8711263548206517E+001,
      -7.8689340697259212E+001,
      -7.8667259038029115E+001,
      -7.8645019442262296E+001,
      -7.8622622787939932E+001,
      -7.8600069959243584E+001,
      -7.8577361846520319E+001,
      -7.8554499346247525E+001,
      -7.8531483360997584E+001,
      -7.8508314799402172E+001,
      -7.8484994576116435E+001,
      -7.8461523611782852E+001,
      -7.8437902832994922E+001,
      -7.8414133172260520E+001,
      -7.8390215567965186E+001,
      -7.8366150964334963E+001,
      -7.8341940311399185E+001,
      -7.8317584564953009E+001,
      -7.8293084686519563E+001,
      -7.8268441643312116E+001,
      -7.8243656408195832E+001,
      -7.8218729959649338E+001,
      -7.8193663281726145E+001,
      -7.8168457364015765E+001,
      -7.8143113201604692E+001,
      -7.8117631795037042E+001,
      -7.8092014150275105E+001,
      -7.8066261278659667E+001,
      -7.8040374196869990E+001,
      -7.8014353926883729E+001,
      -7.7988201495936593E+001,
      -7.7961917936481782E+001,
      -7.7935504286149197E+001,
      -7.7908961587704567E+001,
      -7.7882290889008132E+001,
      -7.7855493242973424E+001,
      -7.7828569707525645E+001,
      -7.7801521345559848E+001,
      -7.7774349224899069E+001,
      -7.7747054418252091E+001,
      -7.7719638003171141E+001,
      -7.7692101062009357E+001,
      -7.7664444681878024E+001,
      -7.7636669954603676E+001,
      -7.7608777976684962E+001,
      -7.7580769849249435E+001,
      -7.7552646678009992E+001,
      -7.7524409573221305E+001,
      -7.7496059649635910E+001,
      -7.7467598026460237E+001,
      -7.7439025827310445E+001,
      -7.7410344180168039E+001,
      -7.7381554217335307E+001,
      -7.7352657075390724E+001,
      -7.7323653895143948E+001,
      -7.7294545821590873E+001,
      -7.7265334003868432E+001,
      -7.7236019595209143E+001,
      -7.7206603752895674E+001,
      -7.7177087638215099E+001,
      -7.7147472416413109E+001,
      -7.7117759256647929E+001,
      -7.7087949331944245E+001,
      -7.7058043819146832E+001,
      -7.7028043898874131E+001,
      -7.6997950755471635E+001,
      -7.6967765576965107E+001,
      -7.6937489555013713E+001,
      -7.6907123884862969E+001,
      -7.6876669765297507E+001,
      -7.6846128398593862E+001,
      -7.6815500990472856E+001,
      -7.6784788750052158E+001,
      -7.6753992889798411E+001,
      -7.6723114625479440E+001,
      -7.6692155176116273E+001,
      -7.6661115763934930E+001,
      -7.6629997614318285E+001,
      -7.6598801955757565E+001,
      -7.6567530019803996E+001,
      -7.6536183041020038E+001,
      -7.6504762256930761E+001,
      -7.6473268907974884E+001,
      -7.6441704237455923E+001,
      -7.6410069491493019E+001,
      -7.6378365918971781E+001,
      -7.6346594771494964E+001,
      -7.6314757303333053E+001,
      -7.6282854771374787E+001,
      -7.6250888435077513E+001,
      -7.6218859556417442E+001,
      -7.6186769399839875E+001,
      -7.6154619232209228E+001,
      -7.6122410322759052E+001,
      -7.6090143943041994E+001,
      -7.6057821366879438E+001,
      -7.6025443870311364E+001,
      -7.5993012731545889E+001,
      -7.5960529230908833E+001,
      -7.5927994650793195E+001,
      -7.5895410275608484E+001,
      -7.5862777391730035E+001,
      -7.5830097287448226E+001,
      -7.5797371252917628E+001,
      -7.5764600580106020E+001,
      -7.5731786562743494E+001,
      -7.5698930496271245E+001,
      -7.5666033677790523E+001,
      -7.5633097406011402E+001,
      -7.5600122981201466E+001,
      -7.5567111705134579E+001,
      -7.5534064881039384E+001,
      -7.5500983813547890E+001,
      -7.5467869808644025E+001,
      -7.5434724173612011E+001,
      -7.5401548216984736E+001,
      -7.5368343248492167E+001,
      -7.5335110579009609E+001,
      -7.5301851520505963E+001,
      -7.5268567385991901E+001,
      -7.5235259489468049E+001,
      -7.5201929145873152E+001,
      -7.5168577671032068E+001,
      -7.5135206381603950E+001,
      -7.5101816595030172E+001,
      -7.5068409629482304E+001,
      -7.5034986803810170E+001,
      -7.5001549437489658E+001,
      -7.4968098850570797E+001,
      -7.4934636363625444E+001,
      -7.4901163297695263E+001,
      -7.4867680974239647E+001,
      -7.4834190715083352E+001,
      -7.4800693842364467E+001,
      -7.4767191678482163E+001,
      -7.4733685546044541E+001,
      -7.4700176767816316E+001,
      -7.4666666666666657E+001,
      -7.4633156565517027E+001,
      -7.4599647787288788E+001,
      -7.4566141654851151E+001,
      -7.4532639490968862E+001,
      -7.4499142618249977E+001,
      -7.4465652359093667E+001,
      -7.4432170035638052E+001,
      -7.4398696969707885E+001,
      -7.4365234482762531E+001,
      -7.4331783895843657E+001,
      -7.4298346529523158E+001,
      -7.4264923703851025E+001,
      -7.4231516738303156E+001,
      -7.4198126951729364E+001,
      -7.4164755662301260E+001,
      -7.4131404187460177E+001,
      -7.4098073843865279E+001,
      -7.4064765947341428E+001,
      -7.4031481812827366E+001,
      -7.3998222754323706E+001,
      -7.3964990084841162E+001,
      -7.3931785116348593E+001,
      -7.3898609159721317E+001,
      -7.3865463524689289E+001,
      -7.3832349519785424E+001,
      -7.3799268452293944E+001,
      -7.3766221628198736E+001,
      -7.3733210352131849E+001,
      -7.3700235927321927E+001,
      -7.3667299655542791E+001,
      -7.3634402837062069E+001,
      -7.3601546770589820E+001,
      -7.3568732753227280E+001,
      -7.3535962080415700E+001,
      -7.3503236045885103E+001,
      -7.3470555941603308E+001,
      -7.3437923057724845E+001,
      -7.3405338682540133E+001,
      -7.3372804102424496E+001,
      -7.3340320601787440E+001,
      -7.3307889463021965E+001,
      -7.3275511966453877E+001,
      -7.3243189390291320E+001,
      -7.3210923010574263E+001,
      -7.3178714101124115E+001,
      -7.3146563933493454E+001,
      -7.3114473776915887E+001,
      -7.3082444898255815E+001,
      -7.3050478561958542E+001,
      -7.3018576030000276E+001,
      -7.2986738561838365E+001,
      -7.2954967414361548E+001,
      -7.2923263841840296E+001,
      -7.2891629095877406E+001,
      -7.2860064425358445E+001,
      -7.2828571076402568E+001,
      -7.2797150292313276E+001,
      -7.2765803313529332E+001,
      -7.2734531377575749E+001,
      -7.2703335719015044E+001,
      -7.2672217569398398E+001,
      -7.2641178157217055E+001,
      -7.2610218707853875E+001,
      -7.2579340443534917E+001,
      -7.2548544583281171E+001,
      -7.2517832342860459E+001,
      -7.2487204934739466E+001,
      -7.2456663568035808E+001,
      -7.2426209448470360E+001,
      -7.2395843778319602E+001,
      -7.2365567756368222E+001,
      -7.2335382577861679E+001,
      -7.2305289434459198E+001,
      -7.2275289514186497E+001,
      -7.2245384001389084E+001,
      -7.2215574076685400E+001,
      -7.2185860916920220E+001,
      -7.2156245695118216E+001,
      -7.2126729580437654E+001,
      -7.2097313738124186E+001,
      -7.2067999329464882E+001,
      -7.2038787511742441E+001,
      -7.2009679438189380E+001,
      -7.1980676257942605E+001,
      -7.1951779115998008E+001,
      -7.1922989153165290E+001,
      -7.1894307506022869E+001,
      -7.1865735306873091E+001,
      -7.1837273683697418E+001,
      -7.1808923760112009E+001,
      -7.1780686655323322E+001,
      -7.1752563484083893E+001,
      -7.1724555356648366E+001,
      -7.1696663378729667E+001,
      -7.1668888651455305E+001,
      -7.1641232271323958E+001,
      -7.1613695330162173E+001,
      -7.1586278915081223E+001,
      -7.1558984108434259E+001,
      -7.1531811987773480E+001,
      -7.1504763625807684E+001,
      -7.1477840090359905E+001,
      -7.1451042444325196E+001,
      -7.1424371745628761E+001,
      -7.1397829047184132E+001,
      -7.1371415396851546E+001,
      -7.1345131837396721E+001,
      -7.1318979406449600E+001,
      -7.1292959136463338E+001,
      -7.1267072054673648E+001,
      -7.1241319183058209E+001,
      -7.1215701538296287E+001,
      -7.1190220131728637E+001,
      -7.1164875969317563E+001,
      -7.1139670051607183E+001,
      -7.1114603373683991E+001,
      -7.1089676925137496E+001,
      -7.1064891690021199E+001,
      -7.1040248646813751E+001,
      -7.1015748768380320E+001,
      -7.0991393021934144E+001,
      -7.0967182368998365E+001,
      -7.0943117765368129E+001,
      -7.0919200161072794E+001,
      -7.0895430500338406E+001,
      -7.0871809721550477E+001,
      -7.0848338757216894E+001,
      -7.0825018533931157E+001,
      -7.0801849972335745E+001,
      -7.0778833987085804E+001,
      -7.0755971486812996E+001,
      -7.0733263374089731E+001,
      -7.0710710545393397E+001,
      -7.0688313891071033E+001,
      -7.0666074295304213E+001,
      -7.0643992636074103E+001,
      -7.0622069785126811E+001,
      -7.0600306607938933E+001,
      -7.0578703963683466E+001,
      -7.0557262705195782E+001,
      -7.0535983678940084E+001,
      -7.0514867724975872E+001,
      -7.0493915676924857E+001,
      -7.0473128361938024E+001,
      -7.0452506600662986E+001,
      -7.0432051207211543E+001,
      -7.0411762989127610E+001,
      -7.0391642747355320E+001,
      -7.0371691276207343E+001,
      -7.0351909363333604E+001,
      -7.0332297789690159E+001,
      -7.0312857329508347E+001,
      -7.0293588750264249E+001,
      -7.0274492812648390E+001,
      -7.0255570270535671E+001,
      -7.0236821870955666E+001,
      -7.0218248354063078E+001,
      -7.0199850453108567E+001,
      -7.0181628894409755E+001,
      -7.0163584397322580E+001,
      -7.0145717674212875E+001,
      -7.0128029430428299E+001,
      -7.0110520364270414E+001,
      -7.0093191166967188E+001,
      -7.0076042522645622E+001,
      -7.0059075108304867E+001,
      -7.0042289593789377E+001,
      -7.0025686641762519E+001,
      -7.0009266907680427E+001,
      -6.9993031039766066E+001,
      -6.9976979678983696E+001,
      -6.9961113459013575E+001,
      -6.9945433006226907E+001,
      -6.9929938939661085E+001,
      -6.9914631870995365E+001,
      -6.9899512404526575E+001,
      -6.9884581137145403E+001,
      -6.9869838658312688E+001,
      -6.9855285550036243E+001,
      -6.9840922386847893E+001,
      -6.9826749735780709E+001,
      -6.9812768156346678E+001,
      -6.9798978200514654E+001,
      -6.9785380412688440E+001,
      -6.9771975329685432E+001,
      -6.9758763480715345E+001,
      -6.9745745387359378E+001,
      -6.9732921563549553E+001,
      -6.9720292515548465E+001,
      -6.9707858741929329E+001,
      -6.9695620733556211E+001,
      -6.9683578973564735E+001,
      -6.9671733937342978E+001,
      -6.9660086092512657E+001,
      -6.9648635898910797E+001,
      -6.9637383808571386E+001,
      -6.9626330265707693E+001,
      -6.9615475706694681E+001,
      -6.9604820560051763E+001,
      -6.9594365246425838E+001,
      -6.9584110178574832E+001,
      -6.9574055761351232E+001,
      -6.9564202391686237E+001,
      -6.9554550458573999E+001,
      -6.9545100343056291E+001,
      -6.9535852418207540E+001,
      -6.9526807049119938E+001,
      -6.9517964592889200E+001,
      -6.9509325398600353E+001,
      -6.9500889807313968E+001,
      -6.9492658152052755E+001,
      -6.9484630757788395E+001,
      -6.9476807941428660E+001,
      -6.9469190011804912E+001,
      -6.9461777269660004E+001,
      -6.9454570007636306E+001,
      -6.9447568510264148E+001,
      -6.9440773053950679E+001,
      -6.9434183906968883E+001,
      -6.9427801329446993E+001,
      -6.9421625573358241E+001,
      -6.9415656882510902E+001,
      -6.9409895492538666E+001,
      -6.9404341630891366E+001,
      -6.9398995516825920E+001,
      -6.9393857361397778E+001,
      -6.9388927367452524E+001,
      -6.9384205729617861E+001,
      -6.9379692634295949E+001,
      -6.9375388259656106E+001,
      -6.9371292775627651E+001,
      -6.9367406343893279E+001,
      -6.9363729117882670E+001,
      -6.9360261242766398E+001,
      -6.9357002855450233E+001,
      -6.9353954084569750E+001,
      -6.9351115050485177E+001,
      -6.9348485865276714E+001,
      -6.9346066632740119E+001,
      -6.9343857448382536E+001,
      -6.9341858399418797E+001,
      -6.9340069564767902E+001,
      -6.9338491015049996E+001,
      -6.9337122812583530E+001,
      -6.9335965011382754E+001,
      -6.9335017657155717E+001,
      -6.9334280787302347E+001,
      -6.9333754430912975E+001,
      -6.9333438608767267E+001,
      -6.9333333333333329E+001,
      -6.9333438608767267E+001,
      -6.9333754430912975E+001,
      -6.9334280787302347E+001,
      -6.9335017657155717E+001,
      -6.9335965011382754E+001,
      -6.9337122812583530E+001,
      -6.9338491015049996E+001,
      -6.9340069564767902E+001,
      -6.9341858399418797E+001,
      -6.9343857448382536E+001,
      -6.9346066632740119E+001,
      -6.9348485865276714E+001,
      -6.9351115050485177E+001,
      -6.9353954084569750E+001,
      -6.9357002855450233E+001,
      -6.9360261242766398E+001,
      -6.9363729117882670E+001,
      -6.9367406343893279E+001,
      -6.9371292775627651E+001,
      -6.9375388259656106E+001,
      -6.9379692634295949E+001,
      -6.9384205729617861E+001,
      -6.9388927367452524E+001,
      -6.9393857361397778E+001,
      -6.9398995516825920E+001,
      -6.9404341630891366E+001,
      -6.9409895492538666E+001,
      -6.9415656882510902E+001,
      -6.9421625573358241E+001,
      -6.9427801329446993E+001,
      -6.9434183906968883E+001,
      -6.9440773053950679E+001,
      -6.9447568510264148E+001,
      -6.9454570007636306E+001,
      -6.9461777269660004E+001,
      -6.9469190011804912E+001,
      -6.9476807941428660E+001,
      -6.9484630757788395E+001,
      -6.9492658152052755E+001,
      -6.9500889807313968E+001,
      -6.9509325398600353E+001,
      -6.9517964592889200E+001,
      -6.9526807049119938E+001,
      -6.9535852418207540E+001,
      -6.9545100343056291E+001,
      -6.9554550458573985E+001,
      -6.9564202391686237E+001,
      -6.9574055761351232E+001,
      -6.9584110178574832E+001,
      -6.9594365246425838E+001,
      -6.9604820560051763E+001,
      -6.9615475706694681E+001,
      -6.9626330265707693E+001,
      -6.9637383808571386E+001,
      -6.9648635898910797E+001,
      -6.9660086092512671E+001,
      -6.9671733937342978E+001,
      -6.9683578973564735E+001,
      -6.9695620733556211E+001,
      -6.9707858741929329E+001,
      -6.9720292515548465E+001,
      -6.9732921563549553E+001,
      -6.9745745387359378E+001,
      -6.9758763480715345E+001,
      -6.9771975329685432E+001,
      -6.9785380412688440E+001,
      -6.9798978200514654E+001,
      -6.9812768156346678E+001,
      -6.9826749735780709E+001,
      -6.9840922386847893E+001,
      -6.9855285550036243E+001,
      -6.9869838658312688E+001,
      -6.9884581137145403E+001,
      -6.9899512404526575E+001,
      -6.9914631870995365E+001,
      -6.9929938939661085E+001,
      -6.9945433006226907E+001,
      -6.9961113459013575E+001,
      -6.9976979678983696E+001,
      -6.9993031039766052E+001,
      -7.0009266907680427E+001,
      -7.0025686641762519E+001,
      -7.0042289593789377E+001,
      -7.0059075108304867E+001,
      -7.0076042522645622E+001,
      -7.0093191166967188E+001,
      -7.0110520364270414E+001,
      -7.0128029430428299E+001,
      -7.0145717674212875E+001,
      -7.0163584397322580E+001,
      -7.0181628894409755E+001,
      -7.0199850453108567E+001,
      -7.0218248354063078E+001,
      -7.0236821870955666E+001,
      -7.0255570270535671E+001,
      -7.0274492812648390E+001,
      -7.0293588750264249E+001,
      -7.0312857329508347E+001,
      -7.0332297789690159E+001,
      -7.0351909363333604E+001,
      -7.0371691276207343E+001,
      -7.0391642747355320E+001,
      -7.0411762989127610E+001,
      -7.0432051207211543E+001,
      -7.0452506600662986E+001,
      -7.0473128361938024E+001,
      -7.0493915676924857E+001,
      -7.0514867724975872E+001,
      -7.0535983678940084E+001,
      -7.0557262705195782E+001,
      -7.0578703963683466E+001,
      -7.0600306607938933E+001,
      -7.0622069785126811E+001,
      -7.0643992636074103E+001,
      -7.0666074295304213E+001,
      -7.0688313891071033E+001,
      -7.0710710545393397E+001,
      -7.0733263374089731E+001,
      -7.0755971486812996E+001,
      -7.0778833987085804E+001,
      -7.0801849972335745E+001,
      -7.0825018533931157E+001,
      -7.0848338757216894E+001,
      -7.0871809721550477E+001,
      -7.0895430500338406E+001,
      -7.0919200161072794E+001,
      -7.0943117765368129E+001,
      -7.0967182368998365E+001,
      -7.0991393021934144E+001,
      -7.1015748768380320E+001,
      -7.1040248646813751E+001,
      -7.1064891690021199E+001,
      -7.1089676925137496E+001,
      -7.1114603373683991E+001,
      -7.1139670051607183E+001,
      -7.1164875969317563E+001,
      -7.1190220131728637E+001,
      -7.1215701538296287E+001,
      -7.1241319183058209E+001,
      -7.1267072054673648E+001,
      -7.1292959136463338E+001,
      -7.1318979406449600E+001,
      -7.1345131837396721E+001,
      -7.1371415396851546E+001,
      -7.1397829047184132E+001,
      -7.1424371745628761E+001,
      -7.1451042444325196E+001,
      -7.1477840090359891E+001,
      -7.1504763625807684E+001,
      -7.1531811987773466E+001,
      -7.1558984108434259E+001,
      -7.1586278915081223E+001,
      -7.1613695330162173E+001,
      -7.1641232271323958E+001,
      -7.1668888651455291E+001,
      -7.1696663378729667E+001,
      -7.1724555356648366E+001,
      -7.1752563484083893E+001,
      -7.1780686655323322E+001,
      -7.1808923760112009E+001,
      -7.1837273683697418E+001,
      -7.1865735306873091E+001,
      -7.1894307506022869E+001,
      -7.1922989153165290E+001,
      -7.1951779115998008E+001,
      -7.1980676257942605E+001,
      -7.2009679438189380E+001,
      -7.2038787511742441E+001,
      -7.2067999329464882E+001,
      -7.2097313738124186E+001,
      -7.2126729580437654E+001,
      -7.2156245695118230E+001,
      -7.2185860916920220E+001,
      -7.2215574076685400E+001,
      -7.2245384001389070E+001,
      -7.2275289514186497E+001,
      -7.2305289434459198E+001,
      -7.2335382577861679E+001,
      -7.2365567756368222E+001,
      -7.2395843778319602E+001,
      -7.2426209448470360E+001,
      -7.2456663568035808E+001,
      -7.2487204934739481E+001,
      -7.2517832342860459E+001,
      -7.2548544583281171E+001,
      -7.2579340443534917E+001,
      -7.2610218707853875E+001,
      -7.2641178157217055E+001,
      -7.2672217569398398E+001,
      -7.2703335719015044E+001,
      -7.2734531377575749E+001,
      -7.2765803313529332E+001,
      -7.2797150292313276E+001,
      -7.2828571076402568E+001,
      -7.2860064425358445E+001,
      -7.2891629095877406E+001,
      -7.2923263841840296E+001,
      -7.2954967414361548E+001,
      -7.2986738561838365E+001,
      -7.3018576030000276E+001,
      -7.3050478561958542E+001,
      -7.3082444898255815E+001,
      -7.3114473776915887E+001,
      -7.3146563933493454E+001,
      -7.3178714101124100E+001,
      -7.3210923010574248E+001,
      -7.3243189390291320E+001,
      -7.3275511966453877E+001,
      -7.3307889463021965E+001,
      -7.3340320601787440E+001,
      -7.3372804102424496E+001,
      -7.3405338682540119E+001,
      -7.3437923057724845E+001,
      -7.3470555941603294E+001,
      -7.3503236045885103E+001,
      -7.3535962080415700E+001,
      -7.3568732753227280E+001,
      -7.3601546770589820E+001,
      -7.3634402837062069E+001,
      -7.3667299655542791E+001,
      -7.3700235927321927E+001,
      -7.3733210352131849E+001,
      -7.3766221628198736E+001,
      -7.3799268452293944E+001,
      -7.3832349519785424E+001,
      -7.3865463524689275E+001,
      -7.3898609159721303E+001,
      -7.3931785116348593E+001,
      -7.3964990084841162E+001,
      -7.3998222754323706E+001,
      -7.4031481812827366E+001,
      -7.4064765947341414E+001,
      -7.4098073843865279E+001,
      -7.4131404187460177E+001,
      -7.4164755662301260E+001,
      -7.4198126951729364E+001,
      -7.4231516738303156E+001,
      -7.4264923703851011E+001,
      -7.4298346529523158E+001,
      -7.4331783895843657E+001,
      -7.4365234482762531E+001,
      -7.4398696969707885E+001,
      -7.4432170035638038E+001,
      -7.4465652359093667E+001,
      -7.4499142618249977E+001,
      -7.4532639490968862E+001,
      -7.4566141654851151E+001,
      -7.4599647787288788E+001,
      -7.4633156565517027E+001,
      -7.4666666666666657E+001,
      -7.4700176767816302E+001,
      -7.4733685546044541E+001,
      -7.4767191678482163E+001,
      -7.4800693842364467E+001,
      -7.4834190715083338E+001,
      -7.4867680974239633E+001,
      -7.4901163297695263E+001,
      -7.4934636363625444E+001,
      -7.4968098850570797E+001,
      -7.5001549437489658E+001,
      -7.5034986803810170E+001,
      -7.5068409629482289E+001,
      -7.5101816595030172E+001,
      -7.5135206381603950E+001,
      -7.5168577671032068E+001,
      -7.5201929145873152E+001,
      -7.5235259489468049E+001,
      -7.5268567385991886E+001,
      -7.5301851520505963E+001,
      -7.5335110579009609E+001,
      -7.5368343248492167E+001,
      -7.5401548216984736E+001,
      -7.5434724173611997E+001,
      -7.5467869808644025E+001,
      -7.5500983813547890E+001,
      -7.5534064881039384E+001,
      -7.5567111705134579E+001,
      -7.5600122981201466E+001,
      -7.5633097406011402E+001,
      -7.5666033677790523E+001,
      -7.5698930496271245E+001,
      -7.5731786562743494E+001,
      -7.5764600580106034E+001,
      -7.5797371252917628E+001,
      -7.5830097287448226E+001,
      -7.5862777391730020E+001,
      -7.5895410275608484E+001,
      -7.5927994650793181E+001,
      -7.5960529230908833E+001,
      -7.5993012731545889E+001,
      -7.6025443870311364E+001,
      -7.6057821366879438E+001,
      -7.6090143943041994E+001,
      -7.6122410322759066E+001,
      -7.6154619232209214E+001,
      -7.6186769399839875E+001,
      -7.6218859556417442E+001,
      -7.6250888435077513E+001,
      -7.6282854771374787E+001,
      -7.6314757303333053E+001,
      -7.6346594771494964E+001,
      -7.6378365918971781E+001,
      -7.6410069491493019E+001,
      -7.6441704237455923E+001,
      -7.6473268907974884E+001,
      -7.6504762256930761E+001,
      -7.6536183041020038E+001,
      -7.6567530019803996E+001,
      -7.6598801955757565E+001,
      -7.6629997614318285E+001,
      -7.6661115763934930E+001,
      -7.6692155176116273E+001,
      -7.6723114625479440E+001,
      -7.6753992889798411E+001,
      -7.6784788750052158E+001,
      -7.6815500990472856E+001,
      -7.6846128398593862E+001,
      -7.6876669765297507E+001,
      -7.6907123884862969E+001,
      -7.6937489555013713E+001,
      -7.6967765576965107E+001,
      -7.6997950755471635E+001,
      -7.7028043898874145E+001,
      -7.7058043819146832E+001,
      -7.7087949331944245E+001,
      -7.7117759256647929E+001,
      -7.7147472416413109E+001,
      -7.7177087638215113E+001,
      -7.7206603752895674E+001,
      -7.7236019595209143E+001,
      -7.7265334003868432E+001,
      -7.7294545821590873E+001,
      -7.7323653895143948E+001,
      -7.7352657075390724E+001,
      -7.7381554217335307E+001,
      -7.7410344180168025E+001,
      -7.7439025827310445E+001,
      -7.7467598026460237E+001,
      -7.7496059649635910E+001,
      -7.7524409573221305E+001,
      -7.7552646678009992E+001,
      -7.7580769849249435E+001,
      -7.7608777976684962E+001,
      -7.7636669954603661E+001,
      -7.7664444681878024E+001,
      -7.7692101062009357E+001,
      -7.7719638003171141E+001,
      -7.7747054418252077E+001,
      -7.7774349224899069E+001,
      -7.7801521345559848E+001,
      -7.7828569707525645E+001,
      -7.7855493242973424E+001,
      -7.7882290889008118E+001,
      -7.7908961587704567E+001,
      -7.7935504286149197E+001,
      -7.7961917936481782E+001,
      -7.7988201495936593E+001,
      -7.8014353926883729E+001,
      -7.8040374196869990E+001,
      -7.8066261278659667E+001,
      -7.8092014150275105E+001,
      -7.8117631795037028E+001,
      -7.8143113201604692E+001,
      -7.8168457364015765E+001,
      -7.8193663281726145E+001,
      -7.8218729959649338E+001,
      -7.8243656408195832E+001,
      -7.8268441643312116E+001,
      -7.8293084686519563E+001,
      -7.8317584564952995E+001,
      -7.8341940311399185E+001,
      -7.8366150964334963E+001,
      -7.8390215567965171E+001,
      -7.8414133172260520E+001,
      -7.8437902832994922E+001,
      -7.8461523611782852E+001,
      -7.8484994576116435E+001,
      -7.8508314799402172E+001,
      -7.8531483360997584E+001,
      -7.8554499346247525E+001,
      -7.8577361846520319E+001,
      -7.8600069959243584E+001,
      -7.8622622787939932E+001,
      -7.8645019442262296E+001,
      -7.8667259038029115E+001,
      -7.8689340697259212E+001,
      -7.8711263548206517E+001,
      -7.8733026725394396E+001,
      -7.8754629369649862E+001,
      -7.8776070628137532E+001,
      -7.8797349654393244E+001,
      -7.8818465608357457E+001,
      -7.8839417656408472E+001,
      -7.8860204971395305E+001,
      -7.8880826732670343E+001,
      -7.8901282126121771E+001,
      -7.8921570344205705E+001,
      -7.8941690585978009E+001,
      -7.8961642057125985E+001,
      -7.8981423969999710E+001,
      -7.9001035543643169E+001,
      -7.9020476003824967E+001,
      -7.9039744583069080E+001,
      -7.9058840520684939E+001,
      -7.9077763062797658E+001,
      -7.9096511462377663E+001,
      -7.9115084979270236E+001,
      -7.9133482880224761E+001,
      -7.9151704438923574E+001,
      -7.9169748936010734E+001,
      -7.9187615659120439E+001,
      -7.9205303902905015E+001,
      -7.9222812969062915E+001,
      -7.9240142166366141E+001,
      -7.9257290810687692E+001,
      -7.9274258225028447E+001,
      -7.9291043739543952E+001,
      -7.9307646691570795E+001,
      -7.9324066425652902E+001,
      -7.9340302293567277E+001,
      -7.9356353654349633E+001,
      -7.9372219874319740E+001,
      -7.9387900327106422E+001,
      -7.9403394393672230E+001,
      -7.9418701462337950E+001,
      -7.9433820928806739E+001,
      -7.9448752196187925E+001,
      -7.9463494675020641E+001,
      -7.9478047783297086E+001,
      -7.9492410946485435E+001,
      -7.9506583597552620E+001,
      -7.9520565176986636E+001,
      -7.9534355132818675E+001,
      -7.9547952920644889E+001,
      -7.9561358003647896E+001,
      -7.9574569852617969E+001,
      -7.9587587945973937E+001,
      -7.9600411769783761E+001,
      -7.9613040817784849E+001,
      -7.9625474591404000E+001,
      -7.9637712599777117E+001,
      -7.9649754359768593E+001,
      -7.9661599395990351E+001,
      -7.9673247240820672E+001,
      -7.9684697434422532E+001,
      -7.9695949524761943E+001,
      -7.9707003067625621E+001,
      -7.9717857626638633E+001,
      -7.9728512773281565E+001,
      -7.9738968086907477E+001,
      -7.9749223154758496E+001,
      -7.9759277571982082E+001,
      -7.9769130941647092E+001,
      -7.9778782874759330E+001,
      -7.9788232990277024E+001,
      -7.9797480915125789E+001,
      -7.9806526284213376E+001,
      -7.9815368740444114E+001,
      -7.9824007934732975E+001,
      -7.9832443526019361E+001,
      -7.9840675181280560E+001,
      -7.9848702575544920E+001,
      -7.9856525391904668E+001,
      -7.9864143321528402E+001,
      -7.9871556063673310E+001,
      -7.9878763325697022E+001,
      -7.9885764823069181E+001,
      -7.9892560279382636E+001,
      -7.9899149426364446E+001,
      -7.9905532003886336E+001,
      -7.9911707759975087E+001,
      -7.9917676450822427E+001,
      -7.9923437840794662E+001,
      -7.9928991702441962E+001,
      -7.9934337816507394E+001,
      -7.9939475971935536E+001,
      -7.9944405965880790E+001,
      -7.9949127603715468E+001,
      -7.9953640699037365E+001,
      -7.9957945073677209E+001,
      -7.9962040557705677E+001,
      -7.9965926989440050E+001,
      -7.9969604215450659E+001,
      -7.9973072090566930E+001,
      -7.9976330477883096E+001,
      -7.9979379248763578E+001,
      -7.9982218282848152E+001,
      -7.9984847468056600E+001,
      -7.9987266700593196E+001,
      -7.9989475884950778E+001,
      -7.9991474933914517E+001,
      -7.9993263768565413E+001,
      -7.9994842318283318E+001,
      -7.9996210520749798E+001,
      -7.9997368321950560E+001,
      -7.9998315676177597E+001,
      -7.9999052546030967E+001,
      -7.9999578902420353E+001,
      -7.9999894724566062E+001,
      -80.0,
      -7.9999894724566062E+001,
      -7.9999578902420353E+001,
      -7.9999052546030967E+001,
      -7.9998315676177597E+001,
      -7.9997368321950560E+001,
      -7.9996210520749798E+001,
      -7.9994842318283318E+001,
      -7.9993263768565413E+001,
      -7.9991474933914517E+001,
      -7.9989475884950778E+001,
      -7.9987266700593196E+001,
      -7.9984847468056600E+001,
      -7.9982218282848152E+001,
      -7.9979379248763578E+001,
      -7.9976330477883096E+001,
      -7.9973072090566930E+001,
      -7.9969604215450659E+001,
      -7.9965926989440050E+001,
      -7.9962040557705677E+001,
      -7.9957945073677209E+001,
      -7.9953640699037365E+001,
      -7.9949127603715468E+001,
      -7.9944405965880790E+001,
      -7.9939475971935536E+001,
      -7.9934337816507394E+001,
      -7.9928991702441962E+001,
      -7.9923437840794662E+001,
      -7.9917676450822427E+001,
      -7.9911707759975087E+001,
      -7.9905532003886336E+001,
      -7.9899149426364446E+001,
      -7.9892560279382636E+001,
      -7.9885764823069181E+001,
      -7.9878763325697037E+001,
      -7.9871556063673310E+001,
      -7.9864143321528402E+001,
      -7.9856525391904668E+001,
      -7.9848702575544920E+001,
      -7.9840675181280560E+001,
      -7.9832443526019361E+001,
      -7.9824007934732975E+001,
      -7.9815368740444114E+001,
      -7.9806526284213376E+001,
      -7.9797480915125789E+001,
      -7.9788232990277024E+001,
      -7.9778782874759330E+001,
      -7.9769130941647092E+001,
      -7.9759277571982082E+001,
      -7.9749223154758496E+001,
      -7.9738968086907477E+001,
      -7.9728512773281565E+001,
      -7.9717857626638633E+001,
      -7.9707003067625621E+001,
      -7.9695949524761943E+001,
      -7.9684697434422532E+001,
      -7.9673247240820643E+001,
      -7.9661599395990351E+001,
      -7.9649754359768593E+001,
      -7.9637712599777117E+001,
      -7.9625474591404000E+001,
      -7.9613040817784849E+001,
      -7.9600411769783761E+001,
      -7.9587587945973937E+001,
      -7.9574569852617969E+001,
      -7.9561358003647896E+001,
      -7.9547952920644889E+001,
      -7.9534355132818675E+001,
      -7.9520565176986636E+001,
      -7.9506583597552620E+001,
      -7.9492410946485435E+001,
      -7.9478047783297086E+001,
      -7.9463494675020641E+001,
      -7.9448752196187925E+001,
      -7.9433820928806725E+001,
      -7.9418701462337950E+001,
      -7.9403394393672230E+001,
      -7.9387900327106422E+001,
      -7.9372219874319740E+001,
      -7.9356353654349633E+001,
      -7.9340302293567277E+001,
      -7.9324066425652902E+001,
      -7.9307646691570795E+001,
      -7.9291043739543952E+001,
      -7.9274258225028447E+001,
      -7.9257290810687692E+001,
      -7.9240142166366141E+001,
      -7.9222812969062915E+001,
      -7.9205303902905015E+001,
      -7.9187615659120439E+001,
      -7.9169748936010734E+001,
      -7.9151704438923574E+001,
      -7.9133482880224747E+001,
      -7.9115084979270236E+001,
      -7.9096511462377663E+001,
      -7.9077763062797658E+001,
      -7.9058840520684939E+001,
      -7.9039744583069080E+001,
      -7.9020476003824967E+001,
      -7.9001035543643169E+001,
      -7.8981423969999710E+001,
      -7.8961642057125985E+001,
      -7.8941690585978009E+001,
      -7.8921570344205705E+001,
      -7.8901282126121771E+001,
      -7.8880826732670343E+001,
      -7.8860204971395305E+001,
      -7.8839417656408472E+001,
      -7.8818465608357457E+001,
      -7.8797349654393244E+001,
      -7.8776070628137532E+001,
      -7.8754629369649862E+001,
      -7.8733026725394396E+001,
      -7.8711263548206517E+001,
      -7.8689340697259212E+001,
      -7.8667259038029115E+001,
      -7.8645019442262296E+001,
      -7.8622622787939946E+001,
      -7.8600069959243584E+001,
      -7.8577361846520319E+001,
      -7.8554499346247525E+001,
      -7.8531483360997584E+001,
      -7.8508314799402172E+001,
      -7.8484994576116435E+001,
      -7.8461523611782852E+001,
      -7.8437902832994922E+001,
      -7.8414133172260520E+001,
      -7.8390215567965186E+001,
      -7.8366150964334963E+001,
      -7.8341940311399185E+001,
      -7.8317584564952995E+001,
      -7.8293084686519563E+001,
      -7.8268441643312116E+001,
      -7.8243656408195832E+001,
      -7.8218729959649338E+001,
      -7.8193663281726145E+001,
      -7.8168457364015765E+001,
      -7.8143113201604692E+001,
      -7.8117631795037028E+001,
      -7.8092014150275105E+001,
      -7.8066261278659667E+001,
      -7.8040374196869990E+001,
      -7.8014353926883743E+001,
      -7.7988201495936593E+001,
      -7.7961917936481782E+001,
      -7.7935504286149211E+001,
      -7.7908961587704539E+001,
      -7.7882290889008118E+001,
      -7.7855493242973424E+001,
      -7.7828569707525645E+001,
      -7.7801521345559863E+001,
      -7.7774349224899069E+001,
      -7.7747054418252077E+001,
      -7.7719638003171141E+001,
      -7.7692101062009371E+001,
      -7.7664444681878038E+001,
      -7.7636669954603676E+001,
      -7.7608777976684962E+001,
      -7.7580769849249435E+001,
      -7.7552646678009992E+001,
      -7.7524409573221305E+001,
      -7.7496059649635910E+001,
      -7.7467598026460252E+001,
      -7.7439025827310445E+001,
      -7.7410344180168039E+001,
      -7.7381554217335292E+001,
      -7.7352657075390724E+001,
      -7.7323653895143948E+001,
      -7.7294545821590873E+001,
      -7.7265334003868432E+001,
      -7.7236019595209157E+001,
      -7.7206603752895674E+001,
      -7.7177087638215113E+001,
      -7.7147472416413109E+001,
      -7.7117759256647943E+001,
      -7.7087949331944245E+001,
      -7.7058043819146832E+001,
      -7.7028043898874131E+001,
      -7.6997950755471635E+001,
      -7.6967765576965107E+001,
      -7.6937489555013713E+001,
      -7.6907123884862969E+001,
      -7.6876669765297507E+001,
      -7.6846128398593848E+001,
      -7.6815500990472856E+001,
      -7.6784788750052158E+001,
      -7.6753992889798411E+001,
      -7.6723114625479440E+001,
      -7.6692155176116273E+001,
      -7.6661115763934930E+001,
      -7.6629997614318285E+001,
      -7.6598801955757565E+001,
      -7.6567530019803996E+001,
      -7.6536183041020038E+001,
      -7.6504762256930761E+001,
      -7.6473268907974884E+001,
      -7.6441704237455923E+001,
      -7.6410069491493019E+001,
      -7.6378365918971795E+001,
      -7.6346594771494964E+001,
      -7.6314757303333053E+001,
      -7.6282854771374787E+001,
      -7.6250888435077513E+001,
      -7.6218859556417442E+001,
      -7.6186769399839875E+001,
      -7.6154619232209228E+001,
      -7.6122410322759066E+001,
      -7.6090143943041994E+001,
      -7.6057821366879452E+001,
      -7.6025443870311364E+001,
      -7.5993012731545889E+001,
      -7.5960529230908833E+001,
      -7.5927994650793181E+001,
      -7.5895410275608484E+001,
      -7.5862777391730035E+001,
      -7.5830097287448226E+001,
      -7.5797371252917628E+001,
      -7.5764600580106020E+001,
      -7.5731786562743494E+001,
      -7.5698930496271245E+001,
      -7.5666033677790523E+001,
      -7.5633097406011402E+001,
      -7.5600122981201466E+001,
      -7.5567111705134579E+001,
      -7.5534064881039384E+001,
      -7.5500983813547890E+001,
      -7.5467869808644039E+001,
      -7.5434724173611997E+001,
      -7.5401548216984736E+001,
      -7.5368343248492167E+001,
      -7.5335110579009609E+001,
      -7.5301851520505963E+001,
      -7.5268567385991901E+001,
      -7.5235259489468049E+001,
      -7.5201929145873152E+001,
      -7.5168577671032068E+001,
      -7.5135206381603950E+001,
      -7.5101816595030158E+001,
      -7.5068409629482289E+001,
      -7.5034986803810156E+001,
      -7.5001549437489658E+001,
      -7.4968098850570797E+001,
      -7.4934636363625444E+001,
      -7.4901163297695263E+001,
      -7.4867680974239647E+001,
      -7.4834190715083338E+001,
      -7.4800693842364467E+001,
      -7.4767191678482163E+001,
      -7.4733685546044541E+001,
      -7.4700176767816316E+001,
      -7.4666666666666657E+001,
      -7.4633156565517027E+001,
      -7.4599647787288788E+001,
      -7.4566141654851151E+001,
      -7.4532639490968862E+001,
      -7.4499142618249977E+001,
      -7.4465652359093667E+001,
      -7.4432170035638038E+001,
      -7.4398696969707885E+001,
      -7.4365234482762531E+001,
      -7.4331783895843657E+001,
      -7.4298346529523158E+001,
      -7.4264923703851025E+001,
      -7.4231516738303156E+001,
      -7.4198126951729364E+001,
      -7.4164755662301260E+001,
      -7.4131404187460177E+001,
      -7.4098073843865279E+001,
      -7.4064765947341428E+001,
      -7.4031481812827366E+001,
      -7.3998222754323706E+001,
      -7.3964990084841162E+001,
      -7.3931785116348593E+001,
      -7.3898609159721303E+001,
      -7.3865463524689289E+001,
      -7.3832349519785424E+001,
      -7.3799268452293944E+001,
      -7.3766221628198736E+001,
      -7.3733210352131849E+001,
      -7.3700235927321927E+001,
      -7.3667299655542791E+001,
      -7.3634402837062069E+001,
      -7.3601546770589820E+001,
      -7.3568732753227295E+001,
      -7.3535962080415700E+001,
      -7.3503236045885117E+001,
      -7.3470555941603308E+001,
      -7.3437923057724859E+001,
      -7.3405338682540133E+001,
      -7.3372804102424496E+001,
      -7.3340320601787440E+001,
      -7.3307889463021965E+001,
      -7.3275511966453877E+001,
      -7.3243189390291320E+001,
      -7.3210923010574248E+001,
      -7.3178714101124115E+001,
      -7.3146563933493454E+001,
      -7.3114473776915887E+001,
      -7.3082444898255815E+001,
      -7.3050478561958542E+001,
      -7.3018576030000276E+001,
      -7.2986738561838365E+001,
      -7.2954967414361548E+001,
      -7.2923263841840310E+001,
      -7.2891629095877406E+001,
      -7.2860064425358445E+001,
      -7.2828571076402582E+001,
      -7.2797150292313290E+001,
      -7.2765803313529332E+001,
      -7.2734531377575749E+001,
      -7.2703335719015058E+001,
      -7.2672217569398398E+001,
      -7.2641178157217055E+001,
      -7.2610218707853875E+001,
      -7.2579340443534917E+001,
      -7.2548544583281171E+001,
      -7.2517832342860459E+001,
      -7.2487204934739466E+001,
      -7.2456663568035808E+001,
      -7.2426209448470360E+001,
      -7.2395843778319602E+001,
      -7.2365567756368222E+001,
      -7.2335382577861679E+001,
      -7.2305289434459198E+001,
      -7.2275289514186483E+001,
      -7.2245384001389084E+001,
      -7.2215574076685400E+001,
      -7.2185860916920220E+001,
      -7.2156245695118230E+001,
      -7.2126729580437654E+001,
      -7.2097313738124186E+001,
      -7.2067999329464882E+001,
      -7.2038787511742441E+001,
      -7.2009679438189380E+001,
      -7.1980676257942605E+001,
      -7.1951779115998008E+001,
      -7.1922989153165304E+001,
      -7.1894307506022869E+001,
      -7.1865735306873077E+001,
      -7.1837273683697418E+001,
      -7.1808923760112009E+001,
      -7.1780686655323322E+001,
      -7.1752563484083893E+001,
      -7.1724555356648381E+001,
      -7.1696663378729653E+001,
      -7.1668888651455305E+001,
      -7.1641232271323958E+001,
      -7.1613695330162173E+001,
      -7.1586278915081223E+001,
      -7.1558984108434259E+001,
      -7.1531811987773480E+001,
      -7.1504763625807684E+001,
      -7.1477840090359891E+001,
      -7.1451042444325182E+001,
      -7.1424371745628761E+001,
      -7.1397829047184132E+001,
      -7.1371415396851546E+001,
      -7.1345131837396721E+001,
      -7.1318979406449600E+001,
      -7.1292959136463338E+001,
      -7.1267072054673648E+001,
      -7.1241319183058209E+001,
      -7.1215701538296287E+001,
      -7.1190220131728637E+001,
      -7.1164875969317563E+001,
      -7.1139670051607183E+001,
      -7.1114603373683991E+001,
      -7.1089676925137496E+001,
      -7.1064891690021199E+001,
      -7.1040248646813751E+001,
      -7.1015748768380320E+001,
      -7.0991393021934144E+001,
      -7.0967182368998365E+001,
      -7.0943117765368143E+001,
      -7.0919200161072794E+001,
      -7.0895430500338406E+001,
      -7.0871809721550477E+001,
      -7.0848338757216894E+001,
      -7.0825018533931157E+001,
      -7.0801849972335759E+001,
      -7.0778833987085804E+001,
      -7.0755971486812996E+001,
      -7.0733263374089731E+001,
      -7.0710710545393397E+001,
      -7.0688313891071019E+001,
      -7.0666074295304213E+001,
      -7.0643992636074103E+001,
      -7.0622069785126811E+001,
      -7.0600306607938933E+001,
      -7.0578703963683466E+001,
      -7.0557262705195782E+001,
      -7.0535983678940084E+001,
      -7.0514867724975872E+001,
      -7.0493915676924857E+001,
      -7.0473128361938024E+001,
      -7.0452506600662986E+001,
      -7.0432051207211529E+001,
      -7.0411762989127610E+001,
      -7.0391642747355320E+001,
      -7.0371691276207343E+001,
      -7.0351909363333604E+001,
      -7.0332297789690159E+001,
      -7.0312857329508347E+001,
      -7.0293588750264249E+001,
      -7.0274492812648390E+001,
      -7.0255570270535671E+001,
      -7.0236821870955666E+001,
      -7.0218248354063078E+001,
      -7.0199850453108581E+001,
      -7.0181628894409755E+001,
      -7.0163584397322580E+001,
      -7.0145717674212875E+001,
      -7.0128029430428313E+001,
      -7.0110520364270414E+001,
      -7.0093191166967188E+001,
      -7.0076042522645622E+001,
      -7.0059075108304867E+001,
      -7.0042289593789377E+001,
      -7.0025686641762519E+001,
      -7.0009266907680427E+001,
      -6.9993031039766066E+001,
      -6.9976979678983696E+001,
      -6.9961113459013575E+001,
      -6.9945433006226907E+001,
      -6.9929938939661085E+001,
      -6.9914631870995365E+001,
      -6.9899512404526604E+001,
      -6.9884581137145403E+001,
      -6.9869838658312688E+001,
      -6.9855285550036243E+001,
      -6.9840922386847893E+001,
      -6.9826749735780709E+001,
      -6.9812768156346678E+001,
      -6.9798978200514654E+001,
      -6.9785380412688440E+001,
      -6.9771975329685432E+001,
      -6.9758763480715345E+001,
      -6.9745745387359378E+001,
      -6.9732921563549553E+001,
      -6.9720292515548465E+001,
      -6.9707858741929329E+001,
      -6.9695620733556211E+001,
      -6.9683578973564735E+001,
      -6.9671733937342978E+001,
      -6.9660086092512657E+001,
      -6.9648635898910797E+001,
      -6.9637383808571386E+001,
      -6.9626330265707693E+001,
      -6.9615475706694681E+001,
      -6.9604820560051763E+001,
      -6.9594365246425838E+001,
      -6.9584110178574832E+001,
      -6.9574055761351232E+001,
      -6.9564202391686237E+001,
      -6.9554550458573999E+001,
      -6.9545100343056291E+001,
      -6.9535852418207540E+001,
      -6.9526807049119938E+001,
      -6.9517964592889200E+001,
      -6.9509325398600353E+001,
      -6.9500889807313968E+001,
      -6.9492658152052755E+001,
      -6.9484630757788395E+001,
      -6.9476807941428660E+001,
      -6.9469190011804912E+001,
      -6.9461777269660004E+001,
      -6.9454570007636306E+001,
      -6.9447568510264148E+001,
      -6.9440773053950679E+001,
      -6.9434183906968883E+001,
      -6.9427801329446993E+001,
      -6.9421625573358241E+001,
      -6.9415656882510902E+001,
      -6.9409895492538666E+001,
      -6.9404341630891366E+001,
      -6.9398995516825920E+001,
      -6.9393857361397778E+001,
      -6.9388927367452524E+001,
      -6.9384205729617861E+001,
      -6.9379692634295949E+001,
      -6.9375388259656106E+001,
      -6.9371292775627651E+001,
      -6.9367406343893279E+001,
      -6.9363729117882670E+001,
      -6.9360261242766398E+001,
      -6.9357002855450233E+001,
      -6.9353954084569750E+001,
      -6.9351115050485177E+001,
      -6.9348485865276714E+001,
      -6.9346066632740119E+001,
      -6.9343857448382536E+001,
      -6.9341858399418797E+001,
      -6.9340069564767902E+001,
      -6.9338491015049996E+001,
      -6.9337122812583530E+001,
      -6.9335965011382754E+001,
      -6.9335017657155717E+001,
      -6.9334280787302347E+001,
      -6.9333754430912975E+001,
      -6.9333438608767267E+001,
      -6.9333333333333329E+001,
      -6.9333438608767267E+001,
      -6.9333754430912975E+001,
      -6.9334280787302347E+001,
      -6.9335017657155717E+001,
      -6.9335965011382754E+001,
      -6.9337122812583530E+001,
      -6.9338491015049996E+001,
      -6.9340069564767902E+001,
      -6.9341858399418797E+001,
      -6.9343857448382536E+001,
      -6.9346066632740119E+001,
      -6.9348485865276714E+001,
      -6.9351115050485177E+001,
      -6.9353954084569750E+001,
      -6.9357002855450233E+001,
      -6.9360261242766398E+001,
      -6.9363729117882670E+001,
      -6.9367406343893279E+001,
      -6.9371292775627651E+001,
      -6.9375388259656106E+001,
      -6.9379692634295949E+001,
      -6.9384205729617861E+001,
      -6.9388927367452524E+001,
      -6.9393857361397778E+001,
      -6.9398995516825920E+001,
      -6.9404341630891366E+001,
      -6.9409895492538666E+001,
      -6.9415656882510902E+001,
      -6.9421625573358241E+001,
      -6.9427801329446993E+001,
      -6.9434183906968883E+001,
      -6.9440773053950679E+001,
      -6.9447568510264148E+001,
      -6.9454570007636306E+001,
      -6.9461777269660004E+001,
      -6.9469190011804912E+001,
      -6.9476807941428660E+001,
      -6.9484630757788395E+001,
      -6.9492658152052755E+001,
      -6.9500889807313968E+001,
      -6.9509325398600353E+001,
      -6.9517964592889200E+001,
      -6.9526807049119938E+001,
      -6.9535852418207540E+001,
      -6.9545100343056291E+001,
      -6.9554550458573985E+001,
      -6.9564202391686237E+001,
      -6.9574055761351232E+001,
      -6.9584110178574832E+001,
      -6.9594365246425838E+001,
      -6.9604820560051763E+001,
      -6.9615475706694681E+001,
      -6.9626330265707693E+001,
      -6.9637383808571386E+001,
      -6.9648635898910797E+001,
      -6.9660086092512657E+001,
      -6.9671733937342978E+001,
      -6.9683578973564735E+001,
      -6.9695620733556211E+001,
      -6.9707858741929329E+001,
      -6.9720292515548465E+001,
      -6.9732921563549553E+001,
      -6.9745745387359378E+001,
      -6.9758763480715345E+001,
      -6.9771975329685432E+001,
      -6.9785380412688440E+001,
      -6.9798978200514654E+001,
      -6.9812768156346678E+001,
      -6.9826749735780709E+001,
      -6.9840922386847893E+001,
      -6.9855285550036243E+001,
      -6.9869838658312688E+001,
      -6.9884581137145403E+001,
      -6.9899512404526604E+001,
      -6.9914631870995365E+001,
      -6.9929938939661085E+001,
      -6.9945433006226907E+001,
      -6.9961113459013575E+001,
      -6.9976979678983696E+001,
      -6.9993031039766052E+001,
      -7.0009266907680427E+001,
      -7.0025686641762519E+001,
      -7.0042289593789377E+001,
      -7.0059075108304867E+001,
      -7.0076042522645622E+001,
      -7.0093191166967188E+001,
      -7.0110520364270428E+001,
      -7.0128029430428299E+001,
      -7.0145717674212875E+001,
      -7.0163584397322580E+001,
      -7.0181628894409769E+001,
      -7.0199850453108581E+001,
      -7.0218248354063078E+001,
      -7.0236821870955666E+001,
      -7.0255570270535671E+001,
      -7.0274492812648390E+001,
      -7.0293588750264249E+001,
      -7.0312857329508361E+001,
      -7.0332297789690159E+001,
      -7.0351909363333604E+001,
      -7.0371691276207343E+001,
      -7.0391642747355320E+001,
      -7.0411762989127610E+001,
      -7.0432051207211543E+001,
      -7.0452506600662986E+001,
      -7.0473128361938024E+001,
      -7.0493915676924857E+001,
      -7.0514867724975872E+001,
      -7.0535983678940084E+001,
      -7.0557262705195782E+001,
      -7.0578703963683452E+001,
      -7.0600306607938933E+001,
      -7.0622069785126811E+001,
      -7.0643992636074103E+001,
      -7.0666074295304213E+001,
      -7.0688313891071033E+001,
      -7.0710710545393397E+001,
      -7.0733263374089731E+001,
      -7.0755971486812996E+001,
      -7.0778833987085804E+001,
      -7.0801849972335745E+001,
      -7.0825018533931157E+001,
      -7.0848338757216894E+001,
      -7.0871809721550477E+001,
      -7.0895430500338406E+001,
      -7.0919200161072794E+001,
      -7.0943117765368129E+001,
      -7.0967182368998365E+001,
      -7.0991393021934144E+001,
      -7.1015748768380334E+001,
      -7.1040248646813751E+001,
      -7.1064891690021199E+001,
      -7.1089676925137496E+001,
      -7.1114603373683991E+001,
      -7.1139670051607183E+001,
      -7.1164875969317563E+001,
      -7.1190220131728637E+001,
      -7.1215701538296301E+001,
      -7.1241319183058209E+001,
      -7.1267072054673648E+001,
      -7.1292959136463338E+001,
      -7.1318979406449600E+001,
      -7.1345131837396721E+001,
      -7.1371415396851546E+001,
      -7.1397829047184118E+001,
      -7.1424371745628775E+001,
      -7.1451042444325182E+001,
      -7.1477840090359905E+001,
      -7.1504763625807684E+001,
      -7.1531811987773466E+001,
      -7.1558984108434259E+001,
      -7.1586278915081238E+001,
      -7.1613695330162173E+001,
      -7.1641232271323958E+001,
      -7.1668888651455291E+001,
      -7.1696663378729667E+001,
      -7.1724555356648366E+001,
      -7.1752563484083893E+001,
      -7.1780686655323322E+001,
      -7.1808923760112009E+001,
      -7.1837273683697418E+001,
      -7.1865735306873091E+001,
      -7.1894307506022869E+001,
      -7.1922989153165304E+001,
      -7.1951779115998008E+001,
      -7.1980676257942605E+001,
      -7.2009679438189380E+001,
      -7.2038787511742441E+001,
      -7.2067999329464882E+001,
      -7.2097313738124186E+001,
      -7.2126729580437654E+001,
      -7.2156245695118216E+001,
      -7.2185860916920220E+001,
      -7.2215574076685400E+001,
      -7.2245384001389084E+001,
      -7.2275289514186497E+001,
      -7.2305289434459198E+001,
      -7.2335382577861694E+001,
      -7.2365567756368222E+001,
      -7.2395843778319602E+001,
      -7.2426209448470360E+001,
      -7.2456663568035808E+001,
      -7.2487204934739466E+001,
      -7.2517832342860459E+001,
      -7.2548544583281171E+001,
      -7.2579340443534932E+001,
      -7.2610218707853875E+001,
      -7.2641178157217055E+001,
      -7.2672217569398398E+001,
      -7.2703335719015044E+001,
      -7.2734531377575749E+001,
      -7.2765803313529332E+001,
      -7.2797150292313276E+001,
      -7.2828571076402568E+001,
      -7.2860064425358445E+001,
      -7.2891629095877406E+001,
      -7.2923263841840296E+001,
      -7.2954967414361548E+001,
      -7.2986738561838365E+001,
      -7.3018576030000276E+001,
      -7.3050478561958528E+001,
      -7.3082444898255815E+001,
      -7.3114473776915887E+001,
      -7.3146563933493468E+001,
      -7.3178714101124100E+001,
      -7.3210923010574263E+001,
      -7.3243189390291320E+001,
      -7.3275511966453877E+001,
      -7.3307889463021965E+001,
      -7.3340320601787440E+001,
      -7.3372804102424496E+001,
      -7.3405338682540133E+001,
      -7.3437923057724845E+001,
      -7.3470555941603308E+001,
      -7.3503236045885103E+001,
      -7.3535962080415700E+001,
      -7.3568732753227295E+001,
      -7.3601546770589820E+001,
      -7.3634402837062069E+001,
      -7.3667299655542791E+001,
      -7.3700235927321927E+001,
      -7.3733210352131849E+001,
      -7.3766221628198736E+001,
      -7.3799268452293944E+001,
      -7.3832349519785424E+001,
      -7.3865463524689289E+001,
      -7.3898609159721303E+001,
      -7.3931785116348593E+001,
      -7.3964990084841162E+001,
      -7.3998222754323706E+001,
      -7.4031481812827366E+001,
      -7.4064765947341414E+001,
      -7.4098073843865279E+001,
      -7.4131404187460177E+001,
      -7.4164755662301260E+001,
      -7.4198126951729364E+001,
      -7.4231516738303156E+001,
      -7.4264923703851011E+001,
      -7.4298346529523172E+001,
      -7.4331783895843657E+001,
      -7.4365234482762531E+001,
      -7.4398696969707885E+001,
      -7.4432170035638052E+001,
      -7.4465652359093681E+001,
      -7.4499142618249977E+001,
      -7.4532639490968862E+001,
      -7.4566141654851151E+001,
      -7.4599647787288788E+001,
      -7.4633156565517012E+001,
      -7.4666666666666657E+001,
      -7.4700176767816316E+001,
      -7.4733685546044541E+001,
      -7.4767191678482163E+001,
      -7.4800693842364467E+001,
      -7.4834190715083352E+001,
      -7.4867680974239633E+001,
      -7.4901163297695277E+001,
      -7.4934636363625444E+001,
      -7.4968098850570797E+001,
      -7.5001549437489658E+001,
      -7.5034986803810170E+001,
      -7.5068409629482304E+001,
      -7.5101816595030172E+001,
      -7.5135206381603950E+001,
      -7.5168577671032068E+001,
      -7.5201929145873152E+001,
      -7.5235259489468049E+001,
      -7.5268567385991886E+001,
      -7.5301851520505977E+001,
      -7.5335110579009609E+001,
      -7.5368343248492167E+001,
      -7.5401548216984736E+001,
      -7.5434724173612011E+001,
      -7.5467869808644025E+001,
      -7.5500983813547890E+001,
      -7.5534064881039384E+001,
      -7.5567111705134565E+001,
      -7.5600122981201466E+001,
      -7.5633097406011402E+001,
      -7.5666033677790523E+001,
      -7.5698930496271245E+001,
      -7.5731786562743494E+001,
      -7.5764600580106034E+001,
      -7.5797371252917628E+001,
      -7.5830097287448226E+001,
      -7.5862777391730020E+001,
      -7.5895410275608484E+001,
      -7.5927994650793181E+001,
      -7.5960529230908833E+001,
      -7.5993012731545889E+001,
      -7.6025443870311378E+001,
      -7.6057821366879438E+001,
      -7.6090143943041994E+001,
      -7.6122410322759066E+001,
      -7.6154619232209214E+001,
      -7.6186769399839875E+001,
      -7.6218859556417456E+001,
      -7.6250888435077513E+001,
      -7.6282854771374787E+001,
      -7.6314757303333053E+001,
      -7.6346594771494964E+001,
      -7.6378365918971781E+001,
      -7.6410069491493019E+001,
      -7.6441704237455923E+001,
      -7.6473268907974884E+001,
      -7.6504762256930746E+001,
      -7.6536183041020038E+001,
      -7.6567530019803996E+001,
      -7.6598801955757580E+001,
      -7.6629997614318270E+001,
      -7.6661115763934930E+001,
      -7.6692155176116273E+001,
      -7.6723114625479440E+001,
      -7.6753992889798411E+001,
      -7.6784788750052158E+001,
      -7.6815500990472856E+001,
      -7.6846128398593862E+001,
      -7.6876669765297507E+001,
      -7.6907123884862969E+001,
      -7.6937489555013713E+001,
      -7.6967765576965107E+001,
      -7.6997950755471635E+001,
      -7.7028043898874145E+001,
      -7.7058043819146846E+001,
      -7.7087949331944259E+001,
      -7.7117759256647929E+001,
      -7.7147472416413123E+001,
      -7.7177087638215099E+001,
      -7.7206603752895674E+001,
      -7.7236019595209143E+001,
      -7.7265334003868432E+001,
      -7.7294545821590873E+001,
      -7.7323653895143948E+001,
      -7.7352657075390724E+001,
      -7.7381554217335307E+001,
      -7.7410344180168025E+001,
      -7.7439025827310445E+001,
      -7.7467598026460252E+001,
      -7.7496059649635910E+001,
      -7.7524409573221305E+001,
      -7.7552646678010007E+001,
      -7.7580769849249435E+001,
      -7.7608777976684962E+001,
      -7.7636669954603676E+001,
      -7.7664444681878038E+001,
      -7.7692101062009357E+001,
      -7.7719638003171141E+001,
      -7.7747054418252091E+001,
      -7.7774349224899069E+001,
      -7.7801521345559848E+001,
      -7.7828569707525645E+001,
      -7.7855493242973438E+001,
      -7.7882290889008132E+001,
      -7.7908961587704567E+001,
      -7.7935504286149197E+001,
      -7.7961917936481782E+001,
      -7.7988201495936593E+001,
      -7.8014353926883729E+001,
      -7.8040374196869990E+001,
      -7.8066261278659667E+001,
      -7.8092014150275105E+001,
      -7.8117631795037042E+001,
      -7.8143113201604692E+001,
      -7.8168457364015765E+001,
      -7.8193663281726145E+001,
      -7.8218729959649338E+001,
      -7.8243656408195832E+001,
      -7.8268441643312116E+001,
      -7.8293084686519563E+001,
      -7.8317584564953009E+001,
      -7.8341940311399185E+001,
      -7.8366150964334963E+001,
      -7.8390215567965171E+001,
      -7.8414133172260520E+001,
      -7.8437902832994922E+001,
      -7.8461523611782852E+001,
      -7.8484994576116435E+001,
      -7.8508314799402172E+001,
      -7.8531483360997569E+001,
      -7.8554499346247525E+001,
      -7.8577361846520319E+001,
      -7.8600069959243584E+001,
      -7.8622622787939932E+001,
      -7.8645019442262310E+001,
      -7.8667259038029115E+001,
      -7.8689340697259212E+001,
      -7.8711263548206517E+001,
      -7.8733026725394396E+001,
      -7.8754629369649862E+001,
      -7.8776070628137532E+001,
      -7.8797349654393244E+001,
      -7.8818465608357457E+001,
      -7.8839417656408472E+001,
      -7.8860204971395305E+001,
      -7.8880826732670343E+001,
      -7.8901282126121785E+001,
      -7.8921570344205705E+001,
      -7.8941690585978009E+001,
      -7.8961642057125971E+001,
      -7.8981423969999710E+001,
      -7.9001035543643169E+001,
      -7.9020476003824982E+001,
      -7.9039744583069080E+001,
      -7.9058840520684939E+001,
      -7.9077763062797658E+001,
      -7.9096511462377663E+001,
      -7.9115084979270250E+001,
      -7.9133482880224761E+001,
      -7.9151704438923574E+001,
      -7.9169748936010748E+001,
      -7.9187615659120439E+001,
      -7.9205303902905015E+001,
      -7.9222812969062915E+001,
      -7.9240142166366141E+001,
      -7.9257290810687692E+001,
      -7.9274258225028447E+001,
      -7.9291043739543952E+001,
      -7.9307646691570795E+001,
      -7.9324066425652902E+001,
      -7.9340302293567277E+001,
      -7.9356353654349633E+001,
      -7.9372219874319740E+001,
      -7.9387900327106422E+001,
      -7.9403394393672230E+001,
      -7.9418701462337950E+001,
      -7.9433820928806739E+001,
      -7.9448752196187925E+001,
      -7.9463494675020641E+001,
      -7.9478047783297086E+001,
      -7.9492410946485435E+001,
      -7.9506583597552620E+001,
      -7.9520565176986636E+001,
      -7.9534355132818675E+001,
      -7.9547952920644889E+001,
      -7.9561358003647896E+001,
      -7.9574569852617969E+001,
      -7.9587587945973937E+001,
      -7.9600411769783761E+001,
      -7.9613040817784849E+001,
      -7.9625474591404000E+001,
      -7.9637712599777117E+001,
      -7.9649754359768593E+001,
      -7.9661599395990351E+001,
      -7.9673247240820643E+001,
      -7.9684697434422532E+001,
      -7.9695949524761943E+001,
      -7.9707003067625621E+001,
      -7.9717857626638633E+001,
      -7.9728512773281565E+001,
      -7.9738968086907477E+001,
      -7.9749223154758496E+001,
      -7.9759277571982082E+001,
      -7.9769130941647092E+001,
      -7.9778782874759344E+001,
      -7.9788232990277024E+001,
      -7.9797480915125789E+001,
      -7.9806526284213376E+001,
      -7.9815368740444114E+001,
      -7.9824007934732975E+001,
      -7.9832443526019361E+001,
      -7.9840675181280560E+001,
      -7.9848702575544920E+001,
      -7.9856525391904668E+001,
      -7.9864143321528402E+001,
      -7.9871556063673310E+001,
      -7.9878763325697022E+001,
      -7.9885764823069181E+001,
      -7.9892560279382636E+001,
      -7.9899149426364446E+001,
      -7.9905532003886336E+001,
      -7.9911707759975087E+001,
      -7.9917676450822427E+001,
      -7.9923437840794662E+001,
      -7.9928991702441962E+001,
      -7.9934337816507394E+001,
      -7.9939475971935536E+001,
      -7.9944405965880790E+001,
      -7.9949127603715468E+001,
      -7.9953640699037365E+001,
      -7.9957945073677209E+001,
      -7.9962040557705677E+001,
      -7.9965926989440050E+001,
      -7.9969604215450659E+001,
      -7.9973072090566930E+001,
      -7.9976330477883096E+001,
      -7.9979379248763578E+001,
      -7.9982218282848152E+001,
      -7.9984847468056600E+001,
      -7.9987266700593196E+001,
      -7.9989475884950778E+001,
      -7.9991474933914517E+001,
      -7.9993263768565413E+001,
      -7.9994842318283318E+001,
      -7.9996210520749798E+001,
      -7.9997368321950560E+001,
      -7.9998315676177597E+001,
      -7.9999052546030967E+001,
      -7.9999578902420353E+001,
      -7.9999894724566062E+001,
      -80.0,
      -7.9999894724566062E+001,
      -7.9999578902420353E+001,
      -7.9999052546030967E+001,
      -7.9998315676177597E+001,
      -7.9997368321950560E+001,
      -7.9996210520749798E+001,
      -7.9994842318283318E+001,
      -7.9993263768565413E+001,
      -7.9991474933914517E+001,
      -7.9989475884950778E+001,
      -7.9987266700593196E+001,
      -7.9984847468056600E+001,
      -7.9982218282848152E+001,
      -7.9979379248763578E+001,
      -7.9976330477883096E+001,
      -7.9973072090566930E+001,
      -7.9969604215450659E+001,
      -7.9965926989440050E+001,
      -7.9962040557705677E+001,
      -7.9957945073677209E+001,
      -7.9953640699037365E+001,
      -7.9949127603715468E+001,
      -7.9944405965880790E+001,
      -7.9939475971935536E+001,
      -7.9934337816507394E+001,
      -7.9928991702441962E+001,
      -7.9923437840794662E+001,
      -7.9917676450822427E+001,
      -7.9911707759975087E+001,
      -7.9905532003886336E+001,
      -7.9899149426364446E+001,
      -7.9892560279382636E+001,
      -7.9885764823069181E+001,
      -7.9878763325697022E+001,
      -7.9871556063673310E+001,
      -7.9864143321528402E+001,
      -7.9856525391904668E+001,
      -7.9848702575544920E+001,
      -7.9840675181280560E+001,
      -7.9832443526019361E+001,
      -7.9824007934732975E+001,
      -7.9815368740444114E+001,
      -7.9806526284213376E+001,
      -7.9797480915125789E+001,
      -7.9788232990277024E+001,
      -7.9778782874759330E+001,
      -7.9769130941647092E+001,
      -7.9759277571982082E+001,
      -7.9749223154758496E+001,
      -7.9738968086907477E+001,
      -7.9728512773281565E+001,
      -7.9717857626638633E+001,
      -7.9707003067625621E+001,
      -7.9695949524761943E+001,
      -7.9684697434422532E+001,
      -7.9673247240820672E+001,
      -7.9661599395990351E+001,
      -7.9649754359768608E+001,
      -7.9637712599777117E+001,
      -7.9625474591404000E+001,
      -7.9613040817784849E+001,
      -7.9600411769783761E+001,
      -7.9587587945973937E+001,
      -7.9574569852617969E+001,
      -7.9561358003647896E+001,
      -7.9547952920644889E+001,
      -7.9534355132818675E+001,
      -7.9520565176986636E+001,
      -7.9506583597552620E+001,
      -7.9492410946485435E+001,
      -7.9478047783297086E+001,
      -7.9463494675020641E+001,
      -7.9448752196187925E+001,
      -7.9433820928806739E+001,
      -7.9418701462337950E+001,
      -7.9403394393672230E+001,
      -7.9387900327106422E+001,
      -7.9372219874319740E+001,
      -7.9356353654349633E+001,
      -7.9340302293567277E+001,
      -7.9324066425652902E+001,
      -7.9307646691570795E+001,
      -7.9291043739543952E+001,
      -7.9274258225028447E+001,
      -7.9257290810687692E+001,
      -7.9240142166366141E+001,
      -7.9222812969062900E+001,
      -7.9205303902905015E+001,
      -7.9187615659120439E+001,
      -7.9169748936010748E+001,
      -7.9151704438923559E+001,
      -7.9133482880224747E+001,
      -7.9115084979270250E+001,
      -7.9096511462377663E+001,
      -7.9077763062797658E+001,
      -7.9058840520684953E+001,
      -7.9039744583069080E+001,
      -7.9020476003824982E+001,
      -7.9001035543643169E+001,
      -7.8981423969999710E+001,
      -7.8961642057125985E+001,
      -7.8941690585977994E+001,
      -7.8921570344205705E+001,
      -7.8901282126121771E+001,
      -7.8880826732670343E+001,
      -7.8860204971395305E+001,
      -7.8839417656408472E+001,
      -7.8818465608357457E+001,
      -7.8797349654393244E+001,
      -7.8776070628137532E+001,
      -7.8754629369649862E+001,
      -7.8733026725394396E+001,
      -7.8711263548206517E+001,
      -7.8689340697259212E+001,
      -7.8667259038029115E+001,
      -7.8645019442262296E+001,
      -7.8622622787939932E+001,
      -7.8600069959243584E+001,
      -7.8577361846520304E+001,
      -7.8554499346247525E+001,
      -7.8531483360997584E+001,
      -7.8508314799402172E+001,
      -7.8484994576116435E+001,
      -7.8461523611782852E+001,
      -7.8437902832994922E+001,
      -7.8414133172260520E+001,
      -7.8390215567965171E+001,
      -7.8366150964334963E+001,
      -7.8341940311399185E+001,
      -7.8317584564953009E+001,
      -7.8293084686519549E+001,
      -7.8268441643312116E+001,
      -7.8243656408195832E+001,
      -7.8218729959649323E+001,
      -7.8193663281726131E+001,
      -7.8168457364015765E+001,
      -7.8143113201604692E+001,
      -7.8117631795037042E+001,
      -7.8092014150275105E+001,
      -7.8066261278659667E+001,
      -7.8040374196870005E+001,
      -7.8014353926883729E+001,
      -7.7988201495936593E+001,
      -7.7961917936481782E+001,
      -7.7935504286149211E+001,
      -7.7908961587704567E+001,
      -7.7882290889008118E+001,
      -7.7855493242973424E+001,
      -7.7828569707525645E+001,
      -7.7801521345559848E+001,
      -7.7774349224899069E+001,
      -7.7747054418252077E+001,
      -7.7719638003171141E+001,
      -7.7692101062009357E+001,
      -7.7664444681878024E+001,
      -7.7636669954603661E+001,
      -7.7608777976684962E+001,
      -7.7580769849249435E+001,
      -7.7552646678009992E+001,
      -7.7524409573221305E+001,
      -7.7496059649635910E+001,
      -7.7467598026460252E+001,
      -7.7439025827310431E+001,
      -7.7410344180168025E+001,
      -7.7381554217335307E+001,
      -7.7352657075390709E+001,
      -7.7323653895143963E+001,
      -7.7294545821590873E+001,
      -7.7265334003868432E+001,
      -7.7236019595209157E+001,
      -7.7206603752895660E+001,
      -7.7177087638215113E+001,
      -7.7147472416413109E+001,
      -7.7117759256647943E+001,
      -7.7087949331944259E+001,
      -7.7058043819146832E+001,
      -7.7028043898874145E+001,
      -7.6997950755471635E+001,
      -7.6967765576965107E+001,
      -7.6937489555013713E+001,
      -7.6907123884862969E+001,
      -7.6876669765297507E+001,
      -7.6846128398593862E+001,
      -7.6815500990472856E+001,
      -7.6784788750052158E+001,
      -7.6753992889798411E+001,
      -7.6723114625479440E+001,
      -7.6692155176116273E+001,
      -7.6661115763934930E+001,
      -7.6629997614318285E+001,
      -7.6598801955757580E+001,
      -7.6567530019803996E+001,
      -7.6536183041020038E+001,
      -7.6504762256930761E+001,
      -7.6473268907974884E+001,
      -7.6441704237455923E+001,
      -7.6410069491493019E+001,
      -7.6378365918971795E+001,
      -7.6346594771494964E+001,
      -7.6314757303333053E+001,
      -7.6282854771374801E+001,
      -7.6250888435077528E+001,
      -7.6218859556417442E+001,
      -7.6186769399839861E+001,
      -7.6154619232209228E+001,
      -7.6122410322759066E+001,
      -7.6090143943042008E+001,
      -7.6057821366879438E+001,
      -7.6025443870311364E+001,
      -7.5993012731545889E+001,
      -7.5960529230908833E+001,
      -7.5927994650793181E+001,
      -7.5895410275608484E+001,
      -7.5862777391730035E+001,
      -7.5830097287448226E+001,
      -7.5797371252917628E+001,
      -7.5764600580106034E+001,
      -7.5731786562743494E+001,
      -7.5698930496271245E+001,
      -7.5666033677790523E+001,
      -7.5633097406011402E+001,
      -7.5600122981201466E+001,
      -7.5567111705134579E+001,
      -7.5534064881039370E+001,
      -7.5500983813547890E+001,
      -7.5467869808644025E+001,
      -7.5434724173611997E+001,
      -7.5401548216984722E+001,
      -7.5368343248492167E+001,
      -7.5335110579009609E+001,
      -7.5301851520505977E+001,
      -7.5268567385991886E+001,
      -7.5235259489468049E+001,
      -7.5201929145873152E+001,
      -7.5168577671032068E+001,
      -7.5135206381603950E+001,
      -7.5101816595030172E+001,
      -7.5068409629482304E+001,
      -7.5034986803810170E+001,
      -7.5001549437489658E+001,
      -7.4968098850570797E+001,
      -7.4934636363625444E+001,
      -7.4901163297695263E+001,
      -7.4867680974239633E+001,
      -7.4834190715083352E+001,
      -7.4800693842364467E+001,
      -7.4767191678482178E+001,
      -7.4733685546044541E+001,
      -7.4700176767816316E+001,
      -7.4666666666666657E+001,
      -7.4633156565517012E+001,
      -7.4599647787288788E+001,
      -7.4566141654851151E+001,
      -7.4532639490968862E+001,
      -7.4499142618249991E+001,
      -7.4465652359093667E+001,
      -7.4432170035638038E+001,
      -7.4398696969707885E+001,
      -7.4365234482762531E+001,
      -7.4331783895843643E+001,
      -7.4298346529523158E+001,
      -7.4264923703851011E+001,
      -7.4231516738303156E+001,
      -7.4198126951729350E+001,
      -7.4164755662301260E+001,
      -7.4131404187460177E+001,
      -7.4098073843865265E+001,
      -7.4064765947341414E+001,
      -7.4031481812827366E+001,
      -7.3998222754323706E+001,
      -7.3964990084841162E+001,
      -7.3931785116348593E+001,
      -7.3898609159721303E+001,
      -7.3865463524689289E+001,
      -7.3832349519785410E+001,
      -7.3799268452293944E+001,
      -7.3766221628198764E+001,
      -7.3733210352131863E+001,
      -7.3700235927321927E+001,
      -7.3667299655542791E+001,
      -7.3634402837062069E+001,
      -7.3601546770589820E+001,
      -7.3568732753227280E+001,
      -7.3535962080415700E+001,
      -7.3503236045885103E+001,
      -7.3470555941603308E+001,
      -7.3437923057724859E+001,
      -7.3405338682540119E+001,
      -7.3372804102424496E+001,
      -7.3340320601787440E+001,
      -7.3307889463021951E+001,
      -7.3275511966453877E+001,
      -7.3243189390291320E+001,
      -7.3210923010574248E+001,
      -7.3178714101124115E+001,
      -7.3146563933493454E+001,
      -7.3114473776915872E+001,
      -7.3082444898255815E+001,
      -7.3050478561958528E+001,
      -7.3018576030000290E+001,
      -7.2986738561838365E+001,
      -7.2954967414361548E+001,
      -7.2923263841840296E+001,
      -7.2891629095877391E+001,
      -7.2860064425358445E+001,
      -7.2828571076402582E+001,
      -7.2797150292313290E+001,
      -7.2765803313529346E+001,
      -7.2734531377575735E+001,
      -7.2703335719015044E+001,
      -7.2672217569398413E+001,
      -7.2641178157217055E+001,
      -7.2610218707853875E+001,
      -7.2579340443534917E+001,
      -7.2548544583281171E+001,
      -7.2517832342860459E+001,
      -7.2487204934739466E+001,
      -7.2456663568035822E+001,
      -7.2426209448470360E+001,
      -7.2395843778319602E+001,
      -7.2365567756368222E+001,
      -7.2335382577861679E+001,
      -7.2305289434459198E+001,
      -7.2275289514186497E+001,
      -7.2245384001389084E+001,
      -7.2215574076685385E+001,
      -7.2185860916920234E+001,
      -7.2156245695118216E+001,
      -7.2126729580437654E+001,
      -7.2097313738124186E+001,
      -7.2067999329464882E+001,
      -7.2038787511742441E+001,
      -7.2009679438189366E+001,
      -7.1980676257942619E+001,
      -7.1951779115998008E+001,
      -7.1922989153165290E+001,
      -7.1894307506022869E+001,
      -7.1865735306873077E+001,
      -7.1837273683697418E+001,
      -7.1808923760112023E+001,
      -7.1780686655323322E+001,
      -7.1752563484083879E+001,
      -7.1724555356648381E+001,
      -7.1696663378729653E+001,
      -7.1668888651455291E+001,
      -7.1641232271323958E+001,
      -7.1613695330162187E+001,
      -7.1586278915081223E+001,
      -7.1558984108434259E+001,
      -7.1531811987773480E+001,
      -7.1504763625807684E+001,
      -7.1477840090359891E+001,
      -7.1451042444325182E+001,
      -7.1424371745628775E+001,
      -7.1397829047184118E+001,
      -7.1371415396851560E+001,
      -7.1345131837396721E+001,
      -7.1318979406449600E+001,
      -7.1292959136463338E+001,
      -7.1267072054673633E+001,
      -7.1241319183058209E+001,
      -7.1215701538296287E+001,
      -7.1190220131728651E+001,
      -7.1164875969317563E+001,
      -7.1139670051607183E+001,
      -7.1114603373683991E+001,
      -7.1089676925137496E+001,
      -7.1064891690021199E+001,
      -7.1040248646813751E+001,
      -7.1015748768380334E+001,
      -7.0991393021934130E+001,
      -7.0967182368998380E+001,
      -7.0943117765368129E+001,
      -7.0919200161072794E+001,
      -7.0895430500338406E+001,
      -7.0871809721550463E+001,
      -7.0848338757216894E+001,
      -7.0825018533931157E+001,
      -7.0801849972335759E+001,
      -7.0778833987085804E+001,
      -7.0755971486812996E+001,
      -7.0733263374089731E+001,
      -7.0710710545393397E+001,
      -7.0688313891071033E+001,
      -7.0666074295304199E+001,
      -7.0643992636074103E+001,
      -7.0622069785126811E+001,
      -7.0600306607938947E+001,
      -7.0578703963683452E+001,
      -7.0557262705195782E+001,
      -7.0535983678940084E+001,
      -7.0514867724975872E+001,
      -7.0493915676924857E+001,
      -7.0473128361938024E+001,
      -7.0452506600662986E+001,
      -7.0432051207211543E+001,
      -7.0411762989127610E+001,
      -7.0391642747355320E+001,
      -7.0371691276207358E+001,
      -7.0351909363333604E+001,
      -7.0332297789690159E+001,
      -7.0312857329508347E+001,
      -7.0293588750264249E+001,
      -7.0274492812648390E+001,
      -7.0255570270535657E+001,
      -7.0236821870955666E+001,
      -7.0218248354063078E+001,
      -7.0199850453108567E+001,
      -7.0181628894409755E+001,
      -7.0163584397322566E+001,
      -7.0145717674212875E+001,
      -7.0128029430428313E+001,
      -7.0110520364270428E+001,
      -7.0093191166967173E+001,
      -7.0076042522645622E+001,
      -7.0059075108304867E+001,
      -7.0042289593789377E+001,
      -7.0025686641762519E+001,
      -7.0009266907680427E+001,
      -6.9993031039766052E+001,
      -6.9976979678983682E+001,
      -6.9961113459013575E+001,
      -6.9945433006226907E+001,
      -6.9929938939661085E+001,
      -6.9914631870995365E+001,
      -6.9899512404526604E+001,
      -6.9884581137145403E+001,
      -6.9869838658312688E+001,
      -6.9855285550036243E+001,
      -6.9840922386847893E+001,
      -6.9826749735780709E+001,
      -6.9812768156346678E+001,
      -6.9798978200514654E+001,
      -6.9785380412688440E+001,
      -6.9771975329685432E+001,
      -6.9758763480715345E+001,
      -6.9745745387359378E+001,
      -6.9732921563549553E+001,
      -6.9720292515548465E+001,
      -6.9707858741929329E+001,
      -6.9695620733556211E+001,
      -6.9683578973564735E+001,
      -6.9671733937342978E+001,
      -6.9660086092512671E+001,
      -6.9648635898910797E+001,
      -6.9637383808571386E+001,
      -6.9626330265707693E+001,
      -6.9615475706694696E+001,
      -6.9604820560051763E+001,
      -6.9594365246425838E+001,
      -6.9584110178574832E+001,
      -6.9574055761351232E+001,
      -6.9564202391686237E+001,
      -6.9554550458573985E+001,
      -6.9545100343056305E+001,
      -6.9535852418207540E+001,
      -6.9526807049119938E+001,
      -6.9517964592889200E+001,
      -6.9509325398600353E+001,
      -6.9500889807313968E+001,
      -6.9492658152052755E+001,
      -6.9484630757788395E+001,
      -6.9476807941428660E+001,
      -6.9469190011804912E+001,
      -6.9461777269660004E+001,
      -6.9454570007636306E+001,
      -6.9447568510264148E+001,
      -6.9440773053950679E+001,
      -6.9434183906968883E+001,
      -6.9427801329446993E+001,
      -6.9421625573358241E+001,
      -6.9415656882510902E+001,
      -6.9409895492538681E+001,
      -6.9404341630891366E+001,
      -6.9398995516825920E+001,
      -6.9393857361397778E+001,
      -6.9388927367452524E+001,
      -6.9384205729617861E+001,
      -6.9379692634295949E+001,
      -6.9375388259656106E+001,
      -6.9371292775627651E+001,
      -6.9367406343893279E+001,
      -6.9363729117882670E+001,
      -6.9360261242766398E+001,
      -6.9357002855450233E+001,
      -6.9353954084569736E+001,
      -6.9351115050485177E+001,
      -6.9348485865276714E+001,
      -6.9346066632740119E+001,
      -6.9343857448382536E+001,
      -6.9341858399418797E+001,
      -6.9340069564767902E+001,
      -6.9338491015049982E+001,
      -6.9337122812583530E+001,
      -6.9335965011382754E+001,
      -6.9335017657155717E+001,
      -6.9334280787302347E+001,
      -6.9333754430912975E+001,
      -6.9333438608767267E+001,
      -6.9333333333333329E+001,
      -6.9333438608767267E+001,
      -6.9333754430912975E+001,
      -6.9334280787302347E+001,
      -6.9335017657155717E+001,
      -6.9335965011382754E+001,
      -6.9337122812583530E+001,
      -6.9338491015049982E+001,
      -6.9340069564767902E+001,
      -6.9341858399418797E+001,
      -6.9343857448382536E+001,
      -6.9346066632740119E+001,
      -6.9348485865276714E+001,
      -6.9351115050485177E+001,
      -6.9353954084569750E+001,
      -6.9357002855450247E+001,
      -6.9360261242766398E+001,
      -6.9363729117882670E+001,
      -6.9367406343893279E+001,
      -6.9371292775627651E+001,
      -6.9375388259656106E+001,
      -6.9379692634295949E+001,
      -6.9384205729617861E+001,
      -6.9388927367452524E+001,
      -6.9393857361397778E+001,
      -6.9398995516825920E+001,
      -6.9404341630891366E+001,
      -6.9409895492538666E+001,
      -6.9415656882510902E+001,
      -6.9421625573358227E+001,
      -6.9427801329446993E+001,
      -6.9434183906968883E+001,
      -6.9440773053950679E+001,
      -6.9447568510264148E+001,
      -6.9454570007636292E+001,
      -6.9461777269660004E+001,
      -6.9469190011804912E+001,
      -6.9476807941428660E+001,
      -6.9484630757788395E+001,
      -6.9492658152052755E+001,
      -6.9500889807313968E+001,
      -6.9509325398600353E+001,
      -6.9517964592889200E+001,
      -6.9526807049119938E+001,
      -6.9535852418207540E+001,
      -6.9545100343056291E+001,
      -6.9554550458573999E+001,
      -6.9564202391686237E+001,
      -6.9574055761351232E+001,
      -6.9584110178574818E+001,
      -6.9594365246425838E+001,
      -6.9604820560051763E+001,
      -6.9615475706694681E+001,
      -6.9626330265707693E+001,
      -6.9637383808571386E+001,
      -6.9648635898910797E+001,
      -6.9660086092512657E+001,
      -6.9671733937342978E+001,
      -6.9683578973564735E+001,
      -6.9695620733556211E+001,
      -6.9707858741929329E+001,
      -6.9720292515548465E+001,
      -6.9732921563549553E+001,
      -6.9745745387359378E+001,
      -6.9758763480715345E+001,
      -6.9771975329685418E+001,
      -6.9785380412688440E+001,
      -6.9798978200514654E+001,
      -6.9812768156346678E+001,
      -6.9826749735780709E+001,
      -6.9840922386847893E+001,
      -6.9855285550036257E+001,
      -6.9869838658312688E+001,
      -6.9884581137145403E+001,
      -6.9899512404526604E+001,
      -6.9914631870995365E+001,
      -6.9929938939661085E+001,
      -6.9945433006226907E+001,
      -6.9961113459013575E+001,
      -6.9976979678983696E+001,
      -6.9993031039766066E+001,
      -7.0009266907680413E+001,
      -7.0025686641762519E+001,
      -7.0042289593789377E+001,
      -7.0059075108304867E+001,
      -7.0076042522645608E+001,
      -7.0093191166967188E+001,
      -7.0110520364270428E+001,
      -7.0128029430428299E+001,
      -7.0145717674212889E+001,
      -7.0163584397322566E+001,
      -7.0181628894409769E+001,
      -7.0199850453108567E+001,
      -7.0218248354063093E+001,
      -7.0236821870955680E+001,
      -7.0255570270535671E+001,
      -7.0274492812648390E+001,
      -7.0293588750264249E+001,
      -7.0312857329508361E+001,
      -7.0332297789690159E+001,
      -7.0351909363333604E+001,
      -7.0371691276207343E+001,
      -7.0391642747355320E+001,
      -7.0411762989127624E+001,
      -7.0432051207211543E+001,
      -7.0452506600662986E+001,
      -7.0473128361938024E+001,
      -7.0493915676924871E+001,
      -7.0514867724975858E+001,
      -7.0535983678940084E+001,
      -7.0557262705195797E+001,
      -7.0578703963683466E+001,
      -7.0600306607938933E+001,
      -7.0622069785126811E+001,
      -7.0643992636074088E+001,
      -7.0666074295304213E+001,
      -7.0688313891071033E+001,
      -7.0710710545393383E+001,
      -7.0733263374089731E+001,
      -7.0755971486812996E+001,
      -7.0778833987085804E+001,
      -7.0801849972335731E+001,
      -7.0825018533931157E+001,
      -7.0848338757216908E+001,
      -7.0871809721550477E+001,
      -7.0895430500338421E+001,
      -7.0919200161072780E+001,
      -7.0943117765368143E+001,
      -7.0967182368998351E+001,
      -7.0991393021934144E+001,
      -7.1015748768380320E+001,
      -7.1040248646813751E+001,
      -7.1064891690021199E+001,
      -7.1089676925137496E+001,
      -7.1114603373684005E+001,
      -7.1139670051607183E+001,
      -7.1164875969317563E+001,
      -7.1190220131728623E+001,
      -7.1215701538296287E+001,
      -7.1241319183058224E+001,
      -7.1267072054673648E+001,
      -7.1292959136463338E+001,
      -7.1318979406449586E+001,
      -7.1345131837396735E+001,
      -7.1371415396851546E+001,
      -7.1397829047184132E+001,
      -7.1424371745628747E+001,
      -7.1451042444325196E+001,
      -7.1477840090359919E+001,
      -7.1504763625807684E+001,
      -7.1531811987773452E+001,
      -7.1558984108434259E+001,
      -7.1586278915081238E+001,
      -7.1613695330162159E+001,
      -7.1641232271323958E+001,
      -7.1668888651455291E+001,
      -7.1696663378729667E+001,
      -7.1724555356648352E+001,
      -7.1752563484083893E+001,
      -7.1780686655323350E+001,
      -7.1808923760112009E+001,
      -7.1837273683697433E+001,
      -7.1865735306873077E+001,
      -7.1894307506022898E+001,
      -7.1922989153165290E+001,
      -7.1951779115998008E+001,
      -7.1980676257942591E+001,
      -7.2009679438189380E+001,
      -7.2038787511742456E+001,
      -7.2067999329464882E+001,
      -7.2097313738124186E+001,
      -7.2126729580437640E+001,
      -7.2156245695118230E+001,
      -7.2185860916920205E+001,
      -7.2215574076685400E+001,
      -7.2245384001389098E+001,
      -7.2275289514186497E+001,
      -7.2305289434459212E+001,
      -7.2335382577861679E+001,
      -7.2365567756368236E+001,
      -7.2395843778319602E+001,
      -7.2426209448470374E+001,
      -7.2456663568035793E+001,
      -7.2487204934739481E+001,
      -7.2517832342860473E+001,
      -7.2548544583281171E+001,
      -7.2579340443534903E+001,
      -7.2610218707853875E+001,
      -7.2641178157217070E+001,
      -7.2672217569398384E+001,
      -7.2703335719015058E+001,
      -7.2734531377575763E+001,
      -7.2765803313529332E+001,
      -7.2797150292313262E+001,
      -7.2828571076402568E+001,
      -7.2860064425358459E+001,
      -7.2891629095877391E+001,
      -7.2923263841840310E+001,
      -7.2954967414361533E+001,
      -7.2986738561838379E+001,
      -7.3018576030000261E+001,
      -7.3050478561958542E+001,
      -7.3082444898255801E+001,
      -7.3114473776915887E+001,
      -7.3146563933493468E+001,
      -7.3178714101124100E+001,
      -7.3210923010574263E+001,
      -7.3243189390291306E+001,
      -7.3275511966453877E+001,
      -7.3307889463021951E+001,
      -7.3340320601787440E+001,
      -7.3372804102424510E+001,
      -7.3405338682540133E+001,
      -7.3437923057724859E+001,
      -7.3470555941603294E+001,
      -7.3503236045885075E+001,
      -7.3535962080415700E+001,
      -7.3568732753227295E+001,
      -7.3601546770589806E+001,
      -7.3634402837062069E+001,
      -7.3667299655542806E+001,
      -7.3700235927321927E+001,
      -7.3733210352131834E+001,
      -7.3766221628198736E+001,
      -7.3799268452293958E+001,
      -7.3832349519785410E+001,
      -7.3865463524689289E+001,
      -7.3898609159721346E+001,
      -7.3931785116348607E+001,
      -7.3964990084841148E+001,
      -7.3998222754323706E+001,
      -7.4031481812827323E+001,
      -7.4064765947341414E+001,
      -7.4098073843865293E+001,
      -7.4131404187460177E+001,
      -7.4164755662301260E+001,
      -7.4198126951729350E+001,
      -7.4231516738303156E+001,
      -7.4264923703850997E+001,
      -7.4298346529523158E+001,
      -7.4331783895843671E+001,
      -7.4365234482762531E+001,
      -7.4398696969707899E+001,
      -7.4432170035638038E+001,
      -7.4465652359093681E+001,
      -7.4499142618249977E+001,
      -7.4532639490968862E+001,
      -7.4566141654851137E+001,
      -7.4599647787288788E+001,
      -7.4633156565517041E+001,
      -7.4666666666666657E+001,
      -7.4700176767816316E+001,
      -7.4733685546044541E+001,
      -7.4767191678482178E+001,
      -7.4800693842364453E+001,
      -7.4834190715083352E+001,
      -7.4867680974239676E+001,
      -7.4901163297695263E+001,
      -7.4934636363625415E+001,
      -7.4968098850570797E+001,
      -7.5001549437489672E+001,
      -7.5034986803810156E+001,
      -7.5068409629482304E+001,
      -7.5101816595030158E+001,
      -7.5135206381603965E+001,
      -7.5168577671032054E+001,
      -7.5201929145873152E+001,
      -7.5235259489468035E+001,
      -7.5268567385991886E+001,
      -7.5301851520505977E+001,
      -7.5335110579009609E+001,
      -7.5368343248492181E+001,
      -7.5401548216984722E+001,
      -7.5434724173612011E+001,
      -7.5467869808644011E+001,
      -7.5500983813547890E+001,
      -7.5534064881039399E+001,
      -7.5567111705134565E+001,
      -7.5600122981201480E+001,
      -7.5633097406011373E+001,
      -7.5666033677790537E+001,
      -7.5698930496271231E+001,
      -7.5731786562743508E+001,
      -7.5764600580106006E+001,
      -7.5797371252917628E+001,
      -7.5830097287448240E+001,
      -7.5862777391730020E+001,
      -7.5895410275608455E+001,
      -7.5927994650793181E+001,
      -7.5960529230908847E+001,
      -7.5993012731545875E+001,
      -7.6025443870311378E+001,
      -7.6057821366879480E+001,
      -7.6090143943041994E+001,
      -7.6122410322759038E+001,
      -7.6154619232209214E+001,
      -7.6186769399839889E+001,
      -7.6218859556417442E+001,
      -7.6250888435077528E+001,
      -7.6282854771374787E+001,
      -7.6314757303333053E+001,
      -7.6346594771494935E+001,
      -7.6378365918971781E+001,
      -7.6410069491493005E+001,
      -7.6441704237455923E+001,
      -7.6473268907974898E+001,
      -7.6504762256930746E+001,
      -7.6536183041020053E+001,
      -7.6567530019803982E+001,
      -7.6598801955757580E+001,
      -7.6629997614318270E+001,
      -7.6661115763934930E+001,
      -7.6692155176116287E+001,
      -7.6723114625479440E+001,
      -7.6753992889798425E+001,
      -7.6784788750052158E+001,
      -7.6815500990472870E+001,
      -7.6846128398593848E+001,
      -7.6876669765297507E+001,
      -7.6907123884862955E+001,
      -7.6937489555013713E+001,
      -7.6967765576965121E+001,
      -7.6997950755471635E+001,
      -7.7028043898874117E+001,
      -7.7058043819146832E+001,
      -7.7087949331944259E+001,
      -7.7117759256647929E+001,
      -7.7147472416413109E+001,
      -7.7177087638215127E+001,
      -7.7206603752895674E+001,
      -7.7236019595209129E+001,
      -7.7265334003868432E+001,
      -7.7294545821590887E+001,
      -7.7323653895143948E+001,
      -7.7352657075390738E+001,
      -7.7381554217335292E+001,
      -7.7410344180168039E+001,
      -7.7439025827310431E+001,
      -7.7467598026460237E+001,
      -7.7496059649635896E+001,
      -7.7524409573221305E+001,
      -7.7552646678010007E+001,
      -7.7580769849249435E+001,
      -7.7608777976684962E+001,
      -7.7636669954603661E+001,
      -7.7664444681878038E+001,
      -7.7692101062009343E+001,
      -7.7719638003171141E+001,
      -7.7747054418252105E+001,
      -7.7774349224899069E+001,
      -7.7801521345559863E+001,
      -7.7828569707525645E+001,
      -7.7855493242973438E+001,
      -7.7882290889008118E+001,
      -7.7908961587704567E+001,
      -7.7935504286149197E+001,
      -7.7961917936481782E+001,
      -7.7988201495936607E+001,
      -7.8014353926883729E+001,
      -7.8040374196869976E+001,
      -7.8066261278659667E+001,
      -7.8092014150275119E+001,
      -7.8117631795037028E+001,
      -7.8143113201604692E+001,
      -7.8168457364015765E+001,
      -7.8193663281726145E+001,
      -7.8218729959649323E+001,
      -7.8243656408195832E+001,
      -7.8268441643312130E+001,
      -7.8293084686519549E+001,
      -7.8317584564953009E+001,
      -7.8341940311399185E+001,
      -7.8366150964334963E+001,
      -7.8390215567965171E+001,
      -7.8414133172260520E+001,
      -7.8437902832994908E+001,
      -7.8461523611782852E+001,
      -7.8484994576116449E+001,
      -7.8508314799402157E+001,
      -7.8531483360997584E+001,
      -7.8554499346247525E+001,
      -7.8577361846520319E+001,
      -7.8600069959243569E+001,
      -7.8622622787939932E+001,
      -7.8645019442262296E+001,
      -7.8667259038029115E+001,
      -7.8689340697259226E+001,
      -7.8711263548206517E+001,
      -7.8733026725394396E+001,
      -7.8754629369649862E+001,
      -7.8776070628137546E+001,
      -7.8797349654393244E+001,
      -7.8818465608357457E+001,
      -7.8839417656408486E+001,
      -7.8860204971395305E+001,
      -7.8880826732670329E+001,
      -7.8901282126121771E+001,
      -7.8921570344205705E+001,
      -7.8941690585977994E+001,
      -7.8961642057125985E+001,
      -7.8981423969999696E+001,
      -7.9001035543643169E+001,
      -7.9020476003824967E+001,
      -7.9039744583069080E+001,
      -7.9058840520684939E+001,
      -7.9077763062797658E+001,
      -7.9096511462377663E+001,
      -7.9115084979270236E+001,
      -7.9133482880224761E+001,
      -7.9151704438923559E+001,
      -7.9169748936010734E+001,
      -7.9187615659120425E+001,
      -7.9205303902905015E+001,
      -7.9222812969062915E+001,
      -7.9240142166366141E+001,
      -7.9257290810687692E+001,
      -7.9274258225028447E+001,
      -7.9291043739543952E+001,
      -7.9307646691570781E+001,
      -7.9324066425652902E+001,
      -7.9340302293567262E+001,
      -7.9356353654349633E+001,
      -7.9372219874319754E+001,
      -7.9387900327106422E+001,
      -7.9403394393672230E+001,
      -7.9418701462337950E+001,
      -7.9433820928806739E+001,
      -7.9448752196187911E+001,
      -7.9463494675020641E+001,
      -7.9478047783297086E+001,
      -7.9492410946485435E+001,
      -7.9506583597552620E+001,
      -7.9520565176986636E+001,
      -7.9534355132818689E+001,
      -7.9547952920644889E+001,
      -7.9561358003647896E+001,
      -7.9574569852617955E+001,
      -7.9587587945973937E+001,
      -7.9600411769783761E+001,
      -7.9613040817784849E+001,
      -7.9625474591404000E+001,
      -7.9637712599777117E+001,
      -7.9649754359768608E+001,
      -7.9661599395990351E+001,
      -7.9673247240820672E+001,
      -7.9684697434422532E+001,
      -7.9695949524761943E+001,
      -7.9707003067625607E+001,
      -7.9717857626638633E+001,
      -7.9728512773281579E+001,
      -7.9738968086907477E+001,
      -7.9749223154758496E+001,
      -7.9759277571982082E+001,
      -7.9769130941647092E+001,
      -7.9778782874759330E+001,
      -7.9788232990277024E+001,
      -7.9797480915125789E+001,
      -7.9806526284213376E+001,
      -7.9815368740444114E+001,
      -7.9824007934732975E+001,
      -7.9832443526019361E+001,
      -7.9840675181280560E+001,
      -7.9848702575544920E+001,
      -7.9856525391904668E+001,
      -7.9864143321528402E+001,
      -7.9871556063673310E+001,
      -7.9878763325697022E+001,
      -7.9885764823069195E+001,
      -7.9892560279382636E+001,
      -7.9899149426364446E+001,
      -7.9905532003886336E+001,
      -7.9911707759975087E+001,
      -7.9917676450822427E+001,
      -7.9923437840794662E+001,
      -7.9928991702441962E+001,
      -7.9934337816507394E+001,
      -7.9939475971935536E+001,
      -7.9944405965880790E+001,
      -7.9949127603715468E+001,
      -7.9953640699037365E+001,
      -7.9957945073677209E+001,
      -7.9962040557705677E+001,
      -7.9965926989440050E+001,
      -7.9969604215450659E+001,
      -7.9973072090566930E+001,
      -7.9976330477883096E+001,
      -7.9979379248763578E+001,
      -7.9982218282848152E+001,
      -7.9984847468056600E+001,
      -7.9987266700593196E+001,
      -7.9989475884950778E+001,
      -7.9991474933914532E+001,
      -7.9993263768565413E+001,
      -7.9994842318283318E+001,
      -7.9996210520749798E+001,
      -7.9997368321950560E+001,
      -7.9998315676177597E+001,
      -7.9999052546030967E+001,
      -7.9999578902420353E+001,
      -7.9999894724566062E+001,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -80.0,
      -79.99995,
      -7.9999800000000008E+001,
      -79.99955,
      -79.9992,
      -79.99875,
      -79.9982,
      -79.99755,
      -7.99968E+001,
      -7.999595E+001,
      -7.9994999999999990E+001,
      -79.99395,
      -79.9928,
      -79.99155,
      -79.9902,
      -79.98875,
      -79.9872,
      -7.9985549999999989E+001,
      -79.9838,
      -79.98195,
      -79.98,
      -7.9977949999999993E+001,
      -7.99758E+001,
      -79.97355,
      -79.9712,
      -79.96875,
      -79.9662,
      -79.96355,
      -7.9960799999999992E+001,
      -79.95795,
      -79.955,
      -7.9951950000000011E+001,
      -7.9948799999999991E+001,
      -79.94555,
      -79.9422,
      -79.93875,
      -79.9352,
      -79.93155,
      -7.99278E+001,
      -7.992395E+001,
      -7.9919999999999987E+001,
      -7.9915950000000009E+001,
      -79.9118,
      -79.90755,
      -79.9032,
      -7.9898749999999993E+001,
      -79.8942,
      -79.88955,
      -79.8848,
      -7.9879950000000008E+001,
      -79.875,
      -79.86995,
      -79.8648,
      -79.85955,
      -7.98542E+001,
      -79.84875,
      -7.9843200000000010E+001,
      -7.9837550000000007E+001,
      -79.8318,
      -7.9825949999999992E+001,
      -7.9820000000000007E+001,
      -7.981395E+001,
      -79.8078,
      -7.980155E+001,
      -7.9795200000000008E+001,
      -7.9788750000000007E+001,
      -79.7822,
      -79.77555,
      -79.7688,
      -79.76195,
      -79.755,
      -79.74795,
      -7.9740800000000007E+001,
      -7.973355E+001,
      -7.9726199999999992E+001,
      -79.71875,
      -7.97112E+001,
      -7.9703549999999993E+001,
      -7.9695799999999991E+001,
      -79.68795,
      -7.968E+001,
      -7.9671950000000010E+001,
      -7.9663800000000009E+001,
      -7.9655549999999991E+001,
      -79.6472,
      -79.63875,
      -79.6302,
      -7.9621550000000013E+001,
      -7.96128E+001,
      -79.60395,
      -79.595,
      -7.9585950000000011E+001,
      -7.9576799999999992E+001,
      -79.56755,
      -79.5582,
      -79.54875,
      -7.95392E+001,
      -79.52955,
      -7.9519799999999989E+001,
      -7.9509949999999989E+001,
      -79.5,
      -7.9490000000000009E+001,
      -79.48,
      -7.9470000000000013E+001,
      -7.946E+001,
      -7.9449999999999989E+001,
      -79.44,
      -7.9429999999999993E+001,
      -79.42,
      -79.41,
      -7.94E+001,
      -79.39,
      -79.38,
      -7.937E+001,
      -79.36,
      -7.9350000000000009E+001,
      -79.34,
      -7.9330000000000013E+001,
      -7.9320000000000007E+001,
      -7.9309999999999988E+001,
      -79.3,
      -7.9289999999999992E+001,
      -79.28,
      -79.27,
      -7.9259999999999991E+001,
      -79.25,
      -79.24,
      -79.23,
      -79.22,
      -7.9210000000000008E+001,
      -79.2,
      -79.19,
      -7.918E+001,
      -79.17,
      -79.16,
      -7.9149999999999991E+001,
      -79.14,
      -79.13,
      -7.9119999999999990E+001,
      -79.11,
      -7.91E+001,
      -79.09,
      -79.08,
      -7.9070000000000007E+001,
      -79.06,
      -79.05,
      -7.904E+001,
      -79.03,
      -7.9020000000000010E+001,
      -7.9009999999999991E+001,
      -79.0,
      -78.99,
      -7.8979999999999990E+001,
      -78.97,
      -7.896E+001,
      -78.95,
      -78.94,
      -7.893E+001,
      -78.92,
      -78.91,
      -7.89E+001,
      -78.89,
      -7.8880000000000010E+001,
      -7.887E+001,
      -7.8860000000000014E+001,
      -7.885E+001,
      -7.8839999999999989E+001,
      -78.83,
      -7.882E+001,
      -78.81,
      -78.8,
      -7.8789999999999992E+001,
      -78.78,
      -78.77,
      -7.876E+001,
      -78.75,
      -7.8740000000000009E+001,
      -78.73,
      -78.72,
      -7.8710000000000008E+001,
      -7.8699999999999989E+001,
      -78.69,
      -7.8679999999999993E+001,
      -78.67,
      -78.66,
      -7.8649999999999991E+001,
      -78.64,
      -78.63,
      -7.862E+001,
      -78.61,
      -7.8600000000000009E+001,
      -78.59,
      -78.58,
      -7.8570000000000007E+001,
      -78.56,
      -78.55,
      -7.8539999999999992E+001,
      -78.53,
      -78.52,
      -7.8509999999999991E+001,
      -78.5,
      -78.49,
      -78.48,
      -78.47,
      -7.8460000000000008E+001,
      -78.45,
      -78.44,
      -7.843E+001,
      -78.42,
      -7.8410000000000011E+001,
      -7.8399999999999991E+001,
      -78.39,
      -78.38,
      -7.8369999999999990E+001,
      -78.36,
      -7.835E+001,
      -78.34,
      -78.33,
      -7.832E+001,
      -78.31,
      -78.3,
      -7.829E+001,
      -78.28,
      -7.8270000000000010E+001,
      -7.826E+001,
      -7.8249999999999986E+001,
      -78.24,
      -7.8229999999999990E+001,
      -78.22,
      -7.821E+001,
      -78.2,
      -78.19,
      -7.8179999999999993E+001,
      -78.17,
      -78.16,
      -7.815E+001,
      -78.14,
      -7.8130000000000010E+001,
      -7.812E+001,
      -78.11,
      -7.8100000000000009E+001,
      -7.8089999999999989E+001,
      -78.08,
      -7.807E+001,
      -78.06,
      -78.05,
      -7.8039999999999992E+001,
      -78.03,
      -78.02,
      -7.801E+001,
      -78.0,
      -7.7990000000000009E+001,
      -77.98,
      -77.97,
      -7.7960000000000008E+001,
      -77.95,
      -77.94,
      -7.7929999999999993E+001,
      -77.92,
      -77.91,
      -7.7899999999999991E+001,
      -77.89,
      -77.88,
      -7.787E+001,
      -77.86,
      -7.785E+001,
      -77.84,
      -77.83,
      -7.7820000000000007E+001,
      -77.81,
      -7.7800000000000011E+001,
      -7.7789999999999992E+001,
      -77.78,
      -77.77,
      -7.7759999999999991E+001,
      -77.75,
      -77.74,
      -77.73,
      -77.72,
      -7.771E+001,
      -77.7,
      -77.69,
      -7.768E+001,
      -77.67,
      -7.7660000000000011E+001,
      -7.765E+001,
      -7.7639999999999986E+001,
      -77.63,
      -7.7619999999999990E+001,
      -77.61,
      -7.76E+001,
      -77.59,
      -77.58,
      -7.757E+001,
      -77.56,
      -77.55,
      -7.754E+001,
      -77.53,
      -7.7520000000000010E+001,
      -7.751E+001,
      -77.5,
      -7.7490000000000009E+001,
      -7.7479999999999990E+001,
      -77.47,
      -7.746E+001,
      -77.45,
      -77.44,
      -7.7429999999999993E+001,
      -77.42,
      -77.41,
      -7.74E+001,
      -77.39,
      -7.7380000000000010E+001,
      -7.737E+001,
      -77.36,
      -7.7350000000000009E+001,
      -77.34,
      -77.33,
      -7.732E+001,
      -77.31,
      -77.3,
      -7.7289999999999992E+001,
      -77.28,
      -77.27,
      -7.726E+001,
      -77.25,
      -77.24,
      -77.23,
      -77.22,
      -7.7210000000000008E+001,
      -77.2,
      -7.7190000000000012E+001,
      -7.7179999999999993E+001,
      -7.7169999999999987E+001,
      -77.16,
      -7.7149999999999991E+001,
      -77.14,
      -77.13,
      -7.712E+001,
      -77.11,
      -7.71E+001,
      -77.09,
      -77.08,
      -7.7070000000000007E+001,
      -77.06,
      -7.7050000000000011E+001,
      -7.704E+001,
      -7.7029999999999987E+001,
      -77.02,
      -7.7009999999999991E+001,
      -77.0,
      -76.99,
      -76.98,
      -76.97,
      -7.696E+001,
      -76.95,
      -76.94,
      -7.693E+001,
      -76.92,
      -76.91,
      -7.69E+001,
      -76.89,
      -7.6880000000000010E+001,
      -7.6869999999999990E+001,
      -76.86,
      -7.685E+001,
      -76.84,
      -76.83,
      -7.682E+001,
      -76.81,
      -76.8,
      -7.679E+001,
      -76.78,
      -76.77,
      -7.676E+001,
      -76.75,
      -7.6740000000000009E+001,
      -76.73,
      -76.72,
      -7.671E+001,
      -7.6699999999999989E+001,
      -76.69,
      -7.6679999999999993E+001,
      -76.67,
      -76.66,
      -7.665E+001,
      -76.64,
      -76.63,
      -7.662E+001,
      -76.61,
      -7.6600000000000009E+001,
      -76.59,
      -7.6580000000000013E+001,
      -7.657E+001,
      -7.6559999999999988E+001,
      -76.55,
      -7.6539999999999992E+001,
      -76.53,
      -76.52,
      -7.651E+001,
      -76.5,
      -76.49,
      -76.48,
      -76.47,
      -7.6460000000000008E+001,
      -76.45,
      -7.6440000000000012E+001,
      -7.643E+001,
      -7.6419999999999987E+001,
      -76.41,
      -7.6399999999999991E+001,
      -76.39,
      -76.38,
      -7.637E+001,
      -76.36,
      -7.635E+001,
      -76.34,
      -76.33,
      -7.6320000000000007E+001,
      -76.31,
      -76.3,
      -7.629E+001,
      -76.28,
      -7.6270000000000010E+001,
      -7.6259999999999991E+001,
      -76.25,
      -76.24,
      -7.6229999999999990E+001,
      -76.22,
      -7.621E+001,
      -76.2,
      -76.19,
      -7.618E+001,
      -76.17,
      -76.16,
      -7.615E+001,
      -76.14,
      -7.6130000000000010E+001,
      -7.612E+001,
      -76.11,
      -7.61E+001,
      -7.6089999999999989E+001,
      -76.08,
      -7.607E+001,
      -76.06,
      -76.05,
      -7.604E+001,
      -76.03,
      -76.02,
      -7.601E+001,
      -76.0,
      -7.5990000000000009E+001,
      -75.98,
      -7.5970000000000013E+001,
      -7.596E+001,
      -7.5949999999999989E+001,
      -75.94,
      -7.5929999999999993E+001,
      -75.92,
      -75.91,
      -7.59E+001,
      -75.89,
      -75.88,
      -7.587E+001,
      -75.86,
      -7.5850000000000009E+001,
      -75.84,
      -75.83,
      -7.5820000000000007E+001,
      -7.5809999999999988E+001,
      -75.8,
      -7.5789999999999992E+001,
      -75.78,
      -75.77,
      -7.576E+001,
      -75.75,
      -75.74,
      -75.73,
      -75.72,
      -7.5710000000000008E+001,
      -75.7,
      -75.69,
      -7.568E+001,
      -75.67,
      -7.5660000000000011E+001,
      -7.5649999999999991E+001,
      -75.64,
      -75.63,
      -7.5619999999999990E+001,
      -75.61,
      -7.56E+001,
      -75.59,
      -75.58,
      -7.5570000000000007E+001,
      -75.56,
      -75.55,
      -7.554E+001,
      -75.53,
      -7.5520000000000010E+001,
      -7.551E+001,
      -7.5499999999999986E+001,
      -75.49,
      -7.5479999999999990E+001,
      -75.47,
      -7.546E+001,
      -75.45,
      -75.44,
      -7.543E+001,
      -75.42,
      -75.41,
      -7.54E+001,
      -75.39,
      -7.5380000000000010E+001,
      -7.537E+001,
      -75.36,
      -7.535E+001,
      -7.5339999999999989E+001,
      -75.33,
      -7.532E+001,
      -75.31,
      -75.3,
      -7.529E+001,
      -75.28,
      -75.27,
      -7.526E+001,
      -75.25,
      -7.5240000000000009E+001,
      -75.23,
      -75.22,
      -7.5210000000000008E+001,
      -7.5199999999999989E+001,
      -75.19,
      -7.5179999999999993E+001,
      -75.17,
      -75.16,
      -7.5149999999999991E+001,
      -75.14,
      -75.13,
      -7.512E+001,
      -75.11,
      -7.5100000000000009E+001,
      -75.09,
      -75.08,
      -7.5070000000000007E+001,
      -75.06,
      -7.5050000000000011E+001,
      -7.5039999999999992E+001,
      -7.5029999999999987E+001,
      -75.02,
      -7.5009999999999991E+001,
      -75.0,
      -74.99,
      -74.98,
      -74.97,
      -7.4960000000000008E+001,
      -74.95,
      -74.94,
      -7.493E+001,
      -74.92,
      -7.4910000000000011E+001,
      -7.49E+001,
      -7.4889999999999986E+001,
      -74.88,
      -7.4869999999999990E+001,
      -74.86,
      -7.485E+001,
      -74.84,
      -74.83,
      -7.4820000000000007E+001,
      -74.81,
      -74.8,
      -7.479E+001,
      -74.78,
      -7.4770000000000010E+001,
      -7.476E+001,
      -74.75,
      -74.74,
      -7.4729999999999990E+001,
      -74.72,
      -7.471E+001,
      -74.7,
      -74.69,
      -7.468E+001,
      -74.67,
      -74.66,
      -7.465E+001,
      -74.64,
      -7.4630000000000010E+001,
      -7.462E+001,
      -74.61,
      -7.4600000000000009E+001,
      -7.4589999999999989E+001,
      -74.58,
      -7.457E+001,
      -7.4559999999999988E+001,
      -74.55,
      -7.4539999999999992E+001,
      -74.53,
      -74.52,
      -7.451E+001,
      -74.5,
      -7.4490000000000009E+001,
      -74.48,
      -74.47,
      -7.4460000000000008E+001,
      -74.45,
      -7.4440000000000012E+001,
      -7.4429999999999993E+001,
      -7.4419999999999987E+001,
      -74.41,
      -7.4399999999999991E+001,
      -74.39,
      -74.38,
      -7.437E+001,
      -74.36,
      -7.4350000000000009E+001,
      -74.34,
      -74.33,
      -7.4320000000000007E+001,
      -74.31,
      -7.4300000000000011E+001,
      -7.429E+001,
      -7.4279999999999987E+001,
      -74.27,
      -7.4259999999999991E+001,
      -74.25,
      -74.24,
      -74.23,
      -74.22,
      -7.421E+001,
      -74.2,
      -74.19,
      -7.418E+001,
      -74.17,
      -7.4160000000000011E+001,
      -7.415E+001,
      -74.14,
      -74.13,
      -7.4119999999999990E+001,
      -74.11,
      -7.41E+001,
      -7.4089999999999989E+001,
      -74.08,
      -7.407E+001,
      -74.06,
      -74.05,
      -7.404E+001,
      -74.03,
      -7.4020000000000010E+001,
      -7.401E+001,
      -74.0,
      -7.3990000000000009E+001,
      -7.3979999999999990E+001,
      -73.97,
      -7.396E+001,
      -7.3949999999999989E+001,
      -73.94,
      -7.3929999999999993E+001,
      -73.92,
      -73.91,
      -7.39E+001,
      -73.89,
      -7.3880000000000010E+001,
      -7.387E+001,
      -73.86,
      -7.3850000000000009E+001,
      -73.84,
      -7.3830000000000013E+001,
      -7.382E+001,
      -7.3809999999999988E+001,
      -73.8,
      -7.3789999999999992E+001,
      -73.78,
      -73.77,
      -7.3759999999999991E+001,
      -73.75,
      -73.74,
      -73.73,
      -73.72,
      -7.3710000000000008E+001,
      -73.7,
      -7.3690000000000012E+001,
      -7.368E+001,
      -7.3669999999999987E+001,
      -73.66,
      -7.3649999999999991E+001,
      -73.64,
      -73.63,
      -7.362E+001,
      -73.61,
      -7.36E+001,
      -73.59,
      -73.58,
      -7.3570000000000007E+001,
      -73.56,
      -7.3550000000000011E+001,
      -7.354E+001,
      -73.53,
      -73.52,
      -7.3509999999999991E+001,
      -73.5,
      -73.49,
      -7.3479999999999990E+001,
      -73.47,
      -7.346E+001,
      -73.45,
      -73.44,
      -7.343E+001,
      -73.42,
      -7.3410000000000011E+001,
      -7.34E+001,
      -73.39,
      -7.3380000000000010E+001,
      -7.3369999999999990E+001,
      -73.36,
      -7.335E+001,
      -7.3339999999999989E+001,
      -73.33,
      -7.332E+001,
      -73.31,
      -73.3,
      -7.329E+001,
      -73.28,
      -7.3270000000000010E+001,
      -7.326E+001,
      -73.25,
      -7.3240000000000009E+001,
      -73.23,
      -7.3220000000000013E+001,
      -7.321E+001,
      -7.3199999999999989E+001,
      -73.19,
      -7.3179999999999993E+001,
      -73.17,
      -73.16,
      -7.3149999999999991E+001,
      -73.14,
      -73.13,
      -7.312E+001,
      -73.11,
      -7.3100000000000009E+001,
      -73.09,
      -7.3080000000000013E+001,
      -7.3070000000000007E+001,
      -7.3059999999999988E+001,
      -73.05,
      -7.3039999999999992E+001,
      -73.03,
      -73.02,
      -7.3009999999999991E+001,
      -73.0,
      -72.99,
      -72.98,
      -72.97,
      -7.2960000000000008E+001,
      -72.95,
      -7.2940000000000012E+001,
      -7.293E+001,
      -72.92,
      -72.91,
      -7.2899999999999991E+001,
      -72.89,
      -72.88,
      -7.2869999999999990E+001,
      -72.86,
      -7.285E+001,
      -72.84,
      -72.83,
      -7.2820000000000007E+001,
      -72.81,
      -72.8,
      -7.279E+001,
      -72.78,
      -7.2770000000000010E+001,
      -7.2759999999999991E+001,
      -72.75,
      -72.74,
      -7.2729999999999990E+001,
      -72.72,
      -7.271E+001,
      -72.7,
      -72.69,
      -7.2679999999999993E+001,
      -72.67,
      -72.66,
      -7.265E+001,
      -72.64,
      -7.2630000000000010E+001,
      -7.262E+001,
      -7.2610000000000014E+001,
      -7.26E+001,
      -7.2589999999999989E+001,
      -72.58,
      -7.257E+001,
      -72.56,
      -72.55,
      -7.2539999999999992E+001,
      -72.53,
      -72.52,
      -7.251E+001,
      -72.5,
      -7.2490000000000009E+001,
      -72.48,
      -7.2470000000000013E+001,
      -7.2460000000000008E+001,
      -7.2449999999999989E+001,
      -72.44,
      -7.2429999999999993E+001,
      -72.42,
      -72.41,
      -7.2399999999999991E+001,
      -72.39,
      -72.38,
      -7.237E+001,
      -72.36,
      -7.2350000000000009E+001,
      -72.34,
      -7.2330000000000013E+001,
      -7.2320000000000007E+001,
      -72.31,
      -72.3,
      -7.2289999999999992E+001,
      -72.28,
      -72.27,
      -7.2259999999999991E+001,
      -72.25,
      -72.24,
      -72.23,
      -72.22,
      -7.2210000000000008E+001,
      -72.2,
      -72.19,
      -7.218E+001,
      -72.17,
      -7.2160000000000011E+001,
      -7.2149999999999991E+001,
      -72.14,
      -72.13,
      -7.2119999999999990E+001,
      -72.11,
      -7.21E+001,
      -72.09,
      -72.08,
      -7.207E+001,
      -72.06,
      -72.05,
      -7.204E+001,
      -72.03,
      -7.2020000000000010E+001,
      -7.201E+001,
      -7.2000000000000014E+001,
      -71.99,
      -7.1979999999999990E+001,
      -71.97,
      -7.196E+001,
      -71.95,
      -71.94,
      -7.1929999999999993E+001,
      -71.92,
      -71.91,
      -7.19E+001,
      -71.89,
      -7.1880000000000010E+001,
      -7.187E+001,
      -7.1860000000000014E+001,
      -7.1850000000000009E+001,
      -7.1839999999999989E+001,
      -71.83,
      -7.182E+001,
      -71.81,
      -71.8,
      -7.1789999999999992E+001,
      -71.78,
      -71.77,
      -7.176E+001,
      -71.75,
      -71.74,
      -71.73,
      -71.72,
      -7.1710000000000008E+001,
      -71.7,
      -71.69,
      -7.1679999999999993E+001,
      -71.67,
      -71.66,
      -7.1649999999999991E+001,
      -71.64,
      -71.63,
      -7.162E+001,
      -71.61,
      -7.16E+001,
      -71.59,
      -71.58,
      -7.1570000000000007E+001,
      -71.56,
      -7.1550000000000011E+001,
      -7.1539999999999992E+001,
      -71.53,
      -71.52,
      -7.1509999999999991E+001,
      -71.5,
      -71.49,
      -71.48,
      -71.47,
      -7.146E+001,
      -71.45,
      -71.44,
      -7.143E+001,
      -71.42,
      -7.1410000000000011E+001,
      -7.14E+001,
      -7.1389999999999986E+001,
      -71.38,
      -7.1369999999999990E+001,
      -71.36,
      -7.135E+001,
      -71.34,
      -71.33,
      -7.132E+001,
      -71.31,
      -71.3,
      -7.129E+001,
      -71.28,
      -71.27,
      -7.126E+001,
      -71.25,
      -7.1240000000000009E+001,
      -7.1229999999999990E+001,
      -71.22,
      -7.121E+001,
      -71.2,
      -71.19,
      -7.1179999999999993E+001,
      -71.17,
      -71.16,
      -7.115E+001,
      -71.14,
      -71.13,
      -7.112E+001,
      -71.11,
      -7.1100000000000009E+001,
      -71.09,
      -71.08,
      -7.107E+001,
      -71.06,
      -71.05,
      -7.1039999999999992E+001,
      -71.03,
      -71.02,
      -7.101E+001,
      -71.0,
      -70.99,
      -70.98,
      -70.97,
      -7.0960000000000008E+001,
      -70.95,
      -7.0940000000000012E+001,
      -7.0929999999999993E+001,
      -70.92,
      -70.91,
      -7.0899999999999991E+001,
      -70.89,
      -70.88,
      -7.087E+001,
      -70.86,
      -7.085E+001,
      -70.84,
      -70.83,
      -7.0820000000000007E+001,
      -70.81,
      -70.8,
      -7.079E+001,
      -7.0779999999999987E+001,
      -70.77,
      -7.0759999999999991E+001,
      -70.75,
      -70.74,
      -70.73,
      -70.72,
      -7.071E+001,
      -70.7,
      -70.69,
      -7.068E+001,
      -70.67,
      -70.66,
      -7.065E+001,
      -70.64,
      -7.0630000000000010E+001,
      -7.0619999999999990E+001,
      -70.61,
      -7.06E+001,
      -70.59,
      -70.58,
      -7.057E+001,
      -70.56,
      -70.55,
      -7.054E+001,
      -70.53,
      -70.52,
      -7.051E+001,
      -70.5,
      -7.0490000000000009E+001,
      -70.48,
      -70.47,
      -7.046E+001,
      -7.0449999999999989E+001,
      -70.44,
      -7.0429999999999993E+001,
      -70.42,
      -70.41,
      -7.04E+001,
      -70.39,
      -70.38,
      -7.037E+001,
      -70.36,
      -7.0350000000000009E+001,
      -70.34,
      -70.33,
      -7.032E+001,
      -7.0309999999999988E+001,
      -70.3,
      -7.0289999999999992E+001,
      -70.28,
      -70.27,
      -7.026E+001,
      -70.25,
      -70.24,
      -70.23,
      -70.22,
      -7.0210000000000008E+001,
      -70.2,
      -70.19,
      -7.018E+001,
      -7.0169999999999987E+001,
      -70.16,
      -7.0149999999999991E+001,
      -70.14,
      -70.13,
      -7.012E+001,
      -70.11,
      -7.01E+001,
      -70.09,
      -70.08,
      -7.0070000000000007E+001,
      -70.06,
      -70.05,
      -7.004E+001,
      -70.03,
      -7.0020000000000010E+001,
      -7.0009999999999991E+001,
      -6.9999999999999986E+001,
      -69.99,
      -6.9979999999999990E+001,
      -69.97,
      -6.996E+001,
      -69.95,
      -69.94,
      -6.993E+001,
      -69.92,
      -69.91,
      -6.99E+001,
      -69.89,
      -6.9880000000000010E+001,
      -6.987E+001,
      -69.86,
      -6.985E+001,
      -6.9839999999999989E+001,
      -69.83,
      -6.982E+001,
      -69.81,
      -69.8,
      -6.979E+001,
      -69.78,
      -69.77,
      -6.976E+001,
      -69.75,
      -6.9740000000000009E+001,
      -69.73,
      -69.72,
      -6.971E+001,
      -6.9699999999999989E+001,
      -69.69,
      -6.9679999999999993E+001,
      -69.67,
      -69.66,
      -6.965E+001,
      -69.64,
      -69.63,
      -6.962E+001,
      -69.61,
      -6.9600000000000009E+001,
      -69.59,
      -69.58,
      -6.9570000000000007E+001,
      -6.9559999999999988E+001,
      -69.55,
      -6.9539999999999992E+001,
      -69.53,
      -69.52,
      -6.951E+001,
      -69.5,
      -69.49,
      -69.48,
      -69.47,
      -6.9460000000000008E+001,
      -69.45,
      -69.44,
      -6.943E+001,
      -69.42,
      -6.9410000000000011E+001,
      -6.9399999999999991E+001,
      -6.9389999999999986E+001,
      -69.38,
      -6.9369999999999990E+001,
      -69.36,
      -6.935E+001,
      -69.34,
      -69.33,
      -6.9320000000000007E+001,
      -69.31,
      -69.3,
      -6.929E+001,
      -69.28,
      -6.9270000000000010E+001,
      -6.926E+001,
      -69.25,
      -69.24,
      -6.9229999999999990E+001,
      -69.22,
      -6.921E+001,
      -69.2,
      -69.19,
      -6.918E+001,
      -69.17,
      -69.16,
      -6.915E+001,
      -69.14,
      -6.9130000000000010E+001,
      -6.912E+001,
      -69.11,
      -6.91E+001,
      -6.9089999999999989E+001,
      -69.08,
      -6.907E+001,
      -69.06,
      -69.05,
      -6.9039999999999992E+001,
      -69.03,
      -69.02,
      -6.901E+001,
      -69.0,
      -6.8990000000000009E+001,
      -68.98,
      -68.97,
      -6.8960000000000008E+001,
      -6.8949999999999989E+001,
      -68.94,
      -6.8929999999999993E+001,
      -6.8919999999999987E+001,
      -68.91,
      -6.8899999999999991E+001,
      -68.89,
      -68.88,
      -6.887E+001,
      -68.86,
      -6.8850000000000009E+001,
      -68.84,
      -68.83,
      -6.8820000000000007E+001,
      -68.81,
      -6.8800000000000011E+001,
      -6.8789999999999992E+001,
      -6.8779999999999987E+001,
      -68.77,
      -6.8759999999999991E+001,
      -68.75,
      -68.74,
      -68.73,
      -68.72,
      -6.8710000000000008E+001,
      -68.7,
      -68.69,
      -6.868E+001,
      -68.67,
      -6.8660000000000011E+001,
      -6.865E+001,
      -6.8639999999999986E+001,
      -68.63,
      -6.8619999999999990E+001,
      -68.61,
      -6.86E+001,
      -68.59,
      -68.58,
      -6.8570000000000007E+001,
      -68.56,
      -68.55,
      -6.854E+001,
      -68.53,
      -6.8520000000000010E+001,
      -6.851E+001,
      -68.5,
      -68.49,
      -6.8479999999999990E+001,
      -68.47,
      -6.846E+001,
      -68.45,
      -68.44,
      -6.8429999999999993E+001,
      -68.42,
      -68.41,
      -6.84E+001,
      -68.39,
      -6.8380000000000010E+001,
      -6.837E+001,
      -68.36,
      -6.8350000000000009E+001,
      -6.8339999999999989E+001,
      -68.33,
      -6.832E+001,
      -6.8309999999999988E+001,
      -68.3,
      -6.8289999999999992E+001,
      -68.28,
      -68.27,
      -6.826E+001,
      -68.25,
      -68.24,
      -68.23,
      -68.22,
      -6.8210000000000008E+001,
      -68.2,
      -6.8190000000000012E+001,
      -6.8179999999999993E+001,
      -6.8169999999999987E+001,
      -68.16,
      -6.8149999999999991E+001,
      -68.14,
      -68.13,
      -6.8119999999999990E+001,
      -68.11,
      -6.81E+001,
      -68.09,
      -68.08,
      -6.8070000000000007E+001,
      -68.06,
      -6.8050000000000011E+001,
      -6.804E+001,
      -6.8029999999999987E+001,
      -68.02,
      -6.8009999999999991E+001,
      -68.0,
      -67.99,
      -6.7979999999999990E+001,
      -67.97,
      -6.7960000000000008E+001,
      -67.95,
      -67.94,
      -6.793E+001,
      -67.92,
      -6.7910000000000011E+001,
      -6.79E+001,
      -67.89,
      -67.88,
      -6.7869999999999990E+001,
      -67.86,
      -6.785E+001,
      -67.84,
      -67.83,
      -6.782E+001,
      -67.81,
      -67.8,
      -6.779E+001,
      -67.78,
      -6.7770000000000010E+001,
      -6.776E+001,
      -67.75,
      -6.7740000000000009E+001,
      -6.7729999999999990E+001,
      -67.72,
      -6.771E+001,
      -6.7699999999999989E+001,
      -67.69,
      -6.7679999999999993E+001,
      -67.67,
      -67.66,
      -6.765E+001,
      -67.64,
      -67.63,
      -6.762E+001,
      -67.61,
      -6.7600000000000009E+001,
      -67.59,
      -6.7580000000000013E+001,
      -6.757E+001,
      -6.7559999999999988E+001,
      -67.55,
      -6.7539999999999992E+001,
      -67.53,
      -67.52,
      -6.7509999999999991E+001,
      -67.5,
      -67.49,
      -67.48,
      -67.47,
      -6.7460000000000008E+001,
      -67.45,
      -6.7440000000000012E+001,
      -6.743E+001,
      -6.7419999999999987E+001,
      -67.41,
      -6.7399999999999991E+001,
      -67.39,
      -67.38,
      -6.7369999999999990E+001,
      -67.36,
      -6.735E+001,
      -67.34,
      -67.33,
      -6.7320000000000007E+001,
      -67.31,
      -6.7300000000000011E+001,
      -6.729E+001,
      -67.28,
      -67.27,
      -6.7259999999999991E+001,
      -67.25,
      -67.24,
      -6.7229999999999990E+001,
      -67.22,
      -6.721E+001,
      -67.2,
      -67.19,
      -6.718E+001,
      -67.17,
      -6.7160000000000011E+001,
      -6.715E+001,
      -67.14,
      -6.7130000000000010E+001,
      -6.7119999999999990E+001,
      -67.11,
      -6.71E+001,
      -6.7089999999999989E+001,
      -67.08,
      -6.707E+001,
      -67.06,
      -67.05,
      -6.704E+001,
      -67.03,
      -67.02,
      -6.701E+001,
      -67.0,
      -6.6990000000000009E+001,
      -66.98,
      -6.6970000000000013E+001,
      -6.696E+001,
      -6.6949999999999989E+001,
      -66.94,
      -6.6929999999999993E+001,
      -66.92,
      -66.91,
      -6.6899999999999991E+001,
      -66.89,
      -66.88,
      -6.687E+001,
      -66.86,
      -6.6850000000000009E+001,
      -66.84,
      -66.83,
      -6.6820000000000007E+001,
      -6.6809999999999988E+001,
      -66.8,
      -6.6789999999999992E+001,
      -66.78,
      -66.77,
      -6.6759999999999991E+001,
      -66.75,
      -66.74,
      -66.73,
      -66.72,
      -6.671E+001,
      -66.7,
      -6.6690000000000012E+001,
      -6.668E+001,
      -66.67,
      -66.66,
      -6.6649999999999991E+001,
      -66.64,
      -66.63,
      -6.662E+001,
      -66.61,
      -6.66E+001,
      -66.59,
      -66.58,
      -6.657E+001,
      -66.56,
      -66.55,
      -6.654E+001,
      -66.53,
      -66.52,
      -6.6509999999999991E+001,
      -66.5,
      -66.49,
      -66.48,
      -66.47,
      -6.646E+001,
      -66.45,
      -66.44,
      -6.6429999999999993E+001,
      -66.42,
      -66.41,
      -6.64E+001,
      -66.39,
      -66.38,
      -6.637E+001,
      -66.36,
      -6.635E+001,
      -66.34,
      -66.33,
      -6.632E+001,
      -66.31,
      -66.3,
      -6.629E+001,
      -66.28,
      -66.27,
      -6.626E+001,
      -66.25,
      -66.24,
      -66.23,
      -66.22,
      -6.6210000000000008E+001,
      -6.6199999999999989E+001,
      -66.19,
      -6.6179999999999993E+001,
      -66.17,
      -66.16,
      -6.615E+001,
      -66.14,
      -66.13,
      -6.6119999999999990E+001,
      -66.11,
      -6.61E+001,
      -66.09,
      -66.08,
      -6.6070000000000007E+001,
      -66.06,
      -66.05,
      -6.6039999999999992E+001,
      -66.03,
      -66.02,
      -6.601E+001,
      -66.0,
      -65.99,
      -6.5979999999999990E+001,
      -65.97,
      -6.596E+001,
      -65.95,
      -65.94,
      -6.593E+001,
      -65.92,
      -65.91,
      -6.5899999999999991E+001,
      -65.89,
      -65.88,
      -6.587E+001,
      -65.86,
      -6.585E+001,
      -65.84,
      -65.83,
      -6.582E+001,
      -65.81,
      -65.8,
      -6.579E+001,
      -65.78,
      -65.77,
      -6.576E+001,
      -65.75,
      -65.74,
      -65.73,
      -65.72,
      -6.571E+001,
      -65.7,
      -65.69,
      -6.568E+001,
      -65.67,
      -65.66,
      -6.565E+001,
      -65.64,
      -65.63,
      -6.562E+001,
      -65.61,
      -6.5600000000000009E+001,
      -6.5589999999999989E+001,
      -65.58,
      -6.557E+001,
      -65.56,
      -65.55,
      -6.554E+001,
      -65.53,
      -65.52,
      -6.5509999999999991E+001,
      -65.5,
      -65.49,
      -65.48,
      -65.47,
      -6.5460000000000008E+001,
      -65.45,
      -65.44,
      -6.5429999999999993E+001,
      -65.42,
      -65.41,
      -6.54E+001,
      -65.39,
      -65.38,
      -6.5369999999999990E+001,
      -65.36,
      -6.535E+001,
      -65.34,
      -65.33,
      -6.5320000000000007E+001,
      -65.31,
      -65.3,
      -6.5289999999999992E+001,
      -65.28,
      -65.27,
      -6.526E+001,
      -65.25,
      -65.24,
      -65.23,
      -65.22,
      -6.521E+001,
      -65.2,
      -65.19,
      -6.518E+001,
      -65.17,
      -65.16,
      -6.515E+001,
      -65.14,
      -65.13,
      -6.512E+001,
      -65.11,
      -6.51E+001,
      -65.09,
      -65.08,
      -6.5070000000000007E+001,
      -65.06,
      -65.05,
      -6.504E+001,
      -65.03,
      -65.02,
      -6.501E+001,
      -65.0,
      -6.4990000000000009E+001,
      -6.4979999999999990E+001,
      -64.97,
      -6.496E+001,
      -64.95,
      -64.94,
      -6.493E+001,
      -64.92,
      -64.91,
      -6.4899999999999991E+001,
      -64.89,
      -64.88,
      -6.487E+001,
      -64.86,
      -6.4850000000000009E+001,
      -64.84,
      -64.83,
      -6.482E+001,
      -64.81,
      -64.8,
      -6.4789999999999992E+001,
      -64.78,
      -64.77,
      -6.4759999999999991E+001,
      -64.75,
      -64.74,
      -64.73,
      -64.72,
      -6.471E+001,
      -64.7,
      -64.69,
      -6.4679999999999993E+001,
      -64.67,
      -64.66,
      -6.4649999999999991E+001,
      -64.64,
      -64.63,
      -6.462E+001,
      -64.61,
      -6.46E+001,
      -64.59,
      -64.58,
      -6.457E+001,
      -64.56,
      -64.55,
      -6.454E+001,
      -64.53,
      -64.52,
      -6.4509999999999991E+001,
      -64.5,
      -64.49,
      -64.48,
      -64.47,
      -6.4460000000000008E+001,
      -64.45,
      -64.44,
      -6.4429999999999993E+001,
      -64.42,
      -64.41,
      -6.44E+001,
      -64.39,
      -6.4380000000000010E+001,
      -6.4369999999999990E+001,
      -64.36,
      -6.435E+001,
      -64.34,
      -64.33,
      -6.4320000000000007E+001,
      -64.31,
      -64.3,
      -6.4289999999999992E+001,
      -64.28,
      -64.27,
      -6.426E+001,
      -64.25,
      -6.4240000000000009E+001,
      -64.23,
      -64.22,
      -6.421E+001,
      -64.2,
      -64.19,
      -6.4179999999999993E+001,
      -64.17,
      -64.16,
      -6.4149999999999991E+001,
      -64.14,
      -64.13,
      -6.412E+001,
      -64.11,
      -6.4100000000000009E+001,
      -64.09,
      -64.08,
      -6.407E+001,
      -64.06,
      -64.05,
      -6.4039999999999992E+001,
      -64.03,
      -64.02,
      -6.401E+001,
      -64.0,
      -63.99,
      -6.3980000000000004E+001,
      -63.97,
      -6.3959999999999994E+001,
      -6.3949999999999996E+001,
      -63.94,
      -63.93,
      -63.92,
      -6.3910000000000004E+001,
      -63.9,
      -6.3890000000000008E+001,
      -6.3879999999999995E+001,
      -63.87,
      -63.86,
      -63.85,
      -63.84,
      -63.83,
      -63.82,
      -6.3809999999999995E+001,
      -63.8,
      -63.79,
      -6.3779999999999994E+001,
      -63.77,
      -63.76,
      -63.75,
      -63.74,
      -63.73,
      -63.72,
      -63.71,
      -63.7,
      -63.69,
      -63.68,
      -63.67,
      -6.3660000000000004E+001,
      -63.65,
      -6.3639999999999993E+001,
      -63.63,
      -63.62,
      -63.61,
      -63.6,
      -63.59,
      -63.58,
      -6.3569999999999993E+001,
      -6.3559999999999995E+001,
      -63.55,
      -63.54,
      -63.53,
      -63.52,
      -6.3510000000000005E+001,
      -6.3499999999999993E+001,
      -63.49,
      -63.48,
      -63.47,
      -63.46,
      -63.45,
      -6.3440000000000005E+001,
      -6.3429999999999993E+001,
      -6.3419999999999995E+001,
      -63.41,
      -63.4,
      -63.39,
      -6.3379999999999995E+001,
      -6.3370000000000005E+001,
      -63.36,
      -6.3349999999999994E+001,
      -6.3339999999999996E+001,
      -63.33,
      -63.32,
      -63.31,
      -6.3300000000000004E+001,
      -63.29,
      -63.28,
      -6.3269999999999996E+001,
      -63.26,
      -63.25,
      -6.3239999999999995E+001,
      -6.3230000000000004E+001,
      -63.22,
      -6.3210000000000008E+001,
      -6.3199999999999996E+001,
      -63.19,
      -63.18,
      -6.3169999999999995E+001,
      -6.3160000000000004E+001,
      -63.15,
      -63.14,
      -63.13,
      -63.12,
      -63.11,
      -6.3099999999999994E+001,
      -63.09,
      -63.08,
      -63.07,
      -63.06,
      -6.3050000000000004E+001,
      -63.04,
      -6.3029999999999994E+001,
      -63.02,
      -63.01,
      -63.0,
      -62.99,
      -62.98,
      -62.97,
      -6.2959999999999994E+001,
      -62.95,
      -62.94,
      -62.93,
      -62.92,
      -6.2910000000000004E+001,
      -6.2900000000000006E+001,
      -6.2889999999999993E+001,
      -6.2879999999999995E+001,
      -62.87,
      -62.86,
      -62.85,
      -62.84,
      -6.2830000000000005E+001,
      -6.2819999999999993E+001,
      -6.2809999999999995E+001,
      -62.8,
      -62.79,
      -62.78,
      -6.2769999999999996E+001,
      -6.2760000000000005E+001,
      -62.75,
      -62.74,
      -62.73,
      -62.72,
      -62.71,
      -6.2699999999999996E+001,
      -6.2690000000000005E+001,
      -62.68,
      -62.67,
      -62.66,
      -62.65,
      -62.64,
      -6.2629999999999995E+001,
      -6.2620000000000005E+001,
      -62.61,
      -62.6,
      -6.2589999999999996E+001,
      -62.58,
      -62.57,
      -6.2559999999999995E+001,
      -6.2550000000000004E+001,
      -62.54,
      -62.53,
      -62.52,
      -6.2509999999999991E+001,
      -62.5,
      -6.2489999999999995E+001,
      -6.2480000000000004E+001,
      -62.47,
      -62.46,
      -62.45,
      -6.2440000000000005E+001,
      -62.43,
      -6.2419999999999995E+001,
      -62.41,
      -62.4,
      -62.39,
      -62.38,
      -62.37,
      -62.36,
      -6.2349999999999994E+001,
      -62.34,
      -62.33,
      -62.32,
      -62.31,
      -62.3,
      -6.2290000000000006E+001,
      -6.2279999999999994E+001,
      -6.2269999999999996E+001,
      -62.26,
      -62.25,
      -62.24,
      -62.23,
      -6.2220000000000006E+001,
      -6.2209999999999994E+001,
      -6.2199999999999996E+001,
      -62.19,
      -62.18,
      -62.17,
      -62.16,
      -6.2150000000000006E+001,
      -62.14,
      -6.2129999999999995E+001,
      -62.12,
      -6.2109999999999992E+001,
      -62.1,
      -6.2089999999999996E+001,
      -6.2080000000000005E+001,
      -62.07,
      -62.06,
      -62.05,
      -62.04,
      -62.03,
      -6.2019999999999996E+001,
      -62.01,
      -62.0,
      -61.99,
      -61.98,
      -6.1969999999999992E+001,
      -61.96,
      -6.1949999999999996E+001,
      -6.1940000000000005E+001,
      -61.93,
      -61.92,
      -6.1910000000000004E+001,
      -6.1899999999999991E+001,
      -61.89,
      -6.1879999999999995E+001,
      -61.87,
      -61.86,
      -61.85,
      -61.84,
      -6.1829999999999991E+001,
      -61.82,
      -6.1809999999999995E+001,
      -61.8,
      -61.79,
      -61.78,
      -61.77,
      -61.76,
      -61.75,
      -6.1739999999999995E+001,
      -61.73,
      -61.72,
      -6.1709999999999994E+001,
      -61.7,
      -61.69,
      -6.1680000000000007E+001,
      -6.1669999999999995E+001,
      -61.66,
      -61.65,
      -61.64,
      -61.63,
      -61.62,
      -61.61,
      -6.1599999999999994E+001,
      -6.1589999999999996E+001,
      -61.58,
      -61.57,
      -61.56,
      -61.55,
      -6.1540000000000006E+001,
      -61.53,
      -6.1519999999999996E+001,
      -61.51,
      -6.1499999999999993E+001,
      -61.49,
      -61.48,
      -6.1470000000000006E+001,
      -61.46,
      -61.45,
      -61.44,
      -61.43,
      -61.42,
      -61.41,
      -61.4,
      -61.39,
      -61.38,
      -61.37,
      -6.1359999999999992E+001,
      -61.35,
      -6.1339999999999996E+001,
      -6.1330000000000005E+001,
      -61.32,
      -61.31,
      -6.1300000000000004E+001,
      -6.1289999999999992E+001,
      -61.28,
      -6.1269999999999996E+001,
      -61.26,
      -61.25,
      -61.24,
      -6.1230000000000004E+001,
      -6.1219999999999992E+001,
      -61.21,
      -6.1199999999999996E+001,
      -61.19,
      -61.18,
      -61.17,
      -6.1160000000000004E+001,
      -61.15,
      -61.14,
      -6.1129999999999995E+001,
      -61.12,
      -61.11,
      -6.1099999999999994E+001,
      -61.09,
      -61.08,
      -6.1070000000000007E+001,
      -6.1059999999999995E+001,
      -61.05,
      -61.04,
      -61.03,
      -61.02,
      -61.01,
      -61.0,
      -6.0989999999999995E+001,
      -60.98,
      -60.97,
      -6.0959999999999994E+001,
      -60.95,
      -60.94,
      -6.0930000000000007E+001,
      -60.92,
      -60.91,
      -60.9,
      -6.0889999999999993E+001,
      -60.88,
      -60.87,
      -60.86,
      -60.85,
      -60.84,
      -60.83,
      -6.0819999999999993E+001,
      -60.81,
      -60.8,
      -60.79,
      -60.78,
      -60.77,
      -60.76,
      -6.0749999999999993E+001,
      -60.74,
      -60.73,
      -60.72,
      -60.71,
      -6.0699999999999996E+001,
      -6.0690000000000005E+001,
      -6.0679999999999993E+001,
      -60.67,
      -60.66,
      -60.65,
      -60.64,
      -60.63,
      -6.0620000000000005E+001,
      -6.0609999999999992E+001,
      -6.0599999999999994E+001,
      -6.0589999999999996E+001,
      -60.58,
      -60.57,
      -6.0559999999999995E+001,
      -6.0550000000000004E+001,
      -60.54,
      -60.53,
      -6.0519999999999996E+001,
      -60.51,
      -60.5,
      -6.0489999999999995E+001,
      -6.0480000000000004E+001,
      -60.47,
      -60.46,
      -6.0449999999999996E+001,
      -60.44,
      -60.43,
      -6.0419999999999995E+001,
      -6.0410000000000004E+001,
      -60.4,
      -60.39,
      -6.0379999999999995E+001,
      -60.37,
      -60.36,
      -6.0349999999999994E+001,
      -60.34,
      -60.33,
      -60.32,
      -60.31,
      -60.3,
      -60.29,
      -6.0279999999999994E+001,
      -60.27,
      -60.26,
      -60.25,
      -60.24,
      -6.0230000000000004E+001,
      -60.22,
      -6.0209999999999994E+001,
      -60.2,
      -60.19,
      -60.18,
      -60.17,
      -6.0160000000000004E+001,
      -60.15,
      -6.0139999999999993E+001,
      -60.13,
      -60.12,
      -60.11,
      -60.1,
      -6.0089999999999996E+001,
      -6.0080000000000005E+001,
      -6.0069999999999993E+001,
      -60.06,
      -60.05,
      -60.04,
      -60.03,
      -60.02,
      -6.0010000000000005E+001,
      -5.9999999999999993E+001,
      -5.9989999999999995E+001,
      -59.98,
      -59.97,
      -59.96,
      -5.9949999999999996E+001,
      -5.9940000000000005E+001,
      -59.93,
      -59.92,
      -59.91,
      -59.9,
      -59.89,
      -5.9879999999999995E+001,
      -5.9870000000000005E+001,
      -59.86,
      -59.85,
      -5.9839999999999996E+001,
      -59.83,
      -59.82,
      -5.9809999999999995E+001,
      -5.9800000000000004E+001,
      -59.79,
      -59.78,
      -5.9769999999999996E+001,
      -59.76,
      -59.75,
      -5.9739999999999995E+001,
      -5.9730000000000004E+001,
      -59.72,
      -59.71,
      -59.7,
      -5.9689999999999991E+001,
      -59.68,
      -5.9669999999999995E+001,
      -5.9660000000000004E+001,
      -59.65,
      -59.64,
      -59.63,
      -5.9620000000000005E+001,
      -59.61,
      -5.9599999999999994E+001,
      -5.9589999999999996E+001,
      -59.58,
      -59.57,
      -59.56,
      -59.55,
      -59.54,
      -5.9529999999999994E+001,
      -59.52,
      -59.51,
      -59.5,
      -59.49,
      -59.48,
      -5.9470000000000006E+001,
      -5.9459999999999994E+001,
      -59.45,
      -59.44,
      -59.43,
      -59.42,
      -5.9410000000000004E+001,
      -59.4,
      -5.9389999999999993E+001,
      -5.9379999999999995E+001,
      -59.37,
      -5.9359999999999992E+001,
      -59.35,
      -5.9339999999999996E+001,
      -5.9330000000000005E+001,
      -59.32,
      -5.9309999999999995E+001,
      -59.3,
      -59.29,
      -59.28,
      -5.9269999999999996E+001,
      -5.9260000000000005E+001,
      -59.25,
      -59.24,
      -59.23,
      -59.22,
      -59.21,
      -5.9199999999999996E+001,
      -59.19,
      -59.18,
      -59.17,
      -59.16,
      -5.9149999999999991E+001,
      -59.14,
      -5.9129999999999995E+001,
      -59.12,
      -59.11,
      -59.1,
      -59.09,
      -5.9079999999999991E+001,
      -59.07,
      -5.9059999999999995E+001,
      -5.9050000000000004E+001,
      -59.04,
      -59.03,
      -59.02,
      -5.9010000000000005E+001,
      -59.0,
      -5.8989999999999995E+001,
      -58.98,
      -58.97,
      -58.96,
      -58.95,
      -58.94,
      -58.93,
      -5.8919999999999995E+001,
      -58.91,
      -58.9,
      -58.89,
      -58.88,
      -58.87,
      -5.8860000000000007E+001,
      -5.8849999999999994E+001,
      -58.84,
      -58.83,
      -58.82,
      -58.81,
      -5.8800000000000004E+001,
      -58.79,
      -5.8779999999999994E+001,
      -5.8769999999999996E+001,
      -58.76,
      -5.8749999999999993E+001,
      -58.74,
      -58.73,
      -5.8720000000000006E+001,
      -58.71,
      -5.8699999999999996E+001,
      -58.69,
      -58.68,
      -58.67,
      -58.66,
      -5.8650000000000006E+001,
      -58.64,
      -58.63,
      -58.62,
      -58.61,
      -58.6,
      -5.8589999999999996E+001,
      -58.58,
      -58.57,
      -58.56,
      -58.55,
      -5.8539999999999992E+001,
      -58.53,
      -5.8519999999999996E+001,
      -58.51,
      -58.5,
      -58.49,
      -5.8480000000000004E+001,
      -5.8469999999999992E+001,
      -58.46,
      -5.8449999999999996E+001,
      -5.8440000000000005E+001,
      -58.43,
      -58.42,
      -5.8410000000000004E+001,
      -5.8400000000000006E+001,
      -5.8389999999999993E+001,
      -5.8379999999999995E+001,
      -58.37,
      -58.36,
      -5.8349999999999994E+001,
      -58.34,
      -58.33,
      -58.32,
      -5.8309999999999995E+001,
      -58.3,
      -58.29,
      -58.28,
      -58.27,
      -58.26,
      -5.8250000000000007E+001,
      -5.8239999999999995E+001,
      -58.23,
      -58.22,
      -58.21,
      -58.2,
      -58.19,
      -58.18,
      -5.8169999999999995E+001,
      -58.16,
      -58.15,
      -5.8139999999999993E+001,
      -58.13,
      -58.12,
      -58.11,
      -58.1,
      -5.8089999999999996E+001,
      -58.08,
      -5.8069999999999993E+001,
      -58.06,
      -58.05,
      -5.8040000000000006E+001,
      -58.03,
      -58.02,
      -58.01,
      -58.0,
      -5.7989999999999995E+001,
      -57.98,
      -57.97,
      -57.96,
      -5.7949999999999996E+001,
      -57.94,
      -5.7929999999999993E+001,
      -57.92,
      -57.91,
      -57.9,
      -57.89,
      -57.88,
      -5.7870000000000005E+001,
      -5.7859999999999992E+001,
      -57.85,
      -5.7839999999999996E+001,
      -57.83,
      -57.82,
      -57.81,
      -5.7800000000000004E+001,
      -5.7789999999999992E+001,
      -5.7779999999999994E+001,
      -5.7769999999999996E+001,
      -57.76,
      -57.75,
      -5.7739999999999995E+001,
      -5.7730000000000004E+001,
      -57.72,
      -57.71,
      -5.7699999999999996E+001,
      -57.69,
      -57.68,
      -57.67,
      -5.7660000000000004E+001,
      -57.65,
      -5.7640000000000008E+001,
      -5.7629999999999995E+001,
      -57.62,
      -57.61,
      -57.6,
      -57.59,
      -57.58,
      -57.57,
      -5.7559999999999995E+001,
      -57.55,
      -57.54,
      -5.7529999999999994E+001,
      -57.52,
      -57.51,
      -57.5,
      -57.49,
      -57.48,
      -57.47,
      -5.7459999999999994E+001,
      -57.45,
      -57.44,
      -5.7430000000000007E+001,
      -57.42,
      -5.7410000000000004E+001,
      -57.4,
      -57.39,
      -5.7379999999999995E+001,
      -57.37,
      -57.36,
      -57.35,
      -5.7339999999999996E+001,
      -57.33,
      -5.7319999999999993E+001,
      -57.31,
      -57.3,
      -57.29,
      -57.28,
      -57.27,
      -5.7260000000000005E+001,
      -5.7249999999999993E+001,
      -57.24,
      -57.23,
      -57.22,
      -57.21,
      -57.2,
      -5.7190000000000005E+001,
      -5.7179999999999993E+001,
      -5.7169999999999995E+001,
      -57.16,
      -57.15,
      -57.14,
      -5.7129999999999995E+001,
      -5.7120000000000005E+001,
      -57.11,
      -5.7099999999999994E+001,
      -5.7089999999999996E+001,
      -57.08,
      -57.07,
      -5.7059999999999995E+001,
      -5.7050000000000004E+001,
      -57.04,
      -5.7030000000000008E+001,
      -5.7019999999999996E+001,
      -57.01,
      -57.0,
      -56.99,
      -56.98,
      -56.97,
      -56.96,
      -5.6949999999999996E+001,
      -5.6939999999999991E+001,
      -56.93,
      -5.6919999999999995E+001,
      -5.6910000000000004E+001,
      -56.9,
      -56.89,
      -56.88,
      -56.87,
      -56.86,
      -5.6849999999999994E+001,
      -56.84,
      -56.83,
      -56.82,
      -56.81,
      -5.6800000000000004E+001,
      -56.79,
      -5.6779999999999994E+001,
      -5.6769999999999996E+001,
      -56.76,
      -56.75,
      -56.74,
      -56.73,
      -56.72,
      -5.6709999999999994E+001,
      -5.6699999999999996E+001,
      -56.69,
      -56.68,
      -56.67,
      -56.66,
      -5.6650000000000006E+001,
      -5.6639999999999993E+001,
      -56.63,
      -56.62,
      -56.61,
      -56.6,
      -56.59,
      -56.58,
      -5.6569999999999993E+001,
      -5.6559999999999995E+001,
      -56.55,
      -5.6539999999999992E+001,
      -56.53,
      -5.6519999999999996E+001,
      -5.6510000000000005E+001,
      -56.5,
      -5.6489999999999995E+001,
      -56.48,
      -56.47,
      -56.46,
      -5.6449999999999996E+001,
      -5.6440000000000005E+001,
      -56.43,
      -5.6420000000000009E+001,
      -56.41,
      -56.4,
      -56.39,
      -56.38,
      -56.37,
      -56.36,
      -56.35,
      -5.6339999999999996E+001,
      -5.6329999999999991E+001,
      -56.32,
      -5.6309999999999995E+001,
      -5.6300000000000004E+001,
      -56.29,
      -56.28,
      -56.27,
      -56.26,
      -56.25,
      -5.6239999999999995E+001,
      -5.6230000000000004E+001,
      -56.22,
      -56.21,
      -56.2,
      -5.6190000000000005E+001,
      -56.18,
      -5.6169999999999995E+001,
      -56.16,
      -56.15,
      -56.14,
      -56.13,
      -56.12,
      -56.11,
      -5.6099999999999994E+001,
      -5.6089999999999996E+001,
      -56.08,
      -56.07,
      -56.06,
      -56.05,
      -5.6040000000000006E+001,
      -5.6029999999999994E+001,
      -56.02,
      -56.01,
      -56.0,
      -55.99,
      -5.5980000000000004E+001,
      -55.97,
      -5.5959999999999994E+001,
      -5.5949999999999996E+001,
      -55.94,
      -5.5929999999999993E+001,
      -55.92,
      -55.91,
      -5.5900000000000006E+001,
      -55.89,
      -5.5879999999999995E+001,
      -55.87,
      -55.86,
      -55.85,
      -5.5839999999999996E+001,
      -5.5830000000000005E+001,
      -55.82,
      -5.5809999999999995E+001,
      -55.8,
      -55.79,
      -55.78,
      -5.5769999999999996E+001,
      -55.76,
      -55.75,
      -55.74,
      -55.73,
      -5.5719999999999992E+001,
      -55.71,
      -5.5699999999999996E+001,
      -55.69,
      -55.68,
      -55.67,
      -5.5660000000000004E+001,
      -5.5649999999999991E+001,
      -55.64,
      -5.5629999999999995E+001,
      -5.5620000000000005E+001,
      -55.61,
      -55.6,
      -55.59,
      -55.58,
      -5.5569999999999993E+001,
      -5.5559999999999995E+001,
      -55.55,
      -55.54,
      -5.5529999999999994E+001,
      -55.52,
      -55.51,
      -55.5,
      -5.5489999999999995E+001,
      -55.48,
      -55.47,
      -55.46,
      -55.45,
      -55.44,
      -5.5430000000000007E+001,
      -5.5419999999999995E+001,
      -55.41,
      -55.4,
      -55.39,
      -55.38,
      -55.37,
      -55.36,
      -5.5349999999999994E+001,
      -5.5339999999999996E+001,
      -55.33,
      -5.5319999999999993E+001,
      -55.31,
      -55.3,
      -55.29,
      -55.28,
      -5.5269999999999996E+001,
      -55.26,
      -5.5249999999999993E+001,
      -55.24,
      -55.23,
      -5.5220000000000006E+001,
      -55.21,
      -5.5199999999999996E+001,
      -55.19,
      -55.18,
      -55.17,
      -55.16,
      -55.15,
      -55.14,
      -55.13,
      -55.12,
      -5.5109999999999992E+001,
      -55.1,
      -5.5089999999999996E+001,
      -55.08,
      -55.07,
      -55.06,
      -5.5050000000000004E+001,
      -5.5039999999999992E+001,
      -55.03,
      -5.5019999999999996E+001,
      -5.5010000000000005E+001,
      -55.0,
      -54.99,
      -5.4980000000000004E+001,
      -54.97,
      -5.4959999999999994E+001,
      -5.4949999999999996E+001,
      -54.94,
      -54.93,
      -5.4919999999999995E+001,
      -5.4910000000000004E+001,
      -54.9,
      -54.89,
      -5.4879999999999995E+001,
      -54.87,
      -54.86,
      -54.85,
      -54.84,
      -54.83,
      -5.4820000000000007E+001,
      -5.4809999999999995E+001,
      -54.8,
      -54.79,
      -54.78,
      -54.77,
      -54.76,
      -54.75,
      -5.4739999999999995E+001,
      -54.73,
      -54.72,
      -5.4709999999999994E+001,
      -54.7,
      -54.69,
      -54.68,
      -54.67,
      -54.66,
      -54.65,
      -5.4639999999999993E+001,
      -54.63,
      -54.62,
      -5.4610000000000007E+001,
      -54.6,
      -5.4589999999999996E+001,
      -54.58,
      -54.57,
      -5.4559999999999995E+001,
      -54.55,
      -54.54,
      -54.53,
      -5.4519999999999996E+001,
      -54.51,
      -5.4499999999999993E+001,
      -54.49,
      -54.48,
      -54.47,
      -54.46,
      -54.45,
      -5.4440000000000005E+001,
      -5.4429999999999993E+001,
      -54.42,
      -54.41,
      -54.4,
      -54.39,
      -54.38,
      -5.4370000000000005E+001,
      -5.4359999999999992E+001,
      -5.4349999999999994E+001,
      -5.4339999999999996E+001,
      -54.33,
      -54.32,
      -5.4309999999999995E+001,
      -5.4300000000000004E+001,
      -54.29,
      -5.4279999999999994E+001,
      -5.4269999999999996E+001,
      -54.26,
      -54.25,
      -5.4239999999999995E+001,
      -5.4230000000000004E+001,
      -54.22,
      -5.4210000000000008E+001,
      -5.4199999999999996E+001,
      -54.19,
      -54.18,
      -54.17,
      -54.16,
      -54.15,
      -54.14,
      -5.4129999999999995E+001,
      -5.4119999999999990E+001,
      -54.11,
      -5.4099999999999994E+001,
      -54.09,
      -54.08,
      -54.07,
      -54.06,
      -54.05,
      -54.04,
      -5.4029999999999994E+001,
      -54.02,
      -54.01,
      -54.0,
      -53.99,
      -53.98,
      -53.97,
      -5.3959999999999994E+001,
      -5.3949999999999996E+001,
      -53.94,
      -53.93,
      -53.92,
      -53.91,
      -53.9,
      -5.3889999999999993E+001,
      -53.88,
      -53.87,
      -53.86,
      -53.85,
      -53.84,
      -5.3830000000000005E+001,
      -5.3819999999999993E+001,
      -53.81,
      -53.8,
      -53.79,
      -53.78,
      -53.77,
      -5.3760000000000005E+001,
      -5.3749999999999993E+001,
      -5.3739999999999995E+001,
      -53.73,
      -53.72,
      -53.71,
      -5.3699999999999996E+001,
      -5.3690000000000005E+001,
      -53.68,
      -5.3669999999999995E+001,
      -53.66,
      -53.65,
      -53.64,
      -5.3629999999999995E+001,
      -5.3620000000000005E+001,
      -53.61,
      -5.3600000000000009E+001,
      -5.3589999999999996E+001,
      -53.58,
      -53.57,
      -53.56,
      -53.55,
      -53.54,
      -53.53,
      -5.3519999999999996E+001,
      -5.3509999999999991E+001,
      -53.5,
      -5.3489999999999995E+001,
      -5.3480000000000004E+001,
      -53.47,
      -53.46,
      -53.45,
      -53.44,
      -53.43,
      -5.3419999999999995E+001,
      -5.3410000000000004E+001,
      -53.4,
      -53.39,
      -53.38,
      -53.37,
      -53.36,
      -5.3349999999999994E+001,
      -5.3339999999999996E+001,
      -53.33,
      -53.32,
      -53.31,
      -53.3,
      -53.29,
      -5.3279999999999994E+001,
      -5.3269999999999996E+001,
      -53.26,
      -53.25,
      -53.24,
      -53.23,
      -5.3220000000000006E+001,
      -5.3209999999999994E+001,
      -53.2,
      -53.19,
      -53.18,
      -53.17,
      -5.3160000000000004E+001,
      -53.15,
      -5.3139999999999993E+001,
      -5.3129999999999995E+001,
      -53.12,
      -5.3109999999999992E+001,
      -53.1,
      -5.3089999999999996E+001,
      -5.3080000000000005E+001,
      -53.07,
      -5.3059999999999995E+001,
      -53.05,
      -53.04,
      -53.03,
      -5.3019999999999996E+001,
      -5.3010000000000005E+001,
      -53.0,
      -5.2989999999999995E+001,
      -52.98,
      -52.97,
      -52.96,
      -5.2949999999999996E+001,
      -52.94,
      -52.93,
      -52.92,
      -52.91,
      -5.2899999999999991E+001,
      -52.89,
      -5.2879999999999995E+001,
      -52.87,
      -52.86,
      -52.85,
      -52.84,
      -5.2829999999999991E+001,
      -52.82,
      -5.2809999999999995E+001,
      -5.2800000000000004E+001,
      -52.79,
      -52.78,
      -52.77,
      -52.76,
      -5.2749999999999993E+001,
      -5.2739999999999995E+001,
      -52.73,
      -52.72,
      -5.2709999999999994E+001,
      -52.7,
      -52.69,
      -52.68,
      -5.2669999999999995E+001,
      -52.66,
      -52.65,
      -52.64,
      -52.63,
      -52.62,
      -5.2610000000000007E+001,
      -5.2599999999999994E+001,
      -52.59,
      -52.58,
      -52.57,
      -52.56,
      -5.2550000000000004E+001,
      -52.54,
      -5.2529999999999994E+001,
      -5.2519999999999996E+001,
      -52.51,
      -5.2499999999999993E+001,
      -52.49,
      -52.48,
      -5.2470000000000006E+001,
      -52.46,
      -5.2449999999999996E+001,
      -52.44,
      -52.43,
      -52.42,
      -52.41,
      -5.2400000000000006E+001,
      -52.39,
      -5.2379999999999995E+001,
      -52.37,
      -52.36,
      -52.35,
      -5.2339999999999996E+001,
      -52.33,
      -52.32,
      -52.31,
      -52.3,
      -5.2289999999999992E+001,
      -52.28,
      -5.2269999999999996E+001,
      -52.26,
      -52.25,
      -52.24,
      -5.2230000000000004E+001,
      -5.2219999999999992E+001,
      -52.21,
      -5.2199999999999996E+001,
      -5.2190000000000005E+001,
      -52.18,
      -52.17,
      -5.2160000000000004E+001,
      -52.15,
      -5.2139999999999993E+001,
      -5.2129999999999995E+001,
      -52.12,
      -52.11,
      -5.2099999999999994E+001,
      -52.09,
      -52.08,
      -52.07,
      -5.2059999999999995E+001,
      -52.05,
      -52.04,
      -52.03,
      -52.02,
      -52.01,
      -5.2000000000000007E+001,
      -5.1989999999999995E+001,
      -51.98,
      -51.97,
      -51.96,
      -51.95,
      -51.94,
      -51.93,
      -5.1919999999999995E+001,
      -51.91,
      -51.9,
      -5.1889999999999993E+001,
      -51.88,
      -51.87,
      -51.86,
      -51.85,
      -5.1839999999999996E+001,
      -51.83,
      -5.1819999999999993E+001,
      -51.81,
      -51.8,
      -5.1790000000000006E+001,
      -51.78,
      -5.1769999999999996E+001,
      -51.76,
      -51.75,
      -5.1739999999999995E+001,
      -51.73,
      -51.72,
      -51.71,
      -5.1699999999999996E+001,
      -51.69,
      -5.1679999999999993E+001,
      -51.67,
      -51.66,
      -51.65,
      -51.64,
      -51.63,
      -5.1620000000000005E+001,
      -5.1609999999999992E+001,
      -51.6,
      -5.1589999999999996E+001,
      -51.58,
      -51.57,
      -51.56,
      -5.1550000000000004E+001,
      -5.1539999999999992E+001,
      -5.1529999999999994E+001,
      -5.1519999999999996E+001,
      -51.51,
      -51.5,
      -5.1489999999999995E+001,
      -5.1480000000000004E+001,
      -51.47,
      -5.1459999999999994E+001,
      -5.1449999999999996E+001,
      -51.44,
      -51.43,
      -5.1419999999999995E+001,
      -5.1410000000000004E+001,
      -51.4,
      -5.1390000000000008E+001,
      -5.1379999999999995E+001,
      -51.37,
      -51.36,
      -51.35,
      -51.34,
      -51.33,
      -51.32,
      -5.1309999999999995E+001,
      -51.3,
      -51.29,
      -5.1279999999999994E+001,
      -51.27,
      -51.26,
      -51.25,
      -51.24,
      -51.23,
      -51.22,
      -5.1209999999999994E+001,
      -51.2,
      -51.19,
      -5.1180000000000007E+001,
      -51.17,
      -51.16,
      -51.15,
      -51.14,
      -5.1129999999999995E+001,
      -51.12,
      -51.11,
      -51.1,
      -5.1089999999999996E+001,
      -51.08,
      -5.1069999999999993E+001,
      -51.06,
      -51.05,
      -51.04,
      -51.03,
      -51.02,
      -5.1010000000000005E+001,
      -5.0999999999999993E+001,
      -50.99,
      -50.98,
      -50.97,
      -50.96,
      -50.95,
      -5.0940000000000005E+001,
      -5.0929999999999993E+001,
      -5.0919999999999995E+001,
      -50.91,
      -50.9,
      -50.89,
      -5.0879999999999995E+001,
      -5.0870000000000005E+001,
      -50.86,
      -5.0849999999999994E+001,
      -5.0839999999999996E+001,
      -50.83,
      -50.82,
      -5.0809999999999995E+001,
      -5.0800000000000004E+001,
      -50.79,
      -5.0780000000000008E+001,
      -5.0769999999999996E+001,
      -50.76,
      -50.75,
      -50.74,
      -50.73,
      -50.72,
      -50.71,
      -5.0699999999999996E+001,
      -5.0689999999999991E+001,
      -50.68,
      -5.0669999999999995E+001,
      -5.0660000000000004E+001,
      -50.65,
      -50.64,
      -50.63,
      -50.62,
      -50.61,
      -5.0599999999999994E+001,
      -50.59,
      -50.58,
      -50.57,
      -50.56,
      -50.55,
      -50.54,
      -5.0529999999999994E+001,
      -5.0519999999999996E+001,
      -50.51,
      -50.5,
      -50.49,
      -50.48,
      -50.47,
      -5.0459999999999994E+001,
      -5.0449999999999996E+001,
      -50.44,
      -50.43,
      -50.42,
      -50.41,
      -5.0400000000000006E+001,
      -5.0389999999999993E+001,
      -50.38,
      -50.37,
      -50.36,
      -50.35,
      -50.34,
      -50.33,
      -5.0319999999999993E+001,
      -5.0309999999999995E+001,
      -50.3,
      -5.0289999999999992E+001,
      -50.28,
      -5.0269999999999996E+001,
      -5.0260000000000005E+001,
      -50.25,
      -5.0239999999999995E+001,
      -50.23,
      -50.22,
      -50.21,
      -5.0199999999999996E+001,
      -5.0190000000000005E+001,
      -50.18,
      -5.0169999999999995E+001,
      -50.16,
      -50.15,
      -50.14,
      -5.0129999999999995E+001,
      -50.12,
      -50.11,
      -50.1,
      -5.0089999999999996E+001,
      -5.0079999999999991E+001,
      -50.07,
      -5.0059999999999995E+001,
      -5.0050000000000004E+001,
      -50.04,
      -50.03,
      -50.02,
      -50.01,
      -50.0,
      -4.9989999999999995E+001,
      -4.9980000000000004E+001,
      -49.97,
      -49.96,
      -49.95,
      -49.94,
      -49.93,
      -4.9919999999999995E+001,
      -49.91,
      -49.9,
      -49.89,
      -49.88,
      -49.87,
      -49.86,
      -4.9849999999999994E+001,
      -4.9839999999999996E+001,
      -49.83,
      -49.82,
      -49.81,
      -49.8,
      -4.9790000000000006E+001,
      -4.9779999999999994E+001,
      -49.77,
      -49.76,
      -49.75,
      -49.74,
      -4.9730000000000004E+001,
      -49.72,
      -4.9709999999999994E+001,
      -4.9699999999999996E+001,
      -49.69,
      -4.9679999999999993E+001,
      -49.67,
      -49.66,
      -4.9650000000000006E+001,
      -49.64,
      -4.9629999999999995E+001,
      -49.62,
      -49.61,
      -49.6,
      -4.9589999999999996E+001,
      -4.9580000000000005E+001,
      -49.57,
      -4.9559999999999995E+001,
      -49.55,
      -49.54,
      -49.53,
      -4.9519999999999996E+001,
      -49.51,
      -49.5,
      -4.9490000000000009E+001,
      -49.48,
      -4.9469999999999992E+001,
      -49.46,
      -4.9449999999999996E+001,
      -49.44,
      -49.43,
      -49.42,
      -4.9410000000000004E+001,
      -4.9399999999999991E+001,
      -49.39,
      -4.9379999999999995E+001,
      -4.9370000000000005E+001,
      -49.36,
      -49.35,
      -49.34,
      -49.33,
      -49.32,
      -4.9309999999999995E+001,
      -4.9300000000000004E+001,
      -49.29,
      -4.9279999999999994E+001,
      -49.27,
      -49.26,
      -49.25,
      -4.9239999999999995E+001,
      -49.23,
      -49.22,
      -49.21,
      -49.2,
      -49.19,
      -4.9180000000000007E+001,
      -4.9169999999999995E+001,
      -49.16,
      -49.15,
      -49.14,
      -49.13,
      -49.12,
      -4.9110000000000007E+001,
      -4.9099999999999994E+001,
      -49.09,
      -49.08,
      -4.9069999999999993E+001,
      -49.06,
      -49.05,
      -49.04,
      -49.03,
      -4.9019999999999996E+001,
      -49.01,
      -4.8999999999999993E+001,
      -48.99,
      -48.98,
      -4.8970000000000006E+001,
      -48.96,
      -4.8949999999999996E+001,
      -48.94,
      -48.93,
      -48.92,
      -48.91,
      -4.8900000000000006E+001,
      -48.89,
      -4.8879999999999995E+001,
      -48.87,
      -4.8859999999999992E+001,
      -48.85,
      -4.8839999999999996E+001,
      -48.83,
      -48.82,
      -48.81,
      -4.8800000000000004E+001,
      -4.8789999999999992E+001,
      -48.78,
      -4.8769999999999996E+001,
      -4.8760000000000005E+001,
      -48.75,
      -48.74,
      -4.8730000000000004E+001,
      -48.72,
      -48.71,
      -4.8699999999999996E+001,
      -4.8690000000000005E+001,
      -48.68,
      -4.8669999999999995E+001,
      -4.8660000000000004E+001,
      -48.65,
      -48.64,
      -4.8629999999999995E+001,
      -48.62,
      -48.61,
      -48.6,
      -48.59,
      -48.58,
      -4.8570000000000007E+001,
      -4.8559999999999995E+001,
      -48.55,
      -48.54,
      -48.53,
      -48.52,
      -48.51,
      -4.8500000000000007E+001,
      -4.8489999999999995E+001,
      -4.8480000000000004E+001,
      -48.47,
      -4.8459999999999994E+001,
      -48.45,
      -48.44,
      -48.43,
      -48.42,
      -48.41,
      -48.4,
      -4.8389999999999993E+001,
      -48.38,
      -48.37,
      -4.8360000000000007E+001,
      -48.35,
      -4.8339999999999996E+001,
      -48.33,
      -48.32,
      -48.31,
      -48.3,
      -4.8290000000000006E+001,
      -48.28,
      -4.8269999999999996E+001,
      -48.26,
      -4.8249999999999993E+001,
      -48.24,
      -48.23,
      -48.22,
      -48.21,
      -48.2,
      -4.8190000000000005E+001,
      -4.8179999999999993E+001,
      -48.17,
      -48.16,
      -48.15,
      -48.14,
      -48.13,
      -4.8120000000000005E+001,
      -4.8109999999999992E+001,
      -48.1,
      -4.8089999999999996E+001,
      -4.8080000000000005E+001,
      -48.07,
      -4.8059999999999995E+001,
      -4.8050000000000004E+001,
      -48.04,
      -4.8029999999999994E+001,
      -4.8019999999999996E+001,
      -48.01,
      -48.0,
      -4.7989999999999995E+001,
      -4.7980000000000004E+001,
      -47.97,
      -47.96,
      -4.7949999999999996E+001,
      -47.94,
      -47.93,
      -47.92,
      -4.7910000000000004E+001,
      -47.9,
      -4.7890000000000008E+001,
      -4.7879999999999995E+001,
      -4.7869999999999990E+001,
      -47.86,
      -4.7849999999999994E+001,
      -47.84,
      -47.83,
      -47.82,
      -4.7809999999999995E+001,
      -47.8,
      -47.79,
      -4.7779999999999994E+001,
      -47.77,
      -47.76,
      -47.75,
      -47.74,
      -47.73,
      -47.72,
      -4.7709999999999994E+001,
      -47.7,
      -47.69,
      -4.7680000000000007E+001,
      -47.67,
      -4.7659999999999989E+001,
      -47.65,
      -4.7639999999999993E+001,
      -4.7629999999999995E+001,
      -47.62,
      -47.61,
      -47.6,
      -4.7589999999999996E+001,
      -47.58,
      -4.7569999999999993E+001,
      -47.56,
      -47.55,
      -47.54,
      -47.53,
      -47.52,
      -4.7510000000000005E+001,
      -4.7499999999999993E+001,
      -47.49,
      -47.48,
      -4.7470000000000006E+001,
      -47.46,
      -4.7449999999999996E+001,
      -4.7440000000000005E+001,
      -4.7429999999999993E+001,
      -4.7419999999999995E+001,
      -47.41,
      -47.4,
      -47.39,
      -4.7379999999999995E+001,
      -4.7370000000000005E+001,
      -47.36,
      -47.35,
      -4.7339999999999996E+001,
      -47.33,
      -47.32,
      -47.31,
      -4.7300000000000004E+001,
      -47.29,
      -4.7280000000000008E+001,
      -4.7269999999999996E+001,
      -4.7259999999999991E+001,
      -47.25,
      -4.7239999999999995E+001,
      -4.7230000000000004E+001,
      -47.22,
      -47.21,
      -4.7199999999999996E+001,
      -47.19,
      -47.18,
      -4.7169999999999995E+001,
      -4.7160000000000004E+001,
      -47.15,
      -47.14,
      -47.13,
      -47.12,
      -47.11,
      -4.7099999999999994E+001,
      -47.09,
      -47.08,
      -4.7070000000000007E+001,
      -47.06,
      -4.7049999999999990E+001,
      -47.04,
      -4.7029999999999994E+001,
      -4.7019999999999996E+001,
      -47.01,
      -47.0,
      -46.99,
      -46.98,
      -46.97,
      -4.6959999999999994E+001,
      -46.95,
      -46.94,
      -46.93,
      -46.92,
      -4.6910000000000004E+001,
      -4.6900000000000006E+001,
      -4.6889999999999993E+001,
      -46.88,
      -46.87,
      -4.6859999999999992E+001,
      -46.85,
      -4.6839999999999996E+001,
      -4.6830000000000005E+001,
      -4.6819999999999993E+001,
      -4.6809999999999995E+001,
      -46.8,
      -46.79,
      -46.78,
      -4.6769999999999996E+001,
      -4.6760000000000005E+001,
      -46.75,
      -4.6739999999999995E+001,
      -46.73,
      -46.72,
      -46.71,
      -4.6699999999999996E+001,
      -4.6690000000000005E+001,
      -46.68,
      -4.6670000000000009E+001,
      -46.66,
      -46.65,
      -46.64,
      -46.63,
      -46.62,
      -46.61,
      -46.6,
      -4.6589999999999996E+001,
      -46.58,
      -46.57,
      -46.56,
      -4.6550000000000004E+001,
      -46.54,
      -46.53,
      -46.52,
      -46.51,
      -46.5,
      -46.49,
      -4.6480000000000004E+001,
      -4.6470000000000006E+001,
      -46.46,
      -46.45,
      -4.6440000000000005E+001,
      -46.43,
      -4.6419999999999995E+001,
      -46.41,
      -46.4,
      -46.39,
      -46.38,
      -4.6370000000000005E+001,
      -46.36,
      -46.35,
      -4.6339999999999996E+001,
      -46.33,
      -46.32,
      -46.31,
      -4.6300000000000004E+001,
      -4.6290000000000006E+001,
      -46.28,
      -46.27,
      -46.26,
      -46.25,
      -46.24,
      -4.6230000000000004E+001,
      -46.22,
      -4.6209999999999994E+001,
      -4.6199999999999996E+001,
      -46.19,
      -46.18,
      -46.17,
      -4.6160000000000004E+001,
      -4.6150000000000006E+001,
      -4.6140000000000008E+001,
      -4.6129999999999995E+001,
      -46.12,
      -46.11,
      -46.1,
      -46.09,
      -4.6080000000000005E+001,
      -4.6070000000000007E+001,
      -4.6060000000000009E+001,
      -46.05,
      -46.04,
      -46.03,
      -46.02,
      -4.6010000000000005E+001,
      -4.6000000000000007E+001,
      -4.5990000000000009E+001,
      -4.5980000000000011E+001,
      -45.97,
      -45.96,
      -45.95,
      -4.5940000000000005E+001,
      -45.93,
      -45.92,
      -4.5910000000000004E+001,
      -45.9,
      -45.89,
      -45.88,
      -4.5870000000000005E+001,
      -4.5860000000000007E+001,
      -45.85,
      -45.84,
      -4.5830000000000005E+001,
      -45.82,
      -45.81,
      -4.5800000000000004E+001,
      -4.5790000000000006E+001,
      -4.5780000000000008E+001,
      -45.77,
      -4.5760000000000005E+001,
      -45.75,
      -45.74,
      -45.73,
      -45.72,
      -45.71,
      -45.7,
      -4.5690000000000005E+001,
      -4.5680000000000007E+001,
      -45.67,
      -4.5660000000000004E+001,
      -45.65,
      -45.64,
      -45.63,
      -4.5620000000000005E+001,
      -4.5610000000000007E+001,
      -4.5600000000000009E+001,
      -45.59,
      -4.5580000000000005E+001,
      -45.57,
      -45.56,
      -4.5550000000000004E+001,
      -4.5540000000000006E+001,
      -45.53,
      -4.5519999999999996E+001,
      -45.51,
      -45.5,
      -45.49,
      -4.5480000000000004E+001,
      -4.5470000000000006E+001,
      -4.5460000000000008E+001,
      -45.45,
      -45.44,
      -45.43,
      -45.42,
      -4.5410000000000004E+001,
      -4.5400000000000006E+001,
      -4.5390000000000008E+001,
      -4.5380000000000010E+001,
      -45.37,
      -45.36,
      -45.35,
      -45.34,
      -45.33,
      -45.32,
      -45.31,
      -4.5300000000000004E+001,
      -45.29,
      -45.28,
      -45.27,
      -4.5260000000000005E+001,
      -45.25,
      -45.24,
      -4.5230000000000004E+001,
      -4.5220000000000006E+001,
      -45.21,
      -45.2,
      -4.5190000000000005E+001,
      -4.5180000000000007E+001,
      -45.17,
      -4.5160000000000004E+001,
      -4.5150000000000006E+001,
      -45.14,
      -4.5129999999999995E+001,
      -45.12,
      -45.11,
      -45.1,
      -45.09,
      -4.5080000000000005E+001,
      -4.5070000000000007E+001,
      -45.06,
      -45.05,
      -45.04,
      -45.03,
      -45.02,
      -4.5010000000000005E+001,
      -4.5000000000000007E+001,
      -4.4990000000000009E+001,
      -4.4980000000000004E+001,
      -44.97,
      -44.96,
      -44.95,
      -4.4940000000000005E+001,
      -4.4930000000000007E+001,
      -44.92,
      -44.91,
      -44.9,
      -44.89,
      -44.88,
      -4.4870000000000005E+001,
      -4.4860000000000007E+001,
      -4.4850000000000009E+001,
      -44.84,
      -44.83,
      -44.82,
      -44.81,
      -4.4800000000000004E+001,
      -4.4790000000000006E+001,
      -4.4780000000000008E+001,
      -4.4770000000000010E+001,
      -44.76,
      -44.75,
      -44.74,
      -4.4730000000000004E+001,
      -44.72,
      -44.71,
      -44.7,
      -4.4690000000000005E+001,
      -44.68,
      -44.67,
      -4.4660000000000004E+001,
      -4.4650000000000006E+001,
      -44.64,
      -44.63,
      -4.4620000000000005E+001,
      -4.4610000000000007E+001,
      -44.6,
      -44.59,
      -4.4580000000000005E+001,
      -4.4570000000000007E+001,
      -44.56,
      -4.4550000000000004E+001,
      -4.4540000000000006E+001,
      -44.53,
      -4.4519999999999996E+001,
      -44.51,
      -44.5,
      -44.49,
      -4.4480000000000004E+001,
      -4.4470000000000006E+001,
      -4.4460000000000008E+001,
      -44.45,
      -44.44,
      -44.43,
      -44.42,
      -4.4410000000000004E+001,
      -4.4400000000000006E+001,
      -4.4390000000000008E+001,
      -4.4380000000000010E+001,
      -4.4370000000000005E+001,
      -44.36,
      -44.35,
      -44.34,
      -4.4330000000000005E+001,
      -44.32,
      -44.31,
      -44.3,
      -44.29,
      -44.28,
      -44.27,
      -4.4260000000000005E+001,
      -4.4250000000000007E+001,
      -44.24,
      -4.4230000000000004E+001,
      -44.22,
      -44.21,
      -44.2,
      -4.4190000000000005E+001,
      -4.4180000000000007E+001,
      -4.4170000000000009E+001,
      -4.4160000000000004E+001,
      -44.15,
      -44.14,
      -44.13,
      -44.12,
      -44.11,
      -44.1,
      -44.09,
      -4.4080000000000005E+001,
      -44.07,
      -44.06,
      -4.4050000000000004E+001,
      -44.04,
      -44.03,
      -44.02,
      -4.4010000000000005E+001,
      -4.4000000000000007E+001,
      -43.99,
      -4.3980000000000004E+001,
      -4.3970000000000006E+001,
      -43.96,
      -43.95,
      -4.3940000000000005E+001,
      -4.3930000000000007E+001,
      -4.3919999999999995E+001,
      -43.91,
      -43.9,
      -43.89,
      -43.88,
      -4.3870000000000005E+001,
      -4.3860000000000007E+001,
      -4.3850000000000009E+001,
      -4.3839999999999996E+001,
      -43.83,
      -43.82,
      -43.81,
      -4.3800000000000004E+001,
      -4.3790000000000006E+001,
      -4.3780000000000008E+001,
      -4.3770000000000010E+001,
      -43.76,
      -43.75,
      -43.74,
      -4.3730000000000004E+001,
      -43.72,
      -43.71,
      -43.7,
      -43.69,
      -43.68,
      -43.67,
      -4.3660000000000004E+001,
      -4.3650000000000006E+001,
      -4.3640000000000008E+001,
      -43.63,
      -4.3620000000000005E+001,
      -43.61,
      -43.6,
      -43.59,
      -4.3580000000000005E+001,
      -4.3570000000000007E+001,
      -4.3560000000000009E+001,
      -4.3550000000000004E+001,
      -43.54,
      -43.53,
      -43.52,
      -43.51,
      -43.5,
      -43.49,
      -4.3480000000000004E+001,
      -4.3470000000000006E+001,
      -43.46,
      -43.45,
      -4.3440000000000005E+001,
      -43.43,
      -43.42,
      -4.3410000000000004E+001,
      -4.3400000000000006E+001,
      -4.3390000000000008E+001,
      -43.38,
      -4.3370000000000005E+001,
      -4.3360000000000007E+001,
      -43.35,
      -43.34,
      -4.3330000000000005E+001,
      -4.3320000000000007E+001,
      -4.3309999999999995E+001,
      -43.3,
      -43.29,
      -43.28,
      -43.27,
      -4.3260000000000005E+001,
      -4.3250000000000007E+001,
      -4.3240000000000009E+001,
      -43.23,
      -43.22,
      -43.21,
      -43.2,
      -4.3190000000000005E+001,
      -4.3180000000000007E+001,
      -4.3170000000000009E+001,
      -4.3160000000000011E+001,
      -43.15,
      -43.14,
      -43.13,
      -4.3120000000000005E+001,
      -43.11,
      -43.1,
      -43.09,
      -43.08,
      -43.07,
      -43.06,
      -4.3050000000000004E+001,
      -4.3040000000000006E+001,
      -43.03,
      -43.02,
      -4.3010000000000005E+001,
      -43.0,
      -42.99,
      -4.2980000000000004E+001,
      -4.2970000000000006E+001,
      -4.2960000000000008E+001,
      -42.95,
      -4.2940000000000005E+001,
      -42.93,
      -42.92,
      -42.91,
      -42.9,
      -42.89,
      -42.88,
      -4.2870000000000005E+001,
      -4.2860000000000007E+001,
      -42.85,
      -42.84,
      -42.83,
      -42.82,
      -42.81,
      -4.2800000000000004E+001,
      -4.2790000000000006E+001,
      -4.2780000000000008E+001,
      -42.77,
      -4.2760000000000005E+001,
      -42.75,
      -42.74,
      -4.2730000000000004E+001,
      -4.2720000000000006E+001,
      -42.71,
      -4.2699999999999996E+001,
      -42.69,
      -42.68,
      -42.67,
      -4.2660000000000004E+001,
      -4.2650000000000006E+001,
      -4.2640000000000008E+001,
      -42.63,
      -42.62,
      -42.61,
      -42.6,
      -42.59,
      -4.2580000000000005E+001,
      -4.2570000000000007E+001,
      -4.2560000000000009E+001,
      -42.55,
      -42.54,
      -42.53,
      -42.52,
      -42.51,
      -42.5,
      -42.49,
      -4.2480000000000004E+001,
      -42.47,
      -42.46,
      -42.45,
      -4.2440000000000005E+001,
      -42.43,
      -42.42,
      -4.2410000000000004E+001,
      -4.2400000000000006E+001,
      -42.39,
      -42.38,
      -4.2370000000000005E+001,
      -4.2360000000000007E+001,
      -4.2350000000000009E+001,
      -42.34,
      -4.2330000000000005E+001,
      -42.32,
      -42.31,
      -42.3,
      -42.29,
      -42.28,
      -42.27,
      -4.2260000000000005E+001,
      -4.2250000000000007E+001,
      -42.24,
      -4.2230000000000004E+001,
      -42.22,
      -42.21,
      -42.2,
      -4.2190000000000005E+001,
      -4.2180000000000007E+001,
      -4.2170000000000009E+001,
      -4.2160000000000004E+001,
      -4.2150000000000006E+001,
      -42.14,
      -42.13,
      -4.2120000000000005E+001,
      -4.2110000000000007E+001,
      -42.1,
      -4.2089999999999996E+001,
      -42.08,
      -42.07,
      -42.06,
      -4.2050000000000004E+001,
      -4.2040000000000006E+001,
      -4.2030000000000008E+001,
      -42.02,
      -42.01,
      -42.0,
      -41.99,
      -4.1980000000000004E+001,
      -4.1970000000000006E+001,
      -4.1960000000000008E+001,
      -4.1950000000000010E+001,
      -41.94,
      -41.93,
      -41.92,
      -4.1910000000000004E+001,
      -41.9,
      -41.89,
      -41.88,
      -4.1870000000000005E+001,
      -41.86,
      -41.85,
      -41.84,
      -4.1830000000000005E+001,
      -41.82,
      -41.81,
      -4.1800000000000004E+001,
      -4.1790000000000006E+001,
      -41.78,
      -41.77,
      -4.1760000000000005E+001,
      -4.1750000000000007E+001,
      -41.74,
      -4.1730000000000004E+001,
      -4.1720000000000006E+001,
      -41.71,
      -4.1699999999999996E+001,
      -41.69,
      -41.68,
      -41.67,
      -4.1660000000000004E+001,
      -4.1650000000000006E+001,
      -4.1640000000000008E+001,
      -41.63,
      -41.62,
      -41.61,
      -41.6,
      -41.59,
      -4.1580000000000005E+001,
      -4.1570000000000007E+001,
      -4.1560000000000009E+001,
      -4.1550000000000004E+001,
      -41.54,
      -41.53,
      -41.52,
      -4.1510000000000005E+001,
      -41.5,
      -41.49,
      -41.48,
      -41.47,
      -41.46,
      -41.45,
      -4.1440000000000005E+001,
      -4.1430000000000007E+001,
      -41.42,
      -4.1410000000000004E+001,
      -41.4,
      -41.39,
      -41.38,
      -4.1370000000000005E+001,
      -4.1360000000000007E+001,
      -4.1350000000000009E+001,
      -41.34,
      -41.33,
      -41.32,
      -41.31,
      -41.3,
      -41.29,
      -41.28,
      -41.27,
      -4.1260000000000005E+001,
      -41.25,
      -41.24,
      -4.1230000000000004E+001,
      -41.22,
      -41.21,
      -41.2,
      -4.1190000000000005E+001,
      -4.1180000000000007E+001,
      -41.17,
      -4.1160000000000004E+001,
      -4.1150000000000006E+001,
      -41.14,
      -41.13,
      -4.1120000000000005E+001,
      -4.1110000000000007E+001,
      -41.1,
      -4.1089999999999996E+001,
      -41.08,
      -41.07,
      -41.06,
      -4.1050000000000004E+001,
      -4.1040000000000006E+001,
      -4.1030000000000008E+001,
      -41.02,
      -41.01,
      -4.1000000000000007E+001,
      -40.99,
      -4.0980000000000004E+001,
      -4.0970000000000006E+001,
      -4.0960000000000008E+001,
      -4.0950000000000010E+001,
      -4.0940000000000005E+001,
      -4.0930000000000007E+001,
      -4.0920000000000009E+001,
      -4.0910000000000004E+001,
      -4.0900000000000006E+001,
      -4.0890000000000008E+001,
      -4.0880000000000010E+001,
      -4.0870000000000005E+001,
      -40.86,
      -40.85,
      -40.84,
      -4.0830000000000005E+001,
      -4.0820000000000007E+001,
      -4.0810000000000009E+001,
      -4.0800000000000011E+001,
      -4.0790000000000006E+001,
      -40.78,
      -40.77,
      -4.0760000000000005E+001,
      -4.0750000000000007E+001,
      -4.0740000000000009E+001,
      -4.0730000000000011E+001,
      -4.0720000000000013E+001,
      -4.0710000000000008E+001,
      -40.7,
      -4.0690000000000005E+001,
      -4.0680000000000007E+001,
      -4.0670000000000009E+001,
      -4.0660000000000004E+001,
      -4.0650000000000006E+001,
      -40.64,
      -40.63,
      -4.0620000000000005E+001,
      -4.0610000000000007E+001,
      -4.0600000000000009E+001,
      -4.0590000000000011E+001,
      -4.0580000000000005E+001,
      -4.0570000000000007E+001,
      -40.56,
      -4.0550000000000004E+001,
      -4.0540000000000006E+001,
      -4.0530000000000008E+001,
      -4.0520000000000010E+001,
      -4.0510000000000012E+001,
      -4.0500000000000007E+001,
      -40.49,
      -4.0480000000000004E+001,
      -4.0470000000000006E+001,
      -40.46,
      -40.45,
      -4.0440000000000005E+001,
      -4.0430000000000007E+001,
      -4.0420000000000009E+001,
      -4.0410000000000004E+001,
      -4.0400000000000006E+001,
      -4.0390000000000008E+001,
      -40.38,
      -4.0370000000000005E+001,
      -4.0360000000000007E+001,
      -4.0350000000000009E+001,
      -4.0340000000000011E+001,
      -4.0330000000000005E+001,
      -4.0320000000000007E+001,
      -4.0310000000000009E+001,
      -4.0300000000000004E+001,
      -4.0290000000000006E+001,
      -4.0280000000000008E+001,
      -4.0270000000000010E+001,
      -40.26,
      -40.25,
      -40.24,
      -4.0230000000000004E+001,
      -4.0220000000000006E+001,
      -4.0210000000000008E+001,
      -4.0200000000000010E+001,
      -4.0190000000000012E+001,
      -40.18,
      -40.17,
      -4.0160000000000004E+001,
      -4.0150000000000006E+001,
      -4.0140000000000008E+001,
      -4.0130000000000010E+001,
      -4.0120000000000012E+001,
      -4.0110000000000014E+001,
      -40.1,
      -40.09,
      -4.0080000000000005E+001,
      -4.0070000000000007E+001,
      -40.06,
      -4.0050000000000004E+001,
      -4.0040000000000006E+001,
      -40.03,
      -40.02,
      -4.0010000000000005E+001,
      -4.0000000000000007E+001,
      -3.9990000000000009E+001,
      -3.9980000000000004E+001,
      -3.9970000000000006E+001,
      -39.96,
      -39.95,
      -3.9940000000000005E+001,
      -3.9930000000000007E+001,
      -3.9920000000000009E+001,
      -3.9910000000000011E+001,
      -3.9900000000000006E+001,
      -3.9890000000000008E+001,
      -39.88,
      -3.9870000000000005E+001,
      -39.86,
      -39.85,
      -39.84,
      -3.9830000000000005E+001,
      -3.9820000000000007E+001,
      -3.9810000000000009E+001,
      -3.9800000000000004E+001,
      -3.9790000000000006E+001,
      -39.78,
      -39.77,
      -3.9760000000000005E+001,
      -3.9750000000000007E+001,
      -3.9740000000000009E+001,
      -3.9730000000000004E+001,
      -3.9720000000000006E+001,
      -3.9710000000000008E+001,
      -39.7,
      -3.9690000000000005E+001,
      -3.9680000000000007E+001,
      -3.9670000000000009E+001,
      -3.9660000000000004E+001,
      -39.65,
      -39.64,
      -39.63,
      -3.9620000000000005E+001,
      -3.9610000000000007E+001,
      -3.9600000000000009E+001,
      -3.9590000000000011E+001,
      -3.9580000000000013E+001,
      -39.57,
      -39.56,
      -3.9550000000000004E+001,
      -3.9540000000000006E+001,
      -3.9530000000000008E+001,
      -3.9520000000000010E+001,
      -3.9510000000000012E+001,
      -3.9500000000000007E+001,
      -3.9490000000000009E+001,
      -3.9480000000000004E+001,
      -39.47,
      -3.9460000000000008E+001,
      -39.45,
      -3.9440000000000005E+001,
      -3.9430000000000007E+001,
      -3.9420000000000009E+001,
      -39.41,
      -3.9400000000000006E+001,
      -3.9390000000000008E+001,
      -3.9380000000000010E+001,
      -3.9370000000000005E+001,
      -3.9360000000000014E+001,
      -39.35,
      -39.34,
      -3.9330000000000005E+001,
      -3.9320000000000007E+001,
      -39.31,
      -3.9300000000000011E+001,
      -3.9290000000000006E+001,
      -39.28,
      -39.27,
      -3.9260000000000012E+001,
      -39.25,
      -39.24,
      -3.9230000000000011E+001,
      -3.9220000000000006E+001,
      -3.9210000000000008E+001,
      -3.9200000000000010E+001,
      -3.9190000000000005E+001,
      -39.18,
      -3.9170000000000009E+001,
      -3.9160000000000004E+001,
      -3.9150000000000006E+001,
      -3.9140000000000008E+001,
      -3.9130000000000010E+001,
      -39.12,
      -3.9110000000000007E+001,
      -3.9100000000000009E+001,
      -3.9089999999999996E+001,
      -3.9080000000000005E+001,
      -3.9070000000000014E+001,
      -3.9060000000000009E+001,
      -3.9050000000000004E+001,
      -3.9040000000000006E+001,
      -39.03,
      -39.02,
      -3.9010000000000005E+001,
      -3.9000000000000007E+001,
      -38.99,
      -3.8980000000000011E+001,
      -38.97,
      -38.96,
      -38.95,
      -3.8940000000000012E+001,
      -38.93,
      -3.8920000000000009E+001,
      -3.8910000000000011E+001,
      -3.8900000000000013E+001,
      -38.89,
      -3.8880000000000010E+001,
      -3.8870000000000005E+001,
      -38.86,
      -3.8850000000000009E+001,
      -38.84,
      -3.8830000000000005E+001,
      -3.8820000000000007E+001,
      -38.81,
      -38.8,
      -3.8790000000000006E+001,
      -3.8780000000000008E+001,
      -38.77,
      -3.8760000000000005E+001,
      -3.8750000000000014E+001,
      -38.74,
      -3.8730000000000004E+001,
      -3.8720000000000006E+001,
      -3.8710000000000008E+001,
      -38.7,
      -3.8690000000000012E+001,
      -3.8680000000000007E+001,
      -38.67,
      -3.8660000000000004E+001,
      -38.65,
      -38.64,
      -38.63,
      -3.8620000000000012E+001,
      -38.61,
      -3.8600000000000009E+001,
      -3.8590000000000011E+001,
      -3.8580000000000005E+001,
      -38.57,
      -3.8560000000000009E+001,
      -3.8550000000000004E+001,
      -3.8540000000000006E+001,
      -3.8530000000000008E+001,
      -3.8520000000000010E+001,
      -38.51,
      -3.8500000000000007E+001,
      -38.49,
      -38.48,
      -3.8470000000000006E+001,
      -3.8460000000000015E+001,
      -38.45,
      -3.8440000000000005E+001,
      -3.8430000000000007E+001,
      -38.42,
      -3.8410000000000004E+001,
      -3.8400000000000006E+001,
      -3.8390000000000008E+001,
      -38.38,
      -3.8370000000000012E+001,
      -38.36,
      -38.35,
      -38.34,
      -3.8330000000000013E+001,
      -38.32,
      -3.8310000000000009E+001,
      -3.8300000000000011E+001,
      -3.8290000000000013E+001,
      -38.28,
      -3.8270000000000010E+001,
      -3.8260000000000005E+001,
      -38.25,
      -3.8240000000000009E+001,
      -3.8230000000000004E+001,
      -3.8220000000000006E+001,
      -3.8210000000000008E+001,
      -38.2,
      -38.19,
      -3.8180000000000007E+001,
      -3.8170000000000009E+001,
      -3.8160000000000004E+001,
      -3.8150000000000006E+001,
      -3.8140000000000015E+001,
      -38.13,
      -3.8120000000000005E+001,
      -3.8110000000000007E+001,
      -3.8100000000000009E+001,
      -38.09,
      -3.8080000000000013E+001,
      -3.8070000000000007E+001,
      -38.06,
      -3.8050000000000004E+001,
      -38.04,
      -38.03,
      -38.02,
      -3.8010000000000012E+001,
      -38.0,
      -3.7990000000000009E+001,
      -3.7980000000000011E+001,
      -3.7970000000000006E+001,
      -37.96,
      -3.7950000000000010E+001,
      -3.7940000000000005E+001,
      -3.7930000000000007E+001,
      -3.7920000000000009E+001,
      -3.7910000000000011E+001,
      -37.9,
      -3.7890000000000008E+001,
      -37.88,
      -37.87,
      -3.7860000000000007E+001,
      -3.7850000000000016E+001,
      -37.84,
      -3.7830000000000005E+001,
      -3.7820000000000007E+001,
      -37.81,
      -3.7800000000000004E+001,
      -3.7790000000000006E+001,
      -3.7780000000000008E+001,
      -37.77,
      -3.7760000000000012E+001,
      -37.75,
      -37.74,
      -3.7730000000000004E+001,
      -3.7720000000000006E+001,
      -37.71,
      -3.7700000000000010E+001,
      -3.7690000000000012E+001,
      -37.68,
      -37.67,
      -3.7660000000000011E+001,
      -3.7650000000000006E+001,
      -37.64,
      -3.7630000000000010E+001,
      -3.7620000000000005E+001,
      -3.7610000000000007E+001,
      -3.7600000000000009E+001,
      -37.59,
      -37.58,
      -3.7570000000000007E+001,
      -37.56,
      -3.7550000000000004E+001,
      -3.7540000000000006E+001,
      -3.7530000000000015E+001,
      -3.7519999999999996E+001,
      -3.7510000000000005E+001,
      -3.7500000000000007E+001,
      -3.7490000000000009E+001,
      -3.7480000000000004E+001,
      -3.7470000000000013E+001,
      -3.7460000000000008E+001,
      -37.45,
      -3.7440000000000005E+001,
      -37.43,
      -37.42,
      -3.7410000000000004E+001,
      -3.7400000000000006E+001,
      -37.39,
      -3.7380000000000010E+001,
      -3.7370000000000012E+001,
      -37.36,
      -37.35,
      -3.7340000000000011E+001,
      -3.7330000000000005E+001,
      -3.7320000000000007E+001,
      -3.7310000000000009E+001,
      -3.7300000000000011E+001,
      -37.29,
      -3.7280000000000008E+001,
      -37.27,
      -37.26,
      -3.7250000000000007E+001,
      -37.24,
      -3.7230000000000004E+001,
      -3.7220000000000006E+001,
      -3.7210000000000008E+001,
      -3.7199999999999996E+001,
      -3.7190000000000005E+001,
      -3.7180000000000007E+001,
      -3.7170000000000009E+001,
      -3.7160000000000004E+001,
      -3.7150000000000013E+001,
      -37.14,
      -37.13,
      -3.7120000000000005E+001,
      -3.7110000000000007E+001,
      -37.1,
      -3.7090000000000011E+001,
      -3.7080000000000005E+001,
      -37.07,
      -37.06,
      -3.7050000000000011E+001,
      -3.7040000000000006E+001,
      -37.03,
      -3.7020000000000010E+001,
      -3.7010000000000005E+001,
      -3.7000000000000007E+001,
      -3.6990000000000009E+001,
      -3.6980000000000004E+001,
      -36.97,
      -3.6960000000000008E+001,
      -36.95,
      -3.6940000000000005E+001,
      -3.6930000000000007E+001,
      -3.6920000000000016E+001,
      -36.91,
      -3.6900000000000006E+001,
      -3.6890000000000008E+001,
      -3.6880000000000010E+001,
      -3.6870000000000005E+001,
      -3.6860000000000014E+001,
      -3.6850000000000009E+001,
      -36.84,
      -3.6830000000000005E+001,
      -36.82,
      -36.81,
      -3.6800000000000004E+001,
      -3.6790000000000006E+001,
      -36.78,
      -3.6770000000000010E+001,
      -3.6760000000000012E+001,
      -36.75,
      -36.74,
      -3.6730000000000011E+001,
      -3.6720000000000006E+001,
      -3.6710000000000008E+001,
      -3.6700000000000010E+001,
      -3.6690000000000012E+001,
      -36.68,
      -3.6670000000000009E+001,
      -3.6660000000000004E+001,
      -36.65,
      -3.6640000000000008E+001,
      -36.63,
      -3.6620000000000005E+001,
      -3.6610000000000007E+001,
      -3.6600000000000009E+001,
      -3.6589999999999996E+001,
      -3.6580000000000005E+001,
      -3.6570000000000007E+001,
      -3.6560000000000009E+001,
      -3.6550000000000004E+001,
      -3.6540000000000013E+001,
      -36.53,
      -36.52,
      -3.6510000000000005E+001,
      -3.6500000000000007E+001,
      -36.49,
      -3.6480000000000011E+001,
      -3.6470000000000006E+001,
      -36.46,
      -36.45,
      -3.6440000000000012E+001,
      -36.43,
      -36.42,
      -3.6410000000000011E+001,
      -3.6400000000000006E+001,
      -3.6390000000000008E+001,
      -3.6380000000000010E+001,
      -3.6370000000000005E+001,
      -36.36,
      -3.6350000000000009E+001,
      -36.34,
      -3.6330000000000005E+001,
      -3.6320000000000007E+001,
      -3.6310000000000009E+001,
      -36.3,
      -3.6290000000000006E+001,
      -3.6280000000000008E+001,
      -3.6269999999999996E+001,
      -3.6260000000000005E+001,
      -3.6250000000000014E+001,
      -3.6240000000000009E+001,
      -3.6230000000000004E+001,
      -3.6220000000000006E+001,
      -36.21,
      -36.2,
      -3.6190000000000005E+001,
      -3.6180000000000007E+001,
      -36.17,
      -3.6160000000000011E+001,
      -36.15,
      -36.14,
      -36.13,
      -3.6120000000000012E+001,
      -36.11,
      -3.6100000000000009E+001,
      -3.6090000000000011E+001,
      -3.6080000000000013E+001,
      -36.07,
      -3.6060000000000009E+001,
      -3.6050000000000004E+001,
      -36.04,
      -3.6030000000000008E+001,
      -36.02,
      -3.6010000000000005E+001,
      -3.6000000000000007E+001,
      -35.99,
      -35.98,
      -3.5970000000000006E+001,
      -3.5960000000000008E+001,
      -35.95,
      -3.5940000000000005E+001,
      -3.5930000000000014E+001,
      -35.92,
      -3.5910000000000004E+001,
      -3.5900000000000006E+001,
      -3.5890000000000008E+001,
      -35.88,
      -3.5870000000000012E+001,
      -3.5860000000000007E+001,
      -35.85,
      -35.84,
      -35.83,
      -35.82,
      -35.81,
      -3.5800000000000011E+001,
      -3.5790000000000006E+001,
      -3.5780000000000008E+001,
      -3.5770000000000010E+001,
      -3.5760000000000005E+001,
      -35.75,
      -3.5740000000000009E+001,
      -3.5730000000000004E+001,
      -3.5720000000000006E+001,
      -3.5710000000000008E+001,
      -3.5700000000000010E+001,
      -35.69,
      -3.5680000000000007E+001,
      -3.5670000000000009E+001,
      -35.66,
      -3.5650000000000006E+001,
      -3.5640000000000015E+001,
      -3.5630000000000010E+001,
      -3.5620000000000005E+001,
      -3.5610000000000007E+001,
      -35.6,
      -35.59,
      -3.5580000000000005E+001,
      -3.5570000000000007E+001,
      -35.56,
      -3.5550000000000011E+001,
      -35.54,
      -35.53,
      -35.52,
      -3.5510000000000012E+001,
      -35.5,
      -3.5490000000000009E+001,
      -3.5480000000000011E+001,
      -3.5470000000000013E+001,
      -35.46,
      -3.5450000000000010E+001,
      -3.5440000000000005E+001,
      -35.43,
      -3.5420000000000009E+001,
      -3.5410000000000004E+001,
      -3.5400000000000006E+001,
      -3.5390000000000008E+001,
      -35.38,
      -35.37,
      -3.5360000000000007E+001,
      -3.5350000000000009E+001,
      -35.34,
      -3.5330000000000005E+001,
      -3.5320000000000014E+001,
      -35.31,
      -3.5300000000000004E+001,
      -3.5290000000000006E+001,
      -3.5280000000000008E+001,
      -35.27,
      -3.5260000000000012E+001,
      -3.5250000000000007E+001,
      -35.24,
      -3.5230000000000004E+001,
      -35.22,
      -35.21,
      -35.2,
      -3.5190000000000012E+001,
      -35.18,
      -3.5170000000000009E+001,
      -3.5160000000000011E+001,
      -3.5150000000000006E+001,
      -35.14,
      -3.5130000000000010E+001,
      -3.5120000000000005E+001,
      -3.5110000000000007E+001,
      -3.5100000000000009E+001,
      -3.5090000000000011E+001,
      -35.08,
      -3.5070000000000007E+001,
      -35.06,
      -35.05,
      -3.5040000000000006E+001,
      -3.5030000000000015E+001,
      -35.02,
      -3.5010000000000005E+001,
      -3.5000000000000007E+001,
      -34.99,
      -3.4980000000000004E+001,
      -3.4970000000000006E+001,
      -3.4960000000000008E+001,
      -34.95,
      -3.4940000000000012E+001,
      -34.93,
      -34.92,
      -3.4910000000000004E+001,
      -3.4900000000000006E+001,
      -34.89,
      -3.4880000000000010E+001,
      -3.4870000000000012E+001,
      -34.86,
      -34.85,
      -3.4840000000000011E+001,
      -3.4830000000000005E+001,
      -34.82,
      -3.4810000000000009E+001,
      -3.4800000000000004E+001,
      -3.4790000000000006E+001,
      -3.4780000000000008E+001,
      -34.77,
      -34.76,
      -3.4750000000000007E+001,
      -34.74,
      -3.4730000000000004E+001,
      -3.4720000000000006E+001,
      -3.4710000000000015E+001,
      -3.4699999999999996E+001,
      -3.4690000000000005E+001,
      -3.4680000000000007E+001,
      -3.4670000000000009E+001,
      -3.4660000000000004E+001,
      -3.4650000000000013E+001,
      -3.4640000000000008E+001,
      -34.63,
      -3.4620000000000005E+001,
      -34.61,
      -34.6,
      -34.59,
      -3.4580000000000005E+001,
      -34.57,
      -3.4560000000000009E+001,
      -3.4550000000000011E+001,
      -34.54,
      -34.53,
      -3.4520000000000010E+001,
      -3.4510000000000005E+001,
      -3.4500000000000007E+001,
      -3.4490000000000009E+001,
      -3.4480000000000011E+001,
      -34.47,
      -3.4460000000000008E+001,
      -34.45,
      -34.44,
      -3.4430000000000007E+001,
      -3.4420000000000016E+001,
      -3.4410000000000004E+001,
      -3.4400000000000006E+001,
      -3.4390000000000008E+001,
      -34.38,
      -3.4370000000000005E+001,
      -3.4360000000000007E+001,
      -3.4350000000000009E+001,
      -34.34,
      -3.4330000000000013E+001,
      -34.32,
      -34.31,
      -3.4300000000000004E+001,
      -3.4290000000000006E+001,
      -34.28,
      -3.4270000000000010E+001,
      -3.4260000000000012E+001,
      -34.25,
      -34.24,
      -3.4230000000000011E+001,
      -3.4220000000000006E+001,
      -34.21,
      -3.4200000000000010E+001,
      -3.4190000000000005E+001,
      -3.4180000000000007E+001,
      -3.4170000000000009E+001,
      -3.4160000000000004E+001,
      -34.15,
      -3.4140000000000008E+001,
      -34.13,
      -3.4120000000000005E+001,
      -3.4110000000000007E+001,
      -3.4100000000000016E+001,
      -3.4089999999999996E+001,
      -3.4080000000000005E+001,
      -3.4070000000000007E+001,
      -3.4060000000000009E+001,
      -3.4050000000000004E+001,
      -3.4040000000000013E+001,
      -3.4030000000000008E+001,
      -34.02,
      -3.4010000000000005E+001,
      -34.0,
      -33.99,
      -3.3980000000000004E+001,
      -3.3970000000000006E+001,
      -33.96,
      -3.3950000000000010E+001,
      -3.3940000000000012E+001,
      -33.93,
      -33.92,
      -3.3910000000000011E+001,
      -3.3900000000000006E+001,
      -3.3890000000000008E+001,
      -3.3880000000000010E+001,
      -3.3870000000000012E+001,
      -33.86,
      -3.3850000000000009E+001,
      -33.84,
      -33.83,
      -3.3820000000000007E+001,
      -33.81,
      -3.3800000000000004E+001,
      -3.3790000000000006E+001,
      -3.3780000000000008E+001,
      -3.3769999999999996E+001,
      -3.3760000000000005E+001,
      -3.3750000000000007E+001,
      -3.3740000000000009E+001,
      -3.3730000000000004E+001,
      -3.3720000000000013E+001,
      -33.71,
      -33.7,
      -3.3690000000000005E+001,
      -3.3680000000000007E+001,
      -33.67,
      -3.3660000000000011E+001,
      -3.3650000000000006E+001,
      -33.64,
      -33.63,
      -3.3620000000000012E+001,
      -33.61,
      -33.6,
      -3.3590000000000011E+001,
      -3.3580000000000005E+001,
      -3.3570000000000007E+001,
      -3.3560000000000009E+001,
      -3.3550000000000004E+001,
      -33.54,
      -3.3530000000000008E+001,
      -33.52,
      -3.3510000000000005E+001,
      -3.3500000000000007E+001,
      -3.3490000000000009E+001,
      -33.48,
      -3.3470000000000006E+001,
      -3.3460000000000008E+001,
      -3.3449999999999996E+001,
      -3.3440000000000005E+001,
      -3.3430000000000014E+001,
      -3.3420000000000009E+001,
      -3.3410000000000004E+001,
      -3.3400000000000006E+001,
      -33.39,
      -33.38,
      -3.3370000000000005E+001,
      -3.3360000000000007E+001,
      -33.35,
      -3.3340000000000011E+001,
      -33.33,
      -33.32,
      -33.31,
      -3.3300000000000011E+001,
      -33.29,
      -3.3280000000000008E+001,
      -3.3270000000000010E+001,
      -3.3260000000000012E+001,
      -33.25,
      -3.3240000000000009E+001,
      -3.3230000000000004E+001,
      -33.22,
      -3.3210000000000008E+001,
      -33.2,
      -3.3190000000000005E+001,
      -3.3180000000000007E+001,
      -3.3170000000000009E+001,
      -33.16,
      -3.3150000000000006E+001,
      -3.3140000000000008E+001,
      -3.3130000000000010E+001,
      -3.3120000000000005E+001,
      -3.3110000000000014E+001,
      -33.1,
      -33.09,
      -3.3080000000000005E+001,
      -3.3070000000000007E+001,
      -33.06,
      -3.3050000000000011E+001,
      -3.3040000000000006E+001,
      -33.03,
      -33.02,
      -3.3010000000000012E+001,
      -33.0,
      -32.99,
      -3.2980000000000011E+001,
      -3.2970000000000006E+001,
      -3.2960000000000008E+001,
      -3.2950000000000010E+001,
      -3.2940000000000005E+001,
      -32.93,
      -3.2920000000000009E+001,
      -3.2910000000000004E+001,
      -3.2900000000000006E+001,
      -3.2890000000000008E+001,
      -3.2880000000000010E+001,
      -32.87,
      -3.2860000000000007E+001,
      -3.2850000000000009E+001,
      -3.2839999999999996E+001,
      -3.2830000000000005E+001,
      -3.2820000000000014E+001,
      -3.2810000000000009E+001,
      -3.2800000000000004E+001,
      -3.2790000000000006E+001,
      -32.78,
      -32.77,
      -3.2760000000000005E+001,
      -3.2750000000000007E+001,
      -32.74,
      -3.2730000000000011E+001,
      -32.72,
      -32.71,
      -32.7,
      -3.2690000000000012E+001,
      -32.68,
      -3.2670000000000009E+001,
      -3.2660000000000011E+001,
      -3.2650000000000013E+001,
      -32.64,
      -3.2630000000000010E+001,
      -3.2620000000000005E+001,
      -32.61,
      -3.2600000000000009E+001,
      -32.59,
      -3.2580000000000005E+001,
      -3.2570000000000007E+001,
      -32.56,
      -32.55,
      -3.2540000000000006E+001,
      -3.2530000000000008E+001,
      -32.52,
      -3.2510000000000005E+001,
      -3.2500000000000014E+001,
      -32.49,
      -3.2480000000000004E+001,
      -3.2470000000000006E+001,
      -3.2460000000000008E+001,
      -32.45,
      -3.2440000000000012E+001,
      -3.2430000000000007E+001,
      -32.42,
      -3.2410000000000004E+001,
      -32.4,
      -32.39,
      -32.38,
      -3.2370000000000012E+001,
      -32.36,
      -3.2350000000000009E+001,
      -3.2340000000000011E+001,
      -3.2330000000000005E+001,
      -32.32,
      -3.2310000000000009E+001,
      -3.2300000000000004E+001,
      -3.2290000000000006E+001,
      -3.2280000000000008E+001,
      -3.2270000000000010E+001,
      -32.26,
      -3.2250000000000007E+001,
      -32.24,
      -32.23,
      -3.2220000000000006E+001,
      -3.2210000000000015E+001,
      -32.2,
      -3.2190000000000005E+001,
      -3.2180000000000007E+001,
      -32.17,
      -3.2160000000000004E+001,
      -3.2150000000000006E+001,
      -3.2140000000000008E+001,
      -32.13,
      -3.2120000000000012E+001,
      -32.11,
      -32.1,
      -32.09,
      -3.2080000000000005E+001,
      -32.07,
      -3.2060000000000009E+001,
      -3.2050000000000011E+001,
      -32.04,
      -32.03,
      -3.2020000000000010E+001,
      -3.2010000000000005E+001,
      -32.0,
      -3.1990000000000009E+001,
      -31.98,
      -3.1970000000000002E+001,
      -3.1960000000000004E+001,
      -3.1950000000000006E+001,
      -3.1939999999999998E+001,
      -3.1930000000000007E+001,
      -3.1920000000000009E+001,
      -3.1910000000000004E+001,
      -3.1900000000000002E+001,
      -3.1890000000000011E+001,
      -3.1880000000000006E+001,
      -3.1870000000000008E+001,
      -3.1860000000000007E+001,
      -3.1850000000000009E+001,
      -3.1840000000000003E+001,
      -3.1830000000000013E+001,
      -3.1820000000000004E+001,
      -31.81,
      -3.1800000000000008E+001,
      -31.79,
      -31.78,
      -3.1770000000000003E+001,
      -3.1760000000000012E+001,
      -3.1749999999999996E+001,
      -3.1740000000000006E+001,
      -3.1730000000000008E+001,
      -3.1720000000000010E+001,
      -31.71,
      -3.1700000000000010E+001,
      -3.1690000000000005E+001,
      -3.1680000000000007E+001,
      -3.1670000000000005E+001,
      -3.1660000000000007E+001,
      -3.1650000000000002E+001,
      -3.1640000000000011E+001,
      -3.1630000000000003E+001,
      -3.1619999999999997E+001,
      -3.1610000000000007E+001,
      -3.1600000000000016E+001,
      -31.59,
      -3.1580000000000002E+001,
      -3.1570000000000011E+001,
      -3.1560000000000002E+001,
      -3.1550000000000004E+001,
      -3.1540000000000006E+001,
      -3.1530000000000008E+001,
      -31.52,
      -3.1510000000000009E+001,
      -3.1500000000000004E+001,
      -3.1490000000000006E+001,
      -3.1480000000000004E+001,
      -3.1470000000000006E+001,
      -31.46,
      -3.1450000000000010E+001,
      -3.1440000000000008E+001,
      -3.1429999999999996E+001,
      -3.1420000000000005E+001,
      -3.1410000000000014E+001,
      -3.1400000000000006E+001,
      -31.39,
      -3.1380000000000010E+001,
      -31.37,
      -3.1360000000000003E+001,
      -3.1350000000000005E+001,
      -3.1340000000000007E+001,
      -31.33,
      -3.1320000000000007E+001,
      -3.1310000000000002E+001,
      -3.1300000000000004E+001,
      -3.1290000000000003E+001,
      -3.1280000000000012E+001,
      -31.27,
      -3.1260000000000009E+001,
      -3.1250000000000007E+001,
      -3.1240000000000009E+001,
      -3.1230000000000004E+001,
      -3.1220000000000013E+001,
      -3.1210000000000004E+001,
      -31.2,
      -3.1190000000000008E+001,
      -31.18,
      -31.17,
      -3.1160000000000004E+001,
      -3.1150000000000006E+001,
      -3.1139999999999997E+001,
      -3.1130000000000006E+001,
      -3.1120000000000008E+001,
      -3.1110000000000003E+001,
      -31.1,
      -3.1090000000000011E+001,
      -3.1080000000000005E+001,
      -3.1070000000000007E+001,
      -3.1060000000000006E+001,
      -3.1050000000000008E+001,
      -3.1040000000000003E+001,
      -3.1030000000000012E+001,
      -3.1020000000000003E+001,
      -3.1009999999999998E+001,
      -3.1000000000000007E+001,
      -30.99,
      -30.98,
      -3.0970000000000002E+001,
      -3.0960000000000012E+001,
      -3.0949999999999996E+001,
      -3.0940000000000005E+001,
      -3.0930000000000007E+001,
      -3.0920000000000009E+001,
      -30.91,
      -3.0900000000000009E+001,
      -3.0890000000000004E+001,
      -3.0880000000000006E+001,
      -3.0870000000000005E+001,
      -3.0860000000000007E+001,
      -30.85,
      -3.0840000000000011E+001,
      -3.0830000000000002E+001,
      -3.0819999999999997E+001,
      -3.0810000000000006E+001,
      -3.0800000000000015E+001,
      -30.79,
      -30.78,
      -3.0770000000000010E+001,
      -30.76,
      -3.0750000000000004E+001,
      -3.0740000000000006E+001,
      -3.0730000000000008E+001,
      -30.72,
      -3.0710000000000008E+001,
      -3.0700000000000003E+001,
      -3.0690000000000005E+001,
      -3.0680000000000003E+001,
      -3.0670000000000005E+001,
      -30.66,
      -3.0650000000000009E+001,
      -3.0640000000000008E+001,
      -3.0630000000000010E+001,
      -3.0620000000000005E+001,
      -3.0610000000000014E+001,
      -3.0600000000000005E+001,
      -30.59,
      -3.0580000000000009E+001,
      -30.57,
      -3.0560000000000002E+001,
      -3.0550000000000004E+001,
      -3.0540000000000006E+001,
      -3.0529999999999998E+001,
      -3.0520000000000007E+001,
      -3.0510000000000009E+001,
      -3.0500000000000004E+001,
      -3.0490000000000002E+001,
      -3.0480000000000011E+001,
      -3.0470000000000006E+001,
      -3.0460000000000008E+001,
      -3.0450000000000006E+001,
      -3.0440000000000008E+001,
      -3.0430000000000003E+001,
      -3.0420000000000012E+001,
      -3.0410000000000004E+001,
      -30.4,
      -3.0390000000000008E+001,
      -30.38,
      -30.37,
      -3.0360000000000003E+001,
      -3.0350000000000012E+001,
      -3.0339999999999996E+001,
      -3.0330000000000005E+001,
      -3.0320000000000007E+001,
      -3.0310000000000009E+001,
      -30.3,
      -3.0290000000000010E+001,
      -3.0280000000000005E+001,
      -3.0270000000000007E+001,
      -3.0260000000000005E+001,
      -3.0250000000000007E+001,
      -3.0240000000000002E+001,
      -3.0230000000000011E+001,
      -3.0220000000000002E+001,
      -3.0209999999999997E+001,
      -3.0200000000000006E+001,
      -3.0190000000000015E+001,
      -30.18,
      -30.17,
      -3.0160000000000011E+001,
      -3.0150000000000002E+001,
      -3.0140000000000004E+001,
      -3.0130000000000006E+001,
      -3.0120000000000008E+001,
      -30.11,
      -3.0100000000000009E+001,
      -3.0090000000000003E+001,
      -3.0080000000000005E+001,
      -3.0070000000000004E+001,
      -3.0060000000000006E+001,
      -30.05,
      -3.0040000000000010E+001,
      -3.0030000000000008E+001,
      -3.0019999999999996E+001,
      -3.0010000000000005E+001,
      -3.0000000000000014E+001,
      -2.9990000000000006E+001,
      -29.98,
      -2.9970000000000010E+001,
      -29.96,
      -2.9950000000000003E+001,
      -2.9940000000000005E+001,
      -2.9930000000000007E+001,
      -2.9919999999999998E+001,
      -2.9910000000000007E+001,
      -2.9900000000000002E+001,
      -2.9890000000000004E+001,
      -2.9880000000000003E+001,
      -2.9870000000000012E+001,
      -29.86,
      -2.9850000000000009E+001,
      -2.9840000000000007E+001,
      -2.9830000000000009E+001,
      -2.9820000000000004E+001,
      -2.9810000000000013E+001,
      -2.9800000000000004E+001,
      -29.79,
      -2.9780000000000008E+001,
      -29.77,
      -29.76,
      -2.9750000000000004E+001,
      -2.9740000000000006E+001,
      -2.9729999999999997E+001,
      -2.9720000000000006E+001,
      -2.9710000000000008E+001,
      -2.9700000000000003E+001,
      -29.69,
      -2.9680000000000010E+001,
      -2.9670000000000005E+001,
      -2.9660000000000007E+001,
      -2.9650000000000006E+001,
      -2.9640000000000008E+001,
      -2.9630000000000003E+001,
      -2.9620000000000012E+001,
      -2.9610000000000003E+001,
      -2.9599999999999998E+001,
      -2.9590000000000007E+001,
      -29.58,
      -29.57,
      -2.9560000000000002E+001,
      -2.9550000000000011E+001,
      -2.9539999999999996E+001,
      -2.9530000000000005E+001,
      -2.9520000000000007E+001,
      -2.9510000000000009E+001,
      -29.5,
      -2.9490000000000009E+001,
      -2.9480000000000004E+001,
      -2.9470000000000006E+001,
      -2.9460000000000004E+001,
      -2.9450000000000006E+001,
      -29.44,
      -2.9430000000000010E+001,
      -29.42,
      -2.9409999999999997E+001,
      -2.9400000000000006E+001,
      -2.9390000000000015E+001,
      -2.9380000000000006E+001,
      -29.37,
      -2.9360000000000010E+001,
      -29.35,
      -2.9340000000000003E+001,
      -2.9330000000000005E+001,
      -2.9320000000000007E+001,
      -29.31,
      -2.9300000000000008E+001,
      -2.9290000000000003E+001,
      -2.9280000000000005E+001,
      -2.9270000000000003E+001,
      -2.9260000000000012E+001,
      -29.25,
      -2.9240000000000009E+001,
      -2.9230000000000008E+001,
      -2.9220000000000010E+001,
      -2.9210000000000004E+001,
      -2.9200000000000014E+001,
      -2.9190000000000005E+001,
      -29.18,
      -2.9170000000000009E+001,
      -29.16,
      -2.9150000000000002E+001,
      -2.9140000000000004E+001,
      -2.9130000000000006E+001,
      -2.9119999999999997E+001,
      -2.9110000000000007E+001,
      -2.9100000000000009E+001,
      -2.9090000000000003E+001,
      -2.9080000000000002E+001,
      -2.9070000000000011E+001,
      -2.9060000000000006E+001,
      -2.9050000000000008E+001,
      -2.9040000000000006E+001,
      -2.9030000000000008E+001,
      -2.9020000000000003E+001,
      -2.9010000000000012E+001,
      -2.9000000000000004E+001,
      -28.99,
      -2.8980000000000008E+001,
      -28.97,
      -28.96,
      -2.8950000000000003E+001,
      -2.8940000000000012E+001,
      -2.8929999999999996E+001,
      -2.8920000000000005E+001,
      -2.8910000000000007E+001,
      -2.8900000000000009E+001,
      -28.89,
      -2.8880000000000010E+001,
      -2.8870000000000005E+001,
      -2.8860000000000007E+001,
      -2.8850000000000005E+001,
      -2.8840000000000007E+001,
      -2.8830000000000002E+001,
      -2.8820000000000011E+001,
      -2.8810000000000002E+001,
      -2.8799999999999997E+001,
      -2.8790000000000006E+001,
      -2.8780000000000015E+001,
      -28.77,
      -28.76,
      -2.8750000000000011E+001,
      -2.8740000000000002E+001,
      -2.8730000000000004E+001,
      -2.8720000000000006E+001,
      -2.8710000000000008E+001,
      -28.7,
      -2.8690000000000008E+001,
      -2.8680000000000003E+001,
      -2.8670000000000005E+001,
      -2.8660000000000004E+001,
      -2.8650000000000006E+001,
      -28.64,
      -2.8630000000000010E+001,
      -2.8620000000000008E+001,
      -2.8609999999999996E+001,
      -2.8600000000000005E+001,
      -2.8590000000000014E+001,
      -2.8580000000000005E+001,
      -28.57,
      -2.8560000000000009E+001,
      -28.55,
      -2.8540000000000003E+001,
      -2.8530000000000005E+001,
      -2.8520000000000007E+001,
      -2.8509999999999998E+001,
      -2.8500000000000007E+001,
      -2.8490000000000002E+001,
      -2.8480000000000004E+001,
      -2.8470000000000002E+001,
      -2.8460000000000012E+001,
      -28.45,
      -2.8440000000000008E+001,
      -2.8430000000000007E+001,
      -2.8420000000000009E+001,
      -2.8410000000000004E+001,
      -2.8400000000000013E+001,
      -2.8390000000000004E+001,
      -28.38,
      -2.8370000000000008E+001,
      -28.36,
      -28.35,
      -2.8340000000000003E+001,
      -2.8330000000000005E+001,
      -2.8319999999999997E+001,
      -2.8310000000000006E+001,
      -2.8300000000000008E+001,
      -2.8290000000000003E+001,
      -28.28,
      -2.8270000000000010E+001,
      -2.8260000000000005E+001,
      -2.8250000000000007E+001,
      -2.8240000000000006E+001,
      -2.8230000000000008E+001,
      -2.8220000000000002E+001,
      -2.8210000000000012E+001,
      -2.8200000000000003E+001,
      -2.8189999999999998E+001,
      -2.8180000000000007E+001,
      -2.8169999999999998E+001,
      -28.16,
      -2.8150000000000002E+001,
      -2.8140000000000011E+001,
      -2.8129999999999995E+001,
      -2.8120000000000005E+001,
      -2.8110000000000007E+001,
      -2.8100000000000009E+001,
      -28.09,
      -2.8080000000000009E+001,
      -2.8070000000000004E+001,
      -2.8060000000000006E+001,
      -2.8050000000000004E+001,
      -2.8040000000000006E+001,
      -28.03,
      -2.8020000000000010E+001,
      -2.8010000000000009E+001,
      -2.7999999999999996E+001,
      -2.7990000000000006E+001,
      -2.7980000000000015E+001,
      -2.7970000000000006E+001,
      -27.96,
      -2.7950000000000010E+001,
      -27.94,
      -2.7930000000000003E+001,
      -2.7920000000000005E+001,
      -2.7910000000000007E+001,
      -27.9,
      -2.7890000000000008E+001,
      -2.7880000000000003E+001,
      -2.7870000000000005E+001,
      -2.7860000000000003E+001,
      -2.7850000000000012E+001,
      -27.84,
      -2.7830000000000009E+001,
      -2.7820000000000007E+001,
      -2.7810000000000009E+001,
      -2.7800000000000004E+001,
      -2.7790000000000013E+001,
      -2.7780000000000005E+001,
      -27.77,
      -2.7760000000000009E+001,
      -27.75,
      -2.7740000000000002E+001,
      -2.7730000000000004E+001,
      -2.7720000000000006E+001,
      -2.7709999999999997E+001,
      -2.7700000000000006E+001,
      -2.7690000000000008E+001,
      -2.7680000000000003E+001,
      -27.67,
      -2.7660000000000011E+001,
      -2.7650000000000006E+001,
      -2.7640000000000008E+001,
      -2.7630000000000006E+001,
      -2.7620000000000008E+001,
      -2.7610000000000003E+001,
      -2.7600000000000012E+001,
      -2.7590000000000003E+001,
      -27.58,
      -2.7570000000000007E+001,
      -27.56,
      -27.55,
      -2.7540000000000003E+001,
      -2.7530000000000012E+001,
      -2.7519999999999996E+001,
      -2.7510000000000005E+001,
      -2.7500000000000007E+001,
      -2.7490000000000009E+001,
      -27.48,
      -2.7470000000000010E+001,
      -2.7460000000000004E+001,
      -2.7450000000000006E+001,
      -2.7440000000000005E+001,
      -2.7430000000000007E+001,
      -27.42,
      -2.7410000000000011E+001,
      -2.7400000000000002E+001,
      -2.7389999999999997E+001,
      -2.7380000000000006E+001,
      -2.7370000000000015E+001,
      -27.36,
      -27.35,
      -2.7340000000000011E+001,
      -2.7330000000000002E+001,
      -2.7320000000000004E+001,
      -2.7310000000000006E+001,
      -2.7300000000000008E+001,
      -27.29,
      -2.7280000000000008E+001,
      -2.7270000000000003E+001,
      -2.7260000000000005E+001,
      -2.7250000000000004E+001,
      -2.7240000000000006E+001,
      -27.23,
      -2.7220000000000010E+001,
      -2.7210000000000008E+001,
      -2.7199999999999996E+001,
      -2.7190000000000005E+001,
      -2.7180000000000014E+001,
      -2.7170000000000005E+001,
      -27.16,
      -2.7150000000000009E+001,
      -27.14,
      -2.7130000000000003E+001,
      -2.7120000000000005E+001,
      -2.7110000000000007E+001,
      -2.7099999999999998E+001,
      -2.7090000000000007E+001,
      -2.7080000000000002E+001,
      -2.7070000000000004E+001,
      -2.7060000000000002E+001,
      -2.7050000000000011E+001,
      -27.04,
      -2.7030000000000008E+001,
      -2.7020000000000007E+001,
      -2.7010000000000009E+001,
      -2.7000000000000004E+001,
      -2.6990000000000013E+001,
      -2.6980000000000004E+001,
      -26.97,
      -2.6960000000000008E+001,
      -26.95,
      -26.94,
      -2.6930000000000003E+001,
      -2.6920000000000005E+001,
      -2.6909999999999997E+001,
      -2.6900000000000006E+001,
      -2.6890000000000008E+001,
      -2.6880000000000003E+001,
      -26.87,
      -2.6860000000000010E+001,
      -2.6850000000000005E+001,
      -2.6840000000000007E+001,
      -2.6830000000000005E+001,
      -2.6820000000000007E+001,
      -2.6810000000000002E+001,
      -2.6800000000000011E+001,
      -2.6790000000000003E+001,
      -2.6779999999999998E+001,
      -2.6770000000000007E+001,
      -2.6760000000000016E+001,
      -26.75,
      -2.6740000000000002E+001,
      -2.6730000000000011E+001,
      -2.6720000000000002E+001,
      -2.6710000000000004E+001,
      -2.6700000000000006E+001,
      -2.6690000000000008E+001,
      -26.68,
      -2.6670000000000009E+001,
      -2.6660000000000004E+001,
      -2.6650000000000006E+001,
      -2.6640000000000004E+001,
      -2.6630000000000006E+001,
      -26.62,
      -2.6610000000000010E+001,
      -2.6600000000000009E+001,
      -2.6589999999999996E+001,
      -2.6580000000000005E+001,
      -2.6570000000000014E+001,
      -2.6560000000000006E+001,
      -26.55,
      -2.6540000000000010E+001,
      -26.53,
      -2.6520000000000003E+001,
      -2.6510000000000005E+001,
      -2.6500000000000007E+001,
      -26.49,
      -2.6480000000000008E+001,
      -2.6470000000000002E+001,
      -2.6460000000000004E+001,
      -2.6450000000000003E+001,
      -2.6440000000000012E+001,
      -26.43,
      -2.6420000000000009E+001,
      -2.6410000000000007E+001,
      -2.6400000000000009E+001,
      -2.6390000000000004E+001,
      -2.6380000000000013E+001,
      -2.6370000000000005E+001,
      -26.36,
      -2.6350000000000009E+001,
      -26.34,
      -2.6330000000000002E+001,
      -2.6320000000000004E+001,
      -2.6310000000000006E+001,
      -2.6299999999999997E+001,
      -2.6290000000000006E+001,
      -2.6280000000000008E+001,
      -2.6270000000000003E+001,
      -26.26,
      -2.6250000000000011E+001,
      -2.6240000000000006E+001,
      -2.6230000000000008E+001,
      -2.6220000000000006E+001,
      -2.6210000000000008E+001,
      -2.6200000000000003E+001,
      -2.6190000000000012E+001,
      -2.6180000000000003E+001,
      -2.6169999999999998E+001,
      -2.6160000000000007E+001,
      -26.15,
      -26.14,
      -2.6130000000000003E+001,
      -2.6120000000000012E+001,
      -2.6109999999999996E+001,
      -2.6100000000000005E+001,
      -2.6090000000000007E+001,
      -2.6080000000000009E+001,
      -26.07,
      -2.6060000000000009E+001,
      -2.6050000000000004E+001,
      -2.6040000000000006E+001,
      -2.6030000000000005E+001,
      -2.6020000000000007E+001,
      -26.01,
      -2.6000000000000011E+001,
      -2.5990000000000002E+001,
      -2.5979999999999997E+001,
      -2.5970000000000006E+001,
      -2.5960000000000015E+001,
      -25.95,
      -25.94,
      -2.5930000000000010E+001,
      -25.92,
      -2.5910000000000004E+001,
      -2.5900000000000006E+001,
      -2.5890000000000008E+001,
      -25.88,
      -2.5870000000000008E+001,
      -2.5860000000000003E+001,
      -2.5850000000000005E+001,
      -2.5840000000000003E+001,
      -2.5830000000000005E+001,
      -25.82,
      -2.5810000000000009E+001,
      -2.5800000000000008E+001,
      -2.5789999999999996E+001,
      -2.5780000000000005E+001,
      -2.5770000000000014E+001,
      -2.5760000000000005E+001,
      -25.75,
      -2.5740000000000009E+001,
      -25.73,
      -2.5720000000000002E+001,
      -2.5710000000000004E+001,
      -2.5700000000000006E+001,
      -2.5689999999999998E+001,
      -2.5680000000000007E+001,
      -25.67,
      -2.5660000000000004E+001,
      -2.5650000000000002E+001,
      -2.5640000000000011E+001,
      -25.63,
      -2.5620000000000008E+001,
      -2.5610000000000007E+001,
      -2.5600000000000009E+001,
      -2.5590000000000003E+001,
      -2.5580000000000013E+001,
      -2.5570000000000004E+001,
      -25.56,
      -2.5550000000000008E+001,
      -25.54,
      -25.53,
      -2.5520000000000003E+001,
      -2.5510000000000012E+001,
      -2.5499999999999996E+001,
      -2.5490000000000006E+001,
      -2.5480000000000008E+001,
      -2.5470000000000010E+001,
      -25.46,
      -2.5450000000000010E+001,
      -2.5440000000000005E+001,
      -2.5430000000000007E+001,
      -2.5420000000000005E+001,
      -2.5410000000000007E+001,
      -2.5400000000000002E+001,
      -2.5390000000000011E+001,
      -2.5380000000000003E+001,
      -2.5369999999999997E+001,
      -2.5360000000000007E+001,
      -2.5350000000000016E+001,
      -25.34,
      -2.5330000000000002E+001,
      -2.5320000000000011E+001,
      -2.5310000000000002E+001,
      -2.5300000000000004E+001,
      -2.5290000000000006E+001,
      -2.5280000000000008E+001,
      -25.27,
      -2.5260000000000009E+001,
      -2.5250000000000004E+001,
      -2.5240000000000006E+001,
      -2.5230000000000004E+001,
      -2.5220000000000006E+001,
      -25.21,
      -2.5200000000000010E+001,
      -2.5190000000000008E+001,
      -2.5179999999999996E+001,
      -2.5170000000000005E+001,
      -2.5160000000000014E+001,
      -2.5150000000000006E+001,
      -25.14,
      -2.5130000000000010E+001,
      -25.12,
      -2.5110000000000003E+001,
      -2.5100000000000005E+001,
      -2.5090000000000007E+001,
      -25.08,
      -2.5070000000000007E+001,
      -2.5060000000000002E+001,
      -2.5050000000000004E+001,
      -2.5040000000000003E+001,
      -2.5030000000000012E+001,
      -25.02,
      -2.5010000000000009E+001,
      -2.5000000000000007E+001,
      -2.4990000000000009E+001,
      -2.4980000000000004E+001,
      -2.4970000000000013E+001,
      -2.4960000000000004E+001,
      -24.95,
      -2.4940000000000008E+001,
      -24.93,
      -24.92,
      -2.4910000000000004E+001,
      -2.4900000000000006E+001,
      -2.4889999999999997E+001,
      -2.4880000000000006E+001,
      -2.4870000000000008E+001,
      -2.4860000000000003E+001,
      -24.85,
      -2.4840000000000011E+001,
      -2.4830000000000005E+001,
      -2.4820000000000007E+001,
      -2.4810000000000006E+001,
      -2.4800000000000008E+001,
      -2.4790000000000003E+001,
      -2.4780000000000012E+001,
      -2.4770000000000003E+001,
      -2.4759999999999998E+001,
      -2.4750000000000007E+001,
      -24.74,
      -24.73,
      -2.4720000000000002E+001,
      -2.4710000000000012E+001,
      -2.4699999999999996E+001,
      -2.4690000000000005E+001,
      -2.4680000000000007E+001,
      -2.4670000000000009E+001,
      -24.66,
      -2.4650000000000009E+001,
      -2.4640000000000004E+001,
      -2.4630000000000006E+001,
      -2.4620000000000005E+001,
      -2.4610000000000007E+001,
      -24.6,
      -2.4590000000000011E+001,
      -2.4580000000000002E+001,
      -2.4569999999999997E+001,
      -2.4560000000000006E+001,
      -2.4550000000000015E+001,
      -24.54,
      -24.53,
      -2.4520000000000010E+001,
      -24.51,
      -2.4500000000000004E+001,
      -2.4490000000000006E+001,
      -2.4480000000000008E+001,
      -24.47,
      -2.4460000000000008E+001,
      -2.4450000000000003E+001,
      -2.4440000000000005E+001,
      -2.4430000000000003E+001,
      -2.4420000000000005E+001,
      -24.41,
      -2.4400000000000009E+001,
      -2.4390000000000008E+001,
      -2.4379999999999995E+001,
      -2.4370000000000005E+001,
      -2.4360000000000014E+001,
      -2.4350000000000005E+001,
      -24.34,
      -2.4330000000000009E+001,
      -24.32,
      -2.4310000000000002E+001,
      -2.4300000000000004E+001,
      -2.4290000000000006E+001,
      -2.4279999999999998E+001,
      -2.4270000000000007E+001,
      -2.4260000000000009E+001,
      -2.4250000000000004E+001,
      -2.4240000000000002E+001,
      -2.4230000000000011E+001,
      -2.4220000000000006E+001,
      -2.4210000000000008E+001,
      -2.4200000000000006E+001,
      -2.4190000000000008E+001,
      -2.4180000000000003E+001,
      -2.4170000000000012E+001,
      -2.4160000000000004E+001,
      -24.15,
      -2.4140000000000008E+001,
      -24.13,
      -24.12,
      -2.4110000000000003E+001,
      -2.4100000000000012E+001,
      -2.4089999999999996E+001,
      -2.4080000000000005E+001,
      -2.4070000000000007E+001,
      -2.4060000000000009E+001,
      -24.05,
      -2.4040000000000010E+001,
      -2.4030000000000005E+001,
      -2.4020000000000007E+001,
      -2.4010000000000005E+001,
      -2.4000000000000007E+001,
      -2.3990000000000002E+001,
      -2.3980000000000011E+001,
      -2.3970000000000002E+001,
      -2.3959999999999997E+001,
      -2.3950000000000006E+001,
      -2.3940000000000015E+001,
      -23.93,
      -23.92,
      -2.3910000000000011E+001,
      -2.3900000000000002E+001,
      -2.3890000000000004E+001,
      -2.3880000000000006E+001,
      -2.3870000000000008E+001,
      -23.86,
      -2.3850000000000009E+001,
      -2.3840000000000003E+001,
      -2.3830000000000005E+001,
      -2.3820000000000004E+001,
      -2.3810000000000006E+001,
      -23.8,
      -2.3790000000000010E+001,
      -2.3780000000000008E+001,
      -2.3769999999999996E+001,
      -2.3760000000000005E+001,
      -2.3750000000000014E+001,
      -2.3740000000000006E+001,
      -23.73,
      -2.3720000000000010E+001,
      -23.71,
      -2.3700000000000003E+001,
      -2.3690000000000005E+001,
      -2.3680000000000007E+001,
      -2.3669999999999998E+001,
      -2.3660000000000007E+001,
      -2.3650000000000002E+001,
      -2.3640000000000004E+001,
      -2.3630000000000003E+001,
      -2.3620000000000012E+001,
      -23.61,
      -2.3600000000000009E+001,
      -2.3590000000000007E+001,
      -2.3580000000000009E+001,
      -2.3570000000000004E+001,
      -2.3560000000000013E+001,
      -2.3550000000000004E+001,
      -23.54,
      -2.3530000000000008E+001,
      -23.52,
      -23.51,
      -2.3500000000000004E+001,
      -2.3490000000000006E+001,
      -2.3479999999999997E+001,
      -2.3470000000000006E+001,
      -2.3460000000000008E+001,
      -2.3450000000000003E+001,
      -23.44,
      -2.3430000000000010E+001,
      -2.3420000000000005E+001,
      -2.3410000000000007E+001,
      -2.3400000000000006E+001,
      -2.3390000000000008E+001,
      -2.3380000000000003E+001,
      -2.3370000000000012E+001,
      -2.3360000000000003E+001,
      -2.3349999999999998E+001,
      -2.3340000000000007E+001,
      -23.33,
      -23.32,
      -2.3310000000000002E+001,
      -2.3300000000000011E+001,
      -2.3289999999999996E+001,
      -2.3280000000000005E+001,
      -2.3270000000000007E+001,
      -2.3260000000000009E+001,
      -23.25,
      -2.3240000000000009E+001,
      -2.3230000000000004E+001,
      -2.3220000000000006E+001,
      -2.3210000000000004E+001,
      -2.3200000000000006E+001,
      -23.19,
      -2.3180000000000010E+001,
      -23.17,
      -2.3159999999999997E+001,
      -2.3150000000000006E+001,
      -2.3140000000000015E+001,
      -23.13,
      -23.12,
      -2.3110000000000010E+001,
      -23.1,
      -2.3090000000000003E+001,
      -2.3080000000000005E+001,
      -2.3070000000000007E+001,
      -23.06,
      -2.3050000000000008E+001,
      -2.3040000000000003E+001,
      -2.3030000000000005E+001,
      -2.3020000000000003E+001,
      -2.3010000000000005E+001,
      -23.0,
      -2.2990000000000009E+001,
      -2.2980000000000008E+001,
      -2.2970000000000010E+001,
      -2.2960000000000004E+001,
      -2.2950000000000014E+001,
      -2.2940000000000005E+001,
      -22.93,
      -2.2920000000000009E+001,
      -22.91,
      -2.2900000000000002E+001,
      -2.2890000000000004E+001,
      -2.2880000000000006E+001,
      -2.2869999999999997E+001,
      -2.2860000000000007E+001,
      -2.2850000000000009E+001,
      -2.2840000000000003E+001,
      -2.2830000000000002E+001,
      -2.2820000000000011E+001,
      -2.2810000000000006E+001,
      -2.2800000000000008E+001,
      -2.2790000000000006E+001,
      -2.2780000000000008E+001,
      -2.2770000000000003E+001,
      -2.2760000000000012E+001,
      -2.2750000000000004E+001,
      -22.74,
      -2.2730000000000008E+001,
      -22.72,
      -22.71,
      -2.2700000000000003E+001,
      -2.2690000000000012E+001,
      -2.2679999999999996E+001,
      -2.2670000000000005E+001,
      -2.2660000000000007E+001,
      -2.2650000000000009E+001,
      -22.64,
      -2.2630000000000010E+001,
      -2.2620000000000005E+001,
      -2.2610000000000007E+001,
      -2.2600000000000005E+001,
      -2.2590000000000007E+001,
      -2.2580000000000002E+001,
      -2.2570000000000011E+001,
      -2.2560000000000002E+001,
      -2.2549999999999997E+001,
      -2.2540000000000006E+001,
      -2.2530000000000015E+001,
      -22.52,
      -22.51,
      -2.2500000000000011E+001,
      -2.2490000000000002E+001,
      -2.2480000000000004E+001,
      -2.2470000000000006E+001,
      -2.2460000000000008E+001,
      -22.45,
      -2.2440000000000008E+001,
      -2.2430000000000003E+001,
      -2.2420000000000005E+001,
      -2.2410000000000004E+001,
      -2.2400000000000006E+001,
      -22.39,
      -2.2380000000000010E+001,
      -22.37,
      -2.2360000000000010E+001,
      -2.2350000000000005E+001,
      -2.2340000000000014E+001,
      -2.2330000000000005E+001,
      -22.32,
      -2.2310000000000009E+001,
      -22.3,
      -2.2290000000000003E+001,
      -2.2280000000000005E+001,
      -2.2270000000000007E+001,
      -2.2259999999999998E+001,
      -2.2250000000000007E+001,
      -2.2240000000000002E+001,
      -2.2230000000000004E+001,
      -2.2220000000000002E+001,
      -2.2210000000000004E+001,
      -2.2200000000000006E+001,
      -2.2190000000000008E+001,
      -2.2180000000000007E+001,
      -2.2170000000000009E+001,
      -2.2160000000000004E+001,
      -2.2150000000000013E+001,
      -2.2140000000000004E+001,
      -22.13,
      -2.2120000000000008E+001,
      -22.11,
      -22.1,
      -2.2090000000000003E+001,
      -2.2080000000000005E+001,
      -2.2069999999999997E+001,
      -2.2060000000000006E+001,
      -22.05,
      -2.2040000000000010E+001,
      -22.03,
      -2.2020000000000010E+001,
      -2.2010000000000005E+001,
      -2.2000000000000007E+001,
      -2.1990000000000006E+001,
      -2.1980000000000008E+001,
      -2.1970000000000002E+001,
      -2.1960000000000012E+001,
      -2.1950000000000003E+001,
      -2.1939999999999998E+001,
      -2.1930000000000007E+001,
      -2.1919999999999998E+001,
      -21.91,
      -2.1900000000000002E+001,
      -2.1890000000000004E+001,
      -2.1880000000000003E+001,
      -2.1870000000000005E+001,
      -2.1860000000000007E+001,
      -2.1850000000000009E+001,
      -21.84,
      -2.1830000000000009E+001,
      -2.1820000000000004E+001,
      -2.1810000000000006E+001,
      -2.1800000000000004E+001,
      -2.1790000000000006E+001,
      -21.78,
      -2.1770000000000010E+001,
      -21.76,
      -2.1749999999999996E+001,
      -2.1740000000000006E+001,
      -2.1729999999999997E+001,
      -2.1720000000000006E+001,
      -21.71,
      -2.1700000000000010E+001,
      -21.69,
      -2.1680000000000003E+001,
      -2.1670000000000005E+001,
      -2.1660000000000007E+001,
      -21.65,
      -2.1640000000000008E+001,
      -2.1630000000000003E+001,
      -2.1620000000000005E+001,
      -2.1610000000000003E+001,
      -2.1600000000000005E+001,
      -2.1590000000000007E+001,
      -2.1580000000000009E+001,
      -2.1570000000000007E+001,
      -2.1560000000000009E+001,
      -2.1550000000000004E+001,
      -2.1540000000000013E+001,
      -2.1530000000000005E+001,
      -21.52,
      -2.1510000000000009E+001,
      -21.5,
      -2.1490000000000002E+001,
      -2.1480000000000004E+001,
      -2.1470000000000006E+001,
      -2.1459999999999997E+001,
      -2.1450000000000006E+001,
      -21.44,
      -2.1430000000000010E+001,
      -21.42,
      -2.1410000000000011E+001,
      -2.1400000000000006E+001,
      -2.1390000000000008E+001,
      -2.1380000000000006E+001,
      -2.1370000000000008E+001,
      -2.1360000000000003E+001,
      -2.1350000000000012E+001,
      -2.1340000000000003E+001,
      -21.33,
      -2.1320000000000007E+001,
      -21.31,
      -21.3,
      -2.1290000000000003E+001,
      -2.1280000000000005E+001,
      -2.1270000000000003E+001,
      -2.1260000000000005E+001,
      -2.1250000000000007E+001,
      -2.1240000000000009E+001,
      -21.23,
      -2.1220000000000010E+001,
      -2.1210000000000004E+001,
      -2.1200000000000006E+001,
      -2.1190000000000005E+001,
      -2.1180000000000007E+001,
      -21.17,
      -2.1160000000000011E+001,
      -2.1150000000000002E+001,
      -2.1139999999999997E+001,
      -2.1130000000000006E+001,
      -2.1119999999999997E+001,
      -2.1110000000000007E+001,
      -21.1,
      -2.1090000000000011E+001,
      -2.1080000000000002E+001,
      -2.1070000000000004E+001,
      -2.1060000000000006E+001,
      -2.1050000000000008E+001,
      -21.04,
      -2.1030000000000008E+001,
      -2.1020000000000003E+001,
      -2.1010000000000005E+001,
      -2.1000000000000004E+001,
      -2.0990000000000006E+001,
      -20.98,
      -2.0970000000000010E+001,
      -20.96,
      -2.0950000000000010E+001,
      -2.0940000000000005E+001,
      -2.0930000000000014E+001,
      -2.0920000000000005E+001,
      -20.91,
      -2.0900000000000009E+001,
      -20.89,
      -2.0880000000000003E+001,
      -2.0870000000000005E+001,
      -2.0860000000000007E+001,
      -2.0849999999999998E+001,
      -2.0840000000000007E+001,
      -2.0830000000000002E+001,
      -2.0820000000000004E+001,
      -2.0810000000000002E+001,
      -2.0800000000000004E+001,
      -2.0790000000000006E+001,
      -2.0780000000000008E+001,
      -2.0770000000000007E+001,
      -2.0760000000000009E+001,
      -2.0750000000000004E+001,
      -2.0740000000000013E+001,
      -2.0730000000000004E+001,
      -20.72,
      -2.0710000000000008E+001,
      -20.7,
      -20.69,
      -2.0680000000000003E+001,
      -2.0670000000000005E+001,
      -2.0659999999999997E+001,
      -2.0650000000000006E+001,
      -20.64,
      -2.0630000000000010E+001,
      -20.62,
      -2.0610000000000010E+001,
      -2.0600000000000005E+001,
      -2.0590000000000007E+001,
      -2.0580000000000005E+001,
      -2.0570000000000007E+001,
      -2.0560000000000002E+001,
      -2.0550000000000011E+001,
      -2.0540000000000003E+001,
      -2.0529999999999998E+001,
      -2.0520000000000007E+001,
      -2.0509999999999998E+001,
      -20.5,
      -2.0490000000000002E+001,
      -2.0480000000000004E+001,
      -2.0470000000000002E+001,
      -2.0460000000000004E+001,
      -2.0450000000000006E+001,
      -2.0440000000000008E+001,
      -20.43,
      -2.0420000000000009E+001,
      -2.0410000000000004E+001,
      -2.0400000000000006E+001,
      -2.0390000000000004E+001,
      -2.0380000000000006E+001,
      -20.37,
      -2.0360000000000010E+001,
      -20.35,
      -2.0340000000000011E+001,
      -2.0330000000000005E+001,
      -2.0320000000000014E+001,
      -2.0310000000000006E+001,
      -20.3,
      -2.0290000000000010E+001,
      -20.28,
      -2.0270000000000003E+001,
      -2.0260000000000005E+001,
      -2.0250000000000007E+001,
      -20.24,
      -2.0230000000000008E+001,
      -2.0220000000000002E+001,
      -2.0210000000000004E+001,
      -2.0200000000000003E+001,
      -2.0190000000000005E+001,
      -2.0180000000000007E+001,
      -2.0170000000000009E+001,
      -2.0160000000000007E+001,
      -2.0150000000000009E+001,
      -2.0140000000000004E+001,
      -2.0130000000000013E+001,
      -2.0120000000000005E+001,
      -20.11,
      -2.0100000000000009E+001,
      -20.09,
      -2.0080000000000002E+001,
      -2.0070000000000004E+001,
      -2.0060000000000006E+001,
      -2.0049999999999997E+001,
      -2.0040000000000006E+001,
      -20.03,
      -2.0020000000000010E+001,
      -20.01,
      -2.0000000000000011E+001,
      -1.9990000000000006E+001,
      -1.9980000000000008E+001,
      -1.9970000000000006E+001,
      -1.9960000000000008E+001,
      -1.9950000000000003E+001,
      -1.9940000000000012E+001,
      -1.9930000000000003E+001,
      -1.9919999999999998E+001,
      -1.9910000000000007E+001,
      -19.9,
      -19.89,
      -1.9880000000000003E+001,
      -1.9870000000000005E+001,
      -1.9860000000000003E+001,
      -1.9850000000000005E+001,
      -1.9840000000000007E+001,
      -1.9830000000000009E+001,
      -19.82,
      -1.9810000000000009E+001,
      -1.9800000000000004E+001,
      -1.9790000000000006E+001,
      -1.9780000000000005E+001,
      -1.9770000000000007E+001,
      -19.76,
      -1.9750000000000011E+001,
      -1.9740000000000002E+001,
      -1.9729999999999997E+001,
      -1.9720000000000006E+001,
      -1.9709999999999997E+001,
      -1.9700000000000006E+001,
      -19.69,
      -1.9680000000000010E+001,
      -19.67,
      -1.9660000000000004E+001,
      -1.9650000000000006E+001,
      -1.9640000000000008E+001,
      -19.63,
      -1.9620000000000008E+001,
      -1.9610000000000003E+001,
      -1.9600000000000005E+001,
      -1.9590000000000003E+001,
      -1.9580000000000005E+001,
      -19.57,
      -1.9560000000000009E+001,
      -19.55,
      -1.9540000000000010E+001,
      -1.9530000000000005E+001,
      -1.9520000000000014E+001,
      -1.9510000000000005E+001,
      -1.9500000000000007E+001,
      -1.9490000000000009E+001,
      -1.9480000000000008E+001,
      -1.9470000000000002E+001,
      -1.9460000000000012E+001,
      -1.9450000000000006E+001,
      -1.9439999999999998E+001,
      -1.9430000000000007E+001,
      -19.42,
      -1.9410000000000004E+001,
      -1.9400000000000002E+001,
      -1.9390000000000004E+001,
      -1.9380000000000006E+001,
      -1.9370000000000008E+001,
      -1.9360000000000007E+001,
      -1.9350000000000009E+001,
      -1.9340000000000003E+001,
      -1.9330000000000013E+001,
      -1.9320000000000004E+001,
      -1.9310000000000006E+001,
      -1.9300000000000008E+001,
      -1.9290000000000006E+001,
      -19.28,
      -1.9270000000000010E+001,
      -1.9260000000000005E+001,
      -1.9249999999999996E+001,
      -1.9240000000000006E+001,
      -19.23,
      -1.9220000000000010E+001,
      -19.21,
      -1.9200000000000010E+001,
      -1.9190000000000005E+001,
      -1.9180000000000007E+001,
      -1.9170000000000005E+001,
      -1.9160000000000007E+001,
      -1.9150000000000002E+001,
      -1.9140000000000011E+001,
      -1.9130000000000003E+001,
      -1.9120000000000005E+001,
      -1.9110000000000007E+001,
      -1.9100000000000005E+001,
      -1.9090000000000007E+001,
      -1.9080000000000009E+001,
      -1.9070000000000011E+001,
      -1.9060000000000009E+001,
      -1.9050000000000004E+001,
      -1.9040000000000013E+001,
      -1.9030000000000008E+001,
      -19.02,
      -1.9010000000000009E+001,
      -1.9000000000000004E+001,
      -1.8990000000000006E+001,
      -1.8980000000000004E+001,
      -1.8970000000000006E+001,
      -18.96,
      -1.8950000000000010E+001,
      -18.94,
      -1.8930000000000010E+001,
      -1.8920000000000005E+001,
      -1.8910000000000014E+001,
      -1.8900000000000006E+001,
      -1.8890000000000008E+001,
      -1.8880000000000010E+001,
      -1.8870000000000008E+001,
      -1.8860000000000003E+001,
      -1.8850000000000012E+001,
      -1.8840000000000007E+001,
      -18.83,
      -1.8820000000000007E+001,
      -1.8810000000000002E+001,
      -1.8800000000000004E+001,
      -1.8790000000000003E+001,
      -1.8780000000000005E+001,
      -1.8770000000000007E+001,
      -1.8760000000000009E+001,
      -1.8750000000000007E+001,
      -1.8740000000000009E+001,
      -1.8730000000000004E+001,
      -1.8720000000000013E+001,
      -1.8710000000000004E+001,
      -1.8700000000000006E+001,
      -1.8690000000000008E+001,
      -1.8680000000000007E+001,
      -18.67,
      -1.8660000000000011E+001,
      -1.8650000000000006E+001,
      -1.8639999999999997E+001,
      -1.8630000000000006E+001,
      -18.62,
      -1.8610000000000010E+001,
      -18.6,
      -1.8590000000000011E+001,
      -1.8580000000000005E+001,
      -1.8570000000000007E+001,
      -1.8560000000000006E+001,
      -1.8550000000000008E+001,
      -1.8540000000000003E+001,
      -1.8530000000000012E+001,
      -1.8520000000000003E+001,
      -1.8510000000000005E+001,
      -1.8500000000000007E+001,
      -1.8490000000000006E+001,
      -18.48,
      -1.8470000000000010E+001,
      -1.8460000000000004E+001,
      -1.8450000000000010E+001,
      -1.8440000000000005E+001,
      -1.8430000000000014E+001,
      -1.8420000000000009E+001,
      -18.41,
      -1.8400000000000009E+001,
      -1.8390000000000004E+001,
      -1.8380000000000006E+001,
      -1.8370000000000005E+001,
      -1.8360000000000007E+001,
      -18.35,
      -1.8340000000000011E+001,
      -1.8330000000000002E+001,
      -1.8320000000000004E+001,
      -1.8310000000000006E+001,
      -1.8300000000000004E+001,
      -1.8290000000000006E+001,
      -1.8280000000000008E+001,
      -1.8270000000000010E+001,
      -1.8260000000000009E+001,
      -1.8250000000000004E+001,
      -1.8240000000000013E+001,
      -1.8230000000000008E+001,
      -18.22,
      -1.8210000000000008E+001,
      -1.8200000000000003E+001,
      -1.8190000000000005E+001,
      -1.8180000000000003E+001,
      -1.8170000000000005E+001,
      -18.16,
      -1.8150000000000009E+001,
      -18.14,
      -1.8130000000000010E+001,
      -1.8120000000000005E+001,
      -1.8110000000000014E+001,
      -1.8100000000000005E+001,
      -1.8090000000000007E+001,
      -1.8080000000000009E+001,
      -1.8070000000000007E+001,
      -1.8060000000000002E+001,
      -1.8050000000000011E+001,
      -1.8040000000000006E+001,
      -1.8029999999999998E+001,
      -1.8020000000000007E+001,
      -18.01,
      -1.8000000000000004E+001,
      -1.7990000000000002E+001,
      -1.7980000000000004E+001,
      -1.7970000000000006E+001,
      -1.7960000000000008E+001,
      -1.7950000000000006E+001,
      -1.7940000000000008E+001,
      -1.7930000000000003E+001,
      -1.7920000000000012E+001,
      -1.7910000000000004E+001,
      -1.7900000000000006E+001,
      -1.7890000000000008E+001,
      -1.7880000000000006E+001,
      -17.87,
      -1.7860000000000010E+001,
      -1.7850000000000005E+001,
      -1.7840000000000011E+001,
      -1.7830000000000005E+001,
      -1.7820000000000014E+001,
      -1.7810000000000009E+001,
      -17.8,
      -1.7790000000000010E+001,
      -1.7780000000000005E+001,
      -1.7770000000000007E+001,
      -1.7760000000000005E+001,
      -1.7750000000000007E+001,
      -1.7740000000000002E+001,
      -1.7730000000000011E+001,
      -1.7720000000000002E+001,
      -1.7710000000000004E+001,
      -1.7700000000000006E+001,
      -1.7690000000000005E+001,
      -1.7680000000000007E+001,
      -1.7670000000000009E+001,
      -1.7660000000000011E+001,
      -1.7650000000000009E+001,
      -1.7640000000000004E+001,
      -1.7630000000000013E+001,
      -1.7620000000000008E+001,
      -17.61,
      -1.7600000000000009E+001,
      -1.7590000000000003E+001,
      -1.7580000000000005E+001,
      -1.7570000000000004E+001,
      -1.7560000000000006E+001,
      -17.55,
      -1.7540000000000010E+001,
      -17.53,
      -1.7520000000000010E+001,
      -1.7510000000000005E+001,
      -1.7500000000000014E+001,
      -1.7490000000000006E+001,
      -1.7480000000000008E+001,
      -1.7470000000000010E+001,
      -1.7460000000000008E+001,
      -1.7450000000000003E+001,
      -1.7440000000000012E+001,
      -1.7430000000000007E+001,
      -1.7419999999999998E+001,
      -1.7410000000000007E+001,
      -1.7400000000000002E+001,
      -1.7390000000000004E+001,
      -1.7380000000000003E+001,
      -1.7370000000000005E+001,
      -1.7360000000000007E+001,
      -1.7350000000000009E+001,
      -1.7340000000000007E+001,
      -1.7330000000000009E+001,
      -1.7320000000000004E+001,
      -1.7310000000000013E+001,
      -1.7300000000000004E+001,
      -1.7290000000000006E+001,
      -1.7280000000000008E+001,
      -1.7270000000000007E+001,
      -17.26,
      -1.7250000000000011E+001,
      -1.7240000000000006E+001,
      -1.7229999999999997E+001,
      -1.7220000000000006E+001,
      -17.21,
      -1.7200000000000010E+001,
      -17.19,
      -1.7180000000000010E+001,
      -1.7170000000000005E+001,
      -1.7160000000000007E+001,
      -1.7150000000000006E+001,
      -1.7140000000000008E+001,
      -1.7130000000000003E+001,
      -1.7120000000000012E+001,
      -1.7110000000000003E+001,
      -1.7100000000000005E+001,
      -1.7090000000000007E+001,
      -1.7080000000000005E+001,
      -17.07,
      -1.7060000000000009E+001,
      -1.7050000000000004E+001,
      -1.7040000000000010E+001,
      -1.7030000000000005E+001,
      -1.7020000000000014E+001,
      -1.7010000000000009E+001,
      -17.0,
      -1.6990000000000009E+001,
      -1.6980000000000004E+001,
      -1.6970000000000006E+001,
      -1.6960000000000004E+001,
      -1.6950000000000006E+001,
      -16.94,
      -1.6930000000000010E+001,
      -16.92,
      -1.6910000000000004E+001,
      -1.6900000000000006E+001,
      -1.6890000000000004E+001,
      -1.6880000000000006E+001,
      -1.6870000000000008E+001,
      -1.6860000000000010E+001,
      -1.6850000000000009E+001,
      -1.6840000000000003E+001,
      -1.6830000000000013E+001,
      -1.6820000000000007E+001,
      -16.81,
      -1.6800000000000008E+001,
      -1.6790000000000003E+001,
      -1.6780000000000005E+001,
      -1.6770000000000003E+001,
      -1.6760000000000005E+001,
      -16.75,
      -1.6740000000000009E+001,
      -16.73,
      -1.6720000000000010E+001,
      -1.6710000000000004E+001,
      -1.6700000000000014E+001,
      -1.6690000000000005E+001,
      -1.6680000000000007E+001,
      -1.6670000000000009E+001,
      -1.6660000000000007E+001,
      -1.6650000000000002E+001,
      -1.6640000000000011E+001,
      -1.6630000000000006E+001,
      -1.6619999999999997E+001,
      -1.6610000000000007E+001,
      -16.6,
      -1.6590000000000003E+001,
      -1.6580000000000002E+001,
      -1.6570000000000011E+001,
      -1.6560000000000006E+001,
      -1.6550000000000008E+001,
      -1.6540000000000006E+001,
      -1.6530000000000008E+001,
      -1.6520000000000003E+001,
      -1.6510000000000012E+001,
      -1.6500000000000004E+001,
      -1.6490000000000006E+001,
      -1.6480000000000008E+001,
      -1.6470000000000006E+001,
      -16.46,
      -1.6450000000000010E+001,
      -1.6440000000000005E+001,
      -1.6430000000000010E+001,
      -1.6420000000000005E+001,
      -1.6410000000000014E+001,
      -1.6400000000000009E+001,
      -16.39,
      -1.6380000000000010E+001,
      -1.6370000000000005E+001,
      -1.6360000000000007E+001,
      -1.6350000000000005E+001,
      -1.6340000000000007E+001,
      -1.6330000000000002E+001,
      -1.6320000000000011E+001,
      -1.6310000000000002E+001,
      -1.6300000000000004E+001,
      -1.6290000000000006E+001,
      -1.6280000000000005E+001,
      -1.6270000000000007E+001,
      -1.6260000000000009E+001,
      -1.6250000000000011E+001,
      -1.6240000000000009E+001,
      -1.6230000000000004E+001,
      -1.6220000000000013E+001,
      -1.6210000000000008E+001,
      -16.2,
      -1.6190000000000008E+001,
      -1.6180000000000003E+001,
      -1.6170000000000005E+001,
      -1.6160000000000004E+001,
      -1.6150000000000006E+001,
      -16.14,
      -1.6130000000000010E+001,
      -16.12,
      -1.6110000000000010E+001,
      -1.6100000000000005E+001,
      -1.6090000000000014E+001,
      -1.6080000000000005E+001,
      -1.6070000000000007E+001,
      -1.6060000000000009E+001,
      -1.6050000000000008E+001,
      -1.6040000000000003E+001,
      -1.6030000000000012E+001,
      -1.6020000000000007E+001,
      -1.6009999999999998E+001,
      -1.6000000000000007E+001,
      -15.99,
      -1.5980000000000002E+001,
      -1.5970000000000002E+001,
      -1.5960000000000004E+001,
      -1.5950000000000005E+001,
      -1.5940000000000007E+001,
      -1.5930000000000007E+001,
      -1.5920000000000009E+001,
      -1.5910000000000002E+001,
      -1.5900000000000011E+001,
      -1.5890000000000004E+001,
      -1.5880000000000006E+001,
      -1.5870000000000006E+001,
      -1.5860000000000008E+001,
      -1.5850000000000001E+001,
      -1.5840000000000011E+001,
      -1.5830000000000004E+001,
      -1.5819999999999997E+001,
      -1.5810000000000006E+001,
      -1.5799999999999999E+001,
      -1.5790000000000008E+001,
      -1.5780000000000001E+001,
      -1.5770000000000010E+001,
      -1.5760000000000003E+001,
      -1.5750000000000005E+001,
      -1.5740000000000006E+001,
      -1.5730000000000008E+001,
      -15.72,
      -1.5710000000000010E+001,
      -1.5700000000000003E+001,
      -1.5690000000000005E+001,
      -1.5680000000000005E+001,
      -1.5670000000000007E+001,
      -15.66,
      -1.5650000000000009E+001,
      -1.5640000000000002E+001,
      -1.5630000000000011E+001,
      -1.5620000000000005E+001,
      -1.5610000000000014E+001,
      -1.5600000000000007E+001,
      -15.59,
      -1.5580000000000009E+001,
      -1.5570000000000002E+001,
      -1.5560000000000004E+001,
      -1.5550000000000004E+001,
      -1.5540000000000006E+001,
      -15.53,
      -1.5520000000000008E+001,
      -1.5510000000000002E+001,
      -1.5500000000000004E+001,
      -1.5490000000000004E+001,
      -1.5480000000000006E+001,
      -1.5470000000000006E+001,
      -1.5460000000000008E+001,
      -1.5450000000000008E+001,
      -1.5440000000000010E+001,
      -1.5430000000000003E+001,
      -1.5420000000000012E+001,
      -1.5410000000000005E+001,
      -1.5399999999999999E+001,
      -1.5390000000000008E+001,
      -15.38,
      -1.5370000000000003E+001,
      -1.5360000000000003E+001,
      -1.5350000000000005E+001,
      -1.5339999999999998E+001,
      -1.5330000000000007E+001,
      -15.32,
      -1.5310000000000009E+001,
      -1.5300000000000002E+001,
      -1.5290000000000012E+001,
      -1.5280000000000005E+001,
      -1.5270000000000007E+001,
      -1.5260000000000007E+001,
      -1.5250000000000009E+001,
      -1.5240000000000002E+001,
      -1.5230000000000011E+001,
      -1.5220000000000004E+001,
      -1.5209999999999997E+001,
      -1.5200000000000006E+001,
      -15.19,
      -1.5180000000000009E+001,
      -1.5170000000000002E+001,
      -1.5160000000000011E+001,
      -1.5150000000000004E+001,
      -1.5140000000000006E+001,
      -1.5130000000000006E+001,
      -1.5120000000000008E+001,
      -1.5110000000000001E+001,
      -1.5100000000000010E+001,
      -1.5090000000000003E+001,
      -1.5080000000000005E+001,
      -1.5070000000000006E+001,
      -1.5060000000000008E+001,
      -15.05,
      -1.5040000000000010E+001,
      -1.5030000000000003E+001,
      -1.5020000000000012E+001,
      -1.5010000000000005E+001,
      -1.5000000000000014E+001,
      -1.4990000000000007E+001,
      -14.98,
      -1.4970000000000010E+001,
      -1.4960000000000003E+001,
      -1.4950000000000005E+001,
      -1.4940000000000005E+001,
      -1.4930000000000007E+001,
      -14.92,
      -1.4910000000000009E+001,
      -1.4900000000000002E+001,
      -1.4890000000000004E+001,
      -1.4880000000000004E+001,
      -1.4870000000000006E+001,
      -1.4860000000000007E+001,
      -1.4850000000000009E+001,
      -1.4840000000000009E+001,
      -1.4830000000000011E+001,
      -1.4820000000000004E+001,
      -1.4810000000000013E+001,
      -1.4800000000000006E+001,
      -14.79,
      -1.4780000000000008E+001,
      -1.4770000000000001E+001,
      -1.4760000000000003E+001,
      -1.4750000000000004E+001,
      -1.4740000000000006E+001,
      -1.4729999999999999E+001,
      -1.4720000000000008E+001,
      -14.71,
      -1.4700000000000010E+001,
      -1.4690000000000003E+001,
      -1.4680000000000012E+001,
      -1.4670000000000005E+001,
      -1.4660000000000007E+001,
      -1.4650000000000007E+001,
      -1.4640000000000009E+001,
      -1.4630000000000003E+001,
      -1.4620000000000012E+001,
      -1.4610000000000005E+001,
      -1.4599999999999998E+001,
      -1.4590000000000007E+001,
      -14.58,
      -1.4570000000000002E+001,
      -1.4560000000000002E+001,
      -1.4550000000000004E+001,
      -1.4540000000000004E+001,
      -1.4530000000000006E+001,
      -1.4520000000000007E+001,
      -1.4510000000000009E+001,
      -1.4500000000000002E+001,
      -1.4490000000000011E+001,
      -1.4480000000000004E+001,
      -1.4470000000000006E+001,
      -1.4460000000000006E+001,
      -1.4450000000000008E+001,
      -1.4440000000000001E+001,
      -1.4430000000000010E+001,
      -1.4420000000000003E+001,
      -1.4409999999999997E+001,
      -1.4400000000000006E+001,
      -1.4389999999999999E+001,
      -1.4380000000000008E+001,
      -1.4370000000000001E+001,
      -1.4360000000000010E+001,
      -1.4350000000000003E+001,
      -1.4340000000000005E+001,
      -1.4330000000000005E+001,
      -1.4320000000000007E+001,
      -14.31,
      -1.4300000000000010E+001,
      -1.4290000000000003E+001,
      -1.4280000000000005E+001,
      -1.4270000000000005E+001,
      -1.4260000000000007E+001,
      -14.25,
      -1.4240000000000009E+001,
      -1.4230000000000002E+001,
      -1.4220000000000011E+001,
      -1.4210000000000004E+001,
      -1.4200000000000014E+001,
      -1.4190000000000007E+001,
      -14.18,
      -1.4170000000000009E+001,
      -1.4160000000000002E+001,
      -1.4150000000000004E+001,
      -1.4140000000000004E+001,
      -1.4130000000000006E+001,
      -14.12,
      -1.4110000000000008E+001,
      -1.4100000000000001E+001,
      -1.4090000000000003E+001,
      -1.4080000000000004E+001,
      -1.4070000000000006E+001,
      -1.4060000000000006E+001,
      -1.4050000000000008E+001,
      -1.4040000000000008E+001,
      -1.4030000000000010E+001,
      -1.4020000000000003E+001,
      -1.4010000000000012E+001,
      -1.4000000000000005E+001,
      -1.3989999999999998E+001,
      -1.3980000000000008E+001,
      -13.97,
      -1.3960000000000003E+001,
      -1.3950000000000003E+001,
      -1.3940000000000005E+001,
      -1.3930000000000005E+001,
      -1.3920000000000007E+001,
      -1.3910000000000007E+001,
      -1.3900000000000009E+001,
      -1.3890000000000002E+001,
      -1.3880000000000011E+001,
      -1.3870000000000005E+001,
      -1.3860000000000007E+001,
      -1.3850000000000007E+001,
      -1.3840000000000009E+001,
      -1.3830000000000002E+001,
      -1.3820000000000011E+001,
      -1.3810000000000004E+001,
      -1.3799999999999997E+001,
      -1.3790000000000006E+001,
      -13.78,
      -1.3770000000000008E+001,
      -1.3760000000000002E+001,
      -1.3750000000000011E+001,
      -1.3740000000000004E+001,
      -1.3730000000000006E+001,
      -1.3720000000000006E+001,
      -1.3710000000000008E+001,
      -1.3700000000000001E+001,
      -1.3690000000000010E+001,
      -1.3680000000000003E+001,
      -1.3670000000000005E+001,
      -1.3660000000000005E+001,
      -1.3650000000000007E+001,
      -13.64,
      -1.3630000000000010E+001,
      -1.3620000000000003E+001,
      -1.3610000000000012E+001,
      -1.3600000000000005E+001,
      -1.3590000000000014E+001,
      -1.3580000000000007E+001,
      -13.57,
      -1.3560000000000009E+001,
      -1.3550000000000002E+001,
      -1.3540000000000004E+001,
      -1.3530000000000005E+001,
      -1.3520000000000007E+001,
      -13.51,
      -1.3500000000000009E+001,
      -1.3490000000000002E+001,
      -1.3480000000000004E+001,
      -1.3470000000000004E+001,
      -1.3460000000000006E+001,
      -1.3450000000000006E+001,
      -1.3440000000000008E+001,
      -1.3430000000000009E+001,
      -1.3420000000000011E+001,
      -1.3410000000000004E+001,
      -1.3400000000000013E+001,
      -1.3390000000000006E+001,
      -1.3379999999999999E+001,
      -1.3370000000000008E+001,
      -1.3360000000000001E+001,
      -1.3350000000000003E+001,
      -1.3340000000000003E+001,
      -1.3330000000000005E+001,
      -1.3319999999999999E+001,
      -1.3310000000000008E+001,
      -13.3,
      -1.3290000000000010E+001,
      -1.3280000000000003E+001,
      -1.3270000000000012E+001,
      -1.3260000000000005E+001,
      -13.25,
      -1.3240000000000007E+001,
      -1.3230000000000002E+001,
      -1.3219999999999995E+001,
      -1.3210000000000004E+001,
      -1.3199999999999998E+001,
      -1.3189999999999991E+001,
      -13.18,
      -1.3169999999999993E+001,
      -1.3160000000000002E+001,
      -1.3149999999999995E+001,
      -1.3140000000000004E+001,
      -1.3129999999999997E+001,
      -1.3120000000000006E+001,
      -13.11,
      -1.3100000000000009E+001,
      -1.3090000000000002E+001,
      -1.3080000000000011E+001,
      -1.3070000000000004E+001,
      -1.3059999999999999E+001,
      -1.3050000000000006E+001,
      -1.3040000000000001E+001,
      -1.3029999999999994E+001,
      -1.3020000000000003E+001,
      -1.3009999999999996E+001,
      -1.2999999999999989E+001,
      -1.2989999999999998E+001,
      -1.2979999999999992E+001,
      -12.97,
      -1.2959999999999994E+001,
      -1.2950000000000003E+001,
      -1.2939999999999996E+001,
      -1.2930000000000005E+001,
      -1.2919999999999998E+001,
      -1.2910000000000007E+001,
      -12.9,
      -1.2890000000000009E+001,
      -1.2880000000000003E+001,
      -1.2869999999999997E+001,
      -1.2860000000000005E+001,
      -12.85,
      -1.2839999999999993E+001,
      -1.2830000000000002E+001,
      -1.2819999999999995E+001,
      -1.2810000000000004E+001,
      -1.2799999999999997E+001,
      -1.2790000000000006E+001,
      -12.78,
      -1.2769999999999992E+001,
      -1.2760000000000002E+001,
      -1.2749999999999995E+001,
      -1.2739999999999990E+001,
      -1.2729999999999997E+001,
      -1.2719999999999992E+001,
      -1.2709999999999999E+001,
      -1.2699999999999994E+001,
      -1.2690000000000001E+001,
      -1.2679999999999996E+001,
      -1.2670000000000003E+001,
      -1.2659999999999998E+001,
      -1.2650000000000006E+001,
      -12.64,
      -1.2630000000000008E+001,
      -1.2620000000000003E+001,
      -1.2609999999999996E+001,
      -1.2600000000000005E+001,
      -1.2589999999999998E+001,
      -1.2579999999999991E+001,
      -12.57,
      -1.2559999999999993E+001,
      -1.2549999999999988E+001,
      -1.2539999999999996E+001,
      -1.2529999999999990E+001,
      -1.2519999999999998E+001,
      -1.2509999999999993E+001,
      -12.5,
      -1.2489999999999995E+001,
      -1.2480000000000002E+001,
      -1.2469999999999997E+001,
      -1.2460000000000004E+001,
      -12.45,
      -1.2440000000000007E+001,
      -1.2430000000000001E+001,
      -1.2419999999999995E+001,
      -1.2410000000000004E+001,
      -1.2399999999999997E+001,
      -1.2389999999999990E+001,
      -1.2379999999999999E+001,
      -1.2369999999999992E+001,
      -1.2360000000000001E+001,
      -1.2349999999999994E+001,
      -1.2339999999999989E+001,
      -1.2329999999999997E+001,
      -1.2319999999999991E+001,
      -1.2309999999999999E+001,
      -1.2299999999999994E+001,
      -1.2290000000000001E+001,
      -1.2279999999999996E+001,
      -1.2270000000000003E+001,
      -1.2259999999999998E+001,
      -1.2250000000000005E+001,
      -12.24,
      -1.2229999999999993E+001,
      -1.2220000000000002E+001,
      -1.2209999999999996E+001,
      -1.2200000000000005E+001,
      -1.2189999999999998E+001,
      -1.2179999999999991E+001,
      -12.17,
      -1.2159999999999993E+001,
      -1.2150000000000002E+001,
      -1.2139999999999995E+001,
      -1.2129999999999990E+001,
      -1.2119999999999997E+001,
      -1.2109999999999992E+001,
      -12.1,
      -1.2089999999999995E+001,
      -1.2080000000000002E+001,
      -1.2069999999999997E+001,
      -1.2060000000000004E+001,
      -1.2049999999999999E+001,
      -1.2040000000000006E+001,
      -1.2030000000000001E+001,
      -1.2020000000000008E+001,
      -1.2010000000000003E+001,
      -1.1999999999999996E+001,
      -1.1990000000000006E+001,
      -1.1979999999999999E+001,
      -1.1969999999999992E+001,
      -11.96,
      -1.1949999999999994E+001,
      -1.1939999999999989E+001,
      -1.1929999999999996E+001,
      -1.1919999999999991E+001,
      -1.1909999999999998E+001,
      -1.1899999999999993E+001,
      -11.89,
      -1.1879999999999995E+001,
      -1.1870000000000003E+001,
      -1.1859999999999998E+001,
      -1.1850000000000005E+001,
      -11.84,
      -1.1830000000000007E+001,
      -1.1820000000000002E+001,
      -1.1809999999999995E+001,
      -1.1800000000000004E+001,
      -1.1789999999999997E+001,
      -1.1779999999999990E+001,
      -11.77,
      -1.1759999999999993E+001,
      -1.1750000000000002E+001,
      -1.1739999999999995E+001,
      -1.1729999999999990E+001,
      -1.1719999999999997E+001,
      -1.1709999999999992E+001,
      -11.7,
      -1.1689999999999994E+001,
      -1.1680000000000001E+001,
      -1.1669999999999996E+001,
      -1.1660000000000004E+001,
      -1.1649999999999999E+001,
      -1.1640000000000006E+001,
      -11.63,
      -1.1619999999999994E+001,
      -1.1610000000000003E+001,
      -1.1599999999999996E+001,
      -1.1590000000000005E+001,
      -1.1579999999999998E+001,
      -1.1569999999999991E+001,
      -11.56,
      -1.1549999999999994E+001,
      -1.1540000000000003E+001,
      -1.1529999999999996E+001,
      -1.1519999999999991E+001,
      -1.1509999999999998E+001,
      -1.1499999999999993E+001,
      -11.49,
      -1.1479999999999995E+001,
      -1.1470000000000002E+001,
      -1.1459999999999997E+001,
      -1.1450000000000005E+001,
      -11.44,
      -1.1430000000000007E+001,
      -1.1420000000000002E+001,
      -1.1409999999999995E+001,
      -1.1400000000000004E+001,
      -1.1389999999999997E+001,
      -1.1380000000000006E+001,
      -11.37,
      -1.1359999999999992E+001,
      -1.1350000000000001E+001,
      -1.1339999999999995E+001,
      -1.1329999999999989E+001,
      -1.1319999999999997E+001,
      -1.1309999999999992E+001,
      -1.1299999999999999E+001,
      -1.1289999999999994E+001,
      -1.1280000000000001E+001,
      -1.1269999999999996E+001,
      -1.1260000000000003E+001,
      -1.1249999999999998E+001,
      -1.1240000000000006E+001,
      -11.23,
      -1.1220000000000008E+001,
      -1.1210000000000003E+001,
      -1.1199999999999996E+001,
      -1.1190000000000005E+001,
      -1.1179999999999998E+001,
      -1.1169999999999991E+001,
      -11.16,
      -1.1149999999999993E+001,
      -1.1139999999999988E+001,
      -1.1129999999999995E+001,
      -1.1119999999999990E+001,
      -1.1109999999999998E+001,
      -1.1099999999999993E+001,
      -11.09,
      -1.1079999999999995E+001,
      -1.1070000000000002E+001,
      -1.1059999999999997E+001,
      -1.1050000000000004E+001,
      -11.04,
      -1.1030000000000006E+001,
      -1.1020000000000001E+001,
      -1.1009999999999994E+001,
      -1.1000000000000004E+001,
      -1.0989999999999997E+001,
      -1.0979999999999990E+001,
      -1.0969999999999999E+001,
      -1.0959999999999992E+001,
      -1.0950000000000001E+001,
      -1.0939999999999994E+001,
      -1.0929999999999989E+001,
      -1.0919999999999996E+001,
      -1.0909999999999991E+001,
      -1.0899999999999999E+001,
      -1.0889999999999993E+001,
      -10.88,
      -1.0869999999999996E+001,
      -1.0860000000000003E+001,
      -1.0849999999999998E+001,
      -1.0840000000000005E+001,
      -10.83,
      -1.0820000000000007E+001,
      -1.0810000000000002E+001,
      -1.0799999999999995E+001,
      -1.0790000000000004E+001,
      -1.0779999999999998E+001,
      -1.0770000000000007E+001,
      -10.76,
      -1.0749999999999993E+001,
      -1.0740000000000002E+001,
      -1.0729999999999995E+001,
      -1.0719999999999990E+001,
      -1.0709999999999997E+001,
      -1.0699999999999992E+001,
      -10.69,
      -1.0679999999999994E+001,
      -1.0670000000000002E+001,
      -1.0659999999999997E+001,
      -1.0650000000000004E+001,
      -1.0639999999999999E+001,
      -1.0630000000000006E+001,
      -1.0620000000000001E+001,
      -1.0610000000000008E+001,
      -1.0600000000000003E+001,
      -1.0589999999999996E+001,
      -1.0580000000000005E+001,
      -1.0569999999999999E+001,
      -1.0559999999999992E+001,
      -10.55,
      -1.0539999999999994E+001,
      -1.0529999999999989E+001,
      -1.0519999999999996E+001,
      -1.0509999999999991E+001,
      -1.0499999999999998E+001,
      -1.0489999999999993E+001,
      -10.48,
      -1.0469999999999995E+001,
      -1.0460000000000003E+001,
      -1.0449999999999998E+001,
      -1.0440000000000005E+001,
      -10.43,
      -1.0420000000000007E+001,
      -1.0410000000000002E+001,
      -1.0399999999999995E+001,
      -1.0390000000000004E+001,
      -1.0379999999999997E+001,
      -1.0369999999999990E+001,
      -10.36,
      -1.0349999999999993E+001,
      -1.0340000000000002E+001,
      -1.0329999999999995E+001,
      -1.0319999999999990E+001,
      -1.0309999999999997E+001,
      -1.0299999999999992E+001,
      -10.29,
      -1.0279999999999994E+001,
      -1.0270000000000001E+001,
      -1.0259999999999996E+001,
      -1.0250000000000004E+001,
      -1.0239999999999998E+001,
      -1.0230000000000006E+001,
      -10.22,
      -1.0209999999999994E+001,
      -1.0200000000000003E+001,
      -1.0189999999999996E+001,
      -1.0180000000000005E+001,
      -1.0169999999999998E+001,
      -1.0159999999999991E+001,
      -10.15,
      -1.0139999999999993E+001,
      -1.0130000000000003E+001,
      -1.0119999999999996E+001,
      -1.0109999999999991E+001,
      -1.0099999999999998E+001,
      -1.0089999999999993E+001,
      -10.08,
      -1.0069999999999995E+001,
      -1.0060000000000002E+001,
      -1.0049999999999997E+001,
      -1.0040000000000004E+001,
      -10.03,
      -1.0020000000000007E+001,
      -1.0010000000000002E+001,
      -9.9999999999999947E+000,
      -9.9900000000000038E+000,
      -9.9799999999999969E+000,
      -9.9700000000000060E+000,
      -9.9599999999999991E+000,
      -9.9499999999999922E+000,
      -9.9400000000000013E+000,
      -9.9299999999999944E+000,
      -9.9199999999999893E+000,
      -9.9099999999999966E+000,
      -9.8999999999999915E+000,
      -9.8899999999999988E+000,
      -9.8799999999999937E+000,
      -9.8700000000000010E+000,
      -9.8599999999999959E+000,
      -9.8500000000000032E+000,
      -9.8399999999999981E+000,
      -9.8300000000000054E+000,
      -9.82,
      -9.8100000000000076E+000,
      -9.8000000000000025E+000,
      -9.7899999999999956E+000,
      -9.7800000000000047E+000,
      -9.7699999999999978E+000,
      -9.7599999999999909E+000,
      -9.75,
      -9.7399999999999931E+000,
      -9.7299999999999880E+000,
      -9.7199999999999953E+000,
      -9.7099999999999902E+000,
      -9.6999999999999975E+000,
      -9.6899999999999924E+000,
      -9.68,
      -9.6699999999999946E+000,
      -9.6600000000000019E+000,
      -9.6499999999999968E+000,
      -9.6400000000000041E+000,
      -9.6299999999999990E+000,
      -9.6200000000000063E+000,
      -9.6100000000000012E+000,
      -9.5999999999999943E+000,
      -9.5900000000000034E+000,
      -9.5799999999999965E+000,
      -9.5699999999999896E+000,
      -9.5599999999999987E+000,
      -9.5499999999999918E+000,
      -9.5400000000000009E+000,
      -9.5299999999999940E+000,
      -9.5200000000000031E+000,
      -9.5099999999999962E+000,
      -9.4999999999999911E+000,
      -9.4899999999999984E+000,
      -9.4799999999999933E+000,
      -9.47,
      -9.4599999999999955E+000,
      -9.4500000000000028E+000,
      -9.4399999999999977E+000,
      -9.4300000000000050E+000,
      -9.42,
      -9.4100000000000072E+000,
      -9.4000000000000021E+000,
      -9.3899999999999952E+000,
      -9.3800000000000043E+000,
      -9.3699999999999974E+000,
      -9.3600000000000065E+000,
      -9.35,
      -9.3399999999999928E+000,
      -9.3300000000000018E+000,
      -9.3199999999999950E+000,
      -9.3099999999999898E+000,
      -9.2999999999999972E+000,
      -9.2899999999999920E+000,
      -9.28,
      -9.2699999999999942E+000,
      -9.2600000000000016E+000,
      -9.2499999999999964E+000,
      -9.2400000000000038E+000,
      -9.2299999999999986E+000,
      -9.2200000000000060E+000,
      -9.21,
      -9.2000000000000082E+000,
      -9.1900000000000031E+000,
      -9.1799999999999962E+000,
      -9.1700000000000053E+000,
      -9.1599999999999984E+000,
      -9.1499999999999915E+000,
      -9.14,
      -9.1299999999999937E+000,
      -9.1199999999999886E+000,
      -9.1099999999999959E+000,
      -9.0999999999999908E+000,
      -9.0899999999999981E+000,
      -9.0799999999999930E+000,
      -9.07,
      -9.0599999999999952E+000,
      -9.0500000000000025E+000,
      -9.0399999999999974E+000,
      -9.0300000000000047E+000,
      -9.02,
      -9.0100000000000069E+000,
      -9.0000000000000018E+000,
      -8.9899999999999949E+000,
      -8.9800000000000040E+000,
      -8.9699999999999971E+000,
      -8.9599999999999902E+000,
      -8.95,
      -8.9399999999999924E+000,
      -8.9300000000000015E+000,
      -8.9199999999999946E+000,
      -8.9099999999999895E+000,
      -8.8999999999999968E+000,
      -8.8899999999999917E+000,
      -8.8799999999999990E+000,
      -8.8699999999999939E+000,
      -8.8600000000000012E+000,
      -8.8499999999999961E+000,
      -8.8400000000000034E+000,
      -8.8299999999999983E+000,
      -8.8200000000000056E+000,
      -8.81,
      -8.7999999999999936E+000,
      -8.7900000000000027E+000,
      -8.7799999999999958E+000,
      -8.7700000000000049E+000,
      -8.7599999999999980E+000,
      -8.7499999999999911E+000,
      -8.74,
      -8.7299999999999933E+000,
      -8.7200000000000024E+000,
      -8.7099999999999955E+000,
      -8.6999999999999904E+000,
      -8.6899999999999977E+000,
      -8.6799999999999926E+000,
      -8.67,
      -8.6599999999999948E+000,
      -8.6500000000000021E+000,
      -8.6399999999999970E+000,
      -8.6300000000000043E+000,
      -8.62,
      -8.6100000000000065E+000,
      -8.6000000000000014E+000,
      -8.5899999999999945E+000,
      -8.5800000000000036E+000,
      -8.5699999999999967E+000,
      -8.5600000000000058E+000,
      -8.5499999999999989E+000,
      -8.5399999999999920E+000,
      -8.5300000000000011E+000,
      -8.5199999999999942E+000,
      -8.5099999999999891E+000,
      -8.4999999999999964E+000,
      -8.4899999999999913E+000,
      -8.4799999999999986E+000,
      -8.4699999999999935E+000,
      -8.46,
      -8.4499999999999957E+000,
      -8.4400000000000031E+000,
      -8.4299999999999979E+000,
      -8.4200000000000053E+000,
      -8.41,
      -8.4000000000000075E+000,
      -8.3900000000000023E+000,
      -8.3799999999999955E+000,
      -8.3700000000000045E+000,
      -8.3599999999999977E+000,
      -8.3499999999999908E+000,
      -8.34,
      -8.3299999999999930E+000,
      -8.3199999999999878E+000,
      -8.3099999999999952E+000,
      -8.2999999999999901E+000,
      -8.2899999999999974E+000,
      -8.2799999999999923E+000,
      -8.27,
      -8.2599999999999945E+000,
      -8.2500000000000018E+000,
      -8.2399999999999967E+000,
      -8.2300000000000040E+000,
      -8.2199999999999989E+000,
      -8.2100000000000062E+000,
      -8.2000000000000011E+000,
      -8.1899999999999942E+000,
      -8.1800000000000033E+000,
      -8.1699999999999964E+000,
      -8.1600000000000055E+000,
      -8.1499999999999986E+000,
      -8.1399999999999917E+000,
      -8.13,
      -8.1199999999999939E+000,
      -8.1100000000000030E+000,
      -8.0999999999999961E+000,
      -8.0899999999999910E+000,
      -8.0799999999999983E+000,
      -8.0699999999999932E+000,
      -8.06,
      -8.0499999999999954E+000,
      -8.0400000000000027E+000,
      -8.0299999999999976E+000,
      -8.0200000000000049E+000,
      -8.01,
      -8.0000000000000071E+000,
      -7.9900000000000011E+000,
      -7.9799999999999951E+000,
      -7.9700000000000033E+000,
      -7.9599999999999973E+000,
      -7.9500000000000055E+000,
      -7.9399999999999995E+000,
      -7.9299999999999926E+000,
      -7.9200000000000017E+000,
      -7.9099999999999948E+000,
      -7.8999999999999888E+000,
      -7.8899999999999970E+000,
      -7.8799999999999910E+000,
      -7.8699999999999992E+000,
      -7.8599999999999932E+000,
      -7.8500000000000014E+000,
      -7.8399999999999954E+000,
      -7.8300000000000036E+000,
      -7.8199999999999976E+000,
      -7.8100000000000058E+000,
      -7.8,
      -7.7900000000000080E+000,
      -7.7800000000000020E+000,
      -7.7699999999999960E+000,
      -7.7600000000000042E+000,
      -7.7499999999999982E+000,
      -7.7399999999999913E+000,
      -7.73,
      -7.7199999999999935E+000,
      -7.7099999999999875E+000,
      -7.6999999999999957E+000,
      -7.6899999999999897E+000,
      -7.6799999999999979E+000,
      -7.6699999999999919E+000,
      -7.66,
      -7.6499999999999941E+000,
      -7.6400000000000023E+000,
      -7.6299999999999963E+000,
      -7.6200000000000045E+000,
      -7.6099999999999985E+000,
      -7.6000000000000068E+000,
      -7.5900000000000007E+000,
      -7.5799999999999947E+000,
      -7.5700000000000029E+000,
      -7.5599999999999969E+000,
      -7.5499999999999901E+000,
      -7.5399999999999991E+000,
      -7.5299999999999923E+000,
      -7.5200000000000014E+000,
      -7.5099999999999945E+000,
      -7.4999999999999885E+000,
      -7.4899999999999967E+000,
      -7.4799999999999907E+000,
      -7.4699999999999989E+000,
      -7.4599999999999929E+000,
      -7.4500000000000011E+000,
      -7.4399999999999951E+000,
      -7.4300000000000033E+000,
      -7.4199999999999973E+000,
      -7.4100000000000055E+000,
      -7.3999999999999995E+000,
      -7.3899999999999935E+000,
      -7.3800000000000017E+000,
      -7.3699999999999957E+000,
      -7.3600000000000039E+000,
      -7.3499999999999979E+000,
      -7.3399999999999910E+000,
      -7.33,
      -7.3199999999999932E+000,
      -7.3100000000000023E+000,
      -7.2999999999999954E+000,
      -7.2899999999999894E+000,
      -7.2799999999999976E+000,
      -7.2699999999999916E+000,
      -7.26,
      -7.2499999999999938E+000,
      -7.2400000000000020E+000,
      -7.2299999999999960E+000,
      -7.2200000000000042E+000,
      -7.2099999999999982E+000,
      -7.2000000000000064E+000,
      -7.19,
      -7.1799999999999944E+000,
      -7.1700000000000026E+000,
      -7.1599999999999966E+000,
      -7.1500000000000048E+000,
      -7.1399999999999988E+000,
      -7.1299999999999919E+000,
      -7.1200000000000010E+000,
      -7.1099999999999941E+000,
      -7.0999999999999881E+000,
      -7.0899999999999963E+000,
      -7.0799999999999903E+000,
      -7.0699999999999985E+000,
      -7.0599999999999925E+000,
      -7.0500000000000007E+000,
      -7.0399999999999947E+000,
      -7.0300000000000029E+000,
      -7.0199999999999969E+000,
      -7.0100000000000051E+000,
      -6.9999999999999991E+000,
      -6.9900000000000073E+000,
      -6.9800000000000013E+000,
      -6.9699999999999953E+000,
      -6.9600000000000035E+000,
      -6.9499999999999975E+000,
      -6.9399999999999906E+000,
      -6.93,
      -6.9199999999999928E+000,
      -6.9100000000000019E+000,
      -6.8999999999999950E+000,
      -6.8899999999999890E+000,
      -6.8799999999999972E+000,
      -6.8699999999999912E+000,
      -6.8599999999999994E+000,
      -6.8499999999999934E+000,
      -6.8400000000000016E+000,
      -6.8299999999999956E+000,
      -6.8200000000000038E+000,
      -6.8099999999999978E+000,
      -6.8000000000000060E+000,
      -6.79,
      -6.7799999999999940E+000,
      -6.7700000000000022E+000,
      -6.7599999999999962E+000,
      -6.7500000000000044E+000,
      -6.7399999999999984E+000,
      -6.7299999999999915E+000,
      -6.7200000000000006E+000,
      -6.7099999999999937E+000,
      -6.6999999999999877E+000,
      -6.6899999999999959E+000,
      -6.6799999999999899E+000,
      -6.6699999999999982E+000,
      -6.6599999999999921E+000,
      -6.65,
      -6.6399999999999944E+000,
      -6.6300000000000026E+000,
      -6.6199999999999966E+000,
      -6.6100000000000048E+000,
      -6.5999999999999988E+000,
      -6.5900000000000070E+000,
      -6.5800000000000010E+000,
      -6.5699999999999950E+000,
      -6.5600000000000032E+000,
      -6.5499999999999972E+000,
      -6.5400000000000054E+000,
      -6.5299999999999994E+000,
      -6.5199999999999925E+000,
      -6.5100000000000016E+000,
      -6.4999999999999947E+000,
      -6.4899999999999887E+000,
      -6.4799999999999969E+000,
      -6.4699999999999909E+000,
      -6.4599999999999991E+000,
      -6.4499999999999931E+000,
      -6.4400000000000013E+000,
      -6.4299999999999953E+000,
      -6.4200000000000035E+000,
      -6.4099999999999975E+000,
      -6.4000000000000057E+000,
      -6.39,
      -6.3800000000000079E+000,
      -6.3700000000000019E+000,
      -6.3599999999999959E+000,
      -6.3500000000000041E+000,
      -6.3399999999999981E+000,
      -6.3299999999999912E+000,
      -6.32,
      -6.3099999999999934E+000,
      -6.2999999999999874E+000,
      -6.2899999999999956E+000,
      -6.2799999999999896E+000,
      -6.2699999999999978E+000,
      -6.2599999999999918E+000,
      -6.25,
      -6.2399999999999940E+000,
      -6.2300000000000022E+000,
      -6.2199999999999962E+000,
      -6.2100000000000044E+000,
      -6.1999999999999984E+000,
      -6.1900000000000066E+000,
      -6.1800000000000006E+000,
      -6.1699999999999946E+000,
      -6.1600000000000028E+000,
      -6.1499999999999968E+000,
      -6.1399999999999899E+000,
      -6.1299999999999990E+000,
      -6.1199999999999921E+000,
      -6.1100000000000012E+000,
      -6.0999999999999943E+000,
      -6.0899999999999883E+000,
      -6.0799999999999965E+000,
      -6.0699999999999905E+000,
      -6.0599999999999987E+000,
      -6.0499999999999927E+000,
      -6.0400000000000009E+000,
      -6.0299999999999949E+000,
      -6.0200000000000031E+000,
      -6.0099999999999971E+000,
      -6.0000000000000053E+000,
      -5.9899999999999993E+000,
      -5.9800000000000075E+000,
      -5.9700000000000015E+000,
      -5.9599999999999955E+000,
      -5.9500000000000037E+000,
      -5.9399999999999977E+000,
      -5.9299999999999908E+000,
      -5.92,
      -5.9099999999999930E+000,
      -5.9000000000000021E+000,
      -5.8899999999999952E+000,
      -5.8799999999999892E+000,
      -5.8699999999999974E+000,
      -5.8599999999999914E+000,
      -5.85,
      -5.8399999999999936E+000,
      -5.8300000000000018E+000,
      -5.8199999999999958E+000,
      -5.8100000000000041E+000,
      -5.7999999999999980E+000,
      -5.7900000000000063E+000,
      -5.78,
      -5.7699999999999942E+000,
      -5.7600000000000025E+000,
      -5.7499999999999964E+000,
      -5.7400000000000047E+000,
      -5.7299999999999986E+000,
      -5.7199999999999918E+000,
      -5.7100000000000009E+000,
      -5.6999999999999940E+000,
      -5.6899999999999880E+000,
      -5.6799999999999962E+000,
      -5.6699999999999902E+000,
      -5.6599999999999984E+000,
      -5.6499999999999924E+000,
      -5.6400000000000006E+000,
      -5.6299999999999946E+000,
      -5.6200000000000028E+000,
      -5.6099999999999968E+000,
      -5.6000000000000050E+000,
      -5.5899999999999990E+000,
      -5.5800000000000072E+000,
      -5.5700000000000012E+000,
      -5.5599999999999952E+000,
      -5.5500000000000034E+000,
      -5.5399999999999974E+000,
      -5.5299999999999905E+000,
      -5.52,
      -5.5099999999999927E+000,
      -5.5000000000000018E+000,
      -5.4899999999999949E+000,
      -5.4799999999999889E+000,
      -5.4699999999999971E+000,
      -5.4599999999999911E+000,
      -5.4499999999999993E+000,
      -5.4399999999999933E+000,
      -5.4300000000000015E+000,
      -5.4199999999999955E+000,
      -5.4100000000000037E+000,
      -5.3999999999999977E+000,
      -5.3900000000000059E+000,
      -5.38,
      -5.3699999999999939E+000,
      -5.3600000000000021E+000,
      -5.3499999999999961E+000,
      -5.3400000000000043E+000,
      -5.3299999999999983E+000,
      -5.3199999999999914E+000,
      -5.3100000000000005E+000,
      -5.2999999999999936E+000,
      -5.2900000000000027E+000,
      -5.2799999999999958E+000,
      -5.2699999999999898E+000,
      -5.2599999999999980E+000,
      -5.2499999999999920E+000,
      -5.24,
      -5.2299999999999942E+000,
      -5.2200000000000024E+000,
      -5.2099999999999964E+000,
      -5.2000000000000046E+000,
      -5.1899999999999986E+000,
      -5.1800000000000068E+000,
      -5.1700000000000008E+000,
      -5.1599999999999948E+000,
      -5.1500000000000030E+000,
      -5.1399999999999970E+000,
      -5.1300000000000052E+000,
      -5.1199999999999992E+000,
      -5.1099999999999923E+000,
      -5.1000000000000014E+000,
      -5.0899999999999945E+000,
      -5.0799999999999885E+000,
      -5.0699999999999967E+000,
      -5.0599999999999907E+000,
      -5.0499999999999989E+000,
      -5.0399999999999929E+000,
      -5.0300000000000011E+000,
      -5.0199999999999951E+000,
      -5.0100000000000033E+000,
      -4.9999999999999973E+000,
      -4.9900000000000055E+000,
      -4.9799999999999995E+000,
      -4.9700000000000077E+000,
      -4.9600000000000017E+000,
      -4.9499999999999957E+000,
      -4.9400000000000039E+000,
      -4.9299999999999979E+000,
      -4.9199999999999910E+000,
      -4.91,
      -4.8999999999999932E+000,
      -4.8900000000000023E+000,
      -4.8799999999999955E+000,
      -4.8699999999999894E+000,
      -4.8599999999999977E+000,
      -4.8499999999999917E+000,
      -4.84,
      -4.8299999999999939E+000,
      -4.8200000000000021E+000,
      -4.8099999999999961E+000,
      -4.8000000000000043E+000,
      -4.7899999999999983E+000,
      -4.7800000000000065E+000,
      -4.7700000000000005E+000,
      -4.7599999999999945E+000,
      -4.7500000000000027E+000,
      -4.7399999999999967E+000,
      -4.7300000000000049E+000,
      -4.7199999999999989E+000,
      -4.7099999999999920E+000,
      -4.7000000000000011E+000,
      -4.6899999999999942E+000,
      -4.6799999999999882E+000,
      -4.6699999999999964E+000,
      -4.6599999999999904E+000,
      -4.6499999999999986E+000,
      -4.6399999999999926E+000,
      -4.6300000000000008E+000,
      -4.6199999999999948E+000,
      -4.6100000000000030E+000,
      -4.5999999999999970E+000,
      -4.5900000000000052E+000,
      -4.5799999999999992E+000,
      -4.5700000000000074E+000,
      -4.5600000000000014E+000,
      -4.5499999999999954E+000,
      -4.5400000000000036E+000,
      -4.5299999999999976E+000,
      -4.5199999999999907E+000,
      -4.51,
      -4.4999999999999929E+000,
      -4.4900000000000020E+000,
      -4.4799999999999951E+000,
      -4.4699999999999891E+000,
      -4.4599999999999973E+000,
      -4.4499999999999913E+000,
      -4.4399999999999995E+000,
      -4.4299999999999935E+000,
      -4.4200000000000017E+000,
      -4.4099999999999957E+000,
      -4.4000000000000039E+000,
      -4.3899999999999979E+000,
      -4.3800000000000061E+000,
      -4.37,
      -4.3599999999999941E+000,
      -4.3500000000000023E+000,
      -4.3399999999999963E+000,
      -4.3300000000000045E+000,
      -4.3199999999999985E+000,
      -4.3099999999999916E+000,
      -4.3000000000000007E+000,
      -4.2899999999999938E+000,
      -4.2799999999999878E+000,
      -4.2699999999999960E+000,
      -4.2599999999999900E+000,
      -4.2499999999999982E+000,
      -4.2399999999999922E+000,
      -4.23,
      -4.2199999999999944E+000,
      -4.2100000000000026E+000,
      -4.1999999999999966E+000,
      -4.1900000000000048E+000,
      -4.1799999999999988E+000,
      -4.1700000000000070E+000,
      -4.1600000000000010E+000,
      -4.1499999999999950E+000,
      -4.1400000000000032E+000,
      -4.1299999999999972E+000,
      -4.1199999999999903E+000,
      -4.1099999999999994E+000,
      -4.0999999999999925E+000,
      -4.0900000000000016E+000,
      -4.0799999999999947E+000,
      -4.0699999999999887E+000,
      -4.0599999999999969E+000,
      -4.0499999999999909E+000,
      -4.0399999999999991E+000,
      -4.0299999999999931E+000,
      -4.0200000000000014E+000,
      -4.0099999999999953E+000,
      -4.0000000000000036E+000,
      -3.9899999999999975E+000,
      -3.9800000000000058E+000,
      -3.9699999999999998E+000,
      -3.9599999999999933E+000,
      -3.9500000000000020E+000,
      -3.9399999999999955E+000,
      -3.9300000000000042E+000,
      -3.9199999999999977E+000,
      -3.9099999999999913E+000,
      -3.9,
      -3.8899999999999935E+000,
      -3.8800000000000021E+000,
      -3.8699999999999957E+000,
      -3.8599999999999897E+000,
      -3.8499999999999979E+000,
      -3.8399999999999919E+000,
      -3.83,
      -3.8199999999999941E+000,
      -3.8100000000000023E+000,
      -3.7999999999999963E+000,
      -3.7900000000000045E+000,
      -3.7799999999999985E+000,
      -3.7700000000000067E+000,
      -3.7600000000000007E+000,
      -3.7499999999999942E+000,
      -3.7400000000000029E+000,
      -3.7299999999999964E+000,
      -3.7200000000000051E+000,
      -3.7099999999999986E+000,
      -3.6999999999999922E+000,
      -3.6900000000000008E+000,
      -3.6799999999999944E+000,
      -3.6699999999999884E+000,
      -3.6599999999999966E+000,
      -3.6499999999999906E+000,
      -3.6399999999999988E+000,
      -3.6299999999999928E+000,
      -3.6200000000000010E+000,
      -3.6099999999999950E+000,
      -3.6000000000000032E+000,
      -3.5899999999999972E+000,
      -3.5800000000000054E+000,
      -3.5699999999999994E+000,
      -3.5600000000000076E+000,
      -3.5500000000000016E+000,
      -3.5399999999999952E+000,
      -3.5300000000000038E+000,
      -3.5199999999999974E+000,
      -3.5099999999999909E+000,
      -3.4999999999999996E+000,
      -3.4899999999999931E+000,
      -3.4800000000000018E+000,
      -3.4699999999999953E+000,
      -3.4599999999999893E+000,
      -3.4499999999999975E+000,
      -3.4399999999999915E+000,
      -3.4299999999999997E+000,
      -3.4199999999999937E+000,
      -3.4100000000000019E+000,
      -3.3999999999999959E+000,
      -3.3900000000000041E+000,
      -3.3799999999999981E+000,
      -3.3700000000000063E+000,
      -3.3600000000000003E+000,
      -3.3499999999999939E+000,
      -3.3400000000000025E+000,
      -3.3299999999999961E+000,
      -3.3200000000000047E+000,
      -3.3099999999999983E+000,
      -3.2999999999999918E+000,
      -3.2900000000000005E+000,
      -3.2799999999999940E+000,
      -3.2699999999999880E+000,
      -3.2599999999999962E+000,
      -3.2499999999999902E+000,
      -3.2399999999999984E+000,
      -3.2299999999999924E+000,
      -3.2200000000000006E+000,
      -3.2099999999999946E+000,
      -3.2000000000000028E+000,
      -3.1899999999999968E+000,
      -3.1800000000000050E+000,
      -3.1699999999999990E+000,
      -3.1600000000000072E+000,
      -3.1500000000000012E+000,
      -3.1399999999999948E+000,
      -3.1300000000000034E+000,
      -3.1199999999999970E+000,
      -3.1099999999999905E+000,
      -3.0999999999999992E+000,
      -3.0899999999999928E+000,
      -3.0800000000000014E+000,
      -3.0699999999999950E+000,
      -3.0599999999999890E+000,
      -3.0499999999999972E+000,
      -3.0399999999999912E+000,
      -3.0299999999999994E+000,
      -3.0199999999999934E+000,
      -3.0100000000000016E+000,
      -2.9999999999999956E+000,
      -2.9900000000000038E+000,
      -2.9799999999999978E+000,
      -2.9700000000000060E+000,
      -2.96,
      -2.9499999999999935E+000,
      -2.9400000000000022E+000,
      -2.9299999999999957E+000,
      -2.9200000000000044E+000,
      -2.9099999999999979E+000,
      -2.8999999999999915E+000,
      -2.89,
      -2.8799999999999937E+000,
      -2.8699999999999877E+000,
      -2.8599999999999959E+000,
      -2.8499999999999899E+000,
      -2.8399999999999981E+000,
      -2.8299999999999921E+000,
      -2.8200000000000003E+000,
      -2.8099999999999943E+000,
      -2.8000000000000025E+000,
      -2.7899999999999965E+000,
      -2.7800000000000047E+000,
      -2.7699999999999987E+000,
      -2.7600000000000069E+000,
      -2.7500000000000009E+000,
      -2.7399999999999944E+000,
      -2.7300000000000031E+000,
      -2.7199999999999966E+000,
      -2.7099999999999902E+000,
      -2.6999999999999988E+000,
      -2.6899999999999924E+000,
      -2.6800000000000010E+000,
      -2.6699999999999946E+000,
      -2.6599999999999886E+000,
      -2.6499999999999968E+000,
      -2.6399999999999908E+000,
      -2.6299999999999990E+000,
      -2.6199999999999930E+000,
      -2.6100000000000012E+000,
      -2.5999999999999952E+000,
      -2.5900000000000034E+000,
      -2.5799999999999974E+000,
      -2.5700000000000056E+000,
      -2.5599999999999996E+000,
      -2.5499999999999932E+000,
      -2.5400000000000018E+000,
      -2.5299999999999954E+000,
      -2.5200000000000040E+000,
      -2.5099999999999976E+000,
      -2.4999999999999911E+000,
      -2.4900499999999921E+000,
      -2.4801999999999920E+000,
      -2.4704499999999907E+000,
      -2.4607999999999892E+000,
      -2.4512499999999866E+000,
      -2.4417999999999980E+000,
      -2.4324499999999936E+000,
      -2.4231999999999885E+000,
      -2.4140499999999974E+000,
      -2.4049999999999905E+000,
      -2.3960499999999980E+000,
      -2.3871999999999893E+000,
      -2.3784499999999951E+000,
      -2.3697999999999850E+000,
      -2.3612499999999890E+000,
      -2.3527999999999922E+000,
      -2.3444499999999944E+000,
      -2.3361999999999958E+000,
      -2.3280499999999966E+000,
      -2.3199999999999963E+000,
      -2.3120499999999953E+000,
      -2.3041999999999936E+000,
      -2.2964499999999908E+000,
      -2.2887999999999873E+000,
      -2.2812499999999978E+000,
      -2.2737999999999925E+000,
      -2.2664499999999865E+000,
      -2.2591999999999945E+000,
      -2.2520499999999872E+000,
      -2.2449999999999934E+000,
      -2.2380499999999843E+000,
      -2.2311999999999887E+000,
      -2.2244499999999929E+000,
      -2.2177999999999960E+000,
      -2.2112499999999979E+000,
      -2.2047999999999845E+000,
      -2.1984499999999851E+000,
      -2.1921999999999850E+000,
      -2.1860499999999838E+000,
      -2.1799999999999971E+000,
      -2.1740499999999940E+000,
      -2.1681999999999908E+000,
      -2.1624499999999864E+000,
      -2.1567999999999961E+000,
      -2.1512499999999899E+000,
      -2.1457999999999977E+000,
      -2.1404499999999902E+000,
      -2.1351999999999967E+000,
      -2.1300499999999873E+000,
      -2.1249999999999920E+000,
      -2.1200499999999955E+000,
      -2.1151999999999838E+000,
      -2.1104499999999859E+000,
      -2.1057999999999875E+000,
      -2.1012499999999878E+000,
      -2.0967999999999876E+000,
      -2.0924499999999866E+000,
      -2.0881999999999845E+000,
      -2.0840499999999968E+000,
      -2.0799999999999930E+000,
      -2.0760499999999888E+000,
      -2.0721999999999983E+000,
      -2.0684499999999924E+000,
      -2.0647999999999853E+000,
      -2.0612499999999923E+000,
      -2.0577999999999839E+000,
      -2.0544499999999895E+000,
      -2.0511999999999939E+000,
      -2.0480499999999977E+000,
      -2.0449999999999857E+000,
      -2.0420499999999882E+000,
      -2.0391999999999895E+000,
      -2.0364499999999897E+000,
      -2.0337999999999896E+000,
      -2.0312499999999885E+000,
      -2.0287999999999862E+000,
      -2.0264499999999983E+000,
      -2.0241999999999947E+000,
      -2.0220499999999904E+000,
      -2.0199999999999849E+000,
      -2.0180499999999935E+000,
      -2.0161999999999867E+000,
      -2.0144499999999939E+000,
      -2.0127999999999853E+000,
      -2.0112499999999907E+000,
      -2.0097999999999949E+000,
      -2.0084499999999839E+000,
      -2.0071999999999868E+000,
      -2.0060499999999890E+000,
      -2.0049999999999901E+000,
      -2.0040499999999906E+000,
      -2.0031999999999903E+000,
      -2.0024499999999890E+000,
      -2.0017999999999869E+000,
      -2.0012499999999842E+000,
      -2.0007999999999955E+000,
      -2.0004499999999910E+000,
      -2.0001999999999853E+000,
      -2.0000499999999941E+000,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -2.0,
      -1.99995,
      -1.9998,
      -1.99955,
      -1.9991999999999999E+000,
      -1.9987499999999998E+000,
      -1.9982,
      -1.9975500000000002E+000,
      -1.9968000000000001E+000,
      -1.9959500000000001E+000,
      -1.995,
      -1.99395,
      -1.9928,
      -1.9915500000000002E+000,
      -1.9902,
      -1.98875,
      -1.9871999999999999E+000,
      -1.98555,
      -1.9838,
      -1.9819499999999999E+000,
      -1.98,
      -1.9779499999999999E+000,
      -1.9758,
      -1.97355,
      -1.9712,
      -1.96875,
      -1.9662,
      -1.9635500000000001E+000,
      -1.9608,
      -1.95795,
      -1.955,
      -1.95195,
      -1.9487999999999999E+000,
      -1.94555,
      -1.9422,
      -1.93875,
      -1.9352,
      -1.93155,
      -1.9278,
      -1.92395,
      -1.92,
      -1.9159499999999998E+000,
      -1.9118,
      -1.90755,
      -1.9032,
      -1.89875,
      -1.8942,
      -1.88955,
      -1.8848,
      -1.87995,
      -1.8749999999999998E+000,
      -1.86995,
      -1.8647999999999998E+000,
      -1.85955,
      -1.8541999999999998E+000,
      -1.84875,
      -1.8432,
      -1.8375499999999998E+000,
      -1.8317999999999999E+000,
      -1.82595,
      -1.8199999999999998E+000,
      -1.81395,
      -1.8078,
      -1.80155,
      -1.7952000000000001E+000,
      -1.78875,
      -1.7822,
      -1.77555,
      -1.7688000000000001E+000,
      -1.76195,
      -1.755,
      -1.7479500000000001E+000,
      -1.7408000000000001E+000,
      -1.73355,
      -1.7262,
      -1.71875,
      -1.7111999999999998E+000,
      -1.7035500000000001E+000,
      -1.6958000000000002E+000,
      -1.68795,
      -1.6800000000000002E+000,
      -1.67195,
      -1.6638000000000002E+000,
      -1.6555499999999999E+000,
      -1.6472000000000002E+000,
      -1.63875,
      -1.6302,
      -1.6215499999999998E+000,
      -1.6128,
      -1.60395,
      -1.5950000000000002E+000,
      -1.58595,
      -1.5768,
      -1.56755,
      -1.5582,
      -1.5487500000000003E+000,
      -1.5392000000000001E+000,
      -1.52955,
      -1.5197999999999998E+000,
      -1.50995,
      -1.5,
      -1.49,
      -1.48,
      -1.47,
      -1.46,
      -1.45,
      -1.4400000000000002E+000,
      -1.43,
      -1.42,
      -1.41,
      -1.4,
      -1.3900000000000001E+000,
      -1.3800000000000001E+000,
      -1.3699999999999999E+000,
      -1.36,
      -1.3499999999999999E+000,
      -1.34,
      -1.33,
      -1.3199999999999998E+000,
      -1.31,
      -1.3,
      -1.29,
      -1.2800000000000002E+000,
      -1.2699999999999998E+000,
      -1.26,
      -1.25,
      -1.24,
      -1.2300000000000002E+000,
      -1.22,
      -1.21,
      -1.2,
      -1.19,
      -1.1800000000000002E+000,
      -1.17,
      -1.16,
      -1.15,
      -1.14,
      -1.1300000000000001E+000,
      -1.1199999999999999E+000,
      -1.1099999999999999E+000,
      -1.1,
      -1.09,
      -1.08,
      -1.0699999999999998E+000,
      -1.06,
      -1.05,
      -1.04,
      -1.03,
      -1.02,
      -1.01,
      -1.0,
      -0.99,
      -9.7999999999999987E-001,
      -0.97,
      -9.5999999999999985E-001,
      -0.95,
      -9.4000000000000017E-001,
      -9.2999999999999983E-001,
      -0.92,
      -9.0999999999999992E-001,
      -8.9999999999999991E-001,
      -8.9000000000000012E-001,
      -8.7999999999999978E-001,
      -0.87,
      -8.6000000000000010E-001,
      -8.4999999999999987E-001,
      -8.4000000000000008E-001,
      -0.83,
      -0.82,
      -0.81,
      -7.9999999999999982E-001,
      -0.79,
      -7.7999999999999992E-001,
      -7.6999999999999991E-001,
      -0.76,
      -7.4999999999999978E-001,
      -0.74,
      -7.2999999999999987E-001,
      -7.1999999999999986E-001,
      -0.71,
      -0.7,
      -0.69,
      -0.68,
      -6.6999999999999982E-001,
      -6.5999999999999992E-001,
      -6.4999999999999991E-001,
      -6.3999999999999990E-001,
      -0.63,
      -6.1999999999999977E-001,
      -6.0999999999999988E-001,
      -6.0000000000000009E-001,
      -5.9000000000000008E-001,
      -0.58,
      -5.7000000000000017E-001,
      -5.5999999999999983E-001,
      -0.55,
      -0.54,
      -5.2999999999999992E-001,
      -5.2000000000000013E-001,
      -5.0999999999999979E-001,
      -0.5,
      -0.49005,
      -4.8020000000000007E-001,
      -4.7045000000000003E-001,
      -4.6080000000000010E-001,
      -4.5125000000000004E-001,
      -4.4180000000000008E-001,
      -0.43245,
      -4.2319999999999997E-001,
      -4.1405000000000008E-001,
      -0.405,
      -3.9605000000000012E-001,
      -3.8720000000000004E-001,
      -3.7845000000000012E-001,
      -0.3698,
      -0.36125,
      -3.5279999999999989E-001,
      -3.4444999999999987E-001,
      -3.3619999999999994E-001,
      -3.2805000000000012E-001,
      -3.1999999999999995E-001,
      -3.1205000000000005E-001,
      -3.0420000000000008E-001,
      -0.29645,
      -2.8879999999999995E-001,
      -2.8125000000000006E-001,
      -0.2738,
      -0.26645,
      -2.5919999999999993E-001,
      -0.25205,
      -2.4500000000000008E-001,
      -2.3805000000000007E-001,
      -2.3119999999999993E-001,
      -2.2444999999999990E-001,
      -2.1779999999999994E-001,
      -2.1124999999999988E-001,
      -2.0479999999999990E-001,
      -1.9845000000000002E-001,
      -0.1922,
      -1.8605000000000010E-001,
      -1.8000000000000008E-001,
      -1.7404999999999990E-001,
      -1.6819999999999985E-001,
      -1.6245000000000009E-001,
      -0.1568,
      -0.15125,
      -1.4580000000000010E-001,
      -1.4044999999999985E-001,
      -1.3519999999999990E-001,
      -1.3005000000000008E-001,
      -1.2500000000000011E-001,
      -1.2005000000000002E-001,
      -1.1520000000000002E-001,
      -1.1044999999999991E-001,
      -1.0579999999999988E-001,
      -1.0124999999999995E-001,
      -9.6800000000000136E-002,
      -9.2449999999999949E-002,
      -8.8199999999999862E-002,
      -8.4049999999999875E-002,
      -7.9999999999999988E-002,
      -7.6049999999999965E-002,
      -7.2200000000000042E-002,
      -0.06845,
      -6.4800000000000052E-002,
      -6.1249999999999964E-002,
      -5.7799999999999983E-002,
      -5.4449999999999874E-002,
      -5.1199999999999857E-002,
      -4.8049999999999947E-002,
      -4.4999999999999901E-002,
      -4.2049999999999962E-002,
      -3.9199999999999888E-002,
      -3.6449999999999913E-002,
      -3.3800000000000038E-002,
      -3.1249999999999799E-002,
      -2.8799999999999892E-002,
      -2.6450000000000085E-002,
      -2.4199999999999916E-002,
      -2.2049999999999847E-002,
      -1.9999999999999879E-002,
      -1.8050000000000010E-002,
      -1.6200000000000013E-002,
      -1.4449999999999880E-002,
      -1.2799999999999850E-002,
      -1.1249999999999918E-002,
      -9.8000000000000864E-003,
      -8.4499999999998934E-003,
      -7.1999999999997994E-003,
      -6.0500000000000371E-003,
      -4.9999999999999125E-003,
      -4.0499999999998870E-003,
      -3.1999999999999624E-003,
      -2.4500000000001374E-003,
      -1.7999999999999499E-003,
      -1.2499999999998623E-003,
      -7.9999999999987492E-004,
      -4.4999999999998747E-004,
      -1.9999999999996873E-004,
      -5.0000000000050004E-005,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0,
      0.0
    };

    rtDWork.From_Workspace_b_PWORK.TimePtr = (void *) 0;
    rtDWork.From_Workspace_b_PWORK.DataPtr = (void *) pDataValues;
  }

  /* child S-Function registration */
  ssSetNumSFunctions(rtS, 1);

  /* register each child */
  {
    static SimStruct childSFunctions[1];
    static SimStruct *childSFunctionPtrs[1];

    (void)memset((char_T *)&childSFunctions[0], 0, sizeof(childSFunctions));
    ssSetSFunctions(rtS, &childSFunctionPtrs[0]);
    {
      int_T i;

      for(i = 0; i < 1; i++) {
        ssSetSFunction(rtS, i, &childSFunctions[i]);
      }
    }

    /* Level2 S-Function Block: kalman_R_ib/<Root>/Kalman, R (joint_ekf_R_ib) */
    {
      SimStruct *rts = ssGetSFunction(rtS, 0);
      /* timing info */
      static time_T sfcnPeriod[1];
      static time_T sfcnOffset[1];
      static int_T sfcnTsMap[1];

      {
        int_T i;

        for(i = 0; i < 1; i++) {
          sfcnPeriod[i] = sfcnOffset[i] = 0.0;
        }
      }
      ssSetSampleTimePtr(rts, &sfcnPeriod[0]);
      ssSetOffsetTimePtr(rts, &sfcnOffset[0]);
      ssSetSampleTimeTaskIDPtr(rts, sfcnTsMap);
      ssSetMdlInfoPtr(rts, ssGetMdlInfoPtr(rtS));
      /* Allocate memory of model methodes 2 */
      {
        static struct _ssSFcnModelMethods2 methodes2;
        ssSetModelMethods2(rts, &methodes2);
      }

      /* inputs */
      {
        static struct _ssPortInputs inputPortInfo[2];

        _ssSetNumInputPorts(rts, 2);
        ssSetPortInfoForInputs(rts, &inputPortInfo[0]);

        /* port 0 */
        {

          ssSetInputPortRequiredContiguous(rts, 0, 1);
          ssSetInputPortSignal(rts, 0, &rtB.Sum1_d);
          _ssSetInputPortNumDimensions(rts, 0, 1);
          ssSetInputPortWidth(rts, 0, 1);
        }

        /* port 1 */
        {

          ssSetInputPortRequiredContiguous(rts, 1, 1);
          ssSetInputPortSignal(rts, 1, &rtB.TmpHiddenBuf1_Driving_Kalman_R[0]);
          _ssSetInputPortNumDimensions(rts, 1, 1);
          ssSetInputPortWidth(rts, 1, 2);
        }
      }

      /* outputs */
      {
        static struct _ssPortOutputs outputPortInfo[1];
        _ssSetNumOutputPorts(rts, 1);
        ssSetPortInfoForOutputs(rts, &outputPortInfo[0]);
        /* port 0 */
        {
          _ssSetOutputPortNumDimensions(rts, 0, 1);
          ssSetOutputPortWidth(rts, 0, 8);
          ssSetOutputPortSignal(rts, 0, ((real_T *) &rtB.Kalman_R[0]));
        }
      }

      /* states */
      ssSetDiscStates(rts, (real_T *) &rtDWork.Kalman_R_DSTATE[0]);
      /* path info */
      ssSetModelName(rts, "Kalman, R");
      ssSetPath(rts, "kalman_R_ib/Kalman, R");
      ssSetParentSS(rts, rtS);
      ssSetRootSS(rts, ssGetRootSS(rtS));
      ssSetVersion(rts, SIMSTRUCT_VERSION_LEVEL2);

      /* parameters */
      {
        static mxArray *sfcnParams[2];

        ssSetSFcnParamsCount(rts, 2);
        ssSetSFcnParamsPtr(rts, &sfcnParams[0]);

        ssSetSFcnParam(rts, 0, &rtP.Kalman_R_P1_Size[0]);
        ssSetSFcnParam(rts, 1, &rtP.Kalman_R_P2_Size[0]);
      }

      /* work vectors */
      ssSetPWork(rts, (void **) &rtDWork.Kalman_R_PWORK[0]);
      {
        static struct _ssDWorkRecord dWorkRecord[2];

        ssSetSFcnDWork(rts, dWorkRecord);
        _ssSetNumDWork(rts, 2);

        /* PWORK */
        ssSetDWorkWidth(rts, 0, 13);
        ssSetDWorkDataType(rts, 0, SS_POINTER);
        ssSetDWorkComplexSignal(rts, 0, 0);
        ssSetDWork(rts, 0, &rtDWork.Kalman_R_PWORK[0]);

        /* DSTATE */
        ssSetDWorkWidth(rts, 1, 8);
        ssSetDWorkDataType(rts, 1, SS_DOUBLE);
        ssSetDWorkComplexSignal(rts, 1, 0);
        ssSetDWorkUsedAsDState(rts, 1, 1);
        ssSetDWork(rts, 1, &rtDWork.Kalman_R_DSTATE[0]);
      }

      /* registration */
      joint_ekf_R_ib(rts);

      sfcnInitializeSizes(rts);
      sfcnInitializeSampleTimes(rts);

      /* adjust sample time */
      ssSetSampleTime(rts, 0, 0.001);
      ssSetOffsetTime(rts, 0, 0.0);
      sfcnTsMap[0] = 1;
      /* Update connectivity flags for each port */
      _ssSetInputPortConnected(rts, 0, 1);
      _ssSetInputPortConnected(rts, 1, 1);
      _ssSetOutputPortConnected(rts, 0, 1);
      _ssSetOutputPortBeingMerged(rts, 0, 0);
      /* Update the BufferDstPort flags for each input port */
      ssSetInputPortBufferDstPort(rts, 0, -1);
      ssSetInputPortBufferDstPort(rts, 1, -1);
    }
  }

  return rtS;
}

/* [EOF] kalman_R_ib_reg.h */
